Package: singleCellTK
Type: Package
Title: Comprehensive and Interactive Analysis of Single Cell RNA-Seq
        Data
Version: 2.20.0
Authors@R: c(person(given="Yichen", family="Wang", email="wangych@bu.edu", role=c("aut"),
                    comment = c(ORCID = "0000-0003-4347-5199")),
             person(given="Irzam", family="Sarfraz", email="isarfraz@bu.edu", role=c("aut"),
                    comment = c(ORCID = "0000-0001-8121-792X")),
             person(given="Rui", family="Hong", email="rzhong@bu.edu", role=c("aut")),
             person(given="Yusuke", family="Koga", email="ykoga07@bu.edu", role=c("aut")),
             person(given="Salam", family="Alabdullatif", email="salamha@bu.edu", role=c("aut")),
             person(given="Nida", family="Pervaiz", email="nidapervaiz27@gmail.com", role=c("aut")),
             person(given="David", family="Jenkins", email="dfj@bu.edu", role=c("aut"),
                    comment = c(ORCID = "0000-0002-7451-4288")),
             person(given="Vidya", family="Akavoor", email="vidyaap@bu.edu", role=c("aut")),
             person(given="Xinyun", family="Cao", email="xcao19@bu.edu", role=c("aut")),
             person(given="Shruthi", family="Bandyadka", email="sbandya@bu.edu", role=c("aut")),
             person(given="Anastasia", family="Leshchyk", email="aleshchk@bu.edu", role=c("aut")),
             person(given="Tyler", family="Faits", email="tfaits@bu.edu", role=c("aut")),
             person(given=c("Mohammed", "Muzamil"), family="Khan", email="mmkhan@bu.edu", role=c("aut")),
             person(given="Zhe", family="Wang", email="zhe@bu.edu", role=c("aut")),
             person(given=c("W.", "Evan"), family="Johnson", email="wej@bu.edu", role=c("aut"),
                    comment = c(ORCID = "0000-0002-6247-6595")),
             person(given="Ming", family="Liu", email="mingl@bu.edu", role=c("aut")),
             person(given=c("Joshua", "David"), family="Campbell", email="camp@bu.edu", role=c("aut", "cre"),
             comment = c(ORCID = "0000-0003-0780-8662"))
             )
Depends: R (>= 4.0), SummarizedExperiment, SingleCellExperiment,
        DelayedArray, Biobase
Description: The Single Cell Toolkit (SCTK) in the singleCellTK package provides an interface to popular tools for importing, quality control, analysis, and visualization of single cell RNA-seq data. SCTK allows users to seamlessly integrate tools from various packages at different stages of the analysis workflow. A general "a la carte" workflow gives users the ability access to multiple methods for data importing, calculation of general QC metrics, doublet detection, ambient RNA estimation and removal, filtering, normalization, batch correction or integration, dimensionality reduction, 2-D embedding, clustering, marker detection, differential expression, cell type labeling, pathway analysis, and data exporting. Curated workflows can be used to run Seurat and Celda. Streamlined quality control can be performed on the command line using the SCTK-QC pipeline. Users can analyze their data using commands in the R console or by using an interactive Shiny Graphical User Interface (GUI). Specific analyses or entire workflows can be summarized and shared with comprehensive HTML reports generated by Rmarkdown. Additional documentation and vignettes can be found at camplab.net/sctk.
License: MIT + file LICENSE
Encoding: UTF-8
biocViews: SingleCell, GeneExpression, DifferentialExpression,
        Alignment, Clustering, ImmunoOncology, BatchEffect,
        Normalization, QualityControl, DataImport, GUI
LazyData: FALSE
Imports: ape, anndata, AnnotationHub, batchelor, BiocParallel, celldex,
        colourpicker, colorspace, cowplot, cluster, ComplexHeatmap,
        data.table, DelayedMatrixStats, DESeq2, dplyr, DT,
        ExperimentHub, ensembldb, fields, ggplot2, ggplotify, ggrepel,
        ggtree, gridExtra, grid, GSVA (>= 1.50.0), GSVAdata, igraph,
        KernSmooth, limma, MAST, Matrix (>= 1.6-1), matrixStats,
        methods, msigdbr, multtest, plotly, plyr, ROCR, Rtsne,
        S4Vectors, scater, scMerge (>= 1.2.0), scran, Seurat (>=
        3.1.3), shiny, shinyjs, SingleR, stringr, SoupX, sva, reshape2,
        shinyalert, circlize, enrichR (>= 3.2), celda, shinycssloaders,
        DropletUtils, scds (>= 1.2.0), reticulate (>= 1.14), tools,
        tximport, tidyr, eds, withr, GSEABase, R.utils, zinbwave,
        scRNAseq (>= 2.0.2), TENxPBMCData, yaml, rmarkdown, magrittr,
        scDblFinder, metap, VAM (>= 0.5.3), tibble, rlang, TSCAN,
        TrajectoryUtils, scuttle, utils, stats, zellkonverter,
        lifecycle
RoxygenNote: 7.3.3
Suggests: testthat, Rsubread, BiocStyle, knitr, lintr, spelling,
        org.Mm.eg.db, kableExtra, shinythemes, shinyBS, shinyjqui,
        shinyWidgets, shinyFiles, BiocGenerics, RColorBrewer, fastmap
        (>= 1.1.0), harmony, SeuratObject, optparse
VignetteBuilder: knitr
URL: https://www.camplab.net/sctk/
BugReports: https://github.com/compbiomed/singleCellTK/issues
Language: en-US
git_url: https://git.bioconductor.org/packages/singleCellTK
git_branch: RELEASE_3_22
git_last_commit: e2bff7b
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29
NeedsCompilation: no
Packaged: 2025-10-30 06:33:33 UTC; biocbuild
Author: Yichen Wang [aut] (ORCID: <https://orcid.org/0000-0003-4347-5199>),
  Irzam Sarfraz [aut] (ORCID: <https://orcid.org/0000-0001-8121-792X>),
  Rui Hong [aut],
  Yusuke Koga [aut],
  Salam Alabdullatif [aut],
  Nida Pervaiz [aut],
  David Jenkins [aut] (ORCID: <https://orcid.org/0000-0002-7451-4288>),
  Vidya Akavoor [aut],
  Xinyun Cao [aut],
  Shruthi Bandyadka [aut],
  Anastasia Leshchyk [aut],
  Tyler Faits [aut],
  Mohammed Muzamil Khan [aut],
  Zhe Wang [aut],
  W. Evan Johnson [aut] (ORCID: <https://orcid.org/0000-0002-6247-6595>),
  Ming Liu [aut],
  Joshua David Campbell [aut, cre] (ORCID:
    <https://orcid.org/0000-0003-0780-8662>)
Maintainer: Joshua David Campbell <camp@bu.edu>

# The Single Cell Tool Kit

[![BioC-check](https://github.com/compbiomed/singleCellTK/actions/workflows/BioC-check.yaml/badge.svg?branch=master)](https://github.com/compbiomed/singleCellTK/actions/workflows/BioC-check.yaml) [![R-CMD-check](https://github.com/compbiomed/singleCellTK/actions/workflows/R-CMD-check.yaml/badge.svg?branch=master)](https://github.com/compbiomed/singleCellTK/actions/workflows/R-CMD-check.yaml) [![codecov](https://codecov.io/gh/compbiomed/singleCellTK/branch/devel/graph/badge.svg)](https://codecov.io/gh/compbiomed/singleCellTK)

The Single Cell Toolkit (SCTK) in the *singleCellTK* R package is an analysis platform that provides an **R interface to several popular single-cell RNA-sequencing (scRNAseq) data preprocessing, quality control, analysis, and visualization tools**. SCTK imports raw or filtered counts from various scRNAseq preprocessing tools such as 10x CellRanger, BUStools, Optimus, STARSolo, and more. By integrating several publicly available tools written in R or Python, SCTK can be used to perform extensive quality control including doublet detection, ambient RNA removal. SCTK integrates analysis workflows from popular tools such as Seurat and Bioconductor/OSCA into a single unified framework. Results from various workflows can be summarized and easily shared using comprehensive HTML reports. Lastly, data can be exported to Seurat or AnnData object to allow for seamless integration with other downstream analysis workflows.

![](https://camplab.net/sctk/img/interior-2.png)

## Features

SCTK offers multiple ways to analyze your scRNAseq data through the R console, the command line, and a graphical user interface (GUI) with the ability to use a large number of algorithms from both R & Python integrated within the toolkit.

-   **Interactive Analysis:** The Shiny APP allows users without programming experience to easily analyze their scRNAseq data with a GUI. Try it out at <https://sctk.bu.edu/>.

-   **Console Analysis:** Traditional analysis of scRNAseq data can be performed in the R console using wrapper functions for a multitude of tools and algorithms.

-   **Reports:** Comprehensive HTML reports developed with RMarkdown allows users to document, explore, and share their analyses.

-   **Interoperability:** Tools from both R and Python package can be seamlessly integrated within the same analysis workflow without the need for manual conversion between different data objects and file formats.

-   **Number of tools:** SCTK provides access to the largest number of tools within the same platform streamlining end-to-end analysis workflows. Curated workflows include those from Seurat, Scanpy, Scater/Scran (Bioconductor), and Celda.

## Tutorials

-   [Import and QC:](https://camplab.net/sctk/current/articles/import_data.html) The Import and QC workflows allow users to import data from multiple formats and perform comprehensive quality control and filtering.
-   ["*A la carte*" workflow:](https://camplab.net/sctk/current/articles/02_a_la_carte_workflow.html) The "A la carte" workflow lets users choose from a variety of options during each step of the analysis workflow including normalization, batch correction (optional), dimensionality reduction, 2-D embedding, and clustering.
-   [Seurat curated workflow:](https://camplab.net/sctk/current/articles/seurat_curated_workflow.html) This curated workflows recapitulates the steps for clustering and integration from the Seurat package (R).
-   [Scanpy curated workflow:](https://camplab.net/sctk/current/articles/scanpy_curated_workflow.html) This curated workflows recapitulates the steps for clustering from the Scanpy package (Python).
-   [Celda curated workflow:](https://camplab.net/sctk/current/articles/celda_curated_workflow.html) The curated Celda workflow performs matrix factorization by clustering genes into co-expression modules, cells into subpopulations, and estimating the amount of each module in each cell population.

## Installation

R package `singleCellTK` is available on [Bioconductor](https://bioconductor.org/packages/release/bioc/html/singleCellTK.html) and can be installed with the following commands:

``` r
if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("singleCellTK")
```

Additional information on how to install from GitHub, install Python dependencies, and for troubleshooting is available on the [Installation](https://camplab.net/sctk/current/articles/installation.html) page.

## Citation

If you use SCTK for quality control, please cite our *Nature Communication* paper:

> Rui Hong, Yusuke Koga, Shruthi Bandyadka, Anastasia Leshchyk, Yichen Wang, Vidya Akavoor, Xinyun Cao, Irzam Sarfraz, Zhe Wang, Salam Alabdullatif, Frederick Jansen, Masanao Yajima, W. Evan Johnson & Joshua D. Campbell, "Comprehensive generation, visualization, and reporting of quality control metrics for single-cell RNA sequencing data," *Nature Communications*, vol. 13, no. 1688, 2022, doi: 10.1038/s41467-022-29212-9.

If you use SCTK for analysis in the Rconsole or the interactive graphical user interface, please cite our *Patterns* paper:

> Yichen Wang, Irzam Sarfraz, Nida Pervaiz, Rui Hong, Yusuke Koga, Vidya Akavoor, Xinyun Cao, Salam Alabdullatif, Syed Ali Zaib, Zhe Wang, Frederick Jansen, Masanao Yajima, W Evan Johnson, Joshua D Campbell, "Interactive analysis of single-cell data using flexible workflows with SCTK2", *Patterns (N Y)*, Aug 3;4(8):100814, 2023, doi: 10.1016/j.patter.2023.100814.

## Report Issues

If you face any difficulty in installing or have identified a bug in the toolkit, please feel free to open up an [Issue](https://github.com/compbiomed/singleCellTK/issues) on GitHub. Questions about how to best analyze your scRNA-seq data can be asked in the [Discussions](https://github.com/compbiomed/singleCellTK/discussions) page on GitHub.

#remove tag from metadata if NULL is set to assay

#' expDeleteDataTag
#' Remove tag against an input data from the stored tag information in the metadata of the input object.
#' @param inSCE Input \code{SingleCellExperiment} object.
#' @param assay Name of the assay or the data item against which a tag should be removed.
#' @return The input \code{SingleCellExperiment} object with tag information removed from the metadata slot.
#' @export
#' @examples 
#' data(scExample, package = "singleCellTK")
#' sce <- expSetDataTag(sce, "raw", "counts")
#' sce <- expDeleteDataTag(sce, "counts")
expDeleteDataTag <- function(inSCE, assay){
  if(!is.null(S4Vectors::metadata(inSCE)$assayType)){
    tbl <- S4Vectors::metadata(inSCE)$assayType
    tbl <- tbl %>% dplyr::filter(!.data$assayName %in% assay)
    S4Vectors::metadata(inSCE)$assayType <- tbl
  }
  return(inSCE)
}

#' expSetDataTag
#' Set tag to an assay or a data item in the input SCE object.
#' @param inSCE Input \code{SingleCellExperiment} object.
#' @param assayType Specify a \code{character(1)} value as a tag that should be set against a data item.
#' @param assays Specify name(s) \code{character()} of data item(s) against which the tag should be set.
#' @return The input \code{SingleCellExperiment} object with tag information stored in the metadata slot.
#' @export
#' @examples 
#' data(scExample, package = "singleCellTK")
#' sce <- expSetDataTag(sce, "raw", "counts")
expSetDataTag <- function(inSCE, assayType, assays){
  tbl <- NULL
  if(is.null(S4Vectors::metadata(inSCE)$assayType)){
    tbl <- tibble::tibble(assayTag = assayType, assayName = assays)
  }
  else{
    tbl <- S4Vectors::metadata(inSCE)$assayType
    tbl <- rbind(tbl, tibble::tibble(assayTag = assayType, assayName = assays))
  }
  S4Vectors::metadata(inSCE)$assayType <- tbl
  return(inSCE)
}

#' expTaggedData
#' Returns a list of names of data items from the 
#' input \code{SingleCellExperiment} object based upon the input parameters.
#' @param inSCE Input \code{SingleCellExperiment} object.
#' @param tags A \code{character()} value indicating if the data items should 
#' be returned separated by the specified tags. Default is \code{NULL} 
#' indicating that returned names of the data items are simply returned as a 
#' list with default tag as "uncategorized".
#' @param redDims A \code{logical} value indicating if \code{reducedDims} 
#' should be returned as well separated with 'redDims' tag.
#' @param recommended A \code{character()} vector indicating the tags that 
#' should be displayed as recommended. Default is \code{NULL}.
#' @param showTags A \code{logical} value indicating if the tags should be 
#' shown. If \code{FALSE}, output is just a simple list, not separated by tags.
#' @return A \code{list} of names of data items specified by the other 
#' parameters.
#' @importFrom stats filter
#' @importFrom tibble tibble
#' @importFrom rlang .data
#' @export
#' @examples 
#' data(scExample, package = "singleCellTK")
#' sce <- expSetDataTag(sce, "raw", "counts")
#' tags <- expTaggedData(sce)
expTaggedData <- function(inSCE, tags = NULL, redDims = FALSE, recommended = NULL, showTags = TRUE){
  namedList <- NULL
  tbl <- S4Vectors::metadata(inSCE)$assayType 
  
  if(!is.null(tags)){
    tbl <- tbl %>% dplyr::filter(.data$assayTag %in% tags)
  }
  
  if(redDims){
    tbl <- rbind(tbl, tibble::tibble(assayTag = "redDims", assayName = reducedDimNames(inSCE)))
  }
  
  if(!is.null(recommended)){
    recIx <- which(tbl$assayTag %in% recommended)
    if(length(recIx) > 0){
      tbl[recIx, ]$assayTag <- paste0(tbl$assayTag[recIx], " (recommended)")
      tbl <- rbind(tbl[recIx, ], tbl[-recIx, ])
      tbl$assayTag <- factor(tbl$assayTag, levels=unique(tbl$assayTag))
    }
  }
  
  if(!showTags){
    namedList <- as.character(tbl$assayName)
  }
  else{
    namedList <- with(tbl, split(tbl$assayName, tbl$assayTag))
    namedList <- lapply(namedList, vapply, list, list(length(namedList)))
  }

  return(namedList)
}

setClassUnion("CharacterOrNullOrMissing", c("character", "NULL", "missing"))
#' expData
#' Store data items using tags to identify the type of data item stored. To be used as a replacement for assay<- setter function but with additional parameter to set a tag to a data item.
#' @param inSCE Input \code{SingleCellExperiment} object.
#' @param assayName Specify the name of the input assay.
#' @param tag Specify the tag to store against the input assay. Default is \code{NULL}, which will set the tag to "uncategorized".
#' @param altExp A \code{logical} value indicating if the input assay is a \code{altExp} or a subset assay.
#' @param value An input matrix-like value to store in the SCE object.
#' @return A \code{SingleCellExperiment} object containing the newly stored data.
#' @export
#' @examples 
#' data(scExample, package = "singleCellTK")
#' mat <- expData(sce, "counts")
#' expData(sce, "counts", tag = "raw") <- mat
setGeneric(name = "expData<-",
           function(inSCE, assayName, tag = NULL, altExp = FALSE, value)
             SummarizedExperiment::`assay<-`(x = inSCE,
                                             i = assayName,
                                             value = value)
)

#' expData
#' Store data items using tags to identify the type of data item stored. To be used as a replacement for assay<- setter function but with additional parameter to set a tag to a data item.
#' @param inSCE Input \code{SingleCellExperiment} object.
#' @param assayName Specify the name of the input assay.
#' @param tag Specify the tag to store against the input assay. Default is \code{NULL}, which will set the tag to "uncategorized".
#' @param altExp A \code{logical} value indicating if the input assay is a \code{altExp} or a subset assay.
#' @param value An input matrix-like value to store in the SCE object.
#' @return A \code{SingleCellExperiment} object containing the newly stored data.
#' @export
#' @examples 
#' data(scExample, package = "singleCellTK")
#' mat <- expData(sce, "counts")
#' expData(sce, "counts", tag = "raw") <- mat
setMethod(f = "expData<-",
          signature = signature(
            inSCE = "ANY",
            assayName = "character",
            tag = "CharacterOrNullOrMissing",
            altExp = "logical"),
          definition = function(inSCE, assayName, tag = NULL, altExp = FALSE, value){
            if(!is.null(value)){
              if(is.null(tag)
                 || missing(tag)){
                inSCE <- expSetDataTag(
                  inSCE = inSCE,
                  assayType = "uncategorized",
                  assays = assayName
                )
              }
              else{
                inSCE <- expSetDataTag(
                  inSCE = inSCE,
                  assayType = tag,
                  assays = assayName
                )
              }
            }
            else{
              inSCE <- expDeleteDataTag(
                inSCE = inSCE,
                assay = assayName
              )
            }
            if(altExp){
              if (inherits(value, "SummarizedExperiment")) {
                altExp(inSCE, assayName) <- value
              } else {
                altExp(inSCE, assayName) <- SingleCellExperiment(list(counts = value))
                SummarizedExperiment::assayNames(altExp(inSCE, assayName)) <- assayName
              }
            }
            else{
                inSCE <- methods::callNextMethod()
            }
            return(inSCE)
          }
)

#' expData
#' Get data item from an input \code{SingleCellExperiment} object. The data item can be an \code{assay}, \code{altExp} (subset) or a \code{reducedDim}, which is retrieved based on the name of the data item.
#' @param inSCE Input \code{SingleCellExperiment} object.
#' @param assayName Specify the name of the data item to retrieve.
#' @return Specified data item.
#' @export
#' @examples 
#' data(scExample, package = "singleCellTK")
#' mat <- expData(sce, "counts")
setGeneric(name = "expData",
           function(inSCE, assayName)
             SummarizedExperiment::assay(x = inSCE,
                                         i = assayName)
)

#' expData
#' Get data item from an input \code{SingleCellExperiment} object. The data item can be an \code{assay}, \code{altExp} (subset) or a \code{reducedDim}, which is retrieved based on the name of the data item.
#' @param inSCE Input \code{SingleCellExperiment} object.
#' @param assayName Specify the name of the data item to retrieve.
#' @return Specified data item.
#' @export
#' @examples 
#' data(scExample, package = "singleCellTK")
#' mat <- expData(sce, "counts")
setMethod(f = "expData",
          signature = signature(inSCE = "ANY", assayName = "character"),
          definition = function(inSCE,  assayName){
            result <- NULL
            if(assayName %in% altExpNames(inSCE)){
              result <- altExp(inSCE, assayName)
              if(nrow(inSCE)<=nrow(result)
                 && ncol(inSCE) <= ncol(result)){
                inSCE <- result[rownames(inSCE), colnames(inSCE)]
              }
              else{
                inSCE <- result
              }
              result <- methods::callNextMethod()
            }
            else if (assayName %in% reducedDimNames(inSCE)){
              result <- reducedDim(inSCE, assayName)
            }
            else{
              result <- methods::callNextMethod()
            }
           return(result)
          }
)

#' expDataNames
#' Get names of all the data items in the input \code{SingleCellExperiment} object including assays, altExps and reducedDims.
#' @param inSCE Input \code{SingleCellExperiment} object.
#' @return A combined \code{vector} of \code{assayNames}, \code{altExpNames} and \code{reducedDimNames}.
#' @export
#' @examples 
#' data(scExample, package = "singleCellTK")
#' expDataNames(sce)
setGeneric(name = "expDataNames",
           function(inSCE)
             SummarizedExperiment::assayNames(x = inSCE)
)

#' expDataNames
#' Get names of all the data items in the input \code{SingleCellExperiment} object including assays, altExps and reducedDims.
#' @param inSCE Input \code{SingleCellExperiment} object.
#' @return A combined \code{vector} of \code{assayNames}, \code{altExpNames} and \code{reducedDimNames}.
#' @export
#' @examples 
#' data(scExample, package = "singleCellTK")
#' expDataNames(sce)
setMethod(f = "expDataNames",
          signature = signature(inSCE = "ANY"),
          definition = function(inSCE){
            result <- c(methods::callNextMethod(), altExpNames(inSCE), reducedDimNames(inSCE))
            return(result)
          }
)

# This utility function removes the redDims from untagged assays for use in expTaggedData function.
.filterRedDims <- function(inSCE, untaggedAssays){
  notRedDims <- untaggedAssays[!untaggedAssays %in% reducedDimNames(inSCE)]
  return(notRedDims)
}

# sctkTagging functions
library(singleCellTK)
context("Testing sctkTagging functions")
data(scExample, package = "singleCellTK")

test_that(desc = "Testing tagging mechanism", {
  sce <- expSetDataTag(
    inSCE = sce, 
    assayType = "raw",
    assays = assayNames(sce))
  testthat::expect_true(!is.null(metadata(sce)$assayType))
  testthat::expect_equal(metadata(sce)$assayType$assayTag[1], "raw")
  testthat::expect_equal(metadata(sce)$assayType$assayName[1], "counts")
  
  tags <- expTaggedData(
    inSCE = sce,
    tags = "raw",
    redDims = TRUE,
    recommended = "raw",
    showTags = FALSE
  )
  testthat::expect_length(tags, 1)
  testthat::expect_equal(tags, "counts")
  testthat::expect_true(inherits(tags, "character"))
  
  tags <- expTaggedData(
    inSCE = sce,
    tags = "raw",
    redDims = TRUE,
    recommended = "raw",
    showTags = TRUE
  )
  testthat::expect_length(tags, 1)
  testthat::expect_equal(names(tags), "raw (recommended)")
  testthat::expect_true(inherits(tags, "list"))
  
  counts <- expData(sce, "counts")
  testthat::expect_true(inherits(expData(sce, "counts"), "dgCMatrix"))
  
  expData(sce, "counts") <- counts
  testthat::expect_true(inherits(expData(sce, "counts"), "dgCMatrix"))
  
  assayNames <- expDataNames(sce)
  testthat::expect_length(assayNames, 1)
  testthat::expect_equal(assayNames, "counts")
  
  sce <- expDeleteDataTag(sce, "counts")
  testthat::expect_true(!is.null(metadata(sce)$assayType))
  testthat::expect_equal(nrow(metadata(sce)$assayType), 0)
})

#' Check if the specified MAST result in SingleCellExperiment object is
#' complete. But does not garantee the biological correctness.
#' @param inSCE \linkS4class{SingleCellExperiment} inherited object. a
#' differential expression analysis function has to be run in advance.
#' @param useResult character. A string specifying the \code{analysisName}
#' used when running a differential expression analysis function.
#' @param labelBy A single character for a column of \code{rowData(inSCE)} as
#' where to search for the labeling text. Default \code{NULL}.
#' @return Stop point if found
#' @noRd
.checkDiffExpResultExists <- function(inSCE, useResult, labelBy = NULL){
  if(!inherits(inSCE, 'SingleCellExperiment')){
    stop('Given object is not a valid SingleCellExperiment object.')
  }
  if(!'diffExp' %in% names(S4Vectors::metadata(inSCE))){
    stop('"diffExp" not in metadata, please run runMAST() first.')
  }
  if(!useResult %in% names(S4Vectors::metadata(inSCE)$diffExp)){
    p <- paste0('"', useResult, '"', ' not in metadata(inSCE)$diffExp. ')
    stop(p,
         'Please check.')
  }
  result <- S4Vectors::metadata(inSCE)$diffExp[[useResult]]
  if(!all(c('groupNames', 'select', 'result', 'useAssay') %in% names(result))){
    p <- paste0('"', useResult, '"', ' result is not complete. ')
    stop(p,
         'You might need to rerun it.')
  }
  if(!is.null(labelBy)){
    if(!labelBy %in% names(SummarizedExperiment::rowData(inSCE))){
      stop("labelBy: '", labelBy, "' not found.")
    }
  }
}

#' Generate violin plot to show the expression of top DEGs
#' @details Any of the differential expression analysis method from SCTK should
#' be performed prior to using this function
#' @param inSCE \linkS4class{SingleCellExperiment} inherited object.
#' @param useResult character. A string specifying the \code{analysisName}
#' used when running a differential expression analysis function.
#' @param threshP logical. Whether to plot threshold values from adaptive
#' thresholding, instead of using the assay used by \code{runMAST()}. Default
#' \code{FALSE}.
#' @param labelBy A single character for a column of \code{rowData(inSCE)} as
#' where to search for the labeling text. Default \code{NULL}.
#' @param nrow Integer. Number of rows in the plot grid. Default \code{6}.
#' @param ncol Integer. Number of columns in the plot grid. Default \code{6}.
#' @param defaultTheme Logical scalar. Whether to use default SCTK theme in
#' ggplot. Default \code{TRUE}.
#' @param isLogged Logical scalar. Whether the assay used for the analysis is
#' logged. If not, will do a \code{log(assay + 1)} transformation. Default
#' \code{TRUE}.
#' @param check_sanity Logical scalar. Whether to perform MAST's sanity check
#' to see if the counts are logged. Default \code{TRUE}
#' @return A ggplot object of violin plot
#' @export
#' @examples
#' data("sceBatches")
#' logcounts(sceBatches) <- log1p(counts(sceBatches))
#' sce.w <- subsetSCECols(sceBatches, colData = "batch == 'w'")
#' sce.w <- runWilcox(sce.w, class = "cell_type",
#'                    classGroup1 = "alpha", classGroup2 = "beta",
#'                    groupName1 = "w.alpha", groupName2 = "w.beta",
#'                    analysisName = "w.aVSb")
#' plotDEGViolin(sce.w, "w.aVSb")
plotDEGViolin <- function(inSCE, useResult, threshP = FALSE, labelBy = NULL,
                          nrow = 6, ncol = 6, defaultTheme = TRUE,
                          isLogged = TRUE, check_sanity = TRUE){
  #TODO: DO we split the up/down regulation too?
  # Check
  .checkDiffExpResultExists(inSCE, useResult, labelBy)
  # Extract
  result <- S4Vectors::metadata(inSCE)$diffExp[[useResult]]
  deg <- result$result
  useAssay <- result$useAssay
  useReducedDim <- result$useReducedDim
  deg <- deg[order(deg$FDR),]
  geneToPlot <- deg[seq_len(min(nrow(deg), nrow*ncol)), "Gene"]
  groupName1 <- result$groupNames[1]
  ix1 <- result$select$ix1
  cells1 <- colnames(inSCE)[ix1]
  groupName2 <- result$groupNames[2]
  ix2 <- result$select$ix2
  cells2 <- colnames(inSCE)[ix2]
  if (!is.null(useAssay)) {
    if(!is.null(labelBy)){
      replGeneName <- SummarizedExperiment::rowData(inSCE[geneToPlot,])[[labelBy]]
    } else {
      replGeneName <- geneToPlot
    }
    expres <- expData(inSCE[geneToPlot, c(cells1, cells2)],
                      useAssay)
    useMat <- useAssay
  } else {
    if(!is.null(labelBy)){
      warning("Analysis performed on reducedDim. Cannot use rowData for ",
              "labelBy. Ignored.")
    }
    replGeneName <- geneToPlot
    expres <- t(expData(inSCE[, c(cells1, cells2)], useReducedDim))[geneToPlot,]
    useMat <- useReducedDim
  }

  if(!is.matrix(expres)){
    expres <- as.matrix(expres)
  }
  rownames(expres) <- replGeneName
  # Format
  cdat <- data.frame(wellKey = colnames(expres),
                     condition = factor(c(rep(groupName1, length(cells1)),
                                          rep(groupName2, length(cells2))),
                                        levels = result$groupNames),
                     ngeneson = rep("", (length(cells1) + length(cells2))),
                     stringsAsFactors = FALSE)
  if (!isTRUE(isLogged)) {
    expres <- log(expres + 1)
  }
  sca <- suppressMessages(MAST::FromMatrix(expres, cdat,
                                           check_sanity = check_sanity))
  if(threshP){
    #TODO: if nrow*ncol < `min_per_bin`` below, there would be an error.
    invisible(utils::capture.output(thres <-
                                      MAST::thresholdSCRNACountMatrix(expres, nbins = 20,
                                                                      min_per_bin = 30)))
    SummarizedExperiment::assay(sca) <- thres$counts_threshold
  }
  flatDat <- methods::as(sca, "data.table")
  flatDat$primerid <- factor(flatDat$primerid, levels = replGeneName)
  names(flatDat)[5] <- useMat
  # Plot
  violinplot <- ggplot2::ggplot(flatDat,
                                ggplot2::aes_string(x = 'condition',
                                                    y = useMat,
                                                    color = 'condition')) +
    ggplot2::geom_jitter() +
    ggplot2::facet_wrap(~primerid, scale = "free_y",
                        ncol = ncol) +
    ggplot2::geom_violin() +
    ggplot2::ggtitle(paste0("Violin Plot for ", useResult))
  if(isTRUE(defaultTheme)){
    violinplot <- .ggSCTKTheme(violinplot)
  }
  return(violinplot)
}

#' Create linear regression plot to show the expression the of top DEGs
#' @details Any of the differential expression analysis method from SCTK should
#' be performed prior to using this function
#' @param inSCE \linkS4class{SingleCellExperiment} inherited object.
#' @param useResult character. A string specifying the \code{analysisName}
#' used when running a differential expression analysis function.
#' @param threshP logical. Whether to plot threshold values from adaptive
#' thresholding, instead of using the assay used by when performing DE analysis.
#' Default \code{FALSE}.
#' @param labelBy A single character for a column of \code{rowData(inSCE)} as
#' where to search for the labeling text. Default \code{NULL}.
#' @param nrow Integer. Number of rows in the plot grid. Default \code{6}.
#' @param ncol Integer. Number of columns in the plot grid. Default \code{6}.
#' @param defaultTheme Logical scalar. Whether to use default SCTK theme in
#' ggplot. Default \code{TRUE}.
#' @param isLogged Logical scalar. Whether the assay used for the analysis is
#' logged. If not, will do a \code{log(assay + 1)} transformation. Default
#' \code{TRUE}.
#' @param check_sanity Logical scalar. Whether to perform MAST's sanity check
#' to see if the counts are logged. Default \code{TRUE}
#' @return A ggplot object of linear regression
#' @export
#' @examples
#' data("sceBatches")
#' logcounts(sceBatches) <- log1p(counts(sceBatches))
#' sce.w <- subsetSCECols(sceBatches, colData = "batch == 'w'")
#' sce.w <- runWilcox(sce.w, class = "cell_type",
#'                    classGroup1 = "alpha", classGroup2 = "beta",
#'                    groupName1 = "w.alpha", groupName2 = "w.beta",
#'                    analysisName = "w.aVSb")
#' plotDEGRegression(sce.w, "w.aVSb")
plotDEGRegression <- function(inSCE, useResult, threshP = FALSE, labelBy = NULL,
                              nrow = 6, ncol = 6, defaultTheme = TRUE,
                              isLogged = TRUE, check_sanity = TRUE){
  #TODO: DO we split the up/down regulation too?
  # Check
  .checkDiffExpResultExists(inSCE, useResult, labelBy)
  # Extract
  result <- S4Vectors::metadata(inSCE)$diffExp[[useResult]]
  deg <- result$result
  useReducedDim <- result$useReducedDim
  useAssay <- result$useAssay
  geneToPlot <- deg[seq_len(min(nrow(deg), nrow*ncol)), "Gene"]
  groupName1 <- result$groupNames[1]
  ix1 <- result$select$ix1
  cells1 <- colnames(inSCE)[ix1]
  groupName2 <- result$groupNames[2]
  ix2 <- result$select$ix2
  cells2 <- colnames(inSCE)[ix2]
  if (!is.null(useAssay)) {
    if(!is.null(labelBy)){
      replGeneName <- SummarizedExperiment::rowData(inSCE[geneToPlot,])[[labelBy]]
    } else {
      replGeneName <- geneToPlot
    }
    expres <- expData(inSCE[geneToPlot, c(cells1, cells2)],
                      useAssay)
    useMat <- useAssay
  } else {
    if (!is.null(labelBy)) {
      warning("Analysis performed on reducedDim. Cannot use rowData for ",
              "labelBy. Ignored.")
    }
    replGeneName <- geneToPlot
    expres <- t(expData(inSCE[,c(cells1, cells2)], useReducedDim))[geneToPlot,]
    useMat <- useReducedDim
  }
  if(!is.matrix(expres)){
    expres <- as.matrix(expres)
  }
  rownames(expres) <- replGeneName
  # Format
  cdat <- data.frame(wellKey = colnames(expres),
                     condition = factor(c(rep(groupName1, length(cells1)),
                                          rep(groupName2, length(cells2))),
                                        levels = result$groupNames),
                     ngeneson = rep("", (length(cells1) + length(cells2))),
                     stringsAsFactors = FALSE)
  if (!isTRUE(isLogged)) {
    expres <- log(expres + 1)
  }
  sca <- suppressMessages(MAST::FromMatrix(expres, cData = cdat,
                                           check_sanity = check_sanity))
  cdr2 <- colSums(SummarizedExperiment::assay(sca) > 0)
  SummarizedExperiment::colData(sca)$cngeneson <- scale(cdr2)
  if(length(unique(SummarizedExperiment::colData(sca)$cngeneson)) < 2){
    stop("Standardized cellular detection rate not various, unable to plot.")
  }
  if(threshP){
    #TODO: if nrow*ncol < `min_per_bin`` below, there would be an error.
    invisible(utils::capture.output(thres <-
                                      MAST::thresholdSCRNACountMatrix(expres,
                                                                      nbins = 20,
                                                                      min_per_bin = 30)))
    SummarizedExperiment::assay(sca) <- thres$counts_threshold
  }
  flatDat <- methods::as(sca, "data.table")
  flatDat$primerid <- factor(flatDat$primerid, levels = replGeneName)
  names(flatDat)[6] <- useMat
  # Calculate
  resData <- NULL
  for (i in unique(flatDat$primerid)){
    resdf <- flatDat[flatDat$primerid == i, ]
    resdf$lmPred <- stats::lm(
      stats::as.formula(paste0(useMat, "~cngeneson+", 'condition')),
      data = flatDat[flatDat$primerid == i, ])$fitted
    if (is.null(resData)){
      resData <- resdf
    } else {
      resData <- rbind(resData, resdf)
    }
  }
  # Plot
  ggbase <- ggplot2::ggplot(resData, ggplot2::aes_string(
    x = 'condition',
    y = useMat,
    color = 'condition')) +
    ggplot2::geom_jitter() +
    ggplot2::facet_wrap(~primerid, scale = "free_y",
                        ncol = ncol)
  regressionplot <- ggbase +
    ggplot2::aes_string(x = "cngeneson") +
    ggplot2::geom_line(ggplot2::aes_string(y = "lmPred"),
                       lty = 1) +
    ggplot2::xlab("Standardized Cellular Detection Rate") +
    ggplot2::ggtitle(paste0("Linear Model Plot for ",
                            useResult))
  if(isTRUE(defaultTheme)){
    regressionplot <- .ggSCTKTheme(regressionplot)
  }
  return(regressionplot)
}

#' Get Top Table of a DEG analysis
#' @description Users have to run \code{runDEAnalysis()} first, any of the
#' wrapped functions of this generic function. Users can set further filters on
#' the result. A \code{data.frame} object, with variables of \code{Gene},
#' \code{Log2_FC}, \code{Pvalue}, and \code{FDR}, will be returned.
#' @param inSCE \linkS4class{SingleCellExperiment} inherited object, with of the
#' singleCellTK DEG method performed in advance.
#' @param useResult character. A string specifying the \code{analysisName}
#' used when running a differential expression analysis function.
#' @param labelBy A single character for a column of \code{rowData(inSCE)} as
#' where to search for the labeling text. Leave \code{NULL} for \code{rownames}.
#' Default \code{metadata(inSCE)$featureDisplay} (see
#' \code{\link{setSCTKDisplayRow}}).
#' @param onlyPos logical. Whether to only fetch DEG with positive log2_FC
#' value. Default \code{FALSE}.
#' @param log2fcThreshold numeric. Only fetch DEGs with the absolute values of
#' log2FC larger than this value. Default \code{0.25}.
#' @param fdrThreshold numeric. Only fetch DEGs with FDR value smaller than this
#' value. Default \code{0.05}.
#' @param minGroup1MeanExp numeric. Only fetch DEGs with mean expression in
#' group1 greater then this value. Default \code{NULL}.
#' @param maxGroup2MeanExp numeric. Only fetch DEGs with mean expression in
#' group2 less then this value. Default \code{NULL}.
#' @param minGroup1ExprPerc numeric. Only fetch DEGs expressed in greater then
#' this fraction of cells in group1. Default \code{NULL}.
#' @param maxGroup2ExprPerc numeric. Only fetch DEGs expressed in less then this
#' fraction of cells in group2. Default \code{NULL}.
#' @return A \code{data.frame} object of the top DEGs, with variables of
#' \code{Gene}, \code{Log2_FC}, \code{Pvalue}, and \code{FDR}.
#' @export
#' @examples
#' data("sceBatches")
#' sceBatches <- scaterlogNormCounts(sceBatches, "logcounts")
#' sce.w <- subsetSCECols(sceBatches, colData = "batch == 'w'")
#' sce.w <- runWilcox(sce.w, class = "cell_type",
#'                    classGroup1 = "alpha", classGroup2 = "beta",
#'                    groupName1 = "w.alpha", groupName2 = "w.beta",
#'                    analysisName = "w.aVSb")
#' getDEGTopTable(sce.w, "w.aVSb")
getDEGTopTable <- function(inSCE, useResult,
                           labelBy = S4Vectors::metadata(inSCE)$featureDisplay,
                           onlyPos = FALSE, log2fcThreshold = 0.25,
                           fdrThreshold = 0.05, minGroup1MeanExp = NULL,
                           maxGroup2MeanExp = NULL, minGroup1ExprPerc = NULL,
                           maxGroup2ExprPerc = NULL){
  # Check
  .checkDiffExpResultExists(inSCE, useResult, labelBy)
  # Extract
  result <- S4Vectors::metadata(inSCE)$diffExp[[useResult]]$result
  if (!is.null(labelBy)) {
    genes <- result$Gene
    geneIdx <- featureIndex(genes, inSCE)
    result$Gene <- SummarizedExperiment::rowData(inSCE)[[labelBy]][geneIdx]
  }
  # Filter
  result <- .filterDETable(result, onlyPos, log2fcThreshold, fdrThreshold,
                           minGroup1MeanExp, maxGroup2MeanExp,
                           minGroup1ExprPerc, maxGroup2ExprPerc)
  return(result)
}

#' Heatmap visualization of DEG result
#'
#' @details A differential expression analysis function has to be run in advance
#' so that information is stored in the metadata of the input SCE object. This
#' function wraps \code{\link{plotSCEHeatmap}}.
#' A feature annotation basing on the log2FC level called \code{"regulation"}
#' will be automatically added. A cell annotation basing on the condition
#' selection while running the analysis called \code{"condition"}, and the
#' annotations used from \code{colData(inSCE)} while setting the condition and
#' covariates will also be added.
#' @param inSCE \linkS4class{SingleCellExperiment} inherited object.
#' @param useResult character. A string specifying the \code{analysisName}
#' used when running a differential expression analysis function.
#' @param doLog Logical scalar. Whether to do \code{log(assay + 1)}
#' transformation on the assay used for the analysis. Default \code{FALSE}.
#' @param onlyPos logical. Whether to only plot DEG with positive log2_FC
#' value. Default \code{FALSE}.
#' @param log2fcThreshold numeric. Only plot DEGs with the absolute values of
#' log2FC larger than this value. Default \code{0.25}.
#' @param fdrThreshold numeric. Only plot DEGs with FDR value smaller than this
#' value. Default \code{0.05}.
#' @param minGroup1MeanExp numeric. Only plot DEGs with mean expression in
#' group1 greater then this value. Default \code{NULL}.
#' @param maxGroup2MeanExp numeric. Only plot DEGs with mean expression in
#' group2 less then this value. Default \code{NULL}.
#' @param minGroup1ExprPerc numeric. Only plot DEGs expressed in greater then
#' this fraction of cells in group1. Default \code{NULL}.
#' @param maxGroup2ExprPerc numeric. Only plot DEGs expressed in less then this
#' fraction of cells in group2. Default \code{NULL}.
#' @param useAssay character. A string specifying an assay of expression value
#' to plot. By default the assay used for \code{runMAST()} will be used.
#' Default \code{NULL}.
#' @param featureAnnotations \code{data.frame}, with \code{rownames} containing
#' all the features going to be plotted. Character columns should be factors.
#' Default \code{NULL}.
#' @param cellAnnotations \code{data.frame}, with \code{rownames} containing
#' all the cells going to be plotted. Character columns should be factors.
#' Default \code{NULL}.
#' @param featureAnnotationColor A named list. Customized color settings for
#' feature labeling. Should match the entries in the \code{featureAnnotations}
#' or \code{rowDataName}. For each entry, there should be a list/vector of
#' colors named with categories. Default \code{NULL}.
#' @param cellAnnotationColor A named list. Customized color settings for
#' cell labeling. Should match the entries in the \code{cellAnnotations} or
#' \code{colDataName}. For each entry, there should be a list/vector of colors
#' named with categories. Default \code{NULL}.
#' @param rowDataName character. The column name(s) in \code{rowData} that need
#' to be added to the annotation. Default \code{NULL}.
#' @param colDataName character. The column name(s) in \code{colData} that need
#' to be added to the annotation. Default \code{NULL}.
#' @param rowSplitBy character. Do semi-heatmap based on the grouping of
#' this(these) annotation(s). Should exist in either \code{rowDataName} or
#' \code{names(featureAnnotations)}. Default \code{"regulation"}.
#' @param colSplitBy character. Do semi-heatmap based on the grouping of
#' this(these) annotation(s). Should exist in either \code{colDataName} or
#' \code{names(cellAnnotations)}. Default \code{"condition"}.
#' @param rowLabel \code{FALSE} for not displaying; a variable in \code{rowData}
#' to display feature identifiers stored there; if have run
#' \code{\link{setSCTKDisplayRow}}, display the specified feature name;
#' \code{TRUE} for the \code{rownames} of \code{inSCE}; \code{NULL} for
#' auto-display \code{rownames} when the number of filtered feature is less
#' than 60. Default looks for \code{\link{setSCTKDisplayRow}} information.
#' @param title character. Main title of the heatmap. Default
#' \code{"DE Analysis: <useResult>"}.
#' @param ... Other arguments passed to \code{\link{plotSCEHeatmap}}
#' @examples
#' data("sceBatches")
#' logcounts(sceBatches) <- log1p(counts(sceBatches))
#' sce.w <- subsetSCECols(sceBatches, colData = "batch == 'w'")
#' sce.w <- runWilcox(sce.w, class = "cell_type",
#'                    classGroup1 = "alpha", classGroup2 = "beta",
#'                    groupName1 = "w.alpha", groupName2 = "w.beta",
#'                    analysisName = "w.aVSb")
#' plotDEGHeatmap(sce.w, "w.aVSb")
#' @return A \code{\link[ggplot2]{ggplot}} object
#' @export
#' @author Yichen Wang
plotDEGHeatmap <- function(inSCE, useResult, onlyPos = FALSE,
                           log2fcThreshold = 0.25, fdrThreshold = 0.05,
                           minGroup1MeanExp = NULL, maxGroup2MeanExp = NULL,
                           minGroup1ExprPerc = NULL, maxGroup2ExprPerc = NULL,
                           useAssay = NULL, doLog = FALSE,
                           featureAnnotations = NULL,
                           cellAnnotations = NULL,
                           featureAnnotationColor = NULL,
                           cellAnnotationColor = NULL,
                           rowDataName = NULL, colDataName = NULL,
                           colSplitBy = 'condition', rowSplitBy = 'regulation',
                           rowLabel = S4Vectors::metadata(inSCE)$featureDisplay,
                           title = paste0("DE Analysis: ", useResult), ...){
  # Check
  .checkDiffExpResultExists(inSCE, useResult)
  extraArgs <- list(...)
  warnArgs <- c('featureIndex', 'cellIndex')
  if(any(warnArgs %in% names(extraArgs))){
    warning('"', paste(warnArgs[warnArgs %in% names(extraArgs)],
                       collapse = ', '), '" are not allowed at this point.')
    extraArgs[c('cellIndex', 'featureIndex')] <- NULL
  }
  # Extract
  result <- S4Vectors::metadata(inSCE)$diffExp[[useResult]]
  if (!is.null(result$useReducedDim)) {
    # Analysis performed with reducedDim, cannot set useAssay in plotDEGHeatmap
    if (!is.null(useAssay)) {
      warning("Analysis performed on reducedDim, cannot set `useAssay`, ",
              "ignored.")
    }
    useAssay <- NULL
    useReducedDim <- result$useReducedDim
  } else {
    if(is.null(useAssay)){
      useAssay <- result$useAssay
    }
    useReducedDim <- NULL
  }

  ix1 <- result$select$ix1
  ix2 <- result$select$ix2
  deg.filtered <- getDEGTopTable(inSCE, useResult = useResult, labelBy = NULL,
                                 onlyPos = onlyPos,
                                 log2fcThreshold = log2fcThreshold,
                                 fdrThreshold = fdrThreshold,
                                 minGroup1MeanExp, maxGroup2MeanExp,
                                 minGroup1ExprPerc, maxGroup2ExprPerc)
  if(dim(deg.filtered)[1] <= 1){
    stop('Too few genes that pass filtration, unable to plot')
  }
  # Not directly using deg.filtered$Gene because rownames might be deduplicated
  # to avoid error when performing DEG.
  if (!is.null(useReducedDim)) {
    mat <- t(expData(inSCE, useReducedDim))
    assayList <- list(mat)
    names(assayList) <- useReducedDim
    tmpSCE <- SingleCellExperiment::SingleCellExperiment(assays = assayList)
    SummarizedExperiment::colData(tmpSCE) <- SummarizedExperiment::colData(inSCE)
    assayName <- useReducedDim
  } else {
    tmpSCE <- inSCE
    assayName <- useAssay
  }
  gene.ix <- rownames(tmpSCE) %in% deg.filtered$Gene
  cell.ix <- which(ix1 | ix2)
  allGenes <- rownames(tmpSCE)[gene.ix]
  allCells <- colnames(tmpSCE)[cell.ix]

  # Annotation organization
  ## Cells
  group <- rep(NA, ncol(tmpSCE))
  group[ix1] <- result$groupNames[1]
  group[ix2] <- result$groupNames[2]
  group <- factor(group[cell.ix], levels = result$groupNames)
  if(!is.null(cellAnnotations)){
    if(!all(allCells %in% rownames(cellAnnotations))){
      stop('Not all cells involved in comparison found in given ',
           '`cellAnnotations`. ')
    }
    cellAnnotations <- cellAnnotations[allCells, , drop = FALSE]
    cellAnnotations <- data.frame(cellAnnotations, condition = group)
  } else {
    cellAnnotations <- data.frame(condition = group,
                                  row.names = allCells)
  }
  kCol <- celda::distinctColors(2)
  names(kCol) <- result$groupNames
  if(!is.null(cellAnnotationColor)){
    if(!"condition" %in% names(cellAnnotationColor)){
      cellAnnotationColor <- c(list(condition = kCol),
                               cellAnnotationColor)
    }
  } else {
    cellAnnotationColor <- list(condition = kCol)
  }
  if(!is.null(colDataName)){
    if (length(which(colDataName %in% result$annotation)) > 0) {
      colDataName <- colDataName[-which(colDataName %in% result$annotation)]
    }
    colDataName <- c(colDataName, result$annotation)
  } else {
    colDataName <- result$annotation
  }
  ## Genes
  regulation <- vector()
  genes.up <- deg.filtered[deg.filtered$Log2_FC > 0, "Gene"]
  genes.down <- deg.filtered[deg.filtered$Log2_FC < 0, "Gene"]
  regulation[rownames(tmpSCE) %in% genes.up] <- 'up'
  regulation[rownames(tmpSCE) %in% genes.down] <- 'down'
  regulation <- factor(regulation[gene.ix], levels = c('up', 'down'))
  if(!is.null(featureAnnotations)){
    if(!all(allGenes %in% rownames(featureAnnotations))){
      stop('Not all genes involved in comparison found in given ',
           '`featureAnnotations`. ')
    }
    featureAnnotations <- featureAnnotations[allGenes, , drop = FALSE]
    featureAnnotations <- data.frame(featureAnnotations,
                                     regulation = regulation)
  } else {
    featureAnnotations <- data.frame(regulation = regulation,
                                     row.names = allGenes)
  }
  lCol <- celda::distinctColors(2)
  names(lCol) <- c('up', 'down')
  if(!is.null(featureAnnotationColor)){
    if(!"regulation" %in% names(featureAnnotationColor)){
      featureAnnotationColor <- c(list(regulation = lCol),
                                  featureAnnotationColor)
    }
  } else {
    featureAnnotationColor <- list(regulation = lCol)
  }
  if (is.null(rowLabel) & nrow(deg.filtered) < 60) {
    rowLabel <- TRUE
  }
  # Plot
  hm <- plotSCEHeatmap(inSCE = tmpSCE, useAssay = assayName, doLog = doLog,
                       featureIndex = gene.ix, cellIndex = cell.ix,
                       featureAnnotations = featureAnnotations,
                       cellAnnotations = cellAnnotations,
                       rowDataName = rowDataName,
                       colDataName = colDataName,
                       featureAnnotationColor = featureAnnotationColor,
                       cellAnnotationColor = cellAnnotationColor,
                       rowSplitBy = rowSplitBy, colSplitBy = colSplitBy,
                       title = title, rowLabel = rowLabel, ...)
  return(hm)
}

#' Generate volcano plot for DEGs
#' @details Any of the differential expression analysis method from SCTK should
#' be performed prior to using this function to generate volcano plots.
#' @param inSCE \linkS4class{SingleCellExperiment} inherited object.
#' @param useResult character. A string specifying the \code{analysisName}
#' used when running a differential expression analysis function.
#' @param labelTopN Integer, label this number of top DEGs that pass the
#' filters. \code{FALSE} for not labeling. Default \code{10}.
#' @param log2fcThreshold numeric. Label genes with the absolute values of
#' log2FC greater than this value as regulated. Default \code{0.25}.
#' @param fdrThreshold numeric. Label genes with FDR value less than this
#' value as regulated. Default \code{0.05}.
#' @param featureDisplay A character string to indicate a variable in
#' \code{rowData(inSCE)} for feature labeling. \code{NULL} for using
#' \code{rownames}. Default \code{metadata(inSCE)$featureDisplay} (see
#' \code{\link{setSCTKDisplayRow}})
#' @return A \code{ggplot} object of volcano plot
#' @seealso \code{\link{runDEAnalysis}}, \code{\link{plotDEGHeatmap}}
#' @export
#' @examples
#' data("sceBatches")
#' sceBatches <- scaterlogNormCounts(sceBatches, "logcounts")
#' sce.w <- subsetSCECols(sceBatches, colData = "batch == 'w'")
#' sce.w <- runWilcox(sce.w, class = "cell_type",
#'                    classGroup1 = "alpha", classGroup2 = "beta",
#'                    groupName1 = "w.alpha", groupName2 = "w.beta",
#'                    analysisName = "w.aVSb")
#' plotDEGVolcano(sce.w, "w.aVSb")
plotDEGVolcano <- function(
  inSCE,
  useResult,
  labelTopN = 10,
  log2fcThreshold = 0.25,
  fdrThreshold = 0.05,
  featureDisplay = S4Vectors::metadata(inSCE)$featureDisplay
) {
  .checkDiffExpResultExists(inSCE, useResult, featureDisplay)
  deg <- S4Vectors::metadata(inSCE)$diffExp[[useResult]]$result
  deg <- deg[order(abs(deg$Log2_FC), decreasing = TRUE),]
  if (!is.null(featureDisplay)) {
    geneIdx <- featureIndex(deg$Gene, inSCE)
    deg$Gene <- SummarizedExperiment::rowData(inSCE)[[featureDisplay]][geneIdx]
  }
  rownames(deg) <- deg$Gene
  groupNames <- S4Vectors::metadata(inSCE)$diffExp[[useResult]]$groupNames
  # Prepare for coloring that shows the filtering
  deg$Regulation <- NA
  deg$Regulation[deg$Log2_FC > 0] <- "Up"
  deg$Regulation[deg$Log2_FC < 0] <- "Down"
  if (!is.null(log2fcThreshold)) {
    deg$Regulation[abs(deg$Log2_FC) <= log2fcThreshold] <- "No"
  }
  if (!is.null(fdrThreshold)) {
    deg$Regulation[deg$FDR >= fdrThreshold] <- "No"
  }
  # Prepare for Top DEG text labeling
  passIdx <- deg$Regulation != "No"
  deg$label <- NA
  if (!is.null(labelTopN) & !isFALSE(labelTopN)) {
    labelTopN <- min(labelTopN, length(which(passIdx)))
    if (labelTopN > 0) {
      deg.pass <- deg[passIdx,]
      label.origTable.idx <- deg$Gene %in% deg.pass$Gene[seq(labelTopN)]
      deg$label[label.origTable.idx] <- deg$Gene[label.origTable.idx]
    }
  }
  # Prepare for lines that mark the cutoffs
  vlineLab <- data.frame(
    X = c(-log2fcThreshold, log2fcThreshold),
    text = c(paste("lower log2FC cutoff:", -log2fcThreshold),
             paste("upper log2FC cutoff:", log2fcThreshold)),
    h = c(1.01, -0.01)
  )
  hlineLab <- data.frame(
    Y = c(-log10(fdrThreshold)),
    text = paste("FDR cutoff:", fdrThreshold)
  )
  # Plot
  ggplot2::ggplot() +
    ggplot2::geom_point(data = deg,
                        ggplot2::aes_string(x = "Log2_FC", y = "-log10(FDR)",
                                            col = "Regulation")) +
    ggplot2::scale_color_manual(values = c("Down" = "#619cff",
                                           "No" = "light grey",
                                           "Up" = "#f8766d")) +
    ggrepel::geom_text_repel(data = deg,
                             ggplot2::aes_string(x = "Log2_FC",
                                                 y = "-log10(FDR)",
                                                 label = "label"),
                             colour = "black", na.rm = TRUE) +
    ggplot2::geom_vline(data = vlineLab,
                        ggplot2::aes_string(xintercept = "X"),
                        linetype = "longdash") +
    ggplot2::geom_text(data = vlineLab,
                       ggplot2::aes_string(x = "X", y = 0, label = "text",
                                           hjust = "h"),
                       size = 3, vjust = 1) +
    ggplot2::geom_hline(data = hlineLab,
                        ggplot2::aes_string(yintercept = "Y"),
                        linetype = "longdash") +
    ggplot2::geom_text(data = hlineLab,
                       ggplot2::aes_string(x = -Inf, y = "Y", label = "text"),
                       size = 3, vjust = -0.5, hjust = -.03) +
    ggplot2::xlab("Fold Change (log2)") +
    ggplot2::ylab("FDR (-Log10 q-value)") +
    ggplot2::theme(panel.grid.major = ggplot2::element_blank(),
                   panel.grid.minor = ggplot2::element_blank(),
                   panel.background = ggplot2::element_blank(),
                   axis.line = ggplot2::element_line(colour = "black")) +
    ggplot2::xlim(-max(abs(deg$Log2_FC)), max(abs(deg$Log2_FC))) +
    ggplot2::ggtitle(paste("DEG between", groupNames[1],
                           "and", groupNames[2]))
}

#' MAST Identify adaptive thresholds
#'
#' Calculate and produce a list of thresholded counts (on natural scale),
#' thresholds, bins, densities estimated on each bin, and the original data from
#' \code{\link[MAST]{thresholdSCRNACountMatrix}}
#' @param inSCE SingleCellExperiment object
#' @param useAssay character, default \code{"logcounts"}
#' @param doPlot Logical scalar. Whether to directly plot in the plotting area.
#' If \code{FALSE}, will return a graphical object which can be visualized with
#' \code{grid.draw()}. Default \code{TRUE}.
#' @param isLogged Logical scalar. Whether the assay used for the analysis is
#' logged. If not, will do a \code{log(assay + 1)} transformation. Default
#' \code{TRUE}.
#' @param check_sanity Logical scalar. Whether to perform MAST's sanity check
#' to see if the counts are logged. Default \code{TRUE}
#' @return Plot the thresholding onto the plotting region if \code{plot == TRUE}
#' or a graphical object if \code{plot == FALSE}.
#' @export
#' @examples
#' data("mouseBrainSubsetSCE")
#' plotMASTThresholdGenes(mouseBrainSubsetSCE)
plotMASTThresholdGenes <- function(inSCE, useAssay="logcounts", doPlot = TRUE,
                                   isLogged = TRUE, check_sanity = TRUE){
  # data preparation
  expres <- expData(inSCE, useAssay)
  if(!is.matrix(expres)){
    expres <- as.matrix(expres)
  }
  expres <- dedupRowNames(expres)
  fdata <- data.frame(Gene = rownames(expres))
  rownames(fdata) <- fdata$Gene
  SCENew <- MAST::FromMatrix(expres, SingleCellExperiment::colData(inSCE),
                             fdata, check_sanity = check_sanity)
  SCENew <- SCENew[which(MAST::freq(SCENew) > 0), ]
  invisible(utils::capture.output(thres <- MAST::thresholdSCRNACountMatrix(
    SummarizedExperiment::assay(SCENew), nbins = 20, min_per_bin = 30,
    data_log = isLogged)))
  # plotting
  plotNRow <- ceiling(length(thres$valleys) / 4)
  thres.grob <- ggplotify::as.grob(function(){
    graphics::par(mfrow = c(plotNRow, 4), mar = c(3, 3, 2, 1),
        mgp = c(2, 0.7, 0), tck = -0.01, new = TRUE)
    plot(thres)
  })
  if (isTRUE(doPlot)) {
    grid::grid.draw(thres.grob)
  } else {
    return(thres.grob)
  }
}

#' Plot highly variable genes
#'
#' @param inSCE Input \code{SingleCellExperiment} object containing the
#' computations.
#' @param method Select either \code{"vst"}, \code{"mean.var.plot"},
#' \code{"dispersion"} or \code{"modelGeneVar"}.
#' @param useFeatureSubset A character string for the \code{rowData} variable
#' name to store a logical index of selected features. Default \code{NULL}. See
#' details.
#' @param hvgNumber Specify the number of top genes to highlight in red. Default
#' \code{2000}. See details.
#' @param labelsCount Specify the number of data points/genes to label. Should
#' be less than \code{hvgNumber}. Default \code{10}. See details.
#' @param featureDisplay A character string for the \code{rowData} variable name
#' to indicate what type of feature ID should be displayed. If set by
#' \code{\link{setSCTKDisplayRow}}, will by default use it. If \code{NULL}, will
#' use \code{rownames(inSCE)}.
#' @param labelSize Numeric, size of the text label on top HVGs. Default 
#' \code{2}.
#' @param dotSize Numeric, size of the dots of the features. Default \code{2}.
#' @param textSize Numeric, size of the text of axis title, axis label, etc.
#' Default \code{12}.
#' @return ggplot of HVG metrics and top HVG labels
#' @details When \code{hvgNumber = NULL} and \code{useFeature = NULL}, only plot
#' the mean VS variance/dispersion scatter plot. When only \code{hvgNumber} set,
#' label the top \code{hvgNumber} HVGs ranked by the metrics calculated by
#' \code{method}. When \code{useFeatureSubset} set, label the features in
#' the subset on the scatter plot created with \code{method} and ignore
#' \code{hvgNumber}.
#' @export
#' @examples
#' data("mouseBrainSubsetSCE", package = "singleCellTK")
#' mouseBrainSubsetSCE <- runModelGeneVar(mouseBrainSubsetSCE)
#' plotTopHVG(mouseBrainSubsetSCE, method = "modelGeneVar")
#' @seealso \code{\link{runFeatureSelection}}, \code{\link{runSeuratFindHVG}},
#' \code{\link{runModelGeneVar}}, \code{\link{getTopHVG}}
#' @importFrom SummarizedExperiment rowData
#' @importFrom S4Vectors metadata
plotTopHVG <- function(inSCE,
                       method = "modelGeneVar",
                       hvgNumber = 2000,
                       useFeatureSubset = NULL,
                       labelsCount = 10,
                       featureDisplay = metadata(inSCE)$featureDisplay,
                       labelSize = 2, dotSize = 2, textSize = 12
                       )
{
  method <- match.arg(method, choices = c("vst", "mean.var.plot", "dispersion",
                                          "modelGeneVar"))
  metric <- .dfFromHVGMetric(inSCE, method)
  yLabelChoice <- list(vst = "Standardized Variance",
                       mean.var.plot = "Dispersion", dispersion = "Dispersion",
                       modelGeneVar = "Variance")
  x <- metric[,"mean"]
  y <- metric[,"v_plot"]
  if (method == "vst") x <- log(x)
  yAxisLabel <- yLabelChoice[[method]]
  hvgList <- character()
  if (!is.null(useFeatureSubset)) {
    hvgList <- .parseUseFeatureSubset(inSCE, useFeatureSubset,
                                      returnType = "character")
    hvgNumber <- length(hvgList)
  } else if (!is.null(hvgNumber)) {
    hvgList <- getTopHVG(inSCE = inSCE, method = method, hvgNumber = hvgNumber,
                         featureDisplay = NULL, useFeatureSubset = NULL)
  }
  if (is.null(hvgNumber) || hvgNumber == 0) {
    redIdx <- logical()
  } else {
    redIdx <- rownames(inSCE) %in% hvgList[seq(hvgNumber)]
  }
  if (is.null(hvgNumber) || labelsCount == 0) {
    labelIdx <- logical()
  } else {
    labelIdx <- rownames(inSCE) %in% hvgList[seq(labelsCount)]
  }
  if (!is.null(featureDisplay)) {
    labelTxt <- rowData(inSCE)[[featureDisplay]][labelIdx]
  } else {
    labelTxt <- rownames(inSCE)[labelIdx]
  }
  vfplot <- ggplot2::ggplot() +
    ggplot2::geom_point(ggplot2::aes(x = x, y = y), size = dotSize) +
    ggplot2::geom_point(ggplot2::aes(x = subset(x, redIdx),
                                     y = subset(y, redIdx)),
                        colour = "red", size = dotSize) +
    ggplot2::geom_label(ggplot2::aes(x = subset(x, labelIdx),
                                     y = subset(y, labelIdx),
                                     label = labelTxt),
                        colour = "red",
                        size = labelSize) +
    ggplot2::labs(x = "Mean", y = yAxisLabel)
  vfplot <- .ggSCTKTheme(vfplot) +
      ggplot2::theme(text = ggplot2::element_text(size = textSize))
  return(vfplot)
}

.importAnnDataSample <- function(sampleDir = './',
                                 sampleName = 'sample',
                                 delayedArray = FALSE,
                                 class){

  anndata_file <- file.path(sampleDir, paste0(sampleName,'.h5ad',sep=''))
  if (!file.exists(anndata_file)){
    stop("AnnData file not found at specified location. Please check path provided and/or filename.")
  }
  anndata <- ad$read_h5ad(anndata_file)

  counts_matrix <- t((reticulate::py_to_r(anndata$X)))

  if (class == "Matrix") {
    counts_matrix <- .convertToMatrix(counts_matrix)
  } else if (class == "matrix") {
    counts_matrix <- base::as.matrix(counts_matrix)
  }

  if (isTRUE(delayedArray)) {
    counts_matrix <- DelayedArray::DelayedArray(counts_matrix)
  }

  sce_rowdata <- S4Vectors::DataFrame(reticulate::py_to_r(anndata$var))
  sce_coldata <- S4Vectors::DataFrame(reticulate::py_to_r(anndata$obs))
  sce <- SingleCellExperiment(list(counts = counts_matrix),
                              rowData = sce_rowdata,
                              colData = sce_coldata)
  colnames(sce) <- paste0(sampleName,"_",colnames(sce))

  multi_Assay <- reticulate::py_to_r(reticulate::dict(anndata$layers))
  for(assay_name in names(multi_Assay)){
    tryCatch({
      SummarizedExperiment::assay(sce, assay_name, withDimnames = FALSE) <- t(reticulate::py_to_r(multi_Assay[[assay_name]]))
      base::dimnames(SummarizedExperiment::assay(sce, assay_name)) <- base::dimnames(SummarizedExperiment::assay(sce, "counts"))
    }, error = function(x){
      error_message <- paste0("Warning: unable to add '",assay_name,"' from .layers AnnData slot to SCE assay. Skipping. ")
      message(error_message)
    })
  }
  
  multidim_observations <- reticulate::py_to_r(anndata$obsm_keys())
  for(obsm_name in multidim_observations){
    tryCatch({
      SingleCellExperiment::reducedDims(sce)[[obsm_name]] <- reticulate::py_to_r(anndata$obsm[obsm_name])
    }, error = function(x){
      error_message <- paste0("Warning: unable to add '",obsm_name,"' from .obsm AnnData slot to SCE reducedDims. Skipping. ")
      message(error_message)
    })
  }

  unstructured_data <- reticulate::py_to_r(anndata$uns_keys())
  for(uns_name in unstructured_data){
    tryCatch({
      sce@metadata[[sampleName]]$annData[[uns_name]] <- reticulate::py_to_r(anndata$uns[uns_name])
    }, error = function(x){
      error_message <- paste0("Warning: unable to add unstructured data (.uns slot): '",uns_name,"' to SCE metadata. Skipping. ")
      message(error_message)
    })

  }

  return(sce)

}

#' @name importAnnData
#' @rdname importAnnData
#' @title Create a SingleCellExperiment Object from Python AnnData .h5ad files
#' @description This function reads in one or more Python AnnData files in the .h5ad format
#' and returns a single \link[SingleCellExperiment]{SingleCellExperiment} object containing all the
#' AnnData samples by concatenating their counts matrices and related information slots.
#' @param sampleDirs Folder containing the .h5ad file. Can be one of -
#' \itemize{
#'   \item Default \code{current working directory}.
#'   \item Full path to the directory containing the .h5ad file.
#'   E.g \code{sampleDirs = '/path/to/sample'}
#'   \item A vector of folder paths for the samples to import.
#'   E.g. \code{sampleDirs = c('/path/to/sample1', '/path/to/sample2','/path/to/sample3')}
#'   importAnnData will return a single SCE object containing all the samples
#'   with the sample name appended to each colname in colData
#' }
#' @param sampleNames The prefix/name of the .h5ad file without the .h5ad extension
#' e.g. if 'sample.h5ad' is the filename, pass \code{sampleNames = 'sample'}.
#' Can be one of -
#' \itemize{
#'   \item Default \code{sample}.
#'   \item A vector of samples to import. Length of vector must be equal to length of sampleDirs vector
#'   E.g. \code{sampleDirs = c('sample1', 'sample2','sample3')}
#'   importAnnData will return a single SCE object containing all the samples
#'   with the sample name appended to each colname in colData
#' }
#' @param delayedArray Boolean. Whether to read the expression matrix as
#'  \link{DelayedArray} object. Default \code{FALSE}.
#' @param class Character. The class of the expression matrix stored in the SCE
#'  object. Can be one of "Matrix" (as returned by
#'  \link{readMM} function), or "matrix" (as returned by
#'  \link[base]{matrix} function). Default \code{"Matrix"}.
#' @param rowNamesDedup Boolean. Whether to deduplicate rownames. Default 
#'  \code{TRUE}.
#' @details
#' \code{importAnnData} converts scRNA-seq data in the AnnData format to the
#' \code{SingleCellExperiment} object. The .X slot in AnnData is transposed to the features x cells
#' format and becomes the 'counts' matrix in the assay slot. The .vars AnnData slot becomes the SCE rowData
#' and the .obs AnnData slot becomes the SCE colData. Multidimensional data in the .obsm AnnData slot is
#' ported over to the SCE reducedDims slot. Additionally, unstructured data in the .uns AnnData slot is
#' available through the SCE metadata slot.
#' There are 2 currently known minor issues -
#' Anndata python module depends on another python module h5pyto read hd5 format files.
#' If there are errors reading the .h5ad files, such as "ValueError: invalid shape in fixed-type tuple."
#' the user will need to do downgrade h5py by running \code{pip3 install --user h5py==2.9.0}
#' Additionally there might be errors in converting some python objects in the unstructured data slots.
#' There are no known R solutions at present. Refer \url{https://github.com/rstudio/reticulate/issues/209}
#' @return A \code{SingleCellExperiment} object.
#' @examples
#' file.path <- system.file("extdata/annData_pbmc_3k", package = "singleCellTK")
#' \dontrun{
#' sce <- importAnnData(sampleDirs = file.path,
#'                      sampleNames = 'pbmc3k_20by20')
#' }
#' @export
importAnnData <- function(sampleDirs = NULL,
                          sampleNames = NULL,
                          delayedArray = FALSE,
                          class = c("Matrix", "matrix"),
                          rowNamesDedup = TRUE) {

  if (length(sampleDirs)!=length(sampleNames)){
    print(length(sampleDirs))
    print(length(sampleNames))
    stop("Number of sampleDirs must be equal to number of SampleNames. Please provide sample names for all input directories")
  }

  class <- match.arg(class)

  res <- vector("list", length = length(sampleDirs))

  for (i in seq_along(sampleDirs)){
    scei <- .importAnnDataSample(sampleDir = sampleDirs[[i]],
                                 sampleName = sampleNames[[i]],
                                 delayedArray = delayedArray,
                                 class = class)
    res[[i]] <- scei
  }
  sce <- do.call(SingleCellExperiment::cbind, res)
  
  if (isTRUE(rowNamesDedup)) {
    if (any(duplicated(rownames(sce)))) {
      message("Duplicated gene names found, adding '-1', '-2', ",
              "... suffix to them.")
    }
    sce <- dedupRowNames(sce)
  }
  
  return(sce)
}

bcdsHelpModal <- function() {
  modalDialog(
    tags$style(HTML("
      div {
        word-wrap: break-word;
      }
      ")),
    tags$div(
      h3("BCDS Parameters"),
      fluidRow(
        column(4, tags$b("Parameter Name")),
        column(8, tags$b("Description"))
      ),
      tags$hr(),
      fluidRow(
        column(4, "ntop"),
        column(8, "Integer. Indicating number of top variance genes to consider. Default: 500")
      ),
      tags$hr(),
      fluidRow(
        column(4, "srat"),
        column(8, 'Numeric. Indicating ratio between orginal number of "cells" and simulated doublets. Default: 1')
      ),
      tags$hr(),
      fluidRow(
        column(4, "nmax"),
        column(8, 'Maximum number of training rounds; integer or "tune". Default: "tune"')
      ),
      tags$hr(),
      fluidRow(
        column(4, "verb"),
        column(8, "Check off to print progress messages to the console. Default: TRUE")
      ),
      tags$hr(),
      fluidRow(
        column(4, "retRes"),
        column(8, "Check off to return the trained classifier.")
      ),
      tags$hr(),
      fluidRow(
        column(4, "varImp"),
        column(8, "Check off to return variable importance.")
      )
    )
  )
}

#' @title Find doublets using \code{scrublet}.
#' @description A wrapper function that calls \code{scrub_doublets} from python
#'  module \code{scrublet}. Simulates doublets from the observed data and uses
#'  a k-nearest-neighbor classifier to calculate a continuous
#'  \code{scrublet_score} (between 0 and 1) for each transcriptome. The score
#'  is automatically thresholded to generate \code{scrublet_call}, a boolean
#'  array that is \code{TRUE} for predicted doublets and \code{FALSE}
#'  otherwise.
#' @param inSCE A \linkS4class{SingleCellExperiment} object.
#' @param sample Character vector or colData variable name. Indicates which 
#' sample each cell belongs to. Default \code{NULL}.
#' @param useAssay  A string specifying which assay in the SCE to use. Default 
#' \code{"counts"}.
#' @param simDoubletRatio Numeric. Number of doublets to simulate relative to
#' the number of observed transcriptomes. Default \code{2.0}.
#' @param nNeighbors Integer. Number of neighbors used to construct the KNN
#' graph of observed transcriptomes and simulated doublets. If \code{NULL},
#' this is set to \code{round(0.5 * sqrt(n_cells))}. Default \code{NULL}.
#' @param minDist Float Determines how tightly UMAP packs points together. If 
#' \code{NULL}, this is set to \code{0.1}. Default \code{NULL}.
#' @param expectedDoubletRate The estimated doublet rate for the experiment.
#' Default \code{0.1}.
#' @param stdevDoubletRate Uncertainty in the expected doublet rate. Default 
#' \code{0.02}.
#' @param syntheticDoubletUmiSubsampling Numeric. Rate for sampling UMIs when
#' creating synthetic doublets. If \code{1.0}, each doublet is created by simply
#' adding the UMIs from two randomly sampled observed transcriptomes. For
#' values less than 1, the UMI counts are added and then randomly sampled at
#' the specified rate. Defuault \code{1.0}.
#' @param useApproxNeighbors Boolean. Use approximate nearest neighbor method
#' (annoy) for the KNN classifier. Default \code{TRUE}.
#' @param distanceMetric Character. Distance metric used when finding nearest
#' neighbors. See detail. Default \code{"euclidean"}. 
#' @param getDoubletNeighborParents Boolean. If \code{TRUE}, return the
#' parent transcriptomes that generated the doublet neighbors of each
#' observed transcriptome. This information can be used to infer the cell states
#' that generated a given doublet state. Default \code{FALSE}.
#' @param minCounts Numeric. Used for gene filtering prior to PCA. Genes
#' expressed at fewer than \code{minCounts} in fewer than \code{minCells} are
#' excluded. Default \code{3}.
#' @param minCells Integer. Used for gene filtering prior to PCA. Genes
#' expressed at fewer than \code{minCounts} in fewer than \code{minCells} are 
#' excluded. Default \code{3}.
#' @param minGeneVariabilityPctl Numeric. Used for gene filtering prior to
#' PCA. Keep the most highly variable genes (in the top
#' \code{minGeneVariabilityPctl} percentile), as measured by the v-statistic
#' (Klein et al., Cell 2015). Default \code{85}.
#' @param logTransform Boolean. If \code{TRUE}, log-transform the counts matrix
#' (log1p(TPM)). \code{sklearn.decomposition.TruncatedSVD} will be used for
#' dimensionality reduction, unless \code{meanCenter} is \code{TRUE}. Default 
#' \code{FALSE}.
#' @param meanCenter If \code{TRUE}, center the data such that each gene has a
#' mean of \code{0}. \code{sklearn.decomposition.PCA} will be used for
#' dimensionality reduction. Default \code{TRUE}.
#' @param normalizeVariance Boolean. If \code{TRUE}, normalize the data such
#' that each gene has a variance of 1.
#' \code{sklearn.decomposition.TruncatedSVD} will be used for dimensionality
#' reduction, unless \code{meanCenter} is \code{TRUE}. Default \code{TRUE}.
#' @param nPrinComps Integer. Number of principal components used to embed
#' the transcriptomes prior to k-nearest-neighbor graph construction.
#' Default \code{30}.
#' @param tsneAngle Float. Determines angular size of a distant node as measured
#' from a point in the t-SNE plot. If \code{NULL}, it is set to \code{0.5}. 
#' Default \code{NULL}.
#' @param tsnePerplexity Integer. The number of nearest neighbors that is used
#' in other manifold learning algorithms. If \code{NULL}, it is set to 30. 
#' Default \code{NULL}.
#' @param verbose Boolean. If \code{TRUE}, print progress updates. Default
#' \code{TRUE}.
#' @param seed Seed for the random number generator, can be set to \code{NULL}. 
#' Default \code{12345}.
#' @details For the list of valid values for \code{distanceMetric}, see the 
#' documentation for 
#' \href{https://github.com/spotify/annoy#full-python-api}{annoy} (if 
#' \code{useApproxNeighbors} is \code{TRUE}) or 
#' \href{https://scikit-learn.org/stable/modules/generated/sklearn.neighbors.NearestNeighbors.html}{sklearn.neighbors.NearestNeighbors}
#' (if \code{useApproxNeighbors} is  \code{FALSE}). 
#' @return A \linkS4class{SingleCellExperiment} object with
#' \code{scrub_doublets} output appended to the \link{colData} slot. The columns
#' include \code{scrublet_score} and \code{scrublet_call}.
#' @seealso \code{\link{plotScrubletResults}}, \code{\link{runCellQC}}
#' @examples
#' data(scExample, package = "singleCellTK")
#' \dontrun{
#' sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
#' sce <- runScrublet(sce)
#' }
#' @export
#' @importFrom reticulate py_module_available py_set_seed import
#' @importFrom SummarizedExperiment colData colData<- assayNames assayNames<-
#' @importFrom SingleCellExperiment reducedDim<- reducedDims
#' @importFrom S4Vectors metadata metadata<-
runScrublet <- function(inSCE,
                        sample = NULL,
                        useAssay = "counts",
                        simDoubletRatio = 2.0,
                        nNeighbors = NULL,
                        minDist = NULL,
                        expectedDoubletRate = 0.1,
                        stdevDoubletRate = 0.02,
                        syntheticDoubletUmiSubsampling = 1.0,
                        useApproxNeighbors = TRUE,
                        distanceMetric = "euclidean",
                        getDoubletNeighborParents = FALSE,
                        minCounts = 3,
                        minCells = 3L,
                        minGeneVariabilityPctl = 85,
                        logTransform = FALSE,
                        meanCenter = TRUE,
                        normalizeVariance = TRUE,
                        nPrinComps = 30L,
                        tsneAngle = NULL,
                        tsnePerplexity = NULL,
                        verbose = TRUE,
                        seed = 12345) {
  
  if (!reticulate::py_module_available(module = "scrublet")) {
    warning("Cannot find python module 'scrublet', please install Conda and",
            " run sctkPythonInstallConda() or run sctkPythonInstallVirtualEnv().",
            "If one of these have been previously run to install the modules,",
            "make sure to run selectSCTKConda() or selectSCTKVirtualEnvironment(),",
            " respectively, if R has been restarted since the module installation.",
            " Alternatively, Scrublet can be installed on the local machine",
            "with pip (e.g. pip install scrublet) and then the 'use_python()'",
            " function from the 'reticulate' package can be used to select the",
            " correct Python environment.")
    return(inSCE)
  }
  
  if (!is.null(seed)) {
    reticulate::py_set_seed(seed = seed)
  }
  
  tempSCE <- inSCE
  #assayNames(inSCE)[which(useAssay %in% assayNames(inSCE))] <- "counts"
  #useAssay <- "counts"
  
  p <- paste0(date(), " ... Running 'scrublet'")
  message(p)
  
  ##  Getting current arguments values
  argsList <- mget(names(formals()),sys.frame(sys.nframe()))
  argsList <- argsList[!names(argsList) %in% c("inSCE")]
  argsList$packageVersion <- pkg_resources$"require"("scrublet")[[1]]
  
  sample <- .manageCellVar(inSCE, var = sample)
  if (is.null(sample)) {
    sample <- rep(1, ncol(inSCE))
  }
  ## Define result matrix for all samples
  output <- S4Vectors::DataFrame(row.names = colnames(inSCE),
                                 scrublet_score = numeric(ncol(inSCE)),
                                 scrublet_call = logical(ncol(inSCE)))
  
  ## Loop through each sample and run scrublet

  # try/catch block for when Scrublet fails (which can be often)

  # boolean flag variable for if the try/catch works
  successful = FALSE

  result <- tryCatch(
    {
        samples <- unique(sample)
        umapDims <- matrix(ncol = 2,
                         nrow = ncol(inSCE))
        rownames(umapDims) = colnames(inSCE)
        colnames(umapDims) = c("UMAP_1", "UMAP_2")
        
        tsneDims <- matrix(ncol = 2,
                          nrow = ncol(inSCE))
        rownames(tsneDims) = colnames(inSCE)
        colnames(tsneDims) = c("TSNE_1", "TSNE_2")
        
        for (s in samples) {
          sceSampleInd <- sample == s
          sceSample <- inSCE[, sceSampleInd]
          
          mat <- SummarizedExperiment::assay(sceSample, i = useAssay)
          mat <- .convertToMatrix(mat)
          
          scr <- scrublet$Scrublet(counts_matrix = t(mat),
                                  sim_doublet_ratio = simDoubletRatio,
                                  n_neighbors = nNeighbors,
                                  expected_doublet_rate = expectedDoubletRate,
                                  stdev_doublet_rate = stdevDoubletRate)
          
          result <- scr$scrub_doublets(
            synthetic_doublet_umi_subsampling = syntheticDoubletUmiSubsampling,
            use_approx_neighbors = useApproxNeighbors,
            distance_metric = distanceMetric,
            get_doublet_neighbor_parents = getDoubletNeighborParents,
            min_counts = minCounts,
            min_cells = as.integer(minCells),
            min_gene_variability_pctl = minGeneVariabilityPctl,
            log_transform = logTransform,
            mean_center = meanCenter,
            normalize_variance = normalizeVariance,
            n_prin_comps = as.integer(nPrinComps),
            verbose = verbose)
          
          output[sceSampleInd, "scrublet_score"] <- result[[1]]
          output[sceSampleInd, "scrublet_call"] <- result[[2]]
          
          ## Extract UMAP and TSNE coordinates
          if (is.null(nNeighbors) && is.null(minDist)) {
            umap_coordinates <- scrublet$get_umap(scr$manifold_obs_)
          } else if (!is.null(nNeighbors) && !is.null(minDist)) {
            umap_coordinates <- scrublet$get_umap(
              scr$manifold_obs_,
              n_neighbors = as.integer(nNeighbors),
              min_dist = minDist
            )
          } else {
            warning("`nNeighbors` and `minDist` has to be specified or set to NULL",
                    " at the same time. Setting both to NULL.")
            umap_coordinates <- scrublet$get_umap(scr$manifold_obs_)
          }
          umapDims[sceSampleInd, ] <- umap_coordinates
          
          if (is.null(tsneAngle) && is.null(tsnePerplexity)) {
            tsne_coordinates <- scrublet$get_tsne(scr$manifold_obs_)
          } else if (!is.null(tsneAngle) && !is.null(tsnePerplexity)) {
            tsne_coordinates <- scrublet$get_tsne(
              scr$manifold_obs_,
              angle = tsneAngle,
              perplexity = as.integer(tsnePerplexity)
            )
          } else {
            warning("`tsneAngle` and `tsnePerplexity` has to be specified or set ", 
                    "to NULL at the same time. Setting both to NULL.")
            tsne_coordinates <- scrublet$get_tsne(scr$manifold_obs_)
          }
          tsneDims[sceSampleInd, ] <- tsne_coordinates
          if (!identical(samples, 1)) {
            metadata(inSCE)$sctk$runScrublet[[s]] <- argsList
          }
        }
        if (identical(samples, 1)) {
          metadata(inSCE)$sctk$runScrublet$all_cells <- argsList
        }
        colData(inSCE)$scrublet_score <- NULL
        colData(inSCE)$scrublet_call <- NULL
        
        colData(inSCE) = cbind(colData(inSCE), output)
        
        ## convert doublet call from TRUE/FALSE to Singlet/Doublet
        inSCE$scrublet_call <- as.factor(inSCE$scrublet_call)
        
        levels(inSCE$scrublet_call) <- list(Singlet = "FALSE", Doublet = "TRUE")
        
        reducedDim(inSCE,'scrublet_TSNE') <- tsneDims
        reducedDim(inSCE,'scrublet_UMAP') <- umapDims
        
        colData(tempSCE) <- colData(inSCE)
        metadata(tempSCE) <- metadata(inSCE)
        reducedDims(tempSCE) <- reducedDims(inSCE)
        
        successful = TRUE
        return(tempSCE)   
    },
    error=function(cond) {
        p <- paste0(date(), " ... Scrublet did not complete successfully; Returning SCE without changes. Scrublet error:")
        message(p)
        message(cond)
        return(inSCE)
    },
    finally={
        if (isTRUE(successful)) {
          return(tempSCE)
        }
        else {
          return(inSCE)
        }
    }
    # if (inherits(error, "try-error")) {
  #   warning("Scrublet did not complete successfully. Returning SCE without",
  #           " making any changes. Error given by Scrublet: \n\n", error)
  #   return(inSCE)
  # }
  )
  return(result)
}

#' @title Detect doublet cells using \link[scDblFinder]{scDblFinder}.
#' @description A wrapper function for \link[scDblFinder]{scDblFinder}. Identify
#'  potential doublet cells based on simulations of putative doublet expression
#'  profiles. Generate a doublet score for each cell.
#' @param inSCE A \linkS4class{SingleCellExperiment} object.
#' @param sample Character vector or colData variable name. Indicates which
#' sample each cell belongs to. Default \code{NULL}.
#' @param useAssay  A string specifying which assay in the SCE to use. Default
#' \code{"counts"}.
#' @param nNeighbors Number of nearest neighbors used to calculate density for
#' doublet detection. Default \code{50}.
#' @param simDoublets Number of simulated doublets created for doublet
#' detection. Default \code{10000}.
#' @param seed Seed for the random number generator, can be set to \code{NULL}.
#' Default \code{12345}.
#' @param BPPARAM A \code{\link[BiocParallel]{BiocParallelParam-class}} object
#' specifying whether the neighbour searches should be parallelized. Default
#' \code{BiocParallel::SerialParam(RNGseed = seed)}.
#' @details This function is a wrapper function for
#' \link[scDblFinder]{scDblFinder}. \code{runScDblFinder} runs
#' \link[scDblFinder]{scDblFinder} for each sample within \code{inSCE}
#' iteratively. The resulting doublet scores for all cells will be appended to
#' the \code{\link{colData}} of \code{inSCE}.
#' @return A \link[SingleCellExperiment]{SingleCellExperiment} object with the
#' scDblFinder QC outputs added to the \link{colData} slot.
#' @references Lun ATL (2018). Detecting doublet cells with scran.
#'  \url{https://ltla.github.io/SingleCellThoughts/software/doublet_detection/bycell.html}
#' @seealso \code{\link[scDblFinder]{scDblFinder}},
#' \code{\link{plotScDblFinderResults}}, \code{\link{runCellQC}}
#' @examples
#' data(scExample, package = "singleCellTK")
#' sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
#' sce <- runScDblFinder(sce)
#' @export
#' @importFrom SummarizedExperiment colData colData<- assayNames assayNames<-
#' @importFrom S4Vectors metadata<- metadata
runScDblFinder <- function(inSCE,
    sample = NULL,
    useAssay = "counts",
    nNeighbors = 50,
    simDoublets = max(10000, ncol(inSCE)),
    seed = 12345,
    BPPARAM = BiocParallel::SerialParam(RNGseed = seed)
) {
  tempSCE <- inSCE
  #assayNames(inSCE)[which(useAssay %in% assayNames(inSCE))] <- "counts"
  #useAssay <- "counts"

  argsList <- mget(names(formals()),sys.frame(sys.nframe()))
  argsList <- argsList[!names(argsList) %in% c("inSCE", "BPPARAM")]
  argsList$packageVersion <- utils::packageDescription("scDblFinder")$Version

  sample <- .manageCellVar(inSCE, var = sample)
  if (is.null(sample)) {
    sample = rep(1, ncol(inSCE))
  }


  message(date(), " ... Running 'scDblFinder'")

  ## Loop through each sample and run barcodeRank

  rm.ix <- which(colSums(assay(inSCE, useAssay)) == 0)
  if (length(rm.ix) > 0) {
    inSCEOrig <- inSCE
    inSCE <- inSCE[,-rm.ix]
    sample <- sample[-rm.ix]
  }
  withr::with_seed(seed, {
    inSCE <- scDblFinder::scDblFinder(sce = inSCE,
                                      samples = sample,
                                      artificialDoublets = simDoublets,
                                      k = nNeighbors,
                                      verbose = FALSE,
                                      BPPARAM = BPPARAM
    )
  })
  if (length(rm.ix) > 0) {
    inSCE <- mergeSCEColData(inSCE1 = inSCEOrig, inSCE2 = inSCE)
  }

  names(colData(inSCE)) <- gsub(pattern = "scDblFinder\\.",
                                "scDblFinder_",
                                names(colData(inSCE)))

  names(colData(inSCE)) <- gsub(pattern = "scDblFinder_score",
                                "scDblFinder_doublet_score",
                                names(colData(inSCE)))
  names(colData(inSCE)) <- gsub(pattern = "scDblFinder_class",
                                "scDblFinder_doublet_call",
                                names(colData(inSCE)))

  levels(inSCE$scDblFinder_doublet_call) <- list(Singlet = "singlet",
                                                 Doublet = "doublet")

  if (all(sample == 1)) {
    metadata(inSCE)$sctk$runScDblFinder$all_cells <- argsList
  } else {
    metadata(inSCE)$sctk$runScDblFinder <- sapply(unique(sample),
                                                  function(x) return(argsList),
                                                  simplify = FALSE,
                                                  USE.NAMES = TRUE)
  }

  colData(tempSCE) <- colData(inSCE)
  metadata(tempSCE) <- metadata(inSCE)

  return(tempSCE)
}

#' Imports samples from different sources and compiles them into a list of SCE objects
#' @param allImportEntries object containing the sources and parameters of all the samples being imported (from the UI)
#' @param delayedArray Boolean. Whether to read the expression matrix as
#'  \link{DelayedArray} object or not. Default \code{FALSE}.
#' @return A list of \link[SingleCellExperiment]{SingleCellExperiment} object containing
#' the droplet or cell data or both,depending on the dataType that users provided.
#' @export
importMultipleSources <- function(allImportEntries, delayedArray = FALSE) {
  sceObjs <- list()
  for (entry in allImportEntries$samples) {
    if (entry$type == "cellRanger2") {
      if (is.null(entry$params$cellRangerDirs)) {
        newSce <- importCellRangerV2Sample(
          dataDir = entry$params$dataDir,
          sampleName = entry$params$sampleName,
          delayedArray = delayedArray
        )
      } else {
        newSce <- importCellRangerV2(
          cellRangerDirs = entry$params$cellRangerDirs,
          sampleDirs = entry$params$sampleDirs,
          sampleNames = entry$params$sampleNames,
          delayedArray = delayedArray,
          reference = entry$params$reference
        )
      }

    } else if (entry$type == "cellRanger3") {
      if (is.null(entry$params$cellRangerDirs)) {
        newSce <- importCellRangerV3Sample(
          dataDir = entry$params$dataDir,
          sampleName = entry$params$sampleName,
          delayedArray = delayedArray
        )
      } else {
        newSce <- importCellRangerV3(
          cellRangerDirs = entry$params$cellRangerDirs,
          sampleDirs = entry$params$sampleDirs,
          sampleNames = entry$params$sampleNames,
          delayedArray = delayedArray
        )
      }
    } else if (entry$type == "cellRanger3_files") {
      
      # get current tempDir by shiny
      mytempdir <- tempdir(check=TRUE)
      
      if(dir.exists(mytempdir)){
        # get uploaded filepaths
        matrixFilePath <- entry$params$assayFile
        barcodesFilePath <- entry$params$annotFile
        featuresFilePath <- entry$params$featureFile
        metricsFilePath <- entry$params$summaryFile
        sampleFileName <- entry$params$sampleName
        
        # rename to original names
        file.rename(matrixFilePath, paste0(dirname(matrixFilePath), "/matrix.mtx.gz"))
        file.rename(barcodesFilePath, paste0(dirname(barcodesFilePath), "/barcodes.tsv.gz"))
        file.rename(featuresFilePath, paste0(dirname(featuresFilePath), "/features.tsv.gz"))
        if(!is.null(metricsFilePath)){
          file.rename(metricsFilePath, paste0(dirname(metricsFilePath), "/metrics_summary.csv"))
        }
        
        # create a sample folder
        dir.create(paste0(mytempdir, "/cellranger/"))
        if(!is.null(metricsFilePath)){
          dir.create(paste0(mytempdir, "/cellranger/outs"))
        }
        
        # move files to this sample folder
        file.copy(paste0(dirname(matrixFilePath), "/matrix.mtx.gz"), paste0(mytempdir, "/cellranger/matrix.mtx.gz"))
        file.copy(paste0(dirname(barcodesFilePath), "/barcodes.tsv.gz"), paste0(mytempdir, "/cellranger/barcodes.tsv.gz"))
        file.copy(paste0(dirname(featuresFilePath), "/features.tsv.gz"), paste0(mytempdir, "/cellranger/features.tsv.gz"))
        if(!is.null(metricsFilePath)){
          file.copy(paste0(dirname(metricsFilePath), "/metrics_summary.csv"), paste0(mytempdir, "/cellranger/outs/metrics_summary.csv"))
        }
        
        # make object
        newSce <- importCellRangerV3Sample(dataDir = paste0(mytempdir, "/cellranger/"), 
                                           sampleName = sampleFileName)
        
        # delete sample folder
        unlink(paste0(mytempdir, "/cellranger/"), recursive = TRUE)
      }
      
    } else if (entry$type == "starSolo") {
      newSce <- importSTARsolo(
        STARsoloDirs = entry$params$STARsoloDirs,
        samples = entry$params$samples,
        STARsoloOuts = entry$params$STARsoloOuts,
        delayedArray = delayedArray
      )
    } else if (entry$type == "starSolo_files") {
      
      # get current tempDir by shiny
      mytempdir <- tempdir(check=TRUE)
      
      if(dir.exists(mytempdir)){
        # get uploaded filepaths
        matrixFilePath <- entry$params$assayFile
        barcodesFilePath <- entry$params$annotFile
        featuresFilePath <- entry$params$featureFile
        # metricsFilePath <- entry$params$summaryFile
        sampleFileName <- entry$params$sampleName
        
        # rename to original names
        file.rename(matrixFilePath, paste0(dirname(matrixFilePath), "/matrix.mtx"))
        file.rename(barcodesFilePath, paste0(dirname(barcodesFilePath), "/barcodes.tsv"))
        file.rename(featuresFilePath, paste0(dirname(featuresFilePath), "/features.tsv"))
        # if(!is.null(metricsFilePath)){
        #   file.rename(metricsFilePath, paste0(dirname(metricsFilePath), "/metrics_summary.csv"))
        # }
        
        # create a sample folder
        dir.create(paste0(mytempdir, "/Solo.out/"))
        dir.create(paste0(mytempdir, "/Solo.out/Gene/"))
        dir.create(paste0(mytempdir, "/Solo.out/Gene/filtered"))
        # if(!is.null(metricsFilePath)){
        #   dir.create(paste0(mytempdir, "/cellranger/outs"))
        # }
        
        # move files to this sample folder
        file.copy(paste0(dirname(matrixFilePath), "/matrix.mtx"), paste0(mytempdir, "/Solo.out/Gene/filtered/matrix.mtx"))
        file.copy(paste0(dirname(barcodesFilePath), "/barcodes.tsv"), paste0(mytempdir, "/Solo.out/Gene/filtered/barcodes.tsv"))
        file.copy(paste0(dirname(featuresFilePath), "/features.tsv"), paste0(mytempdir, "/Solo.out/Gene/filtered/features.tsv"))
        # if(!is.null(metricsFilePath)){
        #   file.copy(paste0(dirname(metricsFilePath), "/metrics_summary.csv"), paste0(mytempdir, "/cellranger/outs/metrics_summary.csv"))
        # }
        
        # make object
        newSce <- importSTARsolo(STARsoloDirs = paste0(mytempdir, "/Solo.out"), samples = sampleFileName)
        
        # delete sample folder
        unlink(paste0(mytempdir, "/Solo.out/"), recursive = TRUE)
        
      # newSce <- importSTARsolo(
      #   STARsoloDirs = entry$params$STARsoloDirs,
      #   samples = entry$params$samples,
      #   STARsoloOuts = entry$params$STARsoloOuts,
      #   delayedArray = delayedArray
      # )
      }
    } else if (entry$type == "busTools") {
      newSce <- importBUStools(
        BUStoolsDirs = entry$params$BUStoolsDirs,
        samples = entry$params$samples,
        delayedArray = delayedArray
      )
    } else if (entry$type == "busTools_files") {
      # get current tempDir by shiny
      mytempdir <- tempdir(check=TRUE)
      
      if(dir.exists(mytempdir)){
        # get uploaded filepaths
        matrixFilePath <- entry$params$assayFile
        barcodesFilePath <- entry$params$annotFile
        featuresFilePath <- entry$params$featureFile
        # metricsFilePath <- entry$params$summaryFile
        sampleFileName <- entry$params$sampleName
        
        # rename to original names
        file.rename(matrixFilePath, paste0(dirname(matrixFilePath), "/genes.mtx"))
        file.rename(barcodesFilePath, paste0(dirname(barcodesFilePath), "/genes.barcodes.txt"))
        file.rename(featuresFilePath, paste0(dirname(featuresFilePath), "/genes.genes.txt"))
        # if(!is.null(metricsFilePath)){
        #   file.rename(metricsFilePath, paste0(dirname(metricsFilePath), "/metrics_summary.csv"))
        # }
        
        # create a sample folder
        dir.create(paste0(mytempdir, "/bus_output/"))
        
        # move files to this sample folder
        file.copy(paste0(dirname(matrixFilePath), "/genes.mtx"), paste0(mytempdir, "/bus_output/genes.mtx"))
        file.copy(paste0(dirname(barcodesFilePath), "/genes.barcodes.txt"), paste0(mytempdir, "/bus_output/genes.barcodes.txt"))
        file.copy(paste0(dirname(featuresFilePath), "/genes.genes.txt"), paste0(mytempdir, "/bus_output/genes.genes.txt"))
        
        # make object
        newSce <- importBUStools(BUStoolsDirs = paste0(mytempdir, "/bus_output"), samples = sampleFileName)
        
        # delete sample folder
        unlink(paste0(mytempdir, "/bus_output/"), recursive = TRUE)
      }
    } else if (entry$type == "seqc") {
      newSce <- importSEQC(
        seqcDirs = entry$params$seqcDirs,
        samples = entry$params$samples,
        prefix = entry$params$prefix,
        delayedArray = delayedArray
      )
    } else if (entry$type == "seqc_files") {
      # get current tempDir by shiny
      mytempdir <- tempdir(check=TRUE)
      
      if(dir.exists(mytempdir)){
        # get uploaded filepaths
        readCountsLocation <- entry$params$readCountsLocation
        moleculeCountsLocation <- entry$params$moleculeCountsLocation
        barcodesLocation <- entry$params$barcodesLocation
        genesLocation <- entry$params$genesLocation
        sampleFileName <- entry$params$sampleName
        
        # rename to original names
        file.rename(readCountsLocation, paste0(dirname(readCountsLocation), "/seqc_sparse_read_counts.mtx"))
        file.rename(moleculeCountsLocation, paste0(dirname(moleculeCountsLocation), "/seqc_sparse_molecule_counts.mtx"))
        file.rename(barcodesLocation, paste0(dirname(barcodesLocation), "/seqc_sparse_counts_barcodes.csv"))
        file.rename(genesLocation, paste0(dirname(genesLocation), "/seqc_sparse_counts_genes.csv"))

        # create a sample folder
        dir.create(paste0(mytempdir, "/seqc/"))
        
        # move files to this sample folder
        file.copy(paste0(dirname(readCountsLocation), "/seqc_sparse_read_counts.mtx"), paste0(mytempdir, "/seqc/seqc_sparse_read_counts.mtx"))
        file.copy(paste0(dirname(moleculeCountsLocation), "/seqc_sparse_molecule_counts.mtx"), paste0(mytempdir, "/seqc/seqc_sparse_molecule_counts.mtx"))
        file.copy(paste0(dirname(barcodesLocation), "/seqc_sparse_counts_barcodes.csv"), paste0(mytempdir, "/seqc/seqc_sparse_counts_barcodes.csv"))
        file.copy(paste0(dirname(genesLocation), "/seqc_sparse_counts_genes.csv"), paste0(mytempdir, "/seqc/seqc_sparse_counts_genes.csv"))
        
        # make object
        newSce <- importSEQC(seqcDirs = paste0(mytempdir, "/seqc"), samples = sampleFileName, prefix = "seqc")
        
        # delete sample folder
        unlink(paste0(mytempdir, "/seqc/"), recursive = TRUE)
      }
    } else if (entry$type == "optimus") {
      newSce <- importOptimus(
        OptimusDirs = entry$params$OptimusDirs,
        samples = entry$params$samples,
        delayedArray = delayedArray
      )
    } else if (entry$type == "optimus_files") {
      # get current tempDir by shiny
      mytempdir <- tempdir(check=TRUE)
      
      if(dir.exists(mytempdir)){
        # get uploaded filepaths
        matrixLocation <- entry$params$matrixLocation
        colIndexLocation <- entry$params$colIndexLocation
        rowIndexLocation <- entry$params$rowIndexLocation
        cellMetricsLocation <- entry$params$cellMetricsLocation
        geneMetricsLocation <- entry$params$geneMetricsLocation
        emptyDropsLocation <- entry$params$emptyDropsLocation
        sampleFileName <- entry$params$sampleName
        
        # rename to original names
        file.rename(matrixLocation, paste0(dirname(matrixLocation), "/sparse_counts.npz"))
        file.rename(colIndexLocation, paste0(dirname(colIndexLocation), "/sparse_counts_col_index.npy"))
        file.rename(rowIndexLocation, paste0(dirname(rowIndexLocation), "/sparse_counts_row_index.npy"))
        file.rename(cellMetricsLocation, paste0(dirname(cellMetricsLocation), "/merged-cell-metrics.csv.gz"))
        file.rename(geneMetricsLocation, paste0(dirname(geneMetricsLocation), "/merged-gene-metrics.csv.gz"))
        file.rename(emptyDropsLocation, paste0(dirname(emptyDropsLocation), "/empty_drops_result.csv"))
        
        # create a sample folder
        dir.create(paste0(mytempdir, "/optimus/"))
        dir.create(paste0(mytempdir, "/optimus/call-MergeCountFiles/"))
        dir.create(paste0(mytempdir, "/optimus/call-MergeCellMetrics/"))
        dir.create(paste0(mytempdir, "/optimus/call-MergeGeneMetrics/"))
        dir.create(paste0(mytempdir, "/optimus/call-RunEmptyDrops/"))
        
        # move files to this sample folder
        file.copy(paste0(dirname(matrixLocation), "/sparse_counts.npz"), paste0(mytempdir, "/optimus/call-MergeCountFiles/sparse_counts.npz"))
        file.copy(paste0(dirname(colIndexLocation), "/sparse_counts_col_index.npy"), paste0(mytempdir, "/optimus/call-MergeCountFiles/sparse_counts_col_index.npy"))
        file.copy(paste0(dirname(rowIndexLocation), "/sparse_counts_row_index.npy"), paste0(mytempdir, "/optimus/call-MergeCountFiles/sparse_counts_row_index.npy"))
        file.copy(paste0(dirname(cellMetricsLocation), "/merged-cell-metrics.csv.gz"), paste0(mytempdir, "/optimus/call-MergeCellMetrics/merged-cell-metrics.csv.gz"))
        file.copy(paste0(dirname(geneMetricsLocation), "/merged-gene-metrics.csv.gz"), paste0(mytempdir, "/optimus/call-MergeGeneMetrics/merged-gene-metrics.csv.gz"))
        file.copy(paste0(dirname(emptyDropsLocation), "/empty_drops_result.csv"), paste0(mytempdir, "/optimus/call-RunEmptyDrops/empty_drops_result.csv"))

        # make object
        newSce <- importOptimus(OptimusDirs = paste0(mytempdir, "/optimus"), samples = sampleFileName)
        
        # delete sample folder
        unlink(paste0(mytempdir, "/optimus/"), recursive = TRUE)
      }
    } else if (entry$type == "files") {
      newSce <- importFromFiles(assayFile = entry$params$assayFile,
                                annotFile = entry$params$annotFile,
                                featureFile = entry$params$featureFile,
                                assayName = entry$params$assayName,
                                delayedArray = delayedArray)
    } else if (entry$type == "example") {
      newSce <- importExampleData(dataset = entry$params$dataset,
                                  delayedArray = delayedArray)
    } else if (entry$type == "rds") {
      importedrds <- readRDS(entry$params$rdsFile)
      if (base::inherits(importedrds, "SummarizedExperiment")) {
        newSce <- importedrds
      } else if (base::inherits(importedrds, "Seurat")) {
        newSce <- convertSeuratToSCE(importedrds)
      } else {
        stop("The '.rds' file should contain a 'SingleCellExperiment' or 'Seurat' object.")
      }

      for(assay in SummarizedExperiment::assayNames(newSce)) {
        if(!base::inherits(SummarizedExperiment::assay(newSce, assay), "dgCMatrix") && !isTRUE(delayedArray)) {
          SummarizedExperiment::assay(newSce, assay) <- .convertToMatrix(SummarizedExperiment::assay(newSce, assay))
        }

        if(!base::inherits(SummarizedExperiment::assay(newSce, assay), "DelayedArray") && isTRUE(delayedArray)) {
          SummarizedExperiment::assay(newSce, assay) <- DelayedArray::DelayedArray(SummarizedExperiment::assay(newSce, assay))
        }
      }

    }

    # Begin Set Tags
    if(entry$type %in% c("cellRanger2", "cellRanger3", "starSolo", "busTools", "seqc", "optimus", "example", "cellRanger3_files", "starSolo_files", "busTools_files", "optimus_files", "seqc_files")){
      newSce <- expSetDataTag(
        inSCE = newSce,
        assayType = "raw",
        assays = SummarizedExperiment::assayNames(newSce))
    }
    else if(entry$type %in% c("rds", "files")){
      # Check if tags already stored in uploaded rds/files
      if(is.null(S4Vectors::metadata(newSce)$assayType)){
        try({
          counts(newSce)
          newSce <- expSetDataTag(
            inSCE = newSce,
            assayType = "raw",
            assays = "counts")
        }, silent = TRUE)

        try({
          logcounts(newSce)
          newSce <- expSetDataTag(
            inSCE = newSce,
            assayType = "transformed",
            assays = "logcounts")
        }, silent = TRUE)

        try({
          normcounts(newSce)
          newSce <- expSetDataTag(
            inSCE = newSce,
            assayType = "transformed",
            assays = "normcounts")
        }, silent = TRUE)

        try({
          celda::decontXcounts(newSce)
          newSce <- expSetDataTag(
            inSCE = newSce,
            assayType = "raw",
            assays = "decontXcounts")
        }, silent = TRUE)

        untaggedAssays <- SummarizedExperiment::assayNames(newSce)
        untaggedAssays <- untaggedAssays[! untaggedAssays %in% c('counts', 'logcounts', 'normcounts', 'decontX')]

        newSce <- expSetDataTag(
          inSCE = newSce,
          assayType = "uncategorized",
          assays = untaggedAssays)
      }
      # End Set Tags
    }

    sceObjs = c(sceObjs, list(newSce))
  }

  return(combineSCE(sceList = sceObjs,
                    by.r = Reduce(base::intersect, lapply(sceObjs, function(x) { colnames(rowData(x))})),
                    by.c = Reduce(base::intersect, lapply(sceObjs, function(x) { colnames(colData(x))})),
                    combined = TRUE)
  )
}

shinyPanelQC <- fluidPage(
  #useShinyalert(),
  tags$div(
    class = "container",
    wellPanel(
      sidebarLayout(
        sidebarPanel(
          h5(tags$a(href = paste0(docs.artPath, "ui_qc.html"),
                    "(help)", target = "_blank")),
          fluidRow(
            column(12, h3("Choose which algorithms to run:"))
          ),

          h4("General"),
          # QCMetrics
          checkboxInput("QCMetrics", "QC Metrics (Number of UMIs, number of features detected, etc.)"),
          shinyjs::hidden(
            tags$style(HTML("#QCMetricsParams {margin-left:40px}")),
            tags$div(id = "QCMetricsParams",
                     actionLink("QCMhelp", "Help", icon = icon("info-circle")),
                     tags$hr(),
                     selectInput("QCMito", "Use mitochondrial gene set",
                                 c("None" = "None",
                                   "Human Mitochondrial Genes (Ensembl)" = "he",
                                   "Human Mitochondrial Genes (Symbol)" = "hs",
                                   "Mouse Mitochondrial Genes (Ensembl)" = "me",
                                   "Mouse Mitochondrial Genes (Symbol)" = "ms")),
                     selectInput("QCMgeneSets",
                                 "collectionName - Select a Gene Set for Quality Control",
                                 c("None")),
                     actionLink("QCImportGS", "Import Gene Sets", icon = icon("upload"))
            )
          ),
          tags$hr(),
          h4("Contamination Estimation"),
          # decontX
          checkboxInput("decontX", "decontX"),
          shinyjs::hidden(
            tags$style(HTML("#decontXParams {margin-left:40px}")),
            tags$div(id = "decontXParams",
                     actionLink("DXhelp", "Help", icon = icon("info-circle")),
                     tags$hr(),
                     numericInput("DXmaxIter", "maxIter - Maximum iterations of the EM algorithm (default 500)", 500),
                     numericInput("DXnativePrior", "nativePrior - Prior for native counts (default 10)", 10),
                     numericInput("DXcontPrior", "contaminationPrior - Prior for contamination counts (default 10)", 10),
                     numericInput("DXconvergence", "convergence - Threshold difference between previous and current iterations (default 0.001)", 0.001),
                     numericInput("DXiterLogLik", "iterLogLik - Number of iterations after which to calculate the log likelihood (default 10)", 10),
                     numericInput("DXvarGenes", "varGenes - Number of variable genes to use in dimensionality reduction before clustering (default 5000)", 5000),
                     numericInput("DXdbscanEps", "dbscanEps - Clustering resolution parameter (if no cell cluster labels) (default 1)", 1),

                     checkboxInput("DXestDelta", "estimateDelta - Estimate delta?"), # T/F input
                     checkboxInput("DXverbose", "verbose - Print log messages?", value = TRUE), # T/F input
            )
          ),
          checkboxInput("soupX", "SoupX"),
          shinyjs::hidden(
            tags$style(HTML("#soupXParams {margin-left:40px}")),
            tags$div(id = "soupXParams",
                     actionLink("SoupXhelp", "Help", icon = icon("info-circle")),
                     tags$hr(),
                     selectInput("soupXCluster", "cluster - Prior knowledge of clustering labels on cells (default None)", list()),
                     numericInput("soupXTfidfMin", "tfidfMin - Minimum value of tfidf to accept for a marker gene (default 1)", 1),
                     numericInput("soupXQuantile", "soupQuantile - Only use genes that are at or above this expression quantile in the soup (default 0.9)", 0.9, min = 0, max = 1),
                     numericInput("soupXMaxMarkers", "maxMarkers - If we have heaps of good markers, keep only the best maxMarkers of them. (Default 100)", 100, min = 1),
                     p("contaminationRange - This constrains the contamination fraction to lie within this range. (default 0.01 - 0.8)"),
                     numericInput("soupXContRangeLow", "Lower range:", 0.01, min = 0, max = 1),
                     numericInput("soupXContRangeHigh", "Higher range:", 0.8, min = 0, max = 1),
                     numericInput("soupXRhoMaxFDR", "rhoMaxFDR - FDR passed to SoupX::estimateNonExpressingCells, to test if rho is less than maximumContamination (default 0.2)", 0.2, min = 0, max = 1),
                     numericInput("soupXPriorRho", "priorRho - Mode of gamma distribution prior on contamination fraction (default 0.05)", 0.05, 0, 1),
                     numericInput("soupXPriorRhoStdDev", "priorRhoStdDev - Standard deviation of gamma distribution prior on contamination fraction (default 0.1)", 0.1),
                     checkboxInput("soupXForceAccept", "forceAccept - Should we allow very high contamination fractions to be used?", FALSE),
                     selectInput("soupXAdjustMethod", "AdjustMethod - Method to use for correction (default 'subtraction')",
                                 choices = c('subtraction', 'soupOnly', 'multinomial'), selected = "subtraction"),
                     checkboxInput("soupXRoundToInt", "roundToInt - Should the resulting matrix be rounded to integers?", FALSE),
                     numericInput("soupXTol", "tol - Allowed deviation from expected number of soup counts (default 0.001)", 0.001),
                     numericInput("soupXPCut", "pCut - The p-value cut-off used when method = 'soupOnly' (default 0.01)", 0.01, 0, 1)
            )
          ),
          tags$hr(),
          h4("Doublet Detection"),
          # scDblFinder
          checkboxInput("scDblFinder", "scDblFinder"),
          shinyjs::hidden(
            tags$style(HTML("#scDblFinderParams {margin-left:40px}")),
            tags$div(id = "scDblFinderParams",
                     actionLink("DChelp", "Help", icon = icon("info-circle")),
                     tags$hr(),
                     numericInput("DCnNeighbors", "nNeighbors - Number of nearest neighbors (default 50)", 50),
                     numericInput("DCsimDoublets", "simDoublets - Number of simulated doublets (default 10000)", 10000)
            )
          ),
          # cxds
          checkboxInput("cxds", "cxds"),
          shinyjs::hidden(
            tags$style(HTML("#cxdsParams {margin-left:40px}")),
            tags$div(id = "cxdsParams",
                     actionLink("CXhelp", "Help", icon = icon("info-circle")),
                     tags$hr(),
                     numericInput("CXntop", "ntop - Number of top variance genes (default 500)", 500),
                     numericInput("CXbinThresh", "binThresh - Threshold to consider a gene 'present' (default 0)", 0),

                     checkboxInput("CXverb", "verb - Output progress messages?", value = TRUE), # T/F input
                     checkboxInput("CXretRes", "retRes - Return gene pair scores and top-scoring gene pairs?"), # T/F input
            )
          ),
          # bcds
          checkboxInput("bcds", "bcds"),
          shinyjs::hidden(
            tags$style(HTML("#bcdsParams {margin-left:40px}")),
            tags$div(id = "bcdsParams",
                     actionLink("BChelp", "Help", icon = icon("info-circle")),
                     tags$hr(),
                     numericInput("BCntop", "ntop - Number of top variance genes (default 500)", 500),
                     numericInput("BCsrat", "srat - Ratio between original number of cells and simulating doublets (decimal value, default 1)", 1),

                     textInput("BCnmax", "nmax - Max number of training rounds (default 'tune')", value = "tune"),

                     checkboxInput("BCverb", "verb - Output progress messages?", value = TRUE), # T/F input
                     checkboxInput("BCretRes", "retRes - Return trained classifier?"), # T/F input
                     checkboxInput("BCvarImp", "varImp - Return variable importance?"), # T/F input
            )
          ),
          # cxds_bcds_hybrid
          checkboxInput("cxds_bcds_hybrid", "cxds_bcds_hybrid"),
          shinyjs::hidden(
            tags$style(HTML("#cxds_bcds_hybridParams {margin-left:40px}")),
            tags$div(id = "cxds_bcds_hybridParams",
                     actionLink("CXBChelp", "Help", icon = icon("info-circle")),
                     tags$hr(),
                     tags$label("cxds Parameters:"),
                     numericInput("CX2ntop", "ntop - Number of top variance genes (default 500)", 500),
                     numericInput("CX2binThresh", "binThresh- Threshold to consider a gene 'present' (default 0)", 0),
                     checkboxInput("CX2retRes", "retRes - Return gene pair scores and top-scoring gene pairs?"), # T/F input

                     tags$hr(),
                     tags$label("bcds Parameters:"),
                     numericInput("BC2ntop", "ntop - Number of top variance genes  (default 500)", 500),
                     numericInput("BC2srat", "srat - Ratio between original number of cells and simulating doublets (decimal value, default 1)", 1),
                     textInput("BC2nmax", "nmax - Max number of training rounds (default 'tune')", value = "tune"),
                     checkboxInput("BC2retRes", "retRes - Return trained classifier?"), # T/F input
                     checkboxInput("BC2varImp", "varImp - Return variable importance?"), # T/F input
                     checkboxInput("CXBCverb", "verb - Output bcds progress messages?", value = TRUE), # T/F input
            )
          ),
          # scrublet
          checkboxInput("scrublet", "scrublet"),
          shinyjs::hidden(
            tags$style(HTML("#scrubletParams {margin-left:40px}")),
            tags$div(id = "scrubletParams",
                     actionLink("Shelp", "Help", icon = icon("info-circle")),
                     tags$hr(),
                     numericInput("SsimDoubletRatio", "simDoubletRatio - Number of soublets to simulate (default 2.0)", 2.0),
                     numericInput("SnNeighbors", "nNeighbors - Number of nearest neighbors (default NULL)", NULL),
                     numericInput("SminDist", "minDist - Tightness of UMAP points (default NULL)", NULL),
                     numericInput("SexpectedDoubletRate", "expectedDoubletRate - Estimated doublet rate (default 0.1)", 0.1),
                     numericInput("SstdevDoubletRate", "stdevDoubletRate - Uncertainty in expected doublet rate (default 0.02)", 0.02),
                     numericInput("SsyntheticDoubletUmiSubsampling", "syntheticDoubletUmiSubsampling - UMI sampling rate (default 1)", 1),
                     numericInput("SminCounts", "minCounts - Prior to PCA, exclude genes with counts below (defualt 3):", 3),
                     numericInput("SminCells", "minCells - Prior to PCA, exclude genes expressed in fewer than X cells (defualt 3):", 3),
                     numericInput("SminGeneVariabilityPctl", "minGeneVariabilityPctl - Prior to PCA, keep X most highly variable genes (defualt 85):", 85),
                     numericInput("SnPrinComps", "nPrinComps - Prior to KNN graph construction, number of principle components used to embed the transcriptomes (defualt 30):", 30),
                     numericInput("StsneAngle", "tsneAngle - Angular size of distant node as measured from a point in the t-SNE plot (defualt NULL):", NULL),
                     numericInput("StsnePerplexity", "tsnePerplexity - Number of nearest neighbors used in other manifold learning algorithms (defualt NULL):", NULL),

                     textInput("SdistanceMetric", "distanceMetric - Distance metric", value = "euclidean"),

                     checkboxInput("SuseApproxNeighbors", "useApproxNeighbors - Use approximate nearest neighbor method?", value = TRUE), # T/F input
                     checkboxInput("SgetDoubletNeighborParents", "getDoubletNeighborParents - Return doublet neighbors' parent transcriptomes?"), # T/F input
                     checkboxInput("SlogTransform", "logTransform - Log transform counts matrix?"), # T/F input
                     checkboxInput("SmeanCenter", "meanCenter - Center each gene's data at zero?", value = TRUE), # T/F input
                     checkboxInput("SnormalizeVariance", "normalizeVariance - Normalize each gene's data to have a variance of 1?", value = TRUE), # T/F input
                     checkboxInput("Sverbose", "verbose - Output progress updates?", value = TRUE), # T/F input
            )
          ),
          # doubletFinder
          checkboxInput("doubletFinder", "doubletFinder"),
          shinyjs::hidden(
            tags$style(HTML("#doubletFinderParams {margin-left:40px}")),
            tags$div(id = "doubletFinderParams",
                     actionLink("DFhelp", "Help", icon = icon("info-circle")),
                     tags$hr(),
                     numericInput("DFseuratNfeatures", "seuratNfeatures - Number of highly variable genes to use (default 2000)", 2000),
                     numericInput("DFseuratRes", "seuratRes - Seurat resolution (please enter comma-separated integers, default 1.5)", 1.5),
                     numericInput("DFformationRate", "formationRate - Doublet formation rate (default 0.075)", 0.075),
                     numericInput("DFseuratPcs", "seuratPcs - PCs to determine the number of clusters (default 15)", 15),

                     checkboxInput("DFverbose", "verbose - Output log messages?", value = TRUE), # T/F input
            )
          ),
          tags$hr(),
          h4("General Parameters"),
          selectizeInput(
            inputId = "qcAssaySelect", 
            label = "Select input matrix:", 
            choices = NULL, 
            selected = NULL, 
            multiple = FALSE,
            options = NULL),
          #uiOutput("qcAssaySelect"),
          #selectInput("qcAssaySelect", "Select an Assay", list()),
          selectInput("qcSampleSelect", "Select variable containing sample labels", list()),

          tags$hr(), # UMAP params
          h4("Quick UMAP Parameters"),
          textInput("QCUMAPName", "UMAP Name (default 'QC_UMAP')", value = "QC_UMAP"),
          numericInput("UnNeighbors", "Size of local neighborhood used for manifold approximation (default 30)", 30),
          numericInput("UnIterations", "Number of iterations performed during layout optimization (default 200)", 200),
          numericInput("Ualpha", 'Initial value of "learning rate" (default 1)', 1),
          numericInput("UminDist", "Effective minimum distance between embedded points (default 0.01)", 0.01),
          numericInput("Uspread", "Effective scale of embedded points (default 1)", 1),
          numericInput("UinitialDims", "Number of dimensions from PCA to use as input (default 25)", 25),
          numericInput("Useed", "Seed value for reproducibility of UMAP result (default 12345)", 12345),


          actionButton("runQC", "Run"),
          tags$div(id = "qcPageErrors"),
        ),
        mainPanel(
          tabsetPanel(
            id = "qcResPlotTabs"
          )
        )
      )
    )
  )
)

#' scaterCPM
#' Uses CPM from scater library to compute counts-per-million.
#' @param inSCE Input SingleCellExperiment object
#' @param assayName New assay name for cpm data.
#' @param useAssay Input assay 
#' @return inSCE Updated SingleCellExperiment object
#' @export
#' @author Irzam Sarfraz
#' @examples
#' data(sce_chcl, package = "scds")
#' sce_chcl <- scaterCPM(sce_chcl,"countsCPM", "counts")
scaterCPM <- function(inSCE, 
                       assayName = "ScaterCPMCounts", 
                       useAssay = "counts"){
  assay(inSCE, assayName) <- scater::calculateCPM(
    x = assay(inSCE, useAssay))
  
  inSCE <- expSetDataTag(inSCE = inSCE, 
                         assayType = "normalized", 
                         assays = assayName)
  return(inSCE)
}

# Scater Functions
library(singleCellTK)
context("Testing scater functions")
data(scExample, package = "singleCellTK")
# Remove zero colsums cells required for scater functions
zeroCols <- which(colSums(assay(sce, "counts")) == 0)
sce <- sce[, -zeroCols]

test_that(desc = "Testing scaterCPM", {
  sce <- scaterCPM(sce)

  testthat::expect_true("ScaterCPMCounts" %in% assayNames(sce))
})

test_that(desc = "Testing scaterLogNormCounts & scaterPCA", {
  sce <- scaterlogNormCounts(sce, useAssay = "counts", assayName = "logNormCounts")
  sce <- scaterPCA(sce, useAssay = "logNormCounts", useFeatureSubset = NULL)

  testthat::expect_true("logNormCounts" %in% assayNames(sce))
  testthat::expect_true("PCA" %in% reducedDimNames(sce))
})

.constructSCEFromSeqcOutputs <- function(
    sampleName,
    matrix,
    features,
    barcodes) {

    coln <- paste(sampleName, barcodes[[1]], sep = "_")
    rownames(matrix) <- features[[1]]

    sce <- SingleCellExperiment::SingleCellExperiment(
        assays = list(counts = matrix))
    SummarizedExperiment::rowData(sce) <- features
    SummarizedExperiment::colData(sce) <- S4Vectors::DataFrame(
        cell_barcode = as.character(barcodes[[1]]),
        column_name = coln,
        sample = sampleName,
        row.names = coln)

    return(sce)
}


.unionGeneMatrix <- function(geneUnion, matrix){
    missGene <- geneUnion[!geneUnion %in% rownames(matrix)]
    missMat <- Matrix::Matrix(0, nrow = length(missGene), ncol = ncol(matrix),
        dimnames = list(missGene, NULL))

    matb <- methods::as(matrix, "CsparseMatrix")
    rownames(matb) <- rownames(matrix)

    mat <- rbind(matb, missMat)
    if (anyDuplicated(rownames(mat))) {
        mat <- mat[!duplicated(rownames(mat)), ]
        warning("Duplicated genes exist in count matrix. Filtered",
            " duplicated genes.")
    }
    return(mat)
}


.getGeneUnion <- function(geneList){
    gene <- geneList
    for (i in seq_along(geneList)){
        gene[[i]] <- geneList[[i]][[1]]
    }

    geneUnion <- base::Reduce(union, gene)
    return(geneUnion)
}


.readBarcodesSEQC <- function(path) {
    res <- data.table::fread(path, header = FALSE, sep=",", colClasses = "character")
    res <- res[,-1,drop = FALSE]
    colnames(res) <- "cell_barcode"
    return(res)
}


.readFeaturesSEQC <- function(path) {
    res <- data.table::fread(path, header = FALSE, sep=",", colClasses = "character")
    res <- res[,-1,drop = FALSE]
    colnames(res) <- "feature_name"
    return(res)
}


.importSEQC <- function(
    seqcDirs,
    samples,
    prefix,
    gzipped,
    class,
    delayedArray,
    cbNotFirstCol,
    feNotFirstCol,
    combinedSample,
    rowNamesDedup) {

    if (length(seqcDirs) != length(samples)) {
        stop("'seqcDirs' and 'samples' have unequal lengths!")
    }

    if (length(seqcDirs) != length(prefix)) {
        stop("'seqcDirs' and 'prefix' have unequal lengths!")
    }

    res <- vector("list", length = length(seqcDirs))
    cb <- vector("list", length = length(seqcDirs))
    fe <- vector("list", length = length(seqcDirs))
    mat <- vector("list", length = length(seqcDirs))

    for (i in seq_along(seqcDirs)) {
        dir <- seqcDirs[i]
        matrixFile <- paste(prefix[i], 'sparse_molecule_counts.mtx', sep = "_")
        featuresFile <- paste(prefix[i], 'sparse_counts_genes.csv', sep = "_")
        barcodesFile <- paste(prefix[i], 'sparse_counts_barcodes.csv',
            sep = "_")

        cb[[i]] <- .readBarcodesSEQC(file.path(dir, barcodesFile))
        fe[[i]] <- .readFeaturesSEQC(file.path(dir, featuresFile))

        mat[[i]] <- .readMatrixMM(file.path(dir, matrixFile),
            gzipped = gzipped, class = class, delayedArray = delayedArray)
        mat[[i]] <- t(mat[[i]])
        rownames(mat[[i]]) <- fe[[i]][[1]]
    }

    if (isTRUE(combinedSample) & length(seqcDirs) > 1) {
        geneUnion <- .getGeneUnion(fe)
        for (i in seq_along(seqcDirs)) {
            matrix <- .unionGeneMatrix(geneUnion = geneUnion, matrix = mat[[i]])
            matrix <- matrix[geneUnion, ]
            feature <- S4Vectors::DataFrame('feature_name' = rownames(matrix))

            scei <- .constructSCEFromSeqcOutputs(
                sampleName = samples[i],
                matrix = matrix,
                features = feature,
                barcodes = cb[[i]])
            res[[i]] <- scei

        }
        sce <- do.call(SingleCellExperiment::cbind, res)
        if (isTRUE(rowNamesDedup)) {
            if (any(duplicated(rownames(sce)))) {
                message("Duplicated gene names found, adding '-1', '-2', ",
                        "... suffix to them.")
            }
            sce <- dedupRowNames(sce)
        }
        return(sce)

    } else {
        for (i in seq_along(seqcDirs)) {
            scei <- .constructSCEFromSeqcOutputs(
                sampleName = samples[i],
                matrix = mat[[i]],
                features = fe[[i]],
                barcodes = cb[[i]])
            res[[i]] <- scei
        }
        if (length(seqcDirs) == 1) {
            sce <- res[[1]]
            if (isTRUE(rowNamesDedup)) {
                if (any(duplicated(rownames(sce)))) {
                    message("Duplicated gene names found, adding '-1', '-2', ",
                            "... suffix to them.")
                }
                sce <- dedupRowNames(sce)
            }
            return(sce)
        } else {
            return(res)
        }
    }
}


#' @name importSEQC
#' @rdname importSEQC
#' @title Construct SCE object from seqc output
#' @description Read the filtered barcodes, features, and matrices for all
#'  samples from (preferably a single run of) seqc output. Import and combine
#'  them as one big \link[SingleCellExperiment]{SingleCellExperiment} object.
#' @param seqcDirs A vector of paths to seqc output files. Each sample
#'  should have its own path. For example: \code{"./pbmc_1k_50x50"}. Must have 
#'  the same length as \code{samples}.
#' @param samples A vector of user-defined sample names for the samples to be
#'  imported. Must have the same length as \code{seqcDirs}.
#' @param prefix A vector containing the prefix of file names within each
#'  sample directory. It cannot be null and the vector should have the same
#'  length as \emph{samples}.
#' @param gzipped Boolean. \code{TRUE} if the seqc output files
#'  (sparse_counts_barcode.csv, sparse_counts_genes.csv, and
#'  sparse_molecule_counts.mtx) were gzip compressed. \code{FALSE} otherwise. 
#'  Default seqc outputs are not gzipped. Default \code{FALSE}.
#' @param class Character. The class of the expression matrix stored in the SCE
#'  object. Can be one of \code{"Matrix"} (as returned by \link{readMM} 
#'  function), or \code{"matrix"} (as returned by \link[base]{matrix} function).
#'  Default \code{"Matrix"}.
#' @param delayedArray Boolean. Whether to read the expression matrix as
#'  \link{DelayedArray} object or not. Default \code{FALSE}.
#' @param feNotFirstCol Boolean. \code{TRUE} if first column of
#'  sparse_counts_genes.csv is row index and it will be removed. \code{FALSE} 
#'  the first column will be kept.
#' @param cbNotFirstCol Boolean. \code{TRUE} if first column of
#'  sparse_counts_barcode.csv is row index and it will be removed. \code{FALSE} 
#'  the first column will be kept.
#' @param combinedSample Boolean. If \code{TRUE}, \code{importSEQC} returns a
#' \code{SingleCellExperiment} object containing the combined count matrix,
#'  feature annotations and the cell annotations. If \code{FALSE}, 
#'  \code{importSEQC} returns a list containing multiple
#'  \code{SingleCellExperiment} objects. Each \code{SingleCellExperiment}
#'  contains count matrix, feature annotations and cell annotations for
#'  each sample.
#' @param rowNamesDedup Boolean. Whether to deduplicate rownames. Only applied 
#' if \code{combinedSample} is \code{TRUE} or only one \code{seqcDirs} 
#' specified. Default \code{TRUE}.
#' @details
#' \code{importSEQC} imports output from seqc. The default 
#'  sparse_counts_barcode.csv or sparse_counts_genes.csv from seqc output
#'  contains two columns. The first column is row index and the second column
#'  is cell-barcode or gene symbol. \code{importSEQC} will remove first column. 
#'  Alternatively, user can call
#'  \code{cbNotFirstCol} or \code{feNotFirstCol} as FALSE to keep the first
#'  column of these files. When \code{combinedSample} is TRUE, \code{importSEQC}
#'  will combined count matrix with genes detected in at least one sample.
#' @return A \code{SingleCellExperiment} object containing the combined count
#'  matrix, the feature annotations, and the cell annotation.
#' @examples
#' # Example #1
#' # The following filtered feature, cell, and matrix files were downloaded from
#' # https://support.10xgenomics.com/single-cell-gene-expression/datasets/
#' # 3.0.0/pbmc_1k_v3
#' # The top 50 hg38 genes are included in this example.
#' # Only the top 50 cells are included.
#' sce <- importSEQC(
#'     seqcDirs = system.file("extdata/pbmc_1k_50x50", package = "singleCellTK"),
#'     samples = "pbmc_1k_50x50",
#'     prefix = "pbmc_1k",
#'     combinedSample = FALSE)
#' @export
importSEQC <- function(
    seqcDirs = NULL,
    samples = NULL,
    prefix = NULL,
    gzipped = FALSE,
    class = c("Matrix", "matrix"),
    delayedArray = FALSE,
    cbNotFirstCol = TRUE,
    feNotFirstCol = TRUE,
    combinedSample = TRUE,
    rowNamesDedup = TRUE) {

    class <- match.arg(class)

    .importSEQC(seqcDirs = seqcDirs,
        samples = samples,
        prefix = prefix,
        gzipped = gzipped,
        class = class,
        delayedArray = delayedArray,
        cbNotFirstCol = cbNotFirstCol,
        feNotFirstCol = feNotFirstCol,
        combinedSample = combinedSample,
        rowNamesDedup = rowNamesDedup)
}

orgpkgs <- c("Anopheles" = "org.Ag.eg.db", "Arabidopsis" = "org.At.tair.db",
             "Bovine" = "org.Bt.eg.db", "Worm" = "org.Ce.eg.db",
             "Canine" = "org.Cf.eg.db", "Fly" = "org.Dm.eg.db",
             "Zebrafish" = "org.Dr.eg.db",
             "E coli strain K12" = "org.EcK12.eg.db",
             "E coli strain Sakai" = "org.EcSakai.eg.db",
             "Chicken" = "org.Gg.eg.db", "Human" = "org.Hs.eg.db",
             "Mouse" = "org.Mm.eg.db", "Rhesus" = "org.Mmu.eg.db",
             "Malaria" = "org.Pf.plasmo.db", "Chimp" = "org.Pt.eg.db",
             "Rat" = "org.Rn.eg.db", "Yeast" = "org.Sc.sgd.db",
             "Pig" = "org.Ss.eg.db", "Xenopus" = "org.Xl.eg.db")

shinyPanelFilter <- fluidPage(
  #useShinyalert(),
  h5(tags$a(href = paste0(docs.artPath, "filtering.html"),
            "(help)", target = "_blank")),
  wellPanel(
    h4("Select Cell Filtering Criteria:"),
    fluidRow(
      column(4, tags$b("Annotation Name")),
      column(4, tags$b("Filter Condition")),
      column(4, tags$b("Remove"))
    ),
    tags$div(id = "newFilteringParams"),
    tags$br(),
    tags$br(),
    actionButton("addFilteringParam", "Add a Filter"),
    actionButton("clearAllFilters", "Clear Filters"),
  ),

  # *** Uncomment when row filtering is finalized ***
  wellPanel(
    h4("Select Feature Filtering Criteria:"),
    fluidRow(
      column(4, tags$b("Assay Name")),
      column(4, tags$b("Filter Condition")),
      column(4, tags$b("Remove"))
    ),
    tags$div(id = "newRowFilteringParams"),
    tags$br(),
    tags$br(),
    actionButton("addRowFilteringParam", "Add a Filter"),
    actionButton("clearAllRowFilters", "Clear Filters"),
  ),
  
  actionButton("filterSCE", "Filter"),
  
  tags$br(),
  tags$br(),
  hidden(wellPanel(id = "filteringSummary",
                   h3("Before Filtering:"),
                   tableOutput("beforeFiltering"),
                   h3("After Filtering:"),
                   tableOutput("afterFiltering"))),

)

shinyPanelBatchcorrect <- fluidPage(
  includeCSS('styles.CSS'),
  tags$script("Shiny.addCustomMessageHandler('close_dropDownBC', function(x){
                  $('html').click();
                });"),
  h1("Normalization & Batch Correction"),
  tabsetPanel(
  tabPanel(
    "Normalization", fluid = TRUE,
        fluidRow(
            column(
                width = 4,
                fluidRow(
                    column(
                        width = 12,
                        panel(
                            heading = "Normalization Options",
                            h5(tags$a(href = paste0(docs.artPath, "cnsl_normalization.html"),
                                      "(help)", target = "_blank")),
                            selectInput(
                              inputId = "normalizeAssayMethodSelect",
                              label = "Select normalization method: ",
                              choices = c("Seurat - LogNormalize" = "LogNormalize",
                                          "Seurat - CLR" = "CLR",
                                          "Seurat - RC" = "RC",
                                          "Seurat - SCTransform" = "SCTransform",
                                          "Scater - LogNormCounts" = "logNormCounts",
                                          "Scater - CPM" = "CPM",
                                          "Scanpy - NormalizeTotal" = "NormalizeTotal",
                                          "Custom Normalization" = "custom")
                            )

                        )
                    )
                )
            ),
            column(
                width = 8,
                fluidRow(
                    column(
                        width = 12,
                        panel(
                            heading = "Options",
                            fluidRow(
                              column(6, style='border-right:1px solid; border-color:#EDEDED;',
                                     conditionalPanel(
                                       condition = "input.normalizeAssayMethodSelect != 'custom'",
                                       selectizeInput(
                                         inputId = "normalizeAssaySelect", 
                                         label = "Select input matrix:", 
                                         choices = NULL, 
                                         selected = NULL, 
                                         multiple = FALSE,
                                         options = NULL),
                                       #uiOutput("normalizeAssaySelect"),
                                       conditionalPanel(
                                         condition = "input.normalizeAssayMethodSelect == 'LogNormalize'
                              || input.normalizeAssayMethodSelect == 'CLR'
                              || input.normalizeAssayMethodSelect == 'RC'",
                                         numericInput(
                                           inputId = "normalizationScaleFactor",
                                           label = "Set scaling factor: ",
                                           value = "10000"
                                         )
                                       ),
                                       textInput(
                                         inputId = "normalizeAssayOutname",
                                         label = "Assay Name:",
                                         value = "SeuratLogNormalize"
                                       ),
                                       awesomeCheckbox(
                                         inputId = "normalizationScale",
                                         label = "Scale data after normalization?",
                                         value = FALSE
                                       ),
                                       conditionalPanel(
                                         condition = "input.normalizationScale == true",
                                         awesomeCheckbox(
                                           inputId = "normalizationTrim",
                                           label = "Trim data after scale?",
                                           value = TRUE
                                         ),
                                         conditionalPanel(
                                           condition = "input.normalizationTrim == true",
                                           numericInput(
                                             inputId = "normalizationTrimUpper",
                                             label = "Upper trim value:",
                                             value = 10
                                           ),
                                           numericInput(
                                             inputId = "normalizationTrimLower",
                                             label = "Lower trim value:",
                                             value = -10
                                           )
                                         )
                                       )
                                     ),
                                     conditionalPanel(
                                       condition = "input.normalizeAssayMethodSelect == 'custom'",
                                       h5("Assay Options:"),
                                       selectizeInput(
                                         inputId = "modifyAssaySelect", 
                                         label = "Select input matrix:", 
                                         choices = NULL, 
                                         selected = NULL, 
                                         multiple = FALSE,
                                         options = NULL),
                                       #uiOutput("modifyAssaySelect"),
                                       textInput("modifyAssayOutname", "Assay Name",
                                                 value = "customNormalizedAssay"),
                                       tags$hr(),
                                       h5("Select Options:"),
                                       awesomeCheckbox(
                                         inputId = "customNormalizeOptionsNormalize",
                                         label = "Normalize",
                                         value = FALSE
                                       ),
                                       conditionalPanel(
                                         condition = "input.customNormalizeOptionsNormalize == true",
                                         h5("Normalize Options:"),
                                         selectInput(
                                           inputId = "customNormalizeAssayMethodSelect",
                                           label = "Select normalization method: ",
                                           choices = c("Seurat - LogNormalize" = "LogNormalize",
                                                       "Seurat - CLR" = "CLR",
                                                       "Seurat - RC" = "RC",
                                                       "Seurat - SCTransform" = "SCTransform",
                                                       "Scater - LogNormCounts" = "logNormCounts",
                                                       "Scanpy - NormalizeTotal" = "NormalizeTotal",
                                                       "Scater - CPM" = "CPM")
                                         )
                                       ),
                                       conditionalPanel(
                                         condition = "!(input.customNormalizeOptionsNormalize == true
                                         && (input.customNormalizeAssayMethodSelect == 'LogNormalize'
                                         || input.customNormalizeAssayMethodSelect == 'CLR'
                                         || input.customNormalizeAssayMethodSelect == 'SCTransform'
                                         || input.customNormalizeAssayMethodSelect == 'logNormCounts'))",
                                         awesomeCheckbox(
                                           inputId = "customNormalizeOptionsTransform",
                                           label = "Transform",
                                           value = FALSE
                                         )
                                       ),
                                       conditionalPanel(
                                         condition = "input.customNormalizeOptionsTransform == true",
                                         h5("Transformation Options:"),
                                         selectInput(
                                           inputId = "customNormalizeTransformOptions",
                                           label = "Select transformation method:",
                                           choices = c("Log2" = "log2",
                                                       "Log1p" = "log1p",
                                                       "Sqrt" = "sqrt")
                                         )
                                       ),
                                       awesomeCheckbox(
                                         inputId = "customNormalizeOptionsPsuedocounts",
                                         label = "Psuedocounts",
                                         value = FALSE
                                       ),
                                       conditionalPanel(
                                         condition = "input.customNormalizeOptionsPsuedocounts == true",
                                         h5("Pseudocounts Options:"),
                                         conditionalPanel(
                                           condition = "input.customNormalizeOptionsNormalize == true",
                                           awesomeCheckbox(
                                             inputId = "customNormalizePseudoOptionsBefore",
                                             label = "before normalization",
                                             value = FALSE
                                           ),
                                           conditionalPanel(
                                             condition = "input.customNormalizePseudoOptionsBefore == true",
                                             numericInput(
                                               inputId = "customNormalizePseudoValueBefore",
                                               label = "Enter a pseudovalue to add:",
                                               value = 1,
                                               min = 1
                                             )
                                           )
                                         ),
                                         conditionalPanel(
                                           condition = "input.customNormalizeOptionsTransform == true",
                                           awesomeCheckbox(
                                             inputId = "customNormalizePseudoOptionsAfter",
                                             label =  "before transformation",
                                             value = FALSE
                                           ),
                                           conditionalPanel(
                                             condition = "input.customNormalizePseudoOptionsAfter == true",
                                             numericInput(
                                               inputId = "customNormalizePseudoValueAfter",
                                               label = "Enter a pseudovalue to add:",
                                               value = 1,
                                               min = 1
                                             )
                                           )
                                         ),
                                         conditionalPanel(
                                           condition = "input.customNormalizeOptionsNormalize == false
                                           && input.customNormalizeOptionsTransform == false",
                                           h6("To add a pseudovalue, must select 'Normalize' or 'Transform' options!")
                                         )
                                       ),
                                       awesomeCheckbox(
                                         inputId = "customNormalizeOptionsScale",
                                         label = "Scale",
                                         value = FALSE
                                       ),
                                       conditionalPanel(
                                         condition = "input.customNormalizeOptionsScale == true",
                                         h5("Scale Options:"),
                                         selectInput(
                                           inputId = "customNormalizeScaleOptions",
                                           label = "Select scaling method:",
                                           choices = c("Z.Score" = "zscore")
                                         )
                                       ),
                                       awesomeCheckbox(
                                         inputId = "customNormalizeOptionsTrim",
                                         label = "Trim",
                                         value = FALSE
                                       ),
                                       conditionalPanel(
                                         condition = "input.customNormalizeOptionsTrim == true",
                                         h5("Trim Options:"),
                                         numericInput(
                                           inputId = "trimUpperValueAssay",
                                           label = "Specify upper trim value",
                                           value = 10
                                         ),
                                         numericInput(
                                           inputId = "trimLowerValueAssay",
                                           label = "Specify lower trim value",
                                           value = -10
                                         )
                                       )
                                     )
                                     ),
                              column(6,
                                     h4("Selected Options:"),
                                     conditionalPanel(
                                       condition = "input.normalizeAssayMethodSelect != 'custom'",
                                       uiOutput("normalizationNormalizeSelectedMethodUI")
                                     ),
                                     conditionalPanel(
                                       condition = "(input.customNormalizeOptionsNormalize == true
                                       && input.normalizeAssayMethodSelect == 'custom')",
                                       h5("Normalize")
                                     ),
                                     conditionalPanel(
                                       condition = "input.customNormalizeOptionsTransform == true
                                       && input.normalizeAssayMethodSelect == 'custom'",
                                       h5("Transform")
                                     ),
                                     conditionalPanel(
                                       condition = "input.customNormalizeOptionsScale == true
                                       && input.normalizeAssayMethodSelect == 'custom'",
                                       h5("Scale")
                                     ),
                                     conditionalPanel(
                                       condition = "input.customNormalizeOptionsPsuedocounts == true
                                       && input.normalizeAssayMethodSelect == 'custom'",
                                       h5("Pseudocounts")
                                     ),
                                     conditionalPanel(
                                       condition = "input.customNormalizeOptionsTrim == true
                                       && input.normalizeAssayMethodSelect == 'custom'",
                                       h5("Trim")
                                     ),
                                     tags$hr(),
                                     h4("Output Data Type:"),
                                     uiOutput("normalizationDataTagUI")
                                     )
                            ),
                            fluidRow(
                              tags$hr(),
                              column(12,
                                     conditionalPanel(
                                       condition = "input.normalizeAssayMethodSelect != 'custom'",
                                       div(style = "display:inline-block; float:right", actionButton("normalizeAssay", "Run")),
                                      ),
                                     conditionalPanel(
                                       condition = "input.normalizeAssayMethodSelect == 'custom'",
                                       div(style = "display:inline-block; float:right", actionButton("modifyAssay", "Run"))
                                       )
                                     )
                            )
                        )
                    )
                )
            )
        )
    ),
  tabPanel(
    "Batch Correction",
    sidebarLayout(
      sidebarPanel(
        h3("Parameters"),
        h5(tags$a(href = paste0(docs.artPath, "batch_correction.html"),
                  "(help)", target = "_blank")),
        selectInput('batchCorrMethods', "Select Batch Correction Method:",
                    c("MNN", "ComBatSeq", "FastMNN", "Limma", #"BBKNN", "Harmony", "LIGER",
                      "scanorama", "scMerge", "Seurat3 Integration",
                      "ZINBWaVE")),
        selectizeInput(
          inputId = "batchCorrAssay", 
          label = "Select input matrix:", 
          choices = NULL, 
          selected = NULL, 
          multiple = FALSE,
          options = NULL),
        #uiOutput("batchCorrAssay"),
        selectInput("batchCorrVar", "Select Batch Annotation:", clusterChoice),
        # BBKNN ####
        conditionalPanel(
          condition = "input.batchCorrMethods == 'BBKNN'",
          h5(tags$a(href = paste0(docs.base, "reference/runBBKNN.html"),
                    "(help for BBKNN)", target = "_blank")),
          numericInput("BBKNNNComp", label = "Number of output dimension:",
                       value = 50L, min = 2, max = 100000, step = 1),
          textInput("BBKNNSaveReddim", "ReducedDim Name to Use:",
                    value = "BBKNN"),
          actionButton("BBKNNRun", "Run")
        ),
        # ComBatSeq ####
        conditionalPanel(
          condition = "input.batchCorrMethods == 'ComBatSeq'",
          h5(tags$a(href = paste0(docs.base, "reference/runComBatSeq.html"),
                    "(help for ComBatSeq)", target = "_blank")),
          radioButtons("combatKnownCT", "Have known cell type variable?",
                       choices = c("Yes", "No")),
          conditionalPanel(
            condition = "input.combatKnownCT == 'Yes'",
            selectInput("combatCond", "Select Condition of Covariance:",
                        clusterChoice),
          ),
          conditionalPanel(
            condition = "input.combatKnownCT == 'No'",
            radioButtons("combatCTBalance", "Are cell types balanced?",
                         choices = c("Yes", "No")),
            conditionalPanel(
              condition = "input.combatCTBalance == 'No'",
              p("Will estimate surrogate variables and use them as an empirical control"),
            )
          ),
          selectInput("combatBioCond", "Select Biology Condition:",
                      clusterChoice),
          checkboxInput("combatShrink",
                        "Apply shrinkage on parameter estimation",
                        value = FALSE),
          conditionalPanel(
            condition = "input.combatShrink == true",
            numericInput("combatNGene",
                         "Number of random genes to use in empirical Bayes estimation",
                         value = NULL)
          ),
          checkboxInput("combatShrinkDisp",
                        "Apply shrinkage on dispersion",
                        value = FALSE),
          textInput("combatSaveAssay", "Assay Name to Use:", value = "ComBatSeq"),
          actionButton("combatRun", "Run")
        ),
        # FastMNN ####
        conditionalPanel(
          condition = "input.batchCorrMethods == 'FastMNN'",
          h5(tags$a(href = paste0(docs.base, "reference/runFastMNN.html"),
                    "(help for fastMNN)", target = "_blank")),
          checkboxInput('FastMNNPcInput', "Use low-dimension input instead",
                        value = FALSE),
          conditionalPanel(
            condition = 'input.FastMNNPcInput == true',
            selectInput('FastMNNReddim', "Select Reduced dimension:",
                        currreddim)
          ),
          textInput("FastMNNSaveReddim", "ReducedDim Name to Use:",
                    value = "FastMNN"),
          actionButton("FastMNNRun", "Run")
        ),
        # # Harmony ####
        # conditionalPanel(
        #   condition = "input.batchCorrMethods == 'Harmony'",
        #   h5(tags$a(href = paste0(docs.base, "reference/runHarmony.html"),
        #             "(help for Harmony)", target = "_blank")),
        #   checkboxInput('HarmonyPcInput', "Use low-dimension input instead",
        #                 value = FALSE),
        #   conditionalPanel(
        #     condition = 'input.HarmonyPcInput == true',
        #     selectInput('HarmonyReddim', "Select Reduced dimension:",
        #                 currreddim)
        #   ),
        #   numericInput("HarmonyNComp", label = "Number of output dimension:",
        #                value = 50L, min = 2, max = 100000, step = 1),
        #   textInput("HarmonyTheta", "Theta value", value = '5',
        #             placeholder = "Type a number"),
        #   numericInput("HarmonyNIter", "Number of iteration",
        #                value = 10L, min = 1, step = 1),
        #   textInput("HarmonySaveReddim", "ReducedDim Name to Use:",
        #             value = "Harmony"),
        #   withBusyIndicatorUI(actionButton("HarmonyRun", "Run"))
        # ),
        # # LIGER ####
        # conditionalPanel(
        #   condition = "input.batchCorrMethods == 'LIGER'",
        #   h5(tags$a(href = paste0(docs.base, "reference/runLIGER.html"),
        #             "(help for LIGER)", target = "_blank")),
        #   numericInput("ligerNComp", label = "Number of output dimension:",
        #                value = 20L, min = 2, max = 100000, step = 1),
        #   numericInput("ligerLambda", label = "Lambda:",
        #                value = 5.0, min = 0, max = 100000, step = 0.1),
        #   numericInput("ligerResolution", label = "Resolution:",
        #                value = 1.0, min = 0, max = 100000, step = 0.1),
        #   textInput("ligerSaveReddim", "ReducedDim Name to Save:",
        #             value = "LIGER"),
        #   withBusyIndicatorUI(actionButton("ligerRun", "Run"))
        # ),
        # Limma ####
        conditionalPanel(
          condition = "input.batchCorrMethods == 'Limma'",
          h5(tags$a(href = paste0(docs.base, "reference/runLimmaBC.html"),
                    "(help for Limma)", target = "_blank")),
          textInput("limmaSaveAssay", "Assay Name to Use:", value = "LIMMA"),
          actionButton("limmaRun", "Run")
        ),
        # MNN ####
        conditionalPanel(
          condition = "input.batchCorrMethods == 'MNN'",
          h5(tags$a(href = paste0(docs.base, "reference/runMNNCorrect.html"),
                    "(help for MNN)", target = "_blank")),
          numericInput('MNNK', 'K value',
                       value = 20, min = 1, step = 1),
          numericInput("MNNSigma", 'Sigma value', value = 0.1),
          textInput("MNNSaveAssay", "Assay Name to Use:", value = "MNN"),
          actionButton("MNNRun", "Run")
        ),
        # scanorama ####
        conditionalPanel(
          condition = "input.batchCorrMethods == 'scanorama'",
          h5(tags$a(href = paste0(docs.base, "reference/runSCANORAMA.html"),
                    "(help for Scanorama)", target = "_blank")),
          numericInput('scnrmSIGMA', 'Sigma value', 15),
          numericInput('scnrmALPHA', 'Alpha value', 0.1),
          numericInput('scnrmKNN', 'KNN value', 20, min = 1, step = 1),
          textInput("scnrmSaveAssay", "Assay Name to Use:",
                    value = "SCANORAMA"),
          actionButton("scnrmRun", "Run")
        ),
        # scMerge ####
        conditionalPanel(
          condition = "input.batchCorrMethods == 'scMerge'",
          h5(tags$a(href = paste0(docs.base, "reference/runSCMerge.html"),
                    "(help for scMerge)", target = "_blank")),
          ## SEG options
          radioButtons('scMergeSEGOpt', "Choose Stable Expressed Gene (SEG) seg",
                       choiceNames = c('Automatically identify',
                                       'Use pre-computed dataset',
                                       'Customized list'),
                       choiceValues = c(1, 2, 3)),
          conditionalPanel(
            condition = 'input.scMergeSEGOpt == 2',
            radioButtons('scMergeSEGSpecies', "The species of SEG:",
                         choices = c('human', 'mouse'))
          ),
          conditionalPanel(
            condition = 'input.scMergeSEGOpt == 3',
            textAreaInput("scMergeSEGCustom", "Use customized SEG:",
              placeholder = "paste them here.\nOne per line with no symbol separator.")
          ),
          checkboxInput("scMergeAutoKmk", "Automatically detect Kmeans-K",
                        value = TRUE),
          conditionalPanel(
            condition = "input.scMergeAutoKmk == false",
            uiOutput('scMergeNBatch'),
            textInput('scMergeUserKmk', label = NULL)
          ),
          selectInput("scMergeCT", "Cell Type Annotation:", clusterChoice),
          textInput("scMergeSaveAssay", "Assay Name to Use:",
                    value = "scMerge"),
          actionButton("scMergeRun", "Run")
        ),
        # Seurat3 Integration ####
        conditionalPanel(
          condition = "input.batchCorrMethods == 'Seurat3 Integration'",
          h5(tags$a(href = paste0(docs.base, "reference/runSeuratIntegration.html"),
                    "(help for Seurat Integration)", target = "_blank")),
          uiOutput('Srt3IntNAnchUI'),
          textInput("Srt3IntSaveAssay", "Assay Name to Use:",
                    value = "Seurat3Int"),
          actionButton("Srt3IntRun", "Run")
        ),
        # ZINBWaVE ####
        conditionalPanel(
          condition = "input.batchCorrMethods == 'ZINBWaVE'",
          h5(tags$a(href = paste0(docs.base, "reference/runZINBWaVE.html"),
                    "(help for ZINBWaVE)", target = "_blank")),
          span("Test on small example not passed yet, don't run.",
               style = 'color:red;'),
          uiOutput('zinbwaveNHvgUI'),
          uiOutput('zinbwaveEpsUI'),
          numericInput('zinbwaveNIter', 'Max number of iteration:',
                       value = 10, step = 1),
          numericInput('zinbwaveNComp', 'Number of dimensions to output:',
                       value = 50, min = 2, step = 1),
          textInput("zinbwaveSaveReddim", "ReducedDim Name to Use:",
                    value = "ZINBWaVE"),
          actionButton("zinbwaveRun", "Run")
        ),
        uiOutput("batchCorrStatus")
      ),
      mainPanel(
        fluidRow(
          class = "batchVarPlotRow",
          panel(
            heading = "Visualization",

            fluidRow(
              column(
                width = 4,
                dropdown(
                  fluidRow(
                    column(
                      width = 12,
                      fluidRow(actionBttn(inputId = "closeDropDownBC", label = NULL, style = "simple", color = "danger", icon = icon("times"), size = "xs"), align = "right"),
                      h5(tags$a(href = "https://compbiomed.github.io/sctk_docs/articles/batch_correction.html#visualization",
                                "(What are plotted?)", target = "_blank")),
                      selectizeInput(
                        inputId = "batchCheckOrigAssay", 
                        label = "Select input matrix:", 
                        choices = NULL, 
                        selected = NULL, 
                        multiple = FALSE,
                        options = NULL),
                      #uiOutput("batchCheckOrigAssay"),
                      #selectInput("batchCheckOrigAssay", "Original Assay:", currassays),
                      selectInput("batchCheckVar", "Batch Annotation:", clusterChoice),
                      selectInput("batchCheckCond", "Additional Condition (optional)",
                                  clusterChoice),
                      p("Only result generated in the current session will be presented. ",
                        style = "color:grey;"),
                      uiOutput("batchCheckResUI"),
                      withBusyIndicatorUI(
                        actionBttn(
                        inputId = "plotBatchCheck",
                        label = "Update",
                        style = "bordered",
                        color = "primary",
                        size = "sm"
                      )
                      )
                    )
                  ),
                  inputId = "dropDownBC",
                  icon = icon("cog"),
                  status = "primary",
                  circle = FALSE,
                  inline = TRUE
                )
              ),
              column(
                width = 7,
                fluidRow(
                  h6(
                    "The top two plots shows the variance explained by the grouping of batches and user specified conditions, and the bottom two plots present the low dimension representation of the datasets. Please refer to our documentation for detatil."
                  ),
                  align="center"
                )
              )
            ),
            hr(),
            br(),


            column(
              width = 6,
              style='border-right: 1px solid #CCCCCC',
              h4('Original Status'),
              plotOutput('batchOriVars',
                height = "300px", width = "300px"),
              plotOutput('batchOriPCA',
                height = "300px", width = "400px")
            ),
            column(
              width = 6,
              h4("Corrected Status"),
              plotOutput('batchCorrVars',
                height = "300px", width = "300px"),
              plotOutput('batchCorrReddim',
                height = "300px", width = "400px")
            ),
          )
        )
      )
    )
  )
  ),
  nonLinearWorkflowUI(id = "nlw-nbc")
)

# dir <- "genecount"
.constructSCEFromBUStoolsOutputs <- function(dir,
    sample,
    matrixFileName,
    featuresFileName,
    barcodesFileName,
    gzipped,
    class,
    delayedArray) {

    cb <- .readBarcodes(file.path(dir, barcodesFileName))
    fe <- .readFeatures(file.path(dir, featuresFileName))
    ma <- .readMatrixMM(file.path(dir, matrixFileName),
        gzipped = gzipped,
        class = class,
        delayedArray = delayedArray)
    ma <- t(ma)

    coln <- paste(sample, cb[[1]], sep = "_")
    rownames(ma) <- fe[[1]]

    sce <- SingleCellExperiment::SingleCellExperiment(
        assays = list(counts = ma))
    SummarizedExperiment::rowData(sce) <- fe
    SummarizedExperiment::colData(sce) <- S4Vectors::DataFrame(cb,
        column_name = coln,
        sample = sample,
        row.names = coln)
    
    return(sce)
}


# main function
.importBUStools <- function(
    BUStoolsDirs,
    samples,
    matrixFileNames,
    featuresFileNames,
    barcodesFileNames,
    gzipped,
    class,
    delayedArray,
    rowNamesDedup) {

    if (length(BUStoolsDirs) != length(samples)) {
        stop("'BUStoolsDirs' and 'samples' have unequal lengths!")
    }

    res <- vector("list", length = length(samples))

    matrixFileNames <- .getVectorized(matrixFileNames, length(samples))
    featuresFileNames <- .getVectorized(featuresFileNames, length(samples))
    barcodesFileNames <- .getVectorized(barcodesFileNames, length(samples))
    gzipped <- .getVectorized(gzipped, length(samples))

    for (i in seq_along(samples)) {
        dir <- file.path(BUStoolsDirs[i])
        scei <- .constructSCEFromBUStoolsOutputs(dir,
            sample = samples[i],
            matrixFileName = matrixFileNames[i],
            featuresFileName = featuresFileNames[i],
            barcodesFileName = barcodesFileNames[i],
            gzipped = gzipped[i],
            class = class,
            delayedArray = delayedArray)
        res[[i]] <- scei
    }

    sce <- do.call(SingleCellExperiment::cbind, res)
    
    if (isTRUE(rowNamesDedup)) {
        if (any(duplicated(rownames(sce)))) {
            message("Duplicated gene names found, adding '-1', '-2', ",
                    "... suffix to them.")
        }
        sce <- dedupRowNames(sce)
    }
    
    return(sce)
}


#' @name importBUStools
#' @rdname importBUStools
#' @title Construct SCE object from BUStools output
#' @description Read the barcodes, features (genes), and matrix from BUStools
#'  output. Import them
#'  as one \link[SingleCellExperiment]{SingleCellExperiment} object. Note the
#'  cells in the output files for BUStools 0.39.4 are not filtered.
#' @param BUStoolsDirs A vector of paths to BUStools output files. Each sample
#'  should have its own path. For example: \code{./genecount}.
#'  Must have the same length as \code{samples}.
#' @param samples A vector of user-defined sample names for the samples to be
#'  imported. Must have the same length as \code{BUStoolsDirs}.
#' @param matrixFileNames Filenames for the Market Exchange Format (MEX) sparse
#'  matrix files (.mtx files). Must have length 1 or the same
#'  length as \code{samples}.
#' @param featuresFileNames Filenames for the feature annotation files.
#'  Must have length 1 or the same length as \code{samples}.
#' @param barcodesFileNames Filenames for the cell barcode list file.
#'  Must have length 1 or the same length as \code{samples}.
#' @param gzipped Boolean. \code{TRUE} if the BUStools output files
#'  (barcodes.txt, genes.txt, and genes.mtx) were
#'  gzip compressed. \code{FALSE} otherwise. This is \code{FALSE} in BUStools
#'  0.39.4. Default \code{"auto"} which automatically detects if the
#'  files are gzip compressed. Must have length 1 or the same length as
#'  \code{samples}.
#' @param class Character. The class of the expression matrix stored in the SCE
#'  object. Can be one of "Matrix" (as returned by
#'  \link{readMM} function), or "matrix" (as returned by
#'  \link[base]{matrix} function). Default "Matrix".
#' @param delayedArray Boolean. Whether to read the expression matrix as
#'  \link[DelayedArray]{DelayedArray-class} object or not. Default \code{FALSE}.
#' @param rowNamesDedup Boolean. Whether to deduplicate rownames. Default 
#'  \code{TRUE}.
#' @return A \code{SingleCellExperiment} object containing the count
#'  matrix, the gene annotation, and the cell annotation.
#' @examples
#' # Example #1
#' # FASTQ files were downloaded from
#' # https://support.10xgenomics.com/single-cell-gene-expression/datasets/3.0.0
#' # /pbmc_1k_v3
#' # They were concatenated as follows:
#' # cat pbmc_1k_v3_S1_L001_R1_001.fastq.gz pbmc_1k_v3_S1_L002_R1_001.fastq.gz >
#' # pbmc_1k_v3_R1.fastq.gz
#' # cat pbmc_1k_v3_S1_L001_R2_001.fastq.gz pbmc_1k_v3_S1_L002_R2_001.fastq.gz >
#' # pbmc_1k_v3_R2.fastq.gz
#' # The following BUStools command generates the gene, cell, and
#' # matrix files
#'
#' # bustools correct -w ./3M-february-2018.txt -p output.bus | \
#' #   bustools sort -T tmp/ -t 4 -p - | \
#' #   bustools count -o genecount/genes \
#' #     -g ./transcripts_to_genes.txt \
#' #     -e matrix.ec \
#' #     -t transcripts.txt \
#' #     --genecounts -
#'
#' # The top 20 genes and the first 20 cells are included in this example.
#' sce <- importBUStools(
#'   BUStoolsDirs = system.file("extdata/BUStools_PBMC_1k_v3_20x20/genecount/",
#'     package = "singleCellTK"),
#'   samples = "PBMC_1k_v3_20x20")
#' @export
importBUStools <- function(
    BUStoolsDirs,
    samples,
    matrixFileNames = "genes.mtx",
    featuresFileNames = "genes.genes.txt",
    barcodesFileNames = "genes.barcodes.txt",
    gzipped = "auto",
    class = c("Matrix", "matrix"),
    delayedArray = FALSE,
    rowNamesDedup = TRUE) {

    class <- match.arg(class)

    .importBUStools(
        BUStoolsDirs = BUStoolsDirs,
        samples = samples,
        matrixFileNames = matrixFileNames,
        featuresFileNames = featuresFileNames,
        barcodesFileNames = barcodesFileNames,
        gzipped = gzipped,
        class = class,
        delayedArray = delayedArray,
        rowNamesDedup = rowNamesDedup)
}

scrubletHelpModal <- function() {
  modalDialog(
    tags$style(HTML("
      div {
        word-wrap: break-word;
      }
      ")),
    tags$div(
      h3("Srublet Parameters"),
      fluidRow(
        column(4, tags$b("Parameter Name")),
        column(8, tags$b("Description"))
      ),
      tags$hr(),
      fluidRow(
        column(4, "simDoubletRatio"),
        column(8, "Numeric. Number of doublets to simulate relative to the number of observed transcriptomes. Default 2.0.")
      ),
      tags$hr(),
      fluidRow(
        column(4, "nNeighbors"),
        column(8, 'Integer. Number of neighbors used to construct the KNN graph of observed transcriptomes and simulated 
               doublets. If NULL, this is set to round(0.5 * sqrt(n_cells)). Default NULL.')
      ),
      tags$hr(),
      fluidRow(
        column(4, "minDist"),
        column(8, "Float Determines how tightly UMAP packs points together. If NULL, this is set to 0.1. Default NULL.")
      ),
      tags$hr(),
      fluidRow(
        column(4, "expectedDoubletRate"),
        column(8, "The estimated doublet rate for the experiment. Default 0.1.")
      ),
      tags$hr(),
      fluidRow(
        column(4, "stdevDoubletRate"),
        column(8, "Uncertainty in the expected doublet rate. Default 0.02.")
      ),
      tags$hr(),
      fluidRow(
        column(4, "syntheticDoubletUmiSubsampling"),
        column(8, "Numeric. Rate for sampling UMIs when creating synthetic doublets. If 1.0, each doublet is created by simply 
               adding the UMIs from two randomly sampled observed transcriptomes. For values less than 1, the UMI counts are 
               added and then randomly sampled at the specified rate. Defuault: 1.0.")
      ),
      tags$hr(),
      fluidRow(
        column(4, "minCounts"),
        column(8, "Numeric. Used for gene filtering prior to PCA. Genes expressed at fewer than minCounts in fewer than minCells 
               are excluded. Default 3.")
      ),
      tags$hr(),
      fluidRow(
        column(4, "minCells"),
        column(8, "Integer. Used for gene filtering prior to PCA. Genes expressed at fewer than minCounts in fewer than minCells 
               are excluded. Default 3.")
      ),
      tags$hr(),
      fluidRow(
        column(4, "minGeneVariabilityPctl"),
        column(8, "Numeric. Used for gene filtering prior to PCA. Keep the most highly variable genes (in the top minGeneVariabilityPctl 
               percentile), as measured by the v-statistic (Klein et al., Cell 2015). Default 85.")
      ),
      tags$hr(),
      fluidRow(
        column(4, "nPrinComps"),
        column(8, "Integer. Number of principal components used to embed the transcriptomes prior to k-nearest-neighbor graph
               construction. Default 30.")
      ),
      tags$hr(),
      fluidRow(
        column(4, "tsneAngle"),
        column(8, "Float. Determines angular size of a distant node as measured from a point in the t-SNE plot. If default, it is set 
               to 0.5 Default NULL.")
      ),
      tags$hr(),
      fluidRow(
        column(4, "tsnePerplexity"),
        column(8, "Integer. The number of nearest neighbors that is used in other manifold learning algorithms. If default, it is set
               to 30. Default NULL.")
      ),
      tags$hr(),
      fluidRow(
        column(4, "distanceMetric"),
        column(8, 'Character. Distance metric used when finding nearest neighbors. For list of valid values, see the documentation for 
               annoy (if useApproxNeighbors is TRUE) or sklearn.neighbors.NearestNeighbors (if useApproxNeighbors is FALSE). 
               Default "euclidean".')
      ),
      tags$hr(),
      fluidRow(
        column(4, "useApproxNeighbors"),
        column(8, "Check off to use approximate nearest neighbor method (annoy) for the KNN classifier. Default TRUE.")
      ),
      tags$hr(),
      fluidRow(
        column(4, "getDoubletNeighborParents"),
        column(8, "Check off to return the parent transcriptomes that generated the doublet neighbors of each observed transcriptome. 
               This information can be used to infer the cell states that generated a given doublet state. Default FALSE.")
      ),
      tags$hr(),
      fluidRow(
        column(4, "logTransform"),
        column(8, "Check off to log-transform the counts matrix (log10(1+TPM)). sklearn.decomposition.TruncatedSVD will be used for 
               dimensionality reduction, unless meanCenter is TRUE. Default FALSE.")
      ),
      tags$hr(),
      fluidRow(
        column(4, "meanCenter"),
        column(8, "Check off to center the data such that each gene has a mean of 0. sklearn.decomposition.PCA will be used for 
               dimensionality reduction. Default TRUE.")
      ),
      tags$hr(),
      fluidRow(
        column(4, "normalizeVariance"),
        column(8, "Check off to normalize the data such that each gene has a variance of 1. sklearn.decomposition.TruncatedSVD will be 
               used for dimensionality reduction, unless meanCenter is TRUE. Default TRUE.")
      ),
      tags$hr(),
      fluidRow(
        column(4, "verbose"),
        column(8, "Check off to print progress updates to the console. Default TRUE.")
      ),
    )
  )
}

#' Plot heatmap of using data stored in SingleCellExperiment Object
#' @rdname plotSCEHeatmap
#' @param inSCE \linkS4class{SingleCellExperiment} inherited object.
#' @param useAssay character. A string indicating the assay name that
#' provides the expression level to plot. Only for \code{plotSCEHeatmap}.
#' @param useReducedDim character. A string indicating the reducedDim name that
#' provides the expression level to plot. Only for \code{plotSCEDimReduceHeatmap}.
#' @param doLog Logical scalar. Whether to do \code{log(assay + 1)}
#' transformation on the assay indicated by \code{useAssay}. Default
#' \code{FALSE}.
#' @param featureIndex A vector that can subset the input SCE object by rows
#' (features). Alternatively, it can be a vector identifying features in
#' another feature list indicated by \code{featureIndexBy}. Default \code{NULL}.
#' @param cellIndex A vector that can subset the input SCE object by columns
#' (cells). Alternatively, it can be a vector identifying cells in another
#' cell list indicated by \code{featureIndexBy}. Default \code{NULL}.
#' @param scale Whether to perform z-score or min-max scaling on each row.Choose from \code{"zscore"}, \code{"min-max"} or default
#' \code{TRUE} or \code{FALSE}
#' @param trim A 2-element numeric vector. Values outside of this range will be
#' trimmed to their nearst bound. Default \code{c(-2, 2)}
#' @param featureIndexBy A single character specifying a column name of
#' \code{rowData(inSCE)}, or a vector of the same length as \code{nrow(inSCE)},
#' where we search for the non-rowname feature indices. Not applicable for
#' \code{plotSCEDimReduceHeatmap}. Default \code{"rownames"}.
#' @param cellIndexBy A single character specifying a column name of
#' \code{colData(inSCE)}, or a vector of the same length as \code{ncol(inSCE)},
#' where we search for the non-rowname cell indices. Default \code{"rownames"}.
#' @param cluster_columns A logical scalar that turns on/off 
#' clustering of columns. Default \code{FALSE}. Clustering columns should be turned off when using reduced dim 
#' for plotting as it will be sorted by PCs
#' @param cluster_rows A logical scalar that turns on/off clustering of rows. 
#' Default \code{FALSE}.
#' @param rowDataName character. The column name(s) in \code{rowData} that need
#' to be added to the annotation. Not applicable for
#' \code{plotSCEDimReduceHeatmap}. Default \code{NULL}.
#' @param colDataName character. The column name(s) in \code{colData} that need
#' to be added to the annotation. Default \code{NULL}.
#' @param aggregateRow Feature variable for aggregating the heatmap by row. Can
#' be a vector or a \code{rowData} column name for feature variable. Multiple
#' variables are allowed. Default \code{NULL}.
#' @param aggregateCol Cell variable for aggregating the heatmap by column. Can
#' be a vector or a \code{colData} column name for cell variable. Multiple
#' variables are allowed. Default \code{NULL}.
#' @param featureAnnotations \code{data.frame}, with \code{rownames} containing
#' all the features going to be plotted. Character columns should be factors.
#' Default \code{NULL}.
#' @param cellAnnotations \code{data.frame}, with \code{rownames} containing
#' all the cells going to be plotted. Character columns should be factors.
#' Default \code{NULL}.
#' @param featureAnnotationColor A named list. Customized color settings for
#' feature labeling. Should match the entries in the \code{featureAnnotations}
#' or \code{rowDataName}. For each entry, there should be a list/vector of
#' colors named with categories. Default \code{NULL}.
#' @param cellAnnotationColor A named list. Customized color settings for
#' cell labeling. Should match the entries in the \code{cellAnnotations} or
#' \code{colDataName}. For each entry, there should be a list/vector of colors
#' named with categories. Default \code{NULL}.
#' @param palette Choose from \code{"ggplot"}, \code{"celda"} or \code{"random"}
#' to generate unique category colors.
#' @param heatmapPalette Choose from \code{"sequential"}, \code{"diverging"} or supply custom palette with colorScheme
#' to generate unique category colors. Default is \code{"sequential"}
#' @param addCellSummary Add summary barplots to column annotation. Supply the name of the column in colData as a character. This option will add summary for categorical variables 
#' as stacked barplots.
#' @param rowSplitBy character. Do semi-heatmap based on the grouping of
#' this(these) annotation(s). Should exist in either \code{rowDataName} or
#' \code{names(featureAnnotations)}. Default \code{NULL}.
#' @param colSplitBy character. Do semi-heatmap based on the grouping of
#' this(these) annotation(s). Should exist in either \code{colDataName} or
#' \code{names(cellAnnotations)}. Default \code{NULL}.
#' @param rowLabel Use a logical for whether to display all the feature names,
#' a single character to display a column of \code{rowData(inSCE)} annotation,
#' a vector of the same length as full/subset \code{nrow(inSCE)} to display
#' customized info. Default \code{FALSE}.
#' @param colLabel Use a logical for whether to display all the cell names, a
#' single character to display a column of \code{colData(inSCE)} annotation,
#' a vector of the same length as full/subset \code{ncol(inSCE)} to display
#' customized info. Default \code{FALSE}.
#' @param rowLabelSize A number for the font size of feature names. Default
#' \code{8}
#' @param colLabelSize A number for the font size of cell names. Default
#' \code{8}
#' @param rowDend Whether to display row dendrogram. Default \code{TRUE}.
#' @param colDend Whether to display column dendrogram. Default \code{TRUE}.
#' @param title The main title of the whole plot. Default \code{NULL}.
#' @param rowTitle The subtitle for the rows. Default \code{"Genes"}.
#' @param colTitle The subtitle for the columns. Default \code{"Cells"}.
#' @param rowGap A numeric value or a \code{\link[grid]{unit}} object. For the
#' gap size between rows of the splitted heatmap. Default
#' \code{grid::unit(0, 'mm')}.
#' @param colGap A numeric value or a \code{\link[grid]{unit}} object. For the
#' gap size between columns of the splitted heatmap. Default
#' \code{grid::unit(0, 'mm')}.
#' @param border A logical scalar. Whether to show the border of the heatmap or
#' splitted heatmaps. Default \code{TRUE}.
#' @param colorScheme function. A function that generates color code by giving
#' a value. Can be generated by \code{\link[circlize]{colorRamp2}}.
#' Default \code{NULL}.
#' @param ... Other arguments passed to \code{\link[ComplexHeatmap]{Heatmap}}.
#' @examples
#' data(scExample, package = "singleCellTK")
#' plotSCEHeatmap(sce[1:3,1:3], useAssay = "counts")
#' @return A \code{\link[ggplot2]{ggplot}} object.
#' @export
#' @author Yichen Wang
#' @importFrom scuttle aggregateAcrossCells aggregateAcrossFeatures
#' @importFrom SingleCellExperiment SingleCellExperiment
#' @importFrom SummarizedExperiment colData assayNames<-
#' @importFrom stringr str_replace_all str_c
#' @importFrom stats prcomp quantile
#' @importFrom dplyr select arrange group_by count ungroup mutate one_of desc
#' @importFrom tidyr spread unite 
#' @importFrom tibble column_to_rownames remove_rownames
#' @importFrom grid gpar
#' @importFrom ComplexHeatmap anno_barplot
#' @importFrom rlang .data
#' @importFrom S4Vectors DataFrame
#' 
#' 
plotSCEHeatmap <- function(inSCE, useAssay = 'logcounts', useReducedDim = NULL,
                           doLog = FALSE, featureIndex = NULL, cellIndex = NULL,
                           scale = TRUE, trim = c(-2,2),
                           featureIndexBy = 'rownames',
                           cellIndexBy = 'rownames',
                           cluster_columns = FALSE,
                           cluster_rows = FALSE,
                           rowDataName = NULL, colDataName = NULL,
                           aggregateRow = NULL, aggregateCol = NULL,
                           featureAnnotations = NULL, cellAnnotations = NULL,
                           featureAnnotationColor = NULL,
                           cellAnnotationColor = NULL,
                           palette = c("ggplot", "celda", "random"),
                           heatmapPalette = c("sequential","diverging"),
                           addCellSummary = NULL,
                           rowSplitBy = NULL, colSplitBy = NULL,
                           rowLabel = FALSE, colLabel = FALSE,
                           rowLabelSize = 6, colLabelSize = 6,
                           rowDend = TRUE, colDend = TRUE,
                           title = NULL, rowTitle = 'Features',
                           colTitle = 'Cells',
                           rowGap = grid::unit(0, 'mm'),
                           colGap = grid::unit(0, 'mm'),
                           border = FALSE, colorScheme = NULL, ...){
  palette<-match.arg(palette)
  heatmapPalette<-match.arg(heatmapPalette)
  # STAGE 1: Create clean SCE object with only needed information ####
  ## .selectSCEMatrix, .manageCellVar and .manageFeatureVar perform checks
  useMat <- .selectSCEMatrix(inSCE, useAssay = useAssay,
                             useReducedDim = useReducedDim,
                             returnMatrix = TRUE, cellAsCol = TRUE)
  useAssay <- useMat$names$useAssay
  useReducedDim <- useMat$names$useReducedDim
  useData <- ifelse(!is.null(useAssay), useAssay, useReducedDim)
  ### cell annotation
  oldColData <- colData(inSCE)
  colDataName <- unique(c(colDataName, aggregateCol))
  colDataAnns <- lapply(colDataName, function(x) .manageCellVar(inSCE, x))
  if (length(colDataName) > 0)
    colDataAnns <- data.frame(colDataAnns, row.names = colnames(inSCE))
  else
    colDataAnns <- data.frame(row.names = colnames(inSCE))
  colnames(colDataAnns) <- colDataName
  cellAnnotations <- .mergeAnnotationDF(colDataAnns, cellAnnotations)
  if (!is.null(colSplitBy) &&
      any(!colSplitBy %in% colnames(cellAnnotations)))
    stop('Specified `colSplitBy` variables not found.')
  if (isTRUE(colLabel)) {
    colLabelName <- colnames(inSCE)
  } else if (isFALSE(colLabel)) {
    colLabelName <- NULL
  } else {
    colLabelName <- .manageCellVar(inSCE, colLabel)
    colLabel <- TRUE
  }
  ### feature annotation
  rowDataAnns <- data.frame(row.names = rownames(useMat$mat))
  if (!is.null(useAssay)) {
    # When using reducedDim, no rowData can be applied
    rowDataName <- unique(c(rowDataName, aggregateRow))
    rowDataAnns <- lapply(rowDataName, function(x) .manageFeatureVar(inSCE, x))
    if (length(rowDataName) > 0)
      rowDataAnns <- data.frame(rowDataAnns, row.names = rownames(inSCE))
    else
      rowDataAnns <- data.frame(row.names = rownames(inSCE))
    colnames(rowDataAnns) <- rowDataName
  }
  # But customized featureAnnotations should work
  featureAnnotations <- .mergeAnnotationDF(rowDataAnns, featureAnnotations)
  if (!is.null(rowSplitBy) &&
      any(!rowSplitBy %in% colnames(featureAnnotations)))
    stop('Specified `rowSplitBy` variables not found.')
  if (isTRUE(rowLabel)) {
    rowLabelName <- rownames(useMat$mat)
  } else if (isFALSE(rowLabel)) {
    rowLabelName <- NULL
  } else {
    if (!is.null(useAssay)) {
      rowLabelName <- .manageFeatureVar(inSCE, rowLabel)
      rowLabel <- TRUE
    } else {
      # Using customized rowLabel for reducedDim
      if (length(rowLabel) != nrow(useMat$mat))
        stop("Length of `rowLabel` does not match nrow of specified ",
             "`useReducedDim`")
      rowLabelName <- rowLabel
      rowLabel <- TRUE
    }
  }
  ### create SCE object
  SCE <- SingleCellExperiment(assay = list(useMat$mat),
                              colData = cellAnnotations,
                              rowData = featureAnnotations)
  assayNames(SCE) <- useData
  
  .minmax<-function(mat){
    min_max<- function(x) {
      new_x =  (x - min(x))/ (max(x) - min(x))
      return(new_x)}
    new_mat<-as.matrix(apply(mat,FUN = min_max,MARGIN = 2))
    return(new_mat)
    }
  
  # STAGE 2: Subset SCE object as needed ####
  # Manage cell subsetting
  if(is.null(cellIndex)){
    cellIndex <- seq(ncol(SCE))
  } else if (is.character(cellIndex)) {
    # cellIndexBy not necessarily included in new "SCE"
    cellIndex <- retrieveSCEIndex(inSCE, cellIndex, axis = "col",
                                  by = cellIndexBy)
  } else if (is.logical(cellIndex)) {
    if (length(cellIndex) != ncol(inSCE)) {
      stop("Logical index length does not match ncol(inSCE)")
    }
    cellIndex <- which(cellIndex)
  }
  # Manage feature subsetting
  if(is.null(featureIndex)){
    featureIndex <- seq(nrow(SCE))
  } else if (is.character(featureIndex)) {
    if (!is.null(useAssay))
      featureIndex <- retrieveSCEIndex(inSCE, featureIndex, axis = "row",
                                       by = featureIndexBy)
    else
      # When using reducedDim, can only go with "PC" names
      # or customized "by"
      featureIndex <- retrieveSCEIndex(SCE, featureIndex, axis = "row",
                                       by = featureIndexBy)
  } else if (is.logical(featureIndex)) {
    if (length(featureIndex) != nrow(SCE)) {
      stop("Logical index length does not match nrow(inSCE)")
    }
    featureIndex <- which(featureIndex)
  }
  if(is.null(colLabelName)){
    colnames(SCE) <- NULL
  }
  else{
    colnames(SCE) <- colLabelName
  }
 
  if(is.null(rowLabelName)){
    rownames(SCE) <- NULL
  }
  else{
    rownames(SCE) <- rowLabelName
  }
  
  SCE <- SCE[featureIndex, cellIndex]
  ### Scaling should be done before aggregating
  if (isTRUE(doLog)) assay(SCE) <- log1p(assay(SCE))
  if(isTRUE(scale)) scale <- "zscore"
  if ((scale == "zscore")) {
    assay(SCE) <- as.matrix(base::scale(assay(SCE)))
  } else if (scale ==  "min_max") {
    assay(SCE) <- as.matrix(.minmax(assay(SCE)))
  }    
  
  
  # STAGE 3: Aggregate As needed ####
  if (!is.null(aggregateCol)) {
    # TODO: whether to also aggregate numeric variable that users want
    # Might need to use "coldata.merge" in aggregate function
    colIDS <- colData(SCE)[, aggregateCol]
    origRowData <- rowData(SCE)
    SCE <- aggregateAcrossCells(SCE, ids = colIDS,
                                use.assay.type = useData,
                                store.number = NULL, statistics = "mean")
    # TODO: `aggregateAcrossCells` produce duplicated variables in colData
    # and unwanted "ncell" variable even if I set `store.number = NULL`.
   #colData(SCE) <- colData(SCE)[,c(aggregateCol),drop=FALSE] ##change
    
    temp_df<-as.data.frame(colData(SCE)[,c(aggregateCol),drop=FALSE]) %>% 
      unite("new_colnames",dplyr::everything(),sep = "_",remove = FALSE) %>% 
      remove_rownames() %>% 
    #  mutate(aggregated_column = new_colnames) %>%
    #  dplyr::select(new_colnames, aggregated_column) %>%
      column_to_rownames("new_colnames")

    colData(SCE)<-DataFrame(temp_df)
    rowData(SCE) <- origRowData
  }
  if (!is.null(aggregateRow)) {
    # `aggregateAcrossFeatures` doesn't work by with multi-var
    # Remake one single variable vector
    rowIDS <- rowData(SCE)[, aggregateRow, drop = FALSE]
    rowIDS <- do.call(paste, c(rowIDS, list(sep = "_")))
    origColData <- colData(SCE)
    SCE <- aggregateAcrossFeatures(SCE, ids = rowIDS, average = TRUE,
                                   use.assay.type = useData)
    colData(SCE) <- origColData
  }
  # STAGE 4: Other minor preparation for plotting ####
 
  # Create a function that sorts the matrix by PC1
  .orderMatrix<-function(mat){
    # Adding extra character to rownames because presence of some char gets a "." if I don't
    mat2<-data.frame(t(mat))
    rownames(mat2)<-stringr::str_c("K_",rownames(mat2))
    pca_mat<-stats::prcomp(mat2,center = TRUE, scale. = FALSE)
    kl<-dplyr::arrange(data.frame(pca_mat$x)["PC1"],desc(data.frame(pca_mat$x)["PC1"]))
    mat<-data.frame(t(mat2)) %>% dplyr::select(rownames(kl))
    colnames(mat)<-stringr::str_replace_all(colnames(mat),"K_","")
    return(as.matrix(mat))
  }
  
  # Prepare
  
  if(!is.null(useReducedDim)){
    mat <- assay(SCE)
    mat <- .orderMatrix(mat)
    
  } else{
    
    if(class(assay(SCE))[1] == "dgCMatrix"){
      mat<- as.matrix(assay(SCE))
    }
    else{
     mat <- assay(SCE)
    }
  }
   
  
  if (!is.null(trim) & scale == "zscore") {
    assay(SCE) <- trimCounts(assay(SCE), trim)  
  }    
  
  
  if (is.null(colorScheme)) {
    if (isFALSE(scale)){
      if (heatmapPalette == "sequential"){
        colorScheme <- circlize::colorRamp2(quantile(mat,na.rm=TRUE),
                                            c('white', "#fecc5c",'#fdae61',"#f03b20","#bd0026"))
      }
      else if (heatmapPalette == "diverging"){
      colorScheme <- circlize::colorRamp2(c(min(mat),
                                            (max(mat) + min(mat))/2,
                                            max(mat)),
                                          c('blue', 'white', 'red'))
      }
    }
    else if (scale == "zscore"){
      colorScheme <- circlize::colorRamp2(quantile(assay(SCE), na.rm = TRUE),
                                          c('#2c7bb6','#abd9e9','#ffffbf','#fdae61','#d7191c'))
    }
    else if (scale == "min_max"){
      if(heatmapPalette == "sequential"){
        colorScheme <- circlize::colorRamp2(c(0,0.3,0.6,0.8,1),
                                            c('white', "#fecc5c",'#fdae61',"#f03b20","#bd0026")) 
        
      }
      else if (heatmapPalette == "diverging") {
      colorScheme <- circlize::colorRamp2(c(0,0.3,0.6,0.8,1),
                                          c('#2c7bb6','#abd9e9','#ffffbf','#fdae61','#d7191c'))     
      }
    }
  } else {
    if (!is.function(colorScheme))
      stop('`colorScheme` must be a function generated by ',
           'circlize::colorRamp2')
    breaks <- attr(colorScheme, 'breaks')
    if (breaks[1] != min(trim) || breaks[length(breaks)] != max(trim))
      stop('Breaks of `colorScheme` do not match with `trim`.')
  }
  
  # Avoid documentation error by setting these values to NULL
  # removed NOTE about namespaces.
  n<-value<-NULL
  
  ### Generate HeatmapAnnotation object
  ca <- NULL
  cellAnnotationColor <- .heatmapAnnColor(SCE, slot = "colData",
                                          custom = cellAnnotationColor,
                                          palette = palette)
  if(dim(cellAnnotations)[2] > 0)
    if(is.null(addCellSummary)){
      ca <- ComplexHeatmap::HeatmapAnnotation(df = as.data.frame(colData(SCE)),
                                              col = cellAnnotationColor)
    }
  else if (!addCellSummary %in% colnames(oldColData)){
    stop(addCellSummary,
         "' not found in colData")
  }
  else if (addCellSummary %in% colnames(oldColData)){
    oldColData %>%
      as.data.frame() %>%
      group_by(!!!rlang::syms(aggregateCol),!!!rlang::syms(addCellSummary)) %>%
      count() %>%
      ungroup() %>%
      group_by(!!! rlang::syms(aggregateCol)) %>%
      mutate(sum = sum(n)) %>%
      mutate(value = n/sum) %>%
      dplyr::select(-n,sum) %>%
      spread(one_of(addCellSummary),value) %>%
      ungroup() %>%
      dplyr::select(-one_of(aggregateCol),-sum) -> boxdata
    
    
    boxdata[is.na(boxdata)]  <- 0
    boxdata<-as.matrix(boxdata)
    ca <- ComplexHeatmap::HeatmapAnnotation(addCellSummary = anno_barplot(boxdata,
                                                                         gp = gpar(fill = 2:5)),
                                            annotation_label = addCellSummary,
                                            col = cellAnnotationColor)
  }
  ra <- NULL
  featureAnnotationColor <- .heatmapAnnColor(SCE, slot = "rowData",
                                             custom = featureAnnotationColor,
                                             palette = palette)
  if(ncol(rowData(SCE)) > 0)
    ra <- ComplexHeatmap::rowAnnotation(df = rowData(SCE),
                                        col = featureAnnotationColor)
  ### Set split variable
  cs <- NULL
  if (!is.null(colSplitBy)) cs <- colData(SCE)[colSplitBy]
  rs <- NULL
  if (!is.null(rowSplitBy)) rs <- rowData(SCE)[rowSplitBy]
  ###
  if (!is.null(colGap)) {
    if (!inherits(colGap, "unit"))
      stop("`colGap` has to be 'unit' object. Try `grid::unit(", colGap,
           ", 'mm')`.")
  }
  else colGap <- grid::unit(0, 'mm')
  if (!is.null(rowGap)) {
    if (!inherits(rowGap, "unit"))
      stop("`rowGap` has to be 'unit' object. Try `grid::unit(", rowGap,
           ", 'mm')`.")
  }
  else rowGap <- grid::unit(0, 'mm')
  
  if (!is.null(useAssay)) name <- useAssay
  else name <- useReducedDim
  hm <- ComplexHeatmap::Heatmap(mat, name = name, left_annotation = ra,
                                top_annotation = ca, col = colorScheme,
                                row_split = rs, column_split = cs,
                                row_title = rowTitle, column_title = colTitle,
                                show_row_names = rowLabel,
                                row_names_gp = grid::gpar(fontsize = rowLabelSize),
                                show_row_dend = rowDend,
                                show_column_dend = colDend,
                                row_dend_reorder = TRUE,
                                cluster_columns = cluster_columns,
                                cluster_rows = cluster_rows,
                                show_column_names = colLabel,
                                column_names_gp = grid::gpar(fontsize = colLabelSize),
                                row_gap = rowGap, column_gap = colGap,
                                border = border,
                                ...)
  return(hm)
}

.mergeAnnotationDF <- function(origin, external) {
  if (!is.null(external)) {
    external <- external[match(rownames(origin), rownames(external)), ,drop = FALSE]
    origin <- cbind(origin, external)
  }
  return(origin)
}

.heatmapAnnColor <- function(inSCE, slot = c("colData", "rowData"),
                             custom = NULL, palette = palette) {
  slot <- match.arg(slot)
  if (!is.null(custom) && !is.list(custom))
    stop("'cellAnnotationColor' or 'featureAnnotationColor' must be a list.")
  if (is.null(custom)) custom <- list()
  if (slot == "colData") data <- SummarizedExperiment::colData(inSCE)
  if (slot == "rowData") data <- SummarizedExperiment::rowData(inSCE)
  todoNames <- colnames(data)
  todoNames <- todoNames[!todoNames %in% names(custom)]
  newColor <- lapply(todoNames, function(n) {
    var <- data[[n]]
    if (is.factor(var)) categories <- levels(var)
    else categories <- unique(var)
    colors <- discreteColorPalette(length(categories), palette = palette)
    names(colors) <- categories
    return(colors)
  })
  names(newColor) <- todoNames
  custom <- c(custom, newColor)
  return(custom)
}
# Test
#logcounts(sceBatches) <- log1p(counts(sceBatches))
#plotSCEHeatmap2(sceBatches, "logcounts",
#                featureIndex = c("GCG1", "COX11", "INS1", "ND41"),
#                featureIndexBy = rowData(sceBatches)$feature_name,
#                cellIndex = c("reads.16087_", "Sample_1073_",
#                              "reads.29330_", "Sample_801_"),
#                cellIndexBy = paste0(colnames(sceBatches), "_"),
#                rowLabel = "feature_name", rowDend = FALSE,
#                cluster_rows = FALSE, colLabel = TRUE, cluster_columns = FALSE,
#                colDataName = c("batch", "cell_type"), aggregateCol = c("cell_type", "batch"))
#sce <-plotSCEHeatmap2(sceBatches, aggregateCol = "batch")
#plotSCEHeatmap2(sceBatches, aggregateCol = c("cell_type", "batch"))
#plotFindMarkerHeatmap(sce, log2fcThreshold = 0, minClustExprPerc = 0.4,
#                      maxCtrlExprPerc = 0.5)
#plotFindMarkerHeatmap(sce, log2fcThreshold = 0, minClustExprPerc = 0.4,
#                      maxCtrlExprPerc = 0.5,
#                      aggregateRow = "marker")
#plotSCEDimReduceColData(sce, "cluster", "UMAP")
CellVarColor <- function(inSCE, var,
                         palette = c("ggplot", "random", "celda"),
                         seed = 12345, ...) {
  var <- .manageCellVar(inSCE, var = var)
  palette <- match.arg(palette)
  if (is.factor(var)) uniqVar <- levels(var)
  else uniqVar <- unique(var)
  colors <- discreteColorPalette(length(uniqVar), palette = palette, seed = seed, ...)
  names(colors) <- uniqVar
  return(colors)
}

# User Interface for TSCAN  ---
shinyPanelTSCAN <- fluidPage(
  # Dropdown closing script ####
  tags$script("Shiny.addCustomMessageHandler('close_dropDownTSCAN', function(x){
                  $('html').click();
                });"),
  tags$script("Shiny.addCustomMessageHandler('close_dropDownTscanDE', function(x){
                  $('html').click();
                });"),
  tags$script("Shiny.addCustomMessageHandler('close_dropDownTscanClusterDEG', function(x){
                  $('html').click();
                });"),

  h1("Trajectory Analysis - TSCAN"),
  h5(tags$a(href = paste0(docs.artPath, "trajectoryAnalysis.html"),
            "(help)", target = "_blank")),
  inlineCSS(list(".panel-danger>.panel-heading" = "background-color:#dcdcdc; color:#000000",
                 ".panel-primary>.panel-heading" = "background-color:#f5f5f5; color:#000000; border-color:#dddddd",
                 ".panel-primary" = "border-color:#dddddd;",
                 ".panel-primary>.panel-heading+.panel-collapse>.panel-body" = "border-color:#dddddd;")),
  bsCollapse(
    id = "TSCANUI",
    open = "Calculate Pseudotime Values",
    bsCollapsePanel(
      # Collapse 1, Get MST ####
      "Calculate Pseudotime Values",
      fluidRow(
        column(
          4,
          panel(
            selectInput("TSCANReddim", "Select input dimension reduction:", currreddim),
            selectInput("TSCANclusterName", "Select clustering result: ",
                        "Auto generate clusters", selected = NULL),
            conditionalPanel(
              condition = 'input.TSCANclusterName == "Auto generate clusters"',
              numericInput(inputId = "seed_TSCAN",
                           label = "Seed value for reproducibility of result:",
                           value = 12345,
                           step = 1)
            ),
            actionButton("TSCANRun", "Run")
          )
        ),
        column(
          8,
          panel(
            fluidRow(
              column(
                width = 3,
                dropdown(
                  fluidRow(
                    column(
                      12,
                      fluidRow(actionBttn(inputId = "closeDropDownTSCAN",
                                          label = NULL, style = "simple",
                                          color = "danger", icon = icon("times"),
                                          size = "xs"),
                               align = "right"),
                      selectInput("TSCANVisRedDim", "Select 2D embedding for visualization:", currreddim),
                      actionBttn(
                        inputId = "TSCANPlot",
                        label = "Update",
                        style = "bordered",
                        color = "primary",
                        size = "sm"
                      )
                    )
                  ),
                  inputId = "dropDownTSCAN",
                  icon = icon("cog"),
                  status = "primary",
                  circle = FALSE,
                  inline = TRUE
                ),
              ),
              column(
                width = 9,
                fluidRow(
                  column(
                    width = 12,
                    h6(
                      "A scatter plot of the selected low-dimensionality representation of the dataset will be generated, with the calculated pseudotime colored on each dot (cell). The MST is also projected to the cells."
                    )
                  ),
                  align="center"
                )
              )
            ),
            hr(),
            shinyjqui::jqui_resizable(plotOutput("TSCANPlot"))
          )
        )
      ),
      style = "primary"
    ),

    bsCollapsePanel(
      # Collapse 2, DEG along selected path ####
      "Identify Genes Differentially Expressed For Path",
      fluidRow(
        column(
          4,
          panel(
            selectizeInput(
              inputId = "TSCANassayselect",
              label = "Select input matrix:",
              choices = NULL,
              selected = NULL,
              multiple = FALSE,
              options = NULL),
            pickerInput("pathIndexx", "Select path terminal node:",
                        choices = "", multiple = FALSE),
            pickerInput("discardCluster",
                        "Select cluster(s) to discard (OPTIONAL):",
                        choices = NULL,
                        selected = NULL,
                        multiple = TRUE,
                        options = list(
                          `none-selected-text` = "No cluster discarded"
                        )),
            actionButton("runTSCANDEG", "Run")
          )
        ),
        column(
          8,
          panel(
            fluidRow(
              column(
                width = 3,
                dropdown(
                  fluidRow(
                    column(
                      12,
                      fluidRow(
                        actionBttn(inputId = "closeDropDownTscanDE",
                                   label = NULL, style = "simple",
                                   color = "danger", icon = icon("times"),
                                   size = "xs"),
                        align = "right"
                      ),
                      selectInput("tscanDEexpPathIndex",
                                  "Select path terminal node:",
                                  choices = "", multiple = FALSE),
                      numericInput(inputId = "tscanDEHMTopGenes",
                                   label = "Number of top features for heatmap",
                                   value = 30,
                                   step = 1),
                      numericInput(inputId = "tscanDERegTopGenes",
                                   label = "Number of top features for regulation plots",
                                   value = 10,
                                   step = 1),
                      selectInput("tscanDEFeatureDisplay",
                                  "Display ID Type",
                                  c("Rownames (Default)",
                                    featureChoice)),
                      actionBttn(
                        inputId = "tscanDEPlot",
                        label = "Update",
                        style = "bordered",
                        color = "primary",
                        size = "sm"
                      )
                    )
                  ),
                  inputId = "dropDownTscanDE",
                  icon = icon("cog"),
                  status = "primary",
                  circle = FALSE,
                  inline = TRUE
                )
              ),
              column(
                width = 9,
                fluidRow(
                  column(
                    width = 12,
                    h6(
                      "Visualization on top genes that have significant expression changes along the pseudotime path of insterest."
                    )
                  ),
                  align = "center"
                )
              )
            ),
            hr(),
            tabsetPanel(
              tabPanel(
                # Tab 2.1, DEG Heatmap ####
                "Heatmap",
                panel(
                  fluidRow(
                    column(
                      width = 12,
                      h6(
                        "A heatmap of the expression of the top DE genes along the path in the cells on the path. "
                      )
                    ),

                  ),
                  hr(),
                  shinyjqui::jqui_resizable(
                    plotOutput(outputId = "heatmapPlot")
                  )
                )
              ),
              tabPanel(
                # Tab 2.2, Gene expression increasing along pseudotime ####
                "Up-regulated Genes",
                panel(
                  fluidRow(
                    column(
                      width = 12,
                      h6(
                        "A cell scatter plot showing the expression change along the pseudotime. Genes with top significance in increasing expression along the pseudotime are displayed."
                      )
                    ),
                    align="center"
                  ),
                  hr(),
                  shinyjqui::jqui_resizable(
                    plotOutput(outputId = "UpregGenesPlot")
                  )
                )
              ),
              tabPanel(
                # Tab 2.3, Gene expression decreasing along pseudotime ####
                "Down-regulated Genes",
                panel(
                  fluidRow(
                    column(
                      width = 12,
                      h6(
                        "A cell scatter plot showing the expression change along the pseudotime. Genes with top significance in decreasing expression along the pseudotime are displayed."
                      )
                    ),
                    align="center"
                  ),
                  hr(),
                  shinyjqui::jqui_resizable(
                    plotOutput(outputId = "DownregGenesPlot")
                  )
                )
              )
            )
          )
        )
      ),
      style = "primary"
    ),

    bsCollapsePanel(
      # Collapse 3, DEG between branches of selected cluster ####
      "Identify Genes Differentially Expressed For Branched Cluster",
      fluidRow(
        column(
          4,
          panel(
            selectInput("TSCANUseCluster",
                        "Select branched cluster of interest:",
                        choices = NULL),
            selectizeInput(
              inputId = "TSCANBranchAssaySelect",
              label = "Select input matrix:",
              choices = NULL,
              selected = NULL,
              multiple = FALSE,
              options = NULL),
            numericInput(inputId = "fdrThreshold_TSCAN",
                         label = "FDR less than:",
                         value = 0.05,
                         step = 0.01),
            actionButton("findDEGenes", "Run")
          )
        ),
        column(
          8,
          panel(
            fluidRow(
              column(
                width = 3,
                dropdown(
                  fluidRow(
                    actionBttn(inputId = "closeDropDownTscanClusterDEG",
                               label = NULL, style = "simple",
                               color = "danger", icon = icon("times"),
                               size = "xs"),
                    align = "right"
                  ),
                  selectInput("plotTSCANClusterDEG_useCluster",
                              "Select branched cluster of interest:",
                              choices = "", multiple = FALSE),
                  pickerInput("plotTSCANClusterDEG_pathIndex",
                              "Select Path Index:",
                              choices = NULL,
                              choicesOpt = NULL,
                              selected = NULL),
                  selectInput("plotTSCANClusterDEG_useReducedDim",
                              "Select 2D embedding for visualization:",
                              currreddim),
                  numericInput("plotTSCANClusterDEG_topN",
                               label = "Number of top features to plot:",
                               value = 4, min = 1, step = 1),
                  selectInput("plotTSCANClusterDEG_featureDisplay",
                              "Display ID Type",
                              c("Rownames (Default)",
                                featureChoice)),
                  actionBttn(
                    inputId = "plotTSCANClusterDEG",
                    label = "Update",
                    style = "bordered",
                    color = "primary",
                    size = "sm"
                  ),
                  inputId = "dropDownTscanClusterDEG",
                  icon = icon("cog"),
                  status = "primary",
                  circle = FALSE,
                  inline = TRUE
                )
              ),
              column(
                width = 9,
                fluidRow(
                  column(
                    width = 12,
                    h6(
                      "Visualization and tables of top DE genes on different branch path of the cluster of interest."
                    )
                  ),
                  align="center"
                )
              )
            ),
            hr(),
            tabsetPanel(
              tabPanel(
                # Tab 3.1, feature cluster expression scatter ####
                "Top Feature Plot",
                panel(
                  fluidRow(
                    column(
                      width = 12,
                      h6(
                        "Scatter plots on the selected low-dimension representation of cells in the selected cluster, colored by the expression of top features differentially expressed in the selected branch path. Local MST overlaid."
                      )
                    ),
                    align="center"
                  ),
                  hr(),
                  shinyjqui::jqui_resizable(
                    plotOutput(outputId = "tscanCLusterDEG")
                  )
                )
              ),
              tabPanel(
                # Tab 3.2, Datatable ####
                "Top Feature Table",
                panel(
                  fluidRow(
                    column(
                      width = 12,
                      h6(
                        "A table of top features differentially expressed in the selected branch path of the selected cluster, with statistical metrics displayed."
                      )
                    ),
                    align="center"
                  ),
                  hr(),
                  DT::dataTableOutput("tscanCLusterDEGTable")
                )
              ),
              tabPanel(
                # Tab 3.3, scatter plots of pseudotime ####
                "Pseudotime",
                panel(
                  fluidRow(
                    column(
                      width = 12,
                      h6(
                        "Scatter plots on the selected low-dimension representation of cells in the selected cluster, colored by the recomputed pseudotime value on each of the branching path. Local MST overlaid."
                      )
                    ),
                    align="center"
                  ),
                  hr(),
                  shinyjqui::jqui_resizable(
                    plotOutput(outputId = "tscanCLusterPeudo")
                  )
                )
              )
            )
          )
        )
      ),
      style = "primary"
    ),
    bsCollapsePanel(
      # Collanpse 4, free plot ####
      "Plot feature expression on trajectory",
      fluidRow(
        column(
          4,
          panel(
            selectizeInput(
              inputId = "plotTSCANDimReduceFeatures_useAssay",
              label = "Select expression matrix:",
              choices = NULL,
              selected = NULL,
              multiple = FALSE,
              options = NULL),
            selectizeInput("plotTSCANDimReduceFeatures_features",
                           label = "Select feature(s):", NULL,
                           multiple = TRUE),
            selectInput("plotTSCANDimReduceFeatures_useReducedDim",
                        "Select 2D embedding for visualization:", currreddim),
            pickerInput("plotTSCANDimReduceFeatures_useCluster",
                        "Show cluster(s) of interest:",
                        choices = NULL,
                        selected = NULL,
                        multiple = TRUE,
                        options = list(
                          `none-selected-text` = "Show all"
                        )),
            selectInput("plotTSCANDimReduceFeatures_featureDisplay",
                        "Display ID Type",
                        c("Rownames (Default)",
                          featureChoice)),
            actionButton("plotTSCANDimReduceFeatures", "Plot")
          )
        ),
        column(
          8,
          panel(
            fluidRow(
              column(
                width = 12,
                h6(
                  "Scatter plots on the selected low-dimension representation of cells in the selected cluster, colored by the expression of selected features, with the MST overlaid."
                )
              ),
              align="center"
            ),
            hr(),
            shinyjqui::jqui_resizable(
              plotOutput("TscanDimReduceFeatures")
            )
          )
        )
      ),
      style = "primary"
    )
  ),
  nonLinearWorkflowUI(id = "nlw-Traj")
)

#' Plot t-SNE plot on dimensionality reduction data run from t-SNE method.
#'
#' @param runTSNE Run t-SNE if the reducedDimName does not exist. the Default is
#' FALSE.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object.
#' @param useAssay Indicate which assay to use. The default is "logcounts".
#' @param reducedDimName a name to store the results of the dimension reduction
#' coordinates obtained from this method. This is stored in the SingleCellExperiment
#' object in the reducedDims slot. Required.
#' @param colorBy color by condition.
#' @param shape add shape to each distinct label.
#'
#' @return A t-SNE plot
#' @export
#' @examples
#' data("mouseBrainSubsetSCE")
#' plotTSNE(mouseBrainSubsetSCE, colorBy = "level1class",
#'          reducedDimName = "TSNE_counts")
plotTSNE <- function(inSCE, colorBy = NULL, shape = NULL,
                     reducedDimName = "TSNE", runTSNE = FALSE,
                     useAssay = "counts"){
  if(!(reducedDimName %in% names(SingleCellExperiment::reducedDims(inSCE)))){
    if (runTSNE){
      inSCE <- runQuickTSNE(inSCE, useAssay = useAssay,
                            reducedDimName = reducedDimName)
    } else {
      stop(reducedDimName,
           " dimension not found. Run `runTSNE()` or set `runTSNE` to `TRUE`.")
    }
  }
  tsneDf <- data.frame(SingleCellExperiment::reducedDim(inSCE,
                                                        reducedDimName))
  if (ncol(tsneDf) > 2){
    warning("More than two t-SNE dimensions. Using the first two.")
  }
  colnames(tsneDf)[1] <- "tSNE1"
  colnames(tsneDf)[2] <- "tSNE2"
  xdim <- colnames(tsneDf)[1]
  ydim <- colnames(tsneDf)[2]
  if (!is.null(colorBy)){
    tsneDf$color <- SingleCellExperiment::colData(inSCE)[, colorBy]
  }
  if (!is.null(shape)){
    tsneDf$shape <- factor(SingleCellExperiment::colData(inSCE)[, shape])
  }
  tsneDf$Sample <- colnames(inSCE)
  g <- ggplot2::ggplot(tsneDf, ggplot2::aes_string(xdim, ydim,
                                                   label = "Sample")) +
    ggplot2::geom_point()
  if (!is.null(colorBy)){
    g <- g + ggplot2::aes_string(color = "color") +
      ggplot2::labs(color = colorBy)
  }
  if (!is.null(shape)){
    g <- g + ggplot2::aes_string(shape = "shape") +
      ggplot2::labs(shape = shape)
  }
  return(g)
}

.runBarcodeRankDrops <- function(barcode.matrix, lower = lower,
                                 fit.bounds = fit.bounds,
                                 df = df) {
  
  ## Convert to sparse matrix if not already in that format
  barcode.matrix <- .convertToMatrix(barcode.matrix)
  
  output <- DropletUtils::barcodeRanks(m = barcode.matrix, lower = lower,
                                       fit.bounds = fit.bounds,
                                       df = df)
  
  knee.ix <- as.integer(output$total >= 
                          S4Vectors::metadata(output)$knee)
  inflection.ix <- as.integer(output$total >= 
                                S4Vectors::metadata(output)$inflection)

  rank.ix <- as.integer(output$rank)
  total.ix <- as.integer(output$total)
  
  result <- cbind(knee.ix, inflection.ix, rank.ix, total.ix)
  colnames(result) <- c("dropletUtils_barcodeRank_knee",
                        "dropletUtils_barcodeRank_inflection",
                        "dropletUtils_barcodeRank_rank",
                        "dropletUtils_barcodeRank_total")
  
  result.list <- list(result,
                      S4Vectors::metadata(output)$knee,
                      S4Vectors::metadata(output)$inflection)
  names(result.list) <- c("matrix", "knee", "inflection")
  return(result.list)
}


#' @title Identify empty droplets using \link[DropletUtils]{barcodeRanks}.
#' @description Run \link[DropletUtils]{barcodeRanks} on a count matrix
#' provided in a \linkS4class{SingleCellExperiment} object. Distinguish between 
#' droplets containing cells and ambient RNA in a droplet-based single-cell RNA 
#' sequencing experiment.
#' @param inSCE A \linkS4class{SingleCellExperiment} object. Must contain a raw 
#' counts matrix before empty droplets have been removed.
#' @param sample Character vector or colData variable name. Indicates which 
#' sample each cell belongs to. Default \code{NULL}.
#' @param useAssay A string specifying which assay in the SCE to use. Default 
#' \code{"counts"}
#' @param lower See \link[DropletUtils]{barcodeRanks} for more information. 
#' Default \code{100}.
#' @param fitBounds See \link[DropletUtils]{barcodeRanks} for more information. 
#' Default \code{NULL}.
#' @param df See \link[DropletUtils]{barcodeRanks} for more information. Default 
#' \code{20}.
#' @return A \linkS4class{SingleCellExperiment} object with the
#' \link[DropletUtils]{barcodeRanks} output table appended to the
#' \link{colData} slot. The columns include
#' \code{dropletUtils_BarcodeRank_Knee} and 
#' \code{dropletUtils_barcodeRank_inflection}. Please refer to the documentation
#' of \link[DropletUtils]{barcodeRanks} for details.
#' @seealso \code{\link[DropletUtils]{barcodeRanks}}, 
#' \code{\link{runDropletQC}}, \code{\link{plotBarcodeRankDropsResults}}
#' @examples
#' data(scExample, package = "singleCellTK")
#' sce <- runBarcodeRankDrops(inSCE = sce)
#' @export
#' @importFrom SummarizedExperiment colData colData<- assay
runBarcodeRankDrops <- function(inSCE,
                                sample = NULL,
                                useAssay = "counts",
                                lower = 100,
                                fitBounds = NULL,
                                df = 20
) {
  
  p <- paste0(date(), " ... Running 'barcodeRanks'")
  message(p)
  
  ##  Getting current arguments values
  argsList <- mget(names(formals()),sys.frame(sys.nframe()))
  argsList <- argsList[!names(argsList) %in% c("inSCE")]
  argsList$packageVersion <- utils::packageDescription("DropletUtils")$Version
  
  sample <- .manageCellVar(inSCE, var = sample)
  if (is.null(sample)) {
    sample <- rep(1, ncol(inSCE))
  }
  
  ## Define result matrix for all samples
  output <- S4Vectors::DataFrame(
    row.names = colnames(inSCE),
    dropletUtils_BarcodeRank_Knee = integer(ncol(inSCE)),
    dropletUtils_BarcodeRank_Inflection = integer(ncol(inSCE))
  )
  
  ## Loop through each sample and run barcodeRank
  samples <- unique(sample)
  for (s in samples) {
    sceSampleInd <- sample == s
    sceSample <- inSCE[, sceSampleInd]
    
    ## Define meta matrix for each subinSCE
    metaOutput <- S4Vectors::DataFrame(
      row.names = colnames(sceSample),
      dropletUtils_barcodeRank_rank = integer(ncol(sceSample)),
      dropletUtils_barcodeRank_total = integer(ncol(sceSample)),
      dropletUtils_barcodeRank_fitted = integer(ncol(sceSample)),
      dropletUtils_barcodeRank_knee = integer(ncol(sceSample)),
      dropletUtils_barcodeRank_inflection = integer(ncol(sceSample))
    )
    metaOutput$sample <- colData(sceSample)[["Sample"]]
    
    mat <- assay(sceSample, i = useAssay)
    result <- .runBarcodeRankDrops(barcode.matrix = mat, lower = lower,
                                   fit.bounds = fitBounds,
                                   df = df)
    
    result.matrix <- result$matrix
    output[sceSampleInd, ] <- 
      result.matrix[, c("dropletUtils_barcodeRank_knee",
                        "dropletUtils_barcodeRank_inflection")]
    
    metaCols <- c("dropletUtils_barcodeRank_rank", 
                  "dropletUtils_barcodeRank_total")
    metaOutput[, metaCols] <- result.matrix[, metaCols]
    metaOutput[,"dropletUtils_barcodeRank_knee"] <- rep(result$knee,
                                                        sum(sceSampleInd))
    metaOutput[,"dropletUtils_barcodeRank_inflection"] <- rep(result$inflection,
                                                              sum(sceSampleInd))
    
    # Remove duplicated Rank
    metaOutput <- 
      metaOutput[!duplicated(metaOutput$dropletUtils_barcodeRank_rank), ]
    if (!identical(samples, 1)) {
      S4Vectors::metadata(inSCE)$sctk$runBarcodeRankDrops[[s]] <- 
        list(metaOutput = metaOutput, argsList = argsList)
    }
  }
  if (identical(samples, 1)) {
    S4Vectors::metadata(inSCE)$sctk$runBarcodeRankDrops$all_cells <- 
      list(metaOutput = metaOutput, argsList = argsList)
  }
  
  colData(inSCE) <- cbind(colData(inSCE), output)
  return(inSCE)
}

# QC algorithms for all barcodes, pre-filter
library(singleCellTK)
context("Testing dropletUtils algorithms")
data(scExample, package = "singleCellTK")

test_that(desc = "Testing runBarcodeRankDrops", {
        sce <- runBarcodeRankDrops(inSCE = sce)
        expect_equal(length(colData(sce)$dropletUtils_BarcodeRank_Inflection),ncol(sce))
        expect_equal(class(colData(sce)$dropletUtils_BarcodeRank_Inflection), "integer")
        gg <- plotBarcodeRankDropsResults(sce)
        expect_is(gg$scatterBarcodeRank, "ggplot")
})

#' @title Imports gene sets from a GMT file
#' @description Converts a list of gene sets stored in a GMT file into a
#' \linkS4class{GeneSetCollection} and stores it in the metadata of the
#' \linkS4class{SingleCellExperiment} object. These gene sets can be used in
#' downstream quality control and analysis functions in \link{singleCellTK}.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object.
#' @param file Character. Path to GMT file. See \link{getGmt} for
#' more information on reading GMT files.
#' @param collectionName Character. Name of collection to add gene sets to.
#' If this collection already exists in \code{inSCE}, then these gene sets will
#' be added to that collection. Any gene sets within the collection with the
#' same name will be overwritten. Default \code{GeneSetCollection}.
#' @param by Character, character vector, or NULL. Describes the
#' location within \code{inSCE} where the gene identifiers in
#' \code{geneSetList} should be mapped. If set to \code{"rownames"} then the
#' features will be searched for among \code{rownames(inSCE)}. This can also be
#' set to one of the column names of \code{rowData(inSCE)} in which case the
#' gene identifies will be mapped to that column in the \code{rowData}
#' of \code{inSCE}. \code{by} can be a vector the same length as
#' the number of gene sets in the GMT file and the elements of the vector
#' can point to different locations within \code{inSCE}. Finally, \code{by}
#' can be \code{NULL}. In this case, the location of the gene identifiers
#' in \code{inSCE} should be saved in the description (2nd column)
#' of the GMT file. See \link{featureIndex} for more information.
#' Default \code{"rownames"}.
#' @param sep Character. Delimiter of the GMT file. Default \code{"\t"}.
#' @param noMatchError Boolean. Show an error if a collection does not have
#' any matching features. Default \code{TRUE}.
#' @details The gene identifiers in gene sets in the GMT file will be
#' mapped to the rownames of \code{inSCE} using the \code{by} parameter and
#' stored in a \linkS4class{GeneSetCollection} object from package
#' \link{GSEABase}. This object is stored in
#' \code{metadata(inSCE)$sctk$genesets}, which can be accessed in downstream
#' analysis functions such as \link[singleCellTK]{runCellQC}.
#' @author Joshua D. Campbell
#' @seealso \link{importGeneSetsFromList} for importing from lists,
#' \link{importGeneSetsFromCollection} for importing from
#' \linkS4class{GeneSetCollection} objects, and
#' \link{importGeneSetsFromMSigDB} for importing MSigDB gene sets.
#' @return A \link[SingleCellExperiment]{SingleCellExperiment} object
#'  with gene set from \code{collectionName} output stored to the
#'  \link{metadata} slot.
#' @examples
#' data(scExample)
#'
#' # GMT file containing gene symbols for a subset of human mitochondrial genes
#' gmt <- system.file("extdata/mito_subset.gmt", package = "singleCellTK")
#'
#' # "feature_name" is the second column in the GMT file, so the ids will
#' # be mapped using this column in the 'rowData' of 'sce'. This
#' # could also be accomplished by setting by = "feature_name" in the
#' # function call.
#' sce <- importGeneSetsFromGMT(inSCE = sce, file = gmt, by = NULL)
#' @export
importGeneSetsFromGMT <- function(inSCE, file,
                                  collectionName = "GeneSetCollection",
                                  by = "rownames",
                                  sep = "\t",
                                  noMatchError = TRUE) {

  # Read gmt file into GeneSetCollection
  gsc <- GSEABase::getGmt(con = file, sep = sep)

  inSCE <- importGeneSetsFromCollection(inSCE = inSCE,
                                        geneSetCollection = gsc,
                                        collectionName = collectionName,
                                        by = by,
                                        noMatchError = noMatchError)
  return(inSCE)
}


#' @title Imports gene sets from a list
#' @description Converts a list of gene sets into a
#' \linkS4class{GeneSetCollection} and stores it in the metadata of the
#' \linkS4class{SingleCellExperiment} object. These gene sets can be used in
#' downstream quality control and analysis functions in \link{singleCellTK}.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object.
#' @param geneSetList Named List. A list containing one or more gene sets.
#' Each element of the list should be a character vector of gene identifiers.
#' The names of the list will be become the gene set names in the
#' \linkS4class{GeneSetCollection} object.
#' @param collectionName Character. Name of collection to add gene sets to.
#' If this collection already exists in \code{inSCE}, then these gene sets will
#' be added to that collection. Any gene sets within the collection with the
#' same name will be overwritten. Default \code{GeneSetCollection}.
#' @param by Character or character vector. Describes the
#' location within \code{inSCE} where the gene identifiers in
#' \code{geneSetList} should be mapped. If set to \code{"rownames"} then the
#' features will be searched for among \code{rownames(inSCE)}. This can also be
#' set to one of the column names of \code{rowData(inSCE)} in which case the
#' gene identifies will be mapped to that column in the \code{rowData}
#' of \code{inSCE}. Finally, \code{by} can be a vector the same length as
#' the number of gene sets in \code{geneSetList} and the elements of the vector
#' can point to different locations within \code{inSCE}. See
#' \link{featureIndex} for more information.
#' Default \code{"rownames"}.
#' @param noMatchError Boolean. Show an error if a collection does not have
#' any matching features. Default \code{TRUE}.
#' @return A \link[SingleCellExperiment]{SingleCellExperiment} object
#' with gene set from \code{collectionName} output stored to the
#' \link{metadata} slot.
#' @details The gene identifiers in gene sets in \code{geneSetList} will be
#' mapped to the rownames of \code{inSCE} using the \code{by} parameter and
#' stored in a \linkS4class{GeneSetCollection} object from package
#' \link{GSEABase}. This object is stored in
#' \code{metadata(inSCE)$sctk$genesets}, which can be accessed in downstream
#' analysis functions such as \link[singleCellTK]{runCellQC}.
#' @author Joshua D. Campbell
#' @seealso \link{importGeneSetsFromCollection} for importing from
#' \linkS4class{GeneSetCollection} objects,
#' \link{importGeneSetsFromGMT} for importing from GMT files, and
#' \link{importGeneSetsFromMSigDB} for importing MSigDB gene sets.
#' @examples
#' data(scExample)
#'
#' # Generate gene sets from 'rownames'
#' gs1 <- rownames(sce)[seq(10)]
#' gs2 <- rownames(sce)[seq(11,20)]
#' gs <- list("geneset1" = gs1, "geneset2" = gs2)
#' sce <- importGeneSetsFromList(inSCE = sce,
#'                               geneSetList = gs,
#'                               by = "rownames")
#'
#' # Generate a gene set for mitochondrial genes using
#' # Gene Symbols stored in 'rowData'
#' mito.ix <- grep("^MT-", rowData(sce)$feature_name)
#' mito <- list(mito = rowData(sce)$feature_name[mito.ix])
#' sce <- importGeneSetsFromList(inSCE = sce,
#'                              geneSetList = mito,
#'                              by = "feature_name")
#' @export
#' @importFrom SummarizedExperiment rowData
importGeneSetsFromList <- function(inSCE, geneSetList,
                                   collectionName = "GeneSetCollection",
                                   by = "rownames",
                                   noMatchError = TRUE) {

  # Check to ensure 'by' is correct
  if(!all(by %in% c("rownames", colnames(rowData(inSCE))))) {
    stop("The entries in 'by' must be 'rownames' or one of the column names ",
         "in the 'rowData(inSCE)': ", paste(colnames(rowData(inSCE)),
         collapse = ", "))
  }
  if(length(by) != 1 & length(by) != length(geneSetList)) {
    stop("'by' needs to be a character of length 1 describing the location ",
         "of all the gene sets in inSCE or a character vector the same ",
         "length as 'geneSetList' where each entry describes the location of ",
         "that particular gene set in 'geneSetList'.")
  }
  if(is.null(names(geneSetList))) {
    stop("'geneSetList' needs to be a named list.")
  }
  if(any(is.na(names(geneSetList)))) {
    stop("No names in 'geneSetList' can be 'NA'.")
  }

  # Convert to GeneSetCollection
  gs <- list()
  for(i in seq_along(geneSetList)) {
    gs[[i]] <- GSEABase::GeneSet(setName = names(geneSetList)[i],
                                 geneIds = geneSetList[[i]])
  }
  gsc <- GSEABase::GeneSetCollection(gs)

  inSCE <- importGeneSetsFromCollection(inSCE = inSCE,
                                        geneSetCollection = gsc,
                                        collectionName = collectionName,
                                        by = by,
                                        noMatchError = noMatchError)
  return(inSCE)
}

#' @title Imports gene sets from a GeneSetCollection object
#' @description Converts a list of gene sets stored in a
#' \linkS4class{GeneSetCollection} object and stores it in the metadata of the
#' \linkS4class{SingleCellExperiment} object. These gene sets can be used in
#' downstream quality control and analysis functions in \link{singleCellTK}.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object.
#' @param geneSetCollection A \linkS4class{GeneSetCollection} object. See
#' \link{GeneSetCollection} for more details.
#' @param collectionName Character. Name of collection to add gene sets to.
#' If this collection already exists in \code{inSCE}, then these gene sets will
#' be added to that collection. Any gene sets within the collection with the
#' same name will be overwritten. Default \code{GeneSetCollection}.
#' @param by Character, character vector, or NULL. Describes the
#' location within \code{inSCE} where the gene identifiers in
#' \code{geneSetCollection} should be mapped. If set to \code{"rownames"} then the
#' features will be searched for among \code{rownames(inSCE)}. This can also be
#' set to one of the column names of \code{rowData(inSCE)} in which case the
#' gene identifies will be mapped to that column in the \code{rowData}
#' of \code{inSCE}. \code{by} can be a vector the same length as
#' the number of gene sets in the \code{GeneSetCollection} and the elements of the vector
#' can point to different locations within \code{inSCE}. Finally, \code{by}
#' can be \code{NULL}. In this case, the location of the gene identifiers
#' in \code{inSCE} should be saved in the description slot for each gene set
#' in the \code{GeneSetCollection}.
#' See \link{featureIndex} for more information.
#' Default \code{"rownames"}.
#' @param noMatchError Boolean. Show an error if a collection does not have
#' any matching features. Default \code{TRUE}.
#' @return A \link[SingleCellExperiment]{SingleCellExperiment} object
#' with gene set from \code{collectionName} output stored to the
#' \link{metadata} slot.
#' @details The gene identifiers in gene sets in the
#' \code{GeneSetCollection} will be mapped to the rownames of
#' \code{inSCE} using the \code{by} parameter and
#' stored in a \linkS4class{GeneSetCollection} object from package
#' \link{GSEABase}. This object is stored in
#' \code{metadata(inSCE)$sctk$genesets}, which can be accessed in downstream
#' analysis functions such as \link[singleCellTK]{runCellQC}.
#' @author Joshua D. Campbell
#' @seealso \link{importGeneSetsFromList} for importing from lists,
#' \link{importGeneSetsFromGMT} for importing from GMT files, and
#' \link{importGeneSetsFromMSigDB} for importing MSigDB gene sets.
#' @examples
#' data(scExample)
#' gs1 <- GSEABase::GeneSet(setName = "geneset1",
#'                          geneIds = rownames(sce)[seq(10)])
#' gs2 <- GSEABase::GeneSet(setName = "geneset2",
#'                          geneIds = rownames(sce)[seq(11,20)])
#' gsc <- GSEABase::GeneSetCollection(list(gs1, gs2))
#' sce <- importGeneSetsFromCollection(inSCE = sce,
#'                                     geneSetCollection = gsc,
#'                                     by = "rownames")
#' @export
importGeneSetsFromCollection <- function(inSCE, geneSetCollection,
                                         collectionName = "GeneSetCollection",
                                         by = "rownames",
                                         noMatchError = TRUE) {

  # If 'by' is NULL, then the location will be derived from the description
  if(is.null(by)) {
    location <- unlist(lapply(seq_along(geneSetCollection),
                   function(i) GSEABase::description(geneSetCollection[[i]])))
  } else {
    if(length(by) != 1 & length(by) != length(geneSetCollection)) {
      stop("If not NULL, then 'by' needs to be a character of ",
           "length 1 describing the location ",
           "of all the gene sets in inSCE or a character vector the same ",
           "length as 'geneSetList' where each entry describes the location of ",
           "that particular gene set in 'geneSetList'.")
    }

    if(length(by) == 1) {
      location <- rep(by, length(geneSetCollection))
    } else {
      location <- by
    }
  }

  # Check to ensure 'by' matches annotation in SCE
  if(!all(location %in% c("rownames", colnames(rowData(inSCE))))) {
    stop("The entries in 'by' must be 'rownames' or one of the column names ",
         "in the 'rowData(inSCE)': ", paste(colnames(rowData(inSCE)),
                                            collapse = ", "))
  }

  gs <- list()
  for(i in seq_along(geneSetCollection)) {

    temp.gs <- featureIndex(
      features = GSEABase::geneIds(geneSetCollection[[i]]),
      inSCE = inSCE,
      by = location[i],
      exactMatch = TRUE,
      removeNA = TRUE,
      errorOnNoMatch = FALSE,
      warningOnPartialMatch = FALSE)
    if(length(temp.gs) > 0) {
      gs.new <- geneSetCollection[[i]]
      GSEABase::geneIds(gs.new) <- rownames(inSCE)[temp.gs]
      gs <- c(gs, gs.new)
    }
  }

  if(length(gs) == 0 & isTRUE(noMatchError)) {
    stop("No gene sets could be imported. This is either because the no
         overlapping genes were identified between the gene sets and the input
         data or different types of identifiers are used between the two.
         Please check if the gene identifiers of both gene sets and input
         data belong to same type.")
  } else if(length(gs) > 0) {
    # Add GeneSetCollection back to metadata
    new.gsc <- GSEABase::GeneSetCollection(gs)
    old.gsc <- NULL
    if(!is.null(S4Vectors::metadata(inSCE)$sctk$genesets)) {
      if(collectionName %in% names(S4Vectors::metadata(inSCE)$sctk$genesets)) {
        old.gsc <- S4Vectors::metadata(inSCE)$sctk$genesets[[collectionName]]
      }
    }

    if(!is.null(old.gsc)) {
      # Remove any old gene sets with same name as new gene sets
      old.gsc <- old.gsc[!(names(old.gsc) %in% names(new.gsc))]

      # Combine old and new GeneSetCollections and save back to metadata
      S4Vectors::metadata(inSCE)$sctk$genesets[[collectionName]] <-
        GSEABase::GeneSetCollection(c(old.gsc, new.gsc))
    } else {
      S4Vectors::metadata(inSCE)$sctk$genesets[[collectionName]] <- new.gsc
    }
  }


  return(inSCE)
}



#' @title Imports gene sets from MSigDB
#' @description Gets a list of MSigDB gene sets stores it in the metadata of the
#' \linkS4class{SingleCellExperiment} object. These gene sets can be used in
#' downstream quality control and analysis functions in \link{singleCellTK}.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object.
#' @param categoryIDs Character vector containing the MSigDB gene set ids.
#' The column \code{ID} in the table returned by \code{getMSigDBTable()} shows
#' the list of possible gene set IDs that can be obtained.
#' Default is \code{"H"}.
#' @param species Character. Species available can be found using the function
#' \code{\link[msigdbr]{msigdbr_species}}. Default \code{"Homo sapiens"}.
#' @param mapping Character. One of "gene_symbol", "human_gene_symbol", or
#' "entrez_gene". Gene identifiers to be used for MSigDB gene sets. IDs
#' denoted by the \code{by} parameter must be either in gene symbol or
#' Entrez gene id format to match IDs from MSigDB.
#' @param by Character. Describes the
#' location within \code{inSCE} where the gene identifiers in
#' the MSigDB gene sets should be mapped. If set to \code{"rownames"} then the
#' features will be searched for among \code{rownames(inSCE)}. This can also be
#' set to one of the column names of \code{rowData(inSCE)} in which case the
#' gene identifies will be mapped to that column in the \code{rowData}
#' of \code{inSCE}. See \link{featureIndex} for more information.
#' Default \code{"rownames"}.
#' @param verbose Boolean. Whether to display progress. Default \code{TRUE}.
#' @param noMatchError Boolean. Show an error if a collection does not have
#' any matching features. Default \code{TRUE}.
#' @return A \link[SingleCellExperiment]{SingleCellExperiment} object
#' with gene set from \code{collectionName} output stored to the
#' \link{metadata} slot.
#' @details The gene identifiers in gene sets from MSigDB will be retrieved
#' using the \code{\link{msigdbr}} package. They will be mapped to the IDs in
#' \code{inSCE} using the \code{by} parameter and
#' stored in a \linkS4class{GeneSetCollection} object from package
#' \link{GSEABase}. This object is stored in
#' \code{metadata(inSCE)$sctk$genesets}, which can be accessed in downstream
#' analysis functions such as \link[singleCellTK]{runCellQC}.
#' @author Joshua D. Campbell
#' @seealso \link{importGeneSetsFromList} for importing from lists,
#' \link{importGeneSetsFromGMT} for importing from GMT files, and
# \link{importGeneSetsFromCollection} for importing from
#' \linkS4class{GeneSetCollection} objects.
#' @examples
#' data(scExample)
#' sce <- importGeneSetsFromMSigDB(inSCE = sce,
#'                                 categoryIDs = "H",
#'                                 species = "Homo sapiens",
#'                                 mapping = "gene_symbol",
#'                                 by = "feature_name")
#' @export
#' @importFrom SummarizedExperiment rowData
importGeneSetsFromMSigDB <- function(inSCE, categoryIDs = "H",
                                     species = "Homo sapiens",
                                     mapping = c("gene_symbol",
                                            "human_gene_symbol",
                                            "entrez_gene"),
                                     by = "rownames",
                                     verbose = TRUE,
                                     noMatchError = TRUE) {

  mapping <- match.arg(mapping)

  # Check species
  all.species <- msigdbr::msigdbr_species()$species_name
  if(!(species %in% all.species)) {
    stop("'species' needs to be one of the following: ",
         paste(all.species, collapse = ", "))
  }
  # Check to ensure 'by' matches annotation in SCE
  if(is.null(by) || length(by) > 1) {
    stop("'by' must a character of length 1.")
  }
  if(!(by %in% c("rownames", colnames(rowData(inSCE))))) {
    stop("'by' must be 'rownames' or one of the column names ",
         "in the 'rowData(inSCE)': ", paste(colnames(rowData(inSCE)),
                                            collapse = ", "))
  }

  msigdb_table <- getMSigDBTable()
  if(!all(categoryIDs %in% msigdb_table$ID)) {
    diff <- setdiff(categoryIDs, msigdb_table$ID)
    stop("Category IDs not found in MSigDB: ", paste(diff, collapse = ", "),
         ". Valid IDs can be found in the table returned by the function ",
         "getMSigDBTable().")
  }

  rownames(msigdb_table) <- msigdb_table$ID
  gs.list <- list()
  for(i in seq_along(categoryIDs)) {

    category <- msigdb_table[categoryIDs[i],"Category"]
    subcat <- msigdb_table[categoryIDs[i],"Subcategory"]
    if(subcat == "N/A") {
      subcat <- NULL
    }

    # Retrieve lists from msigdbr
    gs <- as.data.frame(msigdbr::msigdbr(species = species,
                    collection = category,
                    subcollection = subcat))

    if(is.null(subcat)) {
        subcat <- NA
    }

    # Parse data.frame into list of GeneSets
    gs.names <- unique(gs$gs_name)
    num.gs.names <- length(gs.names)
    if(isTRUE(verbose)){
      p <- paste0(date(), " .. Importing '", categoryIDs[i],
                  "' gene sets (n = ", num.gs.names, ")")
      message(p)
    }

    for(j in seq_along(gs.names)) {
      gs.sub <- gs[gs$gs_name == gs.names[j],mapping]
      gs.list[[j]] <- GSEABase::GeneSet(setName = gs.names[j],
                        geneIds = unique(gs.sub),
                        collectionType = GSEABase::BroadCollection(
                          category = tolower(category),
                          subCategory = subcat))
      if(j %% 1000 == 0) {
        if(isTRUE(verbose)) {
          p <- paste0(date(), " .... Completed ", j, " out of ",
                      num.gs.names, " gene sets")
          message(p)
        }
      }
    }
    if(isTRUE(verbose)) {
      p <- paste0(date(), " .... Completed ", num.gs.names, " gene sets ",
                  "for ", i)
      message(p)
    }

    # Add to SCE
    if(isTRUE(verbose)) {
      p <- paste0(date(), " .. Matching gene sets to '", by, "'")
      message(p)
    }
    gsc <- GSEABase::GeneSetCollection(gs.list)
    inSCE <- importGeneSetsFromCollection(inSCE = inSCE,
                                          geneSetCollection = gsc,
                                          collectionName = categoryIDs[i],
                                          by = by,
                                          noMatchError = noMatchError)
  }

  return(inSCE)
}



#' @title Import mitochondrial gene sets
#' @description Imports mitochondrial gene sets and  stores it in the metadata of the
#' \linkS4class{SingleCellExperiment} object. These gene sets can be used in
#' downstream quality control and analysis functions in \link{singleCellTK}.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object.
#' @param reference Character. Species available are "human" and "mouse".
#' @param by Character. Describes the location within \code{inSCE} where the gene
#' identifiers in the mitochondrial gene sets should be mapped.
#' If set to \code{"rownames"} then the features will
#' be searched for among \code{rownames(inSCE)}. This can also be
#' set to one of the column names of \code{rowData(inSCE)} in which case the
#' gene identifies will be mapped to that column in the \code{rowData}
#' of \code{inSCE}. See \link{featureIndex} for more information.
#' Default \code{"rownames"}.
#' @param id Types of gene id. Now it supports "symbol", "entrez", "ensembl"
#' and "ensemblTranscriptID".
#' @param collectionName Character. Name of collection to add gene sets to.
#' If this collection already exists in \code{inSCE}, then these gene sets will
#' be added to that collection. Any gene sets within the collection with the
#' same name will be overwritten. Default \code{"mito"}.
#' @param noMatchError Boolean. Show an error if a collection does not have
#' any matching features. Default \code{TRUE}.
#' @return A \link[SingleCellExperiment]{SingleCellExperiment} object
#' with gene set from \code{collectionName} output stored to the
#' \link{metadata} slot.
#' @details The gene identifiers of mitochondrial genes will be loaded with
#' "data(AllMito)". Currently, it supports human and mouse references.
#' Also, it supports entrez ID, gene symbol, ensemble ID and ensemble transcript ID.
#' They will be mapped to the IDs in \code{inSCE} using the \code{by} parameter and
#' stored in a \linkS4class{GeneSetCollection} object from package
#' \link{GSEABase}. This object is stored in
#' \code{metadata(inSCE)$sctk$genesets}, which can be accessed in downstream
#' analysis functions such as \link[singleCellTK]{runCellQC}.
#' @author Rui Hong
#' @seealso \link{importGeneSetsFromList} for importing from lists,
#' \link{importGeneSetsFromGMT} for importing from GMT files, and
# \link{importGeneSetsFromCollection} for importing from
#' \linkS4class{GeneSetCollection} objects.
#' @examples
#' data(scExample)
#' sce <- importMitoGeneSet(inSCE = sce,
#'                          reference = "human",
#'                          id = "ensembl",
#'                          collectionName = "human_mito",
#'                          by = "rownames")
#' @export
importMitoGeneSet <- function(inSCE, reference = "human", id = "ensembl",
                              by = "rownames", collectionName = "mito",
                              noMatchError = TRUE) {

  if (!id %in% c("symbol", "entrez", "ensembl", "ensemblTranscriptID")) {
    stop("`id` should be one of 'symbol', 'entrez', 'ensembl' or 'ensemblTranscriptID'")
  }

  reference <- tolower(reference)
  if (!reference %in% c("human", "mouse")) {
    stop("Now it only supports 'human' and 'mouse' reference.")
  }

  MitoGenes <- NULL
  utils::data(MitoGenes, envir = environment())
  target <- paste(reference, id, sep="_")
  if (!target %in% names(MitoGenes)) {
    stop(target, " is not supported now. Please use function 'importGeneSetsFromGMT' or 'importGeneSetsFromList' to load mitochondrial gene sets.")
  }

  mitogenes <- MitoGenes[[target]]
  names(mitogenes) <- collectionName
  inSCE <- importGeneSetsFromList(inSCE = inSCE, geneSetList = mitogenes,
                                  collectionName = collectionName,
                                  by = by,
                                  noMatchError = noMatchError)
  return(inSCE)
}

#' @title Lists imported GeneSetCollections
#' @description Returns a vector of GeneSetCollections that have been
#' imported and stored in \code{metadata(inSCE)$sctk$genesets}.
#' @param inSCE A \link[SingleCellExperiment]{SingleCellExperiment} object.
#' @return Character vector.
#' @author Joshua D. Campbell
#' @seealso \link{importGeneSetsFromList} for importing from lists,
#' \link{importGeneSetsFromGMT} for importing from GMT files,
# \link{importGeneSetsFromCollection} for importing from
#' \linkS4class{GeneSetCollection} objects, and \link{importGeneSetsFromMSigDB}
#' for importing MSigDB gene sets.
#' @examples
#' data(scExample)
#' gs1 <- GSEABase::GeneSet(setName = "geneset1",
#'                          geneIds = rownames(sce)[seq(10)])
#' gs2 <- GSEABase::GeneSet(setName = "geneset2",
#'                          geneIds = rownames(sce)[seq(11,20)])
#' gsc1 <- GSEABase::GeneSetCollection(gs1)
#' gsc2 <- GSEABase::GeneSetCollection(gs2)
#' sce <- importGeneSetsFromCollection(inSCE = sce,
#'                                     geneSetCollection = gsc1,
#'                                     by = "rownames",
#'                                     collectionName = "Collection1")
#' sce <- importGeneSetsFromCollection(inSCE = sce,
#'                                     geneSetCollection = gsc2,
#'                                     by = "rownames",
#'                                     collectionName = "Collection2")
#' collections <- sctkListGeneSetCollections(sce)
#' @export
sctkListGeneSetCollections <- function(inSCE) {
  if(!is.null(S4Vectors::metadata(inSCE)$sctk$genesets)) {
    res <- names(S4Vectors::metadata(inSCE)$sctk$genesets)
  } else {
    res <- character()
  }
  return(res)
}

#' @title Shows MSigDB categories
#' @description Returns a data.frame that shows MSigDB categories and
#' subcategories as well as descriptions for each. The entries in the ID
#' column in this table can be used as input for \link{importGeneSetsFromMSigDB}.
#' @return data.frame, containing MSigDB categories
#' @author Joshua D. Campbell
#' @seealso \link{importGeneSetsFromMSigDB} for importing MSigDB gene sets.
#' @export
#' @examples
#' getMSigDBTable()
getMSigDBTable <- function() {
  # Issues for getting this to pass R CMD Check:
  # https://support.bioconductor.org/p/24756/#24768
  # https://groups.google.com/forum/#!topic/cambridge-r-user-group/c7vf8o3QwDo
  msigdb_table <- NULL
  rm(msigdb_table)
  utils::data(msigdb_table)
  return(msigdb_table)
}


.retrieveGeneSetCollection <- function(inSCE, collectionName) {
  if(!is.null(S4Vectors::metadata(inSCE)$sctk$genesets)) {
    if(collectionName %in% names(S4Vectors::metadata(inSCE)$sctk$genesets)) {
      gsc <- S4Vectors::metadata(inSCE)$sctk$genesets[[collectionName]]
    } else {
      stop("No GeneSetCollection called '", collectionName, "' was found. ",
           "The GeneSetColletions that are available include: ",
           paste(names(S4Vectors::metadata(inSCE)$sctk$genesets),
                 collapse = ", "))
    }
  } else {
    stop("No GeneSetCollections have been imported.")
  }
  return(gsc)
}

# Pathway Analysis
library(singleCellTK)
context("Testing pathway analysis functions")
data(scExample, package = "singleCellTK")
sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
sce <- scaterlogNormCounts(sce, assayName = "logcounts")
gs1 <- rownames(sce)[seq(10)]
gs2 <- rownames(sce)[seq(11,20)]
gs <- list("geneset1" = gs1, "geneset2" = gs2)


sce <- importGeneSetsFromList(inSCE = sce, geneSetList = gs, by = "rownames")
sce <- runVAM(inSCE = sce, geneSetCollectionName = "GeneSetCollection", 
              useAssay = "logcounts")

test_that(desc = "Testing import genesets", {
    sce <- importGeneSetsFromList(inSCE = sce, 
                                  geneSetList = gs, 
                                  by = "rownames")
    testthat::expect_equal(sctkListGeneSetCollections(sce), "GeneSetCollection")
})

test_that(desc = "Testing VAM", {
    sce <- runVAM(inSCE = sce, geneSetCollectionName = "GeneSetCollection", 
                  useAssay = "logcounts")
    testthat::expect_true("VAM_GeneSetCollection_Distance" %in% reducedDimNames(sce))
    testthat::expect_true("VAM_GeneSetCollection_CDF" %in% reducedDimNames(sce))
    
    vamPlot <- plotPathway(sce, resultName = "VAM_GeneSetCollection_CDF", 
                           geneset = "geneset1", groupBy = "type", 
                           summary = "mean", title = "vam")
    testthat::expect_is(vamPlot, "ggplot")
})

test_that(desc = "Testing GSVA", {
    sce <- runGSVA(sce, geneSetCollectionName = "GeneSetCollection", useAssay = "logcounts")
    testthat::expect_true("GSVA_GeneSetCollection_Scores" %in% reducedDimNames(sce))
    
    gsvaPlot <- plotPathway(sce, resultName = "GSVA_GeneSetCollection_Scores", 
                            geneset = "geneset1", groupBy = "type", 
                            boxplot = TRUE, violin = FALSE, dots = FALSE)
    testthat::expect_is(gsvaPlot, "ggplot")
})

library('SummarizedExperiment')
library('SingleCellExperiment')
library('Seurat')
library('testthat')
library('singleCellTK')
library('GSEABase')

context("Testing import functions")

#####################################
## Importing scRNA-seq Data Functions
#####################################

test_that(desc = "Testing import single-cell data", {
  allImportEntries <- list(
    samples = list()
  )
  allImportEntries$samples$a <- list(
    type = "busTools",
    params = list(BUStoolsDirs = system.file("extdata/BUStools_PBMC_1k_v3_20x20/genecount/", package = "singleCellTK"),
                  samples = "BUStools_20x20")
  )
  allImportEntries$samples$b <- list(
    type = "cellRanger3",
    params = list(cellRangerDirs = system.file("extdata",package = "singleCellTK"),
                  sampleDirs = "hgmm_1k_v3_20x20",
                  sampleNames = "cellRanger3_20x20",
                  dataType = "filtered")
  )
  allImportEntries$samples$c <- list(
    type = "seqc",
    params = list(seqcDirs = system.file("extdata/pbmc_1k_50x50",package = "singleCellTK"),
                  samples = "seqc_50x50",
                  prefix = "pbmc_1k",
                  combinedSample = FALSE)
  )
  allImportEntries$samples$d <- list(
    type = "starSolo",
    params = list(STARsoloDirs = system.file("extdata/STARsolo_PBMC_1k_v3_20x20",package = "singleCellTK"),
                  samples = "STARsolo_20x20")
  )
  allImportEntries$samples$e <- list(
    type = "files",
    params = list(assayFile = system.file("extdata/pbmc_1k_50x50/pbmc_1k_sparse_molecule_counts.mtx",package = "singleCellTK"),
                  annotFile = system.file("extdata/pbmc_1k_50x50/pbmc_1k_sparse_counts_barcodes.csv",package = "singleCellTK"),
                  featureFile = system.file("extdata/pbmc_1k_50x50/pbmc_1k_sparse_counts_genes.csv",package = "singleCellTK"),
                  assayName = "counts")
  )
  expect_warning({
    sce <- importMultipleSources(allImportEntries)
  }, "column names 'cell_barcode.x'")
  expect_true(validObject(sce))
  summary <- as.data.frame(table(sce$sample))
  expect_true(all(summary$Var1 %in% c("BUStools_20x20", "cellRanger3_20x20", "seqc_50x50", "STARsolo_20x20", "sample")))
  expect_length(summary$Freq, 5)
})

test_that(desc = "Testing importDropEst", {
  sce <- importDropEst(sampleDirs = system.file("extdata/dropEst_scg71",package = "singleCellTK"),
                       sampleNames = 'scg71')
  expect_true(validObject(sce))
})

#
# test_that(desc = "Testing importOptimus", {
#   if (!reticulate::py_module_available("scipy.sparse") || (!reticulate::py_module_available("numpy"))){
#     skip("scipy.sparse or numpy not available. Skipping testing importOptimus")
#   }
#   sce <- importOptimus(OptimusDirs = system.file("extdata/Optimus_20x1000",package = "singleCellTK"),
#                        samples = "Optimus_20x1000")
#   expect_true(validObject(sce))
# })

# test_that(desc = "Testing importAnnData", {
#   if (!reticulate::py_module_available("anndata")){
#     skip("'anndata' not available. Skipping testing importAnnData")
#   }
#   sce <- importAnnData(sampleDirs = system.file("extdata/annData_pbmc_3k", package = "singleCellTK"),
#                        sampleNames = 'pbmc3k_20by20')
#   expect_true(validObject(sce))
# })
##################################
## Importing Gene Set Functions
##################################
data(scExample)
test_that(desc = "Testing importGeneSetFromGMT", {
  gmt <- system.file("extdata/mito_subset.gmt", package = "singleCellTK")
  sce <- importGeneSetsFromGMT(inSCE = sce, file = gmt, by = NULL,
                               collectionName = "test")
  expect_true(inherits(sce@metadata$sctk$genesets$test[[1]], "GeneSet"))
})

test_that(desc = "Testing importGeneSetFromList", {
  gs1 <- rownames(sce)[1:10]
  gs2 <- rownames(sce)[11:20]
  gs <- list("geneset1" = gs1, "geneset2" = gs2)
  sce <- importGeneSetsFromList(inSCE = sce,
                                geneSetList = gs,
                                collectionName = "test",
                                by = "rownames")
  expect_true(inherits(sce@metadata$sctk$genesets$test[[1]], "GeneSet"))
})

test_that(desc = "Testing importGeneSetFromCollection", {
  gs1 <- GSEABase::GeneSet(setName = "geneset1", geneIds = rownames(sce)[1:10])
  gs2 <- GSEABase::GeneSet(setName = "geneset2", geneIds = rownames(sce)[11:20])
  gsc <- GSEABase::GeneSetCollection(list(gs1, gs2))
  sce <- importGeneSetsFromCollection(inSCE = sce,
                                      geneSetCollection = gsc,
                                      collectionName = "test",
                                      by = "rownames")
  expect_true(inherits(sce@metadata$sctk$genesets$test[[1]], "GeneSet"))
  gscList <- sctkListGeneSetCollections(sce)
  expect_equal(gscList, "test")
  gsList <- getGenesetNamesFromCollection(sce, "test")
  expect_equal(gsList, c("geneset1", "geneset2"))
})

test_that(desc = "Testing importGeneSetFromMSigDB", {
  sce <- importGeneSetsFromMSigDB(inSCE = sce,
                                  categoryIDs = "C2-CP",
                                  species = "Homo sapiens",
                                  mapping = "gene_symbol",
                                  by = "feature_name")
  expect_true(inherits(sce@metadata$sctk$genesets$"C2-CP"[[1]], "GeneSet"))
})

data(scExample)
test_that(desc = "Testing export", {
  exportSCEtoFlatFile(sce)
  expect_true(file.exists("./assays/SCE_counts.mtx.gz"))
  expect_true(file.exists("./SCE_cellData.txt.gz"))
  expect_true(file.exists("./SCE_featureData.txt.gz"))
})

#' Trim Counts
#'
#' Trims an input count matrix such that each value greater than a
# 'provided upper threshold value is trimmed to the upper
#' threshold value and each value less than a provided
#' lower threshold value is trimmed to the lower treshold value.
#' @param counts matrix
#' @param trimValue where trimValue[1] for upper threshold and trimValue[2] as
#' lower threshold. Default is \code{c(10,-10)}
#' @return trimmed counts matrix
#' @export
#' @examples
#' data(sce_chcl, package = "scds")
#' assay(sce_chcl, "countsTrimmed") <- trimCounts(assay(sce_chcl, "counts"),
#'                                                c(10, -10))
trimCounts <- function(counts, trimValue = c(10,-10)) {
    trimValue <- c(max(trimValue), min(trimValue))
    counts[counts > trimValue[1]] <- trimValue[1]
    counts[counts < trimValue[2]] <- trimValue[2]
    return(counts)
}

# dir <- "outs/filtered_feature_bc_matrix/"
.constructSCEFromSTARsoloOutputs <- function(dir,
    sample,
    matrixFileName,
    featuresFileName,
    barcodesFileName,
    gzipped,
    class,
    delayedArray) {

    cb <- .readBarcodes(file.path(dir, barcodesFileName))
    fe <- .readFeatures(file.path(dir, featuresFileName))
    ma <- .readMatrixMM(file.path(dir, matrixFileName),
        gzipped = gzipped,
        class = class,
        delayedArray = delayedArray)

    coln <- paste(sample, cb[[1]], sep = "_")
    rownames(ma) <- fe[[1]]

    sce <- SingleCellExperiment::SingleCellExperiment(
        assays = list(counts = ma))
    SummarizedExperiment::rowData(sce) <- fe
    SummarizedExperiment::colData(sce) <- S4Vectors::DataFrame(cb,
        column_name = coln,
        sample = sample,
        row.names = coln)

    return(sce)
}


# main function
.importSTARsolo <- function(STARsoloDirs,
    samples,
    STARsoloOuts,
    matrixFileNames,
    featuresFileNames,
    barcodesFileNames,
    gzipped,
    class,
    delayedArray,
    rowNamesDedup) {

    if (length(STARsoloDirs) != length(samples)) {
        stop("'STARsoloDirs' and 'samples' have unequal lengths!")
    }

    res <- vector("list", length = length(samples))

    temp <- STARsoloOuts
    # in case the old style arguments get passed in
    if (length(STARsoloOuts) == 2 && identical(STARsoloOuts, c("Gene", "GeneFull"))) {
        STARsoloOuts <- paste0(STARsoloOuts, "/filtered")
    } else if (length(STARsoloOuts) == 1 && (STARsoloOuts == "Gene" || STARsoloOuts == "GeneFull")) {
        STARsoloOuts <- paste0(STARsoloOuts, "/filtered")
    }
    STARsoloOuts <- .getVectorized(STARsoloOuts, length(samples))
    matrixFileNames <- .getVectorized(matrixFileNames, length(samples))
    featuresFileNames <- .getVectorized(featuresFileNames, length(samples))
    barcodesFileNames <- .getVectorized(barcodesFileNames, length(samples))
    gzipped <- .getVectorized(gzipped, length(samples))

    for (i in seq_along(samples)) {
        dir <- file.path(STARsoloDirs[i], STARsoloOuts[i])
        scei <- .constructSCEFromSTARsoloOutputs(dir,
            sample = samples[i],
            matrixFileName = matrixFileNames[i],
            featuresFileName = featuresFileNames[i],
            barcodesFileName = barcodesFileNames[i],
            gzipped = gzipped[i],
            class = class,
            delayedArray = delayedArray)
        res[[i]] <- scei
    }

    sce <- do.call(SingleCellExperiment::cbind, res)

    if (isTRUE(rowNamesDedup)) {
        if (any(duplicated(rownames(sce)))) {
            message("Duplicated gene names found, adding '-1', '-2', ",
                    "... suffix to them.")
        }
        sce <- dedupRowNames(sce)
    }

    # Load metrics summary and store in sce
    metrics_summary <- .importMetricsStarSolo(
      samplePaths = STARsoloDirs, 
      sampleNames = samples, 
      metricsPath = temp, 
      metricsFile = "Summary.csv")
    # sce <- setSampleSummaryStatsTable(sce, "starsolo", metrics_summary)
    if (ncol(metrics_summary) > 0) {
      sce@metadata$sctk$sample_summary[["starsolo"]] <- metrics_summary
    }

    return(sce)
}

#' @name importSTARsolo
#' @rdname importSTARsolo
#' @title Construct SCE object from STARsolo outputs
#' @description Read the barcodes, features (genes), and matrices from STARsolo
#'  outputs. Import them
#'  as one \link[SingleCellExperiment]{SingleCellExperiment} object.
#' @param STARsoloDirs A vector of root directories of STARsolo output files.
#'  The paths should be something like this:
#'  \bold{/PATH/TO/\emph{prefix}Solo.out}. For example: \code{./Solo.out}.
#'  Each sample should have its own path. Must have the same length as
#'  \code{samples}.
#' @param samples A vector of user-defined sample names for the sample to be
#'  imported. Must have the same length as \code{STARsoloDirs}.
#' @param STARsoloOuts Character. The intermediate
#'  folder to filtered or raw cell barcode, feature, and matrix files
#'  for each of \code{samples}. Default \code{"Gene"}.
#'  It can be either Gene or GeneFull as the main folder from
#'  which data needs to be imported. 
#' @param matrixFileNames Filenames for the Market Exchange Format (MEX) sparse
#'  matrix file (.mtx file). Must have length 1 or the same
#'  length as \code{samples}.
#' @param featuresFileNames Filenames for the feature annotation file.
#'  Must have length 1 or the same
#'  length as \code{samples}.
#' @param barcodesFileNames Filenames for the cell barcode list file.
#'  Must have length 1 or the same
#'  length as \code{samples}.
#' @param gzipped Boolean. \code{TRUE} if the STARsolo output files
#'  (barcodes.tsv, features.tsv, and matrix.mtx) were
#'  gzip compressed. \code{FALSE} otherwise. This is \code{FALSE} in STAR
#'  2.7.3a. Default \code{"auto"} which automatically detects if the
#'  files are gzip compressed. Must have length 1 or the same
#'  length as \code{samples}.
#' @param class Character. The class of the expression matrix stored in the SCE
#'  object. Can be one of "Matrix" (as returned by
#'  \link{readMM} function), or "matrix" (as returned by
#'  \link[base]{matrix} function). Default "Matrix".
#' @param delayedArray Boolean. Whether to read the expression matrix as
#'  \link{DelayedArray} object or not. Default \code{FALSE}.
#' @param rowNamesDedup Boolean. Whether to deduplicate rownames. Default
#'  \code{TRUE}.
#' @return A \code{SingleCellExperiment} object containing the count
#'  matrix, the gene annotation, and the cell annotation.
#' @examples
#' # Example #1
#' # FASTQ files were downloaded from
#' # https://support.10xgenomics.com/single-cell-gene-expression/datasets/3.0.0
#' # /pbmc_1k_v3
#' # They were concatenated as follows:
#' # cat pbmc_1k_v3_S1_L001_R1_001.fastq.gz pbmc_1k_v3_S1_L002_R1_001.fastq.gz >
#' # pbmc_1k_v3_R1.fastq.gz
#' # cat pbmc_1k_v3_S1_L001_R2_001.fastq.gz pbmc_1k_v3_S1_L002_R2_001.fastq.gz >
#' # pbmc_1k_v3_R2.fastq.gz
#' # The following STARsolo command generates the filtered feature, cell, and
#' # matrix files
#' # STAR \
#' #   --genomeDir ./index \
#' #   --readFilesIn ./pbmc_1k_v3_R2.fastq.gz \
#' #                 ./pbmc_1k_v3_R1.fastq.gz \
#' #   --readFilesCommand zcat \
#' #   --outSAMtype BAM Unsorted \
#' #   --outBAMcompression -1 \
#' #   --soloType CB_UMI_Simple \
#' #   --soloCBwhitelist ./737K-august-2016.txt \
#' #   --soloUMIlen 12
#'
#' # The top 20 genes and the first 20 cells are included in this example.
#' sce <- importSTARsolo(
#'   STARsoloDirs = system.file("extdata/STARsolo_PBMC_1k_v3_20x20",
#'     package = "singleCellTK"),
#'   samples = "PBMC_1k_v3_20x20")
#' @export
importSTARsolo <- function(
    STARsoloDirs,
    samples,
    STARsoloOuts = c("Gene", "GeneFull"),
    matrixFileNames = "matrix.mtx",
    featuresFileNames = "features.tsv",
    barcodesFileNames = "barcodes.tsv",
    gzipped = "auto",
    class = c("Matrix", "matrix"),
    delayedArray = FALSE,
    rowNamesDedup = TRUE) {

    # accepted STARSolo output directories
    STARsoloOutputs <- c("Gene", "GeneFull", "Gene/filtered", "Gene/raw", "GeneFull/raw", "GeneFull/filtered")
    class <- match.arg(class)
    STARsoloOuts <- match.arg(STARsoloOuts, STARsoloOutputs, several.ok = TRUE)
    # in case the old style arguments get passed in
    if (identical(STARsoloOuts, c("Gene", "GeneFull"))) {
        STARsoloOuts <- paste0(STARsoloOuts, "/filtered")
    }

    .importSTARsolo(
        STARsoloDirs = STARsoloDirs,
        samples = samples,
        STARsoloOuts = STARsoloOuts,
        matrixFileNames = matrixFileNames,
        featuresFileNames = featuresFileNames,
        barcodesFileNames = barcodesFileNames,
        gzipped = gzipped,
        class = class,
        delayedArray = delayedArray,
        rowNamesDedup = rowNamesDedup)
}


# Find metrics_summary.csv file in each sample and merge them into a single dataframe
# Additionally, if file not available for a sample, fill that sample with NA
.importMetricsStarSolo <- function(samplePaths, sampleNames, metricsPath, metricsFile){
  # Check if samplePaths and sampleNames are equal in length
  if(!identical(length(samplePaths), length(sampleNames))){
    stop("Vectors samplePaths and sampleNames must be equal in length.")
  }
  
  # Processing
  metrics_summary <- list()
  for(i in seq(samplePaths)){
    metricsPath <- paste0(samplePaths[i], "/", metricsPath)
    metrics_summary[[i]] <- list.files(pattern= paste0("*", metricsFile, "$"), path = metricsPath, full.names = TRUE)
    if(length(metrics_summary[[i]]) > 0){
      metrics_summary[[i]] <- lapply(metrics_summary[[i]], utils::read.csv, header = FALSE, check.names = FALSE, row.names = 1)[[1]]
    }
    else{
      message("Metrics summary file (", metricsFile, ") not found for sample: ", sampleNames[i])
      ms_colnames_union <- Reduce(union, lapply(metrics_summary, colnames))
      metrics_summary[[i]] <- data.frame(matrix(data = NA, nrow = 1, ncol = length(ms_colnames_union)))
      colnames(metrics_summary[[i]]) <- ms_colnames_union
    }
  }

  # Merge StarSolo summary csv files from all/multiple samples into a single data.frame
  for(i in seq_along(metrics_summary)){
    metrics_summary[[i]] <- as.data.frame(t(metrics_summary[[i]]))
  }
  metrics_summary <- plyr::rbind.fill(metrics_summary)
  metrics_summary <- t(metrics_summary)
  if (ncol(metrics_summary) > 0) {
    colnames(metrics_summary) <- sampleNames
  }

  return(metrics_summary)
}

#' @title Plot Bubble plot
#' @description Plot a bubble plot with the color of the plot being the mean expression
#' and the size of the dot being the percent of cells in the cluster expressing the gene.
#'
#' @param inSCE The single cell experiment to use.
#' @param useAssay The assay to use.
#' @param featureNames A string or vector of strings with each gene to aggregate.
#' @param displayName A string that is the name of the column used for genes.
#' @param groupNames The name of a colData entry that can be used as groupNames.
#' @param title The title of the bubble plot
#' @param xlab The x-axis label
#' @param ylab The y-axis label
#' @param colorLow The color to be used for lowest value of mean expression
#' @param colorHigh The color to be used for highest value of mean expression
#' @param scale Option to scale the data. Default: \code{FALSE}. Selected assay will not be scaled. 
#' @return A ggplot of the bubble plot.
#' @importFrom rlang .data
#' @importFrom reshape2 melt
#' @examples
#' data("scExample")
#' plotBubble(inSCE=sce, useAssay="counts", featureNames=c("B2M", "MALAT1"),
#' displayName="feature_name", groupNames="type", title="cell type test",
#' xlab="gene", ylab="cluster", colorLow="white", colorHigh="blue")
#' @export
plotBubble <- function(inSCE, useAssay="logcounts", featureNames, displayName=NULL, groupNames="cluster", title="", xlab=NULL, ylab=NULL, colorLow="white", colorHigh="blue", scale = FALSE){
  metrics <- runClusterSummaryMetrics(inSCE, useAssay=useAssay, featureNames=featureNames, 
                                      displayName=displayName, groupNames=groupNames, scale = scale)
  .ggBubble(avgExpr = metrics$avgExpr, percExpr = metrics$percExpr, colorLow = colorLow, 
            colorHigh = colorHigh, title = title, xlab=xlab, ylab=ylab)
}

.ggBubble <- function(avgExpr, percExpr, groupNames=NULL, featureNames=NULL, colorLow="white", colorHigh="blue", title="", xlab="Features", ylab="Clusters"){
  if(is.null(featureNames)) {
    if(is.null(rownames(avgExpr))) {
      stop("'featureNames' must be supplied or the 'rownames' of the average expression matrix must be set.")
    }
    featureNames <- rownames(avgExpr)
  } else {
    ## Error checking for feature length
    if(length(featureNames) != nrow(avgExpr)) {
      stop("'featureNames' must be the same length as the number of rows in the average expression matrix.")
  }
  }
  if(is.null(groupNames)) {
    if(is.null(colnames(avgExpr))) {
      stop("'featureNames' must be supplied or the 'rownames' of the average expression matrix must be set.")
    }
    groupNames <- colnames(avgExpr)
  } else {
    ## Error checking for feature length
    if(length(groupNames) != ncol(avgExpr)) {
      stop("'featureNames' must be the same length as the number of rows in the average expression matrix.")
    }
  }
  
  avgExpr <- data.frame(avgExpr)
  avgExpr$featureNames <- featureNames
  df <- reshape2::melt(avgExpr, id="featureNames", value.name = "avgExpr", variable.name = "groupNames")
  
  percExpr <- data.frame(percExpr)
  percExpr$featureNames <- featureNames
  dfP <- reshape2::melt(percExpr, id="featureNames", value.name = "percExpr")
  
  df$percExpr = dfP$percExpr
  
  gg <- ggplot2::ggplot(df, ggplot2::aes(x = .data[['featureNames']], y = .data[['groupNames']])) +
    ggplot2::geom_point(ggplot2::aes(color=.data[['avgExpr']], size=.data[['percExpr']])) +
    ggplot2::ggtitle(title) +
    ggplot2::xlab(xlab) + 
    ggplot2::ylab(ylab) + 
    ggplot2::scale_color_gradient2(low=colorLow, high=colorHigh)
  g <- .ggSCTKTheme(gg)
  
  g <- g + ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90, vjust = 0.5, hjust=1))
  g
}

library(singleCellTK)
library(ggplot2)

test_that(desc = "Testing plotBubble.R", {
  data("scExample")
  
  bubblePlot <- plotBubble(sce, useAssay="counts", feature="B2M", displayName="feature_name", groupNames="type", title="cluster test")
  
  testthat::expect_true(is.ggplot(bubblePlot))
})

#' @title Plot results of reduced dimensions data.
#' @description Plot results of reduced dimensions data and colors the plots by
#'  the input vector.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object with saved
#' dimension reduction components or a variable with saved results. Required
#' @param sample Character vector. Indicates which sample each cell belongs to.
#' @param colorBy If provided, colors dots in the scatterplot based on value.
#' @param groupBy If provided, facet wrap the scatterplot based on value.
#' @param conditionClass class of the annotation data used in colorBy. Options
#'  are NULL, "factor" or "numeric". If NULL, class will default to the original
#'  class. Default NULL.
#' @param shape If provided, add shapes based on the value.
#' @param reducedDimName Saved dimension reduction name in the
#' \linkS4class{SingleCellExperiment} object. Required.
#' @param xlab Character vector. Label for x-axis. Default NULL.
#' @param ylab Character vector. Label for y-axis. Default NULL.
#' @param baseSize The base font size for all text. Default 12.
#'  Can be overwritten by titleSize, axisSize, and axisLabelSize,
#'  legendSize, legendTitleSize.
#' @param axisSize Size of x/y-axis ticks. Default NULL.
#' @param axisLabelSize Size of x/y-axis labels. Default NULL.
#' @param dim1 1st dimension to be used for plotting. Can either be a string which specifies
#'  the name of the dimension to be plotted from reducedDims, or a numeric value which specifies
#'  the index of the dimension to be plotted. Default is NULL.
#' @param dim2 2nd dimension to be used for plotting. Can either be a string which specifies
#'  the name of the dimension to be plotted from reducedDims, or a numeric value which specifies
#'  the index of the dimension to be plotted. Default is NULL.
#' @param bin Numeric vector. If single value, will divide the numeric values into the `bin` groups.
#'  If more than one value, will bin numeric values using values as a cut point.
#' @param binLabel Character vector. Labels for the bins created by the `bin` parameter.
#'  Default NULL.
#' @param dotSize Size of dots. Default 0.1.
#' @param transparency Transparency of the dots, values will be 0-1. Default 1.
#' @param colorScale Vector. Needs to be same length as the
#'  number of unique levels of `colorBy`. Will be used only if
#'  conditionClass = "factor" or "character". Default NULL.
#' @param colorLow Character. A color available from `colors()`.
#'  The color will be used to signify the lowest values on the scale.
#'  Default 'white'. Will be used only if conditionClass = "numeric".
#' @param colorMid Character. A color available from `colors()`.
#'  The color will be used to signify the midpoint on the scale.
#'  Default 'gray'. Will be used only if conditionClass = "numeric".
#' @param colorHigh Character. A color available from `colors()`.
#'  The color will be used to signify the highest values on the scale.
#'  Default 'blue'. Will be used only if conditionClass = "numeric".
#' @param defaultTheme Removes grid in plot and sets axis title size to 10
#'  when TRUE. Default TRUE.
#' @param title Title of plot. Default NULL.
#' @param titleSize Size of title of plot. Default 15.
#' @param labelClusters Logical. Whether the cluster labels are plotted.
#'  Default FALSE.
#' @param clusterLabelSize Numeric. Determines the size of cluster label
#'  when `labelClusters` is set to TRUE. Default 3.5.
#' @param legendTitle title of legend. Default NULL.
#' @param legendTitleSize size of legend title. Default NULL.
#' @param legendSize size of legend. Default NULL.
#' @param combinePlot Must be either "all", "sample", or "none". "all" will combine all plots into a single
#' .ggplot object, while "sample" will output a list of plots separated by sample. Default "none".
#' @param plotLabels labels to each plot. If set to "default", will use the name of the samples
#'  as the labels. If set to "none", no label will be plotted.
#' @return a ggplot of the reduced dimensions.
#' @noRd
.ggScatter <- function(inSCE,
                       reducedDimName,
                       sample = NULL,
                       colorBy = NULL,
                       groupBy = NULL,
                       shape = NULL,
                       conditionClass = NULL,
                       labelClusters = FALSE,
                       clusterLabelSize = 3.5,
                       xlab = NULL,
                       ylab = NULL,
                       baseSize = 12,
                       axisSize = NULL,
                       axisLabelSize = NULL,
                       dim1 = NULL,
                       dim2 = NULL,
                       bin = NULL,
                       binLabel = NULL,
                       dotSize = 0.1,
                       transparency = 1,
                       colorScale = NULL,
                       colorLow = "white",
                       colorMid = "gray",
                       colorHigh = "blue",
                       defaultTheme = TRUE,
                       title = NULL,
                       titleSize = NULL,
                       legendTitle = NULL,
                       legendTitleSize = NULL,
                       legendSize = NULL,
                       combinePlot = "none",
                       plotLabels = NULL) {
  combinePlot <- match.arg(combinePlot,c("all", "sample", "none"))

  if (!is.null(sample)) {
    if (length(sample) != ncol(inSCE)) {
      stop(
        "'sample' must be the same length as the number",
        " of columns in 'inSCE'"
      )
    }
  } else {
    sample <- rep(1, ncol(inSCE))
  }

  samples <- unique(sample)

  plotlist <- lapply(samples, function(x){
    sceSampleInd <- which(sample == x)
    inSCESub <- inSCE[, sceSampleInd]
    colorBySub <- colorBy[sceSampleInd]

    dataframe <- data.frame(SingleCellExperiment::reducedDim(
      inSCESub,
      reducedDimName
    ))
    # If dim1 and dim2 are specified
    if (!is.null(dim1) & !is.null(dim2)) {
      if (is.character(dim1) & is.character(dim2)) {
        if (!(dim1 %in% colnames(dataframe))) {
          stop("X dimension ", dim1, " is not in the reducedDim data")
        }
        if (!(dim2 %in% colnames(dataframe))) {
          stop("Y dimension ", dim2, " is not in the reducedDim data")
        }
        dataframe <- dataframe[, c(dim1, dim2)]
      } else if (is.numeric(dim1) && is.numeric(dim2)) {
        dataframe <- dataframe[, c(dim1, dim2)]
      }
    } else if (ncol(dataframe) > 2) {
      warning("More than two dimensions supplied in reducedDims.
              Using the first two.")
    }

    # If xlab and ylab are specified
    if (!is.null(xlab) & !is.null(ylab)) {
      colnames(dataframe) <- c(xlab, ylab)
      # If reduced dimension matrix didnt have colnames
    } else {
      colnames(dataframe) <- c(paste0(reducedDimName, "_1"),
                               paste0(reducedDimName, "_2"))
    }

    xdim <- colnames(dataframe)[1]
    ydim <- colnames(dataframe)[2]

    if (!is.null(conditionClass) & !is.null(colorBySub)) {
      if (conditionClass %in% c("character", "factor", "numeric")) {
        if (conditionClass == "character") {
          colorBySub <- as.character(colorBySub)
        } else if (conditionClass == "factor") {
          colorBySub <- as.factor(colorBySub)
        } else if (conditionClass == "numeric") {
          colorBySub <- as.numeric(colorBySub)
        }
      }
    }

    if (!is.null(bin) & !is.null(colorBySub)) {
      colorBySub <- .binSCTK(
        value = colorBySub,
        bin = bin,
        binLabel = binLabel
      )
    }

    if (!is.null(colorBySub)) {
      dataframe$color <- colorBySub
    }

    if (!is.null(groupBy)){
      dataframe$groups <- factor(SingleCellExperiment::colData(inSCE)[[groupBy]])
    }
    if (!is.null(shape)) {
      dataframe$shape <- factor(SingleCellExperiment::colData(inSCESub)[[shape]])
    }
    dataframe$Sample <- colnames(inSCESub)
    g <- ggplot2::ggplot(dataframe, ggplot2::aes_string(xdim, ydim,
                                                        label = "Sample")) +
      ggplot2::geom_point(size = dotSize, alpha = transparency)
    if (!is.null(colorBySub)) {
      g <- g + ggplot2::aes_string(color = "color")
    }
    if (inherits(colorBySub, "numeric")){
      g <- g + ggplot2::scale_color_gradient2(
        low = colorLow,
        mid = colorMid,
        high = colorHigh,
        aesthetics = "colour",
        midpoint = mean(colorBySub))
    }else if (inherits(colorBySub, "character") | inherits(colorBySub, "factor")){
      g <- g +
        ggplot2::guides(colour = ggplot2::guide_legend(override.aes = list(size = 2)))
      if(all(!is.null(colorScale))){
        g <- g+ ggplot2::scale_color_manual(values=c(colorScale))
      }
    }
    if (!is.null(shape)) {
      g <- g + ggplot2::aes_string(shape = "shape") +
        ggplot2::labs(shape = shape)
    }
    if (defaultTheme == TRUE) {
      g <- .ggSCTKTheme(g, baseSize, groupBy = factor(sample),
                        combinePlot)
    }else{
      g <- g + ggplot2::theme_gray(base_size = baseSize)
    }

    g <- g + ggplot2::theme(axis.title =
                              ggplot2::element_text(size = axisLabelSize),
                            axis.text =
                              ggplot2::element_text(size = axisSize))
    if (!is.null(title)) {
      if (length(samples) > 1) {
        title <- paste(title, x, sep = "_")
      }
      g <- g + ggplot2::ggtitle(label = title) +
        ggplot2::theme(plot.title = ggplot2::element_text(
          hjust = 0.5,
          size = titleSize
        ))
    }
    if (!is.null(legendTitle)) {
      g <- g + ggplot2::labs(color = legendTitle) +
        ggplot2::theme(legend.title=ggplot2::element_text(size=legendTitleSize),
                       legend.text=ggplot2::element_text(size=legendSize))
    } else {
      g <- g + ggplot2::labs(color = "") +
        ggplot2::theme(legend.text=ggplot2::element_text(size=legendSize))
    }

    if (!is.null(groupBy)){
      g <- g + ggplot2::facet_wrap(~groups)
    }


    if (isTRUE(labelClusters) && class(colorBySub) %in% c("character", "factor")) {
      centroidList <- lapply(unique(colorBySub), function(x) {
        dataframe.sub <- dataframe[dataframe$color == x, ]
        median.1 <- stats::median(dataframe.sub[, 1])
        median.2 <- stats::median(dataframe.sub[, 2])
        cbind(median.1, median.2, as.character(x))
      })
      centroid <- do.call(rbind, centroidList)
      centroid <- data.frame(
        Dimension_1 = as.numeric(centroid[, 1]),
        Dimension_2 = as.numeric(centroid[, 2]),
        color = centroid[, 3],
        Sample = rep(1, length(unique(colorBySub)))
      )

      if (!is.null(shape)) {
        centroid$shape <- dataframe$shape[1]
      }

      if (!is.null(groupBy)){
        g <- g + ggplot2::facet_wrap(~groups)
      }

      colnames(centroid)[seq_len(2)] <- c(xdim, ydim)
      g <- g + ggplot2::geom_point(
        data = centroid,
        mapping = ggplot2::aes_string(x = xdim, y = ydim),
        size = 0,
        alpha = 0
      ) +
        ggrepel::geom_text_repel(
          data = centroid,
          mapping = ggplot2::aes_string(label = "color"),
          show.legend = FALSE,
          color = "black",
          size = clusterLabelSize
        )
    }
    return(g)
  })

  if (length(unique(samples)) > 1) {
    names(plotlist) <- samples
    plotlist <- list(Sample = plotlist)
  }

  ##Needs to be turned off for Shiny User Interface
  if(combinePlot %in% c("all", "sample")){
    figNcol = NULL
    if(!is.null(groupBy)){
      if(length(unique(groupBy)) > 1){
        figNcol = 1
      }
    }
    plotlist <- .ggSCTKCombinePlots(plotlist,
                                    combinePlot = combinePlot,
                                    ncols = figNcol,
                                    labels = plotLabels)
  }else if(combinePlot == "none" && length(plotlist) == 1 && methods::is(plotlist, "list")){
      # Prior to R4.5 and ggplot3
      # Started failing after 9/25 when bioc was using R4.5 and ggplot3 as this
      # was not a list any longer. Added the "is" check for list to the if statement.  
      plotlist <- plotlist[[1]]
  }

  return(plotlist)
}
#' @title Dimension reduction plot tool for colData
#' @description Plot results of reduced dimensions data and
#'  colors by annotation data stored in the colData slot.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object with saved
#' dimension reduction components or a variable with saved results. Required.
#' @param reducedDimName Saved dimension reduction matrix name in the
#' \linkS4class{SingleCellExperiment} object. Required.
#' @param sample Character vector. Indicates which sample each cell belongs to.
#' @param colorBy Color by a condition(any column of the annotation data).
#'  Required.
#' @param groupBy Group by a condition(any column of the annotation data).
#'  Default NULL.
#' @param conditionClass Class of the annotation data used in colorBy.
#'  Options are NULL, "factor" or "numeric". If NULL, class will default to the
#'  original class. Default NULL.
#' @param shape Add shapes to each condition.
#' @param xlab Character vector. Label for x-axis. Default NULL.
#' @param ylab Character vector. Label for y-axis. Default NULL.
#' @param dim1 1st dimension to be used for plotting. Can either be a string which specifies
#'  the name of the dimension to be plotted from reducedDims, or a numeric value which specifies
#'  the index of the dimension to be plotted. Default is NULL.
#' @param dim2 2nd dimension to be used for plotting. Can either be a string which specifies
#'  the name of the dimension to be plotted from reducedDims, or a numeric value which specifies
#'  the index of the dimension to be plotted. Default is NULL.
#' @param baseSize The base font size for all text. Default 12.
#'  Can be overwritten by titleSize, axisSize, and axisLabelSize,
#'  legendSize, legendTitleSize.
#' @param axisSize Size of x/y-axis ticks. Default NULL.
#' @param axisLabelSize Size of x/y-axis labels. Default NULL.
#' @param bin Numeric vector. If single value, will divide the numeric values into the `bin` groups.
#'  If more than one value, will bin numeric values using values as a cut point.
#' @param binLabel Character vector. Labels for the bins created by the `bin` parameter.
#'  Default NULL.
#' @param dotSize Size of dots. Default 0.1.
#' @param transparency Transparency of the dots, values will be 0-1. Default 1.
#' @param colorScale Vector. Needs to be same length as the
#'  number of unique levels of colorBy. Will be used only if
#'  conditionClass = "factor" or "character". Default NULL.
#' @param colorLow Character. A color available from `colors()`.
#'  The color will be used to signify the lowest values on the scale.
#'  Default 'white'.
#' @param colorMid Character. A color available from `colors()`.
#'  The color will be used to signify the midpoint on the scale.
#'  Default 'gray'.
#' @param colorHigh Character. A color available from `colors()`.
#'  The color will be used to signify the highest values on the scale.
#'  Default 'blue'.
#' @param defaultTheme adds grid to plot when TRUE. Default TRUE.
#' @param title Title of plot. Default NULL.
#' @param titleSize Size of title of plot. Default 15.
#' @param labelClusters Logical. Whether the cluster labels are plotted.
#' @param clusterLabelSize Numeric. Determines the size of cluster label
#'  when `labelClusters` is set to TRUE. Default 3.5.
#' @param legendTitle title of legend. Default NULL.
#' @param legendTitleSize size of legend title. Default 12.
#' @param legendSize size of legend. Default NULL.
#'  Default FALSE.
#' @param combinePlot Must be either "all", "sample", or "none". "all" will combine all plots into a single
#' .ggplot object, while "sample" will output a list of plots separated by sample. Default "none".
#' @param plotLabels labels to each plot. If set to "default", will use the name of the samples
#'  as the labels. If set to "none", no label will be plotted.
#' @return a ggplot of the reduced dimension plot of coldata.
#' @examples
#' data("mouseBrainSubsetSCE")
#' plotSCEDimReduceColData(
#'   inSCE = mouseBrainSubsetSCE, colorBy = "tissue",
#'   shape = NULL, conditionClass = "factor",
#'   reducedDimName = "TSNE_counts",
#'   xlab = "tSNE1", ylab = "tSNE2", labelClusters = TRUE
#' )
#'
#' plotSCEDimReduceColData(
#'   inSCE = mouseBrainSubsetSCE, colorBy = "age",
#'   shape = NULL, conditionClass = "numeric",
#'   reducedDimName = "TSNE_counts", bin = c(-Inf, 20, 25, +Inf),
#'   xlab = "tSNE1", ylab = "tSNE2", labelClusters = FALSE
#' )
#' @export
plotSCEDimReduceColData <- function(inSCE,
                                    colorBy,
                                    reducedDimName,
                                    sample = NULL,
                                    groupBy = NULL,
                                    conditionClass = NULL,
                                    shape = NULL,
                                    xlab = NULL,
                                    ylab = NULL,
                                    baseSize = 12,
                                    axisSize = NULL,
                                    axisLabelSize = NULL,
                                    dim1 = NULL,
                                    dim2 = NULL,
                                    bin = NULL,
                                    binLabel = NULL,
                                    dotSize = 0.1,
                                    transparency = 1,
                                    colorScale = NULL,
                                    colorLow = "white",
                                    colorMid = "gray",
                                    colorHigh = "blue",
                                    defaultTheme = TRUE,
                                    title = NULL,
                                    titleSize = 15,
                                    labelClusters = TRUE,
                                    clusterLabelSize = 3.5,
                                    legendTitle = NULL,
                                    legendTitleSize = NULL,
                                    legendSize = NULL,
                                    combinePlot = "none",
                                    plotLabels = NULL) {
  combinePlot <- match.arg(combinePlot,c("all", "sample", "none"))

  colorPlot <- SingleCellExperiment::colData(inSCE)[, colorBy]

  g <- .ggScatter(
    inSCE = inSCE,
    sample = sample,
    colorBy = colorPlot,
    groupBy = groupBy,
    conditionClass = conditionClass,
    shape = shape,
    reducedDimName = reducedDimName,
    xlab = xlab,
    ylab = ylab,
    dim1 = dim1,
    dim2 = dim2,
    axisSize = axisSize,
    axisLabelSize = axisLabelSize,
    bin = bin,
    binLabel = binLabel,
    dotSize = dotSize,
    transparency = transparency,
    colorScale = colorScale,
    colorLow = colorLow,
    colorMid = colorMid,
    colorHigh = colorHigh,
    defaultTheme = defaultTheme,
    baseSize = baseSize,
    title = title,
    titleSize = titleSize,
    labelClusters = labelClusters,
    clusterLabelSize = clusterLabelSize,
    legendTitle = legendTitle,
    legendTitleSize = legendTitleSize,
    legendSize = legendSize,
    combinePlot = combinePlot,
    plotLabels = plotLabels
  )
  return(g)
}


#' @title Dimension reduction plot tool for assay data
#' @description Plot results of reduced dimensions data and
#'  colors by feature data stored in the assays slot.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object with saved
#' dimension reduction components or a variable with saved results. Required.
#' @param reducedDimName saved dimension reduction name in the
#' \linkS4class{SingleCellExperiment} object. Required.
#' @param sample Character vector. Indicates which sample each cell belongs to.
#' @param features Name of feature stored in assay of SingleCellExperiment
#'  object.
#' @param feature Deprecated, use `features` instead.
#' @param featureLocation Indicates which column name of rowData to query gene.
#' @param featureDisplay Indicates which column name of rowData to use
#' to display feature for visualization.
#' @param shape add shapes to each condition. Default NULL.
#' @param useAssay Indicate which assay to use. The default is "logcounts"
#' @param xlab Character vector. Label for x-axis. Default NULL.
#' @param ylab Character vector. Label for y-axis. Default NULL.
#' @param axisSize Size of x/y-axis ticks. Default 10.
#' @param axisLabelSize Size of x/y-axis labels. Default 10.
#' @param dim1 1st dimension to be used for plotting. Can either be a string which specifies
#'  the name of the dimension to be plotted from reducedDims, or a numeric value which specifies
#'  the index of the dimension to be plotted. Default is NULL.
#' @param dim2 2nd dimension to be used for plotting. Can either be a string which specifies
#'  the name of the dimension to be plotted from reducedDims, or a numeric value which specifies
#'  the index of the dimension to be plotted. Default is NULL.
#' @param bin Numeric vector. If single value, will divide the numeric values into the `bin` groups.
#'  If more than one value, will bin numeric values using values as a cut point.
#' @param binLabel Character vector. Labels for the bins created by the `bin` parameter.
#'  Default NULL.
#' @param dotSize Size of dots. Default 0.1.
#' @param transparency Transparency of the dots, values will be 0-1. Default 1.
#' @param colorLow Character. A color available from `colors()`.
#'  The color will be used to signify the lowest values on the scale.
#'  Default 'white'.
#' @param colorMid Character. A color available from `colors()`.
#'  The color will be used to signify the midpoint on the scale.
#'  Default 'gray'.
#' @param colorHigh Character. A color available from `colors()`.
#'  The color will be used to signify the highest values on the scale.
#'  Default 'blue'.
#' @param defaultTheme adds grid to plot when TRUE. Default TRUE.
#' @param title Title of plot. Default NULL.
#' @param titleSize Size of title of plot. Default 15.
#' @param legendTitle title of legend. Default NULL.
#' @param legendTitleSize size of legend title. Default 12.
#' @param legendSize size of legend. Default 10.
#' @param ncols number of columns for multiple feature plotting. Default NULL.
#' @param groupBy Facet wrap the scatterplot based on value.
#' Default \code{NULL}.
#' @param combinePlot Must be either "all", "sample", or "none". "all" will combine all plots into a single
#' .ggplot object, while "sample" will output a list of plots separated by sample. Default "none".
#' @param plotLabels labels to each plot. If set to "default", will use the name of the samples
#'  as the labels. If set to "none", no label will be plotted.
#' @return a ggplot of the reduced dimension plot of feature data.
#' @importFrom lifecycle deprecated deprecate_warn
#' @examples
#' data("mouseBrainSubsetSCE")
#' plotSCEDimReduceFeatures(
#'   inSCE = mouseBrainSubsetSCE, features = "Apoe",
#'   shape = NULL, reducedDimName = "TSNE_counts",
#'   useAssay = "counts", xlab = "tSNE1", ylab = "tSNE2"
#' )
#' @export
plotSCEDimReduceFeatures <- function(inSCE,
                                     features,
                                     feature = deprecated(),
                                     reducedDimName,
                                     sample = NULL,
                                     featureLocation = NULL,
                                     featureDisplay = NULL,
                                     shape = NULL,
                                     useAssay = "logcounts",
                                     xlab = NULL,
                                     ylab = NULL,
                                     axisSize = 10,
                                     axisLabelSize = 10,
                                     dim1 = NULL,
                                     dim2 = NULL,
                                     bin = NULL,
                                     binLabel = NULL,
                                     dotSize = 0.1,
                                     transparency = 1,
                                     colorLow = "white",
                                     colorMid = "gray",
                                     colorHigh = "blue",
                                     defaultTheme = TRUE,
                                     title = NULL,
                                     titleSize = 15,
                                     legendTitle = NULL,
                                     legendSize = 10,
                                     legendTitleSize = 12,
                                     ncols = NULL,
                                     groupBy = NULL,
                                     combinePlot = "none",
                                     plotLabels = NULL) {
  if (lifecycle::is_present(feature)) {
    deprecate_warn("2.19.1", "singleCellTK::plotSCEDimReduceFeatures(feature = )",
    "singleCellTK::plotSCEDimReduceFeatures(features = )")
    features <- feature
  }
  combinePlot <- match.arg(combinePlot,c("all", "sample", "none"))

  if(!is.null(featureDisplay)){
    featureDisplay <- match.arg(featureDisplay,
                                c("rownames",
                                  colnames(SummarizedExperiment::rowData(inSCE))))
  }else{
    if(exists(x = "featureDisplay", inSCE@metadata)){
      featureDisplay <- inSCE@metadata$featureDisplay
    }
  }

  if (length(features) > 1) {
    plotlist <- lapply(features, function(f) {
      mat <- getBiomarker(
        inSCE = inSCE,
        useAssay = useAssay,
        gene = f,
        binary = "Continuous",
        featureLocation = featureLocation,
        featureDisplay = featureDisplay
      )
      counts <- mat[, 2]
      plot_title <- if(!is.null(featureDisplay)) utils::tail(colnames(mat),1) else f
      .ggScatter(
        inSCE = inSCE,
        sample = sample,
        conditionClass = "numeric",
        colorBy = counts,
        shape = shape,
        transparency = 1,
        colorLow = colorLow,
        colorMid = colorMid,
        colorHigh = colorHigh,
        reducedDimName = reducedDimName,
        xlab = xlab,
        ylab = ylab,
        axisSize = axisSize,
        axisLabelSize = axisLabelSize,
        dim1 = dim1,
        dim2 = dim2,
        bin = bin,
        binLabel = binLabel,
        defaultTheme = defaultTheme,
        dotSize = dotSize,
        title = plot_title,
        titleSize = titleSize,
        legendTitle = legendTitle,
        legendTitleSize = legendTitleSize,
        legendSize = legendSize,
        groupBy = groupBy,
        combinePlot = "none",
        plotLabels = plotLabels
      )
    })
    if (combinePlot != "none") {
      plotlist <- .ggSCTKCombinePlots(plotlist,
                                      combinePlot = combinePlot,
                                      ncols = ncols,
                                      labels = plotLabels)
    }
    return(plotlist)
  } else {
    mat <- getBiomarker(
      inSCE = inSCE,
      useAssay = useAssay,
      gene = features,
      binary = "Continuous",
      featureLocation = featureLocation,
      featureDisplay = featureDisplay
    )
    counts <- mat[, 2]
    if(!is.null(featureDisplay)){
      title = utils::tail(colnames(mat),1)
    }
    g <- .ggScatter(
      inSCE = inSCE,
      sample = sample,
      conditionClass = "numeric",
      colorBy = counts,
      shape = shape,
      transparency = 1,
      colorLow = colorLow,
      colorMid = colorMid,
      colorHigh = colorHigh,
      reducedDimName = reducedDimName,
      xlab = xlab,
      ylab = ylab,
      axisSize = axisSize,
      axisLabelSize = axisLabelSize,
      dim1 = dim1,
      dim2 = dim2,
      bin = bin,
      binLabel = binLabel,
      defaultTheme = defaultTheme,
      dotSize = dotSize,
      title = title,
      titleSize = titleSize,
      legendTitle = legendTitle,
      legendTitleSize = legendTitleSize,
      legendSize = legendSize,
      groupBy = groupBy,
      combinePlot = combinePlot,
      plotLabels = plotLabels
    )
    return(g)
  }
}

#' @title Dimension reduction plot tool for all types of data
#' @description Plot results of reduced dimensions data of counts stored in any
#' slot in the SingleCellExperiment object.
#' @param inSCE Input SingleCellExperiment object with saved dimension reduction
#'  components or a variable with saved results. Required.
#' @param reducedDimName saved dimension reduction name in the
#' \linkS4class{SingleCellExperiment} object.
#' @param sample Character vector. Indicates which sample each cell belongs to.
#' @param slot Desired slot of SingleCellExperiment used for plotting. Possible
#'  options: "assays", "colData", "metadata", "reducedDims". Default NULL.
#' @param annotation Desired vector within the slot used for plotting. Default NULL.
#' @param feature name of feature stored in assay of SingleCellExperiment
#'  object. Will be used only if "assays" slot is chosen. Default NULL.
#' @param groupBy Group by a condition(any column of the annotation data).
#'  Default NULL.
#' @param shape add shapes to each condition.
#' @param conditionClass class of the annotation data used in colorBy. Options
#'  are NULL, "factor" or "numeric". If NULL, class will default to the original
#'  class. Default NULL.
#' @param xlab Character vector. Label for x-axis. Default NULL.
#' @param ylab Character vector. Label for y-axis. Default NULL.
#' @param axisSize Size of x/y-axis ticks. Default 10.
#' @param axisLabelSize Size of x/y-axis labels. Default 10.
#' @param dim1 1st dimension to be used for plotting. Can either be a string which specifies
#'  the name of the dimension to be plotted from reducedDims, or a numeric value which specifies
#'  the index of the dimension to be plotted. Default is NULL.
#' @param dim2 2nd dimension to be used for plotting. Can either be a string which specifies
#'  the name of the dimension to be plotted from reducedDims, or a numeric value which specifies
#'  the index of the dimension to be plotted. Default is NULL.
#' @param bin Numeric vector. If single value, will divide the numeric values into the `bin` groups.
#'  If more than one value, will bin numeric values using values as a cut point.
#' @param binLabel Character vector. Labels for the bins created by the `bin` parameter.
#'  Default NULL.
#' @param dotSize Size of dots. Default 0.1.
#' @param transparency Transparency of the dots, values will be 0-1. Default 1.
#' @param colorLow Character. A color available from `colors()`.
#'  The color will be used to signify the lowest values on the scale.
#'  Default 'white'.
#' @param colorMid Character. A color available from `colors()`.
#'  The color will be used to signify the midpoint on the scale.
#'  Default 'gray'.
#' @param colorHigh Character. A color available from `colors()`.
#'  The color will be used to signify the highest values on the scale.
#'  Default 'blue'.
#' @param defaultTheme adds grid to plot when TRUE. Default TRUE.
#' @param title Title of plot. Default NULL.
#' @param titleSize Size of title of plot. Default 15.
#' @param labelClusters Logical. Whether the cluster labels are plotted.
#' @param legendTitle title of legend. Default NULL.
#' @param legendTitleSize size of legend title. Default 12.
#' @param legendSize size of legend. Default 10.
#' @param combinePlot Must be either "all", "sample", or "none". "all" will combine all plots into a single
#' .ggplot object, while "sample" will output a list of plots separated by sample. Default "none".
#' @param plotLabels labels to each plot. If set to "default", will use the name of the samples
#'  as the labels. If set to "none", no label will be plotted.
#' @return a ggplot of the reduced dimensions.
#' @examples
#' data("mouseBrainSubsetSCE")
#' plotSCEScatter(
#'   inSCE = mouseBrainSubsetSCE, legendTitle = NULL,
#'   slot = "assays", annotation = "counts", feature = "Apoe",
#'   reducedDimName = "TSNE_counts", labelClusters = FALSE
#' )
#' @export
#' @import SingleCellExperiment
plotSCEScatter <- function(inSCE,
                           annotation,
                           reducedDimName = NULL,
                           slot = NULL,
                           sample = NULL,
                           feature = NULL,
                           groupBy = NULL,
                           shape = NULL,
                           conditionClass = NULL,
                           xlab = NULL,
                           ylab = NULL,
                           axisSize = 10,
                           axisLabelSize = 10,
                           dim1 = NULL,
                           dim2 = NULL,
                           bin = NULL,
                           binLabel = NULL,
                           dotSize = 0.1,
                           transparency = 1,
                           colorLow = "white",
                           colorMid = "gray",
                           colorHigh = "blue",
                           defaultTheme = TRUE,
                           title = NULL,
                           titleSize = 15,
                           labelClusters = TRUE,
                           legendTitle = NULL,
                           legendTitleSize = 12,
                           legendSize = 10,
                           combinePlot = "none",
                           plotLabels = NULL){
  combinePlot <- match.arg(combinePlot,c("all", "sample", "none"))

  if (!is.null(slot)){
    if (slot == "reducedDims"){
      annotation_clm <- substr(annotation, stringr::str_length(annotation), stringr::str_length(annotation))
      annotation <- substr(annotation, 1, stringr::str_length(annotation) - 2)
    }else if (!slot %in% methods::slotNames(inSCE)) {
      stop("'slot' must be a slot within the SingleCellExperiment object.",
           "Please run 'methods::slotNames' if you are unsure the",
           "specified slot exists.")
    }

    sceSubset <- do.call(slot, args = list(inSCE))

    if (!annotation %in% names(sceSubset)) {
      stop("'annotation' must be an annotation stored within the specified
             slot of the SingleCellExperiment object.")
    }
    annotation.ix <- match(annotation, c(names(sceSubset)))
  }

  if (is.null(slot)){
    colorPlot <- NULL
  }else if (slot == "assays" && !is.null(feature)) {
    counts <- sceSubset[[annotation.ix]]
    if (feature %in% rownames(counts)) {
      colorPlot <- counts[feature, ]
    }
  } else if (slot == "colData") {
    colorPlot <- sceSubset[, annotation.ix]
  } else if (slot == "metadata") {
    colorPlot <- sceSubset[[annotation.ix]]
  } else if (slot == "reducedDims") {
    colorPlot <- sceSubset[[annotation.ix]][, as.numeric(annotation_clm)]
  }

  g <- .ggScatter(
    inSCE = inSCE,
    sample = sample,
    colorBy = colorPlot,
    groupBy = groupBy,
    conditionClass = conditionClass,
    shape = shape,
    reducedDimName = reducedDimName,
    xlab = xlab,
    ylab = ylab,
    axisSize = axisSize,
    axisLabelSize = axisLabelSize,
    dim1 = dim1,
    dim2 = dim2,
    bin = bin,
    binLabel = binLabel,
    dotSize = dotSize,
    transparency = transparency,
    colorLow = colorLow,
    colorMid = colorMid,
    colorHigh = colorHigh,
    defaultTheme = defaultTheme,
    title = title,
    titleSize = titleSize,
    labelClusters = labelClusters,
    legendTitle = legendTitle,
    legendTitleSize = legendTitleSize,
    legendSize = legendSize,
    combinePlot = combinePlot
  )
  return(g)
}

#' @title Violin plot plotting tool.
#' @description Visualizes specified values via a violin plot.
#' @param y Numeric values to be plotted on y-axis.
#' @param groupBy Groupings for each numeric value. A user may input a vector
#' equal length to the number of the samples in the SingleCellExperiment
#' object, or can be retrieved from the colData slot. Default NULL.
#' @param violin Boolean. If TRUE, will plot the violin plot. Default TRUE.
#' @param boxplot Boolean. If TRUE, will plot boxplots for each violin plot.
#'  Default TRUE.
#' @param dots Boolean. If TRUE, will plot dots for each violin plot.
#'  Default TRUE.
#' @param plotOrder Character vector. If set, reorders the violin plots
#'  in the order of the character vector when `groupBy` is set.
#'  Default NULL.
#' @param xlab Character vector. Label for x-axis. Default NULL.
#' @param ylab Character vector. Label for y-axis. Default NULL.
#' @param baseSize The base font size for all text. Default 12.
#'  Can be overwritten by titleSize, axisSize, and axisLabelSize.
#' @param axisSize Size of x/y-axis ticks. Default NULL.
#' @param axisLabelSize Size of x/y-axis labels. Default NULL.
#' @param dotSize Size of dots. Default 0.1.
#' @param transparency Transparency of the dots, values will be 0-1. Default 1.
#' @param defaultTheme Removes grid in plot and sets axis title size to 10
#'  when TRUE. Default TRUE.
#' @param gridLine Adds a horizontal grid line if TRUE. Will still be
#'  drawn even if defaultTheme is TRUE. Default FALSE.
#' @param summary Adds a summary statistic, as well as a crossbar to the
#'  violin plot. Options are "mean" or "median". Default NULL.
#' @param summaryTextSize The text size of the summary statistic displayed
#'  above the violin plot. Default 3.
#' @param combinePlot Must be either "all", "sample", or "none". "all" will combine all plots into a single
#' .ggplot object, while "sample" will output a list of plots separated by sample. Default "none".
#' @param title Title of plot. Default NULL.
#' @param titleSize Size of title of plot. Default 15.
#' @param hcutoff Adds a horizontal line with the y-intercept at given value. Default NULL.
#' @param hcolor Character. A color available from `colors()`.
#'  Controls the color of the horizontal cutoff line, if drawn.
#'  Default 'black'.
#' @param hsize Size of horizontal line, if drawn. Default 0.5.
#' @param hlinetype Type of horizontal line, if drawn. can be specified with either an integer or
#'  a name (0 = blank, 1 = solid, 2 = dashed, 3 = dotted, 4 = dotdash, 5 = longdash, 6 = twodash).
#'  Default 1.
#' @param vcutoff Adds a vertical line with the x-intercept at given value. Default NULL.
#' @param vcolor Character. A color available from `colors()`.
#'  Controls the color of the vertical cutoff line, if drawn.
#'  Default 'black'.
#' @param vsize Size of vertical line, if drawn. Default 0.5.
#' @param vlinetype Type of vertical line, if drawn. can be specified with either an integer or
#'  a name (0 = blank, 1 = solid, 2 = dashed, 3 = dotted, 4 = dotdash, 5 = longdash, 6 = twodash).
#'  Default 1.
#' @return a ggplot of the reduced dimensions.
#' @importFrom dplyr group_by
#' @importFrom dplyr summarize
#' @importFrom dplyr %>%
#' @noRd
.ggViolin <- function(y,
                      groupBy = NULL,
                      violin = TRUE,
                      boxplot = TRUE,
                      dots = TRUE,
                      plotOrder = NULL,
                      xlab = NULL,
                      ylab = NULL,
                      baseSize = 12,
                      axisSize = NULL,
                      axisLabelSize = NULL,
                      dotSize = 0.1,
                      transparency = 1,
                      defaultTheme = TRUE,
                      gridLine = FALSE,
                      summary = NULL,
                      summaryTextSize = 3,
                      combinePlot = "none",
                      title = NULL,
                      titleSize = NULL,
                      hcutoff = NULL,
                      hcolor = "red",
                      hsize = 1,
                      hlinetype = 1,
                      vcutoff = NULL,
                      vcolor = "red",
                      vsize = 1,
                      vlinetype = 1) {

  mult_modules <- FALSE

  if (is.null(groupBy)) {
    if (length(colnames(y)) > 1){
      mult_modules <- TRUE
      groupBy <- rep(colnames(y), each = dim(y)[1])
      y <- tidyr::pivot_longer(as.data.frame(y), cols = 1:dim(y)[2], cols_vary = "slowest")$value#
    }else{
      groupBy <- rep("Sample", length(y))
    }
  }

  if(!is.factor(groupBy)){
    if(is.null(plotOrder)){
      plotOrder = unique(groupBy)
    }
    groupBy <- factor(groupBy, levels = plotOrder)
  }else{
    if(!is.null(plotOrder)){
      groupBy <- factor(groupBy, levels = plotOrder)
    }
  }

  df <- data.frame(groupBy = groupBy, y = y)

  p <- ggplot2::ggplot(df) +
    ggplot2::aes_string(
      x = "groupBy",
      y = "y"
    )
  if (dots == TRUE) {
    p <- p + ggplot2::geom_jitter(
      color = "blue",
      width = 0.2,
      height = 0,
      size = dotSize,
      alpha = transparency
    )
  }
  if (boxplot == TRUE) {
    p <- p + ggplot2::geom_boxplot(width = 0.5,
                                   alpha = 0)
  }
  if (violin == TRUE) {
    p <- p + ggplot2::geom_violin(trim = TRUE,
                                  scale = "width",
                                  linewidth = 0.5,
                                  fill = "grey",
                                  alpha = 0.75)
  }
  if (defaultTheme == TRUE) {
    p <- .ggSCTKTheme(p, baseSize, groupBy, combinePlot)
  }else{
    p <- p + ggplot2::theme_gray(base_size = baseSize)
  }
  if (!is.null(title)) {
    p <- p + ggplot2::ggtitle(label = title) +
      ggplot2::theme(plot.title = ggplot2::element_text(
        hjust = 0.5,
        size = titleSize
      ))
  }

  p <- p + ggplot2::theme(axis.text.y = ggplot2::element_text(size = axisSize))

  if(length(unique(df$groupBy)) > 1){
    p <- p + ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 45,
                                                                hjust = 1,
                                                                size = axisSize))
  }else{
    p <- p + ggplot2::theme(axis.text.x = ggplot2::element_blank(),
                            axis.ticks.x = ggplot2::element_blank(),
                            axis.title.x = ggplot2::element_blank())
  }

  if (mult_modules){
    p <- p + xlab("Modules")
  }

  if (gridLine == TRUE){
    p <- p + ggplot2::theme(panel.grid.major.y = ggplot2::element_line("grey"))
  }
  if (!is.null(xlab)) {
    p <- p + ggplot2::xlab(xlab) +
      ggplot2::theme(axis.title.x = ggplot2::element_text(size = axisLabelSize))
  }
  if (!is.null(ylab)) {
    p <- p + ggplot2::ylab(ylab) +
      ggplot2::theme(axis.title.y = ggplot2::element_text(size = axisLabelSize))
  }
  if (!is.null(summary)){
    if(summary == "mean"){
      summ <- df %>% dplyr::group_by(groupBy) %>% dplyr::summarize(value = base::mean(y))
      fun <- base::mean
    }else if(summary == "median"){
      summ <- df %>% dplyr::group_by(groupBy) %>% dplyr::summarize(value = stats::median(y))
      fun <- stats::median
    }else{
      stop("`summary`` must be either `mean` or `median`.")
    }
    summ$statY <-  max(df$y) + (max(df$y) - min(df$y)) * 0.05
    summary <- paste(toupper(substr(summary, 1, 1)),
                     substr(summary, 2, nchar(summary)), sep="")

    ##Truncate label of mean/median if too many sample types
    if(length(levels(groupBy)) > 5){
      if(all(summ$value>1)){
        summ$label <- round(summ$value, 1)
      }else{
        summ$label <- signif(summ$value, 1)
      }
      p <- p + ggplot2::labs(subtitle = paste0(summary," values shown"))
    }else{
      if(all(summ$value>1)){
        summ$label <- paste0(summary,": ", round(summ$value, 2))
      }else{
        summ$label <- paste0(summary,": ", signif(summ$value, 2))
      }
    }

    if(!is.null(groupBy)){
      summaryTextSize = summaryTextSize/length(levels(groupBy)) + 2
    }

    p <- p + ggplot2::geom_text(data = summ, size = summaryTextSize,
                                ggplot2::aes_string(x = "groupBy",
                                                    y = "statY",
                                                    label = "label"))
    p <- p + ggplot2::stat_summary(fun = fun, fun.min = fun,
                                   fun.max = fun,
                                   geom = "crossbar",
                                   color = "red",
                                   linetype = 1,
                                   linewidth = 0.5,
                                   width = 0.5)
  }
  if(!is.null(hcutoff)){
    p <- .ggAddLine(p, hcutoff = hcutoff, hcolor = hcolor,
                    hsize = hsize, hlinetype = hlinetype)
  }
  if(!is.null(vcutoff)){
    p <- .ggAddLine(p, vcutoff = vcutoff, vcolor = vcolor,
                    vsize = vsize, vlinetype = vlinetype)
  }

  return(p)
}


#' @title Violin plot of colData.
#' @description Visualizes values stored in the colData slot of a
#'  SingleCellExperiment object via a violin plot.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object with saved
#' dimension reduction components or a variable with saved results. Required.
#' @param sample Character vector. Indicates which sample each cell belongs to.
#' @param coldata colData value that will be plotted.
#' @param groupBy Groupings for each numeric value. A user may input a vector
#'  equal length to the number of the samples in the SingleCellExperiment
#'  object, or can be retrieved from the colData slot. Default NULL.
#' @param violin Boolean. If TRUE, will plot the violin plot. Default TRUE.
#' @param boxplot Boolean. If TRUE, will plot boxplots for each violin plot.
#'  Default TRUE.
#' @param dots Boolean. If TRUE, will plot dots for each violin plot.
#'  Default TRUE.
#' @param plotOrder Character vector. If set, reorders the violin plots
#'  in the order of the character vector when `groupBy` is set.
#'  Default NULL.
#' @param xlab Character vector. Label for x-axis. Default NULL.
#' @param ylab Character vector. Label for y-axis. Default NULL.
#' @param baseSize The base font size for all text. Default 12.
#'  Can be overwritten by titleSize, axisSize, and axisLabelSize.
#' @param axisSize Size of x/y-axis ticks. Default NULL.
#' @param axisLabelSize Size of x/y-axis labels. Default NULL.
#' @param dotSize Size of dots. Default 0.1.
#' @param transparency Transparency of the dots, values will be 0-1. Default 1.
#' @param defaultTheme Removes grid in plot and sets axis title size to 10
#'  when TRUE. Default TRUE.
#' @param gridLine Adds a horizontal grid line if TRUE. Will still be
#'  drawn even if defaultTheme is TRUE. Default FALSE.
#' @param summary Adds a summary statistic, as well as a crossbar to the
#'  violin plot. Options are "mean" or "median". Default NULL.
#' @param summaryTextSize The text size of the summary statistic displayed
#'  above the violin plot. Default 3.
#' @param title Title of plot. Default NULL.
#' @param titleSize Size of title of plot. Default 15.
#' @param hcutoff Adds a horizontal line with the y-intercept at given value. Default NULL.
#' @param hcolor Character. A color available from `colors()`.
#'  Controls the color of the horizontal cutoff line, if drawn.
#'  Default 'black'.
#' @param hsize Size of horizontal line, if drawn. Default 0.5.
#' @param hlinetype Type of horizontal line, if drawn. can be specified with either an integer or
#'  a name (0 = blank, 1 = solid, 2 = dashed, 3 = dotted, 4 = dotdash, 5 = longdash, 6 = twodash).
#'  Default 1.
#' @param vcutoff Adds a vertical line with the x-intercept at given value. Default NULL.
#' @param vcolor Character. A color available from `colors()`.
#'  Controls the color of the vertical cutoff line, if drawn.
#'  Default 'black'.
#' @param vsize Size of vertical line, if drawn. Default 0.5.
#' @param vlinetype Type of vertical line, if drawn. can be specified with either an integer or
#'  a name (0 = blank, 1 = solid, 2 = dashed, 3 = dotted, 4 = dotdash, 5 = longdash, 6 = twodash).
#'  Default 1.
#' @param combinePlot Must be either "all", "sample", or "none". "all" will combine all plots into a single
#' .ggplot object, while "sample" will output a list of plots separated by sample. Default "none".
#' @param plotLabels labels to each plot. If set to "default", will use the name of the samples
#'  as the labels. If set to "none", no label will be plotted.
#' @return a ggplot of the violin plot of coldata.
#' @examples
#' data("mouseBrainSubsetSCE")
#' plotSCEViolinColData(
#'   inSCE = mouseBrainSubsetSCE,
#'   coldata = "age", groupBy = "sex"
#' )
#' @export
plotSCEViolinColData <- function(inSCE,
                                 coldata,
                                 sample = NULL,
                                 groupBy = NULL,
                                 violin = TRUE,
                                 boxplot = TRUE,
                                 dots = TRUE,
                                 plotOrder = NULL,
                                 xlab = NULL,
                                 ylab = NULL,
                                 baseSize = 12,
                                 axisSize = NULL,
                                 axisLabelSize = NULL,
                                 dotSize = 0.1,
                                 transparency = 1,
                                 defaultTheme = TRUE,
                                 gridLine = FALSE,
                                 summary = NULL,
                                 summaryTextSize = 3,
                                 title = NULL,
                                 titleSize = NULL,
                                 hcutoff = NULL,
                                 hcolor = "red",
                                 hsize = 1,
                                 hlinetype = 1,
                                 vcutoff = NULL,
                                 vcolor = "red",
                                 vsize = 1,
                                 vlinetype = 1,
                                 combinePlot = "none",
                                 plotLabels = NULL) {
  combinePlot <- match.arg(combinePlot,c("all", "sample", "none"))

  if (!is.null(coldata)) {
    if (!coldata %in% names(SummarizedExperiment::colData(inSCE))) {
      p <- paste(coldata)
      stop("'", p, "' is not found in ColData.")
    }
    coldata <- SummarizedExperiment::colData(inSCE)[, coldata]
  } else {
    stop("You must define the desired colData to plot.")
  }

  if (!is.null(groupBy)) {
    if (length(groupBy) > 1) {
      if (length(groupBy) != length(coldata)) {
        stop("The input vector for 'groupBy' needs to be the same
                     length as the number of samples in your
                     SingleCellExperiment object.")
      }
    } else {
      if (!groupBy %in% names(SummarizedExperiment::colData(inSCE))) {
        p <- paste(groupBy)
        stop("'", p, "' is not found in ColData.")
      }
      groupBy <- as.character(SummarizedExperiment::colData(inSCE)[, groupBy])
    }
  }

  if (!is.null(sample)) {
    if (length(sample) != ncol(inSCE)) {
      stop("'sample' must be the same length as the number",
           " of columns in 'inSCE'")
    }
  } else {
    sample <- rep(1, ncol(inSCE))
  }

  samples <- unique(sample)
  plotlist <- lapply(samples, function(x) {
    sampleInd <- which(sample == x)
    coldataSub <- coldata[sampleInd]
    if(!is.null(groupBy)){
      groupbySub <- groupBy[sampleInd]
    }else{
      groupbySub <- NULL
    }

    if(!is.null(title) && length(samples) > 1){
      title = paste(title, x, sep = ", ")
    }

    p <- .ggViolin(
      y = coldataSub,
      groupBy = groupbySub,
      violin = violin,
      boxplot = boxplot,
      dots = dots,
      plotOrder = plotOrder,
      xlab = xlab,
      ylab = ylab,
      baseSize=baseSize,
      axisSize = axisSize,
      axisLabelSize = axisLabelSize,
      dotSize = dotSize,
      transparency = transparency,
      defaultTheme = defaultTheme,
      gridLine = gridLine,
      summary = summary,
      summaryTextSize=summaryTextSize,
      combinePlot = combinePlot,
      title = title,
      titleSize = titleSize
    )
    if(!is.null(hcutoff)){
      p <- .ggAddLine(p, hcutoff = hcutoff, hcolor = hcolor,
                      hsize = hsize, hlinetype = hlinetype)
    }
    if(!is.null(vcutoff)){
      p <- .ggAddLine(p, vcutoff = vcutoff, vcolor = vcolor,
                      vsize = vsize, vlinetype = vlinetype)
    }
    return(p)
  })

  ##Needs to be turned off for Shiny User Interface
  if(combinePlot %in% c("all", "sample")){
    figNcol = NULL
    if(!is.null(groupBy)){
      if(length(unique(groupBy)) > 1){
        figNcol = 1
      }
    }
    plotlist <- .ggSCTKCombinePlots(plotlist,
                                    combinePlot = combinePlot,
                                    ncols = figNcol,
                                    labels = plotLabels)
  }else if(combinePlot == "none" && length(plotlist) == 1 && methods::is(plotlist, "list")){
      # Prior to R4.5 and ggplot3
      # Started failing after 9/25 when bioc was using R4.5 and ggplot3 as this
      # was not a list any longer. Added the "is" check for list to the if statement.  
      plotlist <- plotlist[[1]]
  }

  return(plotlist)
}


#' @title Violin plot of assay data.
#' @description Visualizes values stored in the assay slot of a
#'  SingleCellExperiment object via a violin plot.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object with saved
#' dimension reduction components or a variable with saved results. Required.
#' @param sample Character vector. Indicates which sample each cell belongs to.
#' @param useAssay Indicate which assay to use. Default "counts".
#' @param feature Name of feature stored in assay of SingleCellExperiment
#'  object.
#' @param featureLocation Indicates which column name of rowData to query gene.
#' @param featureDisplay Indicates which column name of rowData to use
#' to display feature for visualization.
#' @param groupBy Groupings for each numeric value. A user may input a vector
#'  equal length to the number of the samples in the SingleCellExperiment
#'  object, or can be retrieved from the colData slot. Default NULL.
#' @param violin Boolean. If TRUE, will plot the violin plot. Default TRUE.
#' @param boxplot Boolean. If TRUE, will plot boxplots for each violin plot.
#'  Default TRUE.
#' @param dots Boolean. If TRUE, will plot dots for each violin plot.
#'  Default TRUE.
#' @param plotOrder Character vector. If set, reorders the violin plots
#'  in the order of the character vector when `groupBy` is set.
#'  Default NULL.
#' @param xlab Character vector. Label for x-axis. Default NULL.
#' @param ylab Character vector. Label for y-axis. Default NULL.
#' @param axisSize Size of x/y-axis ticks. Default 10.
#' @param axisLabelSize Size of x/y-axis labels. Default 10.
#' @param dotSize Size of dots. Default 0.1.
#' @param transparency Transparency of the dots, values will be 0-1. Default 1.
#' @param defaultTheme Removes grid in plot and sets axis title size to 10
#'  when TRUE. Default TRUE.
#' @param gridLine Adds a horizontal grid line if TRUE. Will still be
#'  drawn even if defaultTheme is TRUE. Default FALSE.
#' @param summary Adds a summary statistic, as well as a crossbar to the
#'  violin plot. Options are "mean" or "median". Default NULL.
#' @param title Title of plot. Default NULL.
#' @param titleSize Size of title of plot. Default 15.
#' @param hcutoff Adds a horizontal line with the y-intercept at given value. Default NULL.
#' @param hcolor Character. A color available from `colors()`.
#'  Controls the color of the horizontal cutoff line, if drawn.
#'  Default 'black'.
#' @param hsize Size of horizontal line, if drawn. Default 0.5.
#' @param hlinetype Type of horizontal line, if drawn. can be specified with either an integer or
#'  a name (0 = blank, 1 = solid, 2 = dashed, 3 = dotted, 4 = dotdash, 5 = longdash, 6 = twodash).
#'  Default 1.
#' @param vcutoff Adds a vertical line with the x-intercept at given value. Default NULL.
#' @param vcolor Character. A color available from `colors()`.
#'  Controls the color of the vertical cutoff line, if drawn.
#'  Default 'black'.
#' @param vsize Size of vertical line, if drawn. Default 0.5.
#' @param vlinetype Type of vertical line, if drawn. can be specified with either an integer or
#'  a name (0 = blank, 1 = solid, 2 = dashed, 3 = dotted, 4 = dotdash, 5 = longdash, 6 = twodash).
#'  Default 1.
#' @param combinePlot Must be either "all", "sample", or "none". "all" will combine all plots into a single
#' .ggplot object, while "sample" will output a list of plots separated by sample. Default "none".
#' @param plotLabels labels to each plot. If set to "default", will use the name of the samples
#'  as the labels. If set to "none", no label will be plotted.
#' @return a ggplot of the violin plot of assay data.
#' @examples
#' data("mouseBrainSubsetSCE")
#' plotSCEViolinAssayData(
#'   inSCE = mouseBrainSubsetSCE,
#'   feature = "Apoe", groupBy = "sex"
#' )
#' @export
plotSCEViolinAssayData <- function(inSCE,
                                   feature,
                                   sample = NULL,
                                   useAssay = "counts",
                                   featureLocation = NULL,
                                   featureDisplay = NULL,
                                   groupBy = NULL,
                                   violin = TRUE,
                                   boxplot = TRUE,
                                   dots = TRUE,
                                   plotOrder = NULL,
                                   xlab = NULL,
                                   ylab = NULL,
                                   axisSize = 10,
                                   axisLabelSize = 10,
                                   dotSize = 0.1,
                                   transparency = 1,
                                   defaultTheme = TRUE,
                                   gridLine = FALSE,
                                   summary = NULL,
                                   title = NULL,
                                   titleSize = NULL,
                                   hcutoff = NULL,
                                   hcolor = "red",
                                   hsize = 1,
                                   hlinetype = 1,
                                   vcutoff = NULL,
                                   vcolor = "red",
                                   vsize = 1,
                                   vlinetype = 1,
                                   combinePlot = "none",
                                   plotLabels = NULL) {
  combinePlot <- match.arg(combinePlot,c("all", "sample", "none"))

  if(!is.null(featureDisplay)){
    featureDisplay <- match.arg(featureDisplay,
                                colnames(SummarizedExperiment::rowData(inSCE)))
  }else{
    if(exists(x = "featureDisplay", inSCE@metadata)){
      featureDisplay <- inSCE@metadata$featureDisplay
    }
  }

  mat <- getBiomarker(
    inSCE = inSCE,
    useAssay = useAssay,
    featureLocation = featureLocation,
    featureDisplay = featureDisplay,
    gene = feature,
    binary = "Continuous"
  )

  counts <- mat[, 2]
  if (!is.null(groupBy)) {
    if (length(groupBy) > 1) {
      if (length(groupBy) != length(counts)) {
        stop("The input vector for 'groupBy' needs to be the same
                     length as the number of samples in your
                     SingleCellExperiment object.")
      }
    } else {
      if (!groupBy %in% names(SummarizedExperiment::colData(inSCE))) {
        p <- paste(groupBy)
        stop("'", p , "' is not found in ColData.")
      }
      groupBy <- as.character(SummarizedExperiment::colData(inSCE)[, groupBy])
    }
  }
  if(!is.null(featureDisplay) && is.null(title)){
    title = utils::tail(colnames(mat),1)
  }
  if(is.null(xlab)){
    ylab = "Expression"
  }
  if (!is.null(sample)) {
    if (length(sample) != ncol(inSCE)) {
      stop("'sample' must be the same length as the number",
           " of columns in 'inSCE'")
    }
  } else {
    sample <- rep(1, ncol(inSCE))
  }

  samples <- unique(sample)

  plotlist <- lapply(samples, function(x) {
    sampleInd <- which(sample == x)
    countSub <- counts[sampleInd]
    if(!is.null(groupBy)){
      groupbySub <- groupBy[sampleInd]
    }else{
      groupbySub <- NULL
    }

    p <- .ggViolin(
      y = countSub,
      groupBy = groupbySub,
      violin = violin,
      boxplot = boxplot,
      dots = dots,
      plotOrder = plotOrder,
      xlab = xlab,
      ylab = ylab,
      axisSize = axisSize,
      axisLabelSize = axisLabelSize,
      dotSize = dotSize,
      transparency = transparency,
      defaultTheme = defaultTheme,
      gridLine = gridLine,
      summary = summary,
      combinePlot = combinePlot,
      title = title,
      titleSize = titleSize
    )
    if(!is.null(hcutoff)){
      p <- .ggAddLine(p, hcutoff = hcutoff, hcolor = hcolor,
                      hsize = hsize, hlinetype = hlinetype)
    }
    if(!is.null(vcutoff)){
      p <- .ggAddLine(p, vcutoff = vcutoff, vcolor = vcolor,
                      vsize = vsize, vlinetype = vlinetype)
    }
    return(p)
  })

  if (length(unique(samples)) > 1) {
    names(plotlist) <- samples
    if(combinePlot == "sample"){
      plotlist <- c(list(Sample = plotlist))
    }
  } else {
    plotlist <- plotlist[[1]]
  }
  ##Needs to be turned off for Shiny User Interface
  if(combinePlot %in% c("all", "sample")){
    figNcol = NULL
    if(!is.null(groupBy)){
      if(length(unique(groupBy)) > 1){
        figNcol = 1
      }
    }
    plotlist <- .ggSCTKCombinePlots(plotlist,
                                    combinePlot = combinePlot,
                                    ncols = figNcol,
                                    labels = plotLabels)
  }else if(combinePlot == "none" && length(plotlist) == 1 && methods::is(plotlist, "list")){
      # Prior to R4.5 and ggplot3
      # Started failing after 9/25 when bioc was using R4.5 and ggplot3 as this
      # was not a list any longer. Added the "is" check for list to the if statement.  
      plotlist <- plotlist[[1]]
      plotlist <- plotlist[[1]]
  }

  return(plotlist)
}

#' @title Violin plot of any data stored in the SingleCellExperiment object.
#' @description Visualizes values stored in any slot of a
#'  SingleCellExperiment object via a violin plot.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object with saved
#' dimension reduction components or a variable with saved results. Required.
#' @param slotName Desired slot of SingleCellExperiment used for plotting. Possible
#'  options: "assays", "colData", "metadata", "reducedDims". Required.
#' @param itemName Desired vector within the slot used for plotting. Required.
#' @param feature Desired name of feature stored in assay of SingleCellExperiment
#'  object. Only used when "assays" slotName is selected. Default NULL.
#' @param sample Character vector. Indicates which sample each cell belongs to.
#' @param dimension Desired dimension(s) stored in the specified reducedDims.
#'  Either an integer which indicates the column(s) or a character vector specifies
#'  column name(s). By default, the 1st dimension/column will be used.
#'  Only used when "reducedDims" slotName is selected. Default NULL.
#' @param groupBy Groupings for each numeric value. A user may input a vector
#' equal length to the number of the samples in the SingleCellExperiment
#' object, or can be retrieved from the colData slot. Default NULL.
#' @param violin Boolean. If TRUE, will plot the violin plot. Default TRUE.
#' @param boxplot Boolean. If TRUE, will plot boxplots for each violin plot.
#'  Default TRUE.
#' @param dots Boolean. If TRUE, will plot dots for each violin plot.
#'  Default TRUE.
#' @param plotOrder Character vector. If set, reorders the violin plots
#'  in the order of the character vector when `groupBy` is set.
#'  Default NULL.
#' @param xlab Character vector. Label for x-axis. Default NULL.
#' @param ylab Character vector. Label for y-axis. Default NULL.
#' @param axisSize Size of x/y-axis ticks. Default 10.
#' @param axisLabelSize Size of x/y-axis labels. Default 10.
#' @param dotSize Size of dots. Default 0.1.
#' @param transparency Transparency of the dots, values will be 0-1. Default 1.
#' @param defaultTheme Removes grid in plot and sets axis title size to 10
#'  when TRUE. Default TRUE.
#' @param gridLine Adds a horizontal grid line if TRUE. Will still be
#'  drawn even if defaultTheme is TRUE. Default FALSE.
#' @param summary Adds a summary statistic, as well as a crossbar to the
#'  violin plot. Options are "mean" or "median". Default NULL.
#' @param title Title of plot. Default NULL.
#' @param titleSize Size of title of plot. Default 15.
#' @param hcutoff Adds a horizontal line with the y-intercept at given value. Default NULL.
#' @param hcolor Character. A color available from `colors()`.
#'  Controls the color of the horizontal cutoff line, if drawn.
#'  Default 'black'.
#' @param hsize Size of horizontal line, if drawn. Default 0.5.
#' @param hlinetype Type of horizontal line, if drawn. can be specified with either an integer or
#'  a name (0 = blank, 1 = solid, 2 = dashed, 3 = dotted, 4 = dotdash, 5 = longdash, 6 = twodash).
#'  Default 1.
#' @param vcutoff Adds a vertical line with the x-intercept at given value. Default NULL.
#' @param vcolor Character. A color available from `colors()`.
#'  Controls the color of the vertical cutoff line, if drawn.
#'  Default 'black'.
#' @param vsize Size of vertical line, if drawn. Default 0.5.
#' @param vlinetype Type of vertical line, if drawn. can be specified with either an integer or
#'  a name (0 = blank, 1 = solid, 2 = dashed, 3 = dotted, 4 = dotdash, 5 = longdash, 6 = twodash).
#'  Default 1.
#' @param combinePlot Must be either "all", "sample", or "none". "all" will combine all plots into a single
#' .ggplot object, while "sample" will output a list of plots separated by sample. Default "none".
#' @param plotLabels labels to each plot. If set to "default", will use the name of the samples
#'  as the labels. If set to "none", no label will be plotted.
#' @return a ggplot of the violin plot.
#' @examples
#' data("mouseBrainSubsetSCE")
#' plotSCEViolin(
#'   inSCE = mouseBrainSubsetSCE, slotName = "assays",
#'   itemName = "counts", feature = "Apoe", groupBy = "sex"
#' )
#' @export
plotSCEViolin <- function(inSCE,
                          slotName,
                          itemName,
                          feature = NULL,
                          sample = NULL,
                          dimension = NULL,
                          groupBy = NULL,
                          violin = TRUE,
                          boxplot = TRUE,
                          dots = TRUE,
                          plotOrder = NULL,
                          xlab = NULL,
                          ylab = NULL,
                          axisSize = 10,
                          axisLabelSize = 10,
                          dotSize = 0.1,
                          transparency = 1,
                          defaultTheme = TRUE,
                          gridLine = FALSE,
                          summary = NULL,
                          title = NULL,
                          titleSize = NULL,
                          hcutoff = NULL,
                          hcolor = "red",
                          hsize = 1,
                          hlinetype = 1,
                          vcutoff = NULL,
                          vcolor = "red",
                          vsize = 1,
                          vlinetype = 1,
                          combinePlot = "none",
                          plotLabels = NULL) {
  combinePlot <- match.arg(combinePlot,c("all", "sample", "none"))

  if (!slotName %in% c("rowData", "colData", "assays", "metadata", "reducedDims")) {
    stop("'slotName' must be a slotName within the SingleCellExperiment object.",
         "Please run 'methods::slot' if you are unsure the",
         "specified slotName exists.")
  }

  sceSubset <- do.call(slotName, args = list(inSCE))

  if (!itemName %in% names(sceSubset)) {
    stop("'itemName' must be an itemName stored within the specified
             slotName of the SingleCellExperiment object.")
  }

  itemName.ix <- match(itemName, names(sceSubset))

  if (slotName == "assays" && !is.null(feature)) {
    counts <- sceSubset[[itemName.ix]]
    if (feature %in% rownames(counts)) {
      counts <- counts[feature, ]
    }
  } else if (slotName == "colData") {
    counts <- sceSubset[, itemName.ix]
  } else if (slotName == "metadata") {
    counts <- sceSubset[[itemName.ix]]
  } else if (slotName == "reducedDims") {
    if(is.null(dimension)){
      dimension <- 1
    }else if(is.character(dimension)){
      dimension <- match(dimension, colnames(sceSubset[[itemName.ix]]))
    }
    counts <- sceSubset[[itemName.ix]][,dimension]
  }

  if (!is.null(groupBy)) {
    if (length(groupBy) > 1) {
      if (length(groupBy) != length(counts)) {
        stop("The input vector for 'groupBy' needs to be the same
                     length as the number of samples in your
                     SingleCellExperiment object.")
      }
    } else {
      if (!groupBy %in% names(SummarizedExperiment::colData(inSCE))) {
        p <- paste(groupBy)
        stop("'", p , "' is not found in ColData.")
      }
      groupBy <- SummarizedExperiment::colData(inSCE)[, groupBy]
    }
  }

  if (!is.null(sample)) {
    if (length(sample) != ncol(inSCE)) {
      stop("'sample' must be the same length as the number",
           " of columns in 'inSCE'")
    }
  } else {
    sample <- rep(1, ncol(inSCE))
  }
  samples <- unique(sample)
  plotlist <- lapply(samples, function(x) {
    sampleInd <- which(sample == x)
    if (length(colnames(counts)) > 1){
      countSub <- counts[sampleInd,]
    }else{
      countSub <- counts[sampleInd]
    }
    if(!is.null(groupBy)){
      groupbySub <- groupBy[sampleInd]
    }else{
      groupbySub <- NULL
    }
    p <- .ggViolin(
      y = countSub,
      groupBy = groupbySub,
      violin = violin,
      boxplot = boxplot,
      dots = dots,
      plotOrder = plotOrder,
      xlab = xlab,
      ylab = ylab,
      axisSize = axisSize,
      axisLabelSize = axisLabelSize,
      dotSize = dotSize,
      transparency = transparency,
      defaultTheme = defaultTheme,
      gridLine = gridLine,
      summary = summary,
      combinePlot = combinePlot,
      title = title,
      titleSize = titleSize
    )
    if(!is.null(hcutoff)){
      p <- .ggAddLine(p, hcutoff = hcutoff, hcolor = hcolor,
                      hsize = hsize, hlinetype = hlinetype)
    }
    if(!is.null(vcutoff)){
      p <- .ggAddLine(p, vcutoff = vcutoff, vcolor = vcolor,
                      vsize = vsize, vlinetype = vlinetype)
    }
    return(p)
  })

  if (length(unique(samples)) > 1) {
    names(plotlist) <- samples
    if(!is.null(combinePlot)){
      if(combinePlot == "sample"){
        plotlist <- c(list(Sample = plotlist))
      }
    }
  } else {
    plotlist <- plotlist[[1]]
    # plotlist <- unlist(plotlist, recursive=F)
  }

  ##Needs to be turned off for Shiny User Interface
  if(combinePlot %in% c("all", "sample") &&
     length(unique(samples)) > 1){
    figNcol = NULL
    if(!is.null(groupBy)){
      if(length(unique(groupBy)) > 1){
        figNcol = 1
      }
    }
    plotlist <- .ggSCTKCombinePlots(plotlist,
                                    combinePlot = combinePlot,
                                    ncols = figNcol,
                                    labels = plotLabels)
  }else if(combinePlot == "none" && length(plotlist) == 1 && methods::is(plotlist, "list")){
      # Prior to R4.5 and ggplot3
      # Started failing after 9/25 when bioc was using R4.5 and ggplot3 as this
      # was not a list any longer. Added the "is" check for list to the if statement.  
      plotlist <- plotlist[[1]]
  }
  return(plotlist)
}

#' @title Density plot plotting tool.
#' @description Visualizes values stored in the specified slot of a
#'  SingleCellExperiment object via a density plot.
#' @param value Numeric value that will be plotted via density plot.
#' @param groupBy Groupings for each numeric value. A user may input a vector
#'  equal length to the number of the samples in the SingleCellExperiment
#'  object, or can be retrieved from the colData slot. Default NULL.
#' @param xlab Character vector. Label for x-axis. Default NULL.
#' @param ylab Character vector. Label for y-axis. Default NULL.
#' @param baseSize The base font size for all text. Default 12.
#'  Can be overwritten by titleSize, axisSize, and axisLabelSize.
#' @param axisSize Size of x/y-axis ticks. Default NULL.
#' @param axisLabelSize Size of x/y-axis labels. Default NULL.
#' @param defaultTheme Removes grid in plot and sets axis title size to 10
#'  when TRUE. Default TRUE.
#' @param title Title of plot. Default NULL.
#' @param titleSize Size of title of plot. Default 15.
#' @param cutoff Numeric value. The plot will be annotated with a vertical line
#'  if set. Default NULL.
#' @param combinePlot Must be either "all", "sample", or "none". "all" will combine all plots into a single
#' .ggplot object, while "sample" will output a list of plots separated by sample. Default "none".
#' @return density plot, in .ggplot.
#' @noRd
.ggDensity <- function(value,
                       groupBy = NULL,
                       xlab = NULL,
                       ylab = NULL,
                       baseSize = 12,
                       axisSize = NULL,
                       axisLabelSize = NULL,
                       defaultTheme = TRUE,
                       title = NULL,
                       titleSize = NULL,
                       combinePlot = "none",
                       cutoff = NULL) {
  if (is.null(groupBy)) {
    groupBy <- rep("Sample", length(value))
  }
  groupBy <- factor(groupBy, levels = unique(groupBy))
  df <- data.frame(x = groupBy, y = value)

  p <- ggplot2::ggplot(df, ggplot2::aes_string(x = value)) +
    ggplot2::geom_density() +
    ggplot2::facet_grid(. ~ x)

  if (defaultTheme == TRUE) {
    p <- .ggSCTKTheme(p, baseSize, groupBy, combinePlot) +
      ggplot2::theme(strip.background = ggplot2::element_blank())
  }else{
    p <- p + ggplot2::theme_gray(base_size = baseSize)
  }

  if (all(unique(groupBy) == "Sample")) {
    p <- p + ggplot2::theme(strip.text.x = ggplot2::element_blank())
  }

  if (!is.null(title)) {
    p <- p + ggplot2::ggtitle(label = title) +
      ggplot2::theme(plot.title = ggplot2::element_text(
        hjust = 0.5,
        size = titleSize
      ))
  }

  if (!is.null(xlab)) {
    p <- p + ggplot2::xlab(xlab) +
      ggplot2::theme(axis.title.x = ggplot2::element_text(size = axisLabelSize))
  }

  if (!is.null(ylab)) {
    p <- p + ggplot2::ylab(ylab) +
      ggplot2::theme(axis.title.y = ggplot2::element_text(size = axisLabelSize))
  }
  p <- p + ggplot2::theme(axis.text = ggplot2::element_text(size = axisSize))

  if (!is.null(cutoff)) {
    p <- p + ggplot2::geom_vline(xintercept = cutoff, color = "red")
  }

  return(p)
}

#' @title Density plot of colData.
#' @description Visualizes values stored in the colData slot of a
#'  SingleCellExperiment object via a density plot.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object with saved
#' dimension reduction components or a variable with saved results. Required.
#' @param sample Character vector. Indicates which sample each cell belongs to.
#' @param coldata colData value that will be plotted.
#' @param groupBy Groupings for each numeric value. A user may input a vector
#'  equal length to the number of the samples in the SingleCellExperiment
#'  object, or can be retrieved from the colData slot. Default NULL.
#' @param xlab Character vector. Label for x-axis. Default NULL.
#' @param ylab Character vector. Label for y-axis. Default NULL.
#' @param baseSize The base font size for all text. Default 12.
#'  Can be overwritten by titleSize, axisSize, and axisLabelSize,
#'  legendSize, legendTitleSize.
#' @param axisSize Size of x/y-axis ticks. Default NULL.
#' @param axisLabelSize Size of x/y-axis labels. Default NULL.
#' @param defaultTheme Removes grid in plot and sets axis title size to 10
#'  when TRUE. Default TRUE.
#' @param title Title of plot. Default NULL.
#' @param titleSize Size of title of plot. Default 15.
#' @param cutoff Numeric value. The plot will be annotated with a vertical line
#'  if set. Default NULL.
#' @param combinePlot Must be either "all", "sample", or "none". "all" will combine all plots into a single
#' .ggplot object, while "sample" will output a list of plots separated by sample. Default "none".
#' @param plotLabels labels to each plot. If set to "default", will use the name of the samples
#'  as the labels. If set to "none", no label will be plotted.
#' @return a ggplot of the density plot of colData.
#' @examples
#' data("mouseBrainSubsetSCE")
#' plotSCEDensityColData(
#'   inSCE = mouseBrainSubsetSCE,
#'   coldata = "age", groupBy = "sex"
#' )
#' @export
plotSCEDensityColData <- function(inSCE,
                                  coldata,
                                  sample = NULL,
                                  groupBy = NULL,
                                  xlab = NULL,
                                  ylab = NULL,
                                  baseSize = 12,
                                  axisSize = NULL,
                                  axisLabelSize = NULL,
                                  defaultTheme = TRUE,
                                  title = NULL,
                                  titleSize = 18,
                                  cutoff = NULL,
                                  combinePlot = "none",
                                  plotLabels = NULL) {
  combinePlot <- match.arg(combinePlot,c("all", "sample", "none"))

  if (!is.null(coldata)) {
    if (!coldata %in% names(SummarizedExperiment::colData(inSCE))) {
      p <- paste(coldata)
      stop("'", p , "' is not found in ColData.")
    }
    coldata <- SummarizedExperiment::colData(inSCE)[, coldata]
  } else {
    stop("You must define the desired colData to plot.")
  }

  if (!is.null(groupBy)) {
    if (length(groupBy) > 1) {
      if (length(groupBy) != length(coldata)) {
        stop("The input vector for 'groupBy' needs to be the same
                     length as the number of samples in your
                     SingleCellExperiment object.")
      }
    } else {
      if (!groupBy %in% names(SummarizedExperiment::colData(inSCE))) {
        p <- paste(groupBy)
        stop("'", p , "' is not found in ColData.")
      }
      groupBy <- as.character(SummarizedExperiment::colData(inSCE)[, groupBy])
    }
  }

  if (!is.null(sample)) {
    if (length(sample) != ncol(inSCE)) {
      stop(
        "'sample' must be the same length as the number",
        " of columns in 'inSCE'"
      )
    }
  } else {
    sample <- rep(1, ncol(inSCE))
  }

  samples <- unique(sample)

  plotlist <- lapply(samples, function(x) {
    sampleInd <- which(sample == x)
    coldataSub <- coldata[sampleInd]
    if (!is.null(groupBy)) {
      groupbySub <- groupBy[sampleInd]
    } else {
      groupbySub <- NULL
    }

    if (!is.null(title) && length(samples) > 1) {
      title <- paste(title, x, sep = ", ")
    }
    p <- .ggDensity(
      value = coldataSub,
      groupBy = groupbySub,
      xlab = xlab,
      ylab = ylab,
      baseSize = baseSize,
      axisSize = axisSize,
      axisLabelSize = axisLabelSize,
      defaultTheme = defaultTheme,
      title = title,
      titleSize = titleSize,
      combinePlot = combinePlot,
      cutoff = cutoff
    )
    return(p)
  })
  ##Needs to be turned off for Shiny User Interface
  if(combinePlot %in% c("all", "sample")){
    figNcol = NULL
    if(!is.null(groupBy)){
      if(length(unique(groupBy)) > 1){
        figNcol = 1
      }
    }
    plotlist <- .ggSCTKCombinePlots(plotlist,
                                    combinePlot = combinePlot,
                                    ncols = figNcol,
                                    labels = plotLabels)
  }

  return(plotlist)
}

#' @title Density plot of assay data.
#' @description Visualizes values stored in the assay slot of a
#'  SingleCellExperiment object via a density plot.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object with saved
#' dimension reduction components or a variable with saved results. Required.
#' @param sample Character vector. Indicates which sample each cell belongs to.
#' @param useAssay Indicate which assay to use. Default "counts".
#' @param feature Name of feature stored in assay of SingleCellExperiment
#'  object.
#' @param featureLocation Indicates which column name of rowData to query gene.
#' @param featureDisplay Indicates which column name of rowData to use
#' to display feature for visualization.
#' @param groupBy Groupings for each numeric value. A user may input a vector
#'  equal length to the number of the samples in the SingleCellExperiment
#'  object, or can be retrieved from the colData slot. Default NULL.
#' @param xlab Character vector. Label for x-axis. Default NULL.
#' @param ylab Character vector. Label for y-axis. Default NULL.
#' @param axisSize Size of x/y-axis ticks. Default 10.
#' @param axisLabelSize Size of x/y-axis labels. Default 10.
#' @param defaultTheme Removes grid in plot and sets axis title size to 10
#'  when TRUE. Default TRUE.
#' @param title Title of plot. Default NULL.
#' @param titleSize Size of title of plot. Default 15.
#' @param cutoff Numeric value. The plot will be annotated with a vertical line
#'  if set. Default NULL.
#' @param combinePlot Must be either "all", "sample", or "none". "all" will combine all plots into a single
#' .ggplot object, while "sample" will output a list of plots separated by sample. Default "none".
#' @param plotLabels labels to each plot. If set to "default", will use the name of the samples
#'  as the labels. If set to "none", no label will be plotted.
#' @return a ggplot of the density plot of assay data.
#' @examples
#' data("mouseBrainSubsetSCE")
#' plotSCEDensityAssayData(
#'   inSCE = mouseBrainSubsetSCE,
#'   feature = "Apoe"
#' )
#' @export
plotSCEDensityAssayData <- function(inSCE,
                                    feature,
                                    sample = NULL,
                                    useAssay = "counts",
                                    featureLocation = NULL,
                                    featureDisplay = NULL,
                                    groupBy = NULL,
                                    xlab = NULL,
                                    ylab = NULL,
                                    axisSize = 10,
                                    axisLabelSize = 10,
                                    defaultTheme = TRUE,
                                    cutoff = NULL,
                                    title = NULL,
                                    titleSize = 18,
                                    combinePlot = "none",
                                    plotLabels = NULL) {
  combinePlot <- match.arg(combinePlot,c("all", "sample", "none"))

  if(!is.null(featureDisplay)){
    featureDisplay <- match.arg(featureDisplay,
                                colnames(SummarizedExperiment::rowData(inSCE)))
  }else{
    if(exists(x = "featureDisplay", inSCE@metadata)){
      featureDisplay <- inSCE@metadata$featureDisplay
    }
  }

  mat <- getBiomarker(
    inSCE = inSCE,
    useAssay = useAssay,
    gene = feature,
    binary = "Continuous",
    featureLocation = featureLocation,
    featureDisplay = featureDisplay
  )
  counts <- mat[, 2]

  if(!is.null(featureDisplay)){
    title = utils::tail(colnames(mat),1)
  }
  if(is.null(xlab)){
    xlab = "Expression"
  }

  if (!is.null(groupBy)) {
    if (length(groupBy) > 1) {
      if (length(groupBy) != length(counts)) {
        stop("The input vector for 'groupBy' needs to be the same
                     length as the number of samples in your
                     SingleCellExperiment object.")
      }
    } else {
      if (!groupBy %in% names(SummarizedExperiment::colData(inSCE))) {
        p <- paste(groupBy)
        stop("'", p , "' is not found in ColData.")
      }
      groupBy <- as.character(SummarizedExperiment::colData(inSCE)[, groupBy])
    }
  }

  if (!is.null(sample)) {
    if (length(sample) != ncol(inSCE)) {
      stop(
        "'sample' must be the same length as the number",
        " of columns in 'inSCE'"
      )
    }
  } else {
    sample <- rep(1, ncol(inSCE))
  }

  samples <- unique(sample)

  plotlist <- lapply(samples, function(x) {
    sampleInd <- which(sample == x)
    countsSub <- counts[sampleInd]
    if (!is.null(groupBy)) {
      groupbySub <- groupBy[sampleInd]
    } else {
      groupbySub <- NULL
    }

    if (!is.null(title) && length(samples) > 1) {
      title <- paste(title, x, sep = "_")
    }

    p <- .ggDensity(
      value = countsSub,
      groupBy = groupbySub,
      xlab = xlab,
      ylab = ylab,
      axisSize = axisSize,
      axisLabelSize = axisLabelSize,
      defaultTheme = defaultTheme,
      title = title,
      titleSize = titleSize,
      cutoff = cutoff
    )
    return(p)
  })

  ##Needs to be turned off for Shiny User Interface
  if(combinePlot %in% c("all", "sample")){
    figNcol = NULL
    if(!is.null(groupBy)){
      if(length(unique(groupBy)) > 1){
        figNcol = 1
      }
    }
    plotlist <- .ggSCTKCombinePlots(plotlist,
                                    combinePlot = combinePlot,
                                    ncols = figNcol,
                                    labels = plotLabels)
  }
  return(plotlist)
}

#' @title Density plot of any data stored in the SingleCellExperiment object.
#' @description Visualizes values stored in any slot of a
#'  SingleCellExperiment object via a densityn plot.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object with saved
#' dimension reduction components or a variable with saved results. Required.
#' @param slotName Desired slot of SingleCellExperiment used for plotting. Possible
#'  options: "assays", "colData", "metadata", "reducedDims". Required.
#' @param itemName Desired vector within the slot used for plotting. Required.
#' @param sample Character vector. Indicates which sample each cell belongs to.
#' @param feature Desired name of feature stored in assay of SingleCellExperiment
#'  object. Only used when "assays" slotName is selected. Default NULL.
#' @param dimension Desired dimension stored in the specified reducedDims.
#'  Either an integer which indicates the column or a character vector specifies
#'  column name. By default, the 1st dimension/column will be used.
#'  Only used when "reducedDims" slotName is selected. Default NULL.
#' @param groupBy Groupings for each numeric value. A user may input a vector
#' equal length to the number of the samples in the SingleCellExperiment
#' object, or can be retrieved from the colData slot. Default NULL.
#' @param xlab Character vector. Label for x-axis. Default NULL.
#' @param ylab Character vector. Label for y-axis. Default NULL.
#' @param axisSize Size of x/y-axis ticks. Default 10.
#' @param axisLabelSize Size of x/y-axis labels. Default 10.
#' @param defaultTheme Removes grid in plot and sets axis title size to 10
#'  when TRUE. Default TRUE.
#' @param title Title of plot. Default NULL.
#' @param titleSize Size of title of plot. Default 15.
#' @param cutoff Numeric value. The plot will be annotated with a vertical line
#'  if set. Default NULL.
#' @param combinePlot Must be either "all", "sample", or "none". "all" will combine all plots into a single
#' .ggplot object, while "sample" will output a list of plots separated by sample. Default "none".
#' @param plotLabels labels to each plot. If set to "default", will use the name of the samples
#'  as the labels. If set to "none", no label will be plotted.
#' @return a ggplot object of the density plot.
#' @examples
#' data("mouseBrainSubsetSCE")
#' plotSCEDensity(
#'   inSCE = mouseBrainSubsetSCE, slotName = "assays",
#'   itemName = "counts", feature = "Apoe", groupBy = "sex"
#' )
#' @export
plotSCEDensity <- function(inSCE,
                           slotName,
                           itemName,
                           sample = NULL,
                           feature = NULL,
                           dimension = NULL,
                           groupBy = NULL,
                           xlab = NULL,
                           ylab = NULL,
                           axisSize = 10,
                           axisLabelSize = 10,
                           defaultTheme = TRUE,
                           title = NULL,
                           titleSize = 18,
                           cutoff = NULL,
                           combinePlot = "none",
                           plotLabels = NULL) {
  combinePlot <- match.arg(combinePlot,c("all", "sample", "none"))

  if (!slotName %in% c("rowData", "colData", "assays", "metadata", "reducedDims")) {
    stop("'slotName' must be a slotName within the SingleCellExperiment object.",
         "Please run 'methods::slotNames' if you are unsure the",
         "specified slot exists.")
  }

  sceSubset <- do.call(slotName, args = list(inSCE))

  if (!itemName %in% names(sceSubset)) {
    stop("'itemName' must be an itemName stored within the specified
             slot of the SingleCellExperiment object.")
  }

  itemName.ix <- match(itemName, names(sceSubset))

  if (slotName == "assays" && !is.null(feature)) {
    counts <- sceSubset[[itemName.ix]]
    if (feature %in% rownames(counts)) {
      counts <- counts[feature, ]
    }
  } else if (slotName == "colData") {
    counts <- sceSubset[, itemName.ix]
  } else if (slotName == "metadata") {
    counts <- sceSubset[[itemName.ix]]
  } else if (slotName == "reducedDims") {
    if(is.null(dimension)){
      dimension <- 1
    }else if(is.character(dimension)){
      dimension <- match(dimension, colnames(sceSubset[[itemName.ix]]))
    }
    counts <- sceSubset[[itemName.ix]][,dimension]
  }

  if (!is.null(groupBy)) {
    if (length(groupBy) > 1) {
      if (length(groupBy) != length(counts)) {
        stop("The input vector for 'groupBy' needs to be the same
                     length as the number of samples in your
                     SingleCellExperiment object.")
      }
    } else {
      if (!groupBy %in% names(SummarizedExperiment::colData(inSCE))) {
        p <- paste(groupBy)
        stop("'", p , "' is not found in ColData.")
      }
      groupBy <- as.character(SummarizedExperiment::colData(inSCE)[, groupBy])
    }
  }

  if (!is.null(sample)) {
    if (length(sample) != ncol(inSCE)) {
      stop(
        "'sample' must be the same length as the number",
        " of columns in 'inSCE'"
      )
    }
  } else {
    sample <- rep(1, ncol(inSCE))
  }

  samples <- unique(sample)

  plotlist <- lapply(samples, function(x) {
    sampleInd <- which(sample == x)
    countsSub <- counts[sampleInd]
    if (!is.null(groupBy)) {
      groupbySub <- groupBy[sampleInd]
    } else {
      groupbySub <- NULL
    }

    if (!is.null(title) && length(samples) > 1) {
      title <- paste(title, x, sep = "_")
    }

    p <- .ggDensity(
      value = countsSub,
      groupBy = groupbySub,
      xlab = xlab,
      ylab = ylab,
      axisSize = axisSize,
      axisLabelSize = axisLabelSize,
      defaultTheme = defaultTheme,
      title = title,
      titleSize = titleSize
    )
    return(p)
  })
  if(!is.null(feature)){
    names(plotlist) <- feature
  }

  ##Needs to be turned off for Shiny User Interface
  if(combinePlot %in% c("all", "sample")){
    figNcol = NULL
    if(!is.null(groupBy)){
      if(length(unique(groupBy)) > 1){
        figNcol = 1
      }
    }
    plotlist <- .ggSCTKCombinePlots(plotlist,
                                    combinePlot = combinePlot,
                                    ncols = figNcol,
                                    labels = plotLabels)
  }else if(combinePlot == "none" && length(plotlist) == 1 && methods::is(plotlist, "list")){
      # Prior to R4.5 and ggplot3
      # Started failing after 9/25 when bioc was using R4.5 and ggplot3 as this
      # was not a list any longer. Added the "is" check for list to the if statement.  
      plotlist <- plotlist[[1]]
  }

  return(plotlist)
}

#' @title Plots for runEmptyDrops outputs.
#' @description A plotting function which visualizes outputs from the
#' \code{\link{runEmptyDrops}} function stored in the colData slot of the
#' \linkS4class{SingleCellExperiment} object via scatter plots.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object with saved
#' dimension reduction components or a variable with saved results from
#' \code{\link{runEmptyDrops}}. Required.
#' @param sample Character vector or colData variable name. Indicates which
#' sample each cell belongs to. Default \code{NULL}.
#' @param fdrCutoff Numeric. Thresholds barcodes based on the FDR values from
#' \code{\link{runEmptyDrops}} as "Empty Droplet" or "Putative Cell". Default
#' \code{0.01}.
#' @param defaultTheme Removes grid in plot and sets axis title size to
#' \code{10} when \code{TRUE}. Default \code{TRUE}.
#' @param dotSize Size of dots. Default \code{0.1}.
#' @param title Title of plot. Default \code{NULL}.
#' @param titleSize Size of title of plot. Default \code{18}.
#' @param xlab Character vector. Label for x-axis. Default \code{NULL}.
#' @param ylab Character vector. Label for y-axis. Default \code{NULL}.
#' @param axisSize Size of x/y-axis ticks. Default \code{12}.
#' @param axisLabelSize Size of x/y-axis labels. Default \code{15}.
#' @param legendTitle Title of legend. Default \code{NULL}.
#' @param legendTitleSize size of legend title. Default \code{12}.
#' @param legendSize size of legend. Default \code{10}.
#' @param combinePlot Must be either \code{"all"}, \code{"sample"}, or
#' \code{"none"}. \code{"all"} will combine all plots into a single .ggplot
#' object, while \code{"sample"} will output a list of plots separated by
#' sample. Default \code{"all"}.
#' @param relHeights Relative heights of plots when combine is set. Default
#' \code{1}.
#' @param relWidths Relative widths of plots when combine is set. Default
#' \code{1}.
#' @param samplePerColumn If \code{TRUE}, when there are multiple samples and
#' combining by \code{"all"}, the output .ggplot will have plots from each
#' sample on a single column. Default \code{TRUE}.
#' @param sampleRelHeights If there are multiple samples and combining by
#' \code{"all"}, the relative heights for each plot. Default \code{1}.
#' @param sampleRelWidths If there are multiple samples and combining by
#' \code{"all"}, the relative widths for each plot. Default \code{1}.
#' @return a ggplot object of the scatter plot.
#' @seealso \code{\link{runEmptyDrops}}, \code{\link{plotEmptyDropsResults}}
#' @examples
#' data(scExample, package = "singleCellTK")
#' sce <- runEmptyDrops(inSCE = sce)
#' plotEmptyDropsScatter(inSCE = sce)
#' @export
plotEmptyDropsScatter <- function(inSCE,
                                  sample = NULL,
                                  fdrCutoff = 0.01,
                                  defaultTheme = TRUE,
                                  dotSize = 0.1,
                                  title = NULL,
                                  titleSize = 18,
                                  xlab = NULL,
                                  ylab = NULL,
                                  axisSize = 12,
                                  axisLabelSize = 15,
                                  legendTitle = NULL,
                                  legendTitleSize = 12,
                                  legendSize = 10,
                                  combinePlot = "none",
                                  relHeights = 1,
                                  relWidths = 1,
                                  samplePerColumn = TRUE,
                                  sampleRelHeights = 1,
                                  sampleRelWidths = 1
){
  sample <- .manageCellVar(inSCE, var = sample)
  if (is.null(sample)) {
    sample = rep(1, ncol(inSCE))
  }

  samples <- unique(sample)

  plotlist <- lapply(samples, function(x) {
    sceSampleInd <- which(sample == x)
    inSCESub <- inSCE[, sceSampleInd]
    inSCESub = inSCESub[,!is.na(inSCESub$dropletUtils_emptyDrops_fdr)]
    isCell <- unlist(lapply(inSCESub$dropletUtils_emptyDrops_fdr, function(x){
      if (!is.na(x)) {
        if (x <= fdrCutoff) {
          return("Putative Cell")
        } else {
          return("Empty Droplet")
        }
      }

    }))

    df <- data.frame(x = inSCESub$dropletUtils_emptyDrops_total,
                     y = -(inSCESub$dropletUtils_emptyDrops_logprob),
                     isCell = isCell)

    p <- ggplot2::ggplot(df, ggplot2::aes_string("x", "y", color = "isCell")) +
      ggplot2::geom_point(size = dotSize) +
      ggplot2::guides(colour = ggplot2::guide_legend(override.aes = list(size = 2))) +
      ggplot2::scale_color_manual(values = c("gray", "red"))

    if (defaultTheme == TRUE) {
      p <- .ggSCTKTheme(p)
    }

    if (!is.null(title)) {
      if (length(samples) > 1) {
        title = paste(title, x, sep = "_")
      }
      p <- p + ggplot2::ggtitle(label = title) +
        ggplot2::theme(plot.title = ggplot2::element_text(
          hjust = 0.5,
          size = titleSize
        ))
    }
    if (!is.null(xlab)) {
      p <- p + ggplot2::xlab(xlab) +
        ggplot2::theme(axis.title.x = ggplot2::element_text(size = axisLabelSize),
                       axis.text.x = ggplot2::element_text(size = axisSize))
    }
    if (!is.null(ylab)) {
      p <- p + ggplot2::ylab(ylab) +
        ggplot2::theme(axis.title.y = ggplot2::element_text(size = axisLabelSize),
                       axis.text.y = ggplot2::element_text(size = axisSize))
    }
    if (!is.null(legendTitle)) {
      p <- p + ggplot2::labs(color = legendTitle) +
        ggplot2::theme(legend.title = ggplot2::element_text(size = legendTitleSize),
                       legend.text = ggplot2::element_text(size = legendSize))
    } else {
      p <- p + ggplot2::labs(color = "") +
        ggplot2::theme(legend.text = ggplot2::element_text(size = legendSize))
    }
    return(p)
  })

  if (length(unique(samples)) > 1) {
    names(plotlist) <- samples
    plotlist <- list(Sample = plotlist)
  } else {
    plotlist <- plotlist[[1]]
  }

  ##Needs to be turned off for Shiny User Interface
  if (!combinePlot == "none") {
    if (combinePlot == "all" && length(unique(samples)) > 1) {
      return(cowplot::plot_grid(plotlist = unlist(plotlist,
                                                  recursive = FALSE),
                                align = "h",
                                vjust = 0,
                                rel_heights = sampleRelHeights,
                                rel_widths = sampleRelWidths))

    } else {
      return(plotlist)
    }
  }
  return(plotlist)
}


#' @title Plots for runBarcodeRankDrops outputs.
#' @description A plotting function which visualizes outputs from the
#'  runBarcodeRankDrops function stored in the colData slot of the SingleCellExperiment
#'  object via scatterplot.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object with saved
#' dimension reduction components or a variable with saved results from
#' \code{\link{runBarcodeRankDrops}}. Required.
#' @param sample Character vector or colData variable name. Indicates which
#' sample each cell belongs to. Default \code{NULL}.
#' @param defaultTheme Removes grid in plot and sets axis title size to
#' \code{10} when \code{TRUE}. Default \code{TRUE}.
#' @param dotSize Size of dots. Default \code{0.1}.
#' @param title Title of plot. Default \code{NULL}.
#' @param titleSize Size of title of plot. Default \code{18}.
#' @param xlab Character vector. Label for x-axis. Default \code{NULL}.
#' @param ylab Character vector. Label for y-axis. Default \code{NULL}.
#' @param axisSize Size of x/y-axis ticks. Default \code{12}.
#' @param axisLabelSize Size of x/y-axis labels. Default \code{15}.
#' @param legendSize size of legend. Default \code{10}.
#' @param combinePlot Must be either \code{"all"}, \code{"sample"}, or
#' \code{"none"}. \code{"all"} will combine all plots into a single .ggplot
#' object, while \code{"sample"} will output a list of plots separated by
#' sample. Default \code{"all"}.
#' @param sampleRelHeights If there are multiple samples and combining by
#' \code{"all"}, the relative heights for each plot. Default \code{1}.
#' @param sampleRelWidths If there are multiple samples and combining by
#' \code{"all"}, the relative widths for each plot. Default \code{1}.
#' @seealso \code{\link{plotBarcodeRankDropsResults}},
#' \code{\link{runBarcodeRankDrops}}
#' @return a ggplot object of the scatter plot.
#' @examples
#' data(scExample, package = "singleCellTK")
#' sce <- runBarcodeRankDrops(inSCE = sce)
#' plotBarcodeRankScatter(inSCE = sce)
#' @export
plotBarcodeRankScatter <- function(inSCE,
                                   sample = NULL,
                                   defaultTheme = TRUE,
                                   dotSize = 0.1,
                                   title = NULL,
                                   titleSize = 18,
                                   xlab = NULL,
                                   ylab = NULL,
                                   axisSize = 12,
                                   axisLabelSize = 15,
                                   legendSize = 10,
                                   combinePlot = "none",
                                   sampleRelHeights = 1,
                                   sampleRelWidths = 1){
  sample <- .manageCellVar(inSCE, var = sample)
  if (is.null(sample)) {
    sample = rep("all_cells", ncol(inSCE))
  }

  samples <- unique(sample)
  meta <- S4Vectors::metadata(inSCE)$sctk$runBarcodeRankDrops
  plotlist <- lapply(samples, function(x){

    sampleMeta <- meta[[x]]$metaOutput
    knee <- sampleMeta$dropletUtils_barcodeRank_knee
    inflection <- sampleMeta$dropletUtils_barcodeRank_inflection
    df <- data.frame(rank = sampleMeta$dropletUtils_barcodeRank_rank,
                     umi = sampleMeta$dropletUtils_barcodeRank_total)


    p <- ggplot2::ggplot(df, ggplot2::aes_string(x = "rank", y = "umi")) +
      ggplot2::geom_point(size = dotSize, shape = 20) +
      ggplot2::scale_x_log10() +
      ggplot2::scale_y_log10()

    p <- p +
      ggplot2::geom_hline(ggplot2::aes(yintercept = knee, linetype = "Knee"),
                          colour = 'red') +
      ggplot2::geom_hline(ggplot2::aes(yintercept = inflection,
                                       linetype = "Inflection"),
                          colour = 'blue') +
      ggplot2::scale_linetype_manual(
        name = "", values = c(2, 2),
        guide = ggplot2::guide_legend(label.theme = ggplot2::element_text(size = legendSize),
                                      override.aes = list(color = c("blue", "red"))))

    if (isTRUE(defaultTheme)) {
      p <- .ggSCTKTheme(p)
    }
    if (!is.null(title)) {
      p <- p + ggplot2::ggtitle(label = title) +
        ggplot2::theme(plot.title = ggplot2::element_text(
          hjust = 0.5,
          size = titleSize
        ))
    }
    if (!is.null(xlab)) {
      p <- p + ggplot2::xlab(xlab) +
        ggplot2::theme(axis.title.x = ggplot2::element_text(size = axisLabelSize),
                       axis.text.x = ggplot2::element_text(size = axisSize))
    }else{
      p <- p + ggplot2::xlab("Rank") +
        ggplot2::theme(axis.title.x = ggplot2::element_text(size = axisLabelSize),
                       axis.text.x = ggplot2::element_text(size = axisSize))
    }

    if (!is.null(ylab)) {
      p <- p + ggplot2::ylab(ylab) +
        ggplot2::theme(axis.title.y = ggplot2::element_text(size = axisLabelSize),
                       axis.text.y = ggplot2::element_text(size = axisSize))
    }else{
      p <- p + ggplot2::ylab("Total UMI Counts") +
        ggplot2::theme(axis.title.y = ggplot2::element_text(size = axisLabelSize),
                       axis.text.y = ggplot2::element_text(size = axisSize))
    }
    return(p)
  })
  if (length(unique(samples)) > 1) {
    names(plotlist) <- samples
    plotlist <- list(Sample = plotlist)
  } else {
    plotlist <- plotlist[[1]]
  }

  ##Needs to be turned off for Shiny User Interface
  if (!combinePlot == "none") {
    if (combinePlot %in% c("all") && length(unique(sample)) > 1) {
      return(cowplot::plot_grid(plotlist = unlist(plotlist,
                                                  recursive = FALSE),
                                align = "h",
                                vjust = 0,
                                rel_heights = sampleRelHeights,
                                rel_widths = sampleRelWidths))
    } else if (combinePlot == "sample") {
      return(plotlist)
    }
  }
  return(plotlist)
}

#' @title Bar plot plotting tool.
#' @description Visualizes specified values via a violin plot.
#' @param y Numeric values to be plotted on y-axis.
#' @param groupBy Groupings for each numeric value. A user may input a vector
#' equal length to the number of the samples in the SingleCellExperiment
#' object, or can be retrieved from the colData slot. Default NULL.
#' @param xlab Character vector. Label for x-axis. Default NULL.
#' @param ylab Character vector. Label for y-axis. Default NULL.
#' @param axisSize Size of x/y-axis ticks. Default 10.
#' @param axisLabelSize Size of x/y-axis labels. Default 10.
#' @param dotSize Size of dots. Default 0.1.
#' @param transparency Transparency of the dots, values will be 0-1. Default 1.
#' @param defaultTheme Removes grid in plot and sets axis title size to 10
#'  when TRUE. Default TRUE.
#' @param gridLine Adds a horizontal grid line if TRUE. Will still be
#'  drawn even if defaultTheme is TRUE. Default FALSE.
#' @param summary Adds a summary statistic, as well as a crossbar to the
#'  violin plot. Options are "mean" or "median". Default NULL.
#' @param title Title of plot. Default NULL.
#' @param titleSize Size of title of plot. Default 15.
#' @return a ggplot of the reduced dimensions.
#' @importFrom dplyr group_by
#' @importFrom dplyr summarize
#' @importFrom dplyr %>%
#' @noRd
.ggBar <- function(y,
                   groupBy = NULL,
                   xlab = NULL,
                   ylab = NULL,
                   axisSize = 10,
                   axisLabelSize = 10,
                   dotSize = 0.1,
                   transparency = 1,
                   defaultTheme = TRUE,
                   gridLine = FALSE,
                   summary = NULL,
                   title = NULL,
                   titleSize = 15) {
  if (is.null(groupBy)) {
    groupBy <- rep("Sample", length(y))
  }

  df <- data.frame(x = groupBy, y = y)

  p <- ggplot2::ggplot(df) +
    ggplot2::aes_string(
      x = "groupBy",
      y = "y"
    )

  p <- p + ggplot2::geom_bar(stat = "identity")

  if (defaultTheme == TRUE) {
    p <- .ggSCTKTheme(p)
  }
  if (!is.null(title)) {
    p <- p + ggplot2::ggtitle(label = title) +
      ggplot2::theme(plot.title = ggplot2::element_text(
        hjust = 0.5,
        size = titleSize
      ))
  }

  ###
  p <- p + ggplot2::theme(axis.text.y = ggplot2::element_text(size = axisSize))
  ###

  if(length(unique(df$groupBy)) > 1){
    p <- p + ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 45,
                                                                hjust = 1,
                                                                size = axisSize))
  }else{
    p <- p + ggplot2::theme(axis.text.x = ggplot2::element_blank(),
                            axis.ticks.x = ggplot2::element_blank(),
                            axis.title.x = ggplot2::element_blank())
  }

  if (gridLine == TRUE){
    p <- p + ggplot2::theme(panel.grid.major.y = ggplot2::element_line("grey"))
  }
  if (!is.null(xlab)) {
    p <- p + ggplot2::xlab(xlab) +
      ggplot2::theme(axis.title.x = ggplot2::element_text(size = axisLabelSize))
  }
  if (!is.null(ylab)) {
    p <- p + ggplot2::ylab(ylab) +
      ggplot2::theme(axis.title.y = ggplot2::element_text(size = axisLabelSize))
  }
  if (!is.null(summary)){
    if(summary == "mean"){
      summ <- df %>% dplyr::group_by(groupBy) %>% dplyr::summarize(value = base::mean(y))
      fun <- base::mean
    }else if(summary == "median"){
      summ <- df %>% dplyr::group_by(groupBy) %>% dplyr::summarize(value = stats::median(y))
      fun <- stats::median
    }else{
      stop("`summary`` must be either `mean` or `median`.")
    }
    summ$statY <-  max(df$y) + (max(df$y) - min(df$y)) * 0.1
    summary <- paste(toupper(substr(summary, 1, 1)),
                     substr(summary, 2, nchar(summary)), sep="")
    summ$label <- paste0(summary,": ", round(summ$value, 5))

    p <- p + ggrepel::geom_text_repel(data = summ,
                                      ggplot2::aes_string(x = "groupBy",
                                                          y = "statY",
                                                          label = "label"),
                                      size = 5)
    p <- p + ggplot2::stat_summary(fun = fun, fun.min = fun,
                                   fun.max = fun,
                                   geom = "crossbar",
                                   color = "red",
                                   linetype = "dashed")
  }

  return(p)
}



#' @title Bar plot of colData.
#' @description Visualizes values stored in the colData slot of a
#'  SingleCellExperiment object via a bar plot.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object with saved
#' dimension reduction components or a variable with saved results. Required.
#' @param sample Character vector. Indicates which sample each cell belongs to.
#' @param coldata colData value that will be plotted.
#' @param groupBy Groupings for each numeric value. A user may input a vector
#'  equal length to the number of the samples in the SingleCellExperiment
#'  object, or can be retrieved from the colData slot. Default NULL.
#' @param dots Boolean. If TRUE, will plot dots for each violin plot.
#'  Default TRUE.
#' @param xlab Character vector. Label for x-axis. Default NULL.
#' @param ylab Character vector. Label for y-axis. Default NULL.
#' @param axisSize Size of x/y-axis ticks. Default 10.
#' @param axisLabelSize Size of x/y-axis labels. Default 10.
#' @param dotSize Size of dots. Default 0.1.
#' @param transparency Transparency of the dots, values will be 0-1. Default 1.
#' @param defaultTheme Removes grid in plot and sets axis title size to 10
#'  when TRUE. Default TRUE.
#' @param gridLine Adds a horizontal grid line if TRUE. Will still be
#'  drawn even if defaultTheme is TRUE. Default FALSE.
#' @param summary Adds a summary statistic, as well as a crossbar to the
#'  violin plot. Options are "mean" or "median". Default NULL.
#' @param title Title of plot. Default NULL.
#' @param titleSize Size of title of plot. Default 15.
#' @param combinePlot Boolean. If multiple plots are generated (multiple
#'  samples, etc.), will combined plots using `cowplot::plot_grid`.
#'  Default TRUE.
#' @return a ggplot of the barplot of coldata.
#' @examples
#' data("mouseBrainSubsetSCE")
#' plotSCEBarColData(
#'   inSCE = mouseBrainSubsetSCE,
#'   coldata = "age", groupBy = "sex"
#' )
#' @export
plotSCEBarColData <- function(inSCE,
                              coldata,
                              sample = NULL,
                              groupBy = NULL,
                              dots = TRUE,
                              xlab = NULL,
                              ylab = NULL,
                              axisSize = 10,
                              axisLabelSize = 10,
                              dotSize = 0.1,
                              transparency = 1,
                              defaultTheme = TRUE,
                              gridLine = FALSE,
                              summary = NULL,
                              title = NULL,
                              titleSize = NULL,
                              combinePlot = TRUE) {
  if (!is.null(coldata)) {
    if (!coldata %in% names(SummarizedExperiment::colData(inSCE))) {
      p <- paste(coldata)
      stop("'", p , "' is not found in ColData.")
    }
    coldata <- SummarizedExperiment::colData(inSCE)[, coldata]
  } else {
    stop("You must define the desired colData to plot.")
  }

  if (!is.null(groupBy)) {
    if (length(groupBy) > 1) {
      if (length(groupBy) != length(coldata)) {
        stop("The input vector for 'groupBy' needs to be the same
                     length as the number of samples in your
                     SingleCellExperiment object.")
      }
    } else {
      if (!groupBy %in% names(SummarizedExperiment::colData(inSCE))) {
        p <- paste(groupBy)
        stop("'", p , "' is not found in ColData.")
      }
      groupBy <- as.character(SummarizedExperiment::colData(inSCE)[, groupBy])
    }
  }

  if (!is.null(sample)) {
    if (length(sample) != ncol(inSCE)) {
      stop("'sample' must be the same length as the number",
           " of columns in 'inSCE'")
    }
  } else {
    sample <- rep(1, ncol(inSCE))
  }

  p <- .ggBar(
    y = coldata,
    groupBy = groupBy,
    xlab = xlab,
    ylab = ylab,
    axisSize = axisSize,
    axisLabelSize = axisLabelSize,
    dotSize = dotSize,
    transparency = transparency,
    defaultTheme = defaultTheme,
    title = title,
    titleSize = titleSize
  )

  return(p)
}

#' @title Bar plot of assay data.
#' @description Visualizes values stored in the assay slot of a
#'  SingleCellExperiment object via a bar plot.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object with saved
#' dimension reduction components or a variable with saved results. Required.
#' @param sample Character vector. Indicates which sample each cell belongs to.
#' @param useAssay Indicate which assay to use. Default "counts".
#' @param feature Name of feature stored in assay of SingleCellExperiment
#'  object.
#' @param featureLocation Indicates which column name of rowData to query gene.
#' @param featureDisplay Indicates which column name of rowData to use
#' to display feature for visualization.
#' @param groupBy Groupings for each numeric value. A user may input a vector
#'  equal length to the number of the samples in the SingleCellExperiment
#'  object, or can be retrieved from the colData slot. Default NULL.
#' @param xlab Character vector. Label for x-axis. Default NULL.
#' @param ylab Character vector. Label for y-axis. Default NULL.
#' @param axisSize Size of x/y-axis ticks. Default 10.
#' @param axisLabelSize Size of x/y-axis labels. Default 10.
#' @param dotSize Size of dots. Default 0.1.
#' @param transparency Transparency of the dots, values will be 0-1. Default 1.
#' @param defaultTheme Removes grid in plot and sets axis title size to 10
#'  when TRUE. Default TRUE.
#' @param gridLine Adds a horizontal grid line if TRUE. Will still be
#'  drawn even if defaultTheme is TRUE. Default FALSE.
#' @param summary Adds a summary statistic, as well as a crossbar to the
#'  violin plot. Options are "mean" or "median". Default NULL.
#' @param title Title of plot. Default NULL.
#' @param titleSize Size of title of plot. Default 15.
#' @param combinePlot Boolean. If multiple plots are generated (multiple
#'  samples, etc.), will combined plots using `cowplot::plot_grid`.
#'  Default TRUE.
#' @return a ggplot of the barplot of assay data.
#' @examples
#' data("mouseBrainSubsetSCE")
#' plotSCEBarAssayData(
#'   inSCE = mouseBrainSubsetSCE,
#'   feature = "Apoe", groupBy = "sex"
#' )
#' @export
plotSCEBarAssayData <- function(inSCE,
                                feature,
                                sample = NULL,
                                useAssay = "counts",
                                featureLocation = NULL,
                                featureDisplay = NULL,
                                groupBy = NULL,
                                xlab = NULL,
                                ylab = NULL,
                                axisSize = 10,
                                axisLabelSize = 10,
                                dotSize = 0.1,
                                transparency = 1,
                                defaultTheme = TRUE,
                                gridLine = FALSE,
                                summary = NULL,
                                title = NULL,
                                titleSize = NULL,
                                combinePlot = TRUE) {
  if(!is.null(featureDisplay)){
    featureDisplay <- match.arg(featureDisplay,
                                colnames(SummarizedExperiment::rowData(inSCE)))
  }else{
    if(exists(x = "featureDisplay", inSCE@metadata)){
      featureDisplay <- inSCE@metadata$featureDisplay
    }
  }

  mat <- getBiomarker(
    inSCE = inSCE,
    useAssay = useAssay,
    gene = feature,
    binary = "Continuous",
    featureLocation = featureLocation,
    featureDisplay = featureDisplay
  )
  counts <- mat[, 2]

  if (!is.null(groupBy)) {
    if (length(groupBy) > 1) {
      if (length(groupBy) != length(counts)) {
        stop("The input vector for 'groupBy' needs to be the same
                     length as the number of samples in your
                     SingleCellExperiment object.")
      }
    } else {
      if (!groupBy %in% names(SummarizedExperiment::colData(inSCE))) {
        p <- paste(groupBy)
        stop("'", p , "' is not found in ColData.")
      }
      groupBy <- as.character(SummarizedExperiment::colData(inSCE)[, groupBy])
    }
  }

  p <- .ggBar(
    y = counts,
    groupBy = groupBy,
    xlab = xlab,
    ylab = ylab,
    axisSize = axisSize,
    axisLabelSize = axisLabelSize,
    dotSize = dotSize,
    transparency = transparency,
    defaultTheme = defaultTheme,
    title = title,
    titleSize = titleSize
  )

  return(p)
}

.binSCTK <- function(value, bin, binLabel = NULL) {
  if (!is.null(binLabel)) {
    if (length(bin) == 1) {
      if (bin != length(binLabel)) {
        stop("'binLabel' must be equal to the bin length")
      }
    } else if (length(bin) > 1) {
      if (bin != length(binLabel) + 1) {
        stop("'binLabel' must be equal to the bin length")
      }
    }
  }
  value.bin <- cut(x = value, breaks = bin, labels = binLabel)
  return(value.bin)
}

#' @title Indicates which rowData to use for visualization
#' @description This function is to be used to specify which
#' @param inSCE Input \linkS4class{SingleCellExperiment} object with saved
#' dimension reduction components or a variable with saved results. Required.
#' @param featureDisplayRow Indicates which column name of rowData to be used for plots.
#' @return A SingleCellExperiment object with the specific column name of rowData
#'  to be used for plotting stored in metadata.
#' @examples
#' data(scExample, package="singleCellTK")
#' sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
#' sce <- setSCTKDisplayRow(inSCE = sce, featureDisplayRow = "feature_name")
#' plotSCEViolinAssayData(inSCE = sce, feature = "ENSG00000019582")
#' @export
setSCTKDisplayRow <- function(inSCE,
                              featureDisplayRow) {
  inSCE@metadata$featureDisplay <- featureDisplayRow
  return(inSCE)
}

.ggSCTKCombinePlots <- function(plotlist,
                                ncols = NULL,
                                nrows = NULL,
                                combinePlot = "all",
                                relHeights = 1,
                                relWidths = 1,
                                labels = "default",
                                labelPositionX = NULL,
                                labelPositionY = NULL,
                                labelSize = 20,
                                samplePerColumn = TRUE,
                                sampleRelHeights = 1,
                                sampleRelWidths = 1) {

  if ("Violin" %in% names(plotlist)) {
    plotlistViolin <- plotlist$Violin
  } else {
    plotlistViolin <- NULL
  }

  if ("Sample" %in% names(plotlist)) {
    plotlistSample <- plotlist$Sample
    if (samplePerColumn) {
      ncols <- 1
      nrowSub <- 1
      sampleRelHeights <- 1
    }else{
      nrowSub = NULL
    }
    plotlistSample <- lapply(plotlistSample, function(x) {
      if(all(class(x) %in% c("gg","ggplot"))){
        return(x)
      }else if (inherits(x, "list")){
        return(cowplot::plot_grid(
          plotlist = x,
          align = "h",
          nrow = nrowSub,
          vjust = 0,
          rel_heights = sampleRelHeights,
          rel_widths = sampleRelWidths
        ))
      }
    })
  }else{
    plotlistSample <- NULL
  }

  if(!is.null(plotlistViolin) | !is.null(plotlistSample)){
    plotlist <- c(plotlistViolin, plotlistSample)
  }
  # To make the resulting plot close to a square as possible
  if (is.null(ncols) && is.null(nrows)) {
    ncols <- round(sqrt(length(plotlist)))
  }

  if (combinePlot == "all") {
    plotRes <- cowplot::plot_grid(
      plotlist = plotlist,
      ncol = ncols,
      nrow = nrows,
      rel_heights = relHeights,
      rel_widths = relWidths
    )

    return(plotRes)
  } else if (combinePlot == "sample") {
    #Will happen if "sample" is chosen and multiple samples exist,
    #whcih means there will be a plotlistViolin object
    if (!is.null(plotlistViolin)) {
      return(list(Violin = plotlistViolin, Sample = plotlistSample))
      #Will happen when calling the non-QC plot fxns (ie, plotSCEScatter, plotSCEViolin)
      #for multiple samples, meaning no merging has occurred across plots
    }else if (!is.null(plotlistSample)){
      return(plotlistSample)
      # #Will happen when?
      # }else if(length(plotlist) == 1) {
      #     return(plotlist[[1]])
      #Will happen when sample = NULL, combinePlot = "sample", meaning up to this point
      #the "plotlist" should be a list of individual plots for only one sample
    } else{
      return(cowplot::plot_grid(
        plotlist = plotlist,
        ncol = ncols,
        nrow = nrows,
        rel_heights = relHeights,
        rel_widths = relWidths
      ))
    }
  }
}
.ggSCTKTheme <- function(gg, baseSize = 12,
                         groupBy = NULL, combinePlot = "none") {

  scaleFactor <- .ggSetScaleFactor(groupBy = groupBy,
                                   combinePlot = combinePlot)
  return(gg + ggplot2::theme_bw(base_size = baseSize * scaleFactor) +
           ggplot2::theme(
             panel.grid.major = ggplot2::element_blank(),
             panel.grid.minor = ggplot2::element_blank(),
             axis.text = ggplot2::element_text(),
             axis.title = ggplot2::element_text()
           ))
}

.ggSetScaleFactor <- function(groupBy = NULL,
                              combinePlot = "none"){
  if(!is.null(groupBy)){
    scaleFactor = 1/length(levels(groupBy)) + 0.5
  }else{
    scaleFactor = 1
  }
  if(combinePlot == "all"){
    scaleFactor = scaleFactor * 0.75
  }
  return(scaleFactor)
}

.ggAddLine <- function(plot,
                       hcutoff = NULL,
                       vcutoff = NULL,
                       hcolor = "red",
                       hsize = 1,
                       hlinetype = 1,
                       vcolor = "red",
                       vsize = 1,
                       vlinetype = 1){
  if(!is.null(hcutoff)){
    plot <- plot + ggplot2::geom_hline(yintercept = hcutoff, colour = hcolor,
                                       size = hsize, linetype = hlinetype)
  }
  if(!is.null(vcutoff)){
    plot <- plot + ggplot2::geom_vline(xintercept = vcutoff, colour = vcolor,
                                       size = vsize, linetype = vlinetype)
  }
  return(plot)
}

shinyPanelEnrichR <- fluidPage(
  tags$div(
    class = "container",
    h1("Gene Set Enrichment Analysis using enrichR"),
    h5(tags$a(href = paste0(docs.artPath, "cnsl_enrichR.html"),
              "(help)", target = "_blank")),
    div(
      id = 'enrichrError', class = 'simpleDiv',
      'The Enrichr web portal was not available. Enrichr analysis currently disabled.'
    ),
    sidebarLayout(
      sidebarPanel(
        id="sidebarEnrichr",
        h4("Choose data source:"),
        radioButtons(
          "geneListChoice", label = NULL, c("Import DEG" = "deg",
                                            "Select Gene(s)" = "selectGenes",
                                            "Upload file" = "geneFile")
        ),
        hr(),
        conditionalPanel(
          condition = "input.geneListChoice == 'deg'",
          selectInput("enrDEGSelect", "Select DE Analysis:", NULL),
          numericInput("enrDEGlog2fc", "Use Log2FC greater than", 0.5),
          numericInput("enrDEGFDR", "Use FDR less than", 0.05),
          checkboxInput("enrDEGUpOnly", "Only use upregulated genes", TRUE),
          numericInput("enrDEGminMean1", "Use mean exp in group1 greater than", 
                       value = 0, min = 0, step = 0.5),
          numericInput("enrDEGmaxMean2", "Use mean exp in group2 less than", 
                       value = 10, min = 0, step = 0.5),
          numericInput("enrDEGminPerc1", "Use exp% in group1 greater than", 
                       value = 0, min = 0, max = 1, step = 0.05),
          numericInput("enrDEGmaxPerc2", "Use exp% in group2 less than", 
                       value = 1, min = 0, max = 1, step = 0.05),
          uiOutput("enrDEGText"),
          verbatimTextOutput(outputId = "enrDEGRes", placeholder = TRUE)
        ),
        conditionalPanel(
          condition = "input.geneListChoice == 'selectGenes'",
          selectizeInput("enrichGenes", label = "Select Gene(s):", NULL, multiple = TRUE)
        ),
        conditionalPanel(
          condition = "input.geneListChoice == 'geneFile'",
          fileInput(
            "enrFile",
            tags$b(tags$i("Please upload a file with only gene names or Entrez Gene Symbols")),
            accept = c("text/csv", "text/comma-separated-values",
                       "text/tab-separated-values", "text/plain",
                       ".csv", ".tsv")
          ),
          h5("Sample files:"),
          tags$a(href = "https://drive.google.com/open?id=1iJZ6H_G2brbeww9B0dA5seMyYUZYyFrU",
                 "Gene Names", target = "_blank"
          ),
          tags$a(href = "https://drive.google.com/open?id=1BLrwW0uMi2pxsX0m1zJrlOTnBLkIiOhk",
                 "Entrez ids", target = "_blank"
          ),
          h5("Options:"),
          # Input: Checkbox if file has header ----
          checkboxInput("header", "Header", value = TRUE),
          # Input: Select separator ----
          radioButtons("sep", "Separator",
                       choices = c(Comma = ",",
                                   Semicolon = ";",
                                   Tab = "\t"),
                       selected = ",",
                       inline = TRUE),
          # Input: Select quotes ----
          radioButtons("quote", "Quote",
                       choices = c(None = "",
                                   "Double Quote" = '"',
                                   "Single Quote" = "'"),
                       selected = '""',
                       inline = TRUE),
          selectInput("enrFileBy", "Match feature type:",
                      choices = c("rownames", featureChoice))
        ),
        hr(),
        selectInput("enrFeatureName", 
                    label = "Select symbol annotation:",
                    choices = c("rownames", featureChoice)),
        selectizeInput("enrichDb", label = "Select DB:", enrichedDB,
                       multiple = TRUE, 
                       options = list(placeholder = "Use all (default)")),
        textInput('enrAnalysisNameSet', "Set analysis name:", 
                  placeholder = "Required"),
        actionButton("enrichRun", "Run"),
      ),
      mainPanel(
        dropdown(
          fluidRow(
            selectInput('enrAnalysisNameSel', label = "Select analysis name:", 
                        choices = NULL),
            selectizeInput('enrDbShow', 
                           label = "Show result of specific database:", 
                           choices = NULL, multiple = TRUE,
                           options = list(placeholder = "Show all (default)"))
          ),
          inputId = "enrDropDown",
          icon = icon("cog"),
          status = "primary",
          circle = FALSE,
          inline = TRUE
        ),
        hr(),
        DT::dataTableOutput("enrDataTable"),
        br(),
        downloadButton("downloadEnrichR", "Download results")
      )
    )
  )
)

#' @name importExampleData
#' @title Retrieve example datasets
#' @description Retrieves published example datasets stored in
#' \link[SingleCellExperiment]{SingleCellExperiment} using the
#' \link{scRNAseq} and
#' \link[TENxPBMCData]{TENxPBMCData} packages. See 'Details' for a
#' list of available datasets.
#' @param dataset Character. Name of the dataset to retrieve.
#' @param class Character. The class of the expression matrix stored in the SCE
#'   object. Can be one of \code{"Matrix"} or \code{"matrix"}. \code{"Matrix"}
#'   will store the data as a sparse matrix from package \link{Matrix} while
#'   \code{"matrix"} will store the data in a standard matrix. Default
#'   \code{"Matrix"}.
#' @param delayedArray Boolean. Whether to read the expression matrix as
#'   \link{DelayedArray} object or not. Default \code{FALSE}.
#' @param rowNamesDedup Boolean. Whether to deduplicate rownames. Default 
#' \code{TRUE}.
#' @details See the list below for the available datasets and their
#' descriptions.
#' \describe{
#' \item{"fluidigm_pollen"}{Retrieved with
#' \code{\link{ReprocessedFluidigmData}}. Returns a dataset of 65
#'  human neural cells from Pollen et al. (2014), each sequenced at high and low
#'  coverage (SRA accession SRP041736).}
#' \item{"allen_tasic"}{Retrieved with
#' \code{\link{ReprocessedAllenData}}. Returns a dataset of 379 mouse
#' brain cells from Tasic et al. (2016).}
#' \item{"NestorowaHSCData"}{Retrieved with
#' \code{\link{NestorowaHSCData}}. Returns a dataset of 1920 mouse  
#'  haematopoietic stem cells from Nestorowa et al. 2015}
#' \item{"pbmc3k"}{Retrieved with \code{\link[TENxPBMCData]{TENxPBMCData}}.
#'  2,700 peripheral blood mononuclear cells (PBMCs) from 10X Genomics.}
#' \item{"pbmc4k"}{Retrieved with \code{\link[TENxPBMCData]{TENxPBMCData}}.
#'  4,340 peripheral blood mononuclear cells (PBMCs) from 10X Genomics.}
#' \item{"pbmc6k"}{Retrieved with \code{\link[TENxPBMCData]{TENxPBMCData}}.
#'  5,419 peripheral blood mononuclear cells (PBMCs) from 10X Genomics.}
#' \item{"pbmc8k"}{Retrieved with \code{\link[TENxPBMCData]{TENxPBMCData}}.
#'  8,381 peripheral blood mononuclear cells (PBMCs) from 10X Genomics.}
#' \item{"pbmc33k"}{Retrieved with \code{\link[TENxPBMCData]{TENxPBMCData}}.
#'  33,148 peripheral blood mononuclear cells (PBMCs) from 10X Genomics.}
#' \item{"pbmc68k"}{Retrieved with \code{\link[TENxPBMCData]{TENxPBMCData}}.
#'  68,579 peripheral blood mononuclear cells (PBMCs) from 10X Genomics.}
#' }
#' @author Joshua D. Campbell, David Jenkins
#' @return The specified \link[SingleCellExperiment]{SingleCellExperiment} object.
#' @examples
#' sce <- importExampleData("pbmc3k")
#' @export
#' @importFrom SummarizedExperiment colData rowData colData<- assay assays
importExampleData <- function(dataset, class = c("Matrix", "matrix"),
                              delayedArray = FALSE, rowNamesDedup = TRUE) {
  class <- match.arg(class)

  scRNAseqDatasets <- c("fluidigm_pollen", "allen_tasic", "NestorowaHSCData")
  tenxPbmcDatasets <- c("pbmc3k", "pbmc4k", "pbmc6k", "pbmc8k", "pbmc33k", "pbmc68k")

  ExperimentHub::setExperimentHubOption("ASK", FALSE)
  
  if(dataset %in% scRNAseqDatasets) {
    if(!("scRNAseq" %in% rownames(utils::installed.packages()))) {
      p <- paste0("Package 'scRNAseq' is not installed. Please install to load dataset '", dataset, "'.")
      stop(p)
    }
    if (dataset == "fluidigm_pollen") {
      temp <- scRNAseq::ReprocessedFluidigmData()
      temp$sample <- paste0(colData(temp)$Biological_Condition, "_", colData(temp)$Coverage_Type)
    } else if (dataset == "allen_tasic") {
      temp <- scRNAseq::ReprocessedAllenData()
      temp$sample <- paste0(colData(temp)$driver_1_s, "_", colData(temp)$dissection_s)
    }else if (dataset == "NestorowaHSCData") {
      temp <- scRNAseq::NestorowaHSCData()
      ens.mm.v97 <- AnnotationHub::AnnotationHub()[["AH73905"]]
      anno <- ensembldb::select(ens.mm.v97, keys=rownames(temp),keytype="GENEID", columns=c("SYMBOL", "SEQNAME"))
      rowData(temp) <- anno[match(rownames(temp), anno$GENEID),]
      temp <- temp[!is.na(rowData(temp)$SYMBOL), ]  
      temp <- setRowNames(temp, "SYMBOL", dedup = rowNamesDedup)
      colnames(rowData(temp))[which(names(rowData(temp)) == "SYMBOL")] <- "Symbol"      
      #rowData(temp)$Symbol <- rowData(temp)$SYMBOL
      temp$cell.type <- NULL
      temp$sample <- "NestorowaHSCData"
      
    }
    if (isTRUE(rowNamesDedup)) {
      temp <- dedupRowNames(temp)
    }
  } else if (dataset %in% tenxPbmcDatasets) {
    if(!("TENxPBMCData" %in% rownames(utils::installed.packages()))) {
      p <- paste0("Package 'TENxPBMCData' is not installed. Please install to load dataset '", dataset, "'.")
      stop(p)
    }
    temp <- TENxPBMCData::TENxPBMCData(dataset = dataset)
    colnames(temp) <- paste(temp$Sample, temp$Barcode, sep="_")
    temp <- setRowNames(temp, "Symbol_TENx", dedup = rowNamesDedup)
    colData(temp)$sample <- colData(temp)$Sample
  } else {
    stop("'dataset' must be one of: ", paste(c(scRNAseqDatasets, tenxPbmcDatasets), collapse = ","))
  }

  # Convert to sparseMatrix or regular matrix
  for(i in seq_along(names(assays(temp)))) {
    if (class == "matrix") {
      assay(temp, i) <- as.matrix(temp)
    } else if(class == "Matrix") {
      assay(temp, i) <- .convertToMatrix(assay(temp, i))
    }

    if (isTRUE(delayedArray)) {
      assay(temp, i) <- DelayedArray::DelayedArray(assay(temp, i))
    }
  }
  return(temp)
}

#' Run t-SNE embedding with Rtsne method
#' @rdname runTSNE
#' @description T-Stochastic Neighbour Embedding (t-SNE) algorithm is commonly
#' for 2D visualization of single-cell data. This function wraps the
#' Rtsne \code{\link[Rtsne]{Rtsne}} function.
#'
#' With this funciton, users can create tSNE embedding directly from raw count
#' matrix, with necessary preprocessing including normalization, scaling,
#' dimension reduction all automated. Yet we still recommend having the PCA as
#' input, so that the result can match with the clustering based on the same
#' input PCA, and will be much faster.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object.
#' @param useReducedDim The low dimension representation to use for UMAP
#' computation. Default \code{"PCA"}.
#' @param useAssay Assay to use for tSNE computation. If \code{useAltExp} is
#' specified, \code{useAssay} has to exist in
#' \code{assays(altExp(inSCE, useAltExp))}. Default \code{NULL}.
#' @param useAltExp The subset to use for tSNE computation, usually for the
#' selected.variable features. Default \code{NULL}.
#' @param reducedDimName a name to store the results of the dimension
#' reductions. Default \code{"TSNE"}.
#' @param logNorm Whether the counts will need to be log-normalized prior to
#' generating the tSNE via \code{\link{scaterlogNormCounts}}. Ignored when using
#' \code{useReducedDim}. Default \code{TRUE}.
#' @param useFeatureSubset Subset of feature to use for dimension reduction. A
#' character string indicating a \code{rowData} variable that stores the logical
#' vector of HVG selection, or a vector that can subset the rows of
#' \code{inSCE}. Default \code{NULL}.
#' @param nTop Automatically detect this number of variable features to use for
#' dimension reduction. Ignored when using \code{useReducedDim} or using
#' \code{useFeatureSubset}. Default \code{2000}.
#' @param center Whether data should be centered before PCA is applied. Ignored
#' when using \code{useReducedDim}. Default \code{TRUE}.
#' @param scale Whether data should be scaled before PCA is applied. Ignored
#' when using \code{useReducedDim}. Default \code{TRUE}.
#' @param pca Whether an initial PCA step should be performed. Ignored when
#' using \code{useReducedDim}. Default \code{TRUE}.
#' @param partialPCA Whether truncated PCA should be used to calculate principal
#' components (requires the irlba package). This is faster for large input
#' matrices. Ignored when using \code{useReducedDim}. Default \code{FALSE}.
#' @param initialDims Number of dimensions from PCA to use as input in tSNE.
#' Default \code{25}.
#' @param theta Numeric value for speed/accuracy trade-off (increase for less
#' accuracy), set to \code{0.0} for exact TSNE. Default \code{0.5}.
#' @param perplexity perplexity parameter. Should not be bigger than
#' \code{3 * perplexity < ncol(inSCE) - 1}. Default \code{30}. See
#' \code{\link[Rtsne]{Rtsne}} details for interpretation.
#' @param nIterations maximum iterations. Default \code{1000}.
#' @param numThreads Integer, number of threads to use using OpenMP, Default
#' \code{1}. \code{0} corresponds to using all available cores.
#' @param seed Random seed for reproducibility of tSNE results.
#' Default \code{NULL} will use global seed in use by the R environment.
#' @return A \linkS4class{SingleCellExperiment} object with tSNE computation
#' updated in \code{reducedDim(inSCE, reducedDimName)}.
#' @export
#' @examples
#' data(scExample, package = "singleCellTK")
#' sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
#' # Run from raw counts
#' sce <- runQuickTSNE(sce)
#' \dontrun{
#' # Run from PCA
#' sce <- scaterlogNormCounts(sce, "logcounts")
#' sce <- runModelGeneVar(sce)
#' sce <- setTopHVG(sce, method = "modelGeneVar", hvgNumber = 2000, 
#'                  featureSubsetName = "HVG_modelGeneVar2000")
#' sce <- scaterPCA(sce, useAssay = "logcounts",
#'                  useFeatureSubset = "HVG_modelGeneVar2000", scale = TRUE)
#' sce <- runTSNE(sce, useReducedDim = "PCA")
#' }
#' @importFrom S4Vectors metadata<-
runTSNE <- function(inSCE, useReducedDim = "PCA", useAssay = NULL, 
                    useAltExp = NULL, reducedDimName = "TSNE", logNorm = TRUE,
                    useFeatureSubset = NULL, nTop = 2000, center = TRUE,
                    scale = TRUE, pca = TRUE, partialPCA = FALSE,
                    initialDims = 25, theta = 0.5, perplexity = 30,
                    nIterations = 1000, numThreads = 1, seed = 12345) {
  params <- as.list(environment())
  params$inSCE <- NULL
  # Note: useMat = list(useAssay = useAssay, ...)
  # `.selectSCEMatrix()` does the check and corrects the conditions
  # When using useReducedDim, useAssay will be ignored
  useMat <- .selectSCEMatrix(inSCE, useAssay = useAssay,
                             useReducedDim = useReducedDim,
                             useAltExp = useAltExp,
                             returnMatrix = FALSE)$names
  params$useAssay <- useMat$useAssay
  useAssay <- useMat$useAssay
  
  if (!is.null(useAltExp)) {
    sce <- SingleCellExperiment::altExp(inSCE, useAltExp)
  } else {
    sce <- inSCE
  }
  
  if (!is.null(useAssay)) {
    if (isTRUE(logNorm)) {
      sce <- scaterlogNormCounts(sce, assayName = "logcounts", useAssay = useAssay)
      useAssay <- "logcounts"
    }
    if (!is.null(useFeatureSubset)) {
      subset_row <- .parseUseFeatureSubset(inSCE, useFeatureSubset,
                                           altExpObj = sce,
                                           returnType = "logical")
      sce <- sce[subset_row,]
    } else {
      if (!is.null(nTop) && nTop < nrow(sce)) {
        suppressMessages({
          sce <- runFeatureSelection(sce, useAssay, method = "modelGeneVar")
          sce <- setTopHVG(sce, method = "modelGeneVar", hvgNumber = nTop,
                           featureSubsetName = "tsneHVG")
        })
        sce <- subsetSCERows(sce, rowData = "tsneHVG", returnAsAltExp = FALSE)
      }
    }
    mat <- t(SummarizedExperiment::assay(sce, useAssay))
    if ((!isTRUE(pca) & !isTRUE(partialPCA))) {
      initialDims <- NULL
    }
  } else {
    mat <- SingleCellExperiment::reducedDim(sce, useReducedDim)
    pca <- FALSE
    partialPCA <- FALSE
    scale <- FALSE
    center <- FALSE
    if (initialDims < ncol(mat)) {
      mat <- mat[,seq(initialDims)]
    }
  }
  
  if (is.null(perplexity)){
    perplexity <- floor(ncol(inSCE) / 5)
  }
  # Rtsne requires a matrix input
  mat <- as.matrix(mat)
  p <- paste0(date(), " ... Computing Rtsne.")
  message(p)
  withr::with_seed(seed, {
    tsneOut <- Rtsne::Rtsne(mat, pca_scale = scale, pca_center = center,
                            pca = pca, partial_pca = partialPCA,
                            perplexity = perplexity,
                            initial_dims = initialDims,
                            max_iter = nIterations, theta = theta,
                            num_threads = numThreads)
  })
  tsneOut <- tsneOut$Y
  rownames(tsneOut) <- colnames(inSCE)
  colnames(tsneOut) <- c("tSNE1", "tSNE2")
  SingleCellExperiment::reducedDim(inSCE, reducedDimName) <- tsneOut
  metadata(inSCE)$sctk$runDimReduce$embedding[[reducedDimName]] <- params
  return(inSCE)
}

#' @rdname runTSNE
#' @param ... Other parameters to be passed to \code{runTSNE}
#' @export
runQuickTSNE <- function(inSCE, useAssay = "counts", ...) {
  args <- list(...)
  if (!is.null(args$useReducedDim)) {
    warning("Forcing `useReducedDim` to be `NULL`. Please use `runTSNE` for ",
            "using reducedDim.")
  }
  args$useReducedDim <- NULL
  args <- c(list(inSCE = inSCE, useAssay = useAssay, useReducedDim = NULL), 
            args)
  inSCE <- do.call("runTSNE", args = args)
  return(inSCE)
}

#' @rdname runTSNE
#' @export
getTSNE <- function(inSCE, useReducedDim = "PCA", useAssay = NULL, 
                    useAltExp = NULL, reducedDimName = "TSNE", logNorm = TRUE,
                    useFeatureSubset = NULL, nTop = 2000, center = TRUE,
                    scale = TRUE, pca = TRUE, partialPCA = FALSE,
                    initialDims = 25, theta = 0.5, perplexity = 30,
                    nIterations = 1000, numThreads = 1, seed = 12345) {
  .Deprecated("runTSNE")
  runTSNE(inSCE = inSCE, useReducedDim = useReducedDim, useAssay = useAssay, 
          useAltExp = useAltExp, reducedDimName = reducedDimName, 
          logNorm = logNorm, useFeatureSubset = useFeatureSubset, nTop = nTop, 
          center = center, scale = scale, pca = pca, partialPCA = partialPCA,
          initialDims = initialDims, theta = theta, perplexity = perplexity,
          nIterations = nIterations, numThreads = numThreads, seed = seed)
}

# dimension reduction
library(singleCellTK)
library(testthat)
context("Testing dimension reduction")
data(scExample, package = "singleCellTK")
sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
sce <- scaterlogNormCounts(sce, "logcounts")
sce <- runFeatureSelection(sce, useAssay = "counts", method="vst")
sce <- setTopHVG(sce, featureSubsetName = "hvf")
sce <- setTopHVG(sce, featureSubsetName = "hvfAltExp", altExp = TRUE)

test_that(desc = "Testing scaterPCA", {
    sce <- scaterPCA(sce, useAssay = "logcounts", useFeatureSubset = "hvf",
                     reducedDimName = "PCA1")
    testthat::expect_true("PCA1" %in% reducedDimNames(sce))

    sce <- scaterPCA(sce, useAssay = "hvfAltExplogcounts", useAltExp = "hvfAltExp",
                     useFeatureSubset = NULL, reducedDimName = "PCA2")
    testthat::expect_true("PCA2" %in% reducedDimNames(sce))

    expect_error({
        scaterPCA(sce, useAssay = "null", useFeatureSubset = "hvf")
    }, "Specified `useAssay` 'null' not found.")
    expect_error({
        scaterPCA(sce, useAssay = "null", useAltExp = "null", useFeatureSubset = "hvf")
    }, "Specified `useAltExp` 'null' not found.")
    expect_error({
        scaterPCA(sce, useAssay = "null", useAltExp = "hvfAltExp", useFeatureSubset = "hvf")
    }, "Specified `useAssay` 'null' not found in the altExp.")

    p1 <- plotPCA(sce, reducedDimName = "PCA1", colorBy = "type", shape = "type")
    p2 <- plotPCA(sce, reducedDimName = "PCA3", runPCA = TRUE)
    expect_is(p1, "ggplot")
    expect_is(p2, "ggplot")
    expect_error({
        plotPCA(sce, pcX = "foo", reducedDimName = "PCA1")
    }, regexp = "pcX dimension")
    expect_error({
        plotPCA(sce, pcY = "bar", reducedDimName = "PCA1")
    }, regexp = "pcY dimension")
    expect_error({
        plotPCA(sce, reducedDimName = "UMAP")
    }, regexp = "dimension not found")
})

test_that(desc = "Testing scater UMAP", {
    sce <- scaterPCA(sce, useFeatureSubset = "hvf", seed = 12345, reducedDimName = "PCA1")
    sce <- runUMAP(sce, useReducedDim = "PCA1", reducedDimName = "UMAP1", initialDims = 25)
    testthat::expect_true("UMAP1" %in% reducedDimNames(sce))
    sce <- runUMAP(sce, useAssay = "hvfAltExplogcounts", useReducedDim = NULL,
                   useAltExp = "hvfAltExp",
                   reducedDimName = "UMAP2", initialDims = 25)
    testthat::expect_true("UMAP2" %in% reducedDimNames(sce))
    # TODO: Still some runable conditions
    expect_error({
        runUMAP(inSCE = 1, initialDims = 25)
    }, "`inSCE` should be a SingleCellExperiment Object.")
    expect_error({
        runUMAP(sce, useAssay = NULL, initialDims = 25, useReducedDim = NULL)
    }, "Either `useAssay` or `useReducedDim` has to be specified.")
    expect_error({
        runUMAP(sce, initialDims = 25, useAltExp = "altexp")
    }, "Specified `useAltExp` 'altexp' not found.")
    expect_error({
        runUMAP(sce, initialDims = 25, useReducedDim = "TSNE")
    }, "Specified `useReducedDim` 'TSNE' not found.")
    expect_error({
        runUMAP(sce, initialDims = 25, useAssay = "TSNE", useReducedDim = NULL)
    }, regexp = "Specified `useAssay` 'TSNE' not found.")
    expect_error({
        runUMAP(sce, initialDims = 25, useReducedDim = "PCA1", sample = "batch")
    }, regexp = "Specified variable 'batch'")
    expect_error({
        runUMAP(sce, initialDims = 25, useReducedDim = "PCA1", sample = letters)
    }, regexp = "Invalid variable length")

    p1 <- plotUMAP(sce, reducedDimName = "UMAP1", colorBy = "type", shape = "type")
    p2 <- plotUMAP(sce, reducedDimName = "UMAP3", runUMAP = TRUE)
    expect_is(p1, "ggplot")
    expect_is(p2, "ggplot")
    expect_error({
        plotUMAP(sce, reducedDimName = "TSNE")
    }, regexp = "dimension not found")
    reducedDim(sce, "UMAP4") <- cbind(reducedDim(sce, "UMAP1"), reducedDim(sce, "UMAP1"))
    expect_warning({
        plotUMAP(sce, reducedDimName = "UMAP4")
    }, "More than two UMAP dimensions")
})

test_that(desc = "Testing Rtsne TSNE", {
    sce <- scaterPCA(sce, useFeatureSubset = "hvf", seed = 12345, reducedDimName = "PCA1")
    sce <- runTSNE(sce, useReducedDim = "PCA1", reducedDimName = "TSNE1")
    testthat::expect_true("TSNE1" %in% reducedDimNames(sce))
    sce <- runQuickTSNE(sce, useAssay = "hvfAltExpcounts", useAltExp = "hvfAltExp",
                        reducedDimName = "TSNE2", logNorm = TRUE, nTop = 50)
    testthat::expect_true("TSNE2" %in% reducedDimNames(sce))
    # TODO: Still some runable conditions
    expect_error({
        runTSNE(sce, useAssay = NULL, useReducedDim = NULL)
    }, "Either `useAssay` or `useReducedDim` has to be specified.")
    expect_error({
        runTSNE(sce, useAltExp = "altexp")
    }, "Specified `useAltExp` 'altexp' not found.")

    p1 <- plotTSNE(sce, reducedDimName = "TSNE1", colorBy = "type", shape = "type")
    p2 <- plotTSNE(sce, reducedDimName = "TSNE3", runTSNE = TRUE)
    expect_is(p1, "ggplot")
    expect_is(p2, "ggplot")
    expect_error({
        plotTSNE(sce, reducedDimName = "UMAP")
    }, regexp = "dimension not found")
    reducedDim(sce, "TSNE4") <- cbind(reducedDim(sce, "TSNE1"), reducedDim(sce, "TSNE1"))
    expect_warning({
        plotTSNE(sce, reducedDimName = "TSNE4")
    }, "More than two t-SNE dimensions")

    p3 <- plotDimRed(sce, useReduction = "PCA1")
    p4 <- plotDimRed(sce, useReduction = "PCA1", xAxisLabel = "PC_1", yAxisLabel = "PC_2")
    expect_is(p3, "ggplot")
    expect_is(p4, "ggplot")
})

.checkGzip <- function(path, gzipped){
    if (gzipped == "auto") {
      ext <- tools::file_ext(path)
      if (ext == "gz") {
            path <- gzfile(path)
        }
    } else if (isTRUE(gzipped)) {
        path <- gzfile(path)
    }

    return(path)
}

#' Create a SingleCellExperiment object from files
#'
#' @details Creates a \linkS4class{SingleCellExperiment} object from a counts 
#' file in various formats, and files of cell and feature annotation.
#' @param assayFile The path to a file in .mtx, .txt, .csv, .tab, or .tsv 
#' format.
#' @param annotFile The path to a text file that contains columns of annotation
#' information for each cell in the \code{assayFile}. This file should have the 
#' same number of rows as there are columns in the \code{assayFile}. If multiple
#' samples are represented in the dataset, this should be denoted by a column 
#' called \code{'sample'} within the \code{annotFile}.
#' @param featureFile The path to a text file that contains columns of
#' annotation information for each gene in the count matrix. This file should
#' have the same genes in the same order as \code{assayFile}. This is optional.
#' @param assayName The name of the assay that you are uploading. The default
#' is \code{"counts"}.
#' @param inputDataFrames If \code{TRUE}, \code{assayFile}, \code{annotFile} and
#' \code{featureFile} should be \code{data.frames} object (or its inheritance) 
#' instead of file paths. The default is \code{FALSE}.
#' @param class Character. The class of the expression matrix stored in the SCE
#'  object. Can be one of \code{"Matrix"} (as returned by
#'  \link{readMM} function), or \code{"matrix"} (as returned by
#'  \link[base]{matrix} function). Default \code{"Matrix"}.
#' @param annotFileHeader Whether there's a header (colnames) in the cell 
#' annotation file. Default is \code{FALSE}.
#' @param annotFileRowName Which column is used as the rownames for the cell 
#' annotation file. This should match to the colnames of the \code{assayFile}. 
#' Default is \code{1} (first column).
#' @param annotFileSep Separater used for the cell annotation file. Default is 
#' \code{"\\t"}.
#' @param featureHeader Whether there's a header (colnames) in the feature 
#' annotation file. Default is \code{FALSE}.
#' @param featureRowName Which column is used as the rownames for the feature 
#' annotation file. This should match to the rownames of the \code{assayFile}. 
#' Default is \code{1}. (first column).
#' @param featureSep Separater used for the feature annotation file. Default is 
#' \code{"\\t"}.
#' @param gzipped Whether the input file is gzipped. Default is \code{"auto"} 
#' and it will automatically detect whether the file is gzipped. Other options 
#' are \code{TRUE} or \code{FALSE}.
#' @param delayedArray Boolean. Whether to read the expression matrix as
#'  \link{DelayedArray} object or not. Default \code{FALSE}.
#' @param rowNamesDedup Boolean. Whether to deduplicate rownames. Default 
#'  \code{TRUE}.
#' @return a \linkS4class{SingleCellExperiment} object
#' @export

importFromFiles <- function(assayFile, annotFile = NULL, featureFile = NULL,
                            assayName = "counts", inputDataFrames = FALSE,
                            class = c("Matrix", "matrix"), delayedArray = FALSE,
                            annotFileHeader = FALSE, annotFileRowName = 1,
                            annotFileSep = "\t", featureHeader = FALSE,
                            featureRowName = 1, featureSep = "\t", 
                            gzipped = "auto", rowNamesDedup = TRUE){

  class <- match.arg(class)

  if (inputDataFrames){
    countsin <- assayFile
    annotin <- annotFile
    featurein <- featureFile
  } else{
    countsin <- readSingleCellMatrix(assayFile, class = class, 
                                     delayedArray = delayedArray)
    if (!is.null(annotFile)){
      annotFile <- .checkGzip(annotFile, gzipped = gzipped)
      annotin <- utils::read.table(annotFile, sep = annotFileSep, 
                                   header = annotFileHeader,
                                   row.names = annotFileRowName, 
                                   stringsAsFactors = FALSE)
    }
    if (!is.null(featureFile)){
      featureFile <- .checkGzip(featureFile, gzipped = gzipped)
      featurein <- utils::read.table(featureFile, sep = featureSep, 
                                     header = featureHeader,
                                     row.names = featureRowName, 
                                     stringsAsFactors = FALSE)
    }
  }
  if (is.null(annotFile)){
    annotin <- data.frame(row.names = colnames(countsin))
    annotin <- S4Vectors::DataFrame(annotin)
  }
  if (is.null(featureFile)){
    featurein <- data.frame(Gene = rownames(countsin))
    rownames(featurein) <- featurein$Gene
    featurein <- S4Vectors::DataFrame(featurein)
  }

  if (nrow(annotin) != ncol(countsin)){
    stop("Different number of cells in input matrix and annotations: annot: ",
         nrow(annotin), ", counts: ", ncol(countsin))
  }
  if (nrow(featurein) != nrow(countsin)){
    stop("Different number of features in input matrix and feature annotation",
         nrow(featurein), ", counts: ", nrow(countsin))
  }
  if (any(rownames(annotin) != colnames(countsin))){
    stop("Cell names in input matrix and annotation do not match!\nExample: ",
         rownames(annotin)[rownames(annotin) != colnames(countsin)][1], " vs. ",
         colnames(countsin)[rownames(annotin) != colnames(countsin)][1])
  }
  if (any(rownames(featurein) != rownames(countsin))){
    stop("Feature names in input matrix and feature annotation do not match!")
  }

  assaylist <- list()
  if (is.null(rownames(countsin))){
    rownames(countsin) <- rownames(featurein)
  }
  if (is.null(colnames(countsin))){
    colnames(countsin) <- rownames(annotin)
  }
  assaylist[[assayName]] <- .convertToMatrix(countsin)

  newassay <- SingleCellExperiment::SingleCellExperiment(assays = assaylist,
                                                         colData = annotin,
                                                         rowData = featurein)

  if(is.null(newassay$sample)) {
    newassay$sample <- "sample"
  }

  if (isTRUE(rowNamesDedup)) {
    if (any(duplicated(rownames(newassay)))) {
      message("Duplicated gene names found, adding '-1', '-2', ",
              "... suffix to them.")
    }
    newassay <- dedupRowNames(newassay)
  }
  
  return(newassay)
}

###################################################
###  Setting accessor functions
###################################################
#' @title getTSCANResults accessor function
#' @description SCTK allows user to access all TSCAN related results with
#' \code{"getTSCANResults"}. See details.
#' @param x Input \linkS4class{SingleCellExperiment} object.
#' @param analysisName Algorithm name implemented, should be one of
#' \code{"Pseudotime"}, \code{"DEG"}, or \code{"ClusterDEAnalysis"}.
#' @param pathName Sub folder name within the \code{analysisName}. See details.
#' @param value Value to be stored within the \code{pathName} or
#' \code{analysisName}
#' @details
#' When \code{analysisName = "Pseudotime"}, returns the list result from
#' \code{\link{runTSCAN}}, including the MST structure.
#'
#' When \code{analysisName = "DEG"}, returns the list result from
#' \code{\link{runTSCANDEG}}, including \code{DataFrame}s containing genes that
#' increase/decrease along each the pseudotime paths. \code{pathName} indicates
#' the path index, the available options of which can be listed by
#' \code{listTSCANTerminalNodes}.
#'
#' When \code{analysisName = "ClusterDEAnalysis"}, returns the list result from
#' \code{\link{runTSCANClusterDEAnalysis}}. Here \code{pathName} needs to match
#' with the \code{useCluster} argument when running the algorithm.
#' @export
#' @rdname getTSCANResults
#' @return Get or set TSCAN results
#' @examples
#' data("mouseBrainSubsetSCE", package = "singleCellTK")
#' mouseBrainSubsetSCE <- runTSCAN(inSCE = mouseBrainSubsetSCE,
#'                                 useReducedDim = "PCA_logcounts")
#' results <- getTSCANResults(mouseBrainSubsetSCE, "Pseudotime")
setGeneric("getTSCANResults", signature = "x",
           function(x, analysisName = NULL, pathName = NULL) {
               standardGeneric("getTSCANResults")
           }
)

#' @export
#' @rdname getTSCANResults
#'
setMethod("getTSCANResults", signature(x = "SingleCellExperiment"),
          function(x, analysisName = NULL, pathName = NULL){
              result.names <- listTSCANResults(x)
              if(!analysisName %in% result.names) {
                  stop("The analysis was not found for TSCAN results")
              }
              if (analysisName == "Pseudotime")
                  results <- S4Vectors::metadata(x)$sctk$Traj$TSCAN$Pseudotime
              else {
                  if (is.null(pathName)) {
                      results <- S4Vectors::metadata(x)$sctk$Traj$TSCAN[[analysisName]]
                  } else {
                      pathName <- as.character(pathName)
                      results <- S4Vectors::metadata(x)$sctk$Traj$TSCAN[[analysisName]][[pathName]]
                  }
              }
              return(results)
          })

#' @export
#' @rdname getTSCANResults
#'
setGeneric("getTSCANResults<-",
           function(x, analysisName, pathName = NULL, value)
               standardGeneric("getTSCANResults<-")
)

#' @export
#' @rdname getTSCANResults
setReplaceMethod("getTSCANResults", signature(x = "SingleCellExperiment"),
                 function(x, analysisName, pathName = NULL, value) {
                     if (analysisName == "Pseudotime")
                         S4Vectors::metadata(x)$sctk$Traj$TSCAN$Pseudotime <- value
                     else {
                         if (is.null(pathName))
                             stop("Have to specify `pathName` for TSCAN DE analyses")
                         pathName <- as.character(pathName)
                         S4Vectors::metadata(x)$sctk$Traj$TSCAN[[analysisName]][[pathName]] <- value
                     }
                     return(x)
                 })

#' @export
#' @rdname getTSCANResults
setGeneric("listTSCANResults", signature = "x",
           function(x) {standardGeneric("listTSCANResults")}
)

#' @export
#' @rdname getTSCANResults
setMethod("listTSCANResults", "SingleCellExperiment", function(x){
    all.results <- S4Vectors::metadata(x)$sctk$Traj$TSCAN
    if (is.null(all.results) ||
        !"Pseudotime" %in% names(all.results)) {
        stop("No TSCAN result found. Please run `runTSCAN` first.")
    }
    return(names(all.results))
})

#' @export
#' @rdname getTSCANResults
setGeneric("listTSCANTerminalNodes", signature = "x",
           function(x) {
               standardGeneric("listTSCANTerminalNodes")
           }
)

#' @export
#' @rdname getTSCANResults
setMethod("listTSCANTerminalNodes", signature(x = "SingleCellExperiment"),
          function(x){
              if (is.null(S4Vectors::metadata(x)$sctk$Traj$TSCAN$Pseudotime))
                  stop("No TSCAN result found. Please run `runTSCAN()` first.")
              results <- S4Vectors::metadata(x)$sctk$Traj$TSCAN$Pseudotime$pathClusters
              return(names(results))
          })

###################################################
###  STEP 1:: creating cluster and MST
###################################################

#' @title Run TSCAN to obtain pseudotime values for cells
#' @description Wrapper for obtaining a pseudotime ordering of the cells by
#' projecting them onto the minimum spanning tree (MST)
#' @param inSCE Input \linkS4class{SingleCellExperiment} object.
#' @param useReducedDim Character. A low-dimension representation in
#' \code{reducedDims}, will be used for both clustering if \code{cluster} not
#' specified and MST construction. Default \code{"PCA"}.
#' @param cluster Grouping for each cell in \code{inSCE}. A vector with equal
#' length to the number of the cells in \code{inSCE}, or a single character for
#' retriving \code{colData} variable. Default \code{NULL}, will run
#' \code{runScranSNN} to obtain.
#' @param starter Character. Specifies the starting node from which to compute
#' the pseudotime. Default \code{NULL}, will select an arbitrary node.
#' @param seed An integer. Random seed for clustering if \code{cluster} is not
#' specified. Default \code{12345}.
#' @return The input \code{inSCE} object with pseudotime ordering of the cells
#' along the paths and the cluster label stored in \code{colData}, and other
#' unstructured information in \code{metadata}.
#' @export
#' @author Nida Pervaiz
#' @examples
#' data("mouseBrainSubsetSCE", package = "singleCellTK")
#' mouseBrainSubsetSCE <- runTSCAN(inSCE = mouseBrainSubsetSCE,
#'                                 useReducedDim = "PCA_logcounts")
runTSCAN <- function(inSCE,
                     useReducedDim = "PCA",
                     cluster = NULL,
                     starter = NULL,
                     seed = 12345) {
    if (is.null(cluster)) {
        # DON'T RETURN TO `inSCE`
        # It really overwrites existing cluster labels
        sce <- runScranSNN(inSCE, useReducedDim = useReducedDim, clusterName = "scranSNN_cluster", k = 8, weightType = "jaccard", seed = seed)
        cluster <- colData(sce)$scranSNN_cluster
        rm(sce)
    } else {
        cluster <- .manageCellVar(inSCE, var = cluster)
    }
    if (length(unique(cluster)) == 1) {
        stop("Only one cluster found. Unable to calculate.")
    }
    message(date(), " ... Running TSCAN to estimate pseudotime")
    inSCE <- scran::computeSumFactors(inSCE, clusters = cluster)
    by.cluster <- scuttle::aggregateAcrossCells(inSCE, ids = cluster)
    centroids <- SingleCellExperiment::reducedDim(by.cluster, useReducedDim)
    mst <- TSCAN::createClusterMST(centroids, clusters = NULL)

    # Map each cell to the closest edge on the MST, reporting also the distance to
    # the corresponding vertices.
    map.tscan <- TSCAN::mapCellsToEdges(inSCE , mst = mst,
                                        use.dimred = useReducedDim,
                                        clusters = cluster)

    # Compute a pseudotime for each cell lying on each path through the MST from a
    # given starting node.
    tscan.pseudo <- TSCAN::orderCells(map.tscan, mst, start = starter)
    common.pseudo <- TrajectoryUtils::averagePseudotime(tscan.pseudo)

    colData(inSCE)$TSCAN_clusters <- cluster
    colData(inSCE)$TSCAN_pseudotime <- common.pseudo

    pathClusters <- list()
    pathList <- data.frame()
    for(i in seq(ncol(tscan.pseudo))){
        pathIndex = as.character(colnames(tscan.pseudo)[i])
        colDataVarName <- paste0("Path_",pathIndex,"_pseudotime")
        inSCE[[colDataVarName]] <- TrajectoryUtils::pathStat(tscan.pseudo)[,pathIndex]
        nonNA.idx <- !is.na(colData(inSCE)[[colDataVarName]])
        pathClusters[[pathIndex]] <- unique(colData(inSCE)$TSCAN_clusters[nonNA.idx])
        pathList[i,1] <- pathIndex
        pathList[i,2] <- toString(pathClusters[[pathIndex]])
        message(date(), " ...   Clusters involved in path index ", pathIndex,
                " are: ", paste(pathClusters[[i]], collapse = ", "))
    }

    maxWidth <- max(stringr::str_length(pathList[, 1]))
    choiceList <- paste0(stringr::str_pad(pathList[, 1], width=maxWidth,
                                          side="right"),
                         "|", pathList[, 2])

    branchClusters <- c()
    edgeList <- mst
    for (i in seq_along(unique(colData(inSCE)$TSCAN_clusters))){
        degree <- sum(edgeList[i] != 0)
        if (degree > 1) branchClusters <- c(branchClusters, i)
    }

    ## Save these results in a list and then make S4 accessor that passes the
    ## entire list
    result <- list(pseudo = tscan.pseudo, mst = mst,
                   maptscan = map.tscan,
                   pathClusters = pathClusters,
                   branchClusters = branchClusters,
                   pathIndexList = choiceList)
    getTSCANResults(inSCE, analysisName = "Pseudotime") <- result

    message(date(), " ...   Number of estimated paths is ", ncol(tscan.pseudo))

    return (inSCE)
}

###################################################
###  plot pseudotime values
###################################################

#' @title Plot MST pseudotime values on cell 2D embedding
#' @description A wrapper function which visualizes outputs from the
#' \code{\link{runTSCAN}} function. Plots the pseudotime ordering of the cells
#' and project them onto the MST.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object.
#' @param useReducedDim Saved dimension reduction name in \code{inSCE} object.
#' Required.
#' @return A \code{.ggplot} object with the pseudotime ordering of the cells
#' colored on a cell 2D embedding, and the MST path drawn on it.
#' @export
#' @author Nida Pervaiz
#' @examples
#' data("mouseBrainSubsetSCE", package = "singleCellTK")
#' mouseBrainSubsetSCE <- runTSCAN(inSCE = mouseBrainSubsetSCE,
#'                                 useReducedDim = "PCA_logcounts")
#' plotTSCANResults(inSCE = mouseBrainSubsetSCE,
#'                  useReducedDim = "TSNE_logcounts")
plotTSCANResults <- function(inSCE, useReducedDim = "UMAP") {

    results <- getTSCANResults(inSCE, analysisName = "Pseudotime")
    clusters <- colData(inSCE)$TSCAN_clusters
    by.cluster <- scuttle::aggregateAcrossCells(inSCE, ids = clusters)
    line.data <- TSCAN::reportEdges(by.cluster, mst = results$mst,
                                    clusters = NULL, use.dimred = useReducedDim)

    scater::plotReducedDim(inSCE, dimred = useReducedDim,
                           colour_by = I(colData(inSCE)$TSCAN_pseudotime),
                           text_by = "TSCAN_clusters", text_colour = "black") +
        suppressMessages(ggplot2::scale_colour_viridis_c(name = "Pseudotime")) +
        ggplot2::geom_path(data = line.data,
                           ggplot2::aes_string(x = names(line.data)[2],
                                               y = names(line.data)[3],
                                               group = 'edge'))
}

###################################################
###  STEP 2:: identify expressive genes
###################################################
#' @title Test gene expression changes along a TSCAN trajectory path
#' @description Wrapper for identifying genes with significant changes with
#' respect to one of the TSCAN pseudotime paths
#' @param inSCE Input \linkS4class{SingleCellExperiment} object.
#' @param pathIndex Path index for which the pseudotime values should be used.
#' This corresponds to the terminal node of specific path from the root
#' node to the terminal node. Run \code{listTSCANTerminalNodes(inSCE)} for
#' available options.
#' @param useAssay Character. The name of the assay to use for testing the
#' expression change. Should be log-normalized. Default \code{"logcounts"}
#' @param discardCluster Cluster(s) which are not of use or masks other
#' interesting effects can be discarded. Default \code{NULL}.
#' @return The input \code{inSCE} with results updated in \code{metadata}.
#' @export
#' @author Nida Pervaiz
#' @examples
#' data("mouseBrainSubsetSCE", package = "singleCellTK")
#' mouseBrainSubsetSCE <- runTSCAN(inSCE = mouseBrainSubsetSCE,
#'                                 useReducedDim = "PCA_logcounts")
#' terminalNodes <- listTSCANTerminalNodes(mouseBrainSubsetSCE)
#' mouseBrainSubsetSCE <- runTSCANDEG(inSCE = mouseBrainSubsetSCE,
#'                                    pathIndex = terminalNodes[1])
runTSCANDEG <- function(inSCE,
                        pathIndex,
                        useAssay = "logcounts",
                        discardCluster = NULL) {
    nx <- inSCE
    if (!is.null(discardCluster)) {
        if (any(!discardCluster %in% unique(colData(nx)$TSCAN_clusters))) {
            stop("Not all `discardCluster` exist in TSCAN clusters")
        }
        nx <- nx[, !(colData(nx)$TSCAN_clusters %in% discardCluster)]
    }

    pseudo <- TSCAN::testPseudotime(nx,
                                    pseudotime = nx[[paste0("Path_", pathIndex,
                                                            "_pseudotime")]],
                                    assay.type = useAssay)
    pseudo <- pseudo[order(pseudo$FDR),]
    up.left <- pseudo[pseudo$logFC < 0,]
    up.right <- pseudo[pseudo$logFC > 0,]

    ## Save these results in a list and then make S4 accessor that passes the
    ## entire list
    pathresults <- list(discardClusters = discardCluster, upLeft = up.left,
                        upRight = up.right, useAssay = useAssay)
    getTSCANResults(inSCE, analysisName = "DEG",
                    pathName = as.character(pathIndex)) <- pathresults

    return (inSCE)
}

###################################################
###  plot heatmap of top genes
###################################################
#' @title Plot heatmap of genes with expression change along TSCAN pseudotime
#' @description A wrapper function which visualizes outputs from the
#' \code{\link{runTSCANDEG}} function. Plots the top genes that change in
#' expression with increasing pseudotime along the path in the MST.
#' \code{\link{runTSCANDEG}} has to be run in advance with using the same
#' \code{pathIndex} of interest.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object.
#' @param pathIndex Path index for which the pseudotime values should be used.
#' Should have being used in \code{\link{runTSCANDEG}}.
#' @param direction Should we show features with expression increasing or
#' decreeasing along the increase in TSCAN pseudotime? Choices are
#' \code{"both"}, \code{"increasing"} or \code{"decreasing"}.
#' @param topN An integer. Only to plot this number of top genes along the path
#' in the MST, in terms of FDR value. Use \code{NULL} to cancel the top N
#' subscription. Default \code{30}.
#' @param log2fcThreshold Only output DEGs with the absolute values of log2FC
#' larger than this value. Default \code{NULL}.
#' @param useAssay A single character to specify a feature expression matrix in
#' \code{assays} slot. The expression of top features from here will be
#' visualized. Default \code{NULL} use the one used for
#' \code{\link{runTSCANDEG}}.
#' @param featureDisplay Whether to display feature ID and what ID type to
#' display. Users can set default ID type by \code{\link{setSCTKDisplayRow}}.
#' \code{NULL} will display when number of features to display is less than 60.
#' \code{FALSE} for no display. Variable name in \code{rowData} to indicate ID
#' type. \code{"rownames"} or \code{TRUE} for using \code{rownames(inSCE)}.
#' @return A ComplexHeatmap in \code{.ggplot} class
#' @export
#' @author Nida Pervaiz
#' @importFrom S4Vectors metadata
#' @examples
#' data("mouseBrainSubsetSCE", package = "singleCellTK")
#' mouseBrainSubsetSCE <- runTSCAN(inSCE = mouseBrainSubsetSCE,
#'                                 useReducedDim = "PCA_logcounts")
#' terminalNodes <- listTSCANTerminalNodes(mouseBrainSubsetSCE)
#' mouseBrainSubsetSCE <- runTSCANDEG(inSCE = mouseBrainSubsetSCE,
#'                                    pathIndex = terminalNodes[1])
#' plotTSCANPseudotimeHeatmap(mouseBrainSubsetSCE,
#'                            pathIndex = terminalNodes[1])
plotTSCANPseudotimeHeatmap <- function(inSCE,
                                       pathIndex,
                                       direction = c("both", "increasing",
                                                     "decreasing"),
                                       topN = 50,
                                       log2fcThreshold = NULL,
                                       useAssay = NULL,
                                       featureDisplay = metadata(inSCE)$featureDisplay){
    results <- getTSCANResults(inSCE, analysisName = "DEG", pathName = pathIndex)
    direction <- match.arg(direction)
    # Organizing cells
    cell.idx <- rep(TRUE, ncol(inSCE))
    if(!is.null(results$discardClusters)){
        cell.idx <- cell.idx &
            (!colData(inSCE)$TSCAN_clusters %in% results$discardClusters)
    }
    colPathPseudo <- paste0("Path_", pathIndex, "_pseudotime")
    cell.idx <- cell.idx & !is.na(colData(inSCE)[[colPathPseudo]])
    cell.order <- order(colData(inSCE)[[colPathPseudo]])
    cell.order <- cell.order[cell.order %in% which(cell.idx)]

    # Organizing genes
    if (direction == "both") {
        degR <- results$upRight
        degL <- results$upLeft
        if (!is.null(log2fcThreshold)) {
            degR <- degR[abs(degR$logFC) > log2fcThreshold,]
            degL <- degL[abs(degL$logFC) > log2fcThreshold,]
        }
        genesR <- rownames(degR)[seq(min(topN, nrow(degR)))]
        genesL <- rownames(degL)[seq(min(topN, nrow(degL)))]
        genesR <- genesR[!is.na(genesR)]
        genesL <- genesL[!is.na(genesL)]
        genes <- c(genesL, genesR)
        if (length(genes) < 1) stop("No feature passed the filter.")
        direction.df <- data.frame(
            Direction = factor(c(rep("decreasing", length(genesL)),
                                 rep("increasing", length(genesR))),
                               levels = c("increasing", "decreasing")),
            row.names = genes)
    } else {
        if (direction == "increasing") deg <- results$upRight
        if (direction == "decreasing") deg <- results$upLeft
        if (!is.null(log2fcThreshold)) {
            deg <- deg[abs(deg$logFC) > log2fcThreshold,]
        }
        topN <- min(topN, nrow(deg))
        if (topN < 1) stop("No feature passed the filter.")
        genes <- rownames(deg)[seq(topN)]
        direction.df <- data.frame(Direction = rep(direction, length(genes)),
                                   row.names = genes)
    }
    rowLabel <- featureDisplay
    if (is.null(featureDisplay)) {
        if (length(genes) <= 60) rowLabel <- TRUE else rowLabel <- FALSE
    } else if (featureDisplay == "rownames") {
        rowLabel <- TRUE
    }
    cellAnnotationColor = list(
        .viridisPseudoTimeColor(colData(inSCE)[[colPathPseudo]])
    )
    names(cellAnnotationColor) <- colPathPseudo
    if (is.null(useAssay)) useAssay <- results$useAssay
    plotSCEHeatmap(inSCE = inSCE,
                   useAssay = useAssay,
                   cellIndex = cell.order,
                   featureIndex = genes,
                   colDend = FALSE,
                   rowDend = FALSE,
                   colDataName = c("TSCAN_clusters", colPathPseudo),
                   rowLabel = rowLabel,
                   featureAnnotations = direction.df,
                   rowSplitBy = "Direction",
                   cellAnnotationColor = cellAnnotationColor
    )
}

#' Basing on pseudotime is presented within range from 0 to 100
#' Use the viridis color scale to match with `plotTSCANResult` embedding color
#' @param x numeric vector of pseudotime
#' @return function object returned by circlize::colorRamp2
#' @noRd
.viridisPseudoTimeColor <- function(x) {
    a <- max(x, na.rm = TRUE)
    b <- min(x, na.rm = TRUE)
    chunk <- (a - b) / 4
    circlize::colorRamp2(seq(0,4) * chunk + b,
                         c("#440154", "#3b528b", "#21918c", "#5ec962", "#fde725"))
}

###################################################
###  plot expressive genes
###################################################
#' @title Plot expression changes of top features along a TSCAN pseudotime path
#' @description A wrapper function which visualizes outputs from the
#' \code{\link{runTSCANDEG}} function. Plots the genes that increase or decrease
#' in expression with increasing pseudotime along the path in the MST.
#' \code{\link{runTSCANDEG}} has to be run in advance with using the same
#' \code{pathIndex} of interest.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object.
#' @param pathIndex Path index for which the pseudotime values should be used.
#' Should have being used in \code{\link{runTSCANDEG}}.
#' @param direction Should we show features with expression increasing or
#' decreeasing along the increase in TSCAN pseudotime? Choices are
#' \code{"increasing"} or \code{"decreasing"}.
#' @param topN An integer. Only to plot this number of top genes that are
#' increasing/decreasing in expression with increasing pseudotime along
#' the path in the MST. Default 10
#' @param useAssay A single character to specify a feature expression matrix in
#' \code{assays} slot. The expression of top features from here will be
#' visualized. Default \code{NULL} use the one used for
#' \code{\link{runTSCANDEG}}.
#' @param featureDisplay Specify the feature ID type to display. Users can set
#' default value with \code{\link{setSCTKDisplayRow}}. \code{NULL} or
#' \code{"rownames"} specifies the rownames of \code{inSCE}. Other character
#' values indicates \code{rowData} variable.
#' @return A \code{.ggplot} object with the facets of the top genes. Expression
#' on y-axis, pseudotime on x-axis.
#' @export
#' @author Nida Pervaiz
#' @importFrom utils head
#' @importFrom S4Vectors metadata
#' @importFrom SummarizedExperiment rowData
#' @examples
#' data("mouseBrainSubsetSCE", package = "singleCellTK")
#' mouseBrainSubsetSCE <- runTSCAN(inSCE = mouseBrainSubsetSCE,
#'                                 useReducedDim = "PCA_logcounts")
#' terminalNodes <- listTSCANTerminalNodes(mouseBrainSubsetSCE)
#' mouseBrainSubsetSCE <- runTSCANDEG(inSCE = mouseBrainSubsetSCE,
#'                                    pathIndex = terminalNodes[1])
#' plotTSCANPseudotimeGenes(mouseBrainSubsetSCE,
#'                          pathIndex = terminalNodes[1],
#'                          useAssay = "logcounts")
plotTSCANPseudotimeGenes <- function(inSCE,
                                     pathIndex,
                                     direction = c("increasing", "decreasing"),
                                     topN = 10,
                                     useAssay = NULL,
                                     featureDisplay = metadata(inSCE)$featureDisplay){
    results <- getTSCANResults(inSCE, analysisName = "DEG", pathName = pathIndex)
    direction = match.arg(direction)
    if (!is.null(featureDisplay) &&
        featureDisplay == "rownames")
        featureDisplay <- NULL
    if(!is.null(results$discardClusters)){
        inSCE <- inSCE[,!colData(inSCE)$TSCAN_clusters %in% results$discardClusters]
    }
    if (direction == "decreasing") features <- rownames(results$upLeft)
    if (direction == "increasing") features <- rownames(results$upRight)
    features <- head(features, topN)
    if (!is.null(featureDisplay)) {
        features.idx <- featureIndex(features, inSCE)
        features <- rowData(inSCE)[[featureDisplay]][features.idx]
    }
    if (is.null(useAssay)) useAssay <- results$useAssay
    scater::plotExpression(inSCE,
                           features = features,
                           exprs_values = useAssay,
                           swap_rownames = featureDisplay,
                           x = paste0("Path_",pathIndex,"_pseudotime"),
                           colour_by = "TSCAN_clusters")
}

###################################################
###  STEP3:: identify DE genes in branch cluster
###################################################
#' @title Find DE genes between all TSCAN paths rooted from given cluster
#' @description This function finds all paths that root from a given cluster
#' \code{useCluster}, and performs tests to identify significant features for
#' each path, and are not significant and/or changing in the opposite direction
#' in the other paths. Using a branching cluster (i.e. a node with degree > 2)
#' may highlight features which are responsible for the branching event. MST has
#' to be pre-calculated with \code{\link{runTSCAN}}.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object.
#' @param useCluster The cluster to be regarded as the root, has to existing in
#' \code{colData(inSCE)$TSCAN_clusters}.
#' @param useAssay Character. The name of the assay to use. This assay should
#' contain log normalized counts. Default \code{"logcounts"}.
#' @param fdrThreshold Only out put DEGs with FDR value smaller than this value.
#' Default \code{0.05}.
#' @return The input \code{inSCE} with results updated in \code{metadata}.
#' @export
#' @author Nida Pervaiz
#' @examples
#' data("mouseBrainSubsetSCE", package = "singleCellTK")
#' mouseBrainSubsetSCE <- runTSCAN(inSCE = mouseBrainSubsetSCE,
#'                                 useReducedDim = "PCA_logcounts")
#' mouseBrainSubsetSCE <- runTSCANClusterDEAnalysis(inSCE = mouseBrainSubsetSCE,
#'                                          useCluster = 1)
runTSCANClusterDEAnalysis <- function(inSCE,
                                      useCluster,
                                      useAssay = "logcounts",
                                      fdrThreshold = 0.05) {
    results <- getTSCANResults(inSCE, analysisName = "Pseudotime")
    message(date(), " ... Finding DEG between TSCAN branches")
    tscan.pseudo <- TSCAN::orderCells(results$maptscan, mst = results$mst,
                                      start = useCluster)
    nPaths <- colnames(tscan.pseudo)

    pathClusters <- list()
    pathList <- data.frame()

    x <- inSCE[,colData(inSCE)$TSCAN_clusters == useCluster]
    store <- list()
    genes <- list()

    for(i in seq(nPaths)){
        # Get Pseudotime of a path
        pathIndex = as.character(nPaths[i])
        branchPseudotime <- TrajectoryUtils::pathStat(tscan.pseudo)[,pathIndex]
        colDataVarName <- paste0("TSCAN_Cluster", useCluster,
                                 "_Path_", pathIndex, "_pseudotime")
        colData(inSCE)[[colDataVarName]] <- branchPseudotime
        nonNA.idx <- !is.na(branchPseudotime)
        pathClusters[[pathIndex]] <- unique(colData(inSCE)$TSCAN_clusters[nonNA.idx])
        pathList[i,1] <- pathIndex
        pathList[i,2] <- toString(pathClusters[[pathIndex]])
        message(date(), " ...   Clusters involved in path index ", pathIndex,
                " are: ", paste(pathClusters[[i]], collapse = ", "))
        # Test along the path
        pseudo.df <- TSCAN::testPseudotime(
            x, df = 1,
            pseudotime = branchPseudotime[colData(inSCE)$TSCAN_clusters == useCluster],
            assay.type = useAssay)
        pseudo.df <- pseudo.df[order(pseudo.df$p.value),]
        store[[pathIndex]] <- pseudo.df
    }
    # Filter against all other paths
    genes <- list()
    for(i in seq(nPaths)){
        pseudo.df <- store[[nPaths[i]]]
        paths <- setdiff(seq(nPaths), i)
        idx <- pseudo.df$FDR < fdrThreshold
        for(j in seq_along(paths)){
            pseudo.otherPath <- store[[paths[j]]]
            idx <- idx & (pseudo.otherPath$p.value >= 0.05 |
                              sign(pseudo.otherPath$logFC) != sign(pseudo.df$logFC))
        }
        pseudo.df <- pseudo.df[which(idx), ]
        genes[[nPaths[i]]] <- pseudo.df[order(pseudo.df$FDR),]
    }

    maxWidth <- max(stringr::str_length(pathList[, 1]))
    choiceList <- paste0(stringr::str_pad(pathList[, 1], width=maxWidth,
                                          side="right"),
                         "|", pathList[, 2])
    expGenes <- list(DEgenes = genes, useAssay = useAssay,
                     terminalNodes = tscan.pseudo,
                     pathIndexList = choiceList)
    getTSCANResults(inSCE, analysisName = "ClusterDEAnalysis",
                    pathName = useCluster) <- expGenes
    return(inSCE)
}

###################################################
###  plot branch cluster
###################################################
#' @title Plot TSCAN pseudotime rooted from given cluster
#' @description This function finds all paths that root from a given cluster
#' \code{useCluster}. For each path, this function plots the recomputed
#' pseudotime starting from the root on a scatter plot which contains cells only
#' in this cluster. MST has to be pre-calculated with \code{\link{runTSCAN}}.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object.
#' @param useCluster The cluster to be regarded as the root, has to existing in
#' \code{colData(inSCE)$TSCAN_clusters}.
#' @param useReducedDim Saved dimension reduction name in the
#' SingleCellExperiment object. Required.
#' @param combinePlot Must be either \code{"all"} or \code{"none"}. \code{"all"}
#' will combine plots of pseudotime along each path into a single \code{.ggplot}
#' object, while \code{"none"} will output a list of plots. Default
#' \code{"all"}.
#' @return
#' \item{combinePlot = "all"}{A \code{.ggplot} object}
#' \item{combinePlot = "none"}{A list of \code{.ggplot}}
#' @export
#' @author Nida Pervaiz
#' @importFrom utils head
#' @examples
#' data("mouseBrainSubsetSCE", package = "singleCellTK")
#' mouseBrainSubsetSCE <- runTSCAN(inSCE = mouseBrainSubsetSCE,
#'                                 useReducedDim = "PCA_logcounts")
#' plotTSCANClusterPseudo(mouseBrainSubsetSCE, useCluster = 1,
#'                        useReducedDim = "TSNE_logcounts")
plotTSCANClusterPseudo <- function(inSCE, useCluster, useReducedDim = "UMAP",
                                   combinePlot = c("all", "none")){
    # Get the plotting info of edges
    results <- getTSCANResults(inSCE, analysisName = "Pseudotime")
    combinePlot <- match.arg(combinePlot)
    clusters <- colData(inSCE)$TSCAN_clusters
    by.cluster <- scuttle::aggregateAcrossCells(inSCE, ids = clusters)
    line.data <- TSCAN::reportEdges(by.cluster, mst = results$mst,
                                    clusters = NULL, use.dimred = useReducedDim)
    line.data.sub <- .getClustersLineData(line.data, useCluster)

    # Get Branch pseudotime
    tscan.pseudo <- TSCAN::orderCells(results$maptscan, mst = results$mst,
                                      start = useCluster)
    nPaths <- colnames(tscan.pseudo)
    x <- inSCE[,colData(inSCE)$TSCAN_clusters == useCluster]
    plotList <- list()
    for (i in seq(nPaths)) {
        branchPseudotime <- TrajectoryUtils::pathStat(tscan.pseudo)[,i]
        branchPseudotime <- branchPseudotime[colData(inSCE)$TSCAN_clusters == useCluster]
        x$pseudotime <- branchPseudotime
        plotList[[i]] <- scater::plotReducedDim(x, dimred = useReducedDim,
                                                colour_by = "pseudotime",
                                                text_by = "TSCAN_clusters",
                                                text_colour = "black") +
            ggplot2::geom_line(data = line.data.sub,
                               ggplot2::aes_string(x = colnames(line.data.sub)[2],
                                                   y = colnames(line.data.sub)[3],
                                                   group = "edge"))
    }
    if (combinePlot == "all") {
        plotList <- cowplot::plot_grid(plotlist = plotList)
    }
    return(plotList)
}

###################################################
###  plot gene of interest in branch cluster
###################################################

#' @title Plot features identified by \code{\link{runTSCANClusterDEAnalysis}} on
#' cell 2D embedding with MST overlaid
#' @description A wrapper function which plot the top features expression
#' identified by \code{\link{runTSCANClusterDEAnalysis}} on the 2D embedding of
#' the cells cluster used in the analysis. The related MST edges are overlaid.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object.
#' @param useCluster Choose a cluster used for identifying DEG with
#' \code{\link{runTSCANClusterDEAnalysis}}. Required.
#' @param pathIndex Specifies one of the branching paths from \code{useCluster}
#' and plot the top DEGs on this path. Ususally presented by the terminal
#' cluster of a path. By default \code{NULL} plot top DEGs of all paths.
#' @param useReducedDim A single character for the matrix of 2D embedding.
#' Should exist in \code{reducedDims} slot. Default \code{"UMAP"}.
#' @param topN Integer. Use top N genes identified. Default \code{9}.
#' @param useAssay A single character for the feature expression matrix. Should
#' exist in \code{assayNames(inSCE)}. Default \code{NULL} for using the one used
#' in \code{\link{runTSCANClusterDEAnalysis}}.
#' @param featureDisplay Specify the feature ID type to display. Users can set
#' default value with \code{\link{setSCTKDisplayRow}}. \code{NULL} or
#' \code{"rownames"} specifies the rownames of \code{inSCE}. Other character
#' values indicates \code{rowData} variable.
#' @param combinePlot Must be either \code{"all"} or \code{"none"}. \code{"all"}
#' will combine plots of each feature into a single \code{.ggplot} object,
#' while \code{"none"} will output a list of plots. Default \code{"all"}.
#' @return A \code{.ggplot} object of cell scatter plot, colored by the
#' expression of a gene identified by \code{\link{runTSCANClusterDEAnalysis}},
#' with the layer of trajectory.
#' @export
#' @author Yichen Wang
#' @importFrom S4Vectors metadata
#' @examples
#' data("mouseBrainSubsetSCE", package = "singleCellTK")
#' mouseBrainSubsetSCE <- runTSCAN(inSCE = mouseBrainSubsetSCE,
#'                                 useReducedDim = "PCA_logcounts")
#' mouseBrainSubsetSCE <- runTSCANClusterDEAnalysis(inSCE = mouseBrainSubsetSCE,
#'                                                  useCluster = 1)
#' plotTSCANClusterDEG(mouseBrainSubsetSCE, useCluster = 1,
#'                     useReducedDim = "TSNE_logcounts")
plotTSCANClusterDEG <- function(
        inSCE,
        useCluster,
        pathIndex = NULL,
        useReducedDim = "UMAP",
        topN = 9,
        useAssay = NULL,
        featureDisplay = metadata(inSCE)$featureDisplay,
        combinePlot = c("all", "none")
) {
    MSTResults <- getTSCANResults(inSCE, analysisName = "Pseudotime")
    if (length(useCluster) != 1) stop("Can only specify one cluster")
    DEResults <- getTSCANResults(inSCE, analysisName = "ClusterDEAnalysis",
                                 pathName = useCluster)
    if (is.null(DEResults)) {
        stop("Branch DE result of specified cluster not found. Run ",
             "`runTSCANClusterDEAnalysis()` with the same `useCluster` first.")
    }
    combinePlot <- match.arg(combinePlot)
    if (is.null(pathIndex)) {
        deg <- do.call(rbind, DEResults$DEgenes)
        deg <- deg[order(deg$FDR),]
    } else {
        pathIndex <- as.character(pathIndex)
        deg <- DEResults$DEgenes[[pathIndex]]
    }
    features <- rownames(deg)[seq(min(topN, nrow(deg), na.rm = TRUE))]
    if (is.null(useAssay)) useAssay <- DEResults$useAssay
    plotTSCANDimReduceFeatures(inSCE = inSCE, features = features,
                               useReducedDim = useReducedDim,
                               useAssay = useAssay, useCluster = useCluster,
                               featureDisplay = featureDisplay,
                               combinePlot = combinePlot)
}

#' @title Plot feature expression on cell 2D embedding with MST overlaid
#' @description A wrapper function which plots all cells or cells in chosen
#' cluster. Each point is a cell colored by the expression of a feature of
#' interest, the relevant edges of the MST are overlaid on top.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object.
#' @param features Choose the feature of interest to explore the expression
#' level on the trajectory. Required.
#' @param useReducedDim A single character for the matrix of 2D embedding.
#' Should exist in \code{reducedDims} slot. Default \code{"UMAP"}.
#' @param useAssay A single character for the feature expression matrix. Should
#' exist in \code{assayNames(inSCE)}. Default \code{"logcounts"}.
#' @param by Where should \code{features} be found? \code{NULL},
#' \code{"rownames"} for \code{rownames(inSCE)}, otherwise will be regarded as
#' \code{rowData} variable.
#' @param useCluster Choose specific clusters where gene expression needs to be
#' visualized. By default \code{NULL}, all clusters are chosen.
#' @param featureDisplay Specify the feature ID type to display. Users can set
#' default value with \code{\link{setSCTKDisplayRow}}. \code{NULL} or
#' \code{"rownames"} specifies the rownames of \code{inSCE}. Other character
#' values indicates \code{rowData} variable.
#' @param combinePlot Must be either \code{"all"} or \code{"none"}. \code{"all"}
#' will combine plots of each feature into a single \code{.ggplot} object,
#' while \code{"none"} will output a list of plots. Default \code{"all"}.
#' @return A \code{.ggplot} object of cell scatter plot, colored by the
#' expression of a gene of interest, with the layer of trajectory.
#' @export
#' @author Yichen Wang
#' @importFrom S4Vectors metadata
#' @examples
#' data("mouseBrainSubsetSCE", package = "singleCellTK")
#' mouseBrainSubsetSCE <- runTSCAN(inSCE = mouseBrainSubsetSCE,
#'                                 useReducedDim = "PCA_logcounts")
#' plotTSCANDimReduceFeatures(inSCE = mouseBrainSubsetSCE,
#'                            features = "Tshz1",
#'                            useReducedDim = "TSNE_logcounts")
plotTSCANDimReduceFeatures <- function(
        inSCE,
        features,
        useReducedDim = "UMAP",
        useAssay = "logcounts",
        by = "rownames",
        useCluster = NULL,
        featureDisplay = metadata(inSCE)$featureDisplay,
        combinePlot = c("all", "none"))
{
    results <- getTSCANResults(inSCE, analysisName = "Pseudotime")
    combinePlot <- match.arg(combinePlot)
    clusters <- colData(inSCE)$TSCAN_clusters
    by.cluster <- scuttle::aggregateAcrossCells(inSCE, ids = clusters)
    line.data <- TSCAN::reportEdges(by.cluster, mst = results$mst,
                                    clusters = NULL, use.dimred = useReducedDim)
    if (!is.null(useCluster)) {
        line.data <- .getClustersLineData(line.data, useCluster)
        inSCE <- inSCE[, clusters %in% useCluster]
    }
    if (by == "rownames") by <- NULL
    plotList <- list()
    features <- stats::na.omit(features)
    for (f in features) {
        # Should not enter the loop if features is length zero after NA omit
        g <- plotSCEDimReduceFeatures(inSCE, features = f,
                                      useAssay = useAssay,
                                      featureLocation = by,dim1 = 1, dim2 = 2,
                                      featureDisplay = featureDisplay,
                                      reducedDimName = useReducedDim,
                                      title = f) +
            ggplot2::geom_line(data = line.data,
                               ggplot2::aes_string(x = colnames(line.data)[2],
                                                   y = colnames(line.data)[3],
                                                   group = "edge"),
                               inherit.aes = FALSE)
        # Text labeling code credit: scater
        reddim <- as.data.frame(SingleCellExperiment::reducedDim(inSCE,
                                                                 useReducedDim))
        text_out <- scater::retrieveCellInfo(inSCE, "TSCAN_clusters",
                                             search = "colData")
        by_text_x <- vapply(split(reddim[,1], text_out$val),
                            stats::median, FUN.VALUE = 0)
        by_text_y <- vapply(split(reddim[,2], text_out$val),
                            stats::median, FUN.VALUE = 0)
        g <- g + ggrepel::geom_text_repel(
            data = data.frame(x = by_text_x,
                              y = by_text_y,
                              label = names(by_text_x)),
            mapping = ggplot2::aes_string(x = "x",
                                          y = "y",
                                          label = "label"),
            inherit.aes = FALSE, na.rm = TRUE,
        )
        plotList[[f]] <- g
    }
    if (combinePlot == "all") {
        if (length(plotList) > 0)
            plotList <- cowplot::plot_grid(plotlist = plotList)
    }
    return(plotList)
}

#' Extract edges that connects to the clusters of interest
#' @param line.data data.frame of three columns. First column should be named
#' "edge", the other two are coordinates of one of the vertices that this
#' edge connects.
#' @param useCluster Vector of clusters, that are going to be the vertices for
#' edge finding.
#' @return data.frame, subset rows of line.data
#' @noRd
.getClustersLineData <- function(line.data, useCluster) {
    idx <- vapply(useCluster, function(x){
        grepl(paste0("^", x, "--"), line.data$edge) |
            grepl(paste0("--", x, "$"), line.data$edge)
    }, logical(nrow(line.data)))
    # `idx` returned was c("matrix", "array") class. Each column is a logical
    # vector for edge selection of each cluster.
    # Next, do "or" for each row.
    idx <- rowSums(idx) > 0
    line.data[idx,]
}

# Trajectory Analysis
library(singleCellTK)
context("Testing Trajectory analysis function")

data("scExample", package = "singleCellTK")
sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
sce <- runNormalization(sce,
                        normalizationMethod = "LogNormalize",
                        useAssay = "counts",
                        outAssayName = "logcounts")
sce <- runDimReduce(inSCE = sce,
                    method = "scaterPCA",
                    useAssay = "logcounts",
                    reducedDimName = "PCA")
sce <- runDimReduce(inSCE = sce,
                    method = "rTSNE",
                    useReducedDim = "PCA",
                    reducedDimName = "TSNE")

test_that(desc = "Testing TSCAN", {
  sce <- runTSCAN(inSCE = sce, useReducedDim = "PCA", seed = NULL)
  terminalNodes <- listTSCANTerminalNodes(sce)
  sce <- runTSCANDEG(inSCE = sce, pathIndex = terminalNodes[1])
  sce <- runTSCANClusterDEAnalysis(inSCE = sce, useCluster = 1)
  testthat::expect_true(!is.null(names(
                          getTSCANResults(sce,
                                          analysisName = "Pseudotime"))))
  testthat::expect_true(!is.null(names(
                          getTSCANResults(sce,
                                          analysisName = "DEG",
                                          terminalNodes[1]))))
  testthat::expect_true(!is.null(names(
                          getTSCANResults(sce,
                                          analysisName = "ClusterDEAnalysis",
                                          1))))


  TSCANResultsPlot <- plotTSCANResults(inSCE = sce, useReducedDim = "TSNE")
  TSCANPseudotimeHeatmapPlot1 <- plotTSCANPseudotimeHeatmap(inSCE = sce,
                                                           pathIndex = terminalNodes[1],
                                                           direction = "both",
                                                           log2fcThreshold = 0.001,
                                                           topN = 5)
  TSCANPseudotimeHeatmapPlot2 <- plotTSCANPseudotimeHeatmap(inSCE = sce,
                                                            pathIndex = terminalNodes[1],
                                                            direction = "inc",
                                                            log2fcThreshold = 0.001,
                                                            topN = 5)
  TSCANPseudotimeGenesPlot <- plotTSCANPseudotimeGenes(inSCE = sce,
                                                       pathIndex = terminalNodes[1],
                                                       direction = "increasing")
  ClusterPseudoPlot <- plotTSCANClusterPseudo(inSCE = sce,
                                              useCluster = 1,
                                              useReducedDim = "TSNE")
  TSCANBranchGenesPlot <- plotTSCANClusterDEG(inSCE = sce,
                                             useCluster = 1,
                                             useReducedDim = "TSNE")
  TSCANFeaturePlot <- plotTSCANDimReduceFeatures(inSCE = sce,
                                                 feature = "CD74",
                                                 by = "feature_name",
                                                 useReducedDim = "TSNE",
                                                 featureDisplay = "feature_name")

  testthat::expect_is(TSCANResultsPlot, "ggplot")
  testthat::expect_is(TSCANPseudotimeHeatmapPlot1, "Heatmap")
  testthat::expect_is(TSCANPseudotimeHeatmapPlot2, "Heatmap")
  testthat::expect_is(TSCANPseudotimeGenesPlot, "ggplot")
  testthat::expect_is(ClusterPseudoPlot, "ggplot")
  testthat::expect_is(TSCANFeaturePlot, "ggplot")
})

.readDropEstFile <- function(sampleDir, dataType,rdsFileName){
  dropEst_cell_counts <- file.path(sampleDir, paste(rdsFileName, '.rds', sep=''))
  if (!file.exists(dropEst_cell_counts)){
    stop("DropEst output not found at location specified. Please check path provided and/or filename.")
  }
  dropEst_rds <- readRDS(dropEst_cell_counts)

  return(dropEst_rds)
}

.constructColdata <- function(dropEst_rds,counts_matrix, dataType){
  coldata_fields <- c("mean_reads_per_umi","aligned_reads_per_cell","aligned_umis_per_cell","requested_umis_per_cb","requested_reads_per_cb")
  coldata_df <-  list()
  for (field in coldata_fields){
    if (field %in% names(dropEst_rds)){
      coldata_field_df <- data.frame(as.matrix(dropEst_rds[[field]]))
      names(coldata_field_df)[1] <- field
      coldata_field_df$cell <- row.names(coldata_field_df)

      coldata_df[[field]] <- coldata_field_df
    }}
  coldata_df_merged <- Reduce(function(x, y) merge(x, y, all=TRUE,by="cell"), coldata_df)
  row.names(coldata_df_merged) <- coldata_df_merged$cell
  coldata_df_merged <- S4Vectors::DataFrame(as.matrix(coldata_df_merged))
  if (dataType == 'filtered'){
    coldata_df_merged <- coldata_df_merged[coldata_df_merged$cell %in% colnames(counts_matrix),]
  }
  return(coldata_df_merged)
}

.extractMetadata <- function(dropEst_rds){
  metadata_fields <- c("saturation_info","merge_targets","reads_per_umi_per_cell")
  metadata <- c()
  for (md in metadata_fields){
    if (md %in% names(dropEst_rds)){
      metadata[[md]] <- dropEst_rds[[md]]
    }}
  return(metadata)
}

.importDropEstSample <- function(sampleDir = './',
                                 dataType,
                                 rdsFileName,
                                 sampleName = 'sample',
                                 delayedArray = FALSE,
                                 class){
  ## Read DropEst RDS
  dropEst_rds <- .readDropEstFile(sampleDir,dataType,rdsFileName)
  if (dataType == 'filtered' && 'cm' %in% names(dropEst_rds)) {
    counts_matrix <- dropEst_rds$cm
  } else if (dataType == 'raw' && 'cm_raw' %in% names(dropEst_rds)) {
    counts_matrix <- dropEst_rds$cm_raw
  } else {
    stop("No counts matrix found in the .rds provided! Exiting.")
  }

  if (class == "Matrix") {
    counts_matrix <- .convertToMatrix(counts_matrix)
  } else if (class == "matrix") {
    counts_matrix <- base::as.matrix(counts_matrix)
  }

  if (isTRUE(delayedArray)) {
    counts_matrix <- DelayedArray::DelayedArray(counts_matrix)
  }
  ## Create SingleCellExperiment object
  ## Add SCE ColData. If using filtered counts matrix, colData is subset to include filtered cells.
  ## append sample name to cells in SCE
  sce <- SingleCellExperiment::SingleCellExperiment(assays = list(counts = counts_matrix))
  colnames(sce) <- paste0(sampleName,"_",colnames(sce))
  sce_coldata <- .constructColdata(dropEst_rds, counts_matrix, dataType)
  row.names(sce_coldata) <- paste0(sampleName,"_",row.names(sce_coldata))

  if (dim(counts_matrix)[2] == dim(sce_coldata)[1]){
    SummarizedExperiment::colData(sce) <- sce_coldata
  } else {
    warning("Unable to add ColData to SCE. nCol of Counts Matrix not equal to nRow of ColData matrix.")
  }

  ## Add SCE metadata
  sce_metadata <- .extractMetadata(dropEst_rds)
  sce@metadata$dropEst <- sce_metadata
  
  return(sce)
}

#' @name importDropEst
#' @rdname importDropEst
#' @title Create a SingleCellExperiment Object from DropEst output
#' @description imports the RDS file created by DropEst (https://github.com/hms-dbmi/dropEst) and
#' create a SingleCellExperiment object from either the raw or filtered counts matrix.
#' Additionally parse through the RDS to obtain appropriate feature annotations as
#' SCE coldata, in addition to any metadata.
#' @param sampleDirs  A path to the directory containing the data files. Default "./".
#' @param sampleNames A User-defined sample name. This will be prepended to all cell barcode IDs.
#'  Default "sample".
#' @param dataType can be "filtered" or "raw". Default \code{"filtered"}.
#' @param rdsFileName File name prefix of the DropEst RDS output. default is "cell.counts"
#' @param delayedArray Boolean. Whether to read the expression matrix as
#'  \link{DelayedArray} object or not. Default \code{FALSE}.
#' @param class Character. The class of the expression matrix stored in the SCE
#'  object. Can be one of "Matrix" (as returned by
#'  \link{readMM} function), or "matrix" (as returned by
#'  \link[base]{matrix} function). Default \code{"Matrix"}.
#' @param rowNamesDedup Boolean. Whether to deduplicate rownames. Default 
#'  \code{TRUE}.
#' @details
#' \code{importDropEst} expects either raw counts matrix stored as "cm_raw" or filtered
#' counts matrix stored as "cm" in the DropEst rds output.
#' ColData is obtained from the DropEst corresponding to "mean_reads_per_umi","aligned_reads_per_cell",
#' "aligned_umis_per_cell","requested_umis_per_cb","requested_reads_per_cb"
#' If using filtered counts matrix, the colData dataframe is
#' subset to contain features from the filtered counts matrix alone.
#' If any annotations of ("saturation_info","merge_targets","reads_per_umi_per_cell") are
#' found in the DropEst rds, they will be added to the SCE metadata field
#' @return A \code{SingleCellExperiment} object containing the count matrix,
#'  the feature annotations from DropEst as ColData, and any metadata from DropEst
#' @examples
#' # Example results were generated as per instructions from the developers of dropEst described in
#' # https://github.com/hms-dbmi/dropEst/blob/master/examples/EXAMPLES.md
#' sce <- importDropEst(sampleDirs = system.file("extdata/dropEst_scg71", package = "singleCellTK"),
#'                      sampleNames = 'scg71')
#' @export
importDropEst <- function(sampleDirs = NULL,
                          dataType = c('filtered','raw'),
                          rdsFileName = 'cell.counts',
                          sampleNames = NULL,
                          delayedArray = FALSE,
                          class = c("Matrix", "matrix"),
                          rowNamesDedup = TRUE) {
  dataType <- match.arg(dataType)
  class <- match.arg(class)

  if (length(sampleDirs)!=length(sampleNames)){
    stop("Please provide sample names for all input directories")
  }

  res <- vector("list", length = length(sampleDirs))

  for (i in seq_along(sampleDirs)){
    scei <- .importDropEstSample(sampleDir = sampleDirs[[i]],
                         sampleName = sampleNames[[i]],
                         dataType = dataType,
                         rdsFileName = rdsFileName,
                         delayedArray = delayedArray,
                         class = class)
    res[[i]] <- scei
  }
  sce <- do.call(SingleCellExperiment::cbind, res)
  
  if (isTRUE(rowNamesDedup)) {
    if (any(duplicated(rownames(sce)))) {
      message("Duplicated gene names found, adding '-1', '-2', ",
              "... suffix to them.")
    }
    sce <- dedupRowNames(sce)
  }
  
  return(sce)
}

# Check if CRAN packages are installed, otherwise prompt user to install them.
requiredPackages <- c("shinyjqui", "shinyWidgets", "shinythemes", "shinyFiles",
                      "shinyBS", "shinybusy", "tidyverse")
if(!all(requiredPackages %in% installed.packages())){
  missingPackages <- requiredPackages[which(requiredPackages %in% installed.packages() == FALSE)]
  message("Installing missing packages: ")
  message(paste0(missingPackages, collapse = " "))
  install.packages(missingPackages)
}

library(shiny)
library(shinyjs)
library(shinyFiles)
library(ComplexHeatmap)
library(limma)
library(ggplot2)
library(plotly)
library(data.table)
library(colourpicker)
library(gridExtra)
library(cluster)
library(ggtree)
library(ape)
library(GSVA)
library(GSVAdata)
library(shinyalert)
library(enrichR)
library(matrixStats)
library(Biobase)
library(base)
library(SingleCellExperiment)
library(singleCellTK)
library(celda)
library(shinycssloaders)
library(shinythemes)
library(shinyBS);
library(shinyjqui);
library(Seurat);
library(ggplotify);
library(ggplot2);
library(cowplot);
library(tidyverse)
library(dplyr)
library(readxl)
library(broom)
library(RColorBrewer)
library(grDevices)
library(shinyWidgets)
library(stringr)
library(Hmisc)
library(tibble)
# library(pushbar)
# library(spsComps)


source("helpers.R")
source("colourGroupInput.R")
data("c2BroadSets")

#source modules
source("module_nonLinearWorkflow.R")
source("module_filterTable.R")

docs.base <- paste0("https://www.camplab.net/sctk/v",
                    package.version("singleCellTK"), "/")
docs.artPath <- paste0(docs.base, "articles/")

#test internet connection for enrichR connectivity
internetConnection <- suppressWarnings(Biobase::testBioCConnection())

clusterChoice <- ""
sampleChoice <- ""
featureChoice <- ""
geneChoice <- ""
alertText <- ""
pcComponents <- ""
numClusters <- ""
currassays <- ""
currreddim <- ""
curraltExps <- ""
currGS <- ""
#from SCE
cell_list <- ""
gene_list <- ""
#from assays
method_list <- ""
#from reduced
approach_list <- ""
#from colData
annotation_list <- ""
#from RColorBrewer
colorbrewer_list <- rownames(RColorBrewer::brewer.pal.info)
color_table <- RColorBrewer::brewer.pal.info %>% data.frame()
color_seqdiv <- rownames(color_table[which(color_table$category == "div"
                                           |color_table$category == "seq"),])
if (internetConnection){
  enrichedDB <- listEnrichrDbs()$libraryName
} else {
  enrichedDB <- ""
}
numSamples <- 30
pcComponentsSelectedY <- NULL
if (!is.null(getShinyOption("inputSCEset"))){
  numSamples <- ncol(getShinyOption("inputSCEset"))
  clusterChoice <- colnames(colData(getShinyOption("inputSCEset")))
  geneChoice <- rownames(getShinyOption("inputSCEset"))
  sampleChoice <- colnames(getShinyOption("inputSCEset"))
  featureChoice <- colnames(rowData(getShinyOption("inputSCEset")))
  pcComponents <- paste("PC", 1:numSamples, sep = "")
  pcComponentsSelectedY <- pcComponents[2]
  numClusters <- 1:numSamples
  currassays <- names(assays(getShinyOption("inputSCEset")))
  currreddim <- names(reducedDims(getShinyOption("inputSCEset")))
  curraltExps <- names(altExp(getShinyOption("inputSCEset")))
  currGS <- sctkListGeneSetCollections(getShinyOption("inputSCEset"))
  ###############################################################
  #from sce
  cell_list <- colnames(getShinyOption("inputSCEset"))
  gene_list <- rownames(getShinyOption("inputSCEset"))
  #from assays
  method_list <- names(assays(getShinyOption("inputSCEset")))
  #from reduced
  approach_list <- names(reducedDims(getShinyOption("inputSCEset")))
  #from colData
  annotation_list <- names(colData(getShinyOption("inputSCEset")))
  #from colorbrewer
  colorbrewer_list <- rownames(RColorBrewer::brewer.pal.info)
  color_table <- RColorBrewer::brewer.pal.info %>% data.frame()
  color_seqdiv <- rownames(color_table[which(color_table$category == "div"|color_table$category == "seq"),])
  ###############################################################
  alertText <- HTML("<div class='alert alert-success alert-dismissible'>\
                    <span class='glyphicon glyphicon-ok' aria-hidden='true'>\
                    </span> Successfully Uploaded from Command Line! <button \
                    type='button' class='close' data-dismiss='alert'>&times;\
                    </button></div>")
}

if (is.null(getShinyOption("theme"))){
  shinyTheme <- "flatly"
} else {
  shinyTheme <- getShinyOption("theme")
}

source("ui_00_helloWorld.R")
source("ui_01_import.R", local = TRUE) #creates shinyPanelImport variable
source("ui_01_gene_sets.R", local = TRUE) #creates shinyPanelGeneSets variable
source("ui_01_columnAnnotation.R", local = TRUE) #creates shinyPanelColumnAnnotation variable
source("ui_01_rowAnnotation.R", local = TRUE) #creates shinyPanelRowAnnotation variable
source("ui_01_removeData.R", local = TRUE) #creates shinyPanelRemove variable
source("ui_export.R", local = TRUE) #creates shinyPanelExport variable
source("ui_02_qc_filter.R", local = TRUE) #creates shinyPanelQCFilter variable
source("ui_03_2_cluster.R", local = TRUE) #creates shinyPanelCluster variable
source("ui_09_3_celdaWorkflow.R", local = TRUE) #creates shinyPanelCelda variable
source("ui_04_batchcorrect.R", local = TRUE) #creates shinyPanelBatchcorrect variable
source("ui_04_fs_dimred.R", local = TRUE) #creates shinyPanelFS_DimRed variable
source("ui_05_1_diffex.R", local = TRUE) #creates shinyPanelDiffex variable
source("ui_05_2_findMarker.R", local = TRUE) #creates shinyPanelfindMarker variable
source("ui_05_3_cellTypeLabel.R", local = TRUE) # creates shinyPanelLabelCellType variable
#source("ui_06_1_pathway.R", local = TRUE) #creates shinyPanelPathway variable
source("ui_06_2_enrichR.R", local = TRUE) #creates shinyPanelEnrichR variable
source("ui_06_1_pathwayAnalysis.R", local = TRUE) #creates shinyPanelvam variable
source("ui_10_1_TSCAN.R", local = TRUE) #creates shinyPanelTSCAN variable
source("ui_07_subsample.R", local = TRUE) #creates shinyPanelSubsample variable
source("ui_08_2_cellviewer.R", local = TRUE) #creates shinyPanelCellViewer variable
source("ui_08_3_heatmap.R", local = TRUE) #creates shinyPanelHeatmap variable
source("ui_08_4_bubbleplot.R", local = TRUE) #creates shinyPanelBubbleplot variable
#source("ui_09_curatedworkflows.R", local = TRUE) #creates shinyPanelCuratedWorkflows variable
source("ui_09_2_seuratWorkflow.R", local = TRUE) #creates shinyPanelSeurat variable
source("ui_09_4_scanpyWorkflow.R", local = TRUE) #creates shinyPanelSeurat variable
jsCode <- "
shinyjs.disableTabs = function() {
  let tabs = $('.nav li a').not('a[data-value=\"Data\"], a[data-value=\"Import\"]');
  tabs.bind('click', function(e) {
    e.preventDefault();
    return false;
  });
  tabs.addClass('disabled');
}
shinyjs.enableTabs = function() {
  let tabs = $('.nav li a');
  tabs.unbind('click');
  tabs.removeClass('disabled');
}
"

jsScriptAutoScrollConsole <- "
function mutate(mutations) {
  mutations.forEach(function(mutation) {
    alert(mutation.type);
  });
}

function startAutoScroll() {
                var $panel = $('#consolePanel');
    $panel.animate({scrollTop: $panel.prop('scrollHeight')});
}

var target = document.querySelector('#consoleText')
var observer = new MutationObserver( mutate );
var config = { characterData: false, attributes: false, childList: true, subtree: false };
observer.observe(target, config);
"


if (is.null(getShinyOption("includeVersion"))){
  tooltitle <- paste("Single Cell Toolkit v",
                     packageVersion("singleCellTK"), sep = "")
} else {
  if (getShinyOption("includeVersion")){
    tooltitle <- paste("Single Cell Toolkit v",
                       packageVersion("singleCellTK"), sep = "")
  } else {
    tooltitle <- "Single Cell Toolkit"
  }
}

shinyUI(
    navbarPage(
      tooltitle,
      id = "navbar",
      # selected="CellViewer",
      # theme = shinytheme(shinyTheme),
      theme = shinytheme("yeti"),
      navbarMenu(
        "Data",
        tabPanel("Import Single Cell Data", shinyPanelImport),
        tabPanel("Import Gene Sets", shinyPanelGeneSets),
        tabPanel("Cell Annotation", shinyPanelColumnAnnotation),
        tabPanel("Feature Annotation", shinyPanelRowAnnotation),
        tabPanel("Export Single Cell Data", shinyPanelExport),
        tabPanel("Delete Single Cell Data", shinyPanelRemove)
      ),
      tabPanel("QC & Filtering", shinyPanelQCFilter),
      tabPanel("Normalization & Batch Correction", shinyPanelBatchcorrect),
      tabPanel("Feature Selection & Dimensionality Reduction", shinyPanelFS_DimRed),
      tabPanel("Clustering", shinyPanelCluster),
      navbarMenu(
        "Differential Expression & Cell Type Labeling",
        tabPanel("Find Marker", shinyPanelfindMarker),
        tabPanel("Differential Expression", shinyPanelDiffex),
        tabPanel("Cell Type Labeling", shinyPanelLabelCellType)

      ),
      navbarMenu(
        "Enrichment & Pathway Analysis",
        tabPanel("EnrichR", shinyPanelEnrichR),
        tabPanel("Pathway Activity", shinyPanelvam)


      ),
      navbarMenu(
        "Trajectory Analysis",
        tabPanel("TSCAN", value = "TSCANWorkflow", shinyPanelTSCAN)
      ),

      tabPanel("Sample Size Calculator", shinyPanelSubsample),
      navbarMenu(
        "Curated Workflows",
        tabPanel("Celda", value = "CeldaWorkflow", shinyPanelCelda),
        tabPanel("Seurat", shinyPanelSeurat),
        tabPanel("Scanpy", shinyPanelScanpy)
      ),
      # tabPanel("Curated Workflows", shinyPanelCuratedWorkflows),
      navbarMenu("Viewers",
                 tabPanel("Cell Viewer", value="CellViewer", shinyPanelCellViewer),
                 tabPanel("Heatmap", shinyPanelHeatmap),
                 tabPanel("Bubbleplot", shinyPanelBubbleplot)
                 ),
      footer = includeHTML("www/logo.html"),
      fluidRow(
        column(12, id = "consoleDiv",
               actionButton(inputId="consoleToggle", label = "Console Log"),
               tags$head(
                 tags$script(HTML(jsScriptAutoScrollConsole))
               ),
               hidden(div(id = "consolePanel", style = "overflow-y:scroll;
                          max-height: 220px; width: 100%; background-color: white;
                          position: relative; bottom: 0; align: centre; padding: 0px;",
                          verbatimTextOutput(outputId="consoleText", placeholder = TRUE)
               ))
        )
      ),
      useShinyjs(),
      extendShinyjs(text = jsCode, functions = c("enableTabs", "disableTabs")),

      # Following lines of code add a loading spinner when toolkit launches and
      # loads several ui elements/plots etc.
      includeCSS("busy-load-piccard21.css"),
      tags$script(src = "initialLoading.js"),
      tags$script(src = "busy-load-piccard21.js"),
      
      # Add ability to track usage with Google Analytics. Requires a 
      # link like:
      # https://www.googletagmanager.com/gtag/js?id=G-XXXXXXXXXX
      # with a code for the Google analytics project. It also requires a .js
      # file. See the following page on the wiki for more info:
      # https://github.com/compbiomed/singleCellTK/wiki/Google-Analytics
      tags$head(
        shiny::tags$script(
          src = "https://www.googletagmanager.com/gtag/js?id=G-NP0B0KLYE2",
          async = ""
        ),
        shiny::tags$script(
          src = "gtag.js"
        )
      )
    )
)

shinyPanelBubbleplot <- fluidPage(
  tags$div(
    class = "container",
    h1("Bubbleplot"),
    p("Generic bubbleplot plotting panel for customized figure.",
      style = "color:grey;"),
    panel(
      
      fluidRow(
        column(width = 4,
               hr(),
               # Subset ####
               h3("Select Cell Annotation"),
               uiOutput("bpClusterUI"),
               h3("Feature"),
               fluidRow(
                 column(width = 12,
                        selectizeInput(
                          inputId = "bpAssay", 
                          label = "Select input matrix:", 
                          choices = NULL, 
                          selected = NULL, 
                          multiple = FALSE,
                          options = NULL)
                 )
               ),
               selectizeInput(
                 'bpFeatures',
                 "Select Features",
                 choices = NULL, multiple = TRUE, width = '550px'),
               h5(style="display: inline-block; margin-top: 0px; margin-bottom: 20px","Scale Data"),
               switchInput(
                 inputId = "scaleBubble",
                 onLabel = "Yes",
                 offLabel = "No",
                 value=FALSE,
                 size="mini",
                 inline = TRUE
               ),
               withBusyIndicatorUI(actionButton("plotBubbleplot", "Plot Bubbleplot")),
               hr(),
        ),
        
        column(
          width = 3,
          dropdown(
            fluidRow(
              column(
                width = 12,
                fluidRow(actionBttn(inputId = "closeDropDownBubble", label = NULL, style = "simple", color = "danger", icon = icon("times"), size = "xs"), align = "right"),
                panel(
                  fluidRow(
                    column(width = 4,
                           textInput("bpTitle", "Title", NULL)
                    )
                  ),
                  fluidRow(
                    column(width = 4,
                           textInput("bpX", "X-axis Label", NULL)
                    ),
                    column(width = 4,
                           textInput("bpY", "Y-axis Label", NULL)
                    )
                  ),
                  fluidRow(
                    column(
                      width = 4,
                      colourpicker::colourInput('bpLow', 'Low color', value = 'white')
                    ),
                    column(
                      width = 4,
                      colourpicker::colourInput('bpHigh', 'High color', value = 'blue')
                    )
                  )
                ),
                withBusyIndicatorUI(
                  actionBttn(
                    inputId = "updateBubbleplot",
                    label = "Update",
                    style = "bordered",
                    color = "primary",
                    size = "sm"
                  )
                ),
              )
            ),
            inputId = "dropDownBubble",
            icon = icon("cog"),
            status = "primary",
            circle = FALSE,
            inline = TRUE
          )
        ),
        
        column(
          8,
          wellPanel(
            h5(strong("Plotting Region")),
            div(
              style = 'height:800px;',
              plotOutput("Bubbleplot")
            ),
            hr(),
          )
        )
      ),
      
    )
  )
)

#' @title Perform comprehensive single cell QC
#' @description A wrapper function to run several QC algorithms on a
#'  SingleCellExperiment
#'  object containing cells after empty droplets have been removed.
#' @param inSCE A \link[SingleCellExperiment]{SingleCellExperiment} object.
#' @param algorithms Character vector. Specify which QC algorithms to run.
#'  Available options are "QCMetrics", "scrublet", "doubletFinder", "scDblFinder", 
#'  "cxds", "bcds", "cxds_bcds_hybrid", "decontX" and "soupX".
#' @param sample Character vector. Indicates which sample each cell belongs to.
#'  Algorithms will be run on cells from each sample separately.
#' @param collectionName Character. Name of a \code{GeneSetCollection} obtained by 
#'  using one of the importGeneSet* functions. Default \code{NULL}.
#' @param geneSetList See \code{runPerCellQC}. Default NULL.
#' @param geneSetListLocation See \code{runPerCellQC}. Default NULL.
#' @param geneSetCollection See \code{runPerCellQC}. Default NULL.
#' @param mitoRef,mitoIDType,mitoPrefix,mitoID,mitoGeneLocation Arguments used to 
#'  import mitochondrial genes and quantify their expression. Please see 
#'  \link[singleCellTK]{runPerCellQC} for detailed information.  
#' @param useAssay  A string specifying which assay contains the count
#'  matrix for cells.
#' @param background A \link[SingleCellExperiment]{SingleCellExperiment}
#' with the matrix located in the assay slot under \code{bgAssayName}. It should have 
#' the same structure as inSCE except it contains the matrix of empty droplets instead 
#' of cells. When supplied, empirical distribution of transcripts from these 
#' empty droplets will be used as the contamination distribution. It is only used in 
#' algorithms "decontX" and "soupX". Default NULL.
#' @param bgAssayName Character. Name of the assay to use if background is a 
#' \link[SingleCellExperiment]{SingleCellExperiment}. If NULL, the function
#' will use the same value as \code{useAssay}. It is only used in algorithms 
#' "decontX" and "soupX". Default is NULL. 
#' @param bgBatch Batch labels for \code{background}. If \code{background} is a 
#' \link[SingleCellExperiment]{SingleCellExperiment} object, this can be a single 
#' character specifying a name that can be found in \code{colData(background)} 
#' to directly use the barcode annotation Its unique values should be the same
#' as those in \code{sample}, such that each batch of cells have their corresponding 
#' batch of empty droplets as background, pointed by this parameter. It is only used in
#' algorithms "decontX" and "soupX". Default to NULL.
#' @param seed Seed for the random number generator. Default 12345.
#' @param paramsList A list containing parameters for QC functions. Default NULL.
#' @return SingleCellExperiment object containing the outputs of the
#'  specified algorithms in the \link{colData}
#' of \code{inSCE}.
#' @examples
#' data(scExample, package = "singleCellTK")
#' sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
#' \dontrun{
#' sce <- runCellQC(sce)
#' }
#' @export

runCellQC <- function(inSCE,
  algorithms = c("QCMetrics", "scDblFinder", "cxds", "bcds",
    "cxds_bcds_hybrid", "decontX", "decontX_bg", "soupX", "soupX_bg"), #"scrublet", "doubletFinder",
  sample = NULL,
  collectionName = NULL,
  geneSetList = NULL,
  geneSetListLocation = "rownames",
  geneSetCollection = NULL,
  mitoRef = "human",
  mitoIDType = "ensembl",
  mitoPrefix = "MT-",
  mitoID = NULL,
  mitoGeneLocation = "rownames",
  useAssay = "counts",
  background = NULL,
  bgAssayName= NULL,
  bgBatch = NULL,
  seed = 12345,
  paramsList = NULL) {

  nonmatch <- setdiff(algorithms, c("scDblFinder", "cxds", "bcds",
    "cxds_bcds_hybrid", "decontX", "decontX_bg", "QCMetrics", "scrublet", 
    "doubletFinder", "soupX", "soupX_bg"))
  if (length(nonmatch) > 0) {
    stop("'", paste(nonmatch, collapse=","), "' are not supported algorithms.")
  }

  if ("QCMetrics" %in% algorithms) {
    inSCE <- do.call(runPerCellQC,
      c(list(inSCE = quote(inSCE),
        useAssay = useAssay,
        collectionName = collectionName,
        geneSetList = geneSetList,
        geneSetListLocation = geneSetListLocation,
        geneSetCollection = geneSetCollection),
        mitoRef = mitoRef,
        mitoIDType = mitoIDType,
        mitoPrefix = mitoPrefix,
        mitoID = list(mitoID),
        mitoGeneLocation = mitoGeneLocation,
        paramsList[["QCMetrics"]]))
  }

  if ("scrublet" %in% algorithms) {

    inSCE <- do.call(runScrublet,
      c(list(inSCE = quote(inSCE),
        sample = sample,
        useAssay = useAssay,
        seed = seed),
        paramsList[["scrublet"]]))
  }

  if ("scDblFinder" %in% algorithms) {
    inSCE <- do.call(runScDblFinder,
      c(list(inSCE = quote(inSCE),
      sample = sample,
      useAssay = useAssay,
      seed = seed),
      paramsList[["scDblFinder"]]))
  }

  if ("doubletFinder" %in% algorithms) {
    inSCE <- do.call(runDoubletFinder,
      c(list(inSCE = quote(inSCE),
      sample = sample,
      useAssay = useAssay,
      seed = seed),
      paramsList[["doubletFinder"]]))
  }

  if ("cxds" %in% algorithms) {
    inSCE <- do.call(runCxds,
      c(list(inSCE = quote(inSCE),
      sample = sample,
      seed = seed,
      useAssay = useAssay,
      estNdbl = TRUE),
      paramsList[["cxds"]]))
  }

  if ("bcds" %in% algorithms) {
    inSCE <- do.call(runBcds,
      c(list(inSCE = quote(inSCE),
      sample = sample,
      seed = seed,
      useAssay = useAssay,
      estNdbl = TRUE),
      paramsList[["bcds"]]))
  }

  if ("cxds_bcds_hybrid" %in% algorithms) {
    inSCE <- do.call(runCxdsBcdsHybrid,
      c(list(inSCE = quote(inSCE),
      sample = sample,
      seed = seed,
      useAssay = useAssay,
      estNdbl = TRUE),
      paramsList[["cxds_bcds_hybrid"]]))
  }

  if ("decontX" %in% algorithms) {
    if (!is.null(paramsList[["decontX"]][['background']])) {
      warning("'decontX' algorithm will decontaminate ambient RNA without the background count ",
        "matrix. Ignore 'background' parameter within 'paramsList[['decontX']]' will be ignored. If you want ",
        "to adjust decontamination with background matrix, please run 'decontX_bg' algorithm.")
      paramsList[["decontX"]][['background']] <- NULL
    }
    inSCE <- do.call(runDecontX,
      c(list(inSCE = quote(inSCE),
      sample = sample,
      useAssay = useAssay,
      seed = seed),
      paramsList[["decontX"]]))
  }

  if ("decontX_bg" %in% algorithms) {
    if (!is.null(background)) {
      inSCE <- do.call(runDecontX,
        c(list(inSCE = quote(inSCE),
        sample = sample,
        useAssay = useAssay,
        seed = seed, 
        background = background,
        bgAssayName = bgAssayName,
        bgBatch = bgBatch),
        paramsList[["decontX_bg"]]))      
    } else {
      warning("'background' is NULL. Skip 'decontX_bg' algorithm.")
    }
  }

  if ("soupX" %in% algorithms) {
    if (!is.null(paramsList[["soupX"]][['background']])) {
      warning("'soupX' algorithm step will decontaminate ambient RNA without the background count ",
        "matrix. 'background' parameter within 'paramsList[['soupX']]' will be ignored. If you want ",
        "to adjust decontamination with background matrix, please run 'soupX_bg' algorithm.")
      paramsList[["soupX"]][['background']] <- NULL
    }
    inSCE <- do.call(runSoupX,
      c(list(inSCE = quote(inSCE),
      sample = sample,
      useAssay = useAssay),
      paramsList[["soupX"]]))
  }

  if ("soupX_bg" %in% algorithms) {
    if (!is.null(background)) {
      inSCE <- do.call(runSoupX,
        c(list(inSCE = quote(inSCE),
        sample = sample,
        useAssay = useAssay,
        background = background,
        bgAssayName = bgAssayName,
        bgBatch = bgBatch),
        paramsList[["soupX_bg"]]))      
    } else {
      warning("'background' is NULL. Skip 'soupX_bg' algorithm. ")
    }
  }
  return(inSCE)
}


#' @title Perform comprehensive droplet QC
#' @description A wrapper function to run several QC algorithms for determining
#' empty droplets in single cell RNA-seq data
#' @param inSCE A \link[SingleCellExperiment]{SingleCellExperiment} object containing
#' the full droplet count matrix
#' @param algorithms Character vector. Specify which QC algorithms to run.
#'  Available options are "emptyDrops" and "barcodeRanks".
#' @param sample Character vector. Indicates which sample each cell belongs to.
#'  Algorithms will be run on cells from each sample separately.
#' @param useAssay  A string specifying which assay contains the count
#'  matrix for droplets.
#' @param paramsList A list containing parameters for QC functions. Default NULL.
#' @return SingleCellExperiment object containing the outputs of the
#'  specified algorithms in the \link{colData}
#' of \code{inSCE}.
#' @examples
#' data(scExample, package = "singleCellTK")
#' \dontrun{
#' sce <- runDropletQC(sce)
#' }
#' @export
runDropletQC <- function(inSCE,
  algorithms = c("QCMetrics", "emptyDrops", "barcodeRanks"),
  sample = NULL,
  useAssay = "counts",
  paramsList = NULL) {

  nonmatch <- setdiff(algorithms, c("QCMetrics", "emptyDrops", "barcodeRanks"))
  if(length(nonmatch) > 0) {
    stop(paste0("'", paste(nonmatch, collapse=","), "' are not supported algorithms."))
  }

  if ("QCMetrics" %in% algorithms) {
    inSCE <- do.call(runPerCellQC,
      c(list(inSCE = quote(inSCE),
        useAssay = useAssay),
        paramsList[["QCMetrics"]]))
  }

  if (any("emptyDrops" %in% algorithms)) {
    inSCE <- do.call(runEmptyDrops,
      c(list(inSCE = quote(inSCE),
      sample = sample,
      useAssay = useAssay),
      paramsList[["emptyDrops"]]))
  }

  if (any("barcodeRanks" %in% algorithms)) {
    inSCE <- do.call(runBarcodeRankDrops,
      c(list(inSCE = quote(inSCE),
      sample = sample,
      useAssay = useAssay),
      paramsList[["barcodeRanks"]]))
  }

  return(inSCE)
}

.checkCell <- function(FilterFile, FilterDir, basepath, Reference, process) {
    if (is.null(FilterFile)) {
        if (is.null(basepath)) {
            if ((is.null(FilterDir))) {
                stop("'cellPath' need to be specified when 'basePath' is NULL.")
            }
            # message("'base_path' is NULL. Data is loaded using directories specified by '--cell_data_path' and '--raw_data_path'.")
            if (length(FilterDir) != length(sample)) {
                stop("The length of '--cellPath' should be the same as the length of '--sample'.")
            }
            if (length(FilterDir) != length(process)) {
                stop('The length of "--cellPath" should be the same as ',
                         'the length of "--preproc"!')
            }

        } else {
            if (length(basepath) != length(process)) {
                stop('The length of "--basePath" should be the same as ',
                         'the length of "--preproc"!')
            }
            if (length(basepath) != length(sample)) {
                stop('The length of "--basePath" should be the same as ',
                         'the length of "--sample"!')
            }
            if (length(Reference) != sum(process == 'CellRangerV2')) {
                stop('The length of --genome should be the same as ',
                        'the number of "CellRangerV2" in the "--preproc"!')
            }
        }

    }

    if (!is.null(FilterFile)) {
        if (length(FilterFile) != length(sample)) {
            stop("The length of '--cellData' should be the same as the length of '--sample'.")
        }
        if (length(FilterFile) != length(process)) {
            stop('The length of "--cellData" should be the same as ',
                     'the length of "--preproc"!')
        }
    }
    return(0)
}

.checkDroplet <- function(RawFile, RawDir, basepath, Reference, process) {
    if (is.null(RawFile)) {
        if (is.null(basepath)) {
            if ((is.null(RawDir))) {
                stop("'rawPath' need to be specified when 'basePath' is NULL.")
            }
            # message("'base_path' is NULL. Data is loaded using directories specified by '--cell_data_path' and '--raw_data_path'.")
            if (length(RawDir) != length(sample)) {
                stop("The length of '--rawPath' should be the same as the length of '--sample'.")
            }
            if (length(RawDir) != length(process)) {
                stop('The length of "--rawPath" should be the same as ',
                         'the length of "--preproc"!')
            }

        } else {
            if (length(basepath) != length(process)) {
                stop('The length of "--basePath" should be the same as ',
                         'the length of "--preproc"!')
            }
            if (length(basepath) != length(sample)) {
                stop('The length of "--basePath" should be the same as ',
                         'the length of "--sample"!')
            } 
            if (length(Reference) != sum(process == 'CellRangerV2')) {
                stop('The length of --genome should be the same as ',
                        'the number of "CellRangerV2" in the "--preproc"!')
            }
        }
    }

    if (!is.null(RawFile)) {
        if (length(RawFile) != length(sample)) {
            stop("The length of '--rawData' should be the same as the length of '--sample'.")
        }
        if (length(RawFile) != length(process)) {
            stop('The length of "--rawData" should be the same as ',
                     'the length of "--preproc"!')
        }
    }
    return(0)
}

.checkBoth <- function(RawFile, FilterFile, RawDir, FilterDir, basepath, Reference, process) {
    if (is.null(RawFile) && is.null(FilterFile)) {
        if (is.null(basepath)) {
            if ((is.null(FilterDir) || is.null(RawDir))) {
                stop("Both 'cellPath' and 'rawPath' need to be specified when 'basePath' is NULL.")
            } else {
                # message("'basePath' is NULL. Data is loaded using directories specified by '--cell_data_path' and '--raw_data_path'.")
                if (length(FilterDir) != length(RawDir)) {
                    stop("The length of '--cellPath' should be the same as the length of '--rawPath'.")
                }
                if (length(FilterDir) != length(sample)) {
                    stop("The length of '--cellPath' should be the same as the length of '--sample'.")
                }
                if (length(FilterDir) != length(process)) {
                    stop('The length of "--cellPath" should be the same as ',
                             'the length of "--preproc"!')
                }
            }
        } else {
            if (length(basepath) != length(process)) {
                stop('The length of "--basePath" should be the same as ',
                         'the length of "--preproc"!')
            }
            if (length(basepath) != length(sample)) {
                stop('The length of "--basePath" should be the same as ',
                         'the length of "--sample"!')

                if (length(Reference) != sum(process == 'CellRangerV2')) {
                    stop('The length of --genome should be the same as ',
                        'the number of "CellRangerV2" in the "--preproc"!')
                }
            }
        }
    }

    if (!is.null(RawFile) || !is.null(FilterFile)) {
        if (length(RawFile) != length(FilterFile)) {
             stop("The length of '--rawData' and '--cellData' should be the same when '--preproc' is SceRDS or CountMatrix.")
        }
        if (length(FilterFile) != length(sample)) {
            stop("The length of '--cellData' should be the same as the length of '--sample'.")
        }
        if (length(FilterFile) != length(process)) {
            stop('The length of "--cellData" should be the same as ',
                     'the length of "--preproc"!')
        }
    }
    return(0)
}

.cellQC <- function(cellSCE, geneSetCollection, Params, cellQCAlgos, mitoInfo, dropletSCE = NULL) {
    p <- paste0(date(), " .. Running cell QC")
    message(p)
    cellSCE <- runCellQC(inSCE = cellSCE, geneSetCollection = geneSetCollection, 
        paramsList=Params, algorithms = cellQCAlgos, background = dropletSCE,
        mitoRef = mitoInfo[['reference']], mitoIDType = mitoInfo[['id']],
        mitoGeneLocation = "rownames")
    return(cellSCE)
}

.runCell <- function(cellSCE, preproc, geneSetCollection, Params, cellQCAlgos, mitoInfo) {
    if (is.null(cellSCE) && (preproc %in% c("BUStools", "SEQC"))) {
        dropletSCE <- runDropletQC(inSCE = dropletSCE, paramsList=Params)
        ix <- !is.na(dropletSCE$dropletUtils_emptyDrops_fdr) & (dropletSCE$dropletUtils_emptyDrops_fdr < 0.01)
        cellSCE <- dropletSCE[,ix]
    }
    p <- paste0(date(), " .. Running cell QC")
    message(p)
    cellSCE <- runCellQC(inSCE = cellSCE, geneSetCollection = geneSetCollection, 
        paramsList=Params, algorithms = cellQCAlgos, background = dropletSCE,
        mitoRef = mitoInfo[['reference']], mitoIDType = mitoInfo[['id']],
        mitoGeneLocation = "rownames")
}

.runDroplet <- function(dropletSCE, geneSetCollection, Params, mitoInfo, cellQCAlgos, detectCell, cellCalling) {
    p <- paste0(date(), " .. Running droplet QC")
    message(p)
    dropletSCE <- runDropletQC(inSCE = dropletSCE, paramsList=Params)
    if (isTRUE(detectCell)) {
        if (cellCalling == "EmptyDrops") {
            ix <- !is.na(dropletSCE$dropletUtils_emptyDrops_fdr) & dropletSCE$dropletUtils_emptyDrops_fdr < 0.01
        } else if (cellCalling == "Knee") {
            ix <- dropletSCE$dropletUtils_BarcodeRank_Knee == 1
        } else {
            ix <- dropletSCE$dropletUtils_BarcodeRank_Inflection == 1
        }
        cellSCE <- dropletSCE[,ix]
        p <- paste0(date(), " .. Running cell QC")
        message(p)
        cellSCE <- runCellQC(inSCE = cellSCE, geneSetCollection = geneSetCollection, 
            paramsList=Params, algorithms = cellQCAlgos, background = dropletSCE,
            mitoRef = mitoInfo[['reference']], mitoIDType = mitoInfo[['id']],
            mitoGeneLocation = "rownames")
    }
}


.exportHTANFlat <- function(dataType, droplet = NULL, cell = NULL, samplename, directory, formats, detectCell = FALSE, level3Meta, level4Meta, i = NULL) {
    if ((dataType == "Droplet" && isTRUE(detectCell))) {
        inputType <- "Both"
    } else {
        inputType <- dataType
    }
    if ("FlatFile" %in% formats) {
        if ("HTAN" %in% formats) {
            meta <- generateHTANMeta(dropletSCE = droplet, cellSCE = cell, samplename = samplename,
                                     dir = directory, htan_biospecimen_id=samplename, inputType)
        } else {
                meta <- generateMeta(dropletSCE = droplet, cellSCE = cell, samplename = samplename,
                                     dir = directory, HTAN=FALSE, inputType)
        }
        # in place modification of level3/4Meta
        if (!is.null(i)) {
            level3Meta[[i]] <- meta[[1]]
            level4Meta[[i]] <- meta[[2]]
        }
        else {
            level3Meta <- meta[[1]]
            level4Meta <- meta[[2]]
        }
    } else {
        warning("'FlatFile' is not in output format. Skip exporting the manifest file.")
    }
    return(meta)
}

#' Summarize an assay in a \linkS4class{SingleCellExperiment}
#'
#' Creates a table of summary metrics from an input
#' \linkS4class{SingleCellExperiment}
#'
#' @param inSCE Input SingleCellExperiment object.
#' @param useAssay Indicate which assay to summarize. If \code{NULL}, then the
#' first assay in \code{inSCE} will be used. Default \code{NULL}.
#' @param sampleVariableName Variable name in \code{colData} denoting which
#' sample each cell belongs to. If \code{NULL}, all cells will be assumed
#' to come from the same sample. Default \code{"sample"}.
#'
#' @return A data.frame object of summary metrics.
#' @export
#' @examples
#' data("mouseBrainSubsetSCE")
#' summarizeSCE(mouseBrainSubsetSCE, sample = NULL)
#' @importFrom SummarizedExperiment assays colData
summarizeSCE <- function(inSCE, useAssay = NULL, sampleVariableName = NULL){

  if(is.null(useAssay)) {
    useAssay <- names(assays(inSCE))[1]
  }

  if(is.null(sampleVariableName)) {
    sampleVariable <- rep("Sample", ncol(inSCE))
  } else {
    if(!(sampleVariableName %in% colnames(colData(inSCE)))) {
      stop("'", sampleVariableName, "' was not found in the 'colData' of ",
           "'inSCE'.")
    }
    sampleVariable <- as.vector(colData(inSCE)[,sampleVariableName])
  }

  numCells <- table(sampleVariable)
  var <- colSums(SummarizedExperiment::assay(inSCE, useAssay))
  meanCounts <- stats::aggregate(var, by = list(sampleVariable), FUN = mean)
  medianCounts <- stats::aggregate(var, by = list(sampleVariable),
                                   FUN = stats::median)
  var2 <- colSums(SummarizedExperiment::assay(inSCE, useAssay) > 0)
  meanDetected <- stats::aggregate(var2, by = list(sampleVariable), FUN = mean)
  medianDetected <- stats::aggregate(var2, by = list(sampleVariable),
                                     FUN = stats::median)

  df <- data.frame("Sample" = names(numCells),
                   "Number of Cells" = as.integer(round(as.numeric(numCells))),
                   "Mean counts per cell" = as.integer(round(meanCounts[,2])),
                   "Median counts per cell" = as.integer(round(medianCounts[,2])),
                   "Mean features detected per cell" = as.integer(round(meanDetected[,2])),
                   "Median features detected per cell" = as.integer(round(medianDetected[,2])),
                   stringsAsFactors = FALSE, check.names = FALSE)
  return(df)
}

#' Generate a distinct palette for coloring different clusters
#'
#' @param n Integer; Number of colors to generate
#' @param hues Character vector of R colors available from the colors()
#' function. These will be used as the base colors for the clustering scheme.
#' Different saturations and values (i.e. darkness) will be generated for each
#' hue.
#' @param saturation.range Numeric vector of length 2 with values between 0 and
#' 1. Default: c(0.25, 1)
#' @param value.range Numeric vector of length 2 with values between 0 and 1.
#' Default: c(0.5, 1)
#' @return A vector of distinct colors that have been converted to  HEX from
#' HSV.
#' @export
#' @examples
#' distinctColors(10)
distinctColors <- function(n, hues = c("red", "cyan", "orange", "blue",
                                        "yellow", "purple", "green", "magenta"),
                           saturation.range = c(0.7, 1),
                           value.range = c(0.7, 1)) {
  #Adapted from compbiomed/celda, thanks to all celda developers
  if (!(all(hues %in% grDevices::colors()))) {
    stop("Only color names listed in the 'color'",
         " function can be used in 'hues'")
  }

  ## Convert R colors to RGB and then to HSV color format
  hues.hsv <- grDevices::rgb2hsv(grDevices::col2rgb(hues))

  ## Calculate all combination of saturation/value pairs
  ## Note that low saturation with low value (i.e. high darkness) is too dark
  ## for all hues
  ## Likewise, high saturation with high value (i.e. low darkness) is hard to
  ## distinguish
  ## Therefore, saturation and value are set to be anticorrelated
  num.vs <- ceiling(n / length(hues))
  s <- seq(from = saturation.range[1], to = saturation.range[2],
           length = num.vs)
  v <- seq(from = value.range[2], to = value.range[1], length = num.vs)

  ## Create all combination of hues with saturation/value pairs
  new.hsv <- c()
  for (i in seq_len(num.vs)) {
    temp <- rbind(hues.hsv[1, ], s[i], v[i])
    new.hsv <- cbind(new.hsv, temp)
  }

  ## Convert to hex
  col <- grDevices::hsv(new.hsv[1, ], new.hsv[2, ], new.hsv[3, ])

  return(col[seq_len(n)])
}

#' Generate given number of color codes
#'
#' @description Three different generation methods are wrapped, including
#' \code{\link[celda]{distinctColors}},
#' [randomcoloR](SCTK_PerformingQC_Cell_V3.Rmd) and the \code{ggplot}
#' default color generation.
#' @param n An integer, the number of color codes to generate.
#' @param palette A single character string. Select the method, available
#' options are \code{"ggplot"}, \code{"celda"} and \code{"random"}. Default
#' \code{"random"}.
#' @param seed An integer. Set the seed for random process that happens only in
#' "random" generation. Default \code{12345}.
#' @param ... Other arguments that are passed to the internal function,
#' according to the method selected.
#' @return A character vector of \code{n} hex color codes.
#' @examples
#' discreteColorPalette(n = 3)
#' @export
discreteColorPalette <- function(n, palette = c("random", "ggplot", "celda"),
                                 seed = 12345, ...) {
  palette <- match.arg(palette)
  # Generate the colors
  if (palette == "random") {
    withr::with_seed(seed, {
      # Using randomcoloR original codes here
      km <- stats::kmeans(colorSpace, n, iter.max = 20)
      colors <- unname(colorspace::hex(colorspace::LAB(km$centers)))
      colors <- colors[order(colors)]
    })
  } else if (palette == "ggplot") {
    hues <- seq(15, 375, length = n + 1)
    colors <- grDevices::hcl(h = hues, l = 65, c = 100)[seq_len(n)]
  } else if (palette == "celda") {
    colors <- distinctColors(n, ...)
  }
  return(colors)
}

#test shiny functions
.testFunctions <- function(){
  if (interactive()){
    res <- DT::datatable(matrix(1, 2))
    shinyjs::runExample("basic")
    shinyalert::runExample()
    p <- plotly::plot_ly(data = data.frame(test = c(1, 2, 3)),
                         x = "test", type = "histogram")
    colourpicker::runExample()
    rt <- ape::rtree(10)
    gt <- ggtree::ggtree(rt)
    shinycssloaders::withSpinner(shiny::plotOutput("my_plot"))
    x <- rbind(cbind(stats::rnorm(200, 0, 8), stats::rnorm(200, 0, 8)),
               cbind(stats::rnorm(300, 50, 8), stats::rnorm(300, 50, 8)))
    clarax <- cluster::clara(x, 2, samples = 50)
    circlize::colorRamp2(c(1, 2, 3), c("red", "blue", "black"))
  }
}

## Convert a matrix to a sparse matrix and preserve column/row names
.convertToMatrix <- function(x, chuS = 3000) {
  cn <- colnames(x)
  rn <- rownames(x)
  #limit <- (2^32/2-1)
  dimN <- dim(x)
  # chuS <- floor(floor(limit/dimN[1])) # size of chunk
  # chuN <- ceiling(dimN[2]/chuS) # number of chunks
  #chuS <- 3000 # loading 3000 cells in each chunk
  chuN <- ceiling(dimN[2]/chuS)
  Mat <- list()

  for (i in seq_len(chuN)) {
    start <- (i-1)*chuS + 1
    end <- min(i*chuS, dimN[2])
    Mat[[i]] <- methods::as(x[, start:end], "CsparseMatrix")
  }
  x <- do.call(base::cbind, Mat)
  colnames(x) <- cn
  rownames(x) <- rn

  return(x)
}

#' Deduplicate the rownames of a matrix or SingleCellExperiment object
#' @description 
#' Adds '-1', '-2', ... '-i' to multiple duplicated rownames, and in place
#' replace the unique rownames, store unique rownames in \code{rowData}, or
#' return the unique rownames as character vecetor.
#' @param x A matrix like or \linkS4class{SingleCellExperiment} object, on which
#' we can apply \code{rownames()} to and has duplicated rownames.
#' @param as.rowData Only applicable when \code{x} is a
#' \linkS4class{SingleCellExperiment} object. When set to \code{TRUE}, will
#' insert a new column called \code{"rownames.uniq"} to \code{rowData(x)}, with
#' the deduplicated rownames.
#' @param return.list When set to \code{TRUE}, will return a character vector
#' of the deduplicated rownames.
#' @export
#' @return By default, a matrix or \linkS4class{SingleCellExperiment} object
#' with rownames deduplicated.
#' When \code{x} is a \linkS4class{SingleCellExperiment} and \code{as.rowData}
#' is set to \code{TRUE}, will return \code{x} with \code{rowData} updated.
#' When \code{return.list} is set to \code{TRUE}, will return a character vector
#' with the deduplicated rownames.
#' @examples
#' data("scExample", package = "singleCellTK")
#' sce <- dedupRowNames(sce)
dedupRowNames <- function(x, as.rowData = FALSE, return.list = FALSE){
  if(!inherits(rownames(x), "character")){
    stop("No character rownames found.")
  }
  dup.names <- unique(rownames(x)[duplicated(rownames(x))])
  dedup.names <- rownames(x)
  for (feature in dup.names) {
    idx <- which(rownames(x) == feature)
    dedup.names[idx] <- paste(feature, seq_along(idx), sep = "-")
  }
  if(isTRUE(return.list)){
    return(dedup.names)
  } else {
    if (inherits(x, "SummarizedExperiment") &&
        isTRUE(as.rowData)) {
      SummarizedExperiment::rowData(x)[["rownames.uniq"]] <- dedup.names
    } else {
      rownames(x) <- dedup.names
    }
    return(x)
  }
}

#' Set rownames of SCE with a character vector or a rowData column
#' @description Users can set rownames of an SCE object with either a character
#' vector where the length equals to \code{nrow(x)}, or a single character
#' specifying a column in \code{rowData(x)}. Also applicable to matrix like
#' object where \code{rownames<-} method works, but only allows full size name
#' vector. Users can set \code{dedup = TRUE} to remove duplicated entries in the
#' specification, by adding \code{-1, -2, ..., -i} suffix to the duplication of
#' the same identifier.
#' @param x Input object where the rownames will be modified.
#' @param rowNames Character vector of the rownames. If \code{x} is an
#' \linkS4class{SingleCellExperiment} object, a single character specifying a
#' column in \code{rowData(x)}.
#' @param dedup Logical. Whether to deduplicate the specified rowNames. Default
#' \code{TRUE}
#' @return The input SCE object with rownames updated.
#' @export
#' @examples
#' data("scExample", package = "singleCellTK")
#' head(rownames(sce))
#' sce <- setRowNames(sce, "feature_name")
#' head(rownames(sce))
setRowNames <- function(x, rowNames, dedup = TRUE) {
  if (!inherits(rowNames, "character")) {
    stop("rowNames should be of character class")
  }
  if (inherits(x, "SingleCellExperiment")) {
    if (length(rowNames) == 1) {
      if (rowNames %in% names(SummarizedExperiment::rowData(x))) {
        rows <- SummarizedExperiment::rowData(x)[[rowNames]]
      } else {
        stop("Single rowNames specification not found in rowData(x)")
      }
    } else if (length(rowNames) == nrow(x)) {
      rows <- rowNames
    } else {
      stop("Length of rowNames does not match nrow(x)")
    }
    rownames(x) <- rows
  } else {
    rownames(x) <- rowNames
  }

  if (isTRUE(dedup)) {
    x <- dedupRowNames(x)
  }
  return(x)
}

#' Retrieve cell/feature index by giving identifiers saved in col/rowData
#'
#' @description Originally written in \code{\link[celda]{retrieveFeatureIndex}}.
#' Modified for also retrieving cell indices and only working for
#' \linkS4class{SingleCellExperiment} object. This will return indices of
#' features among the \code{rowData}/\code{colData}. Partial matching (i.e.
#' grepping) can be used.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object. Required
#' @param IDs Character vector of identifiers for features or cells to find in
#' \code{rowData} or \code{colData} of \code{inSCE}
#' @param axis A character scalar to specify whether to search for features or
#' cells. Use \code{"row"}, \code{"feature"} or \code{"gene"} for features;
#' \code{"col"} or \code{"cell"} for cells.
#' @param by Character. In which column to search for features/cells in
#' \code{rowData}/\code{colData}. Default \code{NULL} for search the
#' \code{rownames}/\code{colnames}
#' @param exactMatch A logical scalar. Whether to only identify exact matches
#' or to identify partial matches using \code{\link{grep}}. Default \code{TRUE}
#' @param firstMatch A logical scalar. Whether to only identify the first
#' matches or to return all plausible matches. Default \code{TRUE}
#' @examples
#' data(scExample, package = "singleCellTK")
#' retrieveSCEIndex(inSCE = sce, IDs = "ENSG00000205542",
#'  axis = "row")
#' @return A unique, non-NA numeric vector of indices for the matching
#' features/cells in \code{inSCE}.
#' @author Yusuke Koga, Joshua Campbell, Yichen Wang
#' @export
retrieveSCEIndex <- function(inSCE, IDs, axis, by = NULL,
                             exactMatch = TRUE, firstMatch = TRUE){
  if(!inherits(inSCE, "SingleCellExperiment")){
    stop("`inSCE` should inherits from a SingleCellExperiment object.")
  }
  if(!axis %in% c('row', 'col', 'cell', 'feature', 'gene')){
    stop("Invalid axis specification")
  }
  if(axis %in% c('row', 'feature', 'gene')){
    data <- SummarizedExperiment::rowData(inSCE)
    if (length(by) == 1 && by == "rownames") by <- NULL
  } else {
    data <- SummarizedExperiment::colData(inSCE)
    if (length(by) == 1 && by == "colnames") by <- NULL
  }

  if(!is.null(by)){
    if (is.character(by) && length(by) == 1) {
      if(!by %in% colnames(data)){
        stop('"', by, '" annotation not found for "', axis, '".')
      }
      search <- data[[by]]
    } else if(length(by) == nrow(data)){
      search <- by
    }
  } else {
    if (is.null(rownames(data))) {
      stop("No default", axis, " name found for 'inSCE'. Please set `by`.")
    }
    search <- rownames(data)
  }
  Indices <- numeric()
  notFound <- numeric()
  if (!isTRUE(exactMatch)) {
    for(i in seq_along(IDs)){
      g <- grep(IDs[i], search)
      if(length(g) == 0){
        notFound <- c(notFound, i)
      } else if (length(g) == 1){
        Indices <- c(Indices, g)
      } else if(length(g) > 1){
        if(isTRUE(firstMatch)){
          Indices <- c(Indices, g[1])
        } else {
          Indices <- c(Indices, g)
        }
      }
    }
    dupMatched <- search[unique(Indices[duplicated(Indices)])]
  } else {
    if(isTRUE(firstMatch)){
      Indices <- match(IDs, search)
      notFound <- which(is.na(Indices))
      Indices <- Indices[!is.na(Indices)]
      dupMatched <- search[unique(Indices[duplicated(Indices)])]
    } else {
      Indices <- which(search %in% IDs)
      notFound <- which(!IDs %in% search)
      dupMatched <- unique(IDs[duplicated(IDs[IDs %in% search])])
    }
  }
  if(length(notFound) == length(IDs)){
    if (isTRUE(exactMatch)) {
      warning("None of the provided features had matching items in '", by,
              "'. Check the spelling or try setting `exactMatch` to FALSE.")
    } else {
      warning("None of the provided features had matching items in '", by,
              "'. Check the spelling and make sure `by` is set to the ",
              "appropriate annotation.")
    }
  } else if(length(notFound) > 0){
    warning("The following IDs were not present in specified annotation: \n'",
            paste(IDs[notFound], collapse = "', '"), "'")
  }
  if(length(dupMatched) > 0){
    warning("Each of the following entries from '", by, "' was matched by ",
            "multiple queries in 'IDs': \n'",
            paste(dupMatched, collapse = "', '"), "'")
  }
  Indices <- unique(Indices)
  return(Indices)
}


# Backup or restore 'factor' columns in a dataframe.
.manageFactor <- function(df, operation = "backup"){
  if(operation == "backup"){
    data <- list()
    data$data_type <- list()
    data$df <- df
    for (i in seq_along(colnames(data$df))) {
      data$data_type[[colnames(data$df)[i]]] <- c(typeof(data$df[,i]),
                                                  is.factor(data$df[,i]))
    }
    data$df <- .convertFactorToCharacter(df)
  }
  else if(operation == "restore"){
    data <- df
    for (i in seq(length(colnames(data$df)))) {
      if(data$data_type[[i]][2] == TRUE){
        data$df[,i] <- as.factor(data$df[,i])
      }
    }
  }
  return(data)
}

# Converts the columns of a dataframe from factor to character.
.convertFactorToCharacter <- function(df){
  for (i in seq(length(colnames(df)))) {
    if (is.factor(df[, i])) {
      df[,i] = as.character(df[,i])
    }
  }
  return(df)
}

# Convert underscore in an input vector to hyphen (for Seurat code).
.convertToHyphen <- function(input){
  input <- lapply(
    X = input,
    FUN = function(t) gsub(
      pattern = "_",
      replacement = "-",
      x = t,
      fixed = TRUE)
  )
  return(input)
}


# creates a class of geneset collection where all genesets are imported which belong to the category genesetCOllectionName
.getGeneSetCollection <- function(inSCE, geneSetCollectionName) {
  gs <- S4Vectors::metadata(inSCE)$sctk$genesets
  if(is.null(gs)) {
    stop("No gene set collections have been imported.")
  }

  if(!geneSetCollectionName %in% names(gs)) {
    stop("'", geneSetCollectionName, "' is not in the list of imported gene set collections: ",
         paste(names(gs), collapse = ","))
  }

  return(gs[[geneSetCollectionName]])
}

#' List geneset names from geneSetCollection
#' @param inSCE Input \linkS4class{SingleCellExperiment} object.
#' @param geneSetCollectionName The name of an imported geneSetCollection.
#' @return A character vector of available genesets from the collection.
#' @export
getGenesetNamesFromCollection <- function(inSCE, geneSetCollectionName) {
  geneSet <- .getGeneSetCollection(inSCE, geneSetCollectionName)
  return(names(geneSet))
}

# deprecating
# does not work as intended
# instead directly using withr::with_seed
.withSeed <- function(seed, code) {
  if (is.null(seed)) {
    code
  } else {
    withr::with_seed(seed = seed,
                     code)
  }
}

.runEmptyDrops <- function(barcode.matrix=barcode.matrix, lower=lower,
                           niters=niters,
                           test.ambient=test.ambient,
                           ignore=ignore, 
                           alpha=alpha,
                           retain=retain,
                           barcode.args=list(),
                           BPPARAM=BiocParallel::SerialParam()) {
  
  barcode.matrix <- .convertToMatrix(barcode.matrix)
  
  result <- DropletUtils::emptyDrops(m = barcode.matrix, 
                                     lower = lower,
                                     niters = niters,
                                     test.ambient = test.ambient,
                                     ignore = ignore,
                                     alpha = alpha,
                                     retain = retain,
                                     barcode.args = barcode.args,
                                     BPPARAM = BPPARAM)
  colnames(result) <- paste0("dropletUtils_emptyDrops_", colnames(result))
  
  return(result)
}


#' @title Identify empty droplets using \link[DropletUtils]{emptyDrops}.
#' @description Run \link[DropletUtils]{emptyDrops} on the count matrix in the
#' provided \linkS4class{SingleCellExperiment} object.
#' Distinguish between droplets containing cells and ambient RNA in a
#' droplet-based single-cell RNA sequencing experiment.
#' @param inSCE A \linkS4class{SingleCellExperiment} object. Must contain a raw 
#' counts matrix before empty droplets have been removed.
#' @param sample Character vector or colData variable name. Indicates which 
#' sample each cell belongs to. Default \code{NULL}.
#' @param useAssay A string specifying which assay in the SCE to use. Default 
#' \code{"counts"}
#' @param lower See \link[DropletUtils]{emptyDrops} for more information. 
#' Default \code{100}.
#' @param niters See \link[DropletUtils]{emptyDrops} for more information. 
#' Default \code{10000}.
#' @param testAmbient See \link[DropletUtils]{emptyDrops} for more information. 
#' Default \code{FALSE}. 
#' @param ignore See \link[DropletUtils]{emptyDrops} for more information. 
#' Default \code{NULL}.
#' @param alpha See \link[DropletUtils]{emptyDrops} for more information. 
#' Default \code{NULL}.
#' @param retain See \link[DropletUtils]{emptyDrops} for more information. 
#' Default \code{NULL}.
#' @param barcodeArgs See \link[DropletUtils]{emptyDrops} for more information. 
#' Default \code{list()}.
#' @param BPPARAM See \link[DropletUtils]{emptyDrops} for more information. 
#' Default \code{BiocParallel::SerialParam()}.
#' @return A \linkS4class{SingleCellExperiment} object with the
#' \link[DropletUtils]{emptyDrops} output table appended to the
#' \link{colData} slot. The columns include
#' \code{emptyDrops_total}, \code{emptyDrops_logprob},
#' \code{emptyDrops_pvalue}, \code{emptyDrops_limited}, \code{emptyDrops_fdr}.
#' Please refer to the documentation of \link[DropletUtils]{emptyDrops} for
#' details.
#' @seealso \code{\link{runDropletQC}}, \code{\link{plotEmptyDropsResults}},
#' \code{\link{plotEmptyDropsScatter}}
#' @examples
#' data(scExample, package = "singleCellTK")
#' sce <- runEmptyDrops(inSCE = sce)
#' @import DropletUtils
#' @export
#' @importFrom SummarizedExperiment colData colData<-
runEmptyDrops <- function(inSCE,
                          sample = NULL,
                          useAssay = "counts", 
                          lower = 100,
                          niters = 10000,
                          testAmbient = FALSE,
                          ignore = NULL, 
                          alpha = NULL,
                          retain = NULL,
                          barcodeArgs = list(),
                          BPPARAM = BiocParallel::SerialParam()
) {
  # getting the current argument values
  argsList <- mget(names(formals()),sys.frame(sys.nframe()))
  argsList <- argsList[!names(argsList) %in% c("inSCE", "BPPARAM")]
  argsList$packageVersion <- utils::packageDescription("DropletUtils")$Version
  
  sample <- .manageCellVar(inSCE, var = sample)
  if (is.null(sample)) {
    sample <- rep(1, ncol(inSCE))
  }
  
  message(date(), " ... Running 'emptyDrops'")
  
  ## Define result matrix for all samples
  output <- S4Vectors::DataFrame(
    row.names = colnames(inSCE),
    dropletUtils_emptyDrops_total = integer(ncol(inSCE)),
    dropletUtils_emptyDrops_logprob = numeric(ncol(inSCE)),
    dropletUtils_emptyDrops_pvalue = numeric(ncol(inSCE)),
    dropletUtils_emptyDrops_limited = logical(ncol(inSCE)),
    dropletUtils_emptyDrops_fdr = numeric(ncol(inSCE))
  )
  
  ## Loop through each sample and run barcodeRank
  samples <- unique(sample)
  for (s in samples) {
    sceSampleInd <- sample == s
    sceSample <- inSCE[, sceSampleInd]
    
    mat <- SummarizedExperiment::assay(sceSample, i = useAssay)
    result <- .runEmptyDrops(barcode.matrix = mat,
                             lower = lower,
                             niters = niters,
                             test.ambient = testAmbient,
                             ignore = ignore, 
                             alpha = alpha,
                             retain = retain,
                             barcode.args = barcodeArgs,
                             BPPARAM = BPPARAM)
    
    
    output[sceSampleInd, ] <- result
    S4Vectors::metadata(output[sceSampleInd, ]) <- S4Vectors::metadata(result)
    if (!identical(samples, 1)) {
      S4Vectors::metadata(inSCE)$sctk$runEmptyDrops[[s]] <- argsList
    }
  }
  if (identical(samples, 1)) {
    S4Vectors::metadata(inSCE)$sctk$runEmptyDrops$all_cells <- argsList
  }
  
  colData(inSCE) <- cbind(colData(inSCE), output)
  return(inSCE)
}

shinyPanelColumnAnnotation <- fluidPage(
  includeCSS('styles.CSS'),
  h5(tags$a(href = paste0(docs.artPath, "import_annotation.html"),
            "(help)", target = "_blank")),
  panel(
    heading = "Options for editing and importing Cell Annotation data",
    tabsetPanel(
      tabPanel(
        "Bins",
        panel(
          uiOutput("inputSelectAttribute_colData"),
          uiOutput("inputSelectAttributeValue_colData"),
          textInput("inputCriteria_colData", "criteria parameter"),
          selectInput("inputOperator_colData", "select comparison",
                      choices = c("=",">","<",">=","<=")),
          textInput("inputBinName_colData", "bin name"),
          actionButton("buttonConfirmBin_colData", "Confirm Bin")
        )
      ),
      tabPanel(
        "Merge Columns",
        panel(
          uiOutput("inputSelectAttributeMerge1_colData"),
          uiOutput("inputSelectAttributeMerge2_colData"),
          textInput("inputSelectSeparatorMerge_colData",
                    "add separator between merged values", value = "_"),
          actionButton("buttonConfirmMerge_colData","Confirm Merge")
        )
      ),
      tabPanel(
        "Magic Fill",
        panel(
          uiOutput("inputSelectAttributeFill1_colData"),
          uiOutput("inputSelectAttributeFill2_colData"),
          uiOutput("inputSelectAttributeFillvalue_colData"),
          textInput("inputReplaceText_colData", "new value"),
          actionButton("buttonConfirmFill_colData","Confirm Fill")
        )
      ),
      tabPanel(
        "Clean",
        panel(
          uiOutput("inputSelectAttributeClean_colData"),
          selectInput("inputRemovalOperation_colData",
                      "select removal criteria",
                      choices = c("remove alphabets", "remove digits",
                                  "remove spaces","remove symbols")),
          actionButton("buttonConfirmClean_colData","Confirm Clean")
        )
      ),
      tabPanel(
        "Add Column",
        panel(
          textInput("inputEmptyColumnName_colData", "enter new empty column name"),
          textInput("inputDefaultValueAddColumn_colData", "default value to fill"),
          actionButton("buttonConfirmEmptyColumnName_colData","Create Column")
        )
      ),
      tabPanel(
        "Delete Column",
        panel(
          uiOutput("inputSelectAttributeDelete_colData"),
          actionButton("buttonConfirmDeleteColumn_colData", "Delete")
        )
      ),
      tabPanel(
        "Import Cell Annotation from File",
        panel(
          radioButtons(
            inputId = "editorChoiceRadio_colData",
            label = "Select source for column annotation:",
            choices = c("Replace Cell Annotations" = "replace",
                        "Add to existing Cell Annotations" = "concatenate"),
            selected = "concatenate"
          ),
          h6("You can either replace the existing colData or you can add/merge the new colData with the existing one."),
          conditionalPanel(
            condition = "input.editorChoiceRadio_colData == 'concatenate'",
            HTML("<h6><span style='color:red'> Warning:</span> Adding to existing colData will override the columns with same names! </h6>")
          ),
          fileInput('uploadFile_colData', 'Choose file to upload',
                    accept = c(
                      'text/csv',
                      'text/comma-separated-values',
                      '.csv'
                    )),
          actionButton(inputId = "importDataButton_colData",
                       label = "Import")
        )
      )
    ),
    br(),
    uiOutput("changesWarning_colData"),
    fluidRow(
      column(
        6,
        panel(
          "Save",
          h6("Changes made to the annotation must be saved before they can be used in other modules of the toolkit:"),
          actionButton("buttonSave_colData","Save",icon = icon("save"))
        )
      ),
      column(
        6,
        panel(
          "Reset",
          h6("Reset annotation to point after changes were last saved:"),
          actionButton("buttonRestore_colData",
                       "Reset", icon = icon("sync"))
        )
      )
    )
  ),
  panel(heading = "Table of Cell Annotations",
        uiOutput("outputColumnAnnotationTable_colData")
  )
)

exampleDatasets <- c() ## Need to add final small example data here
if ("TENxPBMCData" %in% rownames(installed.packages())){
  exampleDatasets <- c(exampleDatasets,
                       "PBMC 3K (10X)" = "pbmc3k",
                       "PBMC 4K (10X)" =  "pbmc4k",
                       "PBMC 6K (10X)" = "pbmc6k",
                       "PBMC 8K (10X)" = "pbmc8k",
                       "PBMC 33K (10X)" = "pbmc33k",
                       "PBMC 68K (10X)" = "pbmc68k")
}

if ("scRNAseq" %in% rownames(installed.packages())){
  exampleDatasets <- c(exampleDatasets,
                       "Fluidigm (Pollen et al, 2014)" = "fluidigm_pollen",
                       "Mouse Brain (Tasic et al, 2016)" = "allen_tasic",
                       "NestorowaHSC (Nestorowa et al, 2016)" = "NestorowaHSCData")
}

# User Interface for import Workflow ---
shinyPanelImport <- fluidPage(
  useShinyjs(),
  tags$style(appCSS),
  tags$div(
    class = "jumbotron", style = "background-color:#ededed",
    tags$div(
      class = "container",
      h1("Single Cell Toolkit"),
      p("Filter, cluster, and analyze single cell RNA-Seq data"),
      p(
        "Need help?",
        tags$a(href = paste0(docs.base, "index.html"),
               "Read the docs.", target = "_blank")
      )
    )
  ),
  tags$br(),
  h1("Import"),
  h5(tags$a(href = paste0(docs.artPath, "import_data.html"),
            "(help)", target = "_blank")),
  tags$hr(),

  bsCollapse(
    id = "importUI",
    open = "1. Add sample to import:",
    bsCollapsePanel(
      "1. Add sample to import:",
      radioButtons("uploadChoice", label = NULL, c("Cell Ranger (Version 3 or above)" = "cellRanger3",
                                                   # "Cell Ranger (Version 2)" = "cellRanger2",
                                                   "STARsolo" = "starSolo",
                                                   "BUStools" = "busTools",
                                                   "SEQC" = "seqc",
                                                   "Optimus" = "optimus",
                                                   #"Import from a preprocessing tool" = 'directory',
                                                   "Import from flat files (.csv, .txt, .mtx)" = "files",
                                                   "Upload SingleCellExperiment or Seurat object stored in an RDS File" = "rds",
                                                   "Import example datasets" = "example")
      ),
      tags$hr(),
      conditionalPanel(condition = sprintf("input['%s'] == 'files'", "uploadChoice"),
                       h4("Upload data in tab separated text format:"),
                       fluidRow(
                         column(width = 4,
                                wellPanel(
                                  h5("Example count file:"),
                                  HTML('<table class="table"><thead><tr class="header"><th>Gene</th>
                 <th>Cell1</th><th>Cell2</th><th>&#x2026;</th><th>CellN</th>
                 </tr></thead><tbody><tr class="odd"><td>Gene1</td><td>0</td>
                 <td>0</td><td>&#x2026;</td><td>0</td></tr><tr class="even">
                 <td>Gene2</td><td>5</td><td>6</td><td>&#x2026;</td><td>0</td>
                 </tr><tr class="odd"><td>Gene3</td><td>4</td><td>3</td>
                 <td>&#x2026;</td><td>8</td></tr><tr class="even">
                 <td>&#x2026;</td><td>&#x2026;</td><td>&#x2026;</td>
                 <td>&#x2026;</td><td>&#x2026;</td></tr><tr class="odd">
                 <td>GeneM</td><td>10</td><td>10</td><td>&#x2026;</td><td>10</td>
                 </tr></tbody></table>'),
                                  tags$a(href = "https://drive.google.com/open?id=1n0CtM6phfkWX0O6xRtgPPg6QuPFP6pY8",
                                         "Download an example count file here.", target = "_blank"),
                                  tags$br(),
                                  fileInput(
                                    "countsfile",
                                    HTML(
                                      paste("Input assay (eg. counts, required):",
                                            tags$span(style = "color:red", "*", sep = ""))
                                    ),
                                    accept = c(
                                      "text/csv", "text/comma-separated-values", "mtx",
                                      "text/tab-separated-values", "text/plain", ".csv", ".tsv"
                                    )
                                  )
                                ),
                                h4("Input Assay Type:"),
                                selectInput("inputAssayType", label = NULL,
                                            c("counts", "normcounts", "logcounts", "cpm",
                                              "logcpm", "tpm", "logtpm")
                                )
                         ),
                         column(width = 4,
                                wellPanel(
                                  h5("Example cell annotation file:"),
                                  HTML('<table class="table"><thead><tr class="header"><th>Cell</th>
                 <th>Annot1</th><th>&#x2026;</th></tr></thead><tbody><tr class="odd">
                 <td>Cell1</td><td>a</td><td>&#x2026;</td></tr><tr class="even">
                 <td>Cell2</td><td>a</td><td>&#x2026;</td></tr><tr class="odd">
                 <td>Cell3</td><td>b</td><td>&#x2026;</td></tr><tr class="even">
                 <td>&#x2026;</td><td>&#x2026;</td><td>&#x2026;</td></tr><tr class="odd"><td>CellN</td>
                 <td>b</td><td>&#x2026;</td></tr></tbody></table>'),
                                  tags$a(href = "https://drive.google.com/open?id=10IDmZQUiASN4wnzO4-WRJQopKvxCNu6J",
                                         "Download an example annotation file here.", target = "_blank"),
                                  tags$br(),
                                  fileInput(
                                    "annotFile", "Cell annotations (optional):",
                                    accept = c(
                                      "text/csv", "text/comma-separated-values",
                                      "text/tab-separated-values", "text/plain", ".csv", ".tsv"
                                    )
                                  )
                                )
                         ),
                         column(width = 4,
                                wellPanel(
                                  h5("Example feature file:"),
                                  HTML('<table class="table"><thead><tr class="header"><th>Gene</th>
               <th>Annot2</th><th>&#x2026;</th></tr></thead><tbody><tr class="odd">
                 <td>Gene1</td><td>a</td><td>&#x2026;</td></tr><tr class="even">
                 <td>Gene2</td><td>a</td><td>&#x2026;</td></tr><tr class="odd">
                 <td>Gene3</td><td>b</td><td>&#x2026;</td></tr><tr class="even">
                 <td>&#x2026;</td><td>&#x2026;</td><td>&#x2026;</td></tr><tr class="odd"><td>GeneM</td>
                 <td>b</td><td>&#x2026;</td></tr></tbody></table>'),
                                  tags$a(href = "https://drive.google.com/open?id=1gxXaZPq5Wrn2lNHacEVaCN2a_FHNvs4O",
                                         "Download an example feature file here.", target = "_blank"),
                                  tags$br(),
                                  fileInput(
                                    "featureFile", "Feature annotations (optional):",
                                    accept = c(
                                      "text/csv", "text/comma-separated-values",
                                      "text/tab-separated-values", "text/plain", ".csv", ".tsv"
                                    )
                                  )
                                )
                         )
                       ),
                       actionButton("addFilesImport", "Add to dataset list")
      ),
      conditionalPanel(
        condition = sprintf("input['%s'] == 'example'", "uploadChoice"),
        h4("Choose Example Dataset:"),
        selectInput("selectExampleData", label = NULL, exampleDatasets, width = "340px"),
        conditionalPanel(
          condition = sprintf("input['%s'] == 'fluidigm_pollen'", "selectExampleData"),
          h4(tags$a(href = "http://dx.doi.org/10.1038/nbt.2967", "130 cells from (Pollen et al. 2014), 65 at high coverage and 65 at low coverage", target = "_blank")),
          "Transcriptomes of cell populations in both of low-coverage (~0.27 million reads per cell) and high-coverage (~5 million reads per cell) to identify cell-type-specific biomarkers, and to compare gene expression across samples specifically for cells of a given type as well as to reconstruct developmental lineages of related cell types. Data was loaded from the 'scRNASeq' package.",
          tags$br(),
          tags$br()
        ),
        conditionalPanel(
          condition = sprintf("input['%s'] == 'allen_tasic'", "selectExampleData"),
          h4(tags$a(href = "http://dx.doi.org/10.1038/nn.4216", "Mouse visual cortex cells from (Tasic et al. 2016)", target = "_blank")),
          "Subset of 379 cells from the mouse visual cortex. Data was loaded from the 'scRNASeq' package.",
          tags$br(),
          tags$br()
        ),
        conditionalPanel(
          condition = sprintf("input['%s'] == 'NestorowaHSCData'", "selectExampleData"),
          h4(tags$a(href = "https://www.nature.com/articles/nbt.2967", "1920 Mouse haematopoietic stem cells from (Nestorowa et al. 2015).", target= "_blank")),
          "Data was loaded from the 'scRNASeq' package.",
          tags$br(),
          tags$br()
        ),
        conditionalPanel(
          condition = sprintf("input['%s'] == 'pbmc3k'", "selectExampleData"),
          h4(tags$a(href = "https://doi.org/10.1038/ncomms14049", "2,700 peripheral blood mononuclear cells (PBMCs) from 10X Genomics", target = "_blank")),
          "Data was loaded with the 'TENxPBMCData' package.",
          tags$br(),
          tags$br()
        ),
        conditionalPanel(
          condition = sprintf("input['%s'] == 'pbmc4k'", "selectExampleData"),
          h4(tags$a(href = "https://doi.org/10.1038/ncomms14049", "4,430 peripheral blood mononuclear cells (PBMCs) from 10X Genomics", target = "_blank")),
          "Data was loaded with the 'TENxPBMCData' package.",
          tags$br(),
          tags$br()
        ),
        conditionalPanel(
          condition = sprintf("input['%s'] == 'pbmc6k'", "selectExampleData"),
          h4(tags$a(href = "https://doi.org/10.1038/ncomms14049", "5,419 peripheral blood mononuclear cells (PBMCs) from 10X Genomics", target = "_blank")),
          "Data was loaded with the 'TENxPBMCData' package.",
          tags$br(),
          tags$br()
        ),
        conditionalPanel(
          condition = sprintf("input['%s'] == 'pbmc8k'", "selectExampleData"),
          h4(tags$a(href = "https://doi.org/10.1038/ncomms14049", "8,381 peripheral blood mononuclear cells (PBMCs) from 10X Genomics", target = "_blank")),
          "Data was loaded with the 'TENxPBMCData' package.",
          tags$br(),
          tags$br()
        ),
        conditionalPanel(
          condition = sprintf("input['%s'] == 'pbmc33k'", "selectExampleData"),
          h4(tags$a(href = "https://doi.org/10.1038/ncomms14049", "33,148 peripheral blood mononuclear cells (PBMCs) from 10X Genomics", target = "_blank")),
          "Data was loaded with the 'TENxPBMCData' package.",
          tags$br(),
          tags$br()
        ),
        conditionalPanel(
          condition = sprintf("input['%s'] == 'pbmc68k'", "selectExampleData"),
          h4(tags$a(href = "https://doi.org/10.1038/ncomms14049", "68,579 peripheral blood mononuclear cells (PBMCs) from 10X Genomics", target = "_blank")),
          "Data was loaded with the 'TENxPBMCData' package.",
          tags$br(),
          tags$br()
        ),
        actionButton("addExampleImport", "Add to sample list")
      ),
      conditionalPanel(
        condition = sprintf("input['%s'] == 'rds'", "uploadChoice"),
        h4("Choose an RDS file that contains a SingleCellExperiment or Seurat object:"),
        fileInput(
          "rdsFile", "SingleCellExperiment or Seurat RDS file:", accept = c(".rds", ".RDS")
        ),
        actionButton("addRDSImport", "Add to sample list")
      ),
      #conditionalPanel(
      #condition = sprintf("input['%s'] == 'directory'", "uploadChoice"),
      #tags$style(HTML("
      #div {
      #  word-wrap: break-word;
      #}
      #")),
      #h3("2. Choose a Preprocessing Tool:"),
      #radioButtons("algoChoice", label = NULL, c("Cell Ranger v2" = "cellRanger2",
      #                                          "Cell Ranger v3" = "cellRanger3",
      #                                         "STARsolo" = "starSolo",
      #                                        "BUStools" = "busTools",
      #                                       "SEQC" = "seqc",
      #                                      "Optimus" = "optimus")
      #),
      #tags$br(),
      # conditionalPanel(
      #   condition = sprintf("input['%s'] == 'cellRanger2'", "uploadChoice"),
      #   actionButton("addCR2Sample", "Add a sample"),
      # ),
      conditionalPanel(
        condition = sprintf("input['%s'] == 'cellRanger3'", "uploadChoice"),
        h4("Upload data for Cell Ranger:"),
        h5("Select matrix, barcodes and feature files for a sample using the file selectors below:"),
        fluidRow(
          column(width = 4,
                 wellPanel(
                   tags$b("Matrix file (e.g. matrix.mtx or matrix.mtx.gz):"),
                   fileInput(
                     "countsfile_custom", "Matrix file:",
                     accept = c(
                       "text/csv", "text/comma-separated-values", ".mtx",
                       "text/tab-separated-values", "text/plain", ".csv", ".tsv", ".gz"
                     ),
                     multiple = TRUE
                   ),
                   tags$a(href = "https://drive.google.com/open?id=1n0CtM6phfkWX0O6xRtgPPg6QuPFP6pY8",
                          "Download an example matrix.mtx file here.", target = "_blank")
                 )
          ),
          column(width = 4,
                 wellPanel(
                   tags$b("Barcodes file (e.g. barcodes.tsv or barcodes.tsv.gz):"),
                   fileInput(
                     "annotFile_custom", "Barcodes file:",
                     accept = c(
                       "text/csv", "text/comma-separated-values",
                       "text/tab-separated-values", "text/plain", ".csv", ".tsv", ".gz"
                     ),
                     multiple = TRUE
                   ),
                   tags$a(href = "https://drive.google.com/open?id=10IDmZQUiASN4wnzO4-WRJQopKvxCNu6J",
                          "Download an example barcodes.tsv file here.", target = "_blank")
                 )
          ),
          column(width = 4,
                 wellPanel(
                   tags$b("Features file (e.g. features.tsv or features.tsv.gz):"),
                   fileInput(
                     "featureFile_custom", "Features file:",
                     accept = c(
                       "text/csv", "text/comma-separated-values",
                       "text/tab-separated-values", "text/plain", ".csv", ".tsv", ".gz"
                     ),
                     multiple = TRUE
                   ),
                   tags$a(href = "https://drive.google.com/open?id=1gxXaZPq5Wrn2lNHacEVaCN2a_FHNvs4O",
                          "Download an example features.tsv file here.", target = "_blank")
                 )
          ),
          column(width = 4,
                 wellPanel(
                   h5("(OPTIONAL)"),
                   h5("Metrics Summary file (metrics_summary.csv):"),
                   fileInput(
                     "summaryFile_custom", "Summary file:",
                     accept = c(
                       "text/csv", "text/comma-separated-values",
                       "text/tab-separated-values", "text/plain", ".csv", ".tsv", ".gz"
                     ),
                     multiple = FALSE
                   )
                   # ,
                   # tags$a(href = "https://drive.google.com/open?id=10IDmZQUiASN4wnzO4-WRJQopKvxCNu6J",
                   #        "Download an example metrics_summary.csv file here.", target = "_blank")
                 )
          )
        ),
        textInput("sampleNameCR", "Name for this sample:", value = "sample", placeholder = "sample"),
        tags$h5("Note: Each sample should be given a unique name", style = "color: red;"),
        actionButton("addFilesImport_custom", "Add to dataset list")
        #actionButton("addCR3Sample", "Add a sample"),
      ),
      # conditionalPanel(
      #   condition = sprintf("input['%s'] == 'starSolo'", "uploadChoice"),
      #   wellPanel(
      #     h5("Please select the directory that contains your /Gene directory as your base directory. ")
      #   ),
      #   actionButton("addSSSample", "Add a sample"),
      # ),
      conditionalPanel(
        condition = sprintf("input['%s'] == 'starSolo'", "uploadChoice"),
        h4("Upload data for starSolo:"),
        h5("Select matrix, barcodes and feature files for a sample using the file selectors below:"),
        fluidRow(
          column(width = 4,
                 wellPanel(
                   tags$b("Matrix file (e.g. matrix.mtx or matrix.mtx.gz):"),
                   fileInput(
                     "countsfile_custom_starSolo", "Matrix file:",
                     accept = c(
                       "text/csv", "text/comma-separated-values", ".mtx",
                       "text/tab-separated-values", "text/plain", ".csv", ".tsv", ".gz"
                     ),
                     multiple = TRUE
                   ),
                   tags$a(href = "https://drive.google.com/open?id=1n0CtM6phfkWX0O6xRtgPPg6QuPFP6pY8",
                          "Download an example matrix.mtx file here.", target = "_blank")
                 )
          ),
          column(width = 4,
                 wellPanel(
                   tags$b("Barcodes file (e.g. barcodes.tsv or barcodes.tsv.gz):"),
                   fileInput(
                     "annotFile_custom_starSolo", "Barcodes file:",
                     accept = c(
                       "text/csv", "text/comma-separated-values",
                       "text/tab-separated-values", "text/plain", ".csv", ".tsv", ".gz"
                     ),
                     multiple = TRUE
                   ),
                   tags$a(href = "https://drive.google.com/open?id=10IDmZQUiASN4wnzO4-WRJQopKvxCNu6J",
                          "Download an example barcodes.tsv file here.", target = "_blank")
                 )
          ),
          column(width = 4,
                 wellPanel(
                   tags$b("Features file (e.g. features.tsv or features.tsv.gz):"),
                   fileInput(
                     "featureFile_custom_starSolo", "Features file:",
                     accept = c(
                       "text/csv", "text/comma-separated-values",
                       "text/tab-separated-values", "text/plain", ".csv", ".tsv", ".gz"
                     ),
                     multiple = TRUE
                   ),
                   tags$a(href = "https://drive.google.com/open?id=1gxXaZPq5Wrn2lNHacEVaCN2a_FHNvs4O",
                          "Download an example features.tsv file here.", target = "_blank")
                 )
          )
        ),
        textInput("sampleNameSS", "Name for this sample:", value = "sample", placeholder = "sample"),
        tags$h5("Note: Each sample should be given a unique name", style = "color: red;"),
        actionButton("addFilesImport_custom_starSolo", "Add to dataset list")
        #actionButton("addCR3Sample", "Add a sample"),
      ),
      # conditionalPanel(
      #   condition = sprintf("input['%s'] == 'busTools'", "uploadChoice"),
      #   wellPanel(
      #     h5("Please select your /genecount directory as your base directory.")
      #   ),
      #   actionButton("addBUSSample", "Add a sample"),
      # ),
      conditionalPanel(
        condition = sprintf("input['%s'] == 'busTools'", "uploadChoice"),
        h4("Upload data for BUSTools:"),
        h5("Select matrix, barcodes and feature files for a sample using the file selectors below:"),
        fluidRow(
          column(width = 4,
                 wellPanel(
                   tags$b("Matrix file (e.g. matrix.mtx or matrix.mtx.gz):"),
                   fileInput(
                     "countsfile_custom_busTools", "Matrix file:",
                     accept = c(
                       "text/csv", "text/comma-separated-values", ".mtx",
                       "text/tab-separated-values", "text/plain", ".csv", ".tsv", ".gz"
                     ),
                     multiple = TRUE
                   ),
                   tags$a(href = "https://drive.google.com/open?id=1n0CtM6phfkWX0O6xRtgPPg6QuPFP6pY8",
                          "Download an example matrix.mtx file here.", target = "_blank")
                 )
          ),
          column(width = 4,
                 wellPanel(
                   tags$b("Barcodes file (e.g. barcodes.tsv or barcodes.tsv.gz):"),
                   fileInput(
                     "annotFile_custom_busTools", "Barcodes file:",
                     accept = c(
                       "text/csv", "text/comma-separated-values",
                       "text/tab-separated-values", "text/plain", ".csv", ".tsv", ".gz"
                     ),
                     multiple = TRUE
                   ),
                   tags$a(href = "https://drive.google.com/open?id=10IDmZQUiASN4wnzO4-WRJQopKvxCNu6J",
                          "Download an example barcodes.tsv file here.", target = "_blank")
                 )
          ),
          column(width = 4,
                 wellPanel(
                   tags$b("Features file (e.g. features.tsv or features.tsv.gz):"),
                   fileInput(
                     "featureFile_custom_busTools", "Features file:",
                     accept = c(
                       "text/csv", "text/comma-separated-values",
                       "text/tab-separated-values", "text/plain", ".csv", ".tsv", ".gz"
                     ),
                     multiple = TRUE
                   ),
                   tags$a(href = "https://drive.google.com/open?id=1gxXaZPq5Wrn2lNHacEVaCN2a_FHNvs4O",
                          "Download an example features.tsv file here.", target = "_blank")
                 )
          )
        ),
        textInput("sampleNameBT", "Name for this sample:", value = "sample", placeholder = "sample"),
        tags$h5("Note: Each sample should be given a unique name", style = "color: red;"),
        actionButton("addFilesImport_custom_busTools", "Add to dataset list")
        #actionButton("addCR3Sample", "Add a sample"),
      ),
      # conditionalPanel(
      #   condition = sprintf("input['%s'] == 'seqc'", "uploadChoice"),
      #   wellPanel(
      #     h5("Please select the directory that contains your sample files as your base directory.")
      #   ),
      #   actionButton("addSEQSample", "Add a sample"),
      # ),
      # conditionalPanel(
      #   condition = sprintf("input['%s'] == 'seqc'", "uploadChoice"),
      #   wellPanel(
      #     h5("Please select the directory that contains your sample files as your base directory.")
      #   ),
      #   actionButton("addSEQSample", "Add a sample"),
      # ),
      conditionalPanel(
        condition = sprintf("input['%s'] == 'seqc'", "uploadChoice"),
        h4("Upload data for SEQC:"),
        h5("Select matrix, barcodes and feature files for a sample using the file selectors below:"),
        fluidRow(
          column(width = 4,
                 wellPanel(
                   tags$b("Read counts file (e.g. pbmc_1k_sparse_read_counts.mtx or pbmc_1k_sparse_read_counts.mtx.gz:"),
                   fileInput(
                     "readCounts_custom_seqc", "Read counts file:",
                     accept = c(
                       "text/csv", "text/comma-separated-values", ".mtx",
                       "text/tab-separated-values", "text/plain", ".csv", ".tsv", ".gz"
                     ),
                     multiple = TRUE
                   )
                   # ,
                   # tags$a(href = "https://drive.google.com/open?id=1n0CtM6phfkWX0O6xRtgPPg6QuPFP6pY8",
                   #        "Download an example matrix.mtx file here.", target = "_blank")
                 )
          ),
          column(width = 4,
                 wellPanel(
                   tags$b("Molecule counts file (e.g. pbmc_1k_sparse_molecule_counts.mtx or pbmc_1k_sparse_molecule_counts.mtx.gz):"),
                   fileInput(
                     "moleculeCounts_custom_seqc", "Molecule counts file:",
                     accept = c(
                       "text/csv", "text/comma-separated-values", ".mtx",
                       "text/tab-separated-values", "text/plain", ".csv", ".tsv", ".gz"
                     ),
                     multiple = TRUE
                   )
                   # ,
                   # tags$a(href = "https://drive.google.com/open?id=10IDmZQUiASN4wnzO4-WRJQopKvxCNu6J",
                   #        "Download an example barcodes.tsv file here.", target = "_blank")
                 )
          ),
          column(width = 4,
                 wellPanel(
                   tags$b("Barcodes file (e.g. pbmc_1k_sparse_counts_barcodes.csv):"),
                   fileInput(
                     "barcodes_custom_seqc", "Barcodes file:",
                     accept = c(
                       "text/csv", "text/comma-separated-values", 
                       "text/tab-separated-values", "text/plain", ".csv", ".tsv", ".gz"
                     ),
                     multiple = TRUE
                   )
                   # ,
                   # tags$a(href = "https://drive.google.com/open?id=1gxXaZPq5Wrn2lNHacEVaCN2a_FHNvs4O",
                   #        "Download an example features.tsv file here.", target = "_blank")
                 )
          ),
          column(width = 4,
                 wellPanel(
                   tags$b("Genes file (e.g. pbmc_1k_sparse_counts_genes.csv):"),
                   fileInput(
                     "genes_custom_seqc", "Genes file:",
                     accept = c(
                       "text/csv", "text/comma-separated-values",
                       "text/tab-separated-values", "text/plain", ".csv", ".tsv", ".gz"
                     ),
                     multiple = TRUE
                   )
                   # ,
                   # tags$a(href = "https://drive.google.com/open?id=1gxXaZPq5Wrn2lNHacEVaCN2a_FHNvs4O",
                   #        "Download an example features.tsv file here.", target = "_blank")
                 )
          )
        ),
        textInput("sampleNameSC", "Name for this sample:", value = "sample", placeholder = "sample"),
        tags$h5("Note: Each sample should be given a unique name", style = "color: red;"),
        actionButton("addFilesImport_custom_seqc", "Add to dataset list")
        #actionButton("addCR3Sample", "Add a sample"),
      ),
      conditionalPanel(
        condition = sprintf("input['%s'] == 'optimus'", "uploadChoice"),
        h4("Upload data for Optimus:"),
        h5("Select matrix, barcodes and feature files for a sample using the file selectors below:"),
        fluidRow(
          column(width = 4,
                 wellPanel(
                   tags$b("Counts file (e.g. sparse_counts.npz):"),
                   fileInput(
                     "matrix_custom_optimus", "Counts file:",
                     accept = c(
                       "text/csv", "text/comma-separated-values", ".npz",
                       "text/tab-separated-values", "text/plain", ".csv", ".tsv", ".gz"
                     ),
                     multiple = TRUE
                   )
                   # ,
                   # tags$a(href = "https://drive.google.com/open?id=1n0CtM6phfkWX0O6xRtgPPg6QuPFP6pY8",
                   #        "Download an example matrix.mtx file here.", target = "_blank")
                 )
          ),
          column(width = 4,
                 wellPanel(
                   tags$b("Column index file (e.g. sparse_counts_col_index.npy):"),
                   fileInput(
                     "colIndex_custom_optimus", "Column index file:",
                     accept = c(
                       "text/csv", "text/comma-separated-values", ".npy",
                       "text/tab-separated-values", "text/plain", ".csv", ".tsv", ".gz"
                     ),
                     multiple = TRUE
                   )
                   # ,
                   # tags$a(href = "https://drive.google.com/open?id=10IDmZQUiASN4wnzO4-WRJQopKvxCNu6J",
                   #        "Download an example barcodes.tsv file here.", target = "_blank")
                 )
          ),
          column(width = 4,
                 wellPanel(
                   tags$b("Row index file (e.g. sparse_counts_row_index.npy):"),
                   fileInput(
                     "rowIndex_custom_optimus", "Row index file:",
                     accept = c(
                       "text/csv", "text/comma-separated-values", ".npy",
                       "text/tab-separated-values", "text/plain", ".csv", ".tsv", ".gz"
                     ),
                     multiple = TRUE
                   )
                   # ,
                   # tags$a(href = "https://drive.google.com/open?id=1gxXaZPq5Wrn2lNHacEVaCN2a_FHNvs4O",
                   #        "Download an example features.tsv file here.", target = "_blank")
                 )
          ),
          column(width = 4,
                 wellPanel(
                   tags$b("Cell metrics file (e.g. merged-cell-metrics.csv or merged-cell-metrics.csv.gz):"),
                   fileInput(
                     "cellMetrics_custom_optimus", "Cell metrics file:",
                     accept = c(
                       "text/csv", "text/comma-separated-values",
                       "text/tab-separated-values", "text/plain", ".csv", ".tsv", ".gz"
                     ),
                     multiple = TRUE
                   )
                   # ,
                   # tags$a(href = "https://drive.google.com/open?id=1gxXaZPq5Wrn2lNHacEVaCN2a_FHNvs4O",
                   #        "Download an example features.tsv file here.", target = "_blank")
                 )
          ),
          column(width = 4,
                 wellPanel(
                   tags$b("Gene metrics file (e.g. merged-gene-metrics.csv or merged-gene-metrics.csv.gz):"),
                   fileInput(
                     "geneMetrics_custom_optimus", "Gene metrics file:",
                     accept = c(
                       "text/csv", "text/comma-separated-values",
                       "text/tab-separated-values", "text/plain", ".csv", ".tsv", ".gz"
                     ),
                     multiple = TRUE
                   )
                   # ,
                   # tags$a(href = "https://drive.google.com/open?id=1gxXaZPq5Wrn2lNHacEVaCN2a_FHNvs4O",
                   #        "Download an example features.tsv file here.", target = "_blank")
                 )
          ),
          column(width = 4,
                 wellPanel(
                   tags$b("Empty drops file (e.g. empty_drops_result.csv):"),
                   fileInput(
                     "emptyDrops_custom_optimus", "Empty drops file:",
                     accept = c(
                       "text/csv", "text/comma-separated-values",
                       "text/tab-separated-values", "text/plain", ".csv", ".tsv", ".gz"
                     ),
                     multiple = TRUE
                   )
                   # ,
                   # tags$a(href = "https://drive.google.com/open?id=1gxXaZPq5Wrn2lNHacEVaCN2a_FHNvs4O",
                   #        "Download an example features.tsv file here.", target = "_blank")
                 )
          )
        ),
        textInput("sampleNameOP", "Name for this sample:", value = "sample", placeholder = "sample"),
        tags$h5("Note: Each sample should be given a unique name", style = "color: red;"),
        actionButton("addFilesImport_custom_optimus", "Add to dataset list")
        #actionButton("addCR3Sample", "Add a sample"),
      ),
      # conditionalPanel(
      #   condition = sprintf("input['%s'] == 'optimus'", "uploadChoice"),
      #   wellPanel(
      #     h5("Please select the directory that contains the following four directories - call-MergeCountFiles, call-MergeCellMetrics, call-MergeGeneMetrics, call-RunEmptyDrops - as your base directory.")
      #   ),
      #   actionButton("addOptSample", "Add a sample"),
      # ),
      style = "primary"
    ),

    bsCollapsePanel(
      "2. Create dataset:",
      wellPanel(
        h4("Samples to Import:"),
        fluidRow(
          column(3, tags$b("Type")),
          column(3, tags$b("Location")),
          column(3, tags$b("Sample Name")),
          column(3, tags$b("Remove"))
        ),
        tags$div(id = "newSampleImport"),
        tags$br(),
        tags$br(),
        actionButton("clearAllImport", "Clear Samples")
      ),
      shinyjs::hidden(
        tags$div(
          id = "combineOptions",
          radioButtons("combineSCEChoice", label = NULL, c("Add to existing dataset" = 'addToExistingSCE',
                                                           "Overwrite existing dataset" = "overwriteSCE")
          )
        )
      ),

        column(
          12,
          fluidRow(
            actionButton("uploadData", "Import"),
            actionButton("backToStepOne", "Add one more sample")
          )
        ),
      style = "primary"
    ),

    bsCollapsePanel(
      "3. Data summary:",
      hidden(
        wellPanel(
          id = "annotationData",
          h3("Data summary"),
          DT::dataTableOutput("summarycontents"),

          tags$hr(),

          h3("Dataset options:"),
          selectInput("importFeatureNamesOpt",
                      "Set feature ID (only showing annotations without the NAs)",
                      c("Default", featureChoice)),
          selectInput("importFeatureDispOpt",
                      "Set feature names to be displayed in downstream visualization",
                      c("Default", featureChoice)),

          withBusyIndicatorUI(actionButton("importFeatureDipSet", "Set")),
        )
      ),

      style = "primary"
    )
  ),
  nonLinearWorkflowUI(id = "nlw-import")
)

#' Plot a heatmap to visualize the result of \code{\link{runFindMarker}}
#' @description This function will first reads the result saved in
#' \code{metadata} slot, named by \code{"findMarker"} and generated by
#' \code{\link{runFindMarker}}. Then it do the filtering on the statistics
#' based on the input parameters and get unique genes to plot. We choose the
#' genes that are identified as up-regulated only. As for the genes identified
#' as up-regulated for multiple clusters, we only keep the belonging towards the
#' one they have the highest Log2FC value.
#' In the heatmap, there will always be a cell annotation for the cluster
#' labeling used when finding the markers, and a feature annotation for which
#' cluster each gene belongs to. And by default we split the heatmap by these
#' two annotations. Additional legends can be added and the splitting can be
#' canceled.
#' @param inSCE \linkS4class{SingleCellExperiment} inherited object.
#' @param log2fcThreshold Only use DEGs with the absolute values of log2FC
#' larger than this value. Default \code{1}
#' @param fdrThreshold Only use DEGs with FDR value smaller than this value.
#' Default \code{0.05}
#' @param minClustExprPerc A numeric scalar. The minimum cutoff of the
#' percentage of cells in the cluster of interests that expressed the marker
#' gene. Default \code{0.7}.
#' @param maxCtrlExprPerc A numeric scalar. The maximum cutoff of the
#' percentage of cells out of the cluster (control group) that expressed the
#' marker gene. Default \code{0.4}.
#' @param minMeanExpr A numeric scalar. The minimum cutoff of the mean
#' expression value of the marker in the cluster of interests. Default \code{1}.
#' @param topN An integer. Only to plot this number of top markers for each
#' cluster in maximum, in terms of log2FC value. Use \code{NULL} to cancel the
#' top N subscription. Default \code{10}.
#' @param orderBy The ordering method of the clusters on the splitted heatmap.
#' Can be chosen from \code{"size"} or \code{"name"}, specified with vector of
#' ordered unique cluster labels, or set as \code{NULL} for unsplitted heatmap.
#' Default \code{"size"}.
#' @param decreasing Order the cluster decreasingly. Default \code{TRUE}.
#' @param rowLabel \code{TRUE} for displaying \code{rownames} of \code{inSCE}, a
#' \code{rowData} variable to use other feature identifiers, or a vector for
#' customized row labels. Use \code{FALSE} for not displaying. Default
#' \code{TRUE}.
#' @param rowDataName character. The column name(s) in \code{rowData} that need
#' to be added to the annotation. Default \code{NULL}.
#' @param colDataName character. The column name(s) in \code{colData} that need
#' to be added to the annotation. Default \code{NULL}.
#' @param featureAnnotations \code{data.frame}, with \code{rownames} containing
#' all the features going to be plotted. Character columns should be factors.
#' Default \code{NULL}.
#' @param cellAnnotations \code{data.frame}, with \code{rownames} containing
#' all the cells going to be plotted. Character columns should be factors.
#' Default \code{NULL}.
#' @param featureAnnotationColor A named list. Customized color settings for
#' feature labeling. Should match the entries in the \code{featureAnnotations}
#' or \code{rowDataName}. For each entry, there should be a list/vector of
#' colors named with categories. Default \code{NULL}.
#' @param cellAnnotationColor A named list. Customized color settings for
#' cell labeling. Should match the entries in the \code{cellAnnotations} or
#' \code{colDataName}. For each entry, there should be a list/vector of colors
#' named with categories. Default \code{NULL}.
#' @param colSplitBy character vector. Do semi-heatmap based on the grouping of
#' this(these) annotation(s). Should exist in either \code{colDataName} or
#' \code{names(cellAnnotations)}. Default is the value of \code{cluster} in
#' \code{\link{runFindMarker}} when \code{orderBy} is not \code{NULL}, or
#' \code{NULL} otherwise.
#' @param rowSplitBy character vector. Do semi-heatmap based on the grouping of
#' this(these) annotation(s). Should exist in either \code{rowDataName} or
#' \code{names(featureAnnotations)}. Default \code{"marker"}, which indicates an
#' auto generated annotation for this plot.
#' @param rowDend Whether to display row dendrogram. Default \code{FALSE}.
#' @param colDend Whether to display column dendrogram. Default \code{FALSE}.
#' @param title Text of the title, at the top of the heatmap. Default
#' \code{"Top Marker Heatmap"}.
#' @param ... Other arguments passed to \code{\link{plotSCEHeatmap}}.
#' @return A \code{\link[ComplexHeatmap]{Heatmap}} object
#' @seealso \code{\link{runFindMarker}}, \code{\link{getFindMarkerTopTable}}
#' @author Yichen Wang
#' @export
#' @examples
#' data("sceBatches")
#' logcounts(sceBatches) <- log1p(counts(sceBatches))
#' sce.w <- subsetSCECols(sceBatches, colData = "batch == 'w'")
#' sce.w <- runFindMarker(sce.w, method = "wilcox", cluster = "cell_type")
#' plotFindMarkerHeatmap(sce.w)
plotFindMarkerHeatmap <- function(inSCE, orderBy = 'size',
                              log2fcThreshold = 1, fdrThreshold = 0.05,
                              minClustExprPerc = 0.7, maxCtrlExprPerc = 0.4,
                              minMeanExpr = 1, topN = 10, decreasing = TRUE,
                              rowLabel = TRUE,
                              rowDataName = NULL, colDataName = NULL,
                              featureAnnotations = NULL, cellAnnotations = NULL,
                              featureAnnotationColor = NULL,
                              cellAnnotationColor = NULL,
                              colSplitBy = NULL,
                              rowSplitBy = "marker", rowDend = FALSE,
                              colDend = FALSE,
                              title = "Top Marker Heatmap", ...) {
  if (!inherits(inSCE, 'SingleCellExperiment')) {
    stop('"inSCE" should be a SingleCellExperiment inherited Object.')
  }
  if (!'findMarker' %in% names(S4Vectors::metadata(inSCE))) {
    stop('"findMarker" result not found in metadata. ',
         'Run runFindMarker() before plotting.')
  }
  colSplitBy <-
    ifelse(is.null(orderBy), NULL, colnames(metadata(inSCE)$findMarker)[5])

  if (!is.null(orderBy)) {
    if (length(orderBy) == 1) {
      if (!orderBy %in% c('size', 'name')) {
        stop('Single charater setting for "orderBy" should be chosen',
             'from "size" or "name".')
      }
    }# else if(any(!SummarizedExperiment::colData(inSCE)[[cluster]] %in%
    #             orderBy)){
    #   stop('Invalid "orderBy", please input a vector of unique ordered ',
    #        'cluster identifiers that match all clusters in ',
    #        'colData(inSCE) specified by "cluster" to adjust the order ',
    #        'of clusters.')
    #}
  }
  # Extract and basic filter
  degFull <- S4Vectors::metadata(inSCE)$findMarker
  if (!all(c("Gene", "Pvalue", "Log2_FC", "FDR") %in%
          colnames(degFull)[seq_len(4)])) {
    stop('"findMarker" result cannot be interpreted properly')
  }
  clusterVar <- attr(degFull, "cluster")
  clusterName <- attr(degFull, "clusterName")
  #if(length(which(!degFull$Gene %in% rownames(inSCE))) > 0){
  # Remove genes happen in deg table but not in sce. Weird.
  # degFull <- degFull[-which(!degFull$Gene %in% rownames(inSCE)),]
  #}
  if (!is.null(log2fcThreshold)) {
    degFull <- degFull[degFull$Log2_FC > log2fcThreshold,]
  }
  if (!is.null(fdrThreshold)) {
    degFull <- degFull[degFull$FDR < fdrThreshold,]
  }
  if (!is.null(minClustExprPerc)) {
    degFull <- degFull[degFull$clusterExprPerc >= minClustExprPerc,]
  }
  if (!is.null(maxCtrlExprPerc)) {
    degFull <- degFull[degFull$ControlExprPerc <= maxCtrlExprPerc,]
  }
  if (!is.null(minMeanExpr)) {
    degFull <- degFull[degFull$clusterAveExpr >= minMeanExpr,]
  }
  # Remove duplicate by assigning the duplicated genes to the cluster where
  # their log2FC is the highest.
  # Done by keeping all unique genes and the rows  with highest Log2FC entry
  # for each duplicated gene.
  dup.gene <- unique(degFull$Gene[duplicated(degFull$Gene)])
  for (g in dup.gene) {
    deg.gix <- degFull$Gene == g
    deg.gtable <- degFull[deg.gix,]
    toKeep <- which.max(deg.gtable$Log2_FC)
    toRemove <- which(deg.gix)[-toKeep]
    degFull <- degFull[-toRemove,]
  }
  selected <- character()
  if (!is.null(topN)) {
    for (c in unique(degFull[[clusterName]])) {
      deg.cluster <- degFull[degFull[[clusterName]] == c,]
      deg.cluster <- deg.cluster[order(deg.cluster$Log2_FC,
                                       decreasing = TRUE),]
      if (dim(deg.cluster)[1] > topN) {
        deg.cluster <- deg.cluster[seq_len(topN),]
      }
      selected <- c(selected, deg.cluster$Gene)
    }
  } else {
    selected <- degFull$Gene
  }
  degFull <- degFull[degFull$Gene %in% selected,]

  if (!is.null(attr(degFull, "useReducedDim"))) {
    mat <- t(expData(inSCE, attr(degFull, "useReducedDim")))
    assayList <- list(mat)
    names(assayList) <- attr(degFull, "useReducedDim")
    tmpSCE <- SingleCellExperiment::SingleCellExperiment(assays = assayList)
    SummarizedExperiment::colData(tmpSCE) <-
      SummarizedExperiment::colData(inSCE)
    assayName <- attr(degFull, "useReducedDim")

  } else {
    tmpSCE <- inSCE
    assayName <- attr(degFull, "useAssay")

  }

  inSCE <- tmpSCE[degFull$Gene,]
  z <- clusterVar
  if (is.factor(z)) {
    z.order <- levels(z)
    # When 'z' is a subset factor, there would be redundant levels.
    z.order <- z.order[z.order %in% as.vector(unique(z))]
    z <- factor(z, levels = z.order)
    SummarizedExperiment::rowData(inSCE)[[clusterName]] <-
      factor(degFull[[clusterName]], levels = z.order)
  } else {
    SummarizedExperiment::rowData(inSCE)[[clusterName]] <-
      degFull[[clusterName]]
  }
  if (!is.null(orderBy)) {
    if (length(orderBy) == 1 && orderBy == 'size') {
      z.order <- names(table(z)[order(table(z), decreasing = decreasing)])
    } else if (length(orderBy) == 1 && orderBy == 'name') {
      if (is.factor(z)) {
        z.order <- sort(levels(z), decreasing = decreasing)
      } else {
        z.order <- sort(unique(z), decreasing = decreasing)
      }
    } else {
      z.order <- orderBy[-which(!orderBy %in% z)]
    }
  }
  SummarizedExperiment::colData(inSCE)[[clusterName]] <-
    factor(z, levels = z.order)


  y <- SummarizedExperiment::rowData(inSCE)[[clusterName]]
  SummarizedExperiment::rowData(inSCE)[["marker"]] <-
    factor(y, levels = z.order)

  #markerConsistColor <-
  #  list(marker = dataAnnotationColor(inSCE, 'col')[[clusterName]])

  # Organize plotSCEHeatmap arguments
  colDataName <- c(colDataName, clusterName)
  rowDataName <- c(rowDataName, "marker")

  #featureAnnotationColor <- c(featureAnnotationColor, markerConsistColor)

  hm <- plotSCEHeatmap(inSCE, useAssay = assayName, colDataName = colDataName,
                       rowDataName = rowDataName, colSplitBy = colSplitBy,
                       rowSplitBy = rowSplitBy,
                       featureAnnotations = featureAnnotations,
                       cellAnnotations = cellAnnotations,
                       featureAnnotationColor = featureAnnotationColor,
                       cellAnnotationColor = cellAnnotationColor, rowLabel = rowLabel,
                       rowDend = rowDend, colDend = colDend, title = title, ...)
  return(hm)
}

#' @rdname plotFindMarkerHeatmap
#' @export
plotMarkerDiffExp <- function(inSCE, orderBy = 'size',
                              log2fcThreshold = 1, fdrThreshold = 0.05,
                              minClustExprPerc = 0.7, maxCtrlExprPerc = 0.4,
                              minMeanExpr = 1, topN = 10, decreasing = TRUE,
                              rowDataName = NULL, colDataName = NULL,
                              featureAnnotations = NULL, cellAnnotations = NULL,
                              featureAnnotationColor = NULL,
                              cellAnnotationColor = NULL,
                              colSplitBy = NULL,
                              rowSplitBy = "marker", rowDend = FALSE,
                              colDend = FALSE,
                              title = "Top Marker Heatmap", ...) {
  .Deprecated("plotFindMarkerHeatmap")
  plotFindMarkerHeatmap(inSCE = inSCE, orderBy = orderBy,
                        log2fcThreshold = log2fcThreshold,
                        fdrThreshold = fdrThreshold,
                        minClustExprPerc = minClustExprPerc,
                        maxCtrlExprPerc = maxCtrlExprPerc,
                        minMeanExpr = minMeanExpr, topN = topN,
                        decreasing = decreasing,
                        rowDataName = rowDataName, colDataName = colDataName,
                        featureAnnotations = featureAnnotations,
                        cellAnnotations = cellAnnotations,
                        featureAnnotationColor = featureAnnotationColor,
                        cellAnnotationColor = cellAnnotationColor,
                        colSplitBy = colSplitBy,
                        rowSplitBy = rowSplitBy, rowDend = rowDend,
                        colDend = colDend, title = title, ...)
}

#' Apply BBKNN batch effect correction method to SingleCellExperiment object
#'
#' BBKNN, an extremely fast graph-based data integration algorithm. It modifies
#' the neighbourhood construction step to produce a graph that is balanced
#' across all batches of the data.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object
#' @param useAssay A single character indicating the name of the assay requiring
#' batch correction. Default \code{"logcounts"}.
#' @param batch A single character indicating a field in \code{colData} that
#' annotates the batches of each cell; or a vector/factor with the same length
#' as the number of cells. Default \code{"batch"}.
#' @param reducedDimName A single character. The name for the corrected
#' low-dimensional representation. Will be saved to \code{reducedDim(inSCE)}.
#' Default \code{"BBKNN"}.
#' @param nComponents An integer. Number of principle components or the
#' dimensionality, adopted in the pre-PCA-computation step, the BBKNN step (for
#' how many PCs the algorithm takes into account), and the final UMAP
#' combination step where the value represent the dimensionality of the updated
#' reducedDim. Default \code{50L}.
#' @return The input \linkS4class{SingleCellExperiment} object with
#' \code{reducedDim(inSCE, reducedDimName)} updated.
#' @export
#' @references Krzysztof Polanski et al., 2020
#' @examples
#' \dontrun{
#' data('sceBatches', package = 'singleCellTK')
#' logcounts(sceBatches) <- log1p(counts(sceBatches))
#' sceBatches <- runBBKNN(sceBatches, useAssay = "logcounts",
#'                        nComponents = 10)
#' }
runBBKNN <-function(inSCE, useAssay = 'logcounts', batch = 'batch',
                    reducedDimName = 'BBKNN', nComponents = 50L){
  if(!reticulate::py_module_available(module = "bbknn")){
    warning("Cannot find python module 'bbknn', please install Conda and",
            " run sctkPythonInstallConda() or run ",
            "sctkPythonInstallVirtualEnv(). If one of these have been ",
            "previously run to install the modules, make sure to run ",
            "selectSCTKConda() or selectSCTKVirtualEnvironment(),",
            " respectively, if R has been restarted since the module ",
            "installation. Alternatively, bbknn can be installed on the local ",
            "machine with pip (e.g. pip install bbknn) and then the ",
            "'use_python()' function from the 'reticulate' package can be used",
            " to select the correct Python environment.")
    return(inSCE)
  }
  useAssay <- .selectSCEMatrix(inSCE, useAssay = useAssay,
                               returnMatrix = FALSE)$names$useAssay
  batchVec <- .manageCellVar(inSCE, batch, as.factor = FALSE)
  reducedDimName <- gsub(' ', '_', reducedDimName)
  nComponents <- as.integer(nComponents)
  ## Run algorithm
  adata <- .sce2adata(inSCE, useAssay = useAssay)
  adata$obs[["batch"]] <- batchVec
  sc$tl$pca(adata, n_comps = nComponents)
  bbknn$bbknn(adata, batch_key = "batch", n_pcs = nComponents)
  sc$tl$umap(adata, n_components = nComponents)
  bbknnUmap <- adata$obsm[["X_umap"]]
  SingleCellExperiment::reducedDim(inSCE, reducedDimName) <- bbknnUmap
  S4Vectors::metadata(inSCE)$batchCorr[[reducedDimName]] <- list(useAssay = useAssay,
                                                            origLogged = TRUE,
                                                            method = "BBKNN",
                                                            matType = "reducedDim",
                                                            batch = batch)
  return(inSCE)
}

#' Apply ComBat-Seq batch effect correction method to SingleCellExperiment
#' object
#'
#' The ComBat-Seq batch adjustment approach assumes that batch effects represent
#' non-biological but systematic shifts in the mean or variability of genomic
#' features for all samples within a processing batch. It uses either parametric
#' or non-parametric empirical Bayes frameworks for adjusting data for batch
#' effects.
#'
#' For the parameters \code{covariates} and \code{useSVA}, when the cell type
#' information is known, it is recommended to specify the cell type annotation
#' to the argument \code{covariates}; if the cell types are unknown but
#' expected to be balanced, it is recommended to run with default settings, yet
#' informative covariates could still be useful. If the cell types are unknown
#' and are expected to be unbalanced, it is recommended to set \code{useSVA}
#' to \code{TRUE}.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object
#' @param useAssay A single character indicating the name of the assay requiring
#' batch correction. Default \code{"counts"}.
#' @param batch A single character indicating a field in
#' \code{\link[SummarizedExperiment]{colData}} that annotates the batches.
#' Default \code{"batch"}.
#' @param covariates A character vector indicating the fields in
#' \code{\link[SummarizedExperiment]{colData}} that annotates other covariates,
#' such as the cell types. Default \code{NULL}.
#' @param bioCond A single character indicating a field in
#' \code{\link[SummarizedExperiment]{colData}} that annotates the biological
#' conditions. Default \code{NULL}.
#' @param useSVA A logical scalar. Whether to estimate surrogate variables and
#' use them as an empirical control. Default \code{FALSE}.
#' @param assayName A single characeter. The name for the corrected assay. Will
#' be saved to \code{\link[SummarizedExperiment]{assay}}. Default
#' \code{"ComBat"}.
#' @param shrink A logical scalar. Whether to apply shrinkage on parameter
#' estimation. Default \code{FALSE}.
#' @param shrinkDisp A logical scalar. Whether to apply shrinkage on dispersion.
#' Default \code{FALSE}.
#' @param nGene An integer. Number of random genes to use in empirical Bayes
#' estimation, only useful when \code{shrink} is set to \code{TRUE}. Default
#' \code{NULL}.
#' @return The input \linkS4class{SingleCellExperiment} object with
#' \code{assay(inSCE, assayName)} updated.
#' @examples
#' data('sceBatches', package = 'singleCellTK')
#' sceBatches <- sample(sceBatches, 40)
#' # Cell type known
#' sceBatches <- runComBatSeq(sceBatches, "counts", "batch",
#'                            covariates = "cell_type",
#'                            assayName = "ComBat_cell_seq")
#' # Cell type unknown but balanced
#' #sceBatches <- runComBatSeq(sceBatches, "counts", "batch",
#' #                           assayName = "ComBat_seq")
#' # Cell type unknown and unbalanced
#' #sceBatches <- runComBatSeq(sceBatches, "counts", "batch",
#' #                           useSVA = TRUE,
#' #                           assayName = "ComBat_sva_seq")
#' @export
runComBatSeq <- function(inSCE, useAssay = "counts", batch = 'batch',
                         covariates = NULL, bioCond = NULL, useSVA = FALSE,
                         assayName = "ComBatSeq", shrink = FALSE,
                         shrinkDisp = FALSE, nGene = NULL) {
  if(!inherits(inSCE, "SingleCellExperiment")){
    stop("\"inSCE\" should be a SingleCellExperiment Object.")
  }
  if(!useAssay %in% SummarizedExperiment::assayNames(inSCE)) {
    p <- paste("\"useAssay\" (assay) name: ", useAssay, " not found.")
    stop(p)
  }
  if(any(!c(batch, covariates, bioCond) %in%
         names(SummarizedExperiment::colData(inSCE)))){
    anns <- c(batch, covariates, bioCond)
    notFound <- which(!anns %in% names(SummarizedExperiment::colData(inSCE)))
    notFound <- anns[notFound]
    stop("\"annotation\" name:", paste(notFound, collapse = ', '), "not found")
  }
  if (!is.null(covariates) &&
      isTRUE(useSVA)) {
    stop("Only one of 'covariates' and 'useSVA' can be specified.")
  }
  # Modeling
  annot <- data.frame(SummarizedExperiment::colData(inSCE))
  if (!is.null(covariates)) {
    # Do ComBat-Cell-Seq
    mod <- stats::model.matrix(
      stats::as.formula(paste0("~", paste0(covariates, collapse = "+"))),
      data = annot)
  } else if (isTRUE(useSVA)) {
    # Do ComBat-SVA-Seq
    mod.batch = stats::model.matrix(
      stats::as.formula(paste0("~", batch)),
      data = annot)
    mod0 = stats::model.matrix(~1, data = annot)
    svobj_filt = sva::svaseq(as.matrix(assay(inSCE, useAssay) + 2.5),
                             mod.batch, mod0)
    nSV <- dim(svobj_filt$sv)[2]
    for (i in seq_len(nSV)) {
      annot[[paste0("SV", i)]] <- svobj_filt$sv[,i]
    }
    mod <- stats::model.matrix(
      stats::as.formula(paste0("~", paste0(paste0("SV", seq_len(nSV)),
                                           collapse = "+"))),
      data = annot)
  } else {
    mod <- NULL
  }
  # Running
  mat <- as.matrix(SummarizedExperiment::assay(inSCE, useAssay))
  batchCol <- annot[[batch]]
  if (!is.null(bioCond)) {
    groupCol <- annot[[bioCond]]
  } else {
    groupCol <- NULL
  }
  mat.corr <-  sva::ComBat_seq(counts = mat, batch = batchCol, group = groupCol,
                               covar_mod = mod, shrink = shrink,
                               shrink.disp = shrinkDisp, gene.subset.n = nGene)
  expData(inSCE, assayName, tag = "batchCorrected", altExp = FALSE) <- mat.corr
  S4Vectors::metadata(inSCE)$batchCorr[[assayName]] <- list(useAssay = useAssay,
                                                            origLogged = FALSE,
                                                            method = "ComBatSeq",
                                                            matType = "assay",
                                                            batch = batch,
                                                            condition = covariates)
  return(inSCE)
}

#' Apply a fast version of the mutual nearest neighbors (MNN) batch effect
#' correction method to SingleCellExperiment object
#'
#' fastMNN is a variant of the classic MNN method, modified for speed and more
#' robust performance. For introduction of MNN, see \code{\link{runMNNCorrect}}.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object
#' @param useAssay A single character indicating the name of the assay requiring
#' batch correction. Default \code{"logcounts"}.
#' @param useReducedDim A single character indicating the dimension reduction
#' used for batch correction. Will ignore \code{useAssay} when using.
#' Default \code{NULL}.
#' @param batch A single character indicating a field in \code{colData} that
#' annotates the batches of each cell; or a vector/factor with the same length
#' as the number of cells. Default \code{"batch"}.
#' @param reducedDimName A single character. The name for the corrected
#' low-dimensional representation. Default \code{"fastMNN"}.
#' @param k An integer scalar specifying the number of nearest neighbors to
#' consider when identifying MNNs. See "See Also". Default \code{20}.
#' @param propK A numeric scalar in (0, 1) specifying the proportion of cells in
#' each dataset to use for mutual nearest neighbor searching. See "See Also".
#' Default \code{NULL}.
#' @param ndist A numeric scalar specifying the threshold beyond which
#' neighbours are to be ignored when computing correction vectors. See "See
#' Also". Default \code{3}.
#' @param minBatchSkip Numeric scalar specifying the minimum relative magnitude
#' of the batch effect, below which no correction will be performed at a given
#' merge step. See "See Also". Default \code{0}.
#' @param cosNorm A logical scalar indicating whether cosine normalization
#' should be performed on \code{useAssay} prior to PCA. See "See Also". Default
#' \code{TRUE}.
#' @param nComponents An integer scalar specifying the number of dimensions to
#' produce. See "See Also". Default \code{50}.
#' @param weights The weighting scheme to use. Passed to
#' \code{\link[batchelor]{multiBatchPCA}}. Default \code{NULL}.
#' @param BPPARAM A \linkS4class{BiocParallelParam} object specifying whether
#' the SVD should be parallelized.
#' @return The input \linkS4class{SingleCellExperiment} object with
#' \code{reducedDim(inSCE, reducedDimName)} updated.
#' @seealso \code{\link[batchelor]{fastMNN}} for using \code{useAssay}, and
#' \code{\link[batchelor]{reducedMNN}} for using \code{useReducedDim}
#' @export
#' @references Lun ATL, et al., 2016
#' @examples
#' data('sceBatches', package = 'singleCellTK')
#' logcounts(sceBatches) <- log1p(counts(sceBatches))
#' sceCorr <- runFastMNN(sceBatches, useAssay = 'logcounts')
runFastMNN <- function(inSCE, useAssay = "logcounts", useReducedDim = NULL,
                       batch = 'batch', reducedDimName = "fastMNN", k = 20,
                       propK = NULL, ndist = 3, minBatchSkip = 0,
                       cosNorm = TRUE, nComponents = 50, weights = NULL,
                       BPPARAM = BiocParallel::SerialParam()){
  useMat <- .selectSCEMatrix(inSCE, useAssay = useAssay,
                             useReducedDim = useReducedDim,
                             returnMatrix = TRUE)
  mat <- useMat$mat
  batchVec <- .manageCellVar(inSCE, batch, as.factor = TRUE)
  reducedDimName <- gsub(' ', '_', reducedDimName)

  if (!is.null(useReducedDim)) {
    redMNN <- batchelor::reducedMNN(mat, batch = batchVec, BPPARAM = BPPARAM,
                                    k = k, prop.k = propK, ndist = ndist,
                                    min.batch.skip = minBatchSkip)
    newRedDim <- redMNN$corrected
  } else {
    mnnSCE <- batchelor::fastMNN(mat, batch = batchVec, BPPARAM = BPPARAM, k = k,
                                 prop.k = propK, ndist = ndist,
                                 min.batch.skip = minBatchSkip,
                                 cos.norm = cosNorm, d = nComponents,
                                 weights = weights)
    newRedDim <- SingleCellExperiment::reducedDim(mnnSCE, 'corrected')
  }
  SingleCellExperiment::reducedDim(inSCE, reducedDimName) <- newRedDim
  S4Vectors::metadata(inSCE)$batchCorr[[reducedDimName]] <-
    list(useAssay = useAssay, origLogged = TRUE, method = "fastMNN",
         matType = "reducedDim", batch = batch)
  return(inSCE)
}

#' Apply Harmony batch effect correction method to SingleCellExperiment object
#' @description Harmony is an algorithm that projects cells into a shared
#' embedding in which cells group by cell type rather than dataset-specific
#' conditions.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object
#' @param useAssay A single character indicating the name of the assay requiring
#' batch correction. Default \code{NULL}. It is recommended to use a reducedDim
#' such as PCA through the `useReducedDim` parameter of this function.
#' @param useReducedDim A single character indicating the name of the reducedDim
#' to be used. It is recommended to use a reducedDim instead of a full assay as 
#' using an assay might cause the algorithm to not converge and throw error.
#' Specifying this will ignore \code{useAssay}. Default
#' \code{NULL}.
#' @param batch A single character indicating a field in \code{colData} that
#' annotates the batches of each cell; or a vector/factor with the same length
#' as the number of cells. Default \code{"batch"}.
#' @param reducedDimName A single character. The name for the corrected
#' low-dimensional representation. Will be saved to \code{reducedDim(inSCE)}.
#' Default \code{"HARMONY"}.
#' @param nComponents An integer. The number of PCs to use and generate.
#' Default \code{50L}.
#' @param lambda A Numeric scalar. Ridge regression penalty parameter. Must be
#' strictly positive. Smaller values result in more aggressive correction.
#' Default \code{0.1}.
#' @param theta A Numeric scalar. Diversity clustering penalty parameter. Larger
#' values of theta result in more diverse clusters. theta=0 does not encourage
#' any diversity. Default \code{5}.
#' @param sigma A Numeric scalar. Width of soft kmeans clusters. Larger values
#' of sigma result in cells assigned to more clusters. Smaller values of sigma
#' make soft kmeans cluster approach hard clustering. Default \code{0.1}.
#' @param nIter An integer. The max number of iterations to perform. Default
#' \code{10L}.
#' @param seed Set seed for reproducibility. Default is \code{12345}.
#' @param verbose Whether to print progress messages. Default \code{TRUE}.
#' @param ... Other arguments passed to \code{\link[harmony]{HarmonyMatrix}}.
#' See details.
#' @details Since some of the arguments of \code{\link[harmony]{HarmonyMatrix}}
#' is controlled by this wrapper function. The additional arguments users can
#' work with only include: \code{nclust}, \code{tau}, \code{block.size},
#' \code{max.iter.cluster}, \code{epsilon.cluster}, \code{epsilon.harmony},
#' \code{plot_convergence}, \code{reference_values} and \code{cluster_prior}.
#' @return The input \linkS4class{SingleCellExperiment} object with
#' \code{reducedDim(inSCE, reducedDimName)} updated.
#' @export
#' @references Ilya Korsunsky, et al., 2019
#' @examples
#' data('sceBatches', package = 'singleCellTK')
#' logcounts(sceBatches) <- log1p(counts(sceBatches))
#' \dontrun{
#' if (require("harmony"))
#'     sceCorr <- runHarmony(sceBatches)
#' }
runHarmony <- function(inSCE, useAssay = NULL, useReducedDim = NULL,
                       batch = "batch", reducedDimName = "HARMONY",
                       nComponents = 50, lambda = 0.1, theta = 5,
                       sigma = 0.1, nIter = 10, seed = 12345, verbose = TRUE, ...) {
  if (!requireNamespace("harmony", quietly = TRUE)) {
    stop("The Harmony package is required to run this function. ",
         "Install harmony with: ",
         "install.packages('harmony')",
         call. = FALSE)
  }
  
  # Check if both useAssay and useReducedDim are not NULL
  if(is.null(useAssay) && is.null(useReducedDim)){
    stop("Both 'useAssay' & 'useReducedDim' cannot be NULL. It is recommended to use a reducedDim (PCA) for this algorithm but a full-sized assay can also be used. However, using an assay may cause the algorithm to not converge.")
  }
  
  # If using useAssay, send a warning to recommend using PCA
  if((!is.null(useAssay)) && is.null(useReducedDim)){
    warning("You are using a full-sized assay with Harmony. It is recommended to use a reducedDim (PCA) for better results, as using a full sized assay may cause the algorithm to not converge. Computation will proceed with selected assay ...")
  }
  
  ## Input check
  useMat <- .selectSCEMatrix(inSCE, useAssay, useReducedDim,
                             useAltExp = NULL, returnMatrix = TRUE)
  batchVec <- .manageCellVar(inSCE, batch, as.factor = TRUE)
  reducedDimName <- gsub(' ', '_', reducedDimName)
  ## Run algorithm
  message(Sys.Date(), " ... Running harmony batch correction")
  mat <- useMat$mat
  do_pca <- ifelse(is.null(useMat$names$useReducedDim), TRUE, FALSE)
  if (!is.null(useMat$names$useReducedDim)) {
    if (nComponents > ncol(mat)) {
      warning("Specified number of components more than available, ",
              "using all (", ncol(mat), ") components.")
      nComponents <- ncol(mat)
    }
    mat <- mat[,seq(nComponents)]
  }
  h <- withr::with_seed(seed, {
    harmony::HarmonyMatrix(data_mat = mat, meta_data = batchVec,
                           do_pca = do_pca, npcs = nComponents,
                           lambda = lambda, theta = theta,
                           sigma = sigma, max.iter.harmony = nIter,
                           verbose = verbose, return_object = FALSE, ...)
  })
  SingleCellExperiment::reducedDim(inSCE, reducedDimName) <- h
  S4Vectors::metadata(inSCE)$batchCorr[[reducedDimName]] <-
    list(useAssay = useAssay, origLogged = TRUE, method = "harmony",
         matType = "reducedDim", batch = batch)
  return(inSCE)
}

# #' Apply LIGER batch effect correction method to SingleCellExperiment object
# #'
# #' LIGER relies on integrative non-negative matrix factorization to identify
# #' shared and dataset-specific factors.
# #' @param Input \linkS4class{SingleCellExperiment} object
# #' @param useAssay A single character indicating the name of the assay requiring
# #' batch correction. Default \code{"logcounts"}.
# #' @param batch A single character indicating a field in
# #' \code{\link{colData}} that annotates the batches.
# #' Default \code{"batch"}.
# #' @param reducedDimName A single character. The name for the corrected
# #' low-dimensional representation. Will be saved to \code{reducedDim(inSCE)}.
# #' Default \code{"LIGER"}.
# #' @param nComponents An integer. The number of principle components or
# #' dimensionality to generate in the resulting matrix. Default \code{20L}.
# #' @param lambda A numeric scalar. Algorithmic parameter, the penalty
# #' parameter which limits the dataset-specific component of the factorization.
# #' Default \code{5.0}.
# #' @param resolution A numeric scalar. Algorithmic paramter, the clustering
# #' resolution, increasing this increases the number of communities detected.
# #' Default \code{1.0}
# #' @return The input \linkS4class{SingleCellExperiment} object with
# #' \code{reducedDim(inSCE, reducedDimName)} updated.
# #' @export
# #' @references Joshua Welch, et al., 2018
# #' @examples
# #' \dontrun{
# #' data('sceBatches', package = 'singleCellTK')
# #' sceCorr <- runLIGER(sceBatches)
# #' }
# runLIGER <- function(inSCE, useAssay = 'logcounts', batch = 'batch',
#                      reducedDimName = 'LIGER', nComponents = 20L, lambda = 5.0,
#                      resolution = 1.0){
#   if (!requireNamespace("liger", quietly = TRUE)) {
#     stop("The Liger package is required to run this function. ",
#          "Install liger with: ",
#          "devtools::install_github('joshua-d-campbell/liger') \n",
#          "NOTICE that the one on cran/BiocManager is not what we need.",
#          call. = FALSE)
#   }
#   if (!exists('createLiger', where=asNamespace('liger'), mode='function')) {
#     stop("You are using the wrong source of Liger, please reinstall with: ",
#          "devtools::install_github('joshua-d-campbell/liger') \n",
#          "NOTICE that the one on cran/BiocManager is not what we need.",
#          call. = FALSE)
#   }
#   ## Input check
#   if(!inherits(inSCE, "SingleCellExperiment")){
#     stop("\"inSCE\" should be a SingleCellExperiment Object.")
#   }
#   if(!useAssay %in% SummarizedExperiment::assayNames(inSCE)) {
#     stop(paste("\"useAssay\" (assay) name: ", useAssay, " not found"))
#   }
#   if(!batch %in% names(SummarizedExperiment::colData(inSCE))){
#     stop(paste("\"batch\" name:", batch, "not found"))
#   }
#   reducedDimName <- gsub(' ', '_', reducedDimName)

#   ## Run algorithm
#   batchCol <- SummarizedExperiment::colData(inSCE)[[batch]]
#   batches <- unique(batchCol)
#   batchMatrices <- list()
#   for(i in seq_along(batches)){
#     b <- batches[i]
#     batchMatrices[[b]] <-
#       SummarizedExperiment::assay(inSCE, useAssay)[,batchCol == b]
#   }
#   ligerex <- liger::createLiger(batchMatrices)
#   ligerex <- liger::normalize(ligerex)
#   ligerex <- liger::selectGenes(ligerex)
#   ligerex <- liger::scaleNotCenter(ligerex)
#   ligerex <- liger::optimizeALS(ligerex, k = nComponents, lambda = lambda,
#                                 resolution = resolution)
#   ligerex <- liger::quantile_norm(ligerex)
#   SingleCellExperiment::reducedDim(inSCE, reducedDimName) <- ligerex@H.norm
#   return(inSCE)
# }

#' Apply Limma's batch effect correction method to SingleCellExperiment object
#'
#' Limma's batch effect removal function fits a linear model to the data, then
#' removes the component due to the batch effects.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object
#' @param useAssay A single character indicating the name of the assay requiring
#' batch correction. Default \code{"logcounts"}.
#' @param batch A single character indicating a field in \code{colData} that
#' annotates the batches of each cell; or a vector/factor with the same length
#' as the number of cells. Default \code{"batch"}.
#' @param assayName A single characeter. The name for the corrected assay. Will
#' be saved to \code{\link{assay}}. Default
#' \code{"LIMMA"}.
#' @return The input \linkS4class{SingleCellExperiment} object with
#' \code{assay(inSCE, assayName)} updated.
#' @export
#' @references Gordon K Smyth, et al., 2003
#' @examples
#' data('sceBatches', package = 'singleCellTK')
#' logcounts(sceBatches) <- log1p(counts(sceBatches))
#' sceCorr <- runLimmaBC(sceBatches)
runLimmaBC <- function(inSCE, useAssay = "logcounts", assayName = "LIMMA",
                       batch = "batch") {
  ## Input check
  useMat <- .selectSCEMatrix(inSCE, useAssay = useAssay, returnMatrix = TRUE)
  mat <- useMat$mat
  batchVec <- .manageCellVar(inSCE, batch, as.factor = TRUE)
  assayName <- gsub(' ', '_', assayName)
  ## Run algorithm
  ## One more check for the batch names
  newMat <- limma::removeBatchEffect(mat, batch = batchVec)
  expData(inSCE, assayName, tag = "batchCorrected", altExp = FALSE) <- newMat
  S4Vectors::metadata(inSCE)$batchCorr[[assayName]] <- list(useAssay = useAssay,
                                                            origLogged = TRUE,
                                                            method = "Limma",
                                                            matType = "assay",
                                                            batch = batch)
  return(inSCE)
}

#' Apply the mutual nearest neighbors (MNN) batch effect correction method to
#' SingleCellExperiment object
#'
#' MNN is designed for batch correction of single-cell RNA-seq data where the
#' batches are partially confounded with biological conditions of interest. It
#' does so by identifying pairs of MNN in the high-dimensional log-expression
#' space. For each MNN pair, a pairwise correction vector is computed by
#' applying a Gaussian smoothing kernel with bandwidth `sigma`.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object
#' @param useAssay A single character indicating the name of the assay requiring
#' batch correction. Default \code{"logcounts"}.
#' @param batch A single character indicating a field in \code{colData} that
#' annotates the batches of each cell; or a vector/factor with the same length
#' as the number of cells. Default \code{"batch"}.
#' @param assayName A single characeter. The name for the corrected assay. Will
#' be saved to \code{\link{assay}}. Default
#' \code{"MNN"}.
#' @param k An integer scalar specifying the number of nearest neighbors to
#' consider when identifying MNNs. See "See Also". Default \code{20}.
#' @param propK A numeric scalar in (0, 1) specifying the proportion of cells in
#' each dataset to use for mutual nearest neighbor searching. See "See Also".
#' Default \code{NULL}.
#' @param sigma A numeric scalar specifying the bandwidth of the Gaussian
#' smoothing kernel used to compute the correction vector for each cell. See
#' "See Also". Default \code{0.1}.
#' @param cosNormIn A logical scalar indicating whether cosine normalization
#' should be performed on the input data prior to calculating distances between
#' cells. See "See Also". Default \code{TRUE}.
#' @param cosNormOut A logical scalar indicating whether cosine normalization
#' should be performed prior to computing corrected expression values. See "See
#' Also". Default \code{TRUE}.
#' @param varAdj A logical scalar indicating whether variance adjustment should
#' be performed on the correction vectors. See "See Also". Default \code{TRUE}.
#' @param BPPARAM A \linkS4class{BiocParallelParam} object specifying whether
#' the PCA and nearest-neighbor searches should be parallelized.
#' @return The input \linkS4class{SingleCellExperiment} object with
#' \code{assay(inSCE, assayName)} updated.
#' @seealso \code{\link[batchelor]{mnnCorrect}}
#' @export
#' @references Haghverdi L, Lun ATL, et. al., 2018
#' @examples
#' data('sceBatches', package = 'singleCellTK')
#' logcounts(sceBatches) <- log1p(counts(sceBatches))
#' sceCorr <- runMNNCorrect(sceBatches)
runMNNCorrect <- function(inSCE, useAssay = 'logcounts', batch = 'batch',
                          assayName = 'MNN', k = 20L, propK = NULL,
                          sigma = 0.1, cosNormIn = TRUE, cosNormOut = TRUE,
                          varAdj = TRUE, BPPARAM = BiocParallel::SerialParam()){
  ## Input check
  useMat <- .selectSCEMatrix(inSCE, useAssay = useAssay, returnMatrix = TRUE)
  mat <- useMat$mat
  batchVec <- .manageCellVar(inSCE, batch, as.factor = TRUE)
  assayName <- gsub(' ', '_', assayName)
  k <- as.integer(k)

  ## Run algorithm
  corr.sce <- batchelor::mnnCorrect(mat, batch = batchVec, k = k,
                                    prop.k = propK, sigma = sigma,
                                    cos.norm.in = cosNormIn,
                                    cos.norm.out = cosNormOut, var.adj = varAdj,
                                    BPPARAM = BPPARAM)
  expData(inSCE, assayName, tag = "batchCorrected", altExp = FALSE) <-
    SummarizedExperiment::assay(corr.sce, "corrected")
  S4Vectors::metadata(inSCE)$batchCorr[[assayName]] <- list(useAssay = useAssay,
                                                            origLogged = TRUE,
                                                            method = "MNN",
                                                            matType = "assay",
                                                            batch = batch)
  return(inSCE)
}

#' Apply the mutual nearest neighbors (MNN) batch effect correction method to
#' SingleCellExperiment object
#'
#' SCANORAMA is analogous to computer vision algorithms for panorama stitching
#' that identify images with overlapping content and merge these into a larger
#' panorama.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object
#' @param useAssay A single character indicating the name of the assay requiring
#' batch correction. Scanorama requires a transformed normalized expression
#' assay. Default \code{"logcounts"}.
#' @param batch A single character indicating a field in \code{colData} that
#' annotates the batches of each cell; or a vector/factor with the same length
#' as the number of cells. Default \code{"batch"}.
#' @param assayName A single characeter. The name for the corrected assay. Will
#' be saved to \code{\link{assay}}. Default
#' \code{"SCANORAMA"}.
#' @param SIGMA A numeric scalar. Algorithmic parameter, correction smoothing
#' parameter on Gaussian kernel. Default \code{15}.
#' @param ALPHA A numeric scalar. Algorithmic parameter, alignment score
#' minimum cutoff. Default \code{0.1}.
#' @param KNN An integer. Algorithmic parameter, number of nearest neighbors to
#' use for matching. Default \code{20}.
#' @param approx Boolean. Use approximate nearest neighbors, greatly speeds up
#' matching runtime. Default \code{TRUE}.
#' @return The input \linkS4class{SingleCellExperiment} object with
#' \code{assay(inSCE, assayName)} updated.
#' @export
#' @references Brian Hie et al, 2019
#' @examples
#' \dontrun{
#' data('sceBatches', package = 'singleCellTK')
#' logcounts(sceBatches) <- log1p(counts(sceBatches))
#' sceCorr <- runSCANORAMA(sceBatches, "ScaterLogNormCounts")
#' }
runSCANORAMA <- function(inSCE, useAssay = 'logcounts', batch = 'batch',
                         assayName = 'SCANORAMA', SIGMA = 15, ALPHA = 0.1,
                         KNN = 20, approx = TRUE){
  ## Input check
  if(!reticulate::py_module_available(module = "scanorama")){
    warning("Cannot find python module 'scanorama', please install Conda and",
            " run sctkPythonInstallConda() or run ",
            "sctkPythonInstallVirtualEnv(). If one of these have been ",
            "previously run to install the modules, make sure to run ",
            "selectSCTKConda() or selectSCTKVirtualEnvironment(), ",
            "respectively, if R has been restarted since the module ",
            "installation. Alternatively, scanorama can be installed on the ",
            "local machine with pip (e.g. pip install scanorama) and then the ",
            "'use_python()' function from the 'reticulate' package can be used",
            " to select the correct Python environment.")
    return(inSCE)
  }
  useMat <- .selectSCEMatrix(inSCE, useAssay = useAssay)
  batchVec <- .manageCellVar(inSCE, batch)
  assayName <- gsub(' ', '_', assayName)
  adata <- .sce2adata(inSCE, useAssay)
  adata$obs[["batch"]] <- batchVec
  py <- reticulate::py
  py$adata <- adata
  py$sigma <- SIGMA
  py$alpha <- ALPHA
  py$KNN <- as.integer(KNN)
  reticulate::py_run_string('
import numpy as np
import scanorama
batches = list(set(adata.obs["batch"]))
adatas = [adata[adata.obs["batch"] == b,] for b in batches]
datasets_full = [a.X for a in adatas]
genes_list = [a.var_names.to_list() for a in adatas]
corrected, genes = scanorama.correct(datasets_full, genes_list, sigma=sigma,
                                     alpha=alpha, knn=KNN)
corrected = [m.toarray() for m in corrected]
cellOrders = [adata.obs["batch"] == b for b in batches]
integrated = np.zeros(adata.shape)
integrated[:,:] = np.NAN
for i in range(len(batches)):
    integrated[cellOrders[i],] = corrected[i]
geneidx = {gene: idx for idx, gene in enumerate(genes)}
orderIdx = []
for gene in adata.var_names:
    orderIdx.append(geneidx[gene])
integrated = integrated[:, orderIdx]
', convert = FALSE)
  mat <- t(py$integrated)
  rownames(mat) <- rownames(inSCE)
  colnames(mat) <- colnames(inSCE)
  expData(inSCE, assayName, tag = "batchCorrected", altExp = FALSE) <- mat
  S4Vectors::metadata(inSCE)$batchCorr[[assayName]] <-
    list(useAssay = useAssay,  origLogged = TRUE, method = "Scanorama",
         matType = "assay", batch = batch)
  return(inSCE)
}

#' Apply scMerge batch effect correction method to SingleCellExperiment object
#'
#' The scMerge method leverages factor analysis, stably expressed genes (SEGs)
#' and (pseudo-) replicates to remove unwanted variations and merge multiple
#' scRNA-Seq data.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object
#' @param useAssay A single character indicating the name of the assay requiring
#' batch correction. Default \code{"logcounts"}.
#' @param batch A single character indicating a field in
#' \code{\link{colData}} that annotates the batches.
#' Default \code{"batch"}.
#' @param assayName A single characeter. The name for the corrected assay. Will
#' be saved to \code{\link{assay}}. Default \code{"scMerge"}.
#' @param hvgExprs A single characeter. The assay that to be used for highly
#' variable genes identification. Default \code{"counts"}.
#' @param kmeansK An integer vector. Indicating the kmeans' K-value for each
#' batch (i.e. how many subclusters in each batch should exist), in order to
#' construct pseudo-replicates. The length of \code{kmeansK} needs to be the same
#' as the number of batches. Default \code{NULL}, and this value will be
#' auto-detected by default, depending on \code{cellType}.
#' @param cellType A single character. A string indicating a field in
#' \code{colData(inSCE)} that defines different cell types. Default
#' \code{'cell_type'}.
#' @param seg A vector of gene names or indices that specifies SEG (Stably
#' Expressed Genes) set as negative control. Pre-defined dataset with human and
#' mouse SEG lists is available with \code{\link[scMerge]{segList}} or
#' \code{\link[scMerge]{segList_ensemblGeneID}}. Default
#' \code{NULL}, and this value will be auto-detected by default with
#' \code{\link[scMerge]{scSEGIndex}}.
#' @param BPPARAM A \linkS4class{BiocParallelParam} object specifying whether
#' should be parallelized. Default \code{BiocParallel::SerialParam()}.
#' @return The input \linkS4class{SingleCellExperiment} object with
#' \code{assay(inSCE, assayName)} updated.
#' @export
#' @references Hoa, et al., 2020
#' @examples
#' data('sceBatches', package = 'singleCellTK')
#' \dontrun{
#' logcounts(sceBatches) <- log1p(counts(sceBatches))
#' sceCorr <- runSCMerge(sceBatches)
#' }
runSCMerge <- function(inSCE, useAssay = "logcounts", batch = 'batch',
                       assayName = "scMerge", hvgExprs = "counts", seg = NULL,
                       kmeansK = NULL, cellType = NULL,
                       BPPARAM = BiocParallel::SerialParam()){
  ## Input check
  useMat <- .selectSCEMatrix(inSCE, useAssay = useAssay, returnMatrix = TRUE)
  .selectSCEMatrix(inSCE, useAssay = hvgExprs, returnMatrix = FALSE)
  mat <- useMat$mat
  batchVec <- .manageCellVar(inSCE, batch)
  cellTypeCol <- .manageCellVar(inSCE, cellType)
  #if(is.null(cellType) & is.null(kmeansK)){
  #  stop("\"cellType\" and \"kmeansK\" cannot be NULL at the same time")
  #}
  assayName <- gsub(' ', '_', assayName)

  ## Run algorithm
  uniqBatch <- unique(batch)

  ## kmeansK
  if(!is.null(cellType) && is.null(kmeansK)){
    # If kmeansK not given, detect by cell type.
    kmeansK <- c()
    for (i in seq_along(uniqBatch)){
      cellTypePerBatch <- cellType[batchVec == uniqBatch[i]]
      kmeansK <- c(kmeansK, length(unique(cellTypePerBatch)))
    }
    cat("Detected kmeansK:\n")
    print(t(data.frame(K = kmeansK, row.names = uniqBatch)))
  }
  ## SEG
  if(is.null(seg)){
    seg <- scMerge::scSEGIndex(mat, cell_type = cellTypeCol, BPPARAM = BPPARAM)
    ctl <- rownames(seg[order(seg$segIdx, decreasing = TRUE)[seq(1000)],])
  } else {
    ctl <- seg
  }

  inSCE <- scMerge::scMerge(sce_combine = inSCE, exprs = useAssay,
                            hvg_exprs = useAssay, batch_name = batch,
                            assay_name = assayName,
                            ctl = ctl, kmeansK = kmeansK,
                            #marker_list = topVarGenesPerBatch,
                            cell_type = cellTypeCol,
                            BPPARAM = BPPARAM)
  # scMerge's function automatically returns the SCE object with information
  # completed, thus using this helper function to simply add the tag.
  inSCE <- expSetDataTag(inSCE, "batchCorrected", assayName)
  S4Vectors::metadata(inSCE)$batchCorr[[assayName]] <-
    list(useAssay = useAssay, origLogged = TRUE, method = "scMerge",
         matType = "assay", batch = batch, condition = cellType)
  return(inSCE)
}

#' Apply ZINBWaVE Batch effect correction method to SingleCellExperiment object
#'
#' A general and flexible zero-inflated negative binomial model that can be
#' used to provide a low-dimensional representations of scRNAseq data. The
#' model accounts for zero inflation (dropouts), over-dispersion, and the count
#' nature of the data. The model also accounts for the difference in library
#' sizes and optionally for batch effects and/or other covariates.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object
#' @param useAssay A single character indicating the name of the assay requiring
#' batch correction. Note that ZINBWaVE works for counts (integer) input rather
#' than logcounts that other methods prefer. Default \code{"counts"}.
#' @param batch A single character indicating a field in
#' \code{\link{colData}} that annotates the batches.
#' Default \code{"batch"}.
#' @param nHVG An integer. Number of highly variable genes to use when fitting
#' the model. Default \code{1000L}.
#' @param nComponents An integer. The number of principle components or
#' dimensionality to generate in the resulting matrix. Default \code{50L}.
#' @param nIter An integer, The max number of iterations to perform. Default
#' \code{10L}.
#' @param epsilon An integer. Algorithmic parameter. Empirically, a high epsilon
#' is often required to obtained a good low-level representation. Default
#' \code{1000L}.
#' @param reducedDimName A single character. The name for the corrected
#' low-dimensional representation. Will be saved to \code{reducedDim(inSCE)}.
#' Default \code{"zinbwave"}.
#' @param BPPARAM A \linkS4class{BiocParallelParam} object specifying whether
#' should be parallelized. Default \code{BiocParallel::SerialParam()}.
#' @return The input \linkS4class{SingleCellExperiment} object with
#' \code{reducedDim(inSCE, reducedDimName)} updated.
#' @export
#' @references Pollen, Alex A et al., 2014
#' @examples
#' data('sceBatches', package = 'singleCellTK')
#' \dontrun{
#'     sceCorr <- runZINBWaVE(sceBatches, nIter = 5)
#' }
runZINBWaVE <- function(inSCE, useAssay = 'counts', batch = 'batch',
                        nHVG = 1000L, nComponents = 50L, epsilon = 1000,
                        nIter = 10L, reducedDimName = 'zinbwave',
                        BPPARAM = BiocParallel::SerialParam()){
  ## Input check
  if(!inherits(inSCE, "SingleCellExperiment")){
    stop("\"inSCE\" should be a SingleCellExperiment Object.")
  }
  if(!useAssay %in% SummarizedExperiment::assayNames(inSCE)) {
    p <- paste("\"useAssay\" (assay) name: ", useAssay, " not found")
    stop(p)
  }
  if(!batch %in% names(SummarizedExperiment::colData(inSCE))){
    p <- paste("\"batch name:", batch, "not found.")
    stop(p)
  }
  reducedDimName <- gsub(' ', '_', reducedDimName)
  nHVG <- as.integer(nHVG)
  nComponents <- as.integer(nComponents)
  epsilon <- as.integer(epsilon)
  nIter <- as.integer(nIter)
  # Run algorithm
  ##ZINBWaVE tutorial style of HVG selection
  if(nHVG < nrow(inSCE)){
    logAssay <- log1p(SummarizedExperiment::assay(inSCE, useAssay))
    vars <- matrixStats::rowVars(logAssay)
    names(vars) <- rownames(inSCE)
    vars <- sort(vars, decreasing = TRUE)
    hvgs <- names(vars)[seq_len(nHVG)]
    #tmpSCE <- inSCE[names(vars)[seq_len(nHVG)],]
  } else {
    #tmpSCE <- inSCE
    hvgs <- rownames(inSCE)
  }
  epsilon <- min(nrow(inSCE), epsilon)
  inSCE <- zinbwave::zinbwave(inSCE, K = nComponents, epsilon = epsilon,
                               which_assay = useAssay, which_genes = hvgs,
                               X = paste('~', batch, sep = ''),
                               maxiter.optimize = nIter, verbose = TRUE,
                              BPPARAM = BPPARAM)
  reddimName <- reducedDimNames(inSCE)
  reddimName[reddimName == "zinbwave"] <- reducedDimName
  #SingleCellExperiment::reducedDim(inSCE, reducedDimName) <-
  #  SingleCellExperiment::reducedDim(inSCE, 'zinbwave')
  S4Vectors::metadata(inSCE)$batchCorr[[reducedDimName]] <-
    list(useAssay = useAssay, origLogged = FALSE, method = "ZINBWaVE",
         matType = "reducedDim", batch = batch)
  return(inSCE)
}

# Batch Correction Functions
library(singleCellTK)
context("Testing Batch Correction functions")
data(sceBatches, package = "singleCellTK")

sceBatches <- scaterlogNormCounts(sceBatches, "logcounts")

test_that(desc = "Testing Limma Batch Correction", {
  sceBatches <- runLimmaBC(inSCE = sceBatches)
  testthat::expect_true("LIMMA" %in% assayNames(sceBatches))

  # Also plotting function at this point
  p <- plotBatchCorrCompare(sceBatches, "LIMMA")
  testthat::expect_is(p, "gtable")
})

test_that(desc = "Testing ComBat_seq without covariate", {
  sceBatches <- runComBatSeq(inSCE = sceBatches, assayName = "CBS1")

  testthat::expect_true("CBS1" %in% assayNames(sceBatches))
})

test_that(desc = "Testing ComBat_seq with covariate", {
  sceBatches <- runComBatSeq(inSCE = sceBatches, assayName = "CBS2",
                             covariates = "cell_type")

  testthat::expect_true("CBS2" %in% assayNames(sceBatches))
})

test_that(desc = "Testing MNN", {
  sceBatches <- runMNNCorrect(inSCE = sceBatches)

  testthat::expect_true("MNN" %in% assayNames(sceBatches))
})

if (isTRUE(reticulate::py_available(initialize = FALSE))) {
  if(reticulate::py_module_available(module = "bbknn")){
    test_that(desc = "Testing BBKNN", {
      sceBatches <- runBBKNN(inSCE = sceBatches)
      testthat::expect_true("BBKNN" %in% reducedDimNames(sceBatches))
    })
  }
  if(reticulate::py_module_available(module = "scanorama")){
    test_that(desc = "Testing SCANORAMA", {
      sceBatches <- runSCANORAMA(inSCE = sceBatches)
      testthat::expect_true("SCANORAMA" %in% assayNames(sceBatches))
    })
  }
}

#' Label cell types with SingleR
#' @description
#' SingleR works with a reference dataset where the cell type
#' labeling is given. Given a reference dataset of samples (single-cell or bulk)
#' with known labels, it assigns those labels to new cells from a test dataset
#' based on similarities in their expression profiles.
#' @param inSCE \linkS4class{SingleCellExperiment} inherited object. Required.
#' @param useAssay character. A string specifying which assay to use for
#' expression profile identification. Required.
#' @param useSCERef \linkS4class{SingleCellExperiment} inherited object. An
#' optional customized reference dataset. Default \code{NULL}.
#' @param labelColName A single character. A string specifying the column in
#' \code{colData(useSCERef)} that stores the cell type labeling. Default
#' \code{NULL}.
#' @param useBltinRef A single character. A string that specifies a reference
#' provided by SingleR. Choose from \code{"hpca", "bpe", "mp", "dice", "immgen",
#' "mouse", "zeisel"}. See detail. Default \code{"hpca"}.
#' @param level A string for cell type labeling level. Used only when using
#' some of the SingleR built-in references. Choose from \code{"main", "fine",
#' "ont"}. Default \code{"fine"}.
#' @param featureType A string for whether to use gene symbols or Ensembl IDs
#' when using a SingleR built-in reference. Should be set based on the type of
#' \code{rownames} of \code{inSCE}. Choose from \code{"symbol", "ensembl"}.
#' Default \code{"symbol"}.
#' @param labelByCluster A single character. A string specifying the column name
#' in \code{colData(inSCE)} that stores clustering labels. Use this when users
#' want to only label cells on cluster level, instead of performing calculation
#' on each cell. Default \code{NULL}.
#' @return Input SCE object with cell type labeling updated in
#' \code{colData(inSCE)}, together with scoring metrics.
#' @export
#' @examples
#' data("sceBatches")
#' logcounts(sceBatches) <- log1p(counts(sceBatches))
#' #sceBatches <- runSingleR(sceBatches, useBltinRef = "mp")
runSingleR <- function(inSCE,
                       useAssay = "logcounts",
                       useSCERef = NULL,
                       labelColName = NULL,
                       useBltinRef = c("hpca", "bpe", "mp", "dice",
                                  "immgen", "mouse", "zeisel"),
                       level = "fine",
                       featureType = c("symbol", "ensembl"),
                       labelByCluster = NULL) {
    # Input checks
    if (!inherits(inSCE, "SingleCellExperiment")) {
        stop('"inSCE" should be a SingleCellExperiment inherited Object.')
    }
    if (!useAssay %in% expDataNames(inSCE)) {
        stop('"useAssay" name: ', useAssay, ' not found.')
    }

    useBltinRef <- match.arg(useBltinRef)
    featureType <- match.arg(featureType)
    level <- match.arg(level, choices = c("main", "fine", "ont"))

    if (featureType == "symbol") {
        useEnsembl <- FALSE
    } else {
        useEnsembl <- TRUE
    }

    if (!is.null(useSCERef)) {
        ref <- useSCERef
        if (is.null(labelColName)) {
            stop("labelColName must be specified if given an SCE reference.")
        } else {
            if (!labelColName %in% SummarizedExperiment::colData(ref)) {
                stop("Specified labelColName not found in given reference.")
            }
            message("Customized reference does not support level setting. ",
                    "Please check if the colData using matches your needs.")
            message("Ensembl vs symbol transfering not supported for cusomized",
                    " reference. Please make sure its rownames match with ",
                    "inSCE.")
        }
    } else {
        if (useBltinRef == "hpca") {
            message(date(), " ... Loading reference data 'HumanPrimaryCellAtlasData'")
            ref <- celldex::HumanPrimaryCellAtlasData(ensembl = useEnsembl,
                                                      cell.ont = "none")
            labelColName <- paste0("label.", level)
        } else if (useBltinRef == "bpe") {
            message(date(), " ... Loading reference data 'BlueprintEncodeData'")
            ref <- celldex::BlueprintEncodeData(ensembl = useEnsembl,
                                                cell.ont = "none")
            labelColName <- paste0("label.", level)
        } else if (useBltinRef == "mp") {
            message(date(), " ... Loading reference data 'MuraroPancreasData'")
            ref <- scRNAseq::MuraroPancreasData(ensembl = useEnsembl)
            if (!isTRUE(useEnsembl)) {
                rownames(ref) <- SummarizedExperiment::rowData(ref)$symbol
            }
            ref <- ref[,!is.na(ref$label) & ref$label != "unclear"]
            ref <- scaterlogNormCounts(ref, assayName = "logcounts")
            labelColName <- "label"
            warning("MuraroPancreasData does not have multiple levels of ",
                    "label. Using its default labeling.")
        } else if (useBltinRef == "dice") {
            message(date(), " ... Loading reference data 'DatabaseImmuneCellExpressionData'")
            ref <- celldex::DatabaseImmuneCellExpressionData(ensembl = useEnsembl)
            labelColName <- paste0("label.", level)
        } else if (useBltinRef == "immgen") {
            message(date(), " ... Loading reference data 'ImmGenData'")
            ref <- celldex::ImmGenData(ensembl = useEnsembl)
            labelColName <- paste0("label.", level)
        } else if (useBltinRef == "mouse") {
            message(date(), " ... Loading reference data 'MouseRNAseqData'")
            ref <- celldex::MouseRNAseqData(ensembl = useEnsembl)
            labelColName <- paste0("label.", level)
        } else if (useBltinRef == "zeisel") {
            message(date(), " ... Loading reference data 'ZeiselBrainData'")
            ref <- scRNAseq::ZeiselBrainData(ensembl = useEnsembl)
            ref <- ref[,ref$level2class!="(none)"]
            ref <- scaterlogNormCounts(ref, assayName = "logcounts")
            labelColName <- "level2class"
            warning("ZeiselBrainData does not support levels. ",
                    "Using its default labeling.")
        }
    }
    clusters <- .manageCellVar(inSCE, var = labelByCluster)
    # predictions <- SingleR::SingleR(test = inSCE, assay.type.test = useAssay,
    #                                 ref = ref, clusters = clusters,
    #                                 labels = ref[[labelColName]])
    message(date(), " ... Labeling cell type with SingleR")
    predictions <- SingleR::SingleR(test = expData(inSCE, useAssay),
                                    ref = ref, clusters = clusters,
                                    labels = ref[[labelColName]])
    predictions$tuning.scores <- NULL
    if (is.null(clusters)) {
        colnames(predictions) <- paste0("SingleR_", useBltinRef, "_", level,
                                        "_", colnames(predictions))
        for (n in colnames(predictions)) {
            inSCE[[n]] <- predictions[[n]]
        }
    } else {
        colnames(predictions) <- paste0("SingleR_", useBltinRef, "_", level,
                                        "_", colnames(predictions))
        for (i in seq(nrow(predictions))) {
            clusterLabel <- rownames(predictions)[i]
            for (n in colnames(predictions)) {
                inSCE[[n]][clusters == clusterLabel] <- predictions[[n]][i]
            }
        }
    }

    return(inSCE)
}

# SingleR
library(singleCellTK)
context("Testing Cell Type Labeling functions")
data(scExample, package = "singleCellTK")
sce <- subsetSCECols(sce, colData = 'type != "EmptyDroplet"')
sce <- scaterlogNormCounts(sce, "logcounts")
rownames(sce) <- rowData(sce)$feature_name

test_that(desc = "Testing SingleR", {
  tryCatch({
    ref <- celldex::HumanPrimaryCellAtlasData()
  }, error = function(e) {
    message("Error importing reference with `celldex` library. ",
            "Skipping runSingleR test.")
  }, finally = {
    sce <- runSingleR(sce, level = "main")
    testthat::expect_true("SingleR_hpca_main_scores" %in% names(colData(sce)))
    testthat::expect_true("SingleR_hpca_main_labels" %in% names(colData(sce)))
    testthat::expect_true("SingleR_hpca_main_first.labels" %in% names(colData(sce)) | "SingleR_hpca_main_delta.next" %in% names(colData(sce)))
    testthat::expect_true("SingleR_hpca_main_pruned.labels" %in% names(colData(sce)))
  })
})

#' Run UMAP embedding with scater method
#' @rdname runUMAP
#' @description Uniform Manifold Approximation and Projection (UMAP) algorithm
#' is commonly for 2D visualization of single-cell data. These functions wrap 
#' the scater \code{\link[scater]{calculateUMAP}} function.
#' 
#' Users can use \code{runQuickUMAP} to directly create UMAP embedding from raw
#' count matrix, with necessary preprocessing including normalization, variable
#' feature selection, scaling, dimension reduction all automated. Therefore, 
#' \code{useReducedDim} is disabled for \code{runQuickUMAP}. 
#' 
#' In a complete analysis, we still recommend having dimension reduction such as
#' PCA created beforehand and select proper numbers of dimensions for using
#' \code{runUMAP}, so that the result can match with the clustering based on the
#' same input PCA. 
#' @param inSCE Input \linkS4class{SingleCellExperiment} object.
#' @param useReducedDim The low dimension representation to use for UMAP
#' computation. If \code{useAltExp} is specified, \code{useReducedDim} has to
#' exist in \code{reducedDims(altExp(inSCE, useAltExp))}. Default \code{"PCA"}.
#' @param useAssay Assay to use for UMAP computation. If \code{useAltExp} is
#' specified, \code{useAssay} has to exist in
#' \code{assays(altExp(inSCE, useAltExp))}. Ignored when using
#' \code{useReducedDim}. Default \code{NULL}.
#' @param useAltExp The subset to use for UMAP computation, usually for the
#' selected variable features. Default \code{NULL}.
#' @param sample Character vector. Indicates which sample each cell belongs to.
#' If given a single character, will take the annotation from \code{colData}.
#' Default \code{NULL}.
#' @param reducedDimName A name to store the results of the UMAP embedding
#' coordinates obtained from this method. Default \code{"UMAP"}.
#' @param logNorm Whether the counts will need to be log-normalized prior to
#' generating the UMAP via \code{\link{scaterlogNormCounts}}. Ignored when using
#' \code{useReducedDim}. Default \code{TRUE}.
#' @param useFeatureSubset Subset of feature to use for dimension reduction. A
#' character string indicating a \code{rowData} variable that stores the logical
#' vector of HVG selection, or a vector that can subset the rows of
#' \code{inSCE}. Default \code{NULL}.
#' @param nTop Automatically detect this number of variable features to use for
#' dimension reduction. Ignored when using \code{useReducedDim} or using
#' \code{useFeatureSubset}. Default \code{2000}.
#' @param scale Whether \code{useAssay} matrix will need to be standardized.
#' Default \code{TRUE}.
#' @param pca Logical. Whether to perform dimension reduction with PCA before
#' UMAP. Ignored when using \code{useReducedDim}. Default \code{TRUE}.
#' @param initialDims Number of dimensions from PCA to use as input in UMAP.
#' Default \code{10}.
#' @param nNeighbors The size of local neighborhood used for manifold
#' approximation. Larger values result in more global views of the manifold,
#' while smaller values result in more local data being preserved. Default
#' \code{30}. See \code{\link[scater]{calculateUMAP}} for more information.
#' @param nIterations The number of iterations performed during layout
#' optimization. Default is \code{200}.
#' @param alpha The initial value of "learning rate" of layout optimization.
#' Default is \code{1}.
#' @param minDist The effective minimum distance between embedded points.
#' Smaller values will result in a more clustered/clumped embedding where nearby
#' points on the manifold are drawn closer together, while larger values will
#' result on a more even dispersal of points. Default \code{0.01}. See
#' \code{\link[scater]{calculateUMAP}} for more information.
#' @param spread The effective scale of embedded points. In combination with
#' \code{minDist}, this determines how clustered/clumped the embedded points
#' are. Default \code{1}. See \code{\link[scater]{calculateUMAP}} for more
#' information.
#' @param seed Random seed for reproducibility of UMAP results.
#' Default \code{NULL} will use global seed in use by the R environment.
#' @param BPPARAM A \linkS4class{BiocParallelParam} object specifying whether
#' the PCA should be parallelized.
#' @param verbose Logical. Whether to print log messages. Default \code{TRUE}.
#' @return A \linkS4class{SingleCellExperiment} object with UMAP computation
#' updated in \code{reducedDim(inSCE, reducedDimName)}.
#' @export
#' @examples
#' data(scExample, package = "singleCellTK")
#' sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
#' # Run from raw counts
#' sce <- runQuickUMAP(sce)
#' plotDimRed(sce, "UMAP")
#' 
#' @importFrom S4Vectors metadata<-
#' @importFrom BiocParallel SerialParam
runUMAP <- function(inSCE, useReducedDim = "PCA", useAssay = NULL, 
                    useAltExp = NULL, sample = NULL, reducedDimName = "UMAP",
                    logNorm = TRUE, useFeatureSubset = NULL, nTop = 2000,
                    scale = TRUE, pca = TRUE, initialDims = 10, nNeighbors = 30,
                    nIterations = 200, alpha = 1, minDist = 0.01, spread = 1,
                    seed = 12345, verbose = TRUE, BPPARAM = SerialParam()) {
  params <- as.list(environment())
  params$inSCE <- NULL
  params$BPPARAM <- NULL
  # Note: useMat = list(useAssay = useAssay, ...)
  # `.selectSCEMatrix()` does the check and corrects the conditions
  # When using useReducedDim, useAssay will be ignored
  useMat <- .selectSCEMatrix(inSCE, useAssay = useAssay,
                             useReducedDim = useReducedDim,
                             useAltExp = useAltExp,
                             returnMatrix = FALSE)$names
  params$useAssay <- useMat$useAssay
  useAssay <- useMat$useAssay
  if (!is.null(useAltExp)) sce <- SingleCellExperiment::altExp(inSCE, useAltExp)
  else sce <- inSCE
  sample <- .manageCellVar(inSCE, sample)
  if (is.null(sample)) sample <- rep(1, ncol(inSCE))
  samples <- unique(sample)
  umapDims <- matrix(nrow = ncol(inSCE), ncol = 2)
  # Start looping for each sample
  for (i in seq_along(samples)){
    sceSampleInd <- sample == samples[i]
    sceSample <- sce[, sceSampleInd]
    # Do logNorm
    useAssayTemp <- useAssay
    if (!is.null(useAssay)) {
      if (isTRUE(logNorm)) {
        sceSample <- scaterlogNormCounts(sceSample, useAssay = useAssay)
        useAssayTemp = "ScaterLogNormCounts"
      }
    }
    subset_row <- .parseUseFeatureSubset(inSCE, useFeatureSubset,
                                         altExpObj = sce, returnType = "logic")
    # initialDims passed to `pca` of scran::calculateUMAP.
    if (!isTRUE(pca) & !is.null(useAssay)) {
      initialDims <- NULL
    }
    
    nNeighbors <- min(ncol(sceSample), nNeighbors)
    if(isTRUE(verbose)) {
      p <- paste0(date(), " ... Computing Scater UMAP for sample '",
                  samples[i], "'.")
      message(p)
    }
    
    umapRes <- withr::with_seed(seed, {
      scater::calculateUMAP(sceSample, exprs_values = useAssayTemp,
                                       dimred = useReducedDim, scale = scale,
                                       n_neighbors = nNeighbors,
                                       learning_rate = alpha,
                                       min_dist = minDist, spread = spread,
                                       n_sgd_threads = 1, pca = initialDims,
                                       n_epochs = nIterations,
                                       subset_row = subset_row, ntop = nTop,
                                       BPPARAM = BPPARAM)
    })
    if (is.null(rownames(sceSample))) {
      rownames(umapRes) <- colnames(sceSample)
    }
    umapDims[sceSampleInd, ] <- umapRes
  }
  colnames(umapDims) <- c("UMAP1", "UMAP2")
  SingleCellExperiment::reducedDim(inSCE, reducedDimName) <- umapDims
  metadata(inSCE)$sctk$runDimReduce$embedding[[reducedDimName]] <- params
  return(inSCE)
}

#' @rdname runUMAP
#' @param ... Parameters passed to \code{runUMAP}
#' @importFrom BiocParallel SerialParam
#' @export
runQuickUMAP <- function(inSCE, useAssay = "counts", sample = "sample", ...) {
  args <- list(...)
  if (!is.null(args$useReducedDim)) {
    warning("Forcing `useReducedDim` to be `NULL`. Please use `runUMAP` for ",
            "using reducedDim.")
  }
  # Here `useReducedDim` entry is removed from list
  # Later, we add the entry with value `NULL`
  args$useReducedDim <- NULL
  args <- c(list(inSCE = inSCE, useAssay = useAssay, useReducedDim = NULL, 
                 sample = sample), args)
  inSCE <- do.call("runUMAP", args = args)
  return(inSCE)
}

#' @rdname runUMAP
#' @export
#' @importFrom BiocParallel SerialParam
getUMAP <- function(inSCE, useReducedDim = "PCA", useAssay = NULL, 
                    useAltExp = NULL, sample = NULL, reducedDimName = "UMAP",
                    logNorm = TRUE, useFeatureSubset = NULL, nTop = 2000,
                    scale = TRUE, pca = TRUE, initialDims = 25, nNeighbors = 30,
                    nIterations = 200, alpha = 1, minDist = 0.01, spread = 1,
                    seed = 12345, BPPARAM = SerialParam()) {
  .Deprecated("runUMAP")
  runUMAP(inSCE, useReducedDim = useReducedDim, useAssay = useAssay, 
          useAltExp = useAltExp, sample = sample, 
          reducedDimName = reducedDimName,
          logNorm = logNorm, useFeatureSubset = useFeatureSubset, nTop = nTop,
          scale = scale, pca = pca, initialDims = initialDims, 
          nNeighbors = nNeighbors, nIterations = nIterations, alpha = alpha, 
          minDist = minDist, spread = spread, seed = seed, BPPARAM = BPPARAM)
}

shinyPanelSubsample <- fluidPage(
  tags$h1("Sample Size Calculator"),
  h5(tags$a(href = paste0(docs.artPath, "ui_sample_size_calc.html"),
            "(help)", target = "_blank")),
  tabsetPanel(
    tabPanel(
      "Sequencing Depth",
      fluidRow(
        column(
          4,
          wellPanel(
            selectizeInput(
              inputId = "depthAssay", 
              label = "Select input matrix:", 
              choices = NULL, 
              selected = NULL, 
              multiple = FALSE,
              options = NULL),
            #uiOutput("depthAssay"),
            # selectInput("depthAssay", "Select Assay:", currassays),
            numericInput("minCount", "Minimum readcount to detect gene",
                         value = 10, min = 1, max = 10000),
            numericInput("minCells", "Minimum number of cells with nonzero expression to detect gene",
                         value = 3, min = 1, max = 100000),
            #TO DO: Add a 'track a particular gene' option. Show counts for that gene.
            numericInput("iterations",
                         label = "Number of bootstrap iterations.",
                         value = 10, min = 2, max = 10000),
            sliderInput("maxDepth", "Maximum log10(number of simulated reads)", 3, 12, 5, 0.5),
            sliderInput("depthResolution", "Number of values to simulate", 5, 100, 10, 5),
            selectInput("selectReadDepthCondition", "Condition for diffex", c("Random", clusterChoice), selected = "Random"),
            actionButton("runSubsampleDepth", "Run subsampler")
          )
        ),
        column(8,
          tabsetPanel(
            tabPanel("Genes Detected", plotOutput("depthDone")),
            tabPanel("Minimum Detectable Effect Size", plotOutput("minEffectDone")),
            tabPanel("Number of Diffex Genes", plotOutput("sigNumDone"))
          )
        )
      )
    ),
    tabPanel(
      "Number of cells",
      fluidRow(
        column(
          4,
          wellPanel(
            selectizeInput(
              inputId = "cellsAssay", 
              label = "Select input matrix:", 
              choices = NULL, 
              selected = NULL, 
              multiple = FALSE,
              options = NULL),
            #uiOutput("cellsAssay"),
            #selectInput("cellsAssay", "Select Assay:", currassays),
            numericInput("minCellNum", "Minimum number of cells to simulate",
                         value = 10, min = 1, max = 10000),
            numericInput("maxCellNum", "Maximum number of cells to simulate",
                         value = 100, min = 10, max = 100000),
            numericInput("iterations",
                         label = "Number of bootstrap iterations per cellcount.",
                         value = 10, min = 2, max = 10000),
            numericInput("totalReads", "Estimated number of aligned reads",
                         value = 1000000, min = 1000, max = 1000000000),
            checkboxInput("useReadCount", "Use the same number of reads as in original dataset"),
            selectInput("selectCellNumCondition", "Condition for diffex", clusterChoice),
            numericInput("minCount", "Minimum readcount to detect gene",
                         value = 10, min = 1, max = 10000),
            numericInput("minCells", "Minimum number of cells with nonzero expression to detect gene",
                         value = 3, min = 1, max = 100000),
            numericInput("depthResolution", "Number of dataset sizes to simulate",
                         value = 10, min = 1, max = 100),
            actionButton("runSubsampleCells", "Run resampler")
          ),
          tabPanel("Genes Detected", plotOutput("CellCountDone")),
          tabPanel("Minimum Detectable Effect Size", plotOutput("MinEffectCellsDone")),
          tabPanel("Number of Significant DiffEx Genes", plotOutput("cellNumSigDone"))
        ),
        column(8,
          tabsetPanel(
            tabPanel("Genes Detected", plotOutput("cellsDone")),
            tabPanel("Minimum Detectable Effect Size", plotOutput("minEffectCells")),
            tabPanel("Number of Diffex Genes", plotOutput("sigNumCells"))
          )
        )
      )
    ),
    tabPanel(
      "Snapshot",
      fluidRow(
        column(
          4,
          wellPanel(
            selectizeInput(
              inputId = "snapshotAssay", 
              label = "Select input matrix:", 
              choices = NULL, 
              selected = NULL, 
              multiple = FALSE,
              options = NULL),
            #uiOutput("snapshotAssay"),
            #selectInput("snapshotAssay", "Select Assay:", currassays),
            numericInput("numCellsSnap", "How many simulated cells?",
                         value = 100, min = 2, max = 10000),
            numericInput("numReadsSnap", "How many total reads?",
                         value = 1000000, min = 1000, max = 1000000000),
            selectInput("selectSnapshotCondition", "Condition for diffex", clusterChoice),
            numericInput("iterationsSnap", "Number of bootstrap iterations",
                         value = 10, min = 2, max = 1000),
            actionButton("runSnapshot", "Run resampling snapshot")
          )
        ),
        column(8,
          plotOutput("Snaplot")
        )
      )
    )
  )
)

#' List pathway analysis result names
#' @details Pathway analysis results will be stored as matrices in
#' \code{reducedDims} slot of \code{inSCE}. This function lists the result names
#' stored in \code{metadata} slot when analysis is performed.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object.
#' @param stopIfNone Whether to stop and raise an error if no results found. If
#' \code{FALSE}, will return an empty character vector.
#' @param verbose Show warning if no result found. Default \code{FALSE}
#' @return A character vector of valid pathway analysis result names.
#' @export
#' @examples
#' data(scExample)
#' getPathwayResultNames(sce)
getPathwayResultNames <- function(inSCE, stopIfNone = FALSE, verbose = FALSE){
    if (!"pathwayAnalysisResultNames" %in% names(S4Vectors::metadata(inSCE))) {
        if (isTRUE(stopIfNone)) {
            stop("No pathway analysis has been performed via singleCellTK. ",
                 "Please try `runVAM()` or `runGSVA()`.")
        } else {
            if (verbose)
            warning("No pathway analysis has been performed via singleCellTK.",
                    "Please try `runVAM()` or `runGSVA()`.")
            return(character())
        }
    } else {
        return(S4Vectors::metadata(inSCE)[["pathwayAnalysisResultNames"]])
    }
}

#' Generate violin plots for pathway analysis results
#' @details \code{runGSVA()} or \code{runVAM()} should be applied in advance of
#' using this function. Users can group the data by specifying \code{groupby}.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object. With
#' \code{runGSVA()} or \code{runVAM()} applied in advance.
#' @param resultName A single character of the name of a score matrix, which
#' should be found in \code{getPathwayResultNames(inSCE)}.
#' @param geneset A single character specifying the geneset of interest. Should
#' be found in the geneSetCollection used for performing the analysis.
#' @param groupBy Either a single character specifying a column of
#' \code{colData(inSCE)} or a vector of equal length as the number of cells.
#' Default \code{NULL}.
#' @param boxplot Boolean, Whether to add a boxplot. Default \code{FALSE}.
#' @param violin Boolean, Whether to add a violin plot. Default \code{TRUE}.
#' @param dots Boolean, If \code{TRUE}, will plot dots for each violin plot.
#' Default \code{TRUE}.
#' @param summary Adds a summary statistic, as well as a crossbar to the violin
#' plot. Options are \code{"mean"} or \code{"median"}, and \code{NULL} for not
#' adding. Default \code{"median"}.
#' @param axisSize Size of x/y-axis ticks. Default \code{10}.
#' @param axisLabelSize Size of x/y-axis labels. Default \code{10}.
#' @param dotSize Size of dots. Default \code{0.5}.
#' @param transparency Transparency of the dots, values will be 0-1. Default
#' \code{1}.
#' @param defaultTheme Removes grid in plot and sets axis title size to
#' \code{10} when \code{TRUE}. Default \code{TRUE}.
#' @param gridLine Adds a horizontal grid line if \code{TRUE}. Will still be
#' drawn even if \code{defaultTheme} is \code{TRUE}. Default \code{FALSE}.
#' @param title Title of plot. Default using \code{geneset}.
#' @param titleSize Size of the title of the plot. Default \code{15}.
#' @return A \code{ggplot} object for the violin plot
#' @export
#' @examples
#' data("scExample", package = "singleCellTK")
#' sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
#' sce <- scaterlogNormCounts(sce, assayName = "logcounts")
#' gs1 <- rownames(sce)[seq(10)]
#' gs2 <- rownames(sce)[seq(11,20)]
#' gs <- list("geneset1" = gs1, "geneset2" = gs2)
#' sce <- importGeneSetsFromList(inSCE = sce, geneSetList = gs,
#'                               by = "rownames")
#' sce <- runVAM(inSCE = sce, geneSetCollectionName = "GeneSetCollection",
#'               useAssay = "logcounts")
#' plotPathway(sce, "VAM_GeneSetCollection_CDF", "geneset1")
plotPathway <- function(inSCE,
                        resultName,
                        geneset,
                        groupBy = NULL,
                        boxplot = FALSE,
                        violin = TRUE,
                        dots = TRUE,
                        summary = "median",
                        axisSize = 10,
                        axisLabelSize = 10,
                        dotSize = 0.5,
                        transparency = 1,
                        defaultTheme = TRUE,
                        gridLine = FALSE,
                        title = geneset,
                        titleSize = NULL
){
    availResults <- getPathwayResultNames(inSCE, stopIfNone = TRUE)
    if (!resultName %in% availResults) {
        stop("Specified resultName not identified as a pathway analysis ",
             "result from singleCellTK. Use `getPathwayResultNames(inSCE)` ",
             "to see available options.")
    } else {
        if (!resultName %in% SingleCellExperiment::reducedDimNames(inSCE)) {
            stop("Pathway analysis result identified, but missing in ",
                 "reducedDims(inSCE)")
        }
    }
    genesetCollectionName <- strsplit(resultName,"_")[[1]][2]
    geneSetCollection <- .getGeneSetCollection(inSCE, genesetCollectionName)
    if(!geneset %in% names(geneSetCollection)) {
        stop('"', geneset, '" is not a geneset from the geneSetCollection: "',
             genesetCollectionName, '". Try `getGenesetNamesFromCollection(inSCE, "',
             genesetCollectionName, '")` for available options.')
    }
    xlab <- ifelse(is.null(groupBy), "Sample", groupBy)
    plotSCEViolin(inSCE,
                  slotName = "reducedDims",
                  itemName = resultName,
                  dimension = geneset ,
                  xlab = xlab,
                  ylab = resultName,
                  sample = NULL,
                  groupBy = groupBy,
                  boxplot = boxplot,
                  dots = dots,
                  violin = violin,
                  summary = summary,
                  axisSize = axisSize,
                  axisLabelSize = axisLabelSize,
                  dotSize = dotSize,
                  transparency = transparency,
                  defaultTheme = defaultTheme,
                  gridLine = gridLine,
                  title = title,
                  titleSize = titleSize)
}

#' @title Detecting outliers within the SingleCellExperiment object.
#' @description A wrapper function for \link[scater]{isOutlier}. Identify
#'  outliers from numeric vectors stored in the SingleCellExperiment object.
#' @param inSCE A \link[SingleCellExperiment]{SingleCellExperiment} object.
#' @param sample A single character specifying a name that can be found in
#' \code{colData(inSCE)} to directly use the cell annotation; or a character
#' vector with as many elements as cells to indicates which sample each cell
#' belongs to. Default NULL. \link[celda]{decontX} will be run on cells from
#' each sample separately.
#' @param slotName Desired slot of SingleCellExperiment used for plotting. Possible
#'  options: "assays", "colData", "metadata", "reducedDims". Required.
#' @param itemName Desired vector within the slot used for plotting. Required.
#' @param nmads Integer. Number of median absolute deviation. Parameter may be
#'  adjusted for more lenient or stringent outlier cutoff. Default 3.
#' @param type Character. Type/direction of outlier detection; whether
#'  the lower/higher outliers should be detected, or both.
#'  Options are "both", "lower", "higher".
#' @param overwrite Boolean. If TRUE, and this function has previously generated
#'  an outlier decision on the same itemName, the outlier decision will be overwritten.
#'  Default TRUE.
#' @return A \link[SingleCellExperiment]{SingleCellExperiment} object with
#'  '' added to the
#'  \link{colData} slot. Additionally, the
#' decontaminated counts will be added as an assay called 'decontXCounts'.
#' @examples
#' data(scExample, package = "singleCellTK")
#' sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
#' sce <- runDecontX(sce[,sample(ncol(sce),20)])
#' sce <- detectCellOutlier(sce, slotName = "colData", sample = sce$sample,
#'  nmads = 4, itemName = "decontX_contamination", type = "both")
#' @export
detectCellOutlier <- function(inSCE, slotName, itemName, sample = NULL, nmads = 3,
                              type = "both", overwrite = TRUE){
    if (!slotName %in% c("rowData", "colData", "assays", "metadata", "reducedDims")) {
        stop("'slotName' must be a slotName within the SingleCellExperiment object.",
             "Please run 'methods::slot' if you are unsure the",
             "specified slotName exists.")
    }
    if(!is.numeric(nmads)){
        nmads = 3
    }
    argsList <- mget(names(formals()),sys.frame(sys.nframe()))
    outlierDF <- S4Vectors::DataFrame(row.names = colnames(inSCE),
                                      outlier = logical(ncol(inSCE)),
                                      threshold = numeric(ncol(inSCE)))
    if (!is.null(sample)) {
        if (length(sample) != ncol(inSCE)) {
            stop("'sample' must be the same length as the number",
                 " of columns in 'inSCE'")
        }
    } else {
        sample <- rep(1, ncol(inSCE))
    }
    samples <- unique(sample)
    for (i in seq_len(length(samples))) {
        sceSampleInd <- sample == samples[i]
        sceSample <- inSCE[, sceSampleInd]

        value <- do.call(slotName, args = list(sceSample))[[itemName]]

        scaterRes <- scater::isOutlier(metric = value, type = type, nmads = nmads)
        outlierDF[sceSampleInd,1] <- scaterRes
        outlierDF[sceSampleInd,2] <- attr(scaterRes, "thresholds")[2]
    }

    colnames(outlierDF) <- paste(itemName, colnames(outlierDF), paste0("mad", nmads), type, sep = "_")
    if(overwrite){
        if(any(colnames(outlierDF) %in% colnames(colData(inSCE)))){
            replaceIx <- which(colnames(colData(inSCE)) %in% colnames(outlierDF))
            colData(inSCE)[,replaceIx] <- outlierDF
        }else{
            colData(inSCE) <- cbind(colData(inSCE), outlierDF)
        }
    }else{
        colData(inSCE) <- cbind(colData(inSCE), outlierDF)
    }
    inSCE@metadata$outlierDetection[[itemName]][[paste0("mad",nmads)]] <- argsList[-1]
    return(inSCE)
}

#' Calculate Variable Genes with Scran modelGeneVar
#' 
#' @description Generates and stores variability data in the input 
#' \linkS4class{SingleCellExperiment} object, using 
#' \code{\link[scran]{modelGeneVar}} method. 
#' 
#' Also selects a specified number of top HVGs and store the logical selection 
#' in \code{rowData}. 
#' @param inSCE A \linkS4class{SingleCellExperiment} object
#' @param useAssay A character string to specify an assay to compute variable 
#' features from. Default \code{"logcounts"}.
#' @return \code{inSCE} updated with variable feature metrics in \code{rowData}
#' @export
#' @author Irzam Sarfraz
#' @examples
#' data("scExample", package = "singleCellTK")
#' sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
#' sce <- scaterlogNormCounts(sce, "logcounts")
#' sce <- runModelGeneVar(sce)
#' hvf <- getTopHVG(sce, method = "modelGeneVar", hvgNumber = 10,
#'           useFeatureSubset = NULL)
#' @seealso \code{\link{runFeatureSelection}}, \code{\link{runSeuratFindHVG}},
#' \code{\link{getTopHVG}}, \code{\link{plotTopHVG}}
#' @importFrom SummarizedExperiment assay rowData rowData<-
#' @importFrom SingleCellExperiment rowSubset
#' @importFrom S4Vectors metadata<-
runModelGeneVar <- function(inSCE,
                            useAssay = "logcounts") {
    tempDataFrame <- data.frame(scran::modelGeneVar(assay(inSCE, useAssay)))
    rowData(inSCE)$scran_modelGeneVar_mean <- tempDataFrame$mean
    rowData(inSCE)$scran_modelGeneVar_totalVariance <- tempDataFrame$total
    rowData(inSCE)$scran_modelGeneVar_bio <- tempDataFrame$bio
    metadata(inSCE)$sctk$runFeatureSelection$modelGeneVar <- 
        list(useAssay = useAssay,
             rowData = c("scran_modelGeneVar_mean", 
                         "scran_modelGeneVar_totalVariance",
                         "scran_modelGeneVar_bio"))
    return(inSCE)
}

#' Plot PCA run data from its components.
#' @param colorBy The variable to color clusters by
#' @param shape Shape of the points
#' @param pcX User choice for the first principal component
#' @param pcY User choice for the second principal component
#' @param runPCA Run PCA if the reducedDimName does not exist. the Default is
#' FALSE.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object.
#' @param useAssay Indicate which assay to use. The default is "logcounts".
#' @param reducedDimName a name to store the results of the dimension reduction
#' coordinates obtained from this method. This is stored in the SingleCellExperiment
#' object in the reducedDims slot. Required.
#'
#' @return A PCA plot
#'
#' @export
#' @examples
#' data("mouseBrainSubsetSCE")
#' plotPCA(mouseBrainSubsetSCE, colorBy = "level1class",
#'         reducedDimName = "PCA_counts")
plotPCA <- function(inSCE, colorBy=NULL, shape=NULL, pcX="PC1",
                    pcY="PC2", reducedDimName="PCA", runPCA=FALSE,
                    useAssay="logcounts"){
  if(!(reducedDimName %in% names(SingleCellExperiment::reducedDims(inSCE)))){
    if (runPCA){
      inSCE <- scaterPCA(inSCE, useAssay = useAssay,
                      reducedDimName = reducedDimName, useFeatureSubset = NULL)
    } else {
      stop(reducedDimName,
           " dimension not found. Run scaterPCA() or set runPCA to TRUE.")
    }
  }
  pcaDf <- data.frame(SingleCellExperiment::reducedDim(inSCE,
                                                       reducedDimName))
  if (!(pcX %in% colnames(pcaDf))){
    stop("pcX dimension ", pcX, " is not in the reducedDim data")
  }
  if (!(pcY %in% colnames(pcaDf))){
    stop("pcY dimension ", pcY, " is not in the reducedDim data")
  }


  # Need to add back in variances in the plot axis labels
  pcXlab <- pcX
  pcYlab <- pcY

  if (!is.null(colorBy)){
    pcaDf$color <- SingleCellExperiment::colData(inSCE)[, colorBy]
  }
  if (!is.null(shape)){
    pcaDf$shape <- factor(SingleCellExperiment::colData(inSCE)[, shape])
  }
  pcaDf$Sample <- colnames(inSCE)
  g <- ggplot2::ggplot(pcaDf, ggplot2::aes_string(pcX, pcY, label = "Sample")) +
    ggplot2::geom_point() +
    ggplot2::labs(x = pcXlab, y = pcYlab)
  if (!is.null(colorBy)){
    g <- g + ggplot2::aes_string(color = "color") +
      ggplot2::labs(color = colorBy)
  }
  if (!is.null(shape)){
    g <- g + ggplot2::aes_string(shape = "shape") +
      ggplot2::labs(shape = shape)
  }
  return(g)
}

#' @title Get runDropletQC .html report
#' @description A  function to generate .html Rmarkdown report containing the visualizations of the runDropletQC function output
#' @param inSCE A \link[SingleCellExperiment]{SingleCellExperiment} object containing
#' the full droplet count matrix with the output from runDropletQC function
#' @param subTitle subtitle of the QC HTML report. Default is NULL.
#' @param studyDesign description of the data set and experiment design. It would be shown at the top of QC HTML report. Default is NULL.
#' @param output_file name of the generated file. If NULL/default then the output file name will be based on the name of the Rmarkdown template
#' @param output_dir name of the output directory to save the rendered file. If NULL/default the file is stored to the current working directory
#' @return .html file
#' @examples
#' data(scExample, package = "singleCellTK")
#' \dontrun{
#' sce <- runDropletQC(sce)
#' reportDropletQC(inSCE = sce)
#' }
#' @export
reportDropletQC <- function(inSCE, output_file = NULL,
                                   output_dir = NULL,
                                   subTitle = NULL,
                                   studyDesign = NULL) {

  if (is.null(output_dir)){
    output_dir<- getwd()
    }

  #report_path <- tempfile(fileext = ".Rmd")
  #file.copy(system.file("rmarkdown/qc/DropletQC.Rmd", package = "singleCellTK"), report_path, overwrite = TRUE)

  ## create temp Rmd file to bypass permission issue on server
  rmarkdown::render(system.file("rmarkdown/qc/DropletQC.Rmd", package = "singleCellTK"),
    params = list(object = inSCE, subTitle = subTitle, studyDesign = studyDesign),
    output_file = output_file,
    output_dir = output_dir,
    intermediates_dir = output_dir,
    knit_root_dir = output_dir)
 }


#' @title Get runCellQC .html report
#' @description A  function to generate .html Rmarkdown report containing the visualizations of the runCellQC function output
#' @param inSCE A \link[SingleCellExperiment]{SingleCellExperiment} object containing
#' the filtered count matrix with the output from runCellQC function
#' @param sample Character. The name of the saved column from the colData indicating the sample grouping variable. Default is "sample"
#' @param useReducedDim Character. The name of the saved dimension reduction slot including cells
#' from all samples in then\linkS4class{SingleCellExperiment} object, Default is NULL
#' @param subTitle subtitle of the QC HTML report. Default is NULL.
#' @param studyDesign Character. The description of the data set and experiment design. It would be shown at the top of QC HTML report. Default is NULL.
#' @param output_file Character. The name of the generated file. If NULL/default then the output file name will be based on the name of the Rmarkdown template.
#' @param output_dir Character. The name of the output directory to save the rendered file. If NULL/default the file is stored to the current working directory
#' @return .html file
#' @examples
#' data(scExample, package = "singleCellTK")
#' sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
#' \dontrun{
#' sce <- runCellQC(sce)
#' reportCellQC(inSCE = sce)
#' }
#' @export
reportCellQC <- function(inSCE, sample = "sample",
                                output_file = NULL,
                                output_dir = NULL,
                                subTitle = NULL,
                                studyDesign = NULL,
                                useReducedDim = NULL) {
  if (is.null(output_dir)){
    output_dir<- getwd()
  }
  #report_path <- tempfile(fileext = ".Rmd")
  #file.copy(system.file("rmarkdown/qc/CellQC.Rmd", package = "singleCellTK"), report_path, overwrite = TRUE)

  rmarkdown::render(system.file("rmarkdown/qc/CellQC.Rmd", package = "singleCellTK"),
    params = list(object = inSCE, sample = sample, subTitle = subTitle, studyDesign = studyDesign,
    reducedDimName = useReducedDim),
    output_file = output_file,
    output_dir = output_dir,
    intermediates_dir = output_dir,
    knit_root_dir = output_dir)
}


#' @title Get .html report of the output of the selected QC algorithm
#' @description A  function to generate .html Rmarkdown report for the specified QC algorithm output
#' @param inSCE A \link[SingleCellExperiment]{SingleCellExperiment} object containing
#' the count matrix (full droplets or filtered matrix, depends on the selected QC algorithm) with the output from at least one of these functions:
#' runQCMetrics, runScrublet, runScDblFinder, runCxds, runBcds, runCxdsBcdsHybrid, runDecontX, runBarcodeRankDrops, runEmptyDrops
#' @param algorithm Character. Specifies which QC algorithm report to generate.
#'  Available options are "BarcodeRankDrops", "EmptyDrops", "QCMetrics", "Scrublet", "ScDblFinder", "Cxds", "Bcds", "CxdsBcdsHybrid", "DoubletFinder", "DecontX" and "SoupX".
#' @param output_file name of the generated file. If NULL/default then the output file name will be based on the name of the selected QC algorithm name .
#' @param output_dir name of the output directory to save the rendered file. If NULL/default the file is stored to the current working directory
#' @return .html file
#' @examples
#' data(scExample, package = "singleCellTK")
#' sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
#' \dontrun{
#' sce <- runDecontX(sce)
#' sce <- runQuickUMAP(sce)
#' reportQCTool(inSCE = sce, algorithm = "DecontX")
#' }
#' @export
reportQCTool <- function(inSCE, algorithm=c("BarcodeRankDrops",
                                            "EmptyDrops",
                                            "QCMetrics",
                                            "Scrublet",
                                            "ScDblFinder",
                                            "Cxds",
                                            "Bcds",
                                            "CxdsBcdsHybrid",
                                            "DoubletFinder",
                                            "DecontX",
                                            "SoupX"),
                         output_file = NULL,
                            output_dir = NULL) {

  algorithm <- match.arg(algorithm)

  if (is.null(output_dir)){
    output_dir<- getwd()
  }

  if (algorithm =="BarcodeRankDrops"){
    rmarkdown::render(system.file("rmarkdown/qc/BarcodeRankDrops.Rmd", package="singleCellTK"), params = list(
      object=inSCE), output_file = output_file, output_dir = output_dir)
  }
  if (algorithm =="EmptyDrops"){
    rmarkdown::render(system.file("rmarkdown/qc/EmptyDrops.Rmd", package="singleCellTK"), params = list(
      object=inSCE), output_file = output_file, output_dir = output_dir)
  }
  if (algorithm =="Cxds"){
    rmarkdown::render(system.file("rmarkdown/qc/Cxds.Rmd", package="singleCellTK"), params = list(
      object=inSCE), output_file = output_file, output_dir = output_dir)
  }
  if (algorithm =="Bcds"){
    rmarkdown::render(system.file("rmarkdown/qc/Bcds.Rmd", package="singleCellTK"), params = list(
      object=inSCE), output_file = output_file, output_dir = output_dir)
  }
  if (algorithm =="CxdsBcdsHybrid"){
    rmarkdown::render(system.file("rmarkdown/qc/CxdsBcdsHybrid.Rmd", package="singleCellTK"), params = list(
      object=inSCE), output_file = output_file, output_dir = output_dir)
  }
  if (algorithm =="DecontX"){
    rmarkdown::render(system.file("rmarkdown/qc/DecontX.Rmd", package="singleCellTK"), params = list(
      object=inSCE), output_file = output_file, output_dir = output_dir)
  }
  if (algorithm =="SoupX"){
    rmarkdown::render(system.file("rmarkdown/qc/SoupX.Rmd", package="singleCellTK"), params = list(
      object=inSCE), output_file = output_file, output_dir = output_dir)
  }
  if (algorithm =="ScDblFinder"){
    rmarkdown::render(system.file("rmarkdown/qc/ScDblFinder.Rmd", package="singleCellTK"), params = list(
      object=inSCE), output_file = output_file, output_dir = output_dir)
  }
  if (algorithm =="QCMetrics"){
    rmarkdown::render(system.file("rmarkdown/qc/QCMetrics.Rmd", package="singleCellTK"), params = list(
      object=inSCE), output_file = output_file, output_dir = output_dir)
  }
  if (algorithm =="Scrublet"){
    rmarkdown::render(system.file("rmarkdown/qc/Scrublet.Rmd", package="singleCellTK"), params = list(
      object=inSCE), output_file = output_file, output_dir = output_dir)
  }
  if (algorithm =="DoubletFinder"){
    rmarkdown::render(system.file("rmarkdown/qc/DoubletFinder.Rmd", package="singleCellTK"), params = list(
      object=inSCE), output_file = output_file, output_dir = output_dir)
  }
 }

#' @title Get runDEAnalysis .html report
#' @description A  function to generate .html Rmarkdown report containing the
#' visualizations of the \code{\link{runDEAnalysis}} function output
#' @param inSCE A \code{\link[SingleCellExperiment]{SingleCellExperiment}}
#' object containing the output from \code{\link{runDEAnalysis}} function
#' @param study The specific analysis to visualize, used as \code{analysisName}
#' argument when running differential expression.
#' @param useReducedDim Specify an embedding for visualizing the relation ship
#' between the conditions.
#' @param featureDisplay The feature ID type to use for displaying. Should
#' exists as a variable name of \code{rowData}. Default \code{NULL} use rownames
#' of \code{inSCE}.
#' @param output_file name of the generated file. If \code{NULL} then the output
#' file name will be based on the name of the Rmarkdown template. Default
#' \code{NULL}.
#' @param output_dir name of the output directory to save the rendered file. If
#' \code{NULL} the file is stored to the current working directory.
#' Default \code{NULL}.
#' @return Saves the HTML report in the specified output directory.
#' @export
reportDiffExp <- function(inSCE, study, useReducedDim,
                          featureDisplay = NULL,
                          output_file = NULL,
                          output_dir = NULL) {

  if (is.null(output_dir)){
    output_dir <- getwd()
  }
  if (!study %in% names(S4Vectors::metadata(inSCE)$diffExp)) {
    stop("Specified study not found in given SCE object")
  }
  rmarkdown::render(system.file("rmarkdown/de/DifferentialExpression.Rmd",
                                package="singleCellTK"),
                    params = list(object=inSCE, study=study,
                                  useReducedDim=useReducedDim,
                                  featureDisplay=featureDisplay),
                    output_file = output_file,
                    output_dir = output_dir )
}

#' @title Get runFindMarker .html report
#' @description A  function to generate .html Rmarkdown report containing the
#' visualizations of the \code{\link{runFindMarker}} function output
#' @param inSCE A \code{\link[SingleCellExperiment]{SingleCellExperiment}}
#' object containing the output from \code{\link{runFindMarker}} function
#' @param output_file name of the generated file. If \code{NULL} then the output
#' file name will be based on the name of the Rmarkdown template. Default
#' \code{NULL}.
#' @param output_dir name of the output directory to save the rendered file. If
#' \code{NULL} the file is stored to the current working directory.
#' Default \code{NULL}.
#' @return An HTML file of the report will be generated at the path specified
#' in the arguments.
#' @export
reportFindMarker <- function(inSCE, output_file = NULL, output_dir = NULL) {

  if (is.null(output_dir)){
    output_dir <- getwd()
  }
  if (!"findMarker" %in% names(S4Vectors::metadata(inSCE))) {
    stop("Find marker result not presented in input SCE object. Run ",
         "runFindMarker() first. ")
  }
  att <- names(attributes(S4Vectors::metadata(inSCE)$findMarker))
  if (!"useAssay" %in% att) {
    stop("Can't identify the structure of find marker result. Run ",
         "runFindMarker() first. ")
  }
  rmarkdown::render(system.file("rmarkdown/de/FindMarker.Rmd",
                                package = "singleCellTK"),
                    params = list(object = inSCE),
                    output_file = output_file,
                    output_dir = output_dir )
}


#' Generates an HTML report for Seurat Run (including Normalization,
#'  Feature Selection, Dimensionality Reduction & Clustering) and returns the
#'  SCE object with the results computed and stored inside the object.
#' @param inSCE Input \code{\link[SingleCellExperiment]{SingleCellExperiment}}
#'  object.
#' @param biological.group A character value that specifies the name of the
#'  \code{colData()} column to use as the main biological group in the Seurat
#'  report for tSNE & UMAP visualization.
#' @param phenotype.groups A character value that specifies the name of the
#'  \code{colData()} column to use as additional phenotype variables in the
#'  Seurat report for tSNE & UMAP visualization.
#' @param variable.features A numeric value indicating the number of top
#'  variable genes to identify in the report. Default is \code{2000}.
#' @param pc.count A numeric value indicating the number of principal
#'  components to use in the analysis workflow. Default is \code{50}.
#' @param runHVG A logical value indicating if feature selection should be run
#'  in the report. Default \code{TRUE}.
#' @param plotHVG A logical value indicating if the top variable genes should
#'  be visualized through a mean-to-variance plot. Default is \code{TRUE}.
#' @param runDimRed A logical value indicating if PCA should be computed in the
#'  report. Default is \code{TRUE}.
#' @param plotJackStraw A logical value indicating if the JackStraw plot should
#'  be visualized for the principal components. Default is \code{FALSE}.
#' @param plotElbowPlot A logical value indicating if the ElbowPlot should be
#'  visualized for the principal components. Default is \code{FALSE}.
#' @param plotHeatmaps A logical value indicating if the Heatmaps should be
#'  visualized for the principal components. Default is \code{FALSE}.
#' @param runClustering A logical value indicating if Clustering should be
#'  run over multiple resolutions as defined by the \code{minResolution} and
#'  \code{maxResolution} parameters. Default is \code{TRUE}.
#' @param plotTSNE A logical value indicating if TSNE plot should be visualized
#'  for clusters. Default is \code{TRUE}.
#' @param plotUMAP A logical value indicating if UMAP plot should be visualized
#'  for clusters. Default is \code{TRUE}.
#' @param minResolution A numeric value indicating the minimum resolution to use
#'  for clustering. Default \code{0.3}.
#' @param maxResolution A numeric value indicating the maximum resolution to use
#'  for clustering. Default \code{1.5}.
#' @param outputFile Specify the name of the generated output HTML file.
#'  If \code{NULL} then the output file name will be based on the name of the
#'  Rmarkdown template. Default \code{NULL}.
#' @param outputPath Specify the name of the output directory to save the
#'  rendered HTML file. If \code{NULL} the file is stored to the current
#'  working directory. Default \code{NULL}.
#' @param subtitle A character value specifying the subtitle to use in the
#'  report. Default \code{NULL}.
#' @param authors A character value specifying the names of the authors to use
#'  in the report. Default \code{NULL}.
#' @param showSession A logical value indicating if session information
#'  should be displayed or not. Default is \code{FALSE}.
#' @param pdf A logical value indicating if a pdf should also be generated for
#'  each figure in the report. Default is \code{FALSE}.
#' @param forceRun A logical value indicating if all computations previously
#'  computed should be re-calculated regardless if these computations are
#'  available in the input object. Default is \code{TRUE}.
#'
#' @return A \code{\link[SingleCellExperiment]{SingleCellExperiment}} object
#'  with computations stored.
#' @export
reportSeuratRun <- function(inSCE,
                            biological.group = NULL,
                            phenotype.groups = NULL,
                            variable.features = 2000,
                            pc.count = 50,
                            runHVG = TRUE,
                            plotHVG = TRUE,
                            runDimRed = TRUE,
                            plotJackStraw = FALSE,
                            plotElbowPlot = TRUE,
                            plotHeatmaps = TRUE,
                            runClustering = TRUE,
                            plotTSNE = TRUE,
                            plotUMAP = TRUE,
                            minResolution = 0.3,
                            maxResolution = 1.5,
                            outputFile = NULL,
                            outputPath = NULL,
                            subtitle = NULL,
                            authors =  NULL,
                            showSession = FALSE,
                            pdf = FALSE,
                            forceRun = TRUE){

  if(is.null(biological.group)){
    stop("Must specify atleast one biological.group that is present in the colData of input object.")
  }

  if(!biological.group %in% names(colData(inSCE))){
    stop(biological.group, " not found in the colData of input object.")
  }

  if(!is.null(phenotype.groups)){
    if(!all(phenotype.groups %in% names(colData(inSCE)))){
      stop(phenotype.groups, " not found in the colData of input object.")
    }
  }

  if(is.null(outputPath)){
    outputPath <- getwd()
    message("No output directory defined, using current working directory ", outputPath, " instead.")
  }

  data <- inSCE

  rmarkdown::render(system.file("rmarkdown/seurat/reportSeuratRun.Rmd",
                                package="singleCellTK"),
                    params = list(
                      subtitle = subtitle,
                      authors = authors,
                      sce = data,
                      biological.group = biological.group,
                      phenotype.groups = phenotype.groups,
                      variable.features = variable.features,
                      pc.count = pc.count,
                      outputPath = outputPath,
                      showSession = showSession,
                      pdf = pdf,
                      runHVG = runHVG,
                      plotHVG = plotHVG,
                      runDimRed = runDimRed,
                      plotJackStraw = plotJackStraw,
                      plotElbowPlot = plotElbowPlot,
                      plotHeatmaps = plotHeatmaps,
                      runClustering = runClustering,
                      plotTSNE = plotTSNE,
                      plotUMAP = plotUMAP,
                      minResolution = minResolution,
                      maxResolution = maxResolution,
                      forceRun = forceRun
                    ),
                    output_file = outputFile,
                    output_dir = outputPath,
                    intermediates_dir = getwd(),
                    knit_root_dir = getwd())

  path <- paste0(outputPath, "SCE_SeuratRun", "-", gsub(" ", "_", Sys.Date()), ".rds")
  saveRDS(data, path)
  p <- paste0("SCE_SeuratRun", "-", gsub(" ", "_", Sys.Date()), ".rds")
  message("Output SCE object stored as ", p , " in ", outputPath, ".")
  message("Output HTML file stored as ", outputFile, " in ", outputPath, ".")

  return(data)
}


#' Generates an HTML report for Seurat Results (including Clustering & Marker
#'  Selection) and returns the SCE object with the results computed and stored
#'  inside the object.
#' @param inSCE Input \code{\link[SingleCellExperiment]{SingleCellExperiment}}
#'  object previously passed through \code{reportSeuratRun()}.
#' @param biological.group A character value that specifies the name of the
#'  \code{colData()} column to use as the main biological group in the Seurat
#'  report for marker selection and grouping.
#' @param phenotype.groups A character vector that specifies the names of the
#'  \code{colData()} columns to use for differential expression in addition to
#'  the \code{biological.group} parameter.
#' @param selected.markers A character vector containing the user-specified
#'  gene symbols or feature names of marker genes that be used to generate
#'  gene plots in addition to the gene markers computed from
#'  differential expression.
#' @param clustering.resolution A numeric value indicating the user-specified
#'  final resolution to use with clustering. Default is \code{0.8}.
#' @param pc.count A numeric value indicating the number of principal components
#'  to use in the analysis workflow. Default is \code{50}.
#' @param plotTSNE A logical value indicating if TSNE plots should be visualized
#'  in the clustering section of the report. Default is \code{TRUE}.
#' @param plotUMAP A logical value indicating if UMAP plots should be visualized
#'  in the clustering section of the report. Default is \code{TRUE}.
#' @param runClustering A logical value indicating if Clustering should be run
#'  or not in the report. Default is \code{TRUE}. If \code{FALSE}, parameters
#'   \code{plotTSNE} and \code{plotUMAP} are also set to \code{FALSE}.
#' @param runMSClusters A logical value indicating if the marker selection
#'  section for identifying marker genes between clusters should be run and
#'  visualized in the report. Default \code{TRUE}.
#' @param runMSBioGroup A logical value indicating if the marker selection
#'  section for identifying marker genes between the \code{biological.group}
#'  parameter should be run and visualized in the report. Default \code{TRUE}.
#' @param numTopFeatures A numeric value indicating the number of top features
#'  to visualize in each group. Default \code{10}.
#' @param outputFile Specify the name of the generated output HTML file.
#'  If \code{NULL} then the output file name will be based on the name of the
#'  Rmarkdown template. Default \code{NULL}.
#' @param outputPath Specify the name of the output directory to save the
#'  rendered HTML file. If \code{NULL} the file is stored to the current
#'  working directory. Default \code{NULL}.
#' @param subtitle A character value specifying the subtitle to use in the
#'  report. Default \code{NULL}.
#' @param authors A character value specifying the names of the authors to use
#'  in the report. Default \code{NULL}.
#' @param showSession A logical value indicating if session information
#'  should be displayed or not. Default is \code{FALSE}.
#' @param pdf A logical value indicating if a pdf should also be generated for
#'  each figure in the report. Default is \code{FALSE}.
#' @param forceRun A logical value indicating if all computations previously
#'  computed should be re-calculated regardless if these computations are
#'  available in the input object. Default is \code{TRUE}.
#'
#' @return A \code{\link[SingleCellExperiment]{SingleCellExperiment}} object
#'  with computations stored.
#' @export
reportSeuratResults <- function(inSCE,
                                biological.group = NULL,
                                phenotype.groups = NULL,
                                selected.markers = NULL,
                                clustering.resolution = 0.8,
                                pc.count = 50,
                                plotTSNE = TRUE,
                                plotUMAP = TRUE,
                                runClustering = TRUE,
                                runMSClusters = TRUE,
                                runMSBioGroup = TRUE,
                                numTopFeatures = 10,
                                outputFile = NULL,
                                outputPath = NULL,
                                subtitle = NULL,
                                authors =  NULL,
                                showSession = FALSE,
                                pdf = FALSE,
                                forceRun = TRUE){

  if(is.null(biological.group)){
    stop("Must specify atleast one biological.group that is present in the colData of input object.")
  }

  if(!biological.group %in% names(colData(inSCE))){
    stop(biological.group, " not found in the colData of input object.")
  }

  if(!is.null(phenotype.groups)){
    if(!all(phenotype.groups %in% names(colData(inSCE)))){
      stop(phenotype.groups, " not found in the colData of input object.")
    }
  }

  if(is.null(outputPath)){
    outputPath <- getwd()
    message("No output directory defined, using current working directory ", outputPath, " instead.")
  }

  data <- inSCE

  rmarkdown::render(system.file("rmarkdown/seurat/reportSeuratResults.Rmd",
                                package="singleCellTK"),
                    params = list(
                      subtitle = subtitle,
                      authors = authors,
                      sce = data,
                      biological.group = biological.group,
                      phenotype.groups = phenotype.groups,
                      selected.markers = selected.markers,
                      clustering.resolution = clustering.resolution,
                      pc.count = pc.count,
                      outputPath = outputPath,
                      showSession = showSession,
                      pdf = pdf,
                      plotTSNE = plotTSNE,
                      plotUMAP = plotUMAP,
                      runClustering = runClustering,
                      runMSClusters = runMSClusters,
                      runMSBioGroup = runMSBioGroup,
                      numTopFeatures = numTopFeatures,
                      forceRun = forceRun
                    ),
                    output_file = outputFile,
                    output_dir = outputPath,
                    intermediates_dir = getwd(),
                    knit_root_dir = getwd())

  path <- paste0(outputPath, "SCE_SeuratResults", "-", gsub(" ", "_", Sys.Date()), ".rds")
  saveRDS(data, path)
  p <- paste0("SCE_SeuratResults", "-", gsub(" ", "_", Sys.Date()), ".rds")
  message("Output SCE object stored as ", p , " in ", outputPath, ".")
  message("Output HTML file stored as ", outputFile, " in ", outputPath, ".")

  return(data)
}


#' Generates an HTML report for Seurat Dimensionality Reduction
#'  and returns the SCE object with the results computed and stored
#'  inside the object.
#' @param inSCE Input \code{\link[SingleCellExperiment]{SingleCellExperiment}}
#'  object.
#' @param pc.count A numeric value indicating the number of principal components
#'  to compute. Default is \code{50}.
#' @param runDimRed A logical value indicating if dimenionality reduction should
#'  be computed. Default \code{TRUE}.
#' @param plotJackStraw A logical value indicating if JackStraw plot should be
#'  visualized. Default \code{FALSE}.
#' @param plotElbowPlot A logical value indicating if ElbowPlot should be
#'  visualized. Default \code{TRUE}.
#' @param plotHeatmaps A logical value indicating if heatmaps should be
#'  visualized. Default \code{TRUE}.
#' @param outputFile Specify the name of the generated output HTML file.
#'  If \code{NULL} then the output file name will be based on the name of the
#'  Rmarkdown template. Default \code{NULL}.
#' @param outputPath Specify the name of the output directory to save the
#'  rendered HTML file. If \code{NULL} the file is stored to the current
#'  working directory. Default \code{NULL}.
#' @param subtitle A character value specifying the subtitle to use in the
#'  report. Default \code{NULL}.
#' @param authors A character value specifying the names of the authors to use
#'  in the report. Default \code{NULL}.
#' @param showSession A logical value indicating if session information
#'  should be displayed or not. Default is \code{FALSE}.
#' @param pdf A logical value indicating if a pdf should also be generated for
#'  each figure in the report. Default is \code{FALSE}.
#' @param forceRun A logical value indicating if all computations previously
#'  computed should be re-calculated regardless if these computations are
#'  available in the input object. Default is \code{TRUE}.
#'
#' @return A \code{\link[SingleCellExperiment]{SingleCellExperiment}} object
#'  with computations stored.
#' @export
reportSeuratDimRed <- function(inSCE,
                               pc.count = 50,
                               runDimRed = TRUE,
                               plotJackStraw = FALSE,
                               plotElbowPlot = TRUE,
                               plotHeatmaps = TRUE,
                               outputFile = NULL,
                               outputPath = NULL,
                               subtitle = NULL,
                               authors =  NULL,
                               showSession = FALSE,
                               pdf = FALSE,
                               forceRun = TRUE){

  if(is.null(outputPath)){
    outputPath <- getwd()
    message("No output directory defined, using current working directory ", outputPath, " instead.")
  }

  data <- inSCE

  rmarkdown::render(system.file("rmarkdown/seurat/reportSeuratDimRed.Rmd",
                                package="singleCellTK"),
                    params = list(
                      subtitle = subtitle,
                      authors = authors,
                      sce = data,
                      pc.count = pc.count,
                      outputPath = outputPath,
                      showSession = showSession,
                      pdf = pdf,
                      runDimRed = runDimRed,
                      plotJackStraw = plotJackStraw,
                      plotElbowPlot = plotElbowPlot,
                      plotHeatmaps = plotHeatmaps,
                      forceRun = forceRun
                    ),
                    output_file = outputFile,
                    output_dir = outputPath,
                    intermediates_dir = getwd(),
                    knit_root_dir = getwd())

  path <- paste0(outputPath, "SCE_SeuratDimRed", "-", gsub(" ", "_", Sys.Date()), ".rds")
  saveRDS(data, path)
  p <- paste0("SCE_SeuratDimRed", "-", gsub(" ", "_", Sys.Date()), ".rds")
  message("Output SCE object stored as ", p , " in ", outputPath, ".")
  message("Output HTML file stored as ", outputFile, " in ", outputPath, ".")

  return(data)
}


#' Generates an HTML report for Seurat Normalization
#'  and returns the SCE object with the results computed and stored
#'  inside the object.
#' @param inSCE Input \code{\link[SingleCellExperiment]{SingleCellExperiment}}
#'  object previously passed through \code{reportSeuratRun()}.
#' @param outputFile Specify the name of the generated output HTML file.
#'  If \code{NULL} then the output file name will be based on the name of the
#'  Rmarkdown template. Default \code{NULL}.
#' @param outputPath Specify the name of the output directory to save the
#'  rendered HTML file. If \code{NULL} the file is stored to the current
#'  working directory. Default \code{NULL}.
#' @param subtitle A character value specifying the subtitle to use in the
#'  report. Default \code{NULL}.
#' @param authors A character value specifying the names of the authors to use
#'  in the report. Default \code{NULL}.
#' @param showSession A logical value indicating if session information
#'  should be displayed or not. Default is \code{FALSE}.
#' @param pdf A logical value indicating if a pdf should also be generated for
#'  each figure in the report. Default is \code{FALSE}.
#' @param forceRun A logical value indicating if all computations previously
#'  computed should be re-calculated regardless if these computations are
#'  available in the input object. Default is \code{TRUE}.
#'
#' @return A \code{\link[SingleCellExperiment]{SingleCellExperiment}} object
#'  with computations stored.
#' @export
reportSeuratNormalization <- function(inSCE,
                               outputFile = NULL,
                               outputPath = NULL,
                               subtitle = NULL,
                               authors =  NULL,
                               showSession = FALSE,
                               pdf = FALSE,
                               forceRun = TRUE){

  if(is.null(outputPath)){
    outputPath <- getwd()
    message("No output directory defined, using current working directory ", outputPath, " instead.")
  }

  data <- inSCE

  rmarkdown::render(system.file("rmarkdown/seurat/reportSeuratNormalizeData.Rmd",
                                package="singleCellTK"),
                    params = list(
                      subtitle = subtitle,
                      authors = authors,
                      sce = data,
                      outputPath = outputPath,
                      showSession = showSession,
                      pdf = pdf,
                      forceRun = forceRun
                    ),
                    output_file = outputFile,
                    output_dir = outputPath,
                    intermediates_dir = getwd(),
                    knit_root_dir = getwd())

  path <- paste0(outputPath, "SCE_SeuratNormalization", "-", gsub(" ", "_", Sys.Date()), ".rds")
  saveRDS(data, path)
  p <- paste0("SCE_SeuratNormalization", "-", gsub(" ", "_", Sys.Date()), ".rds")
  message("Output SCE object stored as ", p , " in ", outputPath, ".")
  message("Output HTML file stored as ", outputFile, " in ", outputPath, ".")

  return(data)
}


#' Generates an HTML report for Seurat Feature Selection and returns the
#' SCE object with the results computed and stored inside the object.
#' @param inSCE Input \code{\link[SingleCellExperiment]{SingleCellExperiment}}
#'  object.
#' @param variable.features A numeric value indicating the number of top variable
#'  features to identify. Default \code{2000}.
#' @param runHVG A logical value indicating if the feature selection algorithm
#'  should be run or not. Default \code{TRUE}.
#' @param plotHVG A logical value indicating if the mean-to-variance plot
#'  of the top variable feature should be visualized or not. Default \code{TRUE}.
#' @param outputFile Specify the name of the generated output HTML file.
#'  If \code{NULL} then the output file name will be based on the name of the
#'  Rmarkdown template. Default \code{NULL}.
#' @param outputPath Specify the name of the output directory to save the
#'  rendered HTML file. If \code{NULL} the file is stored to the current
#'  working directory. Default \code{NULL}.
#' @param subtitle A character value specifying the subtitle to use in the
#'  report. Default \code{NULL}.
#' @param authors A character value specifying the names of the authors to use
#'  in the report. Default \code{NULL}.
#' @param showSession A logical value indicating if session information
#'  should be displayed or not. Default is \code{FALSE}.
#' @param pdf A logical value indicating if a pdf should also be generated for
#'  each figure in the report. Default is \code{FALSE}.
#' @param forceRun A logical value indicating if all computations previously
#'  computed should be re-calculated regardless if these computations are
#'  available in the input object. Default is \code{TRUE}.
#'
#' @return A \code{\link[SingleCellExperiment]{SingleCellExperiment}} object
#'  with computations stored.
#' @export
reportSeuratFeatureSelection <- function(inSCE,
                                         variable.features = 2000,
                                         runHVG = TRUE,
                                         plotHVG = TRUE,
                                         outputFile = NULL,
                                         outputPath = NULL,
                                         subtitle = NULL,
                                         authors =  NULL,
                                         showSession = FALSE,
                                         pdf = FALSE,
                                         forceRun = TRUE){
  if(is.null(outputPath)){
    outputPath <- getwd()
    message("No output directory defined, using current working directory ", outputPath, " instead.")
  }

  data <- inSCE

  rmarkdown::render(system.file("rmarkdown/seurat/reportSeuratFeatureSelection.Rmd",
                                package="singleCellTK"),
                    params = list(
                      subtitle = subtitle,
                      authors = authors,
                      sce = data,
                      variable.features = variable.features,
                      outputPath = outputPath,
                      showSession = showSession,
                      pdf = pdf,
                      forceRun = forceRun
                    ),
                    output_file = outputFile,
                    output_dir = outputPath,
                    intermediates_dir = getwd(),
                    knit_root_dir = getwd())

  path <- paste0(outputPath, "SCE_SeuratFeatureSelection", "-", gsub(" ", "_", Sys.Date()), ".rds")
  saveRDS(data, path)
  p <- paste0("SCE_SeuratFeatureSelection", "-", gsub(" ", "_", Sys.Date()), ".rds")
  message("Output SCE object stored as ", p , " in ", outputPath, ".")
  message("Output HTML file stored as ", outputFile, " in ", outputPath, ".")

  return(data)
}


#' Generates an HTML report for Seurat Scaling
#'  and returns the SCE object with the results computed and stored
#'  inside the object.
#' @param inSCE Input \code{\link[SingleCellExperiment]{SingleCellExperiment}}
#'  object.
#' @param outputFile Specify the name of the generated output HTML file.
#'  If \code{NULL} then the output file name will be based on the name of the
#'  Rmarkdown template. Default \code{NULL}.
#' @param outputPath Specify the name of the output directory to save the
#'  rendered HTML file. If \code{NULL} the file is stored to the current
#'  working directory. Default \code{NULL}.
#' @param subtitle A character value specifying the subtitle to use in the
#'  report. Default \code{NULL}.
#' @param authors A character value specifying the names of the authors to use
#'  in the report. Default \code{NULL}.
#' @param showSession A logical value indicating if session information
#'  should be displayed or not. Default is \code{FALSE}.
#' @param pdf A logical value indicating if a pdf should also be generated for
#'  each figure in the report. Default is \code{FALSE}.
#' @param forceRun A logical value indicating if all computations previously
#'  computed should be re-calculated regardless if these computations are
#'  available in the input object. Default is \code{TRUE}.
#'
#' @return A \code{\link[SingleCellExperiment]{SingleCellExperiment}} object
#'  with computations stored.
#' @export
reportSeuratScaling <- function(inSCE,
                           outputFile = NULL,
                           outputPath = NULL,
                           subtitle = NULL,
                           authors =  NULL,
                           showSession = FALSE,
                           pdf = FALSE,
                           forceRun = TRUE){

  if(is.null(outputPath)){
    outputPath <- getwd()
    message("No output directory defined, using current working directory ", outputPath, " instead.")
  }

  data <- inSCE

  rmarkdown::render(system.file("rmarkdown/seurat/reportSeuratScaleData.Rmd",
                                package="singleCellTK"),
                    params = list(
                      subtitle = subtitle,
                      authors = authors,
                      sce = data,
                      outputPath = outputPath,
                      showSession = showSession,
                      pdf = pdf,
                      forceRun = forceRun
                    ),
                    output_file = outputFile,
                    output_dir = outputPath,
                    intermediates_dir = getwd(),
                    knit_root_dir = getwd())

  path <- paste0(outputPath, "SCE_SeuratScaleData", "-", gsub(" ", "_", Sys.Date()), ".rds")
  saveRDS(data, path)
  p <- paste0("SCE_SeuratScaleData", "-", gsub(" ", "_", Sys.Date()), ".rds")
  message("Output SCE object stored as ", p , " in ", outputPath, ".")
  message("Output HTML file stored as ", outputFile, " in ", outputPath, ".")

  return(data)
}


#' Generates an HTML report for Seurat Clustering and returns the SCE object
#'  with the results computed and stored inside the object.
#' @param inSCE Input \code{\link[SingleCellExperiment]{SingleCellExperiment}}
#'  object.
#' @param biological.group A character value that specifies the name of the
#'  \code{colData()} column to use as the main biological group in the Seurat
#'  report for marker selection and grouping.
#' @param phenotype.groups A character vector that specifies the names of the
#'  \code{colData()} columns to use for differential expression in addition to
#'  the \code{biological.group} parameter.
#' @param runClustering A logical value indicating if Clustering should be run
#'  or not in the report. Default is \code{TRUE}. If \code{FALSE}, parameters
#'   \code{plotTSNE} and \code{plotUMAP} are also set to \code{FALSE}.
#' @param plotTSNE A logical value indicating if TSNE plots should be visualized
#'  in the clustering section of the report. Default is \code{TRUE}.
#' @param plotUMAP A logical value indicating if UMAP plots should be visualized
#'  in the clustering section of the report. Default is \code{TRUE}.
#' @param minResolution A numeric value indicating the minimum resolution to use
#'  for clustering. Default \code{0.3}.
#' @param maxResolution A numeric value indicating the maximum resolution to use
#'  for clustering. Default \code{1.5}.
#' @param numClusters temp (to remove)
#' @param significant_PC temp (change to pc.use)
#' @param outputFile Specify the name of the generated output HTML file.
#'  If \code{NULL} then the output file name will be based on the name of the
#'  Rmarkdown template. Default \code{NULL}.
#' @param outputPath Specify the name of the output directory to save the
#'  rendered HTML file. If \code{NULL} the file is stored to the current
#'  working directory. Default \code{NULL}.
#' @param subtitle A character value specifying the subtitle to use in the
#'  report. Default \code{NULL}.
#' @param authors A character value specifying the names of the authors to use
#'  in the report. Default \code{NULL}.
#' @param showSession A logical value indicating if session information
#'  should be displayed or not. Default is \code{FALSE}.
#' @param pdf A logical value indicating if a pdf should also be generated for
#'  each figure in the report. Default is \code{FALSE}.
#' @param forceRun A logical value indicating if all computations previously
#'  computed should be re-calculated regardless if these computations are
#'  available in the input object. Default is \code{TRUE}.
#'
#' @return A \code{\link[SingleCellExperiment]{SingleCellExperiment}} object
#'  with computations stored.
#' @export
reportSeuratClustering <- function(inSCE,
                                   biological.group = NULL,
                                   phenotype.groups = NULL,
                                   runClustering = TRUE,
                                   plotTSNE = TRUE,
                                   plotUMAP = TRUE,
                                   minResolution = 0.3,
                                   maxResolution = 1.5,
                                   numClusters = 10,
                                   significant_PC = 10,
                                   outputFile = NULL,
                                   outputPath = NULL,
                                   subtitle = NULL,
                                   authors =  NULL,
                                   showSession = FALSE,
                                   pdf = FALSE,
                                   forceRun = TRUE){

  if(is.null(biological.group)){
    stop("Must specify atleast one biological.group that is present in the colData of input object.")
  }

  if(!biological.group %in% names(colData(inSCE))){
    stop(biological.group, " not found in the colData of input object.")
  }

  if(!is.null(phenotype.groups)){
    if(!all(phenotype.groups %in% names(colData(inSCE)))){
      stop(phenotype.groups, " not found in the colData of input object.")
    }
  }

  data <- inSCE

  rmarkdown::render(system.file("rmarkdown/seurat/reportSeuratClustering.Rmd",
                                package="singleCellTK"),
                    params = list(
                      subtitle = subtitle,
                      authors = authors,
                      sce = data,
                      biological.group = biological.group,
                      phenotype.groups = phenotype.groups,
                      outputPath = outputPath,
                      showSession = showSession,
                      pdf = pdf,
                      runClustering = runClustering,
                      plotTSNE = plotTSNE,
                      plotUMAP = plotUMAP,
                      minResolution = minResolution,
                      maxResolution = maxResolution,
                      numClusters = numClusters,
                      significant_PC = significant_PC,
                      forceRun = forceRun
                    ),
                    output_file = outputFile,
                    output_dir = outputPath,
                    intermediates_dir = getwd(),
                    knit_root_dir = getwd())

  path <- paste0(outputPath, "SCE_SeuratClustering", "-", gsub(" ", "_", Sys.Date()), ".rds")
  saveRDS(data, path)
  p <- paste0("SCE_SeuratClustering", "-", gsub(" ", "_", Sys.Date()), ".rds")
  message("Output SCE object stored as ", p , " in ", outputPath, ".")
  message("Output HTML file stored as ", outputFile, " in ", outputPath, ".")

  return(data)
}


#' Generates an HTML report for Seurat Results (including Clustering & Marker
#'  Selection) and returns the SCE object with the results computed and stored
#'  inside the object.
#' @param inSCE Input \code{\link[SingleCellExperiment]{SingleCellExperiment}}
#'  object.
#' @param biological.group A character value that specifies the name of the
#'  \code{colData()} column to use as the main biological group in the Seurat
#'  report for marker selection and grouping.
#' @param phenotype.groups A character vector that specifies the names of the
#'  \code{colData()} columns to use for differential expression in addition to
#'  the \code{biological.group} parameter.
#' @param selected.markers A character vector containing the user-specified
#'  gene symbols or feature names of marker genes that be used to generate
#'  gene plots in addition to the gene markers computed from
#'  differential expression.
#' @param runMarkerSelection A logical value indicating if the marker selection
#'  computation should be run or not. Default \code{TRUE}.
#' @param plotMarkerSelection A logical value indicating if the gene marker
#'  plots should be visualized or not. Default \code{TRUE}.
#' @param numTopFeatures A numeric value indicating the number of top features
#'  to visualize in each group. Default \code{10}.
#' @param outputFile Specify the name of the generated output HTML file.
#'  If \code{NULL} then the output file name will be based on the name of the
#'  Rmarkdown template. Default \code{NULL}.
#' @param outputPath Specify the name of the output directory to save the
#'  rendered HTML file. If \code{NULL} the file is stored to the current
#'  working directory. Default \code{NULL}.
#' @param subtitle A character value specifying the subtitle to use in the
#'  report. Default \code{NULL}.
#' @param authors A character value specifying the names of the authors to use
#'  in the report. Default \code{NULL}.
#' @param showSession A logical value indicating if session information
#'  should be displayed or not. Default is \code{FALSE}.
#' @param pdf A logical value indicating if a pdf should also be generated for
#'  each figure in the report. Default is \code{FALSE}.
#'
#' @return A \code{\link[SingleCellExperiment]{SingleCellExperiment}} object
#'  with computations stored.
#' @export
reportSeuratMarkerSelection <- function(inSCE,
                                        biological.group = NULL,
                                        phenotype.groups = NULL,
                                        selected.markers = NULL,
                                        runMarkerSelection = TRUE,
                                        plotMarkerSelection = TRUE,
                                        numTopFeatures = 10,
                                        outputFile = NULL,
                                        outputPath = NULL,
                                        subtitle = NULL,
                                        authors =  NULL,
                                        showSession = FALSE,
                                        pdf = FALSE){

  if(is.null(biological.group)){
    stop("Must specify atleast one biological.group that is present in the colData of input object.")
  }

  if(!biological.group %in% names(colData(inSCE))){
    stop(biological.group, " not found in the colData of input object.")
  }

  if(!is.null(phenotype.groups)){
    if(!all(phenotype.groups %in% names(colData(inSCE)))){
      stop(phenotype.groups, " not found in the colData of input object.")
    }
  }

  if(is.null(outputPath)){
    outputPath <- getwd()
    message("No output directory defined, using current working directory ", outputPath, " instead.")
  }

  data <- inSCE

  rmarkdown::render(system.file("rmarkdown/seurat/reportSeuratMarkerSelection.Rmd",
                                package="singleCellTK"),
                    params = list(
                      subtitle = subtitle,
                      authors = authors,
                      sce = data,
                      biological.group = biological.group,
                      phenotype.groups = phenotype.groups,
                      selected.markers = selected.markers,
                      outputPath = outputPath,
                      showSession = showSession,
                      pdf = pdf,
                      runMarkerSelection = runMarkerSelection,
                      plotMarkerSelection = plotMarkerSelection,
                      numTopFeatures = numTopFeatures
                    ),
                    output_file = outputFile,
                    output_dir = outputPath,
                    intermediates_dir = getwd(),
                    knit_root_dir = getwd())

  path <- paste0(outputPath, "SCE_SeuratResults", "-", gsub(" ", "_", Sys.Date()), ".rds")
  saveRDS(data, path)
  p <- paste0("SCE_SeuratResults", "-", gsub(" ", "_", Sys.Date()), ".rds")
  message("Output SCE object stored as ", p , " in ", outputPath, ".")
  message("Output HTML file stored as ", outputFile, " in ", outputPath, ".")

  return(data)
}

#' Generates an HTML report for the complete Seurat workflow and returns the
#'  SCE object with the results computed and stored inside the object.
#' @param inSCE Input \code{\link[SingleCellExperiment]{SingleCellExperiment}}
#'  object.
#' @param biological.group A character value that specifies the name of the
#'  \code{colData()} column to use as the main biological group in the Seurat
#'  report for marker selection and grouping.
#' @param phenotype.groups A character vector that specifies the names of the
#'  \code{colData()} columns to use for differential expression in addition to
#'  the \code{biological.group} parameter.
#' @param selected.markers A character vector containing the user-specified
#'  gene symbols or feature names of marker genes that be used to generate
#'  gene plots in addition to the gene markers computed from
#'  differential expression.
#' @param clustering.resolution A numeric value indicating the user-specified
#'  final resolution to use with clustering. Default is \code{0.8}.
#' @param variable.features A numeric value indicating the number of top
#'  variable features to identify. Default \code{2000}.
#' @param pc.count A numeric value indicating the number of principal components
#'  to use in the analysis workflow. Default is \code{50}.
#' @param outputFile Specify the name of the generated output HTML file.
#'  If \code{NULL} then the output file name will be based on the name of the
#'  Rmarkdown template. Default \code{NULL}.
#' @param outputPath Specify the name of the output directory to save the
#'  rendered HTML file. If \code{NULL} the file is stored to the current
#'  working directory. Default \code{NULL}.
#' @param subtitle A character value specifying the subtitle to use in the
#'  report. Default \code{NULL}.
#' @param authors A character value specifying the names of the authors to use
#'  in the report. Default \code{NULL}.
#' @param showSession A logical value indicating if session information
#'  should be displayed or not. Default is \code{FALSE}.
#' @param pdf A logical value indicating if a pdf should also be generated for
#'  each figure in the report. Default is \code{FALSE}.
#' @param runHVG A logical value indicating if the feature selection
#'  computation should be run or not. Default is \code{TRUE}.
#' @param plotHVG A logical value indicating if the plot for the top most
#'  variable genes should be visualized in a mean-to-variance plot.
#'  Default is \code{TRUE}.
#' @param runDimRed A logical value indicating if PCA should be computed.
#'  Default is \code{TRUE}.
#' @param plotJackStraw A logical value indicating if JackStraw plot be
#'  visualized for the principal components. Default is \code{FALSE}.
#' @param plotElbowPlot A logical value indicating if the ElbowPlot be
#'  visualized for the principal components. Default is \code{TRUE}.
#' @param plotHeatmaps A logical value indicating if heatmaps should be plotted
#'  for the principal components. Default is \code{TRUE}.
#' @param runClustering A logical value indicating if clustering section should
#'  be run in the report. Default is \code{TRUE}.
#' @param plotTSNE A logical value indicating if TSNE plots should be visualized
#'  for clustering results. Default is \code{TRUE}.
#' @param plotUMAP A logical value indicating if the UMAP plots should be
#'  visualized for the clustering results. Default is \code{TRUE}.
#' @param minResolution A numeric value indicating the minimum resolution to
#'  use for clustering. Default is \code{0.3}.
#' @param maxResolution A numeric value indicating the maximum resolution to use
#'  for clustering. Default is \code{1.5}.
#' @param runMSClusters A logical value indicating if marker selection should
#'  be run between clusters. Default is \code{TRUE}.
#' @param runMSBioGroup A logical value indicating if marker selection should
#'  be run between the \code{biological.group} parameter.
#'  Default is \code{TRUE}.
#' @param numTopFeatures A numeric value indicating the number of top features
#'  to visualize in each group. Default \code{10}.
#' @param forceRun A logical value indicating if all algorithms should be
#'  re-run regardless if they have been computed previously in the input object.
#'  Default is \code{TRUE}.
#'
#' @return A \code{\link[SingleCellExperiment]{SingleCellExperiment}} object
#'  with computations stored.
#' @export
reportSeurat <- function(
  inSCE,
  biological.group = NULL,
  phenotype.groups = NULL,
  selected.markers = NULL,
  clustering.resolution = 0.8,
  variable.features = 2000,
  pc.count = 50,
  outputFile = NULL,
  outputPath = NULL,
  subtitle = NULL,
  authors =  NULL,
  showSession = FALSE,
  pdf = FALSE,
  runHVG = TRUE,
  plotHVG = TRUE,
  runDimRed = TRUE,
  plotJackStraw = FALSE,
  plotElbowPlot = TRUE,
  plotHeatmaps = TRUE,
  runClustering = TRUE,
  plotTSNE = TRUE,
  plotUMAP = TRUE,
  minResolution = 0.3,
  maxResolution = 1.5,
  runMSClusters = TRUE,
  runMSBioGroup = TRUE,
  numTopFeatures = 10,
  forceRun = TRUE){

  if(is.null(biological.group)){
    stop("Must specify atleast one biological.group that is present in the colData of input object.")
  }

  if(!biological.group %in% names(colData(inSCE))){
    stop(biological.group, " not found in the colData of input object.")
  }

  if(!is.null(phenotype.groups)){
    if(!all(phenotype.groups %in% names(colData(inSCE)))){
      stop(phenotype.groups, " not found in the colData of input object.")
    }
  }

  if(is.null(outputPath)){
    outputPath <- getwd()
    message("No output directory defined, using current working directory ", outputPath, " instead.")
  }

  data <- inSCE

  rmarkdown::render(system.file("rmarkdown/seurat/reportSeurat.Rmd",
                                package="singleCellTK"),
                    params = list(
                      subtitle = subtitle,
                      authors = authors,
                      sce = data,
                      biological.group = biological.group,
                      phenotype.groups = phenotype.groups,
                      selected.markers = selected.markers,
                      clustering.resolution = clustering.resolution,
                      variable.features = variable.features,
                      pc.count = pc.count,
                      outputPath = outputPath,
                      showSession = showSession,
                      pdf = pdf,
                      runHVG = runHVG,
                      plotHVG = plotHVG,
                      runDimRed = runDimRed,
                      plotJackStraw = plotJackStraw,
                      plotElbowPlot = plotElbowPlot,
                      plotHeatmaps = plotHeatmaps,
                      runClustering = runClustering,
                      plotTSNE = plotTSNE,
                      plotUMAP = plotUMAP,
                      minResolution = minResolution,
                      maxResolution = maxResolution,
                      runMSClusters = runMSClusters,
                      runMSBioGroup = runMSBioGroup,
                      forceRun = forceRun,
                      numTopFeatures = numTopFeatures
                    ),
                    output_file = outputFile,
                    output_dir = outputPath,
                    intermediates_dir = getwd(),
                    knit_root_dir = getwd())

  path <- paste0(outputPath, "SCE_SeuratReport", "-", gsub(" ", "_", Sys.Date()), ".rds")
  saveRDS(data, path)
  p <- paste0("SCE_SeuratReport", "-", gsub(" ", "_", Sys.Date()), ".rds")
  message("Output SCE object stored as ", p , " in ", outputPath, ".")
  message("Output HTML file stored as ", outputFile, " in ", outputPath, ".")

  return(data)
}

#' @title Get diffAbundanceFET .html report
#' @description A function to generate .html Rmarkdown report containing the visualizations of the diffAbundanceFET function output
#' @param inSCE A \code{\link[SingleCellExperiment]{SingleCellExperiment}}
#' object.
#' @param cluster A single \code{character}, specifying the name to store the
#' cluster label in \code{\link{colData}}.
#' @param variable A single \code{character}, specifying the name to store the
#' phenotype labels in \code{\link{colData}}.
#' @param control \code{character}. Specifying one or more categories that can
#' be found in the vector specified by \code{variable}.
#' @param case \code{character}. Specifying one or more categories that can
#' be found in the vector specified by \code{variable}.
#' @param analysisName A single \code{character}. Will be used for naming the
#' result table, which will be saved in metadata slot.
#' @param output_dir name of the output directory to save the rendered file. If
#' \code{NULL} the file is stored to the current working directory.
#' Default \code{NULL}.
#' @param output_file name of the generated file. If \code{NULL} then the output
#' file name will be based on the name of the Rmarkdown template. Default
#' \code{NULL}.
#' @param pdf A \code{logical} value indicating if a pdf should also be
#'  generated for each figure in the report. Default is \code{TRUE}.
#' @param showSession A \code{logical} value indicating if session information
#'  should be displayed or not. Default is \code{TRUE}.
#' @return An HTML file of the report will be generated at the path specified
#' in the arguments.
#' @export
reportDiffAbundanceFET <-
    function(inSCE,
             cluster,
             variable,
             control,
             case,
             analysisName,
             output_dir = ".",
             output_file = "DifferentialAbundanceFET_Report",
             pdf = FALSE,
             showSession = TRUE) {
        inSCE <- diffAbundanceFET(inSCE, cluster, variable, control,
                                  case, analysisName)
        rmarkdown::render(
            system.file("rmarkdown/DifferentialAbundanceFET_Report.Rmd",
                        package="singleCellTK"),
            params = list(
               sce = inSCE,
                analysisName = analysisName,
                pdf = isTRUE(pdf),
                showSession = isTRUE(showSession)
            ),
           output_file = output_file,
           output_dir = output_dir
        )
    }

#' @title Get plotClusterAbundance .html report
#' @description A function to generate .html Rmarkdown report containing the
#' visualizations of the plotClusterAbundance function output
#' @param inSCE A \code{\link[SingleCellExperiment]{SingleCellExperiment}}
#' object.
#' @param cluster A single \code{character}, specifying the name to store the
#' cluster label in \code{\link{colData}}.
#' @param variable A single \code{character}, specifying the name to store the
#' phenotype labels in \code{\link{colData}}.
#' @param output_dir name of the output directory to save the rendered file. If
#' \code{NULL} the file is stored to the current working directory.
#' Default \code{NULL}.
#' @param output_file name of the generated file. If \code{NULL} then the output
#' file name will be based on the name of the Rmarkdown template. Default
#' \code{NULL}.
#' @param pdf A \code{logical} value indicating if a pdf should also be
#'  generated for each figure in the report. Default is \code{TRUE}.
#' @param showSession A \code{logical} value indicating if session information
#'  should be displayed or not. Default is \code{TRUE}.
#' @return An HTML file of the report will be generated at the path specified
#' in the arguments.
#' @export
reportClusterAbundance <- function(inSCE,
                                   cluster,
                                   variable,
                                   output_dir = ".",
                                   output_file = "plotClusterAbundance_Report",
                                   pdf = FALSE,
                                   showSession = TRUE) {
    rmarkdown::render(
        system.file("rmarkdown/PlotClusterAbundance_Report.Rmd",
        package="singleCellTK"),
        params = list(
            sce = inSCE,
            cluster = cluster,
            variable = variable,
            pdf = isTRUE(pdf),
            showSession = isTRUE(showSession)
        ),
        output_file = output_file,
        output_dir = output_dir
    )
}

#' @rdname getSampleSummaryStatsTable
#' @importFrom S4Vectors metadata
setMethod("getSampleSummaryStatsTable", "SingleCellExperiment", function(inSCE, statsName, ...){
    allStatsNames <- listSampleSummaryStatsTables(inSCE)
    if(!statsName %in% allStatsNames){
        stop(paste(statsName, "is not a table within the SingleCellExperiment object.",
                   "The following are the names of the tables stored:",
                   paste(allStatsNames, collapse = ",")))
    }else{
        return(metadata(inSCE)$sctk$sample_summary[[statsName]])
    }
})

#' @rdname getSampleSummaryStatsTable
#' @importFrom S4Vectors metadata
setReplaceMethod("setSampleSummaryStatsTable", c("SingleCellExperiment", "ANY"), function(inSCE, statsName, ..., value) {
    metadata(inSCE)$sctk$sample_summary[[statsName]] <- value
    return(inSCE)
})

#' @rdname listSampleSummaryStatsTables
#' @importFrom S4Vectors metadata
setMethod("listSampleSummaryStatsTables", "SingleCellExperiment", function(inSCE, ...){
    if(is.null(metadata(inSCE)$sctk$sample_summary)){
        p <- paste("No sample-level QC tables are available.",
                   "Please try executing functions such as sampleSummaryStats first.")
        stop(p)
    }else{
        allStatsNames <- names(metadata(inSCE)$sctk$sample_summary)
        if(is.null(allStatsNames) || length(allStatsNames) == 0){
            paste("No sample-level QC tables are available.",
                "Please try executing functions such as sampleSummaryStats first.")
            stop(p)
        }else{
            return(names(metadata(inSCE)$sctk$sample_summary))
        }
    }
})

.sampleSummaryStats <- function(dataFrame, colName = "All Samples",
                                simple = TRUE){

    metrics <- c("Number of Cells")
    values <- c(as.integer(nrow(dataFrame)))

    if ("sum" %in% colnames(dataFrame)) {
        metrics <- c(metrics, "Mean counts", "Median counts")
        values <- c(values, mean(dataFrame$sum),
                    stats::median(dataFrame$sum))
    }

    if ("detected" %in% colnames(dataFrame)) {
        metrics <- c(
            metrics, "Mean features detected",
            "Median features detected"
        )
        values <- c(values, mean(dataFrame$detected),
                    stats::median(dataFrame$detected))
    }

    if(simple != TRUE){
        if ("dropletUtils_barcodeRank_knee" %in% colnames(dataFrame)) {
            metrics <- c(
                metrics, "BarcodeRank - Number of libraries above knee point"
            )
            values <- c(values, sum(dataFrame$dropletUtils_BarcodeRank_Knee))
        }

        if ("dropletUtils_barcodeRank_inflection" %in% colnames(dataFrame)) {
            metrics <- c(
                metrics, "BarcodeRank - Number of libraries above inflection point"
            )
            values <- c(values, sum(dataFrame$dropletUtils_BarcodeRank_Inflection))
        }

        if ("scrublet_call" %in% colnames(dataFrame)) {
            metrics <- c(
                metrics, "Scrublet - Number of doublets",
                "Scrublet - Percentage of doublets"
            )
            values <- c(values, sum(dataFrame$scrublet_call == TRUE),
                        signif(sum(dataFrame$scrublet_call == TRUE) / length(dataFrame$scrublet_call) * 100, 3)
            )
        }

        if ("scDblFinder_doublet_call" %in% colnames(dataFrame)) {
            metrics <- c(metrics, "scDblFinder - Number of doublets",
                         "scDblFinder - Percentage of doublets")
            values <- c(values, sum(dataFrame$scDblFinder_doublet_call == "Doublet"),
                        signif(sum(dataFrame$scDblFinder_doublet_call == "Doublet")/length(dataFrame$scDblFinder_doublet_call) * 100, 3))
        }

        if (any(grepl("doubletFinder_doublet_label_resolution",
                      colnames(dataFrame)))) {
            dfIx <- grep("doubletFinder_doublet_label_resolution",
                         colnames(dataFrame))
            for (ix in dfIx) {
                metrics <- c(metrics,
                             paste("DoubletFinder - Number of doublets, Resolution",
                                   gsub("doubletFinder_doublet_label_resolution_",
                                        "",
                                        colnames(dataFrame)[ix])),
                             paste("DoubletFinder - Percentage of doublets, Resolution",
                                   gsub("doubletFinder_doublet_label_resolution_",
                                        "",
                                        colnames(dataFrame)[ix])))
                values <- c(values,sum(dataFrame[, ix] == "Doublet"),
                            signif(sum(dataFrame[, ix] == "Doublet") / length(dataFrame[, ix]) * 100, 3))
            }
        }

        if("scds_cxds_call" %in% colnames(dataFrame)){
            metrics <- c(metrics, "CXDS - Number of doublets",
                         "CXDS - Percentage of doublets")
            values <- c(values, sum(dataFrame$scds_cxds_call == "Doublet"),
                        signif(sum(dataFrame$scds_cxds_call == "Doublet")/length(dataFrame$scds_cxds_call) * 100, 3))
        }

        if("scds_bcds_call" %in% colnames(dataFrame)){
            metrics <- c(metrics, "BCDS - Number of doublets",
                         "BCDS - Percentage of doublets")
            values <- c(values, sum(dataFrame$scds_bcds_call == "Doublet"),
                        signif(sum(dataFrame$scds_bcds_call == "Doublet")/length(dataFrame$scds_bcds_call) * 100, 3))
        }

        if("scds_hybrid_call" %in% colnames(dataFrame)){
            metrics <- c(metrics, "SCDS Hybrid - Number of doublets",
                         "SCDS Hybrid - Percentage of doublets")
            values <- c(values, sum(dataFrame$scds_hybrid_call == "Doublet"),
                        signif(sum(dataFrame$scds_hybrid_call == "Doublet")/length(dataFrame$scds_hybrid_call) * 100, 3))
        }

        if("decontX_clusters" %in% colnames(dataFrame)){
            metrics <- c(metrics, "DecontX - Mean contamination",
                         "DecontX - Median contamination")
            values <- c(values, signif(mean(dataFrame$decontX_contamination), 3),
                        signif(stats::median(dataFrame$decontX_contamination), 3))
        }
    }

    df <- matrix(values)
    rownames(df) <- metrics
    colnames(df) <- colName
    return(df)
}

#' @title Generate table of SCTK QC outputs.
#' @description  Creates a table of QC metrics generated from
#'  QC algorithms, which is stored within the metadata slot of the
#'  input SingleCellExperiment object.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object with saved
#' \link{assay} data and/or \link{colData} data. Required.
#' @param sample Character vector. Indicates which sample each cell belongs to.
#' @param useAssay  A string specifying which assay in the SCE to use. Default
#'  'counts'.
#' @param simple Boolean. Indicates whether to generate a table of only
#' basic QC stats (ex. library size), or to generate a summary table of all
#' QC stats stored in the inSCE.
#' @param statsName Character. The name of the slot that will store the
#' QC stat table. Default "qc_table".
#' @return A SingleCellExperiment object with a summary table for QC statistics
#' in the `sample_summary` slot of metadata.
#' @examples
#' data(scExample, package = "singleCellTK")
#' sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
#' sce <- sampleSummaryStats(sce, simple = TRUE)
#' getSampleSummaryStatsTable(sce, statsName = "qc_table")
#' @importFrom magrittr %>%
#' @export
sampleSummaryStats <- function(inSCE,
                               sample = NULL,
                               useAssay = "counts",
                               simple = TRUE,
                               statsName = "qc_table"){

    if (!is.null(sample)) {
        if(length(sample) == 1){
            if(length(which(colnames(
                SummarizedExperiment::colData(inSCE)) == sample))){
                sample = colnames(SummarizedExperiment::colData(inSCE))
            }else{
                stop("'sample' must be either stored in the colData",
                     "or the same length as the number of columns in 'inSCE'")
            }

        }else if (length(sample) != ncol(inSCE)) {
            stop(
                "'sample' must be the same length as the number",
                " of columns in 'inSCE'"
            )
        }

    } else {
        sample <- rep("Sample", ncol(inSCE))
    }

    samples <- unique(sample)

    if(any(!c("sum", "detected") %in% colnames(SummarizedExperiment::colData(inSCE)))){
        inSCE <- scater::addPerCellQC(inSCE)
    }

    # if(simple == FALSE){
    qcDataFrame <- SummarizedExperiment::colData(inSCE)
    dfTableAll <- .sampleSummaryStats(dataFrame = qcDataFrame, simple = simple)

    if(length(samples) > 1){
        forTable <- lapply(samples, function(x) {
            sampleInd <- which(sample == x)
            sampleSub <- sample[sampleInd]
            inSCESub <- inSCE[, sampleInd]
            qcDataFrame <- SummarizedExperiment::colData(inSCESub)
            df <- .sampleSummaryStats(dataFrame = qcDataFrame, colName = x,
                                      simple = simple)
            return(df)
        })
        dfTableSample <- do.call(cbind, forTable)
        dfTableRes <- cbind(dfTableSample, dfTableAll)
    }else{
        dfTableRes <- dfTableAll
    }

    dfTableRes <- as.data.frame(dfTableRes)

    dfTableRes <- apply(dfTableRes, seq(2), function(x){
        return((signif(x,5)))
    })

    setSampleSummaryStatsTable(inSCE, statsName = statsName) <- dfTableRes
    return(inSCE)
}

.searchBCDefaultInfo <- function(inSCE, corrMat, origAssay, matType) {
  if (is.null(origAssay)) {
    if ("counts" %in% expDataNames(inSCE)) {
      origAssay <- "counts"
    } else {
      origAssay <- expDataNames(inSCE)[1]
    }
    warning("using '", origAssay, "' for comparison.")
  }

  if (is.null(matType)) {
    if (corrMat %in% SummarizedExperiment::assayNames(inSCE)) {
      matType <- "assay"
    } else if (corrMat %in% SingleCellExperiment::altExpNames(inSCE)) {
      matType <- "altExp"
    } else if (corrMat %in% SingleCellExperiment::reducedDimNames(inSCE)) {
      matType <- "reducedDim"
    } else {
      stop("Corrected Matrix name '", corrMat, "' not found in inSCE")
    }
  }

  return(c(origAssay, matType))
}

.checkBCMeta <- function(inSCE, corrMat, origAssay, origLogged, method, matType,
                         batch, condition) {
  if (!is.null(matType)) {
    if (!matType %in% c("assay", "altExp", "reducedDim")) {
      stop("Wrong matrix type '", matType, "'. Choose from 'assay', 'altExp', ",
           "'reducedDim'.")
    }
  }
  if (!"batchCorr" %in% names(S4Vectors::metadata(inSCE))) {
    warning("Batch correction result from SCTK not found.")
    s <- .searchBCDefaultInfo(inSCE, corrMat, origAssay, matType)
    origAssay <- ifelse(is.null(origAssay), s[1], origAssay)
    method <- ifelse(is.null(method), "Unidentified Method", method)
    matType <- ifelse(is.null(matType), s[2], matType)
  } else {
    if (!corrMat %in% names(S4Vectors::metadata(inSCE)$batchCorr)) {
      warning("'", corrMat, "' not identified as a Batch correction result ",
              "from SCTK")
      s <- .searchBCDefaultInfo(inSCE, corrMat, origAssay, matType)
      origAssay <- ifelse(is.null(origAssay), s[1], origAssay)
      method <- ifelse(is.null(method), "Unidentified Method", method)
      matType <- ifelse(is.null(matType), s[2], matType)
    } else {
      bcInfo <- S4Vectors::metadata(inSCE)$batchCorr[[corrMat]]
      origAssay <- ifelse(is.null(origAssay), bcInfo$useAssay, origAssay)
      origLogged <- ifelse(is.null(origLogged), bcInfo$origLogged, origLogged)
      method <- ifelse(is.null(method), bcInfo$method, method)
      if (!is.null(matType) && matType != bcInfo$matType) {
        warning("User specified matType different from SCTK identified ",
                "matType. Force using user specification.")
      }
      matType <- ifelse(is.null(matType), bcInfo$matType, matType)
      if (is.null(batch)) batch <- bcInfo$batch
      if (is.null(condition)) condition <- bcInfo$condition
    }
  }
  return(list(origAssay = origAssay,
              origLogged = origLogged,
              method = method,
              matType = matType,
              batch = batch,
              condition = condition))
}

#' Plot comparison of batch corrected result against original assay
#' @details Four plots will be combined. Two of them are violin/box-plots for
#' percent variance explained by the batch variation, and optionally the
#' covariate, for original and corrected. The other two are UMAPs of the
#' original assay and the correction result matrix. If SCTK batch correction
#' methods are performed in advance, this function will automatically detect
#' necessary input. Otherwise, users can also customize the input. Future
#' improvement might include solution to reduce redundant UMAP calculation.
#' @param inSCE \linkS4class{SingleCellExperiment} inherited object.
#' @param corrMat A single character indicating the name of the corrected matrix.
#' @param batch A single character. The name of batch annotation column in
#' \code{colData(inSCE)}.
#' @param condition A single character. The name of an additional covariate
#' annotation column in \code{colData(inSCE)}.
#' @param origAssay A single character indicating what the original assay used
#' for batch correction is.
#' @param origLogged Logical scalar indicating whether \code{origAssay} is
#' log-normalized.
#' @param method A single character indicating the name of the batch correction
#' method. Only used for the titles of plots.
#' @param matType A single character indicating the type of the batch correction
#' result matrix, choose from \code{"assay"}, \code{"altExp"},
#' \code{"reducedDim"}.
#' @return An object of class \code{"gtable"}, combining four \code{ggplot}s.
#' @examples
#' data("sceBatches")
#' logcounts(sceBatches) <- log1p(counts(sceBatches))
#' sceBatches <- runLimmaBC(sceBatches)
#' plotBatchCorrCompare(sceBatches, "LIMMA", condition = "cell_type")
#' @export
#' @author Yichen Wang
plotBatchCorrCompare <- function(inSCE, corrMat, batch = NULL, condition = NULL,
                                 origAssay = NULL, origLogged = NULL,
                                 method = NULL, matType = NULL) {
  if(!inherits(inSCE, "SingleCellExperiment")){
    stop("\"inSCE\" should be a SingleCellExperiment Object.")
  }
  m <- .checkBCMeta(inSCE, corrMat, origAssay, origLogged, method, matType,
                    batch, condition)
  origAssay <- m$origAssay
  origLogged <- m$origLogged
  method <- m$method
  matType <- m$matType
  batch <- m$batch
  condition <- m$condition

  if (isFALSE(origLogged)) {
    inSCE <- scaterlogNormCounts(inSCE, origAssay, origAssay)
  }

  # Batch Variance Plot for origAssay
  bv.before <- plotBatchVariance(inSCE, useAssay = origAssay, useReddim = NULL,
                                 useAltExp = NULL, batch = batch,
                                 condition = condition,
                                 title = "Batch Variance before correction") +
    ggplot2::theme(text=ggplot2::element_text(size=10))

  inSCE <- runUMAP(inSCE, useAssay = origAssay, useReducedDim = NULL, initialDims = 25,
                   reducedDimName = "umap.before")
  umap.before <- plotSCEDimReduceColData(inSCE, batch, "umap.before",
                                         shape = condition, axisLabelSize = 9,
                                         axisSize = 8, dotSize = 1,
                                         titleSize = 12, labelClusters = FALSE,
                                         legendSize = 10, legendTitle = "batch",
                                         legendTitleSize = 10,
                                         title = "UMAP before correction")

  if (matType == "assay") {
    if (isFALSE(origLogged)) {
      inSCE <- scaterlogNormCounts(inSCE, corrMat, corrMat)
    }
    # Batch Variance Plot for CorrMat
    bv.after <- plotBatchVariance(inSCE, useAssay = corrMat, batch = batch,
                                  condition = condition,
                                  title = paste0("Batch Variance corrected with ",
                                                 method)) +
      ggplot2::theme(text=ggplot2::element_text(size=10))

    if (method == "ComBatSeq") {
      inSCE <- runUMAP(inSCE, useAssay = corrMat, useReducedDim = NULL, initialDims = 25,
                       logNorm = TRUE, reducedDimName = "umap.after")
    } else {
      inSCE <- runUMAP(inSCE, useAssay = corrMat, useReducedDim = NULL, initialDims = 25,
                       logNorm = FALSE, reducedDimName = "umap.after")
    }
  } else if (matType == "altExp") {
    # Doing log, because only Seurat returns altExp,
    # and the assay inside is not logged
    ae <- SingleCellExperiment::altExp(inSCE, corrMat)
    ae <- scaterlogNormCounts(ae, corrMat, corrMat)
    SingleCellExperiment::altExp(inSCE, corrMat) <- ae
    bv.after <- plotBatchVariance(inSCE, useAltExp = corrMat, batch = batch,
                                  condition = condition,
                                  title = paste0("Batch Variance corrected with ",
                                                 method)) +
      ggplot2::theme(text=ggplot2::element_text(size=10))
    inSCE <- runQuickUMAP(inSCE, useAssay = corrMat, useAltExp = corrMat, 
                          reducedDimName = "umap.after")
  } else if (matType == "reducedDim") {
    bv.after <- plotBatchVariance(inSCE, useReddim = corrMat, batch = batch,
                                  condition = condition,
                                  title = paste0("Batch Variance corrected with ",
                                                 method)) +
      ggplot2::theme(text=ggplot2::element_text(size=10))
    if (method == "BBKNN") {
      SingleCellExperiment::reducedDim(inSCE, "umap.after") <-
        SingleCellExperiment::reducedDim(inSCE, corrMat)
    } else {
      inSCE <- runUMAP(inSCE, useReducedDim = corrMat, initialDims = 25,
                       reducedDimName = "umap.after")
    }
  } else {
    stop("Cannot identify result matrix type")
  }
  umap.after <- plotSCEDimReduceColData(inSCE, batch, "umap.after", dim1 = 1,
                                        dim2 = 2,
                                        shape = condition, axisLabelSize = 9,
                                        axisSize = 8, dotSize = 1,
                                        titleSize = 12, labelClusters = FALSE,
                                        legendSize = 10, legendTitle = "batch",
                                        legendTitleSize = 10,
                                        title = "UMAP after correction") +
    ggplot2::theme(text=ggplot2::element_text(size=8))
  return(gridExtra::grid.arrange(bv.before, bv.after,
                                 umap.before, umap.after, nrow = 2))
}

#' Plot the percent of the variation that is explained by batch and condition
#' in the data
#'
#' Visualize the percent variation in the data that is explained by batch and
#' condition, individually, and that explained by combining both annotations.
#' Plotting only the variation explained by batch is supported but not
#' recommended, because this can be confounded by potential condition.
#'
#' When condition and batch both are causing some variation, if the difference
#' between full variation and condition variation is close to batch variation,
#' this might imply that batches are causing some effect; if the difference is
#' much less than batch variation, then the batches are likely to be confounded
#' by the conditions.
#'
#' @param inSCE \linkS4class{SingleCellExperiment} inherited object.
#' @param useAssay A single character. The name of the assay that stores the
#' value to plot. For \code{useReddim} and \code{useAltExp} also. Default
#' \code{NULL}.
#' @param useReddim A single character. The name of the dimension reduced
#' matrix that stores the value to plot. Default \code{NULL}.
#' @param useAltExp A single character. The name of the alternative experiment
#' that stores an assay of the value to plot. Default \code{NULL}.
#' @param batch A single character. The name of batch annotation column in
#' \code{colData(inSCE)}. Default \code{"batch"}.
#' @param condition A single character. The name of an additional condition
#' annotation column in \code{colData(inSCE)}. Default \code{NULL}.
#' @param title A single character. The title text on the top. Default
#' \code{NULL}.
#' @return A ggplot object of a boxplot of variation explained by batch,
#' condition, and batch+condition.
#' @export
#' @examples
#' data('sceBatches', package = 'singleCellTK')
#' plotBatchVariance(sceBatches,
#'                   useAssay="counts",
#'                   batch="batch",
#'                   condition = "cell_type")
plotBatchVariance <- function(inSCE, useAssay = NULL, useReddim = NULL,
                              useAltExp = NULL, batch = 'batch',
                              condition = NULL, title = NULL) {
  useMat <- .selectSCEMatrix(inSCE, useAssay = useAssay,
                             useReducedDim = useReddim, useAltExp = useAltExp,
                             returnMatrix = TRUE, cellAsCol = TRUE)
  mat <- useMat$mat
  if(is.null(batch)){
    stop("Batch annotation has to be given.")
  }
  batchCol <- .manageCellVar(inSCE, var = batch, as.factor = TRUE)
  if(!inherits(mat, 'matrix')){
    mat <- as.matrix(mat)
  }
  nlb <- nlevels(batchCol)
  if (nlb <= 1){
    stop("No more than one batch found in specified annotation")
  } else {
    batchMod <- stats::model.matrix(~batchCol)
  }
  if (is.null(condition)){
    condMod <- matrix(rep(1, ncol(mat)), ncol = 1)
  } else {
    condCol <- .manageCellVar(inSCE, var = condition, as.factor = TRUE)
    nlc <- nlevels(condCol)
    if (nlc <= 1){
      condMod <- matrix(rep(1, ncol(mat)), ncol = 1)
    } else {
      condMod <- stats::model.matrix(~condCol)
    }
  }
  mod <- cbind(condMod, batchMod[, -1])
  condTest <- .batchqc_f.pvalue(mat, mod, batchMod)
  batchTest <- .batchqc_f.pvalue(mat, mod, condMod)
  r2Full <- condTest$r2Full
  condR2 <- batchTest$r2Reduced
  batchR2 <- condTest$r2Reduced
  explainedVariation <- round(cbind(`Full (Condition+Batch)` = r2Full,
                                     Condition = condR2,
                                     Batch = batchR2), 5) * 100
  colnames(explainedVariation) <- c("Full",
                                    ifelse(is.null(condition), "No Condition", condition),
                                    batch)
  exVarM <- reshape2::melt(explainedVariation)
  colnames(exVarM) <- c("Gene", "Model", "Percent.Explained.Variation")
  exVarM$Model <- factor(exVarM$Model)
  a <- ggplot2::ggplot(exVarM,
                       ggplot2::aes_string("Model",
                                           "Percent.Explained.Variation")) +
    ggplot2::geom_point(position = ggplot2::position_jitter(width = 0.2),
                        size = 1, alpha = 0.9) +
    ggplot2::geom_violin(ggplot2::aes_string(fill = "Model"), alpha = 0.7, ) +
    ggplot2::geom_boxplot(alpha = 0.4, width = 0.2) +
    ggplot2::ylim(0, 100) +
    ggplot2::xlab("Model") +
    ggplot2::ylab("Explained Variation %") +
    ggplot2::ggtitle(title) +
    ggplot2::theme_bw() +
    ggplot2::theme(legend.position = "none",
                   panel.grid.major = ggplot2::element_blank(),
                   panel.grid.minor = ggplot2::element_blank())
  return(a)
}

.batchqc_f.pvalue <- function(dat, mod, mod0) {
  # F-test (full/reduced model) and returns R2 values
  # (full/reduced) as well.
  mod00 <- matrix(rep(1, ncol(dat)), ncol = 1)
  n <- dim(dat)[2]
  m <- dim(dat)[1]
  df1 <- dim(mod)[2]
  df0 <- dim(mod0)[2]
  p <- rep(0, m)

  resid <- dat - dat %*% mod %*% solve(t(mod) %*% mod) %*% t(mod)
  rss1 <- rowSums(resid * resid)
  rm(resid)

  resid0 <- dat - dat %*% mod0 %*% solve(t(mod0) %*% mod0) %*% t(mod0)
  rss0 <- rowSums(resid0 * resid0)
  rm(resid0)

  resid00 <- dat - dat %*% mod00 %*% solve(t(mod00) %*% mod00) %*% t(mod00)
  rss00 <- rowSums(resid00 * resid00)
  rm(resid00)

  r2Full <- 1 - rss1 / rss00
  r2Reduced <- 1 - rss0 / rss00

  p <- 1
  if (df1 > df0)  {
    fstats <- ((rss0 - rss1) / (df1 - df0)) / (rss1 / (n - df1))
    p <- 1 - stats::pf(fstats, df1 = (df1 - df0), df2 = (n - df1))
  }
  return(list(p = p, r2Full = r2Full, r2Reduced = r2Reduced))
}

#' Plot mean feature value in each batch of a SingleCellExperiment object
#' @param inSCE \linkS4class{SingleCellExperiment} inherited object.
#' @param useAssay A single character. The name of the assay that stores the
#' value to plot. For \code{useReddim} and \code{useAltExp} also. Default
#' \code{NULL}.
#' @param useReddim A single character. The name of the dimension reduced
#' matrix that stores the value to plot. Default \code{NULL}.
#' @param useAltExp A single character. The name of the alternative experiment
#' that stores an assay of the value to plot. Default \code{NULL}.
#' @param batch A single character. The name of batch annotation column in
#' \code{colData(inSCE)}. Default \code{"batch"}.
#' @param xlab label for x-axis. Default \code{"batch"}.
#' @param ylab label for y-axis. Default \code{"Feature Mean"}.
#' @param ... Additional arguments passed to \code{.ggViolin}.
#' @examples
#' data('sceBatches', package = 'singleCellTK')
#' plotSCEBatchFeatureMean(sceBatches, useAssay = "counts")
#' @return ggplot
#' @export
plotSCEBatchFeatureMean <- function(inSCE, useAssay = NULL, useReddim = NULL,
  useAltExp = NULL, batch = 'batch', xlab='batch', ylab='Feature Mean', ...){
  if(!inherits(inSCE, 'SingleCellExperiment')){
    stop("'inSCE' must inherit from 'SingleCellExperiment'.")
  }
  if(is.null(useAssay) + is.null(useReddim) + is.null(useAltExp) != 2){
    stop("One and only one of `useAssay`, `useReddim`, ",
         "`usAltExp` has to be specified.")
  }
  if(!is.null(useAssay)){
    if(!useAssay %in% SummarizedExperiment::assayNames(inSCE)){
      stop("'useAssay' not found in 'inSCE'.")
    }
    mat <- SummarizedExperiment::assay(inSCE, useAssay)
  }
  if(!is.null(useReddim)){
    if(!useReddim %in% SingleCellExperiment::reducedDimNames(inSCE)){
      stop("'useReddim not found in 'inSCE'.")
    }
    mat <- t(SingleCellExperiment::reducedDim(inSCE, useReddim))
  }
  if(!is.null(useAltExp)){
    if(!useAltExp %in% SingleCellExperiment::altExpNames(inSCE)){
      stop("'useAltExp not found in 'inSCE'.")
    }
    ae <- SingleCellExperiment::altExp(inSCE, useAltExp)
    mat <- SummarizedExperiment::assay(ae)
  }
  if(is.null(batch)){
    stop("Batch annotation has to be given.")
  } else{
    if(!batch %in% names(SummarizedExperiment::colData(inSCE))){
      stop("'batch' not found in 'inSCE'.")
    }
  }
  if(!inherits(mat, 'matrix')){
    mat <- as.matrix(mat)
  }
  batchCol <- SummarizedExperiment::colData(inSCE)[[batch]]
  uniqBatch <- as.vector(unique(batchCol)) #as.vector in case batchCol is factor
  allMeans <- numeric()
  groupBy <- character()
  for(i in uniqBatch){
    allMeans <- c(allMeans, DelayedArray::rowMeans(mat[,batchCol == i]))
    groupBy <- c(groupBy, rep(i, nrow(mat)))
  }
  p <- .ggViolin(allMeans, groupBy = groupBy, xlab = xlab, ylab = ylab, ...)
  p <- .ggSCTKTheme(p)
  return(p)
}

# User Interface for Scanpy Workflow ---
shinyPanelScanpy <- fluidPage(
    tags$script("Shiny.addCustomMessageHandler('close_dropDownScanpy', function(x){
                  $('html').click();
                });"), # close_dropDownSeuratHM
    h1("Scanpy"),
    h5(tags$a(href = paste0(docs.artPath, "cnsl_scanpy_curated_workflow.html"), #cnsl_seurat_curated_workflow.html
              "(help)", target = "_blank")),
    inlineCSS(list(".panel-danger>.panel-heading" = "background-color:#dcdcdc; color:#000000", ".panel-primary>.panel-heading" = "background-color:#f5f5f5; color:#000000; border-color:#dddddd", ".panel-primary" = "border-color:#dddddd;", ".panel-primary>.panel-heading+.panel-collapse>.panel-body" = "border-color:#dddddd;")),
    conditionalPanel(
        condition = "false",
        selectInput(
            "activePanelSelectScanpy", #activePanelSelectSeurat
            label = "Active Panel:",
            choices = c("",
                        "Normalize Data",
                        "Highly Variable Genes",
                        "Dimensionality Reduction",
                        "tSNE/UMAP",
                        "Clustering",
                        "Find Markers",
                        "Heatmap Plot"),
            selected = ""
        )
    ),
    bsCollapse(id = "ScanpyUI", open = "scanpy QC & Filtering", # ScanPy
            bsCollapsePanel("Normalize Data",
                                                                   fluidRow(
                                                                     column(4,
                                                                            panel(heading = "Options",
                                                                                  selectizeInput(
                                                                                    inputId = "scanpySelectNormalizationAssay", # seuratSelectNormalizationAssay
                                                                                    label = "Select input matrix:",
                                                                                    choices = NULL,
                                                                                    selected = NULL,
                                                                                    multiple = FALSE,
                                                                                    options = NULL),
                                                                                  numericInput(inputId = "scanpy_targetSum", label = "Specify targetSum:", value = 10000),
                                                                                  numericInput(inputId = "scanpy_maxFraction", label = "Specify maxFraction:", value = 0.05),
                                                                                  actionButton(inputId = "scanpy_normalize_button", "Normalize") # normalize_button
                                                                            )
                                                                     )
                                                                   ),
                                                                   style = "primary"
            ),
            bsCollapsePanel("Highly Variable Genes",
                            fluidRow(
                              column(4,
                                     fluidRow(
                                       column(12,
                                              panel(heading = "Compute HVG",
                                                    selectInput(inputId = "scanpy_hvg_method", label = "Select HVG method: ", choices = c("seurat", "cell_ranger", "seurat_v3")), # hvg_method
                                                    numericInput(inputId = "scanpy_hvg_no_features", label = "Select number of features to find: ", value = "2000"), # hvg_no_features
                                                    numericInput(inputId = "scanpy_minMean", label = "Specify minMean: ", value = "0.0125"),
                                                    numericInput(inputId = "scanpy_maxMean", label = "Specify maxMean: ", value = "3"),
                                                    numericInput(inputId = "scanpy_minDisp", label = "Specify minDisp: ", value = "0.5"),
                                                    checkboxInput(inputId = "scanpy_maxDisp_Inf", label = "Set maxDisp to infinite?", value = TRUE),
                                                    conditionalPanel(
                                                      condition = 'input.scanpy_maxDisp_Inf == false',
                                                    numericInput(inputId = "scanpy_maxDisp", label = "Specify maxDisp: ", value = 3)
                                                    ),
                                                    actionButton(inputId = "scanpy_find_hvg_button", "Find HVG") # find_hvg_button
                                              )
                                       )
                                     )
                                     # ,
                                     # br(),
                                     # fluidRow(
                                     #   column(12,
                                     #          panel(heading = "Display HVG",
                                     #                numericInput(inputId = "scanpy_hvg_no_features_view", label = "Select number of features to display: ", value = 10, step = 1), # hvg_no_features_view
                                     #                verbatimTextOutput(outputId = "scanpy_hvg_output", placeholder = TRUE) # hvg_output
                                     #          )
                                     #   )
                                     # )
                              ),
                              column(8,
                                     fluidRow(
                                       column(12,
                                              panel(heading = "Plot",
                                                    plotOutput(outputId = "scanpy_plot_hvg") # plot_hvg
                                              )
                                       )
                                     )
                              )
                            ),
                            style = "primary"
            ),
            bsCollapsePanel("Dimensionality Reduction",
                            fluidRow(
                              column(4,
                                     fluidRow(
                                       column(12,
                                              panel(heading = "scanpy PCA",
                                                    selectInput(inputId = "scanpy_pca_method", label = "Select PCA method: ", choices = c("arpack", "randomized", "auto", "lobpcg")),
                                                    numericInput(inputId = "scanpy_pca_no_components", label = "Select number of components to compute: ", value = 50), # pca_no_components
                                                    actionButton(inputId = "scanpy_run_pca_button", "Run PCA")
                                              ),
                                              panel(heading = "Select No. of Components",
                                                    htmlOutput(outputId = "scanpy_pca_significant_pc_output", inline = FALSE),
                                                    numericInput(inputId = "scanpy_pca_significant_pc_counter", label = "Select number of components for downstream analysis: ", min = 1, max = 50, value = 40)
                                              )
                                       )
                                     )
                              ),
                              column(8,
                                     fluidRow(
                                       column(12,
                                              hidden(
                                                tags$div(class = "scanpy_pca_plots", tabsetPanel(id = "scanpyPCAPlotTabset", type = "tabs"
                                                )
                                                ))
                                       )
                                       
                                     )
                              )
                            ),
                            style = "primary"
            ),
            bsCollapsePanel("2D-Embedding",
                            tabsetPanel(id = "tsneUmapTabsetScanpy", type = "tabs",
                                        tabPanel("UMAP",
                                                 br(),
                                                 fluidRow(
                                                   column(4,
                                                          fluidRow(
                                                            column(12,
                                                                   panel(heading = "UMAP",
                                                                         #selectInput(inputId = "scanpy_reduction_umap_method", label = "Select reduction method: ", choices = c("pca", "ica")),
                                                                         #numericInput(inputId = "scanpy_reduction_umap_count", label = "Select number of reduction components: ", value = 50),
                                                                         numericInput(inputId = "scanpy_min_dist_umap", label = "Set min.dist:", value = 0.5),
                                                                         numericInput(inputId = "scanpy_n_neighbors_umap", label = "Set n.neighbors:", value = 10, step = 1),
                                                                         numericInput(inputId = "scanpy_spread_umap", label = "Set spread:", value = 1),
                                                                         numericInput(inputId = "scanpy_spread_alpha", label = "Set alpha:", value = 1),
                                                                         numericInput(inputId = "scanpy_spread_gamma", label = "Set gamma:", value = 1),
                                                                         # numericInput(inputId = "scanpy_seed_UMAP",
                                                                         #              label = "Seed value for reproducibility of result:",
                                                                         #              value = 42,
                                                                         #              step = 1),
                                                                         # htmlOutput(outputId = "scanpy_display_message_umap", inline = FALSE),
                                                                         actionButton(inputId = "scanpy_run_umap_button", "Run UMAP")
                                                                   )
                                                            )
                                                          )
                                                   ),
                                                   column(8,
                                                          fluidRow(
                                                            panel(heading = "Plot",
                                                                  column(12,
                                                                         plotOutput(outputId = "scanpy_plot_umap")
                                                                  )
                                                            )
                                                          )
                                                   )
                                                 )
                                        ),
                                        tabPanel("tSNE",
                                                 br(),
                                                 fluidRow(
                                                   column(4,
                                                          fluidRow(
                                                            column(12,
                                                                   panel(heading = "tSNE",
                                                                         selectInput(inputId = "scanpy_reduction_tsne_method", label = "Select reduction method: ", choices = c("pca", "ica")),
                                                                         #textInput(inputId = "reduction_tsne_count", label = "Select number of reduction components: ", value = "20"),
                                                                         numericInput(inputId = "scanpy_perplexity_tsne", label = "Set perplexity:", value = 15),
                                                                         # numericInput(inputId = "scanpy_seed_TSNE",
                                                                         #              label = "Seed value for reproducibility of result:",
                                                                         #              value = 1,
                                                                         #              step = 1),
                                                                         # htmlOutput(outputId = "scanpy_display_message_tsne", inline = FALSE),
                                                                         actionButton(inputId = "scanpy_run_tsne_button", "Run tSNE")
                                                                   )
                                                            )
                                                          )
                                                   ),
                                                   column(8,
                                                          fluidRow(
                                                            panel(heading = "Plot",
                                                                  column(12,
                                                                         plotOutput(outputId = "scanpy_plot_tsne")
                                                                  )
                                                            )
                                                          )
                                                   )
                                                 )
                                        )
                            ),
                            style = "primary"
            ),
            bsCollapsePanel("Clustering",
                            fluidRow(
                              column(4,
                                     fluidRow(
                                       column(12,
                                              panel(heading = "Options",
                                                    #selectInput(inputId = "scanpy_reduction_clustering_method", label = "Select reduction method: ", choices = c("pca", "ica")),
                                                    #numericInput(inputId = "scanpy_reduction_clustering_count", label = "Select number of reduction components: ", value = 40),
                                                    selectInput(inputId = "scanpy_algorithm.use", label = "Select clustering algorithm: ", choices = list("leiden algorithm" = "leiden", 
                                                                                                                                                          "louvain algorithm" = "louvain")),
                                                    numericInput(inputId = "scanpy_resolution_clustering", label = "Set resolution:", value = 1),
                                                    numericInput(inputId = "scanpy_nNeighbors", label = "Set no. of neigbours:", value = 10),
                                                    # materialSwitch(inputId = "scanpy_group.singletons", label = "Group singletons?", value = TRUE),
                                                    # htmlOutput(outputId = "scanpy_display_message_clustering", inline = FALSE),
                                                    selectInput(inputId = "scanpy_corr_method", label = "Select correlation metric: ", choices = list("pearson" = "pearson",
                                                                                                                                                          "kendall" = "kendall",
                                                                                                                                                        "spearman" = "spearman")),
                                                    actionButton(inputId = "scanpy_find_clusters_button", "Find Clusters")
                                              )
                                       )
                                     )
                              ),
                              column(8,
                                     fluidRow(
                                       column(12,
                                              hidden(
                                                tags$div(class = "scanpy_clustering_plots", tabsetPanel(id = "scanpyClusteringPlotTabset", type = "tabs"
                                                ))
                                              )
                                       )
                                       
                                     )
                              )
                            ),
                            style = "primary"),
            bsCollapsePanel("Find Markers",
                            fluidRow(
                              column(4,
                                     fluidRow(
                                       column(12,
                                              panel(heading = "Options",
                                                    selectInput(
                                                      inputId = "scanpyFindMarkerSelectPhenotype",
                                                      label = "Select biological phenotype:",
                                                      choices = NULL
                                                    ),
                                                    selectInput(
                                                      inputId = "scanpyFindMarkerTest",
                                                      label = "Select test:",
                                                      choices = c("wilcoxon", "t-test", "t-test_overestim_var", "logreg")
                                                    ),
                                                    selectInput(
                                                      inputId = "scanpyFindMarkerCorrMethod",
                                                      label = "Multiple testing correction method:",
                                                      choices = c("benjamini-hochberg", "bonferroni")
                                                    ),
                                                    actionButton(inputId = "scanpyFindMarkerRun", "Find Markers")
                                              )
                                       )
                                     )
                              ),
                              column(8,
                                     fluidRow(
                                       column(12,
                                              hidden(
                                                tags$div(
                                                  class = "scanpy_findmarker_table",
                                                  filterTableUI(id = "filterScanpyFindMarker")
                                                )
                                              ),
                                              br(),
                                              hidden(
                                                tags$div(class = "scanpy_findmarker_jointHeatmap",
                                                         bsCollapse(
                                                           bsCollapsePanel(
                                                             title = "Heatmap Plot",
                                                             fluidRow(
                                                               column(12, align = "center",
                                                                      panel(
                                                                        numericInput("scanpy_findMarkerHeatmapPlotFullNumeric", value = 2, max = 2000, min = 2, step = 1, label = "Select number of top genes from each cluster/group to visualize in the heatmap below based on highest average log fold change value:"),
                                                                        actionButton("scanpy_findMarkerHeatmapPlotFullNumericRun", label = "Plot"),
                                                                        hr(),
                                                                        shinyjqui::jqui_resizable(
                                                                          plotOutput(outputId = "scanpy_findMarkerHeatmapPlotFull", height = "500px")
                                                                        )
                                                                      )
                                                               )
                                                             )
                                                           )
                                                         )
                                                )
                                              ),
                                              br(),
                                              hidden(
                                                tags$div(class = "scanpy_findmarker_plots",
                                                         panel(heading = "Marker Gene Plots",
                                                               HTML("<center><h5><span style='color:red; font-weight:bold; text-align:center;'>Click on the rows of the table above to plot the selected marker genes below!</span></h5></br></center>"),
                                                               tabsetPanel(id = "scanpyFindMarkerPlotTabset", type = "tabs"))
                                                )
                                              )
                                       )
                                       
                                     )
                              )
                            ),
                            style = "primary")
       ),
    nonLinearWorkflowUI(id = "nlw-scanpy") #nlw-seurat
    )

# User Interface for Seurat Workflow ---
shinyPanelSeurat <- fluidPage(
    tags$script("Shiny.addCustomMessageHandler('close_dropDownSeuratHM', function(x){
                  $('html').click();
                });"),
    h1("Seurat"),
    h5(tags$a(href = paste0(docs.artPath, "cnsl_seurat_curated_workflow.html"),
              "(help)", target = "_blank")),
    inlineCSS(list(".panel-danger>.panel-heading" = "background-color:#dcdcdc; color:#000000", ".panel-primary>.panel-heading" = "background-color:#f5f5f5; color:#000000; border-color:#dddddd", ".panel-primary" = "border-color:#dddddd;", ".panel-primary>.panel-heading+.panel-collapse>.panel-body" = "border-color:#dddddd;")),
    conditionalPanel(
        condition = "false",
        selectInput(
            "activePanelSelectSeurat",
            label = "Active Panel:",
            choices = c("",
                        "Normalize Data",
                        "Scale Data",
                        "Highly Variable Genes",
                        "Dimensionality Reduction",
                        "tSNE/UMAP",
                        "Clustering",
                        "Find Markers",
                        "Heatmap Plot"),
            selected = ""
        )
    ),
    bsCollapse(id = "SeuratUI", open = "Normalize Data",
            bsCollapsePanel("Normalize Data",
                fluidRow(
                    column(4,
                        panel(heading = "Options",
                              selectizeInput(
                                  inputId = "seuratSelectNormalizationAssay",
                                  label = "Select input matrix:",
                                  choices = NULL,
                                  selected = NULL,
                                  multiple = FALSE,
                                  options = NULL),
                            #uiOutput("seuratSelectNormalizationAssay"),
                            selectInput(inputId = "normalization_method", label = "Select normalization method: ", choices = c("LogNormalize", "CLR", "RC")),
                            textInput(inputId = "scale_factor", label = "Set scaling factor: ", value = "10000"),
                            actionButton(inputId = "normalize_button", "Normalize")
                             )
                          )
                        ),
                            style = "primary"
                            ),

            bsCollapsePanel("Highly Variable Genes",
                fluidRow(
                    column(4,
                        fluidRow(
                            column(12,
                                panel(heading = "Compute HVG",
                                    selectInput(inputId = "hvg_method", label = "Select HVG method: ", choices = c("vst", "mean.var.plot", "dispersion")),
                                    textInput(inputId = "hvg_no_features", label = "Select number of features to find: ", value = "2000"),
                                    actionButton(inputId = "find_hvg_button", "Find HVG")
                                     )
                                  )
                                ),
                        br(),
                        fluidRow(
                            column(12,
                                panel(heading = "Display HVG",
                                    numericInput(inputId = "hvg_no_features_view", label = "Select number of features to display: ", value = 10, step = 1),
                                    verbatimTextOutput(outputId = "hvg_output", placeholder = TRUE)
                                     )
                                  )
                                )
                          ),
                     column(8,
                        fluidRow(
                            column(12,
                                panel(heading = "Plot",
                                    plotlyOutput(outputId = "plot_hvg")
                                     )
                                  )
                                )
                           )
                    ),
                    style = "primary"),

            # bsCollapsePanel("Scale Data",
            #                 fluidRow(
            #                   column(4,
            #                          panel(heading = "Options",
            #                                #selectInput(inputId = "model.use", label = "Select model for scaling: ", choices = c("linear", "poisson", "negbinom")),
            #                                materialSwitch(inputId = "do.scale", label = "Scale data?", value = TRUE),
            #                                materialSwitch(inputId = "do.center", label = "Center data?", value = TRUE),
            #                                textInput(inputId = "scale.max", label = "Max value for scaled data: ", value = "10"),
            #                                actionButton(inputId = "scale_button", "Scale")
            #                          )
            #                   )
            #                 ),
            #                 style = "primary"
            # ),

            bsCollapsePanel("Dimensionality Reduction",
                tabsetPanel(type = "tabs",
                    tabPanel("PCA",
                        br(),
                        fluidRow(
                            column(4,
                                fluidRow(
                                    column(12,
                                        panel(heading = "PCA",
                                            numericInput(inputId = "pca_no_components", label = "Select number of components to compute: ", value = 50),
                                            materialSwitch(inputId = "pca_compute_elbow", label = "Compute ElbowPlot?", value = TRUE),
                                            materialSwitch(inputId = "pca_compute_jackstraw", label = "Compute JackStrawPlot?", value = FALSE),
                                            materialSwitch(inputId = "pca_compute_heatmap", label = "Compute Heatmap?", value = TRUE),
                                            conditionalPanel(
                                              condition = 'input.pca_compute_heatmap == true',
                                              numericInput(inputId = "pca_compute_heatmap_nfeatures",
                                                           label = "Set number of features for heatmap:", value = 30, step = 1),
                                            ),
                                            numericInput(inputId = "seed_PCA",
                                                         label = "Seed value for reproducibility of result:",
                                                         value = 42,
                                                         step = 1),
                                            actionButton(inputId = "run_pca_button", "Run PCA")
                                             ),
                                        panel(heading = "Select No. of Components",
                                            htmlOutput(outputId = "pca_significant_pc_output", inline = FALSE),
                                            numericInput(inputId = "pca_significant_pc_counter", label = "Select number of components for downstream analysis: ", min = 1, max = 20, value = 10)
                                        )
                                          )
                                        )
                                  ),
                            column(8,
                                fluidRow(
                                    column(12,
                                           hidden(
                                        tags$div(class = "seurat_pca_plots", tabsetPanel(id = "seuratPCAPlotTabset", type = "tabs"
                                                   )
                                                 ))
                                          )

                                        )
                                  )
                               )

                            ),
                    tabPanel("ICA",
                             br(),
                             fluidRow(
                               column(4,
                                      fluidRow(
                                        column(12,
                                               panel(heading = "ICA",
                                                     textInput(inputId = "ica_no_components", label = "Select number of components to compute: ", value = "20"),
                                                     materialSwitch(inputId = "ica_compute_heatmap", label = "Compute Heatmap?", value = TRUE),
                                                     conditionalPanel(
                                                       condition = 'input.ica_compute_heatmap == true',
                                                       numericInput(inputId = "ica_compute_heatmap_nfeatures",
                                                                    label = "Set number of features for heatmap:", value = 30, step = 1),
                                                     ),
                                                     numericInput(inputId = "seed_ICA",
                                                                  label = "Seed value for reproducibility of result:",
                                                                  value = 42,
                                                                  step = 1),
                                                     actionButton(inputId = "run_ica_button", "Run ICA")
                                               ),
                                               panel(heading = "Select No. of Components",
                                                     #h5("Number of components suggested by ElbowPlot: "),
                                                     #verbatimTextOutput(outputId = "ica_significant_pc_output", placeholder = TRUE),
                                                     numericInput(inputId = "ica_significant_ic_counter", label = "Select number of components for downstream analysis: ", min = 1, max = 20, value = 10)
                                               )
                                        )
                                      )
                               ),
                               column(8,
                                      fluidRow(
                                        column(12,
                                               hidden(
                                                tags$div(class = "seurat_ica_plots", tabsetPanel(id="seuratICAPlotTabset", type = "tabs"
                                               ))
                                               )
                                               )
                                      )
                                      )
                             )

                             )
                    ),
                    style = "primary"),



            bsCollapsePanel("2D-Embedding",
                tabsetPanel(id = "tsneUmapTabsetSeurat", type = "tabs",
                            tabPanel("UMAP",
                                     br(),
                                     fluidRow(
                                       column(4,
                                              fluidRow(
                                                column(12,
                                                       panel(heading = "UMAP",
                                                             selectInput(inputId = "reduction_umap_method", label = "Select reduction method: ", choices = c("pca", "ica")),
                                                             #textInput(inputId = "reduction_umap_count", label = "Select number of reduction components: ", value = "20"),
                                                             numericInput(inputId = "min_dist_umap", label = "Set min.dist:", value = 0.3),
                                                             numericInput(inputId = "n_neighbors_umap", label = "Set n.neighbors:", value = 30, step = 1),
                                                             numericInput(inputId = "spread_umap", label = "Set spread:", value = 1),
                                                             numericInput(inputId = "seed_UMAP",
                                                                          label = "Seed value for reproducibility of result:",
                                                                          value = 42,
                                                                          step = 1),
                                                             htmlOutput(outputId = "display_message_umap", inline = FALSE),
                                                             actionButton(inputId = "run_umap_button", "Run UMAP")
                                                       )
                                                )
                                              )
                                       ),
                                       column(8,
                                              fluidRow(
                                                panel(heading = "Plot",
                                                      column(12,
                                                             plotlyOutput(outputId = "plot_umap")
                                                      )
                                                )
                                              )
                                       )
                                     )
                            ),
                    tabPanel("tSNE",
                        br(),
                        fluidRow(
                            column(4,
                                fluidRow(
                                    column(12,
                                        panel(heading = "tSNE",
                                            selectInput(inputId = "reduction_tsne_method", label = "Select reduction method: ", choices = c("pca", "ica")),
                                            #textInput(inputId = "reduction_tsne_count", label = "Select number of reduction components: ", value = "20"),
                                            numericInput(inputId = "perplexity_tsne", label = "Set perplexity:", value = 30),
                                            numericInput(inputId = "seed_TSNE",
                                                         label = "Seed value for reproducibility of result:",
                                                         value = 1,
                                                         step = 1),
                                            htmlOutput(outputId = "display_message_tsne", inline = FALSE),
                                            actionButton(inputId = "run_tsne_button", "Run tSNE")
                                             )
                                          )
                                        )
                                  ),
                            column(8,
                                fluidRow(
                                    panel(heading = "Plot",
                                        column(12,
                                            plotlyOutput(outputId = "plot_tsne")
                                              )
                                         )
                                        )
                                  )
                                )
                            )
                    ),
                    style = "primary"),

            bsCollapsePanel("Clustering",
                fluidRow(
                    column(4,
                        fluidRow(
                            column(12,
                                panel(heading = "Options",
                                    selectInput(inputId = "reduction_clustering_method", label = "Select reduction method: ", choices = c("pca", "ica")),
                                    #textInput(inputId = "reduction_clustering_count", label = "Select number of reduction components: ", value = "20"),
                                    selectInput(inputId = "algorithm.use", label = "Select clustering algorithm: ", choices = list("Original Louvain algorithm" = "louvain",
                                                                                                                               "Louvain algorithm with multilevel refinement" = "multilevel",
                                                                                                                               "SLM algorithm" = "SLM")),
                                    numericInput(inputId = "resolution_clustering", label = "Set resolution:", value = 0.8),
                                    materialSwitch(inputId = "group.singletons", label = "Group singletons?", value = TRUE),
                                    htmlOutput(outputId = "display_message_clustering", inline = FALSE),
                                    actionButton(inputId = "find_clusters_button", "Find Clusters")
                                    )
                                   )
                                )
                          ),
                    column(8,
                           fluidRow(
                             column(12,
                                    hidden(
                                    tags$div(class = "seurat_clustering_plots", tabsetPanel(id = "seuratClusteringPlotTabset", type = "tabs"
                                    ))
                                    )
                             )

                           )
                    )
                    ),
                    style = "primary"),
            bsCollapsePanel("Marker Gene Plots",
                            fluidRow(
                              column(12,
                                     fluidRow(
                                       column(12,
                                              panel(heading = "Options",
                                                    selectizeInput("selectGenesMarkerPlots", "Select a gene:", choices = NULL, multiple = TRUE, options = list('plugins' = list('remove_button'), server = TRUE)),
                                              )
                                       )
                                     )
                              ),
                              column(12,
                                     tags$div(class = "seurat_findmarker_plots",
                                              panel(heading = "",
                                                    tabsetPanel(id = "seuratFindMarkerPlotTabset", type = "tabs"))
                                     )
                              )
                            ),
                            style = "primary"
            ),
            bsCollapsePanel("Find Markers",
                            fluidRow(
                                column(4,
                                       fluidRow(
                                           column(12,
                                                  panel(heading = "Options",
                                                        h6("Compute marker genes that are either differentially expressed or conserved between selected groups and visualize them from the selected plots on right panel."),
                                                      radioButtons(
                                                          inputId = "seuratFindMarkerType",
                                                          label = "Select type of markers to identify:",
                                                          choices = c(
                                                              "markers between all groups" = "markerAll",
                                                              "markers differentially expressed between two selected groups" = "markerDiffExp",
                                                              "markers conserved between two selected groups" = "markerConserved"
                                                                      )
                                                      ),
                                                      selectInput(
                                                          inputId = "seuratFindMarkerSelectPhenotype",
                                                          label = "Select biological phenotype:",
                                                          choices = NULL
                                                      ),
                                                      conditionalPanel(
                                                          condition = "input.seuratFindMarkerType == 'markerDiffExp'
                                                          || input.seuratFindMarkerType == 'markerConserved'",
                                                          selectInput(
                                                              inputId = "seuratFindMarkerGroup1",
                                                              label = "Select first group of interest:",
                                                              choices = NULL
                                                          ),
                                                          selectInput(
                                                              inputId = "seuratFindMarkerGroup2",
                                                              label = "Select second group of interest:",
                                                              choices = NULL
                                                          )
                                                      ),
                                                          selectInput(
                                                              inputId = "seuratFindMarkerTest",
                                                              label = "Select test:",
                                                              choices = c("wilcox", "bimod",
                                                                          "t", "negbinom",
                                                                          "poisson", "LR",
                                                                          "DESeq2")
                                                          ),
                                                          selectInput(
                                                              inputId = "seuratFeatureUseReduction",
                                                              label = "Select reduction method for feature plot:",
                                                              choices = c("umap", "tsne",
                                                                          "pca", "ica")
                                                          ),
                                                          materialSwitch(
                                                              inputId = "seuratFindMarkerPosOnly",
                                                              label = "Only return positive markers?",
                                                              value = FALSE
                                                          ),
                                                          
                                                      actionButton(inputId = "seuratFindMarkerRun", "Find Markers")
                                                  )
                                           )
                                       )
                                ),
                                column(8,
                                       fluidRow(
                                           column(12,
                                                  hidden(
                                                      tags$div(
                                                          class = "seurat_findmarker_table",
                                                          filterTableUI(id = "filterSeuratFindMarker")
                                                      )
                                                  ),
                                                  br(),
                                                  hidden(
                                                      tags$div(class = "seurat_findmarker_jointHeatmap",
                                                               bsCollapse(
                                                                 bsCollapsePanel(
                                                                   title = "Heatmap Plot",
                                                                         fluidRow(
                                                                           column(12, align = "center",
                                                                                               panel(
                                                                                                   numericInput("findMarkerHeatmapPlotFullNumeric", value = 10, max = 2000, min = 2, step = 1, label = "Select number of top genes from each cluster/group to visualize in the heatmap below based on highest average log fold change value:"),
                                                                                                   actionButton("findMarkerHeatmapPlotFullNumericRun", label = "Plot"),
                                                                                                   hr(),
                                                                                                   shinyjqui::jqui_resizable(
                                                                                                       plotOutput(outputId = "findMarkerHeatmapPlotFull", height = "500px")
                                                                                                   )
                                                                                               )
                                                                           )
                                                                         )
                                                                 )
                                                               )
                                                      )
                                                  ),
                                           )

                                       )
                                )
                            ),
                            style = "primary")
       ),
    nonLinearWorkflowUI(id = "nlw-seurat")
    )

#' Estimate numbers of detected genes, significantly differentially expressed
#' genes, and median significant effect size
#'
#' @param originalData \linkS4class{SingleCellExperiment} object storing all
#' assay data from the shiny app.
#' @param useAssay Character. The name of the assay to be used for subsampling.
#' @param minCount Numeric. The minimum number of reads found for a gene to be
#' considered detected.
#' @param minCells Numeric. The minimum number of cells a gene must have at
#' least 1 read in for it to be considered detected.
#' @param maxDepth Numeric. The highest number of total reads to be simulated.
#' @param realLabels Character. The name of the condition of interest. Must match
#' a name from sample data.
#' @param depthResolution Numeric. How many different read depth should the
#' script simulate? Will simulate a number of experimental designs ranging from
#' 10 reads to maxReadDepth, with logarithmic spacing.
#' @param iterations Numeric. How many times should each experimental design be
#' simulated?
#'
#' @return A 3-dimensional array, with dimensions = c(iterations,
#' depthResolution, 3). [,,1] contains the number of detected genes in each
#' simulated dataset, [,,2] contains the number of significantly differentially
#' expressed genes in each simulation, and [,,3] contains the mediansignificant
#' effect size in each simulation. If no genes are significantly differentially
#' expressed, the median effect size defaults to infinity.
#' @export
#' @examples
#' data("mouseBrainSubsetSCE")
#' subset <- mouseBrainSubsetSCE[seq(1000),]
#' res <- downSampleDepth(subset,
#'                        realLabels = "level1class",
#'                        iterations=2)
#'
downSampleDepth <- function(originalData, useAssay = "counts", minCount = 10, minCells = 3,
                            maxDepth = 10000000, realLabels,
                            depthResolution = 10, iterations = 10){
  realLabels <- SingleCellExperiment::colData(originalData)[, realLabels]
  originalData <- expData(originalData, useAssay)
  foundGenesMatrix <- matrix(nrow = iterations, ncol = depthResolution)
  minEffectSizeMatrix <- matrix(nrow = iterations, ncol = depthResolution)
  numSigGenesMatrix <- matrix(nrow = iterations, ncol = depthResolution)
  depths <- floor(10 ^ (seq(0, log10(maxDepth), length.out = depthResolution)))
  cells <- dim(originalData)[2]
  effectSizes <- calcEffectSizes(originalData, realLabels)
  for (i in seq_len(depthResolution)){
    for (j in seq_len(iterations)){
      tempData <- generateSimulatedData(totalReads = depths[i], cells,
                                        as.matrix(originalData),
                                        realLabels = as.factor(realLabels))
      tempSigDiff <- subDiffEx(tempData)
      foundGenesMatrix[j, i] <- sum(apply(tempData[-1, ], 1, function(x){
        sum(x > 0) >= minCells && sum(x) >= minCount
      }))
      numSigGenesMatrix[j, i] <- sum(tempSigDiff <= 0.05)
      minEffectSizeMatrix[j, i] <-
        abs(min(abs(effectSizes[which(tempSigDiff <= 0.05)])))
    }
  }
  outArray <- array(c(foundGenesMatrix, minEffectSizeMatrix, numSigGenesMatrix),
                    dim = c(iterations, depthResolution, 3))
  return(outArray)
}

#' Estimate numbers of detected genes, significantly differentially expressed
#' genes, and median significant effect size
#'
#' @param originalData The \linkS4class{SingleCellExperiment} object storing all
#' assay data from the shiny app.
#' @param useAssay Character. The name of the assay to be used for subsampling.
#' @param minCountDetec Numeric. The minimum number of reads found for a gene to
#' be considered detected.
#' @param minCellsDetec Numeric. The minimum number of cells a gene must have at
#' least 1 read in for it to be considered detected.
#' @param minCellnum Numeric. The minimum number of virtual cells to include in
#' the smallest simulated dataset.
#' @param maxCellnum Numeric. The maximum number of virtual cells to include in
#' the largest simulated dataset
#' @param realLabels Character. The name of the condition of interest. Must match
#' a name from sample data. If only two factors present in the corresponding
#' colData, will default to t-test. If multiple factors, will default to ANOVA.
#' @param depthResolution Numeric. How many different read depth should the
#' script simulate? Will simulate a number of experimental designs ranging from
#' 10 reads to maxReadDepth, with logarithmic spacing.
#' @param iterations Numeric. How many times should each experimental design be
#' simulated?
#' @param totalReads Numeric. How many aligned reads to put in each simulated
#' dataset.
#'
#' @return A 3-dimensional array, with dimensions = c(iterations,
#' depthResolution, 3). [,,1] contains the number of detected genes in each
#' simulated dataset, [,,2] contains the number of significantly differentially
#' expressed genes in each simulation, and [,,3] contains the mediansignificant
#' effect size in each simulation. If no genes are significantly differentially
#' expressed, the median effect size defaults to infinity.
#' @export
#' @examples
#' data("mouseBrainSubsetSCE")
#' subset <- mouseBrainSubsetSCE[seq(100),]
#' res <- downSampleCells(subset,
#'                        realLabels = "level1class",
#'                        iterations=2)
downSampleCells <- function(originalData, useAssay = "counts",
                            minCountDetec = 10, minCellsDetec = 3,
                            minCellnum = 10, maxCellnum = 1000, realLabels,
                            depthResolution = 10, iterations = 10,
                            totalReads = 1000000){
  realLabels <- SingleCellExperiment::colData(originalData)[, realLabels]
  originalData <- expData(originalData, useAssay)
  foundGenesMatrix <- matrix(nrow = iterations, ncol = depthResolution)
  minEffectSizeMatrix <- matrix(nrow = iterations, ncol = depthResolution)
  numSigGenesMatrix <- matrix(nrow = iterations, ncol = depthResolution)
  cellNums <- seq(minCellnum, maxCellnum, length.out = depthResolution)
  effectSizes <- calcEffectSizes(originalData, realLabels)
  for (i in seq_len(depthResolution)){
    for (j in seq_len(iterations)){
      tempData <- generateSimulatedData(totalReads = totalReads,
                                        cells = cellNums[i],
                                        as.matrix(originalData),
                                        realLabels = as.factor(realLabels))
      tempSigDiff <- subDiffEx(tempData)
      foundGenesMatrix[j, i] <- sum(apply(tempData[-1, ], 1, function(x){
        sum(x > 0) >= minCellsDetec && sum(x) >= minCountDetec
      }))
      numSigGenesMatrix[j, i] <- sum(tempSigDiff <= 0.05)
      minEffectSizeMatrix[j, i] <-
        abs(min(abs(effectSizes[which(tempSigDiff <= 0.05)])))
    }
  }
  outArray <- array(c(foundGenesMatrix, minEffectSizeMatrix, numSigGenesMatrix),
                    dim = c(iterations, depthResolution, 3))
  return(outArray)
}

#' Generates a single simulated dataset, bootstrapping from the input counts
#' matrix.
#'
#' @param totalReads Numeric. The total number of reads in the simulated
#' dataset, to be split between all simulated cells.
#' @param originalData Matrix. The original raw read count matrix. When used
#' within the Shiny app, this will be assay(SCEsetObject, "counts").
#' @param cells Numeric. The number of virtual cells to simulate.
#' @param realLabels Factor. The condition labels for differential expression.
#' If only two factors present, will default to t-test. If multiple factors,
#' will default to ANOVA.
#'
#' @return A simulated counts matrix, the first row of which contains the 'true'
#' labels for each virtual cell.
#' @export
#' @examples
#' data("mouseBrainSubsetSCE")
#' res <- generateSimulatedData(
#'          totalReads = 1000, cells=10,
#'          originalData = assay(mouseBrainSubsetSCE, "counts"),
#'          realLabels = colData(mouseBrainSubsetSCE)[, "level1class"])
#'
generateSimulatedData <- function(totalReads, cells, originalData, realLabels){
  cells <- sample(dim(originalData)[2], size = cells, replace = TRUE)
  totalReads <- floor(totalReads / length(cells))
  originalData <- t(t(originalData) / apply(originalData, 2, sum))
  output <- matrix(nrow = dim(originalData)[1], ncol = length(cells))
  for (i in seq_along(cells)){
    output[, i] <- stats::rmultinom(1, totalReads, originalData[, cells[i]])
  }
  return(rbind(realLabels[cells], output))
}

#' Returns significance data from a snapshot.
#'
#' @param originalData The \linkS4class{SingleCellExperiment} object storing all
#' assay data from the shiny app.
#' @param useAssay Character. The name of the assay to be used for subsampling.
#' @param realLabels Character. The name of the condition of interest. Must match
#' a name from sample data.
#' @param totalReads Numeric. The total number of reads in the simulated
#' dataset, to be split between all simulated cells.
#' @param cells Numeric. The number of virtual cells to simulate.
#' @param iterations Numeric. How many times should each experimental design be
#' simulated.
#'
#' @return A matrix of significance information from a snapshot
#' @export
#' @examples
#' data("mouseBrainSubsetSCE")
#' res <- iterateSimulations(mouseBrainSubsetSCE, realLabels = "level1class",
#'                           totalReads = 1000, cells = 10, iterations = 2)
#'
iterateSimulations <- function(originalData, useAssay = "counts", realLabels,
                               totalReads, cells, iterations){
  realLabels <- SingleCellExperiment::colData(originalData)[, realLabels]
  originalData <- expData(originalData, useAssay)
  sigMatrix <- matrix(nrow = dim(originalData)[1])
  for (i in seq_len(iterations)){
    tempData <- generateSimulatedData(totalReads, cells, originalData,
                                      realLabels = as.factor(realLabels))
    sigMatrix <- cbind(sigMatrix, subDiffEx(tempData))
  }
  return(sigMatrix[, -1])
}

#' Passes the output of generateSimulatedData() to differential expression
#' tests, picking either t-tests or ANOVA for data with only two conditions or
#' multiple conditions, respectively.
#'
#' @param tempData Matrix. The output of generateSimulatedData(), where the
#' first row contains condition labels.
#'
#' @return subDiffEx(): A vector of fdr-adjusted p-values for all genes.
#' Nonviable results (such as for genes with 0 counts in a simulated dataset)
#' are coerced to 1.
#'
#' @describeIn subDiffEx
#'
#' @export
#' @examples
#' data("mouseBrainSubsetSCE")
#' res <- generateSimulatedData(
#'          totalReads = 1000, cells=10,
#'          originalData = assay(mouseBrainSubsetSCE, "counts"),
#'          realLabels = colData(mouseBrainSubsetSCE)[, "level1class"])
#' tempSigDiff <- subDiffEx(res)
#'
subDiffEx <- function(tempData){
  realLabels <- tempData[1, ]
  output <- tempData[-1, ]
  if (length(levels(as.factor(realLabels))) > 2){
    fdr <- subDiffExANOVA(output, realLabels)
  } else if (length(levels(as.factor(realLabels))) == 2){
    fdr <- subDiffExttest(output, realLabels)
  }
  else{
    stop("Only 1 (or 0?) factor in ", levels(as.factor(realLabels)))
  }
  fdr[which(is.na(fdr))] <- 1
  return(fdr)
}

#' @describeIn subDiffEx Runs t-tests on all genes in a simulated dataset with 2
#' conditions, and adjusts for FDR.
#'
#' @param countMatrix Matrix. A simulated counts matrix, sans labels.
#' @param class.labels Factor. The condition labels for the simulated cells.
#' Will be coerced into 1's and 0's.
#' @param test.type Type of test to perform. The default is t.equalvar.
#'
#' @return subDiffExttest(): A vector of fdr-adjusted p-values for all genes.
#' Nonviable results (such as for genes with 0 counts in a simulated dataset)
#' are coerced to 1.
#'
#' @export
#' @examples
#' data("mouseBrainSubsetSCE")
#' #sort first 100 expressed genes
#' ord <- rownames(mouseBrainSubsetSCE)[
#'   order(rowSums(assay(mouseBrainSubsetSCE, "counts")),
#'         decreasing = TRUE)][seq(100)]
#' #subset to those first 100 genes
#' subset <- mouseBrainSubsetSCE[ord, ]
#' res <- generateSimulatedData(totalReads = 1000, cells=10,
#'                              originalData = assay(subset, "counts"),
#'                              realLabels = colData(subset)[, "level1class"])
#' realLabels <- res[1, ]
#' output <- res[-1, ]
#' fdr <- subDiffExttest(output, realLabels)
#'
subDiffExttest <- function(countMatrix, class.labels, test.type = "t.equalvar") {
  class.labels <- as.numeric(as.factor(class.labels))
  class.labels <- class.labels - 1
  class.labels[class.labels > 0] <- 1
  tval <- multtest::mt.teststat(countMatrix, classlabel = class.labels,
                                test = test.type, nonpara = "n")
  df <- (ncol(countMatrix) - 2)
  pval <- 2 * (1 - stats::pt(abs(tval), df))
  fdr <- stats::p.adjust(pval, method = "fdr")
  return(fdr)
}

#' @describeIn subDiffEx Runs ANOVA on all genes in a simulated dataset with
#' more than 2 conditions, and adjusts for FDR.
#'
#' @param condition Factor. The condition labels for the simulated cells.
#'
#' @return subDiffExANOVA(): A vector of fdr-adjusted p-values for all genes.
#' Nonviable results (such as for genes with 0 counts in a simulated dataset)
#' are coerced to 1.
#'
#' @export
#' @examples
#' data("mouseBrainSubsetSCE")
#' #sort first 100 expressed genes
#' ord <- rownames(mouseBrainSubsetSCE)[
#'   order(rowSums(assay(mouseBrainSubsetSCE, "counts")),
#'         decreasing = TRUE)][seq(100)]
#' # subset to those first 100 genes
#' subset <- mouseBrainSubsetSCE[ord, ]
#' res <- generateSimulatedData(totalReads = 1000, cells=10,
#'                              originalData = assay(subset, "counts"),
#'                              realLabels = colData(subset)[, "level2class"])
#' realLabels <- res[1, ]
#' output <- res[-1, ]
#' fdr <- subDiffExANOVA(output, realLabels)
#'
subDiffExANOVA <- function(countMatrix, condition){
  mod <- stats::model.matrix(~as.factor(condition))
  mod0 <- stats::model.matrix(~1, data = as.factor(condition))
  dat <- log2(countMatrix + 1)
  n <- dim(dat)[2]
  m <- dim(dat)[1]
  df1 <- dim(mod)[2]
  df0 <- dim(mod0)[2]
  p <- rep(0, m)
  Id <- diag(n)
  resid <- dat %*% (Id - mod %*% solve(t(mod) %*% mod) %*%
                      t(mod))
  resid0 <- dat %*% (Id - mod0 %*% solve(t(mod0) %*% mod0) %*%
                       t(mod0))
  rss1 <- resid ^ 2 %*% rep(1, n)
  rss0 <- resid0 ^ 2 %*% rep(1, n)
  fstats <- ((rss0 - rss1) / (df1 - df0)) / ((rss1 + 1e-50) / (n - df1))
  p <- 1 - stats::pf(fstats, df1 = (df1 - df0), df2 = (n - df1))
  return(stats::p.adjust(p, method = "fdr"))
}

#' Finds the effect sizes for all genes in the original dataset, regardless of
#' significance.
#'
#' @param countMatrix Matrix. A simulated counts matrix, sans labels.
#' @param condition Factor. The condition labels for the simulated cells. If
#' more than 2 conditions are given, the first will be compared to all others by
#' default.
#'
#' @return A vector of cohen's d effect sizes for each gene.
#'
#' @export
#' @examples
#' data("mouseBrainSubsetSCE")
#' res <- calcEffectSizes(assay(mouseBrainSubsetSCE, "counts"),
#'                        condition = colData(mouseBrainSubsetSCE)$level1class)
#'
calcEffectSizes <- function(countMatrix, condition){
  groups <- levels(as.factor(unlist(condition)))
  return((apply(countMatrix[, condition == unlist(groups)[1]], 1, mean) -
            apply(countMatrix[, condition != unlist(groups)[1]], 1, mean)) /
           apply(countMatrix, 1, S4Vectors::sd))
}

powerCalc <- function(datamatrix, sampleSizeRange=c(1000, 10000000),
                      byBatch=FALSE, batch=NULL, numSize=25) {
  if (byBatch == FALSE){
    outmat <- array(NA, dim = c(dim(datamatrix)[1], dim(datamatrix)[2],
                                numSize))
    for (j in seq_len(dim(datamatrix)[2])) {
      probs <- as.numeric(datamatrix[, j] / sum(datamatrix[, j]))
      for (i in seq_along(probs)){
        discoveryPower <- 1 - DelayedArray::dbinom(0, size = floor(seq.int(
          from = sampleSizeRange[1], to = sampleSizeRange[2],
          length.out = numSize)), prob = probs[i])
        outmat[i, j, ] <- discoveryPower
      }
    }
  }
  else {
    outmat <- array(NA, dim = c(dim(datamatrix)[1], dim(datamatrix)[2],
                                numSize))
    for (j in seq_len(nlevels(batch))) {
      probs <- datamatrix[, which(batch == levels(batch)[j])] /
        sum(datamatrix[, which(batch == levels(batch)[j])])
      for (i in seq_along(as.vector(probs))) {
        discoveryPower <- 1 - DelayedArray::dbinom(0, size = floor(seq.int(
          from = sampleSizeRange[1], to = sampleSizeRange[2],
          length.out = numSize)), prob = as.vector(probs)[i])
        outmat[((i - 1) %% dim(datamatrix)[1]) + 1,
               which(batch == levels(batch)[j])[
                 ceiling(i / dim(datamatrix)[1])], ] <- discoveryPower
      }
    }
  }
  return(outmat)
}

#source: https://github.com/klmr/decorator

`%@%` = function (decorator, f) UseMethod('%@%')

`%@%.default` = function (decorator, f)
  stop(deparse(substitute(decorator)), ' is not a decorator')

`%@%.decorator` = function (decorator, f) {
  pretty_decorators = as.list(match.call())[-1]
  # Patch delayed decorator.
  if (! is.null({pretty_patched = attr(decorator, 'calls')}))
    pretty_decorators = c(pretty_patched, pretty_decorators[-1])

  # Handle operator precedence so that we can chain decorators.
  if (inherits(f, 'decorator'))
    .delayed_decorate(decorator, f, pretty_decorators)
  else
    prettify(decorator(f), f, pretty_decorators[-length(pretty_decorators)])
}

decorator = function (f)
  structure(f, class = 'decorator')

decorator = decorator(decorator)

print.decorated = function (x, useSource = TRUE, ...) {
  bare = function (f) {
    bare = unclass(f)
    attr(bare, 'decorators') = NULL
    bare
  }

  fun_def = utils::capture.output(print.function(bare(x), useSource = useSource, ...))
  for (decorator in attr(x, 'decorators'))
    cat(deparse(decorator), '%@%\n')
  cat(fun_def, sep = '\n')
  invisible(x)
}

# modules::register_S3_method('print', 'decorated', print.decorated)

prettify = function (f, original, decorator_calls) {
  attr(f, 'srcref') = pretty_code(original)
  attr(f, 'decorators') = decorator_calls
  class(f) = c(class(f), 'decorated')
  f
}

pretty_code = function (f) {
  srcref = attr(f, 'srcref')
  if (is.null(srcref)) body(f) else srcref
}

.delayed_decorate = function (d1, d2, decorator_calls)
  structure(decorator(function (f) d1(d2(f))), calls = decorator_calls)

#' @name simpleLog
#' @title A decorator that prints the arguments to the decorated function
#' @param f A function to decorate
#' @return Prints message
#' @noRd
simpleLog <- decorator %@% function(f) {
  function(...) {
    message(deparse(match.call()))
    f(...)
  }
}

cxdsHelpModal <- function() {
  modalDialog(
    tags$style(HTML("
      div {
        word-wrap: break-word;
      }
      ")),
    tags$div(
      h3("CXDS Parameters"),
      fluidRow(
        column(4, tags$b("Parameter Name")),
        column(8, tags$b("Description"))
      ),
      tags$hr(),
      fluidRow(
        column(4, "ntop"),
        column(8, "Integer. Indimessageing number of top variance genes to consider. Default: 500")
      ),
      tags$hr(),
      fluidRow(
        column(4, "binThresh"),
        column(8, 'Integer. Minimum counts to consider a gene "present" in a cell. Default: 0')
      ),
      tags$hr(),
      fluidRow(
        column(4, "verb"),
        column(8, "Check off to print log messages to the console. Default: TRUE.")
      ),
      tags$hr(),
      fluidRow(
        column(4, "retRes"),
        column(8, "Check off to return gene pair scores & top-scoring gene pairs.")
      )
    )
  )
}

#' Run GSVA analysis on a \linkS4class{SingleCellExperiment} object
#'
#' @param inSCE Input \linkS4class{SingleCellExperiment} object.
#' @param useAssay Indicate which assay to use. The default is "logcounts"
#' @param geneSetCollectionName Character. The name of the gene set collection 
#' to use. 
#' @param resultNamePrefix  Character. Prefix to the name the GSVA results 
#' which will be stored in the reducedDim slot of \code{inSCE}. The names of the 
#' output matrix will be \code{resultNamePrefix_Scores}. If this parameter is 
#' set to \code{NULL}, then "GSVA_geneSetCollectionName_" will be used. Default 
#' \code{NULL}.
#' @param ... Parameters to pass to gsva()
#'
#' @return A \linkS4class{SingleCellExperiment} object with pathway activity 
#' scores from GSVA stored in \code{reducedDim} as 
#' \code{GSVA_geneSetCollectionName_Scores}.
#' @export
#' @examples
#' data(scExample, package = "singleCellTK")
#' sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
#' sce <- scaterlogNormCounts(sce, assayName = "logcounts")
#' gs1 <- rownames(sce)[seq(10)]
#' gs2 <- rownames(sce)[seq(11,20)]
#' gs <- list("geneset1" = gs1, "geneset2" = gs2)
#' 
#' sce <- importGeneSetsFromList(inSCE = sce,geneSetList = gs,
#'                                            by = "rownames")
#' sce <- runGSVA(inSCE = sce, 
#'                geneSetCollectionName = "GeneSetCollection", 
#'                useAssay = "logcounts")
runGSVA <- function(inSCE, useAssay = "logcounts",
                    resultNamePrefix = NULL, geneSetCollectionName, ...){
  gsvaRes <- NULL
  gene.Set <- .getGeneSetCollection(inSCE, geneSetCollectionName)
  
  message(date(), " ... Running GSVA")

  gsvaData <- as.matrix(expData(inSCE, useAssay))
  gsvaPar <- GSVA::gsvaParam(gsvaData, gene.Set)
  gsvaRes <- t(GSVA::gsva(gsvaPar))
  
  if(is.null(resultNamePrefix)) {
    resultNamePrefix <- paste0("GSVA_", geneSetCollectionName, "_")
  }
  
  SingleCellExperiment::reducedDim(inSCE, 
                                   paste0(resultNamePrefix, 
                                          "Scores")) <- gsvaRes 
  
  if ("pathwayAnalysisResultNames" %in% names(S4Vectors::metadata(inSCE))) {
    S4Vectors::metadata(inSCE)[["pathwayAnalysisResultNames"]] <- 
      c(S4Vectors::metadata(inSCE)[["pathwayAnalysisResultNames"]],
        paste0(resultNamePrefix, "Scores"))
  } else {
    S4Vectors::metadata(inSCE)[["pathwayAnalysisResultNames"]] <- 
      c(paste0(resultNamePrefix, "Scores"))
  }

  return(inSCE)
}

#' @importFrom tools file_ext
.getFileExt <- function(file) {
    ext1 <- tools::file_ext(file)
    if (!(ext1 %in% c("mtx", "txt", "csv", "tab", "tsv",
        "npz", "gz", "bz2", "xz"))) {

        warning("Unknown extension ", ext1, ". Treat as text file.")
        return(c("unknown"))
    }

    # if compressed
    if (ext1 %in% c("gz", "bz2", "xz")) {
        bn <- substr(file, start = 1, stop = nchar(file) - nchar(ext1) - 1)
        ext2 <- tools::file_ext(bn)
        if (!(ext2 %in% c("mtx", "txt", "csv", "tab", "npz"))) {
            warning("Unknown extension ", ext2, ". Treat as text file.")
            return(c(ext1, "unknown"))
        }
        return(c(ext1, ext2))
    } else {
        return(ext1)
    }
}


#' @name readSingleCellMatrix
#' @title Read single cell expression matrix
#' @description Automatically detact the format of the input file and read
#'  the file.
#' @param file Path to input file. Supported file endings include .mtx, .txt,
#'  .csv, .tab, .tsv, .npz, and their corresponding \code{gzip},
#'  \code{bzip2}, or \code{xz} compressed extensions (\code{*.gz},
#'  \code{*.bz2}, or \code{*.xz}).
#' @param class Character. Class of matrix. One of "Matrix" or "matrix". Specifying "Matrix"
#'  will convert to a sparse format which should be used
#'  for datasets with large numbers of cells.  Default "Matrix".
#' @param delayedArray Boolean. Whether to read the expression matrix as
#'  \link{DelayedArray} object or not. Default \code{TRUE}.
#' @param colIndexLocation Character. For Optimus output, the path to the
#'  barcode index .npy file. Used only if \code{file} has .npz extension.
#'  Default \code{NULL}.
#' @param rowIndexLocation Character. For Optimus output, The path to the
#'  feature (gene) index .npy file. Used only if \code{file} has .npz extension.
#'  Default \code{NULL}.
#' @return A \link{DelayedArray} object or matrix.
#' @examples
#' mat <- readSingleCellMatrix(system.file("extdata/hgmm_1k_v3_20x20/outs/",
#'     "filtered_feature_bc_matrix/matrix.mtx.gz", package = "singleCellTK"))
#' @importFrom reticulate import
#' @export
readSingleCellMatrix <- function(file,
    class = c("Matrix", "matrix"),
    delayedArray = TRUE,
    colIndexLocation = NULL,
    rowIndexLocation = NULL) {

    class <- match.arg(class)
    ext <- .getFileExt(file)

    if (ext[1] == "gz") {
        file <- gzfile(file)
    } else if (ext[1] == "bz2") {
        file <- bzfile(file)
    } else if (ext[1] == "xz") {
        file <- xzfile(file)
    }

    ext2 <- data.table::last(ext)

    if (ext2 %in% c("txt", "csv", "tab", "tsv", "unknown")) {
        dt <- data.table::fread(file)
        if (class == "Matrix") {
            mat <- Matrix::Matrix(as.matrix(dt[, -1]))
            rownames(mat) <- dt[[1]]
        } else if (class == "matrix") {
            mat <- as.matrix(dt[, -1])
            rownames(mat) <- dt[[1]]
        }
    } else if (ext2 == "npz") {
        mat <- .readMatrixNpz(matrixLocation = file,
            colIndexLocation = colIndexLocation,
            rowIndexLocation = rowIndexLocation,
            class = class)
    } else if (ext2 == "mtx") {
        mat <- .readMatrixMM(path = file,
            gzipped = FALSE,
            class = class,
            delayedArray = delayedArray)
    }
    return(mat)
}

shinyPanelfindMarker <- fluidPage(
  tags$script("Shiny.addCustomMessageHandler('close_dropDownFM', function(x){
                  $('html').click();
                });"),
    h1("Find Marker"),
    h5(tags$a(href = paste0(docs.artPath, "find_marker.html"),
              "(help)", target = "_blank")),
    sidebarLayout(
      sidebarPanel(
        selectInput('fmMethod', "Select Differential Expression Method",
                    c("wilcox", "MAST", "DESeq2", "Limma", "ANOVA")),
        selectizeInput(
          inputId = "fmAssay", 
          label = "Select input matrix:", 
          choices = NULL, 
          selected = NULL, 
          multiple = FALSE,
          options = NULL),
        selectInput("fmCluster", "Cluster Annotation", clusterChoice),
        selectInput("fmCovar", "Covariate(s)", clusterChoice, multiple = TRUE),
        # numericInput("fmLogFC", "Log2FC greater than",
        #              value = 0, min = 0, step = 0.05),
        numericInput("fmFDR", "Keep FDR less than", value = 0.05,
                     max = 1, min = 0.01, step = 0.01),
        # numericInput("fmMinClustExprPerc",
        #              "Minimum Expressed Percentage in Cluster",
        #              value = 0, min = 0, max = 1),
        # numericInput("fmMaxCtrlExprPerc",
        #              "Maximum Expressed Percentage in Control",
        #              value = 1, min = 0, max = 1),
        # numericInput("fmMinMeanExpr",
        #              "Minimum Mean Expression Level in Cluster",
        #              value = 0, min = 0),
        actionButton("runFM", "Run")
      ),
      mainPanel(
        tabsetPanel(
          tabPanel(
            "Heatmap",
            shinyjs::useShinyjs(),
            fluidRow(
              column(
                width = 4,
                dropdown(
                  fluidRow(
                    column(12,
                           fluidRow(actionBttn(inputId = "closeDropDownFM", label = NULL, style = "simple", color = "danger", icon = icon("times"), size = "xs"), align = "right"),
                    )
                  ),
                  fluidRow(
                    column(
                      width = 6,
                      radioButtons('fmHMOrder', "Order blocks by",
                                   c("size", "name"), inline = TRUE),
                    ),
                    column(
                      width = 6,
                      checkboxInput("fmHMdec", "Decreasing", TRUE),
                    )
                  ),
                  fluidRow(
                    column(
                      width = 6,
                      checkboxInput("fmUseTopN", "Plot Top N markers of each cluster",
                                    TRUE)
                    ),
                    column(
                      width = 6,
                      numericInput("fmTopN", NULL, 5, min = 1, step = 1)
                    )
                  ),
                  fluidRow(
                    column(
                      width = 6,
                      numericInput("fmHMFC", "Plot Log2FC greater than",
                                   value = 0, min = 0, step = 0.05),
                    ),
                    column(
                      width = 6,
                      numericInput("fmHMFDR", "Plot FDR less than",
                                   value = 0.05, max = 1, step = 0.01),
                    )
                  ),
                  fluidRow(
                    column(
                      width = 4,
                      numericInput("fmHMMinClustExprPerc",
                                   "Plot Cluster Expression Percentage More Than",
                                   value = 0.5, min = 0, max = 1)
                    ),
                    column(
                      width = 4,
                      numericInput("fmHMMaxCtrlExprPerc",
                                   "Plot Control Expression Percentage Less Than",
                                   value = 0.4, min = 0, max = 1)
                    ),
                    column(
                      width = 4,
                      numericInput("fmHMMinMeanExpr",
                                   "Plot Mean Cluster Expression Level More Than",
                                   value = 0, min = 0)
                    )
                  ),
                  fluidRow(
                    column(
                      width = 6,
                      selectInput("fmHMrowData", "Additional feature annotation",
                                  featureChoice, multiple = TRUE),
                    ),
                    column(
                      width = 6,
                      selectInput("fmHMcolData", "Additional cell annotation",
                                  clusterChoice, multiple = TRUE)
                    )
                  ),
                  fluidRow(
                    column(
                      width = 12,
                      selectInput("fmHMFeatureDisplay",
                                  "Display ID Type",
                                  c("Rownames (Default)",
                                    featureChoice)),
                      withBusyIndicatorUI(
                        actionBttn(
                          inputId = "plotFM",
                          label = "Update",
                          style = "bordered",
                          color = "primary",
                          size = "sm"
                        )
                      )
                    )
                  ),
                  inputId = "dropDownFM",
                  icon = icon("cog"),
                  status = "primary",
                  circle = FALSE,
                  inline = FALSE,
                  width = "500px"
                )
              ),
              column(
                width = 7,
                fluidRow(
                  h6(
                    "The heatmap plots the expression level of top markers found for each cluster"
                  ),
                  align="center"
                )
              )
            ),
            hr(),
            br(),
            shinyjqui::jqui_resizable(plotOutput('fmHeatmap'))
          ),
          tabPanel(
            "Result Table",
            filterTableUI(id = "filterfmResTable"),
            #DT::dataTableOutput("fmResTable"),
            downloadButton("fmDownload", "Download Results"),
          )
        )
      )
    )
)

#' Get clustering with SNN graph
#' @description Perform SNN graph clustering on a
#' \linkS4class{SingleCellExperiment} object, with graph
#' construction by \code{\link[scran]{buildSNNGraph}} and graph clustering by
#' "igraph" package.
#' @param inSCE A \linkS4class{SingleCellExperiment} object.
#' @param useReducedDim A single \code{character}, specifying which
#' low-dimension representation (\code{\link{reducedDim}})
#' to perform the clustering algorithm on. Default \code{"PCA"}.
#' @param useAssay A single \code{character}, specifying which
#' \code{\link{assay}} to perform the clustering algorithm
#' on. Default \code{NULL}.
#' @param useAltExp A single \code{character}, specifying the assay which
#' \code{\link{altExp}} to perform the clustering
#' algorithm on. Default \code{NULL}.
#' @param altExpAssay A single \code{character}, specifying which
#' \code{\link{assay}} in the chosen
#' \code{\link{altExp}} to work on. Only used when
#' \code{useAltExp} is set. Default \code{"counts"}.
#' @param altExpRedDim A single \code{character}, specifying which
#' \code{\link{reducedDim}} within the \code{\link{altExp}} specified by
#' \code{useAltExp} to use. Only used when \code{useAltExp} is set. Default
#' \code{NULL}.
#' @param clusterName A single \code{character}, specifying the name to store
#' the cluster label in \code{\link{colData}}. Default
#' \code{"cluster"}.
#' @param k An \code{integer}, the number of nearest neighbors used to construct
#' the graph. Smaller value indicates higher resolution and larger number of
#' clusters. Default \code{14}.
#' @param nComp An \code{integer}. The number of components to use for graph
#' construction. Default \code{10}. See Detail.
#' @param weightType A single \code{character}, that specifies the edge weighing
#' scheme when constructing the Shared Nearest-Neighbor (SNN) graph. Choose from
#' \code{"rank"}, \code{"number"}, \code{"jaccard"}. Default \code{"jaccard"}.
#' @param algorithm A single \code{character}, that specifies the community
#' detection algorithm to work on the SNN graph. Choose from \code{"leiden"},
#' \code{"louvain"}, \code{"walktrap"}, \code{"infomap"}, \code{"fastGreedy"},
#' \code{"labelProp"}, \code{"leadingEigen"}. Default \code{"louvain"}. See
#' Detail.
#' @param BPPARAM A \code{\link[BiocParallel]{BiocParallelParam}} object to use
#' for processing the SNN graph generation step in parallel.
#' @param seed Random seed for reproducibility of results. Default \code{NULL}
#' will use global seed in use by the R environment.
#' @param ... Other optional parameters passed to the \code{\link{igraph}}
#' clustering functions. See Details.
#' @return The input \linkS4class{SingleCellExperiment} object with
#' \code{factor} cluster labeling updated in
#' \code{colData(inSCE)[[clusterName]]}.
#' @details Different graph based clustering algorithms have diverse sets of
#' parameters that users can tweak. The help information can be found here:
#' \itemize{
#'  \item{for \code{"louvain"}, see function help
#'  \code{\link[igraph]{cluster_louvain}}}
#'  \item{for \code{"leiden"}, see function help
#'  \code{\link[igraph]{cluster_leiden}}}
#'  \item{for \code{"walktrap"}, see function help
#'  \code{\link[igraph]{cluster_walktrap}}}
#'  \item{for \code{"infomap"}, see function help
#'  \code{\link[igraph]{cluster_infomap}}}
#'  \item{for \code{"fastGreedy"}, see function help
#'  \code{\link[igraph]{cluster_fast_greedy}}}
#'  \item{for \code{"labelProp"}, see function help
#'  \code{\link[igraph]{cluster_label_prop}}}
#'  \item{for \code{"leadingEigen"}, see function help
#'  \code{\link[igraph]{cluster_leading_eigen}}}
#' }
#'
#' The Scran SNN building method can work on specified \code{nComp} components.
#' When users specify input matrix by \code{useAssay} or \code{useAltExp} +
#' \code{altExpAssay}, the method will generate \code{nComp} components and use
#' them all. When specifying \code{useReducedDim} or \code{useAltExp} +
#' \code{altExpRedDim}, this function will subset the top \code{nComp}
#' components and pass them to the method.
#' @references Aaron Lun and et. al., 2016
#' @export
#' @examples
#' data("mouseBrainSubsetSCE")
#' mouseBrainSubsetSCE <- runScranSNN(mouseBrainSubsetSCE,
#'                                    useReducedDim = "PCA_logcounts")
runScranSNN <- function(inSCE, useReducedDim = "PCA", useAssay = NULL,
                        useAltExp = NULL, altExpAssay = "counts",
                        altExpRedDim = NULL,
                        clusterName = "cluster",
                        k = 14, nComp = 10,
                        weightType = "jaccard",
                        algorithm = c("louvain", "leiden", "walktrap",
                                      "infomap", "fastGreedy", "labelProp",
                                      "leadingEigen"),
                        BPPARAM = BiocParallel::SerialParam(),
                        seed = 12345,
                        ...) {
    if (!is.null(seed)) {
        # If set seed, run the whole function again but enter the next condition
        # Not sure if this is computationally inefficient.
        # Doing this now b/c both graph building and clustering steps are
        # randomized.
        withr::with_seed(
            seed = seed,
            code = runScranSNN(inSCE, useAssay = useAssay,
                               useReducedDim = useReducedDim,
                               useAltExp = useAltExp,
                               altExpAssay = altExpAssay,
                               altExpRedDim = altExpRedDim,
                               clusterName = clusterName, k = k, nComp = nComp,
                               weightType = weightType, algorithm = algorithm,
                               BPPARAM = BPPARAM, seed = NULL, ...))
    } else {
        if (!inherits(inSCE, "SingleCellExperiment")) {
            stop("'inSCE' should be a SingleCellExperiment object.")
        }
        if (is.null(useAssay) + is.null(useReducedDim) +
            is.null(useAltExp) != 2) {
            stop("Scran SNN clustering requires one and only one of ",
                 "'useAssay', 'useReducedDim', and 'useAltExp'.")
        }
        weightType <- match.arg(weightType, choices = c("rank", "number", "jaccard"))
        algorithm <- match.arg(algorithm)

        graphClustAlgoList = list(leiden = igraph::cluster_leiden,
                                  walktrap = igraph::cluster_walktrap,
                                  louvain = igraph::cluster_louvain,
                                  infomap = igraph::cluster_infomap,
                                  fastGreedy = igraph::cluster_fast_greedy,
                                  labelProp = igraph::cluster_label_prop,
                                  leadingEigen = igraph::cluster_leading_eigen)
        message(date(), " ... Running 'scran SNN clustering' with '", algorithm,
                "' algorithm")
        if (!is.null(useAssay)){
            if (!useAssay %in% SummarizedExperiment::assayNames(inSCE)) {
                stop("Specified assay '", useAssay, "' not found.")
            }
            g <- scran::buildSNNGraph(x = inSCE, k = k, assay.type = useAssay,
                                      d = nComp, type = weightType,
                                      use.dimred = NULL, BPPARAM = BPPARAM)
        } else if (!is.null(useReducedDim)) {
            if (!useReducedDim %in% SingleCellExperiment::reducedDimNames(inSCE)) {
                stop("Specified reducedDim '", useReducedDim, "' not found.")
            }
            # scran::buildSNNGraph by default use all dims of useReducedDim
            # Need to subset it before passing to Scran, if nComp specified
            nComp <- min(nComp,
                         ncol(SingleCellExperiment::reducedDim(inSCE,
                                                               useReducedDim)))
            tempSCE <- SingleCellExperiment::SingleCellExperiment(
                assays = list(counts = assay(inSCE)),
                reducedDims = list(pca = reducedDim(inSCE,
                                                    useReducedDim)[,seq(nComp)])
            )
            g <- scran::buildSNNGraph(x = tempSCE, k = k, use.dimred = "pca",
                                      type = weightType, BPPARAM = BPPARAM)
        } else if (!is.null(useAltExp)) {
            if (!useAltExp %in% SingleCellExperiment::altExpNames(inSCE)) {
                stop("Specified altExp '", useAltExp, "' not found.")
            }
            ae <- SingleCellExperiment::altExp(inSCE, useAltExp)
            if (!is.null(altExpRedDim)) {
                if (!altExpRedDim %in% SingleCellExperiment::reducedDimNames(ae)) {
                  stop("altExpRedDim: '", altExpRedDim, "' not in specified altExp.")
                }
                nComp <- min(nComp, ncol(SingleCellExperiment::reducedDim(ae, useReducedDim)))
                tempSCE <- SingleCellExperiment::SingleCellExperiment(
                    assays = list(counts = assay(ae)),
                    reducedDims = list(pca = reducedDim(ae, useReducedDim)[,seq(nComp)])
                )
                g <- scran::buildSNNGraph(x = tempSCE, k = k,
                                          use.dimred = "pca",
                                          type = weightType, BPPARAM = BPPARAM)
            } else {
                if (!altExpAssay %in% SummarizedExperiment::assayNames(ae)) {
                    stop("altExpAssay: '", altExpAssay,
                         "' not in specified altExp.")
                }
                g <- scran::buildSNNGraph(x = ae, k = k,
                                          assay.type = altExpAssay,
                                          d = nComp, type = weightType,
                                          use.dimred = NULL,
                                          BPPARAM = BPPARAM)
            }
        }
        clustFunc = graphClustAlgoList[[algorithm]]
        clust <- .relabelClusterBySize(clustFunc(g, ...)$membership)
        SummarizedExperiment::colData(inSCE)[[clusterName]] <- clust
        message(date(), " ...   Identified ", length(unique(clust)), " clusters")
        return(inSCE)
    }
}

#' Get clustering with KMeans
#' @description Perform KMeans clustering on a
#' \linkS4class{SingleCellExperiment} object, with \code{\link[stats]{kmeans}}.
#' @param inSCE A \linkS4class{SingleCellExperiment} object.
#' @param useReducedDim A single \code{character}, specifying which
#' low-dimension representation to perform the clustering algorithm on. Default
#' \code{"PCA"}.
#' @param clusterName A single \code{character}, specifying the name to store
#' the cluster label in \code{\link{colData}}. Default \code{"KMeans_cluster"}.
#' @param nComp An \code{integer}. The number of components to use for K-Means.
#' Default \code{10}. See Detail.
#' @param nCenters An \code{integer}, the number of centroids (clusters).
#' @param nIter An \code{integer}, the maximum number of iterations allowed.
#' Default \code{10}.
#' @param nStart An \code{integer}, the number of random sets to choose. Default
#' \code{1}.
#' @param seed An \code{integer}. The seed for the random number generator.
#' Default \code{12345}.
#' @param algorithm A single \code{character}. Choose from
#' \code{"Hartigan-Wong"}, \code{"Lloyd"}, \code{"MacQueen"}. May be
#' abbreviated. Default \code{"Hartigan-Wong"}.
#' @return The input \linkS4class{SingleCellExperiment} object with
#' \code{factor} cluster labeling updated in
#' \code{colData(inSCE)[[clusterName]]}.
#' @export
#' @examples
#' data("mouseBrainSubsetSCE")
#' mouseBrainSubsetSCE <- runKMeans(mouseBrainSubsetSCE,
#'                                  useReducedDim = "PCA_logcounts",
#'                                  nCenters = 2)
runKMeans <- function(inSCE, nCenters, useReducedDim = "PCA",
                      clusterName = "KMeans_cluster", nComp = 10, nIter = 10,
                      nStart = 1, seed = 12345,
                      algorithm = c("Hartigan-Wong", "Lloyd", "MacQueen")){
    if (!inherits(inSCE, "SingleCellExperiment")) {
        stop("'inSCE' should be a SingleCellExperiment object.")
    }
    if (is.null(useReducedDim)) {
        stop("runKMeans requires 'useReducedDim' input.")
    }
    if (!useReducedDim %in% SingleCellExperiment::reducedDimNames(inSCE)) {
        stop("Specified reducedDim '", useReducedDim, "' not found.")
    }
    algorithm <- match.arg(algorithm)
    message(date(), " ... Running 'KMeans clustering' with ", algorithm,
            " algorithm.")
    mat <- SingleCellExperiment::reducedDim(inSCE, useReducedDim)
    if (nComp < ncol(mat)) {
        mat <- mat[,seq(nComp)]
    }
    withr::with_seed(seed, {
        clust.kmeans <- stats::kmeans(mat, centers = nCenters, iter.max = nIter,
                                  nstart = nStart, algorithm = algorithm)
    })
    clust.kmeans <- .relabelClusterBySize(clust.kmeans$cluster)
    SummarizedExperiment::colData(inSCE)[[clusterName]] <- clust.kmeans
    message(date(), " ...   Identified ", length(levels(clust.kmeans)),
            " clusters")
    return(inSCE)
}

#' Reassign cluster label by group size
#' @param x categorical vector, factor
#' @return factor
#' @noRd
.relabelClusterBySize <- function(x) {
    x <- as.numeric(x)
    count <- as.data.frame(table(x))
    order <- order(count$Freq, decreasing = TRUE)
    count$newLabel <- numeric(nrow(count))
    count$newLabel[order] <- seq(nrow(count))
    assign.list <- vapply(count$x, function(c) x == c, logical(length(x)))
    for (i in seq_along(count$x)) {
        # Be clear that `i` is the n'th row in `count`,
        # but not necessarily cluster i in `x`.
        x[assign.list[,i]] <- count$newLabel[i]
    }
    x <- factor(x, levels = seq(nrow(count)))
    return(x)
}

# Clustering Functions
library(singleCellTK)
context("Testing DEG functions")
data(scExample, package = "singleCellTK")
sce <- subsetSCECols(sce, colData = 'type != "EmptyDroplet"')
sce <- scaterlogNormCounts(sce, "logcounts")
sce <- scaterPCA(sce, useFeatureSubset = NULL)
altExp(sce, "hvg") <- sce

test_that(desc = "Testing Scran SNN with Assay", {
  sce <- runScranSNN(sce, useReducedDim = NULL, k = 8, weightType = "rank", useAssay = "logcounts",
                     clusterName = "logcounts_cluster")

  testthat::expect_true("logcounts_cluster" %in% names(colData(sce)))
})

test_that(desc = "Testing Scran SNN with PCA", {
  sce <- runScranSNN(sce, useReducedDim = "PCA",
                     clusterName = "PCA_cluster")

  testthat::expect_true("PCA_cluster" %in% names(colData(sce)))
})

test_that(desc = "Testing Scran SNN with altExp", {
  sce <- runScranSNN(sce, useReducedDim = NULL, useAltExp = "hvg", altExpAssay = "logcounts",
                     clusterName = "hvg_cluster", k = 8, weightType = "rank")

  testthat::expect_true("hvg_cluster" %in% names(colData(sce)))
})

test_that(desc = "Testing KMeans", {
  sce <- runKMeans(sce, nCenters = 2)

  testthat::expect_true("KMeans_cluster" %in% names(colData(sce)))
})

#' @title Plots for runPerCellQC outputs.
#' @description A wrapper function which visualizes outputs from the
#'  runPerCellQC function stored in the colData slot of the SingleCellExperiment
#'  object via various plots.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object with saved
#' dimension reduction components or a variable with saved results from
#' \code{\link{runPerCellQC}}. Required.
#' @param sample Character vector or colData variable name. Indicates which
#' sample each cell belongs to. Default \code{NULL}.
#' @param groupBy Groupings for each numeric value. Users may input a vector
#' equal length to the number of the samples in \code{inSCE}, or can be
#' retrieved from the colData slot. Default \code{NULL}.
#' @param violin Boolean. If \code{TRUE}, will plot the violin plot. Default
#' \code{TRUE}.
#' @param boxplot Boolean. If \code{TRUE}, will plot boxplots for each violin
#' plot. Default \code{FALSE}.
#' @param dots Boolean. If \code{TRUE}, will plot dots for each violin plot.
#' Default \code{TRUE}.
#' @param dotSize Size of dots. Default \code{0.5}.
#' @param summary Adds a summary statistic, as well as a crossbar to the
#' violin plot. Options are \code{"mean"} or \code{"median"}. Default
#' \code{"median"}.
#' @param summaryTextSize The text size of the summary statistic displayed
#' above the violin plot. Default \code{3}.
#' @param baseSize The base font size for all text. Default \code{15}.
#' Can be overwritten by \code{titleSize}, \code{axisSize}, and
#' \code{axisLabelSize}.
#' @param titleSize Size of title of plot. Default \code{NULL}.
#' @param axisSize Size of x/y-axis ticks. Default \code{NULL}.
#' @param axisLabelSize Size of x/y-axis labels. Default \code{NULL}.
#' @param transparency Transparency of the dots, values will be 0-1. Default \code{1}.
#' @param defaultTheme Removes grid in plot and sets axis title size to
#' \code{10} when \code{TRUE}. Default \code{TRUE}.
#' @param combinePlot Must be either \code{"all"}, \code{"sample"}, or
#' \code{"none"}. \code{"all"} will combine all plots into a single ggplot
#' object, while \code{"sample"} will output a list of plots separated by
#' sample. Default \code{"all"}.
#' @param relHeights Relative heights of plots when combine is set. Default
#' \code{1}.
#' @param relWidths Relative widths of plots when combine is set. Default
#' \code{1}.
#' @param labelSamples Will label sample name in title of plot if \code{TRUE}.
#' Default \code{TRUE}.
#' @param plotNCols Number of columns when plots are combined in a grid. Default
#' \code{NULL}.
#' @param plotNRows Number of rows when plots are combined in a grid. Default
#' \code{NULL}.
#' @param samplePerColumn If \code{TRUE}, when there are multiple samples and
#' combining by \code{"all"}, the output .ggplot will have plots from each
#' sample on a single column. Default \code{TRUE}.
#' @param sampleRelHeights If there are multiple samples and combining by
#' \code{"all"}, the relative heights for each plot. Default \code{1}.
#' @param sampleRelWidths If there are multiple samples and combining by
#' \code{"all"}, the relative widths for each plot. Default \code{1}.
#' @return list of .ggplot objects
#' @seealso \code{\link{runPerCellQC}}
#' @examples
#' data(scExample, package = "singleCellTK")
#' sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
#' sce <- runPerCellQC(sce)
#' plotRunPerCellQCResults(inSCE = sce)
#' @export
plotRunPerCellQCResults <- function(inSCE,
                                    sample = NULL,
                                    groupBy = NULL,
                                    combinePlot = "all",
                                    violin = TRUE,
                                    boxplot = FALSE,
                                    dots = TRUE,
                                    dotSize = 0.5,
                                    summary = "median",
                                    summaryTextSize = 3,
                                    baseSize = 15,
                                    axisSize = NULL,
                                    axisLabelSize = NULL,
                                    transparency = 1,
                                    defaultTheme = TRUE,
                                    titleSize = NULL,
                                    relHeights = 1,
                                    relWidths = 1,
                                    labelSamples = TRUE,
                                    plotNCols = NULL,
                                    plotNRows = NULL,
                                    samplePerColumn = TRUE,
                                    sampleRelHeights = 1,
                                    sampleRelWidths = 1) {
  sample <- .manageCellVar(inSCE, var = sample)
  if (is.null(sample)) {
    sample = rep(1, ncol(inSCE))
  }
  samples <- unique(sample)

  if(combinePlot == "sample" && length(samples) == 1){
    warning("'combinePlot' was set to 'sample' but the sample was not set,
            or there is only one type of sample specified.")
    combinePlot = "all"
  }

  if (length(samples) > 1) {
    combined.sum <- plotSCEViolinColData(
      inSCE=inSCE,
      coldata="sum",
      groupBy=sample,
      xlab="",
      ylab="Counts",
      violin=violin,
      boxplot=boxplot,
      dots=dots,
      transparency=transparency,
      title="Total counts per cell",
      dotSize=dotSize,
      baseSize=baseSize,
      axisSize=axisSize,
      axisLabelSize=axisLabelSize,
      gridLine=TRUE,
      summary=summary,
      summaryTextSize=summaryTextSize,
      titleSize=titleSize,
      combinePlot = "all",
      plotLabels = "none"
    )

    combined.detected <- plotSCEViolinColData(
      inSCE=inSCE,
      coldata="detected",
      groupBy=sample,
      xlab="",
      ylab="Features",
      violin=violin,
      boxplot=boxplot,
      dots=dots,
      transparency=transparency,
      title="Total features detected per cell",
      dotSize=dotSize,
      baseSize=baseSize,
      axisSize=axisSize,
      axisLabelSize=axisLabelSize,
      gridLine=TRUE,
      summary=summary,
      summaryTextSize=summaryTextSize,
      titleSize=titleSize,
      combinePlot = "all",
      plotLabels = "none"
    )
    combined.toppercent <- plotSCEViolinColData(
      inSCE=inSCE,
      coldata="percent.top_50",
      groupBy=sample,
      xlab="",
      ylab="Gene expression percentage (%)",
      violin=violin,
      boxplot=boxplot,
      dots=dots,
      transparency=transparency,
      title="Top 50 gene expression percentage",
      dotSize=dotSize,
      baseSize=baseSize,
      axisSize=axisSize,
      axisLabelSize=axisLabelSize,
      gridLine=TRUE,
      summary=summary,
      summaryTextSize=summaryTextSize,
      titleSize=titleSize,
      combinePlot = "all",
      plotLabels = "none"
    )

    merged.plots <- list(combined.sum, combined.detected, combined.toppercent)
    names(merged.plots) <- c("Sum", "Detected", "TopPercent")

    if (any(grepl(pattern="subsets_",names(colData(inSCE))
    ) | grepl(pattern="mito_", names(colData(inSCE))))) {
      subsets <- grep(
        pattern="subsets_",
        names(colData(inSCE)), value=TRUE
      )
      mitos <- grep(
        pattern="mito_",
        names(colData(inSCE)), value=TRUE
      )
      subsets <- c(subsets, mitos)

      combined.subset <- lapply(subsets, function(x) {
        plotSCEViolinColData(
          inSCE=inSCE,
          coldata=x,
          groupBy = sample,
          xlab="",
          ylab=x,
          violin=violin,
          boxplot=boxplot,
          dots=dots,
          transparency=transparency,
          baseSize=baseSize,
          axisSize=axisSize,
          axisLabelSize=axisLabelSize,
          title=paste0(x, " per cell"),
          dotSize=dotSize,
          titleSize=titleSize,
          summary=summary,
          summaryTextSize=summaryTextSize,
          combinePlot = "all",
          plotLabels = "none"
        )
      })
      names(combined.subset) <- subsets
      merged.plots <- c(merged.plots, combined.subset)
    } else {
      combined.subset <- NULL
    }

    merged.plots <- list(Violin = merged.plots)
  }

  res.list <- c()
  plotlist <- lapply(samples, function(x) {
    sampleInd <- which(sample == x)
    sampleSub <- sample[sampleInd]
    inSCESub <- inSCE[, sampleInd]

    if(combinePlot == "sample" | combinePlot == "none" | length(samples) == 1){
      title = "Total counts per cell"
      if(labelSamples && length(samples) > 1){
        title = paste0(title, ", ", x)
      }

      if(combinePlot == "sample" | combinePlot == "all"){
        baseSize = baseSize * 0.5
      }
      violin.sum <- list(sum = plotSCEViolinColData(
        inSCE=inSCESub,
        coldata="sum",
        sample=sampleSub,
        xlab="",
        ylab="Counts",
        groupBy=groupBy,
        violin=violin,
        boxplot=boxplot,
        dots=dots,
        transparency=transparency,
        title=title,
        dotSize=dotSize,
        baseSize=baseSize,
        axisSize=axisSize,
        axisLabelSize=axisLabelSize,
        summary=summary,
        summaryTextSize=summaryTextSize,
        titleSize=titleSize,
        combinePlot="all"
      ))
      res.list <- c(res.list, violin.sum)

      title = "Total features detected per cell"
      if(labelSamples && length(samples) > 1){
        title = paste0(title, ", ", x)
      }
      violin.detected <- list(detected = plotSCEViolinColData(
        inSCE=inSCESub,
        coldata="detected",
        sample=sampleSub,
        xlab="",
        ylab="Features",
        groupBy=groupBy,
        violin=violin,
        boxplot=boxplot,
        dots=dots,
        transparency=transparency,
        title=title,
        dotSize=dotSize,
        baseSize=baseSize,
        axisSize=axisSize,
        axisLabelSize=axisLabelSize,
        summary=summary,
        summaryTextSize=summaryTextSize,
        titleSize=titleSize,
        combinePlot="all"
      ))
      res.list <- c(res.list, violin.detected)

      topPattern <- grep(
        pattern="percent.top_50$",
        names(colData(inSCESub)), value=TRUE
      )
      title = "Top 50 gene expression percentage"
      if(labelSamples && length(samples) > 1){
        title = paste0(title, ", ", x)
      }
      violin.toppercent <- list(toppercent = plotSCEViolinColData(
        inSCE=inSCESub,
        coldata=topPattern,
        sample=sampleSub,
        xlab="",
        ylab="Gene expression percentage (%)",
        groupBy=groupBy,
        violin=violin,
        boxplot=boxplot,
        dots=dots,
        transparency=transparency,
        title=title,
        dotSize=dotSize,
        baseSize=baseSize,
        axisSize=axisSize,
        axisLabelSize=axisLabelSize,
        summary=summary,
        summaryTextSize=summaryTextSize,
        titleSize=titleSize,
        combinePlot="all"
      ))
      res.list <- c(res.list, violin.toppercent)
      names(res.list) <- c("Sum", "Detected", "TopPercent")

      if (any(grepl(pattern="subsets_", names(colData(inSCESub))) |
              grepl(pattern="mito_", names(colData(inSCESub))))) {
        subsets <- grep(
          pattern="subsets_",
          names(colData(inSCESub)), value=TRUE
        )
        mitos <- grep(
          pattern="mito_",
          names(colData(inSCESub)), value=TRUE
        )
        subsets <- c(subsets, mitos)

        violin.subset <- lapply(subsets, function(y) {
          title = paste0(y, " per cell")
          if(labelSamples && length(samples) > 1){
            title = paste0(title, ", ", x)
          }
          plotSCEViolinColData(
            inSCE=inSCESub,
            coldata=y,
            sample=sampleSub,
            xlab="",
            ylab=y,
            groupBy=groupBy,
            violin=violin,
            boxplot=boxplot,
            dots=dots,
            transparency=transparency,
            baseSize=baseSize,
            axisSize=axisSize,
            axisLabelSize=axisLabelSize,
            title=title,
            dotSize=dotSize,
            titleSize=titleSize,
            summary=summary,
            summaryTextSize=summaryTextSize,
            combinePlot="all"
          )
        })
        names(violin.subset) <- subsets
      } else {
        violin.subset <- NULL
      }

      if (!is.null(violin.subset)) {
        res.list <- c(res.list, violin.subset)
      }
    }

    return(res.list)
  })

  if (length(unique(samples)) > 1) {
    names(plotlist) <- samples
    if (combinePlot == "all") {
      plotlist <- c(merged.plots)
    } else if (combinePlot == "sample") {
      plotlist <- c(merged.plots, list(Sample = plotlist))
    } else if (combinePlot == "none") {
      plotlist <- c(merged.plots, list(Sample = plotlist))
    }
  } else {
    plotlist <- unlist(plotlist, recursive = FALSE)
    relHeights <- 1
  }

  if (!is.null(combinePlot)) {
    if (combinePlot %in% c("all", "sample")) {
      plotlist <- .ggSCTKCombinePlots(plotlist, combinePlot = combinePlot,
                                      relHeights = relHeights,
                                      relWidths = relWidths,
                                      nrows = plotNRows,
                                      ncols = plotNCols,
                                      labels = "none",
                                      samplePerColumn = samplePerColumn,
                                      sampleRelHeights = sampleRelHeights,
                                      sampleRelWidths = sampleRelWidths)
    }
  }
  return(plotlist)
}

#' @title Plots for runEmptyDrops outputs.
#' @description A wrapper function which visualizes outputs from the
#' \code{\link{runEmptyDrops}} function stored in the \code{colData} slot of the
#' \linkS4class{SingleCellExperiment} object.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object with saved
#' dimension reduction components or a variable with saved results from
#' \code{\link{runEmptyDrops}}. Required.
#' @param sample Character vector or colData variable name. Indicates which
#' sample each cell belongs to. Default \code{NULL}.
#' @param defaultTheme Removes grid in plot and sets axis title size to
#' \code{10} when \code{TRUE}. Default \code{TRUE}.
#' @param fdrCutoff Numeric. Thresholds barcodes based on the FDR values from
#' \code{\link{runEmptyDrops}} as "Empty Droplet" or "Putative Cell". Default
#' \code{0.01}.
#' @param dotSize Size of dots. Default \code{0.5}.
#' @param titleSize Size of title of plot. Default \code{18}.
#' @param axisSize Size of x/y-axis ticks. Default \code{15}.
#' @param axisLabelSize Size of x/y-axis labels. Default \code{18}.
#' @param legendSize size of legend. Default \code{15}.
#' @param legendTitleSize size of legend title. Default \code{16}.
#' @param combinePlot Must be either \code{"all"}, \code{"sample"}, or object,
#' \code{"none"}. \code{"all"} will combine all plots into a single .ggplot
#' while \code{"sample"} will output a list of plots separated by sample.
#' Default \code{"all"}.
#' @param relHeights Relative heights of plots when combine is set. Default
#' \code{1}.
#' @param relWidths Relative widths of plots when combine is set. Default
#' \code{1}.
#' @param samplePerColumn If \code{TRUE}, when there are multiple samples and
#' combining by \code{"all"}, the output .ggplot will have plots from each
#' sample on a single column. Default \code{TRUE}.
#' @param sampleRelHeights If there are multiple samples and combining by
#' \code{"all"}, the relative heights for each plot. Default \code{1}.
#' @param sampleRelWidths If there are multiple samples and combining by
#' \code{"all"}, the relative widths for each plot. Default \code{1}.
#' @return list of .ggplot objects
#' @seealso \code{\link{runEmptyDrops}}, \code{\link{plotEmptyDropsScatter}}
#' @examples
#' data(scExample, package = "singleCellTK")
#' sce <- runEmptyDrops(inSCE = sce)
#' plotEmptyDropsResults(inSCE = sce)
#' @export
plotEmptyDropsResults <- function(inSCE,
                                  sample = NULL,
                                  combinePlot = "all",
                                  fdrCutoff = 0.01,
                                  defaultTheme = TRUE,
                                  dotSize = 0.5,
                                  titleSize = 18,
                                  axisLabelSize = 18,
                                  axisSize = 15,
                                  legendSize = 15,
                                  legendTitleSize = 16,
                                  relHeights = 1,
                                  relWidths = 1,
                                  samplePerColumn = TRUE,
                                  sampleRelHeights = 1,
                                  sampleRelWidths = 1) {
  scatterEmptyDrops <- plotEmptyDropsScatter(
    inSCE,
    sample = sample,
    combinePlot = combinePlot,
    fdrCutoff = fdrCutoff,
    dotSize = dotSize,
    title = "EmptyDrops, Total UMI counts vs Log-Probability",
    titleSize = titleSize,
    defaultTheme = TRUE,
    xlab = "Total UMI count",
    ylab = "-Log Probability",
    axisLabelSize = axisLabelSize,
    axisSize = axisSize,
    legendTitle = paste0("Cutoff:\nFDR < ", fdrCutoff),
    legendTitleSize = legendTitleSize,
    legendSize = legendSize,
    relHeights = relHeights,
    relWidths = relWidths,
    samplePerColumn = samplePerColumn,
    sampleRelHeights = sampleRelHeights,
    sampleRelWidths = sampleRelWidths
  )

  res.list <- list(scatterEmptyDrops)
  names(res.list) <- c("scatterEmptyDrops")
  return(res.list)
}

#' @title Plots for runBarcodeRankDrops outputs.
#' @description A wrapper function which visualizes outputs from the
#' \code{runBarcodeRankDrops} function stored in the \code{metadata} slot of
#' the \linkS4class{SingleCellExperiment} object.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object with saved
#' dimension reduction components or a variable with saved results from
#' \code{\link{runBarcodeRankDrops}}. Required.
#' @param sample Character vector or colData variable name. Indicates which
#' sample each cell belongs to. Default \code{NULL}.
#' @param defaultTheme Removes grid in plot and sets axis title size to
#' \code{10} when \code{TRUE}. Default \code{TRUE}.
#' @param dotSize Size of dots. Default \code{0.5}.
#' @param titleSize Size of title of plot. Default \code{18}.
#' @param axisSize Size of x/y-axis ticks. Default \code{15}.
#' @param axisLabelSize Size of x/y-axis labels. Default \code{18}.
#' @param legendSize size of legend. Default \code{15}.
#' @return list of .ggplot objects
#' @examples
#' data(scExample, package = "singleCellTK")
#' sce <- runBarcodeRankDrops(inSCE = sce)
#' plotBarcodeRankDropsResults(inSCE = sce)
#' @export
plotBarcodeRankDropsResults <- function(inSCE,
                                        sample = NULL,
                                        defaultTheme = TRUE,
                                        dotSize = 0.5,
                                        titleSize = 18,
                                        axisSize = 15,
                                        axisLabelSize = 18,
                                        legendSize = 15) {
  scatterBarcodeRank <- plotBarcodeRankScatter(inSCE,
                                               sample = sample,
                                               dotSize = dotSize,
                                               title = "BarcodeRanks Rank Plot",
                                               titleSize = titleSize,
                                               defaultTheme = TRUE,
                                               axisLabelSize = axisLabelSize,
                                               axisSize = axisSize,
                                               legendSize = legendSize
  )

  res.list <- list(scatterBarcodeRank)
  names(res.list) <- c("scatterBarcodeRank")
  return(res.list)
}

#' @title Plots for runScrublet outputs.
#' @description A wrapper function which visualizes outputs from the
#'  runScrublet function stored in the colData slot of the SingleCellExperiment
#'  object via various plots.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object with saved
#' dimension reduction components or a variable with saved results from
#' \code{\link{runCxds}}. Required.
#' @param sample Character vector or colData variable name. Indicates which
#' sample each cell belongs to. Default \code{NULL}.
#' @param shape If provided, add shapes based on the value. Default \code{NULL}.
#' @param groupBy Groupings for each numeric value. A user may input a vector
#' equal length to the number of the samples in \code{inSCE}, or can be
#' retrieved from the colData slot. Default \code{NULL}.
#' @param violin Boolean. If \code{TRUE}, will plot the violin plot. Default
#' \code{TRUE}.
#' @param boxplot Boolean. If \code{TRUE}, will plot boxplots for each violin
#' plot. Default \code{TRUE}.
#' @param dots Boolean. If \code{TRUE}, will plot dots for each violin plot.
#' Default \code{TRUE}.
#' @param reducedDimName Saved dimension reduction name in \code{inSCE}.
#' Default \code{"UMAP"}.
#' @param xlab Character vector. Label for x-axis. Default \code{NULL}.
#' @param ylab Character vector. Label for y-axis. Default \code{NULL}.
#' @param dim1 1st dimension to be used for plotting. Can either be a string
#' which specifies the name of the dimension to be plotted from reducedDims, or
#' a numeric value which specifies the index of the dimension to be plotted.
#' Default is \code{NULL}.
#' @param dim2 2nd dimension to be used for plotting. Similar to \code{dim1}.
#' Default is \code{NULL}.
#' @param bin Numeric vector. If single value, will divide the numeric values
#' into \code{bin} groups. If more than one value, will bin numeric values using
#' values as a cut point. Default \code{NULL}.
#' @param binLabel Character vector. Labels for the bins created by \code{bin}.
#' Default \code{NULL}.
#' @param defaultTheme Removes grid in plot and sets axis title size to
#' \code{10} when \code{TRUE}. Default \code{TRUE}.
#' @param dotSize Size of dots. Default \code{0.5}.
#' @param summary Adds a summary statistic, as well as a crossbar to the
#' violin plot. Options are \code{"mean"} or \code{"median"}. Default
#' \code{NULL}.
#' @param summaryTextSize The text size of the summary statistic displayed
#' above the violin plot. Default \code{3}.
#' @param transparency Transparency of the dots, values will be 0-1. Default
#' \code{1}.
#' @param baseSize The base font size for all text. Default \code{12}.
#' Can be overwritten by \code{titleSize}, \code{axisSize}, and
#' \code{axisLabelSize}, \code{legendSize}, \code{legendTitleSize}.
#' @param titleSize Size of title of plot. Default \code{NULL}.
#' @param axisSize Size of x/y-axis ticks. Default \code{NULL}.
#' @param axisLabelSize Size of x/y-axis labels. Default \code{NULL}.
#' @param legendSize size of legend. Default \code{NULL}.
#' @param legendTitleSize size of legend title. Default \code{NULL}.
#' @param combinePlot Must be either \code{"all"}, \code{"sample"}, or
#' \code{"none"}. \code{"all"} will combine all plots into a single .ggplot
#' object, while \code{"sample"} will output a list of plots separated by
#' sample. Default \code{"all"}.
#' @param relHeights Relative heights of plots when combine is set. Default
#' \code{1}.
#' @param relWidths Relative widths of plots when combine is set. Default
#' \code{c(1, 1, 1)}.
#' @param plotNCols Number of columns when plots are combined in a grid. Default
#' \code{NULL}.
#' @param plotNRows Number of rows when plots are combined in a grid. Default
#' \code{NULL}.
#' @param labelSamples Will label sample name in title of plot if TRUE. Default
#' \code{TRUE}.
#' @param samplePerColumn If \code{TRUE}, when there are multiple samples and
#' combining by \code{"all"}, the output .ggplot will have plots from each
#' sample on a single column. Default \code{TRUE}.
#' @param sampleRelHeights If there are multiple samples and combining by
#' \code{"all"}, the relative heights for each plot. Default \code{1}.
#' @param sampleRelWidths If there are multiple samples and combining by
#' \code{"all"}, the relative widths for each plot. Default \code{1}.
#' @return list of .ggplot objects
#' @seealso \code{\link{runScrublet}}
#' @examples
#' data(scExample, package="singleCellTK")
#' \dontrun{
#' sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
#' sce <- runQuickUMAP(sce)
#' sce <- runScrublet(sce)
#' plotScrubletResults(inSCE=sce, reducedDimName="UMAP")
#' }
#' @export
plotScrubletResults <- function(
    inSCE,
    reducedDimName,
    sample = NULL,
    shape = NULL,
    groupBy = NULL,
    combinePlot = "all",
    violin = TRUE,
    boxplot = FALSE,
    dots = TRUE,
    xlab = NULL,
    ylab = NULL,
    dim1 = NULL,
    dim2 = NULL,
    bin = NULL,
    binLabel = NULL,
    defaultTheme = TRUE,
    dotSize = 0.5,
    summary = "median",
    summaryTextSize = 3,
    transparency = 1,
    baseSize = 15,
    titleSize = NULL,
    axisLabelSize = NULL,
    axisSize = NULL,
    legendSize = NULL,
    legendTitleSize = NULL,
    relHeights = 1,
    relWidths = c(1, 1, 1),
    plotNCols = NULL,
    plotNRows = NULL,
    labelSamples = TRUE,
    samplePerColumn = TRUE,
    sampleRelHeights = 1,
    sampleRelWidths = 1
) {
  sample <- .manageCellVar(inSCE, var = sample)
  if (is.null(sample)) {
    sample = rep(1, ncol(inSCE))
  }
  samples <- unique(sample)
  if (length(samples) > 1) {
    merged.plots <- list(
      Score = plotSCEViolinColData(
        inSCE = inSCE,
        coldata = "scrublet_score",
        groupBy = sample,
        xlab = "",
        ylab = "Doublet Score",
        violin = violin,
        boxplot = boxplot,
        dots = dots,
        transparency = transparency,
        baseSize = baseSize,
        title = "Scrublet Score",
        titleSize = titleSize,
        dotSize = dotSize,
        axisSize = axisSize,
        axisLabelSize = axisLabelSize,
        gridLine = TRUE,
        summary = summary,
        summaryTextSize = summaryTextSize,
        combinePlot = "all",
        plotLabels = "none"
      )
    )
    merged.plots <- list(merged.plots)
    names(merged.plots) <- "Violin"
  }

  res.list <- list()
  plotlist <- lapply(samples, function(x) {
    sampleInd <- which(sample == x)
    sampleSub <- sample[sampleInd]
    inSCESub <- inSCE[, sampleInd]

    if (combinePlot == "sample" | combinePlot == "all") {
      baseSize = baseSize * 0.5
    }

    title = "Density, Scrublet Score"
    if (labelSamples && length(samples) > 1) {
      title = paste0(title, ", ", x)
    }
    densityScore <- list(
      density_doubletScore = plotSCEDensityColData(
        inSCE = inSCESub,
        sample = sampleSub,
        coldata = "scrublet_score",
        groupBy = groupBy,
        xlab = "Score",
        ylab = "Density",
        baseSize = baseSize,
        axisSize = axisSize,
        axisLabelSize = axisLabelSize,
        defaultTheme = defaultTheme,
        title = title,
        titleSize = titleSize,
        combinePlot = "all"
      )
    )
    res.list <- c(res.list, densityScore)

    title = "Scrublet Doublet Score"
    if (labelSamples && length(samples) > 1) {
      title = paste0(title, ", ", x)
    }
    scatterScore <- list(
      scatter_doubletScore = plotSCEDimReduceColData(
        inSCE = inSCESub,
        sample = sampleSub,
        colorBy = "scrublet_score",
        conditionClass = "numeric",
        shape = shape,
        reducedDimName = reducedDimName,
        xlab = xlab,
        ylab = ylab,
        dim1 = dim1,
        dim2 = dim2,
        bin = bin,
        binLabel = binLabel,
        dotSize = dotSize,
        transparency = transparency,
        baseSize = baseSize,
        defaultTheme = defaultTheme,
        title = title,
        titleSize = titleSize,
        axisSize = axisSize,
        axisLabelSize = axisLabelSize,
        labelClusters = FALSE,
        legendTitle = "Doublet \nScore",
        legendSize = legendSize,
        legendTitleSize = legendTitleSize,
        combinePlot = "all"
      )
    )
    res.list <- c(res.list, scatterScore)

    if (combinePlot != "all" | length(samples) == 1) {
      title = "Scrublet Score"
      if (labelSamples && length(samples) > 1) {
        title = paste0(title, ", ", x)
      }

      violinScore <- list(
        violin_doubletScore = plotSCEViolinColData(
          inSCE = inSCESub,
          coldata = "scrublet_score",
          sample = sampleSub,
          xlab = "",
          ylab = "Doublet Score",
          groupBy = groupBy,
          violin = violin,
          boxplot = boxplot,
          dots = dots,
          transparency = transparency,
          baseSize = baseSize,
          defaultTheme = defaultTheme,
          title = title,
          titleSize = titleSize,
          dotSize = dotSize,
          axisSize = axisSize,
          axisLabelSize = axisLabelSize,
          summary = summary,
          summaryTextSize = summaryTextSize,
          combinePlot = "all"
        )
      )
      res.list <- c(res.list, violinScore)
    }

    title = "Scrublet Doublet Assignment"
    if (labelSamples && length(samples) > 1) {
      title = paste0(title, ", ", x)
    }
    scatterCall <- list(
      scatter_doubletCall = plotSCEDimReduceColData(
        inSCE = inSCESub,
        sample = sampleSub,
        colorBy = "scrublet_call",
        conditionClass = "factor",
        shape = shape,
        reducedDimName = reducedDimName,
        xlab = xlab,
        ylab = ylab,
        dim1 = dim1,
        dim2 = dim2,
        bin = bin,
        binLabel = binLabel,
        dotSize = dotSize,
        transparency = transparency,
        baseSize = baseSize,
        colorScale = c("lightgray","red"),
        defaultTheme = defaultTheme,
        title = title,
        titleSize = titleSize,
        axisSize = axisSize,
        axisLabelSize = axisLabelSize,
        labelClusters = FALSE,
        legendTitle = "Doublet \nAssignment",
        legendTitleSize = legendTitleSize,
        legendSize = legendSize,
        combinePlot = "all"
      )
    )
    res.list <- c(res.list, scatterCall)

    return(res.list)
  })

  if (length(unique(samples)) > 1) {
    names(plotlist) <- samples
    plotlist <- c(merged.plots, list(Sample = plotlist))
  } else {
    plotlist <- unlist(plotlist, recursive = FALSE)
    plotLabels <- "none"
    relHeights <- 1
  }

  if (!is.null(combinePlot)) {
    if (combinePlot %in% c("all", "sample")) {
      plotlist <- .ggSCTKCombinePlots(plotlist, combinePlot = combinePlot,
                                      relHeights = relHeights,
                                      relWidths = relWidths,
                                      ncols = plotNCols,
                                      nrows = plotNRows,
                                      samplePerColumn = samplePerColumn,
                                      sampleRelHeights = sampleRelHeights,
                                      sampleRelWidths = sampleRelWidths)
    }
  }

  return(plotlist)
}

#' @title Plots for runDoubletFinder outputs.
#' @description A wrapper function which visualizes outputs from the
#'  runDoubletFinder function stored in the colData slot of the
#'  SingleCellExperiment object via various plots.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object with saved
#' dimension reduction components or a variable with saved results from
#' \code{\link{runDoubletFinder}}. Required.
#' @param sample Character vector or colData variable name. Indicates which
#' sample each cell belongs to. Default \code{NULL}.
#' @param shape If provided, add shapes based on the value. Default \code{NULL}.
#' @param groupBy Groupings for each numeric value. A user may input a vector
#' equal length to the number of the samples in \code{inSCE}, or can be
#' retrieved from the colData slot. Default \code{NULL}.
#' @param violin Boolean. If \code{TRUE}, will plot the violin plot. Default
#' \code{TRUE}.
#' @param boxplot Boolean. If \code{TRUE}, will plot boxplots for each violin
#' plot. Default \code{TRUE}.
#' @param dots Boolean. If \code{TRUE}, will plot dots for each violin plot.
#' Default \code{TRUE}.
#' @param reducedDimName Saved dimension reduction name in \code{inSCE}.
#' Default \code{"UMAP"}.
#' @param xlab Character vector. Label for x-axis. Default \code{NULL}.
#' @param ylab Character vector. Label for y-axis. Default \code{NULL}.
#' @param dim1 1st dimension to be used for plotting. Can either be a string
#' which specifies the name of the dimension to be plotted from reducedDims, or
#' a numeric value which specifies the index of the dimension to be plotted.
#' Default is \code{NULL}.
#' @param dim2 2nd dimension to be used for plotting. Similar to \code{dim1}.
#' Default is \code{NULL}.
#' @param bin Numeric vector. If single value, will divide the numeric values
#' into \code{bin} groups. If more than one value, will bin numeric values using
#' values as a cut point. Default \code{NULL}.
#' @param binLabel Character vector. Labels for the bins created by \code{bin}.
#' Default \code{NULL}.
#' @param defaultTheme Removes grid in plot and sets axis title size to
#' \code{10} when \code{TRUE}. Default \code{TRUE}.
#' @param dotSize Size of dots. Default \code{0.5}.
#' @param summary Adds a summary statistic, as well as a crossbar to the
#' violin plot. Options are \code{"mean"} or \code{"median"}. Default
#' \code{NULL}.
#' @param summaryTextSize The text size of the summary statistic displayed
#' above the violin plot. Default \code{3}.
#' @param transparency Transparency of the dots, values will be 0-1. Default
#' \code{1}.
#' @param baseSize The base font size for all text. Default \code{12}.
#' Can be overwritten by \code{titleSize}, \code{axisSize}, and
#' \code{axisLabelSize}, \code{legendSize}, \code{legendTitleSize}.
#' @param titleSize Size of title of plot. Default \code{NULL}.
#' @param axisSize Size of x/y-axis ticks. Default \code{NULL}.
#' @param axisLabelSize Size of x/y-axis labels. Default \code{NULL}.
#' @param legendSize size of legend. Default \code{NULL}.
#' @param legendTitleSize size of legend title. Default \code{NULL}.
#' @param combinePlot Must be either \code{"all"}, \code{"sample"}, or
#' \code{"none"}. \code{"all"} will combine all plots into a single .ggplot
#' object, while \code{"sample"} will output a list of plots separated by
#' sample. Default \code{"all"}.
#' @param relHeights Relative heights of plots when combine is set. Default
#' \code{1}.
#' @param relWidths Relative widths of plots when combine is set. Default
#' \code{c(1, 1, 1)}.
#' @param plotNCols Number of columns when plots are combined in a grid. Default
#' \code{NULL}.
#' @param plotNRows Number of rows when plots are combined in a grid. Default
#' \code{NULL}.
#' @param labelSamples Will label sample name in title of plot if TRUE. Default
#' \code{TRUE}.
#' @param samplePerColumn If \code{TRUE}, when there are multiple samples and
#' combining by \code{"all"}, the output .ggplot will have plots from each
#' sample on a single column. Default \code{TRUE}.
#' @param sampleRelHeights If there are multiple samples and combining by
#' \code{"all"}, the relative heights for each plot. Default \code{1}.
#' @param sampleRelWidths If there are multiple samples and combining by
#' \code{"all"}, the relative widths for each plot. Default \code{1}.
#' @return list of .ggplot objects
#' @seealso \code{\link{runDoubletFinder}}
#' @examples
#' data(scExample, package="singleCellTK")
#' options(future.globals.maxSize = 786432000)
#' sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
#' sce <- runQuickUMAP(sce)
#' sce <- runDoubletFinder(sce)
#' plotDoubletFinderResults(inSCE = sce, reducedDimName = "UMAP")
#' @export
plotDoubletFinderResults <- function(
    inSCE,
    sample = NULL,
    shape = NULL,
    groupBy = NULL,
    combinePlot = "all",
    violin = TRUE,
    boxplot = FALSE,
    dots = TRUE,
    reducedDimName = "UMAP",
    xlab = NULL,
    ylab = NULL,
    dim1 = NULL,
    dim2 = NULL,
    bin = NULL,
    binLabel = NULL,
    defaultTheme = TRUE,
    dotSize = 0.5,
    summary = "median",
    summaryTextSize = 3,
    transparency = 1,
    baseSize = 15,
    titleSize = NULL,
    axisLabelSize = NULL,
    axisSize = NULL,
    legendSize = NULL,
    legendTitleSize = NULL,
    relHeights = 1,
    relWidths = c(1, 1, 1),
    plotNCols = NULL,
    plotNRows = NULL,
    labelSamples = TRUE,
    samplePerColumn = TRUE,
    sampleRelHeights = 1,
    sampleRelWidths = 1
) {
  sample <- .manageCellVar(inSCE, var = sample)
  if (is.null(sample)) {
    sample <- rep(1, ncol(inSCE))
  }
  samples <- unique(sample)

  if (!(reducedDimName %in% reducedDimNames(inSCE))) {
    stop("Specified `reducedDimName` is not found in input
         SingleCellExperiment object. Please check for spelling errors
         with reducedDimNames().")
  }

  df.scores <- grep(
    pattern = "doubletFinder_doublet_score_resolution_",
    names(colData(inSCE)), value = TRUE
  )

  df.labels <- grep(
    pattern = "doubletFinder_doublet_label_resolution_",
    names(colData(inSCE)), value = TRUE
  )
  if (length(samples) > 1) {
    merged.plots <- lapply(df.scores, function(x) {
      plotSCEViolinColData(
        inSCE = inSCE,
        coldata = x,
        sample = NULL,
        xlab = "",
        ylab = "Doublet Score",
        groupBy = sample,
        violin = violin,
        boxplot = boxplot,
        dots = TRUE,
        transparency = transparency,
        baseSize = baseSize,
        axisSize = axisSize,
        axisLabelSize = axisLabelSize,
        defaultTheme = defaultTheme,
        titleSize = titleSize,
        title = paste(
          "DoubletFinder Score Resolution",
          gsub(pattern = "doubletFinder_doublet_score_Resolution_", "", x)
        ),
        dotSize = dotSize,
        summary = summary,
        summaryTextSize = summaryTextSize,
        combinePlot = "all",
        plotLabels = "none"
      )
    })

    names(merged.plots) <- vapply(df.scores, function(x) {
      paste0("Violin_", gsub(
        pattern = "doubletFinder_doublet_score_",
        "", x = x
      ))
    }, character(1))

    # merged.plots <- list(merged.plots)
    merged.plots <- list(Violin = merged.plots)
  }

  res.list <- list()
  plotlist <- lapply(samples, function(x) {
    sampleInd <- which(sample == x)
    sampleSub <- sample[sampleInd]
    inSCESub <- inSCE[, sampleInd]

    if (combinePlot == "sample" | combinePlot == "all") {
      baseSize = baseSize * 0.5
    }

    densityScore <- lapply(df.scores, function(y) {
      title <- paste(
        "Density, Doublet Score Resolution",
        gsub("doubletFinder_doublet_score_resolution_", "", y))
      if (labelSamples && length(samples) > 1) {
        title = paste0(title, ", ", x)
      }
      plotSCEDensityColData(
        inSCE = inSCESub,
        sample = sampleSub,
        coldata = y,
        groupBy = groupBy,
        xlab = "Score",
        ylab = "Density",
        baseSize = baseSize,
        axisSize = axisSize,
        axisLabelSize = axisLabelSize,
        defaultTheme = defaultTheme,
        cutoff = 0.5,
        combinePlot = "all",
        titleSize = titleSize,
        title = title
      )
    })
    names(densityScore) <- vapply(df.scores, function(y) {
      paste0("Density_", gsub(pattern = "doubletFinder_doublet_score_", "",
                              x = y
      ))
    }, character(1))
    res.list <- c(res.list, densityScore)

    scatterScore <- lapply(df.scores, function(y) {
      title <- paste(
        "Doublet Score Resolution",
        gsub(
          pattern = "doubletFinder_doublet_score_resolution_", "", y))
      if (labelSamples && length(samples) > 1) {
        title = paste0(title, ", ", x)
      }

      plotSCEDimReduceColData(
        inSCE = inSCESub,
        sample = sampleSub,
        conditionClass = "numeric",
        shape = shape,
        colorBy = y,
        reducedDimName = reducedDimName,
        xlab = xlab,
        ylab = ylab,
        dim1 = dim1,
        dim2 = dim2,
        bin = bin,
        binLabel = binLabel,
        dotSize = dotSize,
        transparency = transparency,
        baseSize = baseSize,
        defaultTheme = defaultTheme,
        title = title,
        titleSize = titleSize,
        axisSize = axisSize,
        axisLabelSize = axisLabelSize,
        labelClusters = FALSE,
        legendTitle = "Doublet \nScore",
        legendSize = legendSize,
        legendTitleSize = legendTitleSize,
        combinePlot = "all"
      )
    })

    names(scatterScore) <- vapply(df.scores, function(y) {
      paste0("Scatter_Score_", gsub(
        pattern = "doubletFinder_doublet_score_",
        "", x = y
      ))
    }, character(1))
    res.list <- c(res.list, scatterScore)

    if (combinePlot != "all" | length(samples) == 1) {

      violinScore <- lapply(df.scores, function(y) {
        title <- paste(
          "Doublet Score Resolution",
          gsub(
            pattern = "doubletFinder_doublet_score_resolution_",
            "", y))

        if (labelSamples && length(samples) > 1) {
          title = paste0(title, ", ", x)
        }

        plotSCEViolinColData(
          inSCE = inSCESub,
          coldata = y,
          sample = sampleSub,
          xlab = "",
          ylab = "Doublet Score",
          groupBy = groupBy,
          violin = violin,
          boxplot = boxplot,
          dots = dots,
          transparency = transparency,
          baseSize = baseSize,
          defaultTheme = defaultTheme,
          summary = summary,
          summaryTextSize = summaryTextSize,
          title = title,
          titleSize = titleSize,
          dotSize = dotSize,
          axisSize = axisSize,
          axisLabelSize = axisLabelSize,
          combinePlot = "all"
        )
      })

      names(violinScore) <- vapply(df.scores, function(y) {
        paste0("violin_", gsub(
          pattern = "doubletFinder_doublet_score_",
          "", x = y
        ))
      }, character(1))
      res.list <- c(res.list, violinScore)
    }

    scatterCall <- lapply(df.labels, function(y) {
      title <- paste(
        "Doublet Call Resolution",
        gsub(
          pattern = "doubletFinder_doublet_label_resolution_",
          "", y))

      if (labelSamples && length(samples) > 1) {
        title = paste0(title, ", ", x)
      }

      plotSCEDimReduceColData(
        inSCE = inSCESub,
        sample = sampleSub,
        conditionClass = "factor",
        shape = shape,
        colorBy = y,
        reducedDimName = reducedDimName,
        xlab = xlab,
        ylab = ylab,
        dim1 = dim1,
        dim2 = dim2,
        bin = bin,
        binLabel = binLabel,
        dotSize = dotSize,
        transparency = transparency,
        baseSize = baseSize,
        colorScale = c("lightgray", "red"),
        defaultTheme = defaultTheme,
        title = title,
        titleSize = titleSize,
        axisSize = axisSize,
        axisLabelSize = axisLabelSize,
        labelClusters = FALSE,
        legendTitle = "Doublet \nAssignment",
        legendSize = legendSize,
        legendTitleSize = legendTitleSize,
        combinePlot = "all"
      )
    })

    names(scatterCall) <- vapply(df.labels, function(y) {
      paste0("Scatter_Call_", gsub(
        pattern = "doubletFinder_doublet_label_",
        "", x = y
      ))
    }, character(1))
    res.list <- c(res.list, scatterCall)
    return(res.list)
  })
  if (length(unique(samples)) > 1) {
    names(plotlist) <- samples
    plotlist <- c(merged.plots, list(Sample = plotlist))
  } else {
    plotlist <- unlist(plotlist, recursive = FALSE)
    #plotLabels <- "none"
    relHeights = 1
  }
  if (!is.null(combinePlot)) {
    if (combinePlot %in% c("all", "sample")) {
      plotlist <- .ggSCTKCombinePlots(plotlist, combinePlot = combinePlot,
                                      relHeights = relHeights,
                                      relWidths = relWidths,
                                      ncols = plotNCols,
                                      nrows = plotNRows,
                                      samplePerColumn = samplePerColumn,
                                      sampleRelHeights = sampleRelHeights,
                                      sampleRelWidths = sampleRelWidths)
    }
  }
  return(plotlist)
}

#' @title Plots for runScDblFinder outputs.
#' @description A wrapper function which visualizes outputs from the
#' \code{\link{runScDblFinder}} function stored in the colData slot of the
#' \linkS4class{SingleCellExperiment} object via various plots.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object with saved
#' dimension reduction components or a variable with saved results from
#' \code{\link{runScDblFinder}}. Required.
#' @param sample Character vector or colData variable name. Indicates which
#' sample each cell belongs to. Default \code{NULL}.
#' @param shape If provided, add shapes based on the value. Default \code{NULL}.
#' @param groupBy Groupings for each numeric value. A user may input a vector
#' equal length to the number of the samples in \code{inSCE}, or can be
#' retrieved from the colData slot. Default \code{NULL}.
#' @param violin Boolean. If \code{TRUE}, will plot the violin plot. Default
#' \code{TRUE}.
#' @param boxplot Boolean. If \code{TRUE}, will plot boxplots for each violin
#' plot. Default \code{TRUE}.
#' @param dots Boolean. If \code{TRUE}, will plot dots for each violin plot.
#' Default \code{TRUE}.
#' @param reducedDimName Saved dimension reduction name in \code{inSCE}.
#' Default \code{"UMAP"}.
#' @param xlab Character vector. Label for x-axis. Default \code{NULL}.
#' @param ylab Character vector. Label for y-axis. Default \code{NULL}.
#' @param dim1 1st dimension to be used for plotting. Can either be a string
#' which specifies the name of the dimension to be plotted from reducedDims, or
#' a numeric value which specifies the index of the dimension to be plotted.
#' Default is \code{NULL}.
#' @param dim2 2nd dimension to be used for plotting. Similar to \code{dim1}.
#' Default is \code{NULL}.
#' @param bin Numeric vector. If single value, will divide the numeric values
#' into \code{bin} groups. If more than one value, will bin numeric values using
#' values as a cut point. Default \code{NULL}.
#' @param binLabel Character vector. Labels for the bins created by \code{bin}.
#' Default \code{NULL}.
#' @param defaultTheme Removes grid in plot and sets axis title size to
#' \code{10} when \code{TRUE}. Default \code{TRUE}.
#' @param dotSize Size of dots. Default \code{0.5}.
#' @param summary Adds a summary statistic, as well as a crossbar to the
#' violin plot. Options are \code{"mean"} or \code{"median"}. Default
#' \code{NULL}.
#' @param summaryTextSize The text size of the summary statistic displayed
#' above the violin plot. Default \code{3}.
#' @param transparency Transparency of the dots, values will be 0-1. Default
#' \code{1}.
#' @param baseSize The base font size for all text. Default \code{12}.
#' Can be overwritten by \code{titleSize}, \code{axisSize}, and
#' \code{axisLabelSize}, \code{legendSize}, \code{legendTitleSize}.
#' @param titleSize Size of title of plot. Default \code{NULL}.
#' @param axisSize Size of x/y-axis ticks. Default \code{NULL}.
#' @param axisLabelSize Size of x/y-axis labels. Default \code{NULL}.
#' @param legendSize size of legend. Default \code{NULL}.
#' @param legendTitleSize size of legend title. Default \code{NULL}.
#' @param combinePlot Must be either \code{"all"}, \code{"sample"}, or
#' \code{"none"}. \code{"all"} will combine all plots into a single .ggplot
#' object, while \code{"sample"} will output a list of plots separated by
#' sample. Default \code{"all"}.
#' @param relHeights Relative heights of plots when combine is set. Default \code{1}.
#' @param relWidths Relative widths of plots when combine is set. Default
#' \code{c(1, 1, 1)}.
#' @param plotNCols Number of columns when plots are combined in a grid. Default
#' \code{NULL}.
#' @param plotNRows Number of rows when plots are combined in a grid. Default
#' \code{NULL}.
#' @param labelSamples Will label sample name in title of plot if TRUE. Default
#' \code{TRUE}.
#' @param samplePerColumn If \code{TRUE}, when there are multiple samples and combining
#' by \code{"all"}, the output .ggplot will have plots from each sample on a
#' single column. Default \code{TRUE}.
#' @param sampleRelHeights If there are multiple samples and combining by
#' \code{"all"}, the relative heights for each plot. Default \code{1}.
#' @param sampleRelWidths If there are multiple samples and combining by
#' \code{"all"}, the relative widths for each plot. Default \code{1}.
#' @return list of .ggplot objects
#' @seealso \code{\link{runScDblFinder}}
#' @examples
#' data(scExample, package="singleCellTK")
#' sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
#' sce <- runQuickUMAP(sce)
#' sce <- runScDblFinder(sce)
#' plotScDblFinderResults(inSCE = sce, reducedDimName = "UMAP")
#' @export
plotScDblFinderResults <- function(
    inSCE,
    sample = NULL,
    shape = NULL,
    groupBy = NULL,
    combinePlot = "all",
    violin = TRUE,
    boxplot = FALSE,
    dots = TRUE,
    reducedDimName = "UMAP",
    xlab = NULL,
    ylab = NULL,
    dim1 = NULL,
    dim2 = NULL,
    bin = NULL,
    binLabel = NULL,
    defaultTheme = TRUE,
    dotSize = 0.5,
    summary = "median",
    summaryTextSize = 3,
    transparency = 1,
    baseSize = 15,
    titleSize = NULL,
    axisLabelSize = NULL,
    axisSize = NULL,
    legendSize = NULL,
    legendTitleSize = NULL,
    relHeights = 1,
    relWidths = c(1, 1, 1),
    plotNCols = NULL,
    plotNRows = NULL,
    labelSamples = TRUE,
    samplePerColumn = TRUE,
    sampleRelHeights = 1,
    sampleRelWidths = 1
) {
  sample <- .manageCellVar(inSCE, var = sample)
  if (is.null(sample)) {
    sample = rep(1, ncol(inSCE))
  }

  if (!(reducedDimName %in% reducedDimNames(inSCE))){
    stop("Specified `reducedDimName` is not found in input
         SingleCellExperiment object. Please check for spelling errors
         with reducedDimNames().")
  }
  coldata = "scDblFinder_doublet_score"
  titleScDblFinder <- "ScDblFinder Doublet Score"

  samples <- unique(sample)
  if (length(samples) > 1) {
    merged.plots <- list(Score = plotSCEViolinColData(
      inSCE=inSCE,
      coldata=coldata,
      groupBy=sample,
      xlab="",
      ylab="Doublet Score",
      violin=violin,
      boxplot=boxplot,
      dots=dots,
      transparency=transparency,
      baseSize=baseSize,
      axisSize=axisSize,
      axisLabelSize=axisLabelSize,
      title=titleScDblFinder,
      titleSize=titleSize,
      dotSize=dotSize,
      gridLine=TRUE,
      summary=summary,
      summaryTextSize=summaryTextSize,
      combinePlot = "all",
      plotLabels = "none"
    ))
    merged.plots <- list(merged.plots)
    names(merged.plots) <- "Violin"
  }

  res.list <- list()
  plotlist <- lapply(samples, function(x) {
    sampleInd <- which(sample == x)
    sampleSub <- sample[sampleInd]
    inSCESub <- inSCE[, sampleInd]

    title = paste0("Density, ", titleScDblFinder)
    if(labelSamples && length(samples) > 1){
      title = paste0(title, ", ", x)
    }
    if(combinePlot == "sample" | combinePlot == "all"){
      baseSize = baseSize * 0.5
    }
    densityScore <- list(density_doubletScore = plotSCEDensityColData(
      inSCE=inSCESub,
      sample=sampleSub,
      coldata=coldata,
      groupBy=groupBy,
      xlab="Score",
      ylab="Density",
      baseSize=baseSize,
      axisSize=axisSize,
      axisLabelSize=axisLabelSize,
      defaultTheme=defaultTheme,
      title=title,
      titleSize=titleSize,
      combinePlot="all"
    ))
    res.list = c(res.list, densityScore)

    title = titleScDblFinder
    if(labelSamples && length(samples) > 1){
      title = paste0(title, ", ", x)
    }
    scatterScore <- list(scatter_doubletScore = plotSCEDimReduceColData(
      inSCE=inSCESub,
      sample=sampleSub,
      colorBy=coldata,
      conditionClass="numeric",
      shape=shape,
      reducedDimName=reducedDimName,
      xlab=xlab,
      ylab=ylab,
      dim1=dim1,
      dim2=dim2,
      bin=bin,
      binLabel=binLabel,
      dotSize=dotSize,
      colorLow="gray",
      colorHigh="blue",
      transparency=transparency,
      baseSize=baseSize,
      defaultTheme=defaultTheme,
      axisSize=axisSize,
      axisLabelSize=axisLabelSize,
      title=title,
      titleSize=titleSize,
      labelClusters=FALSE,
      legendTitle="Doublet \nScore",
      legendSize=legendSize,
      legendTitleSize=legendTitleSize,
      combinePlot="all"
    ))
    res.list = c(res.list, scatterScore)

    if("scDblFinder_doublet_call" %in% names(SingleCellExperiment::colData(inSCE))){
      title = "scDblFinder Doublet Assignment"
      if(labelSamples && length(samples) > 1){
        title = paste0(title, ", ", x)
      }
      scatterCall <- list(scatter_doubletCall = plotSCEDimReduceColData(
        inSCE=inSCESub,
        sample=sampleSub,
        colorBy="scDblFinder_doublet_call",
        conditionClass="factor",
        shape=shape,
        reducedDimName=reducedDimName,
        xlab=xlab,
        ylab=ylab,
        dim1=dim1,
        dim2=dim2,
        bin=bin,
        binLabel=binLabel,
        dotSize=dotSize,
        transparency=transparency,
        baseSize=baseSize,
        colorScale = c("lightgray","red"),
        defaultTheme=defaultTheme,
        title=title,
        titleSize=titleSize,
        axisSize=axisSize, axisLabelSize=axisLabelSize,
        labelClusters=FALSE,
        legendTitle="Doublet \nAssignment",
        legendTitleSize=legendTitleSize,
        legendSize=legendSize,
        combinePlot="all"
      ))
      res.list <- c(res.list, scatterCall)
    }

    if(combinePlot != "all" | length(samples) == 1){
      if(labelSamples && length(samples) > 1){
        title = paste0(title, ", ", x)
      }
      violinScore <- list(violin_doubletScore = plotSCEViolinColData(
        inSCE=inSCESub,
        coldata=coldata,
        sample=sampleSub,
        xlab="",
        ylab="Doublet Score",
        groupBy=groupBy,
        violin=violin,
        boxplot=boxplot,
        dots=dots,
        transparency=transparency,
        baseSize=baseSize,
        title=title,
        titleSize=titleSize,
        defaultTheme=defaultTheme,
        axisSize=axisSize,
        axisLabelSize=axisLabelSize,
        dotSize=dotSize,
        summary=summary,
        summaryTextSize=summaryTextSize,
        combinePlot="all"
      ))
      res.list = c(res.list, violinScore)
    }

    return(res.list)
  })
  if (length(unique(samples)) > 1) {
    names(plotlist) <- samples
    plotlist <- c(merged.plots, list(Sample = plotlist))
  } else {
    plotlist <- unlist(plotlist, recursive=FALSE)
    plotLabels <- "none"
    relHeights=1
  }
  if(!is.null(combinePlot)){
    if(combinePlot %in% c("all", "sample")){
      plotlist <- .ggSCTKCombinePlots(plotlist, combinePlot = combinePlot,
                                      relHeights = relHeights,
                                      relWidths = relWidths,
                                      ncols = plotNCols,
                                      nrows = plotNRows,
                                      samplePerColumn = samplePerColumn,
                                      sampleRelHeights = sampleRelHeights,
                                      sampleRelWidths = sampleRelWidths)
    }
  }
  return(plotlist)
}

#' @title Plots for runCxds outputs.
#' @description A wrapper function which visualizes outputs from the
#' \code{\link{runCxds}} function stored in the colData slot of the
#' \linkS4class{SingleCellExperiment} object via various plots.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object with saved
#' dimension reduction components or a variable with saved results from
#' \code{\link{runCxds}}. Required.
#' @param sample Character vector or colData variable name. Indicates which
#' sample each cell belongs to. Default \code{NULL}.
#' @param shape If provided, add shapes based on the value. Default \code{NULL}.
#' @param groupBy Groupings for each numeric value. A user may input a vector
#' equal length to the number of the samples in \code{inSCE}, or can be
#' retrieved from the colData slot. Default \code{NULL}.
#' @param violin Boolean. If \code{TRUE}, will plot the violin plot. Default
#' \code{TRUE}.
#' @param boxplot Boolean. If \code{TRUE}, will plot boxplots for each violin
#' plot. Default \code{TRUE}.
#' @param dots Boolean. If \code{TRUE}, will plot dots for each violin plot.
#' Default \code{TRUE}.
#' @param reducedDimName Saved dimension reduction name in \code{inSCE}.
#' Default \code{"UMAP"}.
#' @param xlab Character vector. Label for x-axis. Default \code{NULL}.
#' @param ylab Character vector. Label for y-axis. Default \code{NULL}.
#' @param dim1 1st dimension to be used for plotting. Can either be a string
#' which specifies the name of the dimension to be plotted from reducedDims, or
#' a numeric value which specifies the index of the dimension to be plotted.
#' Default is \code{NULL}.
#' @param dim2 2nd dimension to be used for plotting. Similar to \code{dim1}.
#' Default is \code{NULL}.
#' @param bin Numeric vector. If single value, will divide the numeric values
#' into \code{bin} groups. If more than one value, will bin numeric values using
#' values as a cut point. Default \code{NULL}.
#' @param binLabel Character vector. Labels for the bins created by \code{bin}.
#' Default \code{NULL}.
#' @param defaultTheme Removes grid in plot and sets axis title size to
#' \code{10} when \code{TRUE}. Default \code{TRUE}.
#' @param dotSize Size of dots. Default \code{0.5}.
#' @param summary Adds a summary statistic, as well as a crossbar to the
#' violin plot. Options are \code{"mean"} or \code{"median"}. Default
#' \code{NULL}.
#' @param summaryTextSize The text size of the summary statistic displayed
#' above the violin plot. Default \code{3}.
#' @param transparency Transparency of the dots, values will be 0-1. Default
#' \code{1}.
#' @param baseSize The base font size for all text. Default \code{12}.
#' Can be overwritten by \code{titleSize}, \code{axisSize}, and
#' \code{axisLabelSize}, \code{legendSize}, \code{legendTitleSize}.
#' @param titleSize Size of title of plot. Default \code{NULL}.
#' @param axisSize Size of x/y-axis ticks. Default \code{NULL}.
#' @param axisLabelSize Size of x/y-axis labels. Default \code{NULL}.
#' @param legendSize size of legend. Default \code{NULL}.
#' @param legendTitleSize size of legend title. Default \code{NULL}.
#' @param combinePlot Must be either \code{"all"}, \code{"sample"}, or
#' \code{"none"}. \code{"all"} will combine all plots into a single .ggplot
#' object, while \code{"sample"} will output a list of plots separated by
#' sample. Default \code{"all"}.
#' @param relHeights Relative heights of plots when combine is set. Default
#' \code{1}.
#' @param relWidths Relative widths of plots when combine is set. Default
#' \code{c(1, 1, 1)}.
#' @param plotNCols Number of columns when plots are combined in a grid. Default
#' \code{NULL}.
#' @param plotNRows Number of rows when plots are combined in a grid. Default
#' \code{NULL}.
#' @param labelSamples Will label sample name in title of plot if TRUE. Default
#' \code{TRUE}.
#' @param samplePerColumn If \code{TRUE}, when there are multiple samples and
#' combining by \code{"all"}, the output .ggplot will have plots from each
#' sample on a single column. Default \code{TRUE}.
#' @param sampleRelHeights If there are multiple samples and combining by
#' \code{"all"}, the relative heights for each plot. Default \code{1}.
#' @param sampleRelWidths If there are multiple samples and combining by
#' \code{"all"}, the relative widths for each plot. Default \code{1}.
#' @seealso \code{\link{runCxds}}
#' @return list of .ggplot objects
#' @examples
#' data(scExample, package="singleCellTK")
#' sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
#' sce <- runQuickUMAP(sce)
#' sce <- runCxds(sce)
#' plotCxdsResults(inSCE=sce, reducedDimName="UMAP")
#' @export
#' @importFrom SingleCellExperiment reducedDimNames
plotCxdsResults <- function(
    inSCE,
    sample = NULL,
    shape = NULL,
    groupBy = NULL,
    combinePlot = "all",
    violin = TRUE,
    boxplot = FALSE,
    dots = TRUE,
    reducedDimName = "UMAP",
    xlab = NULL,
    ylab = NULL,
    dim1 = NULL,
    dim2 = NULL,
    bin = NULL,
    binLabel = NULL,
    defaultTheme = TRUE,
    dotSize = 0.5,
    summary = "median",
    summaryTextSize = 3,
    transparency = 1,
    baseSize = 15,
    titleSize = NULL,
    axisLabelSize = NULL,
    axisSize = NULL,
    legendSize = NULL,
    legendTitleSize = NULL,
    relHeights = 1,
    relWidths = c(1, 1, 1),
    plotNCols = NULL,
    plotNRows = NULL,
    labelSamples = TRUE,
    samplePerColumn = TRUE,
    sampleRelHeights = 1,
    sampleRelWidths = 1
) {
  sample <- .manageCellVar(inSCE, var = sample)
  if (is.null(sample)) {
    sample = rep(1, ncol(inSCE))
  }

  if (!(reducedDimName %in% SingleCellExperiment::reducedDimNames(inSCE))) {
    stop("Specified `reducedDimName` is not found in input",
         "SingleCellExperiment object. Please check for spelling errors with ",
         "reducedDimNames().")
  }
  samples <- unique(sample)
  if (length(samples) > 1) {
    merged.plots <- list(
      Score = plotSCEViolinColData(
        inSCE = inSCE,
        coldata = "scds_cxds_score",
        groupBy = sample,
        xlab = "",
        ylab = "Doublet Score",
        violin = violin,
        boxplot = boxplot,
        dots = dots,
        transparency = transparency,
        baseSize = baseSize,
        title = "CXDS Doublet Score",
        titleSize = titleSize,
        dotSize = dotSize,
        axisSize = axisSize,
        axisLabelSize = axisLabelSize,
        gridLine = TRUE,
        summary = summary,
        summaryTextSize = summaryTextSize,
        combinePlot = "all",
        plotLabels = "none"
      )
    )
    merged.plots <- list(merged.plots)
    names(merged.plots) <- "Violin"
  }

  res.list <- list()
  plotlist <- lapply(samples, function(x) {
    sampleInd <- which(sample == x)
    sampleSub <- sample[sampleInd]
    inSCESub <- inSCE[, sampleInd]

    title = "Density, CXDS Score"
    if (labelSamples && length(samples) > 1) {
      title = paste0(title, ", ", x)
    }
    if (combinePlot == "sample" | combinePlot == "all") {
      baseSize = baseSize * 0.5
    }
    densityScore <- list(
      density_doubletScore = plotSCEDensityColData(
        inSCE = inSCESub,
        sample = sampleSub,
        coldata = "scds_cxds_score",
        groupBy = groupBy,
        xlab = "Score",
        ylab = "Density",
        baseSize = baseSize,
        axisSize = axisSize,
        axisLabelSize = axisLabelSize,
        defaultTheme = defaultTheme,
        title = title,
        titleSize = titleSize,
        plotLabels = NULL,
        combinePlot = "all"
      )
    )
    res.list = c(res.list, densityScore)

    title = "CXDS Doublet Score"
    if (labelSamples && length(samples) > 1) {
      title = paste0(title, ", ", x)
    }
    scatterScore <- list(
      scatter_doubletScore = plotSCEDimReduceColData(
        inSCE = inSCESub,
        sample = sampleSub,
        colorBy = "scds_cxds_score",
        conditionClass = "numeric",
        shape = shape,
        reducedDimName = reducedDimName,
        xlab = xlab,
        ylab = ylab,
        dim1 = dim1,
        dim2 = dim2,
        bin = bin,
        binLabel = binLabel,
        dotSize = dotSize,
        transparency = transparency,
        baseSize = baseSize,
        defaultTheme = defaultTheme,
        title = title,
        titleSize = titleSize,
        axisSize = axisSize,
        axisLabelSize = axisLabelSize,
        labelClusters = FALSE,
        legendTitle = "Doublet \nScore",
        legendSize = legendSize,
        legendTitleSize = legendTitleSize,
        plotLabels = NULL,
        combinePlot = "all"
      )
    )
    res.list = c(res.list, scatterScore)

    if (combinePlot != "all" | length(samples) == 1) {
      title = "CXDS Doublet Score"
      if (labelSamples && length(samples) > 1) {
        title = paste0(title, ", ", x)
      }
      violinScore <- list(
        violin_doubletScore = plotSCEViolinColData(
          inSCE = inSCESub,
          coldata = "scds_cxds_score",
          sample = sampleSub,
          xlab = "",
          ylab = "Doublet Score",
          groupBy = groupBy,
          violin = violin,
          boxplot = boxplot,
          dots = dots,
          transparency = transparency,
          baseSize = baseSize,
          title = title,
          titleSize = titleSize,
          defaultTheme = defaultTheme,
          dotSize = dotSize,
          axisSize = axisSize,
          axisLabelSize = axisLabelSize,
          summary = summary,
          summaryTextSize = summaryTextSize,
          combinePlot = "all"
        )
      )
      res.list = c(res.list, violinScore)
    }

    if ("scds_cxds_call" %in% names(SingleCellExperiment::colData(inSCE))) {
      title = "CXDS Doublet Assignment"
      if (labelSamples && length(samples) > 1) {
        title = paste0(title, ", ", x)
      }
      scatterCall <- list(
        scatter_doubletCall = plotSCEDimReduceColData(
          inSCE = inSCESub,
          sample = sampleSub,
          colorBy = "scds_cxds_call",
          conditionClass = "factor",
          shape = shape,
          reducedDimName = reducedDimName,
          xlab = xlab,
          ylab = ylab,
          dim1 = dim1,
          dim2 = dim2,
          bin = bin,
          binLabel = binLabel,
          dotSize = dotSize,
          transparency = transparency,
          baseSize = baseSize,
          colorScale = c("lightgray", "red"),
          defaultTheme = defaultTheme,
          title = title,
          titleSize = titleSize,
          axisSize = axisSize,
          axisLabelSize = axisLabelSize,
          labelClusters = FALSE,
          legendTitle = "Doublet \nAssignment",
          legendTitleSize = legendTitleSize,
          legendSize = legendSize,
          combinePlot = "all"
        )
      )
      res.list <- c(res.list, scatterCall)
    }
    return(res.list)
  })
  if (length(unique(samples)) > 1) {
    names(plotlist) <- samples
    plotlist <- c(merged.plots, list(Sample = plotlist))
  } else {
    plotlist <- unlist(plotlist, recursive = FALSE)
    plotLabels <- "none"
    relHeights <- 1
  }
  if (!is.null(combinePlot)) {
    if (combinePlot %in% c("all", "sample")) {
      plotlist <- .ggSCTKCombinePlots(plotlist, combinePlot = combinePlot,
                                      relHeights = relHeights,
                                      relWidths = relWidths,
                                      ncols = plotNCols,
                                      nrows = plotNRows,
                                      samplePerColumn = samplePerColumn,
                                      sampleRelHeights = sampleRelHeights,
                                      sampleRelWidths = sampleRelWidths)
    }
  }
  return(plotlist)
}

#' @title Plots for runBcds outputs.
#' @description A wrapper function which visualizes outputs from the
#' \code{\link{runBcds}} function stored in the colData slot of the
#' \linkS4class{SingleCellExperiment} object via various plots.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object with saved
#' dimension reduction components or a variable with saved results from
#' \code{\link{runBcds}}. Required.
#' @param sample Character vector or colData variable name. Indicates which
#' sample each cell belongs to. Default \code{NULL}.
#' @param shape If provided, add shapes based on the value. Default \code{NULL}.
#' @param groupBy Groupings for each numeric value. A user may input a vector
#' equal length to the number of the samples in \code{inSCE}, or can be
#' retrieved from the colData slot. Default \code{NULL}.
#' @param violin Boolean. If \code{TRUE}, will plot the violin plot. Default
#' \code{TRUE}.
#' @param boxplot Boolean. If \code{TRUE}, will plot boxplots for each violin
#' plot. Default \code{TRUE}.
#' @param dots Boolean. If \code{TRUE}, will plot dots for each violin plot.
#' Default \code{TRUE}.
#' @param reducedDimName Saved dimension reduction name in \code{inSCE}.
#' Default \code{"UMAP"}.
#' @param xlab Character vector. Label for x-axis. Default \code{NULL}.
#' @param ylab Character vector. Label for y-axis. Default \code{NULL}.
#' @param dim1 1st dimension to be used for plotting. Can either be a string
#' which specifies the name of the dimension to be plotted from reducedDims, or
#' a numeric value which specifies the index of the dimension to be plotted.
#' Default is \code{NULL}.
#' @param dim2 2nd dimension to be used for plotting. Similar to \code{dim1}.
#' Default is \code{NULL}.
#' @param bin Numeric vector. If single value, will divide the numeric values
#' into \code{bin} groups. If more than one value, will bin numeric values using
#' values as a cut point. Default \code{NULL}.
#' @param binLabel Character vector. Labels for the bins created by \code{bin}.
#' Default \code{NULL}.
#' @param defaultTheme Removes grid in plot and sets axis title size to
#' \code{10} when \code{TRUE}. Default \code{TRUE}.
#' @param dotSize Size of dots. Default \code{0.5}.
#' @param summary Adds a summary statistic, as well as a crossbar to the
#' violin plot. Options are \code{"mean"} or \code{"median"}. Default
#' \code{NULL}.
#' @param summaryTextSize The text size of the summary statistic displayed
#' above the violin plot. Default \code{3}.
#' @param transparency Transparency of the dots, values will be 0-1. Default
#' \code{1}.
#' @param baseSize The base font size for all text. Default \code{12}.
#' Can be overwritten by \code{titleSize}, \code{axisSize}, and
#' \code{axisLabelSize}, \code{legendSize}, \code{legendTitleSize}.
#' @param titleSize Size of title of plot. Default \code{NULL}.
#' @param axisSize Size of x/y-axis ticks. Default \code{NULL}.
#' @param axisLabelSize Size of x/y-axis labels. Default \code{NULL}.
#' @param legendSize size of legend. Default \code{NULL}.
#' @param legendTitleSize size of legend title. Default \code{NULL}.
#' @param combinePlot Must be either \code{"all"}, \code{"sample"}, or
#' \code{"none"}. \code{"all"} will combine all plots into a single .ggplot
#' object, while \code{"sample"} will output a list of plots separated by
#' sample. Default \code{"all"}.
#' @param relHeights Relative heights of plots when combine is set. Default
#' \code{1}.
#' @param relWidths Relative widths of plots when combine is set. Default
#' \code{c(1, 1, 1)}.
#' @param plotNCols Number of columns when plots are combined in a grid. Default
#' \code{NULL}.
#' @param plotNRows Number of rows when plots are combined in a grid. Default
#' \code{NULL}.
#' @param labelSamples Will label sample name in title of plot if TRUE. Default
#' \code{TRUE}.
#' @param samplePerColumn If \code{TRUE}, when there are multiple samples and
#' combining by \code{"all"}, the output .ggplot will have plots from each
#' sample on a single column. Default \code{TRUE}.
#' @param sampleRelHeights If there are multiple samples and combining by
#' \code{"all"}, the relative heights for each plot. Default \code{1}.
#' @param sampleRelWidths If there are multiple samples and combining by
#' \code{"all"}, the relative widths for each plot. Default \code{1}.
#' @seealso \code{\link{runBcds}}
#' @return list of .ggplot objects
#' @examples
#' data(scExample, package="singleCellTK")
#' sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
#' sce <- runQuickUMAP(sce)
#' sce <- runBcds(sce)
#' plotBcdsResults(inSCE=sce, reducedDimName="UMAP")
#' @export
plotBcdsResults <- function(
    inSCE,
    sample = NULL,
    shape = NULL,
    groupBy = NULL,
    combinePlot = "all",
    violin = TRUE,
    boxplot = FALSE,
    dots = TRUE,
    reducedDimName = "UMAP",
    xlab = NULL,
    ylab = NULL,
    dim1 = NULL,
    dim2 = NULL,
    bin = NULL,
    binLabel = NULL,
    defaultTheme = TRUE,
    dotSize = 0.5,
    summary = "median",
    summaryTextSize = 3,
    transparency = 1,
    baseSize = 15,
    titleSize = NULL,
    axisLabelSize = NULL,
    axisSize = NULL,
    legendSize = NULL,
    legendTitleSize = NULL,
    relHeights = 1,
    relWidths = c(1, 1, 1),
    plotNCols = NULL,
    plotNRows = NULL,
    labelSamples = TRUE,
    samplePerColumn = TRUE,
    sampleRelHeights = 1,
    sampleRelWidths = 1
) {
  sample <- .manageCellVar(inSCE, var = sample)
  if (is.null(sample)) {
    sample = rep(1, ncol(inSCE))
  }

  if (!(reducedDimName %in% SingleCellExperiment::reducedDimNames(inSCE))) {
    stop("Specified `reducedDimName` is not found in input",
         "SingleCellExperiment object. Please check for spelling errors with ",
         "reducedDimNames().")
  }
  samples <- unique(sample)
  if (length(samples) > 1) {
    merged.plots <- list(
      Score = plotSCEViolinColData(
        inSCE = inSCE,
        coldata = "scds_cxds_score",
        groupBy = sample,
        xlab = "",
        ylab = "Doublet Score",
        violin = violin,
        boxplot = boxplot,
        dots = dots,
        transparency = transparency,
        baseSize = baseSize,
        title = "BCDS Doublet Score",
        titleSize = titleSize,
        dotSize = dotSize,
        axisSize = axisSize,
        axisLabelSize = axisLabelSize,
        gridLine = TRUE,
        summary = summary,
        summaryTextSize = summaryTextSize,
        combinePlot = "all",
        plotLabels = "none"
      )
    )
    merged.plots <- list(merged.plots)
    names(merged.plots) <- "Violin"
  }

  res.list <- list()
  plotlist <- lapply(samples, function(x) {
    sampleInd <- which(sample == x)
    sampleSub <- sample[sampleInd]
    inSCESub <- inSCE[, sampleInd]

    title = "Density, BCDS Score"
    if (labelSamples && length(samples) > 1) {
      title = paste0(title, ", ", x)
    }
    if (combinePlot == "sample" | combinePlot == "all") {
      baseSize = baseSize * 0.5
    }
    densityScore <- list(
      density_doubletScore = plotSCEDensityColData(
        inSCE = inSCESub,
        sample = sampleSub,
        coldata = "scds_bcds_score",
        groupBy = groupBy,
        xlab = "Score",
        ylab = "Density",
        baseSize = baseSize,
        axisSize = axisSize,
        axisLabelSize = axisLabelSize,
        defaultTheme = defaultTheme,
        title = title,
        titleSize = titleSize,
        plotLabels = NULL,
        combinePlot = "all"
      )
    )
    res.list = c(res.list, densityScore)

    title = "BCDS Doublet Score"
    if (labelSamples && length(samples) > 1) {
      title = paste0(title, ", ", x)
    }
    scatterScore <- list(
      scatter_doubletScore = plotSCEDimReduceColData(
        inSCE = inSCESub,
        sample = sampleSub,
        colorBy = "scds_bcds_score",
        conditionClass = "numeric",
        shape = shape,
        reducedDimName = reducedDimName,
        xlab = xlab,
        ylab = ylab,
        dim1 = dim1,
        dim2 = dim2,
        bin = bin,
        binLabel = binLabel,
        dotSize = dotSize,
        transparency = transparency,
        baseSize = baseSize,
        defaultTheme = defaultTheme,
        title = title,
        titleSize = titleSize,
        axisSize = axisSize,
        axisLabelSize = axisLabelSize,
        labelClusters = FALSE,
        legendTitle = "Doublet \nScore",
        legendSize = legendSize,
        legendTitleSize = legendTitleSize,
        plotLabels = NULL,
        combinePlot = "all"
      )
    )
    res.list = c(res.list, scatterScore)

    if (combinePlot != "all" | length(samples) == 1) {
      title = "BCDS Doublet Score"
      if (labelSamples && length(samples) > 1) {
        title = paste0(title, ", ", x)
      }
      violinScore <- list(
        violin_doubletScore = plotSCEViolinColData(
          inSCE = inSCESub,
          coldata = "scds_bcds_score",
          sample = sampleSub,
          xlab = "",
          ylab = "Doublet Score",
          groupBy = groupBy,
          violin = violin,
          boxplot = boxplot,
          dots = dots,
          transparency = transparency,
          baseSize = baseSize,
          title = title,
          titleSize = titleSize,
          defaultTheme = defaultTheme,
          dotSize = dotSize,
          axisSize = axisSize,
          axisLabelSize = axisLabelSize,
          summary = summary,
          summaryTextSize = summaryTextSize,
          combinePlot = "all"
        )
      )
      res.list = c(res.list, violinScore)
    }

    if ("scds_bcds_call" %in% names(SummarizedExperiment::colData(inSCE))) {
      title = "BCDS Doublet Assignment"
      if (labelSamples && length(samples) > 1) {
        title = paste0(title, ", ", x)
      }
      scatterCall <- list(
        scatter_doubletCall = plotSCEDimReduceColData(
          inSCE = inSCESub,
          sample = sampleSub,
          colorBy = "scds_cxds_call",
          conditionClass = "factor",
          shape = shape,
          reducedDimName = reducedDimName,
          xlab = xlab,
          ylab = ylab,
          dim1 = dim1,
          dim2 = dim2,
          bin = bin,
          binLabel = binLabel,
          dotSize = dotSize,
          transparency = transparency,
          baseSize = baseSize,
          colorScale = c("lightgray", "red"),
          defaultTheme = defaultTheme,
          title = title,
          titleSize = titleSize,
          axisSize = axisSize,
          axisLabelSize = axisLabelSize,
          labelClusters = FALSE,
          legendTitle = "Doublet \nAssignment",
          legendTitleSize = legendTitleSize,
          legendSize = legendSize,
          combinePlot = "all"
        )
      )
      res.list <- c(res.list, scatterCall)
    }
    return(res.list)
  })
  if (length(unique(samples)) > 1) {
    names(plotlist) <- samples
    plotlist <- c(merged.plots, list(Sample = plotlist))
  } else {
    plotlist <- unlist(plotlist, recursive = FALSE)
    plotLabels <- "none"
    relHeights <- 1
  }
  if (!is.null(combinePlot)) {
    if (combinePlot %in% c("all", "sample")) {
      plotlist <- .ggSCTKCombinePlots(plotlist, combinePlot = combinePlot,
                                      relHeights = relHeights,
                                      relWidths = relWidths,
                                      ncols = plotNCols,
                                      nrows = plotNRows,
                                      samplePerColumn = samplePerColumn,
                                      sampleRelHeights = sampleRelHeights,
                                      sampleRelWidths = sampleRelWidths)
    }
  }
  return(plotlist)
}


#' @title Plots for runCxdsBcdsHybrid outputs.
#' @description A wrapper function which visualizes outputs from the
#'  runCxdsBcdsHybrid function stored in the colData slot of the
#'  SingleCellExperiment object via various plots.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object with saved
#' dimension reduction components or a variable with saved results from
#' \link{runCxdsBcdsHybrid}. Required.
#' @param sample Character vector. Indicates which sample each cell belongs to.
#'  Default NULL.
#' @param shape If provided, add shapes based on the value.
#' @param groupBy Groupings for each numeric value. A user may input a vector
#'  equal length to the number of the samples in the SingleCellExperiment
#'  object, or can be retrieved from the colData slot. Default NULL.
#' @param violin Boolean. If TRUE, will plot the violin plot. Default TRUE.
#' @param boxplot Boolean. If TRUE, will plot boxplots for each violin plot.
#'  Default TRUE.
#' @param dots Boolean. If TRUE, will plot dots for each violin plot.
#'  Default TRUE.
#' @param reducedDimName Saved dimension reduction name in the
#' \linkS4class{SingleCellExperiment} object. Required.
#' @param xlab Character vector. Label for x-axis. Default NULL.
#' @param ylab Character vector. Label for y-axis. Default NULL.
#' @param dim1 1st dimension to be used for plotting. Can either be a string which specifies
#'  the name of the dimension to be plotted from reducedDims, or a numeric value which specifies
#'  the index of the dimension to be plotted. Default is NULL.
#' @param dim2 2nd dimension to be used for plotting. Can either be a string which specifies
#'  the name of the dimension to be plotted from reducedDims, or a numeric value which specifies
#'  the index of the dimension to be plotted. Default is NULL.
#' @param bin Numeric vector. If single value, will divide the numeric values into the `bin` groups.
#'  If more than one value, will bin numeric values using values as a cut point.
#' @param binLabel Character vector. Labels for the bins created by the `bin` parameter.
#'  Default NULL.
#' @param defaultTheme Removes grid in plot and sets axis title size to 10
#'  when TRUE. Default TRUE.
#' @param dotSize Size of dots. Default 0.5.
#' @param summary Adds a summary statistic, as well as a crossbar to the
#'  violin plot. Options are "mean" or "median". Default NULL.
#' @param summaryTextSize The text size of the summary statistic displayed
#'  above the violin plot. Default 3.
#' @param transparency Transparency of the dots, values will be 0-1. Default 1.
#' @param baseSize The base font size for all text. Default 12.
#'  Can be overwritten by titleSize, axisSize, and axisLabelSize,
#'  legendSize, legendTitleSize.
#' @param titleSize Size of title of plot. Default NULL.
#' @param axisSize Size of x/y-axis ticks. Default NULL.
#' @param axisLabelSize Size of x/y-axis labels. Default NULL.
#' @param legendSize size of legend. Default NULL.
#' @param legendTitleSize size of legend title. Default NULL.
#' @param combinePlot Must be either "all", "sample", or "none". "all" will combine all plots into a single .ggplot object,
#' while "sample" will output a list of plots separated by sample. Default "all".
#' @param relHeights Relative heights of plots when combine is set.
#' @param relWidths Relative widths of plots when combine is set.
#' @param plotNCols Number of columns when plots are combined in a grid.
#' @param plotNRows Number of rows when plots are combined in a grid.
#' @param labelSamples Will label sample name in title of plot if TRUE. Default TRUE.
#' @param samplePerColumn If TRUE, when there are multiple samples and combining by "all",
#'  the output .ggplot will have plots from each sample on a single column. Default TRUE.
#' @param sampleRelHeights If there are multiple samples and combining by "all",
#'  the relative heights for each plot.
#' @param sampleRelWidths If there are multiple samples and combining by "all",
#'  the relative widths for each plot.
#' @return list of .ggplot objects
#' @examples
#' data(scExample, package="singleCellTK")
#' sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
#' sce <- runQuickUMAP(sce)
#' sce <- runCxdsBcdsHybrid(sce)
#' plotScdsHybridResults(inSCE=sce, reducedDimName="UMAP")
#' @export
plotScdsHybridResults <- function(inSCE,
                                  sample=NULL,
                                  shape=NULL,
                                  groupBy=NULL,
                                  combinePlot="all",
                                  violin=TRUE,
                                  boxplot=FALSE,
                                  dots=TRUE,
                                  reducedDimName="UMAP",
                                  xlab=NULL,
                                  ylab=NULL,
                                  dim1=NULL,
                                  dim2=NULL,
                                  bin=NULL,
                                  binLabel=NULL,
                                  defaultTheme=TRUE,
                                  dotSize=0.5,
                                  summary="median",
                                  summaryTextSize=3,
                                  transparency=1,
                                  baseSize=15,
                                  titleSize=NULL,
                                  axisLabelSize=NULL,
                                  axisSize=NULL,
                                  legendSize=NULL,
                                  legendTitleSize=NULL,
                                  relHeights=1,
                                  relWidths=c(1, 1, 1),
                                  plotNCols = NULL,
                                  plotNRows = NULL,
                                  labelSamples = TRUE,
                                  samplePerColumn = TRUE,
                                  sampleRelHeights = 1,
                                  sampleRelWidths = 1) {
  if (!is.null(sample)) {
    if (length(sample) != ncol(inSCE)) {
      stop(
        "'sample' must be the same length as the number",
        " of columns in 'inSCE'"
      )
    }
  } else {
    sample <- rep(1, ncol(inSCE))
  }

  if (!(reducedDimName %in% reducedDimNames(inSCE))){
    stop("Specified `reducedDimName` is not found in input
         SingleCellExperiment object. Please check for spelling errors
         with reducedDimNames().")
  }
  samples <- unique(sample)
  sampleVector <- sample
  if (length(samples) > 1) {
    merged.plots <- list(Score = plotSCEViolinColData(
      inSCE=inSCE,
      coldata="scds_hybrid_score",
      groupBy=sampleVector,
      xlab="",
      ylab="Doublet Score",
      violin=violin,
      boxplot=boxplot,
      dots=dots,
      transparency=transparency,
      baseSize=baseSize,
      title="CXDS BCDS Doublet Score",
      titleSize=titleSize,
      dotSize=dotSize,
      axisSize=axisSize,
      axisLabelSize=axisLabelSize,
      gridLine=TRUE,
      summary=summary,
      summaryTextSize=summaryTextSize,
      combinePlot = "all",
      plotLabels = "none"
    ))
    merged.plots <- list(merged.plots)
    names(merged.plots) <- "Violin"
  }

  res.list <- c()
  plotlist <- lapply(samples, function(x) {
    sampleInd <- which(sample == x)
    sampleSub <- sample[sampleInd]
    inSCESub <- inSCE[, sampleInd]
    title = "Density, CXDS BCDS Hybrid Score"
    if(labelSamples && length(samples) > 1){
      title = paste0(title, ", ", x)
    }
    if(combinePlot == "sample" | combinePlot == "all"){
      baseSize = baseSize * 0.5
    }
    densityScore <- list(density_doubletScore = plotSCEDensityColData(
      inSCE=inSCESub,
      sample=sampleSub,
      coldata="scds_hybrid_score",
      groupBy=groupBy,
      xlab="Score",
      ylab="Density",
      baseSize=baseSize,
      axisSize=axisSize,
      axisLabelSize=axisLabelSize,
      defaultTheme=defaultTheme,
      title=title,
      titleSize=titleSize,
      combinePlot="all"
    ))
    res.list = c(res.list, densityScore)

    title = "CXDS BCDS Hybrid Score"
    if(labelSamples && length(samples) > 1){
      title = paste0(title, ", ", x)
    }
    scatterScore <- list(scatter_doubletScore = plotSCEDimReduceColData(
      inSCE=inSCESub,
      sample=sampleSub,
      colorBy="scds_hybrid_score",
      conditionClass="numeric",
      shape=shape,
      reducedDimName=reducedDimName,
      xlab=xlab,
      ylab=ylab,
      dim1=dim1,
      dim2=dim2,
      bin=bin,
      binLabel=binLabel,
      dotSize=dotSize,
      transparency=transparency,
      baseSize=baseSize,
      defaultTheme=defaultTheme,
      title=title,
      titleSize=titleSize,
      axisSize=axisSize,
      axisLabelSize=axisLabelSize,
      labelClusters=FALSE,
      legendTitle="Doublet \nScore",
      legendTitleSize=legendTitleSize,
      legendSize=legendSize,
      combinePlot="all"
    ))
    res.list = c(res.list, scatterScore)

    if(combinePlot != "all" | length(samples) == 1){
      title = "CXDS BCDS Hybrid Score"
      if(labelSamples && length(samples) > 1){
        title = paste0(title, ", ", x)
      }
      violinScore <- list(violin_doubletScore = plotSCEViolinColData(
        inSCE=inSCESub,
        coldata="scds_hybrid_score",
        sample=sampleSub,
        xlab="",
        ylab="Doublet Score",
        groupBy=groupBy,
        violin=violin,
        boxplot=boxplot,
        dots=dots,
        transparency=transparency,
        baseSize=baseSize,
        defaultTheme=defaultTheme,
        title=title,
        titleSize=titleSize,
        dotSize=dotSize,
        axisSize=axisSize,
        axisLabelSize=axisLabelSize,
        summary=summary,
        summaryTextSize=summaryTextSize,
        combinePlot="all"
      ))
      res.list = c(res.list, violinScore)
    }

    if("scds_hybrid_call" %in% names(SingleCellExperiment::colData(inSCE))){
      title = "CXDS BCDS Doublet Assignment"
      if(labelSamples && length(samples) > 1){
        title = paste0(title, ", ", x)
      }
      scatterCall <- list(scatter_doubletCall = plotSCEDimReduceColData(
        inSCE=inSCESub,
        sample=sampleSub,
        colorBy="scds_hybrid_call",
        conditionClass="factor",
        shape=shape,
        reducedDimName=reducedDimName,
        xlab=xlab,
        ylab=ylab,
        dim1=dim1,
        dim2=dim2,
        bin=bin,
        binLabel=binLabel,
        dotSize=dotSize,
        transparency=transparency,
        baseSize=baseSize,
        colorScale = c("lightgray","red"),
        defaultTheme=defaultTheme,
        title=title,
        titleSize=titleSize,
        axisSize=axisSize, axisLabelSize=axisLabelSize,
        labelClusters=FALSE,
        legendTitle="Doublet \nAssignment",
        legendTitleSize=legendTitleSize,
        legendSize=legendSize,
        combinePlot="all"
      ))
      res.list <- c(res.list, scatterCall)
    }

    return(res.list)
  })

  if (length(unique(samples)) > 1) {
    names(plotlist) <- samples
    plotlist <- c(merged.plots, list(Sample = plotlist))
  } else {
    plotlist <- unlist(plotlist, recursive=FALSE)
    plotLabels <- "none"
    relHeights=1
  }
  if(!is.null(combinePlot)){
    if(combinePlot %in% c("all", "sample")){
      plotlist <- .ggSCTKCombinePlots(plotlist, combinePlot = combinePlot,
                                      relHeights = relHeights,
                                      relWidths = relWidths,
                                      ncols = plotNCols,
                                      nrows = plotNRows,
                                      samplePerColumn = samplePerColumn,
                                      sampleRelHeights = sampleRelHeights,
                                      sampleRelWidths = sampleRelWidths)
    }
  }
  return(plotlist)
}

#' @title Plots for runDecontX outputs.
#' @description A wrapper function which visualizes outputs from the
#'  runDecontX function stored in the colData slot of the
#'  SingleCellExperiment object via various plots.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object with saved
#' dimension reduction components or a variable with saved results from
#' \link{runDecontX}. Required.
#' @param sample Character vector. Indicates which sample each cell belongs to.
#'  Default NULL.
#' @param bgResult Boolean. If TRUE, will plot decontX results generated with
#' raw/droplet matrix Default FALSE.
#' @param shape If provided, add shapes based on the value.
#' @param groupBy Groupings for each numeric value. A user may input a vector
#'  equal length to the number of the samples in the SingleCellExperiment
#'  object, or can be retrieved from the colData slot. Default NULL.
#' @param violin Boolean. If TRUE, will plot the violin plot. Default TRUE.
#' @param boxplot Boolean. If TRUE, will plot boxplots for each violin plot.
#'  Default TRUE.
#' @param dots Boolean. If TRUE, will plot dots for each violin plot.
#'  Default TRUE.
#' @param reducedDimName Saved dimension reduction name in the
#' \linkS4class{SingleCellExperiment} object. Required. Default = "UMAP"
#' @param xlab Character vector. Label for x-axis. Default NULL.
#' @param ylab Character vector. Label for y-axis. Default NULL.
#' @param dim1 1st dimension to be used for plotting. Can either be a string which specifies
#'  the name of the dimension to be plotted from reducedDims, or a numeric value which specifies
#'  the index of the dimension to be plotted. Default is NULL.
#' @param dim2 2nd dimension to be used for plotting. Can either be a string which specifies
#'  the name of the dimension to be plotted from reducedDims, or a numeric value which specifies
#'  the index of the dimension to be plotted. Default is NULL.
#' @param bin Numeric vector. If single value, will divide the numeric values into the `bin` groups.
#'  If more than one value, will bin numeric values using values as a cut point.
#' @param binLabel Character vector. Labels for the bins created by the `bin` parameter.
#'  Default NULL.
#' @param defaultTheme Removes grid in plot and sets axis title size to 10
#'  when TRUE. Default TRUE.
#' @param dotSize Size of dots. Default 0.5.
#' @param summary Adds a summary statistic, as well as a crossbar to the
#'  violin plot. Options are "mean" or "median". Default NULL.
#' @param summaryTextSize The text size of the summary statistic displayed
#'  above the violin plot. Default 3.
#' @param transparency Transparency of the dots, values will be 0-1. Default 1.
#' @param baseSize The base font size for all text. Default 12.
#'  Can be overwritten by titleSize, axisSize, and axisLabelSize,
#'  legendSize, legendTitleSize.
#' @param titleSize Size of title of plot. Default NULL.
#' @param axisSize Size of x/y-axis ticks. Default NULL.
#' @param axisLabelSize Size of x/y-axis labels. Default NULL.
#' @param legendSize size of legend. Default NULL.
#' @param legendTitleSize size of legend title. Default NULL.
#' @param labelClusters Logical. Whether the cluster labels are plotted.
#'  Default FALSE.
#' @param clusterLabelSize Numeric. Determines the size of cluster label
#'  when `labelClusters` is set to TRUE. Default 3.5.
#' @param combinePlot Must be either "all", "sample", or "none". "all" will combine all plots into a single .ggplot object,
#' while "sample" will output a list of plots separated by sample. Default "all".
#' @param relHeights Relative heights of plots when combine is set.
#' @param relWidths Relative widths of plots when combine is set.
#' @param plotNCols Number of columns when plots are combined in a grid.
#' @param plotNRows Number of rows when plots are combined in a grid.
#' @param labelSamples Will label sample name in title of plot if TRUE. Default TRUE.
#' @param samplePerColumn If TRUE, when there are multiple samples and combining by "all",
#'  the output .ggplot will have plots from each sample on a single column. Default TRUE.
#' @param sampleRelHeights If there are multiple samples and combining by "all",
#'  the relative heights for each plot.
#' @param sampleRelWidths If there are multiple samples and combining by "all",
#'  the relative widths for each plot.
#' @return list of .ggplot objects
#' @examples
#' data(scExample, package="singleCellTK")
#' sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
#' sce <- runDecontX(sce)
#' plotDecontXResults(inSCE=sce, reducedDimName="decontX_UMAP")
#' @export
plotDecontXResults <- function(inSCE,
                               sample=NULL,
                               bgResult = FALSE,
                               shape=NULL,
                               groupBy=NULL,
                               combinePlot="all",
                               violin=TRUE,
                               boxplot=FALSE,
                               dots=TRUE,
                               reducedDimName="UMAP",
                               xlab=NULL,
                               ylab=NULL,
                               dim1=NULL,
                               dim2=NULL,
                               bin=NULL,
                               binLabel=NULL,
                               defaultTheme=TRUE,
                               dotSize=0.5,
                               summary="median",
                               summaryTextSize=3,
                               transparency=1,
                               baseSize=15,
                               titleSize=NULL,
                               axisLabelSize=NULL,
                               axisSize=NULL,
                               legendSize=NULL,
                               legendTitleSize=NULL,
                               relHeights=1,
                               relWidths=c(1, 1, 1),
                               plotNCols = NULL,
                               plotNRows = NULL,
                               labelSamples = TRUE,
                               labelClusters = TRUE,
                               clusterLabelSize = 3.5,
                               samplePerColumn = TRUE,
                               sampleRelHeights = 1,
                               sampleRelWidths = 1) {
  if (!is.null(sample)) {
    if (length(sample) != ncol(inSCE)) {
      stop(
        "'sample' must be the same length as the number",
        " of columns in 'inSCE'"
      )
    }
  } else {
    sample <- rep(1, ncol(inSCE))
  }

  if (!(reducedDimName %in% reducedDimNames(inSCE))){
    stop("Specified `reducedDimName` is not found in input
         SingleCellExperiment object. Please check for spelling errors
         with reducedDimNames().")
  }

  scoreCol <- "decontX_contamination"
  clusterCol <- "decontX_clusters"

  if (!isTRUE(bgResult) & !scoreCol %in% colnames(SummarizedExperiment::colData(inSCE))) {
    stop("The result of running decontX without raw/droplet matrix
           is not found in the input SingleCellExperiment object.
           Please check whether runDecontX has been run without
           'background' parameter. ")
  }

  if (isTRUE(bgResult)) {
    bgColId <- grep('decontX_contamination_bg', colnames(SummarizedExperiment::colData(inSCE)))

    if (length(bgColId) == 0) {
      stop("The result of running decontX with raw/droplet matrix
           is not found in the input SingleCellExperiment object.
           Please check whether runDecontX has been run with
           'background' parameter. ")
    } else {
      scoreCol <- "decontX_contamination_bg"
      clusterCol <- "decontX_clusters_bg"
    }
  }

  samples <- unique(sample)
  sampleVector <- sample
  if (length(samples) > 1) {
    merged.plots <- list(Score = plotSCEViolinColData(
      inSCE=inSCE,
      coldata=scoreCol,
      groupBy=sampleVector,
      xlab="",
      ylab="DecontX Contamination",
      violin=violin,
      boxplot=boxplot,
      dots=dots,
      baseSize=baseSize,
      axisSize=axisSize,
      axisLabelSize=axisLabelSize,
      transparency=transparency,
      title="DecontX Contamination Score",
      titleSize=titleSize,
      dotSize=dotSize,
      gridLine=TRUE,
      summary=summary,
      summaryTextSize=summaryTextSize,
      combinePlot = "all",
      plotLabels = "none"
    ))
    merged.plots <- list(merged.plots)
    names(merged.plots) <- "Violin"
  }

  res.list = list()
  plotlist <- lapply(samples, function(x) {
    sampleInd <- which(sample == x)
    sampleSub <- sample[sampleInd]
    inSCESub <- inSCE[, sampleInd]
    title = "Density, DecontX Contamination Score"
    if(labelSamples && length(samples) > 1){
      title = paste0(title, ", ", x)
    }
    if(combinePlot == "sample" | combinePlot == "all"){
      baseSize = baseSize * 0.5
      clusterLabelSize <- clusterLabelSize * 0.5
    }
    densityContamination <- list(density_decontXContamination = plotSCEDensityColData(
      inSCE=inSCESub,
      sample=sampleSub,
      coldata=scoreCol,
      groupBy=groupBy,
      xlab="Score",
      ylab="Density",
      baseSize=baseSize,
      axisSize=axisSize,
      axisLabelSize=axisLabelSize,
      defaultTheme=defaultTheme,
      title=title,
      titleSize=titleSize,
      combinePlot="all"
    ))
    res.list = c(res.list, densityContamination)

    scatterContamination <- list(scatter_decontXContamination = plotSCEDimReduceColData(
      inSCE=inSCESub,
      sample=sampleSub,
      colorBy=scoreCol,
      conditionClass="numeric",
      shape=shape,
      reducedDimName=reducedDimName,
      xlab=xlab,
      ylab=ylab,
      dim1=dim1,
      dim2=dim2,
      bin=bin,
      binLabel=binLabel,
      dotSize=dotSize,
      baseSize=baseSize,
      axisSize=axisSize,
      axisLabelSize=axisLabelSize,
      transparency=transparency,
      defaultTheme=defaultTheme,
      title="DecontX Contamination",
      titleSize=titleSize,
      labelClusters=FALSE,
      legendTitle="Contamination",
      legendTitleSize=legendTitleSize,
      legendSize=legendSize,
      combinePlot="all"
    ))
    res.list = c(res.list, scatterContamination)

    if(combinePlot != "all" | length(samples) == 1){
      title = "DecontX Contamination Score"
      if(labelSamples && length(samples) > 1){
        title = paste0(title, ", ", x)
      }
      violinContamination <- list(violin_decontXContamination = plotSCEViolinColData(
        inSCE=inSCESub,
        coldata=scoreCol,
        sample=sampleSub,
        xlab="", ylab="DecontX Contamination",
        groupBy=groupBy,
        violin=violin,
        boxplot=boxplot,
        dots=dots,
        transparency=transparency,
        baseSize=baseSize,
        title=title,
        titleSize=titleSize,
        defaultTheme=defaultTheme,
        axisSize=axisSize,
        axisLabelSize=axisLabelSize,
        dotSize=dotSize,
        summary=summary,
        summaryTextSize=summaryTextSize,
        combinePlot="all"
      ))
      res.list = c(res.list, violinContamination)
    }

    if(is.null(legendSize) && !is.null(baseSize)){
      legendSizeScatterCluster = baseSize - 1
    }else{
      legendSizeScatterCluster = legendSize
    }
    title = "DecontX Clusters"
    if(labelSamples && length(samples) > 1){
      title = paste0(title, ", ", x)
    }

    scatterCluster <- list(scatter_decontXClusters = plotSCEDimReduceColData(
      inSCE=inSCESub,
      sample=sampleSub,
      colorBy=clusterCol,
      conditionClass="factor",
      shape=shape,
      reducedDimName=reducedDimName,
      xlab=xlab,
      ylab=ylab,
      dim1=dim1,
      dim2=dim2,
      bin=bin,
      binLabel=binLabel,
      baseSize=baseSize,
      axisSize=axisSize,
      axisLabelSize=axisLabelSize,
      dotSize=dotSize,
      transparency=transparency,
      defaultTheme=defaultTheme,
      title=title,
      titleSize=titleSize,
      labelClusters=labelClusters,
      clusterLabelSize = clusterLabelSize,
      legendTitle="Clusters",
      legendSize=legendSizeScatterCluster,
      legendTitleSize=legendTitleSize,
      combinePlot="all"
    ))
    res.list = c(res.list, scatterCluster)

    return(res.list)
  })

  if (length(unique(samples)) > 1) {
    names(plotlist) <- samples
    plotlist <- c(merged.plots, list(Sample = plotlist))
  } else {
    plotlist <- unlist(plotlist, recursive=FALSE)
    plotLabels <- "none"
    relHeights=1
  }
  if(!is.null(combinePlot)){
    if(combinePlot %in% c("all", "sample")){
      plotlist <- .ggSCTKCombinePlots(plotlist, combinePlot = combinePlot,
                                      relHeights = relHeights,
                                      relWidths = relWidths,
                                      ncols = plotNCols,
                                      nrows = plotNRows,
                                      samplePerColumn = samplePerColumn,
                                      sampleRelHeights = sampleRelHeights,
                                      sampleRelWidths = sampleRelWidths)
    }
  }
  return(plotlist)
}

# dimensionality reduction algorithms
library(singleCellTK)
context("Testing dimensionality reduction algorithms")
data(scExample, package = "singleCellTK")
sceDroplet <- sce
sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
sampleVector <- c(rep("Sample1", 100), rep("Sample2", 95))
sceres <- runQuickUMAP(inSCE = sce, sample = sampleVector, nNeighbors = 10,
                nIterations = 20, alpha = 1, minDist = 0.01, initialDims = 20)

# allow some additional memory over default
options(future.globals.maxSize = 786432000)

test_that(desc = "Testing plotSCEScatter functions", {
    p1 <- plotSCEScatter(inSCE = sceres, legendTitle = NULL,
        slot = "assays", annotation = "counts", feature = "ENSG00000251562",
        reducedDimName = "UMAP", labelClusters = FALSE,
        sample = sampleVector, combinePlot = "all")
    expect_is(p1, c("gg","ggplot"))
    p2 <- plotSCEDimReduceFeatures(inSCE = sceres, features = "ENSG00000251562",
        shape = NULL, reducedDimName = "UMAP",
        useAssay = "counts", xlab = "UMAP1", ylab = "UMAP2",
        sample = sampleVector, combinePlot = "all")
    expect_is(p2, c("gg","ggplot"))
    p3 <- plotSCEDimReduceColData(inSCE = sceres, colorBy = "type",
        shape = NULL, conditionClass = "factor",
        reducedDimName = "UMAP",
        xlab = "UMAP1", ylab = "UMAP2", labelClusters = TRUE,
        sample = sampleVector, combinePlot = "all")
    expect_is(p3, c("gg","ggplot"))
})

test_that(desc = "Testing plotSCEViolin functions", {
    p1 <- plotSCEViolin(inSCE = sceres, slotName = "assays",
                        itemName = "counts", feature = "ENSG00000251562",
                        groupBy = "type", sample = sampleVector,
                        combinePlot = "all")
    expect_is(p1, c("gg","ggplot"))
    p2 <- plotSCEViolinAssayData(inSCE = sceres,
        feature = "ENSG00000251562", groupBy = "type",
        sample = sampleVector,combinePlot = "all")
    expect_is(p2, c("gg","ggplot"))
    p3 <- plotSCEViolinColData(inSCE = sceres,
        coldata = "type", groupBy = "sample",
        sample = sampleVector)
    expect_is(p3, "list")
})


sceres <- sceres[, colData(sceres)$type != 'EmptyDroplet']
sceres <- runCellQC(sceres, algorithms = c("QCMetrics", "cxds", "bcds", "cxds_bcds_hybrid",
                                              "doubletFinder", "decontX"))
sceres <- runScDblFinder(sceres)


context("Testing QC functions")

test_that("Testing scds",{
  sce <- runCxdsBcdsHybrid(sce, estNdbl = TRUE)
  expect_equal(class(colData(sceres)$scds_hybrid_score), 'numeric')
  expect_equal(class(colData(sceres)$scds_hybrid_call), 'factor')
})

test_that(desc = "Testing DoubletFinder",  {
  expect_equal(length(colData(sceres)$doubletFinder_doublet_score_resolution_1.5),ncol(sce))
  expect_equal(class(colData(sceres)$doubletFinder_doublet_score_resolution_1.5), "numeric")
})


test_that(desc = "Testing runScDblFinder", {
  expect_equal(length(colData(sceres)$scDblFinder_doublet_score),ncol(sce))
  expect_equal(class(colData(sceres)$scDblFinder_doublet_score), "numeric")
})

sceDroplet <- runDropletQC(sceDroplet)

test_that("Testing emptydrops",{
  expect_equal(class(colData(sceDroplet)$dropletUtils_emptyDrops_total), 'integer')
  expect_equal(class(colData(sceDroplet)$dropletUtils_emptyDrops_logprob), 'numeric')
  expect_equal(class(colData(sceDroplet)$dropletUtils_emptyDrops_pvalue), 'numeric')
  expect_equal(class(colData(sceDroplet)$dropletUtils_emptyDrops_limited), 'logical')
  expect_equal(class(colData(sceDroplet)$dropletUtils_emptyDrops_fdr), 'numeric')
})


test_that(desc = "Testing plotResults functions", {
  #commenting below two lines of code due to an error in the R CMD check (irzam)
  #r1 <- plotRunPerCellQCResults(inSCE = sceres, sample = sampleVector, combinePlot = "all")
    #expect_is(r1, c("gg","ggplot"))
  # r2 <- plotScrubletResults(inSCE = sceres, reducedDimName="UMAP", sample = sampleVector, combinePlot = "all")
  #   expect_is(r2, c("gg","ggplot"))
  r3 <- plotScDblFinderResults(inSCE = sceres, reducedDimName="UMAP", sample = sampleVector, combinePlot = "all")
    expect_is(r3, c("gg","ggplot"))
  r4 <- plotDoubletFinderResults(inSCE = sceres, reducedDimName="UMAP", sample = sampleVector, combinePlot = "all")
    expect_is(r4, c("gg","ggplot"))
  r5 <- plotCxdsResults(inSCE = sceres, reducedDimName="UMAP", sample = sampleVector, combinePlot = "all")
    expect_is(r5,  c("gg","ggplot"))
  r6 <- plotBcdsResults(inSCE = sceres, reducedDimName="UMAP", sample = sampleVector, combinePlot = "all")
    expect_is(r6,  c("gg","ggplot"))
  r7 <- plotScdsHybridResults(inSCE = sceres, reducedDimName="UMAP", sample = sampleVector, combinePlot = "all")
    expect_is(r7,  c("gg","ggplot"))
  r8 <- plotDecontXResults(inSCE = sceres, reducedDimName="UMAP", sample = sampleVector, combinePlot = "all")
    expect_is(r8, c("gg","ggplot"))

  sceDroplet <- runDropletQC(sceDroplet)
  r9 <- plotEmptyDropsResults(inSCE = sceDroplet, sample = c(rep("Sample1", 100), rep("Sample2", 290)))
    expect_is(r9, "list")
})

#' Helper function for differential expression analysis methods that accepts
#' multiple ways of conditional subsetting and returns stable index format.
#' Meanwhile it does all the input checkings.
#' @param inSCE \linkS4class{SingleCellExperiment} inherited object. Required.
#' @param useAssay character. A string specifying which assay to use. Required.
#' @param useReducedDim character. A string specifying which reducedDim to use
#' for DE analysis. Usually a pathway analysis result matrix. Set
#' \code{useAssay} to \code{NULL} when using. Required.
#' @param index1 Any type of indices that can subset a
#' \linkS4class{SingleCellExperiment} inherited object by cells. Specifies
#' which cells are of interests. Default \code{NULL}.
#' @param index2 Any type of indices that can subset a
#' \linkS4class{SingleCellExperiment} inherited object by cells. specifies
#' the control group against those specified by \code{index1}. If
#' \code{NULL} when using index specification, \code{index1} cells will be
#' compared with all other cells. Default \code{NULL}.
#' @param class A vector/factor with \code{ncol(inSCE)} elements, or a character
#' scalar that specifies a column name of \code{colData(inSCE)}. Default
#' \code{NULL}.
#' @param classGroup1 a vector specifying which "levels" given in \code{class}
#' are of interests. Default \code{NULL}.
#' @param classGroup2 a vector specifying which "levels" given in \code{class}
#' is the control group against those specified by \code{classGroup1}. If
#' \code{NULL} when using annotation specification, \code{classGroup1} cells
#' will be compared with all other cells.
#' @param groupName1 A character scalar naming the group of interests. Required.
#' @param groupName2 A character scalar naming the control group. Required.
#' @param analysisName A character scalar naming the DEG analysis. Required
#' @param covariates A character vector of additional covariates used in linear
#' regression methods such as Limma and DESeq2. Default \code{NULL}
#' @param overwrite A logical scalar. Whether to overwrite result if exists.
#' Default \code{FALSE}.
#' @return A list object with part of formatted DE analysis information
#' @author Yichen Wang
#' @noRd
.formatDEAList <- function(inSCE, useAssay, useReducedDim, index1 = NULL, index2 = NULL,
                           class = NULL, classGroup1 = NULL,
                           classGroup2 = NULL, groupName1, groupName2,
                           analysisName, covariates = NULL, overwrite = FALSE){
    # Input checks
    useMat <- .selectSCEMatrix(inSCE, useAssay = useAssay,
                               useReducedDim = useReducedDim,
                               returnMatrix = FALSE)
    if ("diffExp" %in% names(S4Vectors::metadata(inSCE))){
      if(analysisName %in% names(S4Vectors::metadata(inSCE)$diffExp)){
        if(!isTRUE(overwrite)){
          stop("analysisName '", analysisName, "' already exists. ",
               "Set `overwrite` to `TRUE` to overwrite.")
        }
      }
    }
    if(is.null(index1) && (is.null(classGroup1) || is.null(class))){
        stop('At least "index1" or "classGroup1" should be specified.')
    } else if(!is.null(index1) && (!is.null(classGroup1) || !is.null(class))){
        stop('Only one of "index" and "class"/"classGroup1" ',
             'should be specified.')
    }
    if(!is.null(covariates) &&
       !all(covariates %in% names(SummarizedExperiment::colData(inSCE)))){
        stop("Not all specified covariates exist.")
    }

    groupNames <- c(groupName1, groupName2)
    annotation <- c(class, covariates)
    if(!is.null(index1)){
        cells1 <- colnames(inSCE[,index1])
        if(!is.null(index2)){
            cells2 <- colnames(inSCE[,index2])
        } else {
            cells2 <- sort(setdiff(colnames(inSCE), cells1))
        }
    } else {
        class <- .manageCellVar(inSCE, var = class)
        uniqCats <- unique(as.vector(class))
        index1 <- class %in% classGroup1
        if(is.null(classGroup2)){
            index2 <- !class %in% classGroup1
        } else {
            index2 <- class %in% classGroup2
        }
        cells1 <- colnames(inSCE[,index1])
        cells2 <- colnames(inSCE[,index2])
    }
    if(length(cells1) == 0){
        stop("Number of cells selected for group1 equals to zero.")
    }
    if(length(cells2) == 0){
        stop("Number of cells selected for group2 equals to zero.")
    }
    ix1 <- colnames(inSCE) %in% cells1
    ix2 <- colnames(inSCE) %in% cells2
    isec <- intersect(which(ix1), which(ix2))
    if (length(isec) > 0) {
      stop("Cell(s) selected for both conditions: ",
           paste(colnames(inSCE)[isec], collapse = ", "))
    }
    select <- list(ix1 = ix1, ix2 = ix2)
    if(!is.null(covariates)){
        for (c in covariates){
            col <- SummarizedExperiment::colData(inSCE)[(ix1 | ix2),c]
            if(length(unique(as.vector(col))) < 2){
                stop("Less than 2 levels in specified covariate: ", c)
            }
        }
    }
    return(
        list(useAssay = useMat$names$useAssay,
             useReducedDim = useMat$names$useReducedDim,
             groupNames = groupNames,
             select = select,
             annotation = annotation)
    )
}

# Filter the formated DEG table
# Could be used in runDE, getTable and plotDE functions
.filterDETable <- function(deg, onlyPos = FALSE, log2fcThreshold = NULL,
                           fdrThreshold = NULL, minGroup1MeanExp = NULL,
                           maxGroup2MeanExp = NULL, minGroup1ExprPerc = NULL,
                           maxGroup2ExprPerc = NULL) {
  if (isTRUE(onlyPos)) {
    deg <- deg[deg$Log2_FC > 0,]
  }
  if (!is.null(fdrThreshold)) {
    deg <- deg[deg$FDR < fdrThreshold,]
  }
  if (!is.null(log2fcThreshold)) {
    deg <- deg[abs(deg$Log2_FC) >= log2fcThreshold,]
  }
  if (!is.null(minGroup1MeanExp)) {
    deg <- deg[deg$group1MeanExp >= minGroup1MeanExp,]
  }
  if (!is.null(maxGroup2MeanExp)) {
    deg <- deg[deg$group2MeanExp <= maxGroup2MeanExp,]
  }
  if (!is.null(minGroup1ExprPerc)) {
    deg <- deg[deg$group1ExprPerc >= minGroup1ExprPerc,]
  }
  if (!is.null(maxGroup2ExprPerc)) {
    deg <- deg[deg$group2ExprPerc <= maxGroup2ExprPerc,]
  }
  # Format output
  deg <- deg[order(deg$Log2_FC, na.last = TRUE, decreasing = TRUE),]
  if (length(which(rowSums(is.na(deg)) > 2)) > 0) {
    deg <- deg[-which(rowSums(is.na(deg)) > 2),]
  }
  return(deg)
}

# Calculate extra metrics for each deg
# Including the mean expression value in group1,
# Percentage of cells in group1 that express each gene
# Percentage of cells in group2 that express each gene
.calculateDEMetrics <- function(deg, mat, ix1, ix2) {
  geneIdx <- rownames(mat) %in% deg$Gene
  # Mean expression in group1
  meanExp1 <- rowMeans(mat[geneIdx, ix1, drop=FALSE])
  meanExp1 <- meanExp1[deg$Gene]
  deg$group1MeanExp <- meanExp1
  # Mean expression in group2
  meanExp2 <- rowMeans(mat[geneIdx, ix2, drop=FALSE])
  meanExp2 <- meanExp2[deg$Gene]
  deg$group2MeanExp <- meanExp2
  # Expressed percentage in group1
  group1ExprPerc <- rowMeans(mat[geneIdx, ix1, drop=FALSE] > 0)
  group1ExprPerc <- group1ExprPerc[deg$Gene]
  deg$group1ExprPerc <-group1ExprPerc
  # Expressed percentage in group2
  group2ExprPerc <- rowMeans(mat[geneIdx, ix2, drop=FALSE] > 0)
  group2ExprPerc <- group2ExprPerc[deg$Gene]
  deg$group2ExprPerc <-group2ExprPerc
  return(deg)
}

#' Perform differential expression analysis on SCE object
#' @rdname runDEAnalysis
#' @details
#' SCTK provides Limma, MAST, DESeq2, ANOVA and Wilcoxon test for differential
#' expression analysis, where DESeq2 expects non-negtive integer assay input
#' while others expect logcounts.
#'
#' Condition specification allows two methods:
#' 1. Index level selection. Only use arguments \code{index1} and \code{index2}.
#' 2. Annotation level selection. Only use arguments \code{class},
#' \code{classGroup1} and \code{classGroup2}.
#' @seealso See \code{\link{plotDEGHeatmap}}, \code{\link{plotDEGRegression}},
#' \code{\link{plotDEGViolin}} and \code{\link{plotDEGVolcano}} for
#' visualization method after running DE analysis.
#' @param inSCE \linkS4class{SingleCellExperiment} inherited object.
#' @param method Character. Specify which method to use when using
#' \code{runDEAnalysis()}. Choose from \code{"wilcox"}, \code{"MAST"},
#' \code{"DESeq2"}, \code{"Limma"}, \code{"ANOVA"}. Default \code{"wilcox"}.
#' @param useAssay character. A string specifying which assay to use for the
#' DE regression. Ignored when \code{useReducedDim} is specified. Default
#' \code{"counts"} for DESeq2, \code{"logcounts"} for other methods.
#' @param useReducedDim character. A string specifying which reducedDim to use
#' for DE analysis. Will treat the dimensions as features. Default \code{NULL}.
#' @param index1 Any type of indices that can subset a
#' \linkS4class{SingleCellExperiment} inherited object by cells. Specifies
#' which cells are of interests. Default \code{NULL}.
#' @param index2 Any type of indices that can subset a
#' \linkS4class{SingleCellExperiment} inherited object by cells. specifies
#' the control group against those specified by \code{index1}. If
#' \code{NULL} when using index specification, \code{index1} cells will be
#' compared with all other cells. Default \code{NULL}.
#' @param class A vector/factor with \code{ncol(inSCE)} elements, or a character
#' scalar that specifies a column name of \code{colData(inSCE)}. Default
#' \code{"cluster"}.
#' @param classGroup1 a vector specifying which "levels" given in \code{class}
#' are of interests. Default \code{c(1)}.
#' @param classGroup2 a vector specifying which "levels" given in \code{class}
#' is the control group against those specified by \code{classGroup1}. If
#' \code{NULL} when using annotation specification, \code{classGroup1} cells
#' will be compared with all other cells. Default \code{c(2)}.
#' @param analysisName A character scalar naming the DEG analysis. 
#' Default \code{"cluster1_VS_2"}.
#' @param groupName1 A character scalar naming the group of interests. 
#' Default \code{"cluster1"}.
#' @param groupName2 A character scalar naming the control group. 
#' Default \code{"cluster2"}.
#' @param covariates A character vector of additional covariates to use when
#' building the model. All covariates must exist in
#' \code{names(colData(inSCE))}. Default \code{NULL}.
#' @param onlyPos Whether to only output DEG with positive log2_FC value.
#' Default \code{FALSE}.
#' @param log2fcThreshold Only out put DEGs with the absolute values of log2FC
#' greater than this value. Default \code{NULL}.
#' @param fdrThreshold Only out put DEGs with FDR value less than this
#' value. Default \code{NULL}.
#' @param minGroup1MeanExp Only out put DEGs with mean expression in group1
#' greater then this value. Default \code{NULL}.
#' @param maxGroup2MeanExp Only out put DEGs with mean expression in group2
#' less then this value. Default \code{NULL}.
#' @param minGroup1ExprPerc Only out put DEGs expressed in greater then this
#' fraction of cells in group1. Default \code{NULL}.
#' @param maxGroup2ExprPerc Only out put DEGs expressed in less then this
#' fraction of cells in group2. Default \code{NULL}.
#' @param overwrite A logical scalar. Whether to overwrite result if exists.
#' Default \code{FALSE}.
#' @param verbose A logical scalar. Whether to show messages. Default
#' \code{TRUE}.
#' @param fullReduced Logical, DESeq2 only argument. Whether to apply LRT
#' (Likelihood ratio test) with a 'full' model. Default \code{TRUE}.
#' @param check_sanity Logical, MAST only argument. Whether to perform MAST's
#' sanity check to see if the counts are logged. Default \code{TRUE}.
#' @param ... Arguments to pass to specific methods when using the generic
#' \code{runDEAnalysis()}.
#' @examples
#' data(scExample, package = "singleCellTK")
#' sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
#' sce <- scaterlogNormCounts(sce, assayName = "logcounts")
#' sce <- runDEAnalysis(method = "Limma", inSCE = sce, groupName1 = "group1",
#'  groupName2 = "group2", index1 = seq(20), index2 = seq(21,40),
#'  analysisName = "Limma")
#'
#' @return The input \linkS4class{SingleCellExperiment} object, where
#' \code{metadata(inSCE)$diffExp} is updated with a list named by
#' \code{analysisName}, with elements of:
#' \item{$groupNames}{the naming of the two conditions}
#' \item{$useAssay, $useReducedDim}{the matrix name that was used for
#' calculation}
#' \item{$select}{the cell selection indices (logical) for each condition}
#' \item{$result}{a \code{data.frame} of the DEGs table}
#' \item{$method}{the method used}
#' @export
runDEAnalysis <- function(inSCE, method = 'wilcox', ...){
  validMethods <- c('wilcox', 'MAST', 'DESeq2', 'Limma', 'ANOVA')
  method <- match.arg(method, choices = validMethods)
  funcList <- list(wilcox = runWilcox, 
                   MAST = runMAST,
                   DESeq2 = runDESeq2,
                   Limma = runLimmaDE,
                   ANOVA = runANOVA)
  do.call(funcList[[method]], c(list(inSCE = inSCE), list(...)))
}



#' @rdname runDEAnalysis
#' @export
runDESeq2 <- function(inSCE, useAssay = 'counts', useReducedDim = NULL,
                      index1 = NULL, index2 = NULL, class = NULL,
                      classGroup1 = NULL, classGroup2 = NULL, analysisName,
                      groupName1, groupName2, covariates = NULL,
                      fullReduced = TRUE, onlyPos = FALSE,
                      log2fcThreshold = NULL, fdrThreshold = NULL,
                      minGroup1MeanExp = NULL, maxGroup2MeanExp = NULL,
                      minGroup1ExprPerc = NULL, maxGroup2ExprPerc = NULL,
                      overwrite = FALSE, verbose = TRUE){
    resultList <- .formatDEAList(inSCE, useAssay, useReducedDim, index1, index2,
                                 class, classGroup1, classGroup2, groupName1,
                                 groupName2, analysisName, covariates,
                                 overwrite)
    useAssay <- resultList$useAssay
    ix1 <- resultList$select$ix1
    ix2 <- resultList$select$ix2
    subsetIdx <- (ix1 | ix2)
    conditions <- rep(NA, ncol(inSCE))
    conditions[ix1] <- 'cond1'
    conditions[ix2] <- 'cond2'
    conditions <- conditions[!is.na(conditions)]
    annotData <- data.frame(condition = factor(conditions),
                            row.names = colnames(inSCE)[subsetIdx])
    cov <- SummarizedExperiment::colData(inSCE)[subsetIdx, covariates,
                                                drop = FALSE]
    annotData <- cbind(annotData, cov)
    if (!is.null(useAssay)) {
      mat <- expData(inSCE[,subsetIdx], useAssay)
    } else {
      mat <- t(expData(inSCE[,subsetIdx], useReducedDim))
    }

    if(!inherits(mat, 'matrix')){
        mat <- as.matrix(mat)
    }
    if (any(duplicated(rownames(mat)))) {
      warning("Duplicated feature names found in given dataset. Making them ",
              "unique in the result. They will not show in plots.")
      mat <- dedupRowNames(mat)
    }
    if (isTRUE(verbose)) {
      message(date(), " ... Running DE with DESeq2. Analysis name: ",
              analysisName)
    }
    dds <- DESeq2::DESeqDataSetFromMatrix(
        countData = mat, colData = annotData,
        design = stats::as.formula(paste0("~", c('condition', covariates),
                                          collapse = "+"))
    )
    if(isTRUE(fullReduced)){
        dds <- DESeq2::DESeq(dds, test = "LRT", reduced = ~ 1, quiet = !verbose)
    } else {
        dds <- DESeq2::DESeq(
            dds, test = "LRT",
            reduced = stats::as.formula(paste0('~condition', covariates,
                                               collapse = '+')),
            quiet = !verbose
        )
    }
    res <- DESeq2::results(dds, pAdjustMethod = 'fdr')
    deg <- data.frame(res)[,c(-1, -3, -4)]
    deg <- cbind(data.frame(Gene = as.character(rownames(deg)),
                            stringsAsFactors = FALSE),
                 deg)
    rownames(deg) <- NULL
    colnames(deg) <- c('Gene', 'Log2_FC', 'Pvalue', 'FDR')
    deg$Log2_FC <- - deg$Log2_FC # JNMLP
    deg <- .calculateDEMetrics(deg, expData(inSCE, useAssay), ix1, ix2)
    deg <- .filterDETable(deg, onlyPos, log2fcThreshold, fdrThreshold,
                          minGroup1MeanExp, maxGroup2MeanExp,
                          minGroup1ExprPerc, maxGroup2ExprPerc)

    resultList$result <- deg
    resultList$method <- 'DESeq2'
    if ("diffExp" %in% names(S4Vectors::metadata(inSCE))){
        S4Vectors::metadata(inSCE)$diffExp[[analysisName]] <- resultList
    } else {
        S4Vectors::metadata(inSCE)$diffExp <- list()
        S4Vectors::metadata(inSCE)$diffExp[[analysisName]] <- resultList
    }
    return(inSCE)
}

#' @rdname runDEAnalysis
#' @export
runLimmaDE <- function(inSCE, useAssay = 'logcounts', useReducedDim = NULL,
                       index1 = NULL, index2 = NULL, class = NULL,
                       classGroup1 = NULL, classGroup2 = NULL, analysisName,
                       groupName1, groupName2, covariates = NULL,
                       onlyPos = FALSE, log2fcThreshold = NULL,
                       fdrThreshold = NULL, minGroup1MeanExp = NULL,
                       maxGroup2MeanExp = NULL, minGroup1ExprPerc = NULL,
                       maxGroup2ExprPerc = NULL, overwrite = FALSE,
                       verbose = TRUE){
    resultList <- .formatDEAList(inSCE, useAssay, useReducedDim, index1, index2,
                                 class, classGroup1, classGroup2, groupName1,
                                 groupName2, analysisName, covariates,
                                 overwrite)
    useAssay <- resultList$useAssay
    ix1 <- resultList$select$ix1
    ix2 <- resultList$select$ix2
    subsetIdx <- (ix1 | ix2)
    conditions <- rep(NA, ncol(inSCE))
    conditions[ix1] <- 'cond1'
    conditions[ix2] <- 'cond2'
    conditions <- conditions[!is.na(conditions)]
    annotData <- data.frame(condition = conditions,
                            row.names = colnames(inSCE)[subsetIdx])
    cov <- SummarizedExperiment::colData(inSCE)[subsetIdx, covariates,
                                                drop = FALSE]
    annotData <- cbind(annotData, cov)
    if (!is.null(useAssay)) {
      mat <- expData(inSCE[,subsetIdx], useAssay)
    } else {
      mat <- t(expData(inSCE[,subsetIdx], useReducedDim))
    }

    if(!inherits(mat, 'matrix')){
        mat <- as.matrix(mat)
    }
    if (any(duplicated(rownames(mat)))) {
      warning("Duplicated feature names found in given dataset. Making them ",
              "unique in the result. They will not show in plots.")
      mat <- dedupRowNames(mat)
    }
    if (isTRUE(verbose)) {
      message(date(), " ... Running DE with limma, Analysis name: ",
              analysisName)
    }
    design <- stats::model.matrix(
        stats::as.formula(paste0("~", paste0(c('condition', covariates),
                                             collapse = "+"))),
        data = annotData)
    fit <- limma::lmFit(mat, design)
    ebayes <- limma::eBayes(fit)
    coef <- seq(ncol(ebayes))[-1]
    deg <- limma::topTable(ebayes, coef = coef, adjust = 'fdr',
                           number = nrow(inSCE))
    deg <- deg[,c(-2, -3, -6)]
    deg <- cbind(data.frame(Gene = as.character(rownames(deg)),
                            stringsAsFactors = FALSE),
                 deg)
    rownames(deg) <- NULL
    colnames(deg) <- c("Gene", "Log2_FC", "Pvalue", "FDR")
    deg$Log2_FC <- - deg$Log2_FC # JNMLP
    deg <- .calculateDEMetrics(deg, expData(inSCE, useAssay), ix1, ix2)
    deg <- .filterDETable(deg, onlyPos, log2fcThreshold, fdrThreshold,
                          minGroup1MeanExp, maxGroup2MeanExp,
                          minGroup1ExprPerc, maxGroup2ExprPerc)

    resultList$result <- deg
    resultList$method <- 'Limma'
    if ("diffExp" %in% names(S4Vectors::metadata(inSCE))){
      S4Vectors::metadata(inSCE)$diffExp[[analysisName]] <- resultList
    } else {
      S4Vectors::metadata(inSCE)$diffExp <- list()
      S4Vectors::metadata(inSCE)$diffExp[[analysisName]] <- resultList
    }
    return(inSCE)
}

#' @rdname runDEAnalysis
#' @export
runANOVA <- function(inSCE, useAssay = 'logcounts', useReducedDim = NULL,
                     index1 = NULL, index2 = NULL, class = NULL,
                     classGroup1 = NULL, classGroup2 = NULL, analysisName,
                     groupName1, groupName2, covariates = NULL, onlyPos = FALSE,
                     log2fcThreshold = NULL, fdrThreshold = NULL,
                     minGroup1MeanExp = NULL, maxGroup2MeanExp = NULL,
                     minGroup1ExprPerc = NULL, maxGroup2ExprPerc = NULL,
                     overwrite = FALSE, verbose = TRUE){
    resultList <- .formatDEAList(inSCE, useAssay, useReducedDim, index1, index2,
                                 class, classGroup1, classGroup2, groupName1,
                                 groupName2, analysisName, covariates,
                                 overwrite)
    useAssay <- resultList$useAssay
    ix1 <- resultList$select$ix1
    ix2 <- resultList$select$ix2
    subsetIdx <- (ix1 | ix2)
    conditions <- rep(NA, ncol(inSCE))
    conditions[ix1] <- 'cond1'
    conditions[ix2] <- 'cond2'
    conditions <- conditions[!is.na(conditions)]
    annotData <- data.frame(condition = conditions,
                            row.names = colnames(inSCE)[subsetIdx])
    cov <- SummarizedExperiment::colData(inSCE)[subsetIdx, covariates,
                                                drop = FALSE]
    annotData <- cbind(annotData, cov)
    if (is.null(covariates)) {
      mod <- stats::model.matrix(~condition, annotData)
      mod0 <- stats::model.matrix(~1, annotData)
    } else {
      mod <- stats::model.matrix(
        stats::as.formula(paste0("~", paste0(c("condition", covariates),
                                             collapse = "+"))),
        data = annotData)
      mod0 <- stats::model.matrix(
        stats::as.formula(paste0("~", paste0(covariates, collapse = "+"))),
        data = annotData)
    }
    if (!is.null(useAssay)) {
      dat <- expData(inSCE[,subsetIdx], useAssay)
    } else {
      dat <- t(expData(inSCE[,subsetIdx], useReducedDim))
    }
    if(!inherits(dat, 'matrix')){
        dat <- as.matrix(dat)
    }
    if (any(duplicated(rownames(dat)))) {
      warning("Duplicated feature names found in given dataset. Making them ",
              "unique in the result. They will not show in plots.")
      dat <- dedupRowNames(dat)
    }
    if (isTRUE(verbose)) {
      message(date(), " ... Running DE with ANOVA, Analysis name: ",
              analysisName)
    }
    n <- dim(dat)[2]
    m <- dim(dat)[1]
    df1 <- dim(mod)[2]
    df0 <- dim(mod0)[2]
    p <- rep(0, m)
    Id <- diag(n)
    resid <- dat %*% (Id - mod %*% solve(t(mod) %*% mod) %*%
                        t(mod))
    resid0 <- dat %*% (Id - mod0 %*% solve(t(mod0) %*% mod0) %*%
                         t(mod0))
    rss1 <- resid ^ 2 %*% rep(1, n)
    rss0 <- resid0 ^ 2 %*% rep(1, n)
    fstats <- ((rss0 - rss1) / (df1 - df0)) / (rss1 / (n - df1))
    p <- 1 - stats::pf(fstats, df1 = (df1 - df0), df2 = (n - df1))
    deg <- data.frame(Gene = as.character(rownames(dat)),
                      Log2_FC =NA, Pvalue = p,
                      FDR = stats::p.adjust(p, method = 'fdr'),
                      stringsAsFactors = FALSE)
    rownames(deg) <- NULL

    if (!is.null(useAssay)) {
      cond1.assay <- expData(inSCE, useAssay)[, ix1, drop=FALSE]
      cond2.assay <- expData(inSCE, useAssay)[, ix2, drop=FALSE]
    } else {
      cond1.assay <- t(expData(inSCE, useReducedDim))[, ix1, drop=FALSE]
      cond2.assay <- t(expData(inSCE, useReducedDim))[, ix2, drop=FALSE]
    }
    # Assuming that useAssay is log-normalized counts
    deg$Log2_FC <- rowMeans(cond1.assay) - rowMeans(cond2.assay)
    deg <- .calculateDEMetrics(deg, expData(inSCE, useAssay), ix1, ix2)
    deg <- .filterDETable(deg, onlyPos, log2fcThreshold, fdrThreshold,
                          minGroup1MeanExp, maxGroup2MeanExp,
                          minGroup1ExprPerc, maxGroup2ExprPerc)

    resultList$result <- deg
    resultList$method <- 'ANOVA'

    if ("diffExp" %in% names(S4Vectors::metadata(inSCE))){
      S4Vectors::metadata(inSCE)$diffExp[[analysisName]] <- resultList
    } else {
      S4Vectors::metadata(inSCE)$diffExp <- list()
      S4Vectors::metadata(inSCE)$diffExp[[analysisName]] <- resultList
    }
    return(inSCE)
}

#' @rdname runDEAnalysis
#' @export
runMAST <- function(inSCE, useAssay = 'logcounts', useReducedDim = NULL,
                    index1 = NULL, index2 = NULL, class = NULL,
                    classGroup1 = NULL, classGroup2 = NULL, analysisName,
                    groupName1, groupName2, covariates = NULL, onlyPos = FALSE,
                    log2fcThreshold = NULL, fdrThreshold = NULL,
                    minGroup1MeanExp = NULL, maxGroup2MeanExp = NULL,
                    minGroup1ExprPerc = NULL, maxGroup2ExprPerc = NULL,
                    overwrite = FALSE, check_sanity = TRUE, verbose = TRUE){
    resultList <- .formatDEAList(inSCE, useAssay, useReducedDim, index1, index2,
                                 class, classGroup1, classGroup2, groupName1,
                                 groupName2, analysisName, covariates,
                                 overwrite)
    useAssay <- resultList$useAssay
    ix1 <- resultList$select$ix1
    ix2 <- resultList$select$ix2
    cells1 <- which(ix1)
    cells2 <- which(ix2)
    subsetIdx <- (ix1 | ix2)
    ## Extract
    if (!is.null(useAssay)) {
      mat <- expData(inSCE[,subsetIdx], useAssay)
    } else {
      mat <- t(expData(inSCE[,subsetIdx], useReducedDim))
    }

    if(!inherits(mat, 'matrix')){
      mat <- as.matrix(mat)
    }
    if (any(duplicated(rownames(mat)))) {
      warning("Duplicated feature names found in given dataset. Making them ",
              "unique in the result. They will not show in plots.")
      mat <- dedupRowNames(mat)
    }
    if (isTRUE(verbose)) {
      message(date(), " ... Running DE with MAST, Analysis name: ",
              analysisName)
    }
    cond <- rep(NA, ncol(inSCE))
    cond[ix1] <- 'c1'
    cond[ix2] <- 'c2'
    cond <- cond[subsetIdx]
    cdat <- data.frame(wellKey = colnames(mat),
                       condition = as.factor(cond),
                       ngeneson = rep("", (length(cells1) + length(cells2))),
                       stringsAsFactors = FALSE)
    covariateDat <-
      data.frame(SummarizedExperiment::colData(inSCE[,subsetIdx])[,
                                                                  covariates,
                                                                  drop = FALSE])
    cdat <- cbind(cdat, covariateDat)
    sca <- MAST::FromMatrix(mat, cdat, check_sanity = check_sanity)
    cdr2 <- colSums(SummarizedExperiment::assay(sca) > 0)
    SummarizedExperiment::colData(sca)$cngeneson <- scale(cdr2)
    cond <- factor(SummarizedExperiment::colData(sca)$condition)
    cond <- stats::relevel(cond, "c2")
    SummarizedExperiment::colData(sca)$condition <- cond
    # Calculation
    sca <- sca[which(MAST::freq(sca) > 0),]
    invisible(utils::capture.output(thresh <-
        MAST::thresholdSCRNACountMatrix(SummarizedExperiment::assay(sca),
                                        nbins = 20, min_per_bin = 30)))
    SummarizedExperiment::assays(sca) <-
        list(thresh = thresh$counts_threshold,
             tpm = SummarizedExperiment::assay(sca))
    SummarizedExperiment::colData(sca)$cngeneson <-
        scale(colSums(SummarizedExperiment::assay(sca) > 0))
    if(all(is.na(SummarizedExperiment::colData(sca)$cngeneson))){
        SummarizedExperiment::colData(sca)$cngeneson <- 0
    }
    zlmCond <- MAST::zlm(
        stats::as.formula(
            paste0("~", paste(c("condition", "cngeneson", covariates),
                              collapse = '+'))),
        sca)
    summaryCond <- MAST::summary(zlmCond, doLRT = "conditionc1")
    summaryDt <- summaryCond$datatable
    fcHurdle <- merge(summaryDt[summaryDt$contrast == "conditionc1" &
                                    summaryDt$component == "H",
                                c('primerid', 'Pr(>Chisq)')],
                      summaryDt[summaryDt$contrast == "conditionc1" &
                                    summaryDt$component == "logFC",
                                c('primerid', 'coef', 'ci.hi', 'ci.lo')],
                      by = "primerid")
    fcHurdle$fdr <- stats::p.adjust(fcHurdle$`Pr(>Chisq)`, "fdr")
    fcHurdleSig <- merge(fcHurdle,
                         data.table::as.data.table(S4Vectors::mcols(sca)),
                         by = "primerid")
    fcHurdleSig <- fcHurdleSig[, -c(4, 5)]
    names(fcHurdleSig)[c(1, 2, 3, 4)] <- c("Gene", "Pvalue",
                                           "Log2_FC", "FDR")
    fcHurdleSig$Gene <- as.character(fcHurdleSig$Gene)
    fcHurdleSig <- .calculateDEMetrics(fcHurdleSig, expData(inSCE, useAssay),
                                       ix1, ix2)
    fcHurdleSig <- .filterDETable(fcHurdleSig, onlyPos, log2fcThreshold,
                                  fdrThreshold, minGroup1MeanExp,
                                  maxGroup2MeanExp, minGroup1ExprPerc,
                                  maxGroup2ExprPerc)

    resultList$result <- fcHurdleSig
    resultList$method <- 'MAST'

    if ("diffExp" %in% names(S4Vectors::metadata(inSCE))){
        S4Vectors::metadata(inSCE)$diffExp[[analysisName]] <- resultList
    } else {
        S4Vectors::metadata(inSCE)$diffExp <- list()
        S4Vectors::metadata(inSCE)$diffExp[[analysisName]] <- resultList
    }
    return(inSCE)
}

#' @rdname runDEAnalysis
#' @export
runWilcox <- function(inSCE, useAssay = 'logcounts', useReducedDim = NULL,
                      index1 = NULL, index2 = NULL, class = "cluster",
                      classGroup1 = c(1), classGroup2 = c(2), analysisName = "cluster1_VS_2",
                      groupName1 = "cluster1", groupName2 = "cluster2", covariates = NULL,
                      onlyPos = FALSE, log2fcThreshold = NULL,
                      fdrThreshold = NULL, minGroup1MeanExp = NULL,
                      maxGroup2MeanExp = NULL, minGroup1ExprPerc = NULL,
                      maxGroup2ExprPerc = NULL, overwrite = FALSE,
                      verbose = TRUE){
  resultList <- .formatDEAList(inSCE, useAssay, useReducedDim, index1, index2,
                               class, classGroup1, classGroup2, groupName1,
                               groupName2, analysisName, covariates,
                               overwrite)
  useAssay <- resultList$useAssay
  if (!is.null(covariates)) {
    warning("Wilcoxon test from Scran does not support covariate modeling.
            Ignoring this argument in calculation, but will be included in
            plotting.")
  }
  ix1 <- resultList$select$ix1
  ix2 <- resultList$select$ix2
  conditions <- rep(NA, ncol(inSCE))
  conditions[ix1] <- 'cond1'
  conditions[ix2] <- 'cond2'
  if (!is.null(useAssay)) {
    mat <- expData(inSCE, useAssay)
  } else {
    mat <- t(SingleCellExperiment::reducedDim(inSCE, useReducedDim))
  }
  if (isTRUE(verbose)) {
    message(date(), " ... Running DE with wilcox, Analysis name: ",
            analysisName)
  }
  result <- scran::pairwiseWilcox(mat, groups = conditions)
  # result <- scran::pairwiseWilcox(inSCE, groups = conditions,
  #                                 assay.type = useAssay)
  if (result$pairs$first[1] == "cond1") {
    table <- result$statistics[[1]]
  } else {
    table <- result$statistics[[2]]
  }
  # Generate LogFC value

  if (!is.null(useAssay)) {
    cond1.assay <- expData(inSCE, useAssay)[rownames(table), ix1, drop=FALSE]
    cond2.assay <- expData(inSCE, useAssay)[rownames(table), ix2, drop=FALSE]
  } else {
    cond1.assay <- t(expData(inSCE, useReducedDim))[rownames(table), ix1, drop=FALSE]
    cond2.assay <- t(expData(inSCE, useReducedDim))[rownames(table), ix2, drop=FALSE]
  }
  # Assuming that useAssay is log-normalized counts
  table$Log2_FC <- rowMeans(cond1.assay) - rowMeans(cond2.assay)

  deg <- data.frame(Gene = as.character(rownames(table)),
                    Log2_FC = table$Log2_FC,
                    Pvalue = table$p.value,
                    FDR = table$FDR)
  rownames(deg) <- NULL
  deg <- .calculateDEMetrics(deg, mat, ix1, ix2)
  deg <- .filterDETable(deg, onlyPos, log2fcThreshold, fdrThreshold,
                        minGroup1MeanExp, maxGroup2MeanExp,
                        minGroup1ExprPerc, maxGroup2ExprPerc)

  resultList$result <- deg
  resultList$method <- 'wilcox'
  if ("diffExp" %in% names(S4Vectors::metadata(inSCE))){
    S4Vectors::metadata(inSCE)$diffExp[[analysisName]] <- resultList
  } else {
    S4Vectors::metadata(inSCE)$diffExp <- list()
    S4Vectors::metadata(inSCE)$diffExp[[analysisName]] <- resultList
  }
  return(inSCE)
}

# DEG Functions
library(singleCellTK)
context("Testing DEG functions")
data(sceBatches, package = "singleCellTK")

logcounts(sceBatches) <- log1p(counts(sceBatches))
sceBatches <- subsetSCECols(sceBatches, colData = "batch == 'w'")

test_that(desc = "Testing Limma DE", {
  sceBatches <- runLimmaDE(inSCE = sceBatches,
                           class = "cell_type",
                           classGroup1 = "alpha", classGroup2 = "beta",
                           groupName1 = "a", groupName2 = "b",
                           analysisName = "aVSbLimma")

  testthat::expect_true("diffExp" %in% names(metadata(sceBatches)))
  testthat::expect_true("aVSbLimma" %in% names(metadata(sceBatches)$diffExp))
})

test_that(desc = "Testing MAST DE", {
  sceBatches <- runMAST(inSCE = sceBatches,
                        class = "cell_type",
                        classGroup1 = "alpha", classGroup2 = "beta",
                        groupName1 = "a", groupName2 = "b",
                        analysisName = "aVSbMAST")

  testthat::expect_true("diffExp" %in% names(metadata(sceBatches)))
  testthat::expect_true("aVSbMAST" %in% names(metadata(sceBatches)$diffExp))
})

test_that(desc = "Testing DESeq2 DE", {
  sceBatches <- runDESeq2(inSCE = sceBatches,
                          class = "cell_type",
                          classGroup1 = "alpha", classGroup2 = "beta",
                          groupName1 = "a", groupName2 = "b",
                          analysisName = "aVSbDESeq2")

  testthat::expect_true("diffExp" %in% names(metadata(sceBatches)))
  testthat::expect_true("aVSbDESeq2" %in% names(metadata(sceBatches)$diffExp))
})

test_that(desc = "Testing ANOVA DE", {
  sceBatches <- runANOVA(inSCE = sceBatches,
                         class = "cell_type",
                         classGroup1 = "alpha", classGroup2 = "beta",
                         groupName1 = "a", groupName2 = "b",
                         analysisName = "aVSbANOVA")

  testthat::expect_true("diffExp" %in% names(metadata(sceBatches)))
  testthat::expect_true("aVSbANOVA" %in% names(metadata(sceBatches)$diffExp))
})

test_that(desc = "Testing Wilcoxon DE", {
  sceBatches <- runWilcox(inSCE = sceBatches,
                          class = "cell_type",
                          classGroup1 = "alpha", classGroup2 = "beta",
                          groupName1 = "a", groupName2 = "b",
                          analysisName = "aVSbWilcox")

  testthat::expect_true("diffExp" %in% names(metadata(sceBatches)))
  testthat::expect_true("aVSbWilcox" %in% names(metadata(sceBatches)$diffExp))

  # Also Plotting functions at this point
  vlcn <- plotDEGVolcano(sceBatches, "aVSbWilcox")
  testthat::expect_is(vlcn, "ggplot")

  hm <- plotDEGHeatmap(sceBatches, "aVSbWilcox",
                       minGroup1ExprPerc = NULL, maxGroup2ExprPerc = NULL)
  testthat::expect_is(hm, "Heatmap")

  pR <- plotDEGRegression(sceBatches, "aVSbWilcox")
  testthat::expect_is(pR, "ggplot")

  pV <- plotDEGViolin(sceBatches, "aVSbWilcox")
  testthat::expect_is(pV, "ggplot")
})

test_that(desc = "Testing findMarker", {
  sceBatches <- runFindMarker(inSCE = sceBatches,
                              cluster = "cell_type")
  testthat::expect_true("findMarker" %in% names(metadata(sceBatches)))

  topTable <- getFindMarkerTopTable(sceBatches, log2fcThreshold = 1,
                                    fdrThreshold = 0.05, minClustExprPerc = 0.7,
                                    maxCtrlExprPerc = 0.4, minMeanExpr = 1,
                                    topN = 10)
  testthat::expect_is(topTable, "data.frame")
  testthat::expect_named(topTable, c("Gene", "Log2_FC", "Pvalue", "FDR",
                                     "cell_type", "clusterExprPerc",
                                     "ControlExprPerc", "clusterAveExpr"))
  testthat::expect_gt(nrow(topTable), 0)

  hmFM <- plotFindMarkerHeatmap(sceBatches)
  testthat::expect_is(hmFM, "Heatmap")
})

shinyPanelRemove <- fluidPage(
  includeCSS('styles.CSS'),
  h1("Remove Data"),
  h5(tags$a(href = paste0(docs.artPath, "delete_data.html"),
            "(help)", target = "_blank")),
  hr(),
  h5("Select data to remove:"),
  fluidRow(
    column(
      12,
      uiOutput(
        outputId = "assaysList"
      ),
      uiOutput(
        outputId = "rowDataList"
      ),
      uiOutput(
        outputId = "colDataList"
      ),
      uiOutput(
        outputId = "reducedDimsList"
      ),
      uiOutput(
        outputId = "altExpList"
      ),
      hr(),
      h6("Warning: This action is inreversible. "),
      
      actionButton(
        inputId = "delRedDim",
        label = "Delete"),
      
    )
  ),
  br()
)

.plotHeatmapMulti <- function(plots,
                             components = NULL,
                             nCol = NULL){
  plot <- NULL

  if(is.null(nCol)){
    nCol <- floor(sqrt(length(plots)))
  }

  if(is.null(components)){
    plot <- cowplot::plot_grid(plotlist = plots, ncol = nCol)
  }
  else{
    if(!is.numeric(components)){
      components <- as.numeric(gsub("[^0-9.-]", "", components))
    }
    plot <- cowplot::plot_grid(plotlist = plots[components], ncol = nCol)
  }

  return(plot)
}

#' @title Detecting contamination with DecontX.
#' @description A wrapper function for \link[celda]{decontX}. Identify
#'  potential contamination from experimental factors such as ambient RNA.
#' @param inSCE A \link[SingleCellExperiment]{SingleCellExperiment} object.
#' @param sample A single character specifying a name that can be found in
#' \code{colData(inSCE)} to directly use the cell annotation; or a character
#' vector with as many elements as cells to indicates which sample each cell
#' belongs to. Default NULL. \link[celda]{decontX} will be run on cells from
#' each sample separately.
#' @param useAssay  A string specifying which assay in the SCE to use. Default
#' 'counts'.
#' @param background A \link[SingleCellExperiment]{SingleCellExperiment}
#' with the matrix located in the assay slot under \code{bgAssayName}. It should have 
#' the same structure as inSCE except it contains the matrix of empty droplets instead 
#' of cells. When supplied, empirical distribution of transcripts from these 
#' empty droplets will be used as the contamination distribution. Default NULL.
#' @param bgAssayName Character. Name of the assay to use if background is a 
#' \link[SingleCellExperiment]{SingleCellExperiment}. If NULL, the function
#' will use the same value as \code{useAssay}. Default is NULL. 
#' @param bgBatch Batch labels for \code{background}. If \code{background} is a 
#' \link[SingleCellExperiment]{SingleCellExperiment} object, this can be a single 
#' character specifying a name that can be found in \code{colData(background)} 
#' to directly use the barcode annotation; or a numeric / character vector that has  
#' as many elements as barcodes to indicate which sample each barcode belongs to. Its 
#' unique values should be the same as those in \code{sample}, such that each 
#' batch of cells have their corresponding batch of empty droplets as background, 
#' pointed by this parameter. Default to NULL.
#' @param z Numeric or character vector. Cell cluster labels. If NULL,
#' PCA will be used to reduce the dimensionality of the dataset initially,
#' '\link[uwot]{umap}' from the 'uwot' package
#' will be used to further reduce the dataset to 2 dimenions and
#' the '\link[dbscan]{dbscan}' function from the 'dbscan' package
#' will be used to identify clusters of broad cell types. Default NULL.
#' @param maxIter Integer. Maximum iterations of the EM algorithm. Default 500.
#' @param convergence Numeric. The EM algorithm will be stopped if the maximum
#' difference in the contamination estimates between the previous and
#' current iterations is less than this. Default 0.001.
#' @param iterLogLik Integer. Calculate log likelihood every \code{iterLogLik}
#' iteration. Default 10.
#' @param delta Numeric Vector of length 2. Concentration parameters for
#' the Dirichlet prior for the contamination in each cell. The first element
#' is the prior for the native counts while the second element is the prior for
#' the contamination counts. These essentially act as pseudocounts for the
#' native and contamination in each cell. If \code{estimateDelta = TRUE},
#' this is only used to produce a random sample of proportions for an initial
#' value of contamination in each cell. Then
#' \code{\link[MCMCprecision]{fit_dirichlet}} is used to update
#' \code{delta} in each iteration.
#' If \code{estimateDelta = FALSE}, then \code{delta} is fixed with these
#' values for the entire inference procedure. Fixing \code{delta} and
#' setting a high number in the second element will force \code{decontX}
#' to be more aggressive and estimate higher levels of contamination at
#' the expense of potentially removing native expression.
#' Default \code{c(10, 10)}.
#' @param estimateDelta Boolean. Whether to update \code{delta} at each
#' iteration.
#' @param varGenes Integer. The number of variable genes to use in
#' dimensionality reduction before clustering. Variability is calcualted using
#' \code{\link[scran]{modelGeneVar}} function from the 'scran' package.
#' Used only when z is not provided. Default 5000.
#' @param dbscanEps Numeric. The clustering resolution parameter
#' used in '\link[dbscan]{dbscan}' to estimate broad cell clusters.
#' Used only when z is not provided. Default 1.
#' @param seed Integer. Passed to \link[withr]{with_seed}. For reproducibility,
#'  a default value of 12345 is used. If NULL, no calls to
#'  \link[withr]{with_seed} are made.
#' @param logfile Character. Messages will be redirected to a file named
#'  `logfile`. If NULL, messages will be printed to stdout.  Default NULL.
#' @param verbose Logical. Whether to print log messages. Default TRUE.
#'
#' @return A \link[SingleCellExperiment]{SingleCellExperiment} object with
#'  'decontX_Contamination' and 'decontX_Clusters' added to the
#'  \link{colData} slot. Additionally, the
#' decontaminated counts will be added as an assay called 'decontXCounts'.
#' @examples
#' data(scExample, package = "singleCellTK")
#' sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
#' sce <- runDecontX(sce[,sample(ncol(sce),20)])
#' @export
runDecontX <- function(inSCE,
    sample = NULL,
    useAssay = "counts",
    background = NULL,
    bgAssayName = NULL,
    bgBatch = NULL,
    z = NULL,
    maxIter = 500,
    delta = c(10, 10),
    estimateDelta = TRUE,
    convergence = 0.001,
    iterLogLik = 10,
    varGenes = 5000,
    dbscanEps = 1,
    seed = 12345,
    logfile = NULL,
    verbose = TRUE
) {
  #argsList <- as.list(formals(fun = sys.function(sys.parent()), envir = parent.frame()))
  argsList <- mget(names(formals()),sys.frame(sys.nframe()))
  if(!is.null(sample)) {
    # get sample from colData(inSCE)
    if (length(sample) == 1) {
      if (!sample %in% names(SummarizedExperiment::colData(inSCE))) {
        stop("Specified Sample variable not found in colData")
      }
      sample <- SummarizedExperiment::colData(inSCE)[[sample]]
    } else if(length(sample) != ncol(inSCE)) {
      stop("'sample' must be the same length as the number of columns in 'inSCE'")
    }
    if (is.factor(sample)) {
      sample <- as.character(sample)
    }
    uniqueSample <- unique(sample)

    if (!is.null(background)) {
      ### Background must be a SCE object if the input of count is in SCE object. Required by celda::decontX. 
      if (!inherits(background, 'SingleCellExperiment')) {
        stop("'background' is not a SingleCellExperiment object")
      }

      if (!is.null(bgBatch)) {
        ### check whether variable can be found in colData.
        if(length(bgBatch) == 1) { # & is(background, 'SingleCellExperiment')
          if(!bgBatch %in% names(SummarizedExperiment::colData(background))) {
            stop("Specified bgBatch variable not found in colData")
          }
          bgBatch <- SummarizedExperiment::colData(background)[[bgBatch]]
        } else if(length(bgBatch) != ncol(background)) {
          stop("'bgBatch' must be the same length as the number of columns in 'background'")      
        }

        if (!all(unique(bgBatch) %in% uniqueSample)) {
            stop("Not all bgBatch can be found in 'samples'.")
        }

        if (is.factor(bgBatch)) {
          bgBatch <- as.character(bgBatch)
        }
      }      
    }
  } else {
    # When sample not specified, labeled as "all_cells" 
    sample <- rep("all_cells", ncol(inSCE))
    if (!is.null(background)) {
        if (!is.null(bgBatch)) {
            warning("Using all background because 'sample' not specified.")
        }
        bgBatch <- rep("all_cells", ncol(background))
    }
    uniqSample <- "all_cells"    
  }


  p <- paste0(date(), " ... Running 'DecontX'")
  message(p)

  ## keep a copy of original decontX result, if there's any
  oldColData <- NULL
  oldColId <- grep('decontX_', colnames(SummarizedExperiment::colData(inSCE)))
  if(length(oldColId) != 0) {
    oldColData <- SummarizedExperiment::colData(inSCE)[, oldColId]
    SummarizedExperiment::colData(inSCE)[oldColId] <- NULL
  }

  oldAssay <- NULL
  oldAssayId <- grep('decontXcounts', SummarizedExperiment::assayNames(inSCE))
  if(length(oldAssayId) != 0) {
    oldAssay <- SummarizedExperiment::assays(inSCE)[oldAssayId]
    SummarizedExperiment::assays(inSCE)[oldAssayId] <- NULL
  }

  oldDim<- NULL
  oldDimId <- grep('decontX_', SingleCellExperiment::reducedDimNames(inSCE))
  if(length(oldAssayId) != 0) {
    oldDim <- SingleCellExperiment::reducedDims(inSCE)[oldDimId]
    SingleCellExperiment::reducedDims(inSCE)[oldDimId] <- NULL
  }

  oldMeta <- NULL
  oldMetaId <- grep('runDecontX', names(S4Vectors::metadata(inSCE)$sctk))
  if(length(oldMetaId) != 0) {
    oldMeta <- S4Vectors::metadata(inSCE)$sctk[oldMetaId]
    S4Vectors::metadata(inSCE)$sctk[oldMetaId] <- NULL
  }

  rm.ix <- which(colSums(assay(inSCE, useAssay)) == 0)
  if(length(rm.ix) > 0){
    inSCEOrig <- inSCE
    inSCE <- inSCE[,-rm.ix]
    sample <- sample[-rm.ix]
  }

  inSCE <- celda::decontX(x = inSCE,
                          batch = sample,
                          assayName = useAssay,
                          background = background,
                          bgAssayName = bgAssayName,
                          bgBatch = bgBatch,
                          z = z,
                          maxIter = maxIter,
                          delta = delta,
                          estimateDelta = estimateDelta,
                          convergence = convergence,
                          iterLogLik = iterLogLik,
                          varGenes = varGenes,
                          dbscanEps = dbscanEps,
                          seed = seed,
                          logfile = logfile,
                          verbose = verbose)

  #argsList <- argsList[!names(argsList) %in% ("...")]
  colId <- colnames(SummarizedExperiment::colData(inSCE)) %in% c('decontX_contamination', 'decontX_clusters')
  newCol <- SummarizedExperiment::colData(inSCE)[colId]
  SummarizedExperiment::colData(inSCE)[colId] <- NULL

  assayId <- SummarizedExperiment::assayNames(inSCE) == "decontXcounts"
  newAssay <- SummarizedExperiment::assays(inSCE)[assayId]
  SummarizedExperiment::assays(inSCE)[assayId] <- NULL

  DimId <- grep("decontX", SingleCellExperiment::reducedDimNames(inSCE), 
                value=TRUE)#SingleCellExperiment::reducedDimNames(inSCE) == "decontX_UMAP"
  newDim <- SingleCellExperiment::reducedDims(inSCE)[DimId]
  SingleCellExperiment::reducedDims(inSCE)[DimId] <- NULL

  metaId <- names(S4Vectors::metadata(inSCE)) == "decontX"
  newMeta <- S4Vectors::metadata(inSCE)[metaId]
  newMeta$decontX <- S4Vectors::metadata(inSCE)$decontX$runParams #only keep runParams in metadata
  newMeta$decontX$packageVersion <- utils::packageDescription("celda")$Version
  names(newMeta) <- "runDecontX"
  S4Vectors::metadata(inSCE)[metaId] <- NULL

  ### further process the metadata for each sample
  newMeta_bc <- newMeta
  newMeta <- NULL
  batchMeta <- newMeta_bc$runDecontX$batch
  bgBatchMeta <- newMeta_bc$runDecontX$batchBackground
  newMeta_bc$runDecontX[c("batch", "batchBackground")] <- NULL

  for (s in unique(sample)) {
    newMeta$runDecontX[[s]] <- newMeta_bc$runDecontX
    newMeta$runDecontX[[s]]$batch <- batchMeta[batchMeta == s]
    newMeta$runDecontX[[s]]$batchBackground <- bgBatchMeta[bgBatchMeta == s]
  }

  ### merge inSCE to restore some cells that are removed by rm.ix
  if(length(rm.ix) > 0){
    inSCE <- mergeSCEColData(inSCE1 = inSCEOrig, inSCE2 = inSCE)
  }

  ### update the decontX result, if there's any
  
  if(!is.null(background)) {
    ## need to rename the colData if backgroud is supplied
    colnames(newCol) <- paste(colnames(newCol), 'bg', sep = '_')
    ## need to rename the assay name
    names(newAssay) <- "decontXcounts_bg"
    ## need to rename reducedDim
    names(newDim) <- paste(names(newDim), "bg", sep = "_")
    ## need to rename metadata
    names(newMeta) <- "runDecontX_bg"
  }

  # update Assay
  if(!is.null(oldAssay)) {
    oldAssay[names(newAssay)] <- newAssay
    finalAssay <- oldAssay
  } else {
    finalAssay <- newAssay
  }

  # update reducedDim
  if(!is.null(oldDim)) {
    oldDim[names(newDim)] <- newDim
    finalDim <- oldDim
  } else {
    finalDim <- newDim
  }

  # update colData
  if(!is.null(oldColData)) {
    oldColData[, colnames(newCol)] <- newCol[rownames(oldColData), ]
    finalCol <- oldColData    
  } else {
    finalCol <- newCol[colnames(inSCE), ]
  }

  # update metadata
  if(!is.null(oldMeta)) {
    oldMeta[names(newMeta)] <- newMeta
    finalMeta <- oldMeta
  } else {
    finalMeta <- newMeta
  }
  
  # store new result back to inSCE object
  SummarizedExperiment::colData(inSCE)[colnames(finalCol)] <- finalCol
  SummarizedExperiment::assays(inSCE)[names(finalAssay)] <- finalAssay
  SingleCellExperiment::reducedDims(inSCE)[names(finalDim)] <- finalDim
  S4Vectors::metadata(inSCE)$sctk[names(finalMeta)] <- finalMeta
  # inSCE@metadata$sctk$runDecontX <- argsList[-1]
  # inSCE@metadata$sctk$runDecontX$packageVersion <- utils::packageDescription("celda")$Version
  inSCE <- expSetDataTag(inSCE, "raw", "decontXcounts")
  return(inSCE)
}

# decontamination algorithms
library(singleCellTK)
context("Testing decontamination algorithms")
data(scExample, package = "singleCellTK")
sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")

test_that(desc = "Testing runDecontX", {
        sceres <- runDecontX(sce)
        expect_equal(length(colData(sceres)$decontX_clusters),ncol(sce))
        expect_equal(class(colData(sceres)$decontX_contamination), "numeric")
})

#' @title Retrieve row index for a set of features
#' @description This will return indices of features among the rownames
#' or rowData of a data.frame, matrix, or a \linkS4class{SummarizedExperiment}
#' object including a \linkS4class{SingleCellExperiment}.
#' Partial matching (i.e. grepping) can be used by setting
#' \code{exactMatch = FALSE}.
#' @param features Character vector of feature names to find in the rows of
#' \code{inSCE}.
#' @param inSCE A data.frame, matrix, or \linkS4class{SingleCellExperiment}
#' object to search.
#' @param by Character. Where to search for features in \code{inSCE}. If set to
#' \code{"rownames"} then the features will be searched for among
#' \code{rownames(inSCE)}. If \code{inSCE} inherits from class
#' \linkS4class{SummarizedExperiment}, then \code{by} can be one of the
#' fields in the row annotation data.frame (i.e. one of
#' \code{colnames(rowData(inSCE))}).
#' @param exactMatch Boolean. Whether to only identify exact matches
#' or to identify partial matches using \code{\link{grep}}.
#' @param removeNA Boolean. If set to \code{FALSE}, features not found in
#' \code{inSCE} will be given \code{NA} and the returned vector will be the same
#' length as \code{features}. If set to \code{TRUE}, then the \code{NA}
#' values will be removed from the returned vector. Default \code{FALSE}.
#' @param errorOnNoMatch Boolean. If \code{TRUE}, an error will be given if
#' no matches are found. If \code{FALSE}, an empty vector will be returned if 
#' \code{removeNA} is set to \code{TRUE} or a vector of \code{NA} if 
#' \code{removeNA} is set to \code{FALSE}. Default \code{TRUE}.
#' @param warningOnPartialMatch Boolean. If \code{TRUE}, a warning will be
#' given if some of the entries in \code{features} were not found in 
#' \code{inSCE}. The warning will list the features not found.
#' Default \code{TRUE}.
#' @return A vector of row indices for the matching features in \code{inSCE}.
#' @author Yusuke Koga, Joshua D. Campbell
#' @seealso '\link[scater]{retrieveFeatureInfo}' from package \code{'scater'}
#' and \code{link{regex}} for how to use regular expressions when
#' \code{exactMatch = FALSE}.
#' @examples
#' data(scExample)
#' ix <- featureIndex(features = c("MT-CYB", "MT-ND2"),
#'                              inSCE = sce,
#'                              by = "feature_name")
#' @export
featureIndex <- function(features, inSCE,
                                 by = "rownames",
                                 exactMatch = TRUE,
                                 removeNA = FALSE,
                                 errorOnNoMatch = TRUE,
                                 warningOnPartialMatch = TRUE) {
  
  # Extract vector to search through
  if (by == "rownames") {
    if (is.null(rownames(inSCE))) {
      stop("'rownames' of 'inSCE' are 'NULL'. Please set 'rownames' or change",
           " 'by' to search a different column in 'inSCE'.")
    }
    search <- rownames(inSCE)
  } else if (length(ncol(inSCE)) > 0) {
    if (inherits(inSCE, "SummarizedExperiment")) {
      if (!(by %in% colnames(rowData(inSCE)))) {
        stop("'by' is not a column in 'rowData(inSCE)'.")
      }
      search <- rowData(inSCE)[, by]
    } else {
      if (!(by %in% colnames(inSCE))) {
        stop("'by' is not a column in 'inSCE'.")
      }
      search <- inSCE[, by]
    }
  } else {
    search <- as.character(inSCE)
  }
  
  # Match each element of 'pattern' in vector 'search'
  if (!isTRUE(exactMatch)) {
    featuresIndices <- rep(NA, length(features))
    for (i in seq_along(features)) {
      g <- grep(features[i], search)
      if (length(g) == 1) {
        featuresIndices[i] <- g
      } else if (length(g) > 1) {
        warning(
          "Feature '", features[i], "' matched multiple items in '",
          by, "': ", paste(search[g], collapse = ","),
          ". Only the first match will be selected."
        )
        featuresIndices[i] <- g[1]
      }
    }
  } else {
    featuresIndices <- match(features, search)
  }
  
  if (sum(is.na(featuresIndices)) > 0) {
    if (sum(is.na(featuresIndices)) == length(features)
        & isTRUE(errorOnNoMatch)) {
      if (isTRUE(exactMatch)) {
        stop(
          "None of the provided features had matching",
          " items in '", by, "' within 'inSCE'. ",
          "Check the spelling or try setting",
          " 'exactMatch = FALSE'."
        )
      } else {
        stop(
          "None of the provided features had matching",
          " items in '", by, "' within 'inSCE'. ",
          "Check the spelling and make sure 'by' is set",
          " to the appropriate place in 'inSCE'."
        )
      }
    }
    if(isTRUE(warningOnPartialMatch)){
      warning(
        "The following features were not present in 'inSCE': ",
        paste(features[which(is.na(featuresIndices))],
              collapse = ","
        )
      )
    }
  }
  
  if (isTRUE(removeNA)) {
    featuresIndices <- featuresIndices[!is.na(featuresIndices)]
  }
  return(featuresIndices)
}

# All the code in this file needs to be copied to your Shiny app, and you need
# to call `withBusyIndicatorUI()` and `withBusyIndicatorServer()` in your app.
# You can also include the `appCSS` in your UI, as the example app shows.

# =============================================

# Set up a button to have an animated loading indicator and a checkmark
# for better user experience
# Need to use with the corresponding `withBusyIndicator` server function
withBusyIndicatorUI <- function(button) {
  id <- button[["attribs"]][["id"]]
  div(
    `data-for-btn` = id,
    button,
    span(
      class = "btn-loading-container",
      hidden(
        img(src = "ajax-loader-bar.gif", class = "btn-loading-indicator"),
        icon("check", class = "btn-done-indicator")
      )
    ),
    hidden(
      div(class = "btn-err",
          div(icon("exclamation-circle"),
              tags$b("Error: "),
              span(class = "btn-err-msg")
          )
      )
    )
  )
}

# does the same thing as above, but put the animation inside the button label
actionButtonBusy <- function(buttonId, buttonTitle) {
  tags$div(
    `data-for-btn` = buttonId,
    actionButton(
      buttonId,
      tags$div(
        buttonTitle,
        tags$span( class = "btn-loading-container", style = "float:right",
                   hidden(
                     img(src = "ajax-loader-bar.gif", class = "btn-loading-indicator"),
                     icon("check", class = "btn-done-indicator")
                   )
        )
      )
    ),
    hidden(
      div(class = "btn-err",
          div(icon("exclamation-circle"),
              tags$b("Error: "),
              span(class = "btn-err-msg")
          )
      )
    )
  )
}

# Call this function from the server with the button id that is clicked and the
# expression to run when the button is clicked
withBusyIndicatorServer <- function(buttonId, expr) {
  # UX stuff: show the "busy" message, hide the other messages, disable the button
  loadingEl <- sprintf("[data-for-btn=%s] .btn-loading-indicator", buttonId)
  doneEl <- sprintf("[data-for-btn=%s] .btn-done-indicator", buttonId)
  errEl <- sprintf("[data-for-btn=%s] .btn-err", buttonId)
  shinyjs::disable(buttonId)
  shinyjs::show(selector = loadingEl)
  shinyjs::hide(selector = doneEl)
  shinyjs::hide(selector = errEl)
  on.exit({
    shinyjs::enable(buttonId)
    shinyjs::hide(selector = loadingEl)
  })

  # Try to run the code when the button is clicked and show an error message if
  # an error occurs or a success message if it completes
  tryCatch({
    value <- expr
    shinyjs::show(selector = doneEl)
    shinyjs::delay(2000, shinyjs::hide(selector = doneEl, anim = TRUE, animType = "fade",
                                       time = 0.5))
    value
  }, error = function(err){
    errorFunc(err, buttonId)
  })
}

# When an error happens after a button click, show the error
errorFunc <- function(err, buttonId) {
  message(paste0(date(), " !!! ", err))
  shinyalert("Error", text = err$message, type = "error")
  errEl <- sprintf("[data-for-btn=%s] .btn-err", buttonId)
  errElMsg <- sprintf("[data-for-btn=%s] .btn-err-msg", buttonId)
  errMessage <- gsub("^ddpcr: (.*)", "\\1", err$message)
  shinyjs::html(html = errMessage, selector = errElMsg)
  shinyjs::show(selector = errEl, anim = TRUE, animType = "fade")
}

appCSS <- "
.btn-loading-container {
  margin-left: 10px;
  font-size: 1.2em;
}
.btn-done-indicator {
  color: green;
}
.btn-err {
  margin-top: 10px;
  color: red;
}
"

# Accordion - formatting for collapsible section in an accordion
# Use example:
#     HTML('<div class="accordion" id="myAccordion">
#       <div class="panel">'),

#         HTML(accordionSection("1","2","myAccordion")),
#           # panel content code,
#         HTML('</div>'),

#       HTML('</div>
#     </div>')
accordionSection <- function(collapseId, panelTitle, accordionId) {
  return(
    paste(
      '<button type="button" class="btn btn-default btn-block" ',
      'data-toggle="collapse" data-target="#', collapseId, '" data-parent="#', accordionId, '">',
      panelTitle,
      '</button>
      <div id="', collapseId, '" class="collapse">',
      sep = ""
    )
  )
}

# show or hide all collapses in a list
allSections <- function(action, collapseList) {
  if (action == "hide"){
    for (i in collapseList){
      shinyjs::hide(i, anim = TRUE)
    }
  }
  else if (action == "show"){
    for (i in collapseList){
      shinyjs::show(i, anim = TRUE)
    }
  }
}

withConsoleRedirect <- function(expr) {
  options(warn = 1)
  tmpSinkfileName <- tempfile()
  tmpFD <- file(tmpSinkfileName, open = "wt")
  sink(tmpFD, type="output", split = TRUE)
  sink(tmpFD, type = "message")

  result <- expr

  sink(type = "message")
  sink()
  console.out <- readChar(tmpSinkfileName, file.info(tmpSinkfileName)$size)
  unlink(tmpSinkfileName)
  if (length(console.out) > 0) {
    insertUI(paste0("#", "console"), where = "beforeEnd",
             ui = tags$p(paste0(console.out, "\n", collapse = ""))
    )
  }
  result
}

withConsoleMsgRedirect <- function(expr, msg="Please wait. See console log for progress.") {
  withCallingHandlers(
    expr = {
      .loadOpen(msg)
      tryCatch(
        {
          result <- expr
        },
        error = function(e) {
          message(paste0(date(), " !!! ", e))
          shinyalert("Error", text = e$message, type = "error",
                     callbackR = .loadClose())
        }
      )
      .loadClose()
    },
    message = function(m) {
      shinyjs::html(id = "consoleText", html = m$message, add = TRUE)
    }
  )
}


#-----------#
# Gene Sets #
#-----------#
formatGeneSetList <- function(setListStr) {
  setListArr <- strsplit(setListStr, "\n")[[1]]
  setListList <- list()
  for (set in setListArr) {
    setListList[[set]] <- set
  }
  return(setListList)
}

formatGeneSetDBChoices <- function(dbIDs, dbCats) {
  splitIds = strsplit(dbIDs, " ")
  choices <- list()

  for (i in seq_along(splitIds)) {
    entry <- splitIds[i][[1]]
    choices[[sprintf("%s - %s", entry, dbCats[i])]] <- entry
  }

  return(choices)
}


#--------------#
# QC/Filtering #
#--------------#
combineQCMPlots <- function(input, output, combineP, sampleList, plots, plotIds, statuses) {
  if (length(sampleList) == 1) {
    # Plot output code from https://gist.github.com/wch/5436415/
    output[[plotIds$QCMetrics]] <- renderUI({
      plot_output_list <- lapply(names(plots), function(subScore) {
        subPlotID <- paste0("QCMetrics", subScore)
        plotOutput(subPlotID)
      })

      # Convert the list to a tagList - this is necessary for the list of items
      # to display properly.
      do.call(tagList, plot_output_list)
    })

    for (subScore in names(plots)) {
      # Need local so that each item gets its own number. Without it, the value
      # of i in the renderPlot() will be the same across all instances, because
      # of when the expression is evaluated.
      local({
        my_subScore <- subScore
        subPlotID <- paste0("QCMetrics", subScore)
        output[[subPlotID]] <- renderPlot(plots[[my_subScore]])
      })
    }
  } else {
    output[[plotIds$QCMetrics]] <- renderUI({
      plot_output_list <- lapply(names(plots$Violin), function(subScore) {
        subPlotID <- paste0("QCMetrics", subScore)
        if (is.null(input$subScore)){
          plotOutput(subPlotID)
        }
      })

      # Convert the list to a tagList - this is necessary for the list of items
      # to display properly.
      do.call(tagList, plot_output_list)
    })

    for (subScore in names(plots$Violin)) {
      # Need local so that each item gets its own number. Without it, the value
      # of i in the renderPlot() will be the same across all instances, because
      # of when the expression is evaluated.
      local({
        my_subScore <- subScore
        subPlotID <- paste0("QCMetrics", my_subScore)

        output[[subPlotID]] <- renderPlot(plots$Violin[[my_subScore]])
      })
    }
  }
}

combineQCSubPlots <- function(output, combineP, algo, sampleList, plots, plotIds, statuses) {
  if (length(sampleList) == 1) {
    # Plot output code from https://gist.github.com/wch/5436415/
    output[[plotIds[[algo]]]] <- renderUI({
      plot_output_list <- lapply(names(plots), function(subScore) {
        subPlotID <- paste(c(algo, subScore), collapse="")
        plotOutput(subPlotID)
      })

      # Convert the list to a tagList - this is necessary for the list of items
      # to display properly.
      do.call(tagList, plot_output_list)
    })

    for (subScore in names(plots)) {
      # Need local so that each item gets its own number. Without it, the value
      # of i in the renderPlot() will be the same across all instances, because
      # of when the expression is evaluated.
      local({
        my_subScore <- subScore
        subPlotID <- paste(c(algo, my_subScore), collapse="")
        output[[subPlotID]] <- renderPlot(plots[[my_subScore]])
      })
    }
  } else {
    tabsetID <- paste0(algo, "Tabs") # for the tabsetPanel within a tab
    mainPlotID <- paste0(plotIds[[algo]], "Main")
    if (!is.null(plots$Violin)) {
      output[[plotIds[[algo]]]] <- renderUI(plotOutput(mainPlotID))
      output[[mainPlotID]] <- renderPlot(plots$Violin)
    }


    for (i in seq_along(sampleList)) {
      local({
        s <- sampleList[[i]]
        sID <- paste(c(algo, s, "Tab"), collapse = "")
        if (is.null(statuses[[algo]][[s]])) {
          if (i == 1) {
            appendTab(tabsetID, tabPanel(s, uiOutput(sID)), select = TRUE)
          } else {
            appendTab(tabsetID, tabPanel(s, uiOutput(sID)), select = FALSE)
          }

        }
        # Plot output code from https://gist.github.com/wch/5436415/
        output[[sID]] <- renderUI({
          plot_output_list <- lapply(names(plots$Sample[[s]]), function(subScore) {
            subPlotID <- paste(c(algo, s, subScore), collapse="")
            plotOutput(subPlotID)
          })

          # Convert the list to a tagList - this is necessary for the list of items
          # to display properly.
          do.call(tagList, plot_output_list)
        })

        for (subScore in names(plots$Sample[[s]])) {
          # Need local so that each item gets its own number. Without it, the value
          # of i in the renderPlot() will be the same across all instances, because
          # of when the expression is evaluated.
          local({
            my_subScore <- subScore
            subPlotID <- paste(c(algo, s, my_subScore), collapse="")

            output[[subPlotID]] <- renderPlot(plots$Sample[[s]][[my_subScore]])
          })
        }
      })
    }
  }
}


arrangeQCPlots <- function(inSCE, input, output, algoList, sampleList, plotIDs, statuses, redDimName) {
  uniqueSampleNames <- unique(sampleList)
  combineP <- "none"
  for (a in algoList) {
    if (a == "scDblFinder") {
      dcPlots <- plotScDblFinderResults(inSCE, combinePlot = combineP, sample = sampleList,
                                         reducedDimName = redDimName)
      combineQCSubPlots(output, combineP, a, uniqueSampleNames, dcPlots, plotIDs, statuses)
    } else if (a == "cxds") {
      cxPlots <- plotCxdsResults(inSCE, combinePlot = combineP, sample = sampleList,
                                 reducedDimName = redDimName)
      combineQCSubPlots(output, combineP, a, uniqueSampleNames, cxPlots, plotIDs, statuses)
    } else if (a == "bcds") {
      bcPlots <- plotBcdsResults(inSCE, combinePlot = combineP, sample = sampleList,
                                 reducedDimName = redDimName)
      combineQCSubPlots(output, combineP, a, uniqueSampleNames, bcPlots, plotIDs, statuses)
    } else if (a == "cxds_bcds_hybrid") {
      cxbcPlots <- plotScdsHybridResults(inSCE, combinePlot = combineP, sample = sampleList,
                                         reducedDimName = redDimName)
      combineQCSubPlots(output, combineP, a, uniqueSampleNames, cxbcPlots, plotIDs, statuses)
    } else if (a == "decontX") {
      dxPlots <- plotDecontXResults(inSCE, combinePlot = combineP, sample = sampleList,
                                    reducedDimName = redDimName)
      combineQCSubPlots(output, combineP, a, uniqueSampleNames, dxPlots, plotIDs, statuses)
    } else if (a == "soupX") {
      soupXPlots <- plotSoupXResults(inSCE, combinePlot = combineP, 
                                     sample = sampleList)
      combineQCSubPlots(output, combineP, a, uniqueSampleNames, soupXPlots, plotIDs, statuses)
    } else if (a == "QCMetrics") {
      qcmPlots <- plotRunPerCellQCResults(inSCE, sample = sampleList, combinePlot = combineP)
      combineQCMPlots(input, output, combineP, uniqueSampleNames, qcmPlots, plotIDs, statuses)

    } else if (a == "scrublet") {
      sPlots <- plotScrubletResults(inSCE, combinePlot = combineP, sample = sampleList,
                                    reducedDimName = redDimName)
      combineQCSubPlots(output, combineP, a, uniqueSampleNames, sPlots, plotIDs, statuses)
      return(sPlots)

    } else if (a == "doubletFinder") {
      dfPlots <- plotDoubletFinderResults(inSCE, combinePlot = combineP, sample = sampleList,
                                          reducedDimName = redDimName)
      combineQCSubPlots(output, combineP, a, uniqueSampleNames, dfPlots, plotIDs, statuses)
    }
  }
}


findOverlapping <- function(arr1, arr2) {
  filter <- vector()
  for (x in arr1) {
    if (x %in% arr2) {
      filter <- c(filter, TRUE)
    } else {
      filter <- c(filter, FALSE)
    }
  }
  return(arr1[filter])
}

addToColFilterParams <- function(name, categorial, criteria, criteriaGT, criteriaLT, id, paramsReactive) {
  threshStr <- ""
  if (categorial) {
    threshArr <- list()
    for (c in criteria) {
      threshArr <- c(threshArr, sprintf("%s == '%s'", name, c))
    }
    threshStr <- paste(threshArr, collapse = " | ")
  } else {
    if (is.null(criteriaGT)) {
      threshStr <- sprintf("%s < %.5f", name, criteriaLT)
    } else if (is.null(criteriaLT)) {
      threshStr <- sprintf("%s > %.5f", name, criteriaGT)
    } else {
      threshStr <- sprintf("%s > %.5f & %s < %.5f", name, criteriaGT, name, criteriaLT)
    }
  }

  entry <- list(col=name, param=threshStr, id=id)
  paramsReactive$params <- c(paramsReactive$params, list(entry))
  paramsReactive$id_count <- paramsReactive$id_count + 1
}

addToRowFilterParams <- function(name, X, Y, id, paramsReactive) {
  entry <- reactiveValues(row=name, X=X, Y=Y, id=id)
  paramsReactive$params <- c(paramsReactive$params, list(entry))
  paramsReactive$id_count <- paramsReactive$id_count + 1
}


formatFilteringCriteria <- function(paramsReactive) {
  criteria = list()
  for (entry in paramsReactive) {
    criteria <- c(criteria, entry$param)
  }
  return(criteria)
}


addRowFiltersToSCE <- function(inSCE, paramsReactive) {
  for (entry in paramsReactive$params) {
    rowName <- paste0(entry$row, "_filter")
    a <- assay(inSCE, entry$row)
    vec <- rowSums(a > entry$X) > entry$Y
    rowData(inSCE)[[rowName]] <- vec
    entry$param <- sprintf("%s == T", rowName)
  }
  return(inSCE)
}

#helper function to add notification bar while code is executing
spinnerShape <- "orbit"
spinnerColor <- "gainsboro"

.loadOpen <- function(message) {
  shinybusy::show_modal_spinner(
    spin = spinnerShape,
    color = spinnerColor,
    text = message
  ) # show the notification spinner

  shinyjs::runjs("var intervalVarAutoScrollConsole =  setInterval(startAutoScroll, 1000); Shiny.onInputChange('logDataAutoScrollStatus', intervalVarAutoScrollConsole);")

  shinyjs::show(id = "consolePanel") # open console

}

.loadClose <- function(){
  shinyjs::hide(id = "consolePanel") # close console
  shinybusy::remove_modal_spinner() #closes the notification spinner
}

#' Usually numericInput returns NA when not entering anything in UI, but
#' directly using NA causes error. Similarly, character inputs (selectionInput)
#' returns empty string "", which should usually be changed to NULL.
#' @return if not identified as empty inputs, returns as is; otherwise,
#' changeTo to `changeTo`
handleEmptyInput <- function(x,
                             type = c("auto", "numeric", "character"),
                             changeTo = NULL) {
  type = match.arg(type)
  if (type == "auto") {
    if (is.numeric(x) || is.na(x)) {
      type <- "numeric"
    } else if (is.character(x)) {
      type <- "character"
    }
  }
  if (type == "numeric" & is.na(x)) {
    x <- changeTo
  } else if (type == "character" & x == "") {
    x <- changeTo
  }
  return(x)
}

getTypeByMat <- function(inSCE, matName) {
  if (matName %in% assayNames(inSCE)) {
    return("assay")
  } else if (matName %in% altExpNames(inSCE)) {
    return("altExp")
  } else if (matName %in% reducedDimNames(inSCE)) {
    return("reducedDim")
  } else {
    for (i in altExpNames(inSCE)) {
      if (matName %in% reducedDimNames(altExp(inSCE, i))) {
        return(c("reducedDim", i))
      }
    }
    return()
  }
}

#' Generate distinct colors for all categorical col/rowData entries.
#' Character columns will be considered as well as all-integer columns. Any
#' column with all-distinct values will be excluded.
#' @param inSCE \linkS4class{SingleCellExperiment} inherited object.
#' @param axis Choose from \code{"col"} or \code{"row"}.
#' @param colorGen A function that generates color code vector by giving an
#' integer for the number of colors. Alternatively,
#' \code{\link{rainbow}}. Default \code{\link{distinctColors}}.
#' @return A \code{list} object containing distinct colors mapped to all
#' possible categorical entries in \code{rowData(inSCE)} or
#' \code{colData(inSCE)}.
#' @author Yichen Wang
dataAnnotationColor <- function(inSCE, axis = NULL,
                                colorGen = distinctColors){
    if(!is.null(axis) && axis == 'col'){
        data <- SummarizedExperiment::colData(inSCE)
    } else if(!is.null(axis) && axis == 'row'){
        data <- SummarizedExperiment::rowData(inSCE)
    } else {
        stop('please specify "col" or "row"')
    }
    nColor <- 0
    for(i in names(data)){
        if(length(grep('counts', i)) > 0){
            next
        }
        column <- stats::na.omit(data[[i]])
        if(is.numeric(column)){
            if(!all(as.integer(column) == column)){
                # Temporarily the way to tell whether numeric categorical
                next
            }
        }
        if(is.factor(column)){
            uniqLevel <- levels(column)
        } else {
            uniqLevel <- unique(column)
        }
        if(!length(uniqLevel) == nrow(data)){
            # Don't generate color for all-uniq annotation (such as IDs/symbols)
            nColor <- nColor + length(uniqLevel)
        }
    }
    if (nColor == 0) {
        return(list())
    }
    allColors <- colorGen(nColor)
    nUsed <- 0
    allColorMap <- list()
    for(i in names(data)){
        if(length(grep('counts', i)) > 0){
            next
        }
        column <- stats::na.omit(data[[i]])
        if(is.numeric(column)){
            if(!all(as.integer(column) == column)){
                # Temporarily the way to tell whether numeric categorical
                next
            }
        }
        if(is.factor(column)){
            uniqLevel <- levels(column)
        } else {
            uniqLevel <- unique(column)
        }
        if(!length(uniqLevel) == nrow(data)){
            subColors <- allColors[(nUsed+1):(nUsed+length(uniqLevel))]
            names(subColors) <- uniqLevel
            allColorMap[[i]] <- subColors
            nUsed <- nUsed + length(uniqLevel)
        }
    }
    return(allColorMap)
}

# Pass newly generated QC metric variable from vals$original to vals$counts, the
# latter might be a subset.
passQCVar <- function(sce.original, sce.counts, algoList) {
  vars <- c()
  for (a in algoList) {
    if (a == "scDblFinder") {
      new <- grep("scDblFinder", names(colData(sce.original)), value = TRUE)
    } else if (a == "cxds") {
      new <- grep("scds_cxds", names(colData(sce.original)), value = TRUE)
    } else if (a == "bcds") {
      new <- grep("scds_bcds", names(colData(sce.original)), value = TRUE)
    } else if (a == "cxds_bcds_hybrid") {
      new <- grep("scds_hybrid", names(colData(sce.original)), value = TRUE)
    } else if (a == "decontX") {
      new <- grep("decontX", names(colData(sce.original)), value = TRUE)
    } else if (a == "soupX") {
      new <- grep("soupX", names(colData(sce.original)), value = TRUE)
    } else if (a == "scrublet") {
      new <- grep("scrublet", names(colData(sce.original)), value = TRUE)
    } else if (a == "doubletFinder") {
      new <- grep("doubletFinder", names(colData(sce.original)), value = TRUE)
    } else if (a == "QCMetrics") {
      new <- c("total", "sum", "detected")
      new <- c(new, grep("percent.top", names(colData(sce.original)), value = TRUE))
      new <- c(new, grep("mito_", names(colData(sce.original)), value = TRUE))
      new <- c(new, grep("^subsets_.+_sum$", names(colData(sce.original)), value = TRUE))
      new <- c(new, grep("^subsets_.+_detected$", names(colData(sce.original)), value = TRUE))
      new <- c(new, grep("^subsets_.+_percent$", names(colData(sce.original)), value = TRUE))
    } 
    vars <- c(vars, new)
  }
  sce.original <- sce.original[rownames(sce.counts), colnames(sce.counts)]
  colData(sce.counts)[vars] <- colData(sce.original)[vars]
  return(sce.counts)
}

#' Generic Wrapper function for running dimensionality reduction
#' @details Wrapper function to run one of the available dimensionality
#' reduction algorithms integrated within SCTK from \code{\link{scaterPCA}},
#' \code{\link{runSeuratPCA}}, \code{\link{runSeuratICA}}, \code{\link{runTSNE}},
#' \code{\link{runSeuratTSNE}}, \code{\link{runUMAP}} and
#' \code{\link{runSeuratUMAP}}. Users can use an assay by specifying
#' \code{useAssay}, use the assay in an altExp by specifying both
#' \code{useAltExp} and \code{useAssay}, or use a low-dimensionality
#' representation by specifying \code{useReducedDim}.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object.
#' @param method One from \code{"scaterPCA"}, \code{"seuratPCA"},
#' \code{"seuratICA"}, \code{"rTSNE"}, \code{"seuratTSNE"}, \code{"scaterUMAP"},
#' \code{"seuratUMAP"}, \code{"scanpyPCA"}, \code{"scanpyUMAP"} and \code{"scanpyTSNE"}.
#' @param useAssay Assay to use for computation. If \code{useAltExp} is
#' specified, \code{useAssay} has to exist in
#' \code{assays(altExp(inSCE, useAltExp))}. Default \code{"counts"}.
#' @param useAltExp The subset to use for computation, usually for the
#' selected variable features. Default \code{NULL}.
#' @param useReducedDim The low dimension representation to use for embedding
#' computation. Default \code{NULL}.
#' @param reducedDimName The name of the result matrix. Required.
#' @param useFeatureSubset Subset of feature to use for dimension reduction. A
#' character string indicating a \code{rowData} variable that stores the logical
#' vector of HVG selection, or a vector that can subset the rows of
#' \code{inSCE}. Default \code{NULL}.
#' @param scale Logical scalar, whether to standardize the expression values.
#' Default \code{TRUE}.
#' @param nComponents Specify the number of dimensions to compute with the
#'  selected method in case of PCA/ICA and the number of components to
#'  use in the case of TSNE/UMAP methods.
#' @param seed Random seed for reproducibility of results.
#' Default \code{NULL} will use global seed in use by the R environment.
#' @param ... The other arguments for running a specific algorithm. Please refer
#' to the one you use.
#' @return The input \linkS4class{SingleCellExperiment} object with
#' \code{reducedDim} updated with the result.
#' @export
#' @examples
#' data(scExample, package = "singleCellTK")
#' sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
#' sce <- runNormalization(sce, useAssay = "counts",
#'                         outAssayName = "logcounts",
#'                         normalizationMethod = "logNormCounts")
#' sce <- runDimReduce(inSCE = sce, method = "scaterPCA",
#'                     useAssay = "logcounts", scale = TRUE,
#'                     reducedDimName = "PCA")
runDimReduce <- function(inSCE,
                         method = c("scaterPCA",
                                    "seuratPCA",
                                    "seuratICA",
                                    "scanpyPCA",
                                    "rTSNE",
                                    "seuratTSNE",
                                    "scaterUMAP",
                                    "seuratUMAP",
                                    "scanpyUMAP",
                                    "scanpyTSNE"),
                         useAssay = NULL, useReducedDim = NULL,
                         useAltExp = NULL, reducedDimName = method,
                         nComponents = 20, useFeatureSubset = NULL,
                         scale = FALSE, seed = 12345, ...)
{

  method <- match.arg(method)
  args <- list(...)
  if (method %in% c("scaterPCA", "seuratPCA", "seuratICA") &
      !is.null(useReducedDim)) {
    stop("`useReducedDim` is not allowed for linear dimension reduction.")
  }

  if (method == "scaterPCA") {
    inSCE <- scaterPCA(inSCE = inSCE, useAssay = useAssay,
                       useAltExp = useAltExp, reducedDimName = reducedDimName,
                       nComponents = nComponents,
                       useFeatureSubset = useFeatureSubset, scale = scale,
                       seed = seed, ...)
  } else if (method == "scaterUMAP") {
    inSCE <- runUMAP(inSCE = inSCE, useAssay = useAssay, useAltExp = useAltExp,
                     useReducedDim = useReducedDim,
                     useFeatureSubset = useFeatureSubset, scale = scale,
                     reducedDimName = reducedDimName, seed = seed, ...)
  } else if (method == "scanpyPCA"){
    inSCE <- runScanpyPCA(inSCE = inSCE,
                          useAssay = useAssay, 
                          reducedDimName = reducedDimName, 
                          nPCs = nComponents, 
                          method = "auto", 
                          use_highly_variable = FALSE
                          )
  } else if (method == "scanpyTSNE"){
    inSCE <- runScanpyTSNE(inSCE = inSCE, useAssay = useAssay,
                           useReducedDim = useReducedDim, reducedDimName = reducedDimName, ...)
  } else if (method == "scanpyUMAP"){
    inSCE <- runScanpyUMAP(inSCE = inSCE, useAssay = useAssay, 
                           useReducedDim = useReducedDim, reducedDimName = reducedDimName, ...)
  } else if (method == "rTSNE") {
    inSCE <- runTSNE(inSCE = inSCE, useAssay = useAssay, useAltExp = useAltExp,
                     useReducedDim = useReducedDim,
                     useFeatureSubset = useFeatureSubset, scale = scale,
                     reducedDimName = reducedDimName, seed = seed, ...)
  } else {
    # Seurat part
    # TODO: Honestly, the input checks should have been implemented for
    # functions being wrapped because they are being exposed to users as well.
    # We should not being performing redundant checks when wrapping them again.
    useMat <- .selectSCEMatrix(inSCE, useAssay = useAssay,
                               useReducedDim = useReducedDim,
                               useAltExp = useAltExp, returnMatrix = FALSE)
    useAssay <- useMat$names$useAssay
    if (!is.null(useAltExp)) {
      tempSCE <- SingleCellExperiment::altExp(inSCE, useAltExp)
    } else if (!is.null(useAssay)) {
      tempSCE <- inSCE
    }
    if (method %in% c("seuratPCA", "seuratICA")) {
      ## SeuratPCA/ICA
      if (method == "seuratPCA") {
        p <- paste0(date(), " ... Computing Seurat PCA.")
        message(p)
        tempSCE <- runSeuratPCA(tempSCE, useAssay = useAssay,
                                reducedDimName = reducedDimName,
                                nPCs = nComponents,
                                useFeatureSubset = useFeatureSubset,
                                scale = scale, seed = seed, ...)
      } else if (method == "seuratICA") {
        p <- paste0(date(), " ... Computing Seurat ICA.")
        message(p)
        tempSCE <- runSeuratICA(tempSCE, useAssay = useAssay,
                                reducedDimName = reducedDimName,
                                nics = nComponents,
                                useFeatureSubset = useFeatureSubset,
                                scale = scale, seed = seed, ...)
      }
      seuratObj <- tempSCE@metadata$seurat
      if (!is.null(useAltExp)) {
        altExp(inSCE, useAltExp)@metadata$seurat <- seuratObj
      } else if (!is.null(useAssay)) {
        inSCE@metadata$seurat <- seuratObj
      }
    } else {
      ## SeuratUMAP/TSNE
      if (is.null(useReducedDim)) {
        ### using assay
        if (!"useReduction" %in% names(args)) {
          stop("Must specify `useReduction` when using `useAssay` in seuratUMAP/TSNE")
        }
        if (args$useReduction == "pca") {
          p <- paste0(date(), " ... Computing Seurat PCA.")
          message(p)
          tempSCE <- runSeuratPCA(inSCE = tempSCE,
                               useAssay = useAssay,
                               reducedDimName = paste0(useAssay, "_seuratPCA"),
                               useFeatureSubset = useFeatureSubset, seed = seed)
        } else if (args$useReduction == "ica") {
          p <- paste0(date(), " ... Computing Seurat ICA.")
          message(p)
          tempSCE <- runSeuratICA(inSCE = tempSCE,
                               useAssay = useAssay,
                               reducedDimName = paste0(useAssay, "_seuratICA"),
                               useFeatureSubset = useFeatureSubset, seed = seed)
        }
        if (method == "seuratUMAP") {
          p <- paste0(date(), " ... Computing Seurat UMAP.")
          message(p)
          tempSCE <- runSeuratUMAP(inSCE = tempSCE,
                                   reducedDimName = reducedDimName,
                                   seed = seed, ...)
        } else {
          p <- paste0(date(), " ... Computing Seurat tSNE.")
          message(p)
          tempSCE <- runSeuratTSNE(inSCE = tempSCE,
                                   reducedDimName = reducedDimName,
                                   seed = seed, ...)
        }
      } else {
        ### using external reducedDim
        if (!is.null(args$useReduction)) {
          stop("Cannot specify `useReduction` when using `useReducedDim` in seuratUMAP/TSNE")
        }
        tempSCE <- inSCE
        seuratObj <- convertSCEToSeurat(inSCE)
        tempSCE@metadata$seurat$obj <- seuratObj
        reDim <- SingleCellExperiment::reducedDim(inSCE, useReducedDim)
        colnames(reDim) <- paste0(useReducedDim, "_", seq_len(length(colnames(reDim))))
        rownames(reDim) <- gsub('_', '-', rownames(reDim))
        key <-  gsub('_', '', useReducedDim)
        # hard-code "pca"
        tempSCE@metadata$seurat$obj@reductions$pca <-
          Seurat::CreateDimReducObject(embeddings = reDim,
                                       key = paste0(key, "_"), assay = "RNA")
        if (method == "seuratUMAP") {
          # hard-code useReduction="pca"
          p <- paste0(date(), " ... Computing Seurat UMAP.")
          message(p)
          tempSCE <- runSeuratUMAP(inSCE = tempSCE, useReduction = "pca",
                                   reducedDimName = reducedDimName,
                                   seed = seed, ...)
        } else {
          # hard-code useReduction="pca"
          p <- paste0(date(), " ... Computing Seurat tSNE.")
          message(p)
          tempSCE <- runSeuratTSNE(inSCE = tempSCE, useReduction = "pca",
                                   reducedDimName = reducedDimName,
                                   seed = seed, ...)
        }
      }
    }
    SingleCellExperiment::reducedDim(inSCE, reducedDimName) <-
      SingleCellExperiment::reducedDim(tempSCE, reducedDimName)
  }
  return(inSCE)
}

#' Get or set top HVG after calculation
#' @description Extracts or select the top variable genes from an input
#' \linkS4class{SingleCellExperiment} object. Note that the variability metrics
#' must be computed using the \code{runFeatureSelection} method before
#' extracting the feature names of the top variable features. \code{getTopHVG}
#' only returns a character vector of the HVG selection, while with
#' \code{setTopHVG}, a logical vector of the selection will be saved in the
#' \code{rowData}, and optionally, a subset object for the HVGs can be stored
#' in the \code{altExps} slot at the same time.
#' @rdname getTopHVG
#' @param inSCE Input \linkS4class{SingleCellExperiment} object
#' @param method Specify which method to use for variable gene extraction
#' from Seurat \code{"vst"}, \code{"mean.var.plot"}, \code{"dispersion"} or
#' Scran \code{"modelGeneVar"} or Scanpy \code{"seurat"}, \code{"cell_ranger"}, 
#' \code{"seurat_v3"}. Default \code{"vst"}
#' @param hvgNumber Specify the number of top variable genes to extract.
#' @param useFeatureSubset Get the feature names in the HVG list set by
#' \code{setTopHVG}. \code{method} and \code{hvgNumber} will not be used if not
#' this is not \code{NULL}. Default \code{"hvf"}.
#' @param featureDisplay A character string for the \code{rowData} variable name
#' to indicate what type of feature ID should be displayed. If set by
#' \code{\link{setSCTKDisplayRow}}, will by default use it. If \code{NULL}, will
#' use \code{rownames(inSCE)}.
#' @param genes A customized character vector of gene list to be set as a
#' \code{rowData} variable. Will ignore \code{method} and \code{hvgNumber} if
#' set. Default \code{NULL}.
#' @param genesBy If setting customized \code{genes}, where should it be found
#' in \code{rowData}? Leave \code{NULL} for matching \code{rownames}. Default
#' \code{NULL}.
#' @param altExp \code{TRUE} for also creating a subset \code{inSCE} object with
#' the selected HVGs and store this subset in the \code{altExps} slot, named by
#' \code{hvgListName}. Default \code{FALSE}.
#' @param featureSubsetName A character string for the \code{rowData} variable
#' name to store a logical index of selected features. Default \code{"hvg2000"}.
#' @return
#' \item{getTopHVG}{A character vector of the top \code{hvgNumber} variable
#' feature names}
#' \item{setTopHVG}{The input \code{inSCE} object with the logical vector of
#' HVG selection updated in \code{rowData}, and related parameter updated in
#' \code{metadata}. If \code{altExp} is \code{TRUE}, an \code{altExp} is also
#' added}
#' @export
#' @author Irzam Sarfraz, Yichen Wang
#' @examples
#' data("scExample", package = "singleCellTK")
#' 
#' # Create a "highy variable feature" subset using Seurat's vst method:
#' sce <- runSeuratFindHVG(sce,  method = "vst", hvgNumber = 2000,
#'        createFeatureSubset = "hvf")
#'        
#' # Get the list of genes for a feature subset:
#' hvgs <- getTopHVG(sce, useFeatureSubset = "hvf")
#' 
#' # Create a new feature subset on the fly without rerunning the algorithm:
#' sce <- setTopHVG(sce, method = "vst", hvgNumber = 100,
#'                 featureSubsetName = "hvf100")
#' hvgs <- getTopHVG(sce, useFeatureSubset = "hvf100")
#' 
#' # Get a list of variable features without creating a new feature subset:
#' hvgs <- getTopHVG(sce, useFeatureSubset = NULL,
#'                   method = "vst", hvgNumber = 10)
#' 
#' @seealso \code{\link{runFeatureSelection}}, \code{\link{runSeuratFindHVG}},
#' \code{\link{runModelGeneVar}}, \code{\link{plotTopHVG}}
#' @importFrom SummarizedExperiment rowData
#' @importFrom S4Vectors metadata
getTopHVG <- function(inSCE,
                      method = c("vst", "dispersion",
                                 "mean.var.plot", "modelGeneVar", "seurat", 
                                 "seurat_v3", "cell_ranger"),
                      hvgNumber = 2000,
                      useFeatureSubset = "hvf",
                      featureDisplay = metadata(inSCE)$featureDisplay) {
    method <- match.arg(method)
    topGenes <- character()
    if (!is.null(useFeatureSubset)) {
        topGenes <- .parseUseFeatureSubset(inSCE, useFeatureSubset,
                                           altExpObj = NULL, returnType = "cha")
    } else {
        metrics <- .dfFromHVGMetric(inSCE, method)
        metrics <- metrics[order(-metrics$v_rank),]
        if (method == "seurat"){
          metrics <- metrics[metrics$v_plot > 0, ]
        }
        else{
          metrics <- metrics[metrics$v_rank > 0, ]
        }
        if (method == "mean.var.plot") {
            means.use <- (metrics$mean > 0.1) & (metrics$mean < 8)
            dispersions.use <- (metrics$v_plot > 1) & (metrics$v_plot < Inf)
            metrics <- metrics[means.use & dispersions.use,]
        }
        hvgNumber <- min(hvgNumber, nrow(metrics))
        topGenes <- as.character(metrics$featureNames)[seq_len(hvgNumber)]
    }
    topGenes <- stats::na.omit(topGenes)
    if (!is.null(featureDisplay)) {
        geneIdx <- featureIndex(topGenes, inSCE)
        topGenes <- rowData(inSCE)[[featureDisplay]][geneIdx]
    }
    
    topGenes <- topGenes[!is.na(topGenes)]
    topGenes <- topGenes[1:hvgNumber]

    return(topGenes)
}

#' @rdname getTopHVG
#' @export
#' @importFrom SingleCellExperiment rowSubset
#' @importFrom S4Vectors metadata<-
setTopHVG <- function(inSCE,
                      method = c("vst", "dispersion",
                                 "mean.var.plot", "modelGeneVar", "seurat", 
                                 "seurat_v3", "cell_ranger"),
                      hvgNumber = 2000,
                      featureSubsetName = "hvg2000",
                      genes = NULL, genesBy = NULL,
                      altExp = FALSE) {
    method <- match.arg(method, choices = c("vst", "dispersion", "mean.var.plot", "modelGeneVar", "seurat", "seurat_v3", "cell_ranger"))
    features <- character()
    useAssay <- NULL
    if (!is.null(genes)) {
        # Set customized gene list
        features <- genes
        if (!is.null(genesBy)) {
            geneIdx <- featureIndex(features = features, inSCE = inSCE,
                                    by = genesBy)
            features <- rownames(inSCE)[geneIdx]
        }
    } else {
        # Use pre-calculated variability metrics
        features <- getTopHVG(inSCE, method = method, hvgNumber = hvgNumber,useFeatureSubset = NULL,
                              featureDisplay = NULL)
        useAssay <- metadata(inSCE)$sctk$runFeatureSelection[[method]]$useAssay
    }
    nFeature <- length(features)
    if (is.null(featureSubsetName)) {
        if (!is.null(genes)) {
            featureSubsetName <- "CustomizedHVG"
        } else {
            featureSubsetName <- paste0("HVG_", method, hvgNumber)
        }
    }
    rowSubset(inSCE, featureSubsetName) <- features
    p <- paste0(date(), " ... Feature subset variable '", featureSubsetName,
                "' created.")
    message(p)
    metadata(inSCE)$sctk$featureSubsets[[featureSubsetName]] <-
        list(method = method,
             number = nFeature,
             useAssay = useAssay)
    if (isTRUE(altExp)) {
        inSCE <- subsetSCERows(inSCE,
                               rowData = featureSubsetName,
                               returnAsAltExp = TRUE,
                               altExpName = featureSubsetName)
    }
    return(inSCE)
}

#' Check if specified method has already been performed, and extract the metric.
#' Will be used by `getTopHVG` to rank the top, and `plotTopHVG` for the axis
#' @param inSCE Input \linkS4class{SingleCellExperiment} object
#' @param method Specify which method to use for variable gene extraction
#' from Seurat \code{"vst"}, \code{"mean.var.plot"}, \code{"dispersion"} or
#' Scran \code{"modelGeneVar"} or Scanpy \code{"seurat"}, \code{"cell_ranger"}, 
#' \code{"seurat_v3"}. Default \code{"vst"}
#' @return data.frame object of HVG metrics calculated by \code{method},
#' containing columns of \code{"mean"}, \code{"v_rank"}, \code{"v_plot"}
#' @noRd
.dfFromHVGMetric <- function(inSCE,
                             method = c("vst", "mean.var.plot", "dispersion",
                                        "modelGeneVar", "seurat", 
                                        "seurat_v3", "cell_ranger")) {
    method <- match.arg(method)
    df <- data.frame(featureNames = rownames(inSCE))
    if (method == "vst") {
        m <- "seurat_variableFeatures_vst_mean"
        v_rank <- "seurat_variableFeatures_vst_varianceStandardized"
        v_plot <- "seurat_variableFeatures_vst_varianceStandardized"
        if (is.null(rowData(inSCE)[[v_rank]]) || is.null(rowData(inSCE)[[m]])) {
            stop("Seurat vst metric not found in inSCE. ",
                 "Run `runSeuratFindHVG()` with 'vst' method before ",
                 "using this function!")
        }
    } else if (method == "dispersion") {
        m <- "seurat_variableFeatures_dispersion_mean"
        v_rank <- "seurat_variableFeatures_dispersion_dispersion"
        v_plot <- "seurat_variableFeatures_dispersion_dispersionScaled"
        if (is.null(rowData(inSCE)[[v_rank]]) ||
            is.null(rowData(inSCE)[[m]]) ||
            is.null(rowData(inSCE)[[v_plot]])) {
            stop("Seurat dispersion metric not found in inSCE. ",
                 "Run `runSeuratFindHVG()` with 'dispersion' method ",
                 "before using this function!")
        }
    }else if (method == "seurat_v3") {
      m <- "means"
      v_rank <- "variances"
      v_plot <- "variances_norm"
      if (is.null(rowData(inSCE)[[v_rank]]) ||
          is.null(rowData(inSCE)[[m]]) ||
          is.null(rowData(inSCE)[[v_plot]])) {
        stop("Scanpy variance metric not found in inSCE. ",
             "Run `runScanpyFindHVG()` with 'seurat_v3' method ",
             "before using this function!")
      }
    }else if (method == "cell_ranger") {
      m <- "means"
      v_rank <- "dispersions"
      v_plot <- "dispersions_norm"
      if (is.null(rowData(inSCE)[[v_rank]]) ||
          is.null(rowData(inSCE)[[m]]) ||
          is.null(rowData(inSCE)[[v_plot]])) {
        stop("Scanpy dispersion metric not found in inSCE. ",
             "Run `runScanpyFindHVG()` with 'cell_ranger' method ",
             "before using this function!")
      }
    }else if (method == "seurat") {
      m <- "means"
      v_rank <- "dispersions"
      v_plot <- "dispersions_norm"
      if (is.null(rowData(inSCE)[[v_rank]]) ||
          is.null(rowData(inSCE)[[m]]) ||
          is.null(rowData(inSCE)[[v_plot]])) {
        stop("Scanpy dispersion metric not found in inSCE. ",
             "Run `runScanpyFindHVG()` with 'dispersion' method ",
             "before using this function!")
      }
    } else if (method == "modelGeneVar") {
        m <- "scran_modelGeneVar_mean"
        v_rank <- "scran_modelGeneVar_bio"
        v_plot <- "scran_modelGeneVar_totalVariance"
        if (is.null(rowData(inSCE)[[v_rank]]) ||
            is.null(rowData(inSCE)[[m]]) ||
            is.null(rowData(inSCE)[[v_plot]])) {
            stop("Scran modelGeneVar metric not found in inSCE. Run ",
                 "`runModelGeneVar()` before using this function!")
        }
    } else if (method == "mean.var.plot") {
        m <- "seurat_variableFeatures_mvp_mean"
        v_rank <- "seurat_variableFeatures_mvp_dispersion"
        v_plot <- "seurat_variableFeatures_mvp_dispersionScaled"
        if (is.null(rowData(inSCE)[[v_rank]]) ||
            is.null(rowData(inSCE)[[m]]) ||
            is.null(rowData(inSCE)[[v_plot]])) {
            stop("Seurat mean.var.plot metric not found in inSCE. ",
                 "Run `runSeuratFindHVG()` with ",
                 "'mean.var.plot' method before using this function!")
        }
    }
    df$mean <- rowData(inSCE)[[m]]
    df$v_rank <- rowData(inSCE)[[v_rank]]
    df$v_plot <- rowData(inSCE)[[v_plot]]
    return(df)
}

#' parse `useFeatureSubset` in other functions such as `scaterPCA`, `runUMAP`..
#' Do checks, and return logical vector. Or character vector as needed by Seurat
#' methods
#' @param inSCE Input \linkS4class{SingleCellExperiment} object
#' @param useFeatureSubset Subset of feature to use. A character string
#' indicating a \code{rowData} variable that stores the logical vector of HVG
#' selection, or a vector that can subset the rows of \code{inSCE}.
#' @param altExpObj A \linkS4class{SingleCellExperiment} object, extracted from
#' \code{altExps} of \code{inSCE}, can be \code{identical()} to \code{inSCE}.
#' Used when functions like \code{\link{scaterPCA}} allows \code{useAltExp}, so
#' that the output vector match to the rownames of \code{altExpObj}
#' @param returnType What type of vector should be returned
#' @return \code{NULL} if \code{is.null(useFeatureSubset)}. Otherwise, a vector
#' subsetting the features.
#' @noRd
.parseUseFeatureSubset <- function(inSCE, useFeatureSubset, altExpObj = NULL,
                                  returnType = c("logical", "character")) {
    returnType <- match.arg(returnType)
    if (!is.null(altExpObj)) {
        if (!inherits(altExpObj, "SingleCellExperiment")) {
            stop()
        }
    }
    if (identical(altExpObj, inSCE)) altExpObj <- NULL
    features <- NULL
    if (!is.null(useFeatureSubset)) {
        if (is.character(useFeatureSubset) & length(useFeatureSubset) == 1) {
            # Assume using rowData variable
            if (!useFeatureSubset %in% names(rowData(inSCE))) {
                stop("Specified feature subset not found.")
            }
            feature.logical <- rowData(inSCE)[[useFeatureSubset]]
            if (!is.logical(feature.logical)) {
                stop("Specified rowData variable is not logical.")
            }
            features <- rownames(inSCE)[feature.logical]
            if (useFeatureSubset %in% names(metadata(inSCE)$sctk$featureSubsets)) {
                # If the subset is created with SCTK HVG methods
                # Return a ranked gene list
                method <- metadata(inSCE)$sctk$featureSubsets[[useFeatureSubset]]$method
                useAssay <- metadata(inSCE)$sctk$featureSubsets[[useFeatureSubset]]$useAssay
                metricAssay <- metadata(inSCE)$sctk$runFeatureSelection[[method]]$useAssay
                if (useAssay != metricAssay) {
                    warning("Sorting features subset using metrics ",
                            "calculated from an assay different than the ",
                            "assay used for the subset creation")
                }
                metrics <- .dfFromHVGMetric(inSCE, method)
                metrics <- metrics[order(-metrics$v_rank),]
                features <- metrics$featureNames[metrics$featureNames %in% features]
            }
        } else if (is.character(useFeatureSubset) &
                   length(useFeatureSubset) > 1) {
            # Assume using rownames
            if (any(!useFeatureSubset %in% rownames(inSCE))) {
                nf <- useFeatureSubset[!useFeatureSubset %in% rownames(inSCE)]
                stop("Specified features not found: ",
                     paste(nf, collapse = ", "))
            }
            features <- useFeatureSubset
        } else if (is.logical(useFeatureSubset)) {
            if (length(useFeatureSubset) != nrow(inSCE)) {
                stop("Length of logical subset doesn't match nrow(inSCE).")
            }
            features <- rownames(inSCE)[useFeatureSubset]
        } else if (is.numeric(useFeatureSubset)) {
            features <- rownames(inSCE)[useFeatureSubset]
            if (any(is.na(features))) {
                stop("Numeric subscript contains out-of-bounds indices.")
            }
        } else {
            stop("Invalid useFeatureSubset specification.")
        }
        if (!is.null(altExpObj)) {
            features <- features[features %in% rownames(altExpObj)]
        }
        if (returnType == "logical") {
            if (!is.null(altExpObj)) {
                features <- rownames(altExpObj) %in% features
            } else {
                features <- rownames(inSCE) %in% features
            }
        }

    }
    return(features)
}

# scran_modelGeneVar.R
library(singleCellTK)
context("Testing scran_modelGeneVar.R")
data(scExample, package = "singleCellTK")
sce <- runSeuratNormalizeData(sce)

test_that(desc = "Testing FindHVG", {
    # Running each method
    sce <- runModelGeneVar(sce, "seuratNormData")
    metricNames.mgv <- metadata(sce)$sctk$runFeatureSelection$modelGeneVar$rowData
    testthat::expect_true(all(metricNames.mgv %in% names(rowData(sce))))

    sce <- runFeatureSelection(sce, "counts", "vst")
    metricNames.vst <- metadata(sce)$sctk$runFeatureSelection$vst$rowData
    testthat::expect_true(all(metricNames.vst %in% names(rowData(sce))))

    sce <- runFeatureSelection(sce, "seuratNormData", "dispersion")
    metricNames.disp <- metadata(sce)$sctk$runFeatureSelection$dispersion$rowData
    testthat::expect_true(all(metricNames.disp %in% names(rowData(sce))))

    sce <- runFeatureSelection(sce, "seuratNormData", "mean.var.plot")
    metricNames.mvp <- metadata(sce)$sctk$runFeatureSelection$mean.var.plot$rowData
    testthat::expect_true(all(metricNames.mvp %in% names(rowData(sce))))

    # Test accessor functions
    sce <- setTopHVG(sce, "modelGeneVar", hvgNumber = 50, altExp = TRUE, featureSubsetName = NULL)
    #sce <- setTopHVG(sce, "modelGeneVar", hvgNumber = 2000, altExp = TRUE, featureSubsetName = NULL)
    nHVG <- length(getTopHVG(sce, hvgNumber = 50, useFeatureSubset = "HVG_modelGeneVar50"))
    
    testthat::expect_true(is.logical(rowData(sce)$HVG_modelGeneVar50))
    testthat::expect_equal(nrow(altExp(sce, "HVG_modelGeneVar50")), nHVG)
    testthat::expect_equal(metadata(sce)$sctk$featureSubsets$HVG_modelGeneVar50$useAssay,
                           "seuratNormData")

    hvgs <- getTopHVG(sce, "mean.var.plot", hvgNumber = 2000,
                      featureDisplay = "feature_name", useFeatureSubset = NULL)
    testthat::expect_false(all(startsWith(hvgs, "ENSG00000")))
    hvgs <- getTopHVG(sce, "vst", hvgNumber = 2000, useFeatureSubset = NULL)
    vm1 <- plotTopHVG(sce, "dispersion", hvgNumber = NULL)
    vm2 <- plotTopHVG(sce, "modelGeneVar", hvgNumber = 30, labelsCount = 10,
                     featureDisplay = "feature_name")
    vm3 <- plotTopHVG(sce, method = "mean.var.plot",
                      useFeatureSubset = "HVG_modelGeneVar50", hvgNumber = NULL)
    testthat::expect_true(inherits(vm1, "ggplot"))
    testthat::expect_true(inherits(vm2, "ggplot"))
    testthat::expect_true(inherits(vm3, "ggplot"))
})

.constructSCE <- function(
    matrices,
    features,
    barcodes,
    metadata,
    reducedDims) {
  
  sce <- SingleCellExperiment::SingleCellExperiment(assays = matrices)
  SummarizedExperiment::rowData(sce) <- S4Vectors::DataFrame(features)
  SummarizedExperiment::colData(sce) <- S4Vectors::DataFrame(barcodes)
  S4Vectors::metadata(sce) <- metadata
  SingleCellExperiment::reducedDims(sce) <- reducedDims
  return(sce)
}

.getDimUnion <- function(dataList){
  Row <- lapply(dataList, function(x) {rownames(x)})
  RowUnion <- base::Reduce(union, Row)
  Col <- lapply(dataList, function(x) {colnames(x)})
  ColUnion <- base::Reduce(union, Col)
  return(list(RowUnion, ColUnion))
}

.getMatUnion <- function(dimsList, x,
                         combineRow, combineCol,
                         sparse = FALSE,
                         fill = c("NA", "0")){
  row <- dimsList[[1]]
  col <- dimsList[[2]]
  matOrigin <- x
  fill <- match.arg(fill)
  if (fill == "0") {
    fill <- 0
  } else {
    fill <- NA
  }
  
  ### combine row
  if (isTRUE(combineRow) & (!is.null(row))) {
    missRow <- row[!row %in% rownames(x)]
    missMat <- Matrix::Matrix(fill, nrow = length(missRow), ncol = ncol(matOrigin),
                              dimnames = list(missRow, colnames(matOrigin)))
    if (!isTRUE(sparse)) {
      missMat <- as.matrix(missMat)
    }
    
    mat <- rbind(matOrigin, missMat)
    if (anyDuplicated(rownames(mat))) {
      mat <- mat[!duplicated(rownames(mat)), ]
    }
    matOrigin <- mat[row, ]
  }
  
  ### combine cols
  if (isTRUE(combineCol) & (!is.null(col))) {
    missCol <- col[!col %in% colnames(x)]
    missMat <- Matrix::Matrix(fill, nrow = nrow(matOrigin), ncol = length(missCol),
                              dimnames = list(rownames(matOrigin), missCol))
    if (!isTRUE(sparse)) {
      missMat <- as.matrix(missMat)
    }
    
    mat <- cbind(matOrigin, missMat)
    if (anyDuplicated(colnames(mat))) {
      mat <- mat[, !duplicated(colnames(mat))]
    }
    matOrigin <- mat[, col]
  }
  return(matOrigin)
}


.mergeRowDataSCE <- function(sce.list, by.r) {
    feList <- lapply(sce.list, function(x){
        rw <- SummarizedExperiment::rowData(x)
        rw[['rownames']] <- rownames(rw)
        return(rw)
    })
    
    ## Get merged rowData
    if (is.null(by.r)) {
        by.r <- unique(c('rownames', by.r))
        unionFe <- Reduce(function(r1, r2) merge(r1, r2, by=unique(c(by.r, intersect(names(r1), names(r2)))), all=TRUE), feList)
    }
    else {
      by.r <- unique(c('rownames', by.r))
      unionFe <- Reduce(function(r1, r2) merge(r1, r2, by=by.r, all=TRUE), feList)
    }
    allGenes <- unique(unlist(lapply(feList, rownames)))
    
    ## rowData
    newFe <- unionFe
    if (nrow(newFe) != length(allGenes)) {
        warning("Conflicts were found when merging two rowData. ",
                "Resolved the conflicts by choosing the first entries.",
                "To avoid conflicts, please provide the 'by.r' arguments to ",
                "specify columns in rowData that does not have conflict between two singleCellExperiment object. ")
        newFe <- newFe[!duplicated(newFe$rownames), ]
    }
    rownames(newFe) <- newFe[['rownames']]
    newFe <- newFe[allGenes,]
    return(newFe)
}

.mergeColDataSCE <- function(sceList, by.c) {
  cbList <- lapply(sceList, function(x) {
    cD <- SummarizedExperiment::colData(x)
    cD[['rownames']] <- rownames(cD)
    return(cD)
  })
  
  # Merge columns
  if (is.null(by.c)) {
    by.c <- unique(c("rownames", by.c))
    unionCb <- Reduce(function(c1, c2) merge(c1, c2, by=unique(c(by.c, intersect(names(c1), names(c2)))), all=TRUE), cbList)
  }
  else {
    by.c <- unique(c("rownames", by.c))
    unionCb <- Reduce(function(c1, c2) merge(c1, c2, by=by.c, all=TRUE), cbList)
  }
  rownames(unionCb) <- unionCb[['rownames']]
  newCbList <- list()
  for (i in seq_along(sceList)) {
    newCbList[[i]] <- unionCb[colnames(sceList[[i]]), , drop=FALSE]
  }
  return(newCbList)
}

.mergeRedimSCE <- function(sceList, reduceList) {
  ## get reducedDims for each SCE SummarizedExperiment::
  reduceList <- lapply(sceList, SingleCellExperiment::reducedDims)
  ## get every reducedDim exists in at least one SCEs
  UnionReducedDims <- unique(unlist(lapply(sceList, SingleCellExperiment::reducedDimNames)))
  
  ## for each reducedDim, get union row/cols
  reducedDims <- list()
  for (reduceDim in UnionReducedDims) {
    x <- lapply(sceList, function(x) {if (reduceDim %in% SingleCellExperiment::reducedDimNames(x)) {SingleCellExperiment::reducedDim(x, reduceDim)}})
    reducedDims[[reduceDim]] <- .getDimUnion(x)
  }
  
  ## Merge reducedDim for each SCE
  redList <- list()
  for (idx in seq_along(sceList)){
    redMat <- reduceList[[idx]]
    
    for (DimName in UnionReducedDims) {
      if (DimName %in% names(redMat)) {
        redMat[[DimName]] <- .getMatUnion(reducedDims[[DimName]], redMat[[DimName]],
                                          combineRow = FALSE, combineCol = TRUE,
                                          sparse = FALSE, fill = "NA")
      } else {
        redMat[[DimName]] <- base::matrix(NA, nrow = ncol(sceList[[idx]]),
                                          ncol = length(reducedDims[[DimName]][[2]]),
                                          dimnames = list(colnames(sceList[[idx]]), reducedDims[[DimName]][[2]]))
      }
    }
    
    redList[[idx]] <- redMat
  }
  
  return(redList)
}

.mergeAssaySCE <- function(sceList) {
  UnionAssays <- Reduce(function(d1, d2) base::union(d1, d2),
                        lapply(sceList, SummarizedExperiment::assayNames))
  assayList <- lapply(sceList, assays)
  assayDims <- list(
    unique(unlist(lapply(sceList, rownames))),
    unique(unlist(lapply(sceList, colnames)))
  )
  
  asList <- list()
  for (idx in seq_along(assayList)){
    assay <- assayList[[idx]]
    for (assayName in UnionAssays) {
      if (assayName %in% names(assay)) {
        assay[[assayName]] <- .getMatUnion(assayDims, assay[[assayName]],
                                           combineRow = TRUE, combineCol = FALSE,
                                           sparse = TRUE, fill = "0")
      } else{
        assay[[assayName]] <- Matrix::Matrix(0, nrow = length(assayDims[[1]]),
                                             ncol = ncol(sceList[[idx]]),
                                             dimnames = list(assayDims[[1]], colnames(sceList[[idx]]))) #assayDims[[assayName]])
      }
    }
    asList[[idx]] <- assay
  }
  
  return(asList)
}

# .mergeMetaSCE <- function(sceList) {
#   metaList <- lapply(sceList, S4Vectors::metadata)
#   metaNames <- unlist(lapply(metaList, names))

#   if ("runBarcodeRanksMetaOutput" %in% metaNames) {
#     barcodeMetas <- lapply(metaList, function(x) {x[["runBarcodeRanksMetaOutput"]]})
#     barcodeMetas <- do.call(rbind, barcodeMetas)

#     for (i in seq_along(metaList)) {
#       metaList[[i]][["runBarcodeRanksMetaOutput"]] <- NULL
#     }

#     metaList[["runBarcodeRanksMetaOutput"]] <- barcodeMetas
#   }

#   return(metaList)
# }

.mergeMetaSCE <- function(SCE_list) {
  # Merge highest level metadata entries (except "sctk") by sample names in
  # SCE_list. For analysis results in "sctk", merge by SCE_list sample name if 
  # given "all_cells" in one object, else, use existing sample names. 
  samples <- names(SCE_list)
  sampleMeta <- lapply(SCE_list, S4Vectors::metadata)
  metaNames <- unique(unlist(lapply(sampleMeta, names)))
  sampleSctkMeta <- lapply(SCE_list, function(x) {S4Vectors::metadata(x)$sctk})
  sctkMetaNames <- unique(unlist(lapply(sampleMeta, 
                                        function(x) names(x$sctk))))
  sampleMeta$sctk <- NULL
  metaNames <- metaNames[!metaNames %in% c("sctk")]
  NewMeta <- list()
  for (meta in sctkMetaNames) {
    for (i in seq_along(sampleSctkMeta)) {
      # `i` is for identifying each SCE object, usually matching a sample in 
      # the pipeline. `sampleAvail` for samples stored in metadata entry, in
      # case users are merging merged objects. 
      sampleAvail <- names(sampleSctkMeta[[i]][[meta]])
      if (length(sampleAvail) == 1) {
        NewMeta$sctk[[meta]][[samples[i]]] <- sampleSctkMeta[[i]][[meta]][[1]]
      } else if (length(sampleAvail) > 1) {
        names(sampleSctkMeta[[i]][[meta]]) <- 
          paste(names(sampleSctkMeta)[i], 
                names(sampleSctkMeta[[i]][[meta]]), sep = "_")
        NewMeta$sctk[[meta]] <- c(NewMeta$sctk[[meta]], 
                                  sampleSctkMeta[[i]][[meta]])
      }
    }
  }
  for (meta in metaNames) {
    for (i in seq_along(sampleMeta)) {
      NewMeta[[meta]][[samples[i]]] <- sampleMeta[[i]][[meta]]
    }
  }
  
  if ("assayType" %in% metaNames) {
    assayType <- lapply(SCE_list, function(x){S4Vectors::metadata(x)$assayType})
    assayType <- BiocGenerics::Reduce(dplyr::union, assayType)
    
    NewMeta[["assayType"]] <- assayType
  }
  
  return(NewMeta)
}

#' Combine a list of SingleCellExperiment objects as one SingleCellExperiment object
#' @param sceList A list contains \link[SingleCellExperiment]{SingleCellExperiment} objects.
#' Currently, combineSCE function only support combining SCE objects with assay in dgCMatrix format.
#' It does not support combining SCE with assay in delayedArray format.
#' @param by.r Specifications of the columns used for merging rowData. If set as NULL, 
#' the rownames of rowData tables will be used to merging rowData. Default is NULL. 
#' @param by.c Specifications of the columns used for merging colData. If set as NULL, 
#' the rownames of colData tables will be used to merging colData. Default is NULL.
#' @param combined logical; if TRUE, it will combine the list of SingleCellExperiment objects 
#' and return a SingleCellExperiment. If FALSE, it will return a list of SingleCellExperiment whose
#' rowData, colData, assay and reducedDim data slot are compatible within SCE objects in the list. 
#' Default is TRUE.
#' @return A \link[SingleCellExperiment]{SingleCellExperiment} object which combines all
#' objects in sceList. The colData is merged.
#' @examples
#' data(scExample, package = "singleCellTK")
#' combinedsce <- combineSCE(list(sce,sce), by.r = NULL, by.c = NULL, combined = TRUE)
#' @export

combineSCE <- function(sceList, by.r = NULL, by.c = NULL, combined = TRUE){
  if (length(sceList) == 1) {
    return(sceList[[1]])
  }
  if (typeof(sceList) != "list") {
    stop("Error in combineSCE: input must be a list of SCE objects")
  }
  ##  rowData
  newFeList <- .mergeRowDataSCE(sceList, by.r)
  ## colData
  newCbList <- .mergeColDataSCE(sceList, by.c)
  ## reducedDim
  redMatList <- .mergeRedimSCE(sceList)
  ## assay
  assayList <- .mergeAssaySCE(sceList)
  samples <- names(sceList)
  if (is.null(samples)) {
    samples <- paste0("sample", seq_along(sceList))
  }
  New_SCE <- list()
  for (i in seq(length(sceList))) {
    ## create new sce
    sampleName <- samples[i]
    New_SCE[[sampleName]] <- .constructSCE(matrices = assayList[[i]], 
                                           features = newFeList,
                                           barcodes = newCbList[[i]],
                                           metadata = S4Vectors::metadata(sceList[[i]]),
                                           reducedDims = redMatList[[i]])
  }
  
  if (isTRUE(combined)) {
    sce <- do.call(SingleCellExperiment::cbind, New_SCE)
    meta <- .mergeMetaSCE(New_SCE)
    S4Vectors::metadata(sce) <- meta
    return(sce)
  }
  return(New_SCE)
}

shinyPanelGeneSets <- fluidPage(
  tags$div(
    class = "container",
    style = "margin-bottom: 10px",
    h1("Import Gene Sets"),
    h5(tags$a(href = paste0(docs.artPath, "import_genesets.html"),
              "(help)", target = "_blank")),
    tags$hr(),
    tags$style(HTML("
      div {
        word-wrap: break-word;
      }
      ")
    ),
    wellPanel(
      h4("Existing Gene Sets:"),
      fluidRow(
        column(3, tags$b("Collection Name")),
        column(9, tags$b("Source")),
      ),
      tags$div(id = "newGSImport"),
      tags$br(),
      tags$br(),
    ),
    radioButtons("geneSetSourceChoice", label = NULL, c("Upload a GMT file" = 'gsGMTUpload',
                                                 "Select from a database" = "gsDBUpload",
                                                 "Import mitochondrial gene set" = "gsMito",
                                                 "Paste in your gene set" = "gsPasteUpload"
                                                 )
    ),
    conditionalPanel(
      condition = sprintf("input['%s'] == 'gsGMTUpload'", "geneSetSourceChoice"),
      h3("Upload a GMT file:"),
      fileInput('geneSetGMT', 'Choose GMT File', accept = ".gmt"),
      textInput('gsCollectionNameGMT', label='Collection Name'),
    ),

    conditionalPanel(
      condition = sprintf("input['%s'] == 'gsDBUpload'", "geneSetSourceChoice"),
      h3("Select from a database:"),
      tags$style(HTML("#geneSetDB {width:100%}")),
      checkboxGroupInput('geneSetDB', 'Check the gene sets you want to import',
                         choices = c()),
    ),

    conditionalPanel(
      condition = sprintf("input['%s'] == 'gsMito'", "geneSetSourceChoice"),
      h3("Import mitochondrial gene set"),
      radioButtons("geneSetMitoSpecies", "Species",
                   choices = c("human", "mouse"), selected = "human",
                   inline = TRUE),
      selectInput("geneSetMitoID", "ID Type",
                  choices = c("symbol", "entrez", "ensembl", "ensemblTranscriptID"),
                  selected = "symbol"),
      textInput("geneSetMitoName", "Collection Name", "Mito",
                placeholder = "Required"),
    ),


    conditionalPanel(
      condition = sprintf("input['%s'] == 'gsPasteUpload'", "geneSetSourceChoice"),
      h3("Paste in your gene set:"),
      textInput('gsCollectionNameText', label='Create a new collection (enter collection name)'),
      shinyjs::hidden(
        tags$div(id = "gsAddToExisting",
                 h4("-OR-"),
                 selectInput("gsExisting", "Add to an existing collection", c("None")),
        )
      ),
      textAreaInput('geneSetText', 'Please enter values separated by new lines', width = "300px")
    ),

    selectInput("gsByParam", "Location within SCE object where the gene identifiers in should be mapped.", list()),

    actionButton("uploadGS", "Upload"),
    
    shinyjs::hidden(
      tags$div(id = "gsUploadError",
               tags$b("Please fill out all the required fields", style = "color: red;"),
      )
    ),
  )
)

#' Run Variable Feature Detection Methods
#' @description Wrapper function to run all of the feature selection methods 
#' integrated within the singleCellTK package including three methods from
#' Seurat (\code{"vst"}, \code{"mean.var.plot"} or \code{dispersion}) and the 
#' Scran \code{modelGeneVar} method.
#' 
#' This function does not return the names of the variable features but only 
#' computes the metrics, which will be stored in the \code{rowData} slot. To set
#' a HVG list for downstream use, users should call \code{\link{setTopHVG}} 
#' after computing the metrics. To get the names of the variable features, users
#' should call \code{\link{getTopHVG}} function after computing the metrics.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object.
#' @param useAssay Specify the name of the assay that should be used. Should use
#' raw counts for \code{"vst"} method, or a normalized assay for other methods.
#' @param method Specify the method to use for variable gene selection.
#' Options include \code{"vst"}, \code{"mean.var.plot"} or \code{"dispersion"}
#' from Seurat and \code{"modelGeneVar"} from Scran. Default \code{"vst"}
#' @return The input \linkS4class{SingleCellExperiment} object that contains 
#' the computed statistics in the \code{rowData} slot
#' @seealso \code{\link{runModelGeneVar}}, \code{\link{runSeuratFindHVG}},
#' \code{\link{getTopHVG}}, \code{\link{plotTopHVG}}
#' @export
#' @examples
#' data("mouseBrainSubsetSCE", package = "singleCellTK")
#' mouseBrainSubsetSCE <- runFeatureSelection(mouseBrainSubsetSCE,
#'                                            "logcounts",
#'                                            "modelGeneVar")
runFeatureSelection <- function(inSCE,
                                useAssay,
                                method = "vst")
  {
  method <- match.arg(method, choices = c("vst", "mean.var.plot", "dispersion", "modelGeneVar", "cell_ranger"))
  seuratMethods <- c("vst", "mean.var.plot", "dispersion")
  scranMethods <- c("modelGeneVar")
  scanpyMethods <- c("cell_ranger")

  params <- list(
    inSCE = inSCE,
    useAssay = useAssay
  )

  if(method %in% seuratMethods){
    params$method <- method
    inSCE <- do.call("runSeuratFindHVG", args = params)
  }
  else if(method %in% scranMethods){
    inSCE <- do.call("runModelGeneVar", args = params)
  }
  else if(method %in% scanpyMethods){
    params$method <- method
    inSCE <- do.call("runScanpyFindHVG", args = params)
  }

  return(inSCE)
}

#' Perform scater PCA on a SingleCellExperiment Object
#' @description A wrapper to \link[scater]{runPCA} function to compute principal
#' component analysis (PCA) from a given \linkS4class{SingleCellExperiment}
#' object.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object.
#' @param useAssay Assay to use for PCA computation. If \code{useAltExp} is
#' specified, \code{useAssay} has to exist in
#' \code{assays(altExp(inSCE, useAltExp))}. Default \code{"logcounts"}
#' @param useFeatureSubset Subset of feature to use for dimension reduction. A
#' character string indicating a \code{rowData} variable that stores the logical
#' vector of HVG selection, or a vector that can subset the rows of
#' \code{inSCE}. Default \code{"hvg2000"}.
#' @param scale Logical scalar, whether to standardize the expression values.
#' Default \code{TRUE}.
#' @param reducedDimName Name to use for the reduced output assay. Default
#' \code{"PCA"}.
#' @param nComponents Number of principal components to obtain from the PCA
#' computation. Default \code{50}.
#' @param ntop Automatically detect this number of variable features to use for
#' dimension reduction. Ignored when using \code{useReducedDim} or using
#' \code{useFeatureSubset}. Default \code{2000}.
#' @param useAltExp The subset to use for PCA computation, usually for the
#' selected.variable features. Default \code{NULL}.
#' @param seed Integer, random seed for reproducibility of PCA results.
#' Default \code{NULL}.
#' @param BPPARAM A \linkS4class{BiocParallelParam} object specifying whether
#' the PCA should be parallelized.
#' @return A \linkS4class{SingleCellExperiment} object with PCA computation
#' updated in \code{reducedDim(inSCE, reducedDimName)}.
#' @export
#' @examples
#' data(scExample, package = "singleCellTK")
#' sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
#' sce <- scaterlogNormCounts(sce, "logcounts")
#' 
#' # Example of ranking variable genes, selecting the top variable features,
#' # and running PCA. Make sure to increase the number of highly variable
#' # features (hvgNumber) and the number of principal components (nComponents)
#' # for real datasets
#' sce <- runModelGeneVar(sce, useAssay = "logcounts")
#' sce <- setTopHVG(sce, method = "modelGeneVar", hvgNumber = 100,
#'                  featureSubsetName = "hvf")
#' sce <- scaterPCA(sce, useAssay = "logcounts", scale = TRUE,
#'                  useFeatureSubset = "hvf", nComponents = 5)
#'                  
#' # Alternatively, let the scater PCA function select the top variable genes
#' sce <- scaterPCA(sce, useAssay = "logcounts", scale = TRUE,
#'                  useFeatureSubset = NULL, ntop = 100, nComponents = 5)
#' @importFrom SingleCellExperiment reducedDim altExp rowSubset
#' @importFrom SummarizedExperiment rowData
#' @importFrom S4Vectors metadata<-
scaterPCA <- function(inSCE, useAssay = "logcounts", useFeatureSubset = "hvg2000",
                      scale = TRUE, reducedDimName = "PCA", nComponents = 50,
                      ntop = 2000, useAltExp = NULL, seed = 12345,
                      BPPARAM = BiocParallel::SerialParam()) {
  params <- as.list(environment())
  params$inSCE <- NULL
  params$BPPARAM <- NULL
  # Note: useMat = list(names = list(useAssay = useAssay, ...),
  #                     mat = <matrix>)
  # `.selectSCEMatrix()` does the check
  useMat <- .selectSCEMatrix(inSCE, useAssay = useAssay,
                             useReducedDim = NULL, useAltExp = useAltExp,
                             returnMatrix = TRUE)
  if (!is.null(useAltExp)) {
    sce <- altExp(inSCE, useAltExp)
  } else {
    sce <- inSCE
  }
  subset_row <- .parseUseFeatureSubset(inSCE, useFeatureSubset,
                                       altExpObj = sce, returnType = "logical")
  p <- paste0(date(), " ... Computing Scater PCA.")
  message(p)
  withr::with_seed(seed, {
    pca <- scater::calculatePCA(useMat$mat, ncomponents = nComponents,
                                scale = scale, ntop = ntop,
                                subset_row = subset_row, BPPARAM = BPPARAM)
  })
  reducedDim(inSCE, reducedDimName) <- pca
  metadata(inSCE)$sctk$runDimReduce$reddim[[reducedDimName]] <- params
  return(inSCE)
}

doubletCellsHelpModal <- function() {
  modalDialog(
    tags$style(HTML("
      div {
        word-wrap: break-word;
      }
      ")),
    tags$div(
      h3("Doublet Cells Parameters"),
      fluidRow(
        column(4, tags$b("Parameter Name")),
        column(8, tags$b("Description"))
      ),
      tags$hr(),
      fluidRow(
        column(4, "nNeighbors"),
        column(8, "Number of nearest neighbors used to calculate density for doublet detection. Default 50.")
      ),
      tags$hr(),
      fluidRow(
        column(4, "simDoublets"),
        column(8, 'Number of simulated doublets created for doublet detection. Default 10000.')
      ),
    )
  )
}

QCMHelpModal <- function() {
  modalDialog(
    tags$style(HTML("
      div {
        word-wrap: break-word;
      }
      ")),
    tags$div(
      h3("QC Metrics Parameters"),
      fluidRow(
        column(4, tags$b("Parameter Name")),
        column(8, tags$b("Description"))
      ),
      tags$hr(),
      fluidRow(
        column(4, "collectionName"),
        column(8, "Character. Name of a GeneSetCollection obtained by using one of the importGeneSet* functions. Preset options for mitochondrial gene sets are provided, but users have to choose the one that matches to the dataset if needed. Default None.")
      ),
      tags$hr(),
      fluidRow(
        column(4, "Import Gene Sets"),
        column(8, "Redirect link to Import Gene Sets page, where users can upload GMT files, import gene set from curated database, or paste in a customized list.")
      )
    )
  )
}

#' @title Find doublets/multiplets using \link[scds]{cxds}.
#' @description A wrapper function for \link[scds]{cxds}. Annotate
#' doublets/multiplets using co-expression based approach. Generate a doublet
#' score for each cell. Infer doublets if \code{estNdbl} is \code{TRUE}.
#' @param inSCE A \linkS4class{SingleCellExperiment} object.
#' @param sample Character vector or colData variable name. Indicates which 
#' sample each cell belongs to. Default \code{NULL}.
#' @param seed Seed for the random number generator, can be \code{NULL}. Default
#' \code{12345}.
#' @param ntop See \link[scds]{cxds} for more information. Default \code{500}.
#' @param binThresh See \link[scds]{cxds} for more information. Default 
#' \code{0}.
#' @param verb See \link[scds]{cxds} for more information. Default \code{FALSE}.
#' @param retRes See \link[scds]{cxds} for more information. Default 
#' \code{FALSE}.
#' @param estNdbl See \link[scds]{cxds} for more information. Default 
#' \code{FALSE}.
#' @param useAssay A string specifying which assay in the SCE to use. Default 
#' \code{"counts"}
#' @details When the argument \code{sample} is specified, \link[scds]{cxds} will
#' be run on cells from each sample separately. If \code{sample = NULL}, then 
#' all cells will be processed together.
#' @return A \linkS4class{SingleCellExperiment} object with \link[scds]{cxds} 
#' output appended to the \link{colData} slot. The columns include 
#' \emph{cxds_score} and optionally \emph{cxds_call}. 
#' @seealso \code{\link[scds]{cxds}}, \code{\link{plotCxdsResults}}, 
#' \code{\link{runCellQC}}
#' @examples
#' data(scExample, package = "singleCellTK")
#' sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
#' sce <- runCxds(sce)
#' @export
#' @importFrom SummarizedExperiment colData colData<- assay
#' @importFrom SingleCellExperiment counts<-
#' @importFrom S4Vectors metadata<-
runCxds <- function(
    inSCE,
    sample = NULL,
    seed = 12345,
    ntop = 500,
    binThresh = 0,
    verb = FALSE,
    retRes = FALSE,
    estNdbl = FALSE,
    useAssay = "counts") 
{
  message(date(), " ... Running 'cxds'")
  
  ## Getting current arguments
  argsList <- mget(names(formals()),sys.frame(sys.nframe()))
  argsList <- argsList[!names(argsList) %in% c("inSCE")]
  argsList$packageVersion <- utils::packageDescription("scds")$Version
  
  sample <- .manageCellVar(inSCE, var = sample)
  if (is.null(sample)) {
    sample <- rep(1, ncol(inSCE))
  }
  ## Define result matrix for all samples
  if (isTRUE(estNdbl)) {
    output <- S4Vectors::DataFrame(row.names = colnames(inSCE),
                                   cxds_score = numeric(ncol(inSCE)),
                                   cxds_call = logical(ncol(inSCE)))
  } else {
    output <- S4Vectors::DataFrame(row.names = colnames(inSCE),
                                   cxds_score = numeric(ncol(inSCE)))
  }
  
  ## Loop through each sample and run cxds
  samples <- unique(sample)
  for (s in samples) {
    sceSampleInd <- sample == s
    sceSample <- inSCE[, sceSampleInd]
    
    mat <- assay(sceSample, i = useAssay)
    counts(sceSample) <- .convertToMatrix(mat)
    
    result <- NULL
    nGene <- ntop
    while (!inherits(result, "SingleCellExperiment") & nGene > 0) {
      try({
        result <- withr::with_seed(seed, {
          scds::cxds(sce = sceSample,
                     ntop = nGene,
                     binThresh = binThresh,
                     verb = verb,
                     retRes = retRes,
                     estNdbl = estNdbl)
        })
      }, silent = TRUE)
      nGene <- nGene - 100
    }
    
    if (!inherits(result, "try-error") & !is.null(result)) {
      if ("cxds_call" %in% colnames(colData(result))) {
        output[sceSampleInd, ] <- colData(result)[, c("cxds_score", 
                                                      "cxds_call")]
      } else {
        output[sceSampleInd, ] <- colData(result)[, c("cxds_score")]
      }
    } else {
      output[sceSampleInd, ] <- NA
      warning("'cxds' from package 'scds' did not complete successfully ", 
              "for sample: ", s)
    }
    if (!identical(samples, 1)) {
      metadata(inSCE)$sctk$runCxds[[s]] <- argsList
    }
  }
  if (identical(samples, 1)) {
    metadata(inSCE)$sctk$runCxds$all_cells <- argsList
  }
  
  colData(inSCE)[, paste0("scds_", colnames(output))] <- NULL
  
  if (isTRUE(estNdbl)) {
    output$cxds_call <- as.factor(output$cxds_call)
    levels(output$cxds_call) <- list(Singlet = "FALSE", Doublet = "TRUE")
  }
  
  colnames(output) <- paste0("scds_", colnames(output))
  colData(inSCE) = cbind(colData(inSCE), output)
  
  return(inSCE)
}

#' @title Find doublets/multiplets using \link[scds]{bcds}.
#' @description A wrapper function for \link[scds]{bcds}. Annotate
#'  doublets/multiplets using a binary classification approach to discriminate
#'  artificial doublets from original data. Generate a doublet
#'  score for each cell. Infer doublets if \code{estNdbl} is \code{TRUE}.
#' @param inSCE A \linkS4class{SingleCellExperiment} object.
#' @param sample Character vector or colData variable name. Indicates which 
#' sample each cell belongs to. Default \code{NULL}.
#' @param seed Seed for the random number generator, can be \code{NULL}. Default
#' \code{12345}.
#' @param ntop See \link[scds]{bcds} for more information. Default \code{500}.
#' @param srat See \link[scds]{bcds} for more information. Default \code{1}.
#' @param verb See \link[scds]{bcds} for more information. Default \code{FALSE}.
#' @param retRes See \link[scds]{bcds} for more information. Default 
#' \code{FALSE}.
#' @param nmax See \link[scds]{bcds} for more information. Default 
#' \code{"tune"}.
#' @param varImp See \link[scds]{bcds} for more information. Default 
#' \code{FALSE}.
#' @param estNdbl See \link[scds]{bcds} for more information. Default 
#' \code{FALSE}.
#' @param useAssay  A string specifying which assay in \code{inSCE} to use.
#' Default \code{"counts"}
#' @return A \linkS4class{SingleCellExperiment} object with \link[scds]{bcds} 
#' output appended to the \link{colData} slot. The columns include 
#' \emph{bcds_score} and optionally \emph{bcds_call}. Please refer to the 
#' documentation of \link[scds]{bcds} for details.
#' @details When the argument \code{sample} is specified, \link[scds]{bcds} will
#' be run on cells from each sample separately. If \code{sample = NULL}, then 
#' all cells will be processed together.
#' @seealso \code{\link[scds]{bcds}}, \code{\link{plotBcdsResults}}, 
#' \code{\link{runCellQC}}
#' @examples
#' data(scExample, package = "singleCellTK")
#' sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
#' sce <- runBcds(sce)
#' @export
#' @importFrom SummarizedExperiment colData colData<-
#' @importFrom SingleCellExperiment counts<-
#' @importFrom S4Vectors metadata<-
runBcds <- function(
    inSCE,
    sample = NULL,
    seed = 12345,
    ntop = 500,
    srat = 1,
    verb = FALSE,
    retRes = FALSE,
    nmax = "tune",
    varImp = FALSE,
    estNdbl = FALSE,
    useAssay = "counts"
) {
  message(date(), " ... Running 'bcds'")
  
  ## Getting current arguments
  argsList <- mget(names(formals()),sys.frame(sys.nframe()))
  argsList <- argsList[!names(argsList) %in% c("inSCE")]
  argsList$packageVersion <- utils::packageDescription("scds")$Version
  
  sample <- .manageCellVar(inSCE, var = sample)
  if (is.null(sample)) {
    sample <- rep(1, ncol(inSCE))
  }
  ## Define result matrix for all samples
  if (isTRUE(estNdbl)) {
    output <- S4Vectors::DataFrame(row.names = colnames(inSCE),
                                   bcds_score = numeric(ncol(inSCE)),
                                   bcds_call = logical(ncol(inSCE)))
  } else {
    output <- S4Vectors::DataFrame(row.names = colnames(inSCE),
                                   bcds_score = numeric(ncol(inSCE)))
  }
  
  ## Loop through each sample and run bcds
  samples <- unique(sample)
  for (s in samples) {
    sceSampleInd <- sample == s
    sceSample <- inSCE[, sceSampleInd]
    
    mat <- SummarizedExperiment::assay(sceSample, i = useAssay)
    counts(sceSample) <- .convertToMatrix(mat)
    
    result <- NULL
    nGene <- ntop
    while (!inherits(result, "SingleCellExperiment") & nGene > 0) {
      try({
        result <- withr::with_seed(seed, {
          scds::bcds(sce = sceSample,
                     ntop = nGene,
                     srat = srat,
                     verb = verb,
                     retRes = retRes,
                     nmax = nmax,
                     varImp = varImp,
                     estNdbl = estNdbl
          )
        })
      }, silent = TRUE)
      nGene <- nGene - 100
    }
    
    if (!inherits(result, "try-error") & !is.null(result)) {
      if ("bcds_call" %in% colnames(colData(result))) {
        output[sceSampleInd, ] <- colData(result)[,c("bcds_score", "bcds_call")]
      } else {
        output[sceSampleInd, ] <- colData(result)[,c("bcds_score")]
      }
    } else {
      output[sceSampleInd, ] <- NA
      warning("'bcds' from package 'scds' did not complete successfully for ", 
              "sample: ", s)
    }
    if (!identical(samples, 1)) {
      metadata(inSCE)$sctk$runBcds[[s]] <- argsList
    }
  }
  if (identical(samples, 1)) {
    metadata(inSCE)$sctk$runBcds$all_cells <- argsList
  }
  
  colData(inSCE)[, paste0("scds_", colnames(output))] <- NULL
  
  if (isTRUE(estNdbl)) {
    output$bcds_call <- as.factor(output$bcds_call)
    levels(output$bcds_call) <- list(Singlet = "FALSE", Doublet = "TRUE")
  }
  
  colnames(output) <- paste0("scds_", colnames(output))
  colData(inSCE) = cbind(colData(inSCE), output)
  
  return(inSCE)
}


#' @title Find doublets/multiplets using \link[scds]{cxds_bcds_hybrid}.
#' @description A wrapper function for \link[scds]{cxds_bcds_hybrid}. Annotate
#'  doublets/multiplets using a binary classification approach to discriminate
#'  artificial doublets from original data. Generate a doublet
#'  score for each cell. Infer doublets if \code{estNdbl} is \code{TRUE}.
#' @param inSCE A \link[SingleCellExperiment]{SingleCellExperiment} object.
#'  Needs \code{counts} in assays slot.
#' @param sample Character vector. Indicates which sample each cell belongs to.
#'  \link[scds]{cxds_bcds_hybrid} will be run on cells from each sample
#'  separately. If NULL, then all cells will be processed together.
#'  Default NULL.
#' @param seed Seed for the random number generator. Default 12345.
#' @param nTop The number of top varialbe genes to consider. Used in both \code{csds}
#' and \code{bcds}. Default \code{500}.
#' @param cxdsArgs See \link[scds]{cxds_bcds_hybrid} for more information. Default \code{NULL}.
#' @param bcdsArgs See \link[scds]{cxds_bcds_hybrid} for more information. Default \code{NULL}.
#' @param verb See \link[scds]{cxds_bcds_hybrid} for more information. Default \code{FALSE}.
#' @param estNdbl See \link[scds]{cxds_bcds_hybrid} for more information. Default \code{FALSE}.
#' @param force See \link[scds]{cxds_bcds_hybrid} for more information. Default \code{FALSE}.
#' @param useAssay  A string specifying which assay in the SCE to use.
#' @return A \link[SingleCellExperiment]{SingleCellExperiment} object with
#'  \link[scds]{cxds_bcds_hybrid} output appended to the
#'  \link{colData} slot. The columns include
#'  \emph{hybrid_score} and optionally \emph{hybrid_call}.
#'  Please refer to the documentation of \link[scds]{cxds_bcds_hybrid} for
#'  details.
#' @examples
#' data(scExample, package = "singleCellTK")
#' sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
#' sce <- runCxdsBcdsHybrid(sce)
#' @export
#' @importFrom SummarizedExperiment colData colData<-
#' @importFrom SingleCellExperiment counts counts<-
runCxdsBcdsHybrid <- function(inSCE,
                              sample = NULL,
                              seed = 12345,
                              nTop = 500,
                              cxdsArgs = list(),
                              bcdsArgs = list(),
                              verb = FALSE,
                              estNdbl = FALSE,
                              force = FALSE,
                              useAssay = "counts") 
{
  message(date(), " ... Running 'cxds_bcds_hybrid'")
  
  ## Getting current arguments
  argsList <- mget(names(formals()),sys.frame(sys.nframe()))
  argsList <- argsList[!names(argsList) %in% c("inSCE")]
  argsList$packageVersion <- utils::packageDescription("scds")$Version
  
  sample <- .manageCellVar(inSCE, var = sample)
  if (is.null(sample)) {
    sample <- rep(1, ncol(inSCE))
  }
  ## Define result matrix for all samples
  if (isTRUE(estNdbl)) {
    output <- S4Vectors::DataFrame(row.names = colnames(inSCE),
                                   hybrid_score = numeric(ncol(inSCE)),
                                   hybrid_call = logical(ncol(inSCE)))
  } else {
    output <- S4Vectors::DataFrame(row.names = colnames(inSCE),
                                   hybrid_score = numeric(ncol(inSCE)))
  }
  
  ## Loop through each sample and run cxds_bcds_hybrid
  samples <- unique(sample)
  for (s in samples) {
    sceSampleInd <- sample == s
    sceSample <- inSCE[, sceSampleInd]
    
    mat <- SummarizedExperiment::assay(sceSample, i = useAssay)
    counts(sceSample) <- .convertToMatrix(mat)
    
    # Get ntop from Args list if they are available, otherwise use
    # the 'ntop' parameter
    result <- NULL
    nGene.cxds <- nTop
    if (!is.null(cxdsArgs[["ntop"]])) {
      nGene.cxds <- cxdsArgs[["ntop"]]
      cxdsArgs[["ntop"]] <- NULL
    }
    nGene.bcds <- nTop
    if (!is.null(bcdsArgs[["ntop"]])) {
      nGene.bcds <- bcdsArgs[["ntop"]]
      bcdsArgs[["ntop"]] <- NULL
    }
    
    nGene <- min(nGene.cxds, nGene.bcds)
    while (!inherits(result, "SingleCellExperiment") & nGene > 0) {
      try({
        result <- withr::with_seed(seed, {
          scds::cxds_bcds_hybrid(sce = sceSample,
                                 cxdsArgs = c(list(ntop = nGene.cxds), 
                                              cxdsArgs),
                                 bcdsArgs = c(list(ntop = nGene.bcds), 
                                              bcdsArgs),
                                 verb = verb,
                                 estNdbl = estNdbl,
                                 force = force)
        })
      }, silent = TRUE)
      nGene <- nGene - 100
      nGene.bcds <- nGene.bcds - 100
      nGene.cxds <- nGene.cxds - 100
    }
    
    if (!inherits(result, "try-error") & !is.null(result)) {
      if ("hybrid_call" %in% colnames(colData(result))) {
        output[sceSampleInd, ] <- colData(result)[, c("hybrid_score", 
                                                      "hybrid_call")]
      } else {
        output[sceSampleInd, ] <- colData(result)[, c("hybrid_score")]
      }
    } else {
      output[sceSampleInd, ] <- NA
      warning("'cxds_bcds_hybrid' from package 'scds' did not complete ", 
              "successfully for sample: ", s)
    }
    if (!identical(samples, 1)) {
      metadata(inSCE)$sctk$runCxdsBcdsHybrid[[s]] <- argsList
    }
  }
  if (identical(samples, 1)) {
    metadata(inSCE)$sctk$runCxdsBcdsHybrid$all_cells <- argsList
  }
  colData(inSCE)[, paste0("scds_", colnames(output))] <- NULL
  if (isTRUE(estNdbl)) {
    output$hybrid_call <- as.factor(output$hybrid_call)
    levels(output$hybrid_call) <- list(Singlet = "FALSE", Doublet = "TRUE")
  }
  
  colnames(output) <- paste0("scds_", colnames(output))
  colData(inSCE) <- cbind(colData(inSCE), output)
  
  return(inSCE)
}

########################################
### Helper Functions ##################
#######################################

#' .updateAssaySCEFromScanpy
#' Update/Modify/Add an assay in the provided SingleCellExperiment object from
#' an AnnData object
#' @param inSCE Input SingleCellExperiment object
#' @param scanpyObject Input annData object
#' @param assaySlotSCE Selected assay to update in the input
#' SingleCellExperiment object
#' @param scanpyAssaySlot Selected assay from annData object. Default
#' \code{"X"}.
#' @return A \link[SingleCellExperiment]{SingleCellExperiment} object with
#'  data from annData object appended to the \link{assay} slot.
#' @importFrom SummarizedExperiment assay<-
#' @noRd
.updateAssaySCEFromScanpy <- function(inSCE,
                                      scanpyObject,
                                      assaySlotSCE,
                                      scanpyAssaySlot = "X") {
  assay(inSCE, assaySlotSCE) <- NULL
  temp.matrix <- t(scanpyObject[[scanpyAssaySlot]])
  colnames(temp.matrix) <- colnames(inSCE)
  rownames(temp.matrix) <- rownames(inSCE)
  assay(inSCE, assaySlotSCE) <- temp.matrix
  
  return(inSCE)
}


#####################################################
#### Normalization and Scaling function ############
#####################################################

#' runScanpyNormalizeData
#' Wrapper for NormalizeData() function from scanpy library
#' Normalizes the sce object according to the input parameters
#' @param inSCE (sce) object to normalize
#' @param useAssay Assay containing raw counts to use for normalization.
#' @param targetSum If NULL, after normalization, each observation (cell) has a 
#' total count equal to the median of total counts for observations (cells) 
#' before normalization. Default \code{1e4}
#' @param maxFraction Include cells that have more counts than max_fraction of 
#' the original total counts in at least one cell. Default \code{0.05}
#' @param normAssayName Name of new assay containing normalized data. Default
#' \code{scanpyNormData}.
#' @examples
#' data(scExample, package = "singleCellTK")
#' sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
#' rownames(sce) <- rowData(sce)$feature_name
#' \dontrun{
#' sce <- runScanpyNormalizeData(sce, useAssay = "counts")
#' }
#' @return Normalized \code{SingleCellExperiment} object
#' @export
#' @importFrom reticulate py_module_available py_set_seed import
runScanpyNormalizeData <- function(inSCE,
                                   useAssay,
                                   targetSum = 1e4,
                                   maxFraction = 0.05,
                                   normAssayName = "scanpyNormData") {
  
  if (!reticulate::py_module_available(module = "scanpy")) {
    warning("Cannot find python module 'scanpy', please install Conda and",
            " run sctkPythonInstallConda() or run sctkPythonInstallVirtualEnv().",
            "If one of these have been previously run to install the modules,",
            "make sure to run selectSCTKConda() or selectSCTKVirtualEnvironment(),",
            " respectively, if R has been restarted since the module installation.",
            " Alternatively, Scanpy can be installed on the local machine",
            "with pip (e.g. pip install scanpy) and then the 'use_python()'",
            " function from the 'reticulate' package can be used to select the",
            " correct Python environment.")
    return(inSCE)
  }
  
  if (missing(useAssay)) {
    useAssay <- SummarizedExperiment::assayNames(inSCE)[1]
    message(
      "'useAssay' parameter missing. Using the first available assay ",
      "instead: '",
      useAssay,
      "'"
    )
  }
  scanpyObject <- zellkonverter::SCE2AnnData(sce = inSCE, 
                                             X_name = useAssay,
                                             assays = FALSE,
                                             colData = TRUE,
                                             rowData = TRUE,
                                             varm = TRUE,
                                             reducedDims = FALSE,
                                             metadata = FALSE,
                                             colPairs = FALSE,
                                             rowPairs = FALSE,
                                             skip_assays = FALSE,
                                             verbose = NULL)
  normValue <- sc$pp$normalize_total(scanpyObject, 
                                     target_sum = targetSum, 
                                     max_fraction =  maxFraction,
                                     inplace = FALSE)
  
  scanpyObject$obs$n_counts <- normValue$norm_factor
  scanpyObject$X <- normValue$X
  
  # log transform the data.
  scanpyObject <- sc$pp$log1p(scanpyObject, copy = TRUE)
  
  inSCE <-
    .updateAssaySCEFromScanpy(inSCE, scanpyObject, normAssayName)
  metadata(inSCE)$scanpy$normValues <- normValue$X
  colData(inSCE)$n_counts <- 
    as.factor(unlist(scanpyObject$obs['n_counts']))
  
  inSCE <- expSetDataTag(inSCE = inSCE,
                         assayType = "normalized",
                         assays = normAssayName)
  return(inSCE)
}

#' runScanpyScaleData
#' Scales the input sce object according to the input parameters
#' @param inSCE (sce) object to scale
#' @param useAssay Assay containing normalized counts to scale.
#' @param scaledAssayName Name of new assay containing scaled data. Default
#' \code{scanpyScaledData}.
#' @examples
#' data(scExample, package = "singleCellTK")
#' \dontrun{
#' sce <- runScanpyNormalizeData(sce, useAssay = "counts")
#' sce <- runScanpyScaleData(sce, useAssay = "scanpyNormData")
#' }
#' @return Scaled \code{SingleCellExperiment} object
#' @export
#' @importFrom reticulate py_module_available py_set_seed import
runScanpyScaleData <- function(inSCE,
                               useAssay = "scanpyNormData",
                               scaledAssayName = "scanpyScaledData") {
  
  if (!reticulate::py_module_available(module = "scanpy")) {
    warning("Cannot find python module 'scanpy', please install Conda and",
            " run sctkPythonInstallConda() or run sctkPythonInstallVirtualEnv().",
            "If one of these have been previously run to install the modules,",
            "make sure to run selectSCTKConda() or selectSCTKVirtualEnvironment(),",
            " respectively, if R has been restarted since the module installation.",
            " Alternatively, Scanpy can be installed on the local machine",
            "with pip (e.g. pip install scanpy) and then the 'use_python()'",
            " function from the 'reticulate' package can be used to select the",
            " correct Python environment.")
    return(inSCE)
  }
  
  scanpyObject <- zellkonverter::SCE2AnnData(sce = inSCE, 
                                             X_name = useAssay,
                                             assays = FALSE,
                                             colData = TRUE,
                                             rowData = TRUE,
                                             varm = TRUE,
                                             reducedDims = FALSE,
                                             metadata = TRUE,
                                             colPairs = FALSE,
                                             rowPairs = FALSE,
                                             skip_assays = FALSE,
                                             verbose = NULL)
  sc$pp$scale(scanpyObject, max_value=10)
  inSCE <-
    .updateAssaySCEFromScanpy(inSCE, scanpyObject, scaledAssayName, "X")
  rowData(inSCE)$"Scanpy_mean" <- scanpyObject$var$mean 
  rowData(inSCE)$"Scanpy_std" <- scanpyObject$var$std 
  
  inSCE <- expSetDataTag(inSCE = inSCE,
                         assayType = "scaled",
                         assays = scaledAssayName)
  
  return(inSCE)
}

######################################
### High Variable Genes ###############
######################################

#' runScanpyFindHVG
#' Find highly variable genes and store in the input sce object
#' @param inSCE (sce) object to compute highly variable genes from and to store
#' back to it
#' @param useAssay Specify the name of the assay to use for computation
#'  of variable genes. It is recommended to use log normalized data, except when 
#'  flavor='seurat_v3', in which counts data is expected.
#' @param method selected method to use for computation of highly variable
#' genes. One of \code{'seurat'}, \code{'cell_ranger'}, or \code{'seurat_v3'}.
#' Default \code{"seurat"}.
#' @param altExpName Character. Name of the alternative experiment object to
#' add if \code{returnAsAltExp = TRUE}. Default \code{featureSubset}.
#' @param altExp Logical value indicating if the input object is an
#' altExperiment. Default \code{FALSE}.
#' @param hvgNumber numeric value of how many genes to select as highly
#' variable. Default \code{2000}
#' @param minMean If n_top_genes unequals None, this and all other cutoffs for 
#' the means and the normalized dispersions are ignored. Ignored if 
#' flavor='seurat_v3'. Default \code{0.0125}
#' @param maxMean If n_top_genes unequals None, this and all other cutoffs for 
#' the means and the normalized dispersions are ignored. Ignored if 
#' flavor='seurat_v3'. Default \code{3}
#' @param minDisp If n_top_genes unequals None, this and all other cutoffs for 
#' the means and the normalized dispersions are ignored. Ignored if 
#' flavor='seurat_v3'. Default \code{0.5}
#' @param maxDisp If n_top_genes unequals None, this and all other cutoffs for 
#' the means and the normalized dispersions are ignored. Ignored if 
#' flavor='seurat_v3'. Default \code{Inf}
#' @examples
#' data(scExample, package = "singleCellTK")
#' \dontrun{
#' sce <- runScanpyNormalizeData(sce, useAssay = "counts")
#' sce <- runScanpyFindHVG(sce, useAssay = "scanpyNormData", method = "seurat")
#' g <- getTopHVG(sce, method = "seurat", hvgNumber = 500)
#' }
#' @return Updated \code{SingleCellExperiment} object with highly variable genes
#' computation stored
#' \code{\link{getTopHVG}}, \code{\link{plotTopHVG}}
#' @export
#' @importFrom SummarizedExperiment rowData rowData<-
#' @importFrom S4Vectors metadata<-
#' @importFrom reticulate py_module_available py_set_seed import
runScanpyFindHVG <- function(inSCE,
                             useAssay = "scanpyNormData",
                             method = c("seurat", "cell_ranger", "seurat_v3"),
                             altExpName = "featureSubset",
                             altExp = FALSE,
                             hvgNumber = 2000,
                             minMean = 0.0125,
                             maxMean = 3,
                             minDisp = 0.5,
                             maxDisp = Inf) {
  
  if (!reticulate::py_module_available(module = "scanpy")) {
    warning("Cannot find python module 'scanpy', please install Conda and",
            " run sctkPythonInstallConda() or run sctkPythonInstallVirtualEnv().",
            "If one of these have been previously run to install the modules,",
            "make sure to run selectSCTKConda() or selectSCTKVirtualEnvironment(),",
            " respectively, if R has been restarted since the module installation.",
            " Alternatively, Scanpy can be installed on the local machine",
            "with pip (e.g. pip install scanpy) and then the 'use_python()'",
            " function from the 'reticulate' package can be used to select the",
            " correct Python environment.")
    return(inSCE)
  }
  
  method <- match.arg(method)
  fullSCE_cellranger <- NULL
  
  if (!altExp) {
    if (method == "cell_ranger"){
      # for cell_ranger method only
      fullSCE_cellranger <- inSCE
      inSCE <- inSCE[which(rowSums(assay(inSCE, useAssay)) > 0), ]
      #############################
    }
    scanpyObject <- zellkonverter::SCE2AnnData(sce = inSCE, 
                                               X_name = useAssay,
                                               assays = FALSE,
                                               colData = TRUE,
                                               rowData = TRUE,
                                               varm = TRUE,
                                               reducedDims = FALSE,
                                               metadata = TRUE,
                                               colPairs = FALSE,
                                               rowPairs = FALSE,
                                               skip_assays = FALSE,
                                               verbose = NULL)
  }
  else{
    if (method == "cell_ranger"){
      # for cell_ranger method only
      tempSCE <- inSCE
      inSCE <- altExp(inSCE, altExpName)[which(rowSums(assay(altExp(inSCE, altExpName), useAssay)) > 0), ]
      #############################
    }
    scanpyObject <- zellkonverter::SCE2AnnData(sce = altExp(inSCE, altExpName), 
                                               X_name = useAssay,
                                               assays = FALSE,
                                               colData = TRUE,
                                               rowData = TRUE,
                                               varm = TRUE,
                                               reducedDims = FALSE,
                                               metadata = FALSE,
                                               colPairs = FALSE,
                                               rowPairs = FALSE,
                                               skip_assays = FALSE,
                                               verbose = NULL)
    
  }
  
  if (method == "seurat") {
    scanpyObject$var['mean'] <- rowData(inSCE)$"Scanpy_mean"
    scanpyObject$var['std'] <- rowData(inSCE)$"Scanpy_std"
    sc$pp$highly_variable_genes(scanpyObject, 
                                flavor = method,
                                n_top_genes = as.integer(hvgNumber),
                                min_mean = minMean,
                                max_mean = maxMean,
                                min_disp = minDisp,
                                max_disp = maxDisp)
    
    #tmpSCE <- zellkonverter::AnnData2SCE(adata = scanpyObject)
    metadata(inSCE)$hvg <- scanpyObject$uns['hvg']
    rowData(inSCE)$dispersions <-
      unlist(scanpyObject$var['dispersions'])
    rowData(inSCE)$dispersions_norm <-
      unlist(scanpyObject$var['dispersions_norm'])
    rowData(inSCE)$means <-
      unlist(scanpyObject$var['means'])
    rowData(inSCE)$highly_variable <-
      unlist(scanpyObject$var['highly_variable'])
    
    metadata(inSCE)$sctk$runFeatureSelection$seurat <-
      list(
        useAssay = useAssay,
        rowData = c(
          "dispersions",
          "dispersions_norm",
          "means"
        )
      )
  } 
  #for this approach it is required that sce basic filering of cells and genes 
  #must be done
  else if (method == "cell_ranger") {
    sc$pp$highly_variable_genes(scanpyObject, 
                                flavor = method,
                                n_top_genes = as.integer(hvgNumber),
                                min_mean = minMean,
                                max_mean = maxMean,
                                min_disp = minDisp,
                                max_disp = maxDisp)
    
    
    #metadata(inSCE)$hvg <- metadata(tmpSCE)['hvg'][['hvg']] 
    metadata(fullSCE_cellranger)$hvg <- scanpyObject$uns['hvg']
    if (!altExp) {
      rowData(inSCE)$dispersions <-
        unlist(scanpyObject$var['dispersions'])
      rowData(inSCE)$dispersions_norm <-
        unlist(scanpyObject$var['dispersions_norm'])
      rowData(inSCE)$means <-
        unlist(scanpyObject$var['means'])
      rowData(inSCE)$highly_variable <-
        unlist(scanpyObject$var['highly_variable'])
      
    }
    else{
      altExpRows <- match(rownames(inSCE), rownames(scanpyObject))
      rowData(inSCE)$dispersions <-
        unlist(scanpyObject$var['dispersions'])[altExpRows]
      rowData(inSCE)$dispersions_norm <-
        unlist(scanpyObject$var['dispersions_norm'])[altExpRows]   
      rowData(inSCE)$means <-
        unlist(scanpyObject$var['means'])[altExpRows]
      rowData(inSCE)$highly_variable <-
        unlist(scanpyObject$var['highly_variable'])
    }
    
    metadata(inSCE)$sctk$runFeatureSelection$cell_ranger <-
      list(
        useAssay = useAssay,
        rowData = c(
          "dispersions",
          "dispersions_norm",
          "means",
          "highly_variable"
        )
      )
    
    mergedRowData <- merge(rowData(fullSCE_cellranger), rowData(inSCE)[, metadata(inSCE)$sctk$runFeatureSelection$cell_ranger$rowData],
                           by = 'row.names', all = TRUE)
    row.names(mergedRowData) <- mergedRowData$Row.names
    mergedRowData$Row.names <- NULL
    rowData(fullSCE_cellranger) <- mergedRowData
    inSCE <- fullSCE_cellranger
  }
  
  else if (method == "seurat_v3") {
    sc$pp$highly_variable_genes(scanpyObject, 
                                flavor = method,
                                n_top_genes = as.integer(hvgNumber),
                                min_mean = minMean,
                                max_mean = maxMean,
                                min_disp = minDisp,
                                max_disp = maxDisp)
    
    metadata(inSCE)$hvg <- scanpyObject$uns['hvg']
    
    rowData(inSCE)$variances <-
      unlist(scanpyObject$var['variances'])
    rowData(inSCE)$variances_norm <-
      unlist(scanpyObject$var['variances_norm'])   
    rowData(inSCE)$means <-
      unlist(scanpyObject$var['means'])
    rowData(inSCE)$highly_variable <-
      unlist(scanpyObject$var['highly_variable'])
    metadata(inSCE)$sctk$runFeatureSelection$seurat_v3 <-
      list(
        useAssay = useAssay,
        rowData = c(
          "variances",
          "variances_norm",
          "means"
        )
      )
  }
  return(inSCE)
}


#' plotScanpyHVG
#'
#' @param inSCE Input \code{SingleCellExperiment} object.
#' @param log Plot on logarithmic axes. Default \code{FALSE}.
#' @examples
#' data(scExample, package = "singleCellTK")
#' \dontrun{
#' sce <- runScanpyNormalizeData(sce, useAssay = "counts")
#' sce <- runScanpyFindHVG(sce, useAssay = "scanpyNormData", method = "seurat")
#' plotScanpyHVG(sce)
#' }
#' @return plot object
#' @export
#' @importFrom reticulate py_module_available py_set_seed import
plotScanpyHVG <- function(inSCE,
                          log = FALSE){
  
  if (!reticulate::py_module_available(module = "scanpy")) {
    warning("Cannot find python module 'scanpy', please install Conda and",
            " run sctkPythonInstallConda() or run sctkPythonInstallVirtualEnv().",
            "If one of these have been previously run to install the modules,",
            "make sure to run selectSCTKConda() or selectSCTKVirtualEnvironment(),",
            " respectively, if R has been restarted since the module installation.",
            " Alternatively, Scanpy can be installed on the local machine",
            "with pip (e.g. pip install scanpy) and then the 'use_python()'",
            " function from the 'reticulate' package can be used to select the",
            " correct Python environment.")
    return(inSCE)
  }
  
  scanpyObject <- zellkonverter::SCE2AnnData(sce = inSCE,
                                             assays = FALSE,
                                             colData = TRUE,
                                             rowData = TRUE,
                                             varm = TRUE,
                                             reducedDims = FALSE,
                                             metadata = TRUE,
                                             colPairs = FALSE,
                                             rowPairs = FALSE,
                                             skip_assays = TRUE,
                                             verbose = NULL)
  if(is.null(scanpyObject$uns['hvg'])){
    stop(
      " High variable genes not found. Please run the 'runScanpyFindHVG' first."
    )
  }
  return(sc$pl$highly_variable_genes(scanpyObject,
                                     log = log))
}

################################################
######## PCA Function #########################
################################################

#' runScanpyPCA
#' Computes PCA on the input sce object and stores the calculated principal
#' components within the sce object
#' @param inSCE (sce) object on which to compute PCA
#' @param useAssay Assay containing scaled counts to use in PCA. Default
#' \code{"scanpyScaledData"}.
#' @param reducedDimName Name of new reducedDims object containing Scanpy PCA.
#' Default \code{scanpyPCA}.
#' @param nPCs numeric value of how many components to compute. Default
#' \code{50}.
#' @param method selected method to use for computation of pca. 
#' One of \code{'arpack'}, \code{'randomized'}, \code{'auto'} or \code{'lobpcg'}.
#' Default \code{"arpack"}.
#' @param use_highly_variable boolean value of whether to use highly variable 
#' genes only. By default uses them if they have been determined beforehand. 
#' @param seed Specify numeric value to set as a seed. Default \code{12345}.
#' @examples
#' data(scExample, package = "singleCellTK")
#' \dontrun{
#' sce <- runScanpyNormalizeData(sce, useAssay = "counts")
#' sce <- runScanpyFindHVG(sce, useAssay = "scanpyNormData", method = "seurat")
#' sce <- runScanpyScaleData(sce, useAssay = "scanpyNormData")
#' sce <- runScanpyPCA(sce, useAssay = "scanpyScaledData")
#' }
#' @return Updated \code{SingleCellExperiment} object which now contains the
#' computed principal components
#' @export
#' @importFrom SingleCellExperiment reducedDim<- rowSubset
#' @importFrom S4Vectors metadata<-
#' @importFrom reticulate py_module_available py_set_seed import
runScanpyPCA <- function(inSCE,
                         useAssay = "scanpyScaledData",
                         reducedDimName = "scanpyPCA",
                         nPCs = 50,
                         method = c("arpack", "randomized", "auto", "lobpcg"),
                         use_highly_variable = TRUE,
                         seed = 12345){
  
  if (!reticulate::py_module_available(module = "scanpy")) {
    warning("Cannot find python module 'scanpy', please install Conda and",
            " run sctkPythonInstallConda() or run sctkPythonInstallVirtualEnv().",
            "If one of these have been previously run to install the modules,",
            "make sure to run selectSCTKConda() or selectSCTKVirtualEnvironment(),",
            " respectively, if R has been restarted since the module installation.",
            " Alternatively, Scanpy can be installed on the local machine",
            "with pip (e.g. pip install scanpy) and then the 'use_python()'",
            " function from the 'reticulate' package can be used to select the",
            " correct Python environment.")
    return(inSCE)
  }
  
  if (!is.null(seed)) {
    reticulate::py_set_seed(seed = seed)
  }
  
  params <- as.list(environment())
  params$inSCE <- NULL
  
  method <- match.arg(method)
  
  scanpyObject <- zellkonverter::SCE2AnnData(sce = inSCE,
                                             X_name = useAssay,
                                             assays = FALSE,
                                             colData = TRUE,
                                             rowData = TRUE,
                                             varm = TRUE,
                                             reducedDims = FALSE,
                                             metadata = FALSE,
                                             colPairs = FALSE,
                                             rowPairs = FALSE,
                                             skip_assays = FALSE,
                                             verbose = NULL)
  sc$tl$pca(scanpyObject, 
            svd_solver= method, 
            n_comps = as.integer(nPCs), 
            use_highly_variable = use_highly_variable)
  
  metadata(inSCE)$scanpy$PCA <- scanpyObject
  
  temp <- scanpyObject$obsm[['X_pca']]
  #colnames(temp) <- paste0(rep("PC", ncol(temp)), seq(ncol(10)))
  rownames(temp) <- colnames(inSCE)
  rotation <- scanpyObject$varm[['PCs']]
  rownames(rotation) <- rownames(inSCE)
  
  reducedDim(inSCE, reducedDimName) <- temp
  attr(reducedDim(inSCE, reducedDimName), "percentVar") <- 
    scanpyObject$uns[['pca']][['variance_ratio']]
  attr(reducedDim(inSCE, reducedDimName), "rotation") <- rotation
  metadata(inSCE)$sctk$runDimReduce$reddim[[reducedDimName]] <- params
  
  return(inSCE)
}


#' plotScanpyPCA
#' 
#' @param inSCE Input \code{SingleCellExperiment} object.
#' @param reducedDimName Name of new reducedDims object containing Scanpy PCA. 
#' @param color Keys for annotations of observations/cells or variables/genes.
#' @param title Provide title for panels either as string or list of strings
#' @param legend Location of legend, either 'on data', 'right margin' or a 
#' valid keyword for the loc parameter of Legend.
#' @examples
#' data(scExample, package = "singleCellTK")
#' \dontrun{
#' sce <- runScanpyNormalizeData(sce, useAssay = "counts")
#' sce <- runScanpyFindHVG(sce, useAssay = "scanpyNormData", method = "seurat")
#' sce <- runScanpyScaleData(sce, useAssay = "scanpyNormData")
#' sce <- runScanpyPCA(sce, useAssay = "scanpyScaledData")
#' plotScanpyPCA(sce)
#' }
#' @return plot object
#' @export
#' @importFrom reticulate py_module_available py_set_seed import
plotScanpyPCA <- function(inSCE,
                          reducedDimName = "scanpyPCA", 
                          color = NULL,
                          title = '',
                          legend = 'right margin'){
  
  if (!reticulate::py_module_available(module = "scanpy")) {
    warning("Cannot find python module 'scanpy', please install Conda and",
            " run sctkPythonInstallConda() or run sctkPythonInstallVirtualEnv().",
            "If one of these have been previously run to install the modules,",
            "make sure to run selectSCTKConda() or selectSCTKVirtualEnvironment(),",
            " respectively, if R has been restarted since the module installation.",
            " Alternatively, Scanpy can be installed on the local machine",
            "with pip (e.g. pip install scanpy) and then the 'use_python()'",
            " function from the 'reticulate' package can be used to select the",
            " correct Python environment.")
    return(inSCE)
  }
  
  if(!reducedDimName %in% reducedDimNames(inSCE)){
    stop(
      "PCA results not found. Please run the 'runScanpyPCA' function first."
    )
  }
  reducedDim (inSCE, "X_pca") <- reducedDim(inSCE, reducedDimName)
  useAssay = metadata(inSCE)$sctk$runDimReduce$reddim[[reducedDimName]]$useAssay
  scanpyObject <- zellkonverter::SCE2AnnData(sce = inSCE,
                                             X_name = useAssay,
                                             colData = TRUE,
                                             rowData = TRUE,
                                             varm = TRUE,
                                             reducedDims = TRUE,
                                             metadata = FALSE,
                                             colPairs = TRUE,
                                             rowPairs = TRUE,
                                             verbose = NULL)
  return(sc$pl$pca(scanpyObject,
                   color = color,
                   title = title, 
                   legend_loc = legend))
}


#' plotScanpyPCAGeneRanking
#'
#' @param inSCE Input \code{SingleCellExperiment} object.
#' @param PC_comp For example, '1,2,3' means [1, 2, 3], first, second, 
#' third principal component.
#' @param includeLowest Whether to show the variables with both highest and 
#' lowest loadings. Default \code{TRUE}
#' @examples
#' data(scExample, package = "singleCellTK")
#' \dontrun{
#' sce <- runScanpyNormalizeData(sce, useAssay = "counts")
#' sce <- runScanpyFindHVG(sce, useAssay = "scanpyNormData", method = "seurat")
#' sce <- runScanpyScaleData(sce, useAssay = "scanpyNormData")
#' sce <- runScanpyPCA(sce, useAssay = "scanpyScaledData")
#' plotScanpyPCAGeneRanking(sce)
#' }
#' @return plot object
#' @export
#' @importFrom reticulate py_module_available py_set_seed import
plotScanpyPCAGeneRanking <- function(inSCE, 
                                     PC_comp = "1,2,3",
                                     includeLowest = TRUE){
  
  if (!reticulate::py_module_available(module = "scanpy")) {
    warning("Cannot find python module 'scanpy', please install Conda and",
            " run sctkPythonInstallConda() or run sctkPythonInstallVirtualEnv().",
            "If one of these have been previously run to install the modules,",
            "make sure to run selectSCTKConda() or selectSCTKVirtualEnvironment(),",
            " respectively, if R has been restarted since the module installation.",
            " Alternatively, Scanpy can be installed on the local machine",
            "with pip (e.g. pip install scanpy) and then the 'use_python()'",
            " function from the 'reticulate' package can be used to select the",
            " correct Python environment.")
    return(inSCE)
  }
  
  scanpyObject <- metadata(inSCE)$scanpy$PCA
  return(sc$pl$pca_loadings(scanpyObject,
                            components = PC_comp,
                            include_lowest = includeLowest))
  
}

#' plotScanpyPCAVariance
#'
#' @param inSCE Input \code{SingleCellExperiment} object.
#' @param nPCs Number of PCs to show. Default \code{50}.
#' @param log Plot on logarithmic scale. Default \code{FALSE}
#' @examples
#' data(scExample, package = "singleCellTK")
#' \dontrun{
#' sce <- runScanpyNormalizeData(sce, useAssay = "counts")
#' sce <- runScanpyFindHVG(sce, useAssay = "scanpyNormData", method = "seurat")
#' sce <- runScanpyScaleData(sce, useAssay = "scanpyNormData")
#' sce <- runScanpyPCA(sce, useAssay = "scanpyScaledData")
#' plotScanpyPCAVariance(sce)
#' }
#' @return plot object
#' @export
#' @importFrom reticulate py_module_available py_set_seed import
plotScanpyPCAVariance <- function(inSCE,
                                  nPCs = 50,
                                  log = FALSE){
  
  if (!reticulate::py_module_available(module = "scanpy")) {
    warning("Cannot find python module 'scanpy', please install Conda and",
            " run sctkPythonInstallConda() or run sctkPythonInstallVirtualEnv().",
            "If one of these have been previously run to install the modules,",
            "make sure to run selectSCTKConda() or selectSCTKVirtualEnvironment(),",
            " respectively, if R has been restarted since the module installation.",
            " Alternatively, Scanpy can be installed on the local machine",
            "with pip (e.g. pip install scanpy) and then the 'use_python()'",
            " function from the 'reticulate' package can be used to select the",
            " correct Python environment.")
    return(inSCE)
  }
  
  scanpyObject <- metadata(inSCE)$scanpy$PCA
  return(sc$pl$pca_variance_ratio(scanpyObject,
                                  n_pcs = as.integer(nPCs),
                                  log = log))
  
}

########################################################
###### Clustering function ############################
#######################################################

#' runScanpyFindClusters
#' Computes the clusters from the input sce object and stores them back in sce
#' object
#' @param inSCE (sce) object from which clusters should be computed and stored
#' in
#' @param useAssay Assay containing scaled counts to use for clustering.
#' @param useReducedDim Reduction method to use for computing clusters. 
#' Default \code{"scanpyPCA"}.
#' @param nNeighbors The size of local neighborhood (in terms of number of 
#' neighboring data points) used for manifold approximation. Larger values 
#' result in more global views of the manifold, while smaller values result in 
#' more local data being preserved. Default \code{10}.
#' @param dims numeric value of how many components to use for computing
#' clusters. Default \code{40}.
#' @param method selected method to compute clusters. One of "louvain",
#' and "leiden". Default \code{louvain}.
#' @param colDataName Specify the name to give to this clustering result. 
#'  Default is \code{NULL} that will generate a meaningful name automatically.
#' @param resolution A parameter value controlling the coarseness of the 
#' clustering. Higher values lead to more clusters Default \code{1}.
#' @param niterations How many iterations of the Leiden clustering method to 
#' perform. Positive values above 2 define the total number of iterations to 
#' perform, -1 has the method run until it reaches its optimal clustering.
#' Default \code{-1}.
#' @param flavor Choose between to packages for computing the clustering.
#' Default \code{vtraag} 
#' @param use_weights Boolean. Use weights from knn graph. Default \code{FALSE}
#' @param cor_method correlation method to use. Options are ‘pearson’, 
#' ‘kendall’, and ‘spearman’. Default \code{pearson}.
#' @param inplace If True, adds dendrogram information to annData object, 
#' else this function returns the information. Default \code{TRUE}
#' @param externalReduction Pass DimReduce object if PCA computed through
#' other libraries. Default \code{NULL}.
#' @param seed Specify numeric value to set as a seed. Default \code{12345}.
#' @examples
#' data(scExample, package = "singleCellTK")
#' \dontrun{
#' sce <- runScanpyNormalizeData(sce, useAssay = "counts")
#' sce <- runScanpyFindHVG(sce, useAssay = "scanpyNormData", method = "seurat")
#' sce <- runScanpyScaleData(sce, useAssay = "scanpyNormData")
#' sce <- runScanpyPCA(sce, useAssay = "scanpyScaledData")
#' sce <- runScanpyFindClusters(sce, useReducedDim = "scanpyPCA")
#' }
#' @return Updated sce object which now contains the computed clusters
#' @export
#' @importFrom reticulate py_module_available py_set_seed import
runScanpyFindClusters <- function(inSCE,
                                  useAssay = "scanpyScaledData",
                                  useReducedDim = "scanpyPCA",
                                  nNeighbors = 10,
                                  dims = 40,
                                  method = c("leiden", "louvain"),
                                  colDataName = NULL,
                                  resolution = 1,
                                  niterations = -1,
                                  flavor = 'vtraag',
                                  use_weights = FALSE,
                                  cor_method = 'pearson',
                                  inplace = TRUE,
                                  externalReduction = NULL,
                                  seed = 12345) {
  
  if (!reticulate::py_module_available(module = "scanpy")) {
    warning("Cannot find python module 'scanpy', please install Conda and",
            " run sctkPythonInstallConda() or run sctkPythonInstallVirtualEnv().",
            "If one of these have been previously run to install the modules,",
            "make sure to run selectSCTKConda() or selectSCTKVirtualEnvironment(),",
            " respectively, if R has been restarted since the module installation.",
            " Alternatively, Scanpy can be installed on the local machine",
            "with pip (e.g. pip install scanpy) and then the 'use_python()'",
            " function from the 'reticulate' package can be used to select the",
            " correct Python environment.")
    return(inSCE)
  }
  
  if (!reticulate::py_module_available(module = "louvain")) {
    warning("Cannot find python module 'louvain', please install Conda and",
            " run sctkPythonInstallConda() or run sctkPythonInstallVirtualEnv().",
            "If one of these have been previously run to install the modules,",
            "make sure to run selectSCTKConda() or selectSCTKVirtualEnvironment(),",
            " respectively, if R has been restarted since the module installation.",
            " Alternatively, louvain can be installed on the local machine",
            "with pip (e.g. pip install louvain) and then the 'use_python()'",
            " function from the 'reticulate' package can be used to select the",
            " correct Python environment.")
    return(inSCE)
  }
  
  if (!reticulate::py_module_available(module = "leidenalg")) {
    warning("Cannot find python module 'leidenalg', please install Conda and",
            " run sctkPythonInstallConda() or run sctkPythonInstallVirtualEnv().",
            "If one of these have been previously run to install the modules,",
            "make sure to run selectSCTKConda() or selectSCTKVirtualEnvironment(),",
            " respectively, if R has been restarted since the module installation.",
            " Alternatively, leidenalg can be installed on the local machine",
            "with pip (e.g. pip install leidenalg) and then the 'use_python()'",
            " function from the 'reticulate' package can be used to select the",
            " correct Python environment.")
    return(inSCE)
  }
  
  if (!is.null(seed)) {
    reticulate::py_set_seed(seed = seed)
  }
  
  method <- match.arg(method)
  
  scanpyObject <- zellkonverter::SCE2AnnData(sce = inSCE,  
                                             X_name = useAssay,
                                             assays = FALSE,
                                             colData = TRUE,
                                             rowData = TRUE,
                                             varm = TRUE,
                                             reducedDims = useReducedDim,
                                             metadata = FALSE,
                                             colPairs = FALSE,
                                             rowPairs = FALSE,
                                             skip_assays = FALSE,
                                             verbose = NULL)
  
  if (!is.null(externalReduction)) {
    scanpyObject$obsm <- list(pca = externalReduction)
    useReducedDim <- "pca"
  } 
  
  if(is.null(colDataName)){
    colDataName = paste0("Scanpy", "_", method, "_", resolution) 
  }
  
  sc$pp$neighbors(scanpyObject, 
                  n_neighbors = as.integer(nNeighbors), 
                  n_pcs = as.integer(dims),
                  use_rep = useReducedDim)
  
  if (method == "louvain") {
    sc$tl$louvain(adata = scanpyObject,
                  key_added = colDataName,
                  flavor = flavor,
                  use_weights = use_weights)
  } else if (method == "leiden") {
    sc$tl$leiden(adata = scanpyObject,
                 key_added = colDataName,
                 n_iterations = as.integer(niterations))
  } 
  
  colData(inSCE)[[colDataName]] <-
    as.factor(unlist(scanpyObject$obs[colDataName]))
  S4Vectors::metadata(inSCE)$scanpy[method] <- colDataName
  
  return(inSCE)
}

###############################################
###### Embedding functions #####################
###############################################

#' runScanpyUMAP
#' Computes UMAP from the given sce object and stores the UMAP computations back
#' into the sce object
#' @param inSCE (sce) object on which to compute the UMAP
#' @param useAssay Specify name of assay to use. Default is \code{NULL}, so
#' \code{useReducedDim} param will be used instead.
#' @param useReducedDim Reduction to use for computing UMAP. 
#' Default is \code{"scanpyPCA"}.
#' @param reducedDimName Name of new reducedDims object containing Scanpy UMAP
#' Default \code{scanpyUMAP}.
#' @param dims Numerical value of how many reduction components to use for UMAP
#' computation. Default \code{40}.
#' @param minDist Sets the \code{"min_dist"} parameter to the underlying UMAP
#' call. Default \code{0.5}.
#' @param nNeighbors Sets the \code{"n_neighbors"} parameter to the underlying
#' UMAP call. Default \code{10}.
#' @param spread Sets the \code{"spread"} parameter to the underlying UMAP call.
#' Default \code{1}.
#' @param alpha Sets the \code{"alpha"} parameter to the underlying UMAP call.
#' Default \code{1}.
#' @param gamma Sets the \code{"gamma"} parameter to the underlying UMAP call.
#' Default \code{1}.
#' @param externalReduction Pass DimReduce object if PCA computed through
#' other libraries. Default \code{NULL}.
#' @param seed Specify numeric value to set as a seed. Default \code{12345}.
#' @examples
#' data(scExample, package = "singleCellTK")
#' \dontrun{
#' sce <- runScanpyNormalizeData(sce, useAssay = "counts")
#' sce <- runScanpyFindHVG(sce, useAssay = "scanpyNormData", method = "seurat")
#' sce <- runScanpyScaleData(sce, useAssay = "scanpyNormData")
#' sce <- runScanpyPCA(sce, useAssay = "scanpyScaledData")
#' sce <- runScanpyFindClusters(sce, useReducedDim = "scanpyPCA")
#' sce <- runScanpyUMAP(sce, useReducedDim = "scanpyPCA")
#' }
#' @return Updated sce object with UMAP computations stored
#' @export
#' @importFrom SingleCellExperiment reducedDim<-
#' @importFrom reticulate py_module_available py_set_seed import
runScanpyUMAP <- function(inSCE,
                          useAssay = NULL,
                          useReducedDim = "scanpyPCA",
                          reducedDimName = "scanpyUMAP",
                          dims = 40,  
                          minDist = 0.5,
                          nNeighbors = 10, 
                          spread = 1,
                          alpha=1.0, 
                          gamma=1.0, 
                          externalReduction = NULL,
                          seed = 12345) {
  
  if (!reticulate::py_module_available(module = "scanpy")) {
    warning("Cannot find python module 'scanpy', please install Conda and",
            " run sctkPythonInstallConda() or run sctkPythonInstallVirtualEnv().",
            "If one of these have been previously run to install the modules,",
            "make sure to run selectSCTKConda() or selectSCTKVirtualEnvironment(),",
            " respectively, if R has been restarted since the module installation.",
            " Alternatively, Scanpy can be installed on the local machine",
            "with pip (e.g. pip install scanpy) and then the 'use_python()'",
            " function from the 'reticulate' package can be used to select the",
            " correct Python environment.")
    return(inSCE)
  }
  
  if (!is.null(seed)) {
    reticulate::py_set_seed(seed = seed)
  }
  
  params <- as.list(environment())
  params$inSCE <- NULL
  
  if(!is.null(useAssay)){
    scanpyObject <- zellkonverter::SCE2AnnData(sce = inSCE, 
                                               X_name = useAssay,
                                               assays = FALSE,
                                               colData = TRUE,
                                               rowData = TRUE,
                                               varm = TRUE,
                                               reducedDims = useReducedDim,
                                               metadata = FALSE,
                                               colPairs = FALSE,
                                               rowPairs = FALSE,
                                               skip_assays = FALSE,
                                               verbose = NULL)
  } else{
    scanpyObject <- zellkonverter::SCE2AnnData(sce = inSCE, 
                                               reducedDims = useReducedDim,
                                               assays = FALSE,
                                               colData = TRUE,
                                               rowData = TRUE,
                                               varm = TRUE,
                                               metadata = FALSE,
                                               colPairs = FALSE,
                                               rowPairs = FALSE,
                                               skip_assays = FALSE,
                                               verbose = NULL)
  }
  
  if (!is.null(externalReduction)) {
    scanpyObject$obsm <- list(pca = externalReduction)
    useReducedDim <- "pca"
  } 
  
  sc$pp$neighbors(scanpyObject, 
                  n_neighbors = as.integer(nNeighbors), 
                  n_pcs = as.integer(dims),
                  use_rep = useReducedDim)
  
  
  sc$tl$umap(scanpyObject, 
             n_components = 2L,
             min_dist = minDist,
             alpha = alpha, 
             gamma = gamma,
             spread = spread)
  
  
  temp <- scanpyObject$obsm[['X_umap']]
  rownames(temp) <- colnames(inSCE)
  reducedDim(inSCE, reducedDimName) <- temp
  metadata(inSCE)$sctk$runDimReduce$reddim[[reducedDimName]] <- params
  
  return(inSCE)
}



#' runScanpyTSNE
#' Computes tSNE from the given sce object and stores the tSNE computations back
#' into the sce object
#' @param inSCE (sce) object on which to compute the tSNE
#' @param useAssay Specify name of assay to use. Default is \code{NULL}, so
#' \code{useReducedDim} param will be used instead.
#' @param useReducedDim selected reduction method to use for computing tSNE.
#' Default \code{"scanpyPCA"}.
#' @param reducedDimName Name of new reducedDims object containing Scanpy tSNE
#' Default \code{scanpyTSNE}.
#' @param dims Number of reduction components to use for tSNE computation.
#' Default \code{40}.
#' @param perplexity Adjust the perplexity tuneable parameter for the underlying
#' tSNE call. Default \code{30}.
#' @param externalReduction Pass DimReduc object if PCA computed through
#' other libraries. Default \code{NULL}.
#' @param seed Specify numeric value to set as a seed. Default \code{12345}.
#' @examples
#' data(scExample, package = "singleCellTK")
#' \dontrun{
#' sce <- runScanpyNormalizeData(sce, useAssay = "counts")
#' sce <- runScanpyFindHVG(sce, useAssay = "scanpyNormData", method = "seurat")
#' sce <- runScanpyScaleData(sce, useAssay = "scanpyNormData")
#' sce <- runScanpyPCA(sce, useAssay = "scanpyScaledData")
#' sce <- runScanpyFindClusters(sce, useReducedDim = "scanpyPCA")
#' sce <- runScanpyTSNE(sce, useReducedDim = "scanpyPCA")
#' }
#' @return Updated sce object with tSNE computations stored
#' @export
#' @importFrom SingleCellExperiment reducedDim<-
#' @importFrom reticulate py_module_available py_set_seed import
runScanpyTSNE <- function(inSCE,
                          useAssay = NULL,
                          useReducedDim = "scanpyPCA", 
                          reducedDimName = "scanpyTSNE",
                          dims = 40,
                          perplexity = 30,
                          externalReduction = NULL,
                          seed = 12345){
  
  if (!reticulate::py_module_available(module = "scanpy")) {
    warning("Cannot find python module 'scanpy', please install Conda and",
            " run sctkPythonInstallConda() or run sctkPythonInstallVirtualEnv().",
            "If one of these have been previously run to install the modules,",
            "make sure to run selectSCTKConda() or selectSCTKVirtualEnvironment(),",
            " respectively, if R has been restarted since the module installation.",
            " Alternatively, Scanpy can be installed on the local machine",
            "with pip (e.g. pip install scanpy) and then the 'use_python()'",
            " function from the 'reticulate' package can be used to select the",
            " correct Python environment.")
    return(inSCE)
  }
  
  if (!is.null(seed)) {
    reticulate::py_set_seed(seed = seed)
  }
  
  params <- as.list(environment())
  params$inSCE <- NULL
  
  if(!is.null(useAssay)){
    scanpyObject <- zellkonverter::SCE2AnnData(sce = inSCE, 
                                               X_name = useAssay,
                                               assays = FALSE,
                                               colData = TRUE,
                                               rowData = TRUE,
                                               varm = TRUE,
                                               reducedDims = useReducedDim,
                                               metadata = FALSE,
                                               colPairs = FALSE,
                                               rowPairs = FALSE,
                                               skip_assays = FALSE,
                                               verbose = NULL)
  } else{
    scanpyObject <- zellkonverter::SCE2AnnData(sce = inSCE,
                                               reducedDims = useReducedDim,
                                               assays = FALSE,
                                               colData = TRUE,
                                               rowData = TRUE,
                                               varm = TRUE,
                                               metadata = FALSE,
                                               colPairs = FALSE,
                                               rowPairs = FALSE,
                                               skip_assays = FALSE,
                                               verbose = NULL)
  }
  
  
  if (!is.null(externalReduction)) {
    scanpyObject$obsm <- list(pca = externalReduction)
    useReducedDim <- "pca"
  }
  
  sc$tl$tsne(scanpyObject, 
             n_pcs = as.integer(dims),
             use_rep = useReducedDim, 
             perplexity = as.integer(perplexity))
  
  
  
  temp <- scanpyObject$obsm[['X_tsne']]
  rownames(temp) <- colnames(inSCE)
  reducedDim(inSCE, reducedDimName) <- temp
  metadata(inSCE)$sctk$runDimReduce$reddim[[reducedDimName]] <- params
  
  return(inSCE)
}

#' plotScanpyEmbedding
#' 
#' @param inSCE Input \code{SingleCellExperiment} object.
#' @param reducedDimName Name of reducedDims object containing embeddings.
#' Eg. scanpyUMAP.
#' @param useAssay Specify name of assay to use. Default is \code{NULL},
#' which will use scaled assay by default. 
#' @param color Keys for annotations of observations/cells or variables/genes.
#' @param title Provide title for panels either as string or list of strings
#' @param legend Location of legend, either 'on data', 'right margin' or a 
#' valid keyword for the loc parameter of Legend.
#' @examples
#' data(scExample, package = "singleCellTK")
#' \dontrun{
#' sce <- runScanpyNormalizeData(sce, useAssay = "counts")
#' sce <- runScanpyFindHVG(sce, useAssay = "scanpyNormData", method = "seurat")
#' sce <- runScanpyScaleData(sce, useAssay = "scanpyNormData")
#' sce <- runScanpyPCA(sce, useAssay = "scanpyScaledData")
#' sce <- runScanpyFindClusters(sce, useReducedDim = "scanpyPCA")
#' sce <- runScanpyUMAP(sce, useReducedDim = "scanpyPCA")
#' plotScanpyEmbedding(sce, reducedDimName = "scanpyUMAP", color = 'Scanpy_louvain_1')
#' }
#' @return plot object
#' @export
#' @importFrom reticulate py_module_available py_set_seed import
plotScanpyEmbedding <- function(inSCE,
                                reducedDimName,
                                useAssay = NULL,
                                color = NULL,
                                legend = 'right margin',
                                title = ''){
  
  if (!reticulate::py_module_available(module = "scanpy")) {
    warning("Cannot find python module 'scanpy', please install Conda and",
            " run sctkPythonInstallConda() or run sctkPythonInstallVirtualEnv().",
            "If one of these have been previously run to install the modules,",
            "make sure to run selectSCTKConda() or selectSCTKVirtualEnvironment(),",
            " respectively, if R has been restarted since the module installation.",
            " Alternatively, Scanpy can be installed on the local machine",
            "with pip (e.g. pip install scanpy) and then the 'use_python()'",
            " function from the 'reticulate' package can be used to select the",
            " correct Python environment.")
    return(inSCE)
  }
  
  if(!reducedDimName %in% reducedDimNames(inSCE)){
    stop(
      "Embedding result not found. Please run the 'runScanpyUMAP' or 
      'runScanpyTSNE' first."
    )
  }
  useAssay <- metadata(inSCE)$sctk$runDimReduce$reddim[[reducedDimName]]$useAssay
  if(is.null(useAssay)){
    useAssay <- "scanpyScaledData"
  }
  scanpyObject <- zellkonverter::SCE2AnnData(sce = inSCE,
                                             X_name = useAssay,
                                             assays = FALSE,
                                             colData = TRUE,
                                             rowData = TRUE,
                                             varm = TRUE,
                                             reducedDims = reducedDimName,
                                             metadata = FALSE,
                                             colPairs = FALSE,
                                             rowPairs = FALSE,
                                             skip_assays = FALSE,
                                             verbose = NULL)
  
  return(sc$pl$embedding(scanpyObject,
                         basis = reducedDimName,
                         color = color,
                         legend_loc = legend,
                         title = title))
  
}

###################################################
########## Marker Genes function ###################
###################################################

#' runScanpyFindMarkers
#'
#' @param inSCE Input \code{SingleCellExperiment} object.
#' @param nGenes The number of genes that appear in the returned tables. 
#' Defaults to all genes.
#' @param useAssay Specify the name of the assay to use for computation
#'  of marker genes. It is recommended to use log normalized assay. 
#' @param colDataName colData to use as the key of the observations grouping to 
#' consider.
#' @param group1 Name of group1. Subset of groups, to which comparison shall be 
#' restricted, or 'all' (default), for all groups.
#' @param group2 Name of group2. If 'rest', compare each group to the union of 
#' the rest of the group. If a group identifier, compare with respect to this 
#' group. Default is 'rest'
#' @param test Test to use for DE. Default \code{"t-test"}.
#' @param corr_method p-value correction method. Used only for 't-test', 
#' 't-test_overestim_var', and 'wilcoxon'.
#' @examples
#' data(scExample, package = "singleCellTK")
#' \dontrun{
#' sce <- runScanpyNormalizeData(sce, useAssay = "counts")
#' sce <- runScanpyFindHVG(sce, useAssay = "scanpyNormData", method = "seurat")
#' sce <- runScanpyScaleData(sce, useAssay = "scanpyNormData")
#' sce <- runScanpyPCA(sce, useAssay = "scanpyScaledData")
#' sce <- runScanpyFindClusters(sce, useReducedDim = "scanpyPCA")
#' sce <- runScanpyFindMarkers(sce, colDataName = "Scanpy_louvain_1" )
#' }
#' @return A \code{SingleCellExperiment} object that contains marker genes
#' populated in a data.frame stored inside metadata slot.
#' @export
#' @importFrom reticulate py_module_available py_set_seed import
runScanpyFindMarkers <- function(inSCE,
                                 nGenes = NULL,
                                 useAssay = "scanpyNormData",
                                 colDataName,
                                 group1 = "all",
                                 group2 = "rest",
                                 test = c("wilcoxon", "t-test", "t-test_overestim_var", "logreg"),
                                 corr_method = c("benjamini-hochberg", "bonferroni")) {
  
  if (!reticulate::py_module_available(module = "scanpy")) {
    warning("Cannot find python module 'scanpy', please install Conda and",
            " run sctkPythonInstallConda() or run sctkPythonInstallVirtualEnv().",
            "If one of these have been previously run to install the modules,",
            "make sure to run selectSCTKConda() or selectSCTKVirtualEnvironment(),",
            " respectively, if R has been restarted since the module installation.",
            " Alternatively, Scanpy can be installed on the local machine",
            "with pip (e.g. pip install scanpy) and then the 'use_python()'",
            " function from the 'reticulate' package can be used to select the",
            " correct Python environment.")
    return(inSCE)
  }
  
  test <- match.arg(test)
  corr_method <- match.arg(corr_method)
  
  #store results in a temporary sce object
  tmpSCE <- SingleCellExperiment(
    assays = list(counts = counts(inSCE), temp = as.matrix(assay(inSCE, useAssay))))
  # store back colData from sce into the tmpSCE colData slot
  colData(tmpSCE)[colDataName] <- as.character(colData(inSCE)[[colDataName]])
  rowData(tmpSCE)$id <- rownames(inSCE)
  
  scanpyObject <- zellkonverter::SCE2AnnData(sce = tmpSCE, X_name = "temp")
  if(!is.null(nGenes)){
    nGenes = as.integer(nGenes)
  }
  sc$tl$rank_genes_groups(scanpyObject, 
                          groupby = colDataName, 
                          groups = group1,
                          reference = group2,
                          method = test, 
                          n_genes = nGenes,
                          corr_method = corr_method)
  
  py <- reticulate::py
  py$scanpyObject <- scanpyObject
  reticulate::py_run_string("import pandas as pd")
  reticulate::py_run_string(
    "names = pd.DataFrame(scanpyObject.uns['rank_genes_groups']['names'])", 
    convert = TRUE)
  reticulate::py_run_string(
    "logFoldChanges = pd.DataFrame(scanpyObject.uns['rank_genes_groups']['logfoldchanges'])", 
    convert = TRUE)
  reticulate::py_run_string(
    "pvals_adj = pd.DataFrame(scanpyObject.uns['rank_genes_groups']['pvals_adj'])", 
    convert = TRUE)
  reticulate::py_run_string(
    "scores = pd.DataFrame(scanpyObject.uns['rank_genes_groups']['scores'])",
    convert = TRUE)
  
  markerGenesNames <- utils::stack(py$names)
  colnames(markerGenesNames) <- c("Gene","findMarker_cluster")
  Log2_FC <- unlist(py$logFoldChanges)
  Pvalue <- unlist(py$pvals_adj)
  zscore <- unlist(py$scores)
  
  
  markerGenesTable <- data.frame()
  markerGenesTable <- cbind(markerGenesNames, Log2_FC, Pvalue, zscore)
  
  S4Vectors::metadata(inSCE)$"findMarkerScanpyObject" <- scanpyObject
  S4Vectors::metadata(inSCE)$scanpyMarkersTable <- markerGenesTable
  return(inSCE)
}

#' plotScanpyMarkerGenes
#' 
#' @param inSCE Input \code{SingleCellExperiment} object.
#' @param groups The groups for which to show the gene ranking. Default \code{NULL}
#' means that all groups will be considered. 
#' @param nGenes Number of genes to show. Default \code{10}
#' @param nCols Number of panels shown per row. Default \code{4}
#' @param sharey Controls if the y-axis of each panels should be shared. 
#' Default \code{FALSE} allows each panel to have its own y-axis range.
#' @examples
#' data(scExample, package = "singleCellTK")
#' \dontrun{
#' sce <- runScanpyNormalizeData(sce, useAssay = "counts")
#' sce <- runScanpyFindHVG(sce, useAssay = "scanpyNormData", method = "seurat")
#' sce <- runScanpyScaleData(sce, useAssay = "scanpyNormData")
#' sce <- runScanpyPCA(sce, useAssay = "scanpyScaledData")
#' sce <- runScanpyFindClusters(sce, useReducedDim = "scanpyPCA")
#' sce <- runScanpyFindMarkers(sce, colDataName = "Scanpy_louvain_1" )
#' plotScanpyMarkerGenes(sce, groups = '0')
#' }
#' @return plot object
#' @export
#' @importFrom reticulate py_module_available py_set_seed import
plotScanpyMarkerGenes <- function(inSCE,
                                  groups = NULL,
                                  nGenes = 10,
                                  nCols = 4,
                                  sharey = FALSE){
  
  if (!reticulate::py_module_available(module = "scanpy")) {
    warning("Cannot find python module 'scanpy', please install Conda and",
            " run sctkPythonInstallConda() or run sctkPythonInstallVirtualEnv().",
            "If one of these have been previously run to install the modules,",
            "make sure to run selectSCTKConda() or selectSCTKVirtualEnvironment(),",
            " respectively, if R has been restarted since the module installation.",
            " Alternatively, Scanpy can be installed on the local machine",
            "with pip (e.g. pip install scanpy) and then the 'use_python()'",
            " function from the 'reticulate' package can be used to select the",
            " correct Python environment.")
    return(inSCE)
  }
  
  if(is.null(metadata(inSCE)[["findMarkerScanpyObject"]])){
    stop("Marker genes not found. Please run the 'runScanpyFindMarkers' function first.")
  }
  scanpyObject <- metadata(inSCE)[["findMarkerScanpyObject"]]
  return(sc$pl$rank_genes_groups(scanpyObject, 
                                 groups = groups, 
                                 n_genes = as.integer(nGenes),
                                 ncols = as.integer(nCols), 
                                 sharey = sharey))
  
}

#' plotScanpyMarkerGenesViolin
#' 
#' @param inSCE Input \code{SingleCellExperiment} object.
#' @param groups The groups for which to show the gene ranking. Default \code{NULL}
#' means that all groups will be considered. 
#' @param features List of genes to plot. Is only useful if interested in a 
#' custom gene list
#' @param nGenes Number of genes to show. Default \code{10}
#' @examples
#' data(scExample, package = "singleCellTK")
#' \dontrun{
#' sce <- runScanpyNormalizeData(sce, useAssay = "counts")
#' sce <- runScanpyFindHVG(sce, useAssay = "scanpyNormData", method = "seurat")
#' sce <- runScanpyScaleData(sce, useAssay = "scanpyNormData")
#' sce <- runScanpyPCA(sce, useAssay = "scanpyScaledData")
#' sce <- runScanpyFindClusters(sce, useReducedDim = "scanpyPCA")
#' sce <- runScanpyFindMarkers(sce, colDataName = "Scanpy_louvain_1" )
#' plotScanpyMarkerGenesViolin(sce, groups = '0')
#' }
#' @return plot object
#' @export
#' @importFrom reticulate py_module_available py_set_seed import
plotScanpyMarkerGenesViolin <- function(inSCE,
                                        groups = NULL,
                                        features = NULL,
                                        nGenes = 10){
  
  if (!reticulate::py_module_available(module = "scanpy")) {
    warning("Cannot find python module 'scanpy', please install Conda and",
            " run sctkPythonInstallConda() or run sctkPythonInstallVirtualEnv().",
            "If one of these have been previously run to install the modules,",
            "make sure to run selectSCTKConda() or selectSCTKVirtualEnvironment(),",
            " respectively, if R has been restarted since the module installation.",
            " Alternatively, Scanpy can be installed on the local machine",
            "with pip (e.g. pip install scanpy) and then the 'use_python()'",
            " function from the 'reticulate' package can be used to select the",
            " correct Python environment.")
    return(inSCE)
  }
  
  if(is.null(metadata(inSCE)["findMarkerScanpyObject"])){
    stop("Marker genes not found. Please run the 'runScanpyFindMarkers' function first.")
  }
  scanpyObject <- metadata(inSCE)[["findMarkerScanpyObject"]]
  return(sc$pl$rank_genes_groups_violin(scanpyObject,
                                        groups = groups,
                                        gene_names = features,
                                        n_genes = as.integer(nGenes)))
  
}

#' plotScanpyMarkerGenesHeatmap
#' 
#' @param inSCE Input \code{SingleCellExperiment} object.
#' @param groups The groups for which to show the gene ranking. Default \code{NULL}
#' means that all groups will be considered.
#' @param groupBy The key of the observation grouping to consider. By default, 
#' the groupby is chosen from the rank genes groups parameter.
#' @param nGenes Number of genes to show. Default \code{10}
#' @param features Genes to plot. Sometimes is useful to pass a specific list of
#'  var names (e.g. genes). The var_names could be a dictionary or a list. 
#' @param log2fcThreshold Only output DEGs with the absolute values of log2FC
#' larger than this value. Default \code{NULL}.
#' @examples
#' data(scExample, package = "singleCellTK")
#' \dontrun{
#' sce <- runScanpyNormalizeData(sce, useAssay = "counts")
#' sce <- runScanpyFindHVG(sce, useAssay = "scanpyNormData", method = "seurat")
#' sce <- runScanpyScaleData(sce, useAssay = "scanpyNormData")
#' sce <- runScanpyPCA(sce, useAssay = "scanpyScaledData")
#' sce <- runScanpyFindClusters(sce, useReducedDim = "scanpyPCA")
#' sce <- runScanpyFindMarkers(sce, colDataName = "Scanpy_louvain_1" )
#' plotScanpyMarkerGenesHeatmap(sce, groupBy = 'Scanpy_louvain_1')
#' }
#' @return plot object
#' @export
#' @importFrom reticulate py_module_available py_set_seed import
plotScanpyMarkerGenesHeatmap <- function(inSCE,
                                         groups = NULL,
                                         groupBy,
                                         nGenes = 10,
                                         features = NULL,
                                         log2fcThreshold = NULL){
  
  if (!reticulate::py_module_available(module = "scanpy")) {
    warning("Cannot find python module 'scanpy', please install Conda and",
            " run sctkPythonInstallConda() or run sctkPythonInstallVirtualEnv().",
            "If one of these have been previously run to install the modules,",
            "make sure to run selectSCTKConda() or selectSCTKVirtualEnvironment(),",
            " respectively, if R has been restarted since the module installation.",
            " Alternatively, Scanpy can be installed on the local machine",
            "with pip (e.g. pip install scanpy) and then the 'use_python()'",
            " function from the 'reticulate' package can be used to select the",
            " correct Python environment.")
    return(inSCE)
  }
  
  if(is.null(metadata(inSCE)["findMarkerScanpyObject"])){
    stop("Marker genes not found. Please run the 'runScanpyFindMarkers' function first.")
  }
  scanpyObject <- metadata(inSCE)[["findMarkerScanpyObject"]]
  
  if(!is.null(features)){
    return(sc$pl$rank_genes_groups_heatmap(scanpyObject,
                                           groups = groups,
                                           groupby = groupBy,
                                           var_names = features,
                                           min_logfoldchange = log2fcThreshold,
                                           show_gene_labels = TRUE,
                                           dendrogram = FALSE))
  }
  else
    return(sc$pl$rank_genes_groups_heatmap(scanpyObject,
                                           groups = groups,
                                           groupby = groupBy,
                                           n_genes = as.integer(nGenes),
                                           var_names = NULL,
                                           min_logfoldchange = log2fcThreshold,
                                           show_gene_labels = TRUE,
                                           dendrogram = FALSE))
  
}

#' plotScanpyMarkerGenesDotPlot
#' 
#' @param inSCE Input \code{SingleCellExperiment} object.
#' @param groups The groups for which to show the gene ranking. Default \code{NULL}
#' means that all groups will be considered.
#' @param nGenes Number of genes to show. Default \code{10}
#' @param groupBy The key of the observation grouping to consider. By default, 
#' the groupby is chosen from the rank genes groups parameter.
#' @param log2fcThreshold Only output DEGs with the absolute values of log2FC
#' larger than this value. Default \code{NULL}.
#' @param parameters The options for marker genes results to plot are: 
#' ‘scores’, ‘logfoldchanges’, ‘pvals’, ‘pvals_adj’, ‘log10_pvals’, ‘log10_pvals_adj’.
#' If NULL provided then it uses mean gene value to plot.  
#' @param standardScale Whether or not to standardize the given dimension 
#' between 0 and 1, meaning for each variable or group, subtract the minimum and 
#' divide each by its maximum. Default \code{NULL} means that it doesn't perform
#' any scaling. 
#' @param features Genes to plot. Sometimes is useful to pass a specific list of
#'  var names (e.g. genes) to check their fold changes or p-values, instead of 
#'  the top/bottom genes. The gene names could be a dictionary or a list. 
#'  Default \code{NULL}
#' @param title Provide title for the figure.
#' @param vmin The value representing the lower limit of the color scale. 
#' Values smaller than vmin are plotted with the same color as vmin. 
#' Default \code{NULL}
#' @param vmax The value representing the upper limit of the color scale. 
#' Values larger than vmax are plotted with the same color as vmax. 
#' Default \code{NULL}
#' @param colorBarTitle Title for the color bar. 
#' @examples
#' data(scExample, package = "singleCellTK")
#' \dontrun{
#' sce <- runScanpyNormalizeData(sce, useAssay = "counts")
#' sce <- runScanpyFindHVG(sce, useAssay = "scanpyNormData", method = "seurat")
#' sce <- runScanpyScaleData(sce, useAssay = "scanpyNormData")
#' sce <- runScanpyPCA(sce, useAssay = "scanpyScaledData")
#' sce <- runScanpyFindClusters(sce, useReducedDim = "scanpyPCA")
#' sce <- runScanpyFindMarkers(sce, colDataName = "Scanpy_louvain_1" )
#' plotScanpyMarkerGenesDotPlot(sce, groupBy = 'Scanpy_louvain_1')
#' }
#' @return plot object
#' @export
#' @importFrom reticulate py_module_available py_set_seed import
plotScanpyMarkerGenesDotPlot <- function(inSCE,
                                         groups = NULL,
                                         nGenes = 10, 
                                         groupBy,
                                         log2fcThreshold = NULL,
                                         parameters = "logfoldchanges",
                                         standardScale = NULL,
                                         features = NULL,
                                         title = '',
                                         vmin = NULL,
                                         vmax = NULL,
                                         colorBarTitle = "log fold change"){
  
  if (!reticulate::py_module_available(module = "scanpy")) {
    warning("Cannot find python module 'scanpy', please install Conda and",
            " run sctkPythonInstallConda() or run sctkPythonInstallVirtualEnv().",
            "If one of these have been previously run to install the modules,",
            "make sure to run selectSCTKConda() or selectSCTKVirtualEnvironment(),",
            " respectively, if R has been restarted since the module installation.",
            " Alternatively, Scanpy can be installed on the local machine",
            "with pip (e.g. pip install scanpy) and then the 'use_python()'",
            " function from the 'reticulate' package can be used to select the",
            " correct Python environment.")
    return(inSCE)
  }
  
  if(is.null(metadata(inSCE)["findMarkerScanpyObject"])){
    stop("Marker genes not found. Please run the 'runScanpyFindMarkers' function first.")
  }
  scanpyObject <- metadata(inSCE)[["findMarkerScanpyObject"]]
  
  if(!is.null(features)){
    return(sc$pl$rank_genes_groups_dotplot(scanpyObject,
                                           groups = groups,
                                           groupby = groupBy,
                                           min_logfoldchange = log2fcThreshold,
                                           values_to_plot = parameters,
                                           standard_scale = standardScale,
                                           var_names = features,
                                           title = title,
                                           vmin = vmin,
                                           vmax = vmax,
                                           cmap = 'bwr',
                                           dendrogram = FALSE,
                                           colorbar_title = colorBarTitle))
  }
  else
    return(sc$pl$rank_genes_groups_dotplot(scanpyObject,
                                           groups = groups,
                                           n_genes = as.integer(nGenes),
                                           groupby = groupBy,
                                           min_logfoldchange = log2fcThreshold,
                                           values_to_plot = parameters,
                                           standard_scale = standardScale,
                                           var_names = NULL,
                                           title = title,
                                           vmin = vmin,
                                           vmax = vmax,
                                           cmap = 'bwr',
                                           dendrogram = FALSE,
                                           colorbar_title = colorBarTitle))
  
  
  
}

#' plotScanpyMarkerGenesMatrixPlot
#' 
#' @param inSCE Input \code{SingleCellExperiment} object.
#' @param groups The groups for which to show the gene ranking. Default \code{NULL}
#' means that all groups will be considered.
#' @param nGenes Number of genes to show. Default \code{10}
#' @param groupBy The key of the observation grouping to consider. By default, 
#' the groupby is chosen from the rank genes groups parameter.
#' @param log2fcThreshold Only output DEGs with the absolute values of log2FC
#' larger than this value. Default \code{NULL}.
#' @param parameters The options for marker genes results to plot are: 
#' ‘scores’, ‘logfoldchanges’, ‘pvals’, ‘pvals_adj’, ‘log10_pvals’, ‘log10_pvals_adj’.
#' If NULL provided then it uses mean gene value to plot.  
#' @param standardScale Whether or not to standardize the given dimension 
#' between 0 and 1, meaning for each variable or group, subtract the minimum and 
#' divide each by its maximum. Default \code{NULL} means that it doesn't perform
#' any scaling. 
#' @param features Genes to plot. Sometimes is useful to pass a specific list of
#'  var names (e.g. genes) to check their fold changes or p-values, instead of 
#'  the top/bottom genes. The var_names could be a dictionary or a list. 
#'  Default \code{NULL}
#' @param title Provide title for the figure.
#' @param vmin The value representing the lower limit of the color scale. 
#' Values smaller than vmin are plotted with the same color as vmin. 
#' Default \code{NULL}
#' @param vmax The value representing the upper limit of the color scale. 
#' Values larger than vmax are plotted with the same color as vmax. 
#' Default \code{NULL}
#' @param colorBarTitle Title for the color bar. 
#' @examples
#' data(scExample, package = "singleCellTK")
#' \dontrun{
#' sce <- runScanpyNormalizeData(sce, useAssay = "counts")
#' sce <- runScanpyFindHVG(sce, useAssay = "scanpyNormData", method = "seurat")
#' sce <- runScanpyScaleData(sce, useAssay = "scanpyNormData")
#' sce <- runScanpyPCA(sce, useAssay = "scanpyScaledData")
#' sce <- runScanpyFindClusters(sce, useReducedDim = "scanpyPCA")
#' sce <- runScanpyFindMarkers(sce, colDataName = "Scanpy_louvain_1" )
#' plotScanpyMarkerGenesMatrixPlot(sce, groupBy = 'Scanpy_louvain_1')
#' }
#' @return plot object
#' @export
#' @importFrom reticulate py_module_available py_set_seed import
plotScanpyMarkerGenesMatrixPlot <- function(inSCE,
                                            groups = NULL,
                                            nGenes = 10, 
                                            groupBy,
                                            log2fcThreshold = NULL,
                                            parameters = "logfoldchanges",
                                            standardScale = 'var',
                                            features = NULL,
                                            title = '',
                                            vmin = NULL,
                                            vmax = NULL,
                                            colorBarTitle = "log fold change"){
  
  if (!reticulate::py_module_available(module = "scanpy")) {
    warning("Cannot find python module 'scanpy', please install Conda and",
            " run sctkPythonInstallConda() or run sctkPythonInstallVirtualEnv().",
            "If one of these have been previously run to install the modules,",
            "make sure to run selectSCTKConda() or selectSCTKVirtualEnvironment(),",
            " respectively, if R has been restarted since the module installation.",
            " Alternatively, Scanpy can be installed on the local machine",
            "with pip (e.g. pip install scanpy) and then the 'use_python()'",
            " function from the 'reticulate' package can be used to select the",
            " correct Python environment.")
    return(inSCE)
  }
  
  if(is.null(metadata(inSCE)["findMarkerScanpyObject"])){
    stop("Marker genes not found. Please run the 'runScanpyFindMarkers' function first.")
  }
  scanpyObject <- metadata(inSCE)[["findMarkerScanpyObject"]]
  
  if(!is.null(features)){
    return(sc$pl$rank_genes_groups_matrixplot(scanpyObject,
                                              groups = groups,
                                              groupby = groupBy,
                                              min_logfoldchange = log2fcThreshold,
                                              values_to_plot = parameters,
                                              standard_scale = standardScale,
                                              var_names = features,
                                              title = title,
                                              vmin = vmin,
                                              vmax = vmax,
                                              cmap = 'bwr',
                                              dendrogram = FALSE,
                                              colorbar_title = colorBarTitle))
  }
  else
    return(sc$pl$rank_genes_groups_matrixplot(scanpyObject,
                                              groups = groups,
                                              n_genes = as.integer(nGenes),
                                              groupby = groupBy,
                                              min_logfoldchange = log2fcThreshold,
                                              values_to_plot = parameters,
                                              standard_scale = standardScale,
                                              var_names = NULL,
                                              title = title,
                                              vmin = vmin,
                                              vmax = vmax,
                                              cmap = 'bwr',
                                              dendrogram = FALSE,
                                              colorbar_title = colorBarTitle))
  
  
}



###############################################
####### General plotting functions ############
################################################

#' plotScanpyHeatmap
#' 
#' @param inSCE Input \code{SingleCellExperiment} object.
#' @param useAssay Assay to use for plotting. By default it will use counts
#' assay.
#' @param features Genes to plot. Sometimes is useful to pass a specific list of
#'  var names (e.g. genes). The var_names could be a dictionary or a list. 
#' @param groupBy The key of the observation grouping to consider.
#' @param standardScale Whether or not to standardize the given dimension 
#' between 0 and 1, meaning for each variable or group, subtract the minimum and 
#' divide each by its maximum. Default \code{NULL} means that it doesn't perform
#' any scaling. 
#' @param vmin The value representing the lower limit of the color scale. 
#' Values smaller than vmin are plotted with the same color as vmin.
#' Default \code{NULL}
#' @param vmax The value representing the upper limit of the color scale. 
#' Values larger than vmax are plotted with the same color as vmax. 
#' Default \code{NULL}
#' @examples
#' data(scExample, package = "singleCellTK")
#' \dontrun{
#' sce <- runScanpyNormalizeData(sce, useAssay = "counts")
#' sce <- runScanpyFindHVG(sce, useAssay = "scanpyNormData", method = "seurat")
#' sce <- runScanpyScaleData(sce, useAssay = "scanpyNormData")
#' sce <- runScanpyPCA(sce, useAssay = "scanpyScaledData")
#' sce <- runScanpyFindClusters(sce, useReducedDim = "scanpyPCA")
#' sce <- runScanpyUMAP(sce, useReducedDim = "scanpyPCA")
#' markers <- c("MALAT1" ,"RPS27" ,"CST3")
#' plotScanpyHeatmap(sce, features = markers, groupBy = 'Scanpy_louvain_1')
#' }
#' @return plot object
#' @export
#' @importFrom reticulate py_module_available py_set_seed import
plotScanpyHeatmap <- function(inSCE,
                              useAssay = NULL,
                              features,
                              groupBy,
                              standardScale = 'var',
                              vmin = NULL,
                              vmax = NULL){
  
  if (!reticulate::py_module_available(module = "scanpy")) {
    warning("Cannot find python module 'scanpy', please install Conda and",
            " run sctkPythonInstallConda() or run sctkPythonInstallVirtualEnv().",
            "If one of these have been previously run to install the modules,",
            "make sure to run selectSCTKConda() or selectSCTKVirtualEnvironment(),",
            " respectively, if R has been restarted since the module installation.",
            " Alternatively, Scanpy can be installed on the local machine",
            "with pip (e.g. pip install scanpy) and then the 'use_python()'",
            " function from the 'reticulate' package can be used to select the",
            " correct Python environment.")
    return(inSCE)
  }
  
  scanpyObject <- zellkonverter::SCE2AnnData(sce = inSCE,
                                             X_name = useAssay)
  
  return(sc$pl$heatmap(scanpyObject,
                       var_names = features,
                       groupby = groupBy,
                       standard_scale = standardScale,
                       vmin = vmin,
                       vmax = vmax,
                       show_gene_labels = TRUE,
                       dendrogram = FALSE))
  
}


#' plotScanpyDotPlot
#' 
#' @param inSCE Input \code{SingleCellExperiment} object.
#' @param useAssay Assay to use for plotting. By default it will use counts assay.
#' @param features Genes to plot. Sometimes is useful to pass a specific list of
#'  var names (e.g. genes). The var_names could be a dictionary or a list. 
#' @param groupBy The key of the observation grouping to consider.
#' @param standardScale Whether or not to standardize the given dimension 
#' between 0 and 1, meaning for each variable or group, subtract the minimum and 
#' divide each by its maximum. Default \code{NULL} means that it doesn't perform
#' any scaling. 
#' @param title Provide title for the figure.
#' @param vmin The value representing the lower limit of the color scale. 
#' Values smaller than vmin are plotted with the same color as vmin.
#' Default \code{NULL}
#' @param vmax The value representing the upper limit of the color scale. 
#' Values larger than vmax are plotted with the same color as vmax. 
#' Default \code{NULL}
#' @param title Provide title for the figure.
#' @param vmin The value representing the lower limit of the color scale. 
#' Values smaller than vmin are plotted with the same color as vmin. 
#' Default \code{NULL}
#' @param vmax The value representing the upper limit of the color scale. 
#' Values larger than vmax are plotted with the same color as vmax. 
#' Default \code{NULL}
#' @param colorBarTitle Title for the color bar. 
#' @examples
#' data(scExample, package = "singleCellTK")
#' \dontrun{
#' sce <- runScanpyNormalizeData(sce, useAssay = "counts")
#' sce <- runScanpyFindHVG(sce, useAssay = "scanpyNormData", method = "seurat")
#' sce <- runScanpyScaleData(sce, useAssay = "scanpyNormData")
#' sce <- runScanpyPCA(sce, useAssay = "scanpyScaledData")
#' sce <- runScanpyFindClusters(sce, useReducedDim = "scanpyPCA")
#' sce <- runScanpyUMAP(sce, useReducedDim = "scanpyPCA")
#' markers <- c("MALAT1" ,"RPS27" ,"CST3")
#' plotScanpyDotPlot(sce, features = markers, groupBy = 'Scanpy_louvain_1')
#' }
#' @return plot object
#' @export
#' @importFrom reticulate py_module_available py_set_seed import
plotScanpyDotPlot <- function(inSCE,
                              useAssay = NULL,
                              features,
                              groupBy,
                              standardScale = NULL,
                              title = '',
                              vmin = NULL,
                              vmax = NULL,
                              colorBarTitle = "Mean expression in group"){
  
  if (!reticulate::py_module_available(module = "scanpy")) {
    warning("Cannot find python module 'scanpy', please install Conda and",
            " run sctkPythonInstallConda() or run sctkPythonInstallVirtualEnv().",
            "If one of these have been previously run to install the modules,",
            "make sure to run selectSCTKConda() or selectSCTKVirtualEnvironment(),",
            " respectively, if R has been restarted since the module installation.",
            " Alternatively, Scanpy can be installed on the local machine",
            "with pip (e.g. pip install scanpy) and then the 'use_python()'",
            " function from the 'reticulate' package can be used to select the",
            " correct Python environment.")
    return(inSCE)
  }
  
  scanpyObject <- zellkonverter::SCE2AnnData(sce = inSCE,
                                             X_name = useAssay)
  
  return(sc$pl$dotplot(scanpyObject,
                       var_names = features,
                       groupby = groupBy,
                       standard_scale = standardScale,
                       title = title,
                       vmin = vmin,
                       vmax = vmax,
                       cmap = 'bwr',
                       dendrogram = FALSE,
                       colorbar_title = colorBarTitle))
  
  
}

#' plotScanpyMatrixPlot
#' 
#' @param inSCE Input \code{SingleCellExperiment} object.
#' @param useAssay Assay to use for plotting. By default it will use counts assay.
#' @param features Genes to plot. Sometimes is useful to pass a specific list of
#'  var names (e.g. genes). The var_names could be a dictionary or a list. 
#' @param groupBy The key of the observation grouping to consider.
#' @param standardScale Whether or not to standardize the given dimension 
#' between 0 and 1, meaning for each variable or group, subtract the minimum and 
#' divide each by its maximum. Default \code{NULL} means that it doesn't perform
#' any scaling. 
#' @param title Provide title for the figure.
#' @param vmin The value representing the lower limit of the color scale. 
#' Values smaller than vmin are plotted with the same color as vmin.
#' Default \code{NULL}
#' @param vmax The value representing the upper limit of the color scale. 
#' Values larger than vmax are plotted with the same color as vmax. 
#' Default \code{NULL}
#' @param title Provide title for the figure.
#' @param vmin The value representing the lower limit of the color scale. 
#' Values smaller than vmin are plotted with the same color as vmin. 
#' Default \code{NULL}
#' @param vmax The value representing the upper limit of the color scale. 
#' Values larger than vmax are plotted with the same color as vmax. 
#' Default \code{NULL}
#' @param colorBarTitle Title for the color bar. 
#' @examples
#' data(scExample, package = "singleCellTK")
#' \dontrun{
#' sce <- runScanpyNormalizeData(sce, useAssay = "counts")
#' sce <- runScanpyFindHVG(sce, useAssay = "scanpyNormData", method = "seurat")
#' sce <- runScanpyScaleData(sce, useAssay = "scanpyNormData")
#' sce <- runScanpyPCA(sce, useAssay = "scanpyScaledData")
#' sce <- runScanpyFindClusters(sce, useReducedDim = "scanpyPCA")
#' sce <- runScanpyUMAP(sce, useReducedDim = "scanpyPCA")
#' markers <- c("MALAT1" ,"RPS27" ,"CST3")
#' plotScanpyMatrixPlot(sce, features = markers, groupBy = 'Scanpy_louvain_1')
#' }
#' @return plot object
#' @export
#' @importFrom reticulate py_module_available py_set_seed import
plotScanpyMatrixPlot <- function(inSCE,
                              useAssay = NULL,
                              features,
                              groupBy,
                              standardScale = NULL,
                              title = '',
                              vmin = NULL,
                              vmax = NULL,
                              colorBarTitle = "Mean expression in group"){
  
  if (!reticulate::py_module_available(module = "scanpy")) {
    warning("Cannot find python module 'scanpy', please install Conda and",
            " run sctkPythonInstallConda() or run sctkPythonInstallVirtualEnv().",
            "If one of these have been previously run to install the modules,",
            "make sure to run selectSCTKConda() or selectSCTKVirtualEnvironment(),",
            " respectively, if R has been restarted since the module installation.",
            " Alternatively, Scanpy can be installed on the local machine",
            "with pip (e.g. pip install scanpy) and then the 'use_python()'",
            " function from the 'reticulate' package can be used to select the",
            " correct Python environment.")
    return(inSCE)
  }
  
  scanpyObject <- zellkonverter::SCE2AnnData(sce = inSCE,
                                             X_name = useAssay)
  
  return(sc$pl$matrixplot(scanpyObject,
                       var_names = features,
                       groupby = groupBy,
                       standard_scale = standardScale,
                       title = title,
                       vmin = vmin,
                       vmax = vmax,
                       cmap = 'bwr',
                       dendrogram = FALSE,
                       colorbar_title = colorBarTitle))
  
  
}


#' plotScanpyViolin
#' 
#' @param inSCE Input \code{SingleCellExperiment} object.
#' @param useAssay Assay to use for plotting. By default it will use counts
#' assay.
#' @param features Genes to plot. Sometimes is useful to pass a specific list of
#'  var names (e.g. genes). The var_names could be a dictionary or a list. 
#' @param groupBy The key of the observation grouping to consider.
#' @param xlabel Label of the x axis. Defaults to groupBy.
#' @param ylabel Label of the y axis. If NULL and groupBy is NULL, 
#' defaults to 'value'. If NULL and groupBy is not NULL, defaults to features.
#' @examples
#' data(scExample, package = "singleCellTK")
#' \dontrun{
#' sce <- runScanpyNormalizeData(sce, useAssay = "counts")
#' sce <- runScanpyFindHVG(sce, useAssay = "scanpyNormData", method = "seurat")
#' sce <- runScanpyScaleData(sce, useAssay = "scanpyNormData")
#' sce <- runScanpyPCA(sce, useAssay = "scanpyScaledData")
#' sce <- runScanpyFindClusters(sce, useReducedDim = "scanpyPCA")
#' sce <- runScanpyUMAP(sce, useReducedDim = "scanpyPCA")
#' markers <- c("MALAT1" ,"RPS27" ,"CST3")
#' plotScanpyViolin(sce, features = markers, groupBy = "Scanpy_louvain_1")
#' }
#' @return plot object
#' @export
#' @importFrom reticulate py_module_available py_set_seed import
plotScanpyViolin <- function(inSCE,
                             useAssay = NULL,
                             features,
                             groupBy, 
                             xlabel = '', 
                             ylabel = NULL){
  
  if (!reticulate::py_module_available(module = "scanpy")) {
    warning("Cannot find python module 'scanpy', please install Conda and",
            " run sctkPythonInstallConda() or run sctkPythonInstallVirtualEnv().",
            "If one of these have been previously run to install the modules,",
            "make sure to run selectSCTKConda() or selectSCTKVirtualEnvironment(),",
            " respectively, if R has been restarted since the module installation.",
            " Alternatively, Scanpy can be installed on the local machine",
            "with pip (e.g. pip install scanpy) and then the 'use_python()'",
            " function from the 'reticulate' package can be used to select the",
            " correct Python environment.")
    return(inSCE)
  }
  
  scanpyObject <- zellkonverter::SCE2AnnData(sce = inSCE,
                                             X_name = useAssay)
  
  return(sc$pl$violin(scanpyObject,
                      keys = features,
                      groupby = groupBy,
                      xlabel = xlabel,
                      ylabel = ylabel))
  
}

source("ui_02_qc.R", local = TRUE) #creates shinyPanelQC variable
source("ui_02_filter.R", local = TRUE) #creates shinyPanelFilter variable

shinyPanelQCFilter <- fluidPage(
  includeCSS('styles.CSS'),
  h1("Data QC & Filtering"),
  tabsetPanel(id = "QCFilterTabsetPanel",
    tabPanel("QC", shinyPanelQC),
    tabPanel("Filtering", shinyPanelFilter)
  ),
  nonLinearWorkflowUI(id = "nlw-qcf")
)

#' @title Wrapper for calculating QC metrics with scater.
#' @description A wrapper function for \link[scater]{addPerCellQC}. Calculate
#' general quality control metrics for each cell in the count matrix.
#' @param inSCE A \linkS4class{SingleCellExperiment} object.
#' @param useAssay A string specifying which assay in the SCE to use. Default
#' \code{"counts"}.
#' @param mitoRef Character. The species used to extract mitochondrial genes ID 
#' from build-in mitochondrial geneset in SCTK. Available species options are 
#' \code{"human"} and \code{"mouse"}. Default is \code{"human"}. 
#' @param mitoIDType Character. Types of mitochondrial gene id. SCTK supports 
#' \code{"symbol"}, \code{"entrez"}, \code{"ensembl"} and 
#' \code{"ensemblTranscriptID"}. It is used with \code{mitoRef} to extract 
#' mitochondrial genes from build-in mitochondrial geneset in SCTK. Default 
#' \code{NULL}. 
#' @param mitoGeneLocation Character. Describes the location within \code{inSCE}
#' where the gene identifiers in the mitochondrial gene sets should be located.
#' If set to \code{"rownames"} then the features will be searched for among 
#' \code{rownames(inSCE)}. This can also be set to one of the column names of 
#' \code{rowData(inSCE)} in which case the gene identifies will be mapped to 
#' that column in the \code{rowData} of \code{inSCE}. See 
#' \code{\link{featureIndex}} for more information. If this parameter is set to
#' \code{NULL}, then no mitochondrial metrics will be calculated.
#' Default \code{"rownames"}.
#' @param mitoPrefix Character. The prefix used to get mitochondrial gene from 
#' either \code{rownames(inSCE)} or columns of \code{rowData(inSCE)} specified 
#' by \code{mitoGeneLocation}. This parameter is usually used to extract mitochondrial 
#' genes from the gene symbol. For example, \code{mitoPrefix = "^MT-"} can be used 
#' to detect mito gene symbols like "MT-ND4". Note that case is ignored so "mt-"
#' will still match "MT-ND4". Default \code{"^MT-"}.
#' @param mitoID Character. A vector of mitochondrial genes to be quantified.  
#' @param collectionName Character. Name of a \code{GeneSetCollection} obtained
#' by using one of the \code{importGeneSet*} functions. Default \code{NULL}.
#' @param geneSetList List of gene sets to be quantified. The genes in the
#' assays will be matched to the genes in the list based on
#' \code{geneSetListLocation}. Default \code{NULL}.
#' @param geneSetListLocation Character or numeric vector. If set to 
#' \code{'rownames'}, then the genes in \code{geneSetList} will be looked up in 
#' \code{rownames(inSCE)}. If another character is supplied, then genes will be 
#' looked up in the column names of \code{rowData(inSCE)}. A character vector 
#' with the same length as \code{geneSetList} can be supplied if the IDs for 
#' different gene sets are found in different places, including a mixture of 
#' \code{'rownames'} and \code{rowData(inSCE)}. An integer or integer vector can
#' be supplied to denote the column index in \code{rowData(inSCE)}. Default 
#' \code{'rownames'}.
#' @param geneSetCollection Class of \code{GeneSetCollection} from package
#' GSEABase. The location of the gene IDs in \code{inSCE} should be in the
#' \code{description} slot of each gene set and should follow the
#' same notation as \code{geneSetListLocation}. The function 
#' \code{\link[GSEABase]{getGmt}} can be used to read in gene sets from a GMT 
#' file. If reading a GMT file, the second column for each gene set should be 
#' the description denoting the location of the gene IDs in \code{inSCE}. These 
#' gene sets will be included with those from \code{geneSetList} if both 
#' parameters are provided.
#' @param percent_top An integer vector. Each element is treated as a number of
#' top genes to compute the percentage of library size occupied by the most 
#' highly expressed genes in each cell. Default \code{c(50, 100, 200, 500)}.
#' @param use_altexps Logical scalar indicating whether QC statistics should
#' be computed for alternative Experiments in \code{inSCE} 
#' (\code{altExps(inSCE)}). If \code{TRUE}, statistics are computed for all 
#' alternative experiments. Alternatively, an integer or character vector 
#' specifying the alternative Experiments to use to compute QC statistics. 
#' Alternatively \code{NULL}, in which case alternative experiments are not 
#' used. Default \code{FALSE}.
#' @param flatten Logical scalar indicating whether the nested
#' \link[S4Vectors]{DataFrame-class} in the output should be flattened. Default 
#' \code{TRUE}.
#' @param detectionLimit A numeric scalar specifying the lower detection limit
#' for expression. Default \code{0}
#' @param BPPARAM A \link{BiocParallelParam} object specifying whether the QC
#' calculations should be parallelized. Default 
#' \code{BiocParallel::SerialParam()}.
#' @details 
#' This function allows multiple ways to import mitochondrial genes and quantify 
#' their expression in cells. \code{mitoGeneLocation} is required for all
#' methods to point to the location within inSCE object that stores the
#' mitochondrial gene IDs or Symbols. The various ways mito genes can be 
#' specified are:

#' \itemize{
#'   \item A combination of \code{mitoRef} and \code{mitoIDType} 
#'   parameters can be used to load pre-built mitochondrial gene sets stored
#'   in the SCTK package. These parameters are used in the
#'   \link{importMitoGeneSet} function.
#'   \item The \code{mitoPrefix} parameter can be used to search for features
#'   matching a particular pattern. The default pattern is an "MT-" 
#'   at the beginning of the ID.
#'   \item The \code{mitoID} parameter can be used to directy supply a vector of 
#'   mitochondrial gene IDs or names. Only features that exactly match items
#'   in this vector will be included in the mitochondrial gene set. 
#' }
#' @return A \link[SingleCellExperiment]{SingleCellExperiment} object with
#' cell QC metrics added to the \link{colData} slot. 
#' @seealso \code{\link[scater]{addPerCellQC}}, 
#' \code{link{plotRunPerCellQCResults}}, \code{\link{runCellQC}}
#' @examples
#' data(scExample, package = "singleCellTK")
#' mito.ix = grep("^MT-", rowData(sce)$feature_name)
#' geneSet <- list("Mito"=rownames(sce)[mito.ix])
#' sce <- runPerCellQC(sce, geneSetList = geneSet)
#' @export
#' @importFrom SummarizedExperiment rowData colData
#' @importFrom S4Vectors metadata metadata<-
runPerCellQC <- function(inSCE,
                         useAssay = "counts",
                         mitoGeneLocation = "rownames",                         
                         mitoRef = c(NULL, "human", "mouse"),
                         mitoIDType = c("ensembl", "symbol", "entrez", "ensemblTranscriptID"),
                         mitoPrefix = "MT-",
                         mitoID = NULL,
                         collectionName = NULL,
                         geneSetList = NULL,
                         geneSetListLocation = "rownames",
                         geneSetCollection = NULL,
                         percent_top = c(50, 100, 200, 500),
                         use_altexps = FALSE,
                         flatten = TRUE,
                         detectionLimit = 0,
                         BPPARAM = BiocParallel::SerialParam()
) {

  p <- paste0(date(), " ... Running 'perCellQCMetrics'")
  message(p)
  argsList <- mget(names(formals()),sys.frame(sys.nframe()))
  mitoRef <- match.arg(mitoRef)
  mitoIDType <- match.arg(mitoIDType)
  
  ## Add mito gene collection from built-in mito gene sets in SCTK package
  if (!is.null(mitoGeneLocation) && mitoGeneLocation == "rownames") {
    features <- rownames(inSCE)
  } else if (mitoGeneLocation %in% names(rowData(inSCE))) {
    features <- rowData(inSCE)[[mitoGeneLocation]]
  } else {
    stop("'mitoGeneLocation' needs to be set to 'rownames' or a column name of 'rowData(inSCE)'")
  }
  
  if(!is.null(mitoGeneLocation)) {
    mitoGS <- NULL
    
    # Getting rid of any previous gene sets with the same name
    metadata(inSCE)$sctk$genesets$mito <- NULL

    ## Add mito genes specified in mitoID
    if (!is.null(mitoID)) {
      message(date(), " ...... Attempting to find mitochondiral by identifing features in '", mitoGeneLocation, "' that match those given in `mitoID`.")
      inSCE <- importGeneSetsFromList(inSCE, geneSetList = list(mito=mitoID), 
                                      collectionName = "mito", 
                                      by = mitoGeneLocation,
                                      noMatchError = FALSE)
      mitoGS <- metadata(inSCE)$sctk$genesets$mito[[1]]
    }
    
    if (!is.null(mitoRef) & !is.null(mitoIDType) & is.null(mitoGS)) {
      message(date(), " ...... Attempting to find mitochondrial genes by identifying features in '", mitoGeneLocation, 
      "' that match mitochondrial genes from reference '", mitoRef, "' and ID type '", mitoIDType, "'.")
      
      inSCE <- importMitoGeneSet(inSCE, reference = mitoRef, id = mitoIDType, 
                                 by = mitoGeneLocation, collectionName = "mito",
                                 noMatchError = FALSE)
      mitoGS <- metadata(inSCE)$sctk$genesets$mito[[1]]
    }

    ## Add mito genes by greping mitoPrefix from the mitoGeneLocation
    if (!is.null(mitoPrefix) & is.null(mitoGS)) {
      message(date(), " ...... Attempting to find mitochondrial genes by identifying features in '", mitoGeneLocation, "' starting with '", mitoPrefix, "'")
      mitoG <- grep(paste0("^", mitoPrefix), features, value = TRUE, ignore.case = TRUE)
      
      if(length(mitoG) > 0) {
        inSCE <- importGeneSetsFromList(inSCE, list(mito=mitoG), 
                                        by = mitoGeneLocation, collectionName = "mito",
                                        noMatchError = FALSE)
        mitoGS <- metadata(inSCE)$sctk$genesets$mito[[1]]
      }
    }

    # Creating a new gene set collection from mitoGS and any other user supplied geneSetCollections
    if (is.null(mitoGS)) {
      message(date(), " ...... No mitochondrial genes found. Skipping quantification of mitochondrial metrics.")      
    } else {
      if (!is.null(geneSetCollection)) {
        geneSetCollection <- GSEABase::GeneSetCollection(
          c(mitoGS, unlist(geneSetCollection))
        )
      } else {
        geneSetCollection <- GSEABase::GeneSetCollection(mitoGS)
      }    
    }
  }

  ## Add GeneSetColletion that has been previously imported
  if(!is.null(collectionName)) {
    gsc <- .retrieveGeneSetCollection(inSCE = inSCE,
                                      collectionName = collectionName)
    geneSetList <- c(geneSetList, GSEABase::geneIds(gsc))
  }

  ## Add gene sets in 'geneSetCollection' to 'geneSetList', if available
  original.length <- length(geneSetList)
  geneSetCollectionLocation <- c()
  if(!is.null(geneSetCollection)) {

    ## Get the location where the gene set Ids are stored in SCE object
    geneSetCollectionLocation <- vapply(geneSetCollection, 
                                        GSEABase::description,
                                        FUN.VALUE = character(1))
    #character(length(names(geneSetCollection)))

    ## If blank/null/NA, then set to rownames by default
    ix <- geneSetCollectionLocation == "" ||
      is.na(geneSetCollectionLocation) ||
      is.null(geneSetCollectionLocation)
    geneSetCollectionLocation[ix] <- "rownames"

    ## Add gene sets to geneSetList
    geneSetList <- c(geneSetList, GSEABase::geneIds(geneSetCollection))
  }

  ## Set up locations for all lists
  if(length(geneSetListLocation) == 1) {
    locations <- c(rep(geneSetListLocation, original.length),
                   geneSetCollectionLocation)
  } else if(length(geneSetListLocation) == original.length) {
    locations <- c(geneSetListLocation, geneSetCollectionLocation)
  } else {
    stop("'geneSetListLocation' needs to be of length 1 and will be used for ",
         "all gene sets in 'geneSetList' or needs to be the length of ",
         "'geneSetList'.")
  }

  ## Process gene sets in the list
  geneSets <- list()
  if(!is.null(geneSetList)) {

    if(is.null(names(geneSetList))) {
      names(geneSetList) <- paste0("GeneSet_", seq_along(geneSetList))
    }

    for(i in seq_along(geneSetList)) {
      if(locations[i] == "rownames") {
        ## IDs located in rownames
        gs.i <- intersect(geneSetList[[i]], rownames(inSCE))
        gs.diff <- setdiff(geneSetList[[i]], rownames(inSCE))

        if(length(gs.i) > 0) {
          gs.index <- which(rownames(inSCE) %in% gs.i)
          geneSets[[names(geneSetList)[i]]] <- rownames(inSCE)[gs.index]
        } else {
          warning("No features for '", names(geneSetList)[i], 
                  "' were found in 'rownames(inSCE)'. Excluding this gene set.")
        }

        if(length(gs.diff) > 0 & length(gs.i) > 0) {
          warning("Some features were not found in 'rownames(inSCE)' for ", 
                  "gene set '", names(geneSetList)[i], "': ",
                  paste(gs.diff, collapse=","))
        }

      } else {
        ## If IDs located in rowData
        ## Check for existence of location in rowData(inSCE)
        if(any(locations[i] == seq(ncol(rowData(inSCE))))) {
          temp.location <- as.numeric(locations[i])
        } else if (any(locations[i] == colnames(rowData(inSCE)))) {
          temp.location <- as.character(locations[i])
        } else {
          stop("'", locations[i], "' was not found in the column names of ", 
               "'rowData(inSCE).'")
        }

        gs.i <- intersect(geneSetList[[i]], rowData(inSCE)[,temp.location])
        gs.diff <- setdiff(geneSetList[[i]], rowData(inSCE)[,temp.location])

        if(length(gs.i) > 0) {
          gs.index <- which(rowData(inSCE)[,temp.location] %in% gs.i)
          geneSets[[names(geneSetList)[i]]] <- rownames(inSCE)[gs.index]
        } else {
          p <- paste0("No features for gene set '", names(geneSetList)[i],
                      "' were found in 'rowData(inSCE)' under column '",
                      temp.location, "'. Excluding this gene set.", sep="")
          warning(p)
        }

        if(length(gs.diff) > 0 & length(gs.i) > 0) {
          warning(paste0("Some features were not found in 'rowData(inSCE)' ", 
                         "under column '", temp.location, " 'for gene set '",
                         names(geneSetList)[i], "': ",
                         paste(gs.diff, collapse=","), sep=""))
        }
      }
    }
  }

  if(length(geneSets) == 0) {
    geneSets <- NULL
  }
  
  colData(inSCE)$sum <- NULL
  colData(inSCE)$detected <- NULL
  colData(inSCE)$percent.top_50 <- NULL
  colData(inSCE)$percent.top_100 <- NULL
  colData(inSCE)$percent.top_200 <- NULL
  colData(inSCE)$percent.top_500 <- NULL
  colData(inSCE)$total <- NULL
    
  inSCE <- scater::addPerCellQC(x = inSCE,
                                exprs_values = useAssay,
                                subsets = geneSets,
                                percent_top = percent_top,
                                use_altexps = use_altexps,
                                flatten = flatten,
                                detection_limit = detectionLimit,
                                BPPARAM = BPPARAM)

  ## rename mito gene columns in colData(inSCE)
  names(colData(inSCE)) <- gsub('subsets_mito', 'mito', names(colData(inSCE)))

  argsList <- argsList[!names(argsList) %in% ("BPPARAM")]
  metadata(inSCE)$sctk$runPerCellQC$all_cells <- argsList[-1]
  metadata(inSCE)$sctk$runPerCellQC$all_cells$packageVersion <- 
    utils::packageDescription("scran")$Version

  if(is.null(geneSets)){
    geneSets <- as.character(geneSets)
  }
  metadata(inSCE)$sctk$runPerCellQC$all_cells$geneSets <- geneSets

  return(inSCE)
}

#' Compute Z-Score
#'
#' Computes Z-Score from an input count matrix using the formula
#' ((x-mean(x))/sd(x)) for each gene across all cells. The input count matrix
#' can either be a base matrix, dgCMatrix or a DelayedMatrix. Computations are
#' performed using DelayedMatrixStats package to efficiently compute the
#' Z-Score matrix.
#' @param counts matrix (base matrix, dgCMatrix or DelayedMatrix)
#' @return z-score computed counts matrix (DelayedMatrix)
#' @export
#' @examples
#' data(sce_chcl, package = "scds")
#' assay(sce_chcl, "countsZScore") <- computeZScore(assay(sce_chcl, "counts"))
computeZScore <- function(counts) {
    if (!methods::is(counts, "DelayedArray")) {
        counts <- DelayedArray::DelayedArray(counts)
    }
    counts <- (counts - DelayedMatrixStats::rowMeans2(counts)) / DelayedMatrixStats::rowSds(counts)
    counts[base::is.nan(counts)] <- 0
    return(counts)
}

# computeZScore.R
library(singleCellTK)
context("Testing computeZScore.R")
data(scExample, package = "singleCellTK")

test_that(desc = "Testing computeZScore.R", {
  scaledMatrix <- computeZScore(assay(sce, "counts"))
  
  testthat::expect_equal(nrow(scaledMatrix), nrow(sce))
  testthat::expect_equal(ncol(scaledMatrix), ncol(sce))
})

## Code taken from:
## https://rstudio.github.io/reticulate/articles/package.html
## Meant to delay loading of python environmnet so user can set the python environment

# python modules to use
scrublet <- NULL
scipy <- NULL
sparse <- NULL
numpy <- NULL
scnrm <- NULL
sc <- NULL
bbknn <- NULL
pkg_resources <- NULL
ad <- NULL

.onLoad <- function(libname, pkgname) {
  # use superassignment to update global reference to scipy
  scrublet <<- reticulate::import("scrublet", delay_load = TRUE)
  scipy <<- reticulate::import("scipy", delay_load = TRUE)
  sparse <<- reticulate::import("scipy.sparse", delay_load = TRUE)
  numpy <<- reticulate::import("numpy", delay_load = TRUE)
  scnrm <<- reticulate::import("scanorama", delay_load = TRUE)
  sc <<- reticulate::import("scanpy", delay_load = TRUE)
  bbknn <<- reticulate::import("bbknn", delay_load = TRUE)
  pkg_resources <<- reticulate::import('pkg_resources',delay_load = TRUE)
  ad <<- reticulate::import('anndata',delay_load = TRUE,convert = FALSE)
}

#' @name sctkPythonInstallConda
#' @title Installs Python packages into a Conda environment
#' @description Install all Python packages used in the \code{\link{singleCellTK}} package
#' using \code{\link{conda_install}} from package \code{\link{reticulate}}. This
#' will create a new Conda environment with the name \code{envname} if not already present.
#' Note that Anaconda or Miniconda already need to be installed on the local system.
#' @param envname Character. Name of the conda environment to create.
#' @param conda Character. Path to conda executable. Usue "auto" to find conda using the PATH and other conventional install locations. Default 'auto'.
#' @param packages Character Vector. List of packages to install from Conda.
#' @param pipPackages Character Vector. List of packages to install into the Conda environment using 'pip'.
#' @param selectConda Boolean. Run \code{\link[singleCellTK]{selectSCTKConda}} after installing all packages to select the Conda environment. Default TRUE.
#' @param forge Boolean. Include the Conda Forge repository.
#' @param pipIgnoreInstalled Boolean. Ignore installed versions when using pip. This is TRUE by default so that specific package versions can be installed even if they are downgrades.
#'        The FALSE option is useful for situations where you don't want a pip install to attempt an overwrite of a conda binary package (e.g. SciPy on Windows which is very difficult
#'        to install via pip due to compilation requirements).
#' @param pythonVersion Passed to \code{python_version} variable in \code{\link{conda_install}}. Default NULL.
#' @param ... Other parameters to pass to \code{\link{conda_install}}.
#' @return None. Installation of Conda environment.
#' @examples
#' \dontrun{
#' sctkPythonInstallConda(envname = "sctk-reticulate")
#' }
#' @seealso See \code{\link{conda_create}} for more information on creating a Conda environment.
#' See \code{\link{conda_install}} for more description of the installation parameters.
#' See \url{https://rstudio.github.io/reticulate/} for more information on package \code{\link{reticulate}}.
#' See \code{\link[singleCellTK]{selectSCTKConda}} for reloading the Conda environment if R is restarted without
#' going through the whole installation process again.
#' See \url{https://docs.conda.io/en/latest/} for more information on Conda environments.
#' @export
sctkPythonInstallConda <- function(envname = "sctk-reticulate",
                                   conda = "auto",
                                   packages = c("scipy", "numpy", "astroid", "six"),
                                   pipPackages = c("scrublet", "scanpy", "louvain", "leidenalg", "bbknn", "scanorama", "anndata"),
                                   selectConda = TRUE,
                                   forge = FALSE,
                                   pipIgnoreInstalled = TRUE,
                                   pythonVersion = NULL,
                                   ...) {

  path <- reticulate::conda_create(envname = envname, packages = "python", conda = conda)

  for(i in packages) {
    reticulate::conda_install(envname = envname, packages = i, conda = conda,
                  pip = FALSE, pip_ignore_installed = pipIgnoreInstalled,
                  python_version = pythonVersion, ...)
  }

  reticulate::conda_install(envname = envname, packages = pipPackages,
                pip = TRUE, pip_ignore_installed = pipIgnoreInstalled,
                python_version = pythonVersion, ...)

  if(isTRUE(selectConda)) selectSCTKConda(envname = envname)

  invisible(path)
}



#' @name sctkPythonInstallVirtualEnv
#' @title Installs Python packages into a virtual environment
#' @description Install all Python packages used in the \code{\link{singleCellTK}} package
#' using \code{\link{virtualenv_install}} from package \code{\link{reticulate}}. This
#' will create a new virtual environment with the name \code{envname} if not already present.
#' @param envname Character. Name of the virtual environment to create.
#' @param packages Character Vector. List of packages to install.
#' @param selectEnvironment Boolean. Run \code{\link[singleCellTK]{selectSCTKVirtualEnvironment}} after installing all packages to select the virtual environment. Default TRUE.
#' @param python The path to a Python interpreter, to be used with the created virtual environment. When NULL, the Python interpreter associated with the current session will be used. Default NULL.
#' @return None. Installation of virtual environment.
#' @examples
#' \dontrun{
#' sctkPythonInstallVirtualEnv(envname = "sctk-reticulate")
#' }
#' @seealso See \code{\link{virtualenv_create}} for more information on creating a Conda environment.
#' See \code{\link{virtualenv_install}} for more description of the installation parameters.
#' See \url{https://rstudio.github.io/reticulate/} for more information on package \code{\link{reticulate}}.
#' See \code{\link[singleCellTK]{selectSCTKVirtualEnvironment}} for reloading the virtual environment if R is restarted without
#' going through the whole installation process again.
#' @export
sctkPythonInstallVirtualEnv <- function(envname = "sctk-reticulate",
                                        packages = c("scipy", "numpy", "astroid", "six", "scrublet", "scanpy", "louvain", "leidenalg", "scanorama", "bbknn", "anndata"),
                                        selectEnvironment = TRUE,
                                        python = NULL) {

  path <- reticulate::virtualenv_create(envname = envname, python = python)

  for(i in packages) {
    reticulate::virtualenv_install(envname = envname, packages = i, ignore_installed = TRUE)
  }

  if(isTRUE(selectEnvironment)) selectSCTKVirtualEnvironment(envname = envname)

  invisible(path)
}


#' @name selectSCTKConda
#' @title Selects a Conda environment
#' @description Selects a Conda environment with Python packages used in \code{\link{singleCellTK}}.
#' @param envname Character. Name of the conda environment to activate.
#' @return None. Selects Conda environment.
#' @examples
#' \dontrun{
#' sctkPythonInstallConda(envname = "sctk-reticulate", selectConda = FALSE)
#' selectSCTKConda(envname = "sctk-reticulate")
#' }
#' @seealso \code{\link[reticulate]{conda-tools}} for more information on using Conda environments with package \code{\link{reticulate}}.
#' See \url{https://rstudio.github.io/reticulate/} for more information on package \code{\link{reticulate}}.
#' @export
#' @seealso See \code{\link[singleCellTK]{sctkPythonInstallConda}} for installation of Python modules into a Conda environment.
#' See\code{\link[reticulate]{conda-tools}} for more information on using Conda environments with package \code{\link{reticulate}}.
#' See \url{https://rstudio.github.io/reticulate/} for more information on package \code{\link{reticulate}}.
#' See \url{https://docs.conda.io/en/latest/} for more information on Conda environments.
selectSCTKConda <- function(envname = "sctk-reticulate") {
  condaList <- reticulate::conda_list()
  ix <- condaList$name == envname

  if(!any(ix)) {
    p <- paste0("Environment '", envname, "', not found. Run sctkPythonInstallConda(envname = '", envname, "') to install Python packages into a conda environmanet with this name.")
    stop(p)
  }
  if(sum(ix) > 1) {
    envs <- paste(condaList[ix,"python"], collapse="\n")
    p <- paste0("More than one Conda environment detected with the name '", envname, "'. Selecting the first one in the list:\n", envs)
    warning(p)
  }

  reticulate::use_condaenv(condaenv = envname, required = TRUE)
}



#' @name selectSCTKVirtualEnvironment
#' @title Selects a virtual environment
#' @description Selects a virtual environment with Python packages used in \code{\link{singleCellTK}}
#' @param envname Character. Name of the virtual environment to activate.
#' @return None. Selects virtual environment.
#' @examples
#' \dontrun{
#' sctkPythonInstallVirtualEnv(envname = "sctk-reticulate", selectEnvironment = FALSE)
#' selectSCTKVirtualEnvironment(envname = "sctk-reticulate")
#' }
#' @seealso See \code{\link[singleCellTK]{sctkPythonInstallVirtualEnv}} for installation of Python modules into a virtual environment.
#' See\code{\link[reticulate]{virtualenv-tools}} for more information on using virtual environments with package \code{\link{reticulate}}.
#' See \url{https://rstudio.github.io/reticulate/} for more information on package \code{\link{reticulate}}.
#' @export
selectSCTKVirtualEnvironment <- function(envname = "sctk-reticulate") {
  res <- reticulate::virtualenv_list()
  ix <- res == envname

  if(!any(ix)) {
    p <- paste0("Environmnet '", envname, "', not found. Run selectSCTKVirtualEnvironment(envname = '", envname, "') to install Python packages into a virtual environmanet with this name.")
    stop(p)
  }
  if(sum(ix) > 1) {
    p <- paste0("More than one virtual environment detected with the name '", envname, "'. Selecting the first one in the list.")
    warning(p)
  }

  reticulate::use_virtualenv(res[which(ix)[1]], required = TRUE)
}

#' Coverts SingleCellExperiment object from R to anndata.AnnData object in
#' Python
#'
#' The AnnData object here can be saved to .h5ad file and read into Python
#' interactive console. Mostly used senario is when you want to apply
#' reticulated Python function, which only works with an anndata.AnnData object.
#' @param SCE A SingleCellExperiment object.
#' @param useAssay Character, default `"counts"`. The name of assay of
#' interests that will be set as the primary matrix of the output AnnData.
#' Available options can be listed by `assayNames(SCE)`. Thee primary matrix
#' will be saved in `adata$X`, Other assays will be stored in `adata$obsm`
#' together with the low-dimension representations (for now).
#' @return A Python anndata.AnnData object
#' @noRd
.sce2adata <- function(SCE, useAssay = 'counts') {

    # TODO: use zellkonverter in the future, temporary fix for now
    # this is how we used to do it until we started running into problems with the getters and setters
    # in the future, this function might be depreciated altogether since it is only called internally
    # and we will use zellkonverter::writeH5AD directly from an SCE object

    # # Transfer SCE object back to AnnData
    # # Argument check first
    # stopifnot(inherits(SCE, "SingleCellExperiment"))

    # # Extract information that correspond to AnnData structure
    # #X <- as.matrix(t(SummarizedExperiment::assay(SCE, useAssay)))
    # # Sparse matrix conversion supported now, commenting the line above.
    # X <- t(SummarizedExperiment::assay(SCE, useAssay))
    # AnnData <- sc$AnnData(X = X)
    # obs <- as.data.frame(SummarizedExperiment::colData(SCE))
    # if(length(obs) > 0){
    #     AnnData$obs = obs
    # } else {
    #     AnnData$obs_names <- colnames(SCE)
    # }
    # var <- as.data.frame(SummarizedExperiment::rowData(SCE))
    # if(length(var) > 0){
    #     AnnData$var = var
    # } else {
    #     AnnData$var_names <- rownames(SCE)
    # }
    # # uns  <- S4Vectors::metadata(SCE)
    # # if(length(uns) > 0){ AnnData$uns <- uns }
    # obsmNames <- SingleCellExperiment::reducedDimNames(SCE)
    # if(length(obsmNames) > 0){
    #     for (i in seq_along(obsmNames)) {
    #         AnnData$obsm$'__setitem__'(obsmNames[i], SingleCellExperiment::reducedDim(SCE, obsmNames[i]))
    #     }
    # }

    # # Furthermore, the other assays will for now also be saved to .layers
    # allAssayNames <- SummarizedExperiment::assayNames(SCE)
    # for (i in seq_along(allAssayNames)) {
    #     oneName <- allAssayNames[i]
    #     if (!oneName == useAssay) {
    #         AnnData$layers$'__setitem__'(oneName, as.matrix(t(SummarizedExperiment::assay(SCE, oneName))))
    #     }
    # }

    X <- t(SummarizedExperiment::assay(SCE, useAssay))
    AnnData <- sc$AnnData(X = X)
    obs <- as.data.frame(SummarizedExperiment::colData(SCE))
    if(length(obs) > 0){
        AnnData$obs = obs
    } else {
        AnnData$obs_names <- colnames(SCE)
    }
    var <- as.data.frame(SummarizedExperiment::rowData(SCE))
    if(length(var) > 0){
        AnnData$var = var
    } else {
        AnnData$var_names <- rownames(SCE)
    }
    # previously commented out by someone else
    # uns  <- S4Vectors::metadata(SCE)
    # if(length(uns) > 0){ AnnData$uns <- uns }
    obsmNames <- SingleCellExperiment::reducedDimNames(SCE)
    # new method: make a list of dataframes, which Python can process for H5AD construction
    # initialize empty list for obsm and layers, which are the things we need to do
    obsm <- list()

    if(length(obsmNames) > 0){
        for (i in seq_along(obsmNames)) {
            obsm[[obsmNames[i]]] <- data.frame(SingleCellExperiment::reducedDim(SCE, obsmNames[i]))
            #previously using the dunder setter, which doesn't always work
            #AnnData$obsm$'__setitem__'(obsmNames[i], SingleCellExperiment::reducedDim(SCE, obsmNames[i]))
        }
    }
    
    AnnData$obsm <- obsm

    # Furthermore, the other assays will for now also be saved to .layers
    allAssayNames <- SummarizedExperiment::assayNames(SCE)
    layers <- list()
    for (i in seq_along(allAssayNames)) {
        oneName <- allAssayNames[i]
        if (!oneName == useAssay) {
            layers[[allAssayNames[i]]] <- data.frame(as.matrix(t(SummarizedExperiment::assay(SCE, oneName))))
            # this is the way we used to do it, through a Pythonic dunder setter
            #AnnData$layers$'__setitem__'(oneName, as.matrix(t(SummarizedExperiment::assay(SCE, oneName))))
        }
    }
    AnnData$layers <- layers
    return(AnnData)
}

decontXHelpModal <- function() {
  modalDialog(
    tags$style(HTML("
      div {
        word-wrap: break-word;
      }
      ")),
    tags$div(
      h3("DecontX Parameters"),
      fluidRow(
        column(4, tags$b("Parameter Name")),
        column(8, tags$b("Description"))
      ),
      tags$hr(),
      fluidRow(
        column(4, "maxIter"),
        column(8, "Integer. Maximum iterations of the EM algorithm. Default 500.")
      ),
      tags$hr(),
      fluidRow(
        column(4, "nativePrior"),
        column(8, "Integer. The first element of a vector containing the concentration parameters 
               for the Dirichlet prior for the contamination in each cell.")
      ),
      tags$hr(),
      fluidRow(
        column(4, "contaminationPrior"),
        column(8, "Integer. The second element of a vector containing the concentration parameters 
               for the Dirichlet prior for the contamination in each cell.")
      ),
      tags$hr(),
      fluidRow(
        column(4, "convergence"),
        column(8, "Numeric. The EM algorithm will be stopped if the maximum difference in the contamination 
               estimates between the previous and current iterations is less than this. Default 0.001.")
      ),
      tags$hr(),
      fluidRow(
        column(4, "iterLogLik"),
        column(8, "Integer. Calculate log likelihood every iterLogLik iteration. Default 10.")
      ),
      tags$hr(),
      fluidRow(
        column(4, "varGenes"),
        column(8, "Integer. The number of variable genes to use in dimensionality reduction before clustering. 
               Variability is calcualted using modelGeneVar function from the 'scran' package. Used only when z is not provided. 
               Default 5000.")
      ),
      tags$hr(),
      fluidRow(
        column(4, "dbscanEps"),
        column(8, "Numeric. The clustering resolution parameter used in 'dbscan' to estimate broad cell clusters. 
               Used only when z is not provided. Default 1.")
      ),
      tags$hr(),
      fluidRow(
        column(4, "estimateDelta"),
        column(8, "Check off to update delta at each iteration.")
      ),
      tags$hr(),
      fluidRow(
        column(4, "verbose"),
        column(8, "Check off to print log messages. Default TRUE.")
      ),
    )
  )
}

#' @title Export a \link[SingleCellExperiment]{SingleCellExperiment} R object as
#' Python annData object
#' @description Writes all assays, colData, rowData, reducedDims, and altExps objects in a
#' \link[SingleCellExperiment]{SingleCellExperiment} to a Python annData object in the .h5ad format
#' All parameters of Anndata.write_h5ad function (https://icb-anndata.readthedocs-hosted.com/en/stable/anndata.AnnData.write_h5ad.html)
#' are available as parameters to this export function and set to defaults. Defaults can be
#' overridden at function call.
#' @param sce \link[SingleCellExperiment]{SingleCellExperiment} R object to be
#'  exported.
#' @param useAssay Character. The name of assay of
#' interests that will be set as the primary matrix of the output AnnData.
#' Default \code{"counts"}.
#' @param outputDir Path to the directory where .h5ad outputs will be written. Default is the current working directory.
#' @param prefix Prefix to use for the name of the output file. Default \code{"sample"}.
#' @param overwrite Boolean. Default \code{TRUE}.
#' @param compression If output file compression is required, this variable accepts
#' 'gzip', 'lzf' or "None" as inputs. Default \code{"gzip"}.
#' @param compressionOpts Integer. Sets the compression level
#' @param forceDense Default \code{False} Write sparse data as a dense matrix.
#' Refer \code{anndata.write_h5ad} documentation for details. Default \code{NULL}.
#' @return Generates a Python anndata object containing data from \code{inSCE}.
#' @examples
#' data(sce_chcl, package = "scds")
#' \dontrun{
#' exportSCEtoAnnData(sce=sce_chcl, compression="gzip")
#' }
#' @export
exportSCEtoAnnData <- function(sce,
                                useAssay = 'counts',
                                outputDir = "./",
                                prefix = "sample",
                                overwrite = TRUE,
                                compression = c('gzip','lzf', "None"),
                                compressionOpts = NULL,
                                forceDense = FALSE){
  compression <- match.arg(compression)
  # currently not needed
  #forceDense <- match.arg(forceDense)
  if (compression == 'None'){
    compression <- NULL
  }
  if (!reticulate::py_module_available(module = "scanpy")) {
    warning("Cannot find python module 'scanpy', please install Conda and",
            " run sctkPythonInstallConda() or run sctkPythonInstallVirtualEnv().",
            "If one of these have been previously run to install the modules,",
            "make sure to run selectSCTKConda() or selectSCTKVirtualEnvironment(),",
            " respectively, if R has been restarted since the module installation.",
            " Alternatively, 'scanpy' can be installed on the local machine",
            "with pip (e.g. pip install --user scanpy) and then the 'use_python()'",
            " function from the 'reticulate' package can be used to select the",
            " correct Python environment.")
    return(sce)}
  dir.create(outputDir, showWarnings = FALSE, recursive = TRUE)
  fileName <- paste0(prefix,".h5ad")
  filePath <- file.path(outputDir,fileName)
  if (file.exists(filePath) && !isTRUE(overwrite)) {
    p <- paste0(path, " already exists. Change 'outputDir' or set 'overwrite' to TRUE.")
    stop(p)
  }
  if (isFALSE(forceDense)) {
    forceDense <- NULL
  } else if (isTRUE(forceDense)) {
    forceDense <- "X"
  } else {
    stop("Argument `forceDense` should be `TRUE` or `FALSE`")
  }
  AssayName <- SummarizedExperiment::assayNames(sce)
  for (assay in AssayName){
    if (!methods::is(SummarizedExperiment::assay(sce, assay), 'dgCMatrix')) {
      SummarizedExperiment::assay(sce, assay) <- .convertToMatrix(SummarizedExperiment::assay(sce, assay))
    }
  }
  # convert to AnnData
  annData <- .sce2adata(sce, useAssay)
  # use zellkonverter to output h5ad, but first we have to turn it back into SCE for it to process
  # and zellkonverter won't take the output SCE as it stands
  out <- zellkonverter::AnnData2SCE(annData)
  zellkonverter::writeH5AD(out, file = filePath, compression = compression)

  # commented out until a permanent fix can be found with zellkonverter
  # in the future, sce2adata may be depreciated altogether in favor of just this function, since zellkonverter's output takes an SCE object and writes it
  # and we can drop forceDense from the options, because sparse is default

  #if (is.null(forceDense)) {
  #  anndata::write_h5ad(annData, 
  #                    filePath,
  #                     compression = compression,
  #                     compression_opts = compressionOpts)
  # }
  # else {
  #   anndata::write_h5ad(annData, 
  #                     filePath,
  #                     compression = compression,
  #                     compression_opts = compressionOpts,
  #                     as.dense = forceDense)
  # }
}

shinyPanelLabelCellType <- fluidPage(
  tags$div(
    class = "container",
    h1("Label Cell Type"),
    p("Currently only 'SingleR' method supported. ", style = "color: grey;"),
    h5(tags$a(href = paste0(docs.artPath, "cell_type_labeling.html"),
              "(help)", target = "_blank")),
    panel(
      fluidRow(
        column(
          width = 6,
          selectInput("ctLabelMethod", "Method", c("SingleR"), "SingleR"),
        ),
        column(
          width = 6,
          selectizeInput(
            inputId = "ctLabelAssay", 
            label = "Select input matrix:", 
            choices = NULL, 
            selected = NULL, 
            multiple = FALSE,
            options = NULL)
          #uiOutput("ctLabelAssay"),
        )
      ),
      panel(
        useShinyjs(),
        # SingleR specific panel, in case adding other methods in the future.
        p("SingleR works with a reference dataset where the cell type ",
          "labeling is given. Given a reference dataset of samples ",
          "(single-cell or bulk) with known labels, it assigns those labels ",
          "to new cells from a test dataset based on similarities in their ",
          "expression profiles.",
          style = "color: grey;"),
        fluidRow(
          column(
            width = 6,
            selectInput("ctLabelRef", "Choose a reference",
                        choices = c("Human Primary Cell Atlas Data" = "hpca",
                                    "Blueprint Encode Data" = "bpe",
                                    "Muraro Pancreas Data" = "mp",
                                    "Database Immune Cell Expression Data" = "dice",
                                    "ImmGen Data" = "immgen",
                                    "Mouse RNAseq Data" = "mouse",
                                    "Zeisel Brain Data" = "zeisel")),
            radioButtons("ctLabelFeatureType", "Feature type:",
                         c("symbol", "ensembl"), inline = TRUE),
          ),
          column(
            width = 6,
            uiOutput("ctLabelLevelUI"),
            # selectInput("ctLabelLevel", "Labeling level:",
            #             c("main", "fine", "ont"), "main"),
            radioButtons("ctLabelBy", "Label by",
                         c("Each cell", "Clusters"), "Each cell", inline = TRUE),
          )
        ),
        conditionalPanel(
          "input.ctLabelBy == 'Clusters'",
          selectInput("ctLabelByCluster", "Use cluster label:", clusterChoice)
          ),
        conditionalPanel(
          "input.ctLabelRef == 'hpca'",
          tags$a(href = "https://rdrr.io/github/LTLA/celldex/man/HumanPrimaryCellAtlasData.html",
                "Detail about the reference dataset...", target = "_blank")
        ),
        conditionalPanel(
          "input.ctLabelRef == 'bpe'",
          tags$a(href = "https://rdrr.io/github/LTLA/celldex/man/BlueprintEncodeData.html",
                "Detail about the reference dataset...", target = "_blank")
        ),
        conditionalPanel(
          "input.ctLabelRef == 'mp'",
          tags$a(href = "https://rdrr.io/github/LTLA/scRNAseq/man/MuraroPancreasData.html",
                 "Detail about the reference dataset...", target = "_blank")
        ),
        conditionalPanel(
          "input.ctLabelRef == 'dice'",
          tags$a(href = "https://rdrr.io/github/LTLA/celldex/man/DatabaseImmuneCellExpressionData.html",
                 "Detail about the reference dataset...", target = "_blank")
        ),
        conditionalPanel(
          "input.ctLabelRef == 'immgen'",
          tags$a(href = "https://rdrr.io/github/LTLA/celldex/man/ImmGenData.html",
                 "Detail about the reference dataset...", target = "_blank")
        ),
        conditionalPanel(
          "input.ctLabelRef == 'mouse'",
          tags$a(href = "https://rdrr.io/github/LTLA/celldex/man/MouseRNAseqData.html",
                 "Detail about the reference dataset...", target = "_blank")
        ),
        conditionalPanel(
          "input.ctLabelRef == 'zeisel'",
          tags$a(href = "https://rdrr.io/github/LTLA/scRNAseq/man/ZeiselBrainData.html",
                 "Detail about the reference dataset...", target = "_blank")
        ),
        p("If users want to work with their customized reference dataset, ",
          "please refer to SCTK's console function: runSingleR()",
          style = "color: grey;")
      ),
      actionButton("ctLabelRun", "Run")
    )
  )
)

#' @title Merging colData from two singleCellExperiment objects
#' @description Merges colData of the singleCellExperiment objects
#'  obtained from the same dataset which contain differing colData.
#'  (i.e. raw data and filtered data)
#' @param inSCE1 Input SingleCellExperiment object. The function will output this
#'  singleCellExperiment object with a combined colData from inSCE1 and inSCE2.
#' @param inSCE2 Input SingleCellExperiment object. colData from this object
#'  will be merged with colData from inSCE1 and loaded into inSCE1.
#' @param id1 Character vector. Column in colData of inSCE1 that will be
#'  used to combine inSCE1 and inSCE2. Default "column_name"
#' @param id2 Character vector. Column in colData of inSCE2 that will be
#'  used to combine inSCE1 and inSCE2. Default "column_name"
#' @return SingleCellExperiment object containing combined colData from
#'  both singleCellExperiment for samples in inSCE1.
#' @examples
#' sce1 <- importCellRanger(
#'     cellRangerDirs = system.file("extdata/", package = "singleCellTK"),
#'     sampleDirs = "hgmm_1k_v3_20x20",
#'     sampleNames = "hgmm1kv3",
#'     dataType = "filtered")
#' data(scExample)
#' sce2 <- sce
#' sce <- mergeSCEColData(inSCE1 = sce1, inSCE2 = sce2, id1 = "column_name", id2 = "column_name")
#' @export
mergeSCEColData <- function(inSCE1, inSCE2, id1 = "column_name", id2 = "column_name") {
  # For default case & column_name not in colData
  if (id1 == "column_name" && "column_name" %in%
    names(SummarizedExperiment::colData(inSCE1))) {
    columnNameColExist1 <- TRUE
  } else {
    columnNameColExist1 <- FALSE
    SummarizedExperiment::colData(inSCE1)$column_name <- colnames(inSCE1)
  }

  if (id2 == "column_name" && "column_name" %in%
    names(SummarizedExperiment::colData(inSCE2))) {
  } else {
    SummarizedExperiment::colData(inSCE2)$column_name <- colnames(inSCE2)
  }
  not.in.sce1 <- c(setdiff(
    names(SummarizedExperiment::colData(inSCE2)),
    names(SummarizedExperiment::colData(inSCE1))
  ), id2)
  not.in.sce1 <- not.in.sce1[!is.null(not.in.sce1)]

  coldata.not.in.sce1 <- SummarizedExperiment::colData(inSCE2)[, c(not.in.sce1),
    drop = FALSE
  ]

  coldata.sce1 <- SummarizedExperiment::colData(inSCE1)

  if (is.null(id1) | is.null(id2)) {
    if (is.null(rownames(coldata.not.in.sce1))) {
      stop("Unable to match between singleCellExperiment objects.
              Please define id1/id2 within the function,
              or assign a column name for the singleCellExperiment object.")
    } else {
      coldata.not.in.sce1$cell <- rownames(coldata.not.in.sce1)
      coldata.sce1$cell <- rownames(SummarizedExperiment::colData(inSCE1))
      id1 <- "cell"
      id2 <- "cell"
      placeholder <- TRUE
    }
  } else {
    placeholder <- FALSE
  }

  coldata.merge <- base::merge(coldata.sce1,
    coldata.not.in.sce1,
    all.x = TRUE,
    sort = FALSE,
    by.x = id1,
    by.y = id2
  )

  coldata.merge <- coldata.merge[match(
    colnames(SingleCellExperiment::counts(inSCE1)),
    coldata.merge[, id1]
  ), ]

  rownames(coldata.merge) <- coldata.merge[, id1]

  if (placeholder == TRUE) {
    coldata.merge[, id1] <- NULL
  }

  if(!columnNameColExist1){
    coldata.merge$column_name <- NULL
  }
  SummarizedExperiment::colData(inSCE1) <- S4Vectors::DataFrame(coldata.merge)
  return(inSCE1)
}

library(singleCellTK)
context("Testing mergeSCColData")

data(scExample, package = "singleCellTK")

sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")

colData(sce)$column_name = rownames(colData(sce))
test_that(desc = "Testing mergeSCEColData", {
    sce2 <- sce
    colData(sce2)$test <- 0

    #test again
    mergedsce <- mergeSCEColData(sce, sce2)

    expect_equal(ncol(colData(sce)) + 1, ncol(colData(mergedsce)))
})

shinyPanelExport <- fluidPage(
  tags$div(
  class = "container",
  style = "margin-bottom: 10px",
  h1("Export Data"),
  h5(tags$a(href = paste0(docs.artPath, "export_data.html"),
            "(help)", target = "_blank")),
  tags$hr(),
  fluidRow(
    column(
      6,
      tags$h5(style = "font-weight: bold; margin-bottom: 15px", "Choose export type"),
      radioButtons(
        "exportChoice",
        label = NULL,
        c(
          "Download as RDS file" = "rds",
          "Python annData object" = "annData"
        )
      ),
      conditionalPanel(
        condition = "input.exportChoice == 'annData' || input.exportChoice == 'rds'",
        tags$label(id="exportFileNameLabel", "File Name"),
      ),
      
      uiOutput("exportFileName"),
      downloadButton("exportData", "Download")
    ),
    column(
      6,
      conditionalPanel(
        condition = "input.exportChoice == 'annData'",
        tags$h5(style = "font-weight: bold; margin-bottom: 15px", "Set export specifications"),
        selectizeInput(
          inputId = "exportAssay", 
          label = "Select input matrix:", 
          choices = NULL, 
          selected = NULL, 
          multiple = FALSE,
          options = NULL),
        
      ),
    )
    )
))

scDblFinderHelpModal <- function() {
  modalDialog(
    tags$style(HTML("
      div {
        word-wrap: break-word;
      }
      ")),
    tags$div(
      h3("scDblFinder Parameters"),
      fluidRow(
        column(4, tags$b("Parameter Name")),
        column(8, tags$b("Description"))
      ),
      tags$hr(),
      fluidRow(
        column(4, "nNeighbors"),
        column(8, "Integer. Number of nearest neighbors used to calculate density for doublet detection. Default 50.")
      ),
      tags$hr(),
      fluidRow(
        column(4, "simDoublets"),
        column(8, 'Integer. Number of simulated doublets created for doublet detection. Default 10000.')
      )
    )
  )
}

#' @title Detecting and correct contamination with SoupX
#' @description A wrapper function for \link[SoupX]{autoEstCont} and
#' \link[SoupX]{adjustCounts}. Identify potential contamination from
#' experimental factors such as ambient RNA. Visit
#' \href{https://rawcdn.githack.com/constantAmateur/SoupX/204b602418df12e9fdb4b68775a8b486c6504fe4/inst/doc/pbmcTutorial.html}{their vignette}
#' for better understanding.
#' @param inSCE A \linkS4class{SingleCellExperiment} object.
#' @param sample A single character specifying a name that can be found in
#' \code{colData(inSCE)} to directly use the cell annotation; or a character
#' vector with as many elements as cells to indicates which sample each cell
#' belongs to. SoupX will be run on cells from each sample separately. Default
#' \code{NULL}.
#' @param useAssay A single character string specifying which assay in
#' \code{inSCE} to use. Default \code{'counts'}.
#' @param background A numeric matrix of counts or a
#' \linkS4class{SingleCellExperiment} object with the matrix in \code{assay}
#' slot. It should have the same structure as \code{inSCE} except it contains
#' the matrix including empty droplets. Default \code{NULL}.
#' @param bgAssayName A single character string specifying which assay in
#' \code{background} to use when \code{background} is a
#' \linkS4class{SingleCellExperiment} object. If \code{NULL}, the function
#' will use the same value as \code{useAssay}. Default \code{NULL}.
#' @param bgBatch The same thing as \code{sample} but for \code{background}. Can
#' be a single character only when \code{background} is a
#' \linkS4class{SingleCellExperiment} object. Default \code{NULL}.
#' @param assayName A single character string of the output corrected matrix.
#' Default \code{"SoupX"} when not using a background, otherwise,
#' \code{"SoupX_bg"}.
#' @param cluster Prior knowledge of clustering labels on cells. A single
#' character string for specifying clustering label stored in
#' \code{colData(inSCE)}, or a character vector with as many elements as cells.
#' When not supplied, \code{\link[scran]{quickCluster}} method will be applied.
#' @param reducedDimName A single character string of the prefix of output
#' corrected embedding matrix for each sample. Default \code{"SoupX_UMAP_"} when
#' not using a background, otherwise, \code{"SoupX_bg_UMAP_"}.
#' @param tfidfMin Numeric. Minimum value of tfidf to accept for a marker gene.
#' Default \code{1}. See \code{?SoupX::autoEstCont}.
#' @param soupQuantile Numeric. Only use genes that are at or above this
#' expression quantile in the soup. This prevents inaccurate estimates due to
#' using genes with poorly constrained contribution to the background. Default
#' \code{0.9}. See \code{?SoupX::autoEstCont}.
#' @param maxMarkers Integer. If we have heaps of good markers, keep only the
#' best maxMarkers of them. Default \code{100}. See \code{?SoupX::autoEstCont}.
#' @param contaminationRange Numeric vector of two elements. This constrains
#' the contamination fraction to lie within this range. Must be between 0 and 1.
#' The high end of this range is passed to
#' \code{\link[SoupX]{estimateNonExpressingCells}} as
#' \code{maximumContamination}. Default \code{c(0.01, 0.8)}. See
#' \code{?SoupX::autoEstCont}.
#' @param rhoMaxFDR Numeric. False discovery rate passed to
#' \code{\link[SoupX]{estimateNonExpressingCells}}, to test if rho is less than
#' \code{maximumContamination}. Default \code{0.2}. See
#' \code{?SoupX::autoEstCont}.
#' @param priorRho Numeric. Mode of gamma distribution prior on contamination
#' fraction. Default \code{0.05}. See \code{?SoupX::autoEstCont}.
#' @param priorRhoStdDev Numeric. Standard deviation of gamma distribution prior
#' on contamination fraction. Default \code{0.1}. See
#' \code{?SoupX::autoEstCont}.
#' @param forceAccept Logical. Should we allow very high contamination fractions
#' to be used. Passed to \code{\link[SoupX]{setContaminationFraction}}. Default
#' \code{FALSE}. See \code{?SoupX::autoEstCont}.
#' @param adjustMethod Character. Method to use for correction. One of
#' \code{'subtraction'}, \code{'soupOnly'}, or \code{'multinomial'}. Default
#' \code{'subtraction'}. See \code{?SoupX::adjustCounts}.
#' @param roundToInt Logical. Should the resulting matrix be rounded to
#' integers? Default \code{FALSE}. See \code{?SoupX::adjustCounts}.
#' @param tol Numeric. Allowed deviation from expected number of soup counts.
#' Don't change this. Default \code{0.001}. See \code{?SoupX::adjustCounts}.
#' @param pCut Numeric. The p-value cut-off used when
#' \code{method = 'soupOnly'}. Default \code{0.01}. See
#' \code{?SoupX::adjustCounts}.
#' @return The input \code{inSCE} object with \code{soupX_nUMIs},
#' \code{soupX_clustrers}, \code{soupX_contamination} appended to \code{colData}
#' slot; \code{soupX_{sample}_est} and \code{soupX_{sample}_counts} for each
#' sample appended to \code{rowData} slot; and other computational metrics at
#' \code{getSoupX(inSCE)}. Replace "soupX" to "soupX_bg" when \code{background}
#' is used.
#' @seealso plotSoupXResults
#' @export
#' @author Yichen Wang
#' @examples
#' \dontrun{
#' # SoupX does not work for toy example,
#' sce <- importExampleData("pbmc3k")
#' sce <- runSoupX(sce, sample = "sample")
#' plotSoupXResults(sce, sample = "sample")
#' }
runSoupX <- function(inSCE,
                     sample = NULL,
                     useAssay = "counts",
                     background = NULL,
                     bgAssayName = NULL,
                     bgBatch = NULL,
                     assayName = ifelse(is.null(background),
                                        "SoupX", "SoupX_bg"),
                     cluster = NULL,
                     reducedDimName = ifelse(is.null(background),
                                        "SoupX_UMAP_", "SoupX_bg_UMAP_"),
                     tfidfMin = 1,
                     soupQuantile = 0.9,
                     maxMarkers = 100,
                     contaminationRange = c(0.01, 0.8),
                     rhoMaxFDR = 0.2,
                     priorRho = 0.05,
                     priorRhoStdDev = 0.1,
                     forceAccept = FALSE,
                     adjustMethod = c("subtraction", "soupOnly", "multinomial"),
                     roundToInt = FALSE,
                     tol = 0.001,
                     pCut = 0.01) {
    SingleBGBatchForAllBatch <- FALSE
    adjustMethod <- match.arg(adjustMethod)
    if (!is.null(sample)) {
        sample <- .manageCellVar(inSCE, var = sample)
        if (is.factor(sample)) {
            sample <- as.character(sample)
        }
        uniqSample <- unique(sample)
        if (!is.null(background)) {
            if (is.null(bgBatch)) {
                # 'sample' specified, 'bgBatch' not
                bgBatch <- rep("all_cells", ncol(background))
                SingleBGBatchForAllBatch <- TRUE
            } else {
                # 'sample' & 'bgBatch' both specified
                if (length(bgBatch) == 1) {
                    if (!bgBatch %in% names(SummarizedExperiment::colData(background))) {
                        stop("Specified bgBatch variable not found ",
                             "in background colData")
                    }
                    bgBatch <- SummarizedExperiment::colData(background)[[bgBatch]]
                } else if (length(bgBatch) != ncol(background)) {
                    stop("'bgBatch' must be the same length as ",
                         "the number of columns in 'background'")
                }
                if (is.factor(bgBatch)) {
                    bgBatch <- as.character(bgBatch)
                }
                # Check 'sample's in cell matrix can all be found in bgBatch
                if (!all(sample %in% bgBatch)) {
                    stop("Not all samples can be found in 'bgBatch'.")
                }
            }
        }
    } else {
        # 'sample' not specified.
        sample <- rep("all_cells", ncol(inSCE))
        if (!is.null(background)) {
            if (!is.null(bgBatch)) {
                warning("Using all background because 'sample' not specified.")
            }
            bgBatch <- rep("all_cells", ncol(background))
        }
        uniqSample <- "all_cells"
    }
    
    p <- paste0(date(), " ... Running 'SoupX'")
    message(p)

    # try/catch block in case SoupX finds no marker genes
    result <- tryCatch(
        {
            results <- list()
            sampleIdx <- list()
            for (s in uniqSample) {
                p <- paste0(date(), " ... Running 'SoupX' on sample: ", s)
                message(p)
                cellIdx <- sample == s
                sampleIdx[[s]] <- cellIdx
                tempSCE <- inSCE[,cellIdx]
                if (isTRUE(SingleBGBatchForAllBatch)) {
                    res <- .SoupXOneBatch(inSCE = tempSCE,
                                          useAssay = useAssay,
                                          background = background,
                                          bgAssayName = bgAssayName,
                                          cluster = cluster,
                                          reducedDimName = reducedDimName,
                                          tfidfMin = tfidfMin,
                                          soupQuantile = soupQuantile,
                                          maxMarkers = maxMarkers,
                                          contaminationRange = contaminationRange,
                                          rhoMaxFDR = rhoMaxFDR,
                                          priorRho = priorRho,
                                          priorRhoStdDev = priorRhoStdDev,
                                          forceAccept = forceAccept,
                                          adjustMethod = adjustMethod,
                                          roundToInt = roundToInt,
                                          tol = tol,
                                          pCut = pCut)
                } else {
                    if (!is.null(background)) {
                        bgIdx <- bgBatch == s
                        tempBG <- background[,bgIdx]
                    } else {
                        tempBG <- NULL
                    }
                    res <- .SoupXOneBatch(inSCE = tempSCE,
                                          useAssay = useAssay,
                                          background = tempBG,
                                          bgAssayName = bgAssayName,
                                          cluster = cluster,
                                          reducedDimName = reducedDimName,
                                          tfidfMin = tfidfMin,
                                          soupQuantile = soupQuantile,
                                          maxMarkers = maxMarkers,
                                          contaminationRange = contaminationRange,
                                          rhoMaxFDR = rhoMaxFDR,
                                          priorRho = priorRho,
                                          priorRhoStdDev = priorRhoStdDev,
                                          forceAccept = forceAccept,
                                          adjustMethod = adjustMethod,
                                          roundToInt = roundToInt,
                                          tol = tol,
                                          pCut = pCut)
                }
                results[[s]] <- res
            }
            # Initiate new assay by copying the input selection
            # And then replace with new value at sample indices
            # Similarly for colData and rowData
            corrAssay <- SummarizedExperiment::assay(inSCE, useAssay)
            newColData <- SummarizedExperiment::colData(inSCE)
            if (!is.null(background)) {
                newColData$soupX_bg_nUMIs <- NA
                newColData$soupX_bg_clusters <- NA
                newColData$soupX_bg_contamination <- NA
            } else {
                newColData$soupX_nUMIs <- NA
                newColData$soupX_clusters <- NA
                newColData$soupX_contamination <- NA
            }
            newRowData <- SummarizedExperiment::rowData(inSCE)


            for (s in names(results)) {
                corrAssay[,sampleIdx[[s]]] <- results[[s]]$out
                meta <- results[[s]]$sc$fit
                meta$nDropUMIs <- results[[s]]$sc$nDropUMIs
                meta$param <- list(sample = sample, useAssay = useAssay,
                                   bgAssayName = bgAssayName, bgBatch = bgBatch,
                                   assayName = assayName,
                                   tfidfMin = tfidfMin,
                                   soupQuantile = soupQuantile,
                                   maxMarkers = maxMarkers,
                                   contaminationRange = contaminationRange,
                                   rhoMaxFDR = rhoMaxFDR,
                                   priorRho = priorRho,
                                   priorRhoStdDev = priorRhoStdDev,
                                   forceAccept = forceAccept,
                                   adjustMethod = adjustMethod,
                                   roundToInt = roundToInt,
                                   tol = tol,
                                   pCut = pCut,
                                   reducedDimName = paste0(reducedDimName, s),
                                   sessionInfo = utils::sessionInfo())
                # Output inSCE need to have separated UMAP calculated for each sample
                sampleUMAP <- matrix(nrow = ncol(inSCE), ncol = 2)
                rownames(sampleUMAP) <- colnames(inSCE)
                sampleUMAP[sampleIdx[[s]]] <- results[[s]]$umap
                if (!is.null(cluster)) {
                    meta$param$cluster <- cluster
                } else {
                    if (!is.null(background)) {
                        meta$param$cluster <- "soupX_bg_clusters"
                    } else {
                        meta$param$cluster <- "soupX_clusters"
                    }
                }
                if (!is.null(background)) {
                    newColData$soupX_bg_nUMIs[sampleIdx[[s]]] <- results[[s]]$sc$metaData$nUMIs
                    newColData$soupX_bg_clusters[sampleIdx[[s]]] <- paste0(s, "-", results[[s]]$sc$metaData$clusters)
                    newColData$soupX_bg_contamination[sampleIdx[[s]]] <- results[[s]]$sc$metaData$rho
                    newRowData[[paste0("soupX_bg_",s,"_est")]] <- results[[s]]$sc$soupProfile$est
                    newRowData[[paste0("soupX_bg_",s,"_counts")]] <- results[[s]]$sc$soupProfile$counts
                    getSoupX(inSCE, sampleID = s, background = TRUE) <- meta
                } else {
                    newColData$soupX_nUMIs[sampleIdx[[s]]] <- results[[s]]$sc$metaData$nUMIs
                    newColData$soupX_clusters[sampleIdx[[s]]] <- paste0(s, "-", results[[s]]$sc$metaData$clusters)
                    newColData$soupX_contamination[sampleIdx[[s]]] <- results[[s]]$sc$metaData$rho
                    newRowData[[paste0("soupX_",s,"_est")]] <- results[[s]]$sc$soupProfile$est
                    newRowData[[paste0("soupX_",s,"_counts")]] <- results[[s]]$sc$soupProfile$counts
                    getSoupX(inSCE, sampleID = s) <- meta
                }
                SingleCellExperiment::reducedDim(inSCE,
                                                paste0(reducedDimName,
                                                        s)) <- sampleUMAP
            }
            expData(inSCE, assayName, tag = "raw") <- corrAssay
            inSCE <- expSetDataTag(inSCE, "raw", assayName)
            SummarizedExperiment::colData(inSCE) <- newColData
            SummarizedExperiment::rowData(inSCE) <- newRowData
        }, 
        error=function(cond) {
            p <- paste0(date(), " ... Error occured in 'SoupX'; skipping 'SoupX'. Details as follows:")
            message(p)
            message(cond)
        }
    )
    return(inSCE)

    # results <- list()
    # sampleIdx <- list()
    # for (s in uniqSample) {
    #     message(paste0(date(), " ... Running 'SoupX' on sample: ", s))
    #     cellIdx <- sample == s
    #     sampleIdx[[s]] <- cellIdx
    #     tempSCE <- inSCE[,cellIdx]
    #     if (isTRUE(SingleBGBatchForAllBatch)) {
    #         res <- .SoupXOneBatch(inSCE = tempSCE,
    #                               useAssay = useAssay,
    #                               background = background,
    #                               bgAssayName = bgAssayName,
    #                               cluster = cluster,
    #                               reducedDimName = reducedDimName,
    #                               tfidfMin = tfidfMin,
    #                               soupQuantile = soupQuantile,
    #                               maxMarkers = maxMarkers,
    #                               contaminationRange = contaminationRange,
    #                               rhoMaxFDR = rhoMaxFDR,
    #                               priorRho = priorRho,
    #                               priorRhoStdDev = priorRhoStdDev,
    #                               forceAccept = forceAccept,
    #                               adjustMethod = adjustMethod,
    #                               roundToInt = roundToInt,
    #                               tol = tol,
    #                               pCut = pCut)
    #     } else {
    #         if (!is.null(background)) {
    #             bgIdx <- bgBatch == s
    #             tempBG <- background[,bgIdx]
    #         } else {
    #             tempBG <- NULL
    #         }
    #         res <- .SoupXOneBatch(inSCE = tempSCE,
    #                               useAssay = useAssay,
    #                               background = tempBG,
    #                               bgAssayName = bgAssayName,
    #                               cluster = cluster,
    #                               reducedDimName = reducedDimName,
    #                               tfidfMin = tfidfMin,
    #                               soupQuantile = soupQuantile,
    #                               maxMarkers = maxMarkers,
    #                               contaminationRange = contaminationRange,
    #                               rhoMaxFDR = rhoMaxFDR,
    #                               priorRho = priorRho,
    #                               priorRhoStdDev = priorRhoStdDev,
    #                               forceAccept = forceAccept,
    #                               adjustMethod = adjustMethod,
    #                               roundToInt = roundToInt,
    #                               tol = tol,
    #                               pCut = pCut)
    #     }
    #     results[[s]] <- res
    # }
    # # Initiate new assay by copying the input selection
    # # And then replace with new value at sample indices
    # # Similarly for colData and rowData
    # corrAssay <- SummarizedExperiment::assay(inSCE, useAssay)
    # newColData <- SummarizedExperiment::colData(inSCE)
    # if (!is.null(background)) {
    #     newColData$soupX_bg_nUMIs <- NA
    #     newColData$soupX_bg_clusters <- NA
    #     newColData$soupX_bg_contamination <- NA
    # } else {
    #     newColData$soupX_nUMIs <- NA
    #     newColData$soupX_clusters <- NA
    #     newColData$soupX_contamination <- NA
    # }
    # newRowData <- SummarizedExperiment::rowData(inSCE)


    # for (s in names(results)) {
    #     corrAssay[,sampleIdx[[s]]] <- results[[s]]$out
    #     meta <- results[[s]]$sc$fit
    #     meta$nDropUMIs <- results[[s]]$sc$nDropUMIs
    #     meta$param <- list(sample = sample, useAssay = useAssay,
    #                        bgAssayName = bgAssayName, bgBatch = bgBatch,
    #                        assayName = assayName,
    #                        tfidfMin = tfidfMin,
    #                        soupQuantile = soupQuantile,
    #                        maxMarkers = maxMarkers,
    #                        contaminationRange = contaminationRange,
    #                        rhoMaxFDR = rhoMaxFDR,
    #                        priorRho = priorRho,
    #                        priorRhoStdDev = priorRhoStdDev,
    #                        forceAccept = forceAccept,
    #                        adjustMethod = adjustMethod,
    #                        roundToInt = roundToInt,
    #                        tol = tol,
    #                        pCut = pCut,
    #                        reducedDimName = paste0(reducedDimName, s),
    #                        sessionInfo = utils::sessionInfo())
    #     # Output inSCE need to have separated UMAP calculated for each sample
    #     sampleUMAP <- matrix(nrow = ncol(inSCE), ncol = 2)
    #     rownames(sampleUMAP) <- colnames(inSCE)
    #     sampleUMAP[sampleIdx[[s]]] <- results[[s]]$umap
    #     if (!is.null(cluster)) {
    #         meta$param$cluster <- cluster
    #     } else {
    #         if (!is.null(background)) {
    #             meta$param$cluster <- "soupX_bg_clusters"
    #         } else {
    #             meta$param$cluster <- "soupX_clusters"
    #         }
    #     }
    #     if (!is.null(background)) {
    #         newColData$soupX_bg_nUMIs[sampleIdx[[s]]] <- results[[s]]$sc$metaData$nUMIs
    #         newColData$soupX_bg_clusters[sampleIdx[[s]]] <- paste0(s, "-", results[[s]]$sc$metaData$clusters)
    #         newColData$soupX_bg_contamination[sampleIdx[[s]]] <- results[[s]]$sc$metaData$rho
    #         newRowData[[paste0("soupX_bg_",s,"_est")]] <- results[[s]]$sc$soupProfile$est
    #         newRowData[[paste0("soupX_bg_",s,"_counts")]] <- results[[s]]$sc$soupProfile$counts
    #         getSoupX(inSCE, sampleID = s, background = TRUE) <- meta
    #     } else {
    #         newColData$soupX_nUMIs[sampleIdx[[s]]] <- results[[s]]$sc$metaData$nUMIs
    #         newColData$soupX_clusters[sampleIdx[[s]]] <- paste0(s, "-", results[[s]]$sc$metaData$clusters)
    #         newColData$soupX_contamination[sampleIdx[[s]]] <- results[[s]]$sc$metaData$rho
    #         newRowData[[paste0("soupX_",s,"_est")]] <- results[[s]]$sc$soupProfile$est
    #         newRowData[[paste0("soupX_",s,"_counts")]] <- results[[s]]$sc$soupProfile$counts
    #         getSoupX(inSCE, sampleID = s) <- meta
    #     }
    #     SingleCellExperiment::reducedDim(inSCE,
    #                                      paste0(reducedDimName,
    #                                             s)) <- sampleUMAP
    # }
    # expData(inSCE, assayName, tag = "raw") <- corrAssay
    # inSCE <- expSetDataTag(inSCE, "raw", assayName)
    # SummarizedExperiment::colData(inSCE) <- newColData
    # SummarizedExperiment::rowData(inSCE) <- newRowData
    # return(inSCE)
}

.SoupXOneBatch <- function(inSCE,
                           useAssay,
                           background,
                           bgAssayName,
                           cluster,
                           reducedDimName,
                           tfidfMin,
                           soupQuantile,
                           maxMarkers,
                           contaminationRange,
                           rhoMaxFDR,
                           priorRho,
                           priorRhoStdDev,
                           forceAccept,
                           adjustMethod,
                           roundToInt,
                           tol,
                           pCut) {
    # Building SoupX's SoupChannel object
    toc <- expData(inSCE, useAssay)
    if (is.null(background)) {
        scNoDrops <- SoupX::SoupChannel(toc, toc, calcSoupProfile = FALSE)
        soupProf <- data.frame(row.names = rownames(toc),
                               est = rowSums(toc)/sum(toc),
                               counts = rowSums(toc))
        sc <- SoupX::setSoupProfile(scNoDrops, soupProf)
    } else {
        if (inherits(background, "SingleCellExperiment")) {
            if (is.null(bgAssayName)) {
                bgAssayName <- useAssay
            }
            tod <- SummarizedExperiment::assay(background, bgAssayName)
        } else {
            tod <- background
        }
        sc <- SoupX::SoupChannel(tod, toc)
    }

    # Adding cluster info
    if (!is.null(cluster)) {
        if (is.character(cluster) & length(cluster) == 1) {
            cluster <- SummarizedExperiment::colData(inSCE)[[cluster]]
            names(cluster) <- colnames(inSCE)
            sc <- SoupX::setClusters(sc, cluster)
        } else if (length(cluster) == ncol(inSCE)) {
            names(cluster) <- colnames(inSCE)
            sc <- SoupX::setClusters(sc, cluster)
        } else {
            stop("Invalid cluster specification")
        }
    } else {
        p <- paste0(date(), " ... Cluster info not supplied. Generating clusters with Scran SNN")
        message(p)
        suppressMessages({
            c <- scran::quickCluster(inSCE, assay.type = useAssay,
                                     method = "igraph")
            inSCE$SoupX_cluster <- c
        })
        sc <- SoupX::setClusters(sc, stats::setNames(inSCE$SoupX_cluster,
                                                    colnames(inSCE)))
    }

    sc <- SoupX::autoEstCont(sc, doPlot = FALSE, tfidfMin = tfidfMin,
                             soupQuantile = soupQuantile,
                             maxMarkers = maxMarkers,
                             contaminationRange = contaminationRange,
                             rhoMaxFDR = rhoMaxFDR, priorRho = priorRho,
                             priorRhoStdDev = priorRhoStdDev,
                             forceAccept = forceAccept)

    out <- SoupX::adjustCounts(sc, method = adjustMethod,
                               roundToInt = roundToInt, tol = tol, pCut = pCut)
    inSCE <- runQuickUMAP(inSCE, useAssay = useAssay, sample = NULL,
                          reducedDimName = "sampleUMAP", verbose = FALSE)
    return(list(sc = sc, out = out,
                umap = SingleCellExperiment::reducedDim(inSCE, "sampleUMAP")))
}

#' @title Get or Set SoupX Result
#' @rdname getSoupX
#' @description S4 method for getting and setting SoupX results that cannot be
#' appended to either \code{rowData(inSCE)} or \code{colData(inSCE)}.
#' @param inSCE A \linkS4class{SingleCellExperiment} object. For getter method,
#' \code{\link{runSoupX}} must have been already applied.
#' @param sampleID Character vector. For getter method, the samples that should
#' be included in the returned list. Leave this \code{NULL} for all samples.
#' Default \code{NULL}. For setter method, only one sample allowed.
#' @param background Logical. Whether \code{background} was applied when
#' running \code{\link{runSoupX}}. Default \code{FALSE}.
#' @param value Dedicated list object of SoupX results.
#' @return For getter method, a list with SoupX results for specified samples.
#' For setter method, \code{inSCE} with SoupX results updated.
#' @seealso runSoupX, plotSoupXResults
#' @export
#' @examples
#' \dontrun{
#' sce <- importExampleData("pbmc3k")
#' sce <- runSoupX(sce, sample = "sample")
#' soupXResults <- getSoupX(sce)
#' }
setGeneric("getSoupX<-", function(inSCE, sampleID, background = FALSE, value)
    standardGeneric("getSoupX<-") )

#' @title Insert SoupX result to SCE object
#' @rdname getSoupX
#' @export
setGeneric("getSoupX", function(inSCE, sampleID = NULL, background = FALSE)
    standardGeneric("getSoupX") )

#' @title Get or Set SoupX Result
#' @rdname getSoupX
#' @description S4 method for getting and setting SoupX results that cannot be
#' appended to either \code{rowData(inSCE)} or \code{colData(inSCE)}.
#' @param inSCE A \linkS4class{SingleCellExperiment} object. For getter method,
#' \code{\link{runSoupX}} must have been already applied.
#' @param sampleID Character vector. For getter method, the samples that should
#' be included in the returned list. Leave this \code{NULL} for all samples.
#' Default \code{NULL}. For setter method, only one sample allowed.
#' @param background Logical. Whether \code{background} was applied when
#' running \code{\link{runSoupX}}. Default \code{FALSE}.
#' @param value Dedicated list object of SoupX results.
#' @return For getter method, a list with SoupX results for specified samples.
#' For setter method, \code{inSCE} with SoupX results updated.
#' @export
setMethod("getSoupX",
          "SingleCellExperiment",
          function(inSCE,
                   sampleID = NULL,
                   background = FALSE){
    if (isTRUE(background)) {
        all.results <- S4Vectors::metadata(inSCE)$sctk$runSoupX_bg
    } else {
        all.results <- S4Vectors::metadata(inSCE)$sctk$runSoupX
    }
    if (is.null(all.results)) {
        stop("No result from 'SoupX' is found. Please run `runSoupX()` first, ",
             "or check the setting of `background`.")
    }
    results <- all.results
    if (!is.null(sampleID)) {
        if (!all(sampleID  %in% names(all.results))) {
            stop("Sample(s) not found in the results for tool 'SoupX': ",
                 paste(sampleID[!sampleID %in% names(all.results)], 
                       collapse = ", "))
        }
        results <- all.results[sampleID]
    }
    return(results)
})

#' @title Insert SoupX result to SCE object
#' @rdname getSoupX
#' @export
setReplaceMethod("getSoupX",
                 c("SingleCellExperiment"),
                 function(inSCE,
                          sampleID,
                          background = FALSE,
                          value) {
                     if (isTRUE(background)) {
                         inSCE@metadata$sctk$runSoupX_bg[[sampleID]] <- value
                     } else {
                         inSCE@metadata$sctk$runSoupX[[sampleID]] <- value
                     }
                     return(inSCE)
                 })

#' Plot SoupX Result
#' @description This function will generate a combination of plots basing on the
#' correction done by SoupX. For each sample, there will be a UMAP with cluster
#' labeling, followed by a number of UMAPs showing the change in selected top
#' markers. The cluster labeling is what should be used for SoupX to estimate
#' the contamination. The Soup Fraction is calculated by subtracting the gene
#' expression value of the output corrected matrix from that of the original
#' input matrix, and then devided by the input.
#' @param inSCE A \linkS4class{SingleCellExperiment} object. With
#' \code{\link{runSoupX}} already applied.
#' @param sample Character vector. Indicates which sample each cell belongs to.
#' Default \code{NULL}.
#' @param background Logical. Whether \code{background} was applied when
#' running \code{\link{runSoupX}}. Default \code{FALSE}.
#' @param reducedDimName Character. The embedding to use for plotting. Leave it
#' \code{NULL} for using the sample-specific UMAPs generated when running
#' \code{\link{runSoupX}}. Default \code{NULL}.
#' @param plotNCols Integer. Number of columns for the plot grid per sample.
#' Will determine the number of top markers to show together with
#' \code{plotNRows}. Default \code{3}.
#' @param plotNRows Integer. Number of rows for the plot grid per sample. Will
#' determine the number of top markers to show together with \code{plotNCols}.
#' Default \code{2}.
#' @param baseSize Numeric. The base font size for all text. Default 12. Can be
#' overwritten by titleSize, axisSize, and axisLabelSize, legendSize,
#' legendTitleSize. Default \code{8}.
#' @param combinePlot Must be either \code{"all"}, \code{"sample"}, or
#' \code{"none"}. \code{"all"} will combine all plots into a single
#' \code{.ggplot} object, while \code{"sample"} will output a list of plots
#' separated by sample. Default \code{"all"}.
#' @param xlab Character vector. Label for x-axis. Default \code{NULL}.
#' @param ylab Character vector. Label for y-axis. Default \code{NULL}.
#' @param dim1 See \code{\link{plotSCEDimReduceColData}}. Default \code{NULL}.
#' @param dim2 See \code{\link{plotSCEDimReduceColData}}. Default \code{NULL}.
#' @param labelClusters Logical. Whether the cluster labels are plotted. Default
#' \code{FALSE}.
#' @param clusterLabelSize Numeric. Determines the size of cluster label when
#' \code{labelClusters} is set to \code{TRUE}. Default \code{3.5}.
#' @param defaultTheme Logical. Adds grid to plot when \code{TRUE}. Default
#' \code{TRUE}.
#' @param dotSize Numeric. Size of dots. Default \code{0.5}.
#' @param transparency Numeric. Transparency of the dots, values will be from 0
#' to 1. Default \code{1}.
#' @param titleSize Numeric. Size of title of plot. Default \code{15}.
#' @param axisLabelSize Numeric. Size of x/y-axis labels. Default \code{NULL}.
#' @param axisSize Numeric. Size of x/y-axis ticks. Default \code{NULL}.
#' @param legendSize Numeric. Size of legend. Default \code{NULL}.
#' @param legendTitleSize Numeric. Size of legend title. Default \code{NULL}.
#' @return ggplot object of the combination of UMAPs. See description.
#' @seealso runSoupX
#' @export
#' @examples
#' \dontrun{
#' sce <- importExampleData("pbmc3k")
#' sce <- runSoupX(sce, sample = "sample")
#' plotSoupXResults(sce, sample = "sample")
#' }
plotSoupXResults <- function(inSCE,
                            sample = NULL,
                            background = FALSE,
                            reducedDimName=NULL,
                            plotNCols = 3,
                            plotNRows = 2,
                            baseSize=8,
                            combinePlot = c("all", "sample", "none"),
                            xlab=NULL,
                            ylab=NULL,
                            dim1=NULL,
                            dim2=NULL,
                            labelClusters = FALSE,
                            clusterLabelSize = 3.5,
                            defaultTheme=TRUE,
                            dotSize=0.5,
                            transparency=1,
                            titleSize=NULL,
                            axisLabelSize=NULL,
                            axisSize=NULL,
                            legendSize=NULL,
                            legendTitleSize=NULL
                            )
{
    combinePlot <- match.arg(combinePlot)
    sample <- .manageCellVar(inSCE, var = sample)
    samples <- unique(sample)
    results <- getSoupX(inSCE, sampleID = samples, background = background)
    # Doing this redundancy-like step because: If sample given NULL when running
    # runSoupX(), the actual sample label saved will be "all_cells", which users
    # won't know.
    samplePlots <- list()
    for (s in samples) {
        param <- results[[s]]$param
        sampleIdx <- sample == s
        tmpSCE <- inSCE[,sampleIdx]
        markerTable <- results[[s]]$markersUsed
        markerTable <- markerTable[order(markerTable$qval),]
        # Iteratively pop out the top significant marker from each cluster.
        # i.e. Get top marker from c1 to cn, then the second top marker again
        # from c1 to cn, as long as there is still a marker for cn.
        uniqCluster <- unique(markerTable$cluster)
        markerToUse <- character()
        markerClusterMap <- character()
        nMarkerToUse <- plotNCols * plotNRows - 1
        nIter <- 0
        while (length(markerToUse) < nMarkerToUse) {
            nIter <- nIter + 1
            # c is the cluster to look at in this iteration
            c <- uniqCluster[(nIter - 1) %% length(uniqCluster) + 1]
            markerPerCluster <- markerTable[markerTable$cluster == c,]
            topMarker <- markerPerCluster[1, "gene"]
            markerToUse <- c(markerToUse, topMarker)
            markerClusterMap <- c(markerClusterMap, c)
            markerTable <- markerTable[-which(markerTable$gene == topMarker),]
        }
        names(markerClusterMap) <- markerToUse
        # Get the per-sample UMAP if not specifying one
        useRedDim <- reducedDimName
        if (is.null(reducedDimName)) {
            useRedDim <- param$reducedDimName
        }
        plotList <- list(
            scatter_soupXClusters =
                plotSCEDimReduceColData(tmpSCE,
                                        param$cluster,
                                        useRedDim,
                                        title = "Cluster",
                                        labelClusters = labelClusters,
                                        clusterLabelSize = clusterLabelSize,
                                        xlab = xlab,
                                        ylab = ylab,
                                        dim1 = dim1,
                                        dim2 = dim2,
                                        defaultTheme = defaultTheme,
                                        dotSize = dotSize,
                                        transparency = transparency,
                                        baseSize = baseSize,
                                        titleSize = titleSize,
                                        axisLabelSize = axisLabelSize,
                                        axisSize = axisSize,
                                        legendSize = legendSize,
                                        legendTitleSize = legendTitleSize)
            )
        for (g in markerToUse) {
            # Soup fraction was calculated basing on SoupX's original method.
            # Credit to SoupX::plotChangeMap
            oldName <- param$useAssay
            newName <- param$assayName
            old <- colSums(assay(tmpSCE, oldName)[g, , drop = FALSE])
            new <- colSums(assay(tmpSCE, newName)[g, , drop = FALSE])
            relChange = (old - new)/old
            zLims = c(0, 1)
            relChange[which(relChange < zLims[1])] = zLims[1]
            relChange[which(relChange > zLims[2])] = zLims[2]
            relChange[which(is.na(relChange))] = 0
            # Start to generate the plot
            tmpSCE$Soup_Frac <- relChange
            legendTitle <- paste0(markerClusterMap[g], ":", g, ", ", s)
            plotList[[g]] <- plotSCEDimReduceColData(tmpSCE,
                                                     "Soup_Frac",
                                                     useRedDim,
                                                     legendTitle = "Soup_Frac",
                                                     title = legendTitle,
                                                     xlab=xlab,
                                                     ylab=ylab,
                                                     dim1=dim1,
                                                     dim2=dim2,
                                                     defaultTheme=defaultTheme,
                                                     dotSize=dotSize,
                                                     transparency=transparency,
                                                     baseSize=baseSize,
                                                     titleSize=titleSize,
                                                     axisLabelSize=axisLabelSize,
                                                     axisSize=axisSize,
                                                     legendSize=legendSize,
                                                     legendTitleSize=legendTitleSize
                                                     )
        }
        if (combinePlot %in% c("sample", "all")) {
            samplePlots[[s]] <- .ggSCTKCombinePlots(plotList,
                                                    plotNCols)
        } else if (combinePlot == "none") {
            samplePlots[[s]] <- plotList
        }
    }
    finalPlotList <- list(Sample = samplePlots)
    if (combinePlot == "all") {
        finalPlotList <- .ggSCTKCombinePlots(finalPlotList$Sample, ncols = 1)
    }
    if (length(samples) == 1) {
        if (combinePlot %in% c("none", "sample")) {
            finalPlotList <- finalPlotList$Sample[[1]]
        }
    }
    return(finalPlotList)
}

#' Calculate Differential Abundance with FET
#' @details This function will calculate the cell counting and fraction by
#' dividing all cells to groups specified by the arguments, together with
#' statistical summary by performing Fisher Exact Tests (FET).
#' @param inSCE A \code{\link[SingleCellExperiment]{SingleCellExperiment}}
#' object.
#' @param cluster A single \code{character}, specifying the name to store the
#' cluster label in \code{\link{colData}}.
#' @param variable A single \code{character}, specifying the name to store the
#' phenotype labels in \code{\link{colData}}.
#' @param control \code{character}. Specifying one or more categories that can
#' be found in the vector specified by \code{variable}.
#' @param case \code{character}. Specifying one or more categories that can
#' be found in the vector specified by \code{variable}.
#' @param analysisName A single \code{character}. Will be used for naming the
#' result table, which will be saved in metadata slot.
#' @return The original \code{\link[SingleCellExperiment]{SingleCellExperiment}}
#' object with \code{metadata(inSCE)} updated with a list
#' \code{diffAbundanceFET}, containing a new \code{data.frame} for the analysis
#' result, named by \code{analysisName}. The \code{data.frame} contains columns
#' for number and fraction of cells that belong to different cases, as well as
#' "Odds_Ratio", "PValue" and "FDR".
#' @export
#' @examples
#' data("mouseBrainSubsetSCE", package = "singleCellTK")
#' mouseBrainSubsetSCE <- diffAbundanceFET(inSCE = mouseBrainSubsetSCE,
#'                                                 cluster = "tissue",
#'                                                 variable = "level1class",
#'                                                 case = "oligodendrocytes",
#'                                                 control = "microglia",
#'                                                 analysisName = "diffAbundFET")
diffAbundanceFET <- function(inSCE, cluster, variable, control, case,
                             analysisName) {
  if (!inherits(inSCE, "SingleCellExperiment")) {
    stop("'inSCE' should be a SingleCellExperiment object.")
  }
  if (is.null(cluster) ||
      !cluster %in% names(SummarizedExperiment::colData(inSCE))) {
    stop("Argument 'cluster' should be a column name in colData(inSCE).")
  }
  if (is.null(variable) ||
      !variable %in% names(SummarizedExperiment::colData(inSCE))) {
    stop("Argument 'variable' should be a column name in colData(inSCE).")
  }

  cluster <- SummarizedExperiment::colData(inSCE)[, cluster]
  variable <- SummarizedExperiment::colData(inSCE)[, variable]
  if (!all(control %in% variable)) {
    nf1 <- control[which(!control %in% variable)]
    stop("Given 'control' not all found in 'variable': ",
         paste(nf1, collapse = ", "))
  }
  if (!all(case %in% variable)) {
    nf2 <- case[which(!case %in% variable)]
    stop("Given 'case' not all found in 'variable': ",
         paste(nf2, collapse = ", "))
  }
  if (any(control %in% case)) {
    warning("Overlapping variables found in 'control' and 'case'")
  }

  control.lab <- paste(control, collapse=",")
  case.lab <- paste(case, collapse=",")
  label <- rep(NA, length(variable))
  label[variable %in% case] <- case.lab
  label[variable %in% control] <- control.lab
  label <- factor(label, levels=c(control.lab, case.lab))

  res <- matrix(NA, nrow=length(unique(cluster)), ncol=10)
  cluster.label <- sort(unique(cluster))
  for(i in seq_along(cluster.label)) {
    cluster.factor <- factor(ifelse(cluster %in% cluster.label[i],
                                    cluster.label[i], "Other"),
                             levels=c(i, "Other"))

    ta <- table(cluster.factor, label)
    ta.p <- prop.table(ta, 2)
    fet <- stats::fisher.test(ta)
    res[i,] <- c(ta, ta.p, fet$estimate, fet$p.value)
  }
  colnames(res) <- c(paste0("Number of cells in cluster and in ",
                            control.lab),
                     paste0("Number of cells NOT in cluster and in ",
                            control.lab),
                     paste0("Number of cells in cluster and in ",
                            case.lab),
                     paste0("Number of cells NOT in cluster and in ",
                            case.lab),
                     paste0("Fraction of cells in cluster and in ",
                            control.lab),
                     paste0("Fraction of cells NOT in cluster and in ",
                            control.lab),
                     paste0("Fraction of cells in cluster and in ",
                            case.lab),
                     paste0("Fraction of cells NOT in cluster and in ",
                            case.lab),
                     "Odds_Ratio", "Pvalue")
  res <- data.frame(Cluster=cluster.label, res,
                    FDR=stats::p.adjust(res[,"Pvalue"], 'fdr'),
                    check.names=FALSE)
  getDiffAbundanceResults(inSCE, analysisName = analysisName) <- res
  return(inSCE)
}

#' Get/Set diffAbundanceFET result table
#' @rdname getDiffAbundanceResults
#' @param x A \code{\link[SingleCellExperiment]{SingleCellExperiment}}
#' object.
#' @param analysisName A single character string specifying an analysis 
#' performed with \code{\link{diffAbundanceFET}}
#' @param value The output table of \code{\link{diffAbundanceFET}}
#' @return The differential abundance table for getter method, or update the SCE
#' object with new result for setter method. 
#' @export
#' @examples 
#' data("mouseBrainSubsetSCE", package = "singleCellTK")
#' mouseBrainSubsetSCE <- diffAbundanceFET(inSCE = mouseBrainSubsetSCE,
#'                                                 cluster = "tissue",
#'                                                 variable = "level1class",
#'                                                 case = "oligodendrocytes",
#'                                                 control = "microglia",
#'                                                 analysisName = "diffAbund")
#' result <- getDiffAbundanceResults(mouseBrainSubsetSCE, "diffAbund")
setGeneric("getDiffAbundanceResults", signature = "x",
           function(x, analysisName) {
             standardGeneric("getDiffAbundanceResults")
           }
)

#' @rdname getDiffAbundanceResults
#' @export
setMethod("getDiffAbundanceResults", signature(x = "SingleCellExperiment"), 
          function(x, analysisName) {
  result.names <- names(S4Vectors::metadata(x)$sctk$diffAbundanceFET)
  if(!analysisName %in% result.names) {
    stop("The analysis '", analysisName, "' was not found in the results ", 
         "for tool 'diffAbundanceFET'")
  }
  
  results <- S4Vectors::metadata(x)$sctk$diffAbundanceFET[[analysisName]]
  return(results)
})

#' @rdname getDiffAbundanceResults
#' @export
setGeneric("getDiffAbundanceResults<-", function(x, analysisName, value) {
  standardGeneric("getDiffAbundanceResults<-")
  })

#' @rdname getDiffAbundanceResults
#' @export
setReplaceMethod("getDiffAbundanceResults", 
                 signature(x = "SingleCellExperiment"), 
                 function(x, analysisName, value) {
  S4Vectors::metadata(x)$sctk$diffAbundanceFET[[analysisName]] <- value
  return(x)
})

#' Plot the differential Abundance
#' @details This function will visualize the differential abundance in two given
#' variables, by making bar plots that presents the cell counting and fraction
#' in different cases.
#' @param inSCE A \code{\link[SingleCellExperiment]{SingleCellExperiment}}
#' object.
#' @param cluster A single \code{character}, specifying the name to store the
#' cluster label in \code{\link{colData}}.
#' @param variable A single \code{character}, specifying the name to store the
#' phenotype labels in \code{\link{colData}}.
#' @param combinePlot Must be either "all" or "none". "all" will combine all 
#' plots into a single \code{\link[ggplot2]{ggplot}} object. Default 
#' \code{"all"}.
#' @return When \code{combinePlot = "none"}, a \code{list} with 4 
#' \code{\link[ggplot2]{ggplot}} objects; when \code{combinePlot = "all"}, a 
#' single \code{\link[ggplot2]{ggplot}} object with for subplots. 
#' @export
#' @examples
#' data("mouseBrainSubsetSCE", package = "singleCellTK")
#' plotClusterAbundance(inSCE = mouseBrainSubsetSCE,
#'                      cluster = "tissue",
#'                      variable = "level1class")
plotClusterAbundance <- function(inSCE, cluster, variable, 
                                 combinePlot = c("all", "none")) {
  if (!inherits(inSCE, "SingleCellExperiment")) {
    stop("'inSCE' should be a SingleCellExperiment object.")
  }
  if (is.null(cluster) ||
      !cluster %in% names(SummarizedExperiment::colData(inSCE))) {
    stop("Argument 'cluster' should be a column name in colData(inSCE).")
  }
  if (is.null(variable) ||
      !variable %in% names(SummarizedExperiment::colData(inSCE))) {
    stop("Argument 'variable' should be a column name in colData(inSCE).")
  }
  combinePlot <- match.arg(combinePlot)
  cluster <- SummarizedExperiment::colData(inSCE)[, cluster]
  color_palette <- distinctColors(length(unique(cluster)))

  label <- SummarizedExperiment::colData(inSCE)[, variable]

  cluster.color <- color_palette
    df <- data.frame(Cluster=as.factor(cluster), Sample=as.factor(label))

  g1 <- ggplot2::ggplot(df, ggplot2::aes_string("Cluster")) +
    ggplot2::geom_bar(ggplot2::aes_string(fill="Sample")) +
    ggplot2::theme_classic() +
    ggplot2::scale_y_continuous(expand = c(0, 0))

  g2 <- ggplot2::ggplot(df, ggplot2::aes_string("Cluster")) +
    ggplot2::geom_bar(ggplot2::aes_string(fill="Sample"), position="fill") +
    ggplot2::theme_classic() +
    ggplot2::scale_y_continuous(expand = c(0, 0)) +
    ggplot2:: ylab("Fraction")

  g3 <- ggplot2::ggplot(df, ggplot2::aes_string("Sample")) +
    ggplot2::geom_bar(ggplot2::aes_string(fill="Cluster")) +
    ggplot2::theme_classic() +
    ggplot2::scale_y_continuous(expand = c(0, 0)) +
    ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 45, hjust = 1)) +
    ggplot2::scale_fill_manual(values=cluster.color)

  g4 <- ggplot2::ggplot(df, ggplot2::aes_string("Sample")) +
    ggplot2::geom_bar(ggplot2::aes_string(fill="Cluster"), position="fill") +
    ggplot2::theme_classic() +
    ggplot2::scale_y_continuous(expand = c(0, 0)) +
    ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 45, hjust = 1)) +
    ggplot2::scale_fill_manual(values=cluster.color) +
    ggplot2::ylab("Fraction")
  g <- list(g1, g2, g3, g4)
  if (combinePlot == "all") {
    g <- cowplot::plot_grid(g1, g3, g2, g4, ncol = 2, 
                            align = "hv", axis = "blr")
  } else if (combinePlot == "none") {
    g <- list(g1, g2, g3, g4)
  }
  return(g)
}

# Differential Abundance Tests
library(singleCellTK)
context("Testing differential abundance functions")
data(sceBatches, package = "singleCellTK")

test_that(desc = "Testing diffAbundanceFET", {
    
    sceBatches <- diffAbundanceFET(sceBatches,
                                   cluster = "batch", variable = "cell_type", 
                                   control = "alpha", case = "beta", 
                                   analysisName = "daTest")
    result <- getDiffAbundanceResults(sceBatches, "daTest")
    
    testthat::expect_is(result, "data.frame")
    testthat::expect_equal(nrow(result), length(unique(sceBatches$batch)))
    testthat::expect_equal(ncol(result), 12)
})

test_that(desc = "Testing diffAbundanceFET", {
    plot1 <- plotClusterAbundance(sceBatches,
                                  cluster = "batch", 
                                  variable = "cell_type",
                                  combinePlot = "all")
    testthat::expect_is(plot1, "ggplot")
    
    plot2 <- plotClusterAbundance(sceBatches,
                                  cluster = "batch", 
                                  variable = "cell_type",
                                  combinePlot = "none")
    testthat::expect_is(plot2, "list")
    testthat::expect_is(plot2[[1]], "ggplot")
})

#' @title Subset a SingleCellExperiment object by rows
#' @description Used to peform subsetting of a
#' \linkS4class{SingleCellExperiment} object using a variety of methods that
#' indicate the correct rows to keep. The various methods,
#' \code{index}, \code{bool}, and \code{rowData}, can be used in conjunction
#' with one another. If \code{returnAsAltExp} is set to \code{TRUE},
#' then the returned object will have the same number of rows as the input
#' \code{inSCE} as the subsetted object will be stored in the
#' \code{\link{altExp}} slot.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object.
#' @param index Integer vector. Vector of indicies indicating which rows
#' to keep. If \code{NULL}, this will not be used for subsetting.
#' Default \code{NULL}.
#' @param bool Boolean vector. Vector of \code{TRUE} or \code{FALSE}
#' indicating which rows should be kept. Needs to be the same length as the
#' number of rows in \code{inSCE}. If \code{NULL}, this will not be used
#' for subsetting. Default \code{NULL}.
#' @param rowData Character. An expression that will identify a subset of rows
#' using variables found in the \code{rowData} of \code{inSCE}. For example,
#' if \code{x} is a numeric vector in \code{rowData}, then \code{"x < 5"} will
#' return all rows with x less than 5. Single quotes should be used for
#' character strings. For example, \code{"y == 'yes'"} will return all
#' rows where y is "yes". Multiple expressions can be evaluated by placing them
#' in a vector. For example \code{c("x < 5", "y =='yes'")} will apply both
#' operations for subsetting. If \code{NULL}, this will not be used for
#' subsetting. Default \code{NULL}.
#' @param returnAsAltExp Boolean. If \code{TRUE}, the subsetted
#' \linkS4class{SingleCellExperiment} object will be returned in the
#' \code{altExp} slot of \code{inSCE}. If \code{FALSE}, the subsetted
#' \linkS4class{SingleCellExperiment} object will be directly returned.
#' @param altExpName Character. Name of the alternative experiment object to
#' add if \code{returnAsAltExp = TRUE}. Default \code{subset}.
#' @param prependAltExpName Boolean. If \code{TRUE}, \code{altExpName} will
#' be added to the beginning of the assay names in the \code{altExp} object.
#' This is only utilized if \code{returnAsAltExp = TRUE}. Default \code{TRUE}.
#' @author Joshua D. Campbell
#' @return A \link[SingleCellExperiment]{SingleCellExperiment} object that has
#' been subsetted by rowData.
#' @examples
#' data(scExample)
#'
#' # Set a variable up in the rowData indicating mitochondrial genes
#' rowData(sce)$isMito <- ifelse(grepl("^MT-", rowData(sce)$feature_name),
#'                               "yes", "no")
#' sce <- subsetSCERows(sce, rowData = "isMito == 'yes'")
#' @export
#' @importFrom SummarizedExperiment assays assays<-
subsetSCERows <- function(inSCE, index = NULL, bool = NULL, rowData = NULL,
                          returnAsAltExp = TRUE, altExpName = "subset",
                          prependAltExpName = TRUE) {

  if(is.null(index) & is.null(bool) & is.null(rowData)) {
    stop("At least one of 'index', 'bool', or 'rowData' must be supplied.")
  }
  final.ix <- rep(TRUE, nrow(inSCE))

  # Parse index containing integers
  if(!is.null(index)) {
    if(min(index) < 1 | max(index) > nrow(inSCE)) {
      stop("'index' must contain integers between 1 and the number of rows ",
           "in 'inSCE': ", nrow(inSCE))
    }
    final.ix[!seq(nrow(inSCE)) %in% index] <- FALSE
  }

  # Parse Boolean vector
  if(!is.null(bool)) {
    if(length(bool) != nrow(inSCE) | !is.logical(bool)) {
      stop("'bool' must be a logical vector the same length as the number of ",
           "rows in 'inSCE': ", nrow(inSCE))
    }
    final.ix[!bool] <- FALSE
  }

  # Parse expressions for rowData variables
  if(!is.null(rowData)) {
    for(i in seq_along(rowData)) {
      temp <- eval(parse(text = as.character(rowData[i])),
                   envir = as.data.frame(rowData(inSCE)))
      if(length(temp) != nrow(inSCE) | !is.logical(temp)) {
        stop("The expression ", rowData[i], " did not produce a boolean ",
             "vector the same length as the number of rows in 'inSCE'. ",
             "Please ensure that the spelling of the variable you are ",
             "trying to use matches one of the column names in ",
             "'rowData(inSCE)' and that your expression is valid.")
      }
      final.ix[!temp] <- FALSE
    }
  }

  # Filter object and return in different ways depending on flag
  temp.SCE <- inSCE[final.ix,]
  if(isTRUE(returnAsAltExp)) {
    if(is.null(altExpName) || length(altExpName) > 1
                           || !is.character(altExpName)) {
      stop("'altExpName' needs to be a character of length 1 if the subset
           is going to be saved as an ", "'altExp' object.")
    }
    if(isTRUE(prependAltExpName)) {
      names(assays(temp.SCE)) <- paste0(altExpName, names(assays(temp.SCE)))
    }
    SingleCellExperiment::altExp(inSCE, altExpName) <- temp.SCE
  } else {
    inSCE <- temp.SCE
  }
  return(inSCE)
}

#' @title Subset a SingleCellExperiment object by columns
#' @description Used to peform subsetting of a
#' \linkS4class{SingleCellExperiment} object using a variety of methods that
#' indicate the correct columns to keep. The various methods,
#' \code{index}, \code{bool}, and \code{colData}, can be used in conjunction
#' with one another.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object.
#' @param index Integer vector. Vector of indicies indicating which columns
#' to keep. If \code{NULL}, this will not be used for subsetting.
#' Default \code{NULL}.
#' @param bool Boolean vector. Vector of \code{TRUE} or \code{FALSE}
#' indicating which columns should be kept. Needs to be the same length as the
#' number of columns in \code{inSCE}. If \code{NULL}, this will not be used
#' for subsetting. Default \code{NULL}.
#' @param colData Character. An expression that will identify a subset of
#' columns using variables found in the \code{colData} of \code{inSCE}.
#' For example, if \code{x} is a numeric vector in \code{colData},
#' then \code{"x < 5"} will return all columns with x less than 5.
#' Single quotes should be used for character strings. For example,
#' \code{"y == 'yes'"} will return all columns where y is "yes".
#' Multiple expressions can be evaluated by placing them in a vector.
#' For example \code{c("x < 5", "y =='yes'")} will apply both operations for
#' subsetting. If \code{NULL}, this will not be used for subsetting.
#' Default \code{NULL}.
#' @return A \link[SingleCellExperiment]{SingleCellExperiment} object that has
#' been subsetted by colData.
#' @author Joshua D. Campbell
#' @examples
#' data(scExample)
#' sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
#' @export
subsetSCECols <- function(inSCE, index = NULL, bool = NULL, colData = NULL) {

  if(is.null(index) & is.null(bool) & is.null(colData)) {
    stop("At least one of 'index', 'bool', or 'colData' must be supplied.")
  }
  final.ix <- rep(TRUE, ncol(inSCE))

  # Parse index containing integers
  if(!is.null(index)) {
    if(min(index) < 1 | max(index) > ncol(inSCE)) {
      stop("'index' must contain integers between 1 and the number of columns ",
           "in 'inSCE': ", ncol(inSCE))
    }
    final.ix[!seq(ncol(inSCE)) %in% index] <- FALSE
  }

  # Parse Boolean vector
  if(!is.null(bool)) {
    if(length(bool) != ncol(inSCE) | !is.logical(bool)) {
      stop("'bool' must be a logical vector the same length as the number of ",
           "colmns in 'inSCE': ", ncol(inSCE))
    }
    final.ix[!bool] <- FALSE
  }

  # Parse expressions for colData variables
  if(!is.null(colData)) {
    for(i in seq_along(colData)) {
      temp <- eval(parse(text = as.character(colData[i])),
                   envir = as.data.frame(colData(inSCE)))
      if(length(temp) != ncol(inSCE) | !is.logical(temp)) {
        stop("The expression ", colData[i], " did not produce a boolean ",
             "vector the same length as the number of columns in 'inSCE'. ",
             "Please ensure that the spelling of the variable you are ",
             "trying to use matches one of the column names in ",
             "'colData(inSCE)' and that your expression is valid.")
      }
      final.ix[!temp] <- FALSE
    }
  }

  inSCE <- inSCE[,final.ix]
  return(inSCE)
  }

# Enrichment Analysis
library(singleCellTK)
context("Testing enrichment analysis functions")
data(scExample, package = "singleCellTK")
sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
internetConnection <- suppressWarnings(Biobase::testBioCConnection())

test_that(desc = "Testing wrong getter method usage", {
    testthat::expect_error(getEnrichRResult(sce, "analysis1"),
                           "EnrichR analysis not performed yet")
    getEnrichRResult(sce, "analysis1") <- "placeholder"
    testthat::expect_error(getEnrichRResult(sce, "analysis2"), 
                           '"analysis2" not found in EnrichR analysis names')
})

test_that(desc = "Testing wrong function usage", {
    testthat::expect_error(runEnrichR("character"), 
                           "inSCE has to inherit")
    testthat::expect_error(runEnrichR(sce, "hello", "analysis2"), 
                           "Not all features found in `rownames[(]inSCE[)]`.")
    testthat::expect_error(runEnrichR(sce, rownames(sce)[1:5], "analysis2", 
                                      by="ensembl"), 
                           "`by` not found in rowData[(]inSCE[)].")
    testthat::expect_error(runEnrichR(sce, rownames(sce)[1:5], "analysis2", 
                                      by="feature_name"), 
                           "in `rowData[(]inSCE[)][$]feature_name`.")
    testthat::expect_error(runEnrichR(sce, rownames(sce)[1:5], "analysis2", 
                                      featureName = "sample"), 
                           "featureName not found in")
    testthat::expect_error(runEnrichR(sce, rownames(sce)[1:5], "analysis2", 
                                      featureName = c("gene1", "gene2")), 
                           "Invalid featureName specification.")
    testthat::expect_error(runEnrichR(sce, rownames(sce)[1:5], "analysis2", 
                                      featureName = c("gene1", "gene2")), 
                           "Invalid featureName specification.")
    
    testthat::skip_if_not(internetConnection)
    testthat::expect_error(runEnrichR(sce, rownames(sce)[1:5], "analysis2", 
                                      featureName = "feature_name",
                                      db = "db1"), 
                           "db1 were not found in Enrichr")
})

test_that(desc = "Testing correct function usage", {
    testthat::skip_if_not(internetConnection)
    sce <- runEnrichR(sce, rownames(sce)[1:5], "analysis2", 
                      featureName = "feature_name",
                      db = "HDSigDB_Human_2021")
    testthat::expect_true("analysis2" %in% 
                              names(metadata(sce)$sctk$runEnrichR))
    res <- getEnrichRResult(sce, "analysis2")
    testthat::expect_gt(ncol(res$result), 0)
})

context("misc functions")

### this code runs outside of test_that({})
# data(scExample, package = "singleCellTK")
# sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")

test_that("summarizeSCE", {
  data(scExample, package = "singleCellTK")
  sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
  ta <- summarizeSCE(sce, sample = NULL)
  expect_is(ta, "data.frame")
})

test_that(desc = "Testing sampleSummaryStats", {
  data(scExample)
  sce <- sampleSummaryStats(sce, simple = FALSE)
  expect_true("sctk" %in% names(metadata(sce)))
  expect_is(metadata(sce)$sctk$sample_summary$qc_table,
            "matrix")
  expect_is(getSampleSummaryStatsTable(sce, statsName = "qc_table"),
            "matrix")
})


test_that(desc = "Testing subsetSCECols", {
  data(scExample)
  sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
  expect_true(sum(colData(sce)$type == "EmptyDroplet") == 0)
})

test_that(desc = "Testing subsetSCERows", {
  data(scExample)
  rowData(sce)$isMito <- ifelse(grepl("^MT-", rowData(sce)$feature_name),"yes", "no")
  sce <- subsetSCERows(sce, rowData = "isMito == 'yes'")
  expect_true(length(altExps(sce)) == 1)
})


test_that(desc = "Testing runVAM", {
  data(scExample)
  sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
  sce <- scaterlogNormCounts(sce, assayName = "logcounts")
  sce <- importGeneSetsFromMSigDB(inSCE = sce,
                                  categoryIDs = "H",
                                  species = "Homo sapiens",
                                  mapping = "gene_symbol",
                                  by = "feature_name")

  sce <- runVAM(inSCE = sce, geneSetCollectionName = "H", useAssay = "logcounts")
  expect_true(validObject(reducedDim(sce)))
})


test_that(desc = "Testing runGSVA", {
  data(scExample)
  sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
  sce <- scaterlogNormCounts(sce, assayName = "logcounts")
  sce <- importGeneSetsFromMSigDB(inSCE = sce,
                                  categoryIDs = "H",
                                  species = "Homo sapiens",
                                  mapping = "gene_symbol",
                                  by = "feature_name")

  sce <- runGSVA(inSCE = sce, geneSetCollectionName = "H", useAssay = "logcounts")
  expect_true(validObject(reducedDim(sce)))
})

#' Example Single Cell RNA-Seq data in SingleCellExperiment Object, GSE60361
#' subset
#'
#' A subset of 30 cells from a single cell RNA-Seq experiment from Zeisel, et
#' al. Science 2015. The data was produced from cells from the mouse
#' somatosensory cortex (S1) and hippocampus (CA1). 15 of the cells were
#' identified as oligodendrocytes and 15 of the cell were identified as
#' microglia.
#'
#' @name mouseBrainSubsetSCE
#' @docType data
#' @format SingleCellExperiment
#' @source DOI: 10.1126/science.aaa1934
#' @keywords datasets
#' @usage data("mouseBrainSubsetSCE")
#' @return A subset of 30 cells from a single cell RNA-Seq experiment
#' @examples
#' data("mouseBrainSubsetSCE")
"mouseBrainSubsetSCE"

#' Example Single Cell RNA-Seq data in SingleCellExperiment Object,
#' subset of 10x public dataset
#' @description 
#' https://support.10xgenomics.com/single-cell-gene-expression/datasets/2.1.0/pbmc4k
#' A subset of 390 barcodes and top 200 genes were included in this example.
#' Within 390 barcodes, 195 barcodes are empty droplet, 150 barcodes are cell
#' barcode and 45 barcodes are doublets predicted by scrublet and doubletFinder
#' package. This example only serves as a proof of concept and a tutoriol on how
#' to run the functions in this package. The results should not be used for
#' drawing scientific conclusions.

#' @name sce
#' @docType data
#' @format A \link[SingleCellExperiment]{SingleCellExperiment} object.
#' @keywords datasets
#' @usage data("scExample")
#' @return Example Single Cell RNA-Seq data in SingleCellExperiment Object,
#' subset of 10x public dataset
#' @examples
#' data("scExample")
"sce"

#' Example Single Cell RNA-Seq data in SingleCellExperiment object, with
#' different batches annotated
#'
#' Two batches of pancreas scRNAseq dataset are combined with their original
#' counts. Cell types and batches are annotated in `colData(sceBatches)`.
#' Two batches came from Wang, et al., 2016, annotated as `'w'`; and Xin, et
#' al., 2016, annotated as `'x'`. Two common cell types, `'alpha'` and
#' `'beta'`, that could be found in both original studies with relatively
#' large population were kept for cleaner demonstration.
#' @usage data('sceBatches')
#' @return Example Single Cell RNA-Seq data in SingleCellExperiment object, with
#' different batches annotated
"sceBatches"

#' Stably Expressed Gene (SEG) list obect, with SEG sets for human and mouse.
#'
#' The two gene sets came from dataset called `segList` of package `scMerge`.
#' @name SEG
#' @docType data
#' @format list, with two entries \code{"human"} and \code{"mouse"}, each is a
#' charactor vector.
#' @source \code{data('segList', package='scMerge')}
#' @keywords datasets
#' @usage data('SEG')
#' @return Stably Expressed Gene (SEG) list obect, with SEG sets for human and mouse.
#' @examples
#' data('SEG')
#' humanSEG <- SEG$human
"SEG"

#' MSigDB gene get Category table
#'
#' A table of gene set categories that can be download from MSigDB. The
#' categories and descriptions can be found here:
#' https://www.gsea-msigdb.org/gsea/msigdb/collections.jsp. The IDs in the
#' first column can be used to retrieve the gene sets for these categories
#' using the \link{importGeneSetsFromMSigDB} function.

#' @name msigdb_table
#' @docType data
#' @format A data.frame.
#' @keywords datasets
#' @usage data("msigdb_table")
#' @return A table of gene set categories
#' @examples
#' data("msigdb_table")
"msigdb_table"

#' List of mitochondrial genes of multiple reference
#' 
#' A list of gene set that contains mitochondrial genes of multiple reference
#' (hg38, hg19, mm10 and mm9). It contains multiple types of gene identifier:
#' gene symbol, entrez ID, ensemble ID and ensemble transcript ID. It's used 
#' for the function 'importMitoGeneSet'. 

#' @name MitoGenes
#' @docType data
#' @format A list
#' @keywords datasets
#' @usage data("MitoGenes")
#' @return List of mitochondrial genes of multiple reference
#' @examples
#' data("MitoGenes")
"MitoGenes"

#' Plot dimensionality reduction from computed metrics including PCA, ICA, tSNE
#' and UMAP
#'
#' @param inSCE Input SCE object
#' @param useReduction Reduction to plot. Default is \code{"PCA"}.
#' @param showLegend If legends should be plotted or not
#' @param xDim Numeric value indicating the dimension to use for X-axis.
#'  Default is 1 (refers to PC1).
#' @param yDim Numeric value indicating the dimension to use for Y-axis.
#'  Default is 2 (refers to PC2).
#' @param xAxisLabel Specify the label for x-axis. Default is \code{NULL} which
#' will specify the label as 'x'.
#' @param yAxisLabel Specify the label for y-axis. Default is \code{NULL} which
#' will specify the label as 'y'.
#' @return plot object
#' @export
#' @examples
#' data("mouseBrainSubsetSCE", package = "singleCellTK")
#' plotDimRed(mouseBrainSubsetSCE, "PCA_logcounts")
plotDimRed <- function(inSCE, useReduction = "PCA",
                       showLegend = FALSE,
                       xDim = 1,
                       yDim = 2,
                       xAxisLabel = NULL,
                       yAxisLabel = NULL) {
  dimRed <- reducedDim(inSCE, type = useReduction)

  x <- dimRed[, xDim]
  y <- dimRed[, yDim]

  dimRedPlot <- ggplot2::ggplot() +
    ggplot2::geom_point(ggplot2::aes(x = x, y = y))
  dimRedPlot <- .ggSCTKTheme(dimRedPlot)

  if(!is.null(xAxisLabel)){
    dimRedPlot <- dimRedPlot + ggplot2::xlab(xAxisLabel)
  }
  else{
    dimRedPlot <- dimRedPlot + ggplot2::xlab(colnames(dimRed)[xDim])
  }

  if(!is.null(yAxisLabel)){
    dimRedPlot <- dimRedPlot + ggplot2::ylab(yAxisLabel)
  }
  else{
    dimRedPlot <- dimRedPlot + ggplot2::ylab(colnames(dimRed)[yDim])
  }

  return(dimRedPlot)
}

shinyPanelvam <- fluidPage(

  tags$script("Shiny.addCustomMessageHandler('close_dropDownPathway', function(x){
                  $('html').click();
                });"),

  tags$div(
    class = "container",
    h1("Pathway Analysis"),
    h5(tags$a(href = paste0(docs.artPath, "pathwayAnalysis.html"),
              "(help)", target = "_blank")),

    sidebarLayout(
      sidebarPanel(
        selectizeInput(
          inputId = "vamAssay", 
          label = "Select input matrix:", 
          choices = NULL, 
          selected = NULL, 
          multiple = FALSE,
          options = NULL),
        #uiOutput("vamAssay"),

        selectInput(
                    inputId = "pathway",
                    label = "Select Method: ",
                    choices = c(
                      "VAM" = "VAM",
                      "GSVA" = "GSVA"
                    )
        ),

       #uiOutput("selectPathwayGeneLists"),
       selectizeInput("PathwayGeneLists", "Select Geneset Collection:",
                      choices = "Import geneset before using", multiple = FALSE),
       actionLink("pathwayImportGS", "Import Gene Sets", icon = icon("upload")),
       br(),

       conditionalPanel(
         condition = "input.pathway == 'VAM'",
         checkboxInput("vamCenterParameter", "Select center value",
                       value = TRUE),
         checkboxInput("vamGammaParameter", "Select gamma value", 
                       value = TRUE),
       ),

       actionButton("pathwayRun", "Run"),
       tags$hr(),
       #h3("Save results:"),
       #downloadButton("downloadPathway", "Download Results")

       ),

      mainPanel(

        dropdown(
          fluidRow(
            column(
              12,
              fluidRow(actionBttn(inputId = "closeDropDownPathway", 
                                  label = NULL, style = "simple", 
                                  color = "danger", icon = icon("times"), 
                                  size = "xs"), 
                       align = "right"),
              
              selectizeInput("pathwayRedDimNames", 
                             "Select score matrix which you want to plot:", 
                             choices = NULL, 
                             multiple = FALSE),
              selectizeInput("pathwayPlotGS", "Select Geneset:",
                             choices = "", multiple = FALSE),
              selectInput(inputId = 'pathwayPlotVar',
                          label = 'Select condition of interest to group data: ',
                          choices = clusterChoice,
                          multiple = FALSE),
              checkboxInput("pathwayPlotBoxplot", "Add box plot", 
                            value = FALSE),
              checkboxInput("pathwayPlotViolinplot", "Add violin plot", 
                            value = TRUE),
              checkboxInput("pathwayPlotDots", "Add dots", 
                            value = TRUE),
              pickerInput(
                inputId = "pathwayPlotSummary",
                label = "Select Summary parameter: ",
                choices = c("mean", "median"), 
                selected = "median"),
              
              actionBttn(
                inputId = "pathwayPlot",
                label = "Update Plot",
                style = "bordered",
                color = "primary",
                size = "sm"
              ),
              
            )
          ),
          
          #tags$style(".btn-custom {background-color: #e5e5e5; ;}"),
          #label = "Plot Options",
          inputId = "dropDownPathway",
          icon = icon("cog"),
          status = "primary",
          circle = FALSE,
          inline = TRUE
        ),
        shinyjqui::jqui_resizable(plotOutput("pathwayPlot"))
      )
    )
  )
)

doubletFinderHelpModal <- function() {
  modalDialog(
    tags$style(HTML("
      div {
        word-wrap: break-word;
      }
      ")),
    tags$div(
      h3("Doublet Finder Parameters"),
      fluidRow(
        column(4, tags$b("Parameter Name")),
        column(8, tags$b("Description"))
      ),
      tags$hr(),
      fluidRow(
        column(4, "seuratNfeatures"),
        column(8, "Integer. Number of highly variable genes to use. Default 2000.")
      ),
      tags$hr(),
      fluidRow(
        column(4, "seuratRes"),
        column(8, 'Numeric vector. The resolution parameter used in seurat, which adjusts the number of 
               clusters determined via the algorithm. Default 1.5.')
      ),
      tags$hr(),
      fluidRow(
        column(4, "formationRate"),
        column(8, "Doublet formation rate used within algorithm. Default 0.075.")
      ),
      tags$hr(),
      fluidRow(
        column(4, "seuratPcs"),
        column(8, "Numeric vector. The PCs used in seurat function to determine number of clusters. Default 1:15.")
      ),
      tags$hr(),
      fluidRow(
        column(4, "verbose"),
        column(8, "Check off to print messages from Seurat and DoubletFinder in the console.")
      ),
    )
  )
}

#' @title Run Cluster Summary Metrics
#' @description Calculates the mean expression of percent of cells that express the
#' given genes for each cluster
#'
#' @param inSCE The single cell experiment to use.
#' @param useAssay The assay to use.
#' @param featureNames A string or vector of strings with each gene to aggregate.
#' @param displayName A string that is the name of the column used for genes.
#' @param groupNames The name of a colData entry that can be used as groupNames.
#' @param scale Option to scale the data. Default: \code{FALSE}. Selected assay will not be scaled. 
#' @return A dataframe with mean expression and percent of cells in cluster that 
#' express for each cluster.
#' @examples
#' data("scExample")
#' runClusterSummaryMetrics(inSCE=sce, useAssay="counts", featureNames=c("B2M", "MALAT1"), 
#' displayName="feature_name", groupNames="type")
#' @export

runClusterSummaryMetrics <- function(inSCE, useAssay="logcounts", featureNames, displayName=NULL, groupNames="cluster", scale = FALSE){
  if(isTRUE(scale)){
    runNormalization(inSCE=inSCE, useAssay=useAssay, scale = TRUE, normalizationMethod = NULL, transformation = NULL, 
                     pseudocountsBeforeNorm = NULL, pseudocountsBeforeTransform = NULL)
  }
  if (!groupNames %in% names(SingleCellExperiment::colData(inSCE))) {
    stop("Specified variable '", groupNames, "' not found in colData(inSCE)")
  }
  if (!is.null(displayName)) {
    dimnames(inSCE)[[1]] <- rowData(inSCE)[[displayName]]
    dimnames(assay(inSCE, i=useAssay, withDimnames=FALSE))[[1]] <- rowData(inSCE)[[displayName]]
    falseGenes <- setdiff(featureNames, rowData(inSCE)[[displayName]])
    featureNames <- intersect(featureNames, rowData(inSCE)[[displayName]])
    warning <- paste0("rowData(inSCE)$", displayName)
  }
  else {
    falseGenes <- setdiff(featureNames, dimnames(inSCE)[[1]])
    featureNames <- intersect(featureNames, dimnames(inSCE)[[1]])
    warning <- "dimnames"
  }
  
  if (length(featureNames) == 0) {
    stop("All genes in '", toString(falseGenes), "' not found in ", warning)
  }
  if (length(falseGenes) > 0) {
    warning("Specified genes '", toString(falseGenes), "' not found in ", warning)
  }
  
  tempSCE <- inSCE[featureNames, ]

  
  if(isTRUE(scale)){
    tempSCE <- runNormalization(inSCE=tempSCE, outAssayName = "scaled", useAssay=useAssay,scale = TRUE, normalizationMethod = NULL, transformation = NULL,
                     pseudocountsBeforeNorm = NULL, pseudocountsBeforeTransform = NULL)
    useAssay <- "scaled"
  }
  
  avgExpr <- assay(scuttle::aggregateAcrossCells(tempSCE, ids=SingleCellExperiment::colData(inSCE)[,groupNames], 
                                                            statistics="mean", use.assay.type=useAssay, 
                                                 subset.row=NULL))

  
  
  percExpr <- assay(scuttle::aggregateAcrossCells(tempSCE, ids=SingleCellExperiment::colData(inSCE)[,groupNames], 
                                                             statistics="prop.detected", use.assay.type=useAssay, 
                                                  subset.row=NULL))
  

  df <- data.frame(featureNames = featureNames)
  df$avgExpr <- avgExpr
  df$percExpr <- percExpr
  return(df)

}

library(singleCellTK)

test_that(desc = "Testing runClusterSummaryMetrics.R", {
  data("scExample")
  
  B2M <- runClusterSummaryMetrics(sce, useAssay="counts", featureNames=c("B2M"), displayName="feature_name", groupNames="type")
  percExpr <- c(1, 0, 1)
  aveExpr <- c(94, 2, 54)
  
  testthat::expect_true(identical(floor(B2M$percExpr[1:3]), percExpr) & 
                          
                          identical(floor(B2M$avgExpr[1:3]), aveExpr))
  
  testthat::expect_error(runClusterSummaryMetrics(sce, useAssay="counts", featureNames=c("B2M"), displayName="feature_name", groupNames="howdy"),
                         "Specified variable 'howdy' not found in colData(inSCE)", fixed=TRUE)
  
  testthat::expect_warning(runClusterSummaryMetrics(sce, useAssay="counts", featureNames=c("B2M", "applesauce"), displayName="feature_name", groupNames="type"),
                         "Specified genes 'applesauce' not found in rowData(inSCE)$feature_name", fixed=TRUE)
  
  testthat::expect_error(runClusterSummaryMetrics(sce, useAssay="counts", featureNames=c("applesauce", "cowboy"), displayName="feature_name", groupNames="type"),
                         "All genes in 'applesauce, cowboy' not found in rowData(inSCE)$feature_name", fixed=TRUE)
})

#' Run normalization/transformation with various methods
#' @description 
#' Wrapper function to run any of the integrated normalization/transformation
#' methods in the singleCellTK. The available methods include 'LogNormalize',
#' 'CLR', 'RC' and 'SCTransform' from Seurat, 'logNormCounts and 'CPM' from
#' Scater. Additionally, users can 'scale' using Z.Score, 'transform' using
#' log, log1p and sqrt, add 'pseudocounts' and trim the final matrices
#' between a range of values.
#'
#' @param inSCE Input \code{SingleCellExperiment} object.
#' @param useAssay Specify the name of the assay that should be used.
#' @param outAssayName Specify the name of the new output assay.
#' @param normalizationMethod Specify a normalization method from `LogNormalize`,
#'  `CLR`, `RC` and `SCTransform` from Seurat or `logNormCounts` and `CPM` from
#'  scater packages. Default \code{NULL} is set which will not run any
#'  normalization method.
#' @param scale Logical value indicating if the data should be scaled using
#'  Z.Score. Default \code{FALSE}.
#' @param seuratScaleFactor Specify the `scaleFactor` argument if a Seurat
#'  normalization method is selected. Default is \code{10000}. This parameter
#'  will not be used if methods other than seurat are selected.
#' @param transformation Specify the transformation options to run on the
#'  selected assay. Options include `log2` (base 2 log transformation),
#'  `log1p` (natural log + 1 transformation) and `sqrt` (square root). Default
#'  value is \code{NULL}, which will not run any transformation.
#' @param pseudocountsBeforeNorm Specify a numeric pseudo value that should be added
#'  to the assay before normalization is performed. Default is \code{NULL},
#'  which will not add any value.
#' @param pseudocountsBeforeTransform Specify a numeric pseudo value that should be
#'  added to the assay before transformation is run. Default is \code{NULL},
#'  which will not add any value.
#' @param trim Specify a vector of two numeric values that should be used
#'  as the upper and lower trim values to trim the assay between these two
#'  values. For example, \code{c(10,-10)} will trim the values between 10
#'  and -10. Default is \code{NULL}, which will not trim the data assay.
#' @param verbose Logical value indicating if progress messages should be
#' displayed to the user. Default is \code{TRUE}.
#'
#' @return Output SCE object with new normalized/transformed assay stored.
#' @export
#'
#' @examples
#' data(sce_chcl, package = "scds")
#' sce_chcl <- runNormalization(
#'  inSCE = sce_chcl,
#'  normalizationMethod = "LogNormalize",
#'  useAssay = "counts",
#'  outAssayName = "logcounts")
runNormalization <- function(inSCE,
                             useAssay = "counts",
                             outAssayName = "logcounts",
                             normalizationMethod = "logNormCounts",
                             scale = FALSE,
                             seuratScaleFactor = 10000,
                             transformation = NULL,
                             pseudocountsBeforeNorm = NULL,
                             pseudocountsBeforeTransform = NULL,
                             trim = NULL,
                             verbose = TRUE
                             ){
  seuratMethods <- c("LogNormalize", "CLR", "RC", "SCTransform")
  scaterMethods <- c("logNormCounts", "CPM")
  scanpyMethods <- c("NormalizeTotal")
  tempAssay <- NULL
  tag <- "normalized"

  #Perform 'Pseudocounts' before Normalization
  if(!is.null(pseudocountsBeforeNorm)){
    tempAssay <- assay(inSCE, useAssay)
    tempAssay <- tempAssay + pseudocountsBeforeNorm
    assay(inSCE, useAssay) <- tempAssay

    if(verbose)
      message("Added ", pseudocountsBeforeNorm, " to input matrix before normalizing data.")
  }

  #Normalization (if applicable)
  if(is.null(normalizationMethod)){
    #No normalizationMethod selected - Select the useAssay to perform other transformations
    tempAssay <- assay(inSCE, useAssay)
  }
  else{
    tempSCE <- NULL

    #Perform 'Normalization' - normalizationMethod is selected
    if(normalizationMethod %in% seuratMethods){
      if(normalizationMethod == "SCTransform"){
        tempSCE <- runSeuratSCTransform(
          inSCE = inSCE,
          normAssayName = outAssayName,
          useAssay = useAssay,
          verbose = verbose
        )
        tag <- "transformed"
      }
      else{
        tempSCE <- runSeuratNormalizeData(
          inSCE = inSCE,
          normalizationMethod = normalizationMethod,
          useAssay = useAssay,
          normAssayName = outAssayName,
          scaleFactor = seuratScaleFactor,
          verbose = verbose
        )
        if(normalizationMethod %in% c("LogNormalize", "CLR")){
          tag <- "transformed"
        }
      }
      tempAssay <- assay(tempSCE, outAssayName)
    }
    else if(normalizationMethod %in% scaterMethods){
      tempSCE <- do.call(
        paste0("scater", normalizationMethod),
        list(
          inSCE = inSCE,
          assayName = outAssayName,
          useAssay = useAssay
        )
      )
      tempAssay <- assay(tempSCE, outAssayName)
      if(normalizationMethod == "logNormCounts"){
        tag <- "transformed"
      }
    }
    else if(normalizationMethod %in% scanpyMethods){
      tempSCE <- do.call(
        "runScanpyNormalizeData",
        list(
          inSCE = inSCE,
          normAssayName = outAssayName,
          useAssay = useAssay
        )
      )
      tempAssay <- assay(tempSCE, outAssayName)
      tag <- "transformed"
    }
    else{
      stop("Specified normalization method '", normalizationMethod, "' not found.")
    }

    if(verbose)
      message("Normalization performed using ", normalizationMethod, " method.")
  }

  #Perform 'Pseudocounts' before Transformation
  if(!is.null(pseudocountsBeforeTransform)){
    tempAssay <- tempAssay + pseudocountsBeforeTransform

    if(verbose)
      message("Added ", pseudocountsBeforeTransform, " to input matrix before transforming data.")
  }

  #Perform 'Transformation'
  if("log2" %in% transformation){
    tempAssay <- log2(tempAssay)
    tag <- "transformed"

    if(verbose)
      message("Log2 transformation performed on the input data.")
  }

  if("log1p" %in% transformation){
    tempAssay <- log1p(tempAssay)
    tag <- "transformed"

    if(verbose)
      message("Log1p transformation (natural log + 1) performed on the input data.")
  }

  if("sqrt" %in% transformation){
    tempAssay <- sqrt(tempAssay)
    tag <- "transformed"

    if(verbose)
      message("Sqrt transformation (square root) performed on the input data.")
  }

  #Perform 'Scale'
  if(scale){
    tempAssay <- computeZScore(counts = tempAssay)
    tag <- "scaled"

    if(verbose)
      message("Z.Score scaling performed on the input data.")
  }

  #Perform 'Trim'
  if(!is.null(trim)){
    tempAssay <- trimCounts(tempAssay, c(trim[1], trim[2]))

    if(verbose)
      message("Data trimmed between ", trim[1], " and ", trim[2], ".")
  }

  expData(inSCE, outAssayName, tag = tag, altExp = FALSE) <- tempAssay

  return(inSCE)
}

#' Run the single cell analysis app
#'
#' Use this function to run the single cell analysis app.
#'
#' @param inSCE Input \linkS4class{SingleCellExperiment} object.
#' @param includeVersion Include the version number in the SCTK header. The
#' default is TRUE.
#' @param theme The bootswatch theme to use for the singleCellTK UI. The default
#' is 'flatly'.
#'
#' @import GSVAdata Biobase DelayedArray
#'
#' @return The shiny app will open
#' @export
#' @examples
#' \dontrun{
#' #Upload data through the app
#' singleCellTK()
#'
#' # Load the app with a SingleCellExperiment object
#' data("mouseBrainSubsetSCE")
#' singleCellTK(mouseBrainSubsetSCE)
#' }
singleCellTK <- function(inSCE=NULL, includeVersion=TRUE, theme='yeti') {
  appDir <- system.file("shiny", package = "singleCellTK")
  if (!is.null(inSCE) & is.null(rownames(inSCE))){
    stop("ERROR: No row names (gene names) found.")
  }
  shiny::shinyOptions(inputSCEset = inSCE)
  shiny::shinyOptions(includeVersion = includeVersion)
  shiny::shinyOptions(theme = theme)
  shiny::runApp(appDir, display.mode = "normal")
}

shinyPanelPathway <- fluidPage(
  tags$div(
    class = "container",
    h1("Pathway Activity Analysis"),
    h5(tags$a(href = paste0(docs.artPath, "pathwayAnalysis.html"),
              "(help)", target = "_blank")),
    sidebarLayout(
      sidebarPanel(
        selectizeInput(
          inputId = "pathwayAssay", 
          label = "Select input matrix:", 
          choices = NULL, 
          selected = NULL, 
          multiple = FALSE,
          options = NULL),
        #uiOutput("pathwayAssay"),
        #selectInput("pathwayAssay", "Select Assay:", currassays),
        selectInput("pathwayMethod", "Select Method:", "GSVA"),
        uiOutput("selectPathwayGeneLists"),
        uiOutput("selectNumTopPaths"),
        selectInput("pathwayPlotVar",
                    "Select Condition(s) of interest for plot:", clusterChoice,
                    multiple = TRUE),
        radioButtons("pathwayOutPlot", "Plot Type:", c("Heatmap", "Violin")),
        withBusyIndicatorUI(actionButton("pathwayRun", "Run")),
        tags$hr(),
        h3("Save pathway results:"),
        actionButton("savePathway", "Save Pathways"),
        downloadButton("downloadPathway", "Download Pathway Results")
      ),
      mainPanel(
        tabsetPanel(
          tabPanel(
            "Plot",
            shinyjqui::jqui_resizable(plotOutput("pathwayPlot"))
          ),
          tabPanel(
            "Results Table",
            DT::dataTableOutput("pathwaytable")
          )
        )
      )
    )
  )
)

#' scaterlogNormCounts
#' Uses \link{logNormCounts} to log normalize input data
#' @param inSCE Input SingleCellExperiment object
#' @param assayName New assay name for log normalized data
#' @param useAssay Input assay 
#' @return inSCE Updated SingleCellExperiment object that contains the new log normalized data
#' @export
#' @author Irzam Sarfraz
#' @examples
#' data(sce_chcl, package = "scds")
#' sce_chcl <- scaterlogNormCounts(sce_chcl,"logcounts", "counts")
scaterlogNormCounts <- function(inSCE, 
                                 assayName = "ScaterLogNormCounts", 
                                 useAssay = "counts"){
  inSCE <- scater::logNormCounts(
    x = inSCE, 
    name = assayName,
    exprs_values = useAssay)
  
  inSCE <- expSetDataTag(inSCE = inSCE, 
                         assayType = "normalized", 
                         assays = assayName)
  return(inSCE)
}

shinyPanelCluster <- fluidPage(
  tags$script("Shiny.addCustomMessageHandler('close_dropDownClust', function(x){
                  $('html').click();
                });"),
  tags$div(
    class = "container",
    h1("Clustering"),
    h5(tags$a(href = paste0(docs.artPath, "clustering.html"),
              "(help)", target = "_blank")),
    sidebarLayout(
      sidebarPanel = sidebarPanel(
        # CLUSTERING --> VISUALIZATION
        selectInput("clustAlgo", "Select Algorithm",
                    list("Scran SNN" = c("louvain" = 1, "leiden" = 2, 
                                         "walktrap" = 3, "infomap" = 4, 
                                         "fast greedy" = 5, "label prop" = 6, 
                                         "leading eigen" = 7),
                         "K-Means" = c("Hartigan-Wong" = 8, "Lloyd" = 9,
                                       "MacQueen" = 10),
                         "Seurat" = c("louvain" = 11, "multilevel" = 12,
                                      "SLM" = 13),
                         "Scanpy" = c("louvain" = 14,
                                      "leiden" = 15)),
        ),
        # Scran SNN ####
        conditionalPanel(
          condition = "input.clustAlgo >=1 && input.clustAlgo <= 7",
          selectizeInput(
            inputId = "clustScranSNNMat", 
            label = "Select input matrix:", 
            choices = NULL, 
            selected = NULL, 
            multiple = FALSE,
            options = NULL),
          numericInput("clustScranSNNK", "K value:", 8, min = 1, step = 1),
          numericInput("clustScranSNNd", "Number of Components:",
                       10, min = 1),
          selectInput("clustScranSNNType", "Edge Weight Type:",
                      c("rank", "number", "jaccard"), selected = "rank"),
          conditionalPanel(
            condition = 'input.clustAlgo == 2',
            numericInput("clustScranSNNLeidenReso", "Resolution:",
                         value = 1, min = 0, step = 0.1),
            selectInput("clusterScranSNNLeidenObjFunc", "Objective Function:",
                        c("Constant Potts Model (CPM)" = "CPM",
                          "Modularity" = "modularity"), selected = "CPM")
          ),
          conditionalPanel(
            condition = 'input.clustAlgo == 3',
            numericInput("clustScranSNNWalktrapStep", "Steps:",
                         value = 4, min = 1, step = 1)
          )
        ),
        # K-Means ####
        conditionalPanel(
          "(input.clustAlgo >= 8 && input.clustAlgo <= 10) || input.clustAlgo == 14 || input.clustAlgo == 15",
          selectInput("clustKMeansReddim", "Select A ReducedDim:", currreddim),
          conditionalPanel("(input.clustAlgo >= 8 && input.clustAlgo <= 10)",
                           numericInput("clustKMeansN", "Number of Centers (Clusters):",
                                        value = NULL),
                           numericInput("clustKMeansNIter", "Max Number of Iterations:",
                                        10, min = 2, step = 1),
                           numericInput("clustKMeansNStart", "Number of Random Sets:",
                                        1, min = 1, step = 1)
                           )
        ),
        # Seurat ####
        conditionalPanel(
          "input.clustAlgo >= 11 && input.clustAlgo <= 13",
          selectInput("clustSeuratReddim", "Select A ReducedDim:", currreddim),
          numericInput("clustSeuratDims", "How Many Dimensions to Use:", 10,
                       min = 2, step = 1),
          checkboxInput("clustSeuratGrpSgltn", "Group Singletons",
                        value = TRUE),
          numericInput("clustSeuratRes", "Resolution", 0.8, step = 0.05)
        ),
        # Scanpy ###
        conditionalPanel(
          "input.clustAlgo == 14 || input.clustAlgo == 15",
          numericInput("clustScanpyDims", "No. of dimensions to use:", 10,
                       min = 2, step = 1),
          numericInput("clustScanpyNeighbors", "No. of neigbors:", 15,
                       min = 2, step = 1),
          numericInput("clustScanpyRes", "Resolution:", 0.8, step = 0.05),
          numericInput("clustScanpyIter", "No. of Iterations:", -1, step = 1),
          checkboxInput("clustScanpyWeights", "Use weights from knn graph:",
                        value = FALSE),
          selectInput("clustScanpyCorrMethod", "Correlation method:", c('pearson', 'kendall', 'spearman'))
        ),
        useShinyjs(),
        textInput("clustName", "Name of Clustering Result:",
                  ""),
        withBusyIndicatorUI(actionButton("clustRun", "Run"))
      ),
      mainPanel = mainPanel(
        panel(
          
          fluidRow(
            column(
              width = 3,
              dropdown(
                fluidRow(
                  column(
                    width = 12,
                    fluidRow(actionBttn(inputId = "closeDropDownClust", label = NULL, style = "simple", color = "danger", icon = icon("times"), size = "xs"), align = "right"),
                    radioButtons("clustVisChoicesType", NULL,
                                 c("Select from Current Results:" = 1,
                                   "Select from All Present Annotation:" = 2),
                                 selected = 1, inline = TRUE, ),
                    conditionalPanel(
                      "input.clustVisChoicesType == 1",
                      selectInput("clustVisRes", NULL, "")
                    ),
                    conditionalPanel(
                      "input.clustVisChoicesType == 2",
                      selectInput("clustVisCol", NULL, clusterChoice)
                    ),
                    selectInput("clustVisReddim", "Use Reduction:", currreddim),
                    withBusyIndicatorUI(
                      actionBttn(
                        inputId = "clustPlot",
                        label = "Update",
                        style = "bordered",
                        color = "primary",
                        size = "sm"
                      )
                    )
                  )
                ),
                inputId = "dropDownClust",
                icon = icon("cog"),
                status = "primary",
                circle = FALSE,
                inline = TRUE
              )
            ),
            column(
              width = 9,
              fluidRow(
                column(
                  width = 12,
                  h6(
                    "A scatter plot of the selected low-dimensionality representation of the dataset will be generated, with the selected cluster labeling colored on each dot (cell)."
                  ),
                  h6(
                    "If you are using an expression matrix or subset for calculation, please click on the cog icon on the left to specify the dimensions to plot."
                  )
                ),
                align="center"
              )
            )
          ),
          hr(),
          br(),
          shinyjqui::jqui_resizable(
            plotlyOutput("clustVisPlot")
          )
        )
      )
    )
  ),
  nonLinearWorkflowUI(id = "nlw-cl")
)

#' @title Stores and returns table of SCTK QC outputs to metadata.
#' @rdname getSampleSummaryStatsTable
#' @description  Stores and returns table of QC metrics generated from
#'  QC algorithms within the metadata slot of the SingleCellExperiment object.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object with saved
#' \link{assay} data and/or \link{colData} data. Required.
#' @param statsName A \code{character} value indicating the slot
#' that stores the stats table within the metadata of the
#' SingleCellExperiment object. Required.
#' @param ... Other arguments passed to the function. 
#' @return For \code{getSampleSummaryStatsTable}, A matrix/array object. 
#' Contains a summary table for QC statistics generated from SingleCellTK. For
#' \code{setSampleSummaryStatsTable<-}, A SingleCellExperiment object where the 
#' summary table is updated in the \code{metadata} slot.
#' @examples
#' data(scExample, package = "singleCellTK")
#' sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
#' sce <- sampleSummaryStats(sce, simple = TRUE, statsName = "qc_table")
#' getSampleSummaryStatsTable(sce, statsName = "qc_table")
#' @export
setGeneric("getSampleSummaryStatsTable", function(inSCE, statsName, ...) standardGeneric("getSampleSummaryStatsTable"))

#' @rdname getSampleSummaryStatsTable
#' @param value The summary table for QC statistics generated from SingleCellTK
#' to be added to the SCE object.
setGeneric("setSampleSummaryStatsTable<-", function(inSCE, statsName, ..., value) standardGeneric("setSampleSummaryStatsTable<-"))

#' @title Lists the table of SCTK QC outputs stored within the metadata.
#' @rdname listSampleSummaryStatsTables
#' @description  Returns a character vector of the tables
#' within the metadata slot of the SingleCellExperiment object.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object with saved
#' table within the \link{metadata} data. Required.
#' @param ... Other arguments passed to the function. 
#' @return A character vector. Contains a list of summary tables
#' within the SingleCellExperiment object.
#' @examples
#' data(scExample, package = "singleCellTK")
#' sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
#' sce <- sampleSummaryStats(sce, simple = TRUE, statsName = "qc_table")
#' listSampleSummaryStatsTables(sce)
#' @export
setGeneric("listSampleSummaryStatsTables", function(inSCE, ...) standardGeneric("listSampleSummaryStatsTables"))

.readBarcodes <- function(path,
    header = FALSE,
    colname = "cell_barcode",
    colClasses = "character") {

    res <- data.table::fread(path, header = header, colClasses = colClasses)
    if (ncol(res) == 1) {
        colnames(res) <- colname
    } else {
        warning("'barcodes' file contains >1 columns!",
            " The column names are kept as is.")
    }
    return(res)
}


.readFeatures <- function(path,
    header = FALSE,
    colnames = c("feature_ID", "feature_name", "feature_type"),
    colClasses = "character") {

    res <- data.table::fread(path, header = header)
    if (ncol(res) == 1) {
        colnames(res) <- colnames[1]
    } else if (ncol(res) == 2) {
        colnames(res) <- colnames[seq(2)]
    } else if (ncol(res) == 3) {
        colnames(res) <- colnames
    } else {
        warning("'features' file contains >3 columns!",
            " The column names are kept as is.")
    }
    return(res)
}

#' @importFrom tools file_ext
.readMatrixMM <- function(path, gzipped, class, delayedArray) {

    if (gzipped == "auto") {
        ext <- tools::file_ext(path)
        if (ext == "gz") {
            path <- gzfile(path)
        }
    } else if (isTRUE(gzipped)) {
        path <- gzfile(path)
    }

    mat <- Matrix::readMM(path)
    mat <- methods::as(mat, "CsparseMatrix")

    if (class == "matrix") {
        mat <- as.matrix(mat)
    }

    if (isTRUE(delayedArray)) {
        mat <- DelayedArray::DelayedArray(mat)
    }
    return(mat)
}


# dir <- "outs/filtered_feature_bc_matrix/"
.constructSCEFromCellRangerOutputs <- function(dir,
    sampleName,
    matrixFileName,
    featuresFileName,
    barcodesFileName,
    gzipped,
    class,
    delayedArray) {

    cb <- .readBarcodes(file.path(dir, barcodesFileName))
    fe <- .readFeatures(file.path(dir, featuresFileName))
    ma <- .readMatrixMM(file.path(dir, matrixFileName),
        gzipped = gzipped,
        class = class,
        delayedArray = delayedArray)

    coln <- paste(sampleName, cb[[1]], sep = "_")
    rownames(ma) <- fe[[1]]

    sce <- SingleCellExperiment::SingleCellExperiment(
        assays = list(counts = ma))
    SummarizedExperiment::rowData(sce) <- fe
    SummarizedExperiment::colData(sce) <- S4Vectors::DataFrame(cb,
        column_name = coln,
        sample = sampleName,
        row.names = coln)

    return(sce)
}


.getOutputFolderPath <- function(samplePath, cellRangerOuts, cellRangerOuts2) {
    path <- file.path(samplePath, cellRangerOuts)
    if (dir.exists(path)) {
        return(path)
    }

    if (!is.na(cellRangerOuts2)) {
        path2 <- file.path(samplePath, cellRangerOuts2)
        if (dir.exists(path2)) {
            return(path2)
        } else {
            stop("Invalid path ", path2)
        }
    }

    stop("Invalid path ", path)
}


.checkArgsImportCellRanger <- function(cellRangerDirs,
    sampleDirs,
    sampleNames,
    cellRangerOuts,
    matrixFileNames,
    featuresFileNames,
    barcodesFileNames,
    gzipped) {

    if (any(!(gzipped %in% c("auto", TRUE, FALSE)))) {
        stop("Invalid 'gzipped' argument! Should be one of 'auto',",
            " TRUE, or FALSE")
    }

    if (is.null(cellRangerDirs)) {
        if (is.null(sampleDirs)) {
            stop("'sampleDirs' can not be NULL if 'cellRangerDirs' is NULL!")
        }

        for (i in seq_along(sampleDirs)) {
            if (!dir.exists(sampleDirs[i])) {
                stop("Sample folder ", sampleDirs[i], " does not exist!")
            }
        }

        sampleLength <- length(sampleDirs)

        if (!is.null(sampleNames)) {
            if (length(sampleNames) != sampleLength) {
                stop("'sampleDirs' and 'sampleNames' have unequal lengths!")
            }
        }

        if (!(length(cellRangerOuts) %in% c(0, 1))) {
            if (length(cellRangerOuts) != sampleLength) {
                stop("'sampleDirs' and 'cellRangerOuts' have unequal lengths!")
            }
        }

        if (length(matrixFileNames) != 1) {
            if (length(matrixFileNames) != sampleLength) {
                stop("'sampleDirs' and 'matrixFileNames' have unequal lengths!")
            }
        }

        if (length(featuresFileNames) != 1) {
            if (length(featuresFileNames) != sampleLength) {
                stop("'sampleDirs' and 'featuresFileNames'",
                    " have unequal lengths!")
            }
        }

        if (length(barcodesFileNames) != 1) {
            if (length(barcodesFileNames) != sampleLength) {
                stop("'sampleDirs' and 'barcodesFileNames'",
                    " have unequal lengths!")
            }
        }

        if (gzipped != "auto") {
            if (length(gzipped) != sampleLength && length(gzipped) != 1) {
                stop("'sampleDirs' and 'gzipped' have unequal lengths!")
            }
        }

    } else {

        if (!all(dir.exists(cellRangerDirs))) {
            stop("Invalid cellRangerDirs: ",
                paste(cellRangerDirs[which(!dir.exists(cellRangerDirs))],
                    collapse = ", "))
        }

        if (is.null(sampleDirs)) {
            for (i in seq_along(cellRangerDirs)) {
                if (length(list.dirs(cellRangerDirs[i],
                    recursive = FALSE)) == 0) {
                    warning("Empty cellRangerDir. Skipping ",
                        cellRangerDirs[i])
                }
            }

            # check cellRangerDirs sample length
            sampleLength = 0
            for (i in cellRangerDirs) {
                temp = paste0(i, "/outs")
                if (dir.exists(temp) == TRUE) {
                    sampleLength = sampleLength + 1
                }
                rm(temp)
            }

            #sampleLength <- length(unlist(lapply(cellRangerDirs,
            #    list.dirs, recursive = FALSE)))

            if (!is.null(sampleNames)) {
                if (sampleLength != length(sampleNames)) {
                    stop("The length of 'sampleNames' does not match length of",
                        " subdirectories in 'cellRangerDirs'!")
                }
            }

            if (!(length(cellRangerOuts) %in% c(0, 1))) {
                if (sampleLength != length(cellRangerOuts)) {
                    stop("The length of 'cellRangerOuts' does not match",
                        " length of",
                        " subdirectories in 'cellRangerDirs'!")
                }
            }

            if (length(matrixFileNames) != 1) {
                if (sampleLength != length(matrixFileNames)) {
                    stop("The length of 'matrixFileNames' does not match",
                        " length of",
                        " subdirectories in 'cellRangerDirs'!")
                }
            }

            if (length(featuresFileNames) != 1) {
                if (sampleLength != length(featuresFileNames)) {
                    stop("The length of 'featuresFileNames' does not match",
                        " length of",
                        " subdirectories in 'cellRangerDirs'!")
                }
            }

            if (length(barcodesFileNames) != 1) {
                if (sampleLength != length(barcodesFileNames)) {
                    stop("The length of 'barcodesFileNames' does not match",
                        " length of",
                        " subdirectories in 'cellRangerDirs'!")
                }
            }

            if (gzipped != "auto") {
                if (sampleLength != length(gzipped) && length(gzipped) != 1) {
                    stop("The length of 'gzipped' does not match",
                        " length of",
                        " subdirectories in 'cellRangerDirs'!")
                }
            }
        } else {
            if (length(sampleDirs) != length(cellRangerDirs)) {
                stop("'sampleDirs' and 'cellRangerDirs' have unequal lengths!")
            } else {
                for (i in seq_along(cellRangerDirs)) {
                    paths <- file.path(cellRangerDirs[i], sampleDirs[[i]])
                    for (j in seq_along(paths)) {
                        if (!dir.exists(paths[j])) {
                            stop("Sample folder does not exist!\n",
                                paths[j])
                        }
                    }
                }
            }
            # analogous to length(unlist(sampleDirs))
            sampleLength <- sum(vapply(sampleDirs, length, integer(1)))

            if (!is.null(sampleNames)) {
                if (length(sampleNames) != sampleLength) {
                    stop("'sampleNames' and 'unlist(sampleDirs)' have unequal",
                        " lengths!")
                }
            }

            if (!(length(cellRangerOuts) %in% c(0, 1))) {
                if (length(cellRangerOuts) != sampleLength) {
                    stop("'cellRangerOuts' and 'unlist(sampleDirs)'",
                        " have unequal lengths!")
                }
            }

            if (length(matrixFileNames) != 1) {
                if (length(matrixFileNames) != sampleLength) {
                    stop("'matrixFileNames' and 'unlist(sampleDirs)'",
                        " have unequal lengths!")
                }
            }

            if (length(featuresFileNames) != 1) {
                if (length(featuresFileNames) != sampleLength) {
                    stop("'featuresFileNames' and 'unlist(sampleDirs)'",
                        " have unequal lengths!")
                }
            }

            if (length(barcodesFileNames) != 1) {
                if (length(barcodesFileNames) != sampleLength) {
                    stop("'barcodesFileNames' and 'unlist(sampleDirs)'",
                        " have unequal lengths!")
                }
            }

            if (gzipped != "auto") {
                if (length(gzipped) != sampleLength && length(gzipped) != 1) {
                    stop("'gzipped' and 'unlist(sampleDirs)'",
                        " have unequal lengths!")
                }
            }
        }
    }
}


.getSamplesPaths <- function(cellRangerDirs, samplesDirs) {
    if (is.null(cellRangerDirs)) {
        res <- samplesDirs
    } else {
        if (is.null(samplesDirs)) {
            res <- list.dirs(cellRangerDirs, recursive = FALSE)
        } else {
            res <- vector("list", length = length(cellRangerDirs))
            for (i in seq_along(cellRangerDirs)) {
                res[[i]] <- file.path(cellRangerDirs[i], samplesDirs[[i]])
            }
            res <- unlist(res)
        }
    }
    return(res)
}


.getSampleNames <- function(samplePaths) {
    res <- basename(samplePaths)
    return(res)
}


.getVectorized <- function(arg, len) {
    if (length(arg) == 1) {
        arg <- rep(arg, len)
    }
    return(arg)
}

# main function
.importCellRanger <- function(
    cellRangerDirs,
    sampleDirs,
    sampleNames,
    cellRangerOuts,
    dataType,
    matrixFileNames,
    featuresFileNames,
    barcodesFileNames,
    gzipped,
    class,
    delayedArray,
    rowNamesDedup) {

    .checkArgsImportCellRanger(cellRangerDirs,
        sampleDirs,
        sampleNames,
        cellRangerOuts,
        matrixFileNames,
        featuresFileNames,
        barcodesFileNames,
        gzipped)

    samplePaths <- .getSamplesPaths(cellRangerDirs, sampleDirs)

    res <- vector("list", length = length(samplePaths))

    cellRangerOuts2 <- NA
    if (is.null(cellRangerOuts)) {
        if (dataType == "filtered") {
            cellRangerOuts <- "outs/filtered_gene_bc_matrix"
            cellRangerOuts2 <- "outs/filtered_feature_bc_matrix"
        } else {
            cellRangerOuts <- "outs/raw_gene_bc_matrix"
            cellRangerOuts2 <- "outs/raw_feature_bc_matrix"
        }
    }


    cellRangerOuts <- .getVectorized(cellRangerOuts, length(samplePaths))
    cellRangerOuts2 <- .getVectorized(cellRangerOuts2, length(samplePaths))
    matrixFileNames <- .getVectorized(matrixFileNames, length(samplePaths))
    featuresFileNames <- .getVectorized(featuresFileNames, length(samplePaths))
    barcodesFileNames <- .getVectorized(barcodesFileNames, length(samplePaths))
    gzipped <- .getVectorized(gzipped, length(samplePaths))

    if (is.null(sampleNames)) {
        sampleNames <- .getSampleNames(samplePaths)
    }
    
    for (i in seq_along(samplePaths)) {
        dir <- .getOutputFolderPath(samplePaths[i], cellRangerOuts[i],
            cellRangerOuts2[i])
        scei <- .constructSCEFromCellRangerOutputs(dir,
            sampleName = sampleNames[i],
            matrixFileName = matrixFileNames[i],
            featuresFileName = featuresFileNames[i],
            barcodesFileName = barcodesFileNames[i],
            gzipped = gzipped[i],
            class = class,
            delayedArray = delayedArray)
        res[[i]] <- scei
        
        

    }

    sce <- do.call(SingleCellExperiment::cbind, res)
    
    # Load & Store Cell Ranger Summary into SCE
    metrics_summary <- .importMetricsCellRanger(samplePaths, sampleNames, "outs", "metrics_summary.csv")
    if (ncol(metrics_summary) > 0) {
        sce@metadata$sctk$sample_summary[["cellranger"]] <- metrics_summary
    }
    # sce <- setSampleSummaryStatsTable(sce, "cellranger", metrics_summary)
    
    if (isTRUE(rowNamesDedup)) {
        if (any(duplicated(rownames(sce)))) {
            message("Duplicated gene names found, adding '-1', '-2', ",
                    "... suffix to them.")
        }
        sce <- dedupRowNames(sce)
    }
    
    return(sce)
}

.getCellRangerOutV2 <- function(dataTypeV2, reference) {
    res <- vector("list", length = length(reference))

    for (i in seq_along(reference)) {

        if (dataTypeV2 == 'filtered') {
            res[[i]] <- file.path('outs/filtered_gene_bc_matrices', reference[i])
        } else {
            res[[i]] <- file.path('outs/raw_gene_bc_matrices', reference[i])
        }
    }

    cellRangerOutsV2 <- unlist(res)
    return(cellRangerOutsV2)
}

#' @name importCellRanger
#' @rdname importCellRanger
#' @title Construct SCE object from Cell Ranger output
#' @description Read the filtered barcodes, features, and matrices for all
#'  samples from (preferably a single run of) Cell Ranger output. Import and
#'  combine them
#'  as one big \link[SingleCellExperiment]{SingleCellExperiment} object.
#' @param cellRangerDirs The root directories where Cell Ranger was run. These
#'  folders should contain sample specific folders. Default \code{NULL},
#'  meaning the paths for each sample will be specified in \emph{samples}
#'  argument.
#' @param sampleDirs Default \code{NULL}. Can be one of
#' \itemize{
#'   \item \code{NULL}. All samples within \code{cellRangerDirs} will be
#'    imported. The order of samples will be first determined by the order of
#'    \code{cellRangerDirs} and then by \link{list.dirs}. This is only
#'    for the case where \code{cellRangerDirs} is specified.
#'   \item A list of vectors containing the folder names for samples to import.
#'    Each vector in
#'    the list corresponds to samples from one of \code{cellRangerDirs}.
#'    These names are the same as the folder names under \code{cellRangerDirs}.
#'    This is only for the case where \code{cellRangerDirs} is specified.
#'   \item A vector of folder paths for the samples to import. This is only for
#'    the case where \code{cellRangerDirs} is \code{NULL}.
#' }
#' The cells in the final SCE object will be ordered in the same order of
#'  \code{sampleDirs}.
#' @param sampleNames A vector of user-defined sample names for the samples
#'  to be
#'  imported. Must have the same length as \code{length(unlist(sampleDirs))} if
#'  \code{sampleDirs} is not \code{NULL}. Otherwise, make sure the length and
#'  order match the output of
#'  \code{unlist(lapply(cellRangerDirs, list.dirs, recursive = FALSE))}. Default
#'  \code{NULL}, in which case the folder names will be used as sample names.
#' @param cellRangerOuts Character vector. The intermediate
#'  paths to filtered or raw cell barcode, feature, and matrix files
#'  for each sample. \strong{Supercedes \code{dayaType}}. If \code{NULL},
#'  \code{dataType}
#'  will be used to determine Cell Ranger output directory. If not \code{NULL},
#'  \code{dataType} will be ingored and \code{cellRangerOuts} specifies the
#'  paths. Must have length 1 or the same length as
#'  \code{length(unlist(sampleDirs))} if
#'  \code{sampleDirs} is not \code{NULL}. Otherwise, make sure the length and
#'  order match the output of
#'  \code{unlist(lapply(cellRangerDirs, list.dirs, recursive = FALSE))}.
#'  Reference genome names might need to be
#'  appended for CellRanger version below 3.0.0 if reads were mapped to
#'  multiple genomes when running Cell Ranger pipeline. Probable options
#'  include "outs/filtered_feature_bc_matrix/", "outs/raw_feature_bc_matrix/",
#'  "outs/filtered_gene_bc_matrix/", "outs/raw_gene_bc_matrix/".
#' @param dataType Character. The type of data to import. Can be one of
#'  "filtered" (which is equivalent to
#'  \code{cellRangerOuts = "outs/filtered_feature_bc_matrix/"} or
#'  \code{cellRangerOuts = "outs/filtered_gene_bc_matrix/"}) or "raw" (which
#'  is equivalent to
#'  \code{cellRangerOuts = "outs/raw_feature_bc_matrix/"} or
#'  \code{cellRangerOuts = "outs/raw_gene_bc_matrix/"}). Default
#'  "filtered" which imports the counts for filtered cell barcodes only.
#' @param matrixFileNames Character vector. Filenames for the Market Exchange
#'  Format (MEX) sparse matrix files (matrix.mtx or matrix.mtx.gz files).
#'  Must have length 1 or the same
#'  length as \code{length(unlist(sampleDirs))} if
#'  \code{sampleDirs} is not \code{NULL}. Otherwise, make sure the length and
#'  order match the output of
#'  \code{unlist(lapply(cellRangerDirs, list.dirs, recursive = FALSE))}.
#' @param featuresFileNames Character vector. Filenames for the feature
#'  annotation files. They are usually named \emph{features.tsv.gz} or
#'  \emph{genes.tsv}. Must have length 1 or the same
#'  length as \code{length(unlist(sampleDirs))} if
#'  \code{sampleDirs} is not \code{NULL}. Otherwise, make sure the length and
#'  order match the output of
#'  \code{unlist(lapply(cellRangerDirs, list.dirs, recursive = FALSE))}.
#' @param barcodesFileNames Character vector. Filename for the cell barcode
#'  list files. They are usually named \emph{barcodes.tsv.gz} or
#'  \emph{barcodes.tsv}. Must have length 1 or the same
#'  length as \code{length(unlist(sampleDirs))} if
#'  \code{sampleDirs} is not \code{NULL}. Otherwise, make sure the length and
#'  order match the output of
#'  \code{unlist(lapply(cellRangerDirs, list.dirs, recursive = FALSE))}.
#' @param gzipped \code{TRUE} if the Cell Ranger output files
#'  (barcodes.tsv, features.tsv, and matrix.mtx) were
#'  gzip compressed. \code{FALSE} otherwise. This is true after Cell Ranger
#'  3.0.0 update. Default \code{"auto"} which automatically detects if the
#'  files are gzip compressed. If not \code{"auto"}, \code{gzipped} must have
#'  length 1 or the same
#'  length as \code{length(unlist(sampleDirs))} if
#'  \code{sampleDirs} is not \code{NULL}. Otherwise, make sure the length and
#'  order match the output of
#'  \code{unlist(lapply(cellRangerDirs, list.dirs, recursive = FALSE))}.
#' @param class Character. The class of the expression matrix stored in the SCE
#'  object. Can be one of "Matrix" (as returned by
#'  \link{readMM} function), or "matrix" (as returned by
#'  \link[base]{matrix} function). Default \code{"Matrix"}.
#' @param delayedArray Boolean. Whether to read the expression matrix as
#'  \link{DelayedArray} object or not. Default \code{FALSE}.
#' @param reference Character vector. The reference genome names.
#'  Default \code{NULL}. If not \code{NULL}, it must gave the length and order as
#'  \code{length(unlist(sampleDirs))} if \code{sampleDirs} is not \code{NULL}.
#'  Otherwise, make sure the length and order match the output of
#'  \code{unlist(lapply(cellRangerDirs, list.dirs, recursive = FALSE))}. Only needed
#'  for Cellranger version below 3.0.0.
#' @param dataTypeV2 Character. The type of output to import for
#'  Cellranger version below 3.0.0. Whether to import the filtered or the
#'  raw data. Can be one of 'filtered' or 'raw'. Default 'filtered'. When
#'  \code{cellRangerOuts} is specified, \code{dataTypeV2} and \code{reference} will
#'  be ignored.
#' @param cellRangerOutsV2 Character vector. The intermediate paths
#'  to filtered or raw cell barcode, feature, and matrix files for each
#'  sample for Cellranger version below 3.0.0. If \code{NULL}, \code{reference} and
#'  \code{dataTypeV2} will be used to determine Cell Ranger output directory. If it has
#'  length 1, it assumes that all samples use the same genome reference and
#'  the function will load only filtered or raw data.
#' @param rowNamesDedup Boolean. Whether to deduplicate rownames. Default 
#'  \code{TRUE}.
#' @details
#'  \code{importCellRangerV2} imports output from Cell Ranger V2.
#'  \code{importCellRangerV2Sample} imports output from one sample from Cell
#'  Ranger V2.
#'  \code{importCellRangerV3} imports output from Cell Ranger V3.
#'  \code{importCellRangerV3} imports output from one sample from Cell Ranger
#'  V3.
#'  Some implicit
#'  assumptions which match the output structure of Cell Ranger V2 & V3
#'  are made in these 4 functions including \code{cellRangerOuts},
#'  \code{matrixFileName}, \code{featuresFileName}, \code{barcodesFileName},
#'  and \code{gzipped}.
#'  Alternatively, user can call \code{importCellRanger} to explicitly
#'  specify these arguments.
#' @return A \code{SingleCellExperiment} object containing the combined count
#'  matrix, the feature annotations, and the cell annotation.
#' @examples
#' # Example #1
#' # The following filtered feature, cell, and matrix files were downloaded from
#' # https://support.10xgenomics.com/single-cell-gene-expression/datasets/
#' # 3.0.0/hgmm_1k_v3
#' # The top 10 hg19 & mm10 genes are included in this example.
#' # Only the first 20 cells are included.
#' sce <- importCellRanger(
#'     cellRangerDirs = system.file("extdata/", package = "singleCellTK"),
#'     sampleDirs = "hgmm_1k_v3_20x20",
#'     sampleNames = "hgmm1kv3",
#'     dataType = "filtered")
#' @export
importCellRanger <- function(
    cellRangerDirs = NULL,
    sampleDirs = NULL,
    sampleNames = NULL,
    cellRangerOuts = NULL,
    dataType = c("filtered", "raw"),
    matrixFileNames = "matrix.mtx.gz",
    featuresFileNames = "features.tsv.gz",
    barcodesFileNames = "barcodes.tsv.gz",
    gzipped = "auto",
    class = c("Matrix", "matrix"),
    delayedArray = FALSE,
    rowNamesDedup = TRUE) {

    class <- match.arg(class)
    dataType <- match.arg(dataType)

    .importCellRanger(cellRangerDirs = cellRangerDirs,
        sampleDirs = sampleDirs,
        sampleNames = sampleNames,
        cellRangerOuts = cellRangerOuts,
        dataType = dataType,
        matrixFileNames = matrixFileNames,
        featuresFileNames = featuresFileNames,
        barcodesFileNames = barcodesFileNames,
        gzipped = gzipped,
        class = class,
        delayedArray = delayedArray,
        rowNamesDedup = rowNamesDedup)
}


#' @rdname importCellRanger
#' @examples
#' # The following filtered feature, cell, and matrix files were downloaded from
#' # https://support.10xgenomics.com/single-cell-gene-expression/datasets/
#' # 2.1.0/pbmc4k
#' # Top 20 genes are kept. 20 cell barcodes are extracted.
#' sce <- importCellRangerV2(
#'     cellRangerDirs = system.file("extdata/", package = "singleCellTK"),
#'     sampleDirs = "pbmc_4k_v2_20x20",
#'     sampleNames = "pbmc4k_20",
#'     reference = 'GRCh38',
#'     dataTypeV2 = "filtered")
#' @export
importCellRangerV2 <- function(
    cellRangerDirs = NULL,
    sampleDirs = NULL,
    sampleNames = NULL,
    dataTypeV2 = c("filtered", "raw"),
    class = c("Matrix", "matrix"),
    delayedArray = FALSE,
    reference = NULL,
    cellRangerOutsV2 = NULL,
    rowNamesDedup = TRUE) {

    class <- match.arg(class)
    dataTypeV2 <- match.arg(dataTypeV2)

    if (is.null(cellRangerOutsV2)) {
        if (is.null(reference) || is.null(dataTypeV2)) {
            stop("'reference' and 'dataTypeV2' are required ",
                 "when 'cellRangerOutsV2' is not specified!")
        }
    }

    # Generate cellRangerOuts if it's null
    if (is.null(cellRangerOutsV2)) {
        cellRangerOutsV2 <- .getCellRangerOutV2(dataTypeV2, reference)
    }

    .importCellRanger(cellRangerDirs = cellRangerDirs,
        sampleDirs = sampleDirs,
        sampleNames = sampleNames,
        cellRangerOuts = cellRangerOutsV2,
        dataType = NULL,
        matrixFileNames = "matrix.mtx",
        featuresFileNames = "genes.tsv",
        barcodesFileNames = "barcodes.tsv",
        gzipped = FALSE,
        class = class,
        delayedArray = delayedArray,
        rowNamesDedup = rowNamesDedup)
}


#' @name importCellRangerV2Sample
#' @title Construct SCE object from Cell Ranger V2 output for a single sample
#' @description Read the filtered barcodes, features, and matrices for all
#'  samples from Cell Ranger V2 output. Files are assumed to be named
#'  "matrix.mtx", "genes.tsv", and "barcodes.tsv".
#' @param dataDir  A path to the directory containing the data files. Default "./".
#' @param sampleName A User-defined sample name. This will be prepended to all cell barcode IDs.
#'  Default "sample".
#' @param class Character. The class of the expression matrix stored in the SCE
#'  object. Can be one of "Matrix" (as returned by
#'  \link{readMM} function), or "matrix" (as returned by
#'  \link[base]{matrix} function). Default "Matrix".
#' @param delayedArray Boolean. Whether to read the expression matrix as
#'  \link{DelayedArray} object or not. Default \code{FALSE}.
#' @param rowNamesDedup Boolean. Whether to deduplicate rownames. Default 
#'  \code{TRUE}.
#' @return A \code{SingleCellExperiment} object containing the count
#'  matrix, the feature annotations, and the cell annotation for the sample.
#' @examples
#' sce <- importCellRangerV2Sample(
#'     dataDir = system.file("extdata/pbmc_4k_v2_20x20/outs/",
#'         "filtered_gene_bc_matrices/GRCh38", package = "singleCellTK"),
#'     sampleName = "pbmc4k_20")
#' @export
importCellRangerV2Sample <- function(
    dataDir = NULL,
    sampleName = NULL,
    class = c("Matrix", "matrix"),
    delayedArray = FALSE,
    rowNamesDedup = TRUE) {

    class <- match.arg(class)

    .importCellRanger(cellRangerDirs = NULL,
        sampleDirs = dataDir,
        sampleNames = sampleName,
        cellRangerOuts = '',
        dataType = NULL, # ignored
        matrixFileNames = "matrix.mtx",
        featuresFileNames = "genes.tsv",
        barcodesFileNames = "barcodes.tsv",
        gzipped = FALSE,
        class = class,
        delayedArray = delayedArray,
        rowNamesDedup = rowNamesDedup)
}


#' @rdname importCellRanger
#' @examples
#' sce <- importCellRangerV3(
#'     cellRangerDirs = system.file("extdata/", package = "singleCellTK"),
#'     sampleDirs = "hgmm_1k_v3_20x20",
#'     sampleNames = "hgmm1kv3",
#'     dataType = "filtered")
#' @export
importCellRangerV3 <- function(
    cellRangerDirs = NULL,
    sampleDirs = NULL,
    sampleNames = NULL,
    dataType = c("filtered", "raw"),
    class = c("Matrix", "matrix"),
    delayedArray = FALSE,
    rowNamesDedup = TRUE) {

    class <- match.arg(class)
    dataType <- match.arg(dataType)

    if (dataType == "filtered") {
        cellRangerOuts <- "outs/filtered_feature_bc_matrix/"
    } else if (dataType == "raw") {
        cellRangerOuts <- "outs/raw_feature_bc_matrix/"
    }

    .importCellRanger(cellRangerDirs = cellRangerDirs,
        sampleDirs = sampleDirs,
        sampleNames = sampleNames,
        cellRangerOuts = cellRangerOuts,
        dataType = dataType,
        matrixFileNames = "matrix.mtx.gz",
        featuresFileNames = "features.tsv.gz",
        barcodesFileNames = "barcodes.tsv.gz",
        gzipped = TRUE,
        class = class,
        delayedArray = delayedArray,
        rowNamesDedup = rowNamesDedup)

}


#' @name importCellRangerV3Sample
#' @title Construct SCE object from Cell Ranger V3 output for a single sample
#' @description Read the filtered barcodes, features, and matrices for all
#'  samples from Cell Ranger V3 output. Files are assumed to be named
#'  "matrix.mtx.gz", "features.tsv.gz", and "barcodes.tsv.gz".
#' @param dataDir  A path to the directory containing the data files. Default "./".
#' @param sampleName A User-defined sample name. This will be prepended to all cell barcode IDs.
#'  Default "sample".
#' @param class Character. The class of the expression matrix stored in the SCE
#'  object. Can be one of "Matrix" (as returned by
#'  \link{readMM} function), or "matrix" (as returned by
#'  \link[base]{matrix} function). Default "Matrix".
#' @param delayedArray Boolean. Whether to read the expression matrix as
#'  \link{DelayedArray} object or not. Default \code{FALSE}.
#' @param rowNamesDedup Boolean. Whether to deduplicate rownames. Default 
#'  \code{TRUE}.
#' @return A \code{SingleCellExperiment} object containing the count
#'  matrix, the feature annotations, and the cell annotation for the sample.
#' @examples
#' sce <- importCellRangerV3Sample(
#'     dataDir = system.file("extdata/hgmm_1k_v3_20x20/outs/",
#'         "filtered_feature_bc_matrix", package = "singleCellTK"),
#'     sampleName = "hgmm1kv3")
#' @export
importCellRangerV3Sample <- function(
    dataDir = "./",
    sampleName = "sample",
    class = c("Matrix", "matrix"),
    delayedArray = FALSE,
    rowNamesDedup = TRUE) {

    class <- match.arg(class)

    .importCellRanger(cellRangerDirs = NULL,
        sampleDirs = dataDir,
        sampleNames = sampleName,
        cellRangerOuts = "",
        dataType = "filtered", # ignored
        matrixFileNames = "matrix.mtx.gz",
        featuresFileNames = "features.tsv.gz",
        barcodesFileNames = "barcodes.tsv.gz",
        gzipped = TRUE,
        class = class,
        delayedArray = delayedArray,
        rowNamesDedup = rowNamesDedup)
}

# Find metrics_summary.csv file in each sample and merge them into a single dataframe
# Additionally, if file not available for a sample, fill that sample with NA
.importMetricsCellRanger <- function(samplePaths, sampleNames, metricsPath, metricsFile){
  # Check if samplePaths and sampleNames are equal in length
  if(!identical(length(samplePaths), length(sampleNames))){
    stop("Vectors samplePaths and sampleNames must be equal in length.")
  }
  
  # Processing
  metrics_summary <- list()
  for(i in seq(samplePaths)){
    metrics_summary[[i]] <- list.files(pattern= paste0("*", metricsFile, "$"), path = paste0(samplePaths[i], "/", metricsPath), full.names = TRUE)
    if(length(metrics_summary[[i]]) > 0){
      metrics_summary[[i]] <- lapply(metrics_summary[[i]], utils::read.csv, header = TRUE, check.names = FALSE)[[1]]
    }
    else{
      message("Metrics summary file (", metricsFile, ") not found for sample: ", sampleNames[i])
      ms_colnames_union <- Reduce(union, lapply(metrics_summary, colnames))
      metrics_summary[[i]] <- data.frame(matrix(data = NA, nrow = 1, ncol = length(ms_colnames_union)))
      colnames(metrics_summary[[i]]) <- ms_colnames_union
    }
  }
  
  # Merge cell ranger metrics_summary csv files from all/multiple samples into a single data.frame
  metrics_summary <- plyr::rbind.fill(metrics_summary)
  metrics_summary <- t(metrics_summary)
  colnames(metrics_summary) <- sampleNames
  
  return(metrics_summary)
}

shinyPanelDiffex <- fluidPage(
  tags$script("Shiny.addCustomMessageHandler('close_dropDownDeHM', function(x){
                  $('html').click();
                });"),
  tags$script("Shiny.addCustomMessageHandler('close_dropDownDeVolcano', function(x){
                  $('html').click();
                });"),
  tags$script("Shiny.addCustomMessageHandler('close_dropDownDeViolin', function(x){
                  $('html').click();
                });"),
  tags$script("Shiny.addCustomMessageHandler('close_dropDownDeReg', function(x){
                  $('html').click();
                });"),
  tags$div(
    class = "container",
    h1("Differential Expression"),
    h5(tags$a(href = paste0(docs.artPath, "differential_expression.html"),
              "(help)", target = "_blank")),
    fluidRow(
      panel(
        style = "margin:2px;",
        h3("Method and Matrix"),
        fluidRow(
          column(
            4,
            selectInput('deMethod', "Choose analysis method",
                        c('wilcox', 'MAST', 'DESeq2', 'Limma', 'ANOVA'))
          ),
          column(
            4,
            selectizeInput(
              inputId = "deAssay", 
              label = "Select input matrix:", 
              choices = NULL, 
              selected = NULL, 
              multiple = FALSE,
              options = NULL)
          )
        ),
        useShinyjs(),
        actionButton("deViewThresh", label = "View Thresholding"),
        shinyjs::hidden(
          wellPanel(
            id = "deThreshpanel",
            textOutput("deSanityWarnThresh"),
            uiOutput("deThreshPlotDiv"),
            actionButton("deHideThresh", label = "Hide")
            )
          ),
        h3("Condition Setting"),
        p("Three approaches of setting provided for flexibility. ",
          style = "color:grey;"),
        radioButtons('deCondMethod', "Condition Selection:",
                     choiceNames = c("By annotations",
                                     "Manually select individual cells",
                                     "Manually enter cell IDs"),
                     choiceValues = c(1, 2, 3), inline = TRUE),
        fluidRow(
          column(width = 6,
                 textInput("deG1Name", "Name of Condition1", NULL,
                           placeholder = "Required")
          ),
          column(width = 6,
                 textInput("deG2Name", "Name of Condition2", NULL,
                           placeholder = "Required")
          )
        ),
        conditionalPanel(
          condition = "input.deCondMethod == 1",
          # Select by class UI ####
          panel(
            selectInput("deC1Class", "Choose Annotation Class:",
                        clusterChoice),
            fluidRow(
              column(width = 6,
                     uiOutput("deC1G1UI"),
                     uiOutput("deC1G1CellCheckUI"),
                     uiOutput("deC1G1NCell")
              ),
              column(width = 6,
                     uiOutput("deC1G2UI"),
                     uiOutput("deC1G2CellCheckUI"),
                     uiOutput("deC1G2NCell")
              )
            )
          )
        ),
        conditionalPanel(
          condition = "input.deCondMethod == 2",
          panel(
            tabsetPanel(
              tabPanel(
                "Condition 1",
                tagList(
                  selectInput(
                    'deC2G1Col',
                    "Columns to display",
                    clusterChoice, multiple = TRUE, width = '550px'
                  ),
                  DT::dataTableOutput("deC2G1Table"),
                  actionButton('deC2G1Table_addAll', "Add all filtered"),
                  actionButton('deC2G1Table_clear', "Clear selection"),
                )
              ),
              tabPanel(
                "Condition 2",
                tagList(
                  selectInput(
                    'deC2G2Col',
                    "Columns to display",
                    clusterChoice, multiple = TRUE, width = '550px'
                  ),
                  p("Leave unselected for all the others.",
                    style = 'color:grey;'),
                  DT::dataTableOutput("deC2G2Table"),
                  actionButton('deC2G2Table_addAll', "Add all filtered"),
                  actionButton('deC2G2Table_clear', "Clear selection"),
                )
              )
            ),
            h4("Summary", style = 'margin-top:10px'),
            uiOutput("deC2G1info"),
            uiOutput("deC2G2info")
          )
        ),
        conditionalPanel(
          condition = "input.deCondMethod == 3",
          # Direct enter name UI ####
          panel(
            fluidRow(
              column(width = 6,
                     h4("The Condition of Interests:"),
                     textAreaInput(
                       "deC3G1Cell", "Cell IDs:", height = '150px',
                       placeholder = "Enter cell IDs here, \none per line with no symbol separator."),
                     uiOutput("deC3G1NCell")
              ),
              column(width = 6,
                     h4("The Control Condition:"),
                     textAreaInput(
                       "deC3G2Cell", "Cell IDs:", height = '150px',
                       placeholder = "Leave this blank for all the others."),
                     uiOutput("deC3G2NCell")
              )
            )
          )
        ),
        h3("Parameters"),
        fluidRow(
          column(
            width = 3,
            selectInput("deCovar", "Select Covariates",
                        clusterChoice, multiple = TRUE)
          ),
          column(
            width = 3,
            numericInput("deFDRThresh", "Output FDR less than:",
                         min = 0, max = 1, step = 0.01, value = 0.05)
          ),
          # column(
          #   width = 3,
          #   numericInput("deFCThresh",
          #                "Output Log2FC Absolute value greater than:",
          #                min = 0, step = 0.05, value = NULL)
          # ),
          column(
            width = 3,
            style = 'margin-top: 18px;',
            checkboxInput("dePosOnly", "Only up-regulated genes",
                          value = FALSE)
          )
        ),
        # fluidRow(
        #   column(
        #     width = 3,
        #     numericInput("deMinExp1", 
        #                  "Output Group1 mean expression greater than:",
        #                  min = 0, step = 0.1, value = NULL)
        #   ),
        #   column(
        #     width = 3,
        #     numericInput("deMaxExp2", 
        #                  "Output Group2 mean expression less than:",
        #                  min = 0, step = 0.1, value = NULL)
        #   ),
        #   column(
        #     width = 3,
        #     numericInput("deMinExpPerc1",
        #                  "Output Group1 expression percentage greater than:",
        #                  min = 0, max = 1, step = 0.05, value = NULL)
        #   ),
        #   column(
        #     width = 3,
        #     numericInput("deMaxExpPerc2",
        #                  "Output Group2 expression percentage less than:",
        #                  min = 0, max = 1, step = 0.05, value = NULL)
        #   )
        # ),
        fluidRow(
          column(
            width = 3,
            textInput("deAnalysisName",
                      "Name of Differential Expression Analysis:",
                      placeholder = 'Required.')
          ),
          column(
            width = 2,
            style = 'margin-top: 25px;',
           actionButton("runDE", "Run")
          )
        )
      )
    ),
    h3("Visualization"),
    p('Select an analysis and click on "Update All" to show the results.', 
      style = "color:grey;"),
    fluidRow(
      selectInput("deResSel", "Select Differential Expression Analysis", choices = NULL),
      actionBttn(
        inputId = "deResSelUpdate",
        label = "Update All",
        style = "bordered",
        color = "primary",
        size = "sm", 
      ),
      hr(),
      tabsetPanel(
        tabPanel(
          "Heatmap",
          panel(
            fluidRow(
              column(
                width = 4,
                dropdown(
                  fluidRow(
                    column(12,
                           fluidRow(actionBttn(inputId = "closeDropDownDeHM", label = NULL, style = "simple", color = "danger", icon = icon("times"), size = "xs"), align = "right"),
                    )
                  ),
                  fluidRow(
                    column(
                      width = 6,
                      checkboxInput('deHMDoLog', "Do log transformation", FALSE),
                    ),
                    column(
                      width = 6,
                      checkboxInput('deHMPosOnly', "Only up-regulated",
                                    value = FALSE)
                    )
                  ),
                  fluidRow(
                    column(
                      width = 6,
                      numericInput("deHMFC", "Aboslute log2FC value greater than:",
                                   value = 0.5, min = 0, step = 0.05),
                    ),
                    column(
                      width = 6,
                      numericInput("deHMFDR", "FDR value less than", value = 0.05,
                                   max = 1, step = 0.01),
                    )
                  ),
                  
                  fluidRow(
                    column(
                      width = 6,
                      numericInput("deHMMinExp1", 
                                   "Group1 mean expression greater than:",
                                   value = NULL, min = 0, step = 0.1),
                    ),
                    column(
                      width = 6,
                      numericInput("deHMMaxExp2", 
                                   "Group2 mean expression less than:", 
                                   value = NULL, min = 0, step = 0.1),
                    )
                  ),
                  fluidRow(
                    column(
                      width = 6,
                      numericInput("deHMMinExpPerc1", 
                                   "Group1 expression percentage greater than:",
                                   value = NULL, min = 0, max = 1, step = 0.05),
                    ),
                    column(
                      width = 6,
                      numericInput("deHMMaxExpPerc2", 
                                   "Group2 expression percentage less than:", 
                                   value = NULL, min = 0, max = 1, step = 0.05),
                    )
                  ),
                  
                  fluidRow(
                    column(
                      width = 6,
                      selectInput("deHMcolData", "Additional cell annotation",
                                  choices = clusterChoice, multiple = TRUE),
                    ),
                    column(
                      width = 6,
                      selectInput("deHMrowData", "Additional feature annotation",
                                  choices = featureChoice, multiple = TRUE),
                    )
                  ),
                  fluidRow(
                    column(
                      width = 6,
                      uiOutput('deHMSplitColUI'),
                    ),
                    column(
                      width = 6,
                      uiOutput('deHMSplitRowUI'),
                    )
                  ),
                  fluidRow(
                    column(
                      width = 6,
                      materialSwitch(
                        inputId = "deHMShowRowLabel",
                        label = "Display row labels", status = "success",
                        value = TRUE
                      ),
                      selectInput(
                        inputId = "deHMrowLabel",
                        label = "Select row labels",
                        choices = c("Rownames (Default)",
                                    featureChoice)
                      )
                    ),
                    column(
                      width = 4,
                      br(),
                      withBusyIndicatorUI(
                        actionBttn(
                          inputId = "dePlotHM",
                          label = "Update",
                          style = "bordered",
                          color = "primary",
                          size = "sm"
                        )
                      )
                    )
                  ),
                  inputId = "dropDownDeHM",
                  icon = icon("cog"),
                  status = "primary",
                  circle = FALSE,
                  inline = TRUE,
                  width = "500px"
                )
              ),
              column(
                width = 7,
                fluidRow(
                  h6(
                    "A heatmap of the expression of DEGs in the selected cells, columns splitted by condition setting, and rows splitted by up-/down-regulation (whether log2FC is positive or negative, respectively)"),
                  align="center"
                )
              )
            ),
            hr(),
            br(),

            shinyjqui::jqui_resizable(plotOutput("deHeatmap"))
          )
        ),
        tabPanel("Results Table",
                 filterTableUI(id = "deResult")
                 # DT::dataTableOutput("deResult"),
                 # downloadButton("deDownload", "Download Result Table")
                 ),
        tabPanel(
          "Volcano Plot",
          panel(
            fluidRow(
              column(
                width = 4,
                dropdown(
                  fluidRow(
                    column(
                      12,
                      fluidRow(
                        actionBttn(
                          inputId = "closeDropDownDeVolcano", label = NULL, 
                          style = "simple", color = "danger", 
                          icon = icon("times"), size = "xs"
                        ), 
                        align = "right"
                      ),
                    )
                  ),
                  fluidRow(
                    column(
                      width = 6,
                      numericInput(
                        inputId = "deVolcLog2FC", 
                        label = "Aboslute log2FC value greater than:",
                        value = 0.5, min = 0, step = 0.05
                      )
                    ),
                    column(
                      width = 6,
                      numericInput(inputId = "deVolcFDR", 
                                   label = "FDR value less than",
                                   value = 0.05, min = 0, max = 1, step = 0.01)
                    )
                  ),
                  fluidRow(
                    column(
                      width = 12,
                      materialSwitch("deVolcShowLabel", "Label Top DEG",
                                     value = TRUE, status = "success" )
                    )
                  ),
                  fluidRow(
                    column(
                      width = 6,
                      numericInput(inputId = "deVolcTopN", 
                                   label = "N top DEG to label",
                                   value = 10, min = 1, step = 1)
                    ),
                    column(
                      width = 6,
                      selectInput("deVolcFeatureDisplay",
                                  "Display ID Type",
                                  c("Rownames (Default)",
                                    featureChoice))
                    )
                  ),
                  fluidRow(
                    column(
                      width = 4,
                      style = 'margin-top: 23px;',
                      withBusyIndicatorUI(
                        actionBttn(
                          inputId = "dePlotVolcano",
                          label = "Update",
                          style = "bordered",
                          color = "primary",
                          size = "sm"
                        )
                      )
                    )
                  ),
                  inputId = "dropDownDeVolcano",
                  icon = icon("cog"),
                  status = "primary",
                  circle = FALSE,
                  inline = TRUE,
                  width = "500px"
                )
              ),
              column(
                width = 7,
                fluidRow(
                  h6(
                    "Volcano plots of all identified DEGs in the selected analysis. DEG with top Log2FC could be labeled. Colors indicates the regulation"),
                  align="center"
                )
              )
            ),
            hr(),
            br(),
            shinyjqui::jqui_resizable(plotOutput("deVolcanoPlot"))
          )
        ),
        tabPanel(
          "Violin Plot",
          panel(
            fluidRow(
              column(
                width = 4,
                dropdown(
                  fluidRow(
                    column(12,
                           fluidRow(actionBttn(inputId = "closeDropDownDeViolin", label = NULL, style = "simple", color = "danger", icon = icon("times"), size = "xs"), align = "right"),
                    )
                  ),
                  fluidRow(
                    div(style="display: inline-block;vertical-align:center; width: 100px;margin-left:10px",
                        p('Plot the top')),
                    div(style="display: inline-block;vertical-align:center; width: 60px;",
                        numericInput('deVioNRow', label = NULL, value = 3, min = 1)),
                    div(style="display: inline-block;vertical-align:center; width: 12px;",
                        p('x')),
                    div(style="display: inline-block;vertical-align:center; width: 60px;",
                        numericInput('deVioNCol', label = NULL, value = 3, min = 1)),
                    div(style="display: inline-block;vertical-align:center; width: 10px;",
                        p('=')),
                    div(style="display: inline-block;vertical-align:center; width: 30px;",
                        uiOutput('deVioTotalUI')),
                    div(style="display: inline-block;vertical-align:center; width: 50px;",
                        p('genes'))
                  ),
                  fluidRow(
                    column(
                      width = 6,
                      selectInput('deVioLabel', "Label features by",
                                  c("Rownames (Default)",
                                    featureChoice))
                    ),
                    column(
                      width = 4,
                      style = 'margin-top: 23px;',
                      withBusyIndicatorUI(
                        actionBttn(
                          inputId = "dePlotVio",
                          label = "Update",
                          style = "bordered",
                          color = "primary",
                          size = "sm"
                        )
                      )
                    )
                  ),
                  inputId = "dropDownDeViolin",
                  icon = icon("cog"),
                  status = "primary",
                  circle = FALSE,
                  inline = TRUE,
                  width = "500px"
                )
              ),
              column(
                width = 7,
                fluidRow(
                  h6(
                    "Violin plots of the expression of top DEGs in the selected analysis. The violin plot for each DEG will be grouped by the condition setting."),
                  align="center"
                )
              )
            ),
            hr(),
            br(),
            textOutput("deSanityWarnViolin"),
            shinyjqui::jqui_resizable(plotOutput("deViolinPlot"))
          ),

        ),
        tabPanel(
          "Linear Model",
          panel(

            fluidRow(
              column(
                width = 4,
                dropdown(
                  fluidRow(
                    column(12,
                           fluidRow(actionBttn(inputId = "closeDropDownDeReg", label = NULL, style = "simple", color = "danger", icon = icon("times"), size = "xs"), align = "right"),
                    )
                  ),
                  fluidRow(
                    div(style="display: inline-block;vertical-align:center; width: 100px;margin-left:10px",
                        p('Plot the top')),
                    div(style="display: inline-block;vertical-align:center; width: 60px;",
                        numericInput('deRegNRow', label = NULL, value = 3, min = 1)),
                    div(style="display: inline-block;vertical-align:center; width: 12px;",
                        p('x')),
                    div(style="display: inline-block;vertical-align:center; width: 60px;",
                        numericInput('deRegNCol', label = NULL, value = 3, min = 1)),
                    div(style="display: inline-block;vertical-align:center; width: 10px;",
                        p('=')),
                    div(style="display: inline-block;vertical-align:center; width: 30px;",
                        uiOutput('deRegTotalUI')),
                    div(style="display: inline-block;vertical-align:center; width: 50px;",
                        p('genes'))
                  ),
                  fluidRow(
                    column(
                      width = 6,
                      selectInput('deRegLabel', "Label features by",
                                  c("Rownames (Default)",
                                    featureChoice))
                    ),
                    column(
                      width = 4,
                      style = 'margin-top: 23px;',
                      withBusyIndicatorUI(
                        actionBttn(
                          inputId = "dePlotReg",
                          label = "Update",
                          style = "bordered",
                          color = "primary",
                          size = "sm"
                        )
                      )
                    )
                  ),
                  inputId = "dropDownDeReg",
                  icon = icon("cog"),
                  status = "primary",
                  circle = FALSE,
                  inline = TRUE,
                  width = "500px"
                )
              ),
              column(
                width = 7,
                fluidRow(
                  h6(
                    "Linear regression plots of the expression of top DEGs in the selected analysis. The regression plot for each DEG will be grouped by the condition setting."),
                  align="center"
                )
              )
            ),
            hr(),
            br(),
            textOutput("deSanityWarnReg"),
            shinyjqui::jqui_resizable(plotOutput("deRegPlot"))
          )
        )
      )
    )
  ),
  nonLinearWorkflowUI(id = "nlw-de")
)

#' @title Export a \link[SingleCellExperiment]{SingleCellExperiment} object to flat text files
#' @description Writes all assays, colData, rowData, reducedDims, and altExps objects in a
#' \link[SingleCellExperiment]{SingleCellExperiment} to text files.
#' The items in the 'metadata' slot remain stored in list and are saved in an RDS file.
#' @param sce \link[SingleCellExperiment]{SingleCellExperiment} object to be
#'  exported.
#' @param outputDir Name of the directory to store the exported file(s).
#' @param overwrite Boolean. Whether to overwrite the output files. Default
#'  \code{TRUE}.
#' @param gzipped Boolean. \code{TRUE} if the output files are to be
#'  gzip compressed. \code{FALSE} otherwise. Default
#'  \code{TRUE}.
#' @param prefix Prefix of file names.
#' @return Generates text files containing data from \code{inSCE}.
#' @examples
#' data(sce_chcl, package = "scds")
#' \dontrun{
#' exportSCEtoFlatFile(sce_chcl, "sce_chcl")
#' }
#' @export
#' @importFrom SummarizedExperiment colData rowData
exportSCEtoFlatFile <- function(sce,
                                outputDir = "./",
                                overwrite = TRUE,
                                gzipped = TRUE,
                                prefix = 'SCE') {
  #path <- file.path(outputDir, prefix)
  path <- outputDir
  if (!file.exists(path)){
    dir.create(path, showWarnings = FALSE, recursive = TRUE)
  }
  .writeAssays(sce, path, overwrite, gzipped, prefix)
  .writeColData(sce, path, overwrite, gzipped, prefix)
  .writeRowData(sce, path, overwrite, gzipped, prefix)
  .writeMetaData(sce, path, overwrite, prefix)
  .writeReducedDims(sce, path, overwrite, gzipped, prefix)
  .writeAltExps(sce, path, overwrite, gzipped, prefix)

}

.checkOverwrite <- function(path, overwrite) {
  if (file.exists(path) && !isTRUE(overwrite)) {
    p <- paste0(path, " already exists. Change 'outputDir' or set 'overwrite' to TRUE.")
    stop(p)
  }
}

# function to write txt gz files
.writeSCEFile <- function(data, path, overwrite, gzipped) {

  if(is.null(rownames(data))) {
    data <- data.frame(ID = seq(nrow(data)), data)
  } else {
    data <- data.frame(ID = rownames(data), data)
  }

  if (isTRUE(gzipped)) {
    filename <- paste0(path, ".txt.gz")
  } else {
    filename <- paste0(path, ".txt")
  }
  message(date(), " .. Writing '", filename)
  .checkOverwrite(filename, overwrite)
  data.table::fwrite(x = data, file = filename, nThread = 1, row.names = FALSE)
}


# write assays data
.writeAssays <- function(sce, path, overwrite, gzipped, sample) {
  if (length(SummarizedExperiment::assays(sce)) > 0) {
    assaysFolder <- file.path(path, "/assays")
    dir.create(assaysFolder, showWarnings = FALSE, recursive = TRUE)

    assayNames <- names(SummarizedExperiment::assays(sce))
    if(is.null(assayNames)) {
      assayNames <- paste0("assay", seq(SummarizedExperiment::assays(sce)))
    }
    for (i in seq_along(SummarizedExperiment::assays(sce))) {

      filename <- paste(sample, paste0(assayNames[i], ".mtx"), sep="_")
      assaypath <- file.path(assaysFolder, filename)

      .checkOverwrite(assaypath, overwrite)
      mat <- .convertToMatrix(SummarizedExperiment::assays(sce)[[i]])
      message(date(), " .. Writing assay '", assayNames[i], "' to ", assaypath)
      out <- Matrix::writeMM(mat, assaypath)

      if(isTRUE(gzipped)) {
        .checkOverwrite(paste0(assaypath, ".gz"), overwrite)
        p <- paste0(assaypath, ".gz")
        message(date(), " .. Compressing into ", p)
        R.utils::gzip(filename = assaypath, overwrite = overwrite)
      }
    }
  }
}



# write altExpNames
.writeAltExps <- function(sce, path, overwrite, gzipped, sample) {
  if (length(SingleCellExperiment::altExpNames(sce)) > 0) {
    altExpsFolder <- file.path(path, "/altExps")
    dir.create(altExpsFolder, showWarnings = FALSE, recursive = TRUE)

    altExpNames <- SingleCellExperiment::altExpNames(sce)
    for (i in altExpNames) {
      sceAltExp <- SingleCellExperiment::altExp(sce, i, withColData = FALSE)
      altExpPath <- file.path(path, i)

      message(date(), " .. Writing altExp '", i, "'")

      assaysFolder <- file.path(altExpPath, "/assays")
      dir.create(assaysFolder, showWarnings = FALSE, recursive = TRUE)
      .writeAssays(sceAltExp, path = assaysFolder, overwrite = overwrite, gzipped = gzipped, sample)
      .writeColData(sceAltExp, altExpPath, overwrite, gzipped, sample)
      .writeRowData(sceAltExp, altExpPath, overwrite, gzipped, sample)
      .writeMetaData(sceAltExp, altExpPath, overwrite, sample)
    }
  }
}

# write colData
.writeColData <- function(sce, path, overwrite, gzipped, sample) {
  if(ncol(colData(sce)) > 0) {
    data <- SummarizedExperiment::colData(sce)
    colDataPath <- file.path(path, paste(sample, "cellData", sep="_"))
    .writeSCEFile(data, colDataPath, overwrite, gzipped)
  }
}


# write rowData
.writeRowData <- function(sce, path, overwrite, gzipped, sample) {
  if(ncol(rowData(sce)) > 0) {
    data <- SummarizedExperiment::rowData(sce)
    rowDataPath <-  file.path(path, paste(sample, "featureData", sep="_"))
    .writeSCEFile(data, rowDataPath, overwrite, gzipped)
  }
}


# write reduced dimensions
.writeReducedDims <- function(sce, path, overwrite, gzipped, sample) {
  if (length(SingleCellExperiment::reducedDimNames(sce)) > 0) {
    reducedDimsFolder <- file.path(path, "reducedDims")
    dir.create(reducedDimsFolder, showWarnings = FALSE, recursive = TRUE)

    if (length(reducedDimNames(sce)) > 0) {
      reducedDimNames <- SingleCellExperiment::reducedDimNames(sce)
      for (i in reducedDimNames) {
        data <- SingleCellExperiment::reducedDim(sce, i, withDimnames = TRUE)
        reducedDimNamePath <- file.path(reducedDimsFolder, paste(sample, i, sep="_"))
        message(date(), " .. Writing reducedDim '", i, "' to", reducedDimNamePath)
        .writeSCEFile(data, reducedDimNamePath, overwrite, gzipped)
      }
    }
  }
}

# write metaData
.writeMetaData <- function(sce, path, overwrite, sample) {
  if (length(S4Vectors::metadata(sce)) > 0) {
    metadataFolder <- file.path(path, "/metadata")
    dir.create(metadataFolder, showWarnings = FALSE, recursive = TRUE)

    filename <- file.path(metadataFolder, paste(sample, "metadata.rds", sep="_"))
    .checkOverwrite(filename, overwrite)
    message(date(), " .. Writing metadata to ", filename)
    saveRDS(object = S4Vectors::metadata(sce), file = filename)
  }
}

## Original code from DoubletFinder package
## (https://github.com/chris-mcginnis-ucsf/DoubletFinder)

.parallel_paramSweep <- function(n, n.real.cells, real.cells, pK, pN, data,
                                 orig.commands, PCs, sct, verbose, seed) {
  sweep.res.list <- list()
  list.ind <- 0
  
  ## Make merged real-artifical data
  if (verbose) {
    message(date(), " ...   Creating artificial doublets for pN = ",
            pN[n] * 100, "%")
  }
  n_doublets <- ceiling(n.real.cells / (1 - pN[n]) - n.real.cells)
  real.cells1 <- sample(real.cells, n_doublets, replace = TRUE)
  real.cells2 <- sample(real.cells, n_doublets, replace = TRUE)
  doublets <- (data[, real.cells1] + data[, real.cells2]) / 2
  colnames(doublets) <- paste("X", seq(n_doublets), sep = "")
  data_wdoublets <- cbind(data, doublets)
  
  ## Pre-process Seurat object
  if (sct == FALSE) {
    if (verbose) {
      message(date(), " ...   Creating Seurat object")
    }
    seu_wdoublets <- Seurat::CreateSeuratObject(counts = data_wdoublets)
    
    if (verbose) {
      message(date(), " ...   Normalizing Seurat object")
    }
    seu_wdoublets <- Seurat::NormalizeData(
      seu_wdoublets,
      normalization.method = orig.commands$NormalizeData.RNA@params$normalization.method,
      scale.factor = orig.commands$NormalizeData.RNA@params$scale.factor,
      margin = orig.commands$NormalizeData.RNA@params$margin,
      verbose = verbose
    )
    
    if (verbose) {
      message(date(), " ...   Finding variable genes")
    }
    seu_wdoublets <- Seurat::FindVariableFeatures(
      seu_wdoublets,
      selection.method = orig.commands$FindVariableFeatures.RNA$selection.method,
      loess.span = orig.commands$FindVariableFeatures.RNA$loess.span,
      clip.max = orig.commands$FindVariableFeatures.RNA$clip.max,
      mean.function = orig.commands$FindVariableFeatures.RNA$mean.function,
      dispersion.function = orig.commands$FindVariableFeatures.RNA$dispersion.function,
      num.bin = orig.commands$FindVariableFeatures.RNA$num.bin,
      binning.method = orig.commands$FindVariableFeatures.RNA$binning.method,
      nfeatures = orig.commands$FindVariableFeatures.RNA$nfeatures,
      mean.cutoff = orig.commands$FindVariableFeatures.RNA$mean.cutoff,
      dispersion.cutoff = orig.commands$FindVariableFeatures.RNA$dispersion.cutoff,
      verbose = verbose
    )
    
    if (verbose) {
      message(date(), " ...   Scaling data")
    }
    seu_wdoublets <- Seurat::ScaleData(
      seu_wdoublets,
      features = orig.commands$ScaleData.RNA$features,
      model.use = orig.commands$ScaleData.RNA$model.use,
      do.scale = orig.commands$ScaleData.RNA$do.scale,
      do.center = orig.commands$ScaleData.RNA$do.center,
      scale.max = orig.commands$ScaleData.RNA$scale.max,
      block.size = orig.commands$ScaleData.RNA$block.size,
      min.cells.to.block = orig.commands$ScaleData.RNA$min.cells.to.block,
      verbose = verbose
    )
    
    if (verbose) {
      message(date(), " ...   Running PCA")
    }
    seu_wdoublets <- Seurat::RunPCA(
      seu_wdoublets,
      features = orig.commands$ScaleData.RNA$features,
      npcs = length(PCs),
      rev.pca = orig.commands$RunPCA.RNA$rev.pca,
      weight.by.var = orig.commands$RunPCA.RNA$weight.by.var,
      seed.use = seed,
      verbose = FALSE
    )
  }
  
  if (sct == TRUE) {
    if (verbose) {
      message(date(), " ...   Creating Seurat object")
    }
    seu_wdoublets <- Seurat::CreateSeuratObject(counts = data_wdoublets)
    
    if (verbose) {
      message(date(), " ...   Running SCTransform")
    }
    seu_wdoublets <- Seurat::SCTransform(seu_wdoublets)
    
    if (verbose) {
      message(date(), " ...   Running PCA")
    }
    seu_wdoublets <- Seurat::RunPCA(seu_wdoublets,
                                    npcs = length(PCs), seed.use = seed,
                                    verbose = verbose
    )
  }
  
  ## Compute PC distance matrix
  if (verbose) {
    message(date(), " ...   Calculating PC distance matrix")
  }
  nCells <- ncol(seu_wdoublets)
  pca.coord <- Seurat::Reductions(seu_wdoublets, "pca")@cell.embeddings[, PCs]
  #seu_wdoublets <- NULL
  rm(seu_wdoublets)
  gc()
  dist.mat <- fields::rdist(pca.coord)[, seq(n.real.cells)]
  
  ## Pre-order PC distance matrix prior to iterating across pK
  ## for pANN computations
  if (verbose) {
    message(date(), " ...   Defining neighborhoods")
  }
  
  for (i in seq(n.real.cells)) {
    dist.mat[, i] <- order(dist.mat[, i])
  }
  
  ## Trim PC distance matrix for faster manipulations
  ind <- round(nCells * max(pK)) + 5
  dist.mat <- dist.mat[seq(ind), ]
  
  ## Compute pANN across pK sweep
  
  if (verbose) {
    message(date(), " ...   Computing pANN across all pK")
  }
  for (k in seq_along(pK)) {
    if (verbose) {
      message(date(), " ...   pK = ", pK[k])
    }
    pk.temp <- round(nCells * pK[k])
    pANN <- as.data.frame(matrix(0L, nrow = n.real.cells, ncol = 1))
    colnames(pANN) <- "pANN"
    rownames(pANN) <- real.cells
    list.ind <- list.ind + 1
    
    for (i in seq(n.real.cells)) {
      neighbors <- dist.mat[2:(pk.temp + 1), i]
      pANN$pANN[i] <- length(which(neighbors > n.real.cells)) / pk.temp
    }
    
    sweep.res.list[[list.ind]] <- pANN
  }
  
  return(sweep.res.list)
}

.paramSweep <- function(seu, PCs = seq(10), sct = FALSE,
                        verbose = FALSE, num.cores, seed) {
  ## Set pN-pK param sweep ranges
  pK <- c(0.0005, 0.001, 0.005, seq(0.01, 0.3, by = 0.01))
  pN <- seq(0.05, 0.3, by = 0.05)
  ## Remove pK values with too few cells
  min.cells <- round(nrow(seu[[]]) / (1 - 0.05) - nrow(seu[[]]))
  pK.test <- round(pK * min.cells)
  pK <- pK[which(pK.test >= 1)]
  
  ## Extract pre-processing parameters from original data analysis workflow
  orig.commands <- seu@commands
  
  ## Down-sample cells to 10000 (when applicable) for computational effiency
  if (nrow(seu[[]]) > 10000) {
    real.cells <- rownames(seu[[]])[sample(seq(nrow(seu[[]])),
                                           10000, replace = FALSE)]
    data <- Seurat::GetAssayData(seu, slot = "counts", 
                                 assay = "RNA")[, real.cells]
    n.real.cells <- ncol(data)
  }
  
  if (ncol(seu) <= 10000) {
    real.cells <- colnames(seu)
    data <- Seurat::GetAssayData(seu, slot = "counts", assay = "RNA")
    n.real.cells <- ncol(data)
  }
  ## Iterate through pN, computing pANN vectors at varying pK
  # no_cores <- detectCores()-1
  if (is.null(num.cores)) {
    num.cores <- 1
  }
  
  if (num.cores > 1) {
    cl <- parallel::makeCluster(num.cores)
    
    output2 <- withr::with_seed(
      seed,
      parallel::mclapply(as.list(seq_along(pN)),
                         FUN = .parallel_paramSweep,
                         n.real.cells,
                         real.cells,
                         pK,
                         pN,
                         data,
                         orig.commands,
                         PCs,
                         sct, mc.cores = num.cores,
                         verbose = verbose,
                         seed = seed,
                         mc.set.seed = FALSE
      )
    )
    parallel::stopCluster(cl)
  } else {
    output2 <- lapply(as.list(seq_along(pN)),
                      FUN = .parallel_paramSweep,
                      n.real.cells,
                      real.cells,
                      pK,
                      pN,
                      data,
                      orig.commands,
                      PCs,
                      sct,
                      seed = seed,
                      verbose = verbose
    )
  }
  
  ## Write parallelized output into list
  sweep.res.list <- list()
  list.ind <- 0
  for (i in seq_along(output2)) {
    for (j in seq_along(output2[[i]])) {
      list.ind <- list.ind + 1
      sweep.res.list[[list.ind]] <- output2[[i]][[j]]
    }
  }
  ## Assign names to list of results
  name.vec <- NULL
  for (j in seq_along(pN)) {
    name.vec <- c(name.vec, paste("pN", pN[j], "pK", pK, sep = "_"))
  }
  names(sweep.res.list) <- name.vec
  return(sweep.res.list)
  
}

.runDoubletFinder <- function(counts, seuratPcs, seuratRes, formationRate,
                              seuratNfeatures, sct = FALSE, verbose = FALSE,
                              nCores = NULL, seed = 12345) {
  
  ## Convert to sparse matrix if not already in that format
  counts <- .convertToMatrix(counts)
  colnames(counts) <- gsub("_", "-", colnames(counts))
  
  seurat <- suppressWarnings(Seurat::CreateSeuratObject(
    counts = counts,
    project = "seurat", min.features = 0
  ))
  seurat <- Seurat::NormalizeData(
    object = seurat,
    normalization.method = "LogNormalize", scale.factor = 10000,
    verbose = verbose
  )
  seurat <- Seurat::FindVariableFeatures(seurat,
                                         selection.method = "vst",
                                         nfeatures = seuratNfeatures,
                                         verbose = verbose
  )
  
  allGenes <- rownames(seurat)
  seurat <- Seurat::ScaleData(seurat, features = allGenes, verbose = verbose)
  
  numPc <- min(nrow(Seurat::GetAssayData(seurat, slot = "scale.data", 
                                         assay = "RNA")) - 1, 
               50)
  seurat <- Seurat::RunPCA(seurat,
                           features =
                             Seurat::VariableFeatures(object = seurat),
                           npcs = numPc, verbose = verbose, seed.use = seed
  )
  seurat <- Seurat::FindNeighbors(seurat, dims = seuratPcs, verbose = verbose)
  seurat <- Seurat::FindClusters(seurat,
                                 resolution = seuratRes,
                                 verbose = verbose,
                                 random.seed = seed
  )
  invisible(sweepResListSeurat <- .paramSweep(seurat,
                                              PCs = seuratPcs,
                                              sct = sct,
                                              num.cores = nCores,
                                              verbose = verbose,
                                              seed = seed
  ))
  sweepStatsSeurat <- .summarizeSweep(sweepResListSeurat,
                                      GT = FALSE
  )
  bcmvnSeurat <- .find.pK(sweepStatsSeurat)
  pkOptimal <- as.numeric(as.matrix(bcmvnSeurat$pK[
    which.max(bcmvnSeurat$MeanBC)
  ]))
  #annotations <- seurat[[]]$seurat_clusters
  #homotypicProp <- .modelHomotypic(annotations)
  nExpPoi <- round(formationRate * ncol(seurat))
  seurat <- .doubletFinder_v3(seurat,
                              PCs = seuratPcs,
                              pN = 0.25,
                              pK = pkOptimal,
                              nExp = nExpPoi,
                              reuse.pANN = FALSE,
                              sct = sct,
                              verbose = FALSE
  )
  names(seurat@meta.data)[6] <- "doubletFinderAnnScore"
  names(seurat@meta.data)[7] <- "doubletFinderLabel"
  return(seurat)
}

#' @title Generates a doublet score for each cell via doubletFinder
#' @description Uses doubletFinder to determine cells within the dataset
#'  suspected to be doublets.
#' @param inSCE inSCE A \linkS4class{SingleCellExperiment} object.
#' @param sample Character vector or colData variable name. Indicates which 
#' sample each cell belongs to. Default \code{NULL}.
#' @param useAssay  A string specifying which assay in the SCE to use. Default 
#' \code{"counts"}.
#' @param seed Seed for the random number generator, can be set to \code{NULL}. 
#' Default \code{12345}.
#' @param seuratNfeatures Integer. Number of highly variable genes to use.
#' Default \code{2000}.
#' @param seuratPcs Numeric vector. The PCs used in seurat function to
#' determine number of clusters. Default \code{1:15}.
#' @param seuratRes Numeric vector. The resolution parameter used in Seurat,
#' which adjusts the number of clusters determined via the algorithm. Default 
#' \code{1.5}.
#' @param sct Whether or not to use SCT. Default \code{FALSE}.
#' @param formationRate Doublet formation rate used within algorithm. Default 
#' \code{0.075}.
#' @param nCores Number of cores used for running the function. Default 
#' \code{NULL}.
#' @param verbose Boolean. Wheter to print messages from Seurat and 
#' DoubletFinder. Default \code{FALSE}.
#' @return \linkS4class{SingleCellExperiment} object containing the
#' \code{doublet_finder_doublet_score} variable in \code{colData} slot.
#' @seealso \code{\link{runCellQC}}, \code{\link{plotDoubletFinderResults}}
#' @examples
#' data(scExample, package = "singleCellTK")
#' options(future.globals.maxSize = 786432000)
#' sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
#' sce <- runDoubletFinder(sce)
#' @export
#' @importFrom SummarizedExperiment colData colData<- assayNames assayNames<-
#' @importFrom SingleCellExperiment reducedDim<-
runDoubletFinder <- function(inSCE,
                             sample = NULL,
                             useAssay = "counts",
                             seed = 12345,
                             seuratNfeatures = 2000,
                             seuratPcs = seq(15),
                             seuratRes = 1.5,
                             sct = FALSE,
                             formationRate = 0.075,
                             nCores = NULL,
                             verbose = FALSE) {
  
  argsList <- mget(names(formals()), sys.frame(sys.nframe()))
  argsList <- argsList[!names(argsList) %in% c("inSCE")]
  argsList$packageVersion <- "2.0.2"
  tempSCE <- inSCE
  #assayNames(inSCE)[which(useAssay %in% assayNames(inSCE))] <- "counts"
  #useAssay <- "counts"
  
  sample <- .manageCellVar(inSCE, var = sample)
  if (is.null(sample)) {
    sample <- rep(1, ncol(inSCE))
  }
  
  message(date(), " ... Running 'doubletFinder'")
  
  #doubletScore <- rep(NA, ncol(inSCE))
  #doubletLabel <- rep(NA, ncol(inSCE))
  #allSampleNumbers <- sort(unique(sample))
  
  for (res in seuratRes) {
    output <- S4Vectors::DataFrame(
      row.names = colnames(inSCE),
      doubletFinder_doublet_score = numeric(ncol(inSCE)),
      doubletFinder_doublet_label = character(ncol(inSCE))
    )
    umapDims <- matrix(ncol = 2,
                       nrow = ncol(inSCE))
    rownames(umapDims) = colnames(inSCE)
    colnames(umapDims) = c("UMAP_1", "UMAP_2")
    
    ## Loop through each sample and run doubletFinder
    samples <- unique(sample)
    
    for (s in samples) {
      sceSampleInd <- sample == s
      sceSample <- inSCE[, sceSampleInd]
      mat <- SummarizedExperiment::assay(sceSample, i = useAssay)
      if (length(seuratPcs) > ncol(mat)) {
        seuratPcs <- seq(ncol(mat))
      }
      withr::with_seed(seed, {
        result <- .runDoubletFinder(
          counts = mat,
          seuratPcs = seuratPcs,
          seuratRes = res,
          seuratNfeatures = seuratNfeatures,
          formationRate = formationRate,
          sct = sct,
          nCores = nCores,
          verbose = verbose,
          seed = seed
        )
      })
      
      result <- suppressMessages(Seurat::RunUMAP(result,
                                                 dims = seq(10),
                                                 verbose = verbose,
                                                 umap.method = "uwot"))
      
      seuratDims <- Seurat::Embeddings(result, reduction = "umap")
      umapDims[sceSampleInd, 1] <- seuratDims[,1]
      umapDims[sceSampleInd, 2] <- seuratDims[,2]
      output[sceSampleInd, 1] <- result[[]]$doubletFinderAnnScore
      output[sceSampleInd, 2] <- result[[]]$doubletFinderLabel
      
      if (!identical(samples, 1)) {
        metadata(inSCE)$sctk$runDoubletFinder[[s]] <- argsList
      }
    }
    if (identical(samples, 1)) {
      metadata(inSCE)$sctk$runDoubletFinder$all_cells <- argsList
    }
    colData(inSCE)[, paste0(colnames(output), "_resolution_", res)] <- NULL
    
    colnames(output) <- paste0(colnames(output), "_resolution_", res)
    output[,2] <- factor(output[,2], levels = c("Singlet", "Doublet"))
    
    colData(inSCE) <- cbind(colData(inSCE), output)
    reducedDim(inSCE,'doubletFinder_UMAP') <- umapDims
  }
  
  colData(tempSCE) <- colData(inSCE)
  S4Vectors::metadata(tempSCE) <- S4Vectors::metadata(inSCE)
  reducedDims(tempSCE) <- reducedDims(inSCE)
  
  return(tempSCE)
}


.summarizeSweep <- function(sweep.list, GT = FALSE, GT.calls = NULL) {
  #require(KernSmooth); require(ROCR)
  ## Set pN-pK param sweep ranges
  name.vec <- names(sweep.list)
  name.vec <- unlist(strsplit(name.vec, split = "pN_"))
  name.vec <- name.vec[seq(2, length(name.vec), by = 2)]
  name.vec <- unlist(strsplit(name.vec, split = "_pK_"))
  pN <- as.numeric(unique(name.vec[seq(1, length(name.vec), by = 2)]))
  pK <- as.numeric(unique(name.vec[seq(2, length(name.vec), by = 2)]))
  
  ## Initialize data structure w/ or w/o AUC column, depending on whether 
  ## ground-truth doublet classifications are available
  if (GT == TRUE) {
    sweep.stats <- as.data.frame(matrix(0L, nrow = length(sweep.list), 
                                        ncol = 4))
    colnames(sweep.stats) <- c("pN","pK","AUC","BCreal")
    sweep.stats$pN <- factor(rep(pN, each = length(pK), levels = pN))
    sweep.stats$pK <- factor(rep(pK, length(pN),levels = pK))
  }
  
  if (GT == FALSE) {
    sweep.stats <- as.data.frame(matrix(0L, nrow = length(sweep.list), 
                                        ncol = 3))
    colnames(sweep.stats) <- c("pN","pK","BCreal")
    sweep.stats$pN <- factor(rep(pN, each = length(pK), levels = pN))
    sweep.stats$pK <- factor(rep(pK, length(pN),levels = pK))
  }
  
  ## Perform pN-pK parameter sweep summary
  for (i in seq_along(sweep.list)) {
    res.temp <- sweep.list[[i]]
    
    ## Use gaussian kernel density estimation of pANN vector to compute 
    ## bimodality coefficient
    gkde <- stats::approxfun(KernSmooth::bkde(res.temp$pANN, kernel = "normal"))
    x <- seq(from = min(res.temp$pANN), to = max(res.temp$pANN), 
             length.out = nrow(res.temp))
    sweep.stats$BCreal[i] <- .bimodality_coefficient(gkde(x))
    
    if (GT == FALSE) { next }
    
    ## If ground-truth doublet classifications are available, perform ROC 
    ## analysis on logistic regression model trained using pANN vector
    meta <- as.data.frame(matrix(0L, nrow = nrow(res.temp), ncol = 2))
    meta[,1] <- GT.calls
    meta[,2] <- res.temp$pANN
    train.ind <- sample(seq(nrow(meta)), round(nrow(meta)/2), replace = FALSE)
    test.ind <- seq(nrow(meta))[-train.ind]
    colnames(meta) <- c("SinDub","pANN")
    meta$SinDub <- factor(meta$SinDub, levels = c("Singlet","Doublet"))
    model.lm <- stats::glm(SinDub ~ pANN, 
                           family = stats::binomial(link = 'logit'), 
                           data = meta, subset = train.ind)
    prob <- stats::predict(model.lm, newdata = meta[test.ind, ], 
                           type = "response")
    ROCpred <- ROCR::prediction(predictions = prob, 
                                labels = meta$SinDub[test.ind])
    perf.auc <- ROCR::performance(ROCpred, measure = "auc")
    sweep.stats$AUC[i] <- perf.auc@y.values[[1]]
  }
  
  return(sweep.stats)
}


.bimodality_coefficient <- function(x) {
  G <- .skewness(x)
  sample.excess.kurtosis <- .kurtosis(x)
  K <- sample.excess.kurtosis
  n <- length(x)
  B <- ((G^2) + 1)/(K + ((3*((n - 1)^2))/((n - 2)*(n - 3))))
  return(B)
}

.skewness <- function(x) {
  n <- length(x)
  S <- (1/n)*sum((x - mean(x))^3)/(((1/n)*sum((x - mean(x))^2))^1.5)
  S <- S*(sqrt(n*(n - 1)))/(n - 2)
  return(S)
}

.kurtosis <- function(x) {
  n <- length(x)
  K <- (1/n)*sum((x - mean(x))^4)/(((1/n)*sum((x - mean(x))^2))^2) - 3
  K <- ((n - 1)*((n + 1)*K - 3*(n - 1))/((n - 2)*(n - 3))) + 3
  return(K)
}

.modelHomotypic <- function(annotations) {
  anno.freq <- table(annotations)/length(annotations)
  x <- sum(anno.freq^2)
  return(x)
}

.find.pK <- function(sweep.stats) {
  
  ## Implementation for data without ground-truth doublet classifications
  '%ni%' <- Negate('%in%')
  if ("AUC" %ni% colnames(sweep.stats) == TRUE) {
    ## Initialize data structure for results storage
    bc.mvn <- as.data.frame(matrix(0L, nrow = length(unique(sweep.stats$pK)), 
                                   ncol = 5))
    colnames(bc.mvn) <- c("ParamID","pK","MeanBC","VarBC","BCmetric")
    bc.mvn$pK <- unique(sweep.stats$pK)
    bc.mvn$ParamID <- seq(nrow(bc.mvn))
    
    ## Compute bimodality coefficient mean, variance, and BCmvn across pN-pK 
    ## sweep results
    x <- 0
    for (i in unique(bc.mvn$pK)) {
      x <- x + 1
      ind <- which(sweep.stats$pK == i)
      bc.mvn$MeanBC[x] <- mean(sweep.stats[ind, "BCreal"])
      bc.mvn$VarBC[x] <- stats::sd(sweep.stats[ind, "BCreal"])^2
      bc.mvn$BCmetric[x] <- mean(sweep.stats[ind, "BCreal"]) / 
        (stats::sd(sweep.stats[ind, "BCreal"])^2)
    }
    return(bc.mvn)
  }
  
  ## Implementation for data with ground-truth doublet classifications (e.g., 
  ## MULTI-seq, CellHashing, Demuxlet, etc.)
  if ("AUC" %in% colnames(sweep.stats) == TRUE) {
    ## Initialize data structure for results storage
    bc.mvn <- as.data.frame(matrix(0L, nrow = length(unique(sweep.stats$pK)), 
                                   ncol = 6))
    colnames(bc.mvn) <- c("ParamID","pK","MeanAUC","MeanBC","VarBC","BCmetric")
    bc.mvn$pK <- unique(sweep.stats$pK)
    bc.mvn$ParamID <- seq(nrow(bc.mvn))
    
    ## Compute bimodality coefficient mean, variance, and BCmvn across pN-pK 
    ## sweep results
    x <- 0
    for (i in unique(bc.mvn$pK)) {
      x <- x + 1
      ind <- which(sweep.stats$pK == i)
      bc.mvn$MeanAUC[x] <- mean(sweep.stats[ind, "AUC"])
      bc.mvn$MeanBC[x] <- mean(sweep.stats[ind, "BCreal"])
      bc.mvn$VarBC[x] <- stats::sd(sweep.stats[ind, "BCreal"])^2
      bc.mvn$BCmetric[x] <- mean(sweep.stats[ind, "BCreal"]) / 
        (stats::sd(sweep.stats[ind, "BCreal"])^2)
    }
    
    return(bc.mvn)
    
  }
}

.doubletFinder_v3 <- function(seu, PCs, pN = 0.25, pK, nExp, reuse.pANN = FALSE,
                              sct = FALSE, verbose = FALSE) {
  
  ## Generate new list of doublet classificatons from existing pANN vector to 
  ## save time
  if (reuse.pANN != FALSE ) {
    pANN.old <- seu[[]][ , reuse.pANN]
    classifications <- rep("Singlet", length(pANN.old))
    classifications[order(pANN.old, decreasing = TRUE)[seq(nExp)]] <- "Doublet"
    seu[[]][, paste("DF.classifications", pN, pK, nExp, sep = "_")] <- 
      classifications
    return(seu)
  }
  
  if (reuse.pANN == FALSE) {
    ## Make merged real-artifical data
    real.cells <- colnames(seu)
    data <- Seurat::GetAssayData(seu, slot = "counts", 
                                 assay = "RNA")[, real.cells]
    n_real.cells <- length(real.cells)
    n_doublets <- round(n_real.cells/(1 - pN) - n_real.cells)
    if (verbose) {
      message(date(), " ...   Creating", n_doublets, "artificial doublets")
    }
    real.cells1 <- sample(real.cells, n_doublets, replace = TRUE)
    real.cells2 <- sample(real.cells, n_doublets, replace = TRUE)
    doublets <- (data[, real.cells1] + data[, real.cells2])/2
    colnames(doublets) <- paste("X", seq(n_doublets), sep = "")
    data_wdoublets <- cbind(data, doublets)
    
    ## Store important pre-processing information
    orig.commands <- seu@commands
    
    ## Pre-process Seurat object
    if (sct == FALSE) {
      seu_wdoublets <- Seurat::CreateSeuratObject(counts = data_wdoublets)
      
      seu_wdoublets <- Seurat::NormalizeData(
        seu_wdoublets,
        normalization.method = orig.commands$NormalizeData.RNA@params$normalization.method,
        scale.factor = orig.commands$NormalizeData.RNA@params$scale.factor,
        margin = orig.commands$NormalizeData.RNA@params$margin
      )
      
      seu_wdoublets <- Seurat::FindVariableFeatures(
        seu_wdoublets,
        selection.method = orig.commands$FindVariableFeatures.RNA$selection.method,
        loess.span = orig.commands$FindVariableFeatures.RNA$loess.span,
        clip.max = orig.commands$FindVariableFeatures.RNA$clip.max,
        mean.function = orig.commands$FindVariableFeatures.RNA$mean.function,
        dispersion.function = orig.commands$FindVariableFeatures.RNA$dispersion.function,
        num.bin = orig.commands$FindVariableFeatures.RNA$num.bin,
        binning.method = orig.commands$FindVariableFeatures.RNA$binning.method,
        nfeatures = orig.commands$FindVariableFeatures.RNA$nfeatures,
        mean.cutoff = orig.commands$FindVariableFeatures.RNA$mean.cutoff,
        dispersion.cutoff = orig.commands$FindVariableFeatures.RNA$dispersion.cutoff
      )
      
      seu_wdoublets <- Seurat::ScaleData(
        seu_wdoublets,
        features = orig.commands$ScaleData.RNA$features,
        model.use = orig.commands$ScaleData.RNA$model.use,
        do.scale = orig.commands$ScaleData.RNA$do.scale,
        do.center = orig.commands$ScaleData.RNA$do.center,
        scale.max = orig.commands$ScaleData.RNA$scale.max,
        block.size = orig.commands$ScaleData.RNA$block.size,
        min.cells.to.block = orig.commands$ScaleData.RNA$min.cells.to.block
      )
      
      seu_wdoublets <- Seurat::RunPCA(
        seu_wdoublets,
        features = orig.commands$ScaleData.RNA$features,
        npcs = length(PCs),
        rev.pca =  orig.commands$RunPCA.RNA$rev.pca,
        weight.by.var = orig.commands$RunPCA.RNA$weight.by.var,
        verbose = FALSE
      )
      pca.coord <- Seurat::Reductions(seu_wdoublets, 
                                      "pca")@cell.embeddings[ , PCs]
      cell.names <- rownames(seu_wdoublets[[]])
      nCells <- length(cell.names)
      rm(seu_wdoublets); gc() # Free up memory
    }
    
    if (sct == TRUE) {
      #require(sctransform)
      message(date(), " ...   Creating Seurat object")
      seu_wdoublets <- Seurat::CreateSeuratObject(counts = data_wdoublets)
      
      message(date(), " ...   Running SCTransform")
      seu_wdoublets <- Seurat::SCTransform(seu_wdoublets)
      
      message(date(), " ...   Running PCA")
      seu_wdoublets <- Seurat::RunPCA(seu_wdoublets, npcs = length(PCs))
      pca.coord <- Seurat::Reductions(seu_wdoublets, 
                                      "pca")@cell.embeddings[ , PCs]
      cell.names <- rownames(seu_wdoublets[[]])
      nCells <- length(cell.names)
      rm(seu_wdoublets); gc()
    }
    
    ## Compute PC distance matrix
    dist.mat <- fields::rdist(pca.coord)
    
    ## Compute pANN
    pANN <- as.data.frame(matrix(0L, nrow = n_real.cells, ncol = 1))
    rownames(pANN) <- real.cells
    colnames(pANN) <- "pANN"
    k <- round(nCells * pK)
    for (i in seq(n_real.cells)) {
      neighbors <- order(dist.mat[, i])
      neighbors <- neighbors[2:(k + 1)]
      #neighbor.names <- rownames(dist.mat)[neighbors]
      pANN$pANN[i] <- length(which(neighbors > n_real.cells))/k
    }
    
    classifications <- rep("Singlet",n_real.cells)
    classifications[order(pANN$pANN[seq(n_real.cells)], 
                          decreasing = TRUE)[seq(nExp)]] <- "Doublet"
    seu[[paste("pANN", pN, pK, nExp, sep = "_")]] <- 
      pANN[colnames(seu), 1]
    seu[[paste("DF.classifications", pN, pK, nExp, sep = "_")]] <- 
      classifications
    return(seu)
  }
}

descriptionRunPerCellQC <- function() {
    return(list(
        introduction = "SingleCellTK utilizes the
    [scater](https://bioconductor.org/packages/release/bioc/html/scater.html)
    package to compute cell-level QC metrics. ",
        runPerCellQC = "The wrapper function `runPerCellQC` can be used to separately
    compute QC metrics on its own. ",
        parameter = "In this function, the `inSCE` parameter is the input
    SingleCellExperiment object, while the `useAssay` parameter is the assay
    object that in the SingleCellExperiment object the user wishes to use. ",
        geneSet = "If the user wishes, a list of gene sets can be applied to the
    function to determine the expression of a set of specific genes.
    A gene list imported into the SingleCellExperiment
    object using `importGeneSets` functions can be set as `collectionName`.
    Additionally, a pre-made list of genes can be used to determine the level
    of gene expression per cell. A list containing gene symbols may be set as `geneSetList`,
    or the user may instead use the
    `geneSetCollection` parameter to supply a `GeneSetCollection` object from the
    [GSEABase](https://bioconductor.org/packages/release/bioc/html/GSEABase.html)
    package. ",
        output = "The QC outputs are `sum`, `detected`, and `percent_top_X`. ",
        sum = "`sum` contains the total number of counts for each cell. ",
        detected = "`detected` contains the total number of features for each cell. ",
        percentTop = "`percent_top_X` contains the percentage of the total counts that is made up
    by the expression of the top X genes for each cell. ",
        subsets = "The `subsets_` columns contain information for the specific gene list that
    was used. For instance, if a gene list containing mitochondrial genes
    named `mito` was used, `subsets_mito_sum` would contains the total number of
    mitochondrial counts for each cell. ",
        plotRunPerCellQCResults = "The wrapper function `plotRunPerCellQCResults` can be used
    to plot the general QC outputs. "
    ))
}

descriptionEmptyDrops <- function() {
    return(list(
        introduction = "It is crucial to distinguish the data occurring from real cells
             and empty droplets containing ambient RNA. SCTK employs the
             EmptyDrops algorithm from the
            [DropletUtils](https://bioconductor.org/packages/release/bioc/html/DropletUtils.html)
            package to test for empty droplets. ",
        runEmptyDrops = "The wrapper function `runEmptyDrops` can be used to separately run the
            EmptyDrops algorithm on its own. ",
        parameter = "In `runEmptyDrops`, the `lower` parameter is the lower bound of the
             total UMI count, in which all barcodes below the lower bound are
             assumed to be empty droplets. The `niters` parameter is the number
             of iterations the function will run for the calculation.
            `testAmbient` indicates whether results should be returned for
            barcodes that have a total UMI count below what is specified in
            `lower`. ",
        plotEmptyDropsResults = "The wrapper function `plotEmptyDropsResults` can be used to plot the
              results from the EmptyDrops algorithm. This will visualize the empty droplets,
              by plotting the total UMI counts against the log probability for each barcode. ",
        plot2 = "Data points are colored by FDR values, where we see a small portion
            of the dataset contains barcodes that do not meet the threshold. "
    ))
}

descriptionBarcodeRank <- function() {
    return(list(
        introduction = "[BarcodeRanks](https://rdrr.io/bioc/DropletUtils/man/barcodeRanks.html)
    from the [DropletUtils](https://bioconductor.org/packages/release/bioc/html/DropletUtils.html)
            package computes barcode rank statistics and identifies
             the knee and inflection points on the total count curve. The knee
             and inflection points on the curve represent the difference between
             empty droplets and cell-containing droplets with much more RNA. ",
        runBarcodeRankDrops = "The wrapper function `runBarcodeRankDrops` can be used to separately run the
              BarcodeRanks algorithm on its own. ",
        parameter = "The `lower` parameter is again the lower bound of the total UMI
             count, in which all barcodes below the lower bound are assumed to
             be empty droplets. ",
        plotBarcodeRankDropsResults = "The wrapper function `plotBarcodeRankDropsResults` can be used to plot the
              results from the BarcodeRanks algorithm. ",
        plot = "The total UMI count of each barcode is plotted against its rank, where
              we see a steep dropoff of UMI counts around the inflection point,
              where we see a separation between cell containing and empty droplets. "
    ))
}

descriptionScrublet <- function() {
    return(list(
        introduction = "Scrublet aims to detect doublets by
             creating simulated doublets from combining transcriptomic profiles of existing cells in the dataset. ",
        parameter = "The `sample` parameter indicates what sample each cell originated from.
             It can be set to `NULL` if all cells in the dataset came from the same sample. ",
        additionalParam = "Scrublet also has a large set of parameters that the user can adjust;
             please refer to the Scrublet website for more details. ",
        runScrublet = "The wrapper function `runScrublet` can be used to separately run the
    Scrublet algorithm on its own. ",
        plotScrubletResults = "The wrapper function `plotScrubletResults` can be used to plot the
    results from the Scrublet algorithm. ",
        output = "The Scrublet outputs are `scrublet_score`, which is a numeric
            variable of the likelihood that a cell is a doublet, and the
            `scrublet_label`, which is the assignment of whether the cell
            is a doublet. "
    ))
}

descriptionDoubletFinder <- function() {
    return(list(
        introduction = "DoubletFinder is a doublet detection algorithm which depends on
            the single cell analysis package
            [Seurat](https://cran.r-project.org/web/packages/Seurat/index.html). ",
        runDoubletFinder = "The wrapper function `runDoubletFinder` can be used to separately run the
            DoubletFinder algorithm on its own. ",
        seuratRes = "`runDoubletFinder` relies on a parameter (in Seurat) called
                resolution to determine cells that may be doublets. Users
                will be able to manipulate the resolution parameter through
                `seuratRes`. If multiple numeric vectors are stored in
                `seuratRes`, there will be multiple label/scores. ",
        seuratNfeatures = "The `seuratNfeatures` parameter determines the number of features
            that is used in the `FindVariableFeatures` function in Seurat. ",
        seuratPCs = "`seuratPcs` parameter determines the number of dimensions used in
            the `FindNeighbors` function in Seurat. ",
        seuratFormationRate = "The `formationRate`
            parameter is the estimated doublet detection rate in the dataset.
            aims to detect doublets by creating simulated doublets from
            combining transcriptomic profiles of existing cells in the dataset. ",
        output = "The DoubletFinder outputs are `doubletFinder_doublet_score`,
            which is a numeric variable of the likelihood that a cell is a
            doublet, and the `doubletFinder_doublet_label`, which is the
            assignment of whether the cell is a doublet. ",
        plotDoubletFinderResults = "The wrapper function `plotDoubletFinderResults` can be used to plot the
              QC outputs from the DoubletFinder algorithm. "
    ))
}

descriptionScDblFinder <- function() {
    return(list(
        introduction = "[scDblFinder](https://bioconductor.org/packages/release/bioc/html/scDblFinder.html) is a doublet detection algorithm in the `scran`
             package. scDblFinder aims to detect doublets by creating a
             simulated doublet from existing cells and projecting it to
             the same PCA space as the cells. ",
        runScDblFinder = "The wrapper function `runScDblFinder` can be used to separately run the
              scDblFinder algorithm on its own. ",
        parameter = "The `nNeighbors` parameter is the number of nearest neighbor
used to calculate the density for doublet detection. `simDoublets` is used
to determine the number of simulated doublets used for doublet detection. ",
        output = "The output of scDblFinder is a `scDblFinder_doublet_score` and
             `scDblFinder_doublet_call`. The doublet score of a droplet will be higher if the
             it is deemed likely to be a doublet. ",
        plotScDblFinderResults = "The wrapper function `plotScDblFinderResults` can be used to plot the
              QC outputs from the scDblFinder algorithm. "
    ))
}

descriptionCXDS <- function() {
    return(list(
        introduction = "CXDS, or co-expression based doublet scoring, is an algorithm in
             the [SCDS](https://www.bioconductor.org/packages/release/bioc/html/scds.html)
            package which employs a binomial model for the co-expression of
             pairs of genes to determine doublets. ",
        runCxds = "The wrapper function `runCxds` can be used to separately run the
            CXDS algorithm on its own. ",
        nTop = "In runCxds, the `ntop` parameter is the number of top variance
             genes to consider. ",
        binThresh = "The `binThresh` parameter is the minimum counts
             a gene needs to have to be included in the analysis. ",
        verb = "`verb` determines whether progress messages will be displayed
             or not. ",
        retRes = "`retRes` will determine whether the gene pair results
             should be returned or not. ",
        estNdbl = "The user may set the estimated number of doublets with `estNdbl`. ",
        output = "The output of runCxds is the doublet score, `scds_cxds_score`. ",
        plotCxdsResults = "The wrapper function `plotCxdsResults` can be used to plot the
              QC outputs from the CXDS algorithm. "
    ))
}

descriptionBCDS <- function() {
    return(list(
        introduction = "BCDS, or binary classification based doublet scoring, is an
            algorithm in the [SCDS](https://www.bioconductor.org/packages/release/bioc/html/scds.html)
            package which uses a binary classification approach to determine doublets. ",
        runBcds = "The wrapper function `runBcds` can be used to separately run the
            BCDS algorithm on its own. ",
        nTop = "In runBcds, the `ntop` parameter is the number of top variance
             genes to consider. ",
        srat = "The `srat` parameter is the ratio between
            original number of cells and simulated doublets. ",
        nmax = "The `nmax` parameter is the maximum number of cycles that the algorithm
            should run through. If set to `tune`, this will be automatic. ",
        varImp = "The `varImp` parameter determines if the variable importance
             should be returned or not. ",
        output = "The output of runBcds is `scds_bcds_score`, which is the
             likelihood that a cell is a doublet. ",
        plotBcdsResults = "The wrapper function `plotBCDSResults` can be used to plot the
              QC outputs from the BCDS algorithm. "
    ))
}

descriptionScdsHybrid <- function() {
    return(list(
        introduction = "The CXDS-BCDS hybrid algorithm, uses both CXDS and BCDS
             algorithms from the
            [SCDS](https://www.bioconductor.org/packages/release/bioc/html/scds.html)
            package. ",
        runCxdsBcdsHybrid = "The wrapper function `runCxdsBcdsHybrid` can be used to separately run the
            CXDS-BCDS hybrid algorithm on its own. ",
        parameters = "All parameters from the `runBCDS` and `runBCDS` functions
             may be applied to this function in the `cxdsArgs` and `bcdsArgs`
             parameters, respectively. ",
        output = "The output of runCxdsBcdsHybrid is the doublet score,
             `scds_hybrid_score`. ",
        plotScdsHybridResults = "The wrapper function `plotScdsHybridResults` can be used to plot the
              QC outputs from the CXDS-BCDS hybrid algorithm. "
    ))
}

descriptionDecontX <- function() {
    return(list(
        introduction = "In droplet-based single cell technologies,
            ambient RNA that may have been released from apoptotic or
            damaged cells may get incorporated into another droplet, and can
            lead to contamination. [decontX](https://rdrr.io/bioc/celda/man/decontX.html),
            available from the [celda](https://bioconductor.org/packages/release/bioc/html/celda.html),
            is a Bayesian method for the identification of the contamination 
            level at a cellular level. ",
        runDecontX = "The wrapper function `runDecontX` can be used to 
            separately run the DecontX algorithm on its own. ",
        output = "The outputs of `runDecontX` are `decontX_contamination` and
             `decontX_clusters`. ",
        contamination = "`decontX_contamination` is a numeric vector which 
            characterizes the level of contamination in each cell. ",
        clustering = "Clustering is performed as part of the `runDecontX` 
            algorithm. `decontX_clusters` is the resulting cluster assignment,
            which can also be labeled on the plot. ",
        plotDecontXResults = "The wrapper function `plotDecontXResults` can be 
            used to plot the QC outputs from the DecontX algorithm. "
    ))
}

descriptionSoupX <- function() {
    return(list(
        introduction = "In droplet-based single cell technologies,
            ambient RNA that may have been released from apoptotic or
            damaged cells may get incorporated into another droplet, and can
            lead to contamination. [SoupX](https://github.com/constantAmateur/SoupX)
            uses non-expressed genes to estimates a global contamination 
            fraction.",
        runSoupX = "The wrapper function `runSoupX` can be used to separately 
            run the SoupX algorithm on its own. ",
        output = "The main outputs of `runSoupX` are `soupX_contamination`, 
            `soupX_clusters`, and the corrected assay `SoupX`, together with 
            other intermediate metrics that SoupX generates.",
        contamination = "`soupX_contamination` is a numeric vector which 
            characterizes the level of contamination in each cell. SoupX 
            generates one global contamination estimate per sample, instead of
            returning cell-specific estimation.",
        clustering = "Clustering is required for SoupX algorithm. It will be 
            performed if users do not provide the label as input. 
            `quickCluster()` method from package 
            [scran](https://rdrr.io/bioc/scran/man/quickCluster.html) is adopted
            for this purpose. `soupX_clusters` is the resulting cluster 
            assignment, which can also be labeled on the plot. ",
        plotSoupXResults = "The wrapper function `plotSoupXResult` can be 
            used to plot the QC outputs from the SoupX algorithm. Plots includes
            a UMAP with clustering labels and a number of UMAPs colored with 
            the soup fraction of top marker genes which are identified for 
            contamination estimation. "
    ))
}

descriptionRunCellQC <- function() {
    return(list(
        introduction = "All of the droplet-based QC algorithms are able to be run under the wrapper
             function `runCellQC`. By default all possible QC algorithms will be run. ",
        algorithms = "If users choose to only run a specific set of algorithms,
            they can specify which to run with the `algorithms` parameter. "
    ))
}

descriptionRunDropletQC <- function() {
    return(list(
        introduction = "All droplet-based QC functions are able to be run under
            the wrapper function `runDropletQC`. By default all possible QC algorithms will be run. ",
        algorithms = "If users choose to only run a specific set of algorithms,
            they can specify which to run with the `algorithms` parameter. "
    ))
}

description_subsetSCECols <- function() {
    return(list(
        introduction = "SingleCellExperiment objects can be subset by its colData using
    `subsetSCECols`. ",
        colData = 'The `colData` parameter takes in an expression in character vector form
    which will be used to identify a subset of columns using variables found in the
    colData of the SingleCellExperiment object. For example, if x is a numeric vector
    in colData, then "x < 5" will return all columns with x less than 5.',
        params = "The `index` parameter takes in a vector of indices which should be kept,
    while `bool` takes in a vector of TRUE or FALSE which should be the same length as
    the number of columns in the SingleCellExperiment object. "
    ))
}

# description
library(singleCellTK)
test_that(desc = "Testing description", {
    a <- singleCellTK:::description_subsetSCECols()
    testthat::expect_type(a, "list")
    a <- singleCellTK:::descriptionBarcodeRank()
    testthat::expect_type(a, "list")
    a <- singleCellTK:::descriptionBCDS()
    testthat::expect_type(a, "list")
    a <- singleCellTK:::descriptionCXDS()
    testthat::expect_type(a, "list")
    a <- singleCellTK:::descriptionDecontX()
    testthat::expect_type(a, "list")
    a <- singleCellTK:::descriptionDoubletFinder()
    testthat::expect_type(a, "list")
    a <- singleCellTK:::descriptionEmptyDrops()
    testthat::expect_type(a, "list")
    a <- singleCellTK:::descriptionRunCellQC()
    testthat::expect_type(a, "list")
    a <- singleCellTK:::descriptionRunDropletQC()
    testthat::expect_type(a, "list")
    a <- singleCellTK:::descriptionRunPerCellQC()
    testthat::expect_type(a, "list")
    a <- singleCellTK:::descriptionScDblFinder()
    testthat::expect_type(a, "list")
    a <- singleCellTK:::descriptionScdsHybrid()
    testthat::expect_type(a, "list")
    a <- singleCellTK:::descriptionScrublet()
    testthat::expect_type(a, "list")
    a <- singleCellTK:::descriptionSoupX()
    testthat::expect_type(a, "list")
})

#' Run EnrichR on SCE object
#' @details
#' EnrichR works by querying the specified \code{features} to its online
#' databases, thus it requires the Internet connection.
#'
#' Available \code{db} options could be shown by running
#' \code{enrichR::listEnrichrDbs()$libraryName}
#'
#' This function checks for the existence of features in the SCE object. When
#' \code{features} do not have a match in \code{rownames(inSCE)}, users may
#' try to specify \code{by} to pass the check.
#'
#' EnrichR expects gene symbols/names as the input (i.e. Ensembl ID might not
#' work). When specified \code{features} are not qualified for this, users may
#' try to specify \code{featureName} to change the identifier type to pass to
#' EnrichR.
#' @param inSCE A \linkS4class{SingleCellExperiment} object.
#' @param features Character vector, selected genes for enrichment analysis.
#' @param analysisName A string that identifies each specific analysis.
#' @param db Character vector. Selected database name(s) from the enrichR
#' database list. If \code{NULL} then EnrichR will be run on all the available
#' databases on the enrichR database. See details. Default \code{NULL}
#' @param by Character. From where should we find the \code{features}?
#' \code{"rownames"} for from \code{rownames(inSCE)}, otherwise, from a column
#' of feature metadata (\code{rowData(inSCE)[[by]]}). See details. Default
#' \code{"rownames"}.
#' @param featureName Character. Indicates the actual feature identifiers to be
#' passed to EnrichR. Can be \code{"rownames"}, a column in feature metadata
#' (\code{rowData(inSCE)[[featureName]]}), or a character vector with its length
#' equals to \code{nrow(inSCE)}. See details. Default \code{"rownames"}.
#' @return Updates \code{inSCE} metadata with a data.frame of enrichment terms
#' overlapping in the respective databases along with p-values, z-scores etc.
#' @export
#' @seealso \code{\link{getEnrichRResult}}
#' @examples
#' data("mouseBrainSubsetSCE")
#' if (Biobase::testBioCConnection()) {
#'   mouseBrainSubsetSCE <- runEnrichR(mouseBrainSubsetSCE, features =  c("Vamp7","Cntn2","Olig1"),
#'                                     db = "GO_Cellular_Component_2025",
#'                                     analysisName = "analysis1")
#' }
#'
runEnrichR <- function(inSCE,
                       features,
                       analysisName,
                       db = NULL,
                       by = "rownames",
                       featureName = NULL) {
  if (!inherits(inSCE, "SingleCellExperiment")) {
    stop("inSCE has to inherit from SingleCellExperiment object.")
  }
  if (is.null(analysisName)) {
    stop("Have to specify analysisName.")
  }
  if (by == "rownames") {
    if (!all(features %in% rownames(inSCE))) {
      stop("Not all features found in `rownames(inSCE)`.")
    }
    allFeatures <- rownames(inSCE)
  } else {
    if (!by %in% names(SummarizedExperiment::rowData(inSCE))) {
      stop("`by` not found in rowData(inSCE).")
    }
    if (!all(features %in% SummarizedExperiment::rowData(inSCE)[[by]])) {
      stop("Not all features found in `rowData(inSCE)$",by,"`.")
    }
    allFeatures <- SummarizedExperiment::rowData(inSCE)[[by]]
  }
  if (!is.null(featureName)) {
    featureIdx <- allFeatures %in% features
    if (length(featureName) == 1) {
      if (featureName == "rownames") {
        features <- rownames(inSCE)[featureIdx]
      } else if (featureName %in% names(SummarizedExperiment::rowData(inSCE))) {
        features <- SummarizedExperiment::rowData(inSCE[featureIdx,])[[featureName]]
      } else {
        stop("featureName not found in `rowData(inSCE)`.")
      }
    } else if (length(featureName) == nrow(inSCE)) {
      features <- featureName[featureIdx]
    } else {
      stop("Invalid featureName specification.")
    }
  }
  internetConnection <- suppressWarnings(Biobase::testBioCConnection())
  #check for internet connection
  if (!internetConnection){
    stop("The Enrichr database could not be queried. No internet connection available.")
  }
  err <- tryCatch(
    {
      attachNamespace("enrichR")
    },
    error = function(e) {}
  )
  #options(enrichR.base.address = "https://maayanlab.cloud/Enrichr/")
  #options(enrichR.live = TRUE)
  temp_db <- NULL
  err <- tryCatch(
    {
      temp_db <- .getEnrichrDB(noConnect = "error")
    },
    error = function(e) {}
  )
  enrdb <- temp_db$libraryName
  #test for db existing
  if (is.null(db)){
    db <- enrdb
  } else if (!all(db %in% enrdb)){
    db.notFound <- db[!db %in% enrdb]
    stop("Database(s) ", paste(db.notFound, collapse = ", "), " were not found in Enrichr.")
  }

  enriched <- enrichR::enrichr(features, db)
  enriched <- data.frame(data.table::rbindlist(enriched, use.names = TRUE,
                                               fill = TRUE,
                                               idcol = "Database_selected"))

  if(!is.null(enriched) && nrow(enriched) > 0) {

    #sort the results based on p-values
    enriched <- enriched[order(enriched$P.value, decreasing = FALSE), ]

    getEnrichRResult(inSCE, analysisName) <- list(result = enriched,
                                                  param = list(
                                                    features = features,
                                                    by = by,
                                                    db = db
                                                  ))
  } else {
    stop("No enrichments identified. No enrichment results were created.")
  }

  return(inSCE)
}

#' @title Plot EnrichR results
#' @description Plot results of EnrichR analysis as a barplot.
#' @param inSCE Input \linkS4class{SingleCellExperiment} object with saved
#' EnrichR results. Required.
#' @param analysisName A string that identifies the specific analysis to plot.
#' Required.
#' @param showTerms Number of enrichment terms to show. Default is 20.
#' @param numChar Integer. Indicates the maximum number characters to be
#' displayed in the term names. Default is 40.
#' @param y Character string. Indicates the variable to be shown on the
#' y-axis. Can be one of "Count" or "Ratio". Results that include background
#' genes can only show "Count". Default is "Count".
#' @param orderBy Charachter string. Indicates how to order the results prior
#' to subsetting. Can be one of "P.value", "Adjusted.P.Value",
#' or "Combined.Score". Default is "Adjusted.P.value".
#' @param xlab Character vector. Label for x-axis. Default NULL.
#' @param ylab Character vector. Label for y-axis. Default NULL.
#' @param title Character string. Title of the plot. Default NULL.
#' @return A ggplot object of EnrichR results.
#' @export
plotEnrichR <- function(inSCE,
                        analysisName,
                        showTerms = 20,
                        numChar = 40,
                        y = "Count",
                        orderBy = "Adjusted.P.value",
                        xlab = NULL,
                        ylab = NULL,
                        title = NULL){
    res <- getEnrichRResult(inSCE, analysisName = analysisName)
    p <- enrichR::plotEnrich(df = res$result, showTerms = showTerms, numChar = numChar, y = y,
                    orderBy = orderBy, xlab = xlab, ylab = ylab, title = title)
    return(p)
}


#' @title Get or Set EnrichR Result
#' @rdname getEnrichRResult
#' @param inSCE A \linkS4class{SingleCellExperiment} object.
#' @param analysisName A string that identifies each specific analysis
#' @param value The EnrichR result table
#' @return For getter method, a data.frame of the EnrichR result;
#' For setter method, \code{inSCE} with EnrichR results updated.
#' @export
#' @seealso \code{\link{runEnrichR}}
#' @examples
#' data("mouseBrainSubsetSCE")
#' if (Biobase::testBioCConnection()) {
#'   mouseBrainSubsetSCE <- runEnrichR(mouseBrainSubsetSCE, features = c("Vamp7","Cntn2","Olig1"),
#'                                     db = "GO_Cellular_Component_2025",
#'                                     analysisName = "analysis1")
#'   result <- getEnrichRResult(mouseBrainSubsetSCE, "analysis1")
#' }
setGeneric("getEnrichRResult<-", function(inSCE, analysisName, value)
  standardGeneric("getEnrichRResult<-"))

#' @rdname getEnrichRResult
#' @export
setGeneric("getEnrichRResult", function(inSCE, analysisName)
  standardGeneric("getEnrichRResult"))

#' @rdname getEnrichRResult
#' @export
setMethod("getEnrichRResult",
          "SingleCellExperiment",
          function(inSCE, analysisName){
            if (!"runEnrichR" %in% names(S4Vectors::metadata(inSCE)$sctk)) {
              stop("EnrichR analysis not performed yet. ",
                   "Please run `runEnrichR()`")
            }
            if (!analysisName %in% names(S4Vectors::metadata(inSCE)$sctk$runEnrichR)) {
              stop('"', analysisName, '" not found in EnrichR analysis names.')
            }
            return(S4Vectors::metadata(inSCE)$sctk$runEnrichR[[analysisName]])
          })

#' @rdname getEnrichRResult
#' @export
setReplaceMethod("getEnrichRResult",
                 c("SingleCellExperiment"),
                 function(inSCE, analysisName, value) {
                   if (is.null(analysisName)) {
                     stop("Have to specify analysisName.")
                   }
                   S4Vectors::metadata(inSCE)$sctk$runEnrichR[[analysisName]] <- value
                   return(inSCE)
                 })

.getEnrichrDB <- function(noConnect = c("warn", "error", "ignore")) {
  db <- NULL
  noConnect <- match.arg(noConnect)
  db <- enrichR::listEnrichrDbs()
  if(is.null(db)) {
    if(noConnect == "error") {
      stop("Connection to the online Enrichr database could not be established. No database information retrieved.")
    } else if (noConnect == "warn") {
      warning("Connection to the online Enrichr database could not be established. No database information retrieved.")
    }
  }
  return(db)
}

#------------#
# ROW MAKING #
#------------#

make3ColTableRow <- function(selector, id, col1, col2) {
  fluidRowStyle <- paste0(paste0("#", id), "{border-bottom: 1px solid #bababa; padding-top: .9%; padding-bottom: .5%}")
  removeBtnStyle <- paste0(paste0("#remove", id), "{padding-top: 0; padding-bottom: 0;}")
  insertUI(
    selector = selector,
    ui = fluidRow(
      id = id,
      tags$style(HTML(paste0(fluidRowStyle, removeBtnStyle))),
      column(4, col1),
      column(4, col2),
      column(4, actionButton(paste0("remove", id), "X"))
    )
  )
}

# make4ColTableRow <- function(selector, id, col1, col2, col3) {
#   fluidRowStyle <- paste0(paste0("#", id), "{border-bottom: 1px solid #bababa; padding-top: .9%; padding-bottom: .5%}")
#   removeBtnStyle <- paste0(paste0("#remove", id), "{padding-top: 0; padding-bottom: 0;}")
#   insertUI(
#     selector = selector,
#     ui = fluidRow(
#       id = id,
#       tags$style(HTML(paste0(fluidRowStyle, removeBtnStyle))),
#       column(3, col1),
#       column(3, col2),
#       column(3, col3),
#       column(3, actionButton(paste0("remove", id), "X"))
#     )
#   )
# }

addToGeneralSampleTable <- function(inputID, id, col2, col3) {
  col1 <- ""
  if (inputID == "files") {
    col1 <- "Files"
  } else if (inputID == "example") {
    col1 <- "Example"
  } else if (inputID == "rds") {
    col1 <- "RDS"
  } else if (inputID == "cellRanger2") {
    col1 <- "Cell Ranger 2"
  } else if (inputID == "cellRanger3") {
    col1 <- "Cell Ranger 3"
  } else if (inputID == "starSolo") {
    col1 <- "STARsolo"
  } else if (inputID == "busTools") {
    col1 <- "BUStools"
  } else if (inputID == "seqc") {
    col1 <- "SEQC"
  } else if (inputID == "optimus") {
    col1 <- "Optimus"
  }

  fluidRowStyle <- paste0(paste0("#", id), "{border-bottom: 1px solid #bababa; padding-top: .9%; padding-bottom: .5%}")
  removeBtnStyle <- paste0(paste0("#remove", id), "{padding-top: 0; padding-bottom: 0;}")
  insertUI(
    selector = "#newSampleImport",
    ui = fluidRow(
      id = id,
      tags$style(HTML(paste0(fluidRowStyle, removeBtnStyle))),
      column(3, col1),
      column(3, col2),
      column(3, col3),
      column(3, actionButton(paste0("remove", id), "X"))
    )
  )
}


#---------------#
# IMPORT MODALS #
#---------------#

# modal to import CellRanger data
importCRModal <- function() {
  modalDialog(
    h3("Add a Cell Ranger Sample"),
    tags$br(),
    h4("Option 1 - Select a directory containing multiple sample directories (and no other directories)."),
    actionButton("crOpt1", "Add"),
    tags$br(),
    h4("Option 2 - Select a single sample directory."),
    actionButton("crOpt2", "Add"),
    tags$br(),
    h4("Option 3 - Select a directory containing your data files (barcodes.tsv, features.tsv, matrix.mtx)."),
    actionButton("crOpt3", "Add"),

    footer = tagList(
      modalButton("Cancel"),
      actionButton("crOK", "OK")
    )
  )
}

# Upload a base directory (CR) (parent of possibly multiple sample directories)
# For crOpt1
importCRBDir <- function(failed = FALSE) {
  modalDialog(
    h3("Base Directory"),
    #shinyDirectoryInput::directoryInput('bDirectory', label = 'Choose Directory', value = getwd()),

    shinyFiles::shinyDirButton("bDirectory", label = "Choose Directory", title = "Upload"),
    # A UI to display what users select
    verbatimTextOutput("bDirectoryPath", placeholder = TRUE),

    wellPanel(h5("*For any sample names that you do not provide, the sample name will be set to the sample directory name.")),

    tags$div(id = "bDirTable"),

    if (failed)
      div(tags$b("Please fill out all the required fields", style = "color: red;")),

    footer = tagList(
      modalButton("Cancel"),
      actionButton("BDirOK", "OK")
    )
  )
}

# Upload a sample directory (CR) (parent of 'outs' directory)
# For crOpt2
importCRSDir <- function(failed = FALSE) {
  modalDialog(
    h3("Sample Directory"),
    #shinyDirectoryInput::directoryInput('sDirectory', label = 'Choose Directory', value = '~'),

    shinyFiles::shinyDirButton("sDirectory", label = "Choose Directory", title = "Upload"),
    # A UI to display what users select
    verbatimTextOutput("sDirectoryPath", placeholder = TRUE),
    tags$div(id = "sDirTable"),
    h3("Sample Name"),
    h5("If you do not provide an alternate sample name, the sample name will be set to the sample directory name."),
    textInput("sSampleID", ""),

    if (failed)
      div(tags$b("Please fill out all the required fields", style = "color: red;")),

    footer = tagList(
      modalButton("Cancel"),
      actionButton("SDirOK", "OK")
    )
  )
}

# Upload a data directory (CR) (parent of 'data files')
# For crOpt3
importCRDDir <- function(failed = FALSE) {
  modalDialog(
    h3("Data Directory"),
    #shinyDirectoryInput::directoryInput('directory', label = 'Choose Directory', value = '~'),

    shinyFiles::shinyDirButton("directory", label = "Choose Directory", title = "Upload"),
    # A UI to display what users select
    verbatimTextOutput("directoryPath", placeholder = TRUE),

    h3("Sample Name"),
    textInput("dSampleID", "*This field is mandatory when uploading a data directory"),

    if (failed)
      div(tags$b("Please fill out all the required fields", style = "color: red;")),

    footer = tagList(
      modalButton("Cancel"),
      actionButton("DDirOK", "OK")
    )
  )
}

importModal <- function(failed=FALSE, needsDir=FALSE) {
  modalDialog(
    h3("Sample Name"),
    textInput("sampleName", "*This is the name you would like to give your sample."),
    # only some functions need this input
    if (needsDir)
      h3("Sample ID"),
    if (needsDir)
      textInput("sampleID", "*This name must match your sample's directory name."),

    h3("Base Directory"),
    #shinyDirectoryInput::directoryInput('directory', label = 'Choose Directory', value = ),

    shinyFiles::shinyDirButton("directory", label = "Choose Directory", title = "Upload"),
    # A UI to display what users select
    verbatimTextOutput("directoryPath", placeholder = TRUE),

    if (failed)
      div(tags$b("Please fill out all the required fields", style = "color: red;")),

    footer = tagList(
      modalButton("Cancel"),
      actionButton("modalOk", "OK")
    )
  )
}


importStarModal <- function(failed=FALSE, needsDir=FALSE) {
  modalDialog(
    h3("Sample Name"),
    textInput("sampleName", "*This is the name you would like to give your sample."),
    # only some functions need this input
    if (needsDir)
      h3("Sample ID"),
    if (needsDir)
      textInput("sampleID", "*This name must match your sample's directory name."),
    
    selectInput(
      inputId = "geneFolder",
      label = "Select Gene Folder: ",
      choices = c("Gene" = "Gene",
                  "GeneFull" = "GeneFull")
    ),
    
    
    h3("Base Directory"),
    #shinyDirectoryInput::directoryInput('directory', label = 'Choose Directory', value = ),
    
    shinyFiles::shinyDirButton("directory", label = "Choose Directory", title = "Upload"),
    # A UI to display what users select
    verbatimTextOutput("directoryPath", placeholder = TRUE),
    
    if (failed)
      div(tags$b("Please fill out all the required fields", style = "color: red;")),
    
    footer = tagList(
      modalButton("Cancel"),
      actionButton("modalStarOk", "OK")
    )
  )
}



#--------------#
# QC/FILTERING #
#--------------#

# qcModal <- function(assays=NULL, geneSetList=FALSE, geneSetListLocation=FALSE,
#                     geneSetCollection=FALSE, failed=FALSE, requireAssayStr='') {
#   modalDialog(
#     h3("QC Paramters - some of the algorithms you have selected require the following extra parameters:"),
#     if (!is.null(assays))
#       selectInput("qcAssaySelect", paste0("Select assay for ", requireAssayStr), assays),
#     if (geneSetList)
#       tags$hr(),
#     if (geneSetList)
#       h4(tags$b("Parameters for QCMetrics:")),
#     # The following selectInputs are just place holders until there is gene set code
#     if (geneSetList)
#       selectInput("geneSetList", "Select Gene Set List", assays),
#     if (geneSetListLocation)
#       selectInput("geneLocation", "Select Gene Set List Location", assays),
#     if (geneSetCollection)
#       selectInput("geneCollection", "Select Gene Set Collection", assays),
#
#     if (failed)
#       div(tags$b("Please fill out all the required fields", style = "color: red;")),
#
#     footer = tagList(
#       modalButton("Cancel"),
#       actionButton("modalRunQC", "Run")
#     )
#   )
# }

# creates tabs for results from QC
showQCResTabs <- function(obj, algoList, statuses, plotIds) {
  if (("QCMetrics" %in% algoList) && is.null(statuses$QCMetrics)) {
    appendTab("qcResPlotTabs", tabPanel("QCMetrics",
                                        fluidPage(id = "QCMetricsTab",
                                                  uiOutput(outputId = plotIds$QCMetrics),
                                                  tabsetPanel(
                                                    id ="QCMetricsTabs"
                                                  )
                                        ),
                                ),
              select = TRUE
    )
  }
  for (i in seq_along(algoList)) {
    algo <- algoList[[i]]
    id <- paste0(algo, "Tab")
    if ((algo != "QCMetrics") && is.null(statuses[[algo]])) {
      appendTab("qcResPlotTabs", tabPanel(algo,
                                          fluidPage(id = id,
                                                    uiOutput(outputId = plotIds[[algo]]),
                                                    tabsetPanel(
                                                      id = paste0(algo, "Tabs")
                                                    )
                                          ),
                                  ),
                select = FALSE
      )
    }
  }
}


filteringModal <- function(failed=FALSE, colNames) {
  modalDialog(
    h3("Select an Annotation"),
    selectInput("filterColSelect", "", colNames),
    if (failed)
      div(tags$b("Please fill out all the required fields", style = "color: red;")),
    shinyjs::hidden(
      tags$div(id = "convertFilterType",
               # checkboxInput("convertToCat", "Convert to categorical filter?"),
      )
    ),
    tags$div(id = "filterCriteria"),
    tags$div(id = "filterCrErrors"),
    footer = tagList(
      modalButton("Cancel"),
      actionButton("filtModalOK", "OK")
    )
  )
}

rowFilteringModal <- function(failed=FALSE, assayInput) {
  modalDialog(
    h3("Select an Assay"),
    selectInput("filterAssaySelect", "", assayInput),
    if (failed)
      div(tags$b("Please fill out all the required fields", style = "color: red;")),
    tags$div(id = "rowFilterCriteria"),

    footer = tagList(
      modalButton("Cancel"),
      actionButton("rowFiltModalOK", "OK")
    )
  )
}

addFilteringThresholdOptions <- function(colInput) {
  minCol <- min(colInput)
  maxCol <- max(colInput)

  gt_label_str <- sprintf("Keep values above (please pick a number between %.5f and %.5f):", minCol, maxCol)
  lt_label_str <- sprintf("Keep values below (please pick a number between %.5f and %.5f):", minCol, maxCol)


  insertUI(
    selector = "#filterCriteria",
    ui = tags$div(
      id="newThresh",
      checkboxInput("colGT", "Greater than:"),
      shinyjs::hidden(
        numericInput("filterThreshGT", gt_label_str, minCol, min = minCol, max = maxCol)
      ),
      checkboxInput("colLT", "Less than:"),
      shinyjs::hidden(
        numericInput("filterThreshLT", lt_label_str, minCol, min = minCol, max = maxCol)
      )
    )
  )
}

.checkSCEValidity <- function(inSCE){
  if(is.null(rownames(inSCE)))
    stop("Rownames of the input SCE object cannot be NULL.")
  if(is.null(colnames(inSCE)))
    stop("Colnames of the input SCE object cannot be NULL.")
}

#' Check or retrieve cell metadata variable
#' @description Used as a helper for handling cell variables. Users can input
#' a custom variable or retrieve existing variable from \code{colData}. This
#' function makes sure that the output has valid length (\code{ncol(inSCE)}),
#' and convert vector to factor if needed.
#' @param inSCE Input \linkS4class{SingleCellExperiment} inherited object.
#' @param var A single character for \code{colData} variable or a vector of the
#' same length as \code{ncol(inSCE)}
#' @param as.factor Should the variable be output as \code{factor}?
#' @importFrom SummarizedExperiment colData
#' @return a vector of cell metadata variable, or a factor if
#' \code{as.factor = TRUE}.
#' @noRd
.manageCellVar <- function(inSCE, var = NULL, as.factor = FALSE) {
    if (!is.null(var)) {
      if (!is.vector(var) & !is.factor(var)) {
        stop("Invalid variable class")
      }
      if (length(var) != 1 & length(var) != ncol(inSCE)) {
        stop("Invalid variable length")
      }
      if (is.character(var)) {
        if (length(var) == 1) {
          if (!var %in% names(colData(inSCE))) {
            stop("Specified variable '", var, "' not found in colData(inSCE)")
          }
          var <- colData(inSCE)[[var]]
        }
      } else {
        if (length(var) == 1) {
          stop("Invalid variable class of length 1")
        }
      }
      if (isTRUE(as.factor) & !is.factor(var)) {
        var <- factor(var)
      }
    }
    return(var)
}

.manageFeatureVar <- function(inSCE, var = NULL, as.factor = FALSE) {
  if (!is.null(var)) {
    if (!is.vector(var) & !is.factor(var)) {
      stop("Invalid variable class")
    }
    if (length(var) != 1 & length(var) != nrow(inSCE)) {
      stop("Invalid variable length")
    }
    if (is.character(var)) {
      if (length(var) == 1) {
        if (!var %in% names(rowData(inSCE))) {
          stop("Specified variable '", var, "' not found in rowData(inSCE)")
        }
        var <- rowData(inSCE)[[var]]
      }
    } else {
      if (length(var) == 1) {
        stop("Invalid variable class of length 1")
      }
    }
    if (isTRUE(as.factor) & !is.factor(var)) {
      var <- factor(var)
    }
  }
  return(var)
}

#' Perform Checks and finally indicate which matrix to use.
#' @details Basic rule: (1) When \code{useAltExp} is not \code{NULL}, fetch
#' assay or reducedDim from altExp; (2) When \code{useReducedDim} is not
#' \code{NULL}, ignore \code{useAssay}.
#' @param inSCE Input \linkS4class{SingleCellExperiment} inherited object.
#' @param useAssay Name of assay to use
#' @param useReducedDim Name of low-dimensional representation to use
#' @param useAltExp Name of alt-experiment to use
#' @param returnMatrix Whether to also return the matrix indicated by inputs.
#' @param cellAsCol When \code{returnMatrix = TRUE}, whether each column should
#' be a cell (i.e. transpose reducedDim).
#' @return A list, including \code{$names} for the final decision, and,
#' \code{$mat} for the matrix fetched when \code{returnMatrix = TRUE}.
#' @noRd
.selectSCEMatrix <- function(
    inSCE,
    useAssay = NULL,
    useReducedDim = NULL,
    useAltExp = NULL,
    returnMatrix = FALSE,
    cellAsCol = FALSE
) {
    if (!inherits(inSCE, "SingleCellExperiment")) {
        stop("`inSCE` should be a SingleCellExperiment Object.")
    }
    if (is.null(useAssay) & is.null(useReducedDim)) {
        stop("Either `useAssay` or `useReducedDim` has to be specified.")
    }
    if (is.null(useAltExp)) {
        if (!is.null(useReducedDim)) {
            if (!useReducedDim %in% SingleCellExperiment::reducedDimNames(inSCE)) {
                stop("Specified `useReducedDim` '", useReducedDim,
                     "' not found.")
            }
            useAssay <- NULL
        } else {
            if(!useAssay %in% SummarizedExperiment::assayNames(inSCE)) {
                stop("Specified `useAssay` '", useAssay, "' not found.")
            }
        }
    } else {
        if (!useAltExp %in% SingleCellExperiment::altExpNames(inSCE)) {
            stop("Specified `useAltExp` '", useAltExp, "' not found.")
        }
        ae <- SingleCellExperiment::altExp(inSCE, useAltExp)
        if (!is.null(useReducedDim)) {
            if (!useReducedDim %in% SingleCellExperiment::reducedDimNames(ae)) {
                stop("Specified `useReducedDim` '", useReducedDim,
                     "' not found in the altExp.")
            }
            useAssay <- NULL
        } else {
            if(!useAssay %in% SummarizedExperiment::assayNames(ae)) {
                stop("Specified `useAssay` '", useAssay,
                     "' not found in the altExp.")
            }
        }
    }
    result <- list(
        names = list(
            useAssay = useAssay,
            useReducedDim = useReducedDim,
            useAltExp = useAltExp
        )
    )
    if (isTRUE(returnMatrix)) {
        if (!is.null(useAltExp)) {
            if (!is.null(useReducedDim)) {
                mat <- SingleCellExperiment::reducedDim(
                    SingleCellExperiment::altExp(inSCE, useAltExp),
                    useReducedDim)
                if (isTRUE(cellAsCol)) mat <- t(mat)
            } else {
                mat <- SummarizedExperiment::assay(
                    SingleCellExperiment::altExp(inSCE, useAltExp),
                    useAssay)
            }
        } else {
            if (!is.null(useReducedDim)) {
                mat <- SingleCellExperiment::reducedDim(inSCE, useReducedDim)
                if (isTRUE(cellAsCol)) mat <- t(mat)
            } else {
                mat <- SummarizedExperiment::assay(inSCE, useAssay)
            }
        }
        result$mat <- mat
    }
    return(result)
}

shinyPanelHeatmap <- fluidPage(
  tags$div(
    class = "container",
    h1("Heatmap"),
    p("Generic heatmap plotting panel for customized figure.",
      style = "color:grey;"),
    h5(tags$a(href = paste0(docs.artPath, "heatmap.html"),
              "(help)", target = "_blank")),
    panel(
      fluidRow(
        div(style="display:inline-block;vertical-align:top;width:120px;margin-left:20px;",
            h4("Assay to Plot")),
        div(style="display:inline-block;vertical-align:bottom;width:160px;margin-top:5px;",
            selectizeInput(
              inputId = "hmAssay", 
              label = "Select input matrix:", 
              choices = NULL, 
              selected = NULL, 
              multiple = FALSE,
              options = NULL)
            #uiOutput("hmAssay")
            )
            #selectInput("hmAssay", NULL, currassays))
      ),
      fluidRow(
        div(style="display:inline-block;vertical-align:bottom;width:180px;margin-left:20px;",
            h4("Import from analysis")),
        div(style="display:inline-block;vertical-align:bottom;width:200px;margin-top:5px;",
            selectInput("hmImport", NULL,
                        c("None",
                          "Differential Expression",
                          "Find Marker"),
                        selected = "None")),
        div(style="display:inline-block;vertical-align:bottom;width:50px;margin-left:8px;margin-bottom:15px;",
            actionButton("hmImportRun", "Import"))
      ),
      conditionalPanel(
        condition = "input.hmImport == 'Differential Expression'",
        uiOutput("hmImpDEGUI")
      ),
      hr(),
      # Subset ####
      h3("Cell/Feature Subsetting"),
      p("Only to plot cells/features of interests", style = "color:grey;"),
      tabsetPanel(
        id = 'hmSubsetTSP',
        tabPanel(
          title = "Cell", value = 'hmSubsetCellTP',
          tagList(
            uiOutput('hmCellColUI'),
            DT::dataTableOutput("hmCellColTable"),
            actionButton('hmCellColTable_addAll', "Add all filtered"),
            actionButton('hmCellColTable_clear', "Clear selection"),
          )
        ),
        tabPanel(
          title = "Feature", value = 'hmSubsetGeneTP',
          tagList(
            uiOutput('hmGeneColUI'),
            DT::dataTableOutput("hmGeneColTable"),
            actionButton('hmGeneColTable_addAll', "Add all filtered"),
            actionButton('hmGeneColTable_clear', "Clear selection"),
          )
        ),
        tabPanel(
          title = "Manual Enter", value = 'hmSubsetManualTP',
          fluidRow(
            column(
              width = 6,
              selectInput("hmCellTextBy", "Match input cell identifiers by:",
                          c("Row Names", clusterChoice), selected = "Row Names"),
              checkboxInput('hmCellTextEM', "Exact Match", value = TRUE),
              checkboxInput('hmCellTextFM', "First Match", value = TRUE),
              textAreaInput(
                inputId = 'hmCellText',
                label = "Enter Cell Identifiers",
                placeholder = "One cell per line, with no symbol separator."
              ),
              uiOutput('hmCellNEnteredUI'),
              actionButton("hmCellAddFromText", "Add")
            ),
            column(
              width = 6,
              selectInput("hmGeneTextBy", "Match input feature identifiers by:",
                          c("Row Names", featureChoice), selected = "Row Names"),
              checkboxInput('hmGeneTextEM', "Exact Match", value = TRUE),
              checkboxInput('hmGeneTextFM', "First Match", value = TRUE),
              textAreaInput(
                inputId = 'hmGeneText',
                label = "Enter Feature Identifiers",
                placeholder = "One Feature per line, with no symbol separator."
              ),
              uiOutput('hmGeneNEnteredUI'),
              actionButton("hmGeneAddFromText", "Add")
            )
          )
        )
      ),
      uiOutput("hmCellSumUI"),
      uiOutput("hmGeneSumUI"),
      hr(),
      # Annotation ####
      h3("Annotation Setting"),
      p("Stick additional information at sides of the plot",
        style = "color:grey;"),
      tabsetPanel(
        id = 'hmAnnTSP',
        tabPanel(
          title = "Cell", value = 'hmAnnCellTP',
          uiOutput('hmCellAnnUI'),
          uiOutput('hmCellAnnAssUI')
        ),
        tabPanel(
          title = "Feature", value = 'hmAnnGeneTP',
          uiOutput('hmGeneAnnUI'),
          uiOutput('hmGeneAnnAssUI')
        )
      ),
      hr(),
      # Others ####
      h3("Heatmap Setting"),
      p("Settings for split, label, dendrogram, color scheme and etc.",
        style = "color:grey;"),
      panel(
        fluidRow(
          column(
            width = 6,
            uiOutput('hmColSplitUI'),
            checkboxGroupInput('hmAddLabel', "Add cell/feature labels",
                               choiceNames = c('cells', 'features'),
                               inline = TRUE, choiceValues = c(1, 2)),
            conditionalPanel(
              condition = "input.hmAddLabel.includes('1')",
              selectInput('hmAddCellLabel', "Add cell labels from",
                          c("Default cell IDs", clusterChoice),
                          selected = "Default cell IDs")
            ),
            conditionalPanel(
              condition = "input.hmAddLabel.includes('2')",
              selectInput('hmAddGeneLabel', "Add feature labels from",
                          c("Default feature IDs", featureChoice),
                          selected = "Default feature IDs")
            ),
            uiOutput('hmTrimUI')
          ),
          column(
            width = 6,
            uiOutput('hmRowSplitUI'),
            checkboxGroupInput('hmShowDendro', "Show dendrograms for",
                               choiceNames = c('cells', 'features'),
                               inline = TRUE, choiceValues = c(1, 2),
                               selected = c(1, 2)),
            checkboxInput("hmScale", "Z-Score Scale", value = TRUE)
          )
        ),
        h4("Color Scheme"),
        selectizeInput(
          inputId = 'hmCSPalette',
          label = "Choose from preset:",
          choices = NULL,
        ),
        fluidRow(
          column(
            width = 4,
            colourpicker::colourInput('hmCSLow', 'Low color',value = 'blue')
          ),
          column(
            width = 4,
            colourpicker::colourInput('hmCSMedium', 'Medium color',value = 'white')
          ),
          column(
            width = 4,
            colourpicker::colourInput('hmCSHigh', 'High color',value = 'red')
          )
        )
      ),
      hr(),
      withBusyIndicatorUI(actionButton("plotHeatmap", "Plot Heatmap")),
      div(
        style = 'height:800px;',
        plotOutput("Heatmap")
      )
    )
  )
)

#' @name importAlevin
#' @rdname importAlevin
#' @title Construct SCE object from Salmon-Alevin output
#' @param alevinDir Character. The output directory of salmon-Alevin pipeline.
#'  It should contain subfolder named 'alevin', which contains the count data
#'  which is stored
#'  in 'quants_mat.gz'. Default \code{NULL}.
#' @param sampleName Character. A user-defined sample name for the sample to be
#'  imported. The 'sampleName' will be appended to the begining of cell
#'  barcodes. Default is 'sample'.
#' @param delayedArray Boolean. Whether to read the expression matrix as
#'  \link{DelayedArray} object or not. Default \code{FALSE}.
#' @param class Character. The class of the expression matrix stored in the SCE
#'  object. Can be one of "Matrix" (as returned by
#'  \link{readMM} function), or "matrix" (as returned by
#'  \link[base]{matrix} function). Default "Matrix".
#' @param rowNamesDedup Boolean. Whether to deduplicate rownames. Default 
#'  \code{TRUE}.
#' @return A \code{SingleCellExperiment} object containing the count
#'  matrix, the feature annotations, and the cell annotation
#'  (which includes QC metrics stored in 'featureDump.txt').
#' @import eds
#' @export

importAlevin <- function(
  alevinDir = NULL,
  sampleName = 'sample',
  delayedArray = FALSE,
  class = c("Matrix", "matrix"),
  rowNamesDedup = TRUE) {

  class <- match.arg(class)

  matFile <- file.path(alevinDir, "alevin/quants_mat.gz")

  ### used to require package fishpond, now uses eds
  ma <- tximport::tximport(files = matFile, type = "alevin")
  if (!'counts' %in% names(ma)) {
    stop("RNA count matrix not found in the alevin output!")
  }
  mat <- ma$counts

  if (class == "Matrix") {
    mat <- .convertToMatrix(mat)
  } else if (class == "matrix") {
    mat <- base::as.matrix(mat)
  }
  
  if (delayedArray) {
    mat <- DelayedArray::DelayedArray(mat)
  }
  
  if (isTRUE(rowNamesDedup)) {
    if (any(duplicated(rownames(mat)))) {
      message("Duplicated gene names found, adding '-1', '-2', ",
              "... suffix to them.")
    }
    mat <- dedupRowNames(mat)
  }
  
  genes <- rownames(mat)
  cb <- .readBarcodes(file.path(alevinDir, 'alevin/featureDump.txt'),
                      header = 'auto',
                      colname = "cell_barcode",
                      colClasses = "character")
  coln <- paste(sampleName, cb[[1]], sep = "_")

  sce <- SingleCellExperiment::SingleCellExperiment(
    assays = list(counts = mat))
  SummarizedExperiment::rowData(sce) <- S4Vectors::DataFrame(
    'feature_name' = genes,
    row.names = genes)
  SummarizedExperiment::colData(sce) <- S4Vectors::DataFrame(
    cb,
    column_name = coln,
    sample = sampleName,
    row.names = coln)
  
  return(sce)
}

# UI
nonLinearWorkflowUI <- function(id)
{
  ns <- NS(id)
  fluidPage(
    uiOutput(ns("ui"))
  )
}

# Server
nonLinearWorkflow <- function(input, output, session, parent,
                              de = FALSE,
                              fm = FALSE,
                              cv = FALSE,
                              pa = FALSE,
                              tj = FALSE,
                              qcf = FALSE,
                              nbc = FALSE,
                              cw = FALSE,
                              dr = FALSE,
                              fs = FALSE,
                              cl = FALSE)
{
  ns <- session$ns

  output$ui <- renderUI({
    bsCollapse(
      open = "Next Steps",
      bsCollapsePanel("Next Steps",
                      uiOutput(ns("qcf")),
                      uiOutput(ns("nbc")),
                      uiOutput(ns("fs")),
                      uiOutput(ns("dr")),
                      uiOutput(ns("cl")),
                      uiOutput(ns("fm")),
                      uiOutput(ns("de")),
                      uiOutput(ns("cw")),
                      uiOutput(ns("pa")),
                      uiOutput(ns("tj")),
                      uiOutput(ns("cv")),
                      style = "success")
      )

  })

  if(de){
    output$de <- renderUI({
      panel(
        heading = "Differential Expression",
        h5("Discover quantitative changes between experimental conditions using one of the many integrated statistical frameworks for differential expression:"),
        actionButton(inputId = ns("goDE"), label = "Go to Differential Expression")
      )
    })
  }

  if(fm){
    output$de <- renderUI({
      panel(
        heading = "Marker Selection",
        h5("Compute and visualize marker genes for each cluster using one of the many integrated statistical frameworks for differential expression:"),
        actionButton(inputId = ns("goMS"), label = "Go to Find Marker")
      )
    })
  }

  if(cv){
    output$cv <- renderUI({
      panel(
        heading = "Cell Viewer",
        h5("Visualize data using scatter plot, violin plot, bar or box plots."),
        actionButton(inputId = ns("goCV"), label = "Go to Cell Viewer")
      )
    })
  }

  if(pa){
    output$pa <- renderUI({
      panel(
        heading = "Pathway Analysis",
        h5("Explore biological activity or functions with pathway analysis using 'VAM' or 'GSVA' statistical frameworks, or perform GSEA with 'enrichR':"),
        actionButton(inputId = ns("goPathwayAnalysis"), label = "Go to Pathway Analysis"),
        actionButton(inputId = ns("goEnrichR"), label = "Go to EnrichR"),
      )
    })
  }

  if(tj){
    output$tj <- renderUI({
      panel(
        heading = "Trajectory Analysis",
        h5("Estimate Pseudotime path of cell population with TSCAN method:"),
        actionButton(inputId = ns("goTSCAN"), label = "Go to Trajectory Analysis")
      )
    })
  }

  if(qcf){
    output$qcf <- renderUI({
      panel(
        heading = "Quality Control & Filtering",
        h5("Perform quality control checks to get a better sense of the quality of the input data using a number of available methods. Additionally, perform filtering on the data to remove samples that do not pass a quality criteria."),
        actionButton(inputId = ns("goQC"), label = "Go to QC"),
        actionButton(inputId = ns("goFilter"), label = "Go to Filtering")
      )
    })
  }

  if(nbc){
    output$nbc <- renderUI({
      panel(
        heading = "Normalization & Batch-Correction",
        h5("Normalize the raw/filtered input data to remove biasness of technical variation from the data or additionally adjust for batch-effect if the data is processed in multiple batches."),
        actionButton(inputId = ns("goNBC"), label = "Go to Normalization/Batch-Correction")
      )
    })
  }

  if(cw){
    output$cw <- renderUI({
      panel(
        heading = "Curated Workflows",
        h5("Interactively analyze raw or filtered data in a step-by-step curated workflow using either Seurat, Scanpy or Celda pipeline."),
        actionButton(inputId = ns("goSeurat"), label = "Go to Seurat"),
        actionButton(inputId = ns("goScanpy"), label = "Go to Scanpy"),
        actionButton(inputId = ns("goCelda"), label = "Go to Celda")
      )
    })
  }

  if(dr){
    output$dr <- renderUI({
      panel(
        heading = "Dimensionality Reduction",
        h5("Reduce high-dimensional normalized data into low-dimension using PCA/ICA or tSNE/UMAP which may further be used with some clustering algorithms as the recommended input data type."),
        actionButton(inputId = ns("goDR"), label = "Go to Dimensionality Reduction")
      )
    })
  }

  if(fs){
    output$fs <- renderUI({
      panel(
        heading = "Feature Selection",
        h5("Find and select a subset of features/genes that show the most heterogeneity among the data samples and use this subset in the downstream analysis."),
        actionButton(inputId = ns("goFS"), label = "Go to Feature Selection")
      )
    })
  }

  if(cl){
    output$cl <- renderUI({
      panel(
        heading = "Clustering",
        h5("Identify cluster labels for each of the sample of the input data by grouping together similar samples through a number of available clustering algorithms."),
        actionButton(inputId = ns("goCL"), label = "Go to Clustering")
      )
    })
  }

  observeEvent(input$goCV,{
    showTab(inputId = "navbar",
            target = "CellViewer",
            select = TRUE,
            session = parent)
  })

    observeEvent(input$goDE,{
      showTab(inputId = "navbar",
              target = "Differential Expression",
              select = TRUE,
              session = parent)
    })

    observeEvent(input$goMS,{
      showTab(inputId = "navbar",
              target = "Find Marker",
              select = TRUE,
              session = parent)
    })

    observeEvent(input$goPathwayAnalysis,{
      showTab(inputId = "navbar",
              target = "Pathway Activity",
              select = TRUE,
              session = parent)
    })

    observeEvent(input$goEnrichR,{
      showTab(inputId = "navbar",
              target = "EnrichR",
              select = TRUE,
              session = parent)
    })

    observeEvent(input$goTSCAN,{
      showTab(inputId = "navbar",
              target = "TSCANWorkflow",
              select = TRUE,
              session = parent)
    })

    observeEvent(input$goQC,{
      showTab(inputId = "navbar",
              target = "QC & Filtering",
              select = TRUE,
              session = parent)
      updateTabsetPanel(session = parent,
                        inputId = "QCFilterTabsetPanel",
                        selected = "QC")
    })

    observeEvent(input$goFilter,{
      showTab(inputId = "navbar",
              target = "QC & Filtering",
              select = TRUE,
              session = parent)
      updateTabsetPanel(session = parent,
                        inputId = "QCFilterTabsetPanel",
                        selected = "Filtering")
    })

    observeEvent(input$goNBC,{
      showTab(inputId = "navbar",
              target = "Normalization & Batch Correction",
              select = TRUE,
              session = parent)
    })

    observeEvent(input$goCelda,{
      showTab(inputId = "navbar",
              target = "Celda",
              select = TRUE,
              session = parent)
    })

    observeEvent(input$goSeurat,{
      showTab(inputId = "navbar",
              target = "Seurat",
              select = TRUE,
              session = parent)
    })
    
    observeEvent(input$goScanpy,{
      showTab(inputId = "navbar",
              target = "Scanpy",
              select = TRUE,
              session = parent)
    })

    observeEvent(input$goDR,{
      showTab(inputId = "navbar",
              target = "Feature Selection & Dimensionality Reduction",
              select = TRUE,
              session = parent)
      updateTabsetPanel(session = parent,
                        inputId = "FSDimRedTabsetPanel",
                        selected = "Dimensionality Reduction")
    })

    observeEvent(input$goFS,{
      showTab(inputId = "navbar",
              target = "Feature Selection & Dimensionality Reduction",
              select = TRUE,
              session = parent)
      updateTabsetPanel(session = parent,
                        inputId = "FSDimRedTabsetPanel",
                        selected = "Feature Selection")
    })

    observeEvent(input$goCL,{
      showTab(inputId = "navbar",
              target = "Clustering",
              select = TRUE,
              session = parent)
    })
}

soupXHelpModal <- function() {
    modalDialog(
        tags$style(HTML("
      div {
        word-wrap: break-word;
      }
      ")),
        tags$div(
            h3("SoupX Parameters"),
            fluidRow(
                column(4, tags$b("Parameter Name")),
                column(8, tags$b("Description"))
            ),
            tags$hr(),
            fluidRow(
                column(4, "cluster"),
                column(8, "Prior knowledge of clustering labels on cells. Can 
                       be specified with preloaded cell annotations. When not 
                       supplied, scran::quickCluster method will be applied.")
            ),
            tags$hr(),
            fluidRow(
                column(4, "tfidfMin"),
                column(8, "Minimum value of tfidf to accept for a marker gene. 
                       Default 1. Parameter for SoupX::autoEstCont()")
            ),
            tags$hr(),
            fluidRow(
                column(4, "soupQuantile"),
                column(8, "Only use genes that are at or above this expression 
                       quantile in the soup. This prevents inaccurate estimates 
                       due to using genes with poorly constrained contribution 
                       to the background. Default 0.9. Parameter for 
                       SoupX::autoEstCont()")
            ),
            tags$hr(),
            fluidRow(
                column(4, "maxMarkers"),
                column(8, "If we have heaps of good markers, keep only the best 
                       maxMarkers of them. Default 100. Parameter for 
                       SoupX::autoEstCont()")
            ),
            tags$hr(),
            fluidRow(
                column(4, "contaminationRange"),
                column(8, "This constrains the contamination fraction to lie 
                       within this range. Must be between 0 and 1. The high end 
                       of this range is passed to 
                       SoupX::estimateNonExpressingCells as 
                       `maximumContamination`. Use 'Lower range' and 'Higher 
                       range' for the two values. Default 0.01 - 0.8. Parameter 
                       for SoupX::autoEstCont()")
            ),
            tags$hr(),
            fluidRow(
                column(4, "rhoMaxFDR"),
                column(8, "Integer. False discovery rate passed to 
                       SoupX::estimateNonExpressingCells, to test if rho is 
                       less than `maximumContamination`. Default 0.2. Parameter 
                       for SoupX::autoEstCont()")
            ),
            tags$hr(),
            fluidRow(
                column(4, "priorRho"),
                column(8, "Mode of gamma distribution prior on contamination 
                       fraction. Default 0.05. Parameter for 
                       SoupX::autoEstCont()")
            ),
            tags$hr(),
            fluidRow(
                column(4, "priorRhoStdDev"),
                column(8, "Standard deviation of gamma distribution prior on 
                       contamination fraction. Default 0.1. Parameter for 
                       SoupX::autoEstCont()")
            ),
            tags$hr(),
            fluidRow(
                column(4, "forceAccept"),
                column(8, "Should we allow very high contamination fractions to 
                       be used. Default FALSE (not checked). Parameter for 
                       SoupX::autoEstCont()")
            ),
            tags$hr(),
            fluidRow(
                column(4, "adjustMethod"),
                column(8, "Method to use for correction. One of 'subtraction', 
                       'soupOnly', or 'multinomial'. Default 'subtraction'. 
                       Parameter for SoupX::adjustCounts")
            ),
            tags$hr(),
            fluidRow(
                column(4, "roundToInt"),
                column(8, "Should the resulting matrix be rounded to integers? 
                       Default FALSE (not checked). Parameter for 
                       SoupX::adjustCounts")
            ),
            tags$hr(),
            fluidRow(
                column(4, "tol"),
                column(8, "Allowed deviation from expected number of soup 
                       counts. Don't change this. Default 0.001. Parameter for 
                       SoupX::adjustCounts")
            ),
            tags$hr(),
            fluidRow(
                column(4, "pCut"),
                column(8, "The p-value cut-off used when method = 'soupOnly'. 
                       Default 0.01. Parameter for SoupX::adjustCounts")
            )
        )
    )
}

# Helper functions to get Seurat object or package version numbers
.getSeuratObjectMajorVersion <- function(seuratObject){
    if(!methods::is(seuratObject, "Seurat")) {
        stop("The object was not a 'Seurat' object but was of class: ", class(seuratObject))
    }
    v <- slot(seuratObject, "version")$major
    return(v)
}

.getSeuratPackageVersion <- function(){
    v <- packageVersion(pkg = "SeuratObject")$major
    return(v)
}

# Helper/Wrapper Functions ---

#' .getComponentNames
#' Creates a list of PC/IC components to populate the picker for PC/IC heatmap
#' generation
#' @param maxComponents Number of components to return for the picker
#' @param component Which component to use. Choices are \code{PC} or \code{IC}.
#' @return List of component names (appended with \code{PC} or \code{IC})
#' @noRd
.getComponentNames <-
  function(maxComponents, component = c("PC", "IC")) {
    componentNames <- list()
    for (i in seq(maxComponents)) {
      componentNames[i] <- paste0(component, i)
    }
    return(componentNames)
  }

#' .getSeuratObject
#' Retrieves the Seurat object stored in the input SCE, if exists
#' @param inSCE (sce) object containing the Seurat data, located
#' in inSCE\@\metadata$seurat$obj
#' @return the Seurat object if it exists
#' @noRd
.getSeuratObject <- function(inSCE) {
  return(metadata(inSCE)$seurat$obj)
}

#' .addSeuratToMetaDataSCE
#' Adds the input seurat object to the metadata slot of the input sce object
#' (after removing the data matrices)
#' @param inSCE (sce) object to which seurat object should be added in the
#' metadata slot (copy to)
#' @param seuratObject seurat object which should be added to the metadata slot
#' of sce object (copy from)
#' @return Updated \code{SingleCellExperiment} object which now contains the
#' seurat object in its metadata slot (excluding data matrices)
#' @noRd
.addSeuratToMetaDataSCE <- function(inSCE, seuratObject) {
  seurat.version <- .getSeuratObjectMajorVersion(seuratObject)

  if(seurat.version >= 5.0){

    seuratObject@assays$RNA@layers$counts <- methods::new("dgCMatrix")
    seuratObject@assays$RNA@layers$data <- methods::new("dgCMatrix")
    seuratObject@assays$RNA@layers$scale.data <- methods::new("dgCMatrix")
    inSCE@metadata$seurat$obj <- seuratObject

    # add var features if exists
    #if (!is.null(Seurat::VariableFeatures(seuratObject)) && length(Seurat::VariableFeatures(seuratObject)) > 0) {
    #  inSCE@metadata$seurat$obj@assays$RNA$"var.features" <-
    #    Seurat::VariableFeatures(object = seuratObject)
    #}

    #inSCE@metadata$seurat$obj@assays$RNA@layers$counts <- methods::new("dgCMatrix")
    #inSCE@metadata$seurat$obj@assays$RNA@layers$data <- methods::new("dgCMatrix")
    #inSCE@metadata$seurat$obj@assays$RNA@layers$scale.data <- matrix()

    # Determine if slot is called "meta.data" or "meta.features"
      if("meta.data" %in% methods::slotNames(seuratObject@assays$RNA)) {
         inSCE@metadata$seurat$obj@assays$RNA@meta.data  <- seuratObject@assays$RNA@meta.data
      } else if ("meta.features" %in% methods::slotNames(seuratObject@assays$RNA)) {
         inSCE@metadata$seurat$obj@assays$RNA@meta.features  <- seuratObject@assays$RNA@meta.features
      }

    inSCE@metadata$seurat$obj@meta.data <- seuratObject@meta.data

    inSCE@metadata$seurat$obj@commands <- seuratObject@commands

    inSCE@metadata$seurat$obj@reductions$pca <- seuratObject@reductions$pca
    inSCE@metadata$seurat$obj@reductions$ica <- seuratObject@reductions$ica
    inSCE@metadata$seurat$obj@reductions$tsne <- seuratObject@reductions$tsne
    inSCE@metadata$seurat$obj@reductions$umap <- seuratObject@reductions$umap

  }
  else{
    seuratObject@assays$RNA@counts <- methods::new("dgCMatrix")
    seuratObject@assays$RNA@data <- methods::new("dgCMatrix")
    seuratObject@assays$RNA@scale.data <- matrix()
    inSCE@metadata$seurat$obj <- seuratObject
  }

  return(inSCE)
}

#' .computeSignificantPC
#' Computes the significant principal components from an input sce object (must
#' contain pca slot) using stdev
#' @param inSCE (sce) object with pca computed
#' @return A numerical value indicating how many number of components are
#' considered significant
#' @noRd
.computeSignificantPC <- function(inSCE) {
  seuratObject <- convertSCEToSeurat(inSCE)
  max_components <- 0
  currentDistance <- 0
  previousDistance <- 0
  for (i in seq(seuratObject[["pca"]]@stdev)[-1] - 1) {
    currentDistance <- abs(seuratObject[["pca"]]@stdev[i + 1] -
                             seuratObject[["pca"]]@stdev[i])
    if (abs(currentDistance - previousDistance) > 0.01) {
      previousDistance <- currentDistance
      max_components <- i
    }
    else{
      break
    }
  }
  return(max_components)
}

#' runSeuratNormalizeData
#' Wrapper for NormalizeData() function from seurat library
#' Normalizes the sce object according to the input parameters
#' @param inSCE (sce) object to normalize
#' @param useAssay Assay containing raw counts to use for normalization.
#' @param normAssayName Name of new assay containing normalized data. Default
#' \code{seuratNormData}.
#' @param normalizationMethod selected normalization method. Default
#' \code{"LogNormalize"}.
#' @param scaleFactor numeric value that represents the scaling factor. Default
#' \code{10000}.
#' @param verbose Logical value indicating if informative messages should
#'  be displayed. Default is \code{TRUE}.
#' @examples
#' data(scExample, package = "singleCellTK")
#' \dontrun{
#' sce <- runSeuratNormalizeData(sce, useAssay = "counts")
#' }
#' @return Normalized \code{SingleCellExperiment} object
#' @export
runSeuratNormalizeData <- function(inSCE,
                                   useAssay,
                                   normAssayName = "seuratNormData",
                                   normalizationMethod = "LogNormalize",
                                   scaleFactor = 10000,
                                   verbose = TRUE) {
  if (missing(useAssay)) {
    useAssay <- SummarizedExperiment::assayNames(inSCE)[1]
    message(
      "'useAssay' parameter missing. Using the first available assay ",
      "instead: '",
      useAssay,
      "'"
    )
  }
  seuratObject <-
    Seurat::NormalizeData(
      convertSCEToSeurat(inSCE, useAssay),
      normalization.method = normalizationMethod,
      scale.factor = scaleFactor,
      verbose = verbose
    )
  inSCE <-
    .updateAssaySCE(inSCE, seuratObject, normAssayName, "data")
  inSCE <- .addSeuratToMetaDataSCE(inSCE, seuratObject)
  inSCE@metadata$seurat$normAssay <- normAssayName
  inSCE <- expSetDataTag(inSCE = inSCE,
                         assayType = "normalized",
                         assays = normAssayName)
  return(inSCE)
}

#' runSeuratScaleData
#' Scales the input sce object according to the input parameters
#' @param inSCE (sce) object to scale
#' @param useAssay Assay containing normalized counts to scale.
#' @param scaledAssayName Name of new assay containing scaled data. Default
#' \code{seuratScaledData}.
#' @param model selected model to use for scaling data. Default \code{"linear"}.
#' @param scale boolean if data should be scaled or not. Default \code{TRUE}.
#' @param center boolean if data should be centered or not. Default \code{TRUE}
#' @param scaleMax maximum numeric value to return for scaled data. Default
#' \code{10}.
#' @param verbose Logical value indicating if informative messages should
#'  be displayed. Default is \code{TRUE}.
#' @examples
#' data(scExample, package = "singleCellTK")
#' \dontrun{
#' sce <- runSeuratNormalizeData(sce, useAssay = "counts")
#' sce <- runSeuratFindHVG(sce, useAssay = "counts")
#' sce <- runSeuratScaleData(sce, useAssay = "counts")
#' }
#' @return Scaled \code{SingleCellExperiment} object
#' @export
runSeuratScaleData <- function(inSCE,
                               useAssay = "seuratNormData",
                               scaledAssayName = "seuratScaledData",
                               model = "linear",
                               scale = TRUE,
                               center = TRUE,
                               scaleMax = 10,
                               verbose = TRUE) {
  seuratObject <- convertSCEToSeurat(inSCE, useAssay)
  seuratObject <- Seurat::ScaleData(
    seuratObject,
    features = getSeuratVariableFeatures(inSCE),
    model.use = model,
    do.scale = scale,
    do.center = center,
    scale.max = as.double(scaleMax),
    verbose = verbose
  )
  inSCE <-
    .updateAssaySCE(inSCE, seuratObject, scaledAssayName, "scale.data")
  inSCE <- .addSeuratToMetaDataSCE(inSCE, seuratObject)
  # inSCE@metadata$seurat$scaledAssay <- scaledAssayName
  # inSCE <- expSetDataTag(inSCE = inSCE, assayType = "scaled",
  #                        assays = scaledAssayName)
  return(inSCE)
}

#' runSeuratFindHVG
#' Find highly variable genes and store in the input sce object
#' @param inSCE (sce) object to compute highly variable genes from and to store
#' back to it
#' @param useAssay Specify the name of the assay to use for computation
#'  of variable genes. It is recommended to use a raw counts assay with the
#'  \code{"vst"} method and normalized assay with all other methods. Default
#'  is \code{"counts"}.
#' @param method selected method to use for computation of highly variable
#' genes. One of \code{'vst'}, \code{'dispersion'}, or \code{'mean.var.plot'}.
#' Default \code{"vst"} which uses the raw counts. All other methods use
#' normalized counts.
#' @param hvgNumber numeric value of how many genes to select as highly
#' variable. Default \code{2000}
#' @param createFeatureSubset Specify a name of the subset to create
#' for the identified variable features. Default is \code{"hvf"}.
#' Leave it \code{NULL} if you do not want to create a subset of
#' variable features.
#' @param altExp Logical value indicating if the input object is an
#' altExperiment. Default \code{FALSE}.
#' @param verbose Logical value indicating if informative messages should
#'  be displayed. Default is \code{TRUE}.
#' @examples
#' data(scExample, package = "singleCellTK")
#' sce <- runSeuratFindHVG(sce)
#' @return Updated \code{SingleCellExperiment} object with highly variable genes
#' computation stored
#' @seealso \code{\link{runFeatureSelection}}, \code{\link{runModelGeneVar}},
#' \code{\link{getTopHVG}}, \code{\link{plotTopHVG}}
#' @export
#' @importFrom SummarizedExperiment rowData rowData<-
#' @importFrom S4Vectors metadata<-
runSeuratFindHVG <- function(inSCE,
                             useAssay = "counts",
                             method = c("vst", "dispersion", "mean.var.plot"),
                             hvgNumber = 2000,
                             createFeatureSubset = "hvf",
                             altExp = FALSE,
                             verbose = TRUE) {
  method <- match.arg(method)
  seurat.pkg.version <- .getSeuratPackageVersion()
  if(seurat.pkg.version >= 5.0){
    seuratObject <- convertSCEToSeurat(inSCE, countsAssay = useAssay)
  }
  else{
    if (method == "vst") {
      seuratObject <- convertSCEToSeurat(inSCE, countsAssay = useAssay)
    } else {
      seuratObject <- convertSCEToSeurat(inSCE, normAssay = useAssay)
    }
  }

  # Get version number of object
  seurat.version <- .getSeuratObjectMajorVersion(seuratObject)

  seuratObject <- Seurat::FindVariableFeatures(
    seuratObject,
    selection.method = method,
    nfeatures = hvgNumber,
    verbose = verbose
  )
  inSCE <- .addSeuratToMetaDataSCE(inSCE, seuratObject)
  if (method == "vst") {
    if(seurat.version >= 5.0){
      cn <- colnames(seuratObject@assays$RNA@meta.data)
      if (!altExp) {
        rowData(inSCE)$seurat_variableFeatures_vst_varianceStandardized <-
          unlist(seuratObject@assays$RNA@meta.data["vf_vst_counts_variance.standardized"])
        rowData(inSCE)$seurat_variableFeatures_vst_mean <-
          unlist(seuratObject@assays$RNA@meta.data["vf_vst_counts_mean"])
        rowData(inSCE)[,cn] <- seuratObject@assays$RNA@meta.data
      }
      else{
        # remove this part of code when updating to ExperimentSubset and add the
        # above code in if clause as the complete code
        altExpRows <-
          match(rownames(inSCE),
                seuratObject@assays$RNA@meta.data["var.features"][,1]
          )
        rowData(inSCE)$seurat_variableFeatures_vst_varianceStandardized <-
          unlist(
            seuratObject@assays$RNA@meta.data["vf_vst_counts_variance.standardized"][[1]][altExpRows])
        rowData(inSCE)$seurat_variableFeatures_vst_mean <-
          unlist(
            seuratObject@assays$RNA@meta.data["vst.mean"][[1]][altExpRows])
        rowData(inSCE)[,cn] <- seuratObject@assays$RNA@meta.data[altExpRows,]
      }
    }
    else{
      cn <- colnames(seuratObject@assays$RNA@meta.features)
      if (!altExp) {
        rowData(inSCE)$seurat_variableFeatures_vst_varianceStandardized <-
          methods::slot(inSCE@metadata$seurat$obj, "assays")[["RNA"]]@meta.features$vst.variance.standardized
        rowData(inSCE)$seurat_variableFeatures_vst_mean <-
          methods::slot(inSCE@metadata$seurat$obj, "assays")[["RNA"]]@meta.features$vst.mean
        rowData(inSCE)[,cn] <- seuratObject@assays$RNA@meta.features
      }
      else{
        # remove this part of code when updating to ExperimentSubset and add the
        # above code in if clause as the complete code
        altExpRows <-
          match(rownames(inSCE),
                rownames(
                  methods::slot(inSCE@metadata$seurat$obj, "assays")[["RNA"]]@meta.features
                ))
        rowData(inSCE)$seurat_variableFeatures_vst_varianceStandardized <-
          methods::slot(inSCE@metadata$seurat$obj, "assays")[["RNA"]]@meta.features$vst.variance.standardized[altExpRows]
        rowData(inSCE)$seurat_variableFeatures_vst_mean <-
          methods::slot(inSCE@metadata$seurat$obj, "assays")[["RNA"]]@meta.features$vst.mean[altExpRows]
        rowData(inSCE)[,cn] <- seuratObject@assays$RNA@meta.features[altExpRows,]
      }
    }

    metadata(inSCE)$sctk$runFeatureSelection$vst <-
      list(
        useAssay = useAssay,
        rowData = c(
          "seurat_variableFeatures_vst_varianceStandardized",
          "seurat_variableFeatures_vst_mean"
        )
      )
  } else if (method == "dispersion") {
    if(seurat.version >= 5.0){
      cn <- colnames(seuratObject@assays$RNA@meta.data)
      rowData(inSCE)$seurat_variableFeatures_dispersion_dispersion <-
        unlist(seuratObject@assays$RNA@meta.data["vf_vst_counts_variance.standardized"])
      rowData(inSCE)$seurat_variableFeatures_dispersion_dispersionScaled <-
        unlist(seuratObject@assays$RNA@meta.data["vf_vst_counts_variance.standardized"])
      rowData(inSCE)$seurat_variableFeatures_dispersion_mean <-
        unlist(seuratObject@assays$RNA@meta.data["vf_vst_counts_variance.standardized"])
      rowData(inSCE)[,cn] <- seuratObject@assays$RNA@meta.data
    }
    else{
      cn <- colnames(seuratObject@assays$RNA@meta.features)
      rowData(inSCE)$seurat_variableFeatures_dispersion_dispersion <-
        methods::slot(inSCE@metadata$seurat$obj, "assays")[["RNA"]]@meta.features$mvp.dispersion
      rowData(inSCE)$seurat_variableFeatures_dispersion_dispersionScaled <-
        methods::slot(inSCE@metadata$seurat$obj, "assays")[["RNA"]]@meta.features$mvp.dispersion.scaled
      rowData(inSCE)$seurat_variableFeatures_dispersion_mean <-
        methods::slot(inSCE@metadata$seurat$obj, "assays")[["RNA"]]@meta.features$mvp.mean
      rowData(inSCE)[,cn] <- seuratObject@assays$RNA@meta.features
    }
    metadata(inSCE)$sctk$runFeatureSelection$dispersion <-
      list(
        useAssay = useAssay,
        rowData = c(
          "seurat_variableFeatures_dispersion_dispersion",
          "seurat_variableFeatures_dispersion_dispersionScaled",
          "seurat_variableFeatures_dispersion_mean"
        )
      )
  }
  else if (method == "mean.var.plot") {
    if(seurat.version >= 5.0){
      cn <- colnames(seuratObject@assays$RNA@meta.data)
      rowData(inSCE)$seurat_variableFeatures_mvp_dispersion <-
        unlist(seuratObject@assays$RNA@meta.data["vf_vst_counts_variance.standardized"])
      rowData(inSCE)$seurat_variableFeatures_mvp_dispersionScaled <-
        unlist(seuratObject@assays$RNA@meta.data["vf_vst_counts_variance.standardized"])
      rowData(inSCE)$seurat_variableFeatures_mvp_mean <-
        unlist(seuratObject@assays$RNA@meta.data["vf_vst_counts_variance.standardized"])
      rowData(inSCE)[,cn] <- seuratObject@assays$RNA@meta.data
    }
    else{
      cn <- colnames(seuratObject@assays$RNA@meta.features)
      rowData(inSCE)$seurat_variableFeatures_mvp_dispersion <-
        methods::slot(inSCE@metadata$seurat$obj, "assays")[["RNA"]]@meta.features$mvp.dispersion
      rowData(inSCE)$seurat_variableFeatures_mvp_dispersionScaled <-
        methods::slot(inSCE@metadata$seurat$obj, "assays")[["RNA"]]@meta.features$mvp.dispersion.scaled
      rowData(inSCE)$seurat_variableFeatures_mvp_mean <-
        methods::slot(inSCE@metadata$seurat$obj, "assays")[["RNA"]]@meta.features$mvp.mean
      rowData(inSCE)[,cn] <- seuratObject@assays$RNA@meta.features
    }
   metadata(inSCE)$sctk$runFeatureSelection$mean.var.plot <-
      list(
        useAssay = useAssay,
        rowData = c(
          "seurat_variableFeatures_mvp_dispersion",
          "seurat_variableFeatures_mvp_dispersionScaled",
          "seurat_variableFeatures_mvp_mean"
        )
      )
  }

  # create a feature subset
  if(!is.null(createFeatureSubset)){
    inSCE <- setTopHVG(inSCE = inSCE,
                       method = method,
                       hvgNumber = hvgNumber,
                       featureSubsetName = createFeatureSubset)
  }

  return(inSCE)
}

#' runSeuratPCA
#' Computes PCA on the input sce object and stores the calculated principal
#' components within the sce object
#' @param inSCE (sce) object on which to compute PCA
#' @param useAssay Assay containing scaled counts to use in PCA. Default
#' \code{"seuratNormData"}.
#' @param reducedDimName Name of new reducedDims object containing Seurat PCA.
#' Default \code{seuratPCA}.
#' @param nPCs numeric value of how many components to compute. Default
#' \code{20}.
#' @param useFeatureSubset Subset of feature to use for dimension reduction. A
#' character string indicating a \code{rowData} variable that stores the logical
#' vector of HVG selection, or a vector that can subset the rows of
#' \code{inSCE}. Default \code{"hvf"}.
#' @param scale Logical scalar, whether to standardize the expression values
#' using \code{\link[Seurat]{ScaleData}}. Default \code{TRUE}.
#' @param seed Random seed for reproducibility of results.
#' Default \code{NULL} will use global seed in use by the R environment.
#' @param verbose Logical value indicating if informative messages should
#'  be displayed. Default is \code{TRUE}.
#' @details
#' For features used for computation, it can be controlled by \code{features} or
#' \code{useFeatureSubset}. When \code{features} is specified, the scaling and
#' dimensionality reduction will only be processed with these features. When
#' \code{features} is \code{NULL} but \code{useFeatureSubset} is specified, will
#' use the features that the HVG list points to. If both parameters are
#' \code{NULL}, the function will see if any Seurat's variable feature detection
#' has been ever performed, and use them if found. Otherwise, all features are
#' used.
#' @examples
#' data(scExample, package = "singleCellTK")
#' \dontrun{
#' sce <- runSeuratNormalizeData(sce, useAssay = "counts")
#' sce <- runSeuratFindHVG(sce, useAssay = "counts")
#' sce <- setTopHVG(sce, method = "vst", featureSubsetName = "hvf")
#' sce <- runSeuratScaleData(sce, useAssay = "counts")
#' sce <- runSeuratPCA(sce, useAssay = "counts")
#' }
#' @return Updated \code{SingleCellExperiment} object which now contains the
#' computed principal components
#' @export
#' @importFrom SingleCellExperiment reducedDim<- rowSubset
#' @importFrom S4Vectors metadata<-
runSeuratPCA <-
  function(inSCE,
           useAssay = "seuratNormData",
           useFeatureSubset = "hvf",
           scale = TRUE,
           reducedDimName = "seuratPCA",
           nPCs = 20,
           seed = 12345,
           verbose = TRUE) {
    params <- as.list(environment())
    params$inSCE <- NULL
    if (!isTRUE(scale)) {
      # If not doing a scaling, put useAssay as scaled as RunPCA need it
      seuratObject <-
        convertSCEToSeurat(inSCE, scaledAssay = useAssay)
    } else {
      # If doing scaling, put useAssay as normed, used by ScaleData first
      seuratObject <- convertSCEToSeurat(inSCE, normAssay = useAssay)
    }

    features <- .parseUseFeatureSubset(inSCE, useFeatureSubset,
                                       altExpObj = NULL,
                                       returnType = "character")
    if (is.null(features)) {
      if (length(Seurat::VariableFeatures(seuratObject)) == 0) {
        features <- rownames(inSCE)
      }
    }

    if (isTRUE(scale)) {
      seuratObject <-
        Seurat::ScaleData(seuratObject, features = features,
                          verbose = verbose)
    }

    seuratObject <- Seurat::RunPCA(
      seuratObject,
      npcs = as.double(nPCs),
      verbose = verbose,
      features = features,
      seed.use = seed
    )
    inSCE <- .addSeuratToMetaDataSCE(inSCE, seuratObject)

    temp <- seuratObject@reductions$pca@cell.embeddings
    rownames(temp) <- colnames(inSCE)
    reducedDim(inSCE, reducedDimName) <- temp
    metadata(inSCE)$sctk$runDimReduce$reddim[[reducedDimName]] <- params
    return(inSCE)
  }

#' runSeuratICA
#' Computes ICA on the input sce object and stores the calculated independent
#' components within the sce object
#' @param inSCE (sce) object on which to compute ICA
#' @param useAssay Assay containing scaled counts to use in ICA.
#' @param reducedDimName Name of new reducedDims object containing Seurat ICA
#' Default \code{seuratICA}.
#' @param useFeatureSubset Subset of feature to use for dimension reduction. A
#' character string indicating a \code{rowData} variable that stores the logical
#' vector of HVG selection, or a vector that can subset the rows of
#' \code{inSCE}. Default \code{NULL}.
#' @param scale Logical scalar, whether to standardize the expression values
#' using \code{\link[Seurat]{ScaleData}}. Default \code{TRUE}.
#' @param nics Number of independent components to compute. Default \code{20}.
#' @param seed Random seed for reproducibility of results.
#' Default \code{NULL} will use global seed in use by the R environment.
#' @param verbose Logical value indicating if informative messages should
#'  be displayed. Default is \code{TRUE}.
#' @details
#' For features used for computation, it can be controlled by \code{features} or
#' \code{useFeatureSubset}. When \code{features} is specified, the scaling and
#' dimensionality reduction will only be processed with these features. When
#' \code{features} is \code{NULL} but \code{useFeatureSubset} is specified, will
#' use the features that the HVG list points to. If both parameters are
#' \code{NULL}, the function will see if any Seurat's variable feature detection
#' has been ever performed, and use them if found. Otherwise, all features are
#' used.
#' @examples
#' data(scExample, package = "singleCellTK")
#' \dontrun{
#' sce <- runSeuratNormalizeData(sce, useAssay = "counts")
#' sce <- runSeuratFindHVG(sce, useAssay = "counts")
#' sce <- runSeuratScaleData(sce, useAssay = "counts")
#' sce <- runSeuratICA(sce, useAssay = "counts")
#' }
#' @return Updated \code{SingleCellExperiment} object which now contains the
#' computed independent components
#' @export
#' @importFrom SingleCellExperiment reducedDim<- rowSubset
#' @importFrom S4Vectors metadata<-
runSeuratICA <-
  function(inSCE,
           useAssay = "seuratScaledData",
           useFeatureSubset = NULL,
           scale = TRUE,
           reducedDimName = "seuratICA",
           nics = 20,
           seed = 12345,
           verbose = FALSE) {
    params <- as.list(environment())
    params$inSCE <- NULL

    if (!isTRUE(scale)) {
      # If not doing a scaling, put useAssay as scaled as RunPCA need it
      seuratObject <-
        convertSCEToSeurat(inSCE, scaledAssay = useAssay)
    } else {
      # If doing scaling, put useAssay as normed, used by ScaleData first
      seuratObject <- convertSCEToSeurat(inSCE, normAssay = useAssay)
    }

    features <- .parseUseFeatureSubset(inSCE, useFeatureSubset,
                                       altExpObj = NULL,
                                       returnType = "character")
    if (is.null(features)) {
      if (length(Seurat::VariableFeatures(seuratObject)) == 0) {
        features <- rownames(inSCE)
      }
    }

    if (isTRUE(scale)) {
      seuratObject <-
        Seurat::ScaleData(seuratObject, features = features,
                          verbose = verbose)
    }

    seuratObject <- Seurat::RunICA(
      seuratObject,
      nics = as.double(nics),
      features = features,
      verbose = verbose,
      seed.use = seed
    )
    inSCE <- .addSeuratToMetaDataSCE(inSCE, seuratObject)

    temp <- seuratObject@reductions$ica@cell.embeddings
    rownames(temp) <- colnames(inSCE)
    reducedDim(inSCE, reducedDimName) <- temp
    metadata(inSCE)$sctk$runDimReduce$reddim[[reducedDimName]] <- params
    return(inSCE)
  }

#' runSeuratJackStraw
#' Compute jackstraw plot and store the computations in the input sce object
#' @param inSCE (sce) object on which to compute and store jackstraw plot
#' @param useAssay Specify name of the assay to use for scaling. Assay name
#'  provided against this parameter is scaled by the function and used
#'  for the computation of JackStraw scores along with the reduced dimensions
#'  specified by the \code{dims} parameter.
#' @param dims Number of components to test in Jackstraw. If \code{NULL}, then
#' all components are used. Default \code{NULL}.
#' @param numReplicate Numeric value indicating the number of replicate
#' samplings to perform.
#'  Default value is \code{100}.
#' @param propFreq Numeric value indicating the proportion of data to randomly
#' permute for each replicate.
#'  Default value is \code{0.025}.
#' @param externalReduction Pass DimReduc object if PCA/ICA computed through
#' other libraries. Default \code{NULL}.
#' @examples
#' data(scExample, package = "singleCellTK")
#' \dontrun{
#' sce <- runSeuratNormalizeData(sce, useAssay = "counts")
#' sce <- runSeuratFindHVG(sce, useAssay = "counts")
#' sce <- runSeuratScaleData(sce, useAssay = "counts")
#' sce <- runSeuratPCA(sce, useAssay = "counts")
#' sce <- runSeuratJackStraw(sce, useAssay = "counts")
#' }
#' @return Updated \code{SingleCellExperiment} object with jackstraw
#' computations stored in it
#' @export
runSeuratJackStraw <- function(inSCE,
                               useAssay,
                               dims = NULL,
                               numReplicate = 100,
                               propFreq = 0.025,
                               externalReduction = NULL) {
  seuratObject <- convertSCEToSeurat(inSCE, normAssay = useAssay)
  seuratObject <- Seurat::ScaleData(seuratObject)
  if (!is.null(externalReduction)) {
    #convert (_) to (-) as required by Seurat

    rownames(externalReduction@cell.embeddings) <-
      .convertToHyphen(rownames(externalReduction@cell.embeddings))
    seuratObject <- Seurat::FindVariableFeatures(seuratObject)
    seuratObject <- Seurat::ScaleData(seuratObject)
    seuratObject@reductions <- list(pca = externalReduction)
    seuratObject@reductions$pca@feature.loadings <-
      seuratObject@reductions$pca@feature.loadings[match(
        rownames(
          Seurat::GetAssayData(seuratObject, assay = "RNA", slot = "scale.data")
        ),
        rownames(seuratObject@reductions$pca@feature.loadings)
      ), ]
    if (any(is.na(seuratObject@reductions$pca@feature.loadings))) {
      seuratObject@reductions$pca@feature.loadings <-
        stats::na.omit(seuratObject@reductions$pca@feature.loadings)
    }
    seuratObject@commands$RunPCA.RNA <-
      seuratObject@commands$ScaleData.RNA
    seuratObject@commands$RunPCA.RNA@params$rev.pca <- FALSE
    seuratObject@commands$RunPCA.RNA@params$weight.by.var <- TRUE
  }
  if (is.null(seuratObject@reductions[["pca"]])) {
    stop("'runSeuratPCA' must be run before JackStraw can be computed.")
  }
  if (is.null(dims)) {
    dims <- ncol(seuratObject@reductions[["pca"]])
  }
  seuratObject <-
    Seurat::JackStraw(
      seuratObject,
      dims = as.double(dims),
      num.replicate = numReplicate,
      prop.freq = propFreq
    )
  seuratObject <-
    Seurat::ScoreJackStraw(seuratObject, dims = seq(dims))
  inSCE <- .addSeuratToMetaDataSCE(inSCE, seuratObject)
  return(inSCE)
}

#' plotSeuratJackStraw
#' Computes the plot object for jackstraw plot from the pca slot in the input
#' sce object
#' @param inSCE (sce) object from which to compute the jackstraw plot (pca
#' should be computed)
#' @param dims Number of components to plot in Jackstraw. If \code{NULL}, then
#' all components are plotted Default \code{NULL}.
#' @param xmax X-axis maximum on each QQ plot. Default \code{0.1}.
#' @param ymax Y-axis maximum on each QQ plot. Default \code{0.3}.
#' @param externalReduction Pass DimReduc object if PCA/ICA computed through
#' other libraries. Default \code{NULL}.
#' @examples
#' data(scExample, package = "singleCellTK")
#' \dontrun{
#' sce <- runSeuratNormalizeData(sce, useAssay = "counts")
#' sce <- runSeuratFindHVG(sce, useAssay = "counts")
#' sce <- runSeuratScaleData(sce, useAssay = "counts")
#' sce <- runSeuratPCA(sce, useAssay = "counts")
#' sce <- runSeuratJackStraw(sce, useAssay = "counts")
#' plotSeuratJackStraw(sce)
#' }
#' @return plot object
#' @export
plotSeuratJackStraw <-
  function(inSCE,
           dims = NULL,
           xmax = 0.1,
           ymax = 0.3,
           externalReduction = NULL) {
    seuratObject <- convertSCEToSeurat(inSCE)
    if (!is.null(externalReduction)) {
      seuratObject@reductions <- list(pca = externalReduction)
    }
    if (is.null(seuratObject@reductions[["pca"]])) {
      stop("'runSeuratPCA' must be run before JackStraw can be computed.")
    }
    if (is.null(dims)) {
      dims <- ncol(seuratObject@reductions[["pca"]])
    }
    return(Seurat::JackStrawPlot(
      seuratObject,
      dims = seq(dims),
      xmax = xmax,
      ymax = ymax
    ))
  }

#' plotSeuratHVG
#' Plot highly variable genes from input sce object (must have highly variable
#' genes computations stored)
#' @param inSCE (sce) object that contains the highly variable genes
#' computations
#' @param labelPoints Numeric value indicating the number of top genes that
#' should be labeled.
#'  Default is \code{0}, which will not label any point.
#' @examples
#' data(scExample, package = "singleCellTK")
#' \dontrun{
#' sce <- runSeuratNormalizeData(sce, useAssay = "counts")
#' sce <- runSeuratFindHVG(sce, useAssay = "counts")
#' plotSeuratHVG(sce)
#' }
#' @return plot object
#' @export
plotSeuratHVG <- function(inSCE, labelPoints = 0) {
  seuratObject <- convertSCEToSeurat(inSCE)
  plot <- Seurat::VariableFeaturePlot(seuratObject)
  plot$labels$colour <- "Variable"
  if (requireNamespace("stringr", quietly = TRUE)) {
    plot$data$colors <- stringr::str_to_title(plot$data$colors)
  }
  if (labelPoints > 0) {
    plot <- Seurat::LabelPoints(plot,
                                points = Seurat::VariableFeatures(object = seuratObject)[seq(labelPoints)])
  }
  return(plot)
}

#' plotSeuratReduction
#' Plots the selected dimensionality reduction method
#' @param inSCE (sce) object which has the selected dimensionality reduction
#' algorithm already computed and stored
#' @param useReduction Dimentionality reduction to plot. One of "pca", "ica",
#' "tsne", or "umap". Default \code{"umap"}.
#' @param showLegend Select if legends and labels should be shown on the output
#' plot or not. Either "TRUE" or "FALSE". Default \code{FALSE}.
#' @param groupBy Specify a colData column name that be used for grouping.
#' Default is \code{NULL}.
#' @param splitBy Specify a colData column name that be used for splitting the
#' output plot. Default is \code{NULL}.
#' @examples
#' data(scExample, package = "singleCellTK")
#' \dontrun{
#' sce <- runSeuratNormalizeData(sce, useAssay = "counts")
#' sce <- runSeuratFindHVG(sce, useAssay = "counts")
#' sce <- runSeuratScaleData(sce, useAssay = "counts")
#' sce <- runSeuratPCA(sce, useAssay = "counts")
#' plotSeuratReduction(sce, useReduction = "pca")
#' }
#' @return plot object
#' @export
plotSeuratReduction <-
  function(inSCE,
           useReduction = c("pca", "ica",
                            "tsne", "umap"),
           showLegend = FALSE,
           groupBy = NULL,
           splitBy = NULL) {
    seuratObject <- convertSCEToSeurat(inSCE)
    if (!is.null(seuratObject@meta.data$seurat_cluster)) {
      seuratObject@meta.data <-
        seuratObject@meta.data[, "seurat_clusters", drop = FALSE]
    }
    else{
      seuratObject@meta.data <- data.frame()
    }

    if (showLegend) {
      if (!is.null(seuratObject@meta.data$seurat_clusters)) {
        Seurat::Idents(seuratObject) <-
          seuratObject@meta.data$seurat_clusters
        #seuratObject@meta.data <- data.frame()
      }
    }

    if (!is.null(groupBy)) {
      seuratObject[[groupBy]] <- colData(inSCE)[[groupBy]]
    }

    if (!is.null(splitBy)) {
      seuratObject[[splitBy]] <- colData(inSCE)[[splitBy]]
    }

    if (showLegend) {
      plot <- Seurat::DimPlot(
        object = seuratObject,
        reduction = useReduction,
        group.by = groupBy,
        split.by = splitBy,
        label = TRUE
      )
    }
    else{
      plot <- Seurat::DimPlot(
        object = seuratObject,
        reduction = useReduction,
        group.by = groupBy,
        split.by = splitBy,
        label = FALSE
      ) + Seurat::NoLegend()
    }

    if ("ident" %in% names(plot$data) &&
        "seurat_clusters" %in% names(seuratObject@meta.data)) {
      plot$data$ident <- seuratObject@meta.data$seurat_clusters
    }
    return(plot)
  }


#' runSeuratFindClusters
#' Computes the clusters from the input sce object and stores them back in sce
#' object
#' @param inSCE (sce) object from which clusters should be computed and stored
#' in
#' @param useAssay Assay containing scaled counts to use for clustering.
#' @param useReduction Reduction method to use for computing clusters. One of
#' "pca" or "ica". Default \code{"pca"}.
#' @param dims numeric value of how many components to use for computing
#' clusters. Default \code{10}.
#' @param algorithm selected algorithm to compute clusters. One of "louvain",
#' "multilevel", or "SLM". Use \code{louvain} for "original Louvain algorithm"
#' and \code{multilevel} for "Louvain algorithm with multilevel refinement".
#' Default \code{louvain}.
#' @param groupSingletons boolean if singletons should be grouped together or
#' not. Default \code{TRUE}.
#' @param resolution Set the resolution parameter to find larger (value above 1)
#' or smaller (value below 1) number of communities. Default \code{0.8}.
#' @param seed Specify the seed value. Default \code{12345}.
#' @param externalReduction Pass DimReduc object if PCA/ICA computed through
#' other libraries. Default \code{NULL}.
#' @param verbose Logical value indicating if informative messages should
#'  be displayed. Default is \code{TRUE}.
#' @examples
#' data(scExample, package = "singleCellTK")
#' \dontrun{
#' sce <- runSeuratNormalizeData(sce, useAssay = "counts")
#' sce <- runSeuratFindHVG(sce, useAssay = "counts")
#' sce <- runSeuratScaleData(sce, useAssay = "counts")
#' sce <- runSeuratPCA(sce, useAssay = "counts")
#' sce <- runSeuratFindClusters(sce, useAssay = "counts")
#' }
#' @return Updated sce object which now contains the computed clusters
#' @export
runSeuratFindClusters <- function(inSCE,
                                  useAssay = "seuratNormData",
                                  useReduction = c("pca", "ica"),
                                  dims = 10,
                                  algorithm = c("louvain", "multilevel", "SLM"),
                                  groupSingletons = TRUE,
                                  resolution = 0.8,
                                  seed = 12345,
                                  externalReduction = NULL,
                                  verbose = TRUE) {
  algorithm <- match.arg(algorithm)
  useReduction <- match.arg(useReduction)

  if (!is.null(externalReduction)) {
    seuratObject <- convertSCEToSeurat(inSCE)
    seuratObject@reductions <- list(pca = externalReduction)
    useReduction <- "pca"
  } else {
    if (is.null(useReduction)) {
      seuratObject <- convertSCEToSeurat(inSCE, scaledAssay = useAssay)
    }
    else{
      seuratObject <- convertSCEToSeurat(inSCE)
    }
  }

  # Get version number of object
  seurat.version <- .getSeuratObjectMajorVersion(seuratObject)

  seuratObject <- withr::with_seed(seed, {
    Seurat::FindNeighbors(
      seuratObject,
      reduction = useReduction,
      dims = seq(dims),
      verbose = verbose
    )
  })

  no_algorithm <- 1
  if (algorithm == "louvain") {
    no_algorithm = 1
  } else if (algorithm == "multilevel") {
    no_algorithm = 2
  } else if (algorithm == "SLM") {
    no_algorithm = 3
  }
  tempSeuratObject <- seuratObject
  if(seurat.version < 5.0){
    tempSeuratObject@meta.data <- data.frame()
  }
  tempSeuratObject <- withr::with_seed(seed, {
    Seurat::FindClusters(
      tempSeuratObject,
      algorithm = no_algorithm,
      group.singletons = groupSingletons,
      resolution = resolution,
      verbose = verbose
    )
  })
  seuratObject@meta.data$seurat_clusters <-
    tempSeuratObject@meta.data$seurat_clusters
  inSCE <- .addSeuratToMetaDataSCE(inSCE, seuratObject)
  colData(inSCE)[[paste0("Seurat", "_", algorithm, "_", "Resolution", resolution)]] <-
    seuratObject@meta.data$seurat_clusters
  S4Vectors::metadata(inSCE)$seurat$clusterName <- paste0("Seurat", "_",
                                                         algorithm, "_",
                                                         "Resolution",
                                                         resolution)
  return(inSCE)
}

#' runSeuratTSNE
#' Computes tSNE from the given sce object and stores the tSNE computations back
#' into the sce object
#' @param inSCE (sce) object on which to compute the tSNE
#' @param useReduction selected reduction algorithm to use for computing tSNE.
#' One of "pca" or "ica". Default \code{"pca"}.
#' @param reducedDimName Name of new reducedDims object containing Seurat tSNE
#' Default \code{seuratTSNE}.
#' @param dims Number of reduction components to use for tSNE computation.
#' Default \code{10}.
#' @param perplexity Adjust the perplexity tuneable parameter for the underlying
#' tSNE call. Default \code{30}.
#' @param externalReduction Pass DimReduc object if PCA/ICA computed through
#' other libraries. Default \code{NULL}.
#' @param seed Random seed for reproducibility of results.
#' Default \code{1}.
#' @return Updated sce object with tSNE computations stored
#' @export
#' @importFrom SingleCellExperiment reducedDim<-
runSeuratTSNE <- function(inSCE,
                          useReduction = c("pca", "ica"),
                          reducedDimName = "seuratTSNE",
                          dims = 10,
                          perplexity = 30,
                          externalReduction = NULL,
                          seed = 1) {
  useReduction <- match.arg(useReduction)
  seuratObject <- convertSCEToSeurat(inSCE)

  if (!is.null(externalReduction)) {
    seuratObject@reductions <- list(pca = externalReduction)
    useReduction <- "pca"
  }

  seuratObject <-
    Seurat::RunTSNE(
      seuratObject,
      reduction = useReduction,
      dims = seq(dims),
      perplexity = perplexity,
      check_duplicates = FALSE,
      seed.use = seed
    )
  inSCE <- .addSeuratToMetaDataSCE(inSCE, seuratObject)
  temp <- seuratObject@reductions$tsne@cell.embeddings
  rownames(temp) <- colnames(inSCE)
  reducedDim(inSCE, reducedDimName) <- temp

  return(inSCE)
}

#' runSeuratUMAP
#' Computes UMAP from the given sce object and stores the UMAP computations back
#' into the sce object
#' @param inSCE (sce) object on which to compute the UMAP
#' @param useReduction Reduction to use for computing UMAP. One of "pca" or
#' "ica". Default is \code{"pca"}.
#' @param reducedDimName Name of new reducedDims object containing Seurat UMAP
#' Default \code{seuratUMAP}.
#' @param dims Numerical value of how many reduction components to use for UMAP
#' computation. Default \code{10}.
#' @param minDist Sets the \code{"min.dist"} parameter to the underlying UMAP
#' call. See \link[Seurat]{RunUMAP} for more information. Default \code{0.3}.
#' @param nNeighbors Sets the \code{"n.neighbors"} parameter to the underlying
#' UMAP call. See \link[Seurat]{RunUMAP} for more information. Default
#' \code{30L}.
#' @param spread Sets the \code{"spread"} parameter to the underlying UMAP call.
#' See \link[Seurat]{RunUMAP} for more information. Default \code{1}.
#' @param externalReduction Pass DimReduc object if PCA/ICA computed through
#' other libraries. Default \code{NULL}.
#' @param seed Random seed for reproducibility of results.
#' Default \code{42}.
#' @param verbose Logical value indicating if informative messages should
#'  be displayed. Default is \code{TRUE}.
#' @examples
#' data(scExample, package = "singleCellTK")
#' \dontrun{
#' sce <- runSeuratNormalizeData(sce, useAssay = "counts")
#' sce <- runSeuratFindHVG(sce, useAssay = "counts")
#' sce <- runSeuratScaleData(sce, useAssay = "counts")
#' sce <- runSeuratPCA(sce, useAssay = "counts")
#' sce <- runSeuratFindClusters(sce, useAssay = "counts")
#' sce <- runSeuratUMAP(sce, useReduction = "pca")
#' }
#' @return Updated sce object with UMAP computations stored
#' @export
#' @importFrom SingleCellExperiment reducedDim<-
runSeuratUMAP <- function(inSCE,
                          useReduction = c("pca", "ica"),
                          reducedDimName = "seuratUMAP",
                          dims = 10,
                          minDist = 0.3,
                          nNeighbors = 30L,
                          spread = 1,
                          externalReduction = NULL,
                          seed = 42,
                          verbose = TRUE) {
  useReduction <- match.arg(useReduction)
  seuratObject <- convertSCEToSeurat(inSCE)

  if (!is.null(externalReduction)) {
    seuratObject@reductions <- list(pca = externalReduction)
    useReduction <- "pca"
  }

  seuratObject <- Seurat::RunUMAP(
    seuratObject,
    reduction = useReduction,
    dims = seq(dims),
    min.dist = minDist,
    n.neighbors = nNeighbors,
    spread = spread,
    verbose = verbose,
    seed.use = seed
  )
  inSCE <- .addSeuratToMetaDataSCE(inSCE, seuratObject)

  temp <- seuratObject@reductions$umap@cell.embeddings
  rownames(temp) <- colnames(inSCE)
  reducedDim(inSCE, reducedDimName) <- temp

  return(inSCE)
}

#' .seuratGetVariableFeatures
#' Retrieves the requested number of variable feature names
#' @param inSCE (sce) object from which to extract the variable feature names
#' @param numberOfFeatures numerical value indicating how many feature names
#' should be retrieved (default is 100)
#' @return list() of variable feature names
#' @noRd
.seuratGetVariableFeatures <- function(inSCE, numberOfFeatures) {
  seuratObject <- convertSCEToSeurat(inSCE)

  # Get version number of object
  seurat.version <- .getSeuratObjectMajorVersion(seuratObject)

  if(seurat.version >= 5.0){
    if (length(SeuratObject::Features(seuratObject)) > 0) {
      return(SeuratObject::Features(seuratObject)[seq(numberOfFeatures)])
    }
    #if (length(seuratObject@assays$RNA@misc$var.features) > 0) {
    #  return(seuratObject@assays$RNA@misc$var.features[seq(numberOfFeatures)])
    #}
  }
  else{
    if (length(seuratObject@assays$RNA@meta.data$var.features) > 0) {
      return(seuratObject@assays$RNA@meta.data$var.features[seq(numberOfFeatures)])
    }
  }
}

#' plotSeuratElbow
#' Computes the plot object for elbow plot from the pca slot in the input sce
#' object
#' @param inSCE (sce) object from which to compute the elbow plot (pca should
#' be computed)
#' @param significantPC Number of significant principal components to plot.
#' This is used to alter the color of the points for the corresponding PCs.
#' If \code{NULL}, all points will be the same color. Default \code{NULL}.
#' @param reduction Reduction to use for elbow plot generation. Either
#' \code{"pca"} or \code{"ica"}. Default \code{"pca"}.
#' @param ndims Number of components to use. Default \code{20}.
#' @param externalReduction Pass DimReduc object if PCA/ICA computed through
#' other libraries. Default \code{NULL}.
#' @param interactive Logical value indicating if the returned object should
#'  be an interactive plotly object if \code{TRUE} or a ggplot object if
#'  set to \code{FALSE}. Default is \code{FALSE}.
#' @examples
#' data(scExample, package = "singleCellTK")
#' \dontrun{
#' sce <- runSeuratNormalizeData(sce, useAssay = "counts")
#' sce <- runSeuratFindHVG(sce, useAssay = "counts")
#' sce <- runSeuratScaleData(sce, useAssay = "counts")
#' sce <- runSeuratPCA(sce, useAssay = "counts")
#' plotSeuratElbow(sce)
#' }
#' @return plot object
#' @export
plotSeuratElbow <- function(inSCE,
                            significantPC = NULL,
                            reduction = "pca",
                            ndims = 20,
                            externalReduction = NULL,
                            interactive = FALSE) {
  seuratObject <- convertSCEToSeurat(inSCE)
  if (!is.null(externalReduction)) {
    seuratObject@reductions <- list(pca = externalReduction)
    reduction <- "pca"
  }
  plot <-
    Seurat::ElbowPlot(seuratObject, reduction = reduction, ndims = ndims)
  if (!is.null(significantPC)) {
    if (significantPC > ndims) {
      significantPC <- ndims
    }
    plot$data$Significant <- c(rep("Yes", significantPC),
                               rep("No", length(rownames(plot$data)) - significantPC))
    plot <- ggplot2::ggplot(
      data = plot$data,
      ggplot2::aes(
        x = plot$data$dims,
        y = plot$data$stdev,
        color = plot$data$Significant
      )
    ) +
      ggplot2::geom_point()
  }
  plot$labels$x <- "PC"
  plot$labels$y <- "Standard Deviation"
  plot$labels$colour <- "Significant"

  if (interactive) {
    hoverText <-
      paste(
        "Dimension:",
        plot$data$dims,
        "\nStandard Deviation:",
        round(plot$data$stdev, 1),
        "\nIs Significant?",
        plot$data$Significant
      )
    significant <- plot$data$Significant
    if (length(unique(significant)) > 1) {
      plot <-
        plotly::style(plot, text = hoverText[seq(which(significant == "No")[1]) -
                                               1])
      plot <-
        plotly::style(plot, text = hoverText[which(significant == "No")[1]:length(significant)], traces = 1)
    }
    else{
      plot <- plotly::style(plot, text = hoverText)
    }
  }

  return(plot)
}

#' runSeuratHeatmap
#' Computes the heatmap plot object from the pca slot in the input sce object
#' @param inSCE (sce) object from which to compute heatmap (pca should be
#' computed)
#' @param useAssay Specify name of the assay that will be scaled
#'  by this function. The output scaled assay will be used for computation
#'  of the heatmap.
#' @param useReduction Reduction method to use for computing clusters. One of
#' "pca" or "ica". Default \code{"pca"}.
#' @param dims Number of components to generate heatmap plot objects. If
#' \code{NULL}, a heatmap will be generated for all components. Default
#' \code{NULL}.
#' @param nfeatures Number of features to include in the heatmap. Default
#' \code{30}.
#' @param cells Numeric value indicating the number of top cells to plot.
#'  Default is \code{NULL} which indicates all cells.
#' @param ncol Numeric value indicating the number of columns to use for plot.
#'  Default is \code{NULL} which will automatically compute accordingly.
#' @param balanced Plot equal number of genes with positive and negative scores.
#'  Default is \code{TRUE}.
#' @param fast See \link[Seurat]{DimHeatmap} for more information. Default
#' \code{TRUE}.
#' @param combine See \link[Seurat]{DimHeatmap} for more information. Default
#' \code{TRUE}.
#' @param raster See \link[Seurat]{DimHeatmap} for more information. Default
#' \code{TRUE}.
#' @param externalReduction Pass DimReduc object if PCA/ICA computed through
#' other libraries. Default \code{NULL}.
#' @examples
#' data(scExample, package = "singleCellTK")
#' \dontrun{
#' sce <- runSeuratNormalizeData(sce, useAssay = "counts")
#' sce <- runSeuratFindHVG(sce, useAssay = "counts")
#' sce <- runSeuratScaleData(sce, useAssay = "counts")
#' sce <- runSeuratPCA(sce, useAssay = "counts")
#' heatmap <- runSeuratHeatmap(sce, useAssay = "counts")
#' plotSeuratHeatmap(heatmap)
#' }
#' @return plot object
#' @export
runSeuratHeatmap <- function(inSCE,
                             useAssay,
                             useReduction = c("pca", "ica"),
                             dims = NULL,
                             nfeatures = 30,
                             cells = NULL,
                             ncol = NULL,
                             balanced = TRUE,
                             fast = TRUE,
                             combine = TRUE,
                             raster = TRUE,
                             externalReduction = NULL) {
  useReduction <- match.arg(useReduction)
  # seuratObject <- convertSCEToSeurat(inSCE, scaledAssay = useAssay)
  seuratObject <- convertSCEToSeurat(inSCE, normAssay = useAssay)

  if (!is.null(externalReduction)) {
    seuratObject@reductions <- list(pca = externalReduction)
    useReduction <- "pca"
  }
  if (is.null(dims)) {
    dims <- ncol(seuratObject@reductions[[useReduction]])
  }

  # Only scale requested features
  featuresToScale <- NULL
  temp <-
    as.data.frame(seuratObject[[useReduction]]@feature.loadings)
  for (i in seq(dims)) {
    featuresToScale <-
      c(featuresToScale, rownames(temp[order(-temp[[i]]),])[seq(nfeatures)])
    featuresToScale <-
      c(featuresToScale, rownames(temp[order(temp[[i]]),])[seq(nfeatures)])
  }
  seuratObject <-
    Seurat::ScaleData(seuratObject, features = featuresToScale)

  plotObject <- Seurat::DimHeatmap(
    seuratObject,
    dims = seq(dims),
    nfeatures = nfeatures,
    cells = cells,
    reduction = useReduction,
    ncol = ncol,
    fast = fast,
    combine = combine,
    raster = raster,
    balanced = balanced
  )
  return(plotObject)
}

#' plotSeuratHeatmap
#' Modifies the heatmap plot object so it contains specified number of heatmaps
#' in a single plot
#' @param plotObject plot object computed from runSeuratHeatmap() function
#' @param dims numerical value of how many heatmaps to draw (default is 0)
#' @param ncol numerical value indicating that in how many columns should the
#' heatmaps be distrbuted (default is 2)
#' @param labels list() of labels to draw on heatmaps
#' @return modified plot object
#' @export
plotSeuratHeatmap <- function(plotObject, dims, ncol, labels) {
  componentsToPlot <- as.integer(gsub("[^0-9.]", "", labels))
  return(cowplot::plot_grid(
    plotlist = plotObject[c(componentsToPlot)],
    ncol = ncol,
    labels = labels
  ))
}

#' .updateAssaySCE
#' Update/Modify/Add an assay in the provided SingleCellExperiment object from
#' a Seurat object
#' @param inSCE Input SingleCellExperiment object
#' @param seuratObject Input Seurat object
#' @param assaySlotSCE Selected assay to update in the input
#' SingleCellExperiment object
#' @param seuratDataSlot Selected data slot from the Seurat object. Default
#' \code{"counts"}.
#' @param seuratAssaySlot Selected assay from Seurat object. Default
#' \code{"RNA"}.
#' @return A \link[SingleCellExperiment]{SingleCellExperiment} object with
#'  data from Seurat object appended to the \link{assay} slot.
#' @importFrom SummarizedExperiment assay<-
#' @noRd
.updateAssaySCE <- function(inSCE,
                            seuratObject,
                            assaySlotSCE,
                            seuratDataSlot = "counts",
                            seuratAssaySlot = "RNA") {
  assay(inSCE, assaySlotSCE) <- NULL

  # Get version number of object
  seurat.version <- .getSeuratObjectMajorVersion(seuratObject)

  if(seurat.version >= 5.0){
    temp.matrix <- seuratObject[[seuratAssaySlot]][seuratDataSlot]
  }
  else{
    temp.matrix <-
      methods::slot(Seurat::GetAssay(seuratObject, seuratAssaySlot),
                    seuratDataSlot)
  }
  colnames(temp.matrix) <- colnames(inSCE)

  if (seuratDataSlot == "scale.data" || assaySlotSCE == "SCTCounts") {
    altExp(inSCE, assaySlotSCE) <-
      SingleCellExperiment(list(counts = temp.matrix))
  }
  else{
    rownames(temp.matrix) <- rownames(inSCE)
    assay(inSCE, assaySlotSCE) <- temp.matrix
  }
  return(inSCE)
}

#' convertSeuratToSCE
#' Converts the input seurat object to a sce object
#' @param seuratObject Input Seurat object
#' @param normAssayName Name of assay to store the normalized data. Default
#' \code{"seuratNormData"}.
#' @param scaledAssayName Name of assay to store the scaled data. Default
#' \code{"seuratScaledData"}.
#' @examples
#' data(scExample, package = "singleCellTK")
#' seurat <- convertSCEToSeurat(sce)
#' sce <- convertSeuratToSCE(seurat)
#' @return \code{SingleCellExperiment} output object
#' @export
convertSeuratToSCE <-
  function(seuratObject,
           normAssayName = "seuratNormData",
           scaledAssayName = "seuratScaledData") {

    # Get version number of object
    seurat.version <- .getSeuratObjectMajorVersion(seuratObject)

    if (seurat.version >= 5.0){
      inSCE <- SingleCellExperiment(
        assays = list(counts = seuratObject@assays[[1]]$counts),
        colData = seuratObject@meta.data
      )
      assay(inSCE, normAssayName) <-
        seuratObject[["RNA"]]["data"]
      if (length(seuratObject[["RNA"]]["scale.data"]) > 0) {
        altExp(inSCE, scaledAssayName) <- SingleCellExperiment::SingleCellExperiment(
          list(counts = seuratObject[["RNA"]]["scale.data"]))
      }
    }
    else{
      inSCE <- SingleCellExperiment(
        assays = list(counts = seuratObject@assays[[1]]@counts),
        colData = seuratObject@meta.data
      )
      assay(inSCE, normAssayName) <-
        methods::slot(seuratObject@assays$RNA, "data")
      if (length(methods::slot(seuratObject, "assays")[["RNA"]]@scale.data) > 0) {
        altExp(inSCE, scaledAssayName) <- SingleCellExperiment::SingleCellExperiment(
          list(counts = methods::slot(seuratObject@assays$RNA, "scale.data")))
      }
    }

    inSCE <- .addSeuratToMetaDataSCE(inSCE, seuratObject)
    return(inSCE)
  }

#' convertSCEToSeurat
#' Converts sce object to seurat while retaining all assays and metadata
#' @param inSCE A \code{SingleCellExperiment} object to convert to a Seurat
#'  object.
#' @param countsAssay Which assay to use from sce object for raw counts.
#'  Default \code{NULL}.
#' @param normAssay Which assay to use from sce object for normalized data.
#'  Default \code{NULL}.
#' @param scaledAssay Which assay to use from sce object for scaled data.
#'  Default \code{NULL}.
#' @param copyColData Boolean. Whether copy 'colData' of SCE object to
#'  the 'meta.data' of Seurat object. Default \code{FALSE}.
#' @param copyReducedDim Boolean. Whether copy 'reducedDims' of the SCE
#'  object to the 'reductions' of Seurat object. Default \code{FALSE}.
#' @param copyDecontX Boolean. Whether copy 'decontXcounts' assay of the
#'  SCE object to the 'assays' of Seurat object. Default \code{TRUE}.
#' @param pcaReducedDim Specify a character value indicating the name of
#'  the reducedDim to store as default pca computation in the output seurat
#'  object. Default is \code{NULL} which will not store any reducedDim as the
#'  default pca. This will only work when \code{copyReducedDim} parameter is
#'  set to \code{TRUE}.
#' @param icaReducedDim Specify a character value indicating the name of
#'  the reducedDim to store as default ica computation in the output seurat
#'  object. Default is \code{NULL} which will not store any reducedDim as the
#'  default ica. This will only work when \code{copyReducedDim} parameter is
#'  set to \code{TRUE}.
#' @param tsneReducedDim Specify a character value indicating the name of
#'  the reducedDim to store as default tsne computation in the output seurat
#'  object. Default is \code{NULL} which will not store any reducedDim as the
#'  default tsne. This will only work when \code{copyReducedDim} parameter is
#'  set to \code{TRUE}.
#' @param umapReducedDim Specify a character value indicating the name of
#'  the reducedDim to store as default umap computation in the output seurat
#'  object. Default is \code{NULL} which will not store any reducedDim as the
#'  default umap. This will only work when \code{copyReducedDim} parameter is
#'  set to \code{TRUE}.
#' @examples
#' data(scExample, package = "singleCellTK")
#' seurat <- convertSCEToSeurat(sce)
#' @return Updated seurat object that contains all data from the input sce
#' object
#' @export
#' @importFrom SummarizedExperiment assay assays
#' @importFrom utils packageVersion
convertSCEToSeurat <-
  function(inSCE,
           countsAssay = NULL,
           normAssay = NULL,
           scaledAssay = NULL,
           copyColData = FALSE,
           copyReducedDim = FALSE,
           copyDecontX = FALSE,
           pcaReducedDim = NULL,
           icaReducedDim = NULL,
           tsneReducedDim = NULL,
           umapReducedDim = NULL) {
    .checkSCEValidity(inSCE)

    if (!is.null(countsAssay) &&
        !(countsAssay %in% expDataNames(inSCE))) {
      stop(paste0(
        "'",
        countsAssay,
        "' not found in the list of assays: ",
        paste(names(assays(inSCE)), collapse = ",")
      ))
    }
    if (!is.null(normAssay) &&
        !(normAssay %in% expDataNames(inSCE))) {
      stop(paste0(
        "'",
        normAssay,
        "' not found in the list of assays: ",
        paste(names(assays(inSCE)), collapse = ",")
      ))
    }
    if (!is.null(scaledAssay) &&
        !(scaledAssay %in% expDataNames(inSCE))) {
      stop(paste0(
        "'",
        scaledAssay,
        "' not found in the list of assays: ",
        paste(names(assays(inSCE)), collapse = ",")
      ))
    }
    if (!is.null(pcaReducedDim) &&
        !(pcaReducedDim %in% reducedDimNames(inSCE))) {
      stop(paste0(
        "'",
        pcaReducedDim,
        "' not found in the list of reducedDims: ",
        paste(reducedDimNames(inSCE), collapse = ",")
      ))
    }
    if (!is.null(icaReducedDim) &&
        !(icaReducedDim %in% reducedDimNames(inSCE))) {
      stop(paste0(
        "'",
        icaReducedDim,
        "' not found in the list of reducedDims: ",
        paste(reducedDimNames(inSCE), collapse = ",")
      ))
    }
    if (!is.null(tsneReducedDim) &&
        !(tsneReducedDim %in% reducedDimNames(inSCE))) {
      stop(paste0(
        "'",
        tsneReducedDim,
        "' not found in the list of reducedDims: ",
        paste(reducedDimNames(inSCE), collapse = ",")
      ))
    }
    if (!is.null(umapReducedDim) &&
        !(umapReducedDim %in% reducedDimNames(inSCE))) {
      stop(paste0(
        "'",
        umapReducedDim,
        "' not found in the list of reducedDims: ",
        paste(reducedDimNames(inSCE), collapse = ",")
      ))
    }

    # Seurat has a particular way of modifying row/colnames
    # Save row/colnames in metadata
    seuratRowNames <- gsub("_", "-", rownames(inSCE))
    seuratColNames <- gsub("_", "-", colnames(inSCE))
    inSCE@metadata$seurat$colNames <- seuratColNames
    inSCE@metadata$seurat$rowNames <- seuratRowNames

    # Create Seurat object and Set counts assay
    # If no counts assay is supplied, the first assay is used
    if (!is.null(countsAssay) &&
        countsAssay %in% names(assays(inSCE))) {
      temp <- .convertToMatrix(assay(inSCE, countsAssay))
    } else {
      temp <- .convertToMatrix(assays(inSCE)[[1]])
    }
    rownames(temp) <- seuratRowNames
    colnames(temp) <- seuratColNames
    seuratObject <- Seurat::CreateSeuratObject(counts = temp)
    seurat.version <- .getSeuratObjectMajorVersion(seuratObject)

    # Set normalized assay
    if (!is.null(normAssay) && normAssay %in% names(assays(inSCE))) {
      tempMatrix <- .convertToMatrix(assay(inSCE, normAssay))
      if (inherits(tempMatrix, "dgeMatrix")) {
        tempMatrix <- methods::as(tempMatrix, "CsparseMatrix")
      }
      rownames(tempMatrix) <- seuratRowNames
      colnames(tempMatrix) <- seuratColNames
      if(seurat.version >= 5.0){
        seuratObject[["RNA"]]$data  <- tempMatrix
      }
      else{
        seuratObject@assays$RNA@data <- tempMatrix
      }
    }else {
      if(seurat.version >= 5.0){
        tempMatrix <- Seurat::NormalizeData(seuratObject[["RNA"]]$counts, verbose = FALSE)
        rownames(tempMatrix) <- seuratRowNames
        colnames(tempMatrix) <- seuratColNames
        seuratObject[["RNA"]]$data  <- tempMatrix
      }
    }

    # Set Scaled Assay
    if (!is.null(scaledAssay) &&
        scaledAssay %in% names(assays(inSCE))) {
      tempMatrix <- as.matrix(assay(inSCE, scaledAssay))
      rownames(tempMatrix) <- seuratRowNames
      colnames(tempMatrix) <- seuratColNames

      if(seurat.version >= 5.0){
        seuratObject[["RNA"]]$scale.data  <- tempMatrix
      }
      else{
        seuratObject@assays$RNA@scale.data <- tempMatrix
      }
    }

    if(seurat.version >= 5.0){
      if (!is.null(inSCE@metadata$seurat$obj)) {
        # what is it looking for here? sequence? idk

        if ((nrow(inSCE@metadata$seurat$obj@assays$RNA) > 0 && ncol(inSCE@metadata$seurat$obj@assays$RNA) > 0) && !is.null(inSCE@metadata$seurat$obj@assays$RNA@meta.data$var.features)) {
          seuratObject@assays$RNA@meta.data$var.features <-
            inSCE@metadata$seurat$obj@assays$RNA@meta.data$var.features
        }

        # if no, then set a new matrix to empty
        # if (is.null(inSCE@metadata$seurat$obj@assays$RNA@meta.data$var.features)) {
        #   seuratObject@assays$RNA@meta.data$var.features <-
        #     data.frame(matrix(NA, nrow = nrow(inSCE@metadata$seurat$obj@assays$RNA), ncol = ncol(inSCE@metadata$seurat$obj@assays$RNA)))
        # }

        if (!is.null(inSCE@metadata$seurat$obj@reductions) && !is.null(inSCE@metadata$seurat$obj@reductions$pca)) {
          seuratObject@reductions$pca <-
            inSCE@metadata$seurat$obj@reductions$pca
        }
        if ((nrow(inSCE@metadata$seurat$obj@assays$RNA) > 0 && ncol(inSCE@metadata$seurat$obj@assays$RNA) > 0) && !is.null(inSCE@metadata$seurat$obj@assays$RNA@meta.data)) {
          seuratObject@assays$RNA@meta.data <-
            inSCE@metadata$seurat$obj@assays$RNA@meta.data
          #seuratObject <-
          #  SeuratObject::AddMetaData(seuratObject, inSCE@metadata$seurat$obj@assays$RNA@meta.data)
        }
        if (!is.null(inSCE@metadata$seurat$obj@reductions$ica)) {
          seuratObject@reductions$ica <-
            inSCE@metadata$seurat$obj@reductions$ica
        }
        if (!is.null(inSCE@metadata$seurat$obj@reductions$tsne)) {
          seuratObject@reductions$tsne <-
            inSCE@metadata$seurat$obj@reductions$tsne
        }
        if (!is.null(inSCE@metadata$seurat$obj@reductions$umap)) {
          seuratObject@reductions$umap <-
            inSCE@metadata$seurat$obj@reductions$umap
        }
        if (!is.null(inSCE@metadata$seurat$obj@meta.data)) {
          #seuratObject@meta.data <-
            #inSCE@metadata$seurat$obj$meta.data[match(colnames(seuratObject), rownames(inSCE@metadata$seurat$obj$meta.data)),]
          seuratObject <-
            SeuratObject::AddMetaData(seuratObject, inSCE@metadata$seurat$obj@meta.data[match(colnames(seuratObject), rownames(inSCE@metadata$seurat$obj@meta.data)),])
        }
        if (!is.null(inSCE@metadata$seurat$obj@commands)) {
          seuratObject@commands <- inSCE@metadata$seurat$obj@commands
        }
      }
    }
    else{
      if (!is.null(inSCE@metadata$seurat$obj)) {
        if (length(inSCE@metadata$seurat$obj@assays$RNA@meta.data$var.features) > 0) {
          seuratObject@assays$RNA@meta.data$var.features <-
            inSCE@metadata$seurat$obj@assays$RNA@meta.data$var.features
        }
        if (!is.null(inSCE@metadata$seurat$obj@reductions$pca)) {
          seuratObject@reductions$pca <-
            inSCE@metadata$seurat$obj@reductions$pca
        }
        if (!is.null(inSCE@metadata$seurat$obj@assays$RNA@meta.features)) {
          seuratObject@assays$RNA@meta.features <-
            inSCE@metadata$seurat$obj@assays$RNA@meta.features
        }
        if (!is.null(inSCE@metadata$seurat$obj@reductions$ica)) {
          seuratObject@reductions$ica <-
            inSCE@metadata$seurat$obj@reductions$ica
        }
        if (!is.null(inSCE@metadata$seurat$obj@reductions$tsne)) {
          seuratObject@reductions$tsne <-
            inSCE@metadata$seurat$obj@reductions$tsne
        }
        if (!is.null(inSCE@metadata$seurat$obj@reductions$umap)) {
          seuratObject@reductions$umap <-
            inSCE@metadata$seurat$obj@reductions$umap
        }
        if (!is.null(inSCE@metadata$seurat$obj@meta.data)) {
          #seuratObject@meta.data <- inSCE@metadata$seurat$obj@meta.data[match(colnames(seuratObject), rownames(inSCE@metadata$seurat$obj@meta.data)),]
          seuratObject <-
            SeuratObject::AddMetaData(seuratObject, inSCE@metadata$seurat$obj$meta.data[match(colnames(seuratObject), rownames(inSCE@metadata$seurat$obj$meta.data)),])
        }
        if (!is.null(inSCE@metadata$seurat$obj@commands)) {
          seuratObject@commands <- inSCE@metadata$seurat$obj@commands
        }
      }
    }
    # Set colData from inSCE object if required
    if (!is.null(colData(inSCE)) && copyColData) {
      seuratObject@meta.data <-
        cbind(seuratObject@meta.data, colData(inSCE))
      #seuratObject <- SeuratObject::AddMetaData(seuratObject, colData(inSCE))
    }

    # Set additional reducedDims from inSCE object if required
    if (length(SingleCellExperiment::reducedDims(inSCE)) > 0 &&
        copyReducedDim) {
      for (redc in SingleCellExperiment::reducedDimNames(inSCE)) {
        reDim <- SingleCellExperiment::reducedDim(inSCE, redc)
        colnames(reDim) <-
          paste0(redc, "_", seq_len(ncol(reDim))) #length(colnames(reDim)))
        rownames(reDim) <- gsub('_', '-', rownames(reDim))
        key <-  gsub('_', '', redc)
        seuratObject@reductions[[redc]] <-
          Seurat::CreateDimReducObject(embeddings = reDim,
                                       key = paste0(key, "_"),
                                       assay = "RNA")
      }

      availReducedDims <- c("pca", "ica", "tsne", "umap")
      for (i in availReducedDims) {
        if (!is.null(eval(parse(text = paste0(
          i, "ReducedDim"
        ))))) {
          seuratObject@reductions[[i]] <-
            seuratObject@reductions[[eval(parse(text = paste0(i, "ReducedDim")))]]
          seuratObject@reductions[[eval(parse(text = paste0(i, "ReducedDim")))]] <-
            NULL
          p <- paste0(
            i, "ReducedDim"
          )
          message(
            "'",
            eval(parse(text = p)),
            "' reducedDim from input SCE object saved to the default ",
            i,
            " slot of seurat object."
          )
        }
      }
    }

    # Set row data
    if(seurat.version >= 5) {
        seuratObject@assays$RNA@meta.data <- as.data.frame(rowData(inSCE))
    } else {
        seuratObject@assays$RNA@meta.features <- as.data.frame(rowData(inSCE))
    }

    # Set 'decontXCounts' assay to seurat object if required
    if ("decontXcounts" %in% SummarizedExperiment::assayNames(inSCE) &&
        copyDecontX) {
      decontM <- SummarizedExperiment::assay(inSCE, "decontXcounts")
      colnames(decontM) <- colnames(seuratObject)
      rownames(decontM) <- gsub('_', '-', rownames(decontM))
      if(seurat.version >= 5.0){
        # CreateAssayObject and similar were moved to SeuratObject now (added it to suggests)
        seuratObject[["decontXcounts"]] <-
          SeuratObject::CreateAssay5Object(counts = .convertToMatrix(decontM))
      }
      else{
        seuratObject[["decontXcounts"]] <-
          SeuratObject::CreateAssayObject(counts = .convertToMatrix(decontM))
      }

    }

    # Ensuring that colnames from input SCE converted to Seurat object are same in the Seurat metadata slot
    seuratObject@meta.data <- seuratObject@meta.data[colnames(seuratObject),]
    rownames(seuratObject@meta.data) <- colnames(seuratObject)

    return(seuratObject)
  }

#' runSeuratSCTransform
#' Runs the \link[Seurat]{SCTransform} function to transform/normalize the input
#' data
#' @param inSCE Input SingleCellExperiment object
#' @param normAssayName Name for the output data assay. Default
#' \code{"SCTCounts"}.
#' @param useAssay Name for the input data assay. Default \code{"counts"}.
#' @param verbose Logical value indicating if informative messages should
#'  be displayed. Default is \code{TRUE}.
#' @return Updated SingleCellExperiment object containing the transformed data
#' @export
#' @examples
#' data("mouseBrainSubsetSCE", package = "singleCellTK")
#' mouseBrainSubsetSCE <- runSeuratSCTransform(mouseBrainSubsetSCE)
runSeuratSCTransform <- function(inSCE,
                                 normAssayName = "SCTCounts",
                                 useAssay = "counts",
                                 verbose = TRUE) {
  seuratObject <- base::suppressWarnings(
    Seurat::SCTransform(
      object = convertSCEToSeurat(inSCE, useAssay),
      assay = "RNA",
      new.assay.name = "SCTransform",
      do.correct.umi = FALSE,
      verbose = verbose
    )
  )
  inSCE <-
    .updateAssaySCE(
      inSCE = inSCE,
      seuratObject = seuratObject,
      assaySlotSCE = normAssayName,
      seuratDataSlot = "data",
      seuratAssaySlot = "SCTransform"
    )
  inSCE <- expSetDataTag(inSCE = inSCE,
                         assayType = "normalized",
                         assays = normAssayName)
  return(inSCE)
}


#' .seuratInvalidate
#' Removes seurat data from the input SingleCellExperiment object specified by
#' the task in the Seurat workflow.
#' @param inSCE Input \code{SingleCellExperiment} object to remove Seurat data
#' from.
#' @param scaleData Remove scaled data from seurat. Default \code{TRUE}.
#' @param varFeatures Remove variable features from seurat. Default \code{TRUE}.
#' @param PCA Remove PCA from seurat. Default \code{TRUE}.
#' @param ICA Remove ICA from seurat. Default \code{TRUE}.
#' @param tSNE Remove tSNE from seurat. Default \code{TRUE}.
#' @param UMAP Remove UMAP from seurat. Default \code{TRUE}.
#' @param clusters Remove clusters from seurat. Default \code{TRUE}.
#' @return Updated SingleCellExperiment object containing the Seurat object in
#' the metadata slot with the data removed
#' @importFrom SummarizedExperiment assay<-
#' @noRd
.seuratInvalidate <-
  function(inSCE,
           scaleData = TRUE,
           varFeatures = TRUE,
           PCA = TRUE,
           ICA = TRUE,
           tSNE = TRUE,
           UMAP = TRUE,
           clusters = TRUE) {

    if (scaleData) {
      altExp(inSCE, "seuratScaledData") <- NULL
    }

    if(methods::is(inSCE@metadata$seurat$obj, "list")){
      if (varFeatures) {
        inSCE@metadata$seurat$obj$RNA$"var.features" <- NULL
        inSCE@metadata$seurat$obj$RNA$meta.features <-
          data.frame(row.names = make.unique(gsub("_", "-", rownames(inSCE))))
        #inSCE@metadata$seurat$heatmap_pca <- NULL
      }
      if (PCA) {
        inSCE@metadata$seurat$obj@reductions$pca <- NULL
      }
      if (ICA) {
        inSCE@metadata$seurat$obj@reductions$ica <- NULL
      }
      if (tSNE) {
        inSCE@metadata$seurat$obj@reductions$tsne <- NULL
      }
      if (UMAP) {
        inSCE@metadata$seurat$obj@reductions$umap <- NULL
      }
      if (clusters) {
        inSCE@metadata$seurat$obj$meta.data$seurat_clusters <- NULL
      }
    }
    if(methods::is(inSCE@metadata$seurat$obj, "Seurat")) {
      if (varFeatures) {
        seurat.version <- .getSeuratObjectMajorVersion(inSCE@metadata$seurat$obj)
        if (seurat.version >= 5.0) {
          #methods::slot(inSCE@metadata$seurat$obj, "assays")[["RNA"]]@meta.data$var.features <-
          #  logical()
          methods::slot(inSCE@metadata$seurat$obj, "assays")[["RNA"]]@meta.data <-
          data.frame(row.names = make.unique(gsub("_", "-", rownames(inSCE))))
        }
        else {
          methods::slot(inSCE@metadata$seurat$obj, "assays")[["RNA"]]@var.features <-
            logical()
          methods::slot(inSCE@metadata$seurat$obj, "assays")[["RNA"]]@meta.features <-
            data.frame(row.names = make.unique(gsub("_", "-", rownames(inSCE))))
        }
        inSCE@metadata$seurat$heatmap_pca <- NULL
      }
      if (PCA) {
        inSCE@metadata$seurat$obj@reductions$pca <- NULL
      }
      if (ICA) {
        inSCE@metadata$seurat$obj@reductions$ica <- NULL
      }
      if (tSNE) {
        inSCE@metadata$seurat$obj@reductions$tsne <- NULL
      }
      if (UMAP) {
        inSCE@metadata$seurat$obj@reductions$umap <- NULL
      }
      if (clusters) {
        inSCE@metadata$seurat$obj@meta.data$seurat_clusters <- NULL
      }

    }

    return(inSCE)
  }


#' runSeuratIntegration
#' A wrapper function to Seurat Batch-Correction/Integration workflow.
#' @param inSCE Input \code{SingleCellExperiment} object that contains the assay
#' to batch-correct.
#' @param useAssay Assay to batch-correct.
#' @param batch Batch variable from \code{colData} slot of
#' \code{SingleCellExperiment} object.
#' @param newAssayName Assay name for the batch-corrected output assay.
#' @param kAnchor Number of neighbours to use for finding the anchors in the
#' \link[Seurat]{FindIntegrationAnchors} function.
#' @param kFilter Number of neighbours to use for filtering the anchors in the
#' \link[Seurat]{FindIntegrationAnchors} function.
#' @param kWeight Number of neighbours to use when weigthing the anchors in the
#' \link[Seurat]{IntegrateData} function.
#' @param ndims Number of dimensions to use. Default \code{10}.
#'
#' @return A \code{SingleCellExperiment} object that contains the
#' batch-corrected assay inside the \code{altExp} slot of the object
#' @export
runSeuratIntegration <- function(inSCE,
                                 useAssay = "counts",
                                 batch,
                                 newAssayName = "SeuratIntegratedAssay",
                                 kAnchor,
                                 kFilter,
                                 kWeight,
                                 ndims = 10) {
  if (!useAssay %in% SummarizedExperiment::assayNames(inSCE)) {
    p <- paste(useAssay, "not found in the input object assays")
    stop(p)
  }
  if (is.null(batch)) {
    stop("batch variable must be provided for batch-correction")
  }
  if (kAnchor == 0 || kFilter == 0 || kWeight == 0) {
    stop("kAnchor, kFilter or kWeight cannot be zero. Please input correct ",
         "parameters.")
  }

  #create seurat object
  seuratObject <- convertSCEToSeurat(inSCE, useAssay)
  rownames(seuratObject@meta.data) <- gsub("_", "-",
                                           rownames(seuratObject@meta.data))
  seuratObject@meta.data <-
    cbind(seuratObject@meta.data, colData(inSCE))

  #split seurat object by batch variable
  seurat.list <- Seurat::SplitObject(seuratObject, split.by = batch)
  seurat.list <-
    seurat.list[c(unique(seuratObject@meta.data[[batch]]))]

  #find anchors
  seurat.anchors <-
    Seurat::FindIntegrationAnchors(
      object.list = seurat.list,
      dims = seq(ndims),
      k.anchor = kAnchor,
      k.filter = kFilter
    )
  seurat.integrated <-
    Seurat::IntegrateData(anchorset = seurat.anchors,
                          dims = seq(ndims),
                          k.weight = kWeight)
  #store results back in altExp slot of sce object
  altExp(inSCE, newAssayName) <-
    SingleCellExperiment(list(
      counts = Seurat::GetAssayData(seurat.integrated@assays$integrated, "data")
    ))
  SummarizedExperiment::assayNames(altExp(inSCE, newAssayName)) <-
    newAssayName
  # remove this if counts in above line set to altExp

  # store back colData from sce into the altExp slot
  colData(altExp(inSCE, newAssayName)) <- colData(inSCE)

  #counts <- assay(altExp(inSCE, newAssayName), "altExp")
  # remove NA values from counts and replace with zero so can be used properly
  # by dgCMatrix
  counts <- assay(altExp(inSCE, newAssayName), newAssayName)
  counts[is.na(counts)] <- 0

  #store back counts
  #assay(altExp(inSCE, newAssayName), "altExp") <- counts
  assay(altExp(inSCE, newAssayName), newAssayName) <- counts

  return(inSCE)
}

#' runSeuratFindMarkers
#'
#' @param inSCE Input \code{SingleCellExperiment} object.
#' @param cells1 A \code{list} of sample names included in group1.
#' @param cells2 A \code{list} of sample names included in group2.
#' @param group1 Name of group1.
#' @param group2 Name of group2.
#' @param allGroup Name of all groups.
#' @param conserved Logical value indicating if markers conserved between two
#' groups should be identified. Default is \code{FALSE}.
#' @param test Test to use for DE. Default \code{"wilcox"}.
#' @param onlyPos Logical value indicating if only positive markers should be
#' returned.
#' @param minPCT Numeric value indicating the minimum fraction of min.pct
#'  cells in which genes are detected. Default is \code{0.1}.
#' @param threshUse Numeric value indicating the logFC threshold value on
#'  which on average, at least X-fold difference (log-scale) between the
#'  two groups of cells exists. Default is \code{0.25}.
#' @param verbose Logical value indicating if informative messages should
#'  be displayed. Default is \code{TRUE}.
#' @return A \code{SingleCellExperiment} object that contains marker genes
#' populated in a data.frame stored inside metadata slot.
#' @export
runSeuratFindMarkers <- function(inSCE,
                                 cells1 = NULL,
                                 cells2 = NULL,
                                 group1 = NULL,
                                 group2 = NULL,
                                 allGroup = NULL,
                                 conserved = FALSE,
                                 test = "wilcox",
                                 onlyPos = FALSE,
                                 minPCT = 0.1,
                                 threshUse = 0.25,
                                 verbose = TRUE) {
  seuratObject <- convertSCEToSeurat(inSCE)
  seurat.version <- .getSeuratObjectMajorVersion(seuratObject)
  markerGenes <- NULL
  if (is.null(allGroup)
      && (!is.null(group1) && !is.null(group2))) {
    #convert (_) to (-) as required by Seurat
    cells1 <- .convertToHyphen(cells1)
    cells2 <- .convertToHyphen(cells2)
    if(seurat.version >= 5.0){
      cells1 <- unlist(cells1)
      cells2 <- unlist(cells2)
    }
    Seurat::Idents(seuratObject, cells = cells1) <- group1
    Seurat::Idents(seuratObject, cells = cells2) <- group2
    markerGenes <- NULL
    if (!conserved) {
      markerGenes <- Seurat::FindMarkers(
        object = seuratObject,
        ident.1 = group1,
        ident.2 = group2,
        test.use = test,
        only.pos = onlyPos
      )
    }
    else{
      seuratObject[["groups"]] <- Seurat::Idents(seuratObject)
      markerGenes <- .findConservedMarkers(
        object = seuratObject,
        ident.1 = group1,
        ident.2 = group2,
        grouping.var = "groups",
        test.use = test,
        only.pos = onlyPos,
        cells1 = cells1,
        cells2 = cells2
      )
    }
    markerGenes$cluster1 <- group1
    markerGenes$cluster2 <- group2
    gene.id <- rownames(markerGenes)
    markerGenes <- cbind(gene.id, markerGenes)
  }
  else if (!is.null(allGroup)
           && (is.null(group1) && is.null(group2))) {
    Seurat::Idents(seuratObject,
                   cells = colnames(seuratObject)) <-
      colData(inSCE)[[allGroup]]
    markerGenes <- Seurat::FindAllMarkers(
      seuratObject,
      test.use = test,
      only.pos = onlyPos,
      logfc.threshold = threshUse,
      min.pct = minPCT,
      verbose = verbose
    )
    gene.id <- markerGenes$gene
    markerGenes <- cbind(gene.id, markerGenes)
    markerGenes$gene <- NULL
    # grp <- unique(colData(inSCE)[[allGroup]])
    # clust <- as.integer(unique(Seurat::Idents(seuratObject)))
    # for(i in seq(length(clust))){
    #   levels(markerGenes$cluster)[clust[i]] <- grp[i]
    # }
    colnames(markerGenes)[which(colnames(markerGenes) == "cluster")] <-
      "cluster1"
    markerGenes$cluster2 <- rep("all", nrow(markerGenes))
  }
  else if (is.null(allGroup)
           && (is.null(group1) && is.null(group2))) {
    Seurat::Idents(seuratObject,
                   cells = colnames(seuratObject)) <-
      colData(inSCE)[[S4Vectors::metadata(inSCE)$seurat$clusterName]]
    markerGenes <- Seurat::FindAllMarkers(
      seuratObject,
      test.use = test,
      only.pos = onlyPos,
      logfc.threshold = threshUse,
      min.pct = minPCT,
      verbose = verbose
    )
    gene.id <- markerGenes$gene
    markerGenes <- cbind(gene.id, markerGenes)
    markerGenes$gene <- NULL
    # grp <- unique(colData(inSCE)[[S4Vectors::metadata(inSCE)$seurat$clusterName]])
    # clust <- as.integer(unique(Seurat::Idents(seuratObject)))
    # for(i in seq(length(clust))){
    #   levels(markerGenes$cluster)[clust[i]] <- grp[i]
    # }
  }
  rownames(markerGenes) <- NULL
  S4Vectors::metadata(inSCE)$seuratMarkers <- markerGenes
  return(inSCE)
}

#' Compute and plot visualizations for marker genes
#'
#' @param inSCE Input \code{SingleCellExperiment} object.
#' @param useAssay Specify the name of the assay that will be scaled by this
#'  function.
#' @param plotType Specify the type of the plot to compute. Options are limited
#' to "ridge", "violin", "feature", "dot" and "heatmap".
#' @param features Specify the features to compute the plot against.
#' @param groupVariable Specify the column name from the colData slot that
#' should be used as grouping variable.
#'  Default is \code{NULL}.
#' @param reducedDimName Specify the name of the dimensional reduction to be used.
#' Default is "seuratNormData".
#' @param splitBy Specify the column name from the colData slot that should be
#' used to split samples.
#'  Default is \code{NULL}.
#' @param reducedDimName saved dimension reduction name in the
#' SingleCellExperiment object. Default \code{seuratUMAP}.
#' @param cols Specify two colors to form a gradient between. Default is
#' \code{c("lightgrey", "blue")}.
#' @param ncol Visualizations will be adjusted in "ncol" number of columns.
#'  Default is \code{1}.
#' @param combine A logical value that indicates if the plots should be combined
#'  together into a single plot if \code{TRUE}, else if \code{FALSE} returns
#'  separate ggplot objects for each feature. Only works when \code{plotType}
#'  parameter is \code{"feature"}, \code{"violin"} or \code{"ridge"}. For
#'  \code{"heatmap"} and \code{"dot"}, plots for all features are always
#'  combined into a single plot. Default \code{FALSE}.
#' @return Plot object
#' @export
plotSeuratGenes <- function(inSCE,
                            useAssay = "seuratNormData",
                            plotType,
                            features,
                            groupVariable = NULL,
                            reducedDimName = "seuratUMAP",
                            splitBy = NULL,
                            cols = c("lightgrey", "blue"),
                            ncol = 1,
                            combine = FALSE) {
    plotType <- match.arg(plotType, c("dot", "feature", "ridge", "heatmap", "violin"))

    #setup seurat object and the corresponding groups
    seuratObject <- convertSCEToSeurat(inSCE, normAssay = useAssay, copyReducedDim = TRUE)
    seurat.version <- .getSeuratObjectMajorVersion(seuratObject)

    if(plotType %in% c("dot", "heatmap")){
        if (length(features) == 1) {
            dummyfeature <- rownames(inSCE)[which(!rownames(inSCE) == features)][1]
            seuratObject <-
                Seurat::ScaleData(seuratObject, features = c(features,dummyfeature))
        }else{
            seuratObject <-
                Seurat::ScaleData(seuratObject, features = features)
        }
    }

    indices <- list()
    cells <- list()
    if(!is.null(groupVariable)){
        groups <- unique(colData(inSCE)[[groupVariable]])
        for (i in seq(length(groups))) {
            indices[[i]] <- which(colData(inSCE)[[groupVariable]] == groups[i],
                                  arr.ind = TRUE)
            cells[[i]] <- colnames(inSCE)[indices[[i]]]
            cells[[i]] <- .convertToHyphen(cells[[i]])
            if(seurat.version >= 5.0){
                cells[[i]] <- unlist(cells[[i]])
            }
            Seurat::Idents(seuratObject, cells = cells[[i]]) <- groups[i]
        }
    }

    if (!is.null(splitBy)) {
        seuratObject[[splitBy]] <- colData(inSCE)[[splitBy]]
    }

    #plot required visualization
    if (plotType == "ridge") {
        return(
            Seurat::RidgePlot(
                seuratObject,
                features = features,
                ncol = ncol,
                combine = combine
            )
        )
    }
    else if (plotType == "violin") {
        return(
            Seurat::VlnPlot(
                seuratObject,
                features = features,
                ncol = ncol,
                split.by = splitBy,
                combine = combine
            )
        )
    }
    else if (plotType == "feature") {
        return(
            Seurat::FeaturePlot(
                seuratObject,
                features = features,
                cols = cols,
                ncol = ncol,
                split.by = splitBy,
                combine = combine,
                reduction = reducedDimName
            )
        )
    }
    else if (plotType == "dot") {
        return(Seurat::DotPlot(
            seuratObject,
            features = unique(features),
            split.by = splitBy
        ))
    }
    else if (plotType == "heatmap") {
        return(Seurat::DoHeatmap(seuratObject, features = features))
    }
}


.findConservedMarkers <- function(object,
                                  ident.1,
                                  ident.2,
                                  grouping.var = "groups",
                                  test.use,
                                  only.pos,
                                  cells1,
                                  cells2) {
  meta.method <- metap::minimump
  verbose <- TRUE
  slot <- "data"
  assay <- "RNA"
  marker.test <- list()

  object.var <-
    Seurat::FetchData(object = object, vars = grouping.var)
  levels.split <- names(x = sort(x = table(object.var[, 1])))
  num.groups <- length(levels.split)

  marker.test[[1]] <- Seurat::FindMarkers(
    object = object,
    assay = assay,
    slot = slot,
    ident.1 = levels.split[1],
    ident.2 = levels.split[2],
  )

  marker.test[[2]] <- Seurat::FindMarkers(
    object = object,
    assay = assay,
    slot = slot,
    ident.1 = levels.split[2],
    ident.2 = levels.split[3],
  )

  marker.test[[3]] <- Seurat::FindMarkers(
    object = object,
    assay = assay,
    slot = slot,
    ident.1 = levels.split[3],
    ident.2 = levels.split[1],
  )

  names(x = marker.test)[1] <- levels.split[1]
  names(x = marker.test)[2] <- levels.split[2]
  names(x = marker.test)[3] <- levels.split[3]

  marker.test <- Filter(f = Negate(f = is.null), x = marker.test)
  genes.conserved <- Reduce(f = intersect,
                            x = lapply(
                              X = marker.test,
                              FUN = function(x) {
                                return(rownames(x = x))
                              }
                            ))
  markers.conserved <- list()
  for (i in seq_len(length(x = marker.test))) {
    markers.conserved[[i]] <- marker.test[[i]][genes.conserved,]
    colnames(x = markers.conserved[[i]]) <- paste(names(x = marker.test)[i],
                                                  colnames(x = markers.conserved[[i]]),
                                                  sep = "_")
  }
  markers.combined <- Reduce(cbind, markers.conserved)
  pval.codes <-
    colnames(x = markers.combined)[grepl(pattern = "*_p_val$", x = colnames(x = markers.combined))]
  if (length(x = pval.codes) > 1) {
    markers.combined$max_pval <- apply(X = markers.combined[, pval.codes, drop = FALSE],
                                       MARGIN = 1,
                                       FUN = max)
    combined.pval <- data.frame(cp = apply(
      X = markers.combined[, pval.codes, drop = FALSE],
      MARGIN = 1,
      FUN = function(x) {
        return(meta.method(x)$p)
      }
    ))
    meta.method.name <- as.character(x = formals()$meta.method)
    if (length(x = meta.method.name) == 3) {
      meta.method.name <- meta.method.name[3]
    }
    colnames(x = combined.pval) <-
      paste0(meta.method.name, "_p_val")
    markers.combined <- cbind(markers.combined, combined.pval)
    markers.combined <-
      markers.combined[order(markers.combined[, paste0(meta.method.name, "_p_val")]),]
  }
  lfcCol <-
    colnames(markers.combined)[grep(paste0(ident.1, "_avg"), colnames(markers.combined))]
  markers.combined <- markers.combined[, c(
    paste0(ident.1, "_p_val"),
    lfcCol,
    paste0(ident.1, "_pct.1"),
    paste0(ident.1, "_pct.2"),
    paste0("_p_val")
  )]
  colnames(markers.combined) <- gsub(
    pattern = paste0(ident.1, "_"),
    replacement = "",
    x = colnames(markers.combined)
  )
  colnames(markers.combined) <-
    c(colnames(markers.combined)[-length(colnames(markers.combined))], "p_val_adj")
  return(markers.combined)
}

#' Get variable feature names after running runSeuratFindHVG function
#'
#' @param inSCE Input \code{SingleCellExperiment} object.
#'
#' @return A list of variable feature names.
#' @export
getSeuratVariableFeatures <- function(inSCE) {
  obj <- S4Vectors::metadata(inSCE)$seurat$obj
  result <- NULL
  if (!is.null(obj)) {
    if(methods::is(obj, "list")) {
      result <- obj$RNA$var.features
    }
    if (methods::is(obj, "Seurat")) {
      result <- Seurat::VariableFeatures(obj)
    }
  }
  return(result)
}

# seurat functions
library(singleCellTK)
library(ggplot2)
context("Testing seurat functions")
data(scExample, package = "singleCellTK")

# allow some additional memory over default
options(future.globals.maxSize = 786432000)

test_that(desc = "Testing standard seurat workflow", {
  # Test Normalization Method
  sce <- runSeuratNormalizeData(sce)
  testthat::expect_true("seuratNormData" %in% assayNames(sce))
  
  # Test Scaling Method
  sce <- runSeuratScaleData(sce)
  testthat::expect_true("seuratScaledData" %in% expDataNames(sce))
  
  # Test Feature Selection Method
  sce <- runSeuratFindHVG(sce)
  testthat::expect_true("seurat_variableFeatures_vst_varianceStandardized"
                        %in% names(rowData(sce)))
  
  # Test PCA
  sce <- runSeuratPCA(sce, useAssay = "seuratScaledData")
  testthat::expect_true("seuratPCA" %in% reducedDimNames(sce))
  
  # Test ICA
  #sce <- runSeuratICA(sce, useAssay = "seuratScaledData")
  #testthat::expect_true("seuratICA" %in% reducedDimNames(sce))
  
  # Test JackStraw on PCA
  sce <- suppressWarnings({runSeuratJackStraw(sce, useAssay = "seuratScaledData")})
  jsPlot <- plotSeuratJackStraw(sce)
  testthat::expect_true(is.ggplot(jsPlot))
  
  # Test HVG Plot 
  hvgPlot <- plotSeuratHVG(sce, labelPoints = 10)
  testthat::expect_true(is.ggplot(hvgPlot))
  
  # Test PCA Component Plot
  pcaPlot <- plotSeuratReduction(sce, useReduction = "pca")
  testthat::expect_true(is.ggplot(pcaPlot))
  pcaPlot <- plotSeuratReduction(sce, useReduction = "pca", showLegend = TRUE)
  testthat::expect_true(is.ggplot(pcaPlot))
  
  # Test Clustering
  sce <- runSeuratFindClusters(sce, useAssay = "seuratScaledData")
  testthat::expect_true("Seurat_louvain_Resolution0.8" %in% names(colData(sce)))
  
  # Test TSNE
  sce <- runSeuratTSNE(sce, useReduction = "pca")
  testthat::expect_true("seuratTSNE" %in% reducedDimNames(sce))
  
  # Test UMAP
  sce <- suppressWarnings({runSeuratUMAP(sce, useReduction = "pca")})
  testthat::expect_true("seuratUMAP" %in% reducedDimNames(sce))
  
  # Test ElbowPlot on PCA
  elbowPlot <- plotSeuratElbow(sce)
  testthat::expect_true(is.ggplot(elbowPlot))
  
  # Test Heatmap on PCA
  heatmapPlot <- runSeuratHeatmap(sce, useAssay = "seuratScaledData", dims = 4, fast = FALSE)
  testthat::expect_true(is.ggplot(heatmapPlot))
  
  # Test SCTransform (requires removal of zero rowSums/colSums)
  zeroCols <- which(colSums(assay(sce, "counts")) == 0)
  sce2 <- sce[, -zeroCols]
  metadata(sce2)$seurat <- NULL
  sce2 <- runSeuratSCTransform(sce2)
  testthat::expect_true("SCTCounts" %in% c(altExpNames(sce2), assayNames(sce2)))

  # Test Batch-Correction
  sce <- suppressWarnings(runSeuratIntegration(sce, batch = "type", kAnchor = 10, kFilter = 4, kWeight = 5, ndims = 10))
  testthat::expect_true("SeuratIntegratedAssay" %in% altExpNames(sce))
  
  # Test Marker Selection - Conserved Between 2 Groups
  cells1 <- colnames(sce)[which(colData(sce)$type == "Singlet")]
  cells2 <- colnames(sce)[which(colData(sce)$type == "Doublet")]
  sce <- runSeuratFindMarkers(sce, cells1 = cells1, cells2 = cells2, group1 = "Singlet", group2 = "Doublet", conserved = TRUE)
  testthat::expect_true("seuratMarkers" %in% names(metadata(sce)))
  
  # Test Marker Selection - Standard Between All Groups
  testthat::expect_true(!is.null(metadata(sce)$seurat))
  sce <- runSeuratFindMarkers(sce, allGroup = "type")
  testthat::expect_true("seuratMarkers" %in% names(metadata(sce)))
  
  # Test Plots for Top Marker Genes
  top2Features <- metadata(sce)$seuratMarkers[1:2, ]$gene.id
  genePlot1 <- plotSeuratGenes(sce, plotType = "ridge", features = top2Features, groupVariable = "type", combine = TRUE)
  genePlot2 <- plotSeuratGenes(sce, plotType = "violin", features = top2Features, groupVariable = "type", combine = TRUE)
  genePlot3 <- plotSeuratGenes(sce, plotType = "heatmap", features = top2Features, groupVariable = "type")
  genePlot4 <- plotSeuratGenes(sce, plotType = "feature", features = top2Features, groupVariable = "type", combine = TRUE)
  genePlot5 <- plotSeuratGenes(sce, plotType = "dot", features = top2Features, groupVariable = "Seurat_louvain_Resolution0.8")
  testthat::expect_true(is.ggplot(genePlot1))
  testthat::expect_true(is.ggplot(genePlot2))
  testthat::expect_true(is.ggplot(genePlot3))
  testthat::expect_true(is.ggplot(genePlot4))
  testthat::expect_true(is.ggplot(genePlot5))
})

# computeHeatmap.R
library(singleCellTK)
library(ggplot2)
context("Testing computeHeatmap.R")
data(scExample, package = "singleCellTK")

test_that(desc = "Testing computeHeatmap.R", {
  sce <- runSeuratNormalizeData(sce)
  sce <- runSeuratScaleData(sce)
  sce <- runSeuratFindHVG(sce)
  sce <- runSeuratPCA(sce)
  heatmap_gTree_objects <- computeHeatmap(sce, useAssay = "seuratNormData", dims = 10)
  heatmapPlot <- singleCellTK:::.plotHeatmapMulti(heatmap_gTree_objects)
  
  testthat::expect_equal(length(heatmap_gTree_objects), 10)
  testthat::expect_true(is.ggplot(heatmapPlot))
})

app <- ShinyDriver$new("../../", seed = 20)
app$snapshotInit("seuratUI")

app$setInputs(uploadChoice = "example")
app$setInputs(selectExampleData = "fluidigm_pollen")
app$setInputs(addExampleImport = "click")
app$setInputs(uploadData = "click")
Sys.sleep(1)
app$snapshot(items = list(output = ""), screenshot = TRUE)
app$setInputs(navbar = "Seurat")
app$setInputs(normalize_button = "click")
app$setInputs(scale_button = "click")
app$setInputs(activePanelSelectSeurat = "Highly Variable Genes")
app$setInputs(hvg_method = "dispersion")
app$setInputs(find_hvg_button = "click")
Sys.sleep(1)
app$snapshot(items = list(output = ""), screenshot = TRUE)
app$setInputs(hvg_method = "mean.var.plot")
app$setInputs(find_hvg_button = "click")
Sys.sleep(1)
app$snapshot(items = list(output = ""), screenshot = TRUE)
app$setInputs(hvg_method = "vst")
app$setInputs(find_hvg_button = "click")
Sys.sleep(1)
app$snapshot(items = list(output = ""), screenshot = TRUE)
app$setInputs(activePanelSelectSeurat = "Dimensionality Reduction")
app$setInputs(pca_compute_jackstraw = TRUE)
app$setInputs(pca_no_components = character(0))
app$setInputs(pca_no_components = 2)
app$setInputs(pca_no_components = 20)
app$setInputs(run_pca_button = "click")
app$setInputs(seuratPCAPlotTabset = "PCA Plot")
app$setInputs(picker_dimheatmap_components_pca = character(0))
app$setInputs(plot_heatmap_pca_button = "click")
app$setInputs(slider_dimheatmap_pca = 2)
Sys.sleep(1)
app$snapshot(items = list(output = ""), screenshot = TRUE)
app$setInputs(seuratPCAPlotTabset = "Elbow Plot")
Sys.sleep(1)
app$snapshot(items = list(output = ""), screenshot = TRUE)
app$setInputs(seuratPCAPlotTabset = "JackStraw Plot")
Sys.sleep(1)
app$snapshot(items = list(output = ""), screenshot = TRUE)
app$setInputs(seuratPCAPlotTabset = "Heatmap Plot")
Sys.sleep(1)
app$snapshot(items = list(output = ""), screenshot = TRUE)
app$setInputs(activePanelSelectSeurat = "tSNE/UMAP")
app$setInputs(run_tsne_button = "click")
Sys.sleep(1)
app$snapshot(items = list(output = ""), screenshot = TRUE)
app$setInputs(tsneUmapTabsetSeurat = "UMAP")
app$setInputs(run_umap_button = "click")
Sys.sleep(1)
app$snapshot(items = list(output = ""), screenshot = TRUE)
app$setInputs(activePanelSelectSeurat = "Clustering")
app$setInputs(find_clusters_button = "click")
app$setInputs(seuratClusteringPlotTabset = "PCA Plot")
Sys.sleep(1)
app$snapshot(items = list(output = ""), screenshot = TRUE)
app$setInputs(seuratClusteringPlotTabset = "tSNE Plot")
Sys.sleep(1)
app$snapshot(items = list(output = ""), screenshot = TRUE)
app$setInputs(seuratClusteringPlotTabset = "UMAP Plot")
Sys.sleep(1)
app$snapshot(items = list(output = ""), screenshot = TRUE)
app$setInputs(activePanelSelectSeurat = "Find Markers")
app$setInputs(seuratFindMarkerSelectPhenotype = "Biological_Condition")
app$setInputs(seuratFindMarkerRun = "click")
app$setInputs(activePanelSelectSeurat = "Heatmap Plot")
Sys.sleep(1)
app$snapshot(items = list(output = ""), screenshot = TRUE)

shinyPanelFS_DimRed <- fluidPage(
  tags$script("Shiny.addCustomMessageHandler('close_dropDownDimRedEmbedding', function(x){
                  $('html').click();
                });"),
  tags$script("Shiny.addCustomMessageHandler('close_dropDownFS', function(x){
                  $('html').click();
                });"),
  h1("Feature Selection & Dimensionality Reduction"),
  tabsetPanel(
    id = "FSDimRedTabsetPanel",
    tabPanel(
      "Feature Selection",
      fluidRow(column(
        4,
        panel(
          heading = "1. Compute variability metric",
          h5(tags$a(
            href = paste0(docs.artPath, "cnsl_feature_selection.html"),
            "(help)",
            target = "_blank"
          )),
          selectInput(
            inputId = "hvgMethodFS",
            label = "Select method for calculating variability of features:",
            choices = c(
              "Seurat - vst" = "vst",
              "Seurat - mean.var.plot" = "mean.var.plot",
              "Seurat - dispersion" = "dispersion",
              "Scran - modelGeneVar" = "modelGeneVar",
              "Scanpy - cellranger" = "cell_ranger"
            )
          ),
          selectizeInput(
            inputId = "assaySelectFS_Norm", 
            label = "Select input matrix:", 
            choices = NULL, 
            selected = NULL, 
            multiple = FALSE,
            options = NULL),
          actionButton("findHvgButtonFS","Run")
        ),
        panel(
          heading = "2. Select number of variable features",
          selectInput("hvgMetricSelect", "Select variability metric:",
                      choices = NULL),
          numericInput(
            "hvgNumberSelect", "Select the number of highly variable features:",
            value = 2000, step = 100, min = 0),
          textInput(
            inputId = "hvgSubsetName",
            label = "Name of the feature subset:",
            value = NULL
          ),
          actionButton("hvgSubsetRun", "Run")
        )
      ),
      column(
        8,
        panel(
          heading = "Plot",
          fluidRow(
            column(4, dropdown(
              fluidRow(
                column(12,
                       fluidRow(actionBttn(inputId = "closeDropDownFS", 
                                           label = NULL, style = "simple", 
                                           color = "danger", 
                                           icon = icon("times"), size = "xs"), 
                                align = "right"),
                       
                       selectInput(
                         inputId = "hvgPlotMethod",
                         label = "Select variability metric (created in step 1): ",
                         choices = NULL
                       ),
                       selectInput(
                         inputId = "hvgPlotSubsetSelect",
                         label = "Select feature subset (created in step 2): ",
                         choices = "None"
                       ),
                       numericInput(
                         inputId = "hvgPlotNLabel",
                         label = "Number of features to label:",
                         value = 20, min = 0, step = 10
                       ),
                       selectInput(
                         inputId = "hvgPlotFeatureDisplay",
                         label = "Choose feature label:",
                         choices = c("Rownames (Default)",
                                     featureChoice)
                       ),
                       actionBttn(
                         inputId = "updatePlotFS",
                         label = "Update",
                         style = "bordered",
                         color = "primary",
                         size = "sm"
                       )
                )
              ),
              inputId = "dropDownFS",
              icon = icon("cog"),
              status = "primary",
              circle = FALSE,
              inline = TRUE
            )),
            column(7, fluidRow(h6("Scatterplot showing the variability of each feature versus its average expression across all cells"), align="center"))
          ),
          hr(),
          br(),
          shinyjqui::jqui_resizable(plotOutput(outputId = "plotFS")),
          fluidRow(h6("highlighted features"), align="center"),
          div(
            style = "margin-top: 2px;",
            verbatimTextOutput(outputId = "hvgOutputFS",
                               placeholder = TRUE)
          )
        )
      )),
      nonLinearWorkflowUI(id = "nlw-fs")
    ),
    tabPanel(
      "Dimensionality Reduction",
      h5(tags$a(
        href = paste0(docs.artPath, "cnsl_dimensionality_reduction.html"),
        "(help)",
        target = "_blank"
      )),
      fluidRow(column(4,
                      fluidRow(column(
                        12,
                        panel(
                          heading = "Options",
                          selectizeInput(
                            inputId = "dimRedAssaySelect", 
                            label = "Select input matrix:", 
                            choices = NULL, 
                            selected = NULL, 
                            multiple = FALSE,
                            options = NULL),
                          selectInput(
                            "dimRedPlotMethod",
                            "Select method:",
                            c(
                              "Scater - PCA" = "scaterPCA",
                              "Seurat - PCA" = "seuratPCA",
                              "Seurat - ICA" = "seuratICA",
                              "Scanpy - PCA" = "scanpyPCA"
                            )
                          ),
                          conditionalPanel(
                            condition = "input.dimRedPlotMethod != 'scanpyPCA'",
                            selectInput(
                              inputId = "dimRedHVGSelect",
                              label = "Select HVG list:",
                              choices = "None"
                            ),
                            checkboxInput(
                              inputId = "dimRedScale",
                              label = "Scale",
                              value = TRUE
                            )
                          ),
                          uiOutput("dimRedNameUI"),
                          numericInput(
                            inputId = "dimRedNumberDims",
                            label = "Number of dimensions:",
                            value = 50,
                            step = 1,
                            min = 2
                          ),
                          conditionalPanel(
                            condition = "input.dimRedPlotMethod != 'seuratICA'",
                            materialSwitch(
                              inputId = "computeElbowPlot",
                              label = "Compute ElbowPlot?",
                              value = TRUE
                            ),
                            materialSwitch(
                              inputId = "computeJackstrawPlot",
                              label = "Compute JackstrawPlot?",
                              value = FALSE
                            )
                          ),
                          materialSwitch(
                            inputId = "computeHeatmapPlot",
                            label = "Compute HeatmapPlot?",
                            value = TRUE
                          ),
                          conditionalPanel(
                            condition = "input.computeHeatmapPlot == true",
                            numericInput(
                              inputId = "dimRedNFeaturesHeatmap",
                              label = "Select number of features for heatmap plot:",
                              value = 20,
                              min = 2,
                              step = 1
                            )
                          ),
                          numericInput(inputId = "seed_dimRed",
                                       label = "Seed value for reproducibility of result:",
                                       value = 12345,
                                       step = 1),
                          actionButton("runDimred", "Run")
                        )
                      ))),
               column(8,
                      fluidRow(column(
                        12,
                        hidden(
                          tags$div(
                            class = "dimRedPCAICA_plotTabset_class",
                            tabsetPanel(id = "dimRedPCAICA_plotTabset",
                                        type = "tabs")
                          )
                        )
                      )))),
      nonLinearWorkflowUI(id = "nlw-dr")
    ),
    
    tabPanel(title = "Embedding",
             h5(
               tags$a(
                 href = paste0(docs.artPath, "cnsl_2d_embedding.html"),
                 "(help)",
                 target = "_blank"
               )
             ),
             fluidRow(
               column(4,
                      fluidRow(column(
                        12,
                        panel(
                          heading = "Options",
                          selectizeInput(
                            inputId = "dimRedAssaySelect_tsneUmap", 
                            label = "Select input matrix:", 
                            choices = NULL, 
                            selected = NULL, 
                            multiple = FALSE,
                            options = NULL),
                          selectInput("dimRedPlotMethod_tsneUmap", "Select method:",
                                      c("scaterUMAP" = "scaterUMAP",
                                        "rtSNE" = "rTSNE",
                                        "seuratUMAP" = "seuratUMAP",
                                        "seuratTSNE" = "seuratTSNE",
                                        "scanpyTSNE" = "scanpyTSNE",
                                        "scanpyUMAP" = "scanpyUMAP")),
                          uiOutput("dimRedNameUI_tsneUmap"),
                          conditionalPanel(
                            condition = "input.dimRedPlotMethod_tsneUmap == 'scaterUMAP' ||
                                         input.dimRedPlotMethod_tsneUmap == 'rTSNE'",
                            checkboxInput("logNorm_tsneUmap", 
                                          " Log Normalize the data",
                                          FALSE),
                            selectInput("hvg_tsneUmap", "Use HVG list", 
                                        choices = "None"),
                            checkboxInput("scale_tsneUmap", "Scale assay data", 
                                          TRUE),
                            checkboxInput("pca_tsneUmap", 
                                          "Run PCA on assay data", 
                                          TRUE),
                          ),
                          numericInput(
                            inputId = "dimRedNumberDims_tsneUmap",
                            label = "Number of dimensions to use:",
                            value = 10),
                          conditionalPanel(
                            condition = "input.dimRedPlotMethod_tsneUmap == 'scaterUMAP'",
                            numericInput("iterUMAP", "# of iterations", 
                                         min = 50, max = 500, value = 200),
                            numericInput("neighborsUMAP", "# of nearest neighbors",
                                         min = 2, max = 100, value = 30),
                            numericInput("mindistUMAP",
                                         "minimum distance between points",
                                         min = 0.001, max = 0.1, value = 0.01),
                            numericInput("alphaUMAP", "learning rate(alpha)",
                                         value = 1),
                            numericInput("spreadUMAP", "spread", min = 0.001, 
                                         value = 1)
                          ),
                          conditionalPanel(
                            condition = "input.dimRedPlotMethod_tsneUmap == 'rTSNE'",
                            numericInput("iterTSNE", "No. of iterations:", 
                                         min = 100, max = 2000, value = 1000),
                            numericInput("thetaTSNE", "Set theta value:", 0.5, 
                                         min = 0, step = 0.1),
                            numericInput("perplexityTSNE", "Set perplexity:",
                                         min = 5, max = 50, value = 30)
                          ),
                          conditionalPanel(
                            condition = "input.dimRedPlotMethod_tsneUmap == 'seuratTSNE'
                                           || input.dimRedPlotMethod_tsneUmap == 'seuratUMAP'",
                            selectInput(inputId = "reductionMethodUMAPTSNEDimRed",
                                        label = "Select reduction method: ",
                                        choices = c("pca", "ica")),
                          ),
                          conditionalPanel(
                            condition = "input.dimRedPlotMethod_tsneUmap == 'seuratTSNE'",
                            numericInput(inputId = "perplexityTSNEDimRed",
                                         label = "Set perplexity:",
                                         value = 30)
                          ),
                          conditionalPanel(
                            condition = "input.dimRedPlotMethod_tsneUmap == 'seuratUMAP'",
                            numericInput(inputId = "minDistUMAPDimRed",
                                         label = "Set min.dist:",
                                         value = 0.3),
                            numericInput(inputId = "nNeighboursUMAPDimRed",
                                         label = "Set n.neighbors:",
                                         value = 30,
                                         step = 1),
                            numericInput(inputId = "spreadUMAPDimRed",
                                         label = "Set spread:",
                                         value = 1),
                          ),
                          numericInput(inputId = "seed__tsneUmap",
                                       label = "Seed value for reproducibility of result:",
                                       value = 12345,
                                       step = 1),
                          actionButton("runDimred_tsneUmap", "Run")
                        )
                      ))),
               column(
                 8,
                 fluidRow(
                   column(
                     12,
                     tags$div(
                       class = "dimRedTSNEUMAP_plotTabset_class",
                       tabPanel(
                         title = "Plot",
                         panel(
                           heading = "Plot",
                           fluidRow(
                             column(
                               4, 
                               dropdown(
                                 fluidRow(
                                   column(
                                     12,
                                     fluidRow(
                                       actionBttn(
                                         inputId = "closeDropDownDimRedEmbedding", 
                                         label = NULL, style = "simple", 
                                         color = "danger", icon = icon("times"), 
                                         size = "xs"), align = "right"
                                     ),
                                     selectizeInput(
                                       inputId = "selectRedDimPlot_tsneUmap",
                                       label = "Select reducedDim:",
                                       choices = currreddim
                                     ),
                                     actionBttn(
                                       inputId = "updateRedDimPlot_tsneUmap",
                                       label = "Update",
                                       style = "bordered",
                                       color = "primary",
                                       size = "sm"
                                     )
                                   )
                                 ),
                                 inputId = "dropDownDimRedEmbedding",
                                 icon = icon("cog"),
                                 status = "primary",
                                 circle = FALSE,
                                 inline = TRUE
                               )),
                             column(
                               7, 
                               fluidRow(h6("Scatterplot of cells on a 2D embedding"), 
                                        align="center"))
                           ),
                           hr(),
                           br(),
                           plotlyOutput(outputId = "plotDimRed_tsneUmap"))
                       ))
                   )))
             ))
  )
)

#' Computes heatmap for a set of features against dimensionality reduction 
#' components
#' @description 
#' The computeHeatmap method computes the heatmap visualization for a set
#'  of features against a set of dimensionality reduction components. This
#'  method uses the heatmap computation algorithm code from \code{Seurat} but
#'  plots the heatmap using \code{ComplexHeatmap} and \code{cowplot} libraries.
#' @param inSCE Input \code{SingleCellExperiment} object.
#' @param useAssay Specify the name of the assay that will be scaled
#'  by this function for the features that are used in the heatmap.
#' @param dims Specify the number of dimensions to use for heatmap. Default
#' \code{10}.
#' @param nfeatures Specify the number of features to use for heatmap. Default
#' is \code{30}.
#' @param cells Specify the samples/cells to use for heatmap computation.
#' Default is \code{NULL} which will utilize all samples in the assay.
#' @param reduction Specify the reduction slot in the input object. Default
#' is \code{"pca"}.
#' @param disp.min Specify the minimum dispersion value to use for floor
#' clipping of assay values. Default is \code{-2.5}.
#' @param disp.max Specify the maximum dispersion value to use for ceiling
#' clipping of assay values. Default is \code{2.5}.
#' @param balanced Specify if the number of of up-regulated and down-regulated
#' features should be balanced. Default is \code{TRUE}.
#' @param nCol Specify the number of columns in the output plot. Default
#' is \code{NULL} which will auto-compute the number of columns.
#' @param externalReduction Specify an external reduction if not present in
#' the input object. This external reduction should be created
#' using \code{CreateDimReducObject} function.
#' @return Heatmap plot object.
#' @export
computeHeatmap <- function(inSCE,
                           useAssay,
                           dims = 10,
                           nfeatures = 30,
                           cells = NULL,
                           reduction = 'pca',
                           disp.min = -2.5,
                           disp.max = 2.5,
                           balanced = TRUE,
                           nCol = NULL,
                           externalReduction = NULL) {
  object <- convertSCEToSeurat(inSCE, normAssay = useAssay)

  slot <- "scale.data"
  assays <- NULL
  ncol <- NULL
  projected <- FALSE
  dims <- seq(dims)

  if (!is.null(externalReduction)) {
    if (reduction == "pca") {
      object@reductions <- list(pca = externalReduction)
    }
    else{
      object@reductions <- list(ica = externalReduction)
    }
  }

  if (length(x = dims) > 2) {
    ncol <- 3
  }
  else{
    ncol <- length(x = dims)
  }
  #ncol <- ncol %||% ifelse(test = length(x = dims) > 2, yes = 3,
  #no = length(x = dims))

  #empty list = number of dims
  plots <- vector(mode = 'list', length = length(x = dims))

  #set rna
  assays <- Seurat::DefaultAssay(object = object)
  # assays <- assays %||% Seurat::DefaultAssay(object = object)

  #set disp.max
  # disp.max <- disp.max %||% ifelse(
  #   test = slot == 'scale.data',
  #   yes = 2.5,
  #   no = 6
  # )

  #no. of cells
  cells <- ncol(x = object)
  # cells <- cells %||% ncol(x = object)

  #for each dim get top cells
  cells <- lapply(
    X = dims,
    FUN = function(x) {
      cells <- Seurat::TopCells(
        object = object[[reduction]],
        dim = x,
        ncells = cells,
        balanced = balanced
      )
      if (balanced) {
        cells$negative <- rev(x = cells$negative)
      }
      cells <- unlist(x = unname(obj = cells))
      return(cells)
    }
  )

  #get top features against each dim
  features <- lapply(
    X = dims,
    FUN = Seurat::TopFeatures,
    object = object[[reduction]],
    nfeatures = nfeatures,
    balanced = balanced,
    projected = projected
  )

  #unlist all features in one vector
  features.all <- unique(x = unlist(x = features))


  #assays == 1
  features.keyed <- features.all

  #set default assay
  Seurat::DefaultAssay(object = object) <- assays

  #convert (_) to (-) as required by FetchData function below
  cells <- .convertToHyphen(cells)

  features.keyed <- .convertToHyphen(features.keyed)

  for (i in seq_len(length(dims))) {
    features[[i]] <- .convertToHyphen(features[[i]])
  }

  ## temp fix
  # make sure the cell names are consistent
  # UPDATE THIS IN .convertSCEToSeurat function eventually
  rownames(object@reductions$pca@cell.embeddings) <- 
    unlist(.convertToHyphen(rownames(object@reductions$pca@cell.embeddings)))
  ## 
  
  object <- Seurat::ScaleData(object, features = features.all)

  # get assay data with only selected features (all dims) and
  # selected cells (all)

  data.all <- Seurat::FetchData(
    object = object,
    vars = unique(x = unlist(x = features.keyed)),
    cells = unique(x = unlist(x = cells)),
    slot = slot
  )

  #clip off values for heatmap
  data.all <-
    Seurat::MinMax(data = data.all, min = disp.min, max = disp.max)
  data.limits <- c(min(data.all), max(data.all))

  #draw heatmap for each dim
  for (i in seq_along(dims)) {
    dim.features <- c(features[[i]][[2]], rev(x = features[[i]][[1]]))
    dim.features <- rev(x = unlist(x = lapply(
      X = dim.features,
      FUN = function(feat) {
        return(grep(
          pattern = paste0(feat, '$'),
          x = features.keyed,
          value = TRUE
        ))
      }
    )))
    dim.cells <- cells[[i]]
    data.plot <- data.all[dim.cells, dim.features]
    hm <- suppressMessages(
      ComplexHeatmap::Heatmap(
        t(data.plot),
        show_row_dend = FALSE,
        show_column_dend = FALSE,
        cluster_rows = FALSE,
        cluster_columns = FALSE,
        show_column_names = FALSE,
        row_names_side = "left",
        show_heatmap_legend = FALSE
      )
    )

    plots[[i]] <-
      grid::grid.grabExpr(suppressMessages(ComplexHeatmap::draw(hm)))
  }

  return(plots)
}

#'
#'

colourGroupInput <- function(inputId) {
  ns <- NS(inputId)
  tagList(
    strong(textOutput(ns("heading"))),
    uiOutput(ns("colorChoosers"))
  )
}

#'
#'

colourGroup <- function(input, output, session, heading = "", options="",
                        labels = "", value = "", ...){
  ns <- session$ns
  ids <- reactive(sapply(options, function(option) make.names(paste(option, "inputId", sep = "_"), unique = TRUE)))

  cols <- reactive({
    if (length(options) != 0){
      sapply(seq_along(options), function(i) {
        if (!is.null(input[[as.character(ids()[i])]])){
          setNames(input[[as.character(ids()[i])]], options[i])
        }
      })
    }
  })

  if (length(cols) == 0){
    cols2 <- NULL
  } else {
    cols2 <- debounce(cols, 2000)
  }

  output$heading <- renderText({
    heading
  })

  output$colorChoosers <- renderUI({
    if (length(options) != 0){
      L <- vector("list", length(options))
      for (i in seq_along(L)){
        if (is.null(input[[as.character(ids()[i])]])) {
          color <- palette()[(i %% length(palette())) + 1]
        } else {
          color <- input[[as.character(ids()[i])]]
        }
        L[[i]] <- list(do.call(colourpicker::colourInput,
                               list(ns(ids()[i]), label = options[i],
                                    value = color, ...)))
      }
      return(L)
    }
  })
  return(cols2)
}

#' Find the marker gene set for each cluster
#' @rdname runFindMarker
#' @description With an input SingleCellExperiment object and specifying the
#' clustering labels, this function iteratively call the differential expression
#' analysis on each cluster against all the others. \code{\link{runFindMarker}}
#' will be deprecated in the future.
#' @param inSCE \linkS4class{SingleCellExperiment} inherited object.
#' @param useAssay character. A string specifying which assay to use for the
#' MAST calculations. Default \code{"logcounts"}.
#' @param useReducedDim character. A string specifying which reducedDim to use
#' for MAST calculations. Set \code{useAssay} to \code{NULL} when using.
#' Required.
#' @param method A single character for specific differential expression
#' analysis method. Choose from \code{'wilcox'}, \code{'MAST'}, \code{'DESeq2'},
#' \code{'Limma'}, and \code{'ANOVA'}. Default \code{"wilcox"}.
#' @param cluster One single character to specify a column in
#' \code{colData(inSCE)} for the clustering label. Alternatively, a vector or
#' a factor is also acceptable. Default \code{"cluster"}.
#' @param covariates A character vector of additional covariates to use when
#' building the model. All covariates must exist in
#' \code{names(colData(inSCE))}. Not applicable when \code{method} is
#' \code{"MAST"} method. Default \code{NULL}.
#' @param log2fcThreshold Only out put DEGs with the absolute values of log2FC
#' larger than this value. Default \code{NULL}
#' @param fdrThreshold Only out put DEGs with FDR value smaller than this
#' value. Default \code{NULL}
#' @param minClustExprPerc A numeric scalar. The minimum cutoff of the
#' percentage of cells in the cluster of interests that expressed the marker
#' gene. From 0 to 1. Default \code{NULL}.
#' @param maxCtrlExprPerc A numeric scalar. The maximum cutoff of the
#' percentage of cells out of the cluster (control group) that expressed the
#' marker gene. From 0 to 1. Default \code{NULL}.
#' @param minMeanExpr A numeric scalar. The minimum cutoff of the mean
#' expression value of the marker in the cluster of interests. Default
#' \code{NULL}.
#' @param detectThresh A numeric scalar, above which a matrix value will be
#' treated as expressed when calculating cluster/control expression percentage.
#' Default \code{0}.
#' @details
#' The returned marker table, in the \code{metadata} slot, consists of 8
#' columns: \code{"Gene"}, \code{"Log2_FC"}, \code{"Pvalue"}, \code{"FDR"},
#' \code{cluster}, \code{"clusterExprPerc"}, \code{"ControlExprPerc"} and
#' \code{"clusterAveExpr"}.
#'
#' \code{"clusterExprPerc"} is the fraction of cells,
#' that has marker value (e.g. gene expression counts) larger than
#' \code{detectThresh}, in the cell population of the cluster. As for each
#' cluster, we set all cells out of this cluster as control. Similarly,
#' \code{"ControlExprPerc"} is the fraction of cells with marker value larger
#' than \code{detectThresh} in the control cell group.
#' @return The input \linkS4class{SingleCellExperiment} object with
#' \code{metadata(inSCE)$findMarker} updated with a data.table of the up-
#' regulated DEGs for each cluster.
#' @seealso \code{\link{runDEAnalysis}}, \code{\link{getFindMarkerTopTable}},
#' \code{\link{plotFindMarkerHeatmap}}
#' @export
#' @examples
#' data("mouseBrainSubsetSCE", package = "singleCellTK")
#' mouseBrainSubsetSCE <- runFindMarker(mouseBrainSubsetSCE,
#'                                      useAssay = "logcounts",
#'                                      cluster = "level1class")
runFindMarker <- function(inSCE, useAssay = 'logcounts',
                          useReducedDim = NULL,
                          method = 'wilcox',
                          cluster = 'cluster', covariates = NULL,
                          log2fcThreshold = NULL, fdrThreshold = 0.05,
                          minClustExprPerc = NULL, maxCtrlExprPerc = NULL,
                          minMeanExpr = NULL, detectThresh = 0){
  method <- match.arg(method, choices = c('wilcox', 'MAST', "DESeq2", "Limma",
                                         "ANOVA"))
  # Input checks will be done in `runDEAnalysis()`
  clusterVar <- .manageCellVar(inSCE, var = cluster)
  if (is.character(cluster) && length(cluster) == 1) clusterName <- cluster
  else {
    clusterName <- 'findMarker_cluster'
    inSCE[[clusterName]] <- cluster
  }
  # Iterate
  if (is.factor(clusterVar)) {
    # In case inSCE is a subset, when "levels" is a full list of all
    # clusters, want to keep the ordering stored in the factor.
    uniqClust <- as.vector(unique(clusterVar))
    levelOrder <- levels(clusterVar)
    uniqClust <- levelOrder[levelOrder %in% uniqClust]
  } else {
    uniqClust <- unique(clusterVar)
  }
  for (c in uniqClust) {
    message(date(), " ... Identifying markers for cluster '", c,
            "', using DE method '", method, "'")
    clusterIndex <- clusterVar == c
    inSCE <- runDEAnalysis(method = method, inSCE = inSCE,
                           useAssay = useAssay,
                           useReducedDim = useReducedDim,
                           index1 = clusterIndex,
                           class = NULL,
                           classGroup1 = NULL,
                           classGroup2 = NULL,
                           analysisName = paste0('findMarker', c),
                           onlyPos = TRUE,
                           log2fcThreshold = log2fcThreshold,
                           fdrThreshold = fdrThreshold,
                           covariates = covariates,
                           groupName1 = c, groupName2 = 'others',
                           verbose = FALSE)
  }
  message(date(), " ... Organizing findMarker result")
  degFull <- NULL
  for (c in uniqClust) {
    degTable <-
      S4Vectors::metadata(inSCE)$diffExp[[paste0('findMarker', c)]]$result
    degTable <- degTable[,c(-5,-6,-7,-8)]
    degTable$Gene <- as.character(degTable$Gene)
    if (nrow(degTable) > 0) {
      degTable[[clusterName]] <- c
      if (is.null(degFull)) {
        degFull <- degTable
      } else {
        degFull <- rbind(degFull, degTable)
      }
    }
  }
  S4Vectors::metadata(inSCE)$diffExp[paste0('findMarker', uniqClust)] <- NULL
  if (length(names(S4Vectors::metadata(inSCE)$diffExp)) == 0) {
    S4Vectors::metadata(inSCE)$diffExp <- NULL
  }
  degFull <- degFull[stats::complete.cases(degFull),]
  if (!is.null(useAssay)) {
    attr(degFull, "useAssay") <- useAssay
  } else {
    attr(degFull, "useReducedDim") <- useReducedDim
  }

  degFull <- .calcMarkerExpr(degFull, inSCE, clusterName, clusterVar,
                             detectThresh)
  if (!is.null(minClustExprPerc)) {
    degFull <- degFull[degFull$clusterExprPerc > minClustExprPerc,]
  }
  if (!is.null(maxCtrlExprPerc)) {
    degFull <- degFull[degFull$ControlExprPerc < maxCtrlExprPerc,]
  }
  if (!is.null(minMeanExpr)) {
    degFull <- degFull[degFull$clusterAveExpr > minMeanExpr,]
  }
  attr(degFull, "method") <- method
  attr(degFull, "cluster") <- clusterVar
  attr(degFull, "clusterName") <- clusterName
  attr(degFull, "params") <- list(log2fcThreshold = log2fcThreshold,
                                  fdrThreshold = fdrThreshold,
                                  minClustExprPerc = minClustExprPerc,
                                  maxCtrlExprPerc = maxCtrlExprPerc,
                                  minMeanExpr = minMeanExpr)
  S4Vectors::metadata(inSCE)$findMarker <- degFull
  return(inSCE)
}

#' @rdname runFindMarker
#' @export
findMarkerDiffExp <- function(inSCE, useAssay = 'logcounts',
                              useReducedDim = NULL,
                              method = c('wilcox', 'MAST', "DESeq2", "Limma",
                                         "ANOVA"),
                              cluster = 'cluster', covariates = NULL,
                              log2fcThreshold = NULL, fdrThreshold = 0.05,
                              minClustExprPerc = NULL, maxCtrlExprPerc = NULL,
                              minMeanExpr = NULL, detectThresh = 0) {
  .Deprecated("runFindMarker")
  runFindMarker(inSCE = inSCE, useAssay = useAssay,
                useReducedDim = useReducedDim,
                method = method, cluster = cluster, covariates = covariates,
                log2fcThreshold = log2fcThreshold, fdrThreshold = fdrThreshold,
                minClustExprPerc = minClustExprPerc,
                maxCtrlExprPerc = maxCtrlExprPerc,
                minMeanExpr = minMeanExpr, detectThresh = detectThresh)
}

.calcMarkerExpr <- function(markerTable, inSCE, clusterName, clusterVar,
                            detectThresh) {
  #markerTable <- markerTable[markerTable$Gene %in% rownames(inSCE),]
  genes <- markerTable$Gene
  uniqClust <- unique(markerTable[[clusterName]])
  useAssay <- attr(markerTable, "useAssay" )
  useReducedDim <- attr(markerTable, "useReducedDim")

  cells.in.col <- rep(NA, length(genes))
  cells.out.col <- rep(NA, length(genes))
  exprs.avg <- rep(NA, length(genes))
  for (i in uniqClust) {
    markers <- genes[markerTable[[clusterName]] == i]
    cells.ix <- clusterVar == i
    if (!is.null(useReducedDim)) {
      assay.in <-
        t(expData(inSCE, useReducedDim))[markers, cells.ix, drop = FALSE]
      assay.out <-
        t(expData(inSCE, useReducedDim))[markers, !cells.ix, drop = FALSE]

    } else {
      assay.in <- expData(inSCE, useAssay)[markers, cells.ix, drop = FALSE]
      assay.out <- expData(inSCE, useAssay)[markers, !cells.ix, drop = FALSE]

    }
    assay.in.expr.perc <- rowSums(assay.in > detectThresh) / ncol(assay.in)
    cells.in.col[markerTable[[clusterName]] == i] <- assay.in.expr.perc
    assay.out.expr.perc <- rowSums(assay.out > detectThresh) / ncol(assay.out)
    cells.out.col[markerTable[[clusterName]] == i] <- assay.out.expr.perc
    assay.in.mean <- rowMeans(assay.in)
    exprs.avg[markerTable[[clusterName]] == i] <- assay.in.mean
  }
  markerTable$clusterExprPerc <- cells.in.col
  markerTable$ControlExprPerc <- cells.out.col
  markerTable$clusterAveExpr <- exprs.avg
  return(markerTable)
}


#' Fetch the table of top markers that pass the filtering
#' @rdname getFindMarkerTopTable
#' @details Users have to run \code{\link{runFindMarker}} prior to using this
#' function to extract a top marker table.
#' @param inSCE \linkS4class{SingleCellExperiment} inherited object.
#' @param log2fcThreshold Only use DEGs with the absolute values of log2FC
#' larger than this value. Default \code{1}
#' @param fdrThreshold Only use DEGs with FDR value smaller than this value.
#' Default \code{0.05}
#' @param minClustExprPerc A numeric scalar. The minimum cutoff of the
#' percentage of cells in the cluster of interests that expressed the marker
#' gene. Default \code{0.7}.
#' @param maxCtrlExprPerc A numeric scalar. The maximum cutoff of the
#' percentage of cells out of the cluster (control group) that expressed the
#' marker gene. Default \code{0.4}.
#' @param minMeanExpr A numeric scalar. The minimum cutoff of the mean
#' expression value of the marker in the cluster of interests. Default \code{1}.
#' @param topN An integer. Only to fetch this number of top markers for each
#' cluster in maximum, in terms of log2FC value. Use \code{NULL} to cancel the
#' top N subscription. Default \code{10}.
#' @return An organized \code{data.frame} object, with the top marker gene
#' information.
#' @seealso \code{\link{runFindMarker}}, \code{\link{plotFindMarkerHeatmap}}
#' @export
#' @examples
#' data("mouseBrainSubsetSCE", package = "singleCellTK")
#' mouseBrainSubsetSCE <- runFindMarker(mouseBrainSubsetSCE,
#'                                      useAssay = "logcounts",
#'                                      cluster = "level1class")
#' getFindMarkerTopTable(mouseBrainSubsetSCE)
getFindMarkerTopTable <- function(inSCE, log2fcThreshold = 0,
                                  fdrThreshold = 0.05, minClustExprPerc = 0.5,
                                  maxCtrlExprPerc = 0.5, minMeanExpr = 0,
                                  topN = 1) {
  if (!inherits(inSCE, 'SingleCellExperiment')) {
    stop('"inSCE" should be a SingleCellExperiment inherited Object.')
  }
  if (!'findMarker' %in% names(S4Vectors::metadata(inSCE))) {
    stop('"findMarker" result not found in metadata. ',
         'Run runFindMarker() in advance')
  }

  # Extract and basic filter
  degFull <- S4Vectors::metadata(inSCE)$findMarker
  if (!all(c("Gene", "Pvalue", "Log2_FC", "FDR") %in%
          colnames(degFull)[seq_len(4)])) {
    stop('"findMarker" result cannot be interpreted properly')
  }
  degFull$Gene <- as.character(degFull$Gene)
  if (length(which(!degFull$Gene %in% rownames(inSCE))) > 0) {
    # Remove genes happen in deg table but not in sce. Weird.
    degFull <- degFull[-which(!degFull$Gene %in% rownames(inSCE)),]
  }
  if (!is.null(log2fcThreshold)) {
    degFull <- degFull[degFull$Log2_FC > log2fcThreshold,]
  }
  if (!is.null(fdrThreshold)) {
    degFull <- degFull[degFull$FDR < fdrThreshold,]
  }
  if (!is.null(minClustExprPerc)) {
    degFull <- degFull[degFull$clusterExprPerc >= minClustExprPerc,]
  }
  if (!is.null(maxCtrlExprPerc)) {
    degFull <- degFull[degFull$ControlExprPerc <= maxCtrlExprPerc,]
  }
  if (!is.null(minMeanExpr)) {
    degFull <- degFull[degFull$clusterAveExpr >= minMeanExpr,]
  }
  # Remove duplicate by assigning the duplicated genes to the cluster where
  # their log2FC is the highest.
  # Done by keeping all unique genes and the rows with highest Log2FC entry
  # for each duplicated gene.
  dup.gene <- unique(degFull$Gene[duplicated(degFull$Gene)])
  for (g in dup.gene) {
    deg.gix <- degFull$Gene == g
    deg.gtable <- degFull[deg.gix,]
    toKeep <- which.max(deg.gtable$Log2_FC)
    toRemove <- which(deg.gix)[-toKeep]
    degFull <- degFull[-toRemove,]
  }
  clusterName <- colnames(degFull)[5]
  selected <- character()
  if (!is.null(topN)) {
    for (c in unique(degFull[[clusterName]])) {
      deg.cluster <- degFull[degFull[[clusterName]] == c,]
      deg.cluster <- deg.cluster[order(deg.cluster$Log2_FC,
                                       decreasing = TRUE),]
      if (dim(deg.cluster)[1] > topN) {
        deg.cluster <- deg.cluster[seq_len(topN),]
      }
      selected <- c(selected, deg.cluster$Gene)
    }
  } else {
    selected <- degFull$Gene
  }
  degFull <- degFull[degFull$Gene %in% selected,]
  return(degFull)
}

#' @rdname getFindMarkerTopTable
#' @export
findMarkerTopTable <- function(inSCE, log2fcThreshold = 1,
                               fdrThreshold = 0.05, minClustExprPerc = 0.7,
                               maxCtrlExprPerc = 0.4, minMeanExpr = 1,
                               topN = 10) {
  .Deprecated("getFindMarkerTopTable")
  getFindMarkerTopTable(inSCE = inSCE, log2fcThreshold = log2fcThreshold,
                        fdrThreshold = fdrThreshold,
                        minClustExprPerc = minClustExprPerc,
                        maxCtrlExprPerc = maxCtrlExprPerc,
                        minMeanExpr = minMeanExpr,
                        topN = topN)
}

#' Given a list of genes and a SingleCellExperiment object, return
#' the binary or continuous expression of the genes.
#'
#' @param gene gene list
#' @param binary "Binary" for binary expression or "Continuous" for a gradient.
#' Default: "Binary"
#' @param inSCE Input \linkS4class{SingleCellExperiment} object.
#' @param useAssay Indicates which assay to use. The default is "counts".
#' @param featureLocation Indicates which column name of rowData to query gene.
#' @param featureDisplay Indicates which column name of rowData to use
#' to display feature for visualization.
#'
#' @return getBiomarker(): A data.frame of expression values
#' @export
#' @examples
#' data("mouseBrainSubsetSCE")
#' getBiomarker(mouseBrainSubsetSCE, gene="C1qa")
#'
getBiomarker <- function(inSCE, gene, binary="Binary", useAssay="counts",
                         featureLocation = NULL, featureDisplay = NULL){
  # Get sample names
  sample <- colnames(inSCE)
  # Set rownames
  if(!is.null(featureLocation)){
    rownames(inSCE) = rowData(inSCE)[,featureLocation]
  }

  gene.ix <- c()
  for(g in gene){
    gene.ix <- c(gene.ix, which(rownames(inSCE) == g))
  }

  # Get counts for gene in sample
  c <- SummarizedExperiment::assay(inSCE, useAssay)[gene.ix, ,drop = FALSE]

  # If color scale is "yes"/"no"
  if (binary == "Binary"){
    expression <- c > 0
  } else if (binary == "Continuous"){
    expression <- c
  }
  # Make data frame with sample, counts
  bio <- cbind(sample, as.data.frame(t(as.matrix(expression))))

  if(!is.null(featureDisplay)){
    if (featureDisplay == "rownames") gene <- rownames(inSCE)[gene.ix]
    else
      gene <- rowData(inSCE)[gene.ix,featureDisplay]
  }
  colnames(bio) <- c("sample", gene)
  return(bio)
}

#' @importFrom reticulate import
.readMatrixNpz <- function(matrixLocation,
  colIndexLocation,
  rowIndexLocation,
  class,
  delayedArray) {

  ## Now importing these functions in 'reticulate_setup.R' file
  #  sparse <- reticulate::import("scipy.sparse")
  #  numpy <- reticulate::import("numpy")
  if (!reticulate::py_module_available(module = "scipy.sparse")) {
    stop("Error!", "Cannot find python module 'scipy.sparse', please install 
          Conda and run sctkPythonInstallConda() or run 
          sctkPythonInstallVirtualEnv(). If one of these have been previously 
          run to install the modules, make sure to run selectSCTKConda() or 
          selectSCTKVirtualEnvironment(), respectively, if R has been restarted 
          since the module installation. Alternatively, scipy can be installed 
          on the local machine with pip (e.g. pip install scipy) and then the 
          'use_python()' function from the 'reticulate' package can be used to 
         select the correct Python environment.")
  }
  if (!reticulate::py_module_available(module = "numpy")) {
    stop("Error!", "Cannot find python module 'numpy', please install Conda and 
          run sctkPythonInstallConda() or run sctkPythonInstallVirtualEnv(). If 
          one of these have been previously run to install the modules, make 
          sure to run selectSCTKConda() or selectSCTKVirtualEnvironment(), 
          respectively, if R has been restarted since the module installation. 
          Alternatively, numpy can be installed on the local machine with pip 
          (e.g. pip install numpy) and then the 'use_python()' function from the
          'reticulate' package can be used to select the correct Python 
          environment.")
  }

  error <- try({
    mat <- sparse$load_npz(matrixLocation)
    colIndex <- as.vector(numpy$load(colIndexLocation, allow_pickle = TRUE))
    rowIndex <- as.vector(numpy$load(rowIndexLocation, allow_pickle = TRUE))
    colnames(mat) <- colIndex
    rownames(mat) <- rowIndex
    mat <- t(mat)

    ## Convert to "dgCMatrix"
    newM <- Matrix::Matrix(mat[,1], nrow=nrow(mat))
    newM <- methods::as(newM, "CsparseMatrix")
    breaks <- seq(2, ncol(mat), by=1000)
    if(length(breaks) > 2) {
      for(i in seq(2, length(breaks))) {
        ix <- seq(breaks[i-1], (breaks[i]-1))
        newM <- cbind(newM, mat[,ix])
      }
      ix <- seq(utils::tail(breaks, n = 1), ncol(mat))
      newM <- cbind(newM, mat[,ix])
    } else {
      ix <- seq(2, ncol(mat))
      newM <- cbind(newM, mat[,ix])
    }

    colnames(newM) <- colnames(mat)
    rownames(newM) <- rownames(mat)
    mat <- newM
  }, silent = TRUE)

  if(inherits(error, "try-error")) {
    p <- paste0("importOptimus did not complete successfully. SCE could not be",
                "generated. Error given during the import process: \n\n", 
                error)
    stop(p)
  }

  if (class == "matrix") {
    mat <- as.matrix(mat)
  }

  if (isTRUE(delayedArray)) {
    mat <- DelayedArray::DelayedArray(mat)
  }
  return(mat)
}


.readMetricsOptimus <- function(path) {
  metrics <- data.table::fread(path)
  return(metrics)
}


.readEmptyDrops <- function(path) {
  emptyDrops <- data.table::fread(path)
  colnames(emptyDrops) <- paste0("dropletUtils_emptyDrops_",
    colnames(emptyDrops))
  return(emptyDrops)
}


.combineColData <- function(colnames, cellMetrics, emptyDrops) {
  cd <- data.table::data.table(CellId = colnames)
  cd <- merge(cd,
    cellMetrics,
    by.x = "CellId",
    by.y = "V1",
    all.x = TRUE,
    all.y = FALSE,
    sort = FALSE)

  if (!is.null(emptyDrops)) {
    cd <- merge(cd,
      emptyDrops,
      by.x = "CellId",
      by.y = "dropletUtils_emptyDrops_CellId",
      all.x = TRUE,
      all.y = FALSE,
      sort = FALSE)
  }

  return(cd)
}


.combineRowData <- function(rownames, geneMetrics) {
  rd <- data.table::data.table(feature_ID = rownames)
  rd <- merge(rd,
    geneMetrics,
    by.x = "feature_ID",
    by.y = "V1",
    all.x = TRUE,
    all.y = FALSE,
    sort = FALSE)
  return(rd)
}


.constructSCEFromOptimusOutputs <- function(dir,
  sample,
  matrixLocation,
  colIndexLocation,
  rowIndexLocation,
  cellMetricsLocation,
  geneMetricsLocation,
  emptyDropsLocation,
  class,
  delayedArray) {

  mat <- .readMatrixNpz(file.path(dir, matrixLocation),
    file.path(dir, colIndexLocation),
    file.path(dir, rowIndexLocation),
    class,
    delayedArray)

  cellMetrics <- .readMetricsOptimus(file.path(dir, cellMetricsLocation))
  geneMetrics <- .readMetricsOptimus(file.path(dir, geneMetricsLocation))

  if (!is.null(geneMetricsLocation)) {
    emptyDrops <- .readEmptyDrops(file.path(dir, emptyDropsLocation))
  }

  cd <- .combineColData(colnames(mat), cellMetrics, emptyDrops)
  rd <- .combineRowData(rownames(mat), geneMetrics)

  coln <- paste(sample, colnames(mat), sep = "_")

  sce <- SingleCellExperiment::SingleCellExperiment(
    assays = list(counts = mat))
  SummarizedExperiment::colData(sce) <- S4Vectors::DataFrame(cd,
    column_name = coln,
    sample = sample,
    row.names = coln)
  SummarizedExperiment::rowData(sce) <- S4Vectors::DataFrame(rd)

  return(sce)
}


.checkArgsImportOptimus <- function(OptimusDirs,
  samples) {

  if (length(OptimusDirs) != length(samples)) {
    stop("'OptimusDirs' and 'samples' have unequal lengths!")
  }
}


.importOptimus <- function(OptimusDirs,
  samples,
  matrixLocation,
  colIndexLocation,
  rowIndexLocation,
  cellMetricsLocation,
  geneMetricsLocation,
  emptyDropsLocation,
  class,
  delayedArray,
  rowNamesDedup) {

  .checkArgsImportOptimus(OptimusDirs, samples)

  res <- vector("list", length = length(samples))

  for (i in seq_along(samples)) {
    scei <- .constructSCEFromOptimusOutputs(OptimusDirs[i],
      sample = samples[i],
      matrixLocation = matrixLocation,
      colIndexLocation = colIndexLocation,
      rowIndexLocation = rowIndexLocation,
      cellMetricsLocation = cellMetricsLocation,
      geneMetricsLocation = geneMetricsLocation,
      emptyDropsLocation = emptyDropsLocation,
      class = class,
      delayedArray = delayedArray)
    res[[i]] <- scei
  }

  sce <- do.call(SingleCellExperiment::cbind, res)
  
  if (isTRUE(rowNamesDedup)) {
    if (any(duplicated(rownames(sce)))) {
      message("Duplicated gene names found, adding '-1', '-2', ",
              "... suffix to them.")
    }
    sce <- dedupRowNames(sce)
  }
  
  return(sce)
}


#' @name importOptimus
#' @rdname importOptimus
#' @title Construct SCE object from Optimus output
#' @description Read the barcodes, features (genes), and matrices from Optimus
#'  outputs. Import them
#'  as one \link[SingleCellExperiment]{SingleCellExperiment} object.
#' @param OptimusDirs A vector of root directories of Optimus output files.
#'  The paths should be something like this:
#'  \code{/PATH/TO/bb4a2a5e-ff34-41b6-97d2-0c0c0c534530}.
#'  Each entry in \code{OptimusDirs} is considered a sample and should have
#'  its own path. Must have the same length as \code{samples}.
#' @param samples A vector of user-defined sample names for the sample to be
#'  imported. Must have the same length as \code{OptimusDirs}.
#' @param matrixLocation Character. It is the intermediate
#'  path to the filtered count maxtrix file saved in sparse matrix format
#'  (\code{.npz}). Default
#'  \code{call-MergeCountFiles/sparse_counts.npz} which works for
#'  optimus_v1.4.0.
#' @param colIndexLocation Character. The intermediate path to the barcode
#'  index file. Default \code{call-MergeCountFiles/sparse_counts_col_index.npy}.
#' @param rowIndexLocation Character. The intermediate path to the feature
#'  (gene) index file. Default
#'  \code{call-MergeCountFiles/sparse_counts_row_index.npy}.
#' @param cellMetricsLocation Character. It is the intermediate
#'  path to the cell metrics file (\code{merged-cell-metrics.csv.gz}). Default
#'  \code{call-MergeCellMetrics/merged-cell-metrics.csv.gz} which works for
#'  optimus_v1.4.0.
#' @param geneMetricsLocation Character. It is the intermediate
#'  path to the feature (gene) metrics file (\code{merged-gene-metrics.csv.gz}).
#'  Default \code{call-MergeGeneMetrics/merged-gene-metrics.csv.gz} which works
#'  for optimus_v1.4.0.
#' @param emptyDropsLocation Character. It is the intermediate
#'  path to \link[DropletUtils]{emptyDrops} metrics file
#'  (\code{empty_drops_result.csv}).
#'  Default \code{call-RunEmptyDrops/empty_drops_result.csv} which works for
#'  optimus_v1.4.0.
#' @param class Character. The class of the expression matrix stored in the SCE
#'  object. Can be one of "Matrix" (as returned by
#'  \link{readMM} function), or "matrix" (as returned by
#'  \link[base]{matrix} function). Default "Matrix".
#' @param delayedArray Boolean. Whether to read the expression matrix as
#'  \link{DelayedArray} object or not. Default \code{FALSE}.
#' @param rowNamesDedup Boolean. Whether to deduplicate rownames. Default 
#'  \code{TRUE}.
#' @return A \link[SingleCellExperiment]{SingleCellExperiment} object
#'  containing the count
#'  matrix, the gene annotation, and the cell annotation.
#' @examples
#' file.path <- system.file("extdata/Optimus_20x1000",
#'   package = "singleCellTK")
#' \dontrun{
#' sce <- importOptimus(OptimusDirs = file.path,
#'   samples = "Optimus_20x1000")
#' }
#' @export
importOptimus <- function(OptimusDirs,
  samples,
  matrixLocation = "call-MergeCountFiles/sparse_counts.npz",
  colIndexLocation = "call-MergeCountFiles/sparse_counts_col_index.npy",
  rowIndexLocation = "call-MergeCountFiles/sparse_counts_row_index.npy",
  cellMetricsLocation = "call-MergeCellMetrics/merged-cell-metrics.csv.gz",
  geneMetricsLocation = "call-MergeGeneMetrics/merged-gene-metrics.csv.gz",
  emptyDropsLocation = "call-RunEmptyDrops/empty_drops_result.csv",
  class = c("Matrix", "matrix"),
  delayedArray = FALSE,
  rowNamesDedup = TRUE) {

  class <- match.arg(class)

  .importOptimus(OptimusDirs = OptimusDirs,
    samples = samples,
    matrixLocation = matrixLocation,
    colIndexLocation = colIndexLocation,
    rowIndexLocation = rowIndexLocation,
    cellMetricsLocation = cellMetricsLocation,
    geneMetricsLocation = geneMetricsLocation,
    emptyDropsLocation = emptyDropsLocation,
    class = class,
    delayedArray = delayedArray,
    rowNamesDedup = rowNamesDedup)

}

#!/usr/bin/env Rscript --vanilla

##Check to see if necessary packages are installed
#CRAN packages
cran.packages <- c("optparse", "yaml", "igraph", "Rtsne", "spam", "MCMCprecision")

cran.package.check <- lapply(cran.packages, FUN = function(x) {
    if (!require(x, character.only = TRUE)) {
        install.packages(x, dependencies = TRUE)
    }
})

#Bioconductor packages
bioc.packages <- c("singleCellTK", "celda", "BiocParallel")

bioc.package.check <- lapply(bioc.packages, FUN = function(x) {
    if (!require(x, character.only = TRUE)) {
        BiocManager::install(x)
    }
})

# check for optparse (possibly redundant)
if(!require("optparse")) {
    install.packages("optparse")
}

## Function to parse arguments from yaml file
.parseConfig <- function(sctkConfig, arguments) {
  for (i in seq_along(arguments)) {
    arg <- arguments[i]
    assign(arg, sctkConfig[[arg]], envir = parent.frame())
  }
}

## tmp function to check the output of QC before generate HTAN meta
.check_QC <- function(directory, samplename) {
    absFilterDir <- file.path(directory, samplename, "FlatFile", "Cells")
    print('The layout of the output folder after QC is done')
    print(list.files(absFilterDir, recursive = TRUE))

    decontx_AbsFileName <- file.path(absFilterDir, 'assays', paste0(samplename, '_decontXcounts.mtx.gz'))
    mat_AbsFileName <- file.path(absFilterDir, 'assays', paste0(samplename, '_counts.mtx.gz'))

    AbsColData <- file.path(absFilterDir, paste0(samplename, '_cellData.txt.gz'))
    AbsDecontXUMAP <- file.path(absFilterDir, 'reducedDims', paste0(samplename, '_decontX_UMAP.txt.gz'))
    AbsScrubletTSNE <- file.path(absFilterDir, 'reducedDims', paste0(samplename, '_scrublet_TSNE.txt.gz'))
    AbsScrubletUMAP <- file.path(absFilterDir, 'reducedDims', paste0(samplename, '_scrublet_UMAP.txt.gz'))
    
    for (file in c(decontx_AbsFileName, mat_AbsFileName, AbsColData, AbsDecontXUMAP, AbsScrubletTSNE, AbsScrubletUMAP)) {
        if (!file.exists(file)) {print(paste('The following file cannot be accessed', file))}
    }
}

### helper function for importing Mito gene set
.importMito <- function(MitoImport, MitoType) {
    reference <- NULL
    id <- NULL

    if (isTRUE(MitoImport)) {
        mito_info <- strsplit(MitoType, split = "-")
        if (length(mito_info[[1]]) != 2) {
            stop("The --MitoType ", MitoType, " is not correct or supported. Please double check the documentation.")
        }

        reference <- mito_info[[1]][1]
        id <- mito_info[[1]][2]

        if ((!reference %in% c("human", "mouse")) || (!id %in% c("symbol", "entrez", "ensembl", "ensemblTranscriptID"))) {
            stop("The --MitoType ", MitoType, " is not correct or supported. Please double check the documentation.")
        }
    }
    return(list('reference' = reference, 'id' = id))
}

## Check whether python module is available
if (!reticulate::py_module_available(module = "scrublet")) {
    stop("Cannot find python module 'scrublet'. ",
            "Scrublet can be installed on the local machine",
            "with pip (e.g. pip install --user scanpy) and then the 'use_python()'",
            " function from the 'reticulate' package can be used to select the",
            " correct Python environment.")
}

##Read in flags from command line using optparse
option_list <- list(optparse::make_option(c("-b", "--basePath"),
        type = "character",
        default = NULL,
        help = "Base path for the output from the preprocessing algorithm"),
    optparse::make_option(c("-P", "--preproc"),
        type = "character",
        default = NULL,
        help = "Algorithm used for preprocessing. One of 'CellRangerV2', 'CellRangerV3', 'BUStools', 'STARSolo', 'SEQC', 'Optimus', 'DropEst', 'SceRDS', 'CountMatrix', 'AnnData', 'Seurat', 'Alevin', and 'FlatFile'."),
    optparse::make_option(c("-s", "--sample"),
        type = "character",
        help = "Name of the sample. This will be prepended to the cell barcodes."),
    optparse::make_option(c("-o", "--directory"),
        type = "character",
        default = ".",
        help = "Output directory"),
    optparse::make_option(c("-O", "--outputPrefix"),
        type = "character",
        default = "CombinedSamples",
        help = "Prefix of the name of output file when --splitSample=FALSE."),
    optparse::make_option(c("-g", "--gmt"),
        type = "character",
        default = NULL,
        help = "GMT file containing gene sets for quality control. The second column in the GMT file (i.e. the description) should contain the location to look for the IDs in the data. If set to 'rownames', then the gene set IDs will be matched with the row IDs of the data matrix. If another character or integer index is supplied, then gene set IDs will be matched to IDs the that column of feature table."),
    optparse:: make_option(c("-t", "--delim"),
        type = "character",
        default = "\t",
        help = "Delimiter used in GMT file"),
    optparse::make_option(c("-G", "--genome"),
        type = "character",
        default = NULL,
        help = "The name of genome reference. This is only required for CellRangerV2 data."),
    optparse::make_option(c("-C", "--cellPath"),
        type = "character",
        default = NULL,
        help = "The directory contains cell matrix, gene and cell barcodes information. Default is NULL. If 'basePath' is NULL, both 'cellPath' and 'rawPath' should also be specified."),
    optparse::make_option(c("-R", "--rawPath"),
        type = "character",
        default = NULL,
        help = "The directory contains droplet matrix, gene and cell barcodes information. Default is NULL. If 'basePath' is NULL, both 'cellPath' and 'rawPath' should also be specified."),
    optparse::make_option(c("-S", "--splitSample"),
        type = "logical",
        default = TRUE,
        help = "Save SingleCellExperiment object for each sample. Default is FALSE. If TRUE, all samples will be combined and only one combimed SingleCellExperiment object will be saved."),
    optparse::make_option(c("-r", "--rawData"),
        type = "character",
        default = NULL,
        help = "The full path of the RDS file or Matrix file of the raw gene count matrix. This would be provided only when --preproc is SceRDS or CountMatrix."),
    optparse::make_option(c("-c", "--cellData"),
        type = "character",
        default = NULL,
        help = "The full path of the RDS file or Matrix file of the cell count matrix. This would be use only when --preproc is SceRDS or CountMatrix."),
    optparse::make_option(c("-f", "--flatFiles"),
        type = "character",
        default = NULL,
        help = "The full paths of the matrix, barcodes, and features files needed to construct an SCE object from flat files."),
    optparse::make_option(c("-F", "--outputFormat"),
        type = "character",
        default = NULL,
        help = "The output format of this QC pipeline. Currently, it supports SCE, Flatfile, Seurat, AnnData and HTAN."),
    optparse::make_option(c("-y", "--yamlFile"),
        type = "character",
        default = NULL,
        help = "YAML file containing parameters called by singleCellTK QC functions. Please check documentation for details."),
    optparse::make_option(c("-d", "--dataType"),
        type = "character",
        default = "Both",
        help = "Type of data as input. Default is Both, which means taking both droplet and cell matrix as input. If set as 'Droplet', it will only processes droplet data. If set as 'Cell', it will only processes cell data."),
    optparse::make_option(c("-n", "--numCores"),
        type = "integer",
        default = 1,
        help = "Number of cores used to run the pipeline. By default is 1. Parallel computing is enabled if -n is greater than 1."),
    optparse::make_option(c("-D", "--detectCells"),
        type = "logical",
        default = FALSE,
        help = "Detect cells from droplet matrix. Default is FALSE. This argument is only evaluated when -d is 'Droplet'. If set as TRUE, cells will be detected and cell matrixed will be subset from the droplet matrix. Also, quality control will be performed on the detected cell matrix."),
    optparse::make_option(c("-m", "--cellDetectMethod"),
        type = "character",
        default = "EmptyDrops",
        help = "Methods to detect cells. Default is 'EmptyDrops'. Other options could be 'Knee' or 'Inflection'. More information is provided in the documentation. "),
    optparse::make_option(c("-i", "--studyDesign"),
        type = "character",
        default = NULL,
        help = "The txt file containing the desrciption of the study design. Default is NULL. This would be shown at the begining the html report of cell and droplet QC."),
    optparse::make_option(c("-L", "--subTitle"),
        type = "character",
        default = NULL,
        help = "The subtitle used in the cell and droplet QC HTML report. Default is None. The subtitle can contain information of the sample, like sample name, etc. The length of subsitle should be the same as the length of samples, if -S is set as TRUE. if -S is set as FALSE, the length of subtitle should be one or NULL"),
    optparse::make_option(c("-T", "--parallelType"),
        type = "character",
        default = "MulticoreParam",
        help = "Type of clusters used for parallel computing. Default is 'MulticoreParam'. It can be 'MulticoreParam' or 'SnowParam'. This argument will be evaluated only when numCores > 1."),
    optparse::make_option(c("-M", "--detectMitoLevel"),
        type = "logical",
        default = TRUE,
        help = "Detect mitochondrial gene expression level. If TRUE, the pipeline will examinate mito gene expression level automatically without the need of importing user defined gmt file. Default is TRUE"),
    optparse::make_option(c("-E", "--mitoType"),
        type = "character",
        default = "human-ensembl",
        help = "Type of mitochondrial gene set to be used when --detectMitoLevel is set to TRUE. Possible choices are: 'human-ensembl', 'human-symbol', 'human-entrez', 'human-ensemblTranscriptID',
        'mouse-ensembl', 'mouse-symbol', 'mouse-entrez', 'mouse-ensemblTranscriptID'. The first part defines the species and second part defines type of gene ID used as the rownames of the count matrix"),
    optparse::make_option(c("-Q", "--QCReport"),
        type = "logical",
        default = FALSE,
        help = "Generates QC report when the SCTK-QC pipeline is finished. Default if TRUE")
    )
## Define arguments
arguments <- optparse::parse_args(optparse::OptionParser(option_list=option_list), positional_arguments=TRUE)
opt <- arguments$options
process <- unlist(strsplit(opt[["preproc"]], ","))
sample <- unlist(strsplit(opt[["sample"]], ","))
directory <- unlist(strsplit(opt[["directory"]], ","))
gmt <- opt[["gmt"]]
sep <- opt[["delim"]]
split <- opt[["splitSample"]]
basepath <- opt[["basePath"]]
FilterDir <- opt[["cellPath"]]
RawDir <- opt[["rawPath"]]
Reference <- opt[["genome"]]
RawFile <- opt[["rawData"]]
flatFiles <- opt[["flatFiles"]]
FilterFile <- opt[["cellData"]]
yamlFile <- opt[["yamlFile"]]
formats <- opt[["outputFormat"]]
dataType <- opt[["dataType"]]
detectCell <- opt[["detectCells"]]
numCores <- opt[["numCores"]]
parallelType <- opt[["parallelType"]]
cellCalling <- opt[["cellDetectMethod"]]
studyDesign <- opt[["studyDesign"]]
subTitles <- opt[["subTitle"]]
CombinedSamplesName <- opt[["outputPrefix"]]
MitoImport <- opt[["detectMitoLevel"]]
MitoType <- opt[["mitoType"]]
QCReport <- opt[["QCReport"]]

message("The output directory is")
print(directory)

if (!is.null(basepath)) { basepath <- unlist(strsplit(opt[["basePath"]], ",")) }

if (!is.null(FilterDir)) { FilterDir <- unlist(strsplit(opt[["cellPath"]], ",")) }

if (!is.null(RawDir)) { RawDir <- unlist(strsplit(opt[["rawPath"]], ",")) }

if (!is.null(Reference)) { Reference <- unlist(strsplit(opt[["genome"]], ",")) }

if (!is.null(RawFile)) { RawFile <- unlist(strsplit(opt[["rawData"]], ",")) }

if (!is.null(FilterFile)) { FilterFile <- unlist(strsplit(opt[["cellData"]], ",")) }

if (!is.null(flatFiles)) { flatFiles <- unlist(strsplit(opt[["flatFiles"]], ",")) }

if (!is.null(formats)) { formats <- unlist(strsplit(opt[["outputFormat"]], ",")) }

if (!is.null(studyDesign)) { studyDesign <- base::readLines(studyDesign, n=-1) }

if (is.null(subTitles)) {
    subTitles <- paste("SCTK QC HTML report for sample", sample)
} else {
    subTitles <- unlist(strsplit(opt[["subTitles"]], ","))
}

if ("HTAN" %in% formats) {
    if (!("FlatFile" %in% formats)) {
        message("Note: HTAN specified as output without FlatFile. Automatically including FlatFile export.")
        formats <- append(formats, "FlatFile")
    }
}

## Parse parameters for QC algorithms
if (!is.null(yamlFile)) {
    arguments <- c('Params')
    qcParams <- yaml::read_yaml(yamlFile)
    .parseConfig(qcParams, arguments)
} else {
    Params <- list()
}

## checking numCores argument
isWindows <- .Platform$OS.type == "windows"

if (numCores > 1) {
    if (numCores > parallel::detectCores()) {
        warning("numCores is greater than number of cores available. Set numCores as maximum number of cores available.")
    }

    numCores <- min(numCores, parallel::detectCores())
    message(as.character(numCores), " cores are used for parallel computation.")

    if (parallelType == "MulticoreParam") {
        parallelParam <- MulticoreParam(workers = numCores)

        if (isTRUE(isWindows)) {
            warning("'MulticoreParam' is not supported for Windows system. Setting 'parallelType' as 'SnowParam'. ")
            parallelParam <- SnowParam(workers = numCores)
        }

    } else if (parallelType == "SnowParam") {
        parallelParam <- SnowParam(workers = numCores)
    } else {
        stop("'--parallelType' should be 'MulticoreParam' or 'SnowParam'.")
    }

    Params$QCMetrics$BPPARAM <- parallelParam
    Params$emptyDrops$BPPARAM <- parallelParam
    #Params$doubletCells$BPPARAM <- parallelParam
    Params$doubletFinder$nCores <- numCores
}

### checking output formats
if (!all(formats %in% c("SCE", "AnnData", "FlatFile", "HTAN", "Seurat"))) {
    warning("Output format must be 'SCE', 'AnnData', 'HTAN', 'Seurat' or 'FlatFile'. Format ",
         paste(formats[!formats %in% c("SCE", "AnnData", "FlatFile", "HTAN", "Seurat")], collapse = ","),
         " is not supported now. ")
}

formats <- formats[formats %in% c("SCE", "AnnData", "FlatFile", "HTAN", "Seurat")]
message("The output format is [",
        paste(formats, collapse = ","), "]. ")

if (length(formats) == 0) {
    warning("None of the provided format is supported now. Therefore, the output ",
        "will be SCE, AnnData, Seurat, FlatFile and HTAN. ")
    formats <- c("SCE", "AnnData", "FlatFile", "HTAN", "Seurat")
}

if (!(dataType %in% c("Both", "Droplet", "Cell"))) {
    stop("-d / -dataType must be one of the following: 'Both', 'Droplet' or 'Cell'. ")
}

# Checking argument
check <- switch(dataType,
         "cell" = .checkCell(FilterFile, FilterDir, basepath, Reference, process),
         "droplet" = .checkDroplet(RawFile, RawDir, basepath, Reference, process),
         "both" = .checkBoth(RawFile, FilterFile, RawDir, FilterDir, basepath, Reference, process))

if (!cellCalling %in% c("Knee", "Inflection", "EmptyDrops")) {
    stop("The --cellDetectMethod must be 'Knee', 'Inflection' or 'Emptydrops'.")
}

## Prepare for QC
dropletSCE_list <- list()
cellSCE_list <- list()
geneSetCollection <- NULL
if (!is.null(gmt)) {
    geneSetCollection <- GSEABase::getGmt(gmt, sep = sep)
}


level3Meta <- list()
level4Meta <- list()

for(i in seq_along(process)) {

    # pop elements from FlatFile input list
    if ("FlatFile" %in% process[i]) {
        if (dataType %in% c("Droplet", "Cell")) {
            flatFileInput <- flatFiles[c(1, 2, 3)]
            flatFiles <- flatFiles[-c(1, 2, 3)]
        }
        else {
            flatFileInput <- flatFiles[c(1, 2, 3, 4, 5, 6)]
            flatFiles <- flatFiles[-c(1, 2, 3, 4, 5, 6)]
        }
    }

    preproc <- process[i]
    samplename <- sample[i]
    path <- basepath[i]
    raw <- RawDir[i]
    fil <- FilterDir[i]
    ref <- Reference[i]
    rawFile <- RawFile[i]
    filFile <- FilterFile[i]
    subTitle <- subTitles[i]
    INPUT <- qcInputProcess(preproc,
                            samplename,
                            path,
                            raw,
                            fil,
                            ref,
                            rawFile,
                            filFile,
                            flatFileInput,
                            dataType)
    dropletSCE <- INPUT[[1]]
    cellSCE <- INPUT[[2]]

    mitoInfo <- .importMito(MitoImport = MitoImport, MitoType = MitoType)

    cellQCAlgos <- c("QCMetrics", "scDblFinder", "cxds", "bcds", "scrublet", "doubletFinder",
    "cxds_bcds_hybrid", "decontX", "decontX_bg", "soupX", "soupX_bg") #scrublet
    

    # Checking to see if the input is a file instead of a directory, for RDS and H5AD reading
    # also check to see if the sample name is specified, and if so, set it
    if (!is.null(rawFile) || !is.null(filFile)) {
        if (!dir.exists(path)) {
            if (is.null(samplename)) {
                stop("In Seurat/SCE/AnnData input mode, a sample name must be provided using the -s/--sample flag.")
            } else {
                if (dataType == "Cell" || dataType == "Both") {
                    if (is.null(filFile)) {
                        stop("You must provide a file with cell counts.")
                    }
                }
                if (dataType == "Droplet" || dataType == "Both") {
                    if (is.null(rawFile)) {
                        stop("You must provide a file with raw counts.")
                    }
                }
            samplesname <- sample
            }
        }
    }

    if (dataType == "Cell") {
        if (is.null(cellSCE) && (preproc %in% c("BUStools", "SEQC"))) {
            dropletSCE <- runDropletQC(inSCE = dropletSCE, paramsList=Params)
            ix <- !is.na(dropletSCE$dropletUtils_emptyDrops_fdr) & (dropletSCE$dropletUtils_emptyDrops_fdr < 0.01)
            cellSCE <- dropletSCE[,ix]
        }

        message(paste0(date(), " .. Running cell QC"))
        cellSCE <- runCellQC(inSCE = cellSCE, geneSetCollection = geneSetCollection, 
            paramsList=Params, algorithms = cellQCAlgos, background = dropletSCE,
            mitoRef = mitoInfo[['reference']], mitoIDType = mitoInfo[['id']],
            mitoGeneLocation = "rownames")
    }

    if (dataType == "Droplet") {
        message(paste0(date(), " .. Running droplet QC"))
        dropletSCE <- runDropletQC(inSCE = dropletSCE, paramsList=Params)
        if (isTRUE(detectCell)) {
            if (cellCalling == "EmptyDrops") {
                ix <- !is.na(dropletSCE$dropletUtils_emptyDrops_fdr) & dropletSCE$dropletUtils_emptyDrops_fdr < 0.01
            } else if (cellCalling == "Knee") {
                ix <- dropletSCE$dropletUtils_BarcodeRank_Knee == 1
            } else {
                ix <- dropletSCE$dropletUtils_BarcodeRank_Inflection == 1
            }
            cellSCE <- dropletSCE[,ix]
            message(paste0(date(), " .. Running cell QC"))
            cellSCE <- runCellQC(inSCE = cellSCE, geneSetCollection = geneSetCollection, 
                paramsList=Params, algorithms = cellQCAlgos, background = dropletSCE,
                mitoRef = mitoInfo[['reference']], mitoIDType = mitoInfo[['id']],
                mitoGeneLocation = "rownames")
        }
    }

    if (dataType == "Both") {
        if (!is.null(dropletSCE)) {
            message(paste0(date(), " .. Running droplet QC"))
            dropletSCE <- runDropletQC(inSCE = dropletSCE, paramsList=Params)

            if (is.null(cellSCE)) {
                if (cellCalling == "EmptyDrops") {
                    ix <- !is.na(dropletSCE$dropletUtils_emptyDrops_fdr) & dropletSCE$dropletUtils_emptyDrops_fdr < 0.01
                } else if (cellCalling == "Knee") {
                    ix <- dropletSCE$dropletUtils_BarcodeRank_Knee == 1
                } else {
                    ix <- dropletSCE$dropletUtils_BarcodeRank_Inflection == 1
                }
                cellSCE <- dropletSCE[,ix]
            } else {
                ### add indicator which barcodes are in the user-provided cellSCE
                cbInCellMat <- colnames(dropletSCE) %in% colnames(cellSCE)
                SummarizedExperiment::colData(dropletSCE)$barcodeInCellMatrix <- cbInCellMat
            }
        }

        if (!is.null(cellSCE)) {
            message(paste0(date(), " .. Running cell QC"))

            cellSCE <- runCellQC(inSCE = cellSCE, geneSetCollection = geneSetCollection, 
                paramsList=Params, algorithms = cellQCAlgos, background = dropletSCE,
                mitoRef = mitoInfo[['reference']], mitoIDType = mitoInfo[['id']],
                mitoGeneLocation = "rownames")
        }
    }
    ## merge colData of dropletSCE and FilteredSCE
    mergedDropletSCE <- NULL
    mergedFilteredSCE <- NULL

    if (dataType == "Both") {
        mergedDropletSCE <- mergeSCEColData(dropletSCE, cellSCE)
        mergedFilteredSCE <- mergeSCEColData(cellSCE, dropletSCE)
        #mergedDropletSCE <- dropletSCE
        #mergedCellSCE <- cellSCE
    }

    if (dataType == "Cell") {
        mergedFilteredSCE <- cellSCE
    }

    if (dataType == "Droplet") {
        if (isTRUE(detectCell)) {
            mergedDropletSCE <- mergeSCEColData(dropletSCE, cellSCE)
            mergedFilteredSCE <- mergeSCEColData(cellSCE, dropletSCE)
        } else {
            mergedDropletSCE <- dropletSCE
        }
    }


    if (isTRUE(split)) {
        ### assign sample to every runBarcodeRanksMetaOutput metadata slot
        if (!is.null(mergedDropletSCE)) {
            names(metadata(mergedDropletSCE)$sctk$runBarcodeRankDrops) <- samplename
        }

        if (!is.null(mergedFilteredSCE)) {
            for (name in names(metadata(mergedFilteredSCE))) {
                if (!name %in% c("assayType", "sctk")) {
                    metadata(mergedFilteredSCE)[[name]] <- list(metadata(mergedFilteredSCE)[[name]])
                    names(metadata(mergedFilteredSCE)[[name]]) <- samplename
                }
            }
        }

        if ((dataType == "Both") || (dataType == "Droplet" && isTRUE(detectCell))) {
            exportSCE(inSCE = mergedDropletSCE, samplename = samplename, directory = directory, type = "Droplets", format=formats)
            exportSCE(inSCE = mergedFilteredSCE, samplename = samplename, directory = directory, type = "Cells", format=formats)


            ## Get parameters of QC functions
            getSceParams(inSCE = mergedFilteredSCE, directory = directory,
                         samplename = samplename, writeYAML = TRUE,
                         skip = c("runScrublet","runDecontX","runBarcodeRanksMetaOutput","genesets","runSoupX"))

            ## generate meta data
            if ("FlatFile" %in% formats) {
                if ("HTAN" %in% formats) {
                    meta <- generateHTANMeta(dropletSCE = mergedDropletSCE, cellSCE = mergedFilteredSCE, samplename = samplename,
                                        dir = directory, htan_biospecimen_id=samplename, dataType = "Both")
                } else {
                    meta <- generateMeta(dropletSCE = mergedDropletSCE, cellSCE = mergedFilteredSCE, samplename = samplename,
                                        dir = directory, HTAN=FALSE, dataType = "Both")
                }

                level3Meta[[i]] <- meta[[1]]
                level4Meta[[i]] <- meta[[2]]

            } else {
                warning("'FlatFile' is not in output format. Skip exporting the manifest file.")
            }

            ## generate html report
            if (QCReport) {
                reportDropletQC(inSCE = mergedDropletSCE, output_dir = directory, output_file = paste0("SCTK_", samplename,'_dropletQC.html'), subTitle = subTitle, studyDesign = studyDesign)
                reportCellQC(inSCE = mergedFilteredSCE, output_dir = directory, output_file = paste0("SCTK_", samplename,'_cellQC.html'), subTitle = subTitle, studyDesign = studyDesign)                
            }

            ## generate QC metrics table for mergedFilteredSCE
            mergedFilteredSCE <- sampleSummaryStats(mergedFilteredSCE, simple=FALSE, sample = colData(mergedFilteredSCE)$sample) #colData(cellSCE)$Study_ID
            QCsummary <- getSampleSummaryStatsTable(mergedFilteredSCE, statsName = "qc_table")
            write.csv(QCsummary, file.path(directory,
                                           samplename,
                                           paste0("SCTK_", samplename,'_cellQC_summary.csv')))
        }

        if ((dataType == "Droplet") && (!isTRUE(detectCell))) {
            exportSCE(inSCE = mergedDropletSCE, samplename = samplename, directory = directory, type = "Droplets", format=formats)
            if ("FlatFile" %in% formats) {
                if ("HTAN" %in% formats) {
                    meta <- generateHTANMeta(dropletSCE = mergedDropletSCE, cellSCE = NULL, samplename = samplename,
                                        dir = directory, htan_biospecimen_id=samplename, dataType = "Droplet")
                } else {
                    meta <- generateMeta(dropletSCE = mergedDropletSCE, cellSCE = NULL, samplename = samplename,
                                        dir = directory, HTAN=FALSE, dataType = "Droplet")
                }

                level3Meta[[i]] <- meta[[1]]
                level4Meta[[i]] <- meta[[2]]

            } else {
                warning("'FlatFile' is not in output format. Skip exporting the manifest file.")
            }

            if (QCReport) {
                reportDropletQC(inSCE = mergedDropletSCE, output_dir = directory, output_file = paste0("SCTK_", samplename,'_dropletQC.html'), subTitle = subTitle, studyDesign = studyDesign)
            }
        }

        if (dataType == "Cell") {
            exportSCE(inSCE = mergedFilteredSCE, samplename = samplename, directory = directory, type = "Cells", format=formats)
            if ("FlatFile" %in% formats) {
                if ("HTAN" %in% formats) {
                    .check_QC(directory = directory, samplename = samplename)
                    meta <- generateHTANMeta(dropletSCE = NULL, cellSCE = mergedFilteredSCE, samplename = samplename,
                                        dir = directory, htan_biospecimen_id=samplename, dataType = "Cell")
                } else {
                    meta <- generateMeta(dropletSCE = NULL, cellSCE = mergedFilteredSCE, samplename = samplename,
                                        dir = directory, HTAN=FALSE, dataType = "Cell")
                }

                level3Meta[[i]] <- meta[[1]]
                level4Meta[[i]] <- meta[[2]]

            } else {
                warning("'FlatFile' is not in output format. Skip exporting the manifest file.")
            }

            if (QCReport) {
                reportCellQC(inSCE = mergedFilteredSCE, output_dir = directory, output_file = paste0("SCTK_", samplename,'_cellQC.html'), subTitle = subTitle, studyDesign = studyDesign)
            }
            getSceParams(inSCE = mergedFilteredSCE, directory = directory,
                         samplename = samplename, writeYAML = TRUE,
                         skip = c("runScrublet","runDecontX","runBarcodeRanksMetaOutput","genesets","runSoupX"))

            mergedFilteredSCE <- sampleSummaryStats(mergedFilteredSCE, simple=FALSE, sample = colData(mergedFilteredSCE)$sample) #colData(cellSCE)$Study_ID
            QCsummary <- getSampleSummaryStatsTable(mergedFilteredSCE, statsName = "qc_table")
            write.csv(QCsummary, file.path(directory,
                                           samplename,
                                           paste0("SCTK_", samplename,'_cellQC_summary.csv')))
        }

    }
    dropletSCE_list[[samplename]] <- mergedDropletSCE
    cellSCE_list[[samplename]] <- mergedFilteredSCE
}

if (!isTRUE(split)) {

    if (length(sample) > 1) {
        samplename <- CombinedSamplesName #paste(sample, collapse="-")
        subTitle <- paste("SCTK QC HTML report for sample", samplename)
    }

    if ((dataType == "Both") || (dataType == "Droplet" && isTRUE(detectCell))) {

        by.r <- NULL
        by.c <- Reduce(intersect, lapply(dropletSCE_list, function(x) { colnames(colData(x))}))
        dropletSCE <- combineSCE(dropletSCE_list, by.r, by.c, combined = TRUE)
        names(metadata(dropletSCE)$sctk$runBarcodeRankDrops) <- sample  

        if (length(sample) == 1) {
            ### one sample. Treat it like split == TRUE
            cellSCE <- cellSCE_list[[1]]
            for (name in names(metadata(cellSCE))) {
              if (!name %in% c("assayType", "sctk")) {
                metadata(mergedFilteredSCE)[[name]] <- list(metadata(mergedFilteredSCE)[[name]])
                names(metadata(mergedFilteredSCE)[[name]]) <- samplename
              }
            }
        } else {
            by.c <- Reduce(intersect, lapply(cellSCE_list, function(x) { colnames(colData(x))}))
            cellSCE <- combineSCE(cellSCE_list, by.r, by.c, combined = TRUE)
            for (name in names(metadata(cellSCE))) {
                if (!name %in% c("assayType", "sctk")) {
                    names(metadata(cellSCE)[[name]]) <- sample
                }
            }
        }

        exportSCE(inSCE = dropletSCE, samplename = samplename, directory = directory, type = "Droplets", format=formats)
        exportSCE(inSCE = cellSCE, samplename = samplename, directory = directory, type = "Cells", format=formats)

        ## html report
        if (QCReport) {
            reportDropletQC(inSCE = dropletSCE, output_dir = directory, output_file = paste0("SCTK_", samplename,'_dropletQC.html'), subTitle = subTitle, studyDesign = studyDesign)
            reportCellQC(inSCE = cellSCE, output_dir = directory, output_file = paste0("SCTK_", samplename,'_cellQC.html'), subTitle = subTitle, studyDesign = studyDesign)
        }
        ## Get parameters of QC functions
        getSceParams(inSCE = cellSCE, directory = directory, samplename = samplename, writeYAML = TRUE)

        ## generate meta data
        # generate HTAN level3/level4 output
        if ("FlatFile" %in% formats) {
            if ("HTAN" %in% formats) {
                meta <- generateHTANMeta(dropletSCE = dropletSCE, cellSCE = cellSCE, samplename = samplename,
                                    dir = directory, htan_biospecimen_id=samplename, dataType = "Both")
            } else {
                meta <- generateMeta(dropletSCE = dropletSCE, cellSCE = cellSCE, samplename = samplename,
                                    dir = directory, HTAN=FALSE, dataType = "Both")
            }

            level3Meta <- list(meta[[1]])
            level4Meta <- list(meta[[2]])

        } else {
            warning("'FlatFile' is not in output format. Skip exporting the manifest file.")
        }

        ## generate QC summary
        cellSCE <- sampleSummaryStats(cellSCE, simple=FALSE, sample = colData(cellSCE)$sample)
        QCsummary <- getSampleSummaryStatsTable(cellSCE, statsName = "qc_table")
        write.csv(QCsummary, file.path(directory,
                                       samplename,
                                       paste0("SCTK_", samplename,'_cellQC_summary.csv')))
    }

    if (dataType == "Cell") {

        if (length(sample) == 1) {
            ### one sample. Treat it like split == TRUE
            cellSCE <- cellSCE_list[[1]]
            for (name in names(metadata(cellSCE))) {
              if (!name %in% c("assayType", "sctk")) {
                  metadata(cellSCE)[[name]] <- list(metadata(cellSCE)[[name]])
                  names(metadata(cellSCE)[[name]]) <- samplename
              }
            }
        } else {
            by.r <- NULL
            by.c <- Reduce(intersect, lapply(cellSCE_list, function(x) { colnames(colData(x))}))
            cellSCE <- combineSCE(cellSCE_list, by.r, by.c, combined = TRUE)
            for (name in names(metadata(cellSCE))) {
                if (!name %in% c("assayType", "sctk")) { ### not important and hard to force name. Skipped
                    names(metadata(cellSCE)[[name]]) <- sample
                }
            }
        }

        exportSCE(inSCE = cellSCE, samplename = samplename, directory = directory, type = "Cells", format=formats)
        # generate HTAN level3/level4 output
        if ("FlatFile" %in% formats) {
            if ("HTAN" %in% formats) {
                meta <- generateHTANMeta(dropletSCE = NULL, cellSCE = cellSCE, samplename = samplename,
                                    dir = directory, htan_biospecimen_id=samplename, dataType = "Cell")
            } else {
                meta <- generateMeta(dropletSCE = NULL, cellSCE = cellSCE, samplename = samplename,
                                    dir = directory, HTAN=FALSE, dataType = "Cell")
            }

            level3Meta[[i]] <- meta[[1]]
            level4Meta[[i]] <- meta[[2]]

        } else {
            warning("'FlatFile' is not in output format. Skip exporting the manifest file.")
        }
        if (QCReport) {
            reportCellQC(inSCE = cellSCE, output_dir = directory, output_file = paste0("SCTK_", samplename,'_cellQC.html'), subTitle = subTitle, studyDesign = studyDesign)
        }
        getSceParams(inSCE = cellSCE, directory = directory, samplename = samplename, writeYAML = TRUE)

        cellSCE <- sampleSummaryStats(cellSCE, simple=FALSE, sample = colData(cellSCE)$sample)
        QCsummary <- getSampleSummaryStatsTable(cellSCE, statsName = "qc_table")
        write.csv(QCsummary, file.path(directory,
                                       samplename,
                                       paste0("SCTK_", samplename,'_cellQC_summary.csv')))
    }

    if ((dataType == "Droplet") && (!isTRUE(detectCell))) {
        by.r <- NULL
        by.c <- Reduce(intersect, lapply(dropletSCE_list, function(x) { colnames(colData(x))}))
        dropletSCE <- combineSCE(dropletSCE_list, by.r, by.c, combined = TRUE)
        names(metadata(dropletSCE)$sctk$runBarcodeRankDrops) <- sample

        exportSCE(inSCE = dropletSCE, samplename = samplename, directory = directory, type = "Droplets", format=formats)
        # generate HTAN level3/level4 output
        if ("FlatFile" %in% formats) {
            if ("HTAN" %in% formats) {
                meta <- generateHTANMeta(dropletSCE = dropletSCE, cellSCE = NULL, samplename = samplename,
                                    dir = directory, htan_biospecimen_id=samplename, dataType = "Droplet")
            } else {
                meta <- generateMeta(dropletSCE = dropletSCE, cellSCE = NULL, samplename = samplename,
                                    dir = directory, HTAN=FALSE, dataType = "Droplet")
            }

            level3Meta[[i]] <- meta[[1]]
            level4Meta[[i]] <- meta[[2]]

        } else {
            warning("'FlatFile' is not in output format. Skip exporting the manifest file.")
        }
        if (QCReport) {
            reportDropletQC(inSCE = dropletSCE, output_dir = directory, output_file = paste0("SCTK_", samplename,'_dropletQC.html'), subTitle = subTitle, studyDesign = studyDesign)
        }
    }
}

if (("FlatFile" %in% formats)) {
    HTANLevel3 <- do.call(base::rbind, level3Meta)
    HTANLevel4 <- do.call(base::rbind, level4Meta)
    write.csv(HTANLevel3, file = file.path(directory, "level3Meta.csv"))
    if ( !(dataType == "Droplet" && !isTRUE(detectCell)) ) {
        write.csv(HTANLevel4, file = file.path(directory, "level4Meta.csv"))
    }
}

# output session info
sessionInfo()

#user-interface
filterTableUI <- function(id){
  ns <- NS(id)
  fluidPage(
    fluidRow(
      panel(heading = "Marker Genes",
            uiOutput(ns("seuratFindMarkerFilter")),
            br(),
            DT::dataTableOutput(
              outputId = ns("seuratFindMarkerTable")) %>% withSpinner(
                type = 5,
                color = "#b2b2b2"
                )
      )
    )
  )
}

#server
filterTableServer <- function(input, output, session, dataframe,
                              defaultFilterColumns = NULL,
                              defaultFilterOperators = NULL,
                              defaultFilterValues = NULL,
                              initialTopN = NULL,
                              topText = NULL){

  ns <- session$ns
  x <- session$ns('tmp')
  moduleID <- substr(x, 1, nchar(x)-4)
  rv <- reactiveValues(data = NULL,
                      selectedRows = NULL,
                      parameters = NULL
                      )
  if(length(defaultFilterValues) != length(defaultFilterColumns)
     || length(defaultFilterOperators) != length(defaultFilterColumns)){
    stop("Using a default filter requires all default filter parameters to be equal in length!")
  }
  message("Removing '.' from column names of the input dataframe as it is not supported by filters!")
  colnames(dataframe) <- gsub("\\.", "_", colnames(dataframe))
  colnamesDF <- colnames(dataframe)
  class <- NULL
  option <- NULL
  inputFirst <- NULL
  inputSecond <- NULL
  for(i in seq(length(colnamesDF))){
    class[i] <- paste0("class_", colnamesDF[i])
    option[i] <- paste0("option_", colnamesDF[i])
    inputFirst[i] <- paste0("inputFirst_", colnamesDF[i])
    inputSecond[i] <- paste0("inputSecond_", colnamesDF[i])
  }

  lapply(seq_along(colnamesDF), function(i) {
    if(is.numeric(dataframe[,i])){
      if(i == 1){
        output[[paste0("filterOutput",i)]] <- renderUI({
          div(class = class[i], wellPanel(style='border:1;',
                                                 checkboxGroupButtons(
                                                   inputId = ns(option[i]),
                                                   label = colnamesDF[i],
                                                   choices = c("<", ">", "=", "<=", ">=",
                                                               "extremes", "range"),
                                                   justified = FALSE,
                                                   individual = FALSE,
                                                   size = "xs",
                                                   status = "primary"
                                                 ),
                                          conditionalPanel(
                                            condition = paste0("input['", option[i], "'] == 'extremes'"),
                                            ns = ns,
                                            h6("values greater than (or equal to):")
                                          ),
                                          conditionalPanel(
                                            condition = paste0("input['", option[i], "'] == 'range'"),
                                            ns = ns,
                                            h6("values between:")
                                          ),
                                                 numericInput(
                                                   inputId = ns(inputFirst[i]),
                                                   label = NULL,
                                                   step = 0.001,
                                                   value = 0
                                                 ),
                                          conditionalPanel(
                                            condition = paste0("input['", option[i], "'] == 'extremes'"),
                                            ns = ns,
                                            h6("and values less than (or equal to):")
                                          ),
                                          conditionalPanel(
                                            condition = paste0("input['", option[i], "'] == 'range'"),
                                            ns = ns,
                                            h6("and:")
                                          ),
                                                 conditionalPanel(
                                                   condition = paste0("input['", option[i], "'] == 'extremes'
                                                                    || input['", option[i], "'] == 'range'"),
                                                   ns = ns,
                                                   numericInput(
                                                     inputId = ns(inputSecond[i]),
                                                     label = NULL,
                                                     step = 0.001,
                                                     value = 0
                                                   )
                                                 )
          ))
        })
      }
      else{
        output[[paste0("filterOutput",i)]] <- renderUI({
          hidden(div(class = class[i], wellPanel(style='border:1;',
                                                 checkboxGroupButtons(
                                                   inputId = ns(option[i]),
                                                   label = colnamesDF[i],
                                                   choices = c("<", ">", "=", "<=", ">=",
                                                               "extremes", "range"),
                                                   justified = FALSE,
                                                   individual = FALSE,
                                                   size = "xs",
                                                   status = "primary"
                                                 ),
                                                 conditionalPanel(
                                                   condition = paste0("input['", option[i], "'] == 'extremes'"),
                                                   ns = ns,
                                                   h6("values greater than (or equal to):")
                                                 ),
                                                 conditionalPanel(
                                                   condition = paste0("input['", option[i], "'] == 'range'"),
                                                   ns = ns,
                                                   h6("values between:")
                                                 ),
                                                 numericInput(
                                                   inputId = ns(inputFirst[i]),
                                                   label = NULL,
                                                   step = 0.001,
                                                   value = 0
                                                 ),
                                                 conditionalPanel(
                                                   condition = paste0("input['", option[i], "'] == 'extremes'"),
                                                   ns = ns,
                                                   h6("and values less than (or equal to):")
                                                 ),
                                                 conditionalPanel(
                                                   condition = paste0("input['", option[i], "'] == 'range'"),
                                                   ns = ns,
                                                   h6("and:")
                                                 ),
                                                 conditionalPanel(
                                                   condition = paste0("input['", option[i], "'] == 'extremes'
                                                                    || input['", option[i], "'] == 'range'"),
                                                   ns = ns,
                                                   numericInput(
                                                     inputId = ns(inputSecond[i]),
                                                     label = NULL,
                                                     step = 0.001,
                                                     value = 0
                                                   )
                                                 )
          )))
        })
      }
    }
    else if(is.character(dataframe[,i])
            || is.factor(dataframe[,i])){
      if(i == 1){
        output[[paste0("filterOutput",i)]] <- renderUI({
            div(class = class[i], wellPanel(style='border:0;',
                                            checkboxGroupButtons(
                                              inputId = ns(option[i]), label = colnamesDF[i],
                                              choices = c("=", "!="),
                                              justified = FALSE,
                                              individual = FALSE,
                                              size = "xs",
                                              status = "primary"
                                            ),
                                            selectizeInput(
                                              inputId = ns(inputFirst[i]),
                                              choices = unique(dataframe[, colnamesDF[i]]),
                                              label = NULL,
                                              multiple = TRUE
                                            )
            ))
        })
      }
      else{
        output[[paste0("filterOutput",i)]] <- renderUI({
          hidden(
            div(class = class[i], wellPanel(style='border:0;',
                                            checkboxGroupButtons(
                                              inputId = ns(option[i]), label = colnamesDF[i],
                                              choices = c("=", "!="),
                                              justified = FALSE,
                                              individual = FALSE,
                                              size = "xs",
                                              status = "primary"
                                            ),
                                            selectizeInput(
                                              inputId = ns(inputFirst[i]),
                                              choices = unique(dataframe[, colnamesDF[i]]),
                                              label = NULL,
                                              multiple = TRUE
                                            )
            ))
          )
        })
      }
    }
  })

  output$seuratFindMarkerFilter <- renderUI({
    fluidPage(
      fluidRow(
        h6(topText)
      ),
      br(),
      panel(heading = "Active Filters",
            uiOutput(ns("seuratFindMarkerActiveFilters")),
            br(),
            dropdownButton(
              fluidRow(
                panel(
                  column(12,
                         fluidRow(htmlOutput(ns("textTotalRows"))),
                         br(),
                         numericInput(
                           inputId = ns("seuratFindMarkerFilterTopN"),
                           label = "Return a maximum of how many rows?",
                           value = 100,
                           min = 1,
                           step = 1
                         ),
                         actionButton(
                           inputId = ns("seuratFindMarkerFilterRunTopN"),
                           label = "Apply"
                         )
                  )
                )
              ),
              inputId = ns("addFilterDropdownTopN"),
              label = "Set # of Rows",
              circle = FALSE,
              inline = TRUE
            ),
            dropdownButton(
              fluidRow(
                panel(
                  column(12,
                         selectInput(
                           inputId = ns("seuratFindMarkerSelectFilter"),
                           label = "Select column to filter:",
                           choices = colnamesDF
                         ),
                         lapply(seq_along(colnamesDF), function(i) {
                           uiOutput(ns(paste0("filterOutput", i)))
                         }),
                         actionButton(
                           inputId = ns("seuratFindMarkerFilterRun"),
                           label = "Apply Filter"
                         )
                  )
                )
              ),
              inputId = ns("addFilterDropdown"),
              label = "Add Filter",
              circle = FALSE,
              inline = TRUE
            ),
            if(all(rv$parameters$operators == "NULL")){
              disabled(actionButton(
                inputId = ns("seuratFindMarkerRemoveAllFilters"),
                label = "Remove Filter"
              )
              )
            }
            else{
              actionButton(
                inputId = ns("seuratFindMarkerRemoveAllFilters"),
                label = "Remove Filter"
              )
            }
      )
    )
  })

  if(!is.null(defaultFilterColumns)){
    for(i in seq(length(colnamesDF))){
      rv$parameters$operators[i] <- "NULL"
      rv$parameters$values[i] <- "NULL"
    }
    index <- match(defaultFilterColumns, colnamesDF)
    rv$parameters$operators[index] <- defaultFilterOperators
    rv$parameters$values[index] <- defaultFilterValues

    output$textTotalRows <- renderText({
      paste("<b>Total rows available: ", nrow(dataframe), "</br>")
    })
    
    output$seuratFindMarkerTable <- DT::renderDataTable({
      df <- .filterDF(df = dataframe,
                      operators = rv$parameters$operators,
                      cols = colnamesDF,
                      values = rv$parameters$values,
                      topN = initialTopN)
      rv$data <- df
      rv$data
    }, extensions = 'Buttons', options = list(pageLength = 6, dom = "<'top'li>t<'bottom'Bp>", stateSave = TRUE,
                                              buttons = list(
                                                list(
                                                  extend = "collection",
                                                  text = 'Export',
                                                  action = DT::JS(paste0("function ( e, dt, node, config ) {
                                    Shiny.setInputValue('", moduleID,"-export', true, {priority: 'event'});}"))
                                                )
                                              )
    ))

    activeFilters <- list()
    activeFiltersValues <- list()
    if(!is.null(rv$parameters)){
      for(i in seq(length(colnamesDF))){
        if(rv$parameters$operators[i] != 'NULL'){
          activeFilters <- append(activeFilters, paste(colnamesDF[i], rv$parameters$operators[i], rv$parameters$values[i]))
          activeFiltersValues <- append(activeFiltersValues, colnamesDF[i])
        }
      }
    }

    output$seuratFindMarkerActiveFilters <- renderUI({
      panel(
        checkboxGroupInput(
          inputId = ns("checkboxFiltersToRemove"),
          label = NULL,
          choiceNames = as.character(activeFilters),
          choiceValues = as.character(activeFiltersValues)
        )
      )
    })
  }
    else{
      output$textTotalRows <- renderText({
        paste("<b>Total rows available: ", nrow(dataframe), "</br>")
      })
      
      output$seuratFindMarkerTable <- DT::renderDataTable({
        df <- .filterDF(df = dataframe,
                        topN = initialTopN)
        rv$data <- df
        rv$data
      }, extensions = 'Buttons', options = list(pageLength = 6, dom = "<'top'li>t<'bottom'Bp>", stateSave = TRUE,
                                                buttons = list(
                                                  list(
                                                    extend = "collection",
                                                    text = 'Export',
                                                    action = DT::JS(paste0("function ( e, dt, node, config ) {
                                    Shiny.setInputValue('", moduleID,"-export', true, {priority: 'event'});}"))
                                                  )
                                                )
      ))

      output$seuratFindMarkerActiveFilters <- renderUI({
        panel(
          HTML(paste("<span style='color:red'>No active filters!</span>")),
        )
      })
    }

  observeEvent(input$seuratFindMarkerFilterRunTopN,{
    
    output$textTotalRows <- renderText({
      paste("<b>Total rows available: ", nrow(dataframe), "</br>")
    })
    
    output$seuratFindMarkerTable <- DT::renderDataTable({
      isolate({
        df <- .filterDF(df = dataframe,
                        operators = rv$parameters$operators,
                        cols = colnamesDF,
                        values = rv$parameters$values,
                        topN = input$seuratFindMarkerFilterTopN)
        rv$data <- df
        rv$data
      })
    }, extensions = 'Buttons', options = list(pageLength = 6, dom = "<'top'li>t<'bottom'Bp>", stateSave = TRUE,
                                              buttons = list(
                                                list(
                                                  extend = "collection",
                                                  text = 'Export',
                                                  action = DT::JS(paste0("function ( e, dt, node, config ) {
                                    Shiny.setInputValue('", moduleID,"-export', true, {priority: 'event'});}"))
                                                )
                                              )
    ))
  })
  
  observeEvent(input$seuratFindMarkerFilterRun,{
    #update table
    updateSeuratFindMarkerTable()

    updateSelectInput(
      session = session,
      inputId = "seuratFindMarkerSelectFilter",
      selected = colnamesDF[1]
    )
    #reset inputs
    lapply(1:length(colnamesDF), function(i) {
      if(is.numeric(dataframe[,i])){
        if(input$seuratFindMarkerSelectFilter == colnamesDF[i]){
          output[[paste0("filterOutput",i)]] <- renderUI({
            div(class = class[i], wellPanel(style='border:1;',
                                                   checkboxGroupButtons(
                                                     inputId = ns(option[i]),
                                                     label = colnamesDF[i],
                                                     choices = c("<", ">", "=", "<=", ">=",
                                                                 "extremes", "range"),
                                                     justified = FALSE,
                                                     individual = FALSE,
                                                     size = "xs",
                                                     status = "primary"
                                                   ),
                                            conditionalPanel(
                                              condition = paste0("input['", option[i], "'] == 'extremes'"),
                                              ns = ns,
                                              h6("values greater than (or equal to):")
                                            ),
                                            conditionalPanel(
                                              condition = paste0("input['", option[i], "'] == 'range'"),
                                              ns = ns,
                                              h6("values between:")
                                            ),
                                                   numericInput(
                                                     inputId = ns(inputFirst[i]),
                                                     label = NULL,
                                                     step = 0.001,
                                                     value = 0
                                                   ),
                                            conditionalPanel(
                                              condition = paste0("input['", option[i], "'] == 'extremes'"),
                                              ns = ns,
                                              h6("and values less than (or equal to):")
                                            ),
                                            conditionalPanel(
                                              condition = paste0("input['", option[i], "'] == 'range'"),
                                              ns = ns,
                                              h6("and:")
                                            ),
                                                   conditionalPanel(
                                                     condition = paste0("input['", option[i], "'] == 'extremes'
                                                                    || input['", option[i], "'] == 'range'"),
                                                     ns = ns,
                                                     numericInput(
                                                       inputId = ns(inputSecond[i]),
                                                       label = NULL,
                                                       step = 0.001,
                                                       value = 0
                                                     )
                                                   )
            ))
          })
        }
        else{
          output[[paste0("filterOutput",i)]] <- renderUI({
            hidden(div(class = class[i], wellPanel(style='border:1;',
                                                   checkboxGroupButtons(
                                                     inputId = ns(option[i]),
                                                     label = colnamesDF[i],
                                                     choices = c("<", ">", "=", "<=", ">=",
                                                                 "extremes", "range"),
                                                     justified = FALSE,
                                                     individual = FALSE,
                                                     size = "xs",
                                                     status = "primary"
                                                   ),
                                                   conditionalPanel(
                                                     condition = paste0("input['", option[i], "'] == 'extremes'"),
                                                     ns = ns,
                                                     h6("values greater than (or equal to):")
                                                   ),
                                                   conditionalPanel(
                                                     condition = paste0("input['", option[i], "'] == 'range'"),
                                                     ns = ns,
                                                     h6("values between:")
                                                   ),
                                                   numericInput(
                                                     inputId = ns(inputFirst[i]),
                                                     label = NULL,
                                                     step = 0.001,
                                                     value = 0
                                                   ),
                                                   conditionalPanel(
                                                     condition = paste0("input['", option[i], "'] == 'extremes'"),
                                                     ns = ns,
                                                     h6("and values less than (or equal to):")
                                                   ),
                                                   conditionalPanel(
                                                     condition = paste0("input['", option[i], "'] == 'range'"),
                                                     ns = ns,
                                                     h6("and:")
                                                   ),
                                                   conditionalPanel(
                                                     condition = paste0("input['", option[i], "'] == 'extremes'
                                                                    || input['", option[i], "'] == 'range'"),
                                                     ns = ns,
                                                     numericInput(
                                                       inputId = ns(inputSecond[i]),
                                                       label = NULL,
                                                       step = 0.001,
                                                       value = 0
                                                     )
                                                   )
            )))
          })
        }
      }
      else if(is.character(dataframe[,i])
              || is.factor(dataframe[,i])){
        if(input$seuratFindMarkerSelectFilter == colnamesDF[i]){
          output[[paste0("filterOutput",i)]] <- renderUI({
              div(class = class[i], wellPanel(style='border:0;',
                                              checkboxGroupButtons(
                                                inputId = ns(option[i]), label = colnamesDF[i],
                                                choices = c("=", "!="),
                                                justified = FALSE,
                                                individual = FALSE,
                                                size = "xs",
                                                status = "primary"
                                              ),
                                              selectizeInput(
                                                inputId = ns(inputFirst[i]),
                                                choices = unique(dataframe[, colnamesDF[i]]),
                                                label = NULL,
                                                multiple = TRUE
                                              )
              ))
          })
        }
        else{
          output[[paste0("filterOutput",i)]] <- renderUI({
            hidden(
              div(class = class[i], wellPanel(style='border:0;',
                                              checkboxGroupButtons(
                                                inputId = ns(option[i]), label = colnamesDF[i],
                                                choices = c("=", "!="),
                                                justified = FALSE,
                                                individual = FALSE,
                                                size = "xs",
                                                status = "primary"
                                              ),
                                              selectizeInput(
                                                inputId = ns(inputFirst[i]),
                                                choices = unique(dataframe[, colnamesDF[i]]),
                                                label = NULL,
                                                multiple = TRUE
                                              )
              ))
            )
          })
        }
      }
    })

    shinyjs::enable(id = "seuratFindMarkerRemoveAllFilters")
  })

  updateSeuratFindMarkerTable <- function(){
    df <- NULL
    parameters <- list()
    parameters$operators <- list()
    parameters$values <- list()
    for(i in seq(length(colnamesDF))){
      if(is.null(input[[option[i]]])){
        parameters$operators[i] <- "NULL"
      }
      else{
        parameters$operators[i] <- input[[option[i]]]
      }
      if(is.null(input[[inputFirst[i]]])){
        parameters$values[i] <- "NULL"
      }
      else{
        if(!is.null(input[[option[i]]])){
          if(input[[option[i]]] == "range" || input[[option[i]]] == "extremes"){
            parameters$values[i] <- paste0(input[[inputFirst[i]]], ",", input[[inputSecond[i]]])
          }
          else{
            parameters$values[i] <- paste0(input[[inputFirst[i]]], collapse = ",")
          }
        }
        else{
          parameters$values[i] <- paste0(input[[inputFirst[i]]], collapse = ",")
        }
      }
    }

    if(!is.null(rv$parameters)){
      for(i in seq(length(colnamesDF))){
        if(parameters$operators[i] != "NULL"){
          rv$parameters$operators[i] <- parameters$operators[i]
          rv$parameters$values[i] <- parameters$values[i]
        }
      }
    }
    else{
      rv$parameters <- parameters
    }

    df <- .filterDF(df = dataframe,
                                   operators = rv$parameters$operators,
                                   cols = colnamesDF,
                                   values = rv$parameters$values,
                    topN = initialTopN)



    output$textTotalRows <- renderText({
      paste("<b>Total rows available: ", nrow(dataframe), "</br>")
    })

    output$seuratFindMarkerTable <- DT::renderDataTable({
      df
    }, extensions = 'Buttons', options = list(pageLength = 6, dom = "<'top'li>t<'bottom'Bp>", stateSave = TRUE,
                                              buttons = list(
                                                list(
                                                  extend = "collection",
                                                  text = 'Export',
                                                  action = DT::JS(paste0("function ( e, dt, node, config ) {
                                    Shiny.setInputValue('", moduleID,"-export', true, {priority: 'event'});}"))
                                                )
                                              )
    ))


    activeFilters <- list()
    activeFiltersValues <- list()
    if(!is.null(rv$parameters)){
      for(i in seq(length(colnamesDF))){
        if(rv$parameters$operators[i] != 'NULL'){
          activeFilters <- append(activeFilters, paste(colnamesDF[i], rv$parameters$operators[i], rv$parameters$values[i]))
          activeFiltersValues <- append(activeFiltersValues, colnamesDF[i])
        }
      }
    }

    output$seuratFindMarkerActiveFilters <- renderUI({
      panel(
              checkboxGroupInput(
                inputId = ns("checkboxFiltersToRemove"),
                label = NULL,
                choiceNames = as.character(activeFilters),
                choiceValues = as.character(activeFiltersValues)
              )
      )
    })


    if(!is.null(df)){
      rv$data <- df
    }
  }

  seuratfindMarkerTableObserve <- observe(suspended = FALSE, {
                                            input$seuratFindMarkerTable_rows_selected
                                            isolate({
                                              if(!is.null(input$seuratFindMarkerTable_rows_selected)){
                                                rv$selectedRows <- input$seuratFindMarkerTable_rows_selected
                                              }
                                            })
                                          })

  observeEvent(input$seuratFindMarkerSelectFilter,{
    shinyjs::show(selector = paste0(".class_", input$seuratFindMarkerSelectFilter))
    for(i in seq(length(class))){
      if(class[i] != paste0("class_", input$seuratFindMarkerSelectFilter)){
        shinyjs::hide(selector = paste0(".", class[i]))
      }
    }
  })

  observeEvent(input$seuratFindMarkerRemoveAllFilters, {
    index <- match(input$checkboxFiltersToRemove, colnamesDF)
    rv$parameters$operators[index] <- "NULL"

    df <- .filterDF(df = dataframe,
                    operators = rv$parameters$operators,
                    cols = colnamesDF,
                    values = rv$parameters$values,
                    topN = initialTopN)

    rv$data <- df

    output$textTotalRows <- renderText({
      paste("<b>Total rows available: ", nrow(dataframe), "</br>")
    })
    
    output$seuratFindMarkerTable <- DT::renderDataTable({
      df
    }, extensions = 'Buttons', options = list(pageLength = 6, dom = "<'top'li>t<'bottom'Bp>", stateSave = TRUE,
                                              buttons = list(
                                                list(
                                                  extend = "collection",
                                                  text = 'Export',
                                                  action = DT::JS(paste0("function ( e, dt, node, config ) {
                                    Shiny.setInputValue('", moduleID,"-export', true, {priority: 'event'});}"))
                                                )
                                              )
    ))

    activeFilters <- list()
    activeFiltersValues <- list()
    if(!is.null(rv$parameters)){
      for(i in seq(length(colnamesDF))){
        if(rv$parameters$operators[i] != 'NULL'){
          rv$parameters$operators[i]
          activeFilters <- append(activeFilters, paste(colnamesDF[i], rv$parameters$operators[i], rv$parameters$values[i]))
          activeFiltersValues <- append(activeFiltersValues, colnamesDF[i])
        }
      }
    }

    output$seuratFindMarkerActiveFilters <- renderUI({
      panel(
        checkboxGroupInput(
          inputId = ns("checkboxFiltersToRemove"),
          label = NULL,
          choiceNames = as.character(activeFilters),
          choiceValues = as.character(activeFiltersValues)
        )
      )
    })

    updateSelectInput(
      session = session,
      inputId = "seuratFindMarkerSelectFilter",
      selected = colnamesDF[index]
    )

  })

  observe({
    req(rv)
    if(all(rv$parameters$operators == "NULL")){
      shinyjs::disable(id = "seuratFindMarkerRemoveAllFilters")
      output$seuratFindMarkerActiveFilters <- renderUI({
        panel(
          HTML(paste("<span style='color:red'>No active filters!</span>")),
        )
      })
    }
    else{
      shinyjs::enable(id = "seuratFindMarkerRemoveAllFilters")
    }
  })


  observeEvent(input$export, {
    showModal(
      modalDialog(actionButton(ns("dlCSV"),"Download as CSV"),
                  br(),
                  actionButton(ns("dlPDF"),"Download as PDF"),
                  easyClose = TRUE, title = "Export Table"))
  })

  observeEvent(input$dlCSV, {
    write.csv(rv$data, file = paste0(moduleID, "-", Sys.Date(), ".csv"), row.names = TRUE)
    showNotification("Table saved in working directory as", paste0(moduleID, "-", Sys.Date(), ".csv"), duration = 10)
    removeModal()
  })

  observeEvent(input$dlPDF, {
    df <- rv$data
    dim(df)
    maxrow = 35
    npages = ceiling(nrow(df)/maxrow)
    pdf(paste0(moduleID, "-", Sys.Date(), ".pdf"), height = 11, width = 8.5)
    idx = seq(1, maxrow)
    grid.table(df[idx,],rows = NULL)
    for(i in 2:npages){
      grid.newpage();
      if(i*maxrow <= nrow(df)){
        idx = seq(1+((i-1)*maxrow), i * maxrow)
      }
      else{
        idx = seq(1+((i-1)*maxrow), nrow(df))
      }
      grid.table(df[idx, ],rows = NULL)
    }
    dev.off()
    showNotification("Table saved in working directory as", paste0(moduleID, "-", Sys.Date(), ".pdf"), duration = 10)
    removeModal()
  })


  return(rv)
}

.filterDF <- function(df, operators = NULL, cols = NULL, values = NULL, topN = 100){
  filters <- NULL
  if(!is.null(operators)){
    for(i in seq(length(cols))){
      if(operators[i]!="NULL"){
        if(operators[i] == "="){
          operators[i] <- "=="
          df <- df %>% dplyr::filter(eval(parse(text = cols[i])) == strsplit(values[[1]], split = ',')[[1]])
          next
          }
          if(operators[i] == "range" || operators[i] == "extremes"){
            splitValues <- values[[i]]
            splitValues <- strsplit(splitValues, ",")
            if(operators[i] == "range"){
              filters <- c(filters, paste0("eval(call('", ">=", "', df[['", cols[i], "']],", splitValues[[1]][1], "))"))
              filters <- c(filters, paste0("eval(call('", "<=", "', df[['", cols[i], "']],", splitValues[[1]][2], "))"))
            }
            else{
              filters <- c(filters, paste0("df[['", cols[i],"']] >= ", splitValues[[1]][1]," | df[['", cols[i],"']] <= ", splitValues[[1]][2]))
            }
          }
          else{
            if(is.na(as.numeric(values[i]))){
              values[i] <- paste0("'", values[i], "'")
            }
            filters <- c(filters, paste0("eval(call('", operators[i], "', df[['", cols[i], "']],", values[i], "))"))
          }
      }
    }
  }
  filters <- paste(filters, collapse = ",")
    if(is.null(topN)){
      parseString <- paste0("df %>% dplyr::filter(", filters, ")")
    }
    else {
      parseString <- paste0("df %>% dplyr::filter(", filters, ") %>% slice_head(n = ", topN, ")")
    }
    eval(parse(text = parseString))
}

#' Plot UMAP results either on already run results or run first and then plot.
#'
#' @param inSCE Input \linkS4class{SingleCellExperiment} object with saved
#' dimension reduction components. Required
#' @param colorBy color by a condition(any column of the annotation data).
#' @param shape add shapes to each condition.
#' @param reducedDimName saved dimension reduction name in the
#' \linkS4class{SingleCellExperiment} object. Required.
#' @param runUMAP If the dimension reduction components are already available
#' set this to FALSE, otherwise set to TRUE. Default is False.
#' @param useAssay Indicate which assay to use. The default is "logcounts"
#'
#' @return a UMAP plot of the reduced dimensions.
#' @export
#'
#' @examples
#' data(scExample, package = "singleCellTK")
#' sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
#' sce <- runQuickUMAP(sce)
#' plotUMAP(sce)
plotUMAP <- function(inSCE, colorBy = NULL, shape = NULL,
                     reducedDimName = "UMAP", runUMAP = FALSE,
                     useAssay = "counts"){
  if(!(reducedDimName %in% names(SingleCellExperiment::reducedDims(inSCE)))){
    if (runUMAP){
      inSCE <- runQuickUMAP(inSCE, useAssay = useAssay,
                            reducedDimName = reducedDimName)
    } else {
      stop(reducedDimName,
           " dimension not found. Run `runUMAP()` or set `runUMAP` to `TRUE`.")
    }
  }
  UMAPDf <- data.frame(SingleCellExperiment::reducedDim(inSCE,
                                                        reducedDimName))
  if (ncol(UMAPDf) > 2){
    warning("More than two UMAP dimensions. Using the first two.")
  }
  colnames(UMAPDf)[1] <- "UMAP1"
  colnames(UMAPDf)[2] <- "UMAP2"
  xdim <- colnames(UMAPDf)[1]
  ydim <- colnames(UMAPDf)[2]

  if (!is.null(colorBy)){
    UMAPDf$color <- SingleCellExperiment::colData(inSCE)[, colorBy]
  }
  if (!is.null(shape)){
    UMAPDf$shape <- factor(SingleCellExperiment::colData(inSCE)[, shape])
  }
  UMAPDf$Sample <- colnames(inSCE)
  g <- ggplot2::ggplot(UMAPDf, ggplot2::aes_string(xdim, ydim,
                                                   label = "Sample")) +
    ggplot2::geom_point()
  if (!is.null(colorBy)){
    g <- g + ggplot2::aes_string(color = "color") +
      ggplot2::labs(color = colorBy)
  }
  if (!is.null(shape)){
    g <- g + ggplot2::aes_string(shape = "shape") +
      ggplot2::labs(shape = shape)
  }
  return(g)
}

shinyPanelCellViewer <- fluidPage(tags$div(
  class = "container",
  h1("Cell Viewer"),
  p("Plotting tools for data visualization.",
    style = "color:grey;"),
  h5(tags$a(href = paste0(docs.artPath, "visualization.html"),
            "(help)", target = "_blank")),
  radioGroupButtons(
    "viewertabs",
    choices = c("Scatter Plot", "Bar Plot", "Violin/Box Plot"),
    selected = NULL
  ),
  fluidRow(column(
    3,
    wellPanel(
      # Section 1 - Assay Settings
      actionButton("cv_button1", h4(strong("Select Coordinates"))),
      # open by default
      tags$div(
        id = "cv_collapse1",
        selectInput(
          inputId = "QuickAccess",
          label = NULL,
          choices = c("", approach_list, "Custom")
        ),
        #-+-+-+-+-+-X-Axis###################################
        conditionalPanel(
          condition = sprintf("input['%s'] == 'Custom'", "QuickAccess"),
          h5(strong("X-Axis")),
          selectInput(
            "TypeSelect_Xaxis",
            h5("Data"),
            choices = c("Reduced Dimensions", "Expression Assays", "Cell Annotation")
          ),
          #Reduced Dimensions condition
          conditionalPanel(
            condition = sprintf("input['%s'] == 'Reduced Dimensions'", "TypeSelect_Xaxis"),
            selectizeInput(
              "ApproachSelect_Xaxis",
              label = h5("Approach"),
              choices = c(approach_list)
            ),
            selectInput("ColumnSelect_Xaxis", h5("Dimension"), choices = NULL)
          ),

          #Expression Assays condition
          conditionalPanel(
            condition = sprintf("input['%s'] == 'Expression Assays'", "TypeSelect_Xaxis"),
            selectizeInput(
              inputId = "AdvancedMethodSelect_Xaxis", 
              label = "Select input matrix:", 
              choices = NULL, 
              selected = NULL, 
              multiple = FALSE,
              options = NULL),
            #uiOutput("AdvancedMethodSelect_Xaxis"),
            selectizeInput(
              "GeneSelect_Assays_Xaxis",
              label = h5("Feature"),
              choices = c(gene_list)
            )
          ),

          #Cell Annotation condition
          conditionalPanel(
            condition = sprintf("input['%s'] == 'Cell Annotation'", "TypeSelect_Xaxis"),
            selectizeInput(
              "AnnotationSelect_Xaxis",
              label = h5("Annotation"),
              choices = c(annotation_list)
            )
          ),

          #-+-+-+-+-+-Y-Axis###################################
          h5(strong("Y-Axis")),
          selectInput(
            "TypeSelect_Yaxis",
            h5("Data"),
            choices = c("Reduced Dimensions", "Expression Assays", "Cell Annotation")
          ),
          #Reduced Dimensions condition
          conditionalPanel(
            condition = sprintf("input['%s'] == 'Reduced Dimensions'", "TypeSelect_Yaxis"),
            selectizeInput(
              "ApproachSelect_Yaxis",
              label = h5("Approach"),
              choices = c(approach_list)
            ),
            selectInput("ColumnSelect_Yaxis", h5("Dimension"), choices = NULL)
          ),

          #Expression Assays condition
          conditionalPanel(
            condition = sprintf("input['%s'] == 'Expression Assays'", "TypeSelect_Yaxis"),
            selectizeInput(
              inputId = "AdvancedMethodSelect_Yaxis", 
              label = "Select input matrix:", 
              choices = NULL, 
              selected = NULL, 
              multiple = FALSE,
              options = NULL),
            #uiOutput("AdvancedMethodSelect_Yaxis"),
            selectizeInput(
              "GeneSelect_Assays_Yaxis",
              label = h5("Feature"),
              choices = c(gene_list)
            )
          ),

          #Cell Annotation condition
          conditionalPanel(
            condition = sprintf("input['%s'] == 'Cell Annotation'", "TypeSelect_Yaxis"),
            selectizeInput(
              "AnnotationSelect_Yaxis",
              label = h5("Annotation"),
              choices = c(annotation_list)
            )
          )

        )
      ),

      #-+-+-+-+-+-colorby part1###################################
      tags$hr(),
      #Select Color by Data
      # Section 1 - Assay Settings
      actionButton("cv_button2", h4(strong("Color"))),

      # open by default
      tags$div(
        id = "cv_collapse2",
        selectInput(
          'TypeSelect_Colorby', h5(strong('Color By')), choices = c(
            "Single Color",
            "Reduced Dimensions",
            "Expression Assays",
            "Cell Annotation"
          ),
        ),
        # Single Color condition
        conditionalPanel(
          condition = sprintf("input['%s'] == 'Single Color'", "TypeSelect_Colorby"),
          colourInput("Col", "", "purple", palette = 'limited')
        ),
        #Reduced Dimensions condition
        conditionalPanel(
          condition = sprintf("input['%s'] == 'Reduced Dimensions'", "TypeSelect_Colorby"),
          selectizeInput(
            "ApproachSelect_Colorby",
            label = h5("Approach"),
            choices = c(approach_list)
          ),
          selectInput("ColumnSelect_Colorby", h5("Dimension"), choices = NULL)
        ),

        #Expression Assays condition
        conditionalPanel(
          condition = sprintf("input['%s'] == 'Expression Assays'", "TypeSelect_Colorby"),
          selectizeInput(
            inputId = "AdvancedMethodSelect_Colorby", 
            label = "Select input matrix:", 
            choices = NULL, 
            selected = NULL, 
            multiple = FALSE,
            options = NULL),
          #uiOutput("AdvancedMethodSelect_Colorby"),
          selectizeInput(
            "GeneSelect_Assays_Colorby",
            label = h5("Feature"),
            choices = c(gene_list)
          )
        ),

        #Cell Annotation condition
        conditionalPanel(
          condition = sprintf("input['%s'] == 'Cell Annotation'", "TypeSelect_Colorby"),
          selectizeInput(
            "AnnotationSelect_Colorby",
            label = h5("Annotation"),
            choices = c(annotation_list)
          )
        ),

        # && output.hide_typebtns == 'show'
        #-+-+-+-+-+-colorby part2###################################
        conditionalPanel(
          condition = sprintf("input['TypeSelect_Colorby'] != 'Single Color' && output.hide_typebtns == 'show'"),
          radioButtons(
            "SelectColorType",
            label = NULL,
            choices = c("Categorical", "Continuous"),
          ),
        ),
        hidden(
          tags$div(
            id = "continuousColorConditional",
            colourInput("highColor", "High Color", "blue", "background", "limited"),
            colourInput("midColor", "Middle Color", "#666666", "background", "limited"),
            colourInput("lowColor", "Low Color", "white", "background", "limited")
          )
        ),
        hidden(tags$div(
          id = "categoricalColorConditional",
          selectizeInput(
            "colorTheme",
            label = h5("Color Scheme"),
            c("ggplot", "celda", "random")
          ),
          uiOutput("categoricalColorUI")
        )),
        conditionalPanel(
          id="binningConditional",
          condition = sprintf("input['%s'] == 'Continuous' && input['%s'] != 'Single Color'", "SelectColorType", "TypeSelect_Colorby"),
            #sprintf("input['%s'] == 'Continuous'", "SelectColorType"),
          #checkboxInput("checkColorbinning", "Perform Binning", value = FALSE)
          h5(style="display: inline-block; margin-top: 0px; margin-bottom: 20px","Perform Binning"),
          prettyToggle(
            inputId = "checkColorbinning",
            label_on = "Yes",
            label_off = "No",
            value = FALSE,
            inline = TRUE,
            shape = "curve",
            width = "100%"
          )
          #switchInput(
          #  inputId = "checkColorbinning",
          #  onLabel = "Yes",
          #  offLabel = "No",
          #  value=FALSE,
          #  inline = TRUE,
          #  #shape = "curve"
          #  labelWidth = "50px",
          #  width = "auto"
          #)
        ),
        conditionalPanel(
          condition =  "input.checkColorbinning == 1 && output.hide_bins == 'show'",
          numericInput(
            "adjustColorbinning",
            h5("Number of Bins"),
            value = 2,
            min = 2
          )
        )
      ),
      #-+-+-+-+-+-group by###################################
      tags$hr(),
      shinyjs::useShinyjs(),
      # Section 1 - Assay Settings
      actionButton("cv_button3", h4(strong("Group By"))),
      # open by default
      tags$div(
        id = "cv_collapse3",
        selectizeInput(
          inputId = "adjustgroupby",
          label = NULL,
          choices = c("None", annotation_list)
        )
        #,
        #       conditionalPanel(condition = sprintf("input['%s'] != 'None'", "adjustgroupby"),
        #                       radioButtons("SelectValueType",label = NULL,choices = c("Categorical", "Continuous")),
        #                       conditionalPanel(condition = sprintf("input['%s'] == 'Continuous'", "SelectValueType"),
        #                                         checkboxInput("checkbinning",h5("Perform Binning:"), value = FALSE)),
        #                       conditionalPanel(condition = "input.checkbinning == 1",
        #                                         numericInput("adjustbinning", h5("Number of Bins:"),value = 2, min =2))
        #       )
      ),
      tags$hr(),
      conditionalPanel(
        id="violinConditional",
        condition = sprintf("input['%s'] == 'Violin/Box Plot'", "viewertabs"),
        # checkboxInput("vlnboxcheck", "Violin plot", value = FALSE),
        h5(style="display: inline-block; margin-top: 0px; margin-bottom: 20px","Use Violin Plot"),
        switchInput(
          inputId = "vlnboxcheck",
          onLabel = "Yes",
          offLabel = "No",
          value=FALSE,
          size="mini",
          inline = TRUE
        )
      ),
      actionButton("runCellViewer", "Plot")
    )
  ), #sidebarPanel_end
  #-+-+-+-+-+-mainPanel#################################
  column(
    9,
    wellPanel(
      h5(strong("Plotting Region")),
      plotlyOutput("scatter", height = "600px"),# %>% withSpinner(size = 3, color = "#0dc5c1", type = 8),
      tags$br(),
      # conditionalPanel("$('#scatter').hasClass('recalculating')",
      #                  tags$div('Your plot is loading, due to large manipulation.
      #                           This message will disappear once the plot is generated.')),
      tags$hr(),
      fluidRow(
        column(6, textInput("adjusttitle", h5(strong(
          "Title:"
        )))),
        column(6, textInput("adjustlegendtitle", h5(
          strong("Legend title:")
        ))),
        column(6, textInput("adjustxlab", h5(
          strong("X-axis label:")
        ))),
        column(6, textInput("adjustylab", h5(
          strong("Y-axis label:")
        ))),
        column(3, numericInput(
          "adjustlegendtitlesize",
          h5(strong("Legend title size:")),
          min = 1,
          max = 20,
          value = 12
        )),
        column(3, numericInput(
          "adjustlegendsize",
          h5(strong("Legend size:")),
          min = 1,
          max = 20,
          value = 10
        )),
        column(3, numericInput(
          "adjustaxissize",
          h5(strong("Axis size:")),
          min = 1,
          max = 20,
          value = 10
        )),
        column(3, numericInput(
          "adjustaxislabelsize",
          h5(strong("Axis label size:")),
          min = 1,
          max = 20,
          value = 10
        )),
        column(3, numericInput(
          "adjustalpha",
          h5(strong("Opacity:")),
          min = 0,
          max = 1,
          value = 1,
          step = 0.1
        )),
        column(3, numericInput(
          "adjustsize",
          h5(strong("Dot size:")),
          min = 0.1,
          max = 0.8,
          value = 0.45
        )),
        column(3, checkboxInput(
          "adjustgridlines",
          h5(strong("Use default theme")),
          value = FALSE,
        ))
      )
    )
  ))
))

.convert_hex_to_int <- function(hex) {
  code = paste0("hash = str(int('", hex, "', base=16))[-10:]")
  reticulate::py_run_string(code)
  reticulate::py$hash
}

#' Export data in Seurat object
#' @param inSCE A \link[SingleCellExperiment]{SingleCellExperiment} object
#' that contains the data. QC metrics are stored in colData of the
#' singleCellExperiment object.
#' @param outputDir Path to the directory where outputs will be written. Default is the current working directory.
#' @param prefix Prefix to use for the name of the output file. Default \code{"sample"}.
#' @param overwrite Boolean. Whether overwrite the output if it already exists in the outputDir. Default \code{TRUE}.
#' @param copyColData Boolean. Whether copy 'colData' of SCE object to the 'meta.data' of Seurat object. Default \code{TRUE}.
#' @param copyReducedDim Boolean. Whether copy 'reducedDims' of the SCE object to the 'reductions' of Seurat object. Default \code{TRUE}.
#' @param copyDecontX Boolean. Whether copy 'decontXcounts' assay of the SCE object to the 'assays' of Seurat object. Default \code{TRUE}.
#' @return Generates a Seurat object containing data from \code{inSCE}.
#' @export

exportSCEToSeurat <- function(inSCE, prefix="sample", outputDir="./", overwrite=TRUE,
                              copyColData=TRUE, copyReducedDim=TRUE,
                              copyDecontX=TRUE) {
  Seurat <- singleCellTK::convertSCEToSeurat(inSCE, countsAssay = "counts", 
                                             copyColData = copyColData,
                                             copyReducedDim = copyReducedDim,
                                             copyDecontX = copyDecontX)

  fileName <- paste0(prefix,"_Seurat.RDS")
  filePath <- file.path(outputDir,fileName)

  if (!dir.exists(outputDir)) {
    message("outputDir does not exists. Create the directory. ")
    dir.create(outputDir)
  }

  if (file.exists(filePath) && !isTRUE(overwrite)) {
    p <- paste0(path, " already exists. Change 'outputDir' or set 'overwrite' to TRUE.")
    stop(p)
  }


  saveRDS(Seurat, filePath)
}

#' Export data in SingleCellExperiment object
#' @param inSCE A \link[SingleCellExperiment]{SingleCellExperiment} object
#' that contains the data. QC metrics are stored in colData of the
#' singleCellExperiment object.
#' @param samplename Sample name. This will be used as name of subdirectories
#' and the prefix of flat file output. Default is 'sample'.
#' @param type Type of data. The type of data stored in SingleCellExperiment object.
#' It can be 'Droplets'(raw droplets matrix) or 'Cells' (cells matrix).
#' @param directory Output directory. Default is './'.
#' @param format The format of output. It currently supports flat files, rds files
#' and python h5 files. It can output multiple formats. Default: c("SCE", "AnnData", "FlatFile", "HTAN").
#' @return Generates a file containing data from \code{inSCE}, in specified \code{format}.
#' @examples
#' data(scExample)
#' \dontrun{
#' exportSCE(sce, format = "SCE")
#' }
#' @export
exportSCE <- function(inSCE,
                      samplename = "sample",
                      directory = "./",
                      type = "Cells",
                      format = c("SCE", "AnnData", "FlatFile", "HTAN", "Seurat")) {

    if (any(!format %in% c("SCE", "AnnData", "FlatFile", "HTAN", "Seurat"))) {
        p <- paste(format[!format %in% c("SCE", "AnnData", "FlatFile", "HTAN")], sep = ",")
        warning("Output format must be 'SCE', 'AnnData', 'HTAN', 'Seurat' or 'FlatFile'. Format ",
             p,
             " is not supported now. ") #             "Only output the supported formats in the provided options. "
    }

    format <- format[format %in% c("SCE", "AnnData", "FlatFile", "HTAN", "Seurat")]
    message("The output format is [",
            paste(format, collapse = ","), "]. ")

    if (length(format) == 0) {
        warning("None of the provided format is supported now. Therefore, the output ",
            "will be SCE, AnnData, FlatFile, Seurat and HTAN. ")
        format <- c("SCE", "AnnData", "FlatFile", "HTAN", "Seurat")
    }

    ## Create directories and save objects
    dir.create(file.path(directory, samplename), showWarnings = TRUE, recursive = TRUE)

    if ("SCE" %in% format) {
        ## Export to R
        fp <- file.path(directory, samplename, "R")
        dir.create(fp, showWarnings = TRUE, recursive = TRUE)
        fn <- file.path(fp, paste0(samplename , paste0("_", type, ".rds")))
        saveRDS(object = inSCE, file = fn)
    }

    if ("FlatFile" %in% format) {
        ## Export to flatfile
        fp <- file.path(directory, samplename, "FlatFile")
        dir.create(fp, showWarnings = TRUE, recursive = TRUE)
        fn <- file.path(fp, type)
        exportSCEtoFlatFile(inSCE, outputDir = fn, prefix=samplename)
    }

    if ("AnnData" %in% format) {
        ## Export to Python AnnData
        fp <- file.path(directory, samplename, "Python")
        dir.create(fp, showWarnings = TRUE, recursive = TRUE)
        fn <- file.path(fp, type)
        exportSCEtoAnnData(inSCE, outputDir=fn, compression='gzip', prefix=samplename)
    }

    if ("Seurat" %in% format) {
        ## Export to Seurat object
        fp <- file.path(directory, samplename, "Seurat")
        dir.create(fp, showWarnings = TRUE, recursive = TRUE)
        prefix <- paste0(samplename , paste0("_", type, ".rds"))
        exportSCEToSeurat(inSCE, prefix = prefix, outputDir = fp, overwrite = TRUE)
    }
}


#' Generate HTAN manifest file for droplet and cell count data
#' @param dropletSCE A \link[SingleCellExperiment]{SingleCellExperiment} object containing
#' droplet count matrix data
#' @param cellSCE A \link[SingleCellExperiment]{SingleCellExperiment} object containing
#' cell count matrix data
#' @param samplename The sample name of the \link[SingleCellExperiment]{SingleCellExperiment} objects
#' @param dir The output directory of the SCTK QC pipeline.
#' @param dataType Type of the input data. It can be one of "Droplet", "Cell" or "Both".
#' @param HTAN Whether generates manifest file including HTAN specific ID (HTAN Biospecimen ID, 
#' HTAN parent file ID and HTAN patient ID). Default is TRUE. 
#' @return A \link[SingleCellExperiment]{SingleCellExperiment} object which combines all
#' objects in sceList. The colData is merged.
#' @export

generateMeta <- function(dropletSCE = NULL,
                          cellSCE = NULL,
                          samplename,
                          dir,
                          HTAN=TRUE,
                          dataType = c("Droplet", "Cell", "Both")) {
  level3List <- list()
  level4List <- list()
  dataType = match.arg(dataType)

  directory <- file.path(basename(dir), samplename)
  filterDir <- file.path(directory, 'FlatFile', 'Cells')
  rawDir <- file.path(directory, 'FlatFile', 'Droplets')
  pkgVersion <- Biobase::package.version("singleCellTK")

  WorkFlowData = c(
    WorkFlow = 'Other',
    WorkFlowVer = paste('singleCellTK', pkgVersion, sep=':'),
    ParRaw = 'Ran perCellQC, EmptyDrops and barcodeRankDrops using singleCellTK',
    ParFiltered = 'Ran perCellQC, doublet detection and decontX using singleCellTK',
    PardecontX = 'Ran perCellQC, doublet detection and decontX using singleCellTK',
    PardecontX_bg = 'Ran perCellQC, doublet detection and decontX(with background matrix) using singleCellTK',
    ParSoupX = 'Ran perCellQC, doublet detection and SoupX using singleCellTK',
    ParSoupX_bg = 'Ran perCellQC, doublet detection and SoupX(with background matrix) using singleCellTK',
    ColData = 'Ran perCellQC, doublet detection and decontX using singleCellTK.',
    DecontXUMAP = 'UMAP dimension reduction generated by decontX.',
    DecontXUMAPBP = 'UMAP dimension reduction generated by decontX(with background matrix).',
    SoupXUMAP = 'UMAP dimension reduction generated by SoupX.',
    SoupXUMAPBP = 'UMAP dimension reduction generated by SoupX(with background matrix).',
    ScrubletTSNE = 'tSNE dimension reduction generated by Scrublet.',
    ScrubletUMAP = 'UMAP dimension reduction generated by Scrublet.'
  )
  


  ### calculate summary stats
  if (dataType == "Droplet" | dataType == "Both") {
    droplet_stat = c(CellNum = ncol(dropletSCE),
              MedianReads = stats::median(colData(dropletSCE)$sum),
              MedianGenes = stats::median(colData(dropletSCE)$detected),
              DataType = 'Droplet Matrix',
              FileName = file.path(rawDir, 'assays', paste0(samplename,'_counts.mtx.gz')))
  }

  if (dataType == "Cell" | dataType == "Both") {
    if ("decontXcounts" %in% SummarizedExperiment::assayNames(cellSCE)) {
      decontX_stat = c(CellNum = ncol(cellSCE),
                       MedianReads = stats::median(Matrix::colSums(assay(cellSCE, 'decontXcounts'))),
                       MedianGenes = stats::median(Matrix::colSums(assay(cellSCE, 'decontXcounts') > 0)),
                       DataType = 'Decontaminated cell matrix return returned by runDecontX',
                       FileName = file.path(filterDir, 'assays', paste0(samplename,'_decontXcounts.mtx.gz')))      
    }

    if ("decontXcounts_bg" %in% SummarizedExperiment::assayNames(cellSCE)) {
      decontX_bg_stat = c(CellNum = ncol(cellSCE),
                MedianReads = stats::median(Matrix::colSums(assay(cellSCE, 'decontXcounts_bg'))),
                MedianGenes = stats::median(Matrix::colSums(assay(cellSCE, 'decontXcounts_bg') > 0)),
                DataType = 'Decontaminated cell matrix returned by runDecontX , which is run with background count matrix',
                FileName = file.path(filterDir, 'assays', paste0(samplename,'_decontXcounts_bg.mtx.gz')))      
    }

    if ("SoupX" %in% SummarizedExperiment::assayNames(cellSCE)) {
      SoupX_stat = c(CellNum = ncol(cellSCE),
                       MedianReads = stats::median(Matrix::colSums(assay(cellSCE, 'SoupX'))),
                       MedianGenes = stats::median(Matrix::colSums(assay(cellSCE, 'SoupX') > 0)),
                       DataType = 'Decontaminated cell matrix return returned by SoupX',
                       FileName = file.path(filterDir, 'assays', paste0(samplename,'_SoupX.mtx.gz')))      
    }

    if ("SoupX_bg" %in% SummarizedExperiment::assayNames(cellSCE)) {
      SoupX_bg_stat = c(CellNum = ncol(cellSCE),
                MedianReads = stats::median(Matrix::colSums(assay(cellSCE, 'SoupX_bg'))),
                MedianGenes = stats::median(Matrix::colSums(assay(cellSCE, 'SoupX_bg') > 0)),
                DataType = 'Decontaminated cell matrix returned by SoupX , which is run with background count matrix',
                FileName = file.path(filterDir, 'assays', paste0(samplename,'_SoupX_bg.mtx.gz')))      
    }



    cell_stat = c(CellNum = ncol(cellSCE),
                   MedianReads = stats::median(colData(cellSCE)$sum),
                   MedianGenes = stats::median(colData(cellSCE)$detected),
                   DataType = 'Cell Matrix',
                   FileName = file.path(filterDir, 'assays', paste0(samplename,'_counts.mtx.gz')),
                   ColData = file.path(filterDir, paste0(samplename,'_cellData.txt.gz')),
                   DecontXUMAP = file.path(filterDir, 'reducedDims', paste0(samplename,'_decontX_UMAP.txt.gz')),
                   DecontXUMAPBP = file.path(filterDir, 'reducedDims', paste0(samplename,'_decontX_UMAP_bg.txt.gz')),
                   SoupXUMAP = file.path(filterDir, 'reducedDims', paste0(samplename,'_SoupX_UMAP_all_cells.txt.gz')),
                   SoupXUMAPBP = file.path(filterDir, 'reducedDims', paste0(samplename,'_SoupX_bg_UMAP_all_cells.txt.gz')),
                   ScrubletTSNE = file.path(filterDir, 'reducedDims', paste0(samplename,'_scrublet_TSNE.txt.gz')),
                   ScrubletUMAP = file.path(filterDir, 'reducedDims', paste0(samplename,'_scrublet_UMAP.txt.gz')))
  }

  data <- list("Raw" = if (exists("droplet_stat")) {droplet_stat} else {NULL},
               "Filtered" = if (exists("cell_stat")) {cell_stat} else {NULL},
               "decontX" =  if (exists("decontX_stat")) {decontX_stat} else {NULL},
               "decontX_bg" =  if (exists("decontX_bg_stat")) {decontX_bg_stat} else {NULL},
               "SoupX" =  if (exists("SoupX_stat")) {SoupX_stat} else {NULL},
               "SoupX_bg" =  if (exists("SoupX_bg_stat")) {SoupX_bg_stat} else {NULL}
              )


  if (dataType %in% c("Cell", "Both")) {

    if (dataType == "Cell") {
      types <- c("Filtered")
    } else {
      types <- c("Filtered", "Raw")
    }
    
    l4Metrics <- c('ColData', 'ScrubletTSNE', 'ScrubletUMAP')
    if ('decontXcounts' %in% SummarizedExperiment::assayNames(cellSCE)) {
      types <- c(types, "decontX")
      l4Metrics <- c(l4Metrics, "DecontXUMAP")
    }

    if ('decontXcounts_bg' %in% SummarizedExperiment::assayNames(cellSCE)) {
      types <- c(types, "decontX_bg")
      l4Metrics <- c(l4Metrics, "DecontXUMAPBP")
    }

    if ('SoupX' %in% SummarizedExperiment::assayNames(cellSCE)) {
      types <- c(types, "SoupX")
      l4Metrics <- c(l4Metrics, "SoupXUMAP")
    }

    if ('SoupX_bg' %in% SummarizedExperiment::assayNames(cellSCE)) {
      types <- c(types, "SoupX_bg")
      l4Metrics <- c(l4Metrics, "SoupXUMAPBP")
    }    
  } else if (dataType == "Droplet") { 
    types <- c("Raw") 
  }


  for (type in types) {
    level3List[[type]] <- data.frame(
      SAMPLE = samplename, DATA_TYPE = data[[type]]['DataType'],
      MATRIX_TYPE = 'Raw Counts', DATA_CATEGORY = 'Gene Expression',
      CELL_MEDIAN_NUM_READS = data[[type]]['MedianReads'],
      CELL_MEDIAN_NUM_GENES = data[[type]]['MedianGenes'],
      CELL_TOTAL = data[[type]]['CellNum'],
      FILE_NAME = data[[type]]['FileName'],
      WORKFLOW_TYPE = WorkFlowData['WorkFlow'],
      WORKFLOW_PARAMETERS = WorkFlowData[paste0('Par', type)],
      WORKFLOW_VERSION = WorkFlowData['WorkFlowVer'],
      stringsAsFactors = FALSE)

    if (isTRUE(HTAN)) {
      level3List[[type]] <- cbind(level3List[[type]],HTAN_BIOSPECIMEN_ID = samplename,
                                  HTAN_PARENT_ID = '', HTAN_PARENT_FILE_ID = '')
    }

    if (type == 'Filtered') {
      for (metric in l4Metrics) {
        level4List[[metric]] <- data.frame(
          SAMPLE = samplename, FILE_NAME = data[[type]][metric],
          WORKFLOW_TYPE = WorkFlowData[metric],
          WORKFLOW_PARAMETERS = file.path(directory, paste0(samplename, '_QCParameters.yaml')),
          WORKFLOW_VERSION = WorkFlowData['WorkFlowVer'])
        if (isTRUE(HTAN)) {
          level4List[[metric]] <- cbind(level4List[[metric]],  HTAN_BIOSPECIMEN_ID = samplename,
                                        HTAN_PARENT_ID = '',HTAN_PARENT_FILE_ID = data[[type]]['FileName'])
        }
      }
    }
  }

  level3Meta <- do.call(base::rbind, level3List)
  level4Meta <- do.call(base::rbind, level4List)
  return(list(level3Meta, level4Meta))
}

#' Generate HTAN manifest file for droplet and cell count data
#' @param dropletSCE A \link[SingleCellExperiment]{SingleCellExperiment} object containing
#' droplet count matrix data
#' @param cellSCE A \link[SingleCellExperiment]{SingleCellExperiment} object containing
#' cell count matrix data
#' @param samplename The sample name of the \link[SingleCellExperiment]{SingleCellExperiment} objects
#' @param htan_biospecimen_id The HTAN biospecimen id of the sample in \link[SingleCellExperiment]{SingleCellExperiment} object
#' @param dir The output directory of the SCTK QC pipeline.
#' @param dataType Type of the input data. It can be one of "Droplet", "Cell" or "Both".
#' @return A \link[SingleCellExperiment]{SingleCellExperiment} object which combines all
#' objects in sceList. The colData is merged.
#' @export
#' @importFrom rlang .data

generateHTANMeta <- function(dropletSCE = NULL,
                         cellSCE = NULL,
                         samplename,
                         htan_biospecimen_id,
                         dir,
                         dataType = c("Droplet", "Cell", "Both")) {
  level3List <- list()
  level4List <- list()
  dataType = match.arg(dataType)
  
  directory <- file.path(basename(dir), samplename)
  filterDir <- file.path(directory, 'FlatFile', 'Cells')
  rawDir <- file.path(directory, 'FlatFile', 'Droplets')
  
  absFilterDir <- file.path(dir, samplename, 'FlatFile', 'Cells')
  absRawDir <- file.path(dir, samplename, 'FlatFile', 'Droplets')
  
  pkgVersion <- Biobase::package.version("singleCellTK")
  htan_patient_id <- paste(stringr::str_split(htan_biospecimen_id, 
                                              '_', 
                                              simplify = TRUE)[seq(2)], 
                           collapse = '_')
  
  WorkFlowData = c(
    WorkFlow = 'Other',
    WorkFlowVer = paste('singleCellTK', pkgVersion, sep=':'),
    ParRaw = 'Ran perCellQC, EmptyDrops and barcodeRankDrops using singleCellTK',
    ParFiltered = 'Ran perCellQC, doublet detection and decontX using singleCellTK',
    PardecontX = 'Ran perCellQC, doublet detection and decontX using singleCellTK',
    PardecontX_bg = 'Ran perCellQC, doublet detection and decontX(with background matrix) using singleCellTK',
    ParSoupX = 'Ran perCellQC, doublet detection and SoupX using singleCellTK',
    ParSoupX_bg = 'Ran perCellQC, doublet detection and SoupX(with background matrix) using singleCellTK',
    ColData = 'Ran perCellQC, doublet detection and decontX using singleCellTK. Detailed paramters please see: ',
    DecontXUMAP = 'UMAP dimension reduction generated by decontX. Detailed paramters please see: ',
    DecontXUMAPBP = 'UMAP dimension reduction generated by decontX(with background matrix). Detailed paramters please see: ',
    SoupXUMAP = 'UMAP dimension reduction generated by SoupX. Detailed paramters please see: ',
    SoupXUMAPBP = 'UMAP dimension reduction generated by SoupX(with background matrix). Detailed paramters please see: ',
    ScrubletTSNE = 'tSNE dimension reduction generated by Scrublet. Detailed paramters please see: ',
    ScrubletUMAP = 'UMAP dimension reduction generated by Scrublet. Detailed paramters please see: '
  )
  
  ### calculate summary stats
  if (dataType == "Droplet" | dataType == "Both") {
    droplet_stat = c(CellNum = ncol(dropletSCE),
                     MedianReads = stats::median(colData(dropletSCE)$sum),
                     MedianGenes = stats::median(colData(dropletSCE)$detected),
                     DataType = 'Droplet Matrix',
                     FileName = file.path(rawDir, 'assays', paste0(samplename,'_counts.mtx.gz')),
                     AbsFileName = file.path(absRawDir, 'assays', paste0(samplename,'_counts.mtx.gz')))
  }
  
  if (dataType == "Cell" | dataType == "Both") {
    if ("decontXcounts" %in% SummarizedExperiment::assayNames(cellSCE)) {
      decontX_stat = c(CellNum = ncol(cellSCE),
                       MedianReads = stats::median(Matrix::colSums(assay(cellSCE, 'decontXcounts'))),
                       MedianGenes = stats::median(Matrix::colSums(assay(cellSCE, 'decontXcounts') > 0)),
                       DataType = 'Decontaminated cell matrix return returned by runDecontX',
                       FileName = file.path(filterDir, 'assays', paste0(samplename,'_decontXcounts.mtx.gz')),
                       AbsFileName = file.path(absFilterDir, 'assays', paste0(samplename,'_decontXcounts.mtx.gz')))      
    }

    if ("decontXcounts_bg" %in% SummarizedExperiment::assayNames(cellSCE)) {
      decontX_bg_stat = c(CellNum = ncol(cellSCE),
                MedianReads = stats::median(Matrix::colSums(assay(cellSCE, 'decontXcounts_bg'))),
                MedianGenes = stats::median(Matrix::colSums(assay(cellSCE, 'decontXcounts_bg') > 0)),
                DataType = 'Decontaminated cell matrix returned by runDecontX , which is run with background count matrix',
                FileName = file.path(filterDir, 'assays', paste0(samplename,'_decontXcounts_bg.mtx.gz')),
                AbsFileName = file.path(absFilterDir, 'assays', paste0(samplename,'_decontXcounts_bg.mtx.gz')))      
    }

    if ("SoupX" %in% SummarizedExperiment::assayNames(cellSCE)) {
      SoupX_stat = c(CellNum = ncol(cellSCE),
                       MedianReads = stats::median(Matrix::colSums(assay(cellSCE, 'SoupX'))),
                       MedianGenes = stats::median(Matrix::colSums(assay(cellSCE, 'SoupX') > 0)),
                       DataType = 'Decontaminated cell matrix return returned by SoupX',
                       FileName = file.path(filterDir, 'assays', paste0(samplename,'_SoupX.mtx.gz')),
                       AbsFileName = file.path(absFilterDir, 'assays', paste0(samplename,'_SoupX.mtx.gz')))      
    }

    if ("SoupX_bg" %in% SummarizedExperiment::assayNames(cellSCE)) {
      SoupX_bg_stat = c(CellNum = ncol(cellSCE),
                MedianReads = stats::median(Matrix::colSums(assay(cellSCE, 'SoupX_bg'))),
                MedianGenes = stats::median(Matrix::colSums(assay(cellSCE, 'SoupX_bg') > 0)),
                DataType = 'Decontaminated cell matrix returned by SoupX , which is run with background count matrix',
                FileName = file.path(filterDir, 'assays', paste0(samplename,'_SoupX_bg.mtx.gz')),
                AbsFileName = file.path(absFilterDir, 'assays', paste0(samplename,'_SoupX_bg.mtx.gz')))      
    }

    cell_stat = c(CellNum = ncol(cellSCE),
                  MedianReads = stats::median(colData(cellSCE)$sum),
                  MedianGenes = stats::median(colData(cellSCE)$detected),
                  DataType = 'Cell Matrix',
                  FileName = file.path(filterDir, 'assays', paste0(samplename,'_counts.mtx.gz')),
                  AbsFileName = file.path(absFilterDir, 'assays', paste0(samplename,'_counts.mtx.gz')),
                  ColData = file.path(filterDir, paste0(samplename,'_cellData.txt.gz')),
                  AbsColData = file.path(absFilterDir, paste0(samplename,'_cellData.txt.gz')),
                  DecontXUMAP = file.path(filterDir, 'reducedDims', paste0(samplename,'_decontX_UMAP.txt.gz')),
                  AbsDecontXUMAP = file.path(absFilterDir, 'reducedDims', paste0(samplename,'_decontX_UMAP.txt.gz')),
                  DecontXUMAPBP = file.path(filterDir, 'reducedDims', paste0(samplename,'_decontX_UMAP_bg.txt.gz')),                   
                  AbsDecontXUMAPBP = file.path(absFilterDir, 'reducedDims', paste0(samplename,'_decontX_UMAP_bg.txt.gz')),
                  SoupXUMAP = file.path(filterDir, 'reducedDims', paste0(samplename,'_SoupX_UMAP_all_cells.txt.gz')),
                  AbsSoupXUMAP = file.path(absFilterDir, 'reducedDims', paste0(samplename,'_SoupX_UMAP_all_cells.txt.gz')),
                  SoupXUMAPBP = file.path(filterDir, 'reducedDims', paste0(samplename,'_SoupX_bg_UMAP_all_cells.txt.gz')),                   
                  AbsSoupXUMAPBP = file.path(absFilterDir, 'reducedDims', paste0(samplename,'_SoupX_bg_UMAP_all_cells.txt.gz')),
                  ScrubletTSNE = file.path(filterDir, 'reducedDims', paste0(samplename,'_scrublet_TSNE.txt.gz')),
                  AbsScrubletTSNE = file.path(absFilterDir, 'reducedDims', paste0(samplename,'_scrublet_TSNE.txt.gz')),
                  ScrubletUMAP = file.path(filterDir, 'reducedDims', paste0(samplename,'_scrublet_UMAP.txt.gz')),
                  AbsScrubletUMAP = file.path(absFilterDir, 'reducedDims', paste0(samplename,'_scrublet_UMAP.txt.gz')))
  }
  
  data <- list("Raw" = if (exists("droplet_stat")) {droplet_stat} else {NULL},
               "Filtered" = if (exists("cell_stat")) {cell_stat} else {NULL},
               "decontX" =  if (exists("decontX_stat")) {decontX_stat} else {NULL},
               "decontX_bg" =  if (exists("decontX_bg_stat")) {decontX_bg_stat} else {NULL},
               "SoupX" =  if (exists("SoupX_stat")) {SoupX_stat} else {NULL},
               "SoupX_bg" =  if (exists("SoupX_bg_stat")) {SoupX_bg_stat} else {NULL}
              )


  if (dataType %in% c("Cell", "Both")) {

    if (dataType == "Cell") {
      types <- c("Filtered")
    } else {
      types <- c("Filtered", "Raw")
    }
    
    l4Metrics <- c('ColData', 'ScrubletTSNE', 'ScrubletUMAP')
    if ('decontXcounts' %in% SummarizedExperiment::assayNames(cellSCE)) {
      types <- c(types, "decontX")
      l4Metrics <- c(l4Metrics, "DecontXUMAP")
    }

    if ('decontXcounts_bg' %in% SummarizedExperiment::assayNames(cellSCE)) {
      types <- c(types, "decontX_bg")
      l4Metrics <- c(l4Metrics, "DecontXUMAPBP")
    }

    if ('SoupX' %in% SummarizedExperiment::assayNames(cellSCE)) {
      types <- c(types, "SoupX")
      l4Metrics <- c(l4Metrics, "SoupXUMAP")
    }

    if ('SoupX_bg' %in% SummarizedExperiment::assayNames(cellSCE)) {
      types <- c(types, "SoupX_bg")
      l4Metrics <- c(l4Metrics, "SoupXUMAPBP")
    }    
  } else if (dataType == "Droplet") { 
    types <- c("Raw") 
  }
  
  for (type in types) {
    level3List[[type]] <- data.frame(
      'Component' = 'ScRNA-seqLevel3',
      'Filename' = data[[type]]['FileName'],
      'FileLoc' = data[[type]]['AbsFileName'],
      'File Format' = 'mtx',
      'HTAN Biospecimen ID' = htan_biospecimen_id, #DATA_TYPE = data[[type]]['DataType'],
      'Data Category' = 'Gene Expression', 'Matrix Type' = 'Raw Counts',
      'Cell Median Number Reads' = data[[type]]['MedianReads'],
      'Cell Median Number Genes' = data[[type]]['MedianGenes'],
      'Cell Total' = data[[type]]['CellNum'],
      'scRNAseq Workflow Type' = WorkFlowData['WorkFlow'],
      'scRNAseq Workflow Parameters Description' = WorkFlowData[paste0('Par', type)],
      'Workflow Link' = paste0('http://sctk.camplab.net/v', pkgVersion, '/index.html'), 
      'Workflow Version' = WorkFlowData['WorkFlowVer'],
      'Workflow Start Datetime' = '',
      'Workflow End Datetime' = '',
      stringsAsFactors = FALSE, check.names=FALSE)
    
    
    level3List[[type]] <- cbind(level3List[[type]],
                                'HTAN Patient ID' = htan_patient_id, 'HTAN Parent Data File ID' = '',
                                'HTAN Data File ID' = '', 'Linked Matrices' = '')
  
    
    if (type == 'Filtered') {
      for (metric in l4Metrics) {
        level4List[[metric]] <- data.frame(
          'Component' = 'ScRNA-seqLevel4', "Filename" = data[[type]][metric],
          'FileLoc' = data[[type]][paste0('Abs', metric)],
          'File Format' = 'txt', 
          'HTAN Biospecimen ID' = htan_biospecimen_id, 
          'scRNAseq Workflow Type' = 'Other', #WorkFlowData[metric]
          'scRNAseq Workflow Parameters Description' = paste0(WorkFlowData[metric], file.path(directory, paste0(samplename, '_QCParameters.yaml'))),
          'Workflow Version' = WorkFlowData['WorkFlowVer'],
          'Workflow Link' = paste0('http://sctk.camplab.net/v', pkgVersion, '/index.html'),
          'Workflow Start Datetime' = '',
          'Workflow End Datetime' = '',
          stringsAsFactors = FALSE, check.names=FALSE)

        level4List[[metric]] <- cbind(level4List[[metric]], 'HTAN Patient ID' = htan_patient_id,
                                      'HTAN Data File ID' = '','HTAN Parent Data File ID' = '')
      
      }
    }
  }
  

  level3Meta <- do.call(base::rbind, level3List)
  level4Meta <- do.call(base::rbind, level4List)

  level3Meta$checkSumInt <- vapply(level3Meta$FileLoc, function(f) {
    hash <- tools::md5sum(f)
    .convert_hex_to_int(hash)
  }, character(1))
  
  level3Meta$`HTAN Data File ID` <- paste(level3Meta$`HTAN Patient ID`, level3Meta$checkSumInt, sep="_")
  linkMat <- dplyr::group_by(level3Meta, .data$`HTAN Biospecimen ID`) %>% dplyr::summarise(LinkedMat = paste(.data$`HTAN Data File ID`, collapse=","))
  level3Meta$`Linked Matrices` <- unlist(linkMat[match(level3Meta$`HTAN Biospecimen ID`, linkMat$`HTAN Biospecimen ID`), 'LinkedMat'])
  
  ParentFile <- level3Meta[grep("_counts.mtx.gz", unlist(level3Meta['FileLoc'])), c('HTAN Biospecimen ID', 'HTAN Data File ID')]
  level4Meta$`HTAN Parent Data File ID` <- unlist(ParentFile[match(level4Meta$`HTAN Biospecimen ID`, ParentFile$`HTAN Biospecimen ID`), 
                                                             'HTAN Data File ID'])
  
  level4Meta$checkSumInt <- vapply(level4Meta$FileLoc, function(f) {
    hash <- tools::md5sum(f)
    .convert_hex_to_int(hash)
  }, character(1))
  level4Meta$`HTAN Data File ID` <- paste(level4Meta$`HTAN Patient ID`, level4Meta$checkSumInt, sep="_")
  
  level3Meta <- level3Meta[,c("HTAN Biospecimen ID",
                              "Component",
                              "Filename",
                              "File Format",
                              "HTAN Parent Data File ID",
                              "HTAN Data File ID",
                              "Data Category",
                              "Matrix Type",
                              "Linked Matrices",
                              "Cell Median Number Reads",
                              "Cell Median Number Genes",
                              "Cell Total",
                              "scRNAseq Workflow Type",
                              "scRNAseq Workflow Parameters Description",
                              "Workflow Link",
                              "Workflow Version",
                              "Workflow Start Datetime",
                              "Workflow End Datetime")]
  
  level4Meta <- level4Meta[,c("HTAN Biospecimen ID",
                              "Component",
                              "Filename",
                              "File Format",
                              "HTAN Parent Data File ID",
                              "HTAN Data File ID",
                              "scRNAseq Workflow Type",
                              "scRNAseq Workflow Parameters Description",
                              "Workflow Version",
                              "Workflow Link",
                              "Workflow Start Datetime",
                              "Workflow End Datetime")]
  

  return(list(level3Meta, level4Meta))
}

#' Extract QC parameters from the SingleCellExperiment object
#' @param inSCE A \link[SingleCellExperiment]{SingleCellExperiment} object.
#' @param skip Skip extracting the parameters of the provided QC functions.
#' @param ignore Skip extracting the content within QC functions.
#' @param directory The output directory of the SCTK_runQC.R pipeline.
#' @param samplename The sample name of the \link[SingleCellExperiment]{SingleCellExperiment} objects.
#' @param writeYAML Whether output yaml file to store parameters. Default if TRUE. If FALSE,
#' return character object.
#' @return If \code{writeYAML} TRUE, a yaml object will be generated. If FALSE, character object.
#' @export
getSceParams <- function(inSCE,
                         skip = c("runScrublet","runDecontX","runBarcodeRanksMetaOutput","genesets","runSoupX"),
                         ignore = c("algorithms", "estimates","contamination",
                                    "z","sample","rank","BPPARAM","batch","geneSetCollection",
                                    "barcodeArgs"),
                         directory = './',
                         samplename = '',
                         writeYAML = TRUE) {

  meta <- S4Vectors::metadata(inSCE)
  algos <- names(meta$sctk)[! names(meta$sctk) %in% skip]
  # spit duct tape and hope
  # removed runSoupX until output can be trimmed and reworked
  outputs <- '---\n'
  parList <- list()
  dir <- file.path(directory, samplename)

  # TODO: proper accessor implementation instead of spit and duct tape
  for (algo in algos) {
    if (algo %in% skip) {
      next
    }
    params <- meta$sctk[[algo]]
    if (length(params) == 1) {params <- params[[1]]} ### extract params from sublist
    params <- params[which(!names(params) %in% ignore)]
    parList[[algo]] <- params
  }

  parList[['scDblfinder.threshold']] <- meta$scDblFinder.threshold[[1]]

  outputs <- paste(outputs, yaml::as.yaml(parList), line.sep='\n')
  if (isTRUE(writeYAML)) {
    filename <- paste0(samplename, '_QCParameters.yaml')
    cat(outputs, file=file.path(dir, filename))
  } else {
    return(outputs)
  }
}


#' Create SingleCellExperiment object from csv or txt input
#' @param data A \link[data.table]{data.table} object containing the count matrix.
#' @param samplename The sample name of the data.
#' @return A \link[SingleCellExperiment]{SingleCellExperiment} object containing
#' the count matrix.
#' @export
constructSCE <- function(data, samplename) {
    gene <- data[[1]]
    data <- data[, -1]
    barcode <- colnames(data)
    mat <- methods::as(data, "Matrix")
    dimnames(mat) <- list(gene, barcode)
    coln <- paste(samplename, barcode, sep = '_')

    sce <- SingleCellExperiment::SingleCellExperiment(
        assays = list(counts = mat))
    SummarizedExperiment::rowData(sce) <- S4Vectors::DataFrame(feature = gene)
    SummarizedExperiment::colData(sce) <- S4Vectors::DataFrame(barcode,
        column_name = coln,
        sample = samplename,
        row.names = coln)

    return(sce)
}

#' Create SingleCellExperiment object from command line input arguments
#' @param preproc Method used to preprocess the data. It's one of the path provided in --preproc argument.
#' @param path Base path of the dataset. It's one of the path provided in --bash_path argument.
#' @param samplename The sample name of the data. It's one of the path provided in --sample argument.
#' @param raw The directory contains droplet matrix, gene and cell barcodes information. It's one of the path provided in --raw_data_path argument.
#' @param fil The directory contains cell matrix, gene and cell barcodes information. It's one of the path provided in --cell_data_path argument.
#' @param ref The name of reference used by cellranger. Only need for CellrangerV2 data.
#' @param rawFile The full path of the RDS file or Matrix file of the raw gene count matrix. It's one of the path provided in --raw_data argument.
#' @param filFile The full path of the RDS file or Matrix file of the cell count matrix. It's one of the path provided in --cell_data argument.
#' @param flatFiles The full paths of the matrix, barcode, and features (in that order) files used to construct an SCE object.
#' @param dataType Type of the input. It can be "Both", "Droplet" or "Cell". It's one of the path provided in --genome argument.
#' @return A list of \link[SingleCellExperiment]{SingleCellExperiment} object containing
#' the droplet or cell data or both,depending on the dataType that users provided.
#' @export
qcInputProcess <- function(preproc,
    samplename,
    path,
    raw,
    fil,
    ref,
    rawFile,
    filFile,
    flatFiles,
    dataType) {

    dropletSCE <- NULL
    cellSCE <- NULL

    if (preproc == "BUStools") {
        dropletSCE <- importBUStools(BUStoolsDirs = path, samples = samplename, class = "Matrix", delayedArray=FALSE)
        return(list(dropletSCE, cellSCE))
    }

    if (preproc == "SEQC") {
        dropletSCE <- importSEQC(seqcDirs = path, samples = samplename, prefix = samplename, class = "Matrix", delayedArray=FALSE)
        return(list(dropletSCE, cellSCE))
    }

    if (preproc == "STARSolo") {
        if (dataType == "Both") {
            dropletSCE <- importSTARsolo(STARsoloDirs = path, samples = samplename, STARsoloOuts = "Gene/raw", class = "Matrix", delayedArray=FALSE)
            cellSCE <- importSTARsolo(STARsoloDirs = path, samples = samplename, STARsoloOuts = "Gene/filtered", class = "Matrix", delayedArray=FALSE)
        } else if (dataType == "Cell" && !is.null(path)) {
            cellSCE <- importSTARsolo(STARsoloDirs = path, samples = samplename, STARsoloOuts = "Gene/filtered", class = "Matrix", delayedArray=FALSE)
        } else if (dataType == "Cell" && !is.null(fil)) {
            cellSCE <- importSTARsolo(STARsoloDirs = fil, samples = samplename, STARsoloOuts = "Gene/filtered", class = "Matrix", delayedArray=FALSE)
        } else if (dataType == "Droplet" && !is.null(path)) {
            dropletSCE <- importSTARsolo(STARsoloDirs = path, samples = samplename, STARsoloOuts = "Gene/raw", class = "Matrix", delayedArray=FALSE)
        } else if (dataType == "Droplet" && !is.null(raw)) {
            dropletSCE <- importSTARsolo(STARsoloDirs = raw, samples = samplename, STARsoloOuts = "Gene/raw", class = "Matrix", delayedArray=FALSE)
        }
        return(list(dropletSCE, cellSCE))
    }

    if (preproc == "CellRangerV3") {
        if (!is.null(path)) {
            if (dataType == "Both") {
                dropletSCE <- importCellRangerV3(cellRangerDirs = path, sampleDirs = samplename, sampleNames = samplename, dataType="raw", class = "Matrix", delayedArray=FALSE)
                cellSCE <- importCellRangerV3(cellRangerDirs = path, sampleDirs = samplename, sampleNames = samplename, dataType="filtered", class = "Matrix", delayedArray=FALSE)
            } else if (dataType == "Cell") {
                cellSCE <- importCellRangerV3(cellRangerDirs = path, sampleDirs = samplename, sampleNames = samplename, dataType="filtered", class = "Matrix", delayedArray=FALSE)
            } else if (dataType == "Droplet") {
                dropletSCE <- importCellRangerV3(cellRangerDirs = path, sampleDirs = samplename, sampleNames = samplename, dataType="raw", class = "Matrix", delayedArray=FALSE)
            }
        } else {
            if (dataType == "Both") {
                dropletSCE <- importCellRangerV3Sample(dataDir = raw, sampleName = samplename, class = "Matrix", delayedArray=FALSE)
                cellSCE <- importCellRangerV3Sample(dataDir = fil, sampleName = samplename, class = "Matrix", delayedArray=FALSE)
            } else if (dataType == "Cell") {
                cellSCE <- importCellRangerV3Sample(dataDir = fil, sampleName = samplename, class = "Matrix", delayedArray=FALSE)
            } else if (dataType == "Droplet") {
                dropletSCE <- importCellRangerV3Sample(dataDir = raw, sampleName = samplename, class = "Matrix", delayedArray=FALSE)
            }
        }
        return(list(dropletSCE, cellSCE))
    }

    if (preproc == "CellRangerV2") {
        if (!is.null(path)) {
            if (dataType == "Both") {
                dropletSCE <- importCellRangerV2(cellRangerDirs = path, sampleDirs = samplename, sampleNames = samplename, class="Matrix", delayedArray = FALSE, reference = ref, dataTypeV2="raw")
                cellSCE <- importCellRangerV2(cellRangerDirs = path, sampleDirs = samplename, sampleNames = samplename, class="Matrix", delayedArray = FALSE, reference = ref, dataTypeV2="filtered")
            } else if (dataType == "Cell") {
                cellSCE <- importCellRangerV2(cellRangerDirs = path, sampleDirs = samplename, sampleNames = samplename, class="Matrix", delayedArray = FALSE, reference = ref, dataTypeV2="filtered")
            } else if (dataType == "Droplet") {
                dropletSCE <- importCellRangerV2(cellRangerDirs = path, sampleDirs = samplename, sampleNames = samplename, class="Matrix", delayedArray = FALSE, reference = ref, dataTypeV2="raw")
            }
        } else {
            if (dataType == "Both") {
                dropletSCE <- importCellRangerV2Sample(dataDir = raw, sampleName = samplename, class = "Matrix", delayedArray=FALSE)
                cellSCE <- importCellRangerV2Sample(dataDir = fil, sampleName = samplename, class = "Matrix", delayedArray=FALSE)
            } else if (dataType == "Cell") {
                cellSCE <- importCellRangerV2Sample(dataDir = fil, sampleName = samplename, class = "Matrix", delayedArray=FALSE)
            } else if (dataType == "Droplet") {
                dropletSCE <- importCellRangerV2Sample(dataDir = raw, sampleName = samplename, class = "Matrix", delayedArray=FALSE)
            }
        }
        return(list(dropletSCE, cellSCE))
    }

    if (preproc == "Optimus") {
        ## by default has both droplet and cell data.
        dropletSCE <- importOptimus(OptimusDirs = path, samples = samplename, delayedArray = FALSE)
        cellSCE <- dropletSCE[,which(dropletSCE$dropletUtils_emptyDrops_IsCell)]

        if (dataType == "Cell") {
            dropletSCE <- NULL
        } else if (dataType == "Droplet") {
            cellSCE <- NULL
        }
        return(list(dropletSCE, cellSCE))
    }

    if (preproc == "DropEst") {
        if (dataType == "Both") {
            dropletSCE <- importDropEst(sampleDirs=path, dataType="raw", sampleNames=samplename, delayedArray=FALSE)
            cellSCE <- importDropEst(sampleDirs=path, dataType="filtered", sampleNames=samplename, delayedArray=FALSE)
        } else if (dataType == "Cell") {
            cellSCE <- importDropEst(sampleDirs=path, dataType="filtered", sampleNames=samplename, delayedArray=FALSE)
        } else if (dataType == "Droplet") {
            dropletSCE <- importDropEst(sampleDirs=path, dataType="raw", sampleNames=samplename, delayedArray=FALSE)
        }
        return(list(dropletSCE, cellSCE))
    }

    if (preproc == "SceRDS") {
        if (dataType == "Both") {
            dropletSCE <- readRDS(rawFile)
            cellSCE <- readRDS(filFile)
        } else if (dataType == "Cell") {
            cellSCE <- readRDS(filFile)
        } else if (dataType == "Droplet") {
            dropletSCE <- readRDS(rawFile)
        }
        return(list(dropletSCE, cellSCE))
    }

    if (preproc == "AnnData") {
        if (dataType == "Both") {
            dropletSCE <- importAnnData(dirname(rawFile), tools::file_path_sans_ext(basename(rawFile)))
            cellSCE <- importAnnData(dirname(filFile), tools::file_path_sans_ext(basename(filFile)))
        } else if (dataType == "Cell") {
            cellSCE <- importAnnData(dirname(filFile), tools::file_path_sans_ext(basename(filFile)))
        } else if (dataType == "Droplet") {
            dropletSCE <- importAnnData(dirname(rawFile), tools::file_path_sans_ext(basename(rawFile)))
        }
        return(list(dropletSCE, cellSCE))
    }

    if (preproc == "Seurat") {
        if (dataType == "Both") {
            dropletSCE <- readRDS(rawFile)
            cellSCE <- readRDS(filFile)
            dropletSCE <- Seurat::as.SingleCellExperiment(dropletSCE)
            cellSCE <- Seurat::as.SingleCellExperiment(cellSCE)
        } else if (dataType == "Cell") {
            cellSCE <- readRDS(filFile)
            cellSCE <- Seurat::as.SingleCellExperiment(cellSCE)
        } else if (dataType == "Droplet") {
            dropletSCE <- readRDS(rawFile)
            dropletSCE <- Seurat::as.SingleCellExperiment(dropletSCE)
        }
        return(list(dropletSCE, cellSCE))
    }

    if (preproc == "CountMatrix") {
        if (dataType == "Both") {
            dropletMM <- data.table::fread(rawFile)
            dropletSCE <- constructSCE(data = dropletMM, samplename = samplename)
            cellMM <- data.table::fread(filFile)
            cellSCE <- constructSCE(data = cellMM, samplename = samplename)
        } else if (dataType == "Cell") {
            cellMM <- data.table::fread(filFile)
            cellSCE <- constructSCE(data = cellMM, samplename = samplename)
        } else if (dataType == "Droplet") {
            dropletMM <- data.table::fread(rawFile)
            dropletSCE <- constructSCE(data = dropletMM, samplename = samplename)
        }
        return(list(dropletSCE, cellSCE))
    }
    
    ## todo: AnnData support
    if (preproc == "AnnData") {
        if (dataType == "Both") {
            dropletSCE <- anndata::read_h5ad(rawFile)
            cellSCE <- anndata::read_h5ad(filFile)
        } else if (dataType == "Cell") {
            cellSCE <- anndata::read_h5ad(filFile)
        } else if (dataType == "Droplet") {
            dropletSCE <- anndata::read_h5ad(rawFile) 
        }
        return(list(dropletSCE, cellSCE))
    }

    if (preproc == "Alevin") {
        cellSCE <- importAlevin(alevinDir = path, sampleName = samplename, class = "Matrix", delayedArray=FALSE)
        return(list(dropletSCE, cellSCE))
    }

    # construct cell SCE from FlatFile
    if (preproc == "FlatFile") {
        if (dataType == "Both") {
            dropletSCE <- importFromFiles(assayFile = flatFiles[[1]],
                                          annotFile = flatFiles[[2]],
                                          featureFile = flatFiles[[3]])
            cellSCE <- importFromFiles(assayFile = flatFiles[[4]],
                                       annotFile = flatFiles[[5]],
                                       featureFile = flatFiles[[6]])
        } else if (dataType == "Cell") {
            cellSCE <- importFromFiles(assayFile = flatFiles[[1]],
                                       annotFile = flatFiles[[2]],
                                       featureFile = flatFiles[[3]])
        } else if (dataType == "Droplet") {
            dropletSCE <- importFromFiles(assayFile = flatFiles[[1]],
                                          annotFile = flatFiles[[2]],
                                          featureFile = flatFiles[[3]])
        }
        return(list(dropletSCE, cellSCE))
    }

    ## preproc is not one of the method above. Stop the pipeline.
    p <- paste0("'", preproc, "' not supported.")
    stop(p)
}

# User Interface for Celda Workflow ---
shinyPanelCelda <- fluidPage(
    h1("Celda"),
    h5(tags$a(href = paste0(docs.artPath, "ui_celda_curated_workflow.html"),
              "(help)", target = "_blank")),
    inlineCSS(list(".panel-danger>.panel-heading" = "background-color:#dcdcdc; color:#000000", ".panel-primary>.panel-heading" = "background-color:#f5f5f5; color:#000000; border-color:#dddddd", ".panel-primary" = "border-color:#dddddd;", ".panel-primary>.panel-heading+.panel-collapse>.panel-body" = "border-color:#dddddd;")),
    bsCollapse(
        id = "CeldaUI", 
        open = "Data Input",
        bsCollapsePanel(
            "Identify Number of Feature Modules",
            fluidRow(
                column(
                    4,
                    panel(
                        selectInput("celdaassayselect", "Choose an Assay:",
                                    choices = c()),
                        selectInput("celdafeatureselect", "Choose Feature Selection Method:",
                                    choices = c("None", "SeuratFindHVG", "Scran_modelGeneVar")),
                        conditionalPanel("input.celdafeatureselect == 'SeuratFindHVG'",
                                         selectInput("celdaseurathvgmethod", "Select HVG method:",
                                                     choices = c("vst", "dispersion", "mean.var.plot"))),
                        conditionalPanel("input.celdafeatureselect != 'None'",
                                         numericInput("celdafeaturenum",
                                                      "Select number of variable features:", min = 1, max = 5000, value = 2500)),
                        numericInput("celdarowcountsmin",
                                     "Keep features with this many counts:", value = 3),
                        numericInput("celdacolcountsmin",
                                     "In at least this many cells:", value = 3),
                        numericInput("celdaLinit", "Select Number of Initial Feature Modules:", min = 1, max = 25, value = 10),
                        numericInput("celdaLmax", "Select Number of Maximum Feature Modules:", min = 15, max = 200, value = 100),
                        actionButton("celdamodsplit", "Recursive Module Split"),
                        hidden(
                            numericInput("celdaLselect", "Select Number of Feature Modules:", min = 1, max = 100, value = 25),
                            actionButton("celdaLbtn", "Select Number of Modules")
                        )
                    )
                ),
                column(
                    8,
                    fluidRow(
                        column(
                            12,
                            hidden(
                                tags$div(class = "celda_modsplit_plots", tabsetPanel(id = "celdaModsplitTabset", type = "tabs")
                                )
                            )
                        )
                    )
                )
            ),
            style = "primary"
        ),
        
        bsCollapsePanel(
            "Identify Number of Cell Clusters",
            fluidRow(
                column(
                    4,
                    panel(
                        numericInput("celdaKinit", "Select Number of Initial Cell Modules:", min = 1, max = 10, value = 5),
                        numericInput("celdaKmax", "Select Number of Maximum Cell Modules:", min = 15, max = 40, value = 25),
                        actionButton("celdacellsplit", "Recursive Cell Split"),
                        hidden(
                            numericInput("celdaKselect", "Select Number of Cell Clusters:", min = 2, max = 20, value = 10),
                            actionButton("celdaKbtn", "Select Number of Clusters")
                        )
                    )
                ),
                column(
                    8,
                    fluidRow(
                        column(
                            12,
                            hidden(
                                tags$div(
                                    class = "celda_cellsplit_plots",
                                    fluidRow(
                                        tabsetPanel(
                                            tabPanel("Rate of perplexity change",
                                                     panel(
                                                         plotlyOutput(outputId = "plot_cellsplit_perpdiff", height = "auto")
                                                     )),
                                            tabPanel("Perplexity Plot",
                                                     panel(
                                                         plotlyOutput(outputId = "plot_cellsplit_perp", height = "auto")
                                                     )),
                                            tabPanel("Preliminary UMAP Plots",
                                                     uiOutput("celdaKplots"))
                                        )
                                    )
                                )
                            )
                         )
                       )
                      )
                    ),
                    style = "primary"
                ),
                
                bsCollapsePanel(
                    "Visualization",
                    tabsetPanel(
                        tabPanel(
                            "Embeddings",
                            fluidRow(
                                column(
                                    4,
                                    panel(
                                        radioButtons("celdaPlot", "Plot Type:", c("UMAP", "TSNE")),
                                        conditionalPanel(
                                            condition = "input.celdaPlot == 'UMAP'",
                                            
                                            numericInput("celdaUMAPmaxCells",
                                                         label =
                                                             "Max.cells: Maximum number of cells to plot",
                                                         value = 25000,
                                                         min = 1,
                                                         step = 1),
                                            numericInput("celdaUMAPminClusterSize",
                                                         label =
                                                             "Min.cluster.size: Do not subsample cell
                              clusters below this threshold",
                                                         value = 100,
                                                         min = 1,
                                                         step = 1),
                                            numericInput("celdaUMAPSeed",
                                                         label =
                                                             "Seed: ",
                                                         value = 12345),
                                            numericInput("celdaUMAPmindist",
                                                         label =
                                                             "Min.dist: Effective minimum distance
                                between embedded points",
                                                         value = 0.75),
                                            numericInput("celdaUMAPspread",
                                                         label =
                                                             "Spread: ",
                                                         value = 1),
                                            numericInput("celdaUMAPnn",
                                                         label =
                                                             "nNeighbors: ",
                                                         value = 30),
                                            
                                            actionButton("CeldaUmap", "Run UMAP")
                                            
                                            
                                        ),
                                        
                                        conditionalPanel(
                                            condition = "input.celdaPlot == 'TSNE'",
                                            numericInput("celdatSNEmaxCells",
                                                         label =
                                                             "Max.cells: Maximum number of cells to
                                plot",
                                                         value = 25000,
                                                         min = 1,
                                                         step = 1),
                                            numericInput("celdatSNEminClusterSize",
                                                         label =
                                                             "Min.cluster.size: Do not subsample cell
                              clusters below this threshold",
                                                         value = 100,
                                                         min = 1,
                                                         step = 1),
                                            numericInput("celdatSNEPerplexity",
                                                         label =
                                                             "Perplexity: ",
                                                         value = 20),
                                            numericInput("celdatSNEmaxIter",
                                                         label =
                                                             "Max.iter: Maximum number of iterations in
                              tSNE generation",
                                                         value = 2500),
                                            numericInput("celdatSNESeed",
                                                         label =
                                                             "Seed: ",
                                                         value = 12345),
                                            actionButton("CeldaTsne", "Run tSNE")
                                        )
                                    )
                                ),
                                column(
                                    8,
                                    panel(
                                        conditionalPanel(
                                            condition = "input.celdaPlot == 'UMAP'",
                                            plotlyOutput("celdaumapplot", height = "auto")
                                            
                                        ),
                                        conditionalPanel(
                                            condition = "input.celdaPlot == 'TSNE'",
                                            plotlyOutput("celdatsneplot", height = "auto")
                                        )
                                    )
                                )
                            )
                        ),
                        
                        #tabPanel("Heatmap",
                        #        fluidRow(
                        #           panel(
                        #              plotOutput("celdaheatmapplt")
                        #         )
                        #     )
                        #),
                        tabPanel(
                            "Module Analysis",
                            fluidRow(
                                column(
                                    4,
                                    panel(
                                        numericInput(inputId = "celdamodheatmapnum",
                                                     label = "Select module to display on heatmap:", value = 10, step = 1),
                                        numericInput(inputId = "celdamodheatmaptopcells",
                                                     label = "Select number of cells to display on heatmap:", value = 100),
                                        
                                        actionButton("celdamodheatmapbtn", "Plot Module Heatmap")
                                    )
                                ),
                                column(
                                    8,
                                    panel(
                                        plotOutput(outputId = "celdamodheatmapplt") %>% withSpinner(size = 3, color = "#0dc5c1", type = 8),
                                        plotOutput(outputId = "celdamodprobplt") %>% withSpinner(size = 3, color = "#0dc5c1", type = 8)
                                        
                                    )
                                )
                            )
                        ),
                        tabPanel("Probablity Map",
                                 fluidRow(
                                     panel(
                                         plotOutput("celdaprobmapplt")
                                     )
                                 )
                        )
                    ),
                    style = "primary"
                )
            ),
            nonLinearWorkflowUI(id = "nlw-celda")
        )
   
        

#' @title Run VAM to score gene sets in single cell data
#' @description Wrapper for the Variance-adjusted Mahalanobis (VAM), which is a
#' fast and accurate method for cell-specific gene set scoring of single cell
#' data. This algorithm computes distance statistics and one-sided p-values for
#' all cells in the specified single cell gene expression matrix. Gene sets
#' should already be imported and stored in the meta data using functions such
#' as \link{importGeneSetsFromList} or \link{importGeneSetsFromMSigDB}
#' @param inSCE Input \linkS4class{SingleCellExperiment} object.
#' @param geneSetCollectionName Character. The name of the gene set collection
#' to use. Default \code{"H"}.
#' @param useAssay Character. The name of the assay to use. This assay should
#' contain log normalized counts. Default \code{"logcounts"}.
#' @param resultNamePrefix  Character. Prefix to the name the VAM results which
#' will be stored in the reducedDim slot of \code{inSCE}. The names of the
#' output matrices will be \code{resultNamePrefix_Distance} and
#' \code{resultNamePrefix_CDF}. If this parameter is set to \code{NULL}, then
#' \code{"VAM_geneSetCollectionName_"} will be used. Default \code{NULL}.
#' @param center Boolean. If \code{TRUE}, values will be mean centered when
#' computing the Mahalanobis statistic. Default \code{FALSE}.
#' @param gamma Boolean. If \code{TRUE}, a gamma distribution will be fit to
#' the non-zero squared Mahalanobis distances computed from a row-permuted
#' version of the gene expression matrix. The estimated gamma distribution will
#' be used to compute a one-sided p-value for each cell. If \code{FALSE}, the
#' p-value will be computed using the standard chi-square approximation for the
#' squared Mahalanobis distance (or non-central if \code{center = FALSE}).
#' Default \code{TRUE}.
#' @importFrom methods slot
#' @return A \linkS4class{SingleCellExperiment} object with VAM metrics stored
#' in \code{reducedDim} as \code{VAM_NameOfTheGeneset_Distance} and
#' \code{VAM_NameOfTheGeneset_CDF}.
#' @seealso \link{importGeneSetsFromList}, \link{importGeneSetsFromMSigDB},
#' \link{importGeneSetsFromGMT}, \link{importGeneSetsFromCollection} for
#' importing gene sets. \link{sctkListGeneSetCollections},
#' \link{getPathwayResultNames} and \link{getGenesetNamesFromCollection} for
#' available related information in \code{inSCE}.
#' @author Nida Pervaiz
#' @export
#' @examples
#' data(scExample, package = "singleCellTK")
#' sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
#' sce <- scaterlogNormCounts(sce, assayName = "logcounts")
#' gs1 <- rownames(sce)[seq(10)]
#' gs2 <- rownames(sce)[seq(11,20)]
#' gs <- list("geneset1" = gs1, "geneset2" = gs2)
#' sce <- importGeneSetsFromList(inSCE = sce,geneSetList = gs,
#'                               by = "rownames")
#' sce <- runVAM(inSCE = sce,
#'               geneSetCollectionName = "GeneSetCollection",
#'               useAssay = "logcounts")
runVAM <- function(inSCE, geneSetCollectionName = "H", useAssay = "logcounts",
                   resultNamePrefix = NULL, center = FALSE, gamma = TRUE) {
  ###################################################
  ###  create gene set collection
  ###################################################
  if (!inherits(inSCE, "SingleCellExperiment")) {
    stop("inSCE has to inherit from SingleCellExperiment object.")
  }
  gene.Set <- .getGeneSetCollection(inSCE, geneSetCollectionName)

  num.Genes <- length(gene.Set)
  gene.Set.Rows <- list()
  gene.Set.Collection <- list()

  for (i in seq(num.Genes)){

    gene.Set.Rows[i] <- slot(gene.Set[[i]], "setName")
    gene.Set.Ids <- slot(gene.Set[[i]], "geneIds")
    gene.Set.Collection[[i]] <- gene.Set.Ids

  }
  names(gene.Set.Collection) <- gene.Set.Rows
  message(date(), " ... Running VAM")
  gene.Set.Collection <- VAM::createGeneSetCollection(gene.ids = rownames(inSCE),
                                                      gene.set.collection = gene.Set.Collection)

  ###################################################
  ### execute vam
  ###################################################
  mat <- expData(inSCE, useAssay)
  resultsexp <- VAM::vamForCollection(gene.expr = t(mat),
                                      gene.set.collection = gene.Set.Collection,
                                      center = center, gamma = gamma)

  ###################################################
  #### store results in metadata
  ###################################################
  if(is.null(resultNamePrefix)) {
    resultNamePrefix <- paste0("VAM_", geneSetCollectionName, "_")
  }
  SingleCellExperiment::reducedDim(inSCE, paste0(resultNamePrefix, "Distance")) <- resultsexp$distance.sq
  SingleCellExperiment::reducedDim(inSCE, paste0(resultNamePrefix, "CDF")) <- resultsexp$cdf.value
  if ("pathwayAnalysisResultNames" %in% names(S4Vectors::metadata(inSCE))) {
    S4Vectors::metadata(inSCE)[["pathwayAnalysisResultNames"]] <-
      c(S4Vectors::metadata(inSCE)[["pathwayAnalysisResultNames"]],
        paste0(resultNamePrefix, "Distance"),
        paste0(resultNamePrefix, "CDF"))
  } else {
    S4Vectors::metadata(inSCE)[["pathwayAnalysisResultNames"]] <-
      c(paste0(resultNamePrefix, "Distance"),
        paste0(resultNamePrefix, "CDF"))
  }
  S4Vectors::metadata(inSCE)[["pathwayAnalysisResultNames"]] <-
    unique(S4Vectors::metadata(inSCE)[["pathwayAnalysisResultNames"]])

  return (inSCE)
}

---
title: "Clustering"
author: "`r params$authors`"
date: "`r format(Sys.time(), '%B %d, %Y')`"
params:
  subtitle: !r NULL
  authors: !r NULL
  sce: !r NULL
  outputPath: !r NULL
  showSession: FALSE
  pdf: TRUE
  biological.group: !r NULL
  phenotype.groups: !r NULL
  runClustering: TRUE
  plotTSNE: TRUE
  plotUMAP: TRUE
  minResolution: 0.3
  maxResolution: 1.5
  numClusters: 10
  significant_PC: 10
  forceRun: FALSE
output:
  html_document:
    toc: yes
    toc_float: yes
    number_sections: yes
    theme: cosmo
    code_folding: hide
    self_contained: false
    keep_md: yes
  pdf_document:
    toc: yes
subtitle: "`r params$subtitle`"
editor_options:
  chunk_output_type: console
---
```{r, echo=FALSE}
if(!exists("showClusterDesc")) showClusterDesc <- TRUE
if(!exists("headingClust")) headingClust <- "#"
```

```{r, echo=FALSE, message=FALSE, warning=FALSE}
library(Seurat)
library(dplyr)
library(cowplot)
library(RColorBrewer)
library(ggplot2)
library(knitr)
library(kableExtra)
library(SingleCellExperiment)
library(scater)
library(gridExtra)
library(grid)
library(ggpubr)
library(patchwork)
library(singleCellTK)
```

```{r, echo=FALSE, results='asis', warning=FALSE, message=FALSE, eval = showClusterDesc}
cat(headingClust," Clustering\n\n")

cat("Clustering helps in the identification of inherent cell-types in the data in an unsupervised manner by discovering the natural clusters that may exist on the basis of the transcriptome. Seurat uses the principal components for its graph-based clustering approach where it iteratively groups cells with similar expression patterns together into highly interconnected communities.  

The clustering results can then be visualized using non-linear dimensionality reduction techniques including tSNE and UMAP. The goal of these algorithms is essentially to understand the structure of the data in high-dimensional space in order to place similar cells together in low-dimensional space thus making visualizing clusters much more intuitive. Cells in the data within the graph-based clusters determined above should co-localize on these plots. ")
```

<!-- Compute -->
```{r, results='asis', warning=FALSE, message=FALSE,  eval = !(runClustering && all(paste0("Seurat_louvain_Resolution", seq(from = minResolution, to = maxResolution, by=0.1)) %in% names(colData(data))))}
j <- minResolution
for(i in 1:(((maxResolution-minResolution)*10)+1)){
  data <- runSeuratFindClusters(data, useReduction = "pca", resolution = j, verbose = FALSE)
  j <- j + 0.1
}
```

<!-- Plot -->
```{r, echo=FALSE, results='asis', warning=FALSE, message=FALSE, eval = showClusterDesc}
cat("### Different resolutions {.tabset -} \n\n")
cat("Seurat uses a *resolution parameter* that sets the granularity of the clustering, with increased values leading to a greater number of identified clusters. The choice of resolution is slightly subjective and often varies on the size of the input data. Typically, for larger datasets, the optimal resolution often increases. The different clustering results are provided below using a set of different resolutions (ranging from ", minResolution, " to ",  maxResolution, ") which can be visualized using tSNE and UMAP plots below:")
```

```{r, echo=FALSE}
if(!showClusterDesc){
  headingTSNEUMAP <- "###"
  headingRES <- "####"
  headingClust <- "#####"
}else{
  headingTSNEUMAP <- "####"
  headingRES <- "#####"
  headingClust <- "######"
}
```

```{r, results='asis', warning=FALSE, message=FALSE, eval = !(plotTSNE && !is.null(metadata(data)$seurat$obj$reductions$tsne))}
data <- runSeuratTSNE(data, useReduction = "pca", dims = significant_PC)
```

```{r, echo=FALSE, results='asis', warning=FALSE, message=FALSE, eval=plotTSNE}
cat(headingTSNEUMAP, " tSNE {.tabset .tabset-pills -}\n\n")

j <- minResolution

for(i in 1:(((maxResolution-minResolution)*10)+1)){
  cat(headingRES, " RES ", j, " {.tabset -} \n\n")
  cat(headingClust," Clusters {-} \n\n")
  p <- plotSeuratReduction(data, useReduction = "tsne", groupBy = paste0("Seurat_louvain_Resolution", j), showLegend = TRUE)
  print(p)
  cat("\n\n")
  
  cat(headingClust," Samples {-} \n\n")
      p <- plotSeuratReduction(data, useReduction = "tsne", groupBy = biological.group, showLegend = TRUE)
  print(p)
  cat("\n\n")
  
    cat(headingClust," Samples separated {-} \n\n")
      p <- plotSeuratReduction(data, useReduction = "tsne", groupBy = paste0("Seurat_louvain_Resolution", j), splitBy = biological.group, showLegend = TRUE)
  print(p)
  cat("\n\n")
  j <- j + 0.1
  
  if(!is.null(phenotype.groups)){
    cat(headingClust," Phenotype variable:", phenotype.groups," {-} \n\n")
    p <- plotSeuratReduction(data, useReduction = "tsne", groupBy = phenotype.groups, showLegend = TRUE)
    print(p)
    cat("\n\n")
  }
}
```

```{r, results='asis', warning=FALSE, message=FALSE, eval = !(plotUMAP && !is.null(metadata(data)$seurat$obj$reductions$umap))}
data <- runSeuratUMAP(data, useReduction = "pca", dims = significant_PC)
```

```{r, echo=FALSE, results='asis', warning=FALSE, message=FALSE, eval=plotUMAP}
cat(headingTSNEUMAP, " UMAP {.tabset .tabset-pills -}\n\n")

j <- minResolution

for(i in 1:(((maxResolution-minResolution)*10)+1)){
  cat(headingRES, " RES ", j, " {.tabset -} \n\n")
  cat(headingClust," Clusters {-} \n\n")
  p <- plotSeuratReduction(data, useReduction = "umap", groupBy = paste0("Seurat_louvain_Resolution", j), showLegend = TRUE)
  
  print(p)
  
  cat("\n\n")
  cat(headingClust," Samples {-} \n\n")
  p <- plotSeuratReduction(data, useReduction = "umap", groupBy = biological.group, showLegend = TRUE)
  print(p)
  cat("\n\n")
  
    cat(headingClust," Samples separated {-} \n\n")
  p <- plotSeuratReduction(data, useReduction = "umap", groupBy = paste0("Seurat_louvain_Resolution", j), splitBy = biological.group, showLegend = TRUE)
  print(p)
  cat("\n\n")
  j <- j + 0.1
  
    if(!is.null(phenotype.groups)){
      cat(headingClust," Phenotype variable:", phenotype.groups," {-} \n\n")
      p <- plotSeuratReduction(data, useReduction = "umap", groupBy = phenotype.groups, showLegend = TRUE)
      print(p)
      cat("\n\n")
    }
}
```

```{r, echo=FALSE}
j <- minResolution
numClustersAllRes <- NULL
for(i in 1:(((maxResolution-minResolution)*10)+1)){
  numClustersAllRes <- c(numClustersAllRes, length(unique(colData(data)[[paste0("Seurat_louvain_Resolution", j)]])))
  j <- j + 0.1
}
```

> The data was clustered using the *`r significant_PC`* principal components previously computed using the community detection based *louvain* algorithm. Using this method, `r numClustersAllRes` clusters were identified by using a resolution of `r seq(minResolution, maxResolution, 0.1)` respectively. 

```{r, results='asis', eval=showSession, echo=FALSE}
cat("# Session Information\n\n")
```

```{r, results='markup', eval = showSession, echo = showSession}
sessionInfo()
```

---
title: "Introduction to singleCellTK"
author:
- name: Yichen Wang
  affiliation: 
  - The Section of Computational Biomedicine, Boston University School of Medicine, Boston, MA
- name: Irzam Sarfraz
  affiliation: 
  - The Section of Computational Biomedicine, Boston University School of Medicine, Boston, MA  
- name: Rui Hong
  affiliation: 
  - The Section of Computational Biomedicine, Boston University School of Medicine, Boston, MA
  - Program in Bioinformatics, Boston University, Boston, MA
- name: Yusuke Koga
  affiliation: 
  - The Section of Computational Biomedicine, Boston University School of Medicine, Boston, MA
  - Program in Bioinformatics, Boston University, Boston, MA
- name: Salam Abdullatif
  affiliation: 
  - The Section of Computational Biomedicine, Boston University School of Medicine, Boston, MA
- name: Nida Pervaiz
  affiliation: 
  - The Section of Computational Biomedicine, Boston University School of Medicine, Boston, MA
- name: David Jenkins
  affiliation: 
  - The Section of Computational Biomedicine, Boston University School of Medicine, Boston, MA
  - Program in Bioinformatics, Boston University, Boston, MA
- name: Vidya Akavoor
  affiliation: 
  - Rafik B. Hariri Institute for Computing and Computational Science and Engineering, Boston University, Boston, MA
- name: Xinyun Cao
  affiliation: 
  - Rafik B. Hariri Institute for Computing and Computational Science and Engineering, Boston University, Boston, MA
- name: Shruthi Bandyadka
  affiliation: 
  - The Section of Computational Biomedicine, Boston University School of Medicine, Boston, MA
  - Program in Bioinformatics, Boston University, Boston, MA
- name: Anastasia Leshchyk
  affiliation: 
  - The Section of Computational Biomedicine, Boston University School of Medicine, Boston, MA
  - Program in Bioinformatics, Boston University, Boston, MA
- name: Tyler Faits
  affiliation: 
  - The Section of Computational Biomedicine, Boston University School of Medicine, Boston, MA
  - Program in Bioinformatics, Boston University, Boston, MA
- name: Mohammed Muzamil Khan
  affiliation:
  - The Section of Computational Biomedicine, Boston University School of Medicine, Boston, MA
  - Program in Bioinformatics, Boston University, Boston, MA
- name: Zhe Wang
  affiliation: 
  - The Section of Computational Biomedicine, Boston University School of Medicine, Boston, MA
  - Program in Bioinformatics, Boston University, Boston, MA
- name: W. Evan Johnson
  affiliation: 
  - The Section of Computational Biomedicine, Boston University School of Medicine, Boston, MA
  - Program in Bioinformatics, Boston University, Boston, MA
- name: Ming Liu
  affiliation:
  - The Section of Computational Biomedicine, Boston University School of Medicine, Boston, MA
  - Program in Bioinformatics, Boston University, Boston, MA
- name: Joshua D. Campbell
  affiliation: 
  - The Section of Computational Biomedicine, Boston University School of Medicine, Boston, MA
  - Program in Bioinformatics, Boston University, Boston, MA
  email: camp@bu.edu  
  
  



package: singleCellTK
output: 
  BiocStyle::html_document:
    toc_float: false
vignette: >
  %\VignetteIndexEntry{1. Introduction to singleCellTK}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

The Single Cell Toolkit (SCTK) is an interactive scRNA-Seq analysis package that
allows a user to upload raw scRNA-Seq count matrices and perform downstream
scRNA-Seq analysis interactively through a web interface, or through a set of
R functions through the command line. The package is written in R with a
graphical user interface (GUI) written in Shiny. Users can perform analysis with
modules for conducting quality control, clustering, batch correction, differential
expression, pathway enrichment, and sample size calculator, all in a simple to
use point and click interface. The toolkit also supports command line data
processing, and results can be loaded into the GUI for additional exploration
and downstream analysis.

# Vignettes

Due to the range of features that are available in SCTK, we have prepared several 
vignettes to help you get started, which are all available at [https://www.camplab.net/sctk/](https://www.camplab.net/sctk/)

# Session info {.unnumbered}

```{r sessionInfo, echo=FALSE}
sessionInfo()
```

---
title: "Single Cell Analysis with Seurat using singleCellTK Package"
author: "`r params$authors`"
date: "`r format(Sys.time(), '%B %d, %Y')`"
params:
  subtitle: !r NULL
  authors: !r NULL
  sce: !r NULL
  biological.group: !r NULL
  phenotype.groups: !r NULL
  variable.features: 2000
  pc.count: 50
  outputPath: !r NULL
  showSession: FALSE
  pdf: TRUE
  runHVG: TRUE
  plotHVG: TRUE
  runDimRed: TRUE
  plotJackStraw: FALSE
  plotElbowPlot: TRUE
  plotHeatmaps: TRUE
  runClustering: TRUE
  plotTSNE: TRUE
  plotUMAP: TRUE
  minResolution: 0.3
  maxResolution: 1.5 
  forceRun: FALSE
output:
  html_document:
    toc: yes
    toc_float: yes
    number_sections: yes
    theme: cosmo
    code_folding: hide
    self_contained: false
    keep_md: yes
  pdf_document:
    toc: yes
subtitle: "`r params$subtitle`"
editor_options:
  chunk_output_type: console
---


```{r Load Libraries Seurat Normalization, echo=FALSE, include = TRUE, message=FALSE, warning=FALSE}
#Loading required libraries
library(Seurat)
library(dplyr)
library(cowplot)
library(RColorBrewer)
library(ggplot2)
library(knitr)
library(kableExtra)
library(SingleCellExperiment)
library(scater)
library(gridExtra)
library(grid)
library(ggpubr)
library(patchwork)
library(singleCellTK)

data <- params$sce
sampleNames <- unique(colData(data)[[biological.group]])

numCells <- ncol(data)
numFeatures <- nrow(data)
numSamples <- length(sampleNames)

# Knitr Global Options
# dev <- ifelse(isTRUE(pdf), c("png"), c("png", "pdf"))
# opts_chunk$set(
#   echo = TRUE,
#   cache = FALSE,
#   cache.lazy = FALSE,
#   cache.comments = FALSE,
#   fig.align = "center",
#   fig.keep = "all",
#   dev = dev,
#   warning = FALSE
# )
```

<!-- Compute -->

<!-- Normalization -->
```{r, echo=FALSE, results='asis', message=FALSE}
headingNorm <- "##"
resNormalization <- knitr::knit_child(system.file("rmarkdown/seurat", "reportSeuratNormalizeData.Rmd", package = "singleCellTK"), quiet = TRUE, envir = environment())
```

<!-- Feature Selection -->
```{r, echo=FALSE, results='asis'}
headingFS <- "##"
resFeatureSelection <- knitr::knit_child(system.file("rmarkdown/seurat", "reportSeuratFeatureSelection.Rmd", package = "singleCellTK"), quiet = TRUE)
```

<!-- Scale Data -->
```{r, echo=FALSE, results='asis', warning=FALSE, message=FALSE}
headingSD <- "##"
resScaleData <- knitr::knit_child(system.file("rmarkdown/seurat", "reportSeuratScaleData.Rmd", package = "singleCellTK"), quiet = TRUE)
```

<!-- Dimensionality Reduction -->
```{r, echo=FALSE, results='asis', warning=FALSE, message=FALSE}
headingDR <- "##"
headingDR2 <- "###"
significant_PC <- 10

resDimRed <- knitr::knit_child(system.file("rmarkdown/seurat", "reportSeuratDimRed.Rmd", package = "singleCellTK"), quiet = TRUE, envir = environment())
```

<!-- Clustering -->
```{r, echo=FALSE, results='asis', warning=FALSE, message=FALSE}
numClusters <- 10 # this should be computed by the code itself (do later)
showClusterDesc <- TRUE
headingClust <- "##"

resClustering <- knitr::knit_child(system.file("rmarkdown/seurat", "reportSeuratClustering.Rmd", package = "singleCellTK"), quiet = TRUE, envir = environment())
```

# Seurat Run

## Introduction
[Seurat](https://satijalab.org/seurat/) is a popular R package designed for the analysis of single-cell genomics data and offers a multitude of methods for processing and visualization. The singleCellTK package integrates these methods in an intuitive user-interface and all of which are also accessible through console-based wrapper functions. This comprehensive report summarizes the Seurat workflow for the input data by running all of the steps from the proposed pipeline including Normalization, Feature Selection, Scaling, Dimensionality Reduction, Clustering and Differential Expression, along with all of the supporting visualizations. A summary of the input data and results computed from this data is described below:

<!-- Populate RMD with Results -->
```{r, echo=FALSE, results='asis', warning=FALSE, message=FALSE}
cat(resNormalization, sep = '\n')
cat(resFeatureSelection, sep = '\n')
cat(resScaleData, sep = '\n')
cat(resDimRed, sep = '\n')
cat(resClustering, sep = '\n')
```

```{r, results='asis', eval=showSession, echo=FALSE}
cat("# Session Information\n\n")
```

```{r, results='markup', eval = showSession, echo = showSession}
sessionInfo()
```

---
title: "Comprehensive reporting of QC metrics: predicting doublets with doubletFinder"
date: "`r format(Sys.time(), '%B %d, %Y')`"
params: 
  object: object
output:
  html_document:
    number_sections: yes
    toc: yes
    code_folding: hide
---

```{r, "DoubletFinder-lib", message = F, include=FALSE}
require(singleCellTK)
require(uwot)
require(ggplot2)
```

```{r, "DoubletFinder-import", warning=FALSE}
sce.qc<- params$object
```

```{r, "DoubletFinder", results="asis", fig.align="center", warning=FALSE, message=FALSE}
    plotDoubletFinder<- plotDoubletFinderResults(inSCE = sce.qc, reducedDimName = "UMAP")
    i="DoubletFinder"
    cat(paste0('# ', i, ' {.tabset} \n\n'))
    cat(paste0('## Scatter Score Resolution 1.5 \n\n'))
    plotDoubletFinder$Scatter_Score_Resolution_1.5
    
    cat(paste0('## Scatter Call Resolution 1.5 \n\n'))
    plotDoubletFinder$Scatter_Call_Resolution_1.5
    
    cat(paste0('## Density Resolution 1.5 \n\n'))
    plotDoubletFinder$Density_Resolution_1.5
   
    cat(paste0('## Violin Resolution 1.5 \n\n'))
    plotDoubletFinder$violin_Resolution_1.5
 
    cat(paste0('## Session info \n\n'))
    sce.qc@metadata$runDoubletFinder
```


```{r, "DoubletFinder-description", warning=FALSE, message=FALSE}
description_DoubletFinder <- descriptionDoubletFinder()
```

# {.unlisted .unnumbered .toc-ignore}
`r description_DoubletFinder`

---
title: "Comprehensive reporting of droplet QC metrics: computing barcode ranks with barcodeRank"
date: "`r format(Sys.time(), '%B %d, %Y')`"
params: 
  object: object
output:
  html_document:
    number_sections: yes
    toc: yes
    code_folding: hide
    result: show
---

```{r "BarcodeRank-lib", include=FALSE, warning=FALSE}
require(ggplot2)
require(SingleCellExperiment)
require(singleCellTK)
```

```{r, "BarcodeRank-import", include=FALSE, include=FALSE, warning=FALSE}
sce<-params$object
```

```{r, "BarcodeRanks", results="asis", fig.align="center", warning=FALSE, message=FALSE}
   plotsBarcodeRank<- plotBarcodeRankScatter(sce)
    i="BarcodeRanks"
    cat(paste0('# ', i, ' {.tabset .tabset-fade} \n\n'))
    cat(paste0('## BarcodeRanks, Total UMI counts vs Rank \n\n'))
    plotsBarcodeRank
    cat(paste0('## Session info \n\n'))
    sce@metadata$runBarcodeRankDrops
```

```{r, "BarcodeRank-description", include=FALSE, warning=FALSE, message=FALSE}
description_runBarcodeRank <- descriptionBarcodeRank()
```
# {.unlisted .unnumbered .toc-ignore}
`r description_runBarcodeRank`

---
title: "Seurat Marker Selection"
author: "`r params$authors`"
date: "`r format(Sys.time(), '%B %d, %Y')`"
params:
  subtitle: !r NULL
  authors: !r NULL
  sce: !r NULL
  biological.group: !r NULL
  phenotype.groups: !r NULL
  selected.markers: !r NULL
  outputPath: !r NULL
  showSession: FALSE
  pdf: TRUE
  runMarkerSelection: TRUE
  plotMarkerSelection: TRUE
  numTopFeatures: 10
output:
  html_document:
    toc: yes
    toc_float: yes
    number_sections: yes
    theme: cosmo
    code_folding: hide
    self_contained: false
    keep_md: yes
  pdf_document:
    toc: yes
subtitle: "`r params$subtitle`"
editor_options:
  chunk_output_type: console
---
```{r, echo=FALSE}
if(!exists("titleMarkerPlots")) titleMarkerPlots <- "Plot Features"
if(!exists("groupTitle")) groupTitle <- "Seurat_louvain_Resolution0.3"
if(!exists("selectedOption")) selectedOption <- "Seurat_louvain_Resolution0.3"
if(!exists("headingMS")) headingMS <- "#"
```

```{r, echo=FALSE, message=FALSE, warning=FALSE}
library(Seurat)
library(dplyr)
library(cowplot)
library(RColorBrewer)
library(ggplot2)
library(knitr)
library(kableExtra)
library(SingleCellExperiment)
library(scater)
library(gridExtra)
library(grid)
library(ggpubr)
library(patchwork)
library(singleCellTK)
```

```{r, echo=FALSE, results='asis', warning=FALSE, message=FALSE, eval=runMarkerSelection}
cat(headingMS, " Differential Expression (", groupTitle,")\n\n")
cat("Gene markers that are differentially expressed between the previously computed ", selectedOption, " are identified using the Wilcoxon Rank Sum test. Criteria for the identification of these marker genes required them to be detected at a minimum percentage of 25% in either of the two groups of cells (each cluster against all others), and additionally they show 25% log-fold expression difference between two groups.")
```

```{r, warning=FALSE, message=FALSE, echo = TRUE, eval = runMarkerSelection}
data <- runSeuratFindMarkers(data, allGroup = selectedOption, minPCT = 0.25, threshUse = 0.25, verbose = FALSE)
data.markers <- metadata(data)$seuratMarkers

write.csv(data.markers, file = paste0(outputPath, "DEGTable", selectedOption, "-", gsub(" ", "_", Sys.Date()), ".csv"), row.names = FALSE)

topFeaturesTable <- data.frame(data.markers %>% group_by(cluster1) %>% top_n(numTopFeatures, avg_log2FC))
numClusters <- length(unique(data.markers$cluster1))

```

```{r, echo=FALSE, results='asis', warning=FALSE, message=FALSE, eval=!runMarkerSelection}
topFeaturesTable <- data.frame(gene.id = selected.markers, cluster1 = 1)
data.markers <- data.frame(gene.id = selected.markers, cluster1 = 1)
```

```{r, echo=FALSE, results='asis', warning=FALSE, message=FALSE, eval=plotMarkerSelection}
cat(paste0(headingMS, "# ", titleMarkerPlots," {.tabset .tabset-fade}\n\n"))
cat("Gene plots for the top marker genes are visualized below through a feature plot, ridge plot, violin plot, dot plot and a heatmap plot.")
```

```{r, echo=FALSE, results='asis', warning=FALSE, message=FALSE, eval=plotMarkerSelection}
cat(paste0(headingMS, "## Feature Plot {.tabset .tabset-fade .tabset-pills -}\n\n"))
cat("A feature plot visualizes the expression level of a particular gene marker in all cells of the data on a UMAP plot. The feature plots of the top ", numTopFeatures, " marker genes across all clusters are visualized below:")
```

```{r, echo=FALSE}
figHeight <- numTopFeatures * 1.8
```

```{r, echo=FALSE}
template <- paste0(headingMS, "### %s {.tabset .tabset-fade -}
")
template_inside <- paste0(headingMS, "#### %s {-}
")
space <- "

"
```

```{r, echo = TRUE, warning=FALSE, message=FALSE, results = "asis", fig.height = figHeight, fig.width = 9, eval=plotMarkerSelection}
for (currentCluster in 0:(numClusters-1)) {
  if(numClusters > 1){
    cat(sprintf(template, paste0("Cluster ", unique(topFeaturesTable$cluster1)[currentCluster+1])))
  }
  selectedFeatures <- topFeaturesTable[topFeaturesTable$cluster1 == unique(data.markers$cluster1)[currentCluster+1], ]$gene.id
  plots <- plotSeuratGenes(data, plotType = "feature", features = selectedFeatures, groupVariable = selectedOption, ncol = 1, cols = c("grey", "blue"))
  p <- singleCellTK:::.ggSCTKTheme(patchwork::wrap_plots(plots, ncol = 2))
  print(p)
  cat(space)
}
```

```{r, echo=FALSE, results='asis', warning=FALSE, message=FALSE, eval=plotMarkerSelection}
cat(paste0(headingMS, "## Ridge Plot {.tabset .tabset-fade .tabset-pills -}\n\n"))
cat("A ridge plot visualizes the expression level of a particular gene marker in all cells of the data separated by clusters in the form of ridges. The ridge plots of the top ", numTopFeatures, " marker genes across all clusters are visualized below:")
```

```{r, warning=FALSE, message=FALSE, echo = TRUE, results = "asis", fig.height =figHeight, fig.width = 9, eval = plotMarkerSelection}
for (currentCluster in 0:(numClusters-1)) {
  if(numClusters > 1){
    cat(sprintf(template, paste0("Cluster ", unique(topFeaturesTable$cluster1)[currentCluster+1])))
  }
  selectedFeatures <- topFeaturesTable[topFeaturesTable$cluster1 == unique(data.markers$cluster1)[currentCluster+1], ]$gene.id
  plots <- plotSeuratGenes(data, plotType = "ridge", features = selectedFeatures, groupVariable = selectedOption, ncol = 1, cols = c("grey", "blue"))
  p <- singleCellTK:::.ggSCTKTheme(patchwork::wrap_plots(plots, ncol = 2))
  print(p)
  cat(space)
}
```

```{r, echo=FALSE, results='asis', warning=FALSE, message=FALSE, eval=plotMarkerSelection}
cat(paste0(headingMS, "## Violin Plot {.tabset .tabset-fade .tabset-pills -}\n\n"))
cat("A violin plot visualizes the expression level of a particular gene marker in all cells of the data separated by clusters. The violin plots of the top ", numTopFeatures, " marker genes separated across all clusters are visualized below:")
```

```{r, echo = TRUE, warning=FALSE, message=FALSE, results = "asis", fig.height =figHeight, fig.width = 9, message=FALSE, eval=plotMarkerSelection}
for (currentCluster in 0:(numClusters-1)) {
  if(numClusters > 1){
    cat(sprintf(template, paste0("Cluster ", unique(topFeaturesTable$cluster1)[currentCluster+1])))
  }
  selectedFeatures <- topFeaturesTable[topFeaturesTable$cluster1 == unique(data.markers$cluster1)[currentCluster+1], ]$gene.id
  plots <- plotSeuratGenes(data, plotType = "violin", features = selectedFeatures, groupVariable = selectedOption, ncol = 1, cols = c("grey", "blue"))
  p <- singleCellTK:::.ggSCTKTheme(patchwork::wrap_plots(plots, ncol = 2))
  print(p)
  cat(space)
}
```

```{r, echo=FALSE, results='asis', warning=FALSE, message=FALSE, eval=plotMarkerSelection}
cat(paste0(headingMS, "## Dot Plot {-}\n\n"))
cat("A dot plot visualizes the change in the expression levels of a particular gene marker in all cells of the data separated by clusters in the form of dots where the color of the dots indicate the expression level of that gene in a cluster and the size of the dot indicates the total percentage of the cells in that cluster.")
```

```{r, warning=FALSE, message=FALSE, fig.width=15, fig.height=8, eval = plotMarkerSelection}
plotSeuratGenes(data, plotType = "dot", features = topFeaturesTable$gene.id, groupVariable = selectedOption, ncol = 1, cols = c("grey", "blue")) + theme(axis.text.x = element_text(angle = 90, size = 7), legend.text = element_text(size = 8), legend.key.size = unit(0.4, "cm"), legend.position = "top")
```

```{r, echo=FALSE, results='asis', warning=FALSE, message=FALSE, eval=plotMarkerSelection}
cat(paste0(headingMS, "## Heatmap Plot {-}\n\n"))
```

```{r, warning=FALSE, message=FALSE, fig.width=15, fig.height=15, eval = plotMarkerSelection}
plotSeuratGenes(data, plotType = "heatmap", features = topFeaturesTable$gene.id, groupVariable = selectedOption, ncol = 1, cols = c("grey", "blue")) + theme(axis.text.y = element_text(size = 8), legend.text = element_text(size = 8), legend.key.size = unit(0.5, "cm"), legend.position = "top")
```

```{r, echo=FALSE, results='asis', warning=FALSE, message=FALSE, eval=runMarkerSelection}
cat(paste0(headingMS, "# Table of Top Markers by Cluster\n\n"))
cat("The list of top ", numTopFeatures, " genes for each clusters are listed below:")
```

```{r, echo = FALSE, warning=FALSE, message=FALSE, results='asis', eval=runMarkerSelection}
topFeaturesTable <- data.frame(data.markers %>% group_by(cluster1) %>% top_n(numTopFeatures, avg_log2FC))

colNames<-colnames(topFeaturesTable)

kable(topFeaturesTable, style = 'html', row.names = FALSE) %>%
  kable_styling(bootstrap_options = "striped") %>%
  scroll_box(width = "100%", height = "500px")
```

```{r, results='asis', eval=showSession, echo=FALSE}
cat("# Session Information\n\n")
```

```{r, results='markup', eval = showSession, echo = showSession}
sessionInfo()
```

---
title: "Comprehensive reporting of QC metrics: identifying doublets with Scrublet"
date: "`r format(Sys.time(), '%B %d, %Y')`"
params: 
  object: object
output:
  html_document:
    number_sections: yes
    toc: yes
    code_folding: hide
---

```{r, "scrublet-lib", message = F, include=FALSE}
require(singleCellTK)
require(ggplot2)
```

```{r,"scrublet-import", warning=FALSE, include=FALSE}
sce.qc<- params$object
```

```{r, "Scrublet", results="asis", fig.align="center", warning=FALSE, message=FALSE}
    plotsScrublet<- plotScrubletResults(sce.qc, reducedDimName="UMAP")
    i="Scrublet"
    cat(paste0('# ', i, ' {.tabset .tabset-fade} \n\n'))
    cat(paste0('## Scatter Score \n\n'))
    plotsScrublet$scatter_doubletScore
    
    cat(paste0('## Scatter Call \n\n'))
    plotsScrublet$scatter_doubletCall
   
    cat(paste0('## Density Score \n\n'))
    plotsScrublet$density_doubletScore
   
    cat(paste0('## Violin Score \n\n'))
    plotsScrublet$violin_doubletScore
 
    cat(paste0('## Session info \n\n'))
    sce.qc@metadata$runScrublet
```

```{r, "Scrublet-description", include=FALSE, warning=FALSE, message=FALSE}
description_Scrublet <- descriptionScrublet()
```
# {.unlisted .unnumbered .toc-ignore}
`r description_Scrublet`

---
title: "Seurat Results"
author: "`r params$authors`"
date: "`r format(Sys.time(), '%B %d, %Y')`"
params:
  subtitle: !r NULL
  authors: !r NULL
  sce: !r NULL
  biological.group: !r NULL
  phenotype.groups: !r NULL
  selected.markers: !r NULL
  clustering.resolution: 0.8
  pc.count: 10
  outputPath: !r NULL
  showSession: FALSE
  pdf: TRUE
  plotTSNE: TRUE
  plotUMAP: TRUE
  runClustering: TRUE
  minResolution: 0.3
  maxResolution: 1.5
  runMSClusters: TRUE
  runMSBioGroup: TRUE
  numTopFeatures: 10
  forceRun: FALSE
output:
  html_document:
    toc: yes
    toc_float: yes
    number_sections: yes
    theme: cosmo
    code_folding: hide
    self_contained: false
    keep_md: yes
  pdf_document:
    toc: yes
subtitle: "`r params$subtitle`"
editor_options:
  chunk_output_type: console
---

```{r, echo=FALSE}
if(!exists("significant_PC")) significant_PC <- pc.count
```

```{r, echo=FALSE, message=FALSE, warning=FALSE}
library(Seurat)
library(dplyr)
library(cowplot)
library(RColorBrewer)
library(ggplot2)
library(knitr)
library(kableExtra)
library(SingleCellExperiment)
library(scater)
library(gridExtra)
library(grid)
library(ggpubr)
library(patchwork)
library(singleCellTK)
```

# Seurat Results

## Selected Resolution {.tabset .tabset-fade}
A final resolution of **`r clustering.resolution`** was selected for downstream clustering that better reflects the input data.

<!-- Clustering -->
```{r, echo=FALSE, results='hide', warning=FALSE, message=FALSE}
minResolution <- clustering.resolution
maxResolution <- clustering.resolution
numClusters <- 10 #remove this later
showClusterDesc <- FALSE

resClustering <- knitr::knit_child(system.file("rmarkdown/seurat", "reportSeuratClustering.Rmd", package = "singleCellTK"), quiet = TRUE, envir = environment())
```

```{r, echo=FALSE, results='asis', warning=FALSE, message=FALSE}
cat(resClustering, sep = '\n')
```

<!-- Marker Selection (Clusters) -->
```{r markerSelection Clusters, echo=FALSE, warning=FALSE, message=FALSE, eval=runMSClusters}
runMarkerSelection <- TRUE
plotMarkerSelection <- TRUE
numClusters <- length(unique(colData(data)[[paste0("Seurat_louvain_Resolution", clustering.resolution)]]))
selectedOption <- paste0("Seurat_louvain_Resolution", clustering.resolution)
groupTitle <- "Clusters"
titleMarkerPlots <- "Gene Plots of Top Markers by Clusters"
headingMS <- "##"
resMSC <- knitr::knit_child(system.file("rmarkdown/seurat", "reportSeuratMarkerSelection.Rmd", package = "singleCellTK"), quiet = TRUE, envir = environment())
numMarkerGenesCluster <- nrow(data.markers[data.markers$p_val_adj < 0.05, ])
```

<!-- Marker Selection (Group) -->
```{r, echo=FALSE, warning=FALSE, message=FALSE, eval=runMSBioGroup}
runMarkerSelection <- TRUE
plotMarkerSelection <- TRUE
numClusters <- length(unique(colData(data)[[biological.group]]))
selectedOption <- biological.group
groupTitle <- biological.group
titleMarkerPlots <- paste0("Gene Plots of Top Markers by Group: ", biological.group)
headingMS <- "##"
resMSB <- knitr::knit_child(system.file("rmarkdown/seurat", "reportSeuratMarkerSelection.Rmd", package = "singleCellTK"), quiet = TRUE)
numMarkerGenesBio <- nrow(data.markers[data.markers$p_val_adj < 0.05, ])
```

<!-- Pre-selected Markers -->
```{r preselected markers, echo=FALSE, warning=FALSE, message=FALSE, eval=!is.null(selected.markers)}
runMarkerSelection <- FALSE
plotMarkerSelection <- TRUE
groupTitle <- NULL
numClusters <- 1
selectedOption <- paste0("Seurat_louvain_Resolution", clustering.resolution)
titleMarkerPlots <- "Plot Selected Features"
numTopFeatures <- length(selected.markers)
headingMS <- "#"

resPSM <- knitr::knit_child(system.file("rmarkdown/seurat", "reportSeuratMarkerSelection.Rmd", package = "singleCellTK"), quiet = TRUE)
```

```{r, echo=FALSE, results='asis', warning=FALSE, message=FALSE, eval=!is.null(selected.markers)}
cat(resPSM, sep = '\n')
```

```{r, echo=FALSE, results='asis', warning=FALSE, message=FALSE, eval=runMSClusters}
cat(resMSC, sep = '\n')
```

```{r, echo=FALSE, results='asis', warning=FALSE, message=FALSE, eval=runMSBioGroup}
cat(resMSB, sep = '\n')
```

```{r, results='asis', eval=showSession, echo=showSession}
cat("# Session Information\n\n")
```

```{r, results='markup', eval = showSession, echo = showSession}
sessionInfo()
```

---
title: "SCTK Cell QC Report"
date: "`r format(Sys.time(), '%B %d, %Y')`"
params: 
  object: object
  sample: sample
  subTitle: subTitle
  studyDesign: studyDesign
  reducedDimName: reducedDimName
output:
  html_document:
    number_sections: yes
    toc: yes
    toc_float: true
    collapsed: false
    code_folding: hide
    html_notebook: default
editor_options: 
  chunk_output_type: console
---

<style>
body {
text-align: justify}
</style>

```{r "CellQC-lib", warning=FALSE, include=FALSE}
require(singleCellTK)
require(ggplot2)
require(dplyr)
require(Biobase)
require(cowplot)

docs.base <- paste0("https://www.camplab.net/sctk/v",
                    package.version("singleCellTK"), "/")
docs.qc.Path <- paste0(docs.base, "articles/articles/cmd_qc.html")

metaChecking <- function(metainfo, samples){
  if (any(!samples %in% names(metainfo))) {

    ### if length of metainfo is 1, it indicates that the name is the sample name
    ### This format is compatible with the QC report.
    ### In this case, all samples are ran with single run. Return any sublist is fine. 
    if (length(names(metainfo)) == 1) {
      names(metainfo) <- sample
      return(metainfo)
    }

    ### if QC is ran in R console instead of QC pipeline, we will add place holder.
    ### In this case, different samples also share parameters. Return any sublist is fine 
    newMeta <- list() 
    for (sample in samples) {
      newMeta[[sample]] <- metainfo
    }
    metainfo <- newMeta
  }

  return(metainfo)
}

preprocessMeta <- function(meta, ignore=c("geneSetCollection", "sample", "batch", "batchBackground", "bgBatch")){
  meta <- meta[!names(meta) %in% ignore]
  lapply(meta, function(y){
    while(is.list(y)) {
      if (length(y) != 0){
       y <- y[[1]]
      } else {
       y <- "NULL"
      }
    }
      
    if(is.vector(y)) {
      y <- paste(y,collapse=' ')
    }
      
    if(is.null(y)) {
      y <- "NULL"
    }
    
    return(y)
  })
}

formatPlotList <- function(plotlist, samples) {
  if (length(samples) > 1) {
    return(plotlist)
  }
  
  plotlist <- list(Sample = list(plotlist))
  names(plotlist$Sample) <- samples
  return(plotlist)
}

```

```{r, "CellQC-import", eval = TRUE, include=FALSE}
sce.qc <- params$object
subTitle <- params$subTitle
studyDesign <- params$studyDesign
reducedDimName <- params$reducedDimName
sample <- params$sample
sceSample <- colData(sce.qc)[[sample]]
samples <- unique(sceSample)

## modify assayType data structure for sce generated by SCTK-QC script pipelinne
if (typeof(S4Vectors::metadata(sce.qc)$assayType) == 'list') {
  assayType <- BiocGenerics::Reduce(dplyr::union, S4Vectors::metadata(sce.qc)$assayType)
  S4Vectors::metadata(sce.qc)$assayType <- assayType
}

sce.qc <- runQuickUMAP(sce.qc, reducedDimName = "QC_UMAP", sample = sceSample)

if (is.null(reducedDimName)) {
  allSampleReducedDim <- "All_UMAP"
  sce.qc <- runQuickUMAP(sce.qc, reducedDimName = allSampleReducedDim, sample = NULL)
} else if (!reducedDimName %in% reducedDimNames(sce.qc)) {
  warning("'reducedDimName' not found in the reducedDimNames of the sce object. ",
  "Generate new reduced dimension reduction for all samples. ")
  allSampleReducedDim <- "All_UMAP"
  sce.qc <- runQuickUMAP(sce.qc, reducedDimName = allSampleReducedDim, sample = NULL)
} else {
  allSampleReducedDim <- reducedDimName
}


### when 'sample' doesn't exists in colData
if (is.null(samples)) { samples <- "sample" }

```

---
subtitle: "`r subTitle`"
---
`r studyDesign`
<br />


# Introduction
```{r, "Introduction", echo = FALSE, results="asis", fig.align="center", warning=FALSE, message=FALSE}
cat("\n")

intro <- paste0(
  "Comprehensive quality control (QC) of single-cell RNA-seq data was performed with the [**singleCellTK**](https://github.com/compbiomed/singleCellTK) package. This report contains information about each QC tool and visualization of the QC metrics for each sample. For more information on running this pipeline and performing quality control, see the [**documentation**](",
  docs.qc.Path,
  "). If you use the singleCellTK package for quality control, please include a [**reference**](https://pubmed.ncbi.nlm.nih.gov/35354805/) in your publication."
)

cat(intro)
```
<br />
<br />

```{r, "runPerCellQC-description", include=FALSE, warning=FALSE, message=FALSE}
description_runPerCellQC <- singleCellTK:::descriptionRunPerCellQC()
```

# Summary Statistics {.tabset .tabset-fade}
```{r "SummaryStats", echo = FALSE, results="asis", fig.align="center", warning=FALSE, message=FALSE}
cat("\n")
cat("# {.unlisted .unnumbered .toc-ignore .tabset .tabset-fade}")
cat("\n")

cat(paste0('## SCTK-QC {.tabset .tabset-fade} \n\n'))
sce.qc <- sampleSummaryStats(inSCE = sce.qc, 
                                   sample = sceSample,
                                   simple = FALSE)

summaryTable <- getSampleSummaryStatsTable(sce.qc, statsName = "qc_table")
cat(apply(summaryTable, 1:2, as.character) %>% 
    knitr::kable(format = "html") %>%
      kableExtra::kable_styling() %>%
      kableExtra::scroll_box(width = "80%"))
    
cat("\n")
summary <- "The summary statistics table summarizes QC metrics of the cell matrix. This table summarizes the mean and median of UMI counts and median of genes detected per cell, as well as the number and percentages of doublets and estimated ambient RNA scores per dataset."
cat(summary)
cat("\n\n") 

# cellranger
if ("cellranger" %in% listSampleSummaryStatsTables(sce.qc)) {
  cat(paste0('## cellranger {.tabset .tabset-fade} \n\n'))
  crSummaryTable <- getSampleSummaryStatsTable(sce.qc, 'cellranger')
  cat(apply(crSummaryTable, 1:2, as.character) %>% 
    knitr::kable(format = "html") %>%
      kableExtra::kable_styling() %>%
      kableExtra::scroll_box(width = "80%"))
  cat("\n")
  summary <- "The summary statistics table summarizes QC metrics parsed from 'metrics_summary.csv' file if that's available within the cellranger count output folder. This table summarizes the number of cells detected, mean reads / genes per cell, total number of reads, sequencing saturation and other QC metrics of reads alignment"
  cat(summary)
  cat("\n\n") 
}

# starsolo
if ("starsolo" %in% listSampleSummaryStatsTables(sce.qc)) {
  cat(paste0('## starsolo {.tabset .tabset-fade} \n\n'))
  strSummaryTable <- getSampleSummaryStatsTable(sce.qc, 'starsolo')
  cat(apply(strSummaryTable, 1:2, as.character) %>% 
    knitr::kable(format = "html") %>%
      kableExtra::kable_styling() %>%
      kableExtra::scroll_box(width = "80%"))
  cat("\n")
  summary <- "The summary statistics table summarizes QC metrics parsed from 'Summary.csv' file if that's available within the STARsolo output folder. This table summarizes the number of cells detected, mean reads / genes per cell, total number of reads, reads sequencinng quality, sequencing saturation and other QC metrics of reads alignment"
  cat(summary)
  cat("\n\n") 
}
cat("\n")
```


```{r, "General quality control metrics", results="asis", fig.align="center", warning=FALSE, message=FALSE, echo=FALSE}
i="General quality control metrics"

perCellData <- c("sum", "detected", "percent.top_50")
skipCellData <- any(!perCellData %in% names(colData(sce.qc)))

if (skipCellData) {
  #cat("runPerCellQC did not complete successfully. The section of General quality control metrics is skipped")
  plotsQCMetrics <- NULL
} else {
  cat(paste0('# ', i, ' \n'))
  cat("\n")
  plotsQCMetrics<- tryCatch(
    {plotRunPerCellQCResults(sce.qc, 
                             sample = sceSample,
                             combinePlot="none",
                             axisSize = NULL,
                             axisLabelSize = NULL,
                             titleSize = NULL)},
    error = function(e) {
      cat("runPerCellQC did not complete successfully. The section of General quality control metrics is skipped")
      skipCellData <<- TRUE
      return(NA)
    }
  )
}

if (!skipCellData) {
  
  if (length(samples) == 1) {
    plotsQCMetrics <- list(Violin=plotsQCMetrics)
  }
  # names(plotsQCMetrics$Violin)[names(plotsQCMetrics$Violin) == "mito_percent"] <- "MitoGene_Top50_Percent"
  # names(plotsQCMetrics$Violin)[names(plotsQCMetrics$Violin) == "mito_sum"] <- "MitoGene_Sum"
  # names(plotsQCMetrics$Violin)[names(plotsQCMetrics$Violin) == "mito_detected"] <- "MitoGene_Features"
  geneSubsetData <- grep("subsets_.*", names(plotsQCMetrics$Violin), value = TRUE)
  geneSubsetName <- unique(gsub("_sum|_detected|_percent","",
                                gsub("subsets_","",geneSubsetData)))
  
  cat(description_runPerCellQC$introduction)
  cat(description_runPerCellQC$runPerCellQC)
  cat(description_runPerCellQC$plotRunPerCellQCResults)
  cat(description_runPerCellQC$output)
  cat(description_runPerCellQC$sum)
  cat(description_runPerCellQC$detected)
  cat(description_runPerCellQC$percentTop)
  cat(description_runPerCellQC$subsets)
}
```


# {.unlisted .unnumbered .toc-ignore .tabset .tabset-fade}
```{r "plotsQCMetrics-plot", results="asis", eval=(!skipCellData), fig.align="center", warning=FALSE, message=FALSE, echo=FALSE}
cat("\n")
cat(paste0('## Total Counts {.tabset .tabset-fade} \n\n'))
plotsQCMetrics$Violin$Sum
cat("\n\n")
cat(paste0('## Total Features {.tabset .tabset-fade} \n\n'))
plotsQCMetrics$Violin$Detected
cat("\n\n")
cat(paste0('## Percentage of Library Size Occupied by Top 50 Expressed Features {.tabset .tabset-fade} \n\n'))
plotsQCMetrics$Violin$TopPercent
if(!is.null(plotsQCMetrics$Violin$mito_sum)){
  cat("\n\n")
  cat(paste0('## Total Mitochondrial Counts {.tabset .tabset-fade} \n\n'))
  plotsQCMetrics$Violin$mito_sum
}
if(!is.null(plotsQCMetrics$Violin$mito_detected)){
  cat("\n\n")
  cat(paste0('## Total Mitochondrial Features {.tabset .tabset-fade} \n\n'))
  plotsQCMetrics$Violin$mito_detected
}
if(!is.null(plotsQCMetrics$Violin$mito_percent)){
  cat("\n\n")
  cat(paste0('## Percentage of Mitochondrial Counts {.tabset .tabset-fade} \n\n'))
  plotsQCMetrics$Violin$mito_percent
}


if(length(geneSubsetName) > 0){
  for(ix in seq_along(geneSubsetName)){
    cat("\n\n")
    cat(paste0('## Total Counts of Feature Subset "', geneSubsetName[ix], '"{.tabset .tabset-fade} \n\n'))
    print(plotsQCMetrics$Violin[[paste0("subsets_",geneSubsetName[ix],"_sum")]])
    cat("\n\n")
    cat(paste0('## Total Features within Feature Subset "', geneSubsetName[ix], '"{.tabset .tabset-fade} \n\n'))
    print(plotsQCMetrics$Violin[[paste0("subsets_",geneSubsetName[ix],"_detected")]])
    cat("\n\n")
    cat(paste0('## Percentage of Feature Subset "', geneSubsetName[ix], '" Expression{.tabset .tabset-fade} \n\n'))
    print(plotsQCMetrics$Violin[[paste0("subsets_",geneSubsetName[ix],"_percent")]])
  }
}

cat("\n\n")
cat(paste0('## Parameters {.tabset .tabset-fade} \n\n'))

runPerCellMeta <- sce.qc@metadata$scater_addPerCellQC
runPerCellMeta <- metaChecking(runPerCellMeta, samples[[1]])
x <- preprocessMeta(runPerCellMeta[[ samples[[1]] ]])
t(as.data.frame(x)) %>%
  knitr::kable(format = "html") %>% kableExtra::kable_styling() %>%
  kableExtra::scroll_box(width = "80%")

cat("\n")
cat(description_runPerCellQC$parameter)
```
`r cat("\n\n")`


# Doublet Detection

```{r, "Doublet Summary", fig.width=15, fig.height=5, results="asis", fig.align="center", warning=FALSE, message=FALSE, echo = FALSE}
fontSize <- 15
sampleUMAP =  plotSCEDimReduceColData(
    inSCE=sce.qc,
    sample=NULL,
    colorBy="sample",
    conditionClass="factor",
    reducedDimName=allSampleReducedDim,
    xlab=c("QC_UMAP_1"),
    ylab=c("QC_UMAP_2"),
    axisSize = fontSize,
    axisLabelSize = fontSize,
    legendSize = fontSize,
    titleSize = fontSize,
    labelClusters=FALSE,
    title="Sample",
    plotLabels = NULL,
    combinePlot="none"
  )

dbAlgo <- setNames(
  c("scrublet_call", "scDblFinder_doublet_call", "scds_cxds_call", "scds_bcds_call", "scds_hybrid_call"),
  c("Scrublet", "scDblFinder", "Scds_Cxds", "Scds_Bcds", "Scds_Hybrid")
  )

dF <- grep("doubletFinder_doublet_label", names(colData(sce.qc)), value=TRUE)
if (length(dF) != 0) {
  names(dF) <- paste(unlist(strsplit(dF, "_"))[-c(2,3,4)], collapse = "_")
  dbAlgo <- c(dbAlgo, dF)
}

if (length(dbAlgo) != 0) {
  i="Doublet Detection Summary"
  cat(paste0('## ', i, ' \n'))
  cat("## {.unlisted .unnumbered .toc-ignore .tabset .tabset-fade}")
  cat("\n")
  
  for (algo in dbAlgo) {
    if (!algo %in% names(colData(sce.qc))) {
      next
    }
    algoName <- names(dbAlgo)[dbAlgo == algo]
    cat(paste0("### ", algoName, " {.tabset .tabset-fade} \n"))
    cat("\n\n")
  
    plotDoublet <- plotSCEDimReduceColData(
        inSCE=sce.qc,
        sample=NULL,
        colorBy=algo,
        conditionClass="factor",
        colorScale = c("lightgray","red"),
        # shape=shape,
        reducedDimName=allSampleReducedDim,
        axisSize = fontSize,
        axisLabelSize = fontSize,
        legendSize = fontSize,
        titleSize = fontSize,
        xlab=c("QC_UMAP_1"),
        ylab=c("QC_UMAP_2"),
        labelClusters=FALSE,
        title=algoName,
        legendTitle = "Doublet Call",
        plotLabels = NULL,
        combinePlot="none"
      )
  
    print(plot_grid(sampleUMAP, plotDoublet, ncol = 2))
    cat("\n\n")
  }
}


```


```{r, "Scrublet-description", include=FALSE, warning=FALSE, message=FALSE}
description_Scrublet <- singleCellTK:::descriptionScrublet()
```

```{r, "Scrublet", results="asis", fig.align="center", warning=FALSE, message=FALSE, echo = FALSE}
i="Scrublet"

scrubletData <- c("scrublet_score", "scrublet_call")
skipScrublet <- any(!scrubletData %in% names(colData(sce.qc)))

if (skipScrublet) {
  #cat("runScrublet did not complete successfully. The section of Scrublet is skipped")
  plotsScrublet <- NULL
} else {
  cat(paste0('## ', i, ' \n'))
    plotsScrublet<- tryCatch(
      {plotScrubletResults(sce.qc, 
                           reducedDimName="QC_UMAP",
                           sample = sceSample,
                           combinePlot = "none",
                           axisSize = NULL,
                           axisLabelSize = NULL,
                           titleSize = NULL)},
    error = function(e) {
      cat("runScrublet did not complete successfully. The section of Scrublet is skipped")
      skipScrublet <<- TRUE
      return(NA)
    }
  )
}

if (!skipScrublet) {
  plotsScrublet <- formatPlotList(plotsScrublet, samples)
  cat(description_Scrublet$introduction)
  cat(description_Scrublet$runScrublet)
  cat(description_Scrublet$plotScrubletResults)
  cat(description_Scrublet$output)
  cat("\n")
}
```


```{r "Scrublet-plot", echo=FALSE, eval=(!skipScrublet), results="asis", fig.align="center"}
cat("## {.unlisted .unnumbered .toc-ignore .tabset .tabset-fade}")
cat("\n")
for (sample in samples) {
  cat(paste0("### ", sample, " {.tabset .tabset-fade} \n"))
  cat("\n\n")
  
  cat("#### Scrublet Doublet Assignment {.tabset .tabset-fade} \n\n")
  print(plotsScrublet$Sample[[sample]][["scatter_doubletCall"]])
  cat("\n\n")  
  
  cat("#### Scrublet Doublet Score {.tabset .tabset-fade} \n")
  print(plotsScrublet$Sample[[sample]][["scatter_doubletScore"]])
  cat("\n\n")
  
  cat("#### Density Score {.tabset .tabset-fade} \n")
  print(plotsScrublet$Sample[[sample]][["density_doubletScore"]])
  cat("\n\n")
  
  cat("#### Violin Score {.tabset .tabset-fade} \n ")
  print(plotsScrublet$Sample[[sample]][["violin_doubletScore"]])
  cat("\n\n")
  
  cat("#### Parameters {.tabset .tabset-fade} \n\n")
  runScrubletMeta <- sce.qc@metadata$runScrublet
  runScrubletMeta <- metaChecking(runScrubletMeta, sample)
  # if(length(samples) == 1) {
  #   runScrubletMeta <- list(runScrubletMeta)
  #   names(runScrubletMeta) <- sample
  # }
  
  x <- preprocessMeta(runScrubletMeta[[sample]])
  cat(t(as.data.frame(x)) %>%
    knitr::kable(format = "html") %>% kableExtra::kable_styling() %>%
    kableExtra::scroll_box(width = "80%"))
  cat(description_Scrublet$additionalParam)
  cat("\n\n")
}
cat("\n")
```


```{r, "DoubletFinder-description", include=FALSE, warning=FALSE, message=FALSE}
description_DoubletFinder <- singleCellTK:::descriptionDoubletFinder()
```

```{r, "DoubletFinder-0", results="asis", fig.align="center", warning=FALSE, message=FALSE, echo=FALSE}
i="DoubletFinder"

doubletFinderData <- grep("doubletFinder_doublet", names(colData(sce.qc)), value=TRUE)
skipFinder <- length(doubletFinderData)==0  

if (skipFinder) {
  #cat("runDoubletFinder did not complete successfully. The section of DoubletFinder is skipped")
  plotDoubletFinder <- NULL
} else {
  cat(paste0('## ', i, ' \n'))
  plotDoubletFinder<- tryCatch(
    {plotDoubletFinderResults(inSCE = sce.qc, 
                              reducedDimName = "QC_UMAP",
                              sample = sceSample,
                              combinePlot = "none",
                              axisSize = NULL,
                              axisLabelSize = NULL,
                              titleSize = NULL)},
    error = function(e) {
      cat("runDoubletFinder did not complete successfully. The section of DoubletFinder is skipped")
      skipFinder <<- TRUE
      return(NA)
    }
  )
}

if (!skipFinder) {
  plotDoubletFinder <- formatPlotList(plotDoubletFinder, samples)
  resolutions <- grep("doubletFinder_doublet_score_resolution_", colnames(colData(sce.qc)), value = TRUE)
  resolutions <- gsub("doubletFinder_doublet_score_resolution_", "", resolutions)
  
  cat(description_DoubletFinder$introduction)
  cat(description_DoubletFinder$runDoubletFinder)
  cat(description_DoubletFinder$plotDoubletFinderResults)
  cat(description_DoubletFinder$output)
  cat("\n")
}
```

```{r "DoubletFinder-plot", echo=FALSE, eval=!(skipFinder), results="asis", fig.align="center"}
cat("## {.unlisted .unnumbered .toc-ignore .tabset .tabset-fade}")
cat("\n")
for (sample in samples) {
  cat(paste0("### ", sample, " {.tabset .tabset-fade} \n"))
  cat("\n")
  for (resolution in resolutions) {
    cat(paste0("#### Resolution: ", resolution, " {.tabset .tabset-fade} \n"))
    cat("\n")
    
    cat("##### DoubletFinder Doublet Assignment {.tabset .tabset-fade} \n\n")
    print(plotDoubletFinder$Sample[[sample]][[paste0("Scatter_Call_resolution_", resolution)]])
    cat("\n\n")
    
    cat("##### DoubletFinder Doublet Score {.tabset .tabset-fade} \n\n")
    print(plotDoubletFinder$Sample[[sample]][[paste0("Scatter_Score_resolution_", resolution)]])
    cat("\n\n")
    
    cat("##### Density of Doublet Score {.tabset .tabset-fade} \n\n")
    print(plotDoubletFinder$Sample[[sample]][[paste0("Density_resolution_", resolution)]])
    cat("\n\n")
    
    cat("##### Violin of Doublet Score {.tabset .tabset-fade} \n\n")
    print(plotDoubletFinder$Sample[[sample]][[paste0("violin_resolution_", resolution)]])
    cat("\n\n")
    
    cat("##### Parameters {.tabset .tabset-fade} \n\n")
    DoubletFinderMeta <- sce.qc@metadata$runDoubletFinder
    DoubletFinderMeta <- metaChecking(DoubletFinderMeta, sample)

    # if(length(samples) == 1) {
    #   DoubletFinderMeta <- list(DoubletFinderMeta)
    #   names(DoubletFinderMeta) <- sample
    # }
    
    x <- preprocessMeta(DoubletFinderMeta[[sample]])
    cat(t(as.data.frame(x)) %>%
      knitr::kable(format = "html") %>% kableExtra::kable_styling() %>%
      kableExtra::scroll_box(width = "80%"))
    
    cat(description_DoubletFinder$seuratRes)
    cat(description_DoubletFinder$seuratNfeatures)
    cat(description_DoubletFinder$seuratPCs)
    cat(description_DoubletFinder$seuratFormationRate)
    cat("\n\n")
  }
}
cat("\n")
```


```{r, "ScDblFinder-description", include=FALSE, warning=FALSE, message=FALSE}
description_ScDblFinder<- singleCellTK:::descriptionScDblFinder()
```

```{r, "ScDblFinder", results="asis", fig.align="center", warning=FALSE, message=FALSE, echo=FALSE}
i="ScDblFinder"
#cat(paste0('## ', i, ' \n'))

scDblFinderData <- c("scDblFinder_doublet_score")
skipScDblFinder <- any(!scDblFinderData %in% names(colData(sce.qc)))

if (skipScDblFinder) {
  #cat("runScDblFinder did not complete successfully. The section of ScDblFinder is skipped")
  plotScDblFinder <- NULL
} else {
  cat(paste0('## ', i, ' \n'))
  plotScDblFinder<- tryCatch(
    {plotScDblFinderResults(inSCE = sce.qc, 
                            sample = sceSample,
                            combinePlot = "none",
                            reducedDimName = "QC_UMAP",
                            axisSize = NULL,
                            axisLabelSize = NULL,
                            titleSize = NULL)},
    error = function(e) {
      cat("runScDblFinder did not complete successfully. The section of ScDblFinder is skipped")
      skipScDblFinder <<- TRUE
      return(NA)
    }
  )
}

if(!skipScDblFinder) {
  plotScDblFinder <- formatPlotList(plotScDblFinder, samples)
  cat(description_ScDblFinder$introduction)
  cat(description_ScDblFinder$runScDblFinder)
  cat(description_ScDblFinder$plotScDblFinderResults)
  cat(description_ScDblFinder$output)
  cat("\n")
}
```

```{r "ScDblFinder-plot", echo=FALSE, eval=!(skipScDblFinder), results="asis", fig.align="center"}
cat("## {.unlisted .unnumbered .toc-ignore .tabset .tabset-fade}")
cat("\n")
for (sample in samples){
  cat(paste0("### ", sample, " {.tabset .tabset-fade} \n"))
  cat("\n\n")
  
  cat("#### ScDblFinder Doublet Assignment {.tabset .tabset-fade} \n\n ")
  print(plotScDblFinder$Sample[[sample]][["scatter_doubletCall"]])
  cat("\n\n")
    
  cat("#### ScDblFinder Doublet Score {.tabset .tabset-fade} \n\n ")
  print(plotScDblFinder$Sample[[sample]][["scatter_doubletScore"]])
  cat("\n\n")
  
  cat("#### Density Score {.tabset .tabset-fade} \n\n")
  print(plotScDblFinder$Sample[[sample]][["density_doubletScore"]])
  cat("\n\n")
  
  cat("#### Violin Score {.tabset .tabset-fade} \n\n")
  print(plotScDblFinder$Sample[[sample]][["violin_doubletScore"]])
  cat("\n\n")

  cat("#### Parameters {.tabset .tabset-fade} \n\n")
  ScDblFinderMeta <- sce.qc@metadata$runScDblFinder
  ScDblFinderMeta <- metaChecking(ScDblFinderMeta, sample)

  # if(length(samples) == 1) {
  #   DoubletCellMeta <- list(DoubletCellMeta)
  #   names(DoubletCellMeta) <- sample
  # }
  
  x <- preprocessMeta(ScDblFinderMeta[[sample]])
  cat(t(as.data.frame(x)) %>%
    knitr::kable(format = "html") %>% kableExtra::kable_styling() %>%
    kableExtra::scroll_box(width = "80%"))
  cat(description_ScDblFinder$parameter)
  cat("\n\n")
}
cat("\n")
```


```{r, "Cxds-description", include=FALSE, warning=FALSE, message=FALSE}
descriprion_CxdsResults<- singleCellTK:::descriptionCXDS()
```

```{r, "Cxds", results="asis", fig.align="center", warning=FALSE, message=FALSE, echo=FALSE}
i="Cxds"
# cat(paste0('## ', i, ' \n'))

cvdsData <- c("scds_cxds_score", "scds_cxds_call")
skipCxds <- any(!cvdsData %in% names(colData(sce.qc)))

if (skipCxds) {
  #cat("runCxds did not complete successfully. The section of Cxds is skipped")
  plotCxds <- NULL
} else {
  cat(paste0('## ', i, ' \n'))
  plotCxds<- tryCatch(
    {plotCxdsResults(inSCE = sce.qc, 
                     sample = sceSample,
                     combinePlot = "none",
                     reducedDimName = "QC_UMAP",
                     axisSize = NULL,
                     axisLabelSize = NULL,
                     titleSize = NULL)},
    error = function(e) {
      cat("runCxds did not complete successfully. The section of Cxds is skipped")
      skipCxds <<- TRUE
      return(NA)
    }
  )
}

if (!skipCxds) {
  plotCxds <- formatPlotList(plotCxds, samples)
  cat(descriprion_CxdsResults$introduction)
  cat(descriprion_CxdsResults$runCxds)
  cat(descriprion_CxdsResults$plotCxdsResults)
  cat(descriprion_CxdsResults$output)
  cat("\n")
}
```

```{r "Cxds-plot", echo=FALSE,eval=(!skipCxds), results="asis", fig.align="center"}
cat("## {.unlisted .unnumbered .toc-ignore .tabset .tabset-fade}")
cat("\n")
for (sample in samples){
  cat(paste0("### ", sample, " {.tabset .tabset-fade} \n"))
  cat("\n\n")
  
  cat("#### Cxds Doublet Assignment {.tabset .tabset-fade} \n\n")
  plot(plotCxds$Sample[[sample]][["scatter_doubletCall"]])
  cat("\n\n")
    
  cat("#### Cxds Doublet Score {.tabset .tabset-fade} \n\n")
  plot(plotCxds$Sample[[sample]][["scatter_doubletScore"]])
  cat("\n\n")
  
  cat("#### Density Score {.tabset .tabset-fade} \n\n")
  plot(plotCxds$Sample[[sample]][["density_doubletScore"]])
  cat("\n\n")
  
  cat("#### Violin Score {.tabset .tabset-fade} \n\n")
  plot(plotCxds$Sample[[sample]][["violin_doubletScore"]])
  cat("\n\n")

  cat("#### Parameters {.tabset .tabset-fade} \n\n")
  CxdsMeta <- sce.qc@metadata$runCxds
  CxdsMeta <- metaChecking(CxdsMeta, sample)

  # if(length(samples) == 1) {
  #   CxdsMeta <- list(CxdsMeta)
  #   names(CxdsMeta) <- sample
  # }
  
  x <- preprocessMeta(CxdsMeta[[sample]])
  cat(t(as.data.frame(x)) %>%
    knitr::kable(format = "html") %>% kableExtra::kable_styling() %>%
    kableExtra::scroll_box(width = "80%"))
  
  cat(descriprion_CxdsResults$nTop)
  cat(descriprion_CxdsResults$binThresh)
  cat(descriprion_CxdsResults$verb)
  cat(descriprion_CxdsResults$retRes)
  cat(descriprion_CxdsResults$estNdbl)
  cat("\n\n")
  
}
cat("\n")
```


```{r, "Bcds-description", include=FALSE, warning=FALSE, message=FALSE}
descriprion_BcdsResults<- singleCellTK:::descriptionBCDS()
```

```{r, "Bcds", results="asis", fig.align="center", warning=FALSE, message=FALSE, echo=FALSE}
i="Bcds"
# cat(paste0('## ', i, ' \n'))

bcdsData <- c("scds_bcds_score", "scds_bcds_call")
skipBcds <- any(!bcdsData %in% names(colData(sce.qc)))

if (skipBcds) {
  #cat("runBcds did not complete successfully. The section of Bcds is skipped")
  plotBcds <- NULL
} else {
  cat(paste0('## ', i, ' \n'))
  plotBcds<- tryCatch(
    {plotBcdsResults(inSCE = sce.qc, 
                     sample = sceSample,
                     combinePlot = "none",
                     reducedDimName = "QC_UMAP",
                     axisSize = NULL,
                     axisLabelSize = NULL,
                     titleSize = NULL)},
    error = function(e) {
      cat("runBcds did not complete successfully. The section of Bcds is skipped")
      skipBcds <<- TRUE
      return(NA)
    }
  )
}

if (!skipBcds) {
  plotBcds <- formatPlotList(plotBcds, samples)
  cat(descriprion_BcdsResults$introduction)
  cat(descriprion_BcdsResults$runBcds)
  cat(descriprion_BcdsResults$plotBcdsResults)
  cat(descriprion_BcdsResults$output)
  cat("\n")
}
```

```{r "Bcds-plot", echo=FALSE, eval=(!skipBcds), results="asis", fig.align="center"}
cat("## {.unlisted .unnumbered .toc-ignore .tabset .tabset-fade}")
cat("\n")
for (sample in samples){
  cat(paste0("### ", sample, " {.tabset .tabset-fade} \n"))
  cat("\n\n")
  
  cat("#### Bcds Doublet Assignment {.tabset .tabset-fade} \n\n")
  plot(plotBcds$Sample[[sample]][["scatter_doubletCall"]])
  cat("\n\n")
    
  cat("#### Bcds Doublet Score {.tabset .tabset-fade} \n\n")
  plot(plotBcds$Sample[[sample]][["scatter_doubletScore"]])
  cat("\n\n")
  
  cat("#### Density Score {.tabset .tabset-fade} \n\n")
  plot(plotBcds$Sample[[sample]][["density_doubletScore"]])
  cat("\n\n")
  
  cat("#### Violin Score {.tabset .tabset-fade} \n\n")
  plot(plotBcds$Sample[[sample]][["violin_doubletScore"]])
  cat("\n\n")

  cat("#### Parameters {.tabset .tabset-fade} \n\n")
  BcdsMeta <- sce.qc@metadata$runBcds
  BcdsMeta <- metaChecking(BcdsMeta, sample)

  # if(length(samples) == 1) {
  #   BcdsMeta <- list(BcdsMeta)
  #   names(BcdsMeta) <- sample
  # }
  
  x <- preprocessMeta(BcdsMeta[[sample]])
  cat(t(as.data.frame(x)) %>%
    knitr::kable(format = "html") %>% kableExtra::kable_styling() %>%
    kableExtra::scroll_box(width = "80%"))
  
  cat(descriprion_BcdsResults$nTop)
  cat(descriprion_BcdsResults$srat)
  cat(descriprion_BcdsResults$nmax)
  cat(descriprion_BcdsResults$varImp)
  cat("\n\n")
  
}
cat("\n")
```



```{r, "ScdsHybrid-description", include=FALSE, warning=FALSE, message=FALSE}
description_ScdsHybrid<- singleCellTK:::descriptionScdsHybrid()
```


```{r, "ScdsHybrid", results="asis", fig.align="center", warning=FALSE, message=FALSE, echo=FALSE}
i="ScdsHybrid"
# cat(paste0('## ', i, ' \n'))

hybridData <- c("scds_hybrid_score", "scds_hybrid_call")
skipScdsHybrid <- any(!hybridData %in% names(colData(sce.qc)))

if (skipScdsHybrid) {
  #cat("runCxdsBcdsHybrid did not complete successfully. The section of ScdsHybrid is skipped")
  plotScdsHybrid <- NULL
} else {
  cat(paste0('## ', i, ' \n'))
  plotScdsHybrid<- tryCatch(
    {plotScdsHybridResults(inSCE = sce.qc, 
                           sample = sceSample,
                           combinePlot = "none",
                           reducedDimName = "QC_UMAP",
                           axisSize = NULL,
                           axisLabelSize = NULL,
                           titleSize = NULL)},
    error = function(e) {
      cat("runCxdsBcdsHybrid did not complete successfully. The section of ScdsHybrid is skipped")
      skipScdsHybrid <<- TRUE
      return(NA)
    }
  )
}

if (!skipScdsHybrid) {
  plotScdsHybrid <- formatPlotList(plotScdsHybrid, samples)
  cat(description_ScdsHybrid$introduction)
  cat(description_ScdsHybrid$runCxdsBcdsHybrid)
  cat(description_ScdsHybrid$plotScdsHybridResults)
  cat(description_ScdsHybrid$output)
  cat("\n")
}
```

```{r "ScdsHybrid-plot", echo=FALSE, eval=(!skipScdsHybrid), results="asis", fig.align="center"}
cat("## {.unlisted .unnumbered .toc-ignore .tabset .tabset-fade}")
cat("\n")
for (sample in samples){
  cat(paste0("### ", sample, " {.tabset .tabset-fade} \n"))
  cat("\n\n")
  
  cat("#### ScdsHybrid Doublet Assignment {.tabset .tabset-fade} \n\n")
  plot(plotScdsHybrid$Sample[[sample]][["scatter_doubletCall"]])
  cat("\n\n")
    
  cat("#### ScdsHybrid Doublet Score {.tabset .tabset-fade} \n\n")
  plot(plotScdsHybrid$Sample[[sample]][["scatter_doubletScore"]])
  cat("\n\n")
  
  cat("#### Density Score {.tabset .tabset-fade} \n\n")
  plot(plotScdsHybrid$Sample[[sample]][["density_doubletScore"]])
  cat("\n\n")
  
  cat("#### Violin Score {.tabset .tabset-fade} \n\n")
  plot(plotScdsHybrid$Sample[[sample]][["violin_doubletScore"]])
  cat("\n\n")

  cat("#### Parameters {.tabset .tabset-fade} \n\n")
  HybridMeta <- sce.qc@metadata$runCxdsBcdsHybrid
  HybridMeta <- metaChecking(HybridMeta, sample)

  # if(length(samples) == 1) {
  #   HybridMeta <- list(HybridMeta)
  #   names(HybridMeta) <- sample
  # }
  
  x <- preprocessMeta(HybridMeta[[sample]])
  cat(t(as.data.frame(x)) %>%
    knitr::kable(format = "html") %>% kableExtra::kable_styling() %>%
    kableExtra::scroll_box(width = "80%"))
  
  cat(description_ScdsHybrid$parameters)
  cat("\n\n")
}
cat("\n")
```
`r cat("\n")`


# Ambient RNA Detection

```{r, "AmbientRNA Summary", fig.width=15, fig.height=5, results="asis", fig.align="center", warning=FALSE, message=FALSE, echo = FALSE}
### get all doublet detection algorithms
fontSize <- 15
amBAlgo <- setNames(
  c("decontX_contamination", "decontX_contamination_bg"),
  c("decontX", "decontX with background")
  )

if (length(amBAlgo) != 0) {
  i="Ambient RNA Detection Summary"
  cat(paste0('## ', i, ' \n'))
  cat("## {.unlisted .unnumbered .toc-ignore .tabset .tabset-fade}")
  cat("\n")

  for (algo in amBAlgo) {
    if (!algo %in% names(colData(sce.qc))) {
      next
    }
    algoName <- names(amBAlgo)[amBAlgo == algo]
    cat(paste0("### ", algoName, " {.tabset .tabset-fade} \n"))
    cat("\n\n")
  
    plotAmbient <- plotSCEDimReduceColData(
        inSCE=sce.qc,
        sample=NULL,
        colorBy=algo,
        conditionClass="numeric",
        colorScale = c("lightgray","red"),
        reducedDimName=allSampleReducedDim,
        axisSize = fontSize,
        axisLabelSize = fontSize,
        legendSize = fontSize,
        titleSize = fontSize,
        xlab=c("QC_UMAP_1"),
        ylab=c("QC_UMAP_2"),
        labelClusters=FALSE,
        title=algoName,
        legendTitle = "Ambient \nContamination \nScore",
        plotLabels = NULL,
        combinePlot="none"
      )
  
    print(plot_grid(sampleUMAP, plotAmbient, ncol = 2))
    cat("\n\n")
  }
}

```

```{r, "DecontX-description", include=FALSE, warning=FALSE, message=FALSE}
description_DecontX<- singleCellTK:::descriptionDecontX()
```

```{r, "DecontX", results="asis", fig.align="center", warning=FALSE, message=FALSE, echo=FALSE}
i="DecontX"
# cat(paste0('## ', i, ' \n'))

decontXData <- c("decontX_contamination", "decontX_clusters")
skipDecontX <- any(!decontXData %in% names(colData(sce.qc)))

if (skipDecontX) {
  #cat("runDecontX did not complete successfully. The section of DecontX is skipped")
  plotDecontX <- NULL
} else {
  cat(paste0('## ', i, ' \n'))
  plotDecontX<- tryCatch(
    {plotDecontXResults(inSCE = sce.qc, 
                        sample = sceSample,
                        combinePlot = "none",
                        reducedDimName = "QC_UMAP",
                        axisSize = NULL,
                        axisLabelSize = NULL,
                        titleSize = NULL)},
    error = function(e) {
      cat("runDecontX did not complete successfully. The section of DecontX is skipped")
      skipDecontX <<- TRUE
      return(NA)
    }
  )
}

if (!skipDecontX) {
  plotDecontX <- formatPlotList(plotDecontX, samples)
  cat(description_DecontX$introduction)
  cat(description_DecontX$runDecontX)
  cat(description_DecontX$plotDecontXResults)
  cat(description_DecontX$output)
  cat(description_DecontX$contamination)
  cat(description_DecontX$clustering)
}
```
<br />


## {.unlisted .unnumbered .toc-ignore .tabset .tabset-fade}
```{r "DecontX-plot", echo=FALSE, eval=(!skipDecontX), results="asis", fig.align="center"}
cat("\n")
for (sample in samples){
  cat(paste0("### ", sample, " {.tabset .tabset-fade} \n"))
  cat("\n\n")
  
  cat("#### DecontX Contamination Score {.tabset .tabset-fade} \n\n")
  plot(plotDecontX$Sample[[sample]][["scatter_decontXContamination"]])
  cat("\n\n")
  
  cat("#### DecontX Clusters {.tabset .tabset-fade} \n\n")
  plot(plotDecontX$Sample[[sample]][["scatter_decontXClusters"]])
  cat("\n\n")
    
  cat("#### Density Score {.tabset .tabset-fade} \n\n")
  plot(plotDecontX$Sample[[sample]][["density_decontXContamination"]])
  cat("\n\n")
  
  cat("#### Violin Score {.tabset .tabset-fade} \n\n")
  plot(plotDecontX$Sample[[sample]][["violin_decontXContamination"]])
  cat("\n\n")

  cat("#### Parameters {.tabset .tabset-fade} \n\n")
  DecontXMeta <- sce.qc@metadata$sctk$runDecontX
  DecontXMeta <- metaChecking(DecontXMeta, sample)

  # if(length(samples) == 1) {
  #   DecontXMeta <- list(DecontXMeta)
  #   names(DecontXMeta) <- sample
  # }
  
  x <- preprocessMeta(DecontXMeta[[sample]])
  cat(t(as.data.frame(x)) %>%
    knitr::kable(format = "html") %>% kableExtra::kable_styling() %>%
    kableExtra::scroll_box(width = "80%"))
  cat("\n\n")
}
```
`r cat("\n")`

```{r, "DecontX_bg", results="asis", fig.align="center", warning=FALSE, message=FALSE, echo=FALSE}
i="DecontX with raw/droplet matrix"
# cat(paste0('## ', i, ' \n'))

decontXData_bg <- c("decontX_contamination_bg", "decontX_clusters_bg")
skipDecontX_bg <- any(!decontXData_bg %in% names(colData(sce.qc)))

if (skipDecontX_bg) {
  #cat("runDecontX did not complete successfully. The section of DecontX is skipped")
  plotDecontX_bg <- NULL
} else {
  cat(paste0('## ', i, ' \n'))
  plotDecontX_bg<- tryCatch(
    {plotDecontXResults(inSCE = sce.qc, 
                        sample = sceSample,
                        bgResult = TRUE,
                        combinePlot = "none",
                        reducedDimName = "QC_UMAP",
                        axisSize = NULL,
                        axisLabelSize = NULL,
                        titleSize = NULL)},
    error = function(e) {
      cat("runDecontX did not complete successfully. The section of DecontX_bg is skipped")
      skipDecontX_bg <<- TRUE
      return(NA)
    }
  )
}

if (!skipDecontX_bg) {
  plotDecontX_bg <- formatPlotList(plotDecontX_bg, samples)
  cat(description_DecontX$introduction)
  cat(description_DecontX$runDecontX)
  cat(description_DecontX$plotDecontXResults)
  cat(description_DecontX$output)
  cat(description_DecontX$contamination)
  cat(description_DecontX$clustering)
}
```
<br />


## {.unlisted .unnumbered .toc-ignore .tabset .tabset-fade}
```{r "DecontX_bg-plot", echo=FALSE, eval=(!skipDecontX_bg), results="asis", fig.align="center"}
cat("\n")
for (sample in samples){
  cat(paste0("### ", sample, " {.tabset .tabset-fade} \n"))
  cat("\n\n")
     
  cat("#### DecontX Contamination Score {.tabset .tabset-fade} \n\n")
  plot(plotDecontX_bg$Sample[[sample]][["scatter_decontXContamination"]])
  cat("\n\n")
  
  cat("#### DecontX Clusters {.tabset .tabset-fade} \n\n")
  plot(plotDecontX_bg$Sample[[sample]][["scatter_decontXClusters"]])
  cat("\n\n")

  
  cat("#### Density Score {.tabset .tabset-fade} \n\n")
  plot(plotDecontX_bg$Sample[[sample]][["density_decontXContamination"]])
  cat("\n\n")
  
  cat("#### Violin Score {.tabset .tabset-fade} \n\n")
  plot(plotDecontX_bg$Sample[[sample]][["violin_decontXContamination"]])
  cat("\n\n")

  cat("#### Parameters {.tabset .tabset-fade} \n\n")
  DecontXMeta_bg <- sce.qc@metadata$sctk$runDecontX_bg
  DecontXMeta_bg <- metaChecking(DecontXMeta_bg, sample)

  # if(length(samples) == 1) {
  #   DecontXMeta <- list(DecontXMeta)
  #   names(DecontXMeta) <- sample
  # }
  
  x <- preprocessMeta(DecontXMeta_bg[[sample]])
  cat(t(as.data.frame(x)) %>%
    knitr::kable(format = "html") %>% kableExtra::kable_styling() %>%
    kableExtra::scroll_box(width = "80%"))
  cat("\n\n")
}
```
`r cat("\n")`


```{r, "SoupX-description", include=FALSE, warning=FALSE, message=FALSE}
description_SoupX <- singleCellTK:::descriptionSoupX()
```

```{r, "SoupX", results="asis", fig.align="center", warning=FALSE, message=FALSE, echo=FALSE}
i="SoupX"
# cat(paste0('## ', i, ' \n'))

soupXData <- c("soupX_nUMIs", "soupX_contamination")
# soupX cluster label might be supplied by users, thus not checking it.
skipSoupX <- any(!soupXData %in% names(colData(sce.qc)))

soupXSample <- samples


if (skipSoupX) {
  #cat("runDecontX did not complete successfully. The section of DecontX is skipped")
  plotSoupX <- NULL
} else {
  cat(paste0('## ', i, ' \n'))
  plotSoupX <- tryCatch(
    {plotSoupXResults(inSCE = sce.qc, 
                      sceSample, 
                      combinePlot = "none")},
    error = function(e) {
      cat("runSoupX did not complete successfully. The section of SoupX is skipped\n\n")
      skipSoupX <<- TRUE
      return(NA)
    }
  )
}

if (!skipSoupX) {
  plotSoupX <- formatPlotList(plotSoupX, samples)
  cat(description_SoupX$introduction)
  cat(description_SoupX$runSoupX)
  cat(description_SoupX$output)
  cat(description_SoupX$contamination)
  cat(description_SoupX$clustering)
  cat(description_SoupX$plotSoupXResults)
}
```
<br />


## {.unlisted .unnumbered .toc-ignore .tabset .tabset-fade}
```{r "SoupX-plot", echo=FALSE, eval=(!skipSoupX), results="asis", fig.align="center"}
cat("\n\n")
for (sample in samples){
  cat(paste0("### ", sample, " {.tabset .tabset-fade} \n\n"))
  
  cat("#### SoupX Clustering {.tabset .tabset-fade} \n\n")
  plot(plotSoupX$Sample[[sample]][["scatter_soupXClusters"]])
  cat("\n\n")
  
  cat("#### Soup Fractions {.tabset .tabset-fade} \n\n")
  
  for (marker in names(plotSoupX$Sample[[sample]])[-1]) {
    cat(paste0("##### ", marker, " {.tabset .tabset-fade} \n\n"))
    plot(plotSoupX$Sample[[sample]][[marker]])
    cat("\n\n")
  }
  
  cat("#### Parameters {.tabset .tabset-fade} \n\n")
  if (length(samples) == 1) {
    SoupXMeta <- getSoupX(sce.qc, soupXSample, background = FALSE)[[1]]$param
    SoupXMeta <- metaChecking(SoupXMeta, soupXSample)
    x <- preprocessMeta(SoupXMeta[[soupXSample]])
  } else {
    SoupXMeta <- getSoupX(sce.qc, sample, background = FALSE)[[1]]$param
    SoupXMeta <- metaChecking(SoupXMeta, sample)
    x <- preprocessMeta(SoupXMeta[[sample]])
  }
  cat(t(as.data.frame(x)) %>%
    knitr::kable(format = "html") %>% kableExtra::kable_styling() %>%
    kableExtra::scroll_box(width = "80%"))
  cat("\n\n")
}
```
`r cat("\n")`

```{r, "SoupX_bg", results="asis", fig.align="center", warning=FALSE, message=FALSE, echo=FALSE}
i="SoupX with raw/droplet matrix"
# cat(paste0('## ', i, ' \n'))

soupXData_bg <- c("soupX_bg_nUMIs", "soupX_bg_contamination")
skipSoupX_bg <- any(!soupXData_bg %in% names(colData(sce.qc)))

if (length(samples) == 1) {
  soupXSample <- "all_cells"
} else {
  soupXSample <- samples
}

if (skipSoupX_bg) {
  plotSoupX <- NULL
} else {
  cat(paste0('## ', i, ' \n'))
  plotSoupX_bg <- tryCatch(
    {plotSoupXResults(inSCE = sce.qc, 
                     sceSample, 
                     combinePlot = "none",
                     background = TRUE)},
    error = function(e) {
      cat("runSoupX with background did not complete successfully. The section of SoupX with background is skipped")
      skipSoupX_bg <<- TRUE
      return(NA)
    }
  )
}

if (!skipSoupX_bg) {
  plotSoupX_bg <- formatPlotList(plotSoupX_bg, samples)
  cat(description_SoupX$introduction)
  cat(description_SoupX$runSoupX)
  cat(description_SoupX$output)
  cat(description_SoupX$contamination)
  cat(description_SoupX$clustering)
  cat(description_SoupX$plotSoupXResults)
}
```
<br />


## {.unlisted .unnumbered .toc-ignore .tabset .tabset-fade}
```{r "SoupX_bg-plot", echo=FALSE, eval=(!skipSoupX_bg), results="asis", fig.align="center"}
cat("\n\n")
for (sample in samples){
  cat(paste0("### ", sample, " {.tabset .tabset-fade} \n\n"))
  
  cat("#### SoupX Clustering {.tabset .tabset-fade} \n\n")
  plot(plotSoupX_bg$Sample[[sample]][["scatter_soupXClusters"]])
  cat("\n\n")
  
  cat("#### Soup Fractions {.tabset .tabset-fade} \n\n")
  
  for (marker in names(plotSoupX_bg$Sample[[sample]])[-1]) {
    cat(paste0("##### ", marker, " {.tabset .tabset-fade} \n\n"))
    plot(plotSoupX_bg$Sample[[sample]][[marker]])
    cat("\n\n")
  }
  
  cat("#### Parameters {.tabset .tabset-fade} \n\n")
  if (length(samples) == 1) {
    SoupXMeta <- getSoupX(sce.qc, soupXSample, background = TRUE)[[1]]$param
    SoupXMeta <- metaChecking(SoupXMeta, soupXSample)
    x <- preprocessMeta(SoupXMeta[[soupXSample]])
  } else {
    SoupXMeta <- getSoupX(sce.qc, sample, background = TRUE)[[1]]$param
    SoupXMeta <- metaChecking(SoupXMeta, sample)
    x <- preprocessMeta(SoupXMeta[[sample]])
  }
  cat(t(as.data.frame(x)) %>%
    knitr::kable(format = "html") %>% kableExtra::kable_styling() %>%
    kableExtra::scroll_box(width = "80%"))
  cat("\n\n")
}
```
`r cat("\n")`

# Session Information
<details>
 <summary><b>Session Information</b></summary>
```{r "CellQC-session-info", echo=FALSE}
sessionInfo()
```
</details>

---
title: "Comprehensive reporting of QC metrics: contamination identification using SoupX"
date: "`r format(Sys.time(), '%B %d, %Y')`"
params: 
  object: object
output:
  html_document:
    number_sections: yes
    toc: yes
    code_folding: hide
---

```{r, "soupX-lib", message = F, include=FALSE}
require(singleCellTK)
require(ggplot2)
```

```{r, "soupX-input",  warning=FALSE}
sce.qc <- params$object
```

```{r, "SoupX", results="asis", fig.align="center", warning=FALSE, message=FALSE}
    plotSoupX <- plotSoupXResults(sce.qc, combinePlot = "none")
    i <- "SoupX"
    cat(paste0('# ', i, ' {.tabset} \n\n'))
    
    cat(paste0('## Scatter Cluster\n\n'))
    plot(plotSoupX$scatter_soupXClusters)
    cat("\n\n")
    
    for (marker in names(plotSoupX)[-1]) {
        cat(paste0('## Soup Fraction: ', marker, ' \n\n'))
        plot(plotSoupX[[marker]])
        cat("\n\n")
    }
    
    cat(paste0('## Session info \n\n'))
    soupXMeta <- getSoupX(sce.qc)[[1]]$param
    soupXMeta$sample <- NULL
    soupXMeta$bgBatch <- NULL
    soupXMeta$sessionInfo <- NULL
    soupXMeta
    cat("\n\n")
```

```{r, "decontX-description", include=FALSE, warning=FALSE, message=FALSE}
description_SoupX <- descriptionSoupX()
```

# {.unlisted .unnumbered .toc-ignore}
`r description_SoupX`

---
title: "Seurat Normalization"
author: "`r params$authors`"
date: "`r format(Sys.time(), '%B %d, %Y')`"
params:
  subtitle: !r NULL
  authors: !r NULL
  sce: !r NULL
  outputPath: !r NULL
  showSession: FALSE
  pdf: TRUE
  forceRun: FALSE
output:
  html_document:
    toc: yes
    toc_float: yes
    number_sections: yes
    theme: cosmo
    code_folding: hide
    self_contained: false
    keep_md: yes
  pdf_document:
    toc: yes
subtitle: "`r params$subtitle`"
editor_options:
  chunk_output_type: console
---
```{r, echo=FALSE, message=FALSE, warning=FALSE}
library(Seurat)
library(dplyr)
library(cowplot)
library(RColorBrewer)
library(ggplot2)
library(knitr)
library(kableExtra)
library(SingleCellExperiment)
library(scater)
library(gridExtra)
library(grid)
library(ggpubr)
library(patchwork)
library(singleCellTK)
```

```{r, echo=FALSE, results='asis', warning=FALSE, message=FALSE}
if(!exists("headingNorm")) headingNorm <- "#"
cat(headingNorm, " Normalization {}\n\n")
```

Before the data can be used in the downstream analysis, normalization techniques that remove technical noise or variation must be applied. For this purpose, Seurat uses a global-scaling normalization method where the input raw data matrix is normalized by dividing the gene expression measurements by the total expression for each cell, multiplies it with a global-scaling factor and log-transforms the result. The output log-transformed and normalized gene expression measurements with technical variation and bias minimized can now better reflect the biological variability in the downstream methods. 

> The input raw data matrix '*`r assayNames(data)[1]`*' was normalized using a global-scaling normalization method '*LogNormalize*' that divides the gene expression measurements by the total expression for each cell, multiplies the resultant values with a scaling factor of '*10,000*' and log-transforms the result. 

```{r, message=FALSE, warning=FALSE, eval=is.null(metadata(data)$seurat$normAssay) || forceRun}
normalizeParams <- list(
  inSCE = data,
  normalizationMethod = "LogNormalize",
  scaleFactor = 10000,
  verbose = FALSE
)
data <- do.call("runSeuratNormalizeData", normalizeParams)
```

```{r, echo=FALSE, include=FALSE, eval=(is.null(metadata(data)$seurat$normAssay))}
normalizeParams$inSCE <- NULL
metadata(data)$seurat$sctk$report$normalizeParams <- normalizeParams
```

```{r, results='asis', eval=showSession, echo=FALSE}
cat("# Session Information\n\n")
```

```{r, results='markup', eval = showSession, echo = showSession}
sessionInfo()
```

---
title: "plotClusterAbundance Results"
date: "`r format(Sys.time(), '%B %d, %Y')`"
params:
  sce: sce
  cluster: cluster
  variable: variable
  pdf: pdf
  showSession: showSession
output: 
 html_document:
     toc: true
     toc_float: true
     number_sections: true
     theme: cosmo
     code_folding: hide
---


```{r setup, include=FALSE}
require(singleCellTK)
require(celda)
require(knitr)
require(gridExtra)
require(ggplot2)

sce <- params$sce
cluster <- params$cluster
variable <- params$variable
pdf <- params$pdf
showSession <- params$showSession


dev <- ifelse(isTRUE(pdf), c("png"), c("png", "pdf"))
knitr::opts_chunk$set(
  echo = TRUE,
  cache = FALSE,
  cache.lazy = FALSE,
  # don't do lazy-loading for big objects
  cache.comments = FALSE,
  fig.align = "center",
  fig.keep = "all",
  dev = dev
)


```

# Differential Abundance FET
This report will visualize results from the `plotClusterAbundance` function will visualize the differential abundance in two given variables, by making bar plots that presents the cell counting and fraction in different cases. The analysis presented here shows 

```{r plotting, echo = FALSE, message = FALSE}
plotClusterAbundance(inSCE, cluster, variable, combinePlot = "none")
```

# Session Information
```{r session, eval = showSession, echo = showSession}
sessionInfo()
```

---
title: "Find Marker"
date: "`r format(Sys.time(), '%B %d, %Y')`"
params: 
  object: object
  study: study
output:
  html_document:
    number_sections: yes
    toc: yes
    toc_float: true
    code_folding: hide
    html_notebook: default
---

```{r, "FM-lib", include=FALSE}
require(singleCellTK)
require(DT)
require(knitr)
```

```{r "FM-import", include=FALSE}
sce <- params$object
fmTable <- metadata(sce)$findMarker
useAssay <- attr(fmTable, "useAssay")
method <- attr(fmTable, "method")
clusterName <- names(fmTable)[5]
nCluster <- length(unique(as.vector(sce[[clusterName]])))
uniqClusters <- sort(unique(as.vector(sce[[clusterName]])))
fmParams <- attr(fmTable, "params")
log2fcThreshold <- fmParams$log2fcThreshold
fdrThreshold <- fmParams$ fdrThreshold
minClustExprPerc <- fmParams$minClustExprPerc
maxCtrlExprPerc <- fmParams$maxCtrlExprPerc
minMeanExpr <- fmParams$minMeanExpr
```

# Analysis Setting

## Find Marker basing on: `r clusterName`

The marker finding was accomplished by iteratively performing one-against-others differential expression analysis for each cluster. There are **`r nCluster` clusters** found in the given SingleCellExperiment object. Here is the summary of the number of cells in each cluster:

```{r, "FM-clusterSummary"}
sum.table <- t(as.data.frame(table(sce[[names(metadata(sce)$findMarker)[5]]])))
rownames(sum.table) <- c("cluster", "cell number")
datatable(sum.table, 
          options = list(
            headerCallback = JS(
              "function(thead, data, start, end, display){",
              "  $(thead).remove();",
              "}"),
            dom = 't')
)
```


## Method: `r method`

The method used for performing the differential expression analysis was "**`r method`**". For the more information of the method, please refer to [the help page](#).

## Parameters

After the computation, we further filtered the result to select the differentially expressed genes with high significance and high fold change. Specifically, the parameters used are:

```{r "FM-params"}
p <- data.frame(parameter = c("Min. logFC", 
                              "Max. FDR", 
                              "Min. Cluster Expression %", 
                              "Max. Control Expression %", 
                              "Min. Mean Expression"),
                value = c(log2fcThreshold,
                          fdrThreshold,
                          minClustExprPerc,
                          maxCtrlExprPerc,
                          minMeanExpr))
datatable(p, options = list(dom = "t"))
```

When we identify a gene to be the marker of the cluster of interests:  

- **"Min. logFC"** - The log fold change of this gene, by comparing the cluster of interest against all other clusters, must be higher than this threshold;
- **"Max. FDR"** - The FDR value calculated, by comparing the cluster of interest against all other clusters, must not exceed this threshold; 
- **"Min. Cluster Expression %"** - The gene must be expressed in at least this fraction of cells in the cluster of interests;
- **"Max. Control Expression %"** - The gene must be expressed in less than this fraction of cells in all other clusters;
- **"Min. Mean Expression"** - The mean expression of the gene in the cluster of interests must be higher than this threshold (in the specific assay used for analysis, not necessarily the raw count matrix).

# Result

We report maximum 10 top markers for each cluster, ranked by the FDR value. 

## Marker Table {.tabset}

```{r FM-iterResTable, echo=FALSE, results="asis"}
out = NULL
for (i in uniqClusters) {
  fmTable.cluster <- fmTable[fmTable[[clusterName]] == i,]
  if (nrow(fmTable.cluster) >= 10) {
    fmTable.cluster.top <- fmTable.cluster[1:10,]
  } else {
    fmTable.cluster.top <- fmTable.cluster
  }
  res <- knit_child('FM_child_cluster.Rmd', quiet=TRUE)
  cat(res, sep = '\n')
}
```

## Heatmap

In the marker heatmap, each column stands for a cell in the given SingleCellExperiment object. The cell level color bar annotates the cluster assignment. Each row is a marker gene, and the gene level color bar assigns the cluster correspondence. The cell cluster is ordered by the cluster population size.  

It happens sometimes that a gene is identified as the marker for more than one cluster. In this scenario, we finally assign it to the cluster where it has a higher "logFC" value when plotting.  

```{r FM-heatmap, message=FALSE, warning=FALSE, out.width = '100%'}
plotFindMarkerHeatmap(sce, 
                  log2fcThreshold = 0.5, 
                  minClustExprPerc = 0.7, 
                  maxCtrlExprPerc = 0.4, 
                  minMeanExpr = 1)
```

---
title: "Seurat Feature Selection"
author: "`r params$authors`"
date: "`r format(Sys.time(), '%B %d, %Y')`"
params:
  subtitle: !r NULL
  authors: !r NULL
  sce: !r NULL
  variable.features: 2000
  outputPath: !r NULL
  showSession: FALSE
  pdf: FALSE
  forceRun: FALSE
output:
  html_document:
    toc: yes
    toc_float: yes
    number_sections: yes
    theme: cosmo
    code_folding: hide
    self_contained: false
    keep_md: yes
  pdf_document:
    toc: yes
subtitle: "`r params$subtitle`"
editor_options:
  chunk_output_type: console
---
```{r, message=FALSE, warning=FALSE, echo=FALSE}
library(Seurat)
library(dplyr)
library(cowplot)
library(RColorBrewer)
library(ggplot2)
library(knitr)
library(kableExtra)
library(SingleCellExperiment)
library(scater)
library(gridExtra)
library(grid)
library(ggpubr)
library(patchwork)
library(singleCellTK)
```

```{r, echo=FALSE}
if(!exists("headingFS")) headingFS <- "#"
if(!exists("forceRun")) forceRun <- FALSE
```

```{r, echo=FALSE, results='asis', warning=FALSE, message=FALSE}
cat(headingFS, " Feature Selection {}\n\n")
```

Generally, a subset of features may represent the biological variation in the overall data and to better capture this true biological signal, it is recommended to identify this subset of features that often exhibit high cell-to-cell variation and use it in the downstream analysis instead of the full set of features. For this purpose, Seurat models the mean-to-variance relationship of the expression data by first computing *log of mean* and *log of variance* using *loess* and then standardizes the values using observed mean and expected variance. The overall variance of each feature is computed from the standardized values by clipping to a maximum value and ordering the features in the order of their variance. Lastly, top genes (by default *2000*) are selected as the top most variable features that represent the highest biological variability and used in the downstream methods.

```{r, results='asis', warning=FALSE, message=FALSE, eval = !((runHVG && length(metadata(data)$seurat$obj$RNA$var.features) > 0)) || forceRun}
hvgParams <- list(
  inSCE = data,
  method = "vst", 
  hvgNumber = variable.features)
data <- do.call("runSeuratFindHVG", hvgParams)

```

```{r, echo=FALSE}
num.variable.genes <- length(getSeuratVariableFeatures(data))
```

```{r, echo=FALSE, results='asis', include=plotHVG, eval= plotHVG}
cat("A scatter plot of standardized variance (y-axis) versus average expression (x-axis) for each of the gene is visualized below. Top 10 most variable genes are labeled with their gene symbols and the points (genes) highlighted in red are considered as highly variable genes.")
```

```{r, echo=FALSE, warning=FALSE, message=FALSE, eval = plotHVG}
Labeled_Variable_data <- plotSeuratHVG(inSCE = data, labelPoints = 10)
Labeled_Variable_data
```

```{r, echo=FALSE, warning=FALSE, message=FALSE, include=FALSE, eval=!(runHVG && length(metadata(data)$seurat$obj$RNA$var.features) > 0)}
hvgParams$inSCE <- NULL
hvgParams$labelPoints <- 10
hvgParams$totalFeatures <- variable.features
metadata(data)$seurat$sctk$report$hvgParams <- hvgParams
```

> A total of '*`r variable.features`*' top variable genes were identified from a total of '*`r nrow(data)`*' number of features using Seurat's '*vst*' method that uses log of mean, log of variance and loess to compute the variable features. This subset of '*`r variable.features`*' features was used as an input to dimensionality reduction algorithm. This subset of features was also visualized in a mean-vs-variance plot with the variable features highlighted in red and top most 10 features labeled at the top-right quarter of the plot. 

```{r, results='asis', eval=showSession, echo=FALSE}
cat("# Session Information\n\n")
```

```{r, results='markup', eval = showSession, echo = showSession}
sessionInfo()
```

---
title: "Comprehensive reporting of droplet QC metrics: identifying empty droplets using emptyDrops"
date: "`r format(Sys.time(), '%B %d, %Y')`"
params: 
  object: object
output:
  html_document:
    number_sections: yes
    toc: yes
    code_folding: hide
---
```{r, "EmtyDrops-lib", include=FALSE}
require(singleCellTK)
require(ggplot2)
```

```{r "EmtyDrops-import", include=FALSE}
sce<- params$object
```

```{r, "EmptyDrops", results="asis", fig.align="center", warning=FALSE, message=FALSE}
    plotsEmptyDrops<- plotEmptyDropsResults(sce)
    i="EmptyDrops"
    cat(paste0('# ', i, ' {.tabset .tabset-fade} \n\n'))
    cat(paste0('## EmptyDrops, Total UMI counts vs Log-Probability \n\n'))
    plotsEmptyDrops$scatterEmptyDrops[[1]]
    cat(paste0('## Session info \n\n'))
    sce@metadata$runEmptyDrops
```

```{r, "EmptyDrops-description", include=FALSE, warning=FALSE, message=FALSE}
description_runEmptyDrops <- descriptionEmptyDrops()
```
# {.unlisted .unnumbered .toc-ignore}
`r description_runEmptyDrops`

---
title: "SCTK Droplet QC Report"
date: "`r format(Sys.time(), '%B %d, %Y')`"
params: 
  object: object
  subTitle: subTitle
  studyDesign: studyDesign
output:
  html_document:
    number_sections: yes
    toc: yes
    toc_float: true
    code_folding: hide
    html_notebook: default
---

```{r "DropletQC-lib", include=FALSE, warning=FALSE}
require(SummarizedExperiment)
require(SingleCellExperiment)
require(singleCellTK)
require(dplyr)
require(Biobase)

docs.base <- paste0("https://www.camplab.net/sctk/v",
                    package.version("singleCellTK"), "/")
docs.qc.Path <- paste0(docs.base, "articles/articles/cmd_qc.html")

preprocessMeta <- function(meta, ignore=c("geneSetCollection", "sample")){
  meta <- meta[!names(meta) %in% ignore]
  lapply(meta, function(y){
    while(is.list(y)) {
      if (length(y) != 0){
       y <- y[[1]]  
      } else {
       y <- "NULL"
      }
    }
      
    if(is.vector(y)) {
      y <- paste(y,collapse=' ')
    }
      
    if(is.null(y)) {
      y <- "NULL"
    }
      
    return(y)
  })
}
```

```{r, "DropletQC-import", include=FALSE, include=FALSE, warning=FALSE}
sce<-params$object
subTitle <- params$subTitle
studyDesign <- params$studyDesign
samples <- unique(colData(sce)$sample)
```

---
subtitle: "`r subTitle`"
---

`r studyDesign`
<br />

# Introduction
```{r, "Introduction", echo = FALSE, results="asis", fig.align="center", warning=FALSE, message=FALSE}
cat("\n")

intro <- paste0(
  "Comprehensive quality control (QC) of single-cell RNA-seq data was performed with the [**singleCellTK**](https://github.com/compbiomed/singleCellTK) package. This report contains information about each QC tool and visualization of the QC metrics for each sample. For more information on running this pipeline and performing quality control, see the [**documentation**](",
  docs.qc.Path,
  "). If you use the singleCellTK package for quality control, please include a [**reference**](https://pubmed.ncbi.nlm.nih.gov/35354805/) in your publication."
)

cat(intro)
```
<br />
<br />


# Empty Drops Detection
```{r, "EmptyDrops-description", include=FALSE, warning=FALSE, message=FALSE}
description_runEmptyDrops <- descriptionEmptyDrops()
```

```{r, "EmptyDrops", results="asis", fig.align="center", warning=TRUE, message=FALSE, echo=FALSE}
i="EmptyDrops"
# cat(paste0('## ', i, ' \n'))
# cat("\n")


emptyData <- c("dropletUtils_emptyDrops_logprob", "dropletUtils_emptyDrops_total")
skipRunEmpty <- any(!emptyData %in% names(colData(sce)))

if (skipRunEmpty) {
  cat("runEmptyDrops did not run successfully. The section of EmptyDrops is skipped")
  plotsEmptyDrops <- NULL
} else {
    plotsEmptyDrops <- tryCatch(
    { plotEmptyDropsResults(sce,sample = colData(sce)$sample,
                                             combinePlot = "none") },
      error = function(e) {
        cat("runEmptyDrops did not run successfully. The section of EmptyDrops is skipped")
        skipRunEmpty <- TRUE
        return(NA)
      }
  )
}

if(!skipRunEmpty) {
  cat(paste0('## ', i, ' \n'))
  cat("\n")
  if(length(samples) == 1) {
    plotsEmptyDrops$scatterEmptyDrops <- list(Sample = list(plotsEmptyDrops$scatterEmptyDrops))
    names(plotsEmptyDrops$scatterEmptyDrops$Sample) <- samples
  }

  cat(description_runEmptyDrops$introduction)
  cat(description_runEmptyDrops$runEmptyDrops)
  cat(description_runEmptyDrops$plotEmptyDropsResults)
  cat(description_runEmptyDrops$plot2)
}

```


```{r "EmptyDrops-plot", results="asis", eval=(!skipRunEmpty), fig.align="center", warning=FALSE, message=FALSE, echo=FALSE}
cat("## {.unlisted .unnumbered .toc-ignore .tabset .tabset-fade}")
cat("\n")
for (i in seq_along(samples)) {
  cat(paste0("### ", samples[i], " {.tabset .tabset-fade} \n"))
  cat("\n\n")
  
  cat("#### Total UMI counts vs Log-Probability \n")
  print(plotsEmptyDrops$scatterEmptyDrops$Sample[[i]])
  cat("\n\n")
  
  cat("#### Parameters \n\n")
  runEmptyMeta <- sce@metadata$runEmptyDrops
  if(length(samples) == 1) {runEmptyMeta <- list(runEmptyMeta)}
  
  x <- preprocessMeta(runEmptyMeta[[i]])
  cat(t(as.data.frame(x)) %>%
    knitr::kable(format = "html") %>% kableExtra::kable_styling() %>%
    kableExtra::scroll_box(width = "80%"))
  cat(description_runEmptyDrops$parameter)
  cat("\n\n")
}
cat("\n")
```


```{r, "BarcodeRanks-description", include=FALSE, warning=FALSE, message=FALSE}
description_runBarcodeRank <- descriptionBarcodeRank()
```

```{r, "BarcodeRanks", results="asis", fig.align="center", warning=FALSE, message=FALSE, echo=FALSE}
i="BarcodeRanks"
# cat(paste0('## ', i, ' \n'))
# cat("\n")


barcodeData <- c("dropletUtils_barcodeRank_rank", "dropletUtils_barcodeRank_total", "dropletUtils_barcodeRank_knee", "dropletUtils_barcodeRank_inflection",  "dropletUtils_barcodeRank_fitted") #"sample",

skipBarcode <- (!"runBarcodeRanksMetaOutput" %in% names(S4Vectors::metadata(sce))) || 
              (any(!barcodeData %in% names(S4Vectors::metadata(sce)$runBarcodeRanksMetaOutput[[1]])))

if (skipBarcode) {
  cat("runBarcodeRankDrops did not run successfully. The section of BarcodeRanks is skipped")
  plotsBarcodeRank <- NA
} else {
  plotsBarcodeRank <- tryCatch(
    {plotBarcodeRankScatter(sce,
                            sample = colData(sce)$sample, 
                            title="BarcodeRanks Rank Plot",
                            combinePlot = "none")},
      error = function(e) {
        cat("runBarcodeRankDrops did not run successfully. The section of BarcodeRanks is skipped")
        skipBarcode <- TRUE
        return(NA)
      }
  )
}

if(!skipBarcode) {
  cat(paste0('## ', i, ' \n'))
  cat("\n")
  if(length(samples) == 1) {
    plotsBarcodeRank <- list(Sample = list(plotsBarcodeRank))
    names(plotsBarcodeRank$Sample) <- samples
  }
  
  #names(plotsBarcodeRank) <- samples
  cat(description_runBarcodeRank$introduction)
  cat(description_runBarcodeRank$runBarcodeRankDrops)
  cat(description_runBarcodeRank$plotBarcodeRankDropsResults)
  cat(description_runBarcodeRank$plot)
}
```


```{r "BarcodeRanks-plot", results="asis", eval=!(skipBarcode), fig.align="center", warning=FALSE, message=FALSE, echo=FALSE}
cat("## {.unlisted .unnumbered .toc-ignore .tabset .tabset-fade}")
cat("\n")
for (i in seq_along(samples)) {
  cat(paste0("### ", samples[i], " {.tabset .tabset-fade} \n"))
  cat("\n\n")
  
  cat("#### Total UMI counts vs Rank {.tabset .tabset-fade} \n\n")
  print(plotsBarcodeRank$Sample[[samples[i]]])
  cat("\n\n")
  
  cat("#### Parameters {.tabset .tabset-fade} \n\n")
  runBarcodeMeta <- sce@metadata$runBarcodeRankDrops
  if (length(samples) == 1) { runBarcodeMeta <- list(runBarcodeMeta) }
  x <- preprocessMeta(runBarcodeMeta[[i]])
  cat(t(as.data.frame(x)) %>%
    knitr::kable(format = "html") %>% kableExtra::kable_styling() %>%
    kableExtra::scroll_box(width = "80%"))
  cat(description_runBarcodeRank$parameter)
  cat("\n\n")  
}
cat("\n")
```

# Summary Statistics {.tabset .tabset-fade}
# {.unlisted .unnumbered .toc-ignore .tabset .tabset-fade}
```{r "SummaryStats", echo = FALSE, results="asis", fig.align="center", warning=FALSE, message=FALSE}
cat("\n")

for (i in seq_along(samples)) {
  cat(paste0("## ", samples[i], " {.tabset .tabset-fade} \n"))
  cat("\n\n")
  sceColData <- colData(sce) %>% as.data.frame()
  sceColData <- sceColData[sceColData$sample == samples[i], ]

  idx <- list(
          'Knee'= sceColData$dropletUtils_BarcodeRank_Knee == 1,
          'Inflection'= sceColData$dropletUtils_BarcodeRank_Inflection == 1, 
          'EmptyDrops' = !is.na(sceColData$dropletUtils_emptyDrops_fdr) &
           (sceColData$dropletUtils_emptyDrops_fdr < 0.01))

  SummaryTable <- lapply(idx, function(x){
  sceColData[x,] %>% 
    dplyr::summarise('Number of cells' = n(), 'Median UMI' = median(sum), 
                     'Median Genes' = median(detected))
  })
  
    
  cat(do.call(base::rbind, SummaryTable) %>% 
    knitr::kable(format = "html") %>% kableExtra::kable_styling() %>%
    kableExtra::scroll_box(width = "80%"))
    
  summary <- "The summary statistics table summarizes QC metrics of droplets that passed different cell detection cutoff. Here it summarizes number of cells passing the cutoff, median of UMI count and median of genes detected per cell."
  cat(summary)
  cat("\n\n") 
}
```
`r cat("\n")`

# SessionInfo
```{r "DropletQC-session-info", echo = FALSE}
sessionInfo()
```

---
title: "Seurat Scale Data"
author: "`r params$authors`"
date: "`r format(Sys.time(), '%B %d, %Y')`"
params:
  subtitle: !r NULL
  authors: !r NULL
  sce: !r NULL
  outputPath: !r NULL
  showSession: FALSE
  pdf: TRUE
  forceRun: FALSE
output:
  html_document:
    toc: yes
    toc_float: yes
    number_sections: yes
    theme: cosmo
    code_folding: hide
    self_contained: false
    keep_md: yes
  pdf_document:
    toc: yes
subtitle: "`r params$subtitle`"
editor_options:
  chunk_output_type: console
---
```{r, message=FALSE, warning=FALSE}
library(Seurat)
library(dplyr)
library(cowplot)
library(RColorBrewer)
library(ggplot2)
library(knitr)
library(kableExtra)
library(SingleCellExperiment)
library(scater)
library(gridExtra)
library(grid)
library(ggpubr)
library(patchwork)
library(singleCellTK)
```

```{r, echo=FALSE, results='asis', warning=FALSE, message=FALSE}
if(!exists("headingSD")) headingSD <- "#"

cat(headingSD, " Scale Data {}\n\n")
```

Standardizing gene expression values is considered necessary to ensure that dimensionality reduction tools produce unbiased results due to high variance of some features. For this purpose, Seurat performs a *z-score* scaling on the input matrix and standardizes (centers and scales) the expression values of the variable features identified previously before they are input to the downstream methods.  

> The variable features identified previously were scaled using *z-score* scaling method and the output expression values were clipped to maximum and minimum value of 10 & -10 respectively.

```{r, warning=FALSE, eval=is.null(metadata(data)$seurat$scaledAssay) || forceRun}
data <- runSeuratScaleData(inSCE = data, model = "linear", verbose = FALSE)
```

```{r, echo=FALSE, include=FALSE}
scaleParams <- list(
  model = "linear", 
  verbose = FALSE)
metadata(data)$seurat$sctk$report$scaleParams <- scaleParams
```

```{r, results='asis', eval=showSession, echo=FALSE}
cat("# Session Information\n\n")
```

```{r, results='markup', eval = showSession, echo = showSession}
sessionInfo()
```

---
title: "Seurat Dimensionality Reduction"
author: "`r params$authors`"
date: "`r format(Sys.time(), '%B %d, %Y')`"
params:
  subtitle: !r NULL
  authors: !r NULL
  sce: !r NULL
  variable.features: 2000
  pc.count: 50
  outputPath: !r NULL
  showSession: FALSE
  pdf: TRUE
  runDimRed: TRUE
  plotJackStraw: FALSE
  plotElbowPlot: TRUE
  plotHeatmaps: TRUE
  forceRun: FALSE
output:
  html_document:
    toc: yes
    toc_float: yes
    number_sections: yes
    theme: cosmo
    code_folding: hide
    self_contained: false
    keep_md: yes
  pdf_document:
    toc: yes
subtitle: "`r params$subtitle`"
editor_options:
  chunk_output_type: console
---

```{r, echo=FALSE, message=FALSE, warning=FALSE}
library(Seurat)
library(dplyr)
library(cowplot)
library(RColorBrewer)
library(ggplot2)
library(knitr)
library(kableExtra)
library(SingleCellExperiment)
library(scater)
library(gridExtra)
library(grid)
library(ggpubr)
library(patchwork)
library(singleCellTK)
```

```{r, echo=FALSE, results='asis', warning=FALSE, message=FALSE}
if(!exists("headingDR")) headingDR <- "#"
if(!exists("headingDR2")) headingDR2 <- "##"

cat(headingDR, " PCA {.tabset .tabset-fade}\n\n")
```

To reduce the adverse effects of the inherent technical noise in single-cell data on downstream clustering, reduced dimensions are computed where each dimension represents a set of correlated features. However, an important task is to select the number of components that should be utilized by the downstream methods. To select the number of principal components that should be used in the downstream analysis, JackStraw and Elbow plot provide convenience in the selection of the significant components that contain most of the variability.  

```{r, results='asis', warning=FALSE, eval = !(runDimRed && !is.null(metadata(data)$seurat$obj$reductions$pca)) || forceRun}
pcaParams <- list(
  inSCE = data,
  nPCs = pc.count,
  verbose = FALSE)
#data <- do.call("runSeuratPCA", pcaParams)
data <- runSeuratPCA(inSCE = data, nPCs = pc.count, verbose = FALSE)
```

```{r, echo=plotJackStraw, warning=FALSE, eval = plotJackStraw}
jackStrawParams <- list(
  inSCE = data,
  useAssay = "seuratScaledData",
  dims = pc.count,
  numReplicate = 100,
  propFreq = 0.025
)
#data <- do.call("runSeuratJackStraw", jackStrawParams)
data <- runSeuratJackStraw(data, useAssay = "seuratScaledData", dims = pc.count)
```

```{r, echo=FALSE, results='asis', include=plotElbowPlot, eval= plotElbowPlot}
cat(headingDR2, " Elbow Plot {-}\n\n")
cat("Elbow plot is plotted between the principal components (x-axis) and their standard deviation (y-axis), where a clear elbow between the components highlights the cut-off for the no. of components that should be selected as significant for downstream analysis.")
```

```{r, echo=plotElbowPlot, warning=FALSE, eval=plotElbowPlot}
ElbowPlot <- plotSeuratElbow(
  inSCE = data,
  ndims = pc.count,
  interactive = FALSE
)
ElbowPlot
```

```{r, echo=FALSE, warning=FALSE, eval= plotJackStraw}
if(!is.null(metadata(data)$seurat$obj$reductions$pca@jackstraw)){
  PC_Matrix <- metadata(data)$seurat$obj$reductions$pca@jackstraw$overall.p.values
  
  significant_PC <- which.min(PC_Matrix[,2] < 0.01) - 1
if (!exists("significant_PC") || significant_PC == 0){
  significant_PC <- pc.count
  }
}else{
  significant_PC <- pc.count
}
```

```{r, echo=FALSE, results='asis', include=plotElbowPlot, eval= plotElbowPlot}
cat("> PCA was applied to the scaled subset matrix that contained the ", variable.features, " top most variable genes to transform the data into reduced dimensions for clustering in the downstream analysis. Significant principal components will show a strong enrichment of genes with low p-values from the JackStraw plot or PC cutoff could also be determined roughly by looking at where a clear elbow is depicted in the elbow plot. The first ", significant_PC, " components were selected as the cutoff. These ", significant_PC, " principal components were determined to hold the true dimensionality of the dataset and will be used in the subsequent clustering analysis.")
```

```{r, echo=FALSE, results='asis', include=plotJackStraw, eval= plotJackStraw}
cat(headingDR2, " JackStraw Plot {-}\n\n")
cat("JackStraw computes significance values for all genes in all principal components and plots these genes as a QQ-plot for each component and compares them with the uniform distribution (shown in dotted line). Overall p-values are also computed for each component, where statistically significant principal components can be selected for downstream analysis. Visually, components that lie above the dotted uniform distribution line should be selected.")
```

```{r, echo=plotJackStraw, warning=FALSE, eval=plotJackStraw}
JackStrawPlot <- plotSeuratJackStraw(
  inSCE = data,
  dims = pc.count,
  xmax = 0.05) + guides(col = guide_legend(ncol = 1)) + theme(
    legend.text = element_text(size = 6), legend.key.size = unit(0.2, "cm"))
JackStrawPlot
```


```{r, echo=FALSE}
PC.separated.height <- 3.5 * ceiling(pc.count/3)
```

```{r, echo=FALSE, include=TRUE, eval = !(runDimRed && !is.null(metadata(data)$seurat$obj$reductions$pca))}
pcaParams$inSCE <- NULL
pcaParams$significant_PC <- significant_PC
metadata(data)$seurat$sctk$report$pcaParams <- pcaParams
```

```{r, echo=FALSE, results='asis', include=plotElbowPlot, eval= plotJackStraw}
cat("> PCA was applied to the scaled subset matrix that contained the ", variable.features, " top most variable genes to transform the data into reduced dimensions for clustering in the downstream analysis. Significant principal components will show a strong enrichment of genes with low p-values from the JackStraw plot or PC cutoff could also be determined roughly by looking at where a clear elbow is depicted in the elbow plot. The first ", significant_PC, " components were selected as the cutoff. These ", significant_PC, " principal components were determined to hold the true dimensionality of the dataset and will be used in the subsequent clustering analysis.")
```

```{r, echo=FALSE, results='asis', include=plotHeatmaps, eval= plotHeatmaps}
cat(headingDR2, " PC Heatmap {-}\n\n")
cat("Heatmaps are plotted for each component that highlight the primary sources of heterogeneity in terms of features in the data. Both cells and features are ordered according to their PCA scores and this heatmap can be utilized to explore highly correlated feature sets in the data.")
```

```{r, echo=plotHeatmaps, fig.height= PC.separated.height, fig.width = 15, warning=FALSE, eval = plotHeatmaps}
pcHeatmapParams <- list(
  inSCE = data,
  useAssay = "seuratScaledData",
  useReduction = "pca",
  dims = pc.count,
  balanced = TRUE,
  ncol = 4,
  fast = FALSE
)
#heatmap <- do.call("runSeuratHeatmap", pcHeatmapParams)  
heatmap <- runSeuratHeatmap(inSCE = data, useAssay = "seuratScaledData", useReduction = "pca", dims = pc.count, balanced = TRUE, ncol = 4, fast = FALSE)
heatmap
```

```{r, echo=FALSE, include=FALSE, eval = plotHeatmaps}
pcHeatmapParams$inSCE <- NULL
metadata(data)$seurat$plots$heatmap <- pcHeatmapParams
```

```{r, echo=FALSE, results='asis', include=plotElbowPlot, eval= plotHeatmaps}
cat("> PCA was applied to the scaled subset matrix that contained the ", variable.features, " top most variable genes to transform the data into reduced dimensions for clustering in the downstream analysis. Significant principal components will show a strong enrichment of genes with low p-values from the JackStraw plot or PC cutoff could also be determined roughly by looking at where a clear elbow is depicted in the elbow plot. The first ", significant_PC, " components were selected as the cutoff. These ", significant_PC, " principal components were determined to hold the true dimensionality of the dataset and will be used in the subsequent clustering analysis.")
```

```{r, results='asis', eval=showSession, echo=FALSE}
cat("# Session Information\n\n")
```

```{r, results='markup', eval = showSession, echo = showSession}
sessionInfo()
```

---
title: "Comprehensive reporting of QC metrics: doublet cell annotation using ScDblFinder"
date: "`r format(Sys.time(), '%B %d, %Y')`"
params: 
  object: object
output:
  html_document:
    number_sections: yes
    toc: yes
    code_folding: hide
---

```{r, "scdblfinder-lib", message = F, include=FALSE}
require(singleCellTK)
require(ggplot2)
```

```{r, "scdblfinder-import", warning=FALSE}
sce.qc<- params$object
```

```{r, "scDblFinder", results="asis", fig.align="center", warning=FALSE, message=FALSE}
    plotScDblFinder<- plotScDblFinderResults(inSCE = sce.qc, reducedDimName = "UMAP")
    i="ScDblFinder"
    cat(paste0('# ', i, ' {.tabset} \n\n'))
    cat(paste0('## Scatter Score \n\n'))
    plotScDblFinder$scatter_doubletScore
   
    cat(paste0('## Density Score \n\n'))
    plotScDblFinder$density_doubletScore

    cat(paste0('## Violin Score \n\n'))
    plotScDblFinder$violin_doubletScore
    
    cat(paste0('## Session info \n\n'))
    sce.qc@metadata$runScDblFinder
```

```{r, "scdblfinder-description", include=FALSE, warning=FALSE, message=FALSE}
description_scDblFinder<- descriptionScDblFinder()
```

# {.unlisted .unnumbered .toc-ignore}
`r description_scDblFinder`

---
title: "Single Cell Analysis with Seurat using singleCellTK Package"
author: "`r params$authors`"
date: "`r format(Sys.time(), '%B %d, %Y')`"
params:
  subtitle: !r NULL
  authors: !r NULL
  sce: !r NULL
  biological.group: !r NULL
  phenotype.groups: !r NULL
  selected.markers: !r NULL
  clustering.resolution: 0.8
  variable.features: 2000
  pc.count: 50
  outputPath: !r NULL
  showSession: FALSE
  pdf: TRUE
  runHVG: TRUE
  plotHVG: TRUE
  runDimRed: TRUE
  plotJackStraw: FALSE
  plotElbowPlot: TRUE
  plotHeatmaps: TRUE
  runClustering: TRUE
  plotTSNE: TRUE
  plotUMAP: TRUE
  minResolution: 0.3
  maxResolution: 1.5 
  runMSClusters: TRUE
  runMSBioGroup: TRUE
  numTopFeatures: 10
  forceRun: FALSE
output:
  html_document:
    toc: yes
    toc_float: yes
    number_sections: yes
    theme: cosmo
    code_folding: hide
    self_contained: false
    keep_md: yes
  pdf_document:
    toc: yes
subtitle: "`r params$subtitle`"
editor_options:
  chunk_output_type: console
---

```{r global options, include = FALSE}
knitr::opts_chunk$set(warning=FALSE, message=FALSE)
```

```{r, echo=FALSE}
sampleNames <- unique(colData(data)[[biological.group]])
```

<!-- Seurat Run -->

```{r, echo=FALSE, results='asis', warning=FALSE, message=FALSE}
showSession <- FALSE
seuratRun <- knitr::knit_child(system.file("rmarkdown/seurat", "reportSeuratRun.Rmd", package = "singleCellTK"), quiet = TRUE, envir = environment())
```

<!-- Seurat Results -->

```{r, echo=FALSE, results='asis', warning=FALSE, message=FALSE}
showSession <- FALSE
seuratResults <- knitr::knit_child(system.file("rmarkdown/seurat", "reportSeuratResults.Rmd", package = "singleCellTK"), quiet = TRUE, envir = environment())
```

# Summary {-}
<!-- Summary -->
<!-- some variables still need to be included, e.g. from deg -->
> The input data included *`r numFeatures`* features and *`r numCells`* cells from *`r numSamples`* samples divided through the group *`r biological.group`* namely *`r sampleNames`*. The *`r assayNames(data)[1]`* feature count matrix from the data was normalized using *LogNormalize* method which normalized as well as log-transformed the data. From *`r numFeatures`* total features, a subset of *`r variable.features`* features that exhibited high cell-to-cell variation were selected for the downstream analysis to better capture the biological variation using *vst* (mean-to-variance) feature selection method. This subset of features was then scaled (z-score) using *linear model* method and trimmed to a maximum and minimum value of *10* and *-10* respectively. PCA was run on this scaled subset of features and *`r pc.count`* components were computed from which top *`r significant_PC`* significant components were selected for subsequent clustering analysis. Using the *louvain* algorithm that uses community-based detection to identify clusters with resolution set to *`r 0.8`*, clustering was performed on the scaled subset of features that identified *`r numClusters`* clusters in the data. These clusters were then used to run differential expression using *wilcox* test and identified *`r numMarkerGenesCluster`* genes differentially expressed between clusters at significance criteria of *q-value < 0.05*. The gene markers that defined the main biological group *`r biological.group`* were identified using *wilcox* test that highlighted *`r numMarkerGenesBio`* marker genes at *q-value < 0.05* significance criteria. Additionatlly, markers *`r selected.markers`* from the input pre-selected markers were detected and visualized over UMAP plot.

<!-- Display -->

```{r, echo=FALSE, results='asis', warning=FALSE, message=FALSE}
cat(seuratRun, sep = '\n')
cat(seuratResults, sep = '\n')
```

```{r, echo=FALSE}
showSession <- params$showSession
```

```{r, results='asis', eval=showSession, echo=FALSE}
cat("# Session Information\n\n")
```

```{r, results='markup', eval=showSession, echo=showSession}
sessionInfo()
```

---
title: "Comprehensive reporting of QC metrics: computing per cell QC metrics usind addPerCellQC"
date: "`r format(Sys.time(), '%B %d, %Y')`"
params: 
  object: object
output:
  html_document:
    number_sections: yes
    toc: yes
    code_folding: hide
---

```{r, "QCMetrics-lib", message = F, include=FALSE}
require(singleCellTK)
require(ggplot2)
```

```{r, "QCMetrics-import", warning=FALSE, include=FALSE}
sce.qc<- params$object
```

```{r, "QCMetrics", results="asis", fig.align="center", warning=FALSE, message=FALSE}
    plotsQCMetrics<- plotRunPerCellQCResults(sce.qc)
    i="QCMetrics"
    cat(paste0('# ', i, ' {.tabset .tabset-fade} \n\n'))
    cat(paste0('## Sum \n\n'))
    plotsQCMetrics$sum
    cat(paste0('## Total \n\n'))
    plotsQCMetrics$detected
    cat(paste0('## Subsets mito sum \n\n'))
    plotsQCMetrics$subsets_mito_sum
    cat(paste0('## Subsets mito detected \n\n'))
    plotsQCMetrics$subsets_mito_detected
    cat(paste0('## Subsets mito percent \n\n'))
    plotsQCMetrics$subsets_mito_percent
    cat(paste0('## Session info \n\n'))
    sce.qc@metadata$scater$addPerCellQC
```

```{r, "QCMetrics-description", include=FALSE, warning=FALSE, message=FALSE}
description_runPerCellQC <- descriptionRunPerCellQC()
```
# {.unlisted .unnumbered .toc-ignore}
`r description_runPerCellQC`

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/reticulate_setup.R
\name{sctkPythonInstallVirtualEnv}
\alias{sctkPythonInstallVirtualEnv}
\title{Installs Python packages into a virtual environment}
\usage{
sctkPythonInstallVirtualEnv(
  envname = "sctk-reticulate",
  packages = c("scipy", "numpy", "astroid", "six", "scrublet", "scanpy", "louvain",
    "leidenalg", "scanorama", "bbknn", "anndata"),
  selectEnvironment = TRUE,
  python = NULL
)
}
\arguments{
\item{envname}{Character. Name of the virtual environment to create.}

\item{packages}{Character Vector. List of packages to install.}

\item{selectEnvironment}{Boolean. Run \code{\link[singleCellTK]{selectSCTKVirtualEnvironment}} after installing all packages to select the virtual environment. Default TRUE.}

\item{python}{The path to a Python interpreter, to be used with the created virtual environment. When NULL, the Python interpreter associated with the current session will be used. Default NULL.}
}
\value{
None. Installation of virtual environment.
}
\description{
Install all Python packages used in the \code{\link{singleCellTK}} package
using \code{\link{virtualenv_install}} from package \code{\link{reticulate}}. This
will create a new virtual environment with the name \code{envname} if not already present.
}
\examples{
\dontrun{
sctkPythonInstallVirtualEnv(envname = "sctk-reticulate")
}
}
\seealso{
See \code{\link{virtualenv_create}} for more information on creating a Conda environment.
See \code{\link{virtualenv_install}} for more description of the installation parameters.
See \url{https://rstudio.github.io/reticulate/} for more information on package \code{\link{reticulate}}.
See \code{\link[singleCellTK]{selectSCTKVirtualEnvironment}} for reloading the virtual environment if R is restarted without
going through the whole installation process again.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/htmlReports.R
\name{reportSeuratClustering}
\alias{reportSeuratClustering}
\title{Generates an HTML report for Seurat Clustering and returns the SCE object
 with the results computed and stored inside the object.}
\usage{
reportSeuratClustering(
  inSCE,
  biological.group = NULL,
  phenotype.groups = NULL,
  runClustering = TRUE,
  plotTSNE = TRUE,
  plotUMAP = TRUE,
  minResolution = 0.3,
  maxResolution = 1.5,
  numClusters = 10,
  significant_PC = 10,
  outputFile = NULL,
  outputPath = NULL,
  subtitle = NULL,
  authors = NULL,
  showSession = FALSE,
  pdf = FALSE,
  forceRun = TRUE
)
}
\arguments{
\item{inSCE}{Input \code{\link[SingleCellExperiment]{SingleCellExperiment}}
object.}

\item{biological.group}{A character value that specifies the name of the
\code{colData()} column to use as the main biological group in the Seurat
report for marker selection and grouping.}

\item{phenotype.groups}{A character vector that specifies the names of the
\code{colData()} columns to use for differential expression in addition to
the \code{biological.group} parameter.}

\item{runClustering}{A logical value indicating if Clustering should be run
or not in the report. Default is \code{TRUE}. If \code{FALSE}, parameters
 \code{plotTSNE} and \code{plotUMAP} are also set to \code{FALSE}.}

\item{plotTSNE}{A logical value indicating if TSNE plots should be visualized
in the clustering section of the report. Default is \code{TRUE}.}

\item{plotUMAP}{A logical value indicating if UMAP plots should be visualized
in the clustering section of the report. Default is \code{TRUE}.}

\item{minResolution}{A numeric value indicating the minimum resolution to use
for clustering. Default \code{0.3}.}

\item{maxResolution}{A numeric value indicating the maximum resolution to use
for clustering. Default \code{1.5}.}

\item{numClusters}{temp (to remove)}

\item{significant_PC}{temp (change to pc.use)}

\item{outputFile}{Specify the name of the generated output HTML file.
If \code{NULL} then the output file name will be based on the name of the
Rmarkdown template. Default \code{NULL}.}

\item{outputPath}{Specify the name of the output directory to save the
rendered HTML file. If \code{NULL} the file is stored to the current
working directory. Default \code{NULL}.}

\item{subtitle}{A character value specifying the subtitle to use in the
report. Default \code{NULL}.}

\item{authors}{A character value specifying the names of the authors to use
in the report. Default \code{NULL}.}

\item{showSession}{A logical value indicating if session information
should be displayed or not. Default is \code{FALSE}.}

\item{pdf}{A logical value indicating if a pdf should also be generated for
each figure in the report. Default is \code{FALSE}.}

\item{forceRun}{A logical value indicating if all computations previously
computed should be re-calculated regardless if these computations are
available in the input object. Default is \code{TRUE}.}
}
\value{
A \code{\link[SingleCellExperiment]{SingleCellExperiment}} object
 with computations stored.
}
\description{
Generates an HTML report for Seurat Clustering and returns the SCE object
 with the results computed and stored inside the object.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/importDropEst.R
\name{importDropEst}
\alias{importDropEst}
\title{Create a SingleCellExperiment Object from DropEst output}
\usage{
importDropEst(
  sampleDirs = NULL,
  dataType = c("filtered", "raw"),
  rdsFileName = "cell.counts",
  sampleNames = NULL,
  delayedArray = FALSE,
  class = c("Matrix", "matrix"),
  rowNamesDedup = TRUE
)
}
\arguments{
\item{sampleDirs}{A path to the directory containing the data files. Default "./".}

\item{dataType}{can be "filtered" or "raw". Default \code{"filtered"}.}

\item{rdsFileName}{File name prefix of the DropEst RDS output. default is "cell.counts"}

\item{sampleNames}{A User-defined sample name. This will be prepended to all cell barcode IDs.
Default "sample".}

\item{delayedArray}{Boolean. Whether to read the expression matrix as
\link{DelayedArray} object or not. Default \code{FALSE}.}

\item{class}{Character. The class of the expression matrix stored in the SCE
object. Can be one of "Matrix" (as returned by
\link{readMM} function), or "matrix" (as returned by
\link[base]{matrix} function). Default \code{"Matrix"}.}

\item{rowNamesDedup}{Boolean. Whether to deduplicate rownames. Default 
\code{TRUE}.}
}
\value{
A \code{SingleCellExperiment} object containing the count matrix,
 the feature annotations from DropEst as ColData, and any metadata from DropEst
}
\description{
imports the RDS file created by DropEst (https://github.com/hms-dbmi/dropEst) and
create a SingleCellExperiment object from either the raw or filtered counts matrix.
Additionally parse through the RDS to obtain appropriate feature annotations as
SCE coldata, in addition to any metadata.
}
\details{
\code{importDropEst} expects either raw counts matrix stored as "cm_raw" or filtered
counts matrix stored as "cm" in the DropEst rds output.
ColData is obtained from the DropEst corresponding to "mean_reads_per_umi","aligned_reads_per_cell",
"aligned_umis_per_cell","requested_umis_per_cb","requested_reads_per_cb"
If using filtered counts matrix, the colData dataframe is
subset to contain features from the filtered counts matrix alone.
If any annotations of ("saturation_info","merge_targets","reads_per_umi_per_cell") are
found in the DropEst rds, they will be added to the SCE metadata field
}
\examples{
# Example results were generated as per instructions from the developers of dropEst described in
# https://github.com/hms-dbmi/dropEst/blob/master/examples/EXAMPLES.md
sce <- importDropEst(sampleDirs = system.file("extdata/dropEst_scg71", package = "singleCellTK"),
                     sampleNames = 'scg71')
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/abundance.R
\name{diffAbundanceFET}
\alias{diffAbundanceFET}
\title{Calculate Differential Abundance with FET}
\usage{
diffAbundanceFET(inSCE, cluster, variable, control, case, analysisName)
}
\arguments{
\item{inSCE}{A \code{\link[SingleCellExperiment]{SingleCellExperiment}}
object.}

\item{cluster}{A single \code{character}, specifying the name to store the
cluster label in \code{\link{colData}}.}

\item{variable}{A single \code{character}, specifying the name to store the
phenotype labels in \code{\link{colData}}.}

\item{control}{\code{character}. Specifying one or more categories that can
be found in the vector specified by \code{variable}.}

\item{case}{\code{character}. Specifying one or more categories that can
be found in the vector specified by \code{variable}.}

\item{analysisName}{A single \code{character}. Will be used for naming the
result table, which will be saved in metadata slot.}
}
\value{
The original \code{\link[SingleCellExperiment]{SingleCellExperiment}}
object with \code{metadata(inSCE)} updated with a list
\code{diffAbundanceFET}, containing a new \code{data.frame} for the analysis
result, named by \code{analysisName}. The \code{data.frame} contains columns
for number and fraction of cells that belong to different cases, as well as
"Odds_Ratio", "PValue" and "FDR".
}
\description{
Calculate Differential Abundance with FET
}
\details{
This function will calculate the cell counting and fraction by
dividing all cells to groups specified by the arguments, together with
statistical summary by performing Fisher Exact Tests (FET).
}
\examples{
data("mouseBrainSubsetSCE", package = "singleCellTK")
mouseBrainSubsetSCE <- diffAbundanceFET(inSCE = mouseBrainSubsetSCE,
                                                cluster = "tissue",
                                                variable = "level1class",
                                                case = "oligodendrocytes",
                                                control = "microglia",
                                                analysisName = "diffAbundFET")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/importGeneSets.R
\name{sctkListGeneSetCollections}
\alias{sctkListGeneSetCollections}
\title{Lists imported GeneSetCollections}
\usage{
sctkListGeneSetCollections(inSCE)
}
\arguments{
\item{inSCE}{A \link[SingleCellExperiment]{SingleCellExperiment} object.}
}
\value{
Character vector.
}
\description{
Returns a vector of GeneSetCollections that have been
imported and stored in \code{metadata(inSCE)$sctk$genesets}.
}
\examples{
data(scExample)
gs1 <- GSEABase::GeneSet(setName = "geneset1",
                         geneIds = rownames(sce)[seq(10)])
gs2 <- GSEABase::GeneSet(setName = "geneset2",
                         geneIds = rownames(sce)[seq(11,20)])
gsc1 <- GSEABase::GeneSetCollection(gs1)
gsc2 <- GSEABase::GeneSetCollection(gs2)
sce <- importGeneSetsFromCollection(inSCE = sce,
                                    geneSetCollection = gsc1,
                                    by = "rownames",
                                    collectionName = "Collection1")
sce <- importGeneSetsFromCollection(inSCE = sce,
                                    geneSetCollection = gsc2,
                                    by = "rownames",
                                    collectionName = "Collection2")
collections <- sctkListGeneSetCollections(sce)
}
\seealso{
\link{importGeneSetsFromList} for importing from lists,
\link{importGeneSetsFromGMT} for importing from GMT files,
\linkS4class{GeneSetCollection} objects, and \link{importGeneSetsFromMSigDB}
for importing MSigDB gene sets.
}
\author{
Joshua D. Campbell
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dropletUtils_barcodeRank.R
\name{runBarcodeRankDrops}
\alias{runBarcodeRankDrops}
\title{Identify empty droplets using \link[DropletUtils]{barcodeRanks}.}
\usage{
runBarcodeRankDrops(
  inSCE,
  sample = NULL,
  useAssay = "counts",
  lower = 100,
  fitBounds = NULL,
  df = 20
)
}
\arguments{
\item{inSCE}{A \linkS4class{SingleCellExperiment} object. Must contain a raw 
counts matrix before empty droplets have been removed.}

\item{sample}{Character vector or colData variable name. Indicates which 
sample each cell belongs to. Default \code{NULL}.}

\item{useAssay}{A string specifying which assay in the SCE to use. Default 
\code{"counts"}}

\item{lower}{See \link[DropletUtils]{barcodeRanks} for more information. 
Default \code{100}.}

\item{fitBounds}{See \link[DropletUtils]{barcodeRanks} for more information. 
Default \code{NULL}.}

\item{df}{See \link[DropletUtils]{barcodeRanks} for more information. Default 
\code{20}.}
}
\value{
A \linkS4class{SingleCellExperiment} object with the
\link[DropletUtils]{barcodeRanks} output table appended to the
\link{colData} slot. The columns include
\code{dropletUtils_BarcodeRank_Knee} and 
\code{dropletUtils_barcodeRank_inflection}. Please refer to the documentation
of \link[DropletUtils]{barcodeRanks} for details.
}
\description{
Run \link[DropletUtils]{barcodeRanks} on a count matrix
provided in a \linkS4class{SingleCellExperiment} object. Distinguish between 
droplets containing cells and ambient RNA in a droplet-based single-cell RNA 
sequencing experiment.
}
\examples{
data(scExample, package = "singleCellTK")
sce <- runBarcodeRankDrops(inSCE = sce)
}
\seealso{
\code{\link[DropletUtils]{barcodeRanks}}, 
\code{\link{runDropletQC}}, \code{\link{plotBarcodeRankDropsResults}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scanpyFunctions.R
\name{plotScanpyMarkerGenesViolin}
\alias{plotScanpyMarkerGenesViolin}
\title{plotScanpyMarkerGenesViolin}
\usage{
plotScanpyMarkerGenesViolin(inSCE, groups = NULL, features = NULL, nGenes = 10)
}
\arguments{
\item{inSCE}{Input \code{SingleCellExperiment} object.}

\item{groups}{The groups for which to show the gene ranking. Default \code{NULL}
means that all groups will be considered.}

\item{features}{List of genes to plot. Is only useful if interested in a 
custom gene list}

\item{nGenes}{Number of genes to show. Default \code{10}}
}
\value{
plot object
}
\description{
plotScanpyMarkerGenesViolin
}
\examples{
data(scExample, package = "singleCellTK")
\dontrun{
sce <- runScanpyNormalizeData(sce, useAssay = "counts")
sce <- runScanpyFindHVG(sce, useAssay = "scanpyNormData", method = "seurat")
sce <- runScanpyScaleData(sce, useAssay = "scanpyNormData")
sce <- runScanpyPCA(sce, useAssay = "scanpyScaledData")
sce <- runScanpyFindClusters(sce, useReducedDim = "scanpyPCA")
sce <- runScanpyFindMarkers(sce, colDataName = "Scanpy_louvain_1" )
plotScanpyMarkerGenesViolin(sce, groups = '0')
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runDimReduce.R
\name{runDimReduce}
\alias{runDimReduce}
\title{Generic Wrapper function for running dimensionality reduction}
\usage{
runDimReduce(
  inSCE,
  method = c("scaterPCA", "seuratPCA", "seuratICA", "scanpyPCA", "rTSNE", "seuratTSNE",
    "scaterUMAP", "seuratUMAP", "scanpyUMAP", "scanpyTSNE"),
  useAssay = NULL,
  useReducedDim = NULL,
  useAltExp = NULL,
  reducedDimName = method,
  nComponents = 20,
  useFeatureSubset = NULL,
  scale = FALSE,
  seed = 12345,
  ...
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object.}

\item{method}{One from \code{"scaterPCA"}, \code{"seuratPCA"},
\code{"seuratICA"}, \code{"rTSNE"}, \code{"seuratTSNE"}, \code{"scaterUMAP"},
\code{"seuratUMAP"}, \code{"scanpyPCA"}, \code{"scanpyUMAP"} and \code{"scanpyTSNE"}.}

\item{useAssay}{Assay to use for computation. If \code{useAltExp} is
specified, \code{useAssay} has to exist in
\code{assays(altExp(inSCE, useAltExp))}. Default \code{"counts"}.}

\item{useReducedDim}{The low dimension representation to use for embedding
computation. Default \code{NULL}.}

\item{useAltExp}{The subset to use for computation, usually for the
selected variable features. Default \code{NULL}.}

\item{reducedDimName}{The name of the result matrix. Required.}

\item{nComponents}{Specify the number of dimensions to compute with the
selected method in case of PCA/ICA and the number of components to
use in the case of TSNE/UMAP methods.}

\item{useFeatureSubset}{Subset of feature to use for dimension reduction. A
character string indicating a \code{rowData} variable that stores the logical
vector of HVG selection, or a vector that can subset the rows of
\code{inSCE}. Default \code{NULL}.}

\item{scale}{Logical scalar, whether to standardize the expression values.
Default \code{TRUE}.}

\item{seed}{Random seed for reproducibility of results.
Default \code{NULL} will use global seed in use by the R environment.}

\item{...}{The other arguments for running a specific algorithm. Please refer
to the one you use.}
}
\value{
The input \linkS4class{SingleCellExperiment} object with
\code{reducedDim} updated with the result.
}
\description{
Generic Wrapper function for running dimensionality reduction
}
\details{
Wrapper function to run one of the available dimensionality
reduction algorithms integrated within SCTK from \code{\link{scaterPCA}},
\code{\link{runSeuratPCA}}, \code{\link{runSeuratICA}}, \code{\link{runTSNE}},
\code{\link{runSeuratTSNE}}, \code{\link{runUMAP}} and
\code{\link{runSeuratUMAP}}. Users can use an assay by specifying
\code{useAssay}, use the assay in an altExp by specifying both
\code{useAltExp} and \code{useAssay}, or use a low-dimensionality
representation by specifying \code{useReducedDim}.
}
\examples{
data(scExample, package = "singleCellTK")
sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
sce <- runNormalization(sce, useAssay = "counts",
                        outAssayName = "logcounts",
                        normalizationMethod = "logNormCounts")
sce <- runDimReduce(inSCE = sce, method = "scaterPCA",
                    useAssay = "logcounts", scale = TRUE,
                    reducedDimName = "PCA")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotUMAP.R
\name{plotUMAP}
\alias{plotUMAP}
\title{Plot UMAP results either on already run results or run first and then plot.}
\usage{
plotUMAP(
  inSCE,
  colorBy = NULL,
  shape = NULL,
  reducedDimName = "UMAP",
  runUMAP = FALSE,
  useAssay = "counts"
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object with saved
dimension reduction components. Required}

\item{colorBy}{color by a condition(any column of the annotation data).}

\item{shape}{add shapes to each condition.}

\item{reducedDimName}{saved dimension reduction name in the
\linkS4class{SingleCellExperiment} object. Required.}

\item{runUMAP}{If the dimension reduction components are already available
set this to FALSE, otherwise set to TRUE. Default is False.}

\item{useAssay}{Indicate which assay to use. The default is "logcounts"}
}
\value{
a UMAP plot of the reduced dimensions.
}
\description{
Plot UMAP results either on already run results or run first and then plot.
}
\examples{
data(scExample, package = "singleCellTK")
sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
sce <- runQuickUMAP(sce)
plotUMAP(sce)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scDblFinder_doubletDetection.R
\name{runScDblFinder}
\alias{runScDblFinder}
\title{Detect doublet cells using \link[scDblFinder]{scDblFinder}.}
\usage{
runScDblFinder(
  inSCE,
  sample = NULL,
  useAssay = "counts",
  nNeighbors = 50,
  simDoublets = max(10000, ncol(inSCE)),
  seed = 12345,
  BPPARAM = BiocParallel::SerialParam(RNGseed = seed)
)
}
\arguments{
\item{inSCE}{A \linkS4class{SingleCellExperiment} object.}

\item{sample}{Character vector or colData variable name. Indicates which
sample each cell belongs to. Default \code{NULL}.}

\item{useAssay}{A string specifying which assay in the SCE to use. Default
\code{"counts"}.}

\item{nNeighbors}{Number of nearest neighbors used to calculate density for
doublet detection. Default \code{50}.}

\item{simDoublets}{Number of simulated doublets created for doublet
detection. Default \code{10000}.}

\item{seed}{Seed for the random number generator, can be set to \code{NULL}.
Default \code{12345}.}

\item{BPPARAM}{A \code{\link[BiocParallel]{BiocParallelParam-class}} object
specifying whether the neighbour searches should be parallelized. Default
\code{BiocParallel::SerialParam(RNGseed = seed)}.}
}
\value{
A \link[SingleCellExperiment]{SingleCellExperiment} object with the
scDblFinder QC outputs added to the \link{colData} slot.
}
\description{
A wrapper function for \link[scDblFinder]{scDblFinder}. Identify
 potential doublet cells based on simulations of putative doublet expression
 profiles. Generate a doublet score for each cell.
}
\details{
This function is a wrapper function for
\link[scDblFinder]{scDblFinder}. \code{runScDblFinder} runs
\link[scDblFinder]{scDblFinder} for each sample within \code{inSCE}
iteratively. The resulting doublet scores for all cells will be appended to
the \code{\link{colData}} of \code{inSCE}.
}
\examples{
data(scExample, package = "singleCellTK")
sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
sce <- runScDblFinder(sce)
}
\references{
Lun ATL (2018). Detecting doublet cells with scran.
 \url{https://ltla.github.io/SingleCellThoughts/software/doublet_detection/bycell.html}
}
\seealso{
\code{\link[scDblFinder]{scDblFinder}},
\code{\link{plotScDblFinderResults}}, \code{\link{runCellQC}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scanpyFunctions.R
\name{plotScanpyPCAGeneRanking}
\alias{plotScanpyPCAGeneRanking}
\title{plotScanpyPCAGeneRanking}
\usage{
plotScanpyPCAGeneRanking(inSCE, PC_comp = "1,2,3", includeLowest = TRUE)
}
\arguments{
\item{inSCE}{Input \code{SingleCellExperiment} object.}

\item{PC_comp}{For example, '1,2,3' means [1, 2, 3], first, second, 
third principal component.}

\item{includeLowest}{Whether to show the variables with both highest and 
lowest loadings. Default \code{TRUE}}
}
\value{
plot object
}
\description{
plotScanpyPCAGeneRanking
}
\examples{
data(scExample, package = "singleCellTK")
\dontrun{
sce <- runScanpyNormalizeData(sce, useAssay = "counts")
sce <- runScanpyFindHVG(sce, useAssay = "scanpyNormData", method = "seurat")
sce <- runScanpyScaleData(sce, useAssay = "scanpyNormData")
sce <- runScanpyPCA(sce, useAssay = "scanpyScaledData")
plotScanpyPCAGeneRanking(sce)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runTSCAN.R
\name{plotTSCANClusterPseudo}
\alias{plotTSCANClusterPseudo}
\title{Plot TSCAN pseudotime rooted from given cluster}
\usage{
plotTSCANClusterPseudo(
  inSCE,
  useCluster,
  useReducedDim = "UMAP",
  combinePlot = c("all", "none")
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object.}

\item{useCluster}{The cluster to be regarded as the root, has to existing in
\code{colData(inSCE)$TSCAN_clusters}.}

\item{useReducedDim}{Saved dimension reduction name in the
SingleCellExperiment object. Required.}

\item{combinePlot}{Must be either \code{"all"} or \code{"none"}. \code{"all"}
will combine plots of pseudotime along each path into a single \code{.ggplot}
object, while \code{"none"} will output a list of plots. Default
\code{"all"}.}
}
\value{
\item{combinePlot = "all"}{A \code{.ggplot} object}
\item{combinePlot = "none"}{A list of \code{.ggplot}}
}
\description{
This function finds all paths that root from a given cluster
\code{useCluster}. For each path, this function plots the recomputed
pseudotime starting from the root on a scatter plot which contains cells only
in this cluster. MST has to be pre-calculated with \code{\link{runTSCAN}}.
}
\examples{
data("mouseBrainSubsetSCE", package = "singleCellTK")
mouseBrainSubsetSCE <- runTSCAN(inSCE = mouseBrainSubsetSCE,
                                useReducedDim = "PCA_logcounts")
plotTSCANClusterPseudo(mouseBrainSubsetSCE, useCluster = 1,
                       useReducedDim = "TSNE_logcounts")
}
\author{
Nida Pervaiz
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runFeatureSelection.R
\name{runFeatureSelection}
\alias{runFeatureSelection}
\title{Run Variable Feature Detection Methods}
\usage{
runFeatureSelection(inSCE, useAssay, method = "vst")
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object.}

\item{useAssay}{Specify the name of the assay that should be used. Should use
raw counts for \code{"vst"} method, or a normalized assay for other methods.}

\item{method}{Specify the method to use for variable gene selection.
Options include \code{"vst"}, \code{"mean.var.plot"} or \code{"dispersion"}
from Seurat and \code{"modelGeneVar"} from Scran. Default \code{"vst"}}
}
\value{
The input \linkS4class{SingleCellExperiment} object that contains 
the computed statistics in the \code{rowData} slot
}
\description{
Wrapper function to run all of the feature selection methods 
integrated within the singleCellTK package including three methods from
Seurat (\code{"vst"}, \code{"mean.var.plot"} or \code{dispersion}) and the 
Scran \code{modelGeneVar} method.

This function does not return the names of the variable features but only 
computes the metrics, which will be stored in the \code{rowData} slot. To set
a HVG list for downstream use, users should call \code{\link{setTopHVG}} 
after computing the metrics. To get the names of the variable features, users
should call \code{\link{getTopHVG}} function after computing the metrics.
}
\examples{
data("mouseBrainSubsetSCE", package = "singleCellTK")
mouseBrainSubsetSCE <- runFeatureSelection(mouseBrainSubsetSCE,
                                           "logcounts",
                                           "modelGeneVar")
}
\seealso{
\code{\link{runModelGeneVar}}, \code{\link{runSeuratFindHVG}},
\code{\link{getTopHVG}}, \code{\link{plotTopHVG}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/importFromFiles.R
\name{importFromFiles}
\alias{importFromFiles}
\title{Create a SingleCellExperiment object from files}
\usage{
importFromFiles(
  assayFile,
  annotFile = NULL,
  featureFile = NULL,
  assayName = "counts",
  inputDataFrames = FALSE,
  class = c("Matrix", "matrix"),
  delayedArray = FALSE,
  annotFileHeader = FALSE,
  annotFileRowName = 1,
  annotFileSep = "\\t",
  featureHeader = FALSE,
  featureRowName = 1,
  featureSep = "\\t",
  gzipped = "auto",
  rowNamesDedup = TRUE
)
}
\arguments{
\item{assayFile}{The path to a file in .mtx, .txt, .csv, .tab, or .tsv 
format.}

\item{annotFile}{The path to a text file that contains columns of annotation
information for each cell in the \code{assayFile}. This file should have the 
same number of rows as there are columns in the \code{assayFile}. If multiple
samples are represented in the dataset, this should be denoted by a column 
called \code{'sample'} within the \code{annotFile}.}

\item{featureFile}{The path to a text file that contains columns of
annotation information for each gene in the count matrix. This file should
have the same genes in the same order as \code{assayFile}. This is optional.}

\item{assayName}{The name of the assay that you are uploading. The default
is \code{"counts"}.}

\item{inputDataFrames}{If \code{TRUE}, \code{assayFile}, \code{annotFile} and
\code{featureFile} should be \code{data.frames} object (or its inheritance) 
instead of file paths. The default is \code{FALSE}.}

\item{class}{Character. The class of the expression matrix stored in the SCE
object. Can be one of \code{"Matrix"} (as returned by
\link{readMM} function), or \code{"matrix"} (as returned by
\link[base]{matrix} function). Default \code{"Matrix"}.}

\item{delayedArray}{Boolean. Whether to read the expression matrix as
\link{DelayedArray} object or not. Default \code{FALSE}.}

\item{annotFileHeader}{Whether there's a header (colnames) in the cell 
annotation file. Default is \code{FALSE}.}

\item{annotFileRowName}{Which column is used as the rownames for the cell 
annotation file. This should match to the colnames of the \code{assayFile}. 
Default is \code{1} (first column).}

\item{annotFileSep}{Separater used for the cell annotation file. Default is 
\code{"\\t"}.}

\item{featureHeader}{Whether there's a header (colnames) in the feature 
annotation file. Default is \code{FALSE}.}

\item{featureRowName}{Which column is used as the rownames for the feature 
annotation file. This should match to the rownames of the \code{assayFile}. 
Default is \code{1}. (first column).}

\item{featureSep}{Separater used for the feature annotation file. Default is 
\code{"\\t"}.}

\item{gzipped}{Whether the input file is gzipped. Default is \code{"auto"} 
and it will automatically detect whether the file is gzipped. Other options 
are \code{TRUE} or \code{FALSE}.}

\item{rowNamesDedup}{Boolean. Whether to deduplicate rownames. Default 
\code{TRUE}.}
}
\value{
a \linkS4class{SingleCellExperiment} object
}
\description{
Create a SingleCellExperiment object from files
}
\details{
Creates a \linkS4class{SingleCellExperiment} object from a counts 
file in various formats, and files of cell and feature annotation.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scran_modelGeneVar.R
\name{runModelGeneVar}
\alias{runModelGeneVar}
\title{Calculate Variable Genes with Scran modelGeneVar}
\usage{
runModelGeneVar(inSCE, useAssay = "logcounts")
}
\arguments{
\item{inSCE}{A \linkS4class{SingleCellExperiment} object}

\item{useAssay}{A character string to specify an assay to compute variable 
features from. Default \code{"logcounts"}.}
}
\value{
\code{inSCE} updated with variable feature metrics in \code{rowData}
}
\description{
Generates and stores variability data in the input 
\linkS4class{SingleCellExperiment} object, using 
\code{\link[scran]{modelGeneVar}} method. 

Also selects a specified number of top HVGs and store the logical selection 
in \code{rowData}.
}
\examples{
data("scExample", package = "singleCellTK")
sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
sce <- scaterlogNormCounts(sce, "logcounts")
sce <- runModelGeneVar(sce)
hvf <- getTopHVG(sce, method = "modelGeneVar", hvgNumber = 10,
          useFeatureSubset = NULL)
}
\seealso{
\code{\link{runFeatureSelection}}, \code{\link{runSeuratFindHVG}},
\code{\link{getTopHVG}}, \code{\link{plotTopHVG}}
}
\author{
Irzam Sarfraz
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotPathway.R
\name{getPathwayResultNames}
\alias{getPathwayResultNames}
\title{List pathway analysis result names}
\usage{
getPathwayResultNames(inSCE, stopIfNone = FALSE, verbose = FALSE)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object.}

\item{stopIfNone}{Whether to stop and raise an error if no results found. If
\code{FALSE}, will return an empty character vector.}

\item{verbose}{Show warning if no result found. Default \code{FALSE}}
}
\value{
A character vector of valid pathway analysis result names.
}
\description{
List pathway analysis result names
}
\details{
Pathway analysis results will be stored as matrices in
\code{reducedDims} slot of \code{inSCE}. This function lists the result names
stored in \code{metadata} slot when analysis is performed.
}
\examples{
data(scExample)
getPathwayResultNames(sce)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runFindMarker.R
\name{getFindMarkerTopTable}
\alias{getFindMarkerTopTable}
\alias{findMarkerTopTable}
\title{Fetch the table of top markers that pass the filtering}
\usage{
getFindMarkerTopTable(
  inSCE,
  log2fcThreshold = 0,
  fdrThreshold = 0.05,
  minClustExprPerc = 0.5,
  maxCtrlExprPerc = 0.5,
  minMeanExpr = 0,
  topN = 1
)

findMarkerTopTable(
  inSCE,
  log2fcThreshold = 1,
  fdrThreshold = 0.05,
  minClustExprPerc = 0.7,
  maxCtrlExprPerc = 0.4,
  minMeanExpr = 1,
  topN = 10
)
}
\arguments{
\item{inSCE}{\linkS4class{SingleCellExperiment} inherited object.}

\item{log2fcThreshold}{Only use DEGs with the absolute values of log2FC
larger than this value. Default \code{1}}

\item{fdrThreshold}{Only use DEGs with FDR value smaller than this value.
Default \code{0.05}}

\item{minClustExprPerc}{A numeric scalar. The minimum cutoff of the
percentage of cells in the cluster of interests that expressed the marker
gene. Default \code{0.7}.}

\item{maxCtrlExprPerc}{A numeric scalar. The maximum cutoff of the
percentage of cells out of the cluster (control group) that expressed the
marker gene. Default \code{0.4}.}

\item{minMeanExpr}{A numeric scalar. The minimum cutoff of the mean
expression value of the marker in the cluster of interests. Default \code{1}.}

\item{topN}{An integer. Only to fetch this number of top markers for each
cluster in maximum, in terms of log2FC value. Use \code{NULL} to cancel the
top N subscription. Default \code{10}.}
}
\value{
An organized \code{data.frame} object, with the top marker gene
information.
}
\description{
Fetch the table of top markers that pass the filtering
}
\details{
Users have to run \code{\link{runFindMarker}} prior to using this
function to extract a top marker table.
}
\examples{
data("mouseBrainSubsetSCE", package = "singleCellTK")
mouseBrainSubsetSCE <- runFindMarker(mouseBrainSubsetSCE,
                                     useAssay = "logcounts",
                                     cluster = "level1class")
getFindMarkerTopTable(mouseBrainSubsetSCE)
}
\seealso{
\code{\link{runFindMarker}}, \code{\link{plotFindMarkerHeatmap}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sctkQCUtils.R
\name{constructSCE}
\alias{constructSCE}
\title{Create SingleCellExperiment object from csv or txt input}
\usage{
constructSCE(data, samplename)
}
\arguments{
\item{data}{A \link[data.table]{data.table} object containing the count matrix.}

\item{samplename}{The sample name of the data.}
}
\value{
A \link[SingleCellExperiment]{SingleCellExperiment} object containing
the count matrix.
}
\description{
Create SingleCellExperiment object from csv or txt input
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scanpyFunctions.R
\name{plotScanpyViolin}
\alias{plotScanpyViolin}
\title{plotScanpyViolin}
\usage{
plotScanpyViolin(
  inSCE,
  useAssay = NULL,
  features,
  groupBy,
  xlabel = "",
  ylabel = NULL
)
}
\arguments{
\item{inSCE}{Input \code{SingleCellExperiment} object.}

\item{useAssay}{Assay to use for plotting. By default it will use counts
assay.}

\item{features}{Genes to plot. Sometimes is useful to pass a specific list of
var names (e.g. genes). The var_names could be a dictionary or a list.}

\item{groupBy}{The key of the observation grouping to consider.}

\item{xlabel}{Label of the x axis. Defaults to groupBy.}

\item{ylabel}{Label of the y axis. If NULL and groupBy is NULL, 
defaults to 'value'. If NULL and groupBy is not NULL, defaults to features.}
}
\value{
plot object
}
\description{
plotScanpyViolin
}
\examples{
data(scExample, package = "singleCellTK")
\dontrun{
sce <- runScanpyNormalizeData(sce, useAssay = "counts")
sce <- runScanpyFindHVG(sce, useAssay = "scanpyNormData", method = "seurat")
sce <- runScanpyScaleData(sce, useAssay = "scanpyNormData")
sce <- runScanpyPCA(sce, useAssay = "scanpyScaledData")
sce <- runScanpyFindClusters(sce, useReducedDim = "scanpyPCA")
sce <- runScanpyUMAP(sce, useReducedDim = "scanpyPCA")
markers <- c("MALAT1" ,"RPS27" ,"CST3")
plotScanpyViolin(sce, features = markers, groupBy = "Scanpy_louvain_1")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sctkTagging.R
\name{expTaggedData}
\alias{expTaggedData}
\title{expTaggedData
Returns a list of names of data items from the 
input \code{SingleCellExperiment} object based upon the input parameters.}
\usage{
expTaggedData(
  inSCE,
  tags = NULL,
  redDims = FALSE,
  recommended = NULL,
  showTags = TRUE
)
}
\arguments{
\item{inSCE}{Input \code{SingleCellExperiment} object.}

\item{tags}{A \code{character()} value indicating if the data items should 
be returned separated by the specified tags. Default is \code{NULL} 
indicating that returned names of the data items are simply returned as a 
list with default tag as "uncategorized".}

\item{redDims}{A \code{logical} value indicating if \code{reducedDims} 
should be returned as well separated with 'redDims' tag.}

\item{recommended}{A \code{character()} vector indicating the tags that 
should be displayed as recommended. Default is \code{NULL}.}

\item{showTags}{A \code{logical} value indicating if the tags should be 
shown. If \code{FALSE}, output is just a simple list, not separated by tags.}
}
\value{
A \code{list} of names of data items specified by the other 
parameters.
}
\description{
expTaggedData
Returns a list of names of data items from the 
input \code{SingleCellExperiment} object based upon the input parameters.
}
\examples{
data(scExample, package = "singleCellTK")
sce <- expSetDataTag(sce, "raw", "counts")
tags <- expTaggedData(sce)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sctkQCUtils.R
\name{qcInputProcess}
\alias{qcInputProcess}
\title{Create SingleCellExperiment object from command line input arguments}
\usage{
qcInputProcess(
  preproc,
  samplename,
  path,
  raw,
  fil,
  ref,
  rawFile,
  filFile,
  flatFiles,
  dataType
)
}
\arguments{
\item{preproc}{Method used to preprocess the data. It's one of the path provided in --preproc argument.}

\item{samplename}{The sample name of the data. It's one of the path provided in --sample argument.}

\item{path}{Base path of the dataset. It's one of the path provided in --bash_path argument.}

\item{raw}{The directory contains droplet matrix, gene and cell barcodes information. It's one of the path provided in --raw_data_path argument.}

\item{fil}{The directory contains cell matrix, gene and cell barcodes information. It's one of the path provided in --cell_data_path argument.}

\item{ref}{The name of reference used by cellranger. Only need for CellrangerV2 data.}

\item{rawFile}{The full path of the RDS file or Matrix file of the raw gene count matrix. It's one of the path provided in --raw_data argument.}

\item{filFile}{The full path of the RDS file or Matrix file of the cell count matrix. It's one of the path provided in --cell_data argument.}

\item{flatFiles}{The full paths of the matrix, barcode, and features (in that order) files used to construct an SCE object.}

\item{dataType}{Type of the input. It can be "Both", "Droplet" or "Cell". It's one of the path provided in --genome argument.}
}
\value{
A list of \link[SingleCellExperiment]{SingleCellExperiment} object containing
the droplet or cell data or both,depending on the dataType that users provided.
}
\description{
Create SingleCellExperiment object from command line input arguments
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scrublet_doubletDetection.R
\name{runScrublet}
\alias{runScrublet}
\title{Find doublets using \code{scrublet}.}
\usage{
runScrublet(
  inSCE,
  sample = NULL,
  useAssay = "counts",
  simDoubletRatio = 2,
  nNeighbors = NULL,
  minDist = NULL,
  expectedDoubletRate = 0.1,
  stdevDoubletRate = 0.02,
  syntheticDoubletUmiSubsampling = 1,
  useApproxNeighbors = TRUE,
  distanceMetric = "euclidean",
  getDoubletNeighborParents = FALSE,
  minCounts = 3,
  minCells = 3L,
  minGeneVariabilityPctl = 85,
  logTransform = FALSE,
  meanCenter = TRUE,
  normalizeVariance = TRUE,
  nPrinComps = 30L,
  tsneAngle = NULL,
  tsnePerplexity = NULL,
  verbose = TRUE,
  seed = 12345
)
}
\arguments{
\item{inSCE}{A \linkS4class{SingleCellExperiment} object.}

\item{sample}{Character vector or colData variable name. Indicates which 
sample each cell belongs to. Default \code{NULL}.}

\item{useAssay}{A string specifying which assay in the SCE to use. Default 
\code{"counts"}.}

\item{simDoubletRatio}{Numeric. Number of doublets to simulate relative to
the number of observed transcriptomes. Default \code{2.0}.}

\item{nNeighbors}{Integer. Number of neighbors used to construct the KNN
graph of observed transcriptomes and simulated doublets. If \code{NULL},
this is set to \code{round(0.5 * sqrt(n_cells))}. Default \code{NULL}.}

\item{minDist}{Float Determines how tightly UMAP packs points together. If 
\code{NULL}, this is set to \code{0.1}. Default \code{NULL}.}

\item{expectedDoubletRate}{The estimated doublet rate for the experiment.
Default \code{0.1}.}

\item{stdevDoubletRate}{Uncertainty in the expected doublet rate. Default 
\code{0.02}.}

\item{syntheticDoubletUmiSubsampling}{Numeric. Rate for sampling UMIs when
creating synthetic doublets. If \code{1.0}, each doublet is created by simply
adding the UMIs from two randomly sampled observed transcriptomes. For
values less than 1, the UMI counts are added and then randomly sampled at
the specified rate. Defuault \code{1.0}.}

\item{useApproxNeighbors}{Boolean. Use approximate nearest neighbor method
(annoy) for the KNN classifier. Default \code{TRUE}.}

\item{distanceMetric}{Character. Distance metric used when finding nearest
neighbors. See detail. Default \code{"euclidean"}.}

\item{getDoubletNeighborParents}{Boolean. If \code{TRUE}, return the
parent transcriptomes that generated the doublet neighbors of each
observed transcriptome. This information can be used to infer the cell states
that generated a given doublet state. Default \code{FALSE}.}

\item{minCounts}{Numeric. Used for gene filtering prior to PCA. Genes
expressed at fewer than \code{minCounts} in fewer than \code{minCells} are
excluded. Default \code{3}.}

\item{minCells}{Integer. Used for gene filtering prior to PCA. Genes
expressed at fewer than \code{minCounts} in fewer than \code{minCells} are 
excluded. Default \code{3}.}

\item{minGeneVariabilityPctl}{Numeric. Used for gene filtering prior to
PCA. Keep the most highly variable genes (in the top
\code{minGeneVariabilityPctl} percentile), as measured by the v-statistic
(Klein et al., Cell 2015). Default \code{85}.}

\item{logTransform}{Boolean. If \code{TRUE}, log-transform the counts matrix
(log1p(TPM)). \code{sklearn.decomposition.TruncatedSVD} will be used for
dimensionality reduction, unless \code{meanCenter} is \code{TRUE}. Default 
\code{FALSE}.}

\item{meanCenter}{If \code{TRUE}, center the data such that each gene has a
mean of \code{0}. \code{sklearn.decomposition.PCA} will be used for
dimensionality reduction. Default \code{TRUE}.}

\item{normalizeVariance}{Boolean. If \code{TRUE}, normalize the data such
that each gene has a variance of 1.
\code{sklearn.decomposition.TruncatedSVD} will be used for dimensionality
reduction, unless \code{meanCenter} is \code{TRUE}. Default \code{TRUE}.}

\item{nPrinComps}{Integer. Number of principal components used to embed
the transcriptomes prior to k-nearest-neighbor graph construction.
Default \code{30}.}

\item{tsneAngle}{Float. Determines angular size of a distant node as measured
from a point in the t-SNE plot. If \code{NULL}, it is set to \code{0.5}. 
Default \code{NULL}.}

\item{tsnePerplexity}{Integer. The number of nearest neighbors that is used
in other manifold learning algorithms. If \code{NULL}, it is set to 30. 
Default \code{NULL}.}

\item{verbose}{Boolean. If \code{TRUE}, print progress updates. Default
\code{TRUE}.}

\item{seed}{Seed for the random number generator, can be set to \code{NULL}. 
Default \code{12345}.}
}
\value{
A \linkS4class{SingleCellExperiment} object with
\code{scrub_doublets} output appended to the \link{colData} slot. The columns
include \code{scrublet_score} and \code{scrublet_call}.
}
\description{
A wrapper function that calls \code{scrub_doublets} from python
 module \code{scrublet}. Simulates doublets from the observed data and uses
 a k-nearest-neighbor classifier to calculate a continuous
 \code{scrublet_score} (between 0 and 1) for each transcriptome. The score
 is automatically thresholded to generate \code{scrublet_call}, a boolean
 array that is \code{TRUE} for predicted doublets and \code{FALSE}
 otherwise.
}
\details{
For the list of valid values for \code{distanceMetric}, see the 
documentation for 
\href{https://github.com/spotify/annoy#full-python-api}{annoy} (if 
\code{useApproxNeighbors} is \code{TRUE}) or 
\href{https://scikit-learn.org/stable/modules/generated/sklearn.neighbors.NearestNeighbors.html}{sklearn.neighbors.NearestNeighbors}
(if \code{useApproxNeighbors} is  \code{FALSE}).
}
\examples{
data(scExample, package = "singleCellTK")
\dontrun{
sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
sce <- runScrublet(sce)
}
}
\seealso{
\code{\link{plotScrubletResults}}, \code{\link{runCellQC}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/miscFunctions.R
\name{dedupRowNames}
\alias{dedupRowNames}
\title{Deduplicate the rownames of a matrix or SingleCellExperiment object}
\usage{
dedupRowNames(x, as.rowData = FALSE, return.list = FALSE)
}
\arguments{
\item{x}{A matrix like or \linkS4class{SingleCellExperiment} object, on which
we can apply \code{rownames()} to and has duplicated rownames.}

\item{as.rowData}{Only applicable when \code{x} is a
\linkS4class{SingleCellExperiment} object. When set to \code{TRUE}, will
insert a new column called \code{"rownames.uniq"} to \code{rowData(x)}, with
the deduplicated rownames.}

\item{return.list}{When set to \code{TRUE}, will return a character vector
of the deduplicated rownames.}
}
\value{
By default, a matrix or \linkS4class{SingleCellExperiment} object
with rownames deduplicated.
When \code{x} is a \linkS4class{SingleCellExperiment} and \code{as.rowData}
is set to \code{TRUE}, will return \code{x} with \code{rowData} updated.
When \code{return.list} is set to \code{TRUE}, will return a character vector
with the deduplicated rownames.
}
\description{
Adds '-1', '-2', ... '-i' to multiple duplicated rownames, and in place
replace the unique rownames, store unique rownames in \code{rowData}, or
return the unique rownames as character vecetor.
}
\examples{
data("scExample", package = "singleCellTK")
sce <- dedupRowNames(sce)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/celda_decontX.R
\name{runDecontX}
\alias{runDecontX}
\title{Detecting contamination with DecontX.}
\usage{
runDecontX(
  inSCE,
  sample = NULL,
  useAssay = "counts",
  background = NULL,
  bgAssayName = NULL,
  bgBatch = NULL,
  z = NULL,
  maxIter = 500,
  delta = c(10, 10),
  estimateDelta = TRUE,
  convergence = 0.001,
  iterLogLik = 10,
  varGenes = 5000,
  dbscanEps = 1,
  seed = 12345,
  logfile = NULL,
  verbose = TRUE
)
}
\arguments{
\item{inSCE}{A \link[SingleCellExperiment]{SingleCellExperiment} object.}

\item{sample}{A single character specifying a name that can be found in
\code{colData(inSCE)} to directly use the cell annotation; or a character
vector with as many elements as cells to indicates which sample each cell
belongs to. Default NULL. \link[celda]{decontX} will be run on cells from
each sample separately.}

\item{useAssay}{A string specifying which assay in the SCE to use. Default
'counts'.}

\item{background}{A \link[SingleCellExperiment]{SingleCellExperiment}
with the matrix located in the assay slot under \code{bgAssayName}. It should have 
the same structure as inSCE except it contains the matrix of empty droplets instead 
of cells. When supplied, empirical distribution of transcripts from these 
empty droplets will be used as the contamination distribution. Default NULL.}

\item{bgAssayName}{Character. Name of the assay to use if background is a 
\link[SingleCellExperiment]{SingleCellExperiment}. If NULL, the function
will use the same value as \code{useAssay}. Default is NULL.}

\item{bgBatch}{Batch labels for \code{background}. If \code{background} is a 
\link[SingleCellExperiment]{SingleCellExperiment} object, this can be a single 
character specifying a name that can be found in \code{colData(background)} 
to directly use the barcode annotation; or a numeric / character vector that has  
as many elements as barcodes to indicate which sample each barcode belongs to. Its 
unique values should be the same as those in \code{sample}, such that each 
batch of cells have their corresponding batch of empty droplets as background, 
pointed by this parameter. Default to NULL.}

\item{z}{Numeric or character vector. Cell cluster labels. If NULL,
PCA will be used to reduce the dimensionality of the dataset initially,
'\link[uwot]{umap}' from the 'uwot' package
will be used to further reduce the dataset to 2 dimenions and
the '\link[dbscan]{dbscan}' function from the 'dbscan' package
will be used to identify clusters of broad cell types. Default NULL.}

\item{maxIter}{Integer. Maximum iterations of the EM algorithm. Default 500.}

\item{delta}{Numeric Vector of length 2. Concentration parameters for
the Dirichlet prior for the contamination in each cell. The first element
is the prior for the native counts while the second element is the prior for
the contamination counts. These essentially act as pseudocounts for the
native and contamination in each cell. If \code{estimateDelta = TRUE},
this is only used to produce a random sample of proportions for an initial
value of contamination in each cell. Then
\code{\link[MCMCprecision]{fit_dirichlet}} is used to update
\code{delta} in each iteration.
If \code{estimateDelta = FALSE}, then \code{delta} is fixed with these
values for the entire inference procedure. Fixing \code{delta} and
setting a high number in the second element will force \code{decontX}
to be more aggressive and estimate higher levels of contamination at
the expense of potentially removing native expression.
Default \code{c(10, 10)}.}

\item{estimateDelta}{Boolean. Whether to update \code{delta} at each
iteration.}

\item{convergence}{Numeric. The EM algorithm will be stopped if the maximum
difference in the contamination estimates between the previous and
current iterations is less than this. Default 0.001.}

\item{iterLogLik}{Integer. Calculate log likelihood every \code{iterLogLik}
iteration. Default 10.}

\item{varGenes}{Integer. The number of variable genes to use in
dimensionality reduction before clustering. Variability is calcualted using
\code{\link[scran]{modelGeneVar}} function from the 'scran' package.
Used only when z is not provided. Default 5000.}

\item{dbscanEps}{Numeric. The clustering resolution parameter
used in '\link[dbscan]{dbscan}' to estimate broad cell clusters.
Used only when z is not provided. Default 1.}

\item{seed}{Integer. Passed to \link[withr]{with_seed}. For reproducibility,
a default value of 12345 is used. If NULL, no calls to
\link[withr]{with_seed} are made.}

\item{logfile}{Character. Messages will be redirected to a file named
`logfile`. If NULL, messages will be printed to stdout.  Default NULL.}

\item{verbose}{Logical. Whether to print log messages. Default TRUE.}
}
\value{
A \link[SingleCellExperiment]{SingleCellExperiment} object with
 'decontX_Contamination' and 'decontX_Clusters' added to the
 \link{colData} slot. Additionally, the
decontaminated counts will be added as an assay called 'decontXCounts'.
}
\description{
A wrapper function for \link[celda]{decontX}. Identify
 potential contamination from experimental factors such as ambient RNA.
}
\examples{
data(scExample, package = "singleCellTK")
sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
sce <- runDecontX(sce[,sample(ncol(sce),20)])
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scanpyFunctions.R
\name{runScanpyPCA}
\alias{runScanpyPCA}
\title{runScanpyPCA
Computes PCA on the input sce object and stores the calculated principal
components within the sce object}
\usage{
runScanpyPCA(
  inSCE,
  useAssay = "scanpyScaledData",
  reducedDimName = "scanpyPCA",
  nPCs = 50,
  method = c("arpack", "randomized", "auto", "lobpcg"),
  use_highly_variable = TRUE,
  seed = 12345
)
}
\arguments{
\item{inSCE}{(sce) object on which to compute PCA}

\item{useAssay}{Assay containing scaled counts to use in PCA. Default
\code{"scanpyScaledData"}.}

\item{reducedDimName}{Name of new reducedDims object containing Scanpy PCA.
Default \code{scanpyPCA}.}

\item{nPCs}{numeric value of how many components to compute. Default
\code{50}.}

\item{method}{selected method to use for computation of pca. 
One of \code{'arpack'}, \code{'randomized'}, \code{'auto'} or \code{'lobpcg'}.
Default \code{"arpack"}.}

\item{use_highly_variable}{boolean value of whether to use highly variable 
genes only. By default uses them if they have been determined beforehand.}

\item{seed}{Specify numeric value to set as a seed. Default \code{12345}.}
}
\value{
Updated \code{SingleCellExperiment} object which now contains the
computed principal components
}
\description{
runScanpyPCA
Computes PCA on the input sce object and stores the calculated principal
components within the sce object
}
\examples{
data(scExample, package = "singleCellTK")
\dontrun{
sce <- runScanpyNormalizeData(sce, useAssay = "counts")
sce <- runScanpyFindHVG(sce, useAssay = "scanpyNormData", method = "seurat")
sce <- runScanpyScaleData(sce, useAssay = "scanpyNormData")
sce <- runScanpyPCA(sce, useAssay = "scanpyScaledData")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotBubble.R
\name{plotBubble}
\alias{plotBubble}
\title{Plot Bubble plot}
\usage{
plotBubble(
  inSCE,
  useAssay = "logcounts",
  featureNames,
  displayName = NULL,
  groupNames = "cluster",
  title = "",
  xlab = NULL,
  ylab = NULL,
  colorLow = "white",
  colorHigh = "blue",
  scale = FALSE
)
}
\arguments{
\item{inSCE}{The single cell experiment to use.}

\item{useAssay}{The assay to use.}

\item{featureNames}{A string or vector of strings with each gene to aggregate.}

\item{displayName}{A string that is the name of the column used for genes.}

\item{groupNames}{The name of a colData entry that can be used as groupNames.}

\item{title}{The title of the bubble plot}

\item{xlab}{The x-axis label}

\item{ylab}{The y-axis label}

\item{colorLow}{The color to be used for lowest value of mean expression}

\item{colorHigh}{The color to be used for highest value of mean expression}

\item{scale}{Option to scale the data. Default: \code{FALSE}. Selected assay will not be scaled.}
}
\value{
A ggplot of the bubble plot.
}
\description{
Plot a bubble plot with the color of the plot being the mean expression
and the size of the dot being the percent of cells in the cluster expressing the gene.
}
\examples{
data("scExample")
plotBubble(inSCE=sce, useAssay="counts", featureNames=c("B2M", "MALAT1"),
displayName="feature_name", groupNames="type", title="cell type test",
xlab="gene", ylab="cluster", colorLow="white", colorHigh="blue")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/allGenerics.R, R/sampleSummaryStats.R
\name{listSampleSummaryStatsTables}
\alias{listSampleSummaryStatsTables}
\alias{listSampleSummaryStatsTables,SingleCellExperiment-method}
\title{Lists the table of SCTK QC outputs stored within the metadata.}
\usage{
listSampleSummaryStatsTables(inSCE, ...)

\S4method{listSampleSummaryStatsTables}{SingleCellExperiment}(inSCE, ...)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object with saved
table within the \link{metadata} data. Required.}

\item{...}{Other arguments passed to the function.}
}
\value{
A character vector. Contains a list of summary tables
within the SingleCellExperiment object.
}
\description{
Returns a character vector of the tables
within the metadata slot of the SingleCellExperiment object.
}
\examples{
data(scExample, package = "singleCellTK")
sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
sce <- sampleSummaryStats(sce, simple = TRUE, statsName = "qc_table")
listSampleSummaryStatsTables(sce)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runTSCAN.R
\name{runTSCAN}
\alias{runTSCAN}
\title{Run TSCAN to obtain pseudotime values for cells}
\usage{
runTSCAN(
  inSCE,
  useReducedDim = "PCA",
  cluster = NULL,
  starter = NULL,
  seed = 12345
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object.}

\item{useReducedDim}{Character. A low-dimension representation in
\code{reducedDims}, will be used for both clustering if \code{cluster} not
specified and MST construction. Default \code{"PCA"}.}

\item{cluster}{Grouping for each cell in \code{inSCE}. A vector with equal
length to the number of the cells in \code{inSCE}, or a single character for
retriving \code{colData} variable. Default \code{NULL}, will run
\code{runScranSNN} to obtain.}

\item{starter}{Character. Specifies the starting node from which to compute
the pseudotime. Default \code{NULL}, will select an arbitrary node.}

\item{seed}{An integer. Random seed for clustering if \code{cluster} is not
specified. Default \code{12345}.}
}
\value{
The input \code{inSCE} object with pseudotime ordering of the cells
along the paths and the cluster label stored in \code{colData}, and other
unstructured information in \code{metadata}.
}
\description{
Wrapper for obtaining a pseudotime ordering of the cells by
projecting them onto the minimum spanning tree (MST)
}
\examples{
data("mouseBrainSubsetSCE", package = "singleCellTK")
mouseBrainSubsetSCE <- runTSCAN(inSCE = mouseBrainSubsetSCE,
                                useReducedDim = "PCA_logcounts")
}
\author{
Nida Pervaiz
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scanpyFunctions.R
\name{runScanpyFindHVG}
\alias{runScanpyFindHVG}
\title{runScanpyFindHVG
Find highly variable genes and store in the input sce object}
\usage{
runScanpyFindHVG(
  inSCE,
  useAssay = "scanpyNormData",
  method = c("seurat", "cell_ranger", "seurat_v3"),
  altExpName = "featureSubset",
  altExp = FALSE,
  hvgNumber = 2000,
  minMean = 0.0125,
  maxMean = 3,
  minDisp = 0.5,
  maxDisp = Inf
)
}
\arguments{
\item{inSCE}{(sce) object to compute highly variable genes from and to store
back to it}

\item{useAssay}{Specify the name of the assay to use for computation
of variable genes. It is recommended to use log normalized data, except when 
flavor='seurat_v3', in which counts data is expected.}

\item{method}{selected method to use for computation of highly variable
genes. One of \code{'seurat'}, \code{'cell_ranger'}, or \code{'seurat_v3'}.
Default \code{"seurat"}.}

\item{altExpName}{Character. Name of the alternative experiment object to
add if \code{returnAsAltExp = TRUE}. Default \code{featureSubset}.}

\item{altExp}{Logical value indicating if the input object is an
altExperiment. Default \code{FALSE}.}

\item{hvgNumber}{numeric value of how many genes to select as highly
variable. Default \code{2000}}

\item{minMean}{If n_top_genes unequals None, this and all other cutoffs for 
the means and the normalized dispersions are ignored. Ignored if 
flavor='seurat_v3'. Default \code{0.0125}}

\item{maxMean}{If n_top_genes unequals None, this and all other cutoffs for 
the means and the normalized dispersions are ignored. Ignored if 
flavor='seurat_v3'. Default \code{3}}

\item{minDisp}{If n_top_genes unequals None, this and all other cutoffs for 
the means and the normalized dispersions are ignored. Ignored if 
flavor='seurat_v3'. Default \code{0.5}}

\item{maxDisp}{If n_top_genes unequals None, this and all other cutoffs for 
the means and the normalized dispersions are ignored. Ignored if 
flavor='seurat_v3'. Default \code{Inf}}
}
\value{
Updated \code{SingleCellExperiment} object with highly variable genes
computation stored
\code{\link{getTopHVG}}, \code{\link{plotTopHVG}}
}
\description{
runScanpyFindHVG
Find highly variable genes and store in the input sce object
}
\examples{
data(scExample, package = "singleCellTK")
\dontrun{
sce <- runScanpyNormalizeData(sce, useAssay = "counts")
sce <- runScanpyFindHVG(sce, useAssay = "scanpyNormData", method = "seurat")
g <- getTopHVG(sce, method = "seurat", hvgNumber = 500)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scanpyFunctions.R
\name{plotScanpyMatrixPlot}
\alias{plotScanpyMatrixPlot}
\title{plotScanpyMatrixPlot}
\usage{
plotScanpyMatrixPlot(
  inSCE,
  useAssay = NULL,
  features,
  groupBy,
  standardScale = NULL,
  title = "",
  vmin = NULL,
  vmax = NULL,
  colorBarTitle = "Mean expression in group"
)
}
\arguments{
\item{inSCE}{Input \code{SingleCellExperiment} object.}

\item{useAssay}{Assay to use for plotting. By default it will use counts assay.}

\item{features}{Genes to plot. Sometimes is useful to pass a specific list of
var names (e.g. genes). The var_names could be a dictionary or a list.}

\item{groupBy}{The key of the observation grouping to consider.}

\item{standardScale}{Whether or not to standardize the given dimension 
between 0 and 1, meaning for each variable or group, subtract the minimum and 
divide each by its maximum. Default \code{NULL} means that it doesn't perform
any scaling.}

\item{title}{Provide title for the figure.}

\item{vmin}{The value representing the lower limit of the color scale. 
Values smaller than vmin are plotted with the same color as vmin. 
Default \code{NULL}}

\item{vmax}{The value representing the upper limit of the color scale. 
Values larger than vmax are plotted with the same color as vmax. 
Default \code{NULL}}

\item{colorBarTitle}{Title for the color bar.}
}
\value{
plot object
}
\description{
plotScanpyMatrixPlot
}
\examples{
data(scExample, package = "singleCellTK")
\dontrun{
sce <- runScanpyNormalizeData(sce, useAssay = "counts")
sce <- runScanpyFindHVG(sce, useAssay = "scanpyNormData", method = "seurat")
sce <- runScanpyScaleData(sce, useAssay = "scanpyNormData")
sce <- runScanpyPCA(sce, useAssay = "scanpyScaledData")
sce <- runScanpyFindClusters(sce, useReducedDim = "scanpyPCA")
sce <- runScanpyUMAP(sce, useReducedDim = "scanpyPCA")
markers <- c("MALAT1" ,"RPS27" ,"CST3")
plotScanpyMatrixPlot(sce, features = markers, groupBy = 'Scanpy_louvain_1')
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runCluster.R
\name{runScranSNN}
\alias{runScranSNN}
\title{Get clustering with SNN graph}
\usage{
runScranSNN(
  inSCE,
  useReducedDim = "PCA",
  useAssay = NULL,
  useAltExp = NULL,
  altExpAssay = "counts",
  altExpRedDim = NULL,
  clusterName = "cluster",
  k = 14,
  nComp = 10,
  weightType = "jaccard",
  algorithm = c("louvain", "leiden", "walktrap", "infomap", "fastGreedy", "labelProp",
    "leadingEigen"),
  BPPARAM = BiocParallel::SerialParam(),
  seed = 12345,
  ...
)
}
\arguments{
\item{inSCE}{A \linkS4class{SingleCellExperiment} object.}

\item{useReducedDim}{A single \code{character}, specifying which
low-dimension representation (\code{\link{reducedDim}})
to perform the clustering algorithm on. Default \code{"PCA"}.}

\item{useAssay}{A single \code{character}, specifying which
\code{\link{assay}} to perform the clustering algorithm
on. Default \code{NULL}.}

\item{useAltExp}{A single \code{character}, specifying the assay which
\code{\link{altExp}} to perform the clustering
algorithm on. Default \code{NULL}.}

\item{altExpAssay}{A single \code{character}, specifying which
\code{\link{assay}} in the chosen
\code{\link{altExp}} to work on. Only used when
\code{useAltExp} is set. Default \code{"counts"}.}

\item{altExpRedDim}{A single \code{character}, specifying which
\code{\link{reducedDim}} within the \code{\link{altExp}} specified by
\code{useAltExp} to use. Only used when \code{useAltExp} is set. Default
\code{NULL}.}

\item{clusterName}{A single \code{character}, specifying the name to store
the cluster label in \code{\link{colData}}. Default
\code{"cluster"}.}

\item{k}{An \code{integer}, the number of nearest neighbors used to construct
the graph. Smaller value indicates higher resolution and larger number of
clusters. Default \code{14}.}

\item{nComp}{An \code{integer}. The number of components to use for graph
construction. Default \code{10}. See Detail.}

\item{weightType}{A single \code{character}, that specifies the edge weighing
scheme when constructing the Shared Nearest-Neighbor (SNN) graph. Choose from
\code{"rank"}, \code{"number"}, \code{"jaccard"}. Default \code{"jaccard"}.}

\item{algorithm}{A single \code{character}, that specifies the community
detection algorithm to work on the SNN graph. Choose from \code{"leiden"},
\code{"louvain"}, \code{"walktrap"}, \code{"infomap"}, \code{"fastGreedy"},
\code{"labelProp"}, \code{"leadingEigen"}. Default \code{"louvain"}. See
Detail.}

\item{BPPARAM}{A \code{\link[BiocParallel]{BiocParallelParam}} object to use
for processing the SNN graph generation step in parallel.}

\item{seed}{Random seed for reproducibility of results. Default \code{NULL}
will use global seed in use by the R environment.}

\item{...}{Other optional parameters passed to the \code{\link{igraph}}
clustering functions. See Details.}
}
\value{
The input \linkS4class{SingleCellExperiment} object with
\code{factor} cluster labeling updated in
\code{colData(inSCE)[[clusterName]]}.
}
\description{
Perform SNN graph clustering on a
\linkS4class{SingleCellExperiment} object, with graph
construction by \code{\link[scran]{buildSNNGraph}} and graph clustering by
"igraph" package.
}
\details{
Different graph based clustering algorithms have diverse sets of
parameters that users can tweak. The help information can be found here:
\itemize{
 \item{for \code{"louvain"}, see function help
 \code{\link[igraph]{cluster_louvain}}}
 \item{for \code{"leiden"}, see function help
 \code{\link[igraph]{cluster_leiden}}}
 \item{for \code{"walktrap"}, see function help
 \code{\link[igraph]{cluster_walktrap}}}
 \item{for \code{"infomap"}, see function help
 \code{\link[igraph]{cluster_infomap}}}
 \item{for \code{"fastGreedy"}, see function help
 \code{\link[igraph]{cluster_fast_greedy}}}
 \item{for \code{"labelProp"}, see function help
 \code{\link[igraph]{cluster_label_prop}}}
 \item{for \code{"leadingEigen"}, see function help
 \code{\link[igraph]{cluster_leading_eigen}}}
}

The Scran SNN building method can work on specified \code{nComp} components.
When users specify input matrix by \code{useAssay} or \code{useAltExp} +
\code{altExpAssay}, the method will generate \code{nComp} components and use
them all. When specifying \code{useReducedDim} or \code{useAltExp} +
\code{altExpRedDim}, this function will subset the top \code{nComp}
components and pass them to the method.
}
\examples{
data("mouseBrainSubsetSCE")
mouseBrainSubsetSCE <- runScranSNN(mouseBrainSubsetSCE,
                                   useReducedDim = "PCA_logcounts")
}
\references{
Aaron Lun and et. al., 2016
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DownsampleMatrix.R
\name{calcEffectSizes}
\alias{calcEffectSizes}
\title{Finds the effect sizes for all genes in the original dataset, regardless of
significance.}
\usage{
calcEffectSizes(countMatrix, condition)
}
\arguments{
\item{countMatrix}{Matrix. A simulated counts matrix, sans labels.}

\item{condition}{Factor. The condition labels for the simulated cells. If
more than 2 conditions are given, the first will be compared to all others by
default.}
}
\value{
A vector of cohen's d effect sizes for each gene.
}
\description{
Finds the effect sizes for all genes in the original dataset, regardless of
significance.
}
\examples{
data("mouseBrainSubsetSCE")
res <- calcEffectSizes(assay(mouseBrainSubsetSCE, "counts"),
                       condition = colData(mouseBrainSubsetSCE)$level1class)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{sce}
\alias{sce}
\title{Example Single Cell RNA-Seq data in SingleCellExperiment Object,
subset of 10x public dataset}
\format{
A \link[SingleCellExperiment]{SingleCellExperiment} object.
}
\usage{
data("scExample")
}
\value{
Example Single Cell RNA-Seq data in SingleCellExperiment Object,
subset of 10x public dataset
}
\description{
https://support.10xgenomics.com/single-cell-gene-expression/datasets/2.1.0/pbmc4k
A subset of 390 barcodes and top 200 genes were included in this example.
Within 390 barcodes, 195 barcodes are empty droplet, 150 barcodes are cell
barcode and 45 barcodes are doublets predicted by scrublet and doubletFinder
package. This example only serves as a proof of concept and a tutoriol on how
to run the functions in this package. The results should not be used for
drawing scientific conclusions.
}
\examples{
data("scExample")
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/importSTARSolo.R
\name{importSTARsolo}
\alias{importSTARsolo}
\title{Construct SCE object from STARsolo outputs}
\usage{
importSTARsolo(
  STARsoloDirs,
  samples,
  STARsoloOuts = c("Gene", "GeneFull"),
  matrixFileNames = "matrix.mtx",
  featuresFileNames = "features.tsv",
  barcodesFileNames = "barcodes.tsv",
  gzipped = "auto",
  class = c("Matrix", "matrix"),
  delayedArray = FALSE,
  rowNamesDedup = TRUE
)
}
\arguments{
\item{STARsoloDirs}{A vector of root directories of STARsolo output files.
The paths should be something like this:
\bold{/PATH/TO/\emph{prefix}Solo.out}. For example: \code{./Solo.out}.
Each sample should have its own path. Must have the same length as
\code{samples}.}

\item{samples}{A vector of user-defined sample names for the sample to be
imported. Must have the same length as \code{STARsoloDirs}.}

\item{STARsoloOuts}{Character. The intermediate
folder to filtered or raw cell barcode, feature, and matrix files
for each of \code{samples}. Default \code{"Gene"}.
It can be either Gene or GeneFull as the main folder from
which data needs to be imported.}

\item{matrixFileNames}{Filenames for the Market Exchange Format (MEX) sparse
matrix file (.mtx file). Must have length 1 or the same
length as \code{samples}.}

\item{featuresFileNames}{Filenames for the feature annotation file.
Must have length 1 or the same
length as \code{samples}.}

\item{barcodesFileNames}{Filenames for the cell barcode list file.
Must have length 1 or the same
length as \code{samples}.}

\item{gzipped}{Boolean. \code{TRUE} if the STARsolo output files
(barcodes.tsv, features.tsv, and matrix.mtx) were
gzip compressed. \code{FALSE} otherwise. This is \code{FALSE} in STAR
2.7.3a. Default \code{"auto"} which automatically detects if the
files are gzip compressed. Must have length 1 or the same
length as \code{samples}.}

\item{class}{Character. The class of the expression matrix stored in the SCE
object. Can be one of "Matrix" (as returned by
\link{readMM} function), or "matrix" (as returned by
\link[base]{matrix} function). Default "Matrix".}

\item{delayedArray}{Boolean. Whether to read the expression matrix as
\link{DelayedArray} object or not. Default \code{FALSE}.}

\item{rowNamesDedup}{Boolean. Whether to deduplicate rownames. Default
\code{TRUE}.}
}
\value{
A \code{SingleCellExperiment} object containing the count
 matrix, the gene annotation, and the cell annotation.
}
\description{
Read the barcodes, features (genes), and matrices from STARsolo
 outputs. Import them
 as one \link[SingleCellExperiment]{SingleCellExperiment} object.
}
\examples{
# Example #1
# FASTQ files were downloaded from
# https://support.10xgenomics.com/single-cell-gene-expression/datasets/3.0.0
# /pbmc_1k_v3
# They were concatenated as follows:
# cat pbmc_1k_v3_S1_L001_R1_001.fastq.gz pbmc_1k_v3_S1_L002_R1_001.fastq.gz >
# pbmc_1k_v3_R1.fastq.gz
# cat pbmc_1k_v3_S1_L001_R2_001.fastq.gz pbmc_1k_v3_S1_L002_R2_001.fastq.gz >
# pbmc_1k_v3_R2.fastq.gz
# The following STARsolo command generates the filtered feature, cell, and
# matrix files
# STAR \
#   --genomeDir ./index \
#   --readFilesIn ./pbmc_1k_v3_R2.fastq.gz \
#                 ./pbmc_1k_v3_R1.fastq.gz \
#   --readFilesCommand zcat \
#   --outSAMtype BAM Unsorted \
#   --outBAMcompression -1 \
#   --soloType CB_UMI_Simple \
#   --soloCBwhitelist ./737K-august-2016.txt \
#   --soloUMIlen 12

# The top 20 genes and the first 20 cells are included in this example.
sce <- importSTARsolo(
  STARsoloDirs = system.file("extdata/STARsolo_PBMC_1k_v3_20x20",
    package = "singleCellTK"),
  samples = "PBMC_1k_v3_20x20")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/reticulate_setup.R
\name{selectSCTKVirtualEnvironment}
\alias{selectSCTKVirtualEnvironment}
\title{Selects a virtual environment}
\usage{
selectSCTKVirtualEnvironment(envname = "sctk-reticulate")
}
\arguments{
\item{envname}{Character. Name of the virtual environment to activate.}
}
\value{
None. Selects virtual environment.
}
\description{
Selects a virtual environment with Python packages used in \code{\link{singleCellTK}}
}
\examples{
\dontrun{
sctkPythonInstallVirtualEnv(envname = "sctk-reticulate", selectEnvironment = FALSE)
selectSCTKVirtualEnvironment(envname = "sctk-reticulate")
}
}
\seealso{
See \code{\link[singleCellTK]{sctkPythonInstallVirtualEnv}} for installation of Python modules into a virtual environment.
See\code{\link[reticulate]{virtualenv-tools}} for more information on using virtual environments with package \code{\link{reticulate}}.
See \url{https://rstudio.github.io/reticulate/} for more information on package \code{\link{reticulate}}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{mouseBrainSubsetSCE}
\alias{mouseBrainSubsetSCE}
\title{Example Single Cell RNA-Seq data in SingleCellExperiment Object, GSE60361
subset}
\format{
SingleCellExperiment
}
\source{
DOI: 10.1126/science.aaa1934
}
\usage{
data("mouseBrainSubsetSCE")
}
\value{
A subset of 30 cells from a single cell RNA-Seq experiment
}
\description{
A subset of 30 cells from a single cell RNA-Seq experiment from Zeisel, et
al. Science 2015. The data was produced from cells from the mouse
somatosensory cortex (S1) and hippocampus (CA1). 15 of the cells were
identified as oligodendrocytes and 15 of the cell were identified as
microglia.
}
\examples{
data("mouseBrainSubsetSCE")
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/htmlReports.R
\name{reportFindMarker}
\alias{reportFindMarker}
\title{Get runFindMarker .html report}
\usage{
reportFindMarker(inSCE, output_file = NULL, output_dir = NULL)
}
\arguments{
\item{inSCE}{A \code{\link[SingleCellExperiment]{SingleCellExperiment}}
object containing the output from \code{\link{runFindMarker}} function}

\item{output_file}{name of the generated file. If \code{NULL} then the output
file name will be based on the name of the Rmarkdown template. Default
\code{NULL}.}

\item{output_dir}{name of the output directory to save the rendered file. If
\code{NULL} the file is stored to the current working directory.
Default \code{NULL}.}
}
\value{
An HTML file of the report will be generated at the path specified
in the arguments.
}
\description{
A  function to generate .html Rmarkdown report containing the
visualizations of the \code{\link{runFindMarker}} function output
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runBatchCorrection.R
\name{runSCMerge}
\alias{runSCMerge}
\title{Apply scMerge batch effect correction method to SingleCellExperiment object}
\usage{
runSCMerge(
  inSCE,
  useAssay = "logcounts",
  batch = "batch",
  assayName = "scMerge",
  hvgExprs = "counts",
  seg = NULL,
  kmeansK = NULL,
  cellType = NULL,
  BPPARAM = BiocParallel::SerialParam()
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object}

\item{useAssay}{A single character indicating the name of the assay requiring
batch correction. Default \code{"logcounts"}.}

\item{batch}{A single character indicating a field in
\code{\link{colData}} that annotates the batches.
Default \code{"batch"}.}

\item{assayName}{A single characeter. The name for the corrected assay. Will
be saved to \code{\link{assay}}. Default \code{"scMerge"}.}

\item{hvgExprs}{A single characeter. The assay that to be used for highly
variable genes identification. Default \code{"counts"}.}

\item{seg}{A vector of gene names or indices that specifies SEG (Stably
Expressed Genes) set as negative control. Pre-defined dataset with human and
mouse SEG lists is available with \code{\link[scMerge]{segList}} or
\code{\link[scMerge]{segList_ensemblGeneID}}. Default
\code{NULL}, and this value will be auto-detected by default with
\code{\link[scMerge]{scSEGIndex}}.}

\item{kmeansK}{An integer vector. Indicating the kmeans' K-value for each
batch (i.e. how many subclusters in each batch should exist), in order to
construct pseudo-replicates. The length of \code{kmeansK} needs to be the same
as the number of batches. Default \code{NULL}, and this value will be
auto-detected by default, depending on \code{cellType}.}

\item{cellType}{A single character. A string indicating a field in
\code{colData(inSCE)} that defines different cell types. Default
\code{'cell_type'}.}

\item{BPPARAM}{A \linkS4class{BiocParallelParam} object specifying whether
should be parallelized. Default \code{BiocParallel::SerialParam()}.}
}
\value{
The input \linkS4class{SingleCellExperiment} object with
\code{assay(inSCE, assayName)} updated.
}
\description{
The scMerge method leverages factor analysis, stably expressed genes (SEGs)
and (pseudo-) replicates to remove unwanted variations and merge multiple
scRNA-Seq data.
}
\examples{
data('sceBatches', package = 'singleCellTK')
\dontrun{
logcounts(sceBatches) <- log1p(counts(sceBatches))
sceCorr <- runSCMerge(sceBatches)
}
}
\references{
Hoa, et al., 2020
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scanpyFunctions.R
\name{runScanpyTSNE}
\alias{runScanpyTSNE}
\title{runScanpyTSNE
Computes tSNE from the given sce object and stores the tSNE computations back
into the sce object}
\usage{
runScanpyTSNE(
  inSCE,
  useAssay = NULL,
  useReducedDim = "scanpyPCA",
  reducedDimName = "scanpyTSNE",
  dims = 40,
  perplexity = 30,
  externalReduction = NULL,
  seed = 12345
)
}
\arguments{
\item{inSCE}{(sce) object on which to compute the tSNE}

\item{useAssay}{Specify name of assay to use. Default is \code{NULL}, so
\code{useReducedDim} param will be used instead.}

\item{useReducedDim}{selected reduction method to use for computing tSNE.
Default \code{"scanpyPCA"}.}

\item{reducedDimName}{Name of new reducedDims object containing Scanpy tSNE
Default \code{scanpyTSNE}.}

\item{dims}{Number of reduction components to use for tSNE computation.
Default \code{40}.}

\item{perplexity}{Adjust the perplexity tuneable parameter for the underlying
tSNE call. Default \code{30}.}

\item{externalReduction}{Pass DimReduc object if PCA computed through
other libraries. Default \code{NULL}.}

\item{seed}{Specify numeric value to set as a seed. Default \code{12345}.}
}
\value{
Updated sce object with tSNE computations stored
}
\description{
runScanpyTSNE
Computes tSNE from the given sce object and stores the tSNE computations back
into the sce object
}
\examples{
data(scExample, package = "singleCellTK")
\dontrun{
sce <- runScanpyNormalizeData(sce, useAssay = "counts")
sce <- runScanpyFindHVG(sce, useAssay = "scanpyNormData", method = "seurat")
sce <- runScanpyScaleData(sce, useAssay = "scanpyNormData")
sce <- runScanpyPCA(sce, useAssay = "scanpyScaledData")
sce <- runScanpyFindClusters(sce, useReducedDim = "scanpyPCA")
sce <- runScanpyTSNE(sce, useReducedDim = "scanpyPCA")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runQC.R
\name{runCellQC}
\alias{runCellQC}
\title{Perform comprehensive single cell QC}
\usage{
runCellQC(
  inSCE,
  algorithms = c("QCMetrics", "scDblFinder", "cxds", "bcds", "cxds_bcds_hybrid",
    "decontX", "decontX_bg", "soupX", "soupX_bg"),
  sample = NULL,
  collectionName = NULL,
  geneSetList = NULL,
  geneSetListLocation = "rownames",
  geneSetCollection = NULL,
  mitoRef = "human",
  mitoIDType = "ensembl",
  mitoPrefix = "MT-",
  mitoID = NULL,
  mitoGeneLocation = "rownames",
  useAssay = "counts",
  background = NULL,
  bgAssayName = NULL,
  bgBatch = NULL,
  seed = 12345,
  paramsList = NULL
)
}
\arguments{
\item{inSCE}{A \link[SingleCellExperiment]{SingleCellExperiment} object.}

\item{algorithms}{Character vector. Specify which QC algorithms to run.
Available options are "QCMetrics", "scrublet", "doubletFinder", "scDblFinder", 
"cxds", "bcds", "cxds_bcds_hybrid", "decontX" and "soupX".}

\item{sample}{Character vector. Indicates which sample each cell belongs to.
Algorithms will be run on cells from each sample separately.}

\item{collectionName}{Character. Name of a \code{GeneSetCollection} obtained by 
using one of the importGeneSet* functions. Default \code{NULL}.}

\item{geneSetList}{See \code{runPerCellQC}. Default NULL.}

\item{geneSetListLocation}{See \code{runPerCellQC}. Default NULL.}

\item{geneSetCollection}{See \code{runPerCellQC}. Default NULL.}

\item{mitoRef, mitoIDType, mitoPrefix, mitoID, mitoGeneLocation}{Arguments used to 
import mitochondrial genes and quantify their expression. Please see 
\link[singleCellTK]{runPerCellQC} for detailed information.}

\item{useAssay}{A string specifying which assay contains the count
matrix for cells.}

\item{background}{A \link[SingleCellExperiment]{SingleCellExperiment}
with the matrix located in the assay slot under \code{bgAssayName}. It should have 
the same structure as inSCE except it contains the matrix of empty droplets instead 
of cells. When supplied, empirical distribution of transcripts from these 
empty droplets will be used as the contamination distribution. It is only used in 
algorithms "decontX" and "soupX". Default NULL.}

\item{bgAssayName}{Character. Name of the assay to use if background is a 
\link[SingleCellExperiment]{SingleCellExperiment}. If NULL, the function
will use the same value as \code{useAssay}. It is only used in algorithms 
"decontX" and "soupX". Default is NULL.}

\item{bgBatch}{Batch labels for \code{background}. If \code{background} is a 
\link[SingleCellExperiment]{SingleCellExperiment} object, this can be a single 
character specifying a name that can be found in \code{colData(background)} 
to directly use the barcode annotation Its unique values should be the same
as those in \code{sample}, such that each batch of cells have their corresponding 
batch of empty droplets as background, pointed by this parameter. It is only used in
algorithms "decontX" and "soupX". Default to NULL.}

\item{seed}{Seed for the random number generator. Default 12345.}

\item{paramsList}{A list containing parameters for QC functions. Default NULL.}
}
\value{
SingleCellExperiment object containing the outputs of the
 specified algorithms in the \link{colData}
of \code{inSCE}.
}
\description{
A wrapper function to run several QC algorithms on a
 SingleCellExperiment
 object containing cells after empty droplets have been removed.
}
\examples{
data(scExample, package = "singleCellTK")
sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
\dontrun{
sce <- runCellQC(sce)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/seuratFunctions.R
\name{runSeuratFindClusters}
\alias{runSeuratFindClusters}
\title{runSeuratFindClusters
Computes the clusters from the input sce object and stores them back in sce
object}
\usage{
runSeuratFindClusters(
  inSCE,
  useAssay = "seuratNormData",
  useReduction = c("pca", "ica"),
  dims = 10,
  algorithm = c("louvain", "multilevel", "SLM"),
  groupSingletons = TRUE,
  resolution = 0.8,
  seed = 12345,
  externalReduction = NULL,
  verbose = TRUE
)
}
\arguments{
\item{inSCE}{(sce) object from which clusters should be computed and stored
in}

\item{useAssay}{Assay containing scaled counts to use for clustering.}

\item{useReduction}{Reduction method to use for computing clusters. One of
"pca" or "ica". Default \code{"pca"}.}

\item{dims}{numeric value of how many components to use for computing
clusters. Default \code{10}.}

\item{algorithm}{selected algorithm to compute clusters. One of "louvain",
"multilevel", or "SLM". Use \code{louvain} for "original Louvain algorithm"
and \code{multilevel} for "Louvain algorithm with multilevel refinement".
Default \code{louvain}.}

\item{groupSingletons}{boolean if singletons should be grouped together or
not. Default \code{TRUE}.}

\item{resolution}{Set the resolution parameter to find larger (value above 1)
or smaller (value below 1) number of communities. Default \code{0.8}.}

\item{seed}{Specify the seed value. Default \code{12345}.}

\item{externalReduction}{Pass DimReduc object if PCA/ICA computed through
other libraries. Default \code{NULL}.}

\item{verbose}{Logical value indicating if informative messages should
be displayed. Default is \code{TRUE}.}
}
\value{
Updated sce object which now contains the computed clusters
}
\description{
runSeuratFindClusters
Computes the clusters from the input sce object and stores them back in sce
object
}
\examples{
data(scExample, package = "singleCellTK")
\dontrun{
sce <- runSeuratNormalizeData(sce, useAssay = "counts")
sce <- runSeuratFindHVG(sce, useAssay = "counts")
sce <- runSeuratScaleData(sce, useAssay = "counts")
sce <- runSeuratPCA(sce, useAssay = "counts")
sce <- runSeuratFindClusters(sce, useAssay = "counts")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/importExampleData.R
\name{importExampleData}
\alias{importExampleData}
\title{Retrieve example datasets}
\usage{
importExampleData(
  dataset,
  class = c("Matrix", "matrix"),
  delayedArray = FALSE,
  rowNamesDedup = TRUE
)
}
\arguments{
\item{dataset}{Character. Name of the dataset to retrieve.}

\item{class}{Character. The class of the expression matrix stored in the SCE
object. Can be one of \code{"Matrix"} or \code{"matrix"}. \code{"Matrix"}
will store the data as a sparse matrix from package \link{Matrix} while
\code{"matrix"} will store the data in a standard matrix. Default
\code{"Matrix"}.}

\item{delayedArray}{Boolean. Whether to read the expression matrix as
\link{DelayedArray} object or not. Default \code{FALSE}.}

\item{rowNamesDedup}{Boolean. Whether to deduplicate rownames. Default 
\code{TRUE}.}
}
\value{
The specified \link[SingleCellExperiment]{SingleCellExperiment} object.
}
\description{
Retrieves published example datasets stored in
\link[SingleCellExperiment]{SingleCellExperiment} using the
\link{scRNAseq} and
\link[TENxPBMCData]{TENxPBMCData} packages. See 'Details' for a
list of available datasets.
}
\details{
See the list below for the available datasets and their
descriptions.
\describe{
\item{"fluidigm_pollen"}{Retrieved with
\code{\link{ReprocessedFluidigmData}}. Returns a dataset of 65
 human neural cells from Pollen et al. (2014), each sequenced at high and low
 coverage (SRA accession SRP041736).}
\item{"allen_tasic"}{Retrieved with
\code{\link{ReprocessedAllenData}}. Returns a dataset of 379 mouse
brain cells from Tasic et al. (2016).}
\item{"NestorowaHSCData"}{Retrieved with
\code{\link{NestorowaHSCData}}. Returns a dataset of 1920 mouse  
 haematopoietic stem cells from Nestorowa et al. 2015}
\item{"pbmc3k"}{Retrieved with \code{\link[TENxPBMCData]{TENxPBMCData}}.
 2,700 peripheral blood mononuclear cells (PBMCs) from 10X Genomics.}
\item{"pbmc4k"}{Retrieved with \code{\link[TENxPBMCData]{TENxPBMCData}}.
 4,340 peripheral blood mononuclear cells (PBMCs) from 10X Genomics.}
\item{"pbmc6k"}{Retrieved with \code{\link[TENxPBMCData]{TENxPBMCData}}.
 5,419 peripheral blood mononuclear cells (PBMCs) from 10X Genomics.}
\item{"pbmc8k"}{Retrieved with \code{\link[TENxPBMCData]{TENxPBMCData}}.
 8,381 peripheral blood mononuclear cells (PBMCs) from 10X Genomics.}
\item{"pbmc33k"}{Retrieved with \code{\link[TENxPBMCData]{TENxPBMCData}}.
 33,148 peripheral blood mononuclear cells (PBMCs) from 10X Genomics.}
\item{"pbmc68k"}{Retrieved with \code{\link[TENxPBMCData]{TENxPBMCData}}.
 68,579 peripheral blood mononuclear cells (PBMCs) from 10X Genomics.}
}
}
\examples{
sce <- importExampleData("pbmc3k")
}
\author{
Joshua D. Campbell, David Jenkins
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scanpyFunctions.R
\name{plotScanpyHVG}
\alias{plotScanpyHVG}
\title{plotScanpyHVG}
\usage{
plotScanpyHVG(inSCE, log = FALSE)
}
\arguments{
\item{inSCE}{Input \code{SingleCellExperiment} object.}

\item{log}{Plot on logarithmic axes. Default \code{FALSE}.}
}
\value{
plot object
}
\description{
plotScanpyHVG
}
\examples{
data(scExample, package = "singleCellTK")
\dontrun{
sce <- runScanpyNormalizeData(sce, useAssay = "counts")
sce <- runScanpyFindHVG(sce, useAssay = "scanpyNormData", method = "seurat")
plotScanpyHVG(sce)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/seuratFunctions.R
\name{runSeuratPCA}
\alias{runSeuratPCA}
\title{runSeuratPCA
Computes PCA on the input sce object and stores the calculated principal
components within the sce object}
\usage{
runSeuratPCA(
  inSCE,
  useAssay = "seuratNormData",
  useFeatureSubset = "hvf",
  scale = TRUE,
  reducedDimName = "seuratPCA",
  nPCs = 20,
  seed = 12345,
  verbose = TRUE
)
}
\arguments{
\item{inSCE}{(sce) object on which to compute PCA}

\item{useAssay}{Assay containing scaled counts to use in PCA. Default
\code{"seuratNormData"}.}

\item{useFeatureSubset}{Subset of feature to use for dimension reduction. A
character string indicating a \code{rowData} variable that stores the logical
vector of HVG selection, or a vector that can subset the rows of
\code{inSCE}. Default \code{"hvf"}.}

\item{scale}{Logical scalar, whether to standardize the expression values
using \code{\link[Seurat]{ScaleData}}. Default \code{TRUE}.}

\item{reducedDimName}{Name of new reducedDims object containing Seurat PCA.
Default \code{seuratPCA}.}

\item{nPCs}{numeric value of how many components to compute. Default
\code{20}.}

\item{seed}{Random seed for reproducibility of results.
Default \code{NULL} will use global seed in use by the R environment.}

\item{verbose}{Logical value indicating if informative messages should
be displayed. Default is \code{TRUE}.}
}
\value{
Updated \code{SingleCellExperiment} object which now contains the
computed principal components
}
\description{
runSeuratPCA
Computes PCA on the input sce object and stores the calculated principal
components within the sce object
}
\details{
For features used for computation, it can be controlled by \code{features} or
\code{useFeatureSubset}. When \code{features} is specified, the scaling and
dimensionality reduction will only be processed with these features. When
\code{features} is \code{NULL} but \code{useFeatureSubset} is specified, will
use the features that the HVG list points to. If both parameters are
\code{NULL}, the function will see if any Seurat's variable feature detection
has been ever performed, and use them if found. Otherwise, all features are
used.
}
\examples{
data(scExample, package = "singleCellTK")
\dontrun{
sce <- runSeuratNormalizeData(sce, useAssay = "counts")
sce <- runSeuratFindHVG(sce, useAssay = "counts")
sce <- setTopHVG(sce, method = "vst", featureSubsetName = "hvf")
sce <- runSeuratScaleData(sce, useAssay = "counts")
sce <- runSeuratPCA(sce, useAssay = "counts")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readSingleCellMatrix.R
\name{readSingleCellMatrix}
\alias{readSingleCellMatrix}
\title{Read single cell expression matrix}
\usage{
readSingleCellMatrix(
  file,
  class = c("Matrix", "matrix"),
  delayedArray = TRUE,
  colIndexLocation = NULL,
  rowIndexLocation = NULL
)
}
\arguments{
\item{file}{Path to input file. Supported file endings include .mtx, .txt,
.csv, .tab, .tsv, .npz, and their corresponding \code{gzip},
\code{bzip2}, or \code{xz} compressed extensions (\code{*.gz},
\code{*.bz2}, or \code{*.xz}).}

\item{class}{Character. Class of matrix. One of "Matrix" or "matrix". Specifying "Matrix"
will convert to a sparse format which should be used
for datasets with large numbers of cells.  Default "Matrix".}

\item{delayedArray}{Boolean. Whether to read the expression matrix as
\link{DelayedArray} object or not. Default \code{TRUE}.}

\item{colIndexLocation}{Character. For Optimus output, the path to the
barcode index .npy file. Used only if \code{file} has .npz extension.
Default \code{NULL}.}

\item{rowIndexLocation}{Character. For Optimus output, The path to the
feature (gene) index .npy file. Used only if \code{file} has .npz extension.
Default \code{NULL}.}
}
\value{
A \link{DelayedArray} object or matrix.
}
\description{
Automatically detact the format of the input file and read
 the file.
}
\examples{
mat <- readSingleCellMatrix(system.file("extdata/hgmm_1k_v3_20x20/outs/",
    "filtered_feature_bc_matrix/matrix.mtx.gz", package = "singleCellTK"))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/seuratFunctions.R
\name{runSeuratFindHVG}
\alias{runSeuratFindHVG}
\title{runSeuratFindHVG
Find highly variable genes and store in the input sce object}
\usage{
runSeuratFindHVG(
  inSCE,
  useAssay = "counts",
  method = c("vst", "dispersion", "mean.var.plot"),
  hvgNumber = 2000,
  createFeatureSubset = "hvf",
  altExp = FALSE,
  verbose = TRUE
)
}
\arguments{
\item{inSCE}{(sce) object to compute highly variable genes from and to store
back to it}

\item{useAssay}{Specify the name of the assay to use for computation
of variable genes. It is recommended to use a raw counts assay with the
\code{"vst"} method and normalized assay with all other methods. Default
is \code{"counts"}.}

\item{method}{selected method to use for computation of highly variable
genes. One of \code{'vst'}, \code{'dispersion'}, or \code{'mean.var.plot'}.
Default \code{"vst"} which uses the raw counts. All other methods use
normalized counts.}

\item{hvgNumber}{numeric value of how many genes to select as highly
variable. Default \code{2000}}

\item{createFeatureSubset}{Specify a name of the subset to create
for the identified variable features. Default is \code{"hvf"}.
Leave it \code{NULL} if you do not want to create a subset of
variable features.}

\item{altExp}{Logical value indicating if the input object is an
altExperiment. Default \code{FALSE}.}

\item{verbose}{Logical value indicating if informative messages should
be displayed. Default is \code{TRUE}.}
}
\value{
Updated \code{SingleCellExperiment} object with highly variable genes
computation stored
}
\description{
runSeuratFindHVG
Find highly variable genes and store in the input sce object
}
\examples{
data(scExample, package = "singleCellTK")
sce <- runSeuratFindHVG(sce)
}
\seealso{
\code{\link{runFeatureSelection}}, \code{\link{runModelGeneVar}},
\code{\link{getTopHVG}}, \code{\link{plotTopHVG}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scanpyFunctions.R
\name{plotScanpyEmbedding}
\alias{plotScanpyEmbedding}
\title{plotScanpyEmbedding}
\usage{
plotScanpyEmbedding(
  inSCE,
  reducedDimName,
  useAssay = NULL,
  color = NULL,
  legend = "right margin",
  title = ""
)
}
\arguments{
\item{inSCE}{Input \code{SingleCellExperiment} object.}

\item{reducedDimName}{Name of reducedDims object containing embeddings.
Eg. scanpyUMAP.}

\item{useAssay}{Specify name of assay to use. Default is \code{NULL},
which will use scaled assay by default.}

\item{color}{Keys for annotations of observations/cells or variables/genes.}

\item{legend}{Location of legend, either 'on data', 'right margin' or a 
valid keyword for the loc parameter of Legend.}

\item{title}{Provide title for panels either as string or list of strings}
}
\value{
plot object
}
\description{
plotScanpyEmbedding
}
\examples{
data(scExample, package = "singleCellTK")
\dontrun{
sce <- runScanpyNormalizeData(sce, useAssay = "counts")
sce <- runScanpyFindHVG(sce, useAssay = "scanpyNormData", method = "seurat")
sce <- runScanpyScaleData(sce, useAssay = "scanpyNormData")
sce <- runScanpyPCA(sce, useAssay = "scanpyScaledData")
sce <- runScanpyFindClusters(sce, useReducedDim = "scanpyPCA")
sce <- runScanpyUMAP(sce, useReducedDim = "scanpyPCA")
plotScanpyEmbedding(sce, reducedDimName = "scanpyUMAP", color = 'Scanpy_louvain_1')
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runUMAP.R
\name{runUMAP}
\alias{runUMAP}
\alias{runQuickUMAP}
\alias{getUMAP}
\title{Run UMAP embedding with scater method}
\usage{
runUMAP(
  inSCE,
  useReducedDim = "PCA",
  useAssay = NULL,
  useAltExp = NULL,
  sample = NULL,
  reducedDimName = "UMAP",
  logNorm = TRUE,
  useFeatureSubset = NULL,
  nTop = 2000,
  scale = TRUE,
  pca = TRUE,
  initialDims = 10,
  nNeighbors = 30,
  nIterations = 200,
  alpha = 1,
  minDist = 0.01,
  spread = 1,
  seed = 12345,
  verbose = TRUE,
  BPPARAM = SerialParam()
)

runQuickUMAP(inSCE, useAssay = "counts", sample = "sample", ...)

getUMAP(
  inSCE,
  useReducedDim = "PCA",
  useAssay = NULL,
  useAltExp = NULL,
  sample = NULL,
  reducedDimName = "UMAP",
  logNorm = TRUE,
  useFeatureSubset = NULL,
  nTop = 2000,
  scale = TRUE,
  pca = TRUE,
  initialDims = 25,
  nNeighbors = 30,
  nIterations = 200,
  alpha = 1,
  minDist = 0.01,
  spread = 1,
  seed = 12345,
  BPPARAM = SerialParam()
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object.}

\item{useReducedDim}{The low dimension representation to use for UMAP
computation. If \code{useAltExp} is specified, \code{useReducedDim} has to
exist in \code{reducedDims(altExp(inSCE, useAltExp))}. Default \code{"PCA"}.}

\item{useAssay}{Assay to use for UMAP computation. If \code{useAltExp} is
specified, \code{useAssay} has to exist in
\code{assays(altExp(inSCE, useAltExp))}. Ignored when using
\code{useReducedDim}. Default \code{NULL}.}

\item{useAltExp}{The subset to use for UMAP computation, usually for the
selected variable features. Default \code{NULL}.}

\item{sample}{Character vector. Indicates which sample each cell belongs to.
If given a single character, will take the annotation from \code{colData}.
Default \code{NULL}.}

\item{reducedDimName}{A name to store the results of the UMAP embedding
coordinates obtained from this method. Default \code{"UMAP"}.}

\item{logNorm}{Whether the counts will need to be log-normalized prior to
generating the UMAP via \code{\link{scaterlogNormCounts}}. Ignored when using
\code{useReducedDim}. Default \code{TRUE}.}

\item{useFeatureSubset}{Subset of feature to use for dimension reduction. A
character string indicating a \code{rowData} variable that stores the logical
vector of HVG selection, or a vector that can subset the rows of
\code{inSCE}. Default \code{NULL}.}

\item{nTop}{Automatically detect this number of variable features to use for
dimension reduction. Ignored when using \code{useReducedDim} or using
\code{useFeatureSubset}. Default \code{2000}.}

\item{scale}{Whether \code{useAssay} matrix will need to be standardized.
Default \code{TRUE}.}

\item{pca}{Logical. Whether to perform dimension reduction with PCA before
UMAP. Ignored when using \code{useReducedDim}. Default \code{TRUE}.}

\item{initialDims}{Number of dimensions from PCA to use as input in UMAP.
Default \code{10}.}

\item{nNeighbors}{The size of local neighborhood used for manifold
approximation. Larger values result in more global views of the manifold,
while smaller values result in more local data being preserved. Default
\code{30}. See \code{\link[scater]{calculateUMAP}} for more information.}

\item{nIterations}{The number of iterations performed during layout
optimization. Default is \code{200}.}

\item{alpha}{The initial value of "learning rate" of layout optimization.
Default is \code{1}.}

\item{minDist}{The effective minimum distance between embedded points.
Smaller values will result in a more clustered/clumped embedding where nearby
points on the manifold are drawn closer together, while larger values will
result on a more even dispersal of points. Default \code{0.01}. See
\code{\link[scater]{calculateUMAP}} for more information.}

\item{spread}{The effective scale of embedded points. In combination with
\code{minDist}, this determines how clustered/clumped the embedded points
are. Default \code{1}. See \code{\link[scater]{calculateUMAP}} for more
information.}

\item{seed}{Random seed for reproducibility of UMAP results.
Default \code{NULL} will use global seed in use by the R environment.}

\item{verbose}{Logical. Whether to print log messages. Default \code{TRUE}.}

\item{BPPARAM}{A \linkS4class{BiocParallelParam} object specifying whether
the PCA should be parallelized.}

\item{...}{Parameters passed to \code{runUMAP}}
}
\value{
A \linkS4class{SingleCellExperiment} object with UMAP computation
updated in \code{reducedDim(inSCE, reducedDimName)}.
}
\description{
Uniform Manifold Approximation and Projection (UMAP) algorithm
is commonly for 2D visualization of single-cell data. These functions wrap 
the scater \code{\link[scater]{calculateUMAP}} function.

Users can use \code{runQuickUMAP} to directly create UMAP embedding from raw
count matrix, with necessary preprocessing including normalization, variable
feature selection, scaling, dimension reduction all automated. Therefore, 
\code{useReducedDim} is disabled for \code{runQuickUMAP}. 

In a complete analysis, we still recommend having dimension reduction such as
PCA created beforehand and select proper numbers of dimensions for using
\code{runUMAP}, so that the result can match with the clustering based on the
same input PCA.
}
\examples{
data(scExample, package = "singleCellTK")
sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
# Run from raw counts
sce <- runQuickUMAP(sce)
plotDimRed(sce, "UMAP")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/seuratFunctions.R
\name{plotSeuratHVG}
\alias{plotSeuratHVG}
\title{plotSeuratHVG
Plot highly variable genes from input sce object (must have highly variable
genes computations stored)}
\usage{
plotSeuratHVG(inSCE, labelPoints = 0)
}
\arguments{
\item{inSCE}{(sce) object that contains the highly variable genes
computations}

\item{labelPoints}{Numeric value indicating the number of top genes that
should be labeled.
 Default is \code{0}, which will not label any point.}
}
\value{
plot object
}
\description{
plotSeuratHVG
Plot highly variable genes from input sce object (must have highly variable
genes computations stored)
}
\examples{
data(scExample, package = "singleCellTK")
\dontrun{
sce <- runSeuratNormalizeData(sce, useAssay = "counts")
sce <- runSeuratFindHVG(sce, useAssay = "counts")
plotSeuratHVG(sce)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scanpyFunctions.R
\name{runScanpyFindMarkers}
\alias{runScanpyFindMarkers}
\title{runScanpyFindMarkers}
\usage{
runScanpyFindMarkers(
  inSCE,
  nGenes = NULL,
  useAssay = "scanpyNormData",
  colDataName,
  group1 = "all",
  group2 = "rest",
  test = c("wilcoxon", "t-test", "t-test_overestim_var", "logreg"),
  corr_method = c("benjamini-hochberg", "bonferroni")
)
}
\arguments{
\item{inSCE}{Input \code{SingleCellExperiment} object.}

\item{nGenes}{The number of genes that appear in the returned tables. 
Defaults to all genes.}

\item{useAssay}{Specify the name of the assay to use for computation
of marker genes. It is recommended to use log normalized assay.}

\item{colDataName}{colData to use as the key of the observations grouping to 
consider.}

\item{group1}{Name of group1. Subset of groups, to which comparison shall be 
restricted, or 'all' (default), for all groups.}

\item{group2}{Name of group2. If 'rest', compare each group to the union of 
the rest of the group. If a group identifier, compare with respect to this 
group. Default is 'rest'}

\item{test}{Test to use for DE. Default \code{"t-test"}.}

\item{corr_method}{p-value correction method. Used only for 't-test', 
't-test_overestim_var', and 'wilcoxon'.}
}
\value{
A \code{SingleCellExperiment} object that contains marker genes
populated in a data.frame stored inside metadata slot.
}
\description{
runScanpyFindMarkers
}
\examples{
data(scExample, package = "singleCellTK")
\dontrun{
sce <- runScanpyNormalizeData(sce, useAssay = "counts")
sce <- runScanpyFindHVG(sce, useAssay = "scanpyNormData", method = "seurat")
sce <- runScanpyScaleData(sce, useAssay = "scanpyNormData")
sce <- runScanpyPCA(sce, useAssay = "scanpyScaledData")
sce <- runScanpyFindClusters(sce, useReducedDim = "scanpyPCA")
sce <- runScanpyFindMarkers(sce, colDataName = "Scanpy_louvain_1" )
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scds_doubletdetection.R
\name{runCxds}
\alias{runCxds}
\title{Find doublets/multiplets using \link[scds]{cxds}.}
\usage{
runCxds(
  inSCE,
  sample = NULL,
  seed = 12345,
  ntop = 500,
  binThresh = 0,
  verb = FALSE,
  retRes = FALSE,
  estNdbl = FALSE,
  useAssay = "counts"
)
}
\arguments{
\item{inSCE}{A \linkS4class{SingleCellExperiment} object.}

\item{sample}{Character vector or colData variable name. Indicates which 
sample each cell belongs to. Default \code{NULL}.}

\item{seed}{Seed for the random number generator, can be \code{NULL}. Default
\code{12345}.}

\item{ntop}{See \link[scds]{cxds} for more information. Default \code{500}.}

\item{binThresh}{See \link[scds]{cxds} for more information. Default 
\code{0}.}

\item{verb}{See \link[scds]{cxds} for more information. Default \code{FALSE}.}

\item{retRes}{See \link[scds]{cxds} for more information. Default 
\code{FALSE}.}

\item{estNdbl}{See \link[scds]{cxds} for more information. Default 
\code{FALSE}.}

\item{useAssay}{A string specifying which assay in the SCE to use. Default 
\code{"counts"}}
}
\value{
A \linkS4class{SingleCellExperiment} object with \link[scds]{cxds} 
output appended to the \link{colData} slot. The columns include 
\emph{cxds_score} and optionally \emph{cxds_call}.
}
\description{
A wrapper function for \link[scds]{cxds}. Annotate
doublets/multiplets using co-expression based approach. Generate a doublet
score for each cell. Infer doublets if \code{estNdbl} is \code{TRUE}.
}
\details{
When the argument \code{sample} is specified, \link[scds]{cxds} will
be run on cells from each sample separately. If \code{sample = NULL}, then 
all cells will be processed together.
}
\examples{
data(scExample, package = "singleCellTK")
sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
sce <- runCxds(sce)
}
\seealso{
\code{\link[scds]{cxds}}, \code{\link{plotCxdsResults}}, 
\code{\link{runCellQC}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getTopHVG.R
\name{getTopHVG}
\alias{getTopHVG}
\alias{setTopHVG}
\title{Get or set top HVG after calculation}
\usage{
getTopHVG(
  inSCE,
  method = c("vst", "dispersion", "mean.var.plot", "modelGeneVar", "seurat", "seurat_v3",
    "cell_ranger"),
  hvgNumber = 2000,
  useFeatureSubset = "hvf",
  featureDisplay = metadata(inSCE)$featureDisplay
)

setTopHVG(
  inSCE,
  method = c("vst", "dispersion", "mean.var.plot", "modelGeneVar", "seurat", "seurat_v3",
    "cell_ranger"),
  hvgNumber = 2000,
  featureSubsetName = "hvg2000",
  genes = NULL,
  genesBy = NULL,
  altExp = FALSE
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object}

\item{method}{Specify which method to use for variable gene extraction
from Seurat \code{"vst"}, \code{"mean.var.plot"}, \code{"dispersion"} or
Scran \code{"modelGeneVar"} or Scanpy \code{"seurat"}, \code{"cell_ranger"}, 
\code{"seurat_v3"}. Default \code{"vst"}}

\item{hvgNumber}{Specify the number of top variable genes to extract.}

\item{useFeatureSubset}{Get the feature names in the HVG list set by
\code{setTopHVG}. \code{method} and \code{hvgNumber} will not be used if not
this is not \code{NULL}. Default \code{"hvf"}.}

\item{featureDisplay}{A character string for the \code{rowData} variable name
to indicate what type of feature ID should be displayed. If set by
\code{\link{setSCTKDisplayRow}}, will by default use it. If \code{NULL}, will
use \code{rownames(inSCE)}.}

\item{featureSubsetName}{A character string for the \code{rowData} variable
name to store a logical index of selected features. Default \code{"hvg2000"}.}

\item{genes}{A customized character vector of gene list to be set as a
\code{rowData} variable. Will ignore \code{method} and \code{hvgNumber} if
set. Default \code{NULL}.}

\item{genesBy}{If setting customized \code{genes}, where should it be found
in \code{rowData}? Leave \code{NULL} for matching \code{rownames}. Default
\code{NULL}.}

\item{altExp}{\code{TRUE} for also creating a subset \code{inSCE} object with
the selected HVGs and store this subset in the \code{altExps} slot, named by
\code{hvgListName}. Default \code{FALSE}.}
}
\value{
\item{getTopHVG}{A character vector of the top \code{hvgNumber} variable
feature names}
\item{setTopHVG}{The input \code{inSCE} object with the logical vector of
HVG selection updated in \code{rowData}, and related parameter updated in
\code{metadata}. If \code{altExp} is \code{TRUE}, an \code{altExp} is also
added}
}
\description{
Extracts or select the top variable genes from an input
\linkS4class{SingleCellExperiment} object. Note that the variability metrics
must be computed using the \code{runFeatureSelection} method before
extracting the feature names of the top variable features. \code{getTopHVG}
only returns a character vector of the HVG selection, while with
\code{setTopHVG}, a logical vector of the selection will be saved in the
\code{rowData}, and optionally, a subset object for the HVGs can be stored
in the \code{altExps} slot at the same time.
}
\examples{
data("scExample", package = "singleCellTK")

# Create a "highy variable feature" subset using Seurat's vst method:
sce <- runSeuratFindHVG(sce,  method = "vst", hvgNumber = 2000,
       createFeatureSubset = "hvf")
       
# Get the list of genes for a feature subset:
hvgs <- getTopHVG(sce, useFeatureSubset = "hvf")

# Create a new feature subset on the fly without rerunning the algorithm:
sce <- setTopHVG(sce, method = "vst", hvgNumber = 100,
                featureSubsetName = "hvf100")
hvgs <- getTopHVG(sce, useFeatureSubset = "hvf100")

# Get a list of variable features without creating a new feature subset:
hvgs <- getTopHVG(sce, useFeatureSubset = NULL,
                  method = "vst", hvgNumber = 10)

}
\seealso{
\code{\link{runFeatureSelection}}, \code{\link{runSeuratFindHVG}},
\code{\link{runModelGeneVar}}, \code{\link{plotTopHVG}}
}
\author{
Irzam Sarfraz, Yichen Wang
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/miscFunctions.R
\name{setRowNames}
\alias{setRowNames}
\title{Set rownames of SCE with a character vector or a rowData column}
\usage{
setRowNames(x, rowNames, dedup = TRUE)
}
\arguments{
\item{x}{Input object where the rownames will be modified.}

\item{rowNames}{Character vector of the rownames. If \code{x} is an
\linkS4class{SingleCellExperiment} object, a single character specifying a
column in \code{rowData(x)}.}

\item{dedup}{Logical. Whether to deduplicate the specified rowNames. Default
\code{TRUE}}
}
\value{
The input SCE object with rownames updated.
}
\description{
Users can set rownames of an SCE object with either a character
vector where the length equals to \code{nrow(x)}, or a single character
specifying a column in \code{rowData(x)}. Also applicable to matrix like
object where \code{rownames<-} method works, but only allows full size name
vector. Users can set \code{dedup = TRUE} to remove duplicated entries in the
specification, by adding \code{-1, -2, ..., -i} suffix to the duplication of
the same identifier.
}
\examples{
data("scExample", package = "singleCellTK")
head(rownames(sce))
sce <- setRowNames(sce, "feature_name")
head(rownames(sce))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/computeHeatmap.R
\name{computeHeatmap}
\alias{computeHeatmap}
\title{Computes heatmap for a set of features against dimensionality reduction 
components}
\usage{
computeHeatmap(
  inSCE,
  useAssay,
  dims = 10,
  nfeatures = 30,
  cells = NULL,
  reduction = "pca",
  disp.min = -2.5,
  disp.max = 2.5,
  balanced = TRUE,
  nCol = NULL,
  externalReduction = NULL
)
}
\arguments{
\item{inSCE}{Input \code{SingleCellExperiment} object.}

\item{useAssay}{Specify the name of the assay that will be scaled
by this function for the features that are used in the heatmap.}

\item{dims}{Specify the number of dimensions to use for heatmap. Default
\code{10}.}

\item{nfeatures}{Specify the number of features to use for heatmap. Default
is \code{30}.}

\item{cells}{Specify the samples/cells to use for heatmap computation.
Default is \code{NULL} which will utilize all samples in the assay.}

\item{reduction}{Specify the reduction slot in the input object. Default
is \code{"pca"}.}

\item{disp.min}{Specify the minimum dispersion value to use for floor
clipping of assay values. Default is \code{-2.5}.}

\item{disp.max}{Specify the maximum dispersion value to use for ceiling
clipping of assay values. Default is \code{2.5}.}

\item{balanced}{Specify if the number of of up-regulated and down-regulated
features should be balanced. Default is \code{TRUE}.}

\item{nCol}{Specify the number of columns in the output plot. Default
is \code{NULL} which will auto-compute the number of columns.}

\item{externalReduction}{Specify an external reduction if not present in
the input object. This external reduction should be created
using \code{CreateDimReducObject} function.}
}
\value{
Heatmap plot object.
}
\description{
The computeHeatmap method computes the heatmap visualization for a set
 of features against a set of dimensionality reduction components. This
 method uses the heatmap computation algorithm code from \code{Seurat} but
 plots the heatmap using \code{ComplexHeatmap} and \code{cowplot} libraries.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/seuratFunctions.R
\name{runSeuratJackStraw}
\alias{runSeuratJackStraw}
\title{runSeuratJackStraw
Compute jackstraw plot and store the computations in the input sce object}
\usage{
runSeuratJackStraw(
  inSCE,
  useAssay,
  dims = NULL,
  numReplicate = 100,
  propFreq = 0.025,
  externalReduction = NULL
)
}
\arguments{
\item{inSCE}{(sce) object on which to compute and store jackstraw plot}

\item{useAssay}{Specify name of the assay to use for scaling. Assay name
provided against this parameter is scaled by the function and used
for the computation of JackStraw scores along with the reduced dimensions
specified by the \code{dims} parameter.}

\item{dims}{Number of components to test in Jackstraw. If \code{NULL}, then
all components are used. Default \code{NULL}.}

\item{numReplicate}{Numeric value indicating the number of replicate
samplings to perform.
 Default value is \code{100}.}

\item{propFreq}{Numeric value indicating the proportion of data to randomly
permute for each replicate.
 Default value is \code{0.025}.}

\item{externalReduction}{Pass DimReduc object if PCA/ICA computed through
other libraries. Default \code{NULL}.}
}
\value{
Updated \code{SingleCellExperiment} object with jackstraw
computations stored in it
}
\description{
runSeuratJackStraw
Compute jackstraw plot and store the computations in the input sce object
}
\examples{
data(scExample, package = "singleCellTK")
\dontrun{
sce <- runSeuratNormalizeData(sce, useAssay = "counts")
sce <- runSeuratFindHVG(sce, useAssay = "counts")
sce <- runSeuratScaleData(sce, useAssay = "counts")
sce <- runSeuratPCA(sce, useAssay = "counts")
sce <- runSeuratJackStraw(sce, useAssay = "counts")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sctkTagging.R
\name{expDataNames,ANY-method}
\alias{expDataNames,ANY-method}
\title{expDataNames
Get names of all the data items in the input \code{SingleCellExperiment} object including assays, altExps and reducedDims.}
\usage{
\S4method{expDataNames}{ANY}(inSCE)
}
\arguments{
\item{inSCE}{Input \code{SingleCellExperiment} object.}
}
\value{
A combined \code{vector} of \code{assayNames}, \code{altExpNames} and \code{reducedDimNames}.
}
\description{
expDataNames
Get names of all the data items in the input \code{SingleCellExperiment} object including assays, altExps and reducedDims.
}
\examples{
data(scExample, package = "singleCellTK")
expDataNames(sce)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runTSCAN.R
\name{plotTSCANPseudotimeHeatmap}
\alias{plotTSCANPseudotimeHeatmap}
\title{Plot heatmap of genes with expression change along TSCAN pseudotime}
\usage{
plotTSCANPseudotimeHeatmap(
  inSCE,
  pathIndex,
  direction = c("both", "increasing", "decreasing"),
  topN = 50,
  log2fcThreshold = NULL,
  useAssay = NULL,
  featureDisplay = metadata(inSCE)$featureDisplay
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object.}

\item{pathIndex}{Path index for which the pseudotime values should be used.
Should have being used in \code{\link{runTSCANDEG}}.}

\item{direction}{Should we show features with expression increasing or
decreeasing along the increase in TSCAN pseudotime? Choices are
\code{"both"}, \code{"increasing"} or \code{"decreasing"}.}

\item{topN}{An integer. Only to plot this number of top genes along the path
in the MST, in terms of FDR value. Use \code{NULL} to cancel the top N
subscription. Default \code{30}.}

\item{log2fcThreshold}{Only output DEGs with the absolute values of log2FC
larger than this value. Default \code{NULL}.}

\item{useAssay}{A single character to specify a feature expression matrix in
\code{assays} slot. The expression of top features from here will be
visualized. Default \code{NULL} use the one used for
\code{\link{runTSCANDEG}}.}

\item{featureDisplay}{Whether to display feature ID and what ID type to
display. Users can set default ID type by \code{\link{setSCTKDisplayRow}}.
\code{NULL} will display when number of features to display is less than 60.
\code{FALSE} for no display. Variable name in \code{rowData} to indicate ID
type. \code{"rownames"} or \code{TRUE} for using \code{rownames(inSCE)}.}
}
\value{
A ComplexHeatmap in \code{.ggplot} class
}
\description{
A wrapper function which visualizes outputs from the
\code{\link{runTSCANDEG}} function. Plots the top genes that change in
expression with increasing pseudotime along the path in the MST.
\code{\link{runTSCANDEG}} has to be run in advance with using the same
\code{pathIndex} of interest.
}
\examples{
data("mouseBrainSubsetSCE", package = "singleCellTK")
mouseBrainSubsetSCE <- runTSCAN(inSCE = mouseBrainSubsetSCE,
                                useReducedDim = "PCA_logcounts")
terminalNodes <- listTSCANTerminalNodes(mouseBrainSubsetSCE)
mouseBrainSubsetSCE <- runTSCANDEG(inSCE = mouseBrainSubsetSCE,
                                   pathIndex = terminalNodes[1])
plotTSCANPseudotimeHeatmap(mouseBrainSubsetSCE,
                           pathIndex = terminalNodes[1])
}
\author{
Nida Pervaiz
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runBatchCorrection.R
\name{runHarmony}
\alias{runHarmony}
\title{Apply Harmony batch effect correction method to SingleCellExperiment object}
\usage{
runHarmony(
  inSCE,
  useAssay = NULL,
  useReducedDim = NULL,
  batch = "batch",
  reducedDimName = "HARMONY",
  nComponents = 50,
  lambda = 0.1,
  theta = 5,
  sigma = 0.1,
  nIter = 10,
  seed = 12345,
  verbose = TRUE,
  ...
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object}

\item{useAssay}{A single character indicating the name of the assay requiring
batch correction. Default \code{NULL}. It is recommended to use a reducedDim
such as PCA through the `useReducedDim` parameter of this function.}

\item{useReducedDim}{A single character indicating the name of the reducedDim
to be used. It is recommended to use a reducedDim instead of a full assay as 
using an assay might cause the algorithm to not converge and throw error.
Specifying this will ignore \code{useAssay}. Default
\code{NULL}.}

\item{batch}{A single character indicating a field in \code{colData} that
annotates the batches of each cell; or a vector/factor with the same length
as the number of cells. Default \code{"batch"}.}

\item{reducedDimName}{A single character. The name for the corrected
low-dimensional representation. Will be saved to \code{reducedDim(inSCE)}.
Default \code{"HARMONY"}.}

\item{nComponents}{An integer. The number of PCs to use and generate.
Default \code{50L}.}

\item{lambda}{A Numeric scalar. Ridge regression penalty parameter. Must be
strictly positive. Smaller values result in more aggressive correction.
Default \code{0.1}.}

\item{theta}{A Numeric scalar. Diversity clustering penalty parameter. Larger
values of theta result in more diverse clusters. theta=0 does not encourage
any diversity. Default \code{5}.}

\item{sigma}{A Numeric scalar. Width of soft kmeans clusters. Larger values
of sigma result in cells assigned to more clusters. Smaller values of sigma
make soft kmeans cluster approach hard clustering. Default \code{0.1}.}

\item{nIter}{An integer. The max number of iterations to perform. Default
\code{10L}.}

\item{seed}{Set seed for reproducibility. Default is \code{12345}.}

\item{verbose}{Whether to print progress messages. Default \code{TRUE}.}

\item{...}{Other arguments passed to \code{\link[harmony]{HarmonyMatrix}}.
See details.}
}
\value{
The input \linkS4class{SingleCellExperiment} object with
\code{reducedDim(inSCE, reducedDimName)} updated.
}
\description{
Harmony is an algorithm that projects cells into a shared
embedding in which cells group by cell type rather than dataset-specific
conditions.
}
\details{
Since some of the arguments of \code{\link[harmony]{HarmonyMatrix}}
is controlled by this wrapper function. The additional arguments users can
work with only include: \code{nclust}, \code{tau}, \code{block.size},
\code{max.iter.cluster}, \code{epsilon.cluster}, \code{epsilon.harmony},
\code{plot_convergence}, \code{reference_values} and \code{cluster_prior}.
}
\examples{
data('sceBatches', package = 'singleCellTK')
logcounts(sceBatches) <- log1p(counts(sceBatches))
\dontrun{
if (require("harmony"))
    sceCorr <- runHarmony(sceBatches)
}
}
\references{
Ilya Korsunsky, et al., 2019
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/seuratFunctions.R
\name{plotSeuratElbow}
\alias{plotSeuratElbow}
\title{plotSeuratElbow
Computes the plot object for elbow plot from the pca slot in the input sce
object}
\usage{
plotSeuratElbow(
  inSCE,
  significantPC = NULL,
  reduction = "pca",
  ndims = 20,
  externalReduction = NULL,
  interactive = FALSE
)
}
\arguments{
\item{inSCE}{(sce) object from which to compute the elbow plot (pca should
be computed)}

\item{significantPC}{Number of significant principal components to plot.
This is used to alter the color of the points for the corresponding PCs.
If \code{NULL}, all points will be the same color. Default \code{NULL}.}

\item{reduction}{Reduction to use for elbow plot generation. Either
\code{"pca"} or \code{"ica"}. Default \code{"pca"}.}

\item{ndims}{Number of components to use. Default \code{20}.}

\item{externalReduction}{Pass DimReduc object if PCA/ICA computed through
other libraries. Default \code{NULL}.}

\item{interactive}{Logical value indicating if the returned object should
be an interactive plotly object if \code{TRUE} or a ggplot object if
set to \code{FALSE}. Default is \code{FALSE}.}
}
\value{
plot object
}
\description{
plotSeuratElbow
Computes the plot object for elbow plot from the pca slot in the input sce
object
}
\examples{
data(scExample, package = "singleCellTK")
\dontrun{
sce <- runSeuratNormalizeData(sce, useAssay = "counts")
sce <- runSeuratFindHVG(sce, useAssay = "counts")
sce <- runSeuratScaleData(sce, useAssay = "counts")
sce <- runSeuratPCA(sce, useAssay = "counts")
plotSeuratElbow(sce)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ggPlotting.R
\name{plotSCEViolinColData}
\alias{plotSCEViolinColData}
\title{Violin plot of colData.}
\usage{
plotSCEViolinColData(
  inSCE,
  coldata,
  sample = NULL,
  groupBy = NULL,
  violin = TRUE,
  boxplot = TRUE,
  dots = TRUE,
  plotOrder = NULL,
  xlab = NULL,
  ylab = NULL,
  baseSize = 12,
  axisSize = NULL,
  axisLabelSize = NULL,
  dotSize = 0.1,
  transparency = 1,
  defaultTheme = TRUE,
  gridLine = FALSE,
  summary = NULL,
  summaryTextSize = 3,
  title = NULL,
  titleSize = NULL,
  hcutoff = NULL,
  hcolor = "red",
  hsize = 1,
  hlinetype = 1,
  vcutoff = NULL,
  vcolor = "red",
  vsize = 1,
  vlinetype = 1,
  combinePlot = "none",
  plotLabels = NULL
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object with saved
dimension reduction components or a variable with saved results. Required.}

\item{coldata}{colData value that will be plotted.}

\item{sample}{Character vector. Indicates which sample each cell belongs to.}

\item{groupBy}{Groupings for each numeric value. A user may input a vector
equal length to the number of the samples in the SingleCellExperiment
object, or can be retrieved from the colData slot. Default NULL.}

\item{violin}{Boolean. If TRUE, will plot the violin plot. Default TRUE.}

\item{boxplot}{Boolean. If TRUE, will plot boxplots for each violin plot.
Default TRUE.}

\item{dots}{Boolean. If TRUE, will plot dots for each violin plot.
Default TRUE.}

\item{plotOrder}{Character vector. If set, reorders the violin plots
in the order of the character vector when `groupBy` is set.
Default NULL.}

\item{xlab}{Character vector. Label for x-axis. Default NULL.}

\item{ylab}{Character vector. Label for y-axis. Default NULL.}

\item{baseSize}{The base font size for all text. Default 12.
Can be overwritten by titleSize, axisSize, and axisLabelSize.}

\item{axisSize}{Size of x/y-axis ticks. Default NULL.}

\item{axisLabelSize}{Size of x/y-axis labels. Default NULL.}

\item{dotSize}{Size of dots. Default 0.1.}

\item{transparency}{Transparency of the dots, values will be 0-1. Default 1.}

\item{defaultTheme}{Removes grid in plot and sets axis title size to 10
when TRUE. Default TRUE.}

\item{gridLine}{Adds a horizontal grid line if TRUE. Will still be
drawn even if defaultTheme is TRUE. Default FALSE.}

\item{summary}{Adds a summary statistic, as well as a crossbar to the
violin plot. Options are "mean" or "median". Default NULL.}

\item{summaryTextSize}{The text size of the summary statistic displayed
above the violin plot. Default 3.}

\item{title}{Title of plot. Default NULL.}

\item{titleSize}{Size of title of plot. Default 15.}

\item{hcutoff}{Adds a horizontal line with the y-intercept at given value. Default NULL.}

\item{hcolor}{Character. A color available from `colors()`.
Controls the color of the horizontal cutoff line, if drawn.
Default 'black'.}

\item{hsize}{Size of horizontal line, if drawn. Default 0.5.}

\item{hlinetype}{Type of horizontal line, if drawn. can be specified with either an integer or
a name (0 = blank, 1 = solid, 2 = dashed, 3 = dotted, 4 = dotdash, 5 = longdash, 6 = twodash).
Default 1.}

\item{vcutoff}{Adds a vertical line with the x-intercept at given value. Default NULL.}

\item{vcolor}{Character. A color available from `colors()`.
Controls the color of the vertical cutoff line, if drawn.
Default 'black'.}

\item{vsize}{Size of vertical line, if drawn. Default 0.5.}

\item{vlinetype}{Type of vertical line, if drawn. can be specified with either an integer or
a name (0 = blank, 1 = solid, 2 = dashed, 3 = dotted, 4 = dotdash, 5 = longdash, 6 = twodash).
Default 1.}

\item{combinePlot}{Must be either "all", "sample", or "none". "all" will combine all plots into a single
.ggplot object, while "sample" will output a list of plots separated by sample. Default "none".}

\item{plotLabels}{labels to each plot. If set to "default", will use the name of the samples
as the labels. If set to "none", no label will be plotted.}
}
\value{
a ggplot of the violin plot of coldata.
}
\description{
Visualizes values stored in the colData slot of a
 SingleCellExperiment object via a violin plot.
}
\examples{
data("mouseBrainSubsetSCE")
plotSCEViolinColData(
  inSCE = mouseBrainSubsetSCE,
  coldata = "age", groupBy = "sex"
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/htmlReports.R
\name{reportDiffExp}
\alias{reportDiffExp}
\title{Get runDEAnalysis .html report}
\usage{
reportDiffExp(
  inSCE,
  study,
  useReducedDim,
  featureDisplay = NULL,
  output_file = NULL,
  output_dir = NULL
)
}
\arguments{
\item{inSCE}{A \code{\link[SingleCellExperiment]{SingleCellExperiment}}
object containing the output from \code{\link{runDEAnalysis}} function}

\item{study}{The specific analysis to visualize, used as \code{analysisName}
argument when running differential expression.}

\item{useReducedDim}{Specify an embedding for visualizing the relation ship
between the conditions.}

\item{featureDisplay}{The feature ID type to use for displaying. Should
exists as a variable name of \code{rowData}. Default \code{NULL} use rownames
of \code{inSCE}.}

\item{output_file}{name of the generated file. If \code{NULL} then the output
file name will be based on the name of the Rmarkdown template. Default
\code{NULL}.}

\item{output_dir}{name of the output directory to save the rendered file. If
\code{NULL} the file is stored to the current working directory.
Default \code{NULL}.}
}
\value{
Saves the HTML report in the specified output directory.
}
\description{
A  function to generate .html Rmarkdown report containing the
visualizations of the \code{\link{runDEAnalysis}} function output
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runBatchCorrection.R
\name{runFastMNN}
\alias{runFastMNN}
\title{Apply a fast version of the mutual nearest neighbors (MNN) batch effect
correction method to SingleCellExperiment object}
\usage{
runFastMNN(
  inSCE,
  useAssay = "logcounts",
  useReducedDim = NULL,
  batch = "batch",
  reducedDimName = "fastMNN",
  k = 20,
  propK = NULL,
  ndist = 3,
  minBatchSkip = 0,
  cosNorm = TRUE,
  nComponents = 50,
  weights = NULL,
  BPPARAM = BiocParallel::SerialParam()
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object}

\item{useAssay}{A single character indicating the name of the assay requiring
batch correction. Default \code{"logcounts"}.}

\item{useReducedDim}{A single character indicating the dimension reduction
used for batch correction. Will ignore \code{useAssay} when using.
Default \code{NULL}.}

\item{batch}{A single character indicating a field in \code{colData} that
annotates the batches of each cell; or a vector/factor with the same length
as the number of cells. Default \code{"batch"}.}

\item{reducedDimName}{A single character. The name for the corrected
low-dimensional representation. Default \code{"fastMNN"}.}

\item{k}{An integer scalar specifying the number of nearest neighbors to
consider when identifying MNNs. See "See Also". Default \code{20}.}

\item{propK}{A numeric scalar in (0, 1) specifying the proportion of cells in
each dataset to use for mutual nearest neighbor searching. See "See Also".
Default \code{NULL}.}

\item{ndist}{A numeric scalar specifying the threshold beyond which
neighbours are to be ignored when computing correction vectors. See "See
Also". Default \code{3}.}

\item{minBatchSkip}{Numeric scalar specifying the minimum relative magnitude
of the batch effect, below which no correction will be performed at a given
merge step. See "See Also". Default \code{0}.}

\item{cosNorm}{A logical scalar indicating whether cosine normalization
should be performed on \code{useAssay} prior to PCA. See "See Also". Default
\code{TRUE}.}

\item{nComponents}{An integer scalar specifying the number of dimensions to
produce. See "See Also". Default \code{50}.}

\item{weights}{The weighting scheme to use. Passed to
\code{\link[batchelor]{multiBatchPCA}}. Default \code{NULL}.}

\item{BPPARAM}{A \linkS4class{BiocParallelParam} object specifying whether
the SVD should be parallelized.}
}
\value{
The input \linkS4class{SingleCellExperiment} object with
\code{reducedDim(inSCE, reducedDimName)} updated.
}
\description{
fastMNN is a variant of the classic MNN method, modified for speed and more
robust performance. For introduction of MNN, see \code{\link{runMNNCorrect}}.
}
\examples{
data('sceBatches', package = 'singleCellTK')
logcounts(sceBatches) <- log1p(counts(sceBatches))
sceCorr <- runFastMNN(sceBatches, useAssay = 'logcounts')
}
\references{
Lun ATL, et al., 2016
}
\seealso{
\code{\link[batchelor]{fastMNN}} for using \code{useAssay}, and
\code{\link[batchelor]{reducedMNN}} for using \code{useReducedDim}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runBatchCorrection.R
\name{runMNNCorrect}
\alias{runMNNCorrect}
\title{Apply the mutual nearest neighbors (MNN) batch effect correction method to
SingleCellExperiment object}
\usage{
runMNNCorrect(
  inSCE,
  useAssay = "logcounts",
  batch = "batch",
  assayName = "MNN",
  k = 20L,
  propK = NULL,
  sigma = 0.1,
  cosNormIn = TRUE,
  cosNormOut = TRUE,
  varAdj = TRUE,
  BPPARAM = BiocParallel::SerialParam()
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object}

\item{useAssay}{A single character indicating the name of the assay requiring
batch correction. Default \code{"logcounts"}.}

\item{batch}{A single character indicating a field in \code{colData} that
annotates the batches of each cell; or a vector/factor with the same length
as the number of cells. Default \code{"batch"}.}

\item{assayName}{A single characeter. The name for the corrected assay. Will
be saved to \code{\link{assay}}. Default
\code{"MNN"}.}

\item{k}{An integer scalar specifying the number of nearest neighbors to
consider when identifying MNNs. See "See Also". Default \code{20}.}

\item{propK}{A numeric scalar in (0, 1) specifying the proportion of cells in
each dataset to use for mutual nearest neighbor searching. See "See Also".
Default \code{NULL}.}

\item{sigma}{A numeric scalar specifying the bandwidth of the Gaussian
smoothing kernel used to compute the correction vector for each cell. See
"See Also". Default \code{0.1}.}

\item{cosNormIn}{A logical scalar indicating whether cosine normalization
should be performed on the input data prior to calculating distances between
cells. See "See Also". Default \code{TRUE}.}

\item{cosNormOut}{A logical scalar indicating whether cosine normalization
should be performed prior to computing corrected expression values. See "See
Also". Default \code{TRUE}.}

\item{varAdj}{A logical scalar indicating whether variance adjustment should
be performed on the correction vectors. See "See Also". Default \code{TRUE}.}

\item{BPPARAM}{A \linkS4class{BiocParallelParam} object specifying whether
the PCA and nearest-neighbor searches should be parallelized.}
}
\value{
The input \linkS4class{SingleCellExperiment} object with
\code{assay(inSCE, assayName)} updated.
}
\description{
MNN is designed for batch correction of single-cell RNA-seq data where the
batches are partially confounded with biological conditions of interest. It
does so by identifying pairs of MNN in the high-dimensional log-expression
space. For each MNN pair, a pairwise correction vector is computed by
applying a Gaussian smoothing kernel with bandwidth `sigma`.
}
\examples{
data('sceBatches', package = 'singleCellTK')
logcounts(sceBatches) <- log1p(counts(sceBatches))
sceCorr <- runMNNCorrect(sceBatches)
}
\references{
Haghverdi L, Lun ATL, et. al., 2018
}
\seealso{
\code{\link[batchelor]{mnnCorrect}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/seuratFunctions.R
\name{runSeuratSCTransform}
\alias{runSeuratSCTransform}
\title{runSeuratSCTransform
Runs the \link[Seurat]{SCTransform} function to transform/normalize the input
data}
\usage{
runSeuratSCTransform(
  inSCE,
  normAssayName = "SCTCounts",
  useAssay = "counts",
  verbose = TRUE
)
}
\arguments{
\item{inSCE}{Input SingleCellExperiment object}

\item{normAssayName}{Name for the output data assay. Default
\code{"SCTCounts"}.}

\item{useAssay}{Name for the input data assay. Default \code{"counts"}.}

\item{verbose}{Logical value indicating if informative messages should
be displayed. Default is \code{TRUE}.}
}
\value{
Updated SingleCellExperiment object containing the transformed data
}
\description{
runSeuratSCTransform
Runs the \link[Seurat]{SCTransform} function to transform/normalize the input
data
}
\examples{
data("mouseBrainSubsetSCE", package = "singleCellTK")
mouseBrainSubsetSCE <- runSeuratSCTransform(mouseBrainSubsetSCE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotBatchVariance.R
\name{plotBatchVariance}
\alias{plotBatchVariance}
\title{Plot the percent of the variation that is explained by batch and condition
in the data}
\usage{
plotBatchVariance(
  inSCE,
  useAssay = NULL,
  useReddim = NULL,
  useAltExp = NULL,
  batch = "batch",
  condition = NULL,
  title = NULL
)
}
\arguments{
\item{inSCE}{\linkS4class{SingleCellExperiment} inherited object.}

\item{useAssay}{A single character. The name of the assay that stores the
value to plot. For \code{useReddim} and \code{useAltExp} also. Default
\code{NULL}.}

\item{useReddim}{A single character. The name of the dimension reduced
matrix that stores the value to plot. Default \code{NULL}.}

\item{useAltExp}{A single character. The name of the alternative experiment
that stores an assay of the value to plot. Default \code{NULL}.}

\item{batch}{A single character. The name of batch annotation column in
\code{colData(inSCE)}. Default \code{"batch"}.}

\item{condition}{A single character. The name of an additional condition
annotation column in \code{colData(inSCE)}. Default \code{NULL}.}

\item{title}{A single character. The title text on the top. Default
\code{NULL}.}
}
\value{
A ggplot object of a boxplot of variation explained by batch,
condition, and batch+condition.
}
\description{
Visualize the percent variation in the data that is explained by batch and
condition, individually, and that explained by combining both annotations.
Plotting only the variation explained by batch is supported but not
recommended, because this can be confounded by potential condition.
}
\details{
When condition and batch both are causing some variation, if the difference
between full variation and condition variation is close to batch variation,
this might imply that batches are causing some effect; if the difference is
much less than batch variation, then the batches are likely to be confounded
by the conditions.
}
\examples{
data('sceBatches', package = 'singleCellTK')
plotBatchVariance(sceBatches,
                  useAssay="counts",
                  batch="batch",
                  condition = "cell_type")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/htmlReports.R
\name{reportClusterAbundance}
\alias{reportClusterAbundance}
\title{Get plotClusterAbundance .html report}
\usage{
reportClusterAbundance(
  inSCE,
  cluster,
  variable,
  output_dir = ".",
  output_file = "plotClusterAbundance_Report",
  pdf = FALSE,
  showSession = TRUE
)
}
\arguments{
\item{inSCE}{A \code{\link[SingleCellExperiment]{SingleCellExperiment}}
object.}

\item{cluster}{A single \code{character}, specifying the name to store the
cluster label in \code{\link{colData}}.}

\item{variable}{A single \code{character}, specifying the name to store the
phenotype labels in \code{\link{colData}}.}

\item{output_dir}{name of the output directory to save the rendered file. If
\code{NULL} the file is stored to the current working directory.
Default \code{NULL}.}

\item{output_file}{name of the generated file. If \code{NULL} then the output
file name will be based on the name of the Rmarkdown template. Default
\code{NULL}.}

\item{pdf}{A \code{logical} value indicating if a pdf should also be
generated for each figure in the report. Default is \code{TRUE}.}

\item{showSession}{A \code{logical} value indicating if session information
should be displayed or not. Default is \code{TRUE}.}
}
\value{
An HTML file of the report will be generated at the path specified
in the arguments.
}
\description{
A function to generate .html Rmarkdown report containing the
visualizations of the plotClusterAbundance function output
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runBatchCorrection.R
\name{runLimmaBC}
\alias{runLimmaBC}
\title{Apply Limma's batch effect correction method to SingleCellExperiment object}
\usage{
runLimmaBC(inSCE, useAssay = "logcounts", assayName = "LIMMA", batch = "batch")
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object}

\item{useAssay}{A single character indicating the name of the assay requiring
batch correction. Default \code{"logcounts"}.}

\item{assayName}{A single characeter. The name for the corrected assay. Will
be saved to \code{\link{assay}}. Default
\code{"LIMMA"}.}

\item{batch}{A single character indicating a field in \code{colData} that
annotates the batches of each cell; or a vector/factor with the same length
as the number of cells. Default \code{"batch"}.}
}
\value{
The input \linkS4class{SingleCellExperiment} object with
\code{assay(inSCE, assayName)} updated.
}
\description{
Limma's batch effect removal function fits a linear model to the data, then
removes the component due to the batch effects.
}
\examples{
data('sceBatches', package = 'singleCellTK')
logcounts(sceBatches) <- log1p(counts(sceBatches))
sceCorr <- runLimmaBC(sceBatches)
}
\references{
Gordon K Smyth, et al., 2003
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runTSCAN.R
\name{plotTSCANClusterDEG}
\alias{plotTSCANClusterDEG}
\title{Plot features identified by \code{\link{runTSCANClusterDEAnalysis}} on
cell 2D embedding with MST overlaid}
\usage{
plotTSCANClusterDEG(
  inSCE,
  useCluster,
  pathIndex = NULL,
  useReducedDim = "UMAP",
  topN = 9,
  useAssay = NULL,
  featureDisplay = metadata(inSCE)$featureDisplay,
  combinePlot = c("all", "none")
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object.}

\item{useCluster}{Choose a cluster used for identifying DEG with
\code{\link{runTSCANClusterDEAnalysis}}. Required.}

\item{pathIndex}{Specifies one of the branching paths from \code{useCluster}
and plot the top DEGs on this path. Ususally presented by the terminal
cluster of a path. By default \code{NULL} plot top DEGs of all paths.}

\item{useReducedDim}{A single character for the matrix of 2D embedding.
Should exist in \code{reducedDims} slot. Default \code{"UMAP"}.}

\item{topN}{Integer. Use top N genes identified. Default \code{9}.}

\item{useAssay}{A single character for the feature expression matrix. Should
exist in \code{assayNames(inSCE)}. Default \code{NULL} for using the one used
in \code{\link{runTSCANClusterDEAnalysis}}.}

\item{featureDisplay}{Specify the feature ID type to display. Users can set
default value with \code{\link{setSCTKDisplayRow}}. \code{NULL} or
\code{"rownames"} specifies the rownames of \code{inSCE}. Other character
values indicates \code{rowData} variable.}

\item{combinePlot}{Must be either \code{"all"} or \code{"none"}. \code{"all"}
will combine plots of each feature into a single \code{.ggplot} object,
while \code{"none"} will output a list of plots. Default \code{"all"}.}
}
\value{
A \code{.ggplot} object of cell scatter plot, colored by the
expression of a gene identified by \code{\link{runTSCANClusterDEAnalysis}},
with the layer of trajectory.
}
\description{
A wrapper function which plot the top features expression
identified by \code{\link{runTSCANClusterDEAnalysis}} on the 2D embedding of
the cells cluster used in the analysis. The related MST edges are overlaid.
}
\examples{
data("mouseBrainSubsetSCE", package = "singleCellTK")
mouseBrainSubsetSCE <- runTSCAN(inSCE = mouseBrainSubsetSCE,
                                useReducedDim = "PCA_logcounts")
mouseBrainSubsetSCE <- runTSCANClusterDEAnalysis(inSCE = mouseBrainSubsetSCE,
                                                 useCluster = 1)
plotTSCANClusterDEG(mouseBrainSubsetSCE, useCluster = 1,
                    useReducedDim = "TSNE_logcounts")
}
\author{
Yichen Wang
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sctkTagging.R
\name{expData,ANY,character-method}
\alias{expData,ANY,character-method}
\title{expData
Get data item from an input \code{SingleCellExperiment} object. The data item can be an \code{assay}, \code{altExp} (subset) or a \code{reducedDim}, which is retrieved based on the name of the data item.}
\usage{
\S4method{expData}{ANY,character}(inSCE, assayName)
}
\arguments{
\item{inSCE}{Input \code{SingleCellExperiment} object.}

\item{assayName}{Specify the name of the data item to retrieve.}
}
\value{
Specified data item.
}
\description{
expData
Get data item from an input \code{SingleCellExperiment} object. The data item can be an \code{assay}, \code{altExp} (subset) or a \code{reducedDim}, which is retrieved based on the name of the data item.
}
\examples{
data(scExample, package = "singleCellTK")
mat <- expData(sce, "counts")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scanpyFunctions.R
\name{runScanpyFindClusters}
\alias{runScanpyFindClusters}
\title{runScanpyFindClusters
Computes the clusters from the input sce object and stores them back in sce
object}
\usage{
runScanpyFindClusters(
  inSCE,
  useAssay = "scanpyScaledData",
  useReducedDim = "scanpyPCA",
  nNeighbors = 10,
  dims = 40,
  method = c("leiden", "louvain"),
  colDataName = NULL,
  resolution = 1,
  niterations = -1,
  flavor = "vtraag",
  use_weights = FALSE,
  cor_method = "pearson",
  inplace = TRUE,
  externalReduction = NULL,
  seed = 12345
)
}
\arguments{
\item{inSCE}{(sce) object from which clusters should be computed and stored
in}

\item{useAssay}{Assay containing scaled counts to use for clustering.}

\item{useReducedDim}{Reduction method to use for computing clusters. 
Default \code{"scanpyPCA"}.}

\item{nNeighbors}{The size of local neighborhood (in terms of number of 
neighboring data points) used for manifold approximation. Larger values 
result in more global views of the manifold, while smaller values result in 
more local data being preserved. Default \code{10}.}

\item{dims}{numeric value of how many components to use for computing
clusters. Default \code{40}.}

\item{method}{selected method to compute clusters. One of "louvain",
and "leiden". Default \code{louvain}.}

\item{colDataName}{Specify the name to give to this clustering result. 
Default is \code{NULL} that will generate a meaningful name automatically.}

\item{resolution}{A parameter value controlling the coarseness of the 
clustering. Higher values lead to more clusters Default \code{1}.}

\item{niterations}{How many iterations of the Leiden clustering method to 
perform. Positive values above 2 define the total number of iterations to 
perform, -1 has the method run until it reaches its optimal clustering.
Default \code{-1}.}

\item{flavor}{Choose between to packages for computing the clustering.
Default \code{vtraag}}

\item{use_weights}{Boolean. Use weights from knn graph. Default \code{FALSE}}

\item{cor_method}{correlation method to use. Options are ‘pearson’, 
‘kendall’, and ‘spearman’. Default \code{pearson}.}

\item{inplace}{If True, adds dendrogram information to annData object, 
else this function returns the information. Default \code{TRUE}}

\item{externalReduction}{Pass DimReduce object if PCA computed through
other libraries. Default \code{NULL}.}

\item{seed}{Specify numeric value to set as a seed. Default \code{12345}.}
}
\value{
Updated sce object which now contains the computed clusters
}
\description{
runScanpyFindClusters
Computes the clusters from the input sce object and stores them back in sce
object
}
\examples{
data(scExample, package = "singleCellTK")
\dontrun{
sce <- runScanpyNormalizeData(sce, useAssay = "counts")
sce <- runScanpyFindHVG(sce, useAssay = "scanpyNormData", method = "seurat")
sce <- runScanpyScaleData(sce, useAssay = "scanpyNormData")
sce <- runScanpyPCA(sce, useAssay = "scanpyScaledData")
sce <- runScanpyFindClusters(sce, useReducedDim = "scanpyPCA")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/miscFunctions.R
\name{discreteColorPalette}
\alias{discreteColorPalette}
\title{Generate given number of color codes}
\usage{
discreteColorPalette(
  n,
  palette = c("random", "ggplot", "celda"),
  seed = 12345,
  ...
)
}
\arguments{
\item{n}{An integer, the number of color codes to generate.}

\item{palette}{A single character string. Select the method, available
options are \code{"ggplot"}, \code{"celda"} and \code{"random"}. Default
\code{"random"}.}

\item{seed}{An integer. Set the seed for random process that happens only in
"random" generation. Default \code{12345}.}

\item{...}{Other arguments that are passed to the internal function,
according to the method selected.}
}
\value{
A character vector of \code{n} hex color codes.
}
\description{
Three different generation methods are wrapped, including
\code{\link[celda]{distinctColors}},
[randomcoloR](SCTK_PerformingQC_Cell_V3.Rmd) and the \code{ggplot}
default color generation.
}
\examples{
discreteColorPalette(n = 3)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/computeZScore.R
\name{computeZScore}
\alias{computeZScore}
\title{Compute Z-Score}
\usage{
computeZScore(counts)
}
\arguments{
\item{counts}{matrix (base matrix, dgCMatrix or DelayedMatrix)}
}
\value{
z-score computed counts matrix (DelayedMatrix)
}
\description{
Computes Z-Score from an input count matrix using the formula
((x-mean(x))/sd(x)) for each gene across all cells. The input count matrix
can either be a base matrix, dgCMatrix or a DelayedMatrix. Computations are
performed using DelayedMatrixStats package to efficiently compute the
Z-Score matrix.
}
\examples{
data(sce_chcl, package = "scds")
assay(sce_chcl, "countsZScore") <- computeZScore(assay(sce_chcl, "counts"))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DownsampleMatrix.R
\name{subDiffEx}
\alias{subDiffEx}
\alias{subDiffExttest}
\alias{subDiffExANOVA}
\title{Passes the output of generateSimulatedData() to differential expression
tests, picking either t-tests or ANOVA for data with only two conditions or
multiple conditions, respectively.}
\usage{
subDiffEx(tempData)

subDiffExttest(countMatrix, class.labels, test.type = "t.equalvar")

subDiffExANOVA(countMatrix, condition)
}
\arguments{
\item{tempData}{Matrix. The output of generateSimulatedData(), where the
first row contains condition labels.}

\item{countMatrix}{Matrix. A simulated counts matrix, sans labels.}

\item{class.labels}{Factor. The condition labels for the simulated cells.
Will be coerced into 1's and 0's.}

\item{test.type}{Type of test to perform. The default is t.equalvar.}

\item{condition}{Factor. The condition labels for the simulated cells.}
}
\value{
subDiffEx(): A vector of fdr-adjusted p-values for all genes.
Nonviable results (such as for genes with 0 counts in a simulated dataset)
are coerced to 1.

subDiffExttest(): A vector of fdr-adjusted p-values for all genes.
Nonviable results (such as for genes with 0 counts in a simulated dataset)
are coerced to 1.

subDiffExANOVA(): A vector of fdr-adjusted p-values for all genes.
Nonviable results (such as for genes with 0 counts in a simulated dataset)
are coerced to 1.
}
\description{
Passes the output of generateSimulatedData() to differential expression
tests, picking either t-tests or ANOVA for data with only two conditions or
multiple conditions, respectively.
}
\section{Functions}{
\itemize{
\item \code{subDiffEx()}: 

\item \code{subDiffExttest()}: Runs t-tests on all genes in a simulated dataset with 2
conditions, and adjusts for FDR.

\item \code{subDiffExANOVA()}: Runs ANOVA on all genes in a simulated dataset with
more than 2 conditions, and adjusts for FDR.

}}
\examples{
data("mouseBrainSubsetSCE")
res <- generateSimulatedData(
         totalReads = 1000, cells=10,
         originalData = assay(mouseBrainSubsetSCE, "counts"),
         realLabels = colData(mouseBrainSubsetSCE)[, "level1class"])
tempSigDiff <- subDiffEx(res)

data("mouseBrainSubsetSCE")
#sort first 100 expressed genes
ord <- rownames(mouseBrainSubsetSCE)[
  order(rowSums(assay(mouseBrainSubsetSCE, "counts")),
        decreasing = TRUE)][seq(100)]
#subset to those first 100 genes
subset <- mouseBrainSubsetSCE[ord, ]
res <- generateSimulatedData(totalReads = 1000, cells=10,
                             originalData = assay(subset, "counts"),
                             realLabels = colData(subset)[, "level1class"])
realLabels <- res[1, ]
output <- res[-1, ]
fdr <- subDiffExttest(output, realLabels)

data("mouseBrainSubsetSCE")
#sort first 100 expressed genes
ord <- rownames(mouseBrainSubsetSCE)[
  order(rowSums(assay(mouseBrainSubsetSCE, "counts")),
        decreasing = TRUE)][seq(100)]
# subset to those first 100 genes
subset <- mouseBrainSubsetSCE[ord, ]
res <- generateSimulatedData(totalReads = 1000, cells=10,
                             originalData = assay(subset, "counts"),
                             realLabels = colData(subset)[, "level2class"])
realLabels <- res[1, ]
output <- res[-1, ]
fdr <- subDiffExANOVA(output, realLabels)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sctkTagging.R
\name{expData<-,ANY,character,CharacterOrNullOrMissing,logical-method}
\alias{expData<-,ANY,character,CharacterOrNullOrMissing,logical-method}
\title{expData
Store data items using tags to identify the type of data item stored. To be used as a replacement for assay<- setter function but with additional parameter to set a tag to a data item.}
\usage{
\S4method{expData}{ANY,character,CharacterOrNullOrMissing,logical}(inSCE, assayName, tag = NULL, altExp = FALSE) <- value
}
\arguments{
\item{inSCE}{Input \code{SingleCellExperiment} object.}

\item{assayName}{Specify the name of the input assay.}

\item{tag}{Specify the tag to store against the input assay. Default is \code{NULL}, which will set the tag to "uncategorized".}

\item{altExp}{A \code{logical} value indicating if the input assay is a \code{altExp} or a subset assay.}

\item{value}{An input matrix-like value to store in the SCE object.}
}
\value{
A \code{SingleCellExperiment} object containing the newly stored data.
}
\description{
expData
Store data items using tags to identify the type of data item stored. To be used as a replacement for assay<- setter function but with additional parameter to set a tag to a data item.
}
\examples{
data(scExample, package = "singleCellTK")
mat <- expData(sce, "counts")
expData(sce, "counts", tag = "raw") <- mat
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runSoupX.R
\name{getSoupX<-}
\alias{getSoupX<-}
\alias{getSoupX}
\alias{getSoupX,SingleCellExperiment-method}
\alias{getSoupX<-,SingleCellExperiment-method}
\title{Get or Set SoupX Result}
\usage{
getSoupX(inSCE, sampleID, background = FALSE) <- value

getSoupX(inSCE, sampleID = NULL, background = FALSE)

\S4method{getSoupX}{SingleCellExperiment}(inSCE, sampleID = NULL, background = FALSE)

\S4method{getSoupX}{SingleCellExperiment}(inSCE, sampleID, background = FALSE) <- value
}
\arguments{
\item{inSCE}{A \linkS4class{SingleCellExperiment} object. For getter method,
\code{\link{runSoupX}} must have been already applied.}

\item{sampleID}{Character vector. For getter method, the samples that should
be included in the returned list. Leave this \code{NULL} for all samples.
Default \code{NULL}. For setter method, only one sample allowed.}

\item{background}{Logical. Whether \code{background} was applied when
running \code{\link{runSoupX}}. Default \code{FALSE}.}

\item{value}{Dedicated list object of SoupX results.}
}
\value{
For getter method, a list with SoupX results for specified samples.
For setter method, \code{inSCE} with SoupX results updated.

For getter method, a list with SoupX results for specified samples.
For setter method, \code{inSCE} with SoupX results updated.
}
\description{
S4 method for getting and setting SoupX results that cannot be
appended to either \code{rowData(inSCE)} or \code{colData(inSCE)}.

S4 method for getting and setting SoupX results that cannot be
appended to either \code{rowData(inSCE)} or \code{colData(inSCE)}.
}
\examples{
\dontrun{
sce <- importExampleData("pbmc3k")
sce <- runSoupX(sce, sample = "sample")
soupXResults <- getSoupX(sce)
}
}
\seealso{
runSoupX, plotSoupXResults
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sctkQCUtils.R
\name{exportSCEToSeurat}
\alias{exportSCEToSeurat}
\title{Export data in Seurat object}
\usage{
exportSCEToSeurat(
  inSCE,
  prefix = "sample",
  outputDir = "./",
  overwrite = TRUE,
  copyColData = TRUE,
  copyReducedDim = TRUE,
  copyDecontX = TRUE
)
}
\arguments{
\item{inSCE}{A \link[SingleCellExperiment]{SingleCellExperiment} object
that contains the data. QC metrics are stored in colData of the
singleCellExperiment object.}

\item{prefix}{Prefix to use for the name of the output file. Default \code{"sample"}.}

\item{outputDir}{Path to the directory where outputs will be written. Default is the current working directory.}

\item{overwrite}{Boolean. Whether overwrite the output if it already exists in the outputDir. Default \code{TRUE}.}

\item{copyColData}{Boolean. Whether copy 'colData' of SCE object to the 'meta.data' of Seurat object. Default \code{TRUE}.}

\item{copyReducedDim}{Boolean. Whether copy 'reducedDims' of the SCE object to the 'reductions' of Seurat object. Default \code{TRUE}.}

\item{copyDecontX}{Boolean. Whether copy 'decontXcounts' assay of the SCE object to the 'assays' of Seurat object. Default \code{TRUE}.}
}
\value{
Generates a Seurat object containing data from \code{inSCE}.
}
\description{
Export data in Seurat object
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scanpyFunctions.R
\name{plotScanpyMarkerGenesDotPlot}
\alias{plotScanpyMarkerGenesDotPlot}
\title{plotScanpyMarkerGenesDotPlot}
\usage{
plotScanpyMarkerGenesDotPlot(
  inSCE,
  groups = NULL,
  nGenes = 10,
  groupBy,
  log2fcThreshold = NULL,
  parameters = "logfoldchanges",
  standardScale = NULL,
  features = NULL,
  title = "",
  vmin = NULL,
  vmax = NULL,
  colorBarTitle = "log fold change"
)
}
\arguments{
\item{inSCE}{Input \code{SingleCellExperiment} object.}

\item{groups}{The groups for which to show the gene ranking. Default \code{NULL}
means that all groups will be considered.}

\item{nGenes}{Number of genes to show. Default \code{10}}

\item{groupBy}{The key of the observation grouping to consider. By default, 
the groupby is chosen from the rank genes groups parameter.}

\item{log2fcThreshold}{Only output DEGs with the absolute values of log2FC
larger than this value. Default \code{NULL}.}

\item{parameters}{The options for marker genes results to plot are: 
‘scores’, ‘logfoldchanges’, ‘pvals’, ‘pvals_adj’, ‘log10_pvals’, ‘log10_pvals_adj’.
If NULL provided then it uses mean gene value to plot.}

\item{standardScale}{Whether or not to standardize the given dimension 
between 0 and 1, meaning for each variable or group, subtract the minimum and 
divide each by its maximum. Default \code{NULL} means that it doesn't perform
any scaling.}

\item{features}{Genes to plot. Sometimes is useful to pass a specific list of
var names (e.g. genes) to check their fold changes or p-values, instead of 
the top/bottom genes. The gene names could be a dictionary or a list. 
Default \code{NULL}}

\item{title}{Provide title for the figure.}

\item{vmin}{The value representing the lower limit of the color scale. 
Values smaller than vmin are plotted with the same color as vmin. 
Default \code{NULL}}

\item{vmax}{The value representing the upper limit of the color scale. 
Values larger than vmax are plotted with the same color as vmax. 
Default \code{NULL}}

\item{colorBarTitle}{Title for the color bar.}
}
\value{
plot object
}
\description{
plotScanpyMarkerGenesDotPlot
}
\examples{
data(scExample, package = "singleCellTK")
\dontrun{
sce <- runScanpyNormalizeData(sce, useAssay = "counts")
sce <- runScanpyFindHVG(sce, useAssay = "scanpyNormData", method = "seurat")
sce <- runScanpyScaleData(sce, useAssay = "scanpyNormData")
sce <- runScanpyPCA(sce, useAssay = "scanpyScaledData")
sce <- runScanpyFindClusters(sce, useReducedDim = "scanpyPCA")
sce <- runScanpyFindMarkers(sce, colDataName = "Scanpy_louvain_1" )
plotScanpyMarkerGenesDotPlot(sce, groupBy = 'Scanpy_louvain_1')
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ggPlotting.R
\name{plotSCEDimReduceFeatures}
\alias{plotSCEDimReduceFeatures}
\title{Dimension reduction plot tool for assay data}
\usage{
plotSCEDimReduceFeatures(
  inSCE,
  features,
  feature = deprecated(),
  reducedDimName,
  sample = NULL,
  featureLocation = NULL,
  featureDisplay = NULL,
  shape = NULL,
  useAssay = "logcounts",
  xlab = NULL,
  ylab = NULL,
  axisSize = 10,
  axisLabelSize = 10,
  dim1 = NULL,
  dim2 = NULL,
  bin = NULL,
  binLabel = NULL,
  dotSize = 0.1,
  transparency = 1,
  colorLow = "white",
  colorMid = "gray",
  colorHigh = "blue",
  defaultTheme = TRUE,
  title = NULL,
  titleSize = 15,
  legendTitle = NULL,
  legendSize = 10,
  legendTitleSize = 12,
  ncols = NULL,
  groupBy = NULL,
  combinePlot = "none",
  plotLabels = NULL
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object with saved
dimension reduction components or a variable with saved results. Required.}

\item{features}{Name of feature stored in assay of SingleCellExperiment
object.}

\item{feature}{Deprecated, use `features` instead.}

\item{reducedDimName}{saved dimension reduction name in the
\linkS4class{SingleCellExperiment} object. Required.}

\item{sample}{Character vector. Indicates which sample each cell belongs to.}

\item{featureLocation}{Indicates which column name of rowData to query gene.}

\item{featureDisplay}{Indicates which column name of rowData to use
to display feature for visualization.}

\item{shape}{add shapes to each condition. Default NULL.}

\item{useAssay}{Indicate which assay to use. The default is "logcounts"}

\item{xlab}{Character vector. Label for x-axis. Default NULL.}

\item{ylab}{Character vector. Label for y-axis. Default NULL.}

\item{axisSize}{Size of x/y-axis ticks. Default 10.}

\item{axisLabelSize}{Size of x/y-axis labels. Default 10.}

\item{dim1}{1st dimension to be used for plotting. Can either be a string which specifies
the name of the dimension to be plotted from reducedDims, or a numeric value which specifies
the index of the dimension to be plotted. Default is NULL.}

\item{dim2}{2nd dimension to be used for plotting. Can either be a string which specifies
the name of the dimension to be plotted from reducedDims, or a numeric value which specifies
the index of the dimension to be plotted. Default is NULL.}

\item{bin}{Numeric vector. If single value, will divide the numeric values into the `bin` groups.
If more than one value, will bin numeric values using values as a cut point.}

\item{binLabel}{Character vector. Labels for the bins created by the `bin` parameter.
Default NULL.}

\item{dotSize}{Size of dots. Default 0.1.}

\item{transparency}{Transparency of the dots, values will be 0-1. Default 1.}

\item{colorLow}{Character. A color available from `colors()`.
The color will be used to signify the lowest values on the scale.
Default 'white'.}

\item{colorMid}{Character. A color available from `colors()`.
The color will be used to signify the midpoint on the scale.
Default 'gray'.}

\item{colorHigh}{Character. A color available from `colors()`.
The color will be used to signify the highest values on the scale.
Default 'blue'.}

\item{defaultTheme}{adds grid to plot when TRUE. Default TRUE.}

\item{title}{Title of plot. Default NULL.}

\item{titleSize}{Size of title of plot. Default 15.}

\item{legendTitle}{title of legend. Default NULL.}

\item{legendSize}{size of legend. Default 10.}

\item{legendTitleSize}{size of legend title. Default 12.}

\item{ncols}{number of columns for multiple feature plotting. Default NULL.}

\item{groupBy}{Facet wrap the scatterplot based on value.
Default \code{NULL}.}

\item{combinePlot}{Must be either "all", "sample", or "none". "all" will combine all plots into a single
.ggplot object, while "sample" will output a list of plots separated by sample. Default "none".}

\item{plotLabels}{labels to each plot. If set to "default", will use the name of the samples
as the labels. If set to "none", no label will be plotted.}
}
\value{
a ggplot of the reduced dimension plot of feature data.
}
\description{
Plot results of reduced dimensions data and
 colors by feature data stored in the assays slot.
}
\examples{
data("mouseBrainSubsetSCE")
plotSCEDimReduceFeatures(
  inSCE = mouseBrainSubsetSCE, features = "Apoe",
  shape = NULL, reducedDimName = "TSNE_counts",
  useAssay = "counts", xlab = "tSNE1", ylab = "tSNE2"
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotBatchVariance.R
\name{plotBatchCorrCompare}
\alias{plotBatchCorrCompare}
\title{Plot comparison of batch corrected result against original assay}
\usage{
plotBatchCorrCompare(
  inSCE,
  corrMat,
  batch = NULL,
  condition = NULL,
  origAssay = NULL,
  origLogged = NULL,
  method = NULL,
  matType = NULL
)
}
\arguments{
\item{inSCE}{\linkS4class{SingleCellExperiment} inherited object.}

\item{corrMat}{A single character indicating the name of the corrected matrix.}

\item{batch}{A single character. The name of batch annotation column in
\code{colData(inSCE)}.}

\item{condition}{A single character. The name of an additional covariate
annotation column in \code{colData(inSCE)}.}

\item{origAssay}{A single character indicating what the original assay used
for batch correction is.}

\item{origLogged}{Logical scalar indicating whether \code{origAssay} is
log-normalized.}

\item{method}{A single character indicating the name of the batch correction
method. Only used for the titles of plots.}

\item{matType}{A single character indicating the type of the batch correction
result matrix, choose from \code{"assay"}, \code{"altExp"},
\code{"reducedDim"}.}
}
\value{
An object of class \code{"gtable"}, combining four \code{ggplot}s.
}
\description{
Plot comparison of batch corrected result against original assay
}
\details{
Four plots will be combined. Two of them are violin/box-plots for
percent variance explained by the batch variation, and optionally the
covariate, for original and corrected. The other two are UMAPs of the
original assay and the correction result matrix. If SCTK batch correction
methods are performed in advance, this function will automatically detect
necessary input. Otherwise, users can also customize the input. Future
improvement might include solution to reduce redundant UMAP calculation.
}
\examples{
data("sceBatches")
logcounts(sceBatches) <- log1p(counts(sceBatches))
sceBatches <- runLimmaBC(sceBatches)
plotBatchCorrCompare(sceBatches, "LIMMA", condition = "cell_type")
}
\author{
Yichen Wang
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runSingleR.R
\name{runSingleR}
\alias{runSingleR}
\title{Label cell types with SingleR}
\usage{
runSingleR(
  inSCE,
  useAssay = "logcounts",
  useSCERef = NULL,
  labelColName = NULL,
  useBltinRef = c("hpca", "bpe", "mp", "dice", "immgen", "mouse", "zeisel"),
  level = "fine",
  featureType = c("symbol", "ensembl"),
  labelByCluster = NULL
)
}
\arguments{
\item{inSCE}{\linkS4class{SingleCellExperiment} inherited object. Required.}

\item{useAssay}{character. A string specifying which assay to use for
expression profile identification. Required.}

\item{useSCERef}{\linkS4class{SingleCellExperiment} inherited object. An
optional customized reference dataset. Default \code{NULL}.}

\item{labelColName}{A single character. A string specifying the column in
\code{colData(useSCERef)} that stores the cell type labeling. Default
\code{NULL}.}

\item{useBltinRef}{A single character. A string that specifies a reference
provided by SingleR. Choose from \code{"hpca", "bpe", "mp", "dice", "immgen",
"mouse", "zeisel"}. See detail. Default \code{"hpca"}.}

\item{level}{A string for cell type labeling level. Used only when using
some of the SingleR built-in references. Choose from \code{"main", "fine",
"ont"}. Default \code{"fine"}.}

\item{featureType}{A string for whether to use gene symbols or Ensembl IDs
when using a SingleR built-in reference. Should be set based on the type of
\code{rownames} of \code{inSCE}. Choose from \code{"symbol", "ensembl"}.
Default \code{"symbol"}.}

\item{labelByCluster}{A single character. A string specifying the column name
in \code{colData(inSCE)} that stores clustering labels. Use this when users
want to only label cells on cluster level, instead of performing calculation
on each cell. Default \code{NULL}.}
}
\value{
Input SCE object with cell type labeling updated in
\code{colData(inSCE)}, together with scoring metrics.
}
\description{
SingleR works with a reference dataset where the cell type
labeling is given. Given a reference dataset of samples (single-cell or bulk)
with known labels, it assigns those labels to new cells from a test dataset
based on similarities in their expression profiles.
}
\examples{
data("sceBatches")
logcounts(sceBatches) <- log1p(counts(sceBatches))
#sceBatches <- runSingleR(sceBatches, useBltinRef = "mp")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/featureIndex.R
\name{featureIndex}
\alias{featureIndex}
\title{Retrieve row index for a set of features}
\usage{
featureIndex(
  features,
  inSCE,
  by = "rownames",
  exactMatch = TRUE,
  removeNA = FALSE,
  errorOnNoMatch = TRUE,
  warningOnPartialMatch = TRUE
)
}
\arguments{
\item{features}{Character vector of feature names to find in the rows of
\code{inSCE}.}

\item{inSCE}{A data.frame, matrix, or \linkS4class{SingleCellExperiment}
object to search.}

\item{by}{Character. Where to search for features in \code{inSCE}. If set to
\code{"rownames"} then the features will be searched for among
\code{rownames(inSCE)}. If \code{inSCE} inherits from class
\linkS4class{SummarizedExperiment}, then \code{by} can be one of the
fields in the row annotation data.frame (i.e. one of
\code{colnames(rowData(inSCE))}).}

\item{exactMatch}{Boolean. Whether to only identify exact matches
or to identify partial matches using \code{\link{grep}}.}

\item{removeNA}{Boolean. If set to \code{FALSE}, features not found in
\code{inSCE} will be given \code{NA} and the returned vector will be the same
length as \code{features}. If set to \code{TRUE}, then the \code{NA}
values will be removed from the returned vector. Default \code{FALSE}.}

\item{errorOnNoMatch}{Boolean. If \code{TRUE}, an error will be given if
no matches are found. If \code{FALSE}, an empty vector will be returned if 
\code{removeNA} is set to \code{TRUE} or a vector of \code{NA} if 
\code{removeNA} is set to \code{FALSE}. Default \code{TRUE}.}

\item{warningOnPartialMatch}{Boolean. If \code{TRUE}, a warning will be
given if some of the entries in \code{features} were not found in 
\code{inSCE}. The warning will list the features not found.
Default \code{TRUE}.}
}
\value{
A vector of row indices for the matching features in \code{inSCE}.
}
\description{
This will return indices of features among the rownames
or rowData of a data.frame, matrix, or a \linkS4class{SummarizedExperiment}
object including a \linkS4class{SingleCellExperiment}.
Partial matching (i.e. grepping) can be used by setting
\code{exactMatch = FALSE}.
}
\examples{
data(scExample)
ix <- featureIndex(features = c("MT-CYB", "MT-ND2"),
                             inSCE = sce,
                             by = "feature_name")
}
\seealso{
'\link[scater]{retrieveFeatureInfo}' from package \code{'scater'}
and \code{link{regex}} for how to use regular expressions when
\code{exactMatch = FALSE}.
}
\author{
Yusuke Koga, Joshua D. Campbell
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runClusterSummaryMetrics.R
\name{runClusterSummaryMetrics}
\alias{runClusterSummaryMetrics}
\title{Run Cluster Summary Metrics}
\usage{
runClusterSummaryMetrics(
  inSCE,
  useAssay = "logcounts",
  featureNames,
  displayName = NULL,
  groupNames = "cluster",
  scale = FALSE
)
}
\arguments{
\item{inSCE}{The single cell experiment to use.}

\item{useAssay}{The assay to use.}

\item{featureNames}{A string or vector of strings with each gene to aggregate.}

\item{displayName}{A string that is the name of the column used for genes.}

\item{groupNames}{The name of a colData entry that can be used as groupNames.}

\item{scale}{Option to scale the data. Default: \code{FALSE}. Selected assay will not be scaled.}
}
\value{
A dataframe with mean expression and percent of cells in cluster that 
express for each cluster.
}
\description{
Calculates the mean expression of percent of cells that express the
given genes for each cluster
}
\examples{
data("scExample")
runClusterSummaryMetrics(inSCE=sce, useAssay="counts", featureNames=c("B2M", "MALAT1"), 
displayName="feature_name", groupNames="type")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotDEAnalysis.R
\name{plotDEGVolcano}
\alias{plotDEGVolcano}
\title{Generate volcano plot for DEGs}
\usage{
plotDEGVolcano(
  inSCE,
  useResult,
  labelTopN = 10,
  log2fcThreshold = 0.25,
  fdrThreshold = 0.05,
  featureDisplay = S4Vectors::metadata(inSCE)$featureDisplay
)
}
\arguments{
\item{inSCE}{\linkS4class{SingleCellExperiment} inherited object.}

\item{useResult}{character. A string specifying the \code{analysisName}
used when running a differential expression analysis function.}

\item{labelTopN}{Integer, label this number of top DEGs that pass the
filters. \code{FALSE} for not labeling. Default \code{10}.}

\item{log2fcThreshold}{numeric. Label genes with the absolute values of
log2FC greater than this value as regulated. Default \code{0.25}.}

\item{fdrThreshold}{numeric. Label genes with FDR value less than this
value as regulated. Default \code{0.05}.}

\item{featureDisplay}{A character string to indicate a variable in
\code{rowData(inSCE)} for feature labeling. \code{NULL} for using
\code{rownames}. Default \code{metadata(inSCE)$featureDisplay} (see
\code{\link{setSCTKDisplayRow}})}
}
\value{
A \code{ggplot} object of volcano plot
}
\description{
Generate volcano plot for DEGs
}
\details{
Any of the differential expression analysis method from SCTK should
be performed prior to using this function to generate volcano plots.
}
\examples{
data("sceBatches")
sceBatches <- scaterlogNormCounts(sceBatches, "logcounts")
sce.w <- subsetSCECols(sceBatches, colData = "batch == 'w'")
sce.w <- runWilcox(sce.w, class = "cell_type",
                   classGroup1 = "alpha", classGroup2 = "beta",
                   groupName1 = "w.alpha", groupName2 = "w.beta",
                   analysisName = "w.aVSb")
plotDEGVolcano(sce.w, "w.aVSb")
}
\seealso{
\code{\link{runDEAnalysis}}, \code{\link{plotDEGHeatmap}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/importAlevin.R
\name{importAlevin}
\alias{importAlevin}
\title{Construct SCE object from Salmon-Alevin output}
\usage{
importAlevin(
  alevinDir = NULL,
  sampleName = "sample",
  delayedArray = FALSE,
  class = c("Matrix", "matrix"),
  rowNamesDedup = TRUE
)
}
\arguments{
\item{alevinDir}{Character. The output directory of salmon-Alevin pipeline.
It should contain subfolder named 'alevin', which contains the count data
which is stored
in 'quants_mat.gz'. Default \code{NULL}.}

\item{sampleName}{Character. A user-defined sample name for the sample to be
imported. The 'sampleName' will be appended to the begining of cell
barcodes. Default is 'sample'.}

\item{delayedArray}{Boolean. Whether to read the expression matrix as
\link{DelayedArray} object or not. Default \code{FALSE}.}

\item{class}{Character. The class of the expression matrix stored in the SCE
object. Can be one of "Matrix" (as returned by
\link{readMM} function), or "matrix" (as returned by
\link[base]{matrix} function). Default "Matrix".}

\item{rowNamesDedup}{Boolean. Whether to deduplicate rownames. Default 
\code{TRUE}.}
}
\value{
A \code{SingleCellExperiment} object containing the count
 matrix, the feature annotations, and the cell annotation
 (which includes QC metrics stored in 'featureDump.txt').
}
\description{
Construct SCE object from Salmon-Alevin output
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scater_logNormCounts.R
\name{scaterlogNormCounts}
\alias{scaterlogNormCounts}
\title{scaterlogNormCounts
Uses \link{logNormCounts} to log normalize input data}
\usage{
scaterlogNormCounts(
  inSCE,
  assayName = "ScaterLogNormCounts",
  useAssay = "counts"
)
}
\arguments{
\item{inSCE}{Input SingleCellExperiment object}

\item{assayName}{New assay name for log normalized data}

\item{useAssay}{Input assay}
}
\value{
inSCE Updated SingleCellExperiment object that contains the new log normalized data
}
\description{
scaterlogNormCounts
Uses \link{logNormCounts} to log normalize input data
}
\examples{
data(sce_chcl, package = "scds")
sce_chcl <- scaterlogNormCounts(sce_chcl,"logcounts", "counts")
}
\author{
Irzam Sarfraz
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runSoupX.R
\name{runSoupX}
\alias{runSoupX}
\title{Detecting and correct contamination with SoupX}
\usage{
runSoupX(
  inSCE,
  sample = NULL,
  useAssay = "counts",
  background = NULL,
  bgAssayName = NULL,
  bgBatch = NULL,
  assayName = ifelse(is.null(background), "SoupX", "SoupX_bg"),
  cluster = NULL,
  reducedDimName = ifelse(is.null(background), "SoupX_UMAP_", "SoupX_bg_UMAP_"),
  tfidfMin = 1,
  soupQuantile = 0.9,
  maxMarkers = 100,
  contaminationRange = c(0.01, 0.8),
  rhoMaxFDR = 0.2,
  priorRho = 0.05,
  priorRhoStdDev = 0.1,
  forceAccept = FALSE,
  adjustMethod = c("subtraction", "soupOnly", "multinomial"),
  roundToInt = FALSE,
  tol = 0.001,
  pCut = 0.01
)
}
\arguments{
\item{inSCE}{A \linkS4class{SingleCellExperiment} object.}

\item{sample}{A single character specifying a name that can be found in
\code{colData(inSCE)} to directly use the cell annotation; or a character
vector with as many elements as cells to indicates which sample each cell
belongs to. SoupX will be run on cells from each sample separately. Default
\code{NULL}.}

\item{useAssay}{A single character string specifying which assay in
\code{inSCE} to use. Default \code{'counts'}.}

\item{background}{A numeric matrix of counts or a
\linkS4class{SingleCellExperiment} object with the matrix in \code{assay}
slot. It should have the same structure as \code{inSCE} except it contains
the matrix including empty droplets. Default \code{NULL}.}

\item{bgAssayName}{A single character string specifying which assay in
\code{background} to use when \code{background} is a
\linkS4class{SingleCellExperiment} object. If \code{NULL}, the function
will use the same value as \code{useAssay}. Default \code{NULL}.}

\item{bgBatch}{The same thing as \code{sample} but for \code{background}. Can
be a single character only when \code{background} is a
\linkS4class{SingleCellExperiment} object. Default \code{NULL}.}

\item{assayName}{A single character string of the output corrected matrix.
Default \code{"SoupX"} when not using a background, otherwise,
\code{"SoupX_bg"}.}

\item{cluster}{Prior knowledge of clustering labels on cells. A single
character string for specifying clustering label stored in
\code{colData(inSCE)}, or a character vector with as many elements as cells.
When not supplied, \code{\link[scran]{quickCluster}} method will be applied.}

\item{reducedDimName}{A single character string of the prefix of output
corrected embedding matrix for each sample. Default \code{"SoupX_UMAP_"} when
not using a background, otherwise, \code{"SoupX_bg_UMAP_"}.}

\item{tfidfMin}{Numeric. Minimum value of tfidf to accept for a marker gene.
Default \code{1}. See \code{?SoupX::autoEstCont}.}

\item{soupQuantile}{Numeric. Only use genes that are at or above this
expression quantile in the soup. This prevents inaccurate estimates due to
using genes with poorly constrained contribution to the background. Default
\code{0.9}. See \code{?SoupX::autoEstCont}.}

\item{maxMarkers}{Integer. If we have heaps of good markers, keep only the
best maxMarkers of them. Default \code{100}. See \code{?SoupX::autoEstCont}.}

\item{contaminationRange}{Numeric vector of two elements. This constrains
the contamination fraction to lie within this range. Must be between 0 and 1.
The high end of this range is passed to
\code{\link[SoupX]{estimateNonExpressingCells}} as
\code{maximumContamination}. Default \code{c(0.01, 0.8)}. See
\code{?SoupX::autoEstCont}.}

\item{rhoMaxFDR}{Numeric. False discovery rate passed to
\code{\link[SoupX]{estimateNonExpressingCells}}, to test if rho is less than
\code{maximumContamination}. Default \code{0.2}. See
\code{?SoupX::autoEstCont}.}

\item{priorRho}{Numeric. Mode of gamma distribution prior on contamination
fraction. Default \code{0.05}. See \code{?SoupX::autoEstCont}.}

\item{priorRhoStdDev}{Numeric. Standard deviation of gamma distribution prior
on contamination fraction. Default \code{0.1}. See
\code{?SoupX::autoEstCont}.}

\item{forceAccept}{Logical. Should we allow very high contamination fractions
to be used. Passed to \code{\link[SoupX]{setContaminationFraction}}. Default
\code{FALSE}. See \code{?SoupX::autoEstCont}.}

\item{adjustMethod}{Character. Method to use for correction. One of
\code{'subtraction'}, \code{'soupOnly'}, or \code{'multinomial'}. Default
\code{'subtraction'}. See \code{?SoupX::adjustCounts}.}

\item{roundToInt}{Logical. Should the resulting matrix be rounded to
integers? Default \code{FALSE}. See \code{?SoupX::adjustCounts}.}

\item{tol}{Numeric. Allowed deviation from expected number of soup counts.
Don't change this. Default \code{0.001}. See \code{?SoupX::adjustCounts}.}

\item{pCut}{Numeric. The p-value cut-off used when
\code{method = 'soupOnly'}. Default \code{0.01}. See
\code{?SoupX::adjustCounts}.}
}
\value{
The input \code{inSCE} object with \code{soupX_nUMIs},
\code{soupX_clustrers}, \code{soupX_contamination} appended to \code{colData}
slot; \code{soupX_{sample}_est} and \code{soupX_{sample}_counts} for each
sample appended to \code{rowData} slot; and other computational metrics at
\code{getSoupX(inSCE)}. Replace "soupX" to "soupX_bg" when \code{background}
is used.
}
\description{
A wrapper function for \link[SoupX]{autoEstCont} and
\link[SoupX]{adjustCounts}. Identify potential contamination from
experimental factors such as ambient RNA. Visit
\href{https://rawcdn.githack.com/constantAmateur/SoupX/204b602418df12e9fdb4b68775a8b486c6504fe4/inst/doc/pbmcTutorial.html}{their vignette}
for better understanding.
}
\examples{
\dontrun{
# SoupX does not work for toy example,
sce <- importExampleData("pbmc3k")
sce <- runSoupX(sce, sample = "sample")
plotSoupXResults(sce, sample = "sample")
}
}
\seealso{
plotSoupXResults
}
\author{
Yichen Wang
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DownsampleMatrix.R
\name{downSampleCells}
\alias{downSampleCells}
\title{Estimate numbers of detected genes, significantly differentially expressed
genes, and median significant effect size}
\usage{
downSampleCells(
  originalData,
  useAssay = "counts",
  minCountDetec = 10,
  minCellsDetec = 3,
  minCellnum = 10,
  maxCellnum = 1000,
  realLabels,
  depthResolution = 10,
  iterations = 10,
  totalReads = 1e+06
)
}
\arguments{
\item{originalData}{The \linkS4class{SingleCellExperiment} object storing all
assay data from the shiny app.}

\item{useAssay}{Character. The name of the assay to be used for subsampling.}

\item{minCountDetec}{Numeric. The minimum number of reads found for a gene to
be considered detected.}

\item{minCellsDetec}{Numeric. The minimum number of cells a gene must have at
least 1 read in for it to be considered detected.}

\item{minCellnum}{Numeric. The minimum number of virtual cells to include in
the smallest simulated dataset.}

\item{maxCellnum}{Numeric. The maximum number of virtual cells to include in
the largest simulated dataset}

\item{realLabels}{Character. The name of the condition of interest. Must match
a name from sample data. If only two factors present in the corresponding
colData, will default to t-test. If multiple factors, will default to ANOVA.}

\item{depthResolution}{Numeric. How many different read depth should the
script simulate? Will simulate a number of experimental designs ranging from
10 reads to maxReadDepth, with logarithmic spacing.}

\item{iterations}{Numeric. How many times should each experimental design be
simulated?}

\item{totalReads}{Numeric. How many aligned reads to put in each simulated
dataset.}
}
\value{
A 3-dimensional array, with dimensions = c(iterations,
depthResolution, 3). [,,1] contains the number of detected genes in each
simulated dataset, [,,2] contains the number of significantly differentially
expressed genes in each simulation, and [,,3] contains the mediansignificant
effect size in each simulation. If no genes are significantly differentially
expressed, the median effect size defaults to infinity.
}
\description{
Estimate numbers of detected genes, significantly differentially expressed
genes, and median significant effect size
}
\examples{
data("mouseBrainSubsetSCE")
subset <- mouseBrainSubsetSCE[seq(100),]
res <- downSampleCells(subset,
                       realLabels = "level1class",
                       iterations=2)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/trimCounts.R
\name{trimCounts}
\alias{trimCounts}
\title{Trim Counts}
\usage{
trimCounts(counts, trimValue = c(10, -10))
}
\arguments{
\item{counts}{matrix}

\item{trimValue}{where trimValue[1] for upper threshold and trimValue[2] as
lower threshold. Default is \code{c(10,-10)}}
}
\value{
trimmed counts matrix
}
\description{
Trims an input count matrix such that each value greater than a
threshold value and each value less than a provided
lower threshold value is trimmed to the lower treshold value.
}
\examples{
data(sce_chcl, package = "scds")
assay(sce_chcl, "countsTrimmed") <- trimCounts(assay(sce_chcl, "counts"),
                                               c(10, -10))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runBatchCorrection.R
\name{runZINBWaVE}
\alias{runZINBWaVE}
\title{Apply ZINBWaVE Batch effect correction method to SingleCellExperiment object}
\usage{
runZINBWaVE(
  inSCE,
  useAssay = "counts",
  batch = "batch",
  nHVG = 1000L,
  nComponents = 50L,
  epsilon = 1000,
  nIter = 10L,
  reducedDimName = "zinbwave",
  BPPARAM = BiocParallel::SerialParam()
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object}

\item{useAssay}{A single character indicating the name of the assay requiring
batch correction. Note that ZINBWaVE works for counts (integer) input rather
than logcounts that other methods prefer. Default \code{"counts"}.}

\item{batch}{A single character indicating a field in
\code{\link{colData}} that annotates the batches.
Default \code{"batch"}.}

\item{nHVG}{An integer. Number of highly variable genes to use when fitting
the model. Default \code{1000L}.}

\item{nComponents}{An integer. The number of principle components or
dimensionality to generate in the resulting matrix. Default \code{50L}.}

\item{epsilon}{An integer. Algorithmic parameter. Empirically, a high epsilon
is often required to obtained a good low-level representation. Default
\code{1000L}.}

\item{nIter}{An integer, The max number of iterations to perform. Default
\code{10L}.}

\item{reducedDimName}{A single character. The name for the corrected
low-dimensional representation. Will be saved to \code{reducedDim(inSCE)}.
Default \code{"zinbwave"}.}

\item{BPPARAM}{A \linkS4class{BiocParallelParam} object specifying whether
should be parallelized. Default \code{BiocParallel::SerialParam()}.}
}
\value{
The input \linkS4class{SingleCellExperiment} object with
\code{reducedDim(inSCE, reducedDimName)} updated.
}
\description{
A general and flexible zero-inflated negative binomial model that can be
used to provide a low-dimensional representations of scRNAseq data. The
model accounts for zero inflation (dropouts), over-dispersion, and the count
nature of the data. The model also accounts for the difference in library
sizes and optionally for batch effects and/or other covariates.
}
\examples{
data('sceBatches', package = 'singleCellTK')
\dontrun{
    sceCorr <- runZINBWaVE(sceBatches, nIter = 5)
}
}
\references{
Pollen, Alex A et al., 2014
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sctkTagging.R
\name{expSetDataTag}
\alias{expSetDataTag}
\title{expSetDataTag
Set tag to an assay or a data item in the input SCE object.}
\usage{
expSetDataTag(inSCE, assayType, assays)
}
\arguments{
\item{inSCE}{Input \code{SingleCellExperiment} object.}

\item{assayType}{Specify a \code{character(1)} value as a tag that should be set against a data item.}

\item{assays}{Specify name(s) \code{character()} of data item(s) against which the tag should be set.}
}
\value{
The input \code{SingleCellExperiment} object with tag information stored in the metadata slot.
}
\description{
expSetDataTag
Set tag to an assay or a data item in the input SCE object.
}
\examples{
data(scExample, package = "singleCellTK")
sce <- expSetDataTag(sce, "raw", "counts")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/importAnnData.R
\name{importAnnData}
\alias{importAnnData}
\title{Create a SingleCellExperiment Object from Python AnnData .h5ad files}
\usage{
importAnnData(
  sampleDirs = NULL,
  sampleNames = NULL,
  delayedArray = FALSE,
  class = c("Matrix", "matrix"),
  rowNamesDedup = TRUE
)
}
\arguments{
\item{sampleDirs}{Folder containing the .h5ad file. Can be one of -
\itemize{
  \item Default \code{current working directory}.
  \item Full path to the directory containing the .h5ad file.
  E.g \code{sampleDirs = '/path/to/sample'}
  \item A vector of folder paths for the samples to import.
  E.g. \code{sampleDirs = c('/path/to/sample1', '/path/to/sample2','/path/to/sample3')}
  importAnnData will return a single SCE object containing all the samples
  with the sample name appended to each colname in colData
}}

\item{sampleNames}{The prefix/name of the .h5ad file without the .h5ad extension
e.g. if 'sample.h5ad' is the filename, pass \code{sampleNames = 'sample'}.
Can be one of -
\itemize{
  \item Default \code{sample}.
  \item A vector of samples to import. Length of vector must be equal to length of sampleDirs vector
  E.g. \code{sampleDirs = c('sample1', 'sample2','sample3')}
  importAnnData will return a single SCE object containing all the samples
  with the sample name appended to each colname in colData
}}

\item{delayedArray}{Boolean. Whether to read the expression matrix as
\link{DelayedArray} object. Default \code{FALSE}.}

\item{class}{Character. The class of the expression matrix stored in the SCE
object. Can be one of "Matrix" (as returned by
\link{readMM} function), or "matrix" (as returned by
\link[base]{matrix} function). Default \code{"Matrix"}.}

\item{rowNamesDedup}{Boolean. Whether to deduplicate rownames. Default 
\code{TRUE}.}
}
\value{
A \code{SingleCellExperiment} object.
}
\description{
This function reads in one or more Python AnnData files in the .h5ad format
and returns a single \link[SingleCellExperiment]{SingleCellExperiment} object containing all the
AnnData samples by concatenating their counts matrices and related information slots.
}
\details{
\code{importAnnData} converts scRNA-seq data in the AnnData format to the
\code{SingleCellExperiment} object. The .X slot in AnnData is transposed to the features x cells
format and becomes the 'counts' matrix in the assay slot. The .vars AnnData slot becomes the SCE rowData
and the .obs AnnData slot becomes the SCE colData. Multidimensional data in the .obsm AnnData slot is
ported over to the SCE reducedDims slot. Additionally, unstructured data in the .uns AnnData slot is
available through the SCE metadata slot.
There are 2 currently known minor issues -
Anndata python module depends on another python module h5pyto read hd5 format files.
If there are errors reading the .h5ad files, such as "ValueError: invalid shape in fixed-type tuple."
the user will need to do downgrade h5py by running \code{pip3 install --user h5py==2.9.0}
Additionally there might be errors in converting some python objects in the unstructured data slots.
There are no known R solutions at present. Refer \url{https://github.com/rstudio/reticulate/issues/209}
}
\examples{
file.path <- system.file("extdata/annData_pbmc_3k", package = "singleCellTK")
\dontrun{
sce <- importAnnData(sampleDirs = file.path,
                     sampleNames = 'pbmc3k_20by20')
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runDEAnalysis.R
\name{runDEAnalysis}
\alias{runDEAnalysis}
\alias{runDESeq2}
\alias{runLimmaDE}
\alias{runANOVA}
\alias{runMAST}
\alias{runWilcox}
\title{Perform differential expression analysis on SCE object}
\usage{
runDEAnalysis(inSCE, method = "wilcox", ...)

runDESeq2(
  inSCE,
  useAssay = "counts",
  useReducedDim = NULL,
  index1 = NULL,
  index2 = NULL,
  class = NULL,
  classGroup1 = NULL,
  classGroup2 = NULL,
  analysisName,
  groupName1,
  groupName2,
  covariates = NULL,
  fullReduced = TRUE,
  onlyPos = FALSE,
  log2fcThreshold = NULL,
  fdrThreshold = NULL,
  minGroup1MeanExp = NULL,
  maxGroup2MeanExp = NULL,
  minGroup1ExprPerc = NULL,
  maxGroup2ExprPerc = NULL,
  overwrite = FALSE,
  verbose = TRUE
)

runLimmaDE(
  inSCE,
  useAssay = "logcounts",
  useReducedDim = NULL,
  index1 = NULL,
  index2 = NULL,
  class = NULL,
  classGroup1 = NULL,
  classGroup2 = NULL,
  analysisName,
  groupName1,
  groupName2,
  covariates = NULL,
  onlyPos = FALSE,
  log2fcThreshold = NULL,
  fdrThreshold = NULL,
  minGroup1MeanExp = NULL,
  maxGroup2MeanExp = NULL,
  minGroup1ExprPerc = NULL,
  maxGroup2ExprPerc = NULL,
  overwrite = FALSE,
  verbose = TRUE
)

runANOVA(
  inSCE,
  useAssay = "logcounts",
  useReducedDim = NULL,
  index1 = NULL,
  index2 = NULL,
  class = NULL,
  classGroup1 = NULL,
  classGroup2 = NULL,
  analysisName,
  groupName1,
  groupName2,
  covariates = NULL,
  onlyPos = FALSE,
  log2fcThreshold = NULL,
  fdrThreshold = NULL,
  minGroup1MeanExp = NULL,
  maxGroup2MeanExp = NULL,
  minGroup1ExprPerc = NULL,
  maxGroup2ExprPerc = NULL,
  overwrite = FALSE,
  verbose = TRUE
)

runMAST(
  inSCE,
  useAssay = "logcounts",
  useReducedDim = NULL,
  index1 = NULL,
  index2 = NULL,
  class = NULL,
  classGroup1 = NULL,
  classGroup2 = NULL,
  analysisName,
  groupName1,
  groupName2,
  covariates = NULL,
  onlyPos = FALSE,
  log2fcThreshold = NULL,
  fdrThreshold = NULL,
  minGroup1MeanExp = NULL,
  maxGroup2MeanExp = NULL,
  minGroup1ExprPerc = NULL,
  maxGroup2ExprPerc = NULL,
  overwrite = FALSE,
  check_sanity = TRUE,
  verbose = TRUE
)

runWilcox(
  inSCE,
  useAssay = "logcounts",
  useReducedDim = NULL,
  index1 = NULL,
  index2 = NULL,
  class = "cluster",
  classGroup1 = c(1),
  classGroup2 = c(2),
  analysisName = "cluster1_VS_2",
  groupName1 = "cluster1",
  groupName2 = "cluster2",
  covariates = NULL,
  onlyPos = FALSE,
  log2fcThreshold = NULL,
  fdrThreshold = NULL,
  minGroup1MeanExp = NULL,
  maxGroup2MeanExp = NULL,
  minGroup1ExprPerc = NULL,
  maxGroup2ExprPerc = NULL,
  overwrite = FALSE,
  verbose = TRUE
)
}
\arguments{
\item{inSCE}{\linkS4class{SingleCellExperiment} inherited object.}

\item{method}{Character. Specify which method to use when using
\code{runDEAnalysis()}. Choose from \code{"wilcox"}, \code{"MAST"},
\code{"DESeq2"}, \code{"Limma"}, \code{"ANOVA"}. Default \code{"wilcox"}.}

\item{...}{Arguments to pass to specific methods when using the generic
\code{runDEAnalysis()}.}

\item{useAssay}{character. A string specifying which assay to use for the
DE regression. Ignored when \code{useReducedDim} is specified. Default
\code{"counts"} for DESeq2, \code{"logcounts"} for other methods.}

\item{useReducedDim}{character. A string specifying which reducedDim to use
for DE analysis. Will treat the dimensions as features. Default \code{NULL}.}

\item{index1}{Any type of indices that can subset a
\linkS4class{SingleCellExperiment} inherited object by cells. Specifies
which cells are of interests. Default \code{NULL}.}

\item{index2}{Any type of indices that can subset a
\linkS4class{SingleCellExperiment} inherited object by cells. specifies
the control group against those specified by \code{index1}. If
\code{NULL} when using index specification, \code{index1} cells will be
compared with all other cells. Default \code{NULL}.}

\item{class}{A vector/factor with \code{ncol(inSCE)} elements, or a character
scalar that specifies a column name of \code{colData(inSCE)}. Default
\code{"cluster"}.}

\item{classGroup1}{a vector specifying which "levels" given in \code{class}
are of interests. Default \code{c(1)}.}

\item{classGroup2}{a vector specifying which "levels" given in \code{class}
is the control group against those specified by \code{classGroup1}. If
\code{NULL} when using annotation specification, \code{classGroup1} cells
will be compared with all other cells. Default \code{c(2)}.}

\item{analysisName}{A character scalar naming the DEG analysis. 
Default \code{"cluster1_VS_2"}.}

\item{groupName1}{A character scalar naming the group of interests. 
Default \code{"cluster1"}.}

\item{groupName2}{A character scalar naming the control group. 
Default \code{"cluster2"}.}

\item{covariates}{A character vector of additional covariates to use when
building the model. All covariates must exist in
\code{names(colData(inSCE))}. Default \code{NULL}.}

\item{fullReduced}{Logical, DESeq2 only argument. Whether to apply LRT
(Likelihood ratio test) with a 'full' model. Default \code{TRUE}.}

\item{onlyPos}{Whether to only output DEG with positive log2_FC value.
Default \code{FALSE}.}

\item{log2fcThreshold}{Only out put DEGs with the absolute values of log2FC
greater than this value. Default \code{NULL}.}

\item{fdrThreshold}{Only out put DEGs with FDR value less than this
value. Default \code{NULL}.}

\item{minGroup1MeanExp}{Only out put DEGs with mean expression in group1
greater then this value. Default \code{NULL}.}

\item{maxGroup2MeanExp}{Only out put DEGs with mean expression in group2
less then this value. Default \code{NULL}.}

\item{minGroup1ExprPerc}{Only out put DEGs expressed in greater then this
fraction of cells in group1. Default \code{NULL}.}

\item{maxGroup2ExprPerc}{Only out put DEGs expressed in less then this
fraction of cells in group2. Default \code{NULL}.}

\item{overwrite}{A logical scalar. Whether to overwrite result if exists.
Default \code{FALSE}.}

\item{verbose}{A logical scalar. Whether to show messages. Default
\code{TRUE}.}

\item{check_sanity}{Logical, MAST only argument. Whether to perform MAST's
sanity check to see if the counts are logged. Default \code{TRUE}.}
}
\value{
The input \linkS4class{SingleCellExperiment} object, where
\code{metadata(inSCE)$diffExp} is updated with a list named by
\code{analysisName}, with elements of:
\item{$groupNames}{the naming of the two conditions}
\item{$useAssay, $useReducedDim}{the matrix name that was used for
calculation}
\item{$select}{the cell selection indices (logical) for each condition}
\item{$result}{a \code{data.frame} of the DEGs table}
\item{$method}{the method used}
}
\description{
Perform differential expression analysis on SCE object
}
\details{
SCTK provides Limma, MAST, DESeq2, ANOVA and Wilcoxon test for differential
expression analysis, where DESeq2 expects non-negtive integer assay input
while others expect logcounts.

Condition specification allows two methods:
1. Index level selection. Only use arguments \code{index1} and \code{index2}.
2. Annotation level selection. Only use arguments \code{class},
\code{classGroup1} and \code{classGroup2}.
}
\examples{
data(scExample, package = "singleCellTK")
sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
sce <- scaterlogNormCounts(sce, assayName = "logcounts")
sce <- runDEAnalysis(method = "Limma", inSCE = sce, groupName1 = "group1",
 groupName2 = "group2", index1 = seq(20), index2 = seq(21,40),
 analysisName = "Limma")

}
\seealso{
See \code{\link{plotDEGHeatmap}}, \code{\link{plotDEGRegression}},
\code{\link{plotDEGViolin}} and \code{\link{plotDEGVolcano}} for
visualization method after running DE analysis.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/seuratFunctions.R
\name{plotSeuratHeatmap}
\alias{plotSeuratHeatmap}
\title{plotSeuratHeatmap
Modifies the heatmap plot object so it contains specified number of heatmaps
in a single plot}
\usage{
plotSeuratHeatmap(plotObject, dims, ncol, labels)
}
\arguments{
\item{plotObject}{plot object computed from runSeuratHeatmap() function}

\item{dims}{numerical value of how many heatmaps to draw (default is 0)}

\item{ncol}{numerical value indicating that in how many columns should the
heatmaps be distrbuted (default is 2)}

\item{labels}{list() of labels to draw on heatmaps}
}
\value{
modified plot object
}
\description{
plotSeuratHeatmap
Modifies the heatmap plot object so it contains specified number of heatmaps
in a single plot
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotTopHVG.R
\name{plotTopHVG}
\alias{plotTopHVG}
\title{Plot highly variable genes}
\usage{
plotTopHVG(
  inSCE,
  method = "modelGeneVar",
  hvgNumber = 2000,
  useFeatureSubset = NULL,
  labelsCount = 10,
  featureDisplay = metadata(inSCE)$featureDisplay,
  labelSize = 2,
  dotSize = 2,
  textSize = 12
)
}
\arguments{
\item{inSCE}{Input \code{SingleCellExperiment} object containing the
computations.}

\item{method}{Select either \code{"vst"}, \code{"mean.var.plot"},
\code{"dispersion"} or \code{"modelGeneVar"}.}

\item{hvgNumber}{Specify the number of top genes to highlight in red. Default
\code{2000}. See details.}

\item{useFeatureSubset}{A character string for the \code{rowData} variable
name to store a logical index of selected features. Default \code{NULL}. See
details.}

\item{labelsCount}{Specify the number of data points/genes to label. Should
be less than \code{hvgNumber}. Default \code{10}. See details.}

\item{featureDisplay}{A character string for the \code{rowData} variable name
to indicate what type of feature ID should be displayed. If set by
\code{\link{setSCTKDisplayRow}}, will by default use it. If \code{NULL}, will
use \code{rownames(inSCE)}.}

\item{labelSize}{Numeric, size of the text label on top HVGs. Default 
\code{2}.}

\item{dotSize}{Numeric, size of the dots of the features. Default \code{2}.}

\item{textSize}{Numeric, size of the text of axis title, axis label, etc.
Default \code{12}.}
}
\value{
ggplot of HVG metrics and top HVG labels
}
\description{
Plot highly variable genes
}
\details{
When \code{hvgNumber = NULL} and \code{useFeature = NULL}, only plot
the mean VS variance/dispersion scatter plot. When only \code{hvgNumber} set,
label the top \code{hvgNumber} HVGs ranked by the metrics calculated by
\code{method}. When \code{useFeatureSubset} set, label the features in
the subset on the scatter plot created with \code{method} and ignore
\code{hvgNumber}.
}
\examples{
data("mouseBrainSubsetSCE", package = "singleCellTK")
mouseBrainSubsetSCE <- runModelGeneVar(mouseBrainSubsetSCE)
plotTopHVG(mouseBrainSubsetSCE, method = "modelGeneVar")
}
\seealso{
\code{\link{runFeatureSelection}}, \code{\link{runSeuratFindHVG}},
\code{\link{runModelGeneVar}}, \code{\link{getTopHVG}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ggPlotting.R
\name{setSCTKDisplayRow}
\alias{setSCTKDisplayRow}
\title{Indicates which rowData to use for visualization}
\usage{
setSCTKDisplayRow(inSCE, featureDisplayRow)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object with saved
dimension reduction components or a variable with saved results. Required.}

\item{featureDisplayRow}{Indicates which column name of rowData to be used for plots.}
}
\value{
A SingleCellExperiment object with the specific column name of rowData
 to be used for plotting stored in metadata.
}
\description{
This function is to be used to specify which
}
\examples{
data(scExample, package="singleCellTK")
sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
sce <- setSCTKDisplayRow(inSCE = sce, featureDisplayRow = "feature_name")
plotSCEViolinAssayData(inSCE = sce, feature = "ENSG00000019582")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/combineSCE.R
\name{combineSCE}
\alias{combineSCE}
\title{Combine a list of SingleCellExperiment objects as one SingleCellExperiment object}
\usage{
combineSCE(sceList, by.r = NULL, by.c = NULL, combined = TRUE)
}
\arguments{
\item{sceList}{A list contains \link[SingleCellExperiment]{SingleCellExperiment} objects.
Currently, combineSCE function only support combining SCE objects with assay in dgCMatrix format.
It does not support combining SCE with assay in delayedArray format.}

\item{by.r}{Specifications of the columns used for merging rowData. If set as NULL, 
the rownames of rowData tables will be used to merging rowData. Default is NULL.}

\item{by.c}{Specifications of the columns used for merging colData. If set as NULL, 
the rownames of colData tables will be used to merging colData. Default is NULL.}

\item{combined}{logical; if TRUE, it will combine the list of SingleCellExperiment objects 
and return a SingleCellExperiment. If FALSE, it will return a list of SingleCellExperiment whose
rowData, colData, assay and reducedDim data slot are compatible within SCE objects in the list. 
Default is TRUE.}
}
\value{
A \link[SingleCellExperiment]{SingleCellExperiment} object which combines all
objects in sceList. The colData is merged.
}
\description{
Combine a list of SingleCellExperiment objects as one SingleCellExperiment object
}
\examples{
data(scExample, package = "singleCellTK")
combinedsce <- combineSCE(list(sce,sce), by.r = NULL, by.c = NULL, combined = TRUE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scanpyFunctions.R
\name{plotScanpyMarkerGenesHeatmap}
\alias{plotScanpyMarkerGenesHeatmap}
\title{plotScanpyMarkerGenesHeatmap}
\usage{
plotScanpyMarkerGenesHeatmap(
  inSCE,
  groups = NULL,
  groupBy,
  nGenes = 10,
  features = NULL,
  log2fcThreshold = NULL
)
}
\arguments{
\item{inSCE}{Input \code{SingleCellExperiment} object.}

\item{groups}{The groups for which to show the gene ranking. Default \code{NULL}
means that all groups will be considered.}

\item{groupBy}{The key of the observation grouping to consider. By default, 
the groupby is chosen from the rank genes groups parameter.}

\item{nGenes}{Number of genes to show. Default \code{10}}

\item{features}{Genes to plot. Sometimes is useful to pass a specific list of
var names (e.g. genes). The var_names could be a dictionary or a list.}

\item{log2fcThreshold}{Only output DEGs with the absolute values of log2FC
larger than this value. Default \code{NULL}.}
}
\value{
plot object
}
\description{
plotScanpyMarkerGenesHeatmap
}
\examples{
data(scExample, package = "singleCellTK")
\dontrun{
sce <- runScanpyNormalizeData(sce, useAssay = "counts")
sce <- runScanpyFindHVG(sce, useAssay = "scanpyNormData", method = "seurat")
sce <- runScanpyScaleData(sce, useAssay = "scanpyNormData")
sce <- runScanpyPCA(sce, useAssay = "scanpyScaledData")
sce <- runScanpyFindClusters(sce, useReducedDim = "scanpyPCA")
sce <- runScanpyFindMarkers(sce, colDataName = "Scanpy_louvain_1" )
plotScanpyMarkerGenesHeatmap(sce, groupBy = 'Scanpy_louvain_1')
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runFindMarker.R
\name{runFindMarker}
\alias{runFindMarker}
\alias{findMarkerDiffExp}
\title{Find the marker gene set for each cluster}
\usage{
runFindMarker(
  inSCE,
  useAssay = "logcounts",
  useReducedDim = NULL,
  method = "wilcox",
  cluster = "cluster",
  covariates = NULL,
  log2fcThreshold = NULL,
  fdrThreshold = 0.05,
  minClustExprPerc = NULL,
  maxCtrlExprPerc = NULL,
  minMeanExpr = NULL,
  detectThresh = 0
)

findMarkerDiffExp(
  inSCE,
  useAssay = "logcounts",
  useReducedDim = NULL,
  method = c("wilcox", "MAST", "DESeq2", "Limma", "ANOVA"),
  cluster = "cluster",
  covariates = NULL,
  log2fcThreshold = NULL,
  fdrThreshold = 0.05,
  minClustExprPerc = NULL,
  maxCtrlExprPerc = NULL,
  minMeanExpr = NULL,
  detectThresh = 0
)
}
\arguments{
\item{inSCE}{\linkS4class{SingleCellExperiment} inherited object.}

\item{useAssay}{character. A string specifying which assay to use for the
MAST calculations. Default \code{"logcounts"}.}

\item{useReducedDim}{character. A string specifying which reducedDim to use
for MAST calculations. Set \code{useAssay} to \code{NULL} when using.
Required.}

\item{method}{A single character for specific differential expression
analysis method. Choose from \code{'wilcox'}, \code{'MAST'}, \code{'DESeq2'},
\code{'Limma'}, and \code{'ANOVA'}. Default \code{"wilcox"}.}

\item{cluster}{One single character to specify a column in
\code{colData(inSCE)} for the clustering label. Alternatively, a vector or
a factor is also acceptable. Default \code{"cluster"}.}

\item{covariates}{A character vector of additional covariates to use when
building the model. All covariates must exist in
\code{names(colData(inSCE))}. Not applicable when \code{method} is
\code{"MAST"} method. Default \code{NULL}.}

\item{log2fcThreshold}{Only out put DEGs with the absolute values of log2FC
larger than this value. Default \code{NULL}}

\item{fdrThreshold}{Only out put DEGs with FDR value smaller than this
value. Default \code{NULL}}

\item{minClustExprPerc}{A numeric scalar. The minimum cutoff of the
percentage of cells in the cluster of interests that expressed the marker
gene. From 0 to 1. Default \code{NULL}.}

\item{maxCtrlExprPerc}{A numeric scalar. The maximum cutoff of the
percentage of cells out of the cluster (control group) that expressed the
marker gene. From 0 to 1. Default \code{NULL}.}

\item{minMeanExpr}{A numeric scalar. The minimum cutoff of the mean
expression value of the marker in the cluster of interests. Default
\code{NULL}.}

\item{detectThresh}{A numeric scalar, above which a matrix value will be
treated as expressed when calculating cluster/control expression percentage.
Default \code{0}.}
}
\value{
The input \linkS4class{SingleCellExperiment} object with
\code{metadata(inSCE)$findMarker} updated with a data.table of the up-
regulated DEGs for each cluster.
}
\description{
With an input SingleCellExperiment object and specifying the
clustering labels, this function iteratively call the differential expression
analysis on each cluster against all the others. \code{\link{runFindMarker}}
will be deprecated in the future.
}
\details{
The returned marker table, in the \code{metadata} slot, consists of 8
columns: \code{"Gene"}, \code{"Log2_FC"}, \code{"Pvalue"}, \code{"FDR"},
\code{cluster}, \code{"clusterExprPerc"}, \code{"ControlExprPerc"} and
\code{"clusterAveExpr"}.

\code{"clusterExprPerc"} is the fraction of cells,
that has marker value (e.g. gene expression counts) larger than
\code{detectThresh}, in the cell population of the cluster. As for each
cluster, we set all cells out of this cluster as control. Similarly,
\code{"ControlExprPerc"} is the fraction of cells with marker value larger
than \code{detectThresh} in the control cell group.
}
\examples{
data("mouseBrainSubsetSCE", package = "singleCellTK")
mouseBrainSubsetSCE <- runFindMarker(mouseBrainSubsetSCE,
                                     useAssay = "logcounts",
                                     cluster = "level1class")
}
\seealso{
\code{\link{runDEAnalysis}}, \code{\link{getFindMarkerTopTable}},
\code{\link{plotFindMarkerHeatmap}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scanpyFunctions.R
\name{plotScanpyPCA}
\alias{plotScanpyPCA}
\title{plotScanpyPCA}
\usage{
plotScanpyPCA(
  inSCE,
  reducedDimName = "scanpyPCA",
  color = NULL,
  title = "",
  legend = "right margin"
)
}
\arguments{
\item{inSCE}{Input \code{SingleCellExperiment} object.}

\item{reducedDimName}{Name of new reducedDims object containing Scanpy PCA.}

\item{color}{Keys for annotations of observations/cells or variables/genes.}

\item{title}{Provide title for panels either as string or list of strings}

\item{legend}{Location of legend, either 'on data', 'right margin' or a 
valid keyword for the loc parameter of Legend.}
}
\value{
plot object
}
\description{
plotScanpyPCA
}
\examples{
data(scExample, package = "singleCellTK")
\dontrun{
sce <- runScanpyNormalizeData(sce, useAssay = "counts")
sce <- runScanpyFindHVG(sce, useAssay = "scanpyNormData", method = "seurat")
sce <- runScanpyScaleData(sce, useAssay = "scanpyNormData")
sce <- runScanpyPCA(sce, useAssay = "scanpyScaledData")
plotScanpyPCA(sce)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/seuratFunctions.R
\name{runSeuratIntegration}
\alias{runSeuratIntegration}
\title{runSeuratIntegration
A wrapper function to Seurat Batch-Correction/Integration workflow.}
\usage{
runSeuratIntegration(
  inSCE,
  useAssay = "counts",
  batch,
  newAssayName = "SeuratIntegratedAssay",
  kAnchor,
  kFilter,
  kWeight,
  ndims = 10
)
}
\arguments{
\item{inSCE}{Input \code{SingleCellExperiment} object that contains the assay
to batch-correct.}

\item{useAssay}{Assay to batch-correct.}

\item{batch}{Batch variable from \code{colData} slot of
\code{SingleCellExperiment} object.}

\item{newAssayName}{Assay name for the batch-corrected output assay.}

\item{kAnchor}{Number of neighbours to use for finding the anchors in the
\link[Seurat]{FindIntegrationAnchors} function.}

\item{kFilter}{Number of neighbours to use for filtering the anchors in the
\link[Seurat]{FindIntegrationAnchors} function.}

\item{kWeight}{Number of neighbours to use when weigthing the anchors in the
\link[Seurat]{IntegrateData} function.}

\item{ndims}{Number of dimensions to use. Default \code{10}.}
}
\value{
A \code{SingleCellExperiment} object that contains the
batch-corrected assay inside the \code{altExp} slot of the object
}
\description{
runSeuratIntegration
A wrapper function to Seurat Batch-Correction/Integration workflow.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runTSCAN.R
\name{runTSCANDEG}
\alias{runTSCANDEG}
\title{Test gene expression changes along a TSCAN trajectory path}
\usage{
runTSCANDEG(inSCE, pathIndex, useAssay = "logcounts", discardCluster = NULL)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object.}

\item{pathIndex}{Path index for which the pseudotime values should be used.
This corresponds to the terminal node of specific path from the root
node to the terminal node. Run \code{listTSCANTerminalNodes(inSCE)} for
available options.}

\item{useAssay}{Character. The name of the assay to use for testing the
expression change. Should be log-normalized. Default \code{"logcounts"}}

\item{discardCluster}{Cluster(s) which are not of use or masks other
interesting effects can be discarded. Default \code{NULL}.}
}
\value{
The input \code{inSCE} with results updated in \code{metadata}.
}
\description{
Wrapper for identifying genes with significant changes with
respect to one of the TSCAN pseudotime paths
}
\examples{
data("mouseBrainSubsetSCE", package = "singleCellTK")
mouseBrainSubsetSCE <- runTSCAN(inSCE = mouseBrainSubsetSCE,
                                useReducedDim = "PCA_logcounts")
terminalNodes <- listTSCANTerminalNodes(mouseBrainSubsetSCE)
mouseBrainSubsetSCE <- runTSCANDEG(inSCE = mouseBrainSubsetSCE,
                                   pathIndex = terminalNodes[1])
}
\author{
Nida Pervaiz
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/importGeneSets.R
\name{importGeneSetsFromMSigDB}
\alias{importGeneSetsFromMSigDB}
\title{Imports gene sets from MSigDB}
\usage{
importGeneSetsFromMSigDB(
  inSCE,
  categoryIDs = "H",
  species = "Homo sapiens",
  mapping = c("gene_symbol", "human_gene_symbol", "entrez_gene"),
  by = "rownames",
  verbose = TRUE,
  noMatchError = TRUE
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object.}

\item{categoryIDs}{Character vector containing the MSigDB gene set ids.
The column \code{ID} in the table returned by \code{getMSigDBTable()} shows
the list of possible gene set IDs that can be obtained.
Default is \code{"H"}.}

\item{species}{Character. Species available can be found using the function
\code{\link[msigdbr]{msigdbr_species}}. Default \code{"Homo sapiens"}.}

\item{mapping}{Character. One of "gene_symbol", "human_gene_symbol", or
"entrez_gene". Gene identifiers to be used for MSigDB gene sets. IDs
denoted by the \code{by} parameter must be either in gene symbol or
Entrez gene id format to match IDs from MSigDB.}

\item{by}{Character. Describes the
location within \code{inSCE} where the gene identifiers in
the MSigDB gene sets should be mapped. If set to \code{"rownames"} then the
features will be searched for among \code{rownames(inSCE)}. This can also be
set to one of the column names of \code{rowData(inSCE)} in which case the
gene identifies will be mapped to that column in the \code{rowData}
of \code{inSCE}. See \link{featureIndex} for more information.
Default \code{"rownames"}.}

\item{verbose}{Boolean. Whether to display progress. Default \code{TRUE}.}

\item{noMatchError}{Boolean. Show an error if a collection does not have
any matching features. Default \code{TRUE}.}
}
\value{
A \link[SingleCellExperiment]{SingleCellExperiment} object
with gene set from \code{collectionName} output stored to the
\link{metadata} slot.
}
\description{
Gets a list of MSigDB gene sets stores it in the metadata of the
\linkS4class{SingleCellExperiment} object. These gene sets can be used in
downstream quality control and analysis functions in \link{singleCellTK}.
}
\details{
The gene identifiers in gene sets from MSigDB will be retrieved
using the \code{\link{msigdbr}} package. They will be mapped to the IDs in
\code{inSCE} using the \code{by} parameter and
stored in a \linkS4class{GeneSetCollection} object from package
\link{GSEABase}. This object is stored in
\code{metadata(inSCE)$sctk$genesets}, which can be accessed in downstream
analysis functions such as \link[singleCellTK]{runCellQC}.
}
\examples{
data(scExample)
sce <- importGeneSetsFromMSigDB(inSCE = sce,
                                categoryIDs = "H",
                                species = "Homo sapiens",
                                mapping = "gene_symbol",
                                by = "feature_name")
}
\seealso{
\link{importGeneSetsFromList} for importing from lists,
\link{importGeneSetsFromGMT} for importing from GMT files, and
\linkS4class{GeneSetCollection} objects.
}
\author{
Joshua D. Campbell
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/importCellRanger.R
\name{importCellRanger}
\alias{importCellRanger}
\alias{importCellRangerV2}
\alias{importCellRangerV3}
\title{Construct SCE object from Cell Ranger output}
\usage{
importCellRanger(
  cellRangerDirs = NULL,
  sampleDirs = NULL,
  sampleNames = NULL,
  cellRangerOuts = NULL,
  dataType = c("filtered", "raw"),
  matrixFileNames = "matrix.mtx.gz",
  featuresFileNames = "features.tsv.gz",
  barcodesFileNames = "barcodes.tsv.gz",
  gzipped = "auto",
  class = c("Matrix", "matrix"),
  delayedArray = FALSE,
  rowNamesDedup = TRUE
)

importCellRangerV2(
  cellRangerDirs = NULL,
  sampleDirs = NULL,
  sampleNames = NULL,
  dataTypeV2 = c("filtered", "raw"),
  class = c("Matrix", "matrix"),
  delayedArray = FALSE,
  reference = NULL,
  cellRangerOutsV2 = NULL,
  rowNamesDedup = TRUE
)

importCellRangerV3(
  cellRangerDirs = NULL,
  sampleDirs = NULL,
  sampleNames = NULL,
  dataType = c("filtered", "raw"),
  class = c("Matrix", "matrix"),
  delayedArray = FALSE,
  rowNamesDedup = TRUE
)
}
\arguments{
\item{cellRangerDirs}{The root directories where Cell Ranger was run. These
folders should contain sample specific folders. Default \code{NULL},
meaning the paths for each sample will be specified in \emph{samples}
argument.}

\item{sampleDirs}{Default \code{NULL}. Can be one of
\itemize{
  \item \code{NULL}. All samples within \code{cellRangerDirs} will be
   imported. The order of samples will be first determined by the order of
   \code{cellRangerDirs} and then by \link{list.dirs}. This is only
   for the case where \code{cellRangerDirs} is specified.
  \item A list of vectors containing the folder names for samples to import.
   Each vector in
   the list corresponds to samples from one of \code{cellRangerDirs}.
   These names are the same as the folder names under \code{cellRangerDirs}.
   This is only for the case where \code{cellRangerDirs} is specified.
  \item A vector of folder paths for the samples to import. This is only for
   the case where \code{cellRangerDirs} is \code{NULL}.
}
The cells in the final SCE object will be ordered in the same order of
 \code{sampleDirs}.}

\item{sampleNames}{A vector of user-defined sample names for the samples
to be
imported. Must have the same length as \code{length(unlist(sampleDirs))} if
\code{sampleDirs} is not \code{NULL}. Otherwise, make sure the length and
order match the output of
\code{unlist(lapply(cellRangerDirs, list.dirs, recursive = FALSE))}. Default
\code{NULL}, in which case the folder names will be used as sample names.}

\item{cellRangerOuts}{Character vector. The intermediate
paths to filtered or raw cell barcode, feature, and matrix files
for each sample. \strong{Supercedes \code{dayaType}}. If \code{NULL},
\code{dataType}
will be used to determine Cell Ranger output directory. If not \code{NULL},
\code{dataType} will be ingored and \code{cellRangerOuts} specifies the
paths. Must have length 1 or the same length as
\code{length(unlist(sampleDirs))} if
\code{sampleDirs} is not \code{NULL}. Otherwise, make sure the length and
order match the output of
\code{unlist(lapply(cellRangerDirs, list.dirs, recursive = FALSE))}.
Reference genome names might need to be
appended for CellRanger version below 3.0.0 if reads were mapped to
multiple genomes when running Cell Ranger pipeline. Probable options
include "outs/filtered_feature_bc_matrix/", "outs/raw_feature_bc_matrix/",
"outs/filtered_gene_bc_matrix/", "outs/raw_gene_bc_matrix/".}

\item{dataType}{Character. The type of data to import. Can be one of
"filtered" (which is equivalent to
\code{cellRangerOuts = "outs/filtered_feature_bc_matrix/"} or
\code{cellRangerOuts = "outs/filtered_gene_bc_matrix/"}) or "raw" (which
is equivalent to
\code{cellRangerOuts = "outs/raw_feature_bc_matrix/"} or
\code{cellRangerOuts = "outs/raw_gene_bc_matrix/"}). Default
"filtered" which imports the counts for filtered cell barcodes only.}

\item{matrixFileNames}{Character vector. Filenames for the Market Exchange
Format (MEX) sparse matrix files (matrix.mtx or matrix.mtx.gz files).
Must have length 1 or the same
length as \code{length(unlist(sampleDirs))} if
\code{sampleDirs} is not \code{NULL}. Otherwise, make sure the length and
order match the output of
\code{unlist(lapply(cellRangerDirs, list.dirs, recursive = FALSE))}.}

\item{featuresFileNames}{Character vector. Filenames for the feature
annotation files. They are usually named \emph{features.tsv.gz} or
\emph{genes.tsv}. Must have length 1 or the same
length as \code{length(unlist(sampleDirs))} if
\code{sampleDirs} is not \code{NULL}. Otherwise, make sure the length and
order match the output of
\code{unlist(lapply(cellRangerDirs, list.dirs, recursive = FALSE))}.}

\item{barcodesFileNames}{Character vector. Filename for the cell barcode
list files. They are usually named \emph{barcodes.tsv.gz} or
\emph{barcodes.tsv}. Must have length 1 or the same
length as \code{length(unlist(sampleDirs))} if
\code{sampleDirs} is not \code{NULL}. Otherwise, make sure the length and
order match the output of
\code{unlist(lapply(cellRangerDirs, list.dirs, recursive = FALSE))}.}

\item{gzipped}{\code{TRUE} if the Cell Ranger output files
(barcodes.tsv, features.tsv, and matrix.mtx) were
gzip compressed. \code{FALSE} otherwise. This is true after Cell Ranger
3.0.0 update. Default \code{"auto"} which automatically detects if the
files are gzip compressed. If not \code{"auto"}, \code{gzipped} must have
length 1 or the same
length as \code{length(unlist(sampleDirs))} if
\code{sampleDirs} is not \code{NULL}. Otherwise, make sure the length and
order match the output of
\code{unlist(lapply(cellRangerDirs, list.dirs, recursive = FALSE))}.}

\item{class}{Character. The class of the expression matrix stored in the SCE
object. Can be one of "Matrix" (as returned by
\link{readMM} function), or "matrix" (as returned by
\link[base]{matrix} function). Default \code{"Matrix"}.}

\item{delayedArray}{Boolean. Whether to read the expression matrix as
\link{DelayedArray} object or not. Default \code{FALSE}.}

\item{rowNamesDedup}{Boolean. Whether to deduplicate rownames. Default 
\code{TRUE}.}

\item{dataTypeV2}{Character. The type of output to import for
Cellranger version below 3.0.0. Whether to import the filtered or the
raw data. Can be one of 'filtered' or 'raw'. Default 'filtered'. When
\code{cellRangerOuts} is specified, \code{dataTypeV2} and \code{reference} will
be ignored.}

\item{reference}{Character vector. The reference genome names.
Default \code{NULL}. If not \code{NULL}, it must gave the length and order as
\code{length(unlist(sampleDirs))} if \code{sampleDirs} is not \code{NULL}.
Otherwise, make sure the length and order match the output of
\code{unlist(lapply(cellRangerDirs, list.dirs, recursive = FALSE))}. Only needed
for Cellranger version below 3.0.0.}

\item{cellRangerOutsV2}{Character vector. The intermediate paths
to filtered or raw cell barcode, feature, and matrix files for each
sample for Cellranger version below 3.0.0. If \code{NULL}, \code{reference} and
\code{dataTypeV2} will be used to determine Cell Ranger output directory. If it has
length 1, it assumes that all samples use the same genome reference and
the function will load only filtered or raw data.}
}
\value{
A \code{SingleCellExperiment} object containing the combined count
 matrix, the feature annotations, and the cell annotation.
}
\description{
Read the filtered barcodes, features, and matrices for all
 samples from (preferably a single run of) Cell Ranger output. Import and
 combine them
 as one big \link[SingleCellExperiment]{SingleCellExperiment} object.
}
\details{
\code{importCellRangerV2} imports output from Cell Ranger V2.
 \code{importCellRangerV2Sample} imports output from one sample from Cell
 Ranger V2.
 \code{importCellRangerV3} imports output from Cell Ranger V3.
 \code{importCellRangerV3} imports output from one sample from Cell Ranger
 V3.
 Some implicit
 assumptions which match the output structure of Cell Ranger V2 & V3
 are made in these 4 functions including \code{cellRangerOuts},
 \code{matrixFileName}, \code{featuresFileName}, \code{barcodesFileName},
 and \code{gzipped}.
 Alternatively, user can call \code{importCellRanger} to explicitly
 specify these arguments.
}
\examples{
# Example #1
# The following filtered feature, cell, and matrix files were downloaded from
# https://support.10xgenomics.com/single-cell-gene-expression/datasets/
# 3.0.0/hgmm_1k_v3
# The top 10 hg19 & mm10 genes are included in this example.
# Only the first 20 cells are included.
sce <- importCellRanger(
    cellRangerDirs = system.file("extdata/", package = "singleCellTK"),
    sampleDirs = "hgmm_1k_v3_20x20",
    sampleNames = "hgmm1kv3",
    dataType = "filtered")
# The following filtered feature, cell, and matrix files were downloaded from
# https://support.10xgenomics.com/single-cell-gene-expression/datasets/
# 2.1.0/pbmc4k
# Top 20 genes are kept. 20 cell barcodes are extracted.
sce <- importCellRangerV2(
    cellRangerDirs = system.file("extdata/", package = "singleCellTK"),
    sampleDirs = "pbmc_4k_v2_20x20",
    sampleNames = "pbmc4k_20",
    reference = 'GRCh38',
    dataTypeV2 = "filtered")
sce <- importCellRangerV3(
    cellRangerDirs = system.file("extdata/", package = "singleCellTK"),
    sampleDirs = "hgmm_1k_v3_20x20",
    sampleNames = "hgmm1kv3",
    dataType = "filtered")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sctkQCUtils.R
\name{generateMeta}
\alias{generateMeta}
\title{Generate HTAN manifest file for droplet and cell count data}
\usage{
generateMeta(
  dropletSCE = NULL,
  cellSCE = NULL,
  samplename,
  dir,
  HTAN = TRUE,
  dataType = c("Droplet", "Cell", "Both")
)
}
\arguments{
\item{dropletSCE}{A \link[SingleCellExperiment]{SingleCellExperiment} object containing
droplet count matrix data}

\item{cellSCE}{A \link[SingleCellExperiment]{SingleCellExperiment} object containing
cell count matrix data}

\item{samplename}{The sample name of the \link[SingleCellExperiment]{SingleCellExperiment} objects}

\item{dir}{The output directory of the SCTK QC pipeline.}

\item{HTAN}{Whether generates manifest file including HTAN specific ID (HTAN Biospecimen ID, 
HTAN parent file ID and HTAN patient ID). Default is TRUE.}

\item{dataType}{Type of the input data. It can be one of "Droplet", "Cell" or "Both".}
}
\value{
A \link[SingleCellExperiment]{SingleCellExperiment} object which combines all
objects in sceList. The colData is merged.
}
\description{
Generate HTAN manifest file for droplet and cell count data
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/seuratFunctions.R
\name{getSeuratVariableFeatures}
\alias{getSeuratVariableFeatures}
\title{Get variable feature names after running runSeuratFindHVG function}
\usage{
getSeuratVariableFeatures(inSCE)
}
\arguments{
\item{inSCE}{Input \code{SingleCellExperiment} object.}
}
\value{
A list of variable feature names.
}
\description{
Get variable feature names after running runSeuratFindHVG function
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scanpyFunctions.R
\name{runScanpyScaleData}
\alias{runScanpyScaleData}
\title{runScanpyScaleData
Scales the input sce object according to the input parameters}
\usage{
runScanpyScaleData(
  inSCE,
  useAssay = "scanpyNormData",
  scaledAssayName = "scanpyScaledData"
)
}
\arguments{
\item{inSCE}{(sce) object to scale}

\item{useAssay}{Assay containing normalized counts to scale.}

\item{scaledAssayName}{Name of new assay containing scaled data. Default
\code{scanpyScaledData}.}
}
\value{
Scaled \code{SingleCellExperiment} object
}
\description{
runScanpyScaleData
Scales the input sce object according to the input parameters
}
\examples{
data(scExample, package = "singleCellTK")
\dontrun{
sce <- runScanpyNormalizeData(sce, useAssay = "counts")
sce <- runScanpyScaleData(sce, useAssay = "scanpyNormData")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dropletUtils_emptyDrops.R
\name{runEmptyDrops}
\alias{runEmptyDrops}
\title{Identify empty droplets using \link[DropletUtils]{emptyDrops}.}
\usage{
runEmptyDrops(
  inSCE,
  sample = NULL,
  useAssay = "counts",
  lower = 100,
  niters = 10000,
  testAmbient = FALSE,
  ignore = NULL,
  alpha = NULL,
  retain = NULL,
  barcodeArgs = list(),
  BPPARAM = BiocParallel::SerialParam()
)
}
\arguments{
\item{inSCE}{A \linkS4class{SingleCellExperiment} object. Must contain a raw 
counts matrix before empty droplets have been removed.}

\item{sample}{Character vector or colData variable name. Indicates which 
sample each cell belongs to. Default \code{NULL}.}

\item{useAssay}{A string specifying which assay in the SCE to use. Default 
\code{"counts"}}

\item{lower}{See \link[DropletUtils]{emptyDrops} for more information. 
Default \code{100}.}

\item{niters}{See \link[DropletUtils]{emptyDrops} for more information. 
Default \code{10000}.}

\item{testAmbient}{See \link[DropletUtils]{emptyDrops} for more information. 
Default \code{FALSE}.}

\item{ignore}{See \link[DropletUtils]{emptyDrops} for more information. 
Default \code{NULL}.}

\item{alpha}{See \link[DropletUtils]{emptyDrops} for more information. 
Default \code{NULL}.}

\item{retain}{See \link[DropletUtils]{emptyDrops} for more information. 
Default \code{NULL}.}

\item{barcodeArgs}{See \link[DropletUtils]{emptyDrops} for more information. 
Default \code{list()}.}

\item{BPPARAM}{See \link[DropletUtils]{emptyDrops} for more information. 
Default \code{BiocParallel::SerialParam()}.}
}
\value{
A \linkS4class{SingleCellExperiment} object with the
\link[DropletUtils]{emptyDrops} output table appended to the
\link{colData} slot. The columns include
\code{emptyDrops_total}, \code{emptyDrops_logprob},
\code{emptyDrops_pvalue}, \code{emptyDrops_limited}, \code{emptyDrops_fdr}.
Please refer to the documentation of \link[DropletUtils]{emptyDrops} for
details.
}
\description{
Run \link[DropletUtils]{emptyDrops} on the count matrix in the
provided \linkS4class{SingleCellExperiment} object.
Distinguish between droplets containing cells and ambient RNA in a
droplet-based single-cell RNA sequencing experiment.
}
\examples{
data(scExample, package = "singleCellTK")
sce <- runEmptyDrops(inSCE = sce)
}
\seealso{
\code{\link{runDropletQC}}, \code{\link{plotEmptyDropsResults}},
\code{\link{plotEmptyDropsScatter}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sctkQCUtils.R
\name{getSceParams}
\alias{getSceParams}
\title{Extract QC parameters from the SingleCellExperiment object}
\usage{
getSceParams(
  inSCE,
  skip = c("runScrublet", "runDecontX", "runBarcodeRanksMetaOutput", "genesets",
    "runSoupX"),
  ignore = c("algorithms", "estimates", "contamination", "z", "sample", "rank",
    "BPPARAM", "batch", "geneSetCollection", "barcodeArgs"),
  directory = "./",
  samplename = "",
  writeYAML = TRUE
)
}
\arguments{
\item{inSCE}{A \link[SingleCellExperiment]{SingleCellExperiment} object.}

\item{skip}{Skip extracting the parameters of the provided QC functions.}

\item{ignore}{Skip extracting the content within QC functions.}

\item{directory}{The output directory of the SCTK_runQC.R pipeline.}

\item{samplename}{The sample name of the \link[SingleCellExperiment]{SingleCellExperiment} objects.}

\item{writeYAML}{Whether output yaml file to store parameters. Default if TRUE. If FALSE,
return character object.}
}
\value{
If \code{writeYAML} TRUE, a yaml object will be generated. If FALSE, character object.
}
\description{
Extract QC parameters from the SingleCellExperiment object
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/seuratFunctions.R
\name{convertSeuratToSCE}
\alias{convertSeuratToSCE}
\title{convertSeuratToSCE
Converts the input seurat object to a sce object}
\usage{
convertSeuratToSCE(
  seuratObject,
  normAssayName = "seuratNormData",
  scaledAssayName = "seuratScaledData"
)
}
\arguments{
\item{seuratObject}{Input Seurat object}

\item{normAssayName}{Name of assay to store the normalized data. Default
\code{"seuratNormData"}.}

\item{scaledAssayName}{Name of assay to store the scaled data. Default
\code{"seuratScaledData"}.}
}
\value{
\code{SingleCellExperiment} output object
}
\description{
convertSeuratToSCE
Converts the input seurat object to a sce object
}
\examples{
data(scExample, package = "singleCellTK")
seurat <- convertSCEToSeurat(sce)
sce <- convertSeuratToSCE(seurat)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/importGeneSets.R
\name{importGeneSetsFromGMT}
\alias{importGeneSetsFromGMT}
\title{Imports gene sets from a GMT file}
\usage{
importGeneSetsFromGMT(
  inSCE,
  file,
  collectionName = "GeneSetCollection",
  by = "rownames",
  sep = "\\t",
  noMatchError = TRUE
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object.}

\item{file}{Character. Path to GMT file. See \link{getGmt} for
more information on reading GMT files.}

\item{collectionName}{Character. Name of collection to add gene sets to.
If this collection already exists in \code{inSCE}, then these gene sets will
be added to that collection. Any gene sets within the collection with the
same name will be overwritten. Default \code{GeneSetCollection}.}

\item{by}{Character, character vector, or NULL. Describes the
location within \code{inSCE} where the gene identifiers in
\code{geneSetList} should be mapped. If set to \code{"rownames"} then the
features will be searched for among \code{rownames(inSCE)}. This can also be
set to one of the column names of \code{rowData(inSCE)} in which case the
gene identifies will be mapped to that column in the \code{rowData}
of \code{inSCE}. \code{by} can be a vector the same length as
the number of gene sets in the GMT file and the elements of the vector
can point to different locations within \code{inSCE}. Finally, \code{by}
can be \code{NULL}. In this case, the location of the gene identifiers
in \code{inSCE} should be saved in the description (2nd column)
of the GMT file. See \link{featureIndex} for more information.
Default \code{"rownames"}.}

\item{sep}{Character. Delimiter of the GMT file. Default \code{"\t"}.}

\item{noMatchError}{Boolean. Show an error if a collection does not have
any matching features. Default \code{TRUE}.}
}
\value{
A \link[SingleCellExperiment]{SingleCellExperiment} object
 with gene set from \code{collectionName} output stored to the
 \link{metadata} slot.
}
\description{
Converts a list of gene sets stored in a GMT file into a
\linkS4class{GeneSetCollection} and stores it in the metadata of the
\linkS4class{SingleCellExperiment} object. These gene sets can be used in
downstream quality control and analysis functions in \link{singleCellTK}.
}
\details{
The gene identifiers in gene sets in the GMT file will be
mapped to the rownames of \code{inSCE} using the \code{by} parameter and
stored in a \linkS4class{GeneSetCollection} object from package
\link{GSEABase}. This object is stored in
\code{metadata(inSCE)$sctk$genesets}, which can be accessed in downstream
analysis functions such as \link[singleCellTK]{runCellQC}.
}
\examples{
data(scExample)

# GMT file containing gene symbols for a subset of human mitochondrial genes
gmt <- system.file("extdata/mito_subset.gmt", package = "singleCellTK")

# "feature_name" is the second column in the GMT file, so the ids will
# be mapped using this column in the 'rowData' of 'sce'. This
# could also be accomplished by setting by = "feature_name" in the
# function call.
sce <- importGeneSetsFromGMT(inSCE = sce, file = gmt, by = NULL)
}
\seealso{
\link{importGeneSetsFromList} for importing from lists,
\link{importGeneSetsFromCollection} for importing from
\linkS4class{GeneSetCollection} objects, and
\link{importGeneSetsFromMSigDB} for importing MSigDB gene sets.
}
\author{
Joshua D. Campbell
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/seuratFunctions.R
\name{runSeuratUMAP}
\alias{runSeuratUMAP}
\title{runSeuratUMAP
Computes UMAP from the given sce object and stores the UMAP computations back
into the sce object}
\usage{
runSeuratUMAP(
  inSCE,
  useReduction = c("pca", "ica"),
  reducedDimName = "seuratUMAP",
  dims = 10,
  minDist = 0.3,
  nNeighbors = 30L,
  spread = 1,
  externalReduction = NULL,
  seed = 42,
  verbose = TRUE
)
}
\arguments{
\item{inSCE}{(sce) object on which to compute the UMAP}

\item{useReduction}{Reduction to use for computing UMAP. One of "pca" or
"ica". Default is \code{"pca"}.}

\item{reducedDimName}{Name of new reducedDims object containing Seurat UMAP
Default \code{seuratUMAP}.}

\item{dims}{Numerical value of how many reduction components to use for UMAP
computation. Default \code{10}.}

\item{minDist}{Sets the \code{"min.dist"} parameter to the underlying UMAP
call. See \link[Seurat]{RunUMAP} for more information. Default \code{0.3}.}

\item{nNeighbors}{Sets the \code{"n.neighbors"} parameter to the underlying
UMAP call. See \link[Seurat]{RunUMAP} for more information. Default
\code{30L}.}

\item{spread}{Sets the \code{"spread"} parameter to the underlying UMAP call.
See \link[Seurat]{RunUMAP} for more information. Default \code{1}.}

\item{externalReduction}{Pass DimReduc object if PCA/ICA computed through
other libraries. Default \code{NULL}.}

\item{seed}{Random seed for reproducibility of results.
Default \code{42}.}

\item{verbose}{Logical value indicating if informative messages should
be displayed. Default is \code{TRUE}.}
}
\value{
Updated sce object with UMAP computations stored
}
\description{
runSeuratUMAP
Computes UMAP from the given sce object and stores the UMAP computations back
into the sce object
}
\examples{
data(scExample, package = "singleCellTK")
\dontrun{
sce <- runSeuratNormalizeData(sce, useAssay = "counts")
sce <- runSeuratFindHVG(sce, useAssay = "counts")
sce <- runSeuratScaleData(sce, useAssay = "counts")
sce <- runSeuratPCA(sce, useAssay = "counts")
sce <- runSeuratFindClusters(sce, useAssay = "counts")
sce <- runSeuratUMAP(sce, useReduction = "pca")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ggPlotting.R
\name{plotSCEBarAssayData}
\alias{plotSCEBarAssayData}
\title{Bar plot of assay data.}
\usage{
plotSCEBarAssayData(
  inSCE,
  feature,
  sample = NULL,
  useAssay = "counts",
  featureLocation = NULL,
  featureDisplay = NULL,
  groupBy = NULL,
  xlab = NULL,
  ylab = NULL,
  axisSize = 10,
  axisLabelSize = 10,
  dotSize = 0.1,
  transparency = 1,
  defaultTheme = TRUE,
  gridLine = FALSE,
  summary = NULL,
  title = NULL,
  titleSize = NULL,
  combinePlot = TRUE
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object with saved
dimension reduction components or a variable with saved results. Required.}

\item{feature}{Name of feature stored in assay of SingleCellExperiment
object.}

\item{sample}{Character vector. Indicates which sample each cell belongs to.}

\item{useAssay}{Indicate which assay to use. Default "counts".}

\item{featureLocation}{Indicates which column name of rowData to query gene.}

\item{featureDisplay}{Indicates which column name of rowData to use
to display feature for visualization.}

\item{groupBy}{Groupings for each numeric value. A user may input a vector
equal length to the number of the samples in the SingleCellExperiment
object, or can be retrieved from the colData slot. Default NULL.}

\item{xlab}{Character vector. Label for x-axis. Default NULL.}

\item{ylab}{Character vector. Label for y-axis. Default NULL.}

\item{axisSize}{Size of x/y-axis ticks. Default 10.}

\item{axisLabelSize}{Size of x/y-axis labels. Default 10.}

\item{dotSize}{Size of dots. Default 0.1.}

\item{transparency}{Transparency of the dots, values will be 0-1. Default 1.}

\item{defaultTheme}{Removes grid in plot and sets axis title size to 10
when TRUE. Default TRUE.}

\item{gridLine}{Adds a horizontal grid line if TRUE. Will still be
drawn even if defaultTheme is TRUE. Default FALSE.}

\item{summary}{Adds a summary statistic, as well as a crossbar to the
violin plot. Options are "mean" or "median". Default NULL.}

\item{title}{Title of plot. Default NULL.}

\item{titleSize}{Size of title of plot. Default 15.}

\item{combinePlot}{Boolean. If multiple plots are generated (multiple
samples, etc.), will combined plots using `cowplot::plot_grid`.
Default TRUE.}
}
\value{
a ggplot of the barplot of assay data.
}
\description{
Visualizes values stored in the assay slot of a
 SingleCellExperiment object via a bar plot.
}
\examples{
data("mouseBrainSubsetSCE")
plotSCEBarAssayData(
  inSCE = mouseBrainSubsetSCE,
  feature = "Apoe", groupBy = "sex"
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runPerCellQC.R
\name{runPerCellQC}
\alias{runPerCellQC}
\title{Wrapper for calculating QC metrics with scater.}
\usage{
runPerCellQC(
  inSCE,
  useAssay = "counts",
  mitoGeneLocation = "rownames",
  mitoRef = c(NULL, "human", "mouse"),
  mitoIDType = c("ensembl", "symbol", "entrez", "ensemblTranscriptID"),
  mitoPrefix = "MT-",
  mitoID = NULL,
  collectionName = NULL,
  geneSetList = NULL,
  geneSetListLocation = "rownames",
  geneSetCollection = NULL,
  percent_top = c(50, 100, 200, 500),
  use_altexps = FALSE,
  flatten = TRUE,
  detectionLimit = 0,
  BPPARAM = BiocParallel::SerialParam()
)
}
\arguments{
\item{inSCE}{A \linkS4class{SingleCellExperiment} object.}

\item{useAssay}{A string specifying which assay in the SCE to use. Default
\code{"counts"}.}

\item{mitoGeneLocation}{Character. Describes the location within \code{inSCE}
where the gene identifiers in the mitochondrial gene sets should be located.
If set to \code{"rownames"} then the features will be searched for among 
\code{rownames(inSCE)}. This can also be set to one of the column names of 
\code{rowData(inSCE)} in which case the gene identifies will be mapped to 
that column in the \code{rowData} of \code{inSCE}. See 
\code{\link{featureIndex}} for more information. If this parameter is set to
\code{NULL}, then no mitochondrial metrics will be calculated.
Default \code{"rownames"}.}

\item{mitoRef}{Character. The species used to extract mitochondrial genes ID 
from build-in mitochondrial geneset in SCTK. Available species options are 
\code{"human"} and \code{"mouse"}. Default is \code{"human"}.}

\item{mitoIDType}{Character. Types of mitochondrial gene id. SCTK supports 
\code{"symbol"}, \code{"entrez"}, \code{"ensembl"} and 
\code{"ensemblTranscriptID"}. It is used with \code{mitoRef} to extract 
mitochondrial genes from build-in mitochondrial geneset in SCTK. Default 
\code{NULL}.}

\item{mitoPrefix}{Character. The prefix used to get mitochondrial gene from 
either \code{rownames(inSCE)} or columns of \code{rowData(inSCE)} specified 
by \code{mitoGeneLocation}. This parameter is usually used to extract mitochondrial 
genes from the gene symbol. For example, \code{mitoPrefix = "^MT-"} can be used 
to detect mito gene symbols like "MT-ND4". Note that case is ignored so "mt-"
will still match "MT-ND4". Default \code{"^MT-"}.}

\item{mitoID}{Character. A vector of mitochondrial genes to be quantified.}

\item{collectionName}{Character. Name of a \code{GeneSetCollection} obtained
by using one of the \code{importGeneSet*} functions. Default \code{NULL}.}

\item{geneSetList}{List of gene sets to be quantified. The genes in the
assays will be matched to the genes in the list based on
\code{geneSetListLocation}. Default \code{NULL}.}

\item{geneSetListLocation}{Character or numeric vector. If set to 
\code{'rownames'}, then the genes in \code{geneSetList} will be looked up in 
\code{rownames(inSCE)}. If another character is supplied, then genes will be 
looked up in the column names of \code{rowData(inSCE)}. A character vector 
with the same length as \code{geneSetList} can be supplied if the IDs for 
different gene sets are found in different places, including a mixture of 
\code{'rownames'} and \code{rowData(inSCE)}. An integer or integer vector can
be supplied to denote the column index in \code{rowData(inSCE)}. Default 
\code{'rownames'}.}

\item{geneSetCollection}{Class of \code{GeneSetCollection} from package
GSEABase. The location of the gene IDs in \code{inSCE} should be in the
\code{description} slot of each gene set and should follow the
same notation as \code{geneSetListLocation}. The function 
\code{\link[GSEABase]{getGmt}} can be used to read in gene sets from a GMT 
file. If reading a GMT file, the second column for each gene set should be 
the description denoting the location of the gene IDs in \code{inSCE}. These 
gene sets will be included with those from \code{geneSetList} if both 
parameters are provided.}

\item{percent_top}{An integer vector. Each element is treated as a number of
top genes to compute the percentage of library size occupied by the most 
highly expressed genes in each cell. Default \code{c(50, 100, 200, 500)}.}

\item{use_altexps}{Logical scalar indicating whether QC statistics should
be computed for alternative Experiments in \code{inSCE} 
(\code{altExps(inSCE)}). If \code{TRUE}, statistics are computed for all 
alternative experiments. Alternatively, an integer or character vector 
specifying the alternative Experiments to use to compute QC statistics. 
Alternatively \code{NULL}, in which case alternative experiments are not 
used. Default \code{FALSE}.}

\item{flatten}{Logical scalar indicating whether the nested
\link[S4Vectors]{DataFrame-class} in the output should be flattened. Default 
\code{TRUE}.}

\item{detectionLimit}{A numeric scalar specifying the lower detection limit
for expression. Default \code{0}}

\item{BPPARAM}{A \link{BiocParallelParam} object specifying whether the QC
calculations should be parallelized. Default 
\code{BiocParallel::SerialParam()}.}
}
\value{
A \link[SingleCellExperiment]{SingleCellExperiment} object with
cell QC metrics added to the \link{colData} slot.
}
\description{
A wrapper function for \link[scater]{addPerCellQC}. Calculate
general quality control metrics for each cell in the count matrix.
}
\details{
This function allows multiple ways to import mitochondrial genes and quantify 
their expression in cells. \code{mitoGeneLocation} is required for all
methods to point to the location within inSCE object that stores the
mitochondrial gene IDs or Symbols. The various ways mito genes can be 
specified are:
\itemize{
  \item A combination of \code{mitoRef} and \code{mitoIDType} 
  parameters can be used to load pre-built mitochondrial gene sets stored
  in the SCTK package. These parameters are used in the
  \link{importMitoGeneSet} function.
  \item The \code{mitoPrefix} parameter can be used to search for features
  matching a particular pattern. The default pattern is an "MT-" 
  at the beginning of the ID.
  \item The \code{mitoID} parameter can be used to directy supply a vector of 
  mitochondrial gene IDs or names. Only features that exactly match items
  in this vector will be included in the mitochondrial gene set. 
}
}
\examples{
data(scExample, package = "singleCellTK")
mito.ix = grep("^MT-", rowData(sce)$feature_name)
geneSet <- list("Mito"=rownames(sce)[mito.ix])
sce <- runPerCellQC(sce, geneSetList = geneSet)
}
\seealso{
\code{\link[scater]{addPerCellQC}}, 
\code{link{plotRunPerCellQCResults}}, \code{\link{runCellQC}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runTSCAN.R
\name{plotTSCANResults}
\alias{plotTSCANResults}
\title{Plot MST pseudotime values on cell 2D embedding}
\usage{
plotTSCANResults(inSCE, useReducedDim = "UMAP")
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object.}

\item{useReducedDim}{Saved dimension reduction name in \code{inSCE} object.
Required.}
}
\value{
A \code{.ggplot} object with the pseudotime ordering of the cells
colored on a cell 2D embedding, and the MST path drawn on it.
}
\description{
A wrapper function which visualizes outputs from the
\code{\link{runTSCAN}} function. Plots the pseudotime ordering of the cells
and project them onto the MST.
}
\examples{
data("mouseBrainSubsetSCE", package = "singleCellTK")
mouseBrainSubsetSCE <- runTSCAN(inSCE = mouseBrainSubsetSCE,
                                useReducedDim = "PCA_logcounts")
plotTSCANResults(inSCE = mouseBrainSubsetSCE,
                 useReducedDim = "TSNE_logcounts")
}
\author{
Nida Pervaiz
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/htmlReports.R
\name{reportQCTool}
\alias{reportQCTool}
\title{Get .html report of the output of the selected QC algorithm}
\usage{
reportQCTool(
  inSCE,
  algorithm = c("BarcodeRankDrops", "EmptyDrops", "QCMetrics", "Scrublet", "ScDblFinder",
    "Cxds", "Bcds", "CxdsBcdsHybrid", "DoubletFinder", "DecontX", "SoupX"),
  output_file = NULL,
  output_dir = NULL
)
}
\arguments{
\item{inSCE}{A \link[SingleCellExperiment]{SingleCellExperiment} object containing
the count matrix (full droplets or filtered matrix, depends on the selected QC algorithm) with the output from at least one of these functions:
runQCMetrics, runScrublet, runScDblFinder, runCxds, runBcds, runCxdsBcdsHybrid, runDecontX, runBarcodeRankDrops, runEmptyDrops}

\item{algorithm}{Character. Specifies which QC algorithm report to generate.
Available options are "BarcodeRankDrops", "EmptyDrops", "QCMetrics", "Scrublet", "ScDblFinder", "Cxds", "Bcds", "CxdsBcdsHybrid", "DoubletFinder", "DecontX" and "SoupX".}

\item{output_file}{name of the generated file. If NULL/default then the output file name will be based on the name of the selected QC algorithm name .}

\item{output_dir}{name of the output directory to save the rendered file. If NULL/default the file is stored to the current working directory}
}
\value{
.html file
}
\description{
A  function to generate .html Rmarkdown report for the specified QC algorithm output
}
\examples{
data(scExample, package = "singleCellTK")
sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
\dontrun{
sce <- runDecontX(sce)
sce <- runQuickUMAP(sce)
reportQCTool(inSCE = sce, algorithm = "DecontX")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sampleSummaryStats.R
\name{sampleSummaryStats}
\alias{sampleSummaryStats}
\title{Generate table of SCTK QC outputs.}
\usage{
sampleSummaryStats(
  inSCE,
  sample = NULL,
  useAssay = "counts",
  simple = TRUE,
  statsName = "qc_table"
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object with saved
\link{assay} data and/or \link{colData} data. Required.}

\item{sample}{Character vector. Indicates which sample each cell belongs to.}

\item{useAssay}{A string specifying which assay in the SCE to use. Default
'counts'.}

\item{simple}{Boolean. Indicates whether to generate a table of only
basic QC stats (ex. library size), or to generate a summary table of all
QC stats stored in the inSCE.}

\item{statsName}{Character. The name of the slot that will store the
QC stat table. Default "qc_table".}
}
\value{
A SingleCellExperiment object with a summary table for QC statistics
in the `sample_summary` slot of metadata.
}
\description{
Creates a table of QC metrics generated from
 QC algorithms, which is stored within the metadata slot of the
 input SingleCellExperiment object.
}
\examples{
data(scExample, package = "singleCellTK")
sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
sce <- sampleSummaryStats(sce, simple = TRUE)
getSampleSummaryStatsTable(sce, statsName = "qc_table")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/importCellRanger.R
\name{importCellRangerV2Sample}
\alias{importCellRangerV2Sample}
\title{Construct SCE object from Cell Ranger V2 output for a single sample}
\usage{
importCellRangerV2Sample(
  dataDir = NULL,
  sampleName = NULL,
  class = c("Matrix", "matrix"),
  delayedArray = FALSE,
  rowNamesDedup = TRUE
)
}
\arguments{
\item{dataDir}{A path to the directory containing the data files. Default "./".}

\item{sampleName}{A User-defined sample name. This will be prepended to all cell barcode IDs.
Default "sample".}

\item{class}{Character. The class of the expression matrix stored in the SCE
object. Can be one of "Matrix" (as returned by
\link{readMM} function), or "matrix" (as returned by
\link[base]{matrix} function). Default "Matrix".}

\item{delayedArray}{Boolean. Whether to read the expression matrix as
\link{DelayedArray} object or not. Default \code{FALSE}.}

\item{rowNamesDedup}{Boolean. Whether to deduplicate rownames. Default 
\code{TRUE}.}
}
\value{
A \code{SingleCellExperiment} object containing the count
 matrix, the feature annotations, and the cell annotation for the sample.
}
\description{
Read the filtered barcodes, features, and matrices for all
 samples from Cell Ranger V2 output. Files are assumed to be named
 "matrix.mtx", "genes.tsv", and "barcodes.tsv".
}
\examples{
sce <- importCellRangerV2Sample(
    dataDir = system.file("extdata/pbmc_4k_v2_20x20/outs/",
        "filtered_gene_bc_matrices/GRCh38", package = "singleCellTK"),
    sampleName = "pbmc4k_20")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mergeSCEColData.R
\name{mergeSCEColData}
\alias{mergeSCEColData}
\title{Merging colData from two singleCellExperiment objects}
\usage{
mergeSCEColData(inSCE1, inSCE2, id1 = "column_name", id2 = "column_name")
}
\arguments{
\item{inSCE1}{Input SingleCellExperiment object. The function will output this
singleCellExperiment object with a combined colData from inSCE1 and inSCE2.}

\item{inSCE2}{Input SingleCellExperiment object. colData from this object
will be merged with colData from inSCE1 and loaded into inSCE1.}

\item{id1}{Character vector. Column in colData of inSCE1 that will be
used to combine inSCE1 and inSCE2. Default "column_name"}

\item{id2}{Character vector. Column in colData of inSCE2 that will be
used to combine inSCE1 and inSCE2. Default "column_name"}
}
\value{
SingleCellExperiment object containing combined colData from
 both singleCellExperiment for samples in inSCE1.
}
\description{
Merges colData of the singleCellExperiment objects
 obtained from the same dataset which contain differing colData.
 (i.e. raw data and filtered data)
}
\examples{
sce1 <- importCellRanger(
    cellRangerDirs = system.file("extdata/", package = "singleCellTK"),
    sampleDirs = "hgmm_1k_v3_20x20",
    sampleNames = "hgmm1kv3",
    dataType = "filtered")
data(scExample)
sce2 <- sce
sce <- mergeSCEColData(inSCE1 = sce1, inSCE2 = sce2, id1 = "column_name", id2 = "column_name")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ggPlotting.R
\name{plotSCEDensity}
\alias{plotSCEDensity}
\title{Density plot of any data stored in the SingleCellExperiment object.}
\usage{
plotSCEDensity(
  inSCE,
  slotName,
  itemName,
  sample = NULL,
  feature = NULL,
  dimension = NULL,
  groupBy = NULL,
  xlab = NULL,
  ylab = NULL,
  axisSize = 10,
  axisLabelSize = 10,
  defaultTheme = TRUE,
  title = NULL,
  titleSize = 18,
  cutoff = NULL,
  combinePlot = "none",
  plotLabels = NULL
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object with saved
dimension reduction components or a variable with saved results. Required.}

\item{slotName}{Desired slot of SingleCellExperiment used for plotting. Possible
options: "assays", "colData", "metadata", "reducedDims". Required.}

\item{itemName}{Desired vector within the slot used for plotting. Required.}

\item{sample}{Character vector. Indicates which sample each cell belongs to.}

\item{feature}{Desired name of feature stored in assay of SingleCellExperiment
object. Only used when "assays" slotName is selected. Default NULL.}

\item{dimension}{Desired dimension stored in the specified reducedDims.
Either an integer which indicates the column or a character vector specifies
column name. By default, the 1st dimension/column will be used.
Only used when "reducedDims" slotName is selected. Default NULL.}

\item{groupBy}{Groupings for each numeric value. A user may input a vector
equal length to the number of the samples in the SingleCellExperiment
object, or can be retrieved from the colData slot. Default NULL.}

\item{xlab}{Character vector. Label for x-axis. Default NULL.}

\item{ylab}{Character vector. Label for y-axis. Default NULL.}

\item{axisSize}{Size of x/y-axis ticks. Default 10.}

\item{axisLabelSize}{Size of x/y-axis labels. Default 10.}

\item{defaultTheme}{Removes grid in plot and sets axis title size to 10
when TRUE. Default TRUE.}

\item{title}{Title of plot. Default NULL.}

\item{titleSize}{Size of title of plot. Default 15.}

\item{cutoff}{Numeric value. The plot will be annotated with a vertical line
if set. Default NULL.}

\item{combinePlot}{Must be either "all", "sample", or "none". "all" will combine all plots into a single
.ggplot object, while "sample" will output a list of plots separated by sample. Default "none".}

\item{plotLabels}{labels to each plot. If set to "default", will use the name of the samples
as the labels. If set to "none", no label will be plotted.}
}
\value{
a ggplot object of the density plot.
}
\description{
Visualizes values stored in any slot of a
 SingleCellExperiment object via a densityn plot.
}
\examples{
data("mouseBrainSubsetSCE")
plotSCEDensity(
  inSCE = mouseBrainSubsetSCE, slotName = "assays",
  itemName = "counts", feature = "Apoe", groupBy = "sex"
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/miscFunctions.R
\name{retrieveSCEIndex}
\alias{retrieveSCEIndex}
\title{Retrieve cell/feature index by giving identifiers saved in col/rowData}
\usage{
retrieveSCEIndex(
  inSCE,
  IDs,
  axis,
  by = NULL,
  exactMatch = TRUE,
  firstMatch = TRUE
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object. Required}

\item{IDs}{Character vector of identifiers for features or cells to find in
\code{rowData} or \code{colData} of \code{inSCE}}

\item{axis}{A character scalar to specify whether to search for features or
cells. Use \code{"row"}, \code{"feature"} or \code{"gene"} for features;
\code{"col"} or \code{"cell"} for cells.}

\item{by}{Character. In which column to search for features/cells in
\code{rowData}/\code{colData}. Default \code{NULL} for search the
\code{rownames}/\code{colnames}}

\item{exactMatch}{A logical scalar. Whether to only identify exact matches
or to identify partial matches using \code{\link{grep}}. Default \code{TRUE}}

\item{firstMatch}{A logical scalar. Whether to only identify the first
matches or to return all plausible matches. Default \code{TRUE}}
}
\value{
A unique, non-NA numeric vector of indices for the matching
features/cells in \code{inSCE}.
}
\description{
Originally written in \code{\link[celda]{retrieveFeatureIndex}}.
Modified for also retrieving cell indices and only working for
\linkS4class{SingleCellExperiment} object. This will return indices of
features among the \code{rowData}/\code{colData}. Partial matching (i.e.
grepping) can be used.
}
\examples{
data(scExample, package = "singleCellTK")
retrieveSCEIndex(inSCE = sce, IDs = "ENSG00000205542",
 axis = "row")
}
\author{
Yusuke Koga, Joshua Campbell, Yichen Wang
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/abundance.R
\name{getDiffAbundanceResults}
\alias{getDiffAbundanceResults}
\alias{getDiffAbundanceResults,SingleCellExperiment-method}
\alias{getDiffAbundanceResults<-}
\alias{getDiffAbundanceResults<-,SingleCellExperiment-method}
\title{Get/Set diffAbundanceFET result table}
\usage{
getDiffAbundanceResults(x, analysisName)

\S4method{getDiffAbundanceResults}{SingleCellExperiment}(x, analysisName)

getDiffAbundanceResults(x, analysisName) <- value

\S4method{getDiffAbundanceResults}{SingleCellExperiment}(x, analysisName) <- value
}
\arguments{
\item{x}{A \code{\link[SingleCellExperiment]{SingleCellExperiment}}
object.}

\item{analysisName}{A single character string specifying an analysis 
performed with \code{\link{diffAbundanceFET}}}

\item{value}{The output table of \code{\link{diffAbundanceFET}}}
}
\value{
The differential abundance table for getter method, or update the SCE
object with new result for setter method.
}
\description{
Get/Set diffAbundanceFET result table
}
\examples{
data("mouseBrainSubsetSCE", package = "singleCellTK")
mouseBrainSubsetSCE <- diffAbundanceFET(inSCE = mouseBrainSubsetSCE,
                                                cluster = "tissue",
                                                variable = "level1class",
                                                case = "oligodendrocytes",
                                                control = "microglia",
                                                analysisName = "diffAbund")
result <- getDiffAbundanceResults(mouseBrainSubsetSCE, "diffAbund")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/subsetSCE.R
\name{subsetSCECols}
\alias{subsetSCECols}
\title{Subset a SingleCellExperiment object by columns}
\usage{
subsetSCECols(inSCE, index = NULL, bool = NULL, colData = NULL)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object.}

\item{index}{Integer vector. Vector of indicies indicating which columns
to keep. If \code{NULL}, this will not be used for subsetting.
Default \code{NULL}.}

\item{bool}{Boolean vector. Vector of \code{TRUE} or \code{FALSE}
indicating which columns should be kept. Needs to be the same length as the
number of columns in \code{inSCE}. If \code{NULL}, this will not be used
for subsetting. Default \code{NULL}.}

\item{colData}{Character. An expression that will identify a subset of
columns using variables found in the \code{colData} of \code{inSCE}.
For example, if \code{x} is a numeric vector in \code{colData},
then \code{"x < 5"} will return all columns with x less than 5.
Single quotes should be used for character strings. For example,
\code{"y == 'yes'"} will return all columns where y is "yes".
Multiple expressions can be evaluated by placing them in a vector.
For example \code{c("x < 5", "y =='yes'")} will apply both operations for
subsetting. If \code{NULL}, this will not be used for subsetting.
Default \code{NULL}.}
}
\value{
A \link[SingleCellExperiment]{SingleCellExperiment} object that has
been subsetted by colData.
}
\description{
Used to peform subsetting of a
\linkS4class{SingleCellExperiment} object using a variety of methods that
indicate the correct columns to keep. The various methods,
\code{index}, \code{bool}, and \code{colData}, can be used in conjunction
with one another.
}
\examples{
data(scExample)
sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
}
\author{
Joshua D. Campbell
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sctkTagging.R
\name{expDeleteDataTag}
\alias{expDeleteDataTag}
\title{expDeleteDataTag
Remove tag against an input data from the stored tag information in the metadata of the input object.}
\usage{
expDeleteDataTag(inSCE, assay)
}
\arguments{
\item{inSCE}{Input \code{SingleCellExperiment} object.}

\item{assay}{Name of the assay or the data item against which a tag should be removed.}
}
\value{
The input \code{SingleCellExperiment} object with tag information removed from the metadata slot.
}
\description{
expDeleteDataTag
Remove tag against an input data from the stored tag information in the metadata of the input object.
}
\examples{
data(scExample, package = "singleCellTK")
sce <- expSetDataTag(sce, "raw", "counts")
sce <- expDeleteDataTag(sce, "counts")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runTSNE.R
\name{runTSNE}
\alias{runTSNE}
\alias{runQuickTSNE}
\alias{getTSNE}
\title{Run t-SNE embedding with Rtsne method}
\usage{
runTSNE(
  inSCE,
  useReducedDim = "PCA",
  useAssay = NULL,
  useAltExp = NULL,
  reducedDimName = "TSNE",
  logNorm = TRUE,
  useFeatureSubset = NULL,
  nTop = 2000,
  center = TRUE,
  scale = TRUE,
  pca = TRUE,
  partialPCA = FALSE,
  initialDims = 25,
  theta = 0.5,
  perplexity = 30,
  nIterations = 1000,
  numThreads = 1,
  seed = 12345
)

runQuickTSNE(inSCE, useAssay = "counts", ...)

getTSNE(
  inSCE,
  useReducedDim = "PCA",
  useAssay = NULL,
  useAltExp = NULL,
  reducedDimName = "TSNE",
  logNorm = TRUE,
  useFeatureSubset = NULL,
  nTop = 2000,
  center = TRUE,
  scale = TRUE,
  pca = TRUE,
  partialPCA = FALSE,
  initialDims = 25,
  theta = 0.5,
  perplexity = 30,
  nIterations = 1000,
  numThreads = 1,
  seed = 12345
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object.}

\item{useReducedDim}{The low dimension representation to use for UMAP
computation. Default \code{"PCA"}.}

\item{useAssay}{Assay to use for tSNE computation. If \code{useAltExp} is
specified, \code{useAssay} has to exist in
\code{assays(altExp(inSCE, useAltExp))}. Default \code{NULL}.}

\item{useAltExp}{The subset to use for tSNE computation, usually for the
selected.variable features. Default \code{NULL}.}

\item{reducedDimName}{a name to store the results of the dimension
reductions. Default \code{"TSNE"}.}

\item{logNorm}{Whether the counts will need to be log-normalized prior to
generating the tSNE via \code{\link{scaterlogNormCounts}}. Ignored when using
\code{useReducedDim}. Default \code{TRUE}.}

\item{useFeatureSubset}{Subset of feature to use for dimension reduction. A
character string indicating a \code{rowData} variable that stores the logical
vector of HVG selection, or a vector that can subset the rows of
\code{inSCE}. Default \code{NULL}.}

\item{nTop}{Automatically detect this number of variable features to use for
dimension reduction. Ignored when using \code{useReducedDim} or using
\code{useFeatureSubset}. Default \code{2000}.}

\item{center}{Whether data should be centered before PCA is applied. Ignored
when using \code{useReducedDim}. Default \code{TRUE}.}

\item{scale}{Whether data should be scaled before PCA is applied. Ignored
when using \code{useReducedDim}. Default \code{TRUE}.}

\item{pca}{Whether an initial PCA step should be performed. Ignored when
using \code{useReducedDim}. Default \code{TRUE}.}

\item{partialPCA}{Whether truncated PCA should be used to calculate principal
components (requires the irlba package). This is faster for large input
matrices. Ignored when using \code{useReducedDim}. Default \code{FALSE}.}

\item{initialDims}{Number of dimensions from PCA to use as input in tSNE.
Default \code{25}.}

\item{theta}{Numeric value for speed/accuracy trade-off (increase for less
accuracy), set to \code{0.0} for exact TSNE. Default \code{0.5}.}

\item{perplexity}{perplexity parameter. Should not be bigger than
\code{3 * perplexity < ncol(inSCE) - 1}. Default \code{30}. See
\code{\link[Rtsne]{Rtsne}} details for interpretation.}

\item{nIterations}{maximum iterations. Default \code{1000}.}

\item{numThreads}{Integer, number of threads to use using OpenMP, Default
\code{1}. \code{0} corresponds to using all available cores.}

\item{seed}{Random seed for reproducibility of tSNE results.
Default \code{NULL} will use global seed in use by the R environment.}

\item{...}{Other parameters to be passed to \code{runTSNE}}
}
\value{
A \linkS4class{SingleCellExperiment} object with tSNE computation
updated in \code{reducedDim(inSCE, reducedDimName)}.
}
\description{
T-Stochastic Neighbour Embedding (t-SNE) algorithm is commonly
for 2D visualization of single-cell data. This function wraps the
Rtsne \code{\link[Rtsne]{Rtsne}} function.

With this funciton, users can create tSNE embedding directly from raw count
matrix, with necessary preprocessing including normalization, scaling,
dimension reduction all automated. Yet we still recommend having the PCA as
input, so that the result can match with the clustering based on the same
input PCA, and will be much faster.
}
\examples{
data(scExample, package = "singleCellTK")
sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
# Run from raw counts
sce <- runQuickTSNE(sce)
\dontrun{
# Run from PCA
sce <- scaterlogNormCounts(sce, "logcounts")
sce <- runModelGeneVar(sce)
sce <- setTopHVG(sce, method = "modelGeneVar", hvgNumber = 2000, 
                 featureSubsetName = "HVG_modelGeneVar2000")
sce <- scaterPCA(sce, useAssay = "logcounts",
                 useFeatureSubset = "HVG_modelGeneVar2000", scale = TRUE)
sce <- runTSNE(sce, useReducedDim = "PCA")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scater_PCA.R
\name{scaterPCA}
\alias{scaterPCA}
\title{Perform scater PCA on a SingleCellExperiment Object}
\usage{
scaterPCA(
  inSCE,
  useAssay = "logcounts",
  useFeatureSubset = "hvg2000",
  scale = TRUE,
  reducedDimName = "PCA",
  nComponents = 50,
  ntop = 2000,
  useAltExp = NULL,
  seed = 12345,
  BPPARAM = BiocParallel::SerialParam()
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object.}

\item{useAssay}{Assay to use for PCA computation. If \code{useAltExp} is
specified, \code{useAssay} has to exist in
\code{assays(altExp(inSCE, useAltExp))}. Default \code{"logcounts"}}

\item{useFeatureSubset}{Subset of feature to use for dimension reduction. A
character string indicating a \code{rowData} variable that stores the logical
vector of HVG selection, or a vector that can subset the rows of
\code{inSCE}. Default \code{"hvg2000"}.}

\item{scale}{Logical scalar, whether to standardize the expression values.
Default \code{TRUE}.}

\item{reducedDimName}{Name to use for the reduced output assay. Default
\code{"PCA"}.}

\item{nComponents}{Number of principal components to obtain from the PCA
computation. Default \code{50}.}

\item{ntop}{Automatically detect this number of variable features to use for
dimension reduction. Ignored when using \code{useReducedDim} or using
\code{useFeatureSubset}. Default \code{2000}.}

\item{useAltExp}{The subset to use for PCA computation, usually for the
selected.variable features. Default \code{NULL}.}

\item{seed}{Integer, random seed for reproducibility of PCA results.
Default \code{NULL}.}

\item{BPPARAM}{A \linkS4class{BiocParallelParam} object specifying whether
the PCA should be parallelized.}
}
\value{
A \linkS4class{SingleCellExperiment} object with PCA computation
updated in \code{reducedDim(inSCE, reducedDimName)}.
}
\description{
A wrapper to \link[scater]{runPCA} function to compute principal
component analysis (PCA) from a given \linkS4class{SingleCellExperiment}
object.
}
\examples{
data(scExample, package = "singleCellTK")
sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
sce <- scaterlogNormCounts(sce, "logcounts")

# Example of ranking variable genes, selecting the top variable features,
# and running PCA. Make sure to increase the number of highly variable
# features (hvgNumber) and the number of principal components (nComponents)
# for real datasets
sce <- runModelGeneVar(sce, useAssay = "logcounts")
sce <- setTopHVG(sce, method = "modelGeneVar", hvgNumber = 100,
                 featureSubsetName = "hvf")
sce <- scaterPCA(sce, useAssay = "logcounts", scale = TRUE,
                 useFeatureSubset = "hvf", nComponents = 5)
                 
# Alternatively, let the scater PCA function select the top variable genes
sce <- scaterPCA(sce, useAssay = "logcounts", scale = TRUE,
                 useFeatureSubset = NULL, ntop = 100, nComponents = 5)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/seuratFunctions.R
\name{runSeuratHeatmap}
\alias{runSeuratHeatmap}
\title{runSeuratHeatmap
Computes the heatmap plot object from the pca slot in the input sce object}
\usage{
runSeuratHeatmap(
  inSCE,
  useAssay,
  useReduction = c("pca", "ica"),
  dims = NULL,
  nfeatures = 30,
  cells = NULL,
  ncol = NULL,
  balanced = TRUE,
  fast = TRUE,
  combine = TRUE,
  raster = TRUE,
  externalReduction = NULL
)
}
\arguments{
\item{inSCE}{(sce) object from which to compute heatmap (pca should be
computed)}

\item{useAssay}{Specify name of the assay that will be scaled
by this function. The output scaled assay will be used for computation
of the heatmap.}

\item{useReduction}{Reduction method to use for computing clusters. One of
"pca" or "ica". Default \code{"pca"}.}

\item{dims}{Number of components to generate heatmap plot objects. If
\code{NULL}, a heatmap will be generated for all components. Default
\code{NULL}.}

\item{nfeatures}{Number of features to include in the heatmap. Default
\code{30}.}

\item{cells}{Numeric value indicating the number of top cells to plot.
Default is \code{NULL} which indicates all cells.}

\item{ncol}{Numeric value indicating the number of columns to use for plot.
Default is \code{NULL} which will automatically compute accordingly.}

\item{balanced}{Plot equal number of genes with positive and negative scores.
Default is \code{TRUE}.}

\item{fast}{See \link[Seurat]{DimHeatmap} for more information. Default
\code{TRUE}.}

\item{combine}{See \link[Seurat]{DimHeatmap} for more information. Default
\code{TRUE}.}

\item{raster}{See \link[Seurat]{DimHeatmap} for more information. Default
\code{TRUE}.}

\item{externalReduction}{Pass DimReduc object if PCA/ICA computed through
other libraries. Default \code{NULL}.}
}
\value{
plot object
}
\description{
runSeuratHeatmap
Computes the heatmap plot object from the pca slot in the input sce object
}
\examples{
data(scExample, package = "singleCellTK")
\dontrun{
sce <- runSeuratNormalizeData(sce, useAssay = "counts")
sce <- runSeuratFindHVG(sce, useAssay = "counts")
sce <- runSeuratScaleData(sce, useAssay = "counts")
sce <- runSeuratPCA(sce, useAssay = "counts")
heatmap <- runSeuratHeatmap(sce, useAssay = "counts")
plotSeuratHeatmap(heatmap)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/importGeneSets.R
\name{importGeneSetsFromList}
\alias{importGeneSetsFromList}
\title{Imports gene sets from a list}
\usage{
importGeneSetsFromList(
  inSCE,
  geneSetList,
  collectionName = "GeneSetCollection",
  by = "rownames",
  noMatchError = TRUE
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object.}

\item{geneSetList}{Named List. A list containing one or more gene sets.
Each element of the list should be a character vector of gene identifiers.
The names of the list will be become the gene set names in the
\linkS4class{GeneSetCollection} object.}

\item{collectionName}{Character. Name of collection to add gene sets to.
If this collection already exists in \code{inSCE}, then these gene sets will
be added to that collection. Any gene sets within the collection with the
same name will be overwritten. Default \code{GeneSetCollection}.}

\item{by}{Character or character vector. Describes the
location within \code{inSCE} where the gene identifiers in
\code{geneSetList} should be mapped. If set to \code{"rownames"} then the
features will be searched for among \code{rownames(inSCE)}. This can also be
set to one of the column names of \code{rowData(inSCE)} in which case the
gene identifies will be mapped to that column in the \code{rowData}
of \code{inSCE}. Finally, \code{by} can be a vector the same length as
the number of gene sets in \code{geneSetList} and the elements of the vector
can point to different locations within \code{inSCE}. See
\link{featureIndex} for more information.
Default \code{"rownames"}.}

\item{noMatchError}{Boolean. Show an error if a collection does not have
any matching features. Default \code{TRUE}.}
}
\value{
A \link[SingleCellExperiment]{SingleCellExperiment} object
with gene set from \code{collectionName} output stored to the
\link{metadata} slot.
}
\description{
Converts a list of gene sets into a
\linkS4class{GeneSetCollection} and stores it in the metadata of the
\linkS4class{SingleCellExperiment} object. These gene sets can be used in
downstream quality control and analysis functions in \link{singleCellTK}.
}
\details{
The gene identifiers in gene sets in \code{geneSetList} will be
mapped to the rownames of \code{inSCE} using the \code{by} parameter and
stored in a \linkS4class{GeneSetCollection} object from package
\link{GSEABase}. This object is stored in
\code{metadata(inSCE)$sctk$genesets}, which can be accessed in downstream
analysis functions such as \link[singleCellTK]{runCellQC}.
}
\examples{
data(scExample)

# Generate gene sets from 'rownames'
gs1 <- rownames(sce)[seq(10)]
gs2 <- rownames(sce)[seq(11,20)]
gs <- list("geneset1" = gs1, "geneset2" = gs2)
sce <- importGeneSetsFromList(inSCE = sce,
                              geneSetList = gs,
                              by = "rownames")

# Generate a gene set for mitochondrial genes using
# Gene Symbols stored in 'rowData'
mito.ix <- grep("^MT-", rowData(sce)$feature_name)
mito <- list(mito = rowData(sce)$feature_name[mito.ix])
sce <- importGeneSetsFromList(inSCE = sce,
                             geneSetList = mito,
                             by = "feature_name")
}
\seealso{
\link{importGeneSetsFromCollection} for importing from
\linkS4class{GeneSetCollection} objects,
\link{importGeneSetsFromGMT} for importing from GMT files, and
\link{importGeneSetsFromMSigDB} for importing MSigDB gene sets.
}
\author{
Joshua D. Campbell
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/doubletFinder_doubletDetection.R
\name{runDoubletFinder}
\alias{runDoubletFinder}
\title{Generates a doublet score for each cell via doubletFinder}
\usage{
runDoubletFinder(
  inSCE,
  sample = NULL,
  useAssay = "counts",
  seed = 12345,
  seuratNfeatures = 2000,
  seuratPcs = seq(15),
  seuratRes = 1.5,
  sct = FALSE,
  formationRate = 0.075,
  nCores = NULL,
  verbose = FALSE
)
}
\arguments{
\item{inSCE}{inSCE A \linkS4class{SingleCellExperiment} object.}

\item{sample}{Character vector or colData variable name. Indicates which 
sample each cell belongs to. Default \code{NULL}.}

\item{useAssay}{A string specifying which assay in the SCE to use. Default 
\code{"counts"}.}

\item{seed}{Seed for the random number generator, can be set to \code{NULL}. 
Default \code{12345}.}

\item{seuratNfeatures}{Integer. Number of highly variable genes to use.
Default \code{2000}.}

\item{seuratPcs}{Numeric vector. The PCs used in seurat function to
determine number of clusters. Default \code{1:15}.}

\item{seuratRes}{Numeric vector. The resolution parameter used in Seurat,
which adjusts the number of clusters determined via the algorithm. Default 
\code{1.5}.}

\item{sct}{Whether or not to use SCT. Default \code{FALSE}.}

\item{formationRate}{Doublet formation rate used within algorithm. Default 
\code{0.075}.}

\item{nCores}{Number of cores used for running the function. Default 
\code{NULL}.}

\item{verbose}{Boolean. Wheter to print messages from Seurat and 
DoubletFinder. Default \code{FALSE}.}
}
\value{
\linkS4class{SingleCellExperiment} object containing the
\code{doublet_finder_doublet_score} variable in \code{colData} slot.
}
\description{
Uses doubletFinder to determine cells within the dataset
 suspected to be doublets.
}
\examples{
data(scExample, package = "singleCellTK")
options(future.globals.maxSize = 786432000)
sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
sce <- runDoubletFinder(sce)
}
\seealso{
\code{\link{runCellQC}}, \code{\link{plotDoubletFinderResults}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/importSeqc.R
\name{importSEQC}
\alias{importSEQC}
\title{Construct SCE object from seqc output}
\usage{
importSEQC(
  seqcDirs = NULL,
  samples = NULL,
  prefix = NULL,
  gzipped = FALSE,
  class = c("Matrix", "matrix"),
  delayedArray = FALSE,
  cbNotFirstCol = TRUE,
  feNotFirstCol = TRUE,
  combinedSample = TRUE,
  rowNamesDedup = TRUE
)
}
\arguments{
\item{seqcDirs}{A vector of paths to seqc output files. Each sample
should have its own path. For example: \code{"./pbmc_1k_50x50"}. Must have 
the same length as \code{samples}.}

\item{samples}{A vector of user-defined sample names for the samples to be
imported. Must have the same length as \code{seqcDirs}.}

\item{prefix}{A vector containing the prefix of file names within each
sample directory. It cannot be null and the vector should have the same
length as \emph{samples}.}

\item{gzipped}{Boolean. \code{TRUE} if the seqc output files
(sparse_counts_barcode.csv, sparse_counts_genes.csv, and
sparse_molecule_counts.mtx) were gzip compressed. \code{FALSE} otherwise. 
Default seqc outputs are not gzipped. Default \code{FALSE}.}

\item{class}{Character. The class of the expression matrix stored in the SCE
object. Can be one of \code{"Matrix"} (as returned by \link{readMM} 
function), or \code{"matrix"} (as returned by \link[base]{matrix} function).
Default \code{"Matrix"}.}

\item{delayedArray}{Boolean. Whether to read the expression matrix as
\link{DelayedArray} object or not. Default \code{FALSE}.}

\item{cbNotFirstCol}{Boolean. \code{TRUE} if first column of
sparse_counts_barcode.csv is row index and it will be removed. \code{FALSE} 
the first column will be kept.}

\item{feNotFirstCol}{Boolean. \code{TRUE} if first column of
sparse_counts_genes.csv is row index and it will be removed. \code{FALSE} 
the first column will be kept.}

\item{combinedSample}{Boolean. If \code{TRUE}, \code{importSEQC} returns a
\code{SingleCellExperiment} object containing the combined count matrix,
 feature annotations and the cell annotations. If \code{FALSE}, 
 \code{importSEQC} returns a list containing multiple
 \code{SingleCellExperiment} objects. Each \code{SingleCellExperiment}
 contains count matrix, feature annotations and cell annotations for
 each sample.}

\item{rowNamesDedup}{Boolean. Whether to deduplicate rownames. Only applied 
if \code{combinedSample} is \code{TRUE} or only one \code{seqcDirs} 
specified. Default \code{TRUE}.}
}
\value{
A \code{SingleCellExperiment} object containing the combined count
 matrix, the feature annotations, and the cell annotation.
}
\description{
Read the filtered barcodes, features, and matrices for all
 samples from (preferably a single run of) seqc output. Import and combine
 them as one big \link[SingleCellExperiment]{SingleCellExperiment} object.
}
\details{
\code{importSEQC} imports output from seqc. The default 
 sparse_counts_barcode.csv or sparse_counts_genes.csv from seqc output
 contains two columns. The first column is row index and the second column
 is cell-barcode or gene symbol. \code{importSEQC} will remove first column. 
 Alternatively, user can call
 \code{cbNotFirstCol} or \code{feNotFirstCol} as FALSE to keep the first
 column of these files. When \code{combinedSample} is TRUE, \code{importSEQC}
 will combined count matrix with genes detected in at least one sample.
}
\examples{
# Example #1
# The following filtered feature, cell, and matrix files were downloaded from
# https://support.10xgenomics.com/single-cell-gene-expression/datasets/
# 3.0.0/pbmc_1k_v3
# The top 50 hg38 genes are included in this example.
# Only the top 50 cells are included.
sce <- importSEQC(
    seqcDirs = system.file("extdata/pbmc_1k_50x50", package = "singleCellTK"),
    samples = "pbmc_1k_50x50",
    prefix = "pbmc_1k",
    combinedSample = FALSE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/miscFunctions.R
\name{getGenesetNamesFromCollection}
\alias{getGenesetNamesFromCollection}
\title{List geneset names from geneSetCollection}
\usage{
getGenesetNamesFromCollection(inSCE, geneSetCollectionName)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object.}

\item{geneSetCollectionName}{The name of an imported geneSetCollection.}
}
\value{
A character vector of available genesets from the collection.
}
\description{
List geneset names from geneSetCollection
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runQC.R
\name{runDropletQC}
\alias{runDropletQC}
\title{Perform comprehensive droplet QC}
\usage{
runDropletQC(
  inSCE,
  algorithms = c("QCMetrics", "emptyDrops", "barcodeRanks"),
  sample = NULL,
  useAssay = "counts",
  paramsList = NULL
)
}
\arguments{
\item{inSCE}{A \link[SingleCellExperiment]{SingleCellExperiment} object containing
the full droplet count matrix}

\item{algorithms}{Character vector. Specify which QC algorithms to run.
Available options are "emptyDrops" and "barcodeRanks".}

\item{sample}{Character vector. Indicates which sample each cell belongs to.
Algorithms will be run on cells from each sample separately.}

\item{useAssay}{A string specifying which assay contains the count
matrix for droplets.}

\item{paramsList}{A list containing parameters for QC functions. Default NULL.}
}
\value{
SingleCellExperiment object containing the outputs of the
 specified algorithms in the \link{colData}
of \code{inSCE}.
}
\description{
A wrapper function to run several QC algorithms for determining
empty droplets in single cell RNA-seq data
}
\examples{
data(scExample, package = "singleCellTK")
\dontrun{
sce <- runDropletQC(sce)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scanpyFunctions.R
\name{runScanpyUMAP}
\alias{runScanpyUMAP}
\title{runScanpyUMAP
Computes UMAP from the given sce object and stores the UMAP computations back
into the sce object}
\usage{
runScanpyUMAP(
  inSCE,
  useAssay = NULL,
  useReducedDim = "scanpyPCA",
  reducedDimName = "scanpyUMAP",
  dims = 40,
  minDist = 0.5,
  nNeighbors = 10,
  spread = 1,
  alpha = 1,
  gamma = 1,
  externalReduction = NULL,
  seed = 12345
)
}
\arguments{
\item{inSCE}{(sce) object on which to compute the UMAP}

\item{useAssay}{Specify name of assay to use. Default is \code{NULL}, so
\code{useReducedDim} param will be used instead.}

\item{useReducedDim}{Reduction to use for computing UMAP. 
Default is \code{"scanpyPCA"}.}

\item{reducedDimName}{Name of new reducedDims object containing Scanpy UMAP
Default \code{scanpyUMAP}.}

\item{dims}{Numerical value of how many reduction components to use for UMAP
computation. Default \code{40}.}

\item{minDist}{Sets the \code{"min_dist"} parameter to the underlying UMAP
call. Default \code{0.5}.}

\item{nNeighbors}{Sets the \code{"n_neighbors"} parameter to the underlying
UMAP call. Default \code{10}.}

\item{spread}{Sets the \code{"spread"} parameter to the underlying UMAP call.
Default \code{1}.}

\item{alpha}{Sets the \code{"alpha"} parameter to the underlying UMAP call.
Default \code{1}.}

\item{gamma}{Sets the \code{"gamma"} parameter to the underlying UMAP call.
Default \code{1}.}

\item{externalReduction}{Pass DimReduce object if PCA computed through
other libraries. Default \code{NULL}.}

\item{seed}{Specify numeric value to set as a seed. Default \code{12345}.}
}
\value{
Updated sce object with UMAP computations stored
}
\description{
runScanpyUMAP
Computes UMAP from the given sce object and stores the UMAP computations back
into the sce object
}
\examples{
data(scExample, package = "singleCellTK")
\dontrun{
sce <- runScanpyNormalizeData(sce, useAssay = "counts")
sce <- runScanpyFindHVG(sce, useAssay = "scanpyNormData", method = "seurat")
sce <- runScanpyScaleData(sce, useAssay = "scanpyNormData")
sce <- runScanpyPCA(sce, useAssay = "scanpyScaledData")
sce <- runScanpyFindClusters(sce, useReducedDim = "scanpyPCA")
sce <- runScanpyUMAP(sce, useReducedDim = "scanpyPCA")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runCluster.R
\name{runKMeans}
\alias{runKMeans}
\title{Get clustering with KMeans}
\usage{
runKMeans(
  inSCE,
  nCenters,
  useReducedDim = "PCA",
  clusterName = "KMeans_cluster",
  nComp = 10,
  nIter = 10,
  nStart = 1,
  seed = 12345,
  algorithm = c("Hartigan-Wong", "Lloyd", "MacQueen")
)
}
\arguments{
\item{inSCE}{A \linkS4class{SingleCellExperiment} object.}

\item{nCenters}{An \code{integer}, the number of centroids (clusters).}

\item{useReducedDim}{A single \code{character}, specifying which
low-dimension representation to perform the clustering algorithm on. Default
\code{"PCA"}.}

\item{clusterName}{A single \code{character}, specifying the name to store
the cluster label in \code{\link{colData}}. Default \code{"KMeans_cluster"}.}

\item{nComp}{An \code{integer}. The number of components to use for K-Means.
Default \code{10}. See Detail.}

\item{nIter}{An \code{integer}, the maximum number of iterations allowed.
Default \code{10}.}

\item{nStart}{An \code{integer}, the number of random sets to choose. Default
\code{1}.}

\item{seed}{An \code{integer}. The seed for the random number generator.
Default \code{12345}.}

\item{algorithm}{A single \code{character}. Choose from
\code{"Hartigan-Wong"}, \code{"Lloyd"}, \code{"MacQueen"}. May be
abbreviated. Default \code{"Hartigan-Wong"}.}
}
\value{
The input \linkS4class{SingleCellExperiment} object with
\code{factor} cluster labeling updated in
\code{colData(inSCE)[[clusterName]]}.
}
\description{
Perform KMeans clustering on a
\linkS4class{SingleCellExperiment} object, with \code{\link[stats]{kmeans}}.
}
\examples{
data("mouseBrainSubsetSCE")
mouseBrainSubsetSCE <- runKMeans(mouseBrainSubsetSCE,
                                 useReducedDim = "PCA_logcounts",
                                 nCenters = 2)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/htmlReports.R
\name{reportCellQC}
\alias{reportCellQC}
\title{Get runCellQC .html report}
\usage{
reportCellQC(
  inSCE,
  sample = "sample",
  output_file = NULL,
  output_dir = NULL,
  subTitle = NULL,
  studyDesign = NULL,
  useReducedDim = NULL
)
}
\arguments{
\item{inSCE}{A \link[SingleCellExperiment]{SingleCellExperiment} object containing
the filtered count matrix with the output from runCellQC function}

\item{sample}{Character. The name of the saved column from the colData indicating the sample grouping variable. Default is "sample"}

\item{output_file}{Character. The name of the generated file. If NULL/default then the output file name will be based on the name of the Rmarkdown template.}

\item{output_dir}{Character. The name of the output directory to save the rendered file. If NULL/default the file is stored to the current working directory}

\item{subTitle}{subtitle of the QC HTML report. Default is NULL.}

\item{studyDesign}{Character. The description of the data set and experiment design. It would be shown at the top of QC HTML report. Default is NULL.}

\item{useReducedDim}{Character. The name of the saved dimension reduction slot including cells
from all samples in then\linkS4class{SingleCellExperiment} object, Default is NULL}
}
\value{
.html file
}
\description{
A  function to generate .html Rmarkdown report containing the visualizations of the runCellQC function output
}
\examples{
data(scExample, package = "singleCellTK")
sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
\dontrun{
sce <- runCellQC(sce)
reportCellQC(inSCE = sce)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ggPerQCWrapper.R
\name{plotScdsHybridResults}
\alias{plotScdsHybridResults}
\title{Plots for runCxdsBcdsHybrid outputs.}
\usage{
plotScdsHybridResults(
  inSCE,
  sample = NULL,
  shape = NULL,
  groupBy = NULL,
  combinePlot = "all",
  violin = TRUE,
  boxplot = FALSE,
  dots = TRUE,
  reducedDimName = "UMAP",
  xlab = NULL,
  ylab = NULL,
  dim1 = NULL,
  dim2 = NULL,
  bin = NULL,
  binLabel = NULL,
  defaultTheme = TRUE,
  dotSize = 0.5,
  summary = "median",
  summaryTextSize = 3,
  transparency = 1,
  baseSize = 15,
  titleSize = NULL,
  axisLabelSize = NULL,
  axisSize = NULL,
  legendSize = NULL,
  legendTitleSize = NULL,
  relHeights = 1,
  relWidths = c(1, 1, 1),
  plotNCols = NULL,
  plotNRows = NULL,
  labelSamples = TRUE,
  samplePerColumn = TRUE,
  sampleRelHeights = 1,
  sampleRelWidths = 1
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object with saved
dimension reduction components or a variable with saved results from
\link{runCxdsBcdsHybrid}. Required.}

\item{sample}{Character vector. Indicates which sample each cell belongs to.
Default NULL.}

\item{shape}{If provided, add shapes based on the value.}

\item{groupBy}{Groupings for each numeric value. A user may input a vector
equal length to the number of the samples in the SingleCellExperiment
object, or can be retrieved from the colData slot. Default NULL.}

\item{combinePlot}{Must be either "all", "sample", or "none". "all" will combine all plots into a single .ggplot object,
while "sample" will output a list of plots separated by sample. Default "all".}

\item{violin}{Boolean. If TRUE, will plot the violin plot. Default TRUE.}

\item{boxplot}{Boolean. If TRUE, will plot boxplots for each violin plot.
Default TRUE.}

\item{dots}{Boolean. If TRUE, will plot dots for each violin plot.
Default TRUE.}

\item{reducedDimName}{Saved dimension reduction name in the
\linkS4class{SingleCellExperiment} object. Required.}

\item{xlab}{Character vector. Label for x-axis. Default NULL.}

\item{ylab}{Character vector. Label for y-axis. Default NULL.}

\item{dim1}{1st dimension to be used for plotting. Can either be a string which specifies
the name of the dimension to be plotted from reducedDims, or a numeric value which specifies
the index of the dimension to be plotted. Default is NULL.}

\item{dim2}{2nd dimension to be used for plotting. Can either be a string which specifies
the name of the dimension to be plotted from reducedDims, or a numeric value which specifies
the index of the dimension to be plotted. Default is NULL.}

\item{bin}{Numeric vector. If single value, will divide the numeric values into the `bin` groups.
If more than one value, will bin numeric values using values as a cut point.}

\item{binLabel}{Character vector. Labels for the bins created by the `bin` parameter.
Default NULL.}

\item{defaultTheme}{Removes grid in plot and sets axis title size to 10
when TRUE. Default TRUE.}

\item{dotSize}{Size of dots. Default 0.5.}

\item{summary}{Adds a summary statistic, as well as a crossbar to the
violin plot. Options are "mean" or "median". Default NULL.}

\item{summaryTextSize}{The text size of the summary statistic displayed
above the violin plot. Default 3.}

\item{transparency}{Transparency of the dots, values will be 0-1. Default 1.}

\item{baseSize}{The base font size for all text. Default 12.
Can be overwritten by titleSize, axisSize, and axisLabelSize,
legendSize, legendTitleSize.}

\item{titleSize}{Size of title of plot. Default NULL.}

\item{axisLabelSize}{Size of x/y-axis labels. Default NULL.}

\item{axisSize}{Size of x/y-axis ticks. Default NULL.}

\item{legendSize}{size of legend. Default NULL.}

\item{legendTitleSize}{size of legend title. Default NULL.}

\item{relHeights}{Relative heights of plots when combine is set.}

\item{relWidths}{Relative widths of plots when combine is set.}

\item{plotNCols}{Number of columns when plots are combined in a grid.}

\item{plotNRows}{Number of rows when plots are combined in a grid.}

\item{labelSamples}{Will label sample name in title of plot if TRUE. Default TRUE.}

\item{samplePerColumn}{If TRUE, when there are multiple samples and combining by "all",
the output .ggplot will have plots from each sample on a single column. Default TRUE.}

\item{sampleRelHeights}{If there are multiple samples and combining by "all",
the relative heights for each plot.}

\item{sampleRelWidths}{If there are multiple samples and combining by "all",
the relative widths for each plot.}
}
\value{
list of .ggplot objects
}
\description{
A wrapper function which visualizes outputs from the
 runCxdsBcdsHybrid function stored in the colData slot of the
 SingleCellExperiment object via various plots.
}
\examples{
data(scExample, package="singleCellTK")
sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
sce <- runQuickUMAP(sce)
sce <- runCxdsBcdsHybrid(sce)
plotScdsHybridResults(inSCE=sce, reducedDimName="UMAP")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scds_doubletdetection.R
\name{runBcds}
\alias{runBcds}
\title{Find doublets/multiplets using \link[scds]{bcds}.}
\usage{
runBcds(
  inSCE,
  sample = NULL,
  seed = 12345,
  ntop = 500,
  srat = 1,
  verb = FALSE,
  retRes = FALSE,
  nmax = "tune",
  varImp = FALSE,
  estNdbl = FALSE,
  useAssay = "counts"
)
}
\arguments{
\item{inSCE}{A \linkS4class{SingleCellExperiment} object.}

\item{sample}{Character vector or colData variable name. Indicates which 
sample each cell belongs to. Default \code{NULL}.}

\item{seed}{Seed for the random number generator, can be \code{NULL}. Default
\code{12345}.}

\item{ntop}{See \link[scds]{bcds} for more information. Default \code{500}.}

\item{srat}{See \link[scds]{bcds} for more information. Default \code{1}.}

\item{verb}{See \link[scds]{bcds} for more information. Default \code{FALSE}.}

\item{retRes}{See \link[scds]{bcds} for more information. Default 
\code{FALSE}.}

\item{nmax}{See \link[scds]{bcds} for more information. Default 
\code{"tune"}.}

\item{varImp}{See \link[scds]{bcds} for more information. Default 
\code{FALSE}.}

\item{estNdbl}{See \link[scds]{bcds} for more information. Default 
\code{FALSE}.}

\item{useAssay}{A string specifying which assay in \code{inSCE} to use.
Default \code{"counts"}}
}
\value{
A \linkS4class{SingleCellExperiment} object with \link[scds]{bcds} 
output appended to the \link{colData} slot. The columns include 
\emph{bcds_score} and optionally \emph{bcds_call}. Please refer to the 
documentation of \link[scds]{bcds} for details.
}
\description{
A wrapper function for \link[scds]{bcds}. Annotate
 doublets/multiplets using a binary classification approach to discriminate
 artificial doublets from original data. Generate a doublet
 score for each cell. Infer doublets if \code{estNdbl} is \code{TRUE}.
}
\details{
When the argument \code{sample} is specified, \link[scds]{bcds} will
be run on cells from each sample separately. If \code{sample = NULL}, then 
all cells will be processed together.
}
\examples{
data(scExample, package = "singleCellTK")
sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
sce <- runBcds(sce)
}
\seealso{
\code{\link[scds]{bcds}}, \code{\link{plotBcdsResults}}, 
\code{\link{runCellQC}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DownsampleMatrix.R
\name{generateSimulatedData}
\alias{generateSimulatedData}
\title{Generates a single simulated dataset, bootstrapping from the input counts
matrix.}
\usage{
generateSimulatedData(totalReads, cells, originalData, realLabels)
}
\arguments{
\item{totalReads}{Numeric. The total number of reads in the simulated
dataset, to be split between all simulated cells.}

\item{cells}{Numeric. The number of virtual cells to simulate.}

\item{originalData}{Matrix. The original raw read count matrix. When used
within the Shiny app, this will be assay(SCEsetObject, "counts").}

\item{realLabels}{Factor. The condition labels for differential expression.
If only two factors present, will default to t-test. If multiple factors,
will default to ANOVA.}
}
\value{
A simulated counts matrix, the first row of which contains the 'true'
labels for each virtual cell.
}
\description{
Generates a single simulated dataset, bootstrapping from the input counts
matrix.
}
\examples{
data("mouseBrainSubsetSCE")
res <- generateSimulatedData(
         totalReads = 1000, cells=10,
         originalData = assay(mouseBrainSubsetSCE, "counts"),
         realLabels = colData(mouseBrainSubsetSCE)[, "level1class"])

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/importMultipleSources.R
\name{importMultipleSources}
\alias{importMultipleSources}
\title{Imports samples from different sources and compiles them into a list of SCE objects}
\usage{
importMultipleSources(allImportEntries, delayedArray = FALSE)
}
\arguments{
\item{allImportEntries}{object containing the sources and parameters of all the samples being imported (from the UI)}

\item{delayedArray}{Boolean. Whether to read the expression matrix as
\link{DelayedArray} object or not. Default \code{FALSE}.}
}
\value{
A list of \link[SingleCellExperiment]{SingleCellExperiment} object containing
the droplet or cell data or both,depending on the dataType that users provided.
}
\description{
Imports samples from different sources and compiles them into a list of SCE objects
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/htmlReports.R
\name{reportSeuratDimRed}
\alias{reportSeuratDimRed}
\title{Generates an HTML report for Seurat Dimensionality Reduction
 and returns the SCE object with the results computed and stored
 inside the object.}
\usage{
reportSeuratDimRed(
  inSCE,
  pc.count = 50,
  runDimRed = TRUE,
  plotJackStraw = FALSE,
  plotElbowPlot = TRUE,
  plotHeatmaps = TRUE,
  outputFile = NULL,
  outputPath = NULL,
  subtitle = NULL,
  authors = NULL,
  showSession = FALSE,
  pdf = FALSE,
  forceRun = TRUE
)
}
\arguments{
\item{inSCE}{Input \code{\link[SingleCellExperiment]{SingleCellExperiment}}
object.}

\item{pc.count}{A numeric value indicating the number of principal components
to compute. Default is \code{50}.}

\item{runDimRed}{A logical value indicating if dimenionality reduction should
be computed. Default \code{TRUE}.}

\item{plotJackStraw}{A logical value indicating if JackStraw plot should be
visualized. Default \code{FALSE}.}

\item{plotElbowPlot}{A logical value indicating if ElbowPlot should be
visualized. Default \code{TRUE}.}

\item{plotHeatmaps}{A logical value indicating if heatmaps should be
visualized. Default \code{TRUE}.}

\item{outputFile}{Specify the name of the generated output HTML file.
If \code{NULL} then the output file name will be based on the name of the
Rmarkdown template. Default \code{NULL}.}

\item{outputPath}{Specify the name of the output directory to save the
rendered HTML file. If \code{NULL} the file is stored to the current
working directory. Default \code{NULL}.}

\item{subtitle}{A character value specifying the subtitle to use in the
report. Default \code{NULL}.}

\item{authors}{A character value specifying the names of the authors to use
in the report. Default \code{NULL}.}

\item{showSession}{A logical value indicating if session information
should be displayed or not. Default is \code{FALSE}.}

\item{pdf}{A logical value indicating if a pdf should also be generated for
each figure in the report. Default is \code{FALSE}.}

\item{forceRun}{A logical value indicating if all computations previously
computed should be re-calculated regardless if these computations are
available in the input object. Default is \code{TRUE}.}
}
\value{
A \code{\link[SingleCellExperiment]{SingleCellExperiment}} object
 with computations stored.
}
\description{
Generates an HTML report for Seurat Dimensionality Reduction
 and returns the SCE object with the results computed and stored
 inside the object.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runTSCAN.R
\name{getTSCANResults}
\alias{getTSCANResults}
\alias{getTSCANResults,SingleCellExperiment-method}
\alias{getTSCANResults<-}
\alias{getTSCANResults<-,SingleCellExperiment-method}
\alias{listTSCANResults}
\alias{listTSCANResults,SingleCellExperiment-method}
\alias{listTSCANTerminalNodes}
\alias{listTSCANTerminalNodes,SingleCellExperiment-method}
\title{getTSCANResults accessor function}
\usage{
getTSCANResults(x, analysisName = NULL, pathName = NULL)

\S4method{getTSCANResults}{SingleCellExperiment}(x, analysisName = NULL, pathName = NULL)

getTSCANResults(x, analysisName, pathName = NULL) <- value

\S4method{getTSCANResults}{SingleCellExperiment}(x, analysisName, pathName = NULL) <- value

listTSCANResults(x)

\S4method{listTSCANResults}{SingleCellExperiment}(x)

listTSCANTerminalNodes(x)

\S4method{listTSCANTerminalNodes}{SingleCellExperiment}(x)
}
\arguments{
\item{x}{Input \linkS4class{SingleCellExperiment} object.}

\item{analysisName}{Algorithm name implemented, should be one of
\code{"Pseudotime"}, \code{"DEG"}, or \code{"ClusterDEAnalysis"}.}

\item{pathName}{Sub folder name within the \code{analysisName}. See details.}

\item{value}{Value to be stored within the \code{pathName} or
\code{analysisName}}
}
\value{
Get or set TSCAN results
}
\description{
SCTK allows user to access all TSCAN related results with
\code{"getTSCANResults"}. See details.
}
\details{
When \code{analysisName = "Pseudotime"}, returns the list result from
\code{\link{runTSCAN}}, including the MST structure.

When \code{analysisName = "DEG"}, returns the list result from
\code{\link{runTSCANDEG}}, including \code{DataFrame}s containing genes that
increase/decrease along each the pseudotime paths. \code{pathName} indicates
the path index, the available options of which can be listed by
\code{listTSCANTerminalNodes}.

When \code{analysisName = "ClusterDEAnalysis"}, returns the list result from
\code{\link{runTSCANClusterDEAnalysis}}. Here \code{pathName} needs to match
with the \code{useCluster} argument when running the algorithm.
}
\examples{
data("mouseBrainSubsetSCE", package = "singleCellTK")
mouseBrainSubsetSCE <- runTSCAN(inSCE = mouseBrainSubsetSCE,
                                useReducedDim = "PCA_logcounts")
results <- getTSCANResults(mouseBrainSubsetSCE, "Pseudotime")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotDimRed.R
\name{plotDimRed}
\alias{plotDimRed}
\title{Plot dimensionality reduction from computed metrics including PCA, ICA, tSNE
and UMAP}
\usage{
plotDimRed(
  inSCE,
  useReduction = "PCA",
  showLegend = FALSE,
  xDim = 1,
  yDim = 2,
  xAxisLabel = NULL,
  yAxisLabel = NULL
)
}
\arguments{
\item{inSCE}{Input SCE object}

\item{useReduction}{Reduction to plot. Default is \code{"PCA"}.}

\item{showLegend}{If legends should be plotted or not}

\item{xDim}{Numeric value indicating the dimension to use for X-axis.
Default is 1 (refers to PC1).}

\item{yDim}{Numeric value indicating the dimension to use for Y-axis.
Default is 2 (refers to PC2).}

\item{xAxisLabel}{Specify the label for x-axis. Default is \code{NULL} which
will specify the label as 'x'.}

\item{yAxisLabel}{Specify the label for y-axis. Default is \code{NULL} which
will specify the label as 'y'.}
}
\value{
plot object
}
\description{
Plot dimensionality reduction from computed metrics including PCA, ICA, tSNE
and UMAP
}
\examples{
data("mouseBrainSubsetSCE", package = "singleCellTK")
plotDimRed(mouseBrainSubsetSCE, "PCA_logcounts")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/subsetSCE.R
\name{subsetSCERows}
\alias{subsetSCERows}
\title{Subset a SingleCellExperiment object by rows}
\usage{
subsetSCERows(
  inSCE,
  index = NULL,
  bool = NULL,
  rowData = NULL,
  returnAsAltExp = TRUE,
  altExpName = "subset",
  prependAltExpName = TRUE
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object.}

\item{index}{Integer vector. Vector of indicies indicating which rows
to keep. If \code{NULL}, this will not be used for subsetting.
Default \code{NULL}.}

\item{bool}{Boolean vector. Vector of \code{TRUE} or \code{FALSE}
indicating which rows should be kept. Needs to be the same length as the
number of rows in \code{inSCE}. If \code{NULL}, this will not be used
for subsetting. Default \code{NULL}.}

\item{rowData}{Character. An expression that will identify a subset of rows
using variables found in the \code{rowData} of \code{inSCE}. For example,
if \code{x} is a numeric vector in \code{rowData}, then \code{"x < 5"} will
return all rows with x less than 5. Single quotes should be used for
character strings. For example, \code{"y == 'yes'"} will return all
rows where y is "yes". Multiple expressions can be evaluated by placing them
in a vector. For example \code{c("x < 5", "y =='yes'")} will apply both
operations for subsetting. If \code{NULL}, this will not be used for
subsetting. Default \code{NULL}.}

\item{returnAsAltExp}{Boolean. If \code{TRUE}, the subsetted
\linkS4class{SingleCellExperiment} object will be returned in the
\code{altExp} slot of \code{inSCE}. If \code{FALSE}, the subsetted
\linkS4class{SingleCellExperiment} object will be directly returned.}

\item{altExpName}{Character. Name of the alternative experiment object to
add if \code{returnAsAltExp = TRUE}. Default \code{subset}.}

\item{prependAltExpName}{Boolean. If \code{TRUE}, \code{altExpName} will
be added to the beginning of the assay names in the \code{altExp} object.
This is only utilized if \code{returnAsAltExp = TRUE}. Default \code{TRUE}.}
}
\value{
A \link[SingleCellExperiment]{SingleCellExperiment} object that has
been subsetted by rowData.
}
\description{
Used to peform subsetting of a
\linkS4class{SingleCellExperiment} object using a variety of methods that
indicate the correct rows to keep. The various methods,
\code{index}, \code{bool}, and \code{rowData}, can be used in conjunction
with one another. If \code{returnAsAltExp} is set to \code{TRUE},
then the returned object will have the same number of rows as the input
\code{inSCE} as the subsetted object will be stored in the
\code{\link{altExp}} slot.
}
\examples{
data(scExample)

# Set a variable up in the rowData indicating mitochondrial genes
rowData(sce)$isMito <- ifelse(grepl("^MT-", rowData(sce)$feature_name),
                              "yes", "no")
sce <- subsetSCERows(sce, rowData = "isMito == 'yes'")
}
\author{
Joshua D. Campbell
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotTSNE.R
\name{plotTSNE}
\alias{plotTSNE}
\title{Plot t-SNE plot on dimensionality reduction data run from t-SNE method.}
\usage{
plotTSNE(
  inSCE,
  colorBy = NULL,
  shape = NULL,
  reducedDimName = "TSNE",
  runTSNE = FALSE,
  useAssay = "counts"
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object.}

\item{colorBy}{color by condition.}

\item{shape}{add shape to each distinct label.}

\item{reducedDimName}{a name to store the results of the dimension reduction
coordinates obtained from this method. This is stored in the SingleCellExperiment
object in the reducedDims slot. Required.}

\item{runTSNE}{Run t-SNE if the reducedDimName does not exist. the Default is
FALSE.}

\item{useAssay}{Indicate which assay to use. The default is "logcounts".}
}
\value{
A t-SNE plot
}
\description{
Plot t-SNE plot on dimensionality reduction data run from t-SNE method.
}
\examples{
data("mouseBrainSubsetSCE")
plotTSNE(mouseBrainSubsetSCE, colorBy = "level1class",
         reducedDimName = "TSNE_counts")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runBatchCorrection.R
\name{runComBatSeq}
\alias{runComBatSeq}
\title{Apply ComBat-Seq batch effect correction method to SingleCellExperiment
object}
\usage{
runComBatSeq(
  inSCE,
  useAssay = "counts",
  batch = "batch",
  covariates = NULL,
  bioCond = NULL,
  useSVA = FALSE,
  assayName = "ComBatSeq",
  shrink = FALSE,
  shrinkDisp = FALSE,
  nGene = NULL
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object}

\item{useAssay}{A single character indicating the name of the assay requiring
batch correction. Default \code{"counts"}.}

\item{batch}{A single character indicating a field in
\code{\link[SummarizedExperiment]{colData}} that annotates the batches.
Default \code{"batch"}.}

\item{covariates}{A character vector indicating the fields in
\code{\link[SummarizedExperiment]{colData}} that annotates other covariates,
such as the cell types. Default \code{NULL}.}

\item{bioCond}{A single character indicating a field in
\code{\link[SummarizedExperiment]{colData}} that annotates the biological
conditions. Default \code{NULL}.}

\item{useSVA}{A logical scalar. Whether to estimate surrogate variables and
use them as an empirical control. Default \code{FALSE}.}

\item{assayName}{A single characeter. The name for the corrected assay. Will
be saved to \code{\link[SummarizedExperiment]{assay}}. Default
\code{"ComBat"}.}

\item{shrink}{A logical scalar. Whether to apply shrinkage on parameter
estimation. Default \code{FALSE}.}

\item{shrinkDisp}{A logical scalar. Whether to apply shrinkage on dispersion.
Default \code{FALSE}.}

\item{nGene}{An integer. Number of random genes to use in empirical Bayes
estimation, only useful when \code{shrink} is set to \code{TRUE}. Default
\code{NULL}.}
}
\value{
The input \linkS4class{SingleCellExperiment} object with
\code{assay(inSCE, assayName)} updated.
}
\description{
The ComBat-Seq batch adjustment approach assumes that batch effects represent
non-biological but systematic shifts in the mean or variability of genomic
features for all samples within a processing batch. It uses either parametric
or non-parametric empirical Bayes frameworks for adjusting data for batch
effects.
}
\details{
For the parameters \code{covariates} and \code{useSVA}, when the cell type
information is known, it is recommended to specify the cell type annotation
to the argument \code{covariates}; if the cell types are unknown but
expected to be balanced, it is recommended to run with default settings, yet
informative covariates could still be useful. If the cell types are unknown
and are expected to be unbalanced, it is recommended to set \code{useSVA}
to \code{TRUE}.
}
\examples{
data('sceBatches', package = 'singleCellTK')
sceBatches <- sample(sceBatches, 40)
# Cell type known
sceBatches <- runComBatSeq(sceBatches, "counts", "batch",
                           covariates = "cell_type",
                           assayName = "ComBat_cell_seq")
# Cell type unknown but balanced
#sceBatches <- runComBatSeq(sceBatches, "counts", "batch",
#                           assayName = "ComBat_seq")
# Cell type unknown and unbalanced
#sceBatches <- runComBatSeq(sceBatches, "counts", "batch",
#                           useSVA = TRUE,
#                           assayName = "ComBat_sva_seq")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ggPlotting.R
\name{plotSCEViolin}
\alias{plotSCEViolin}
\title{Violin plot of any data stored in the SingleCellExperiment object.}
\usage{
plotSCEViolin(
  inSCE,
  slotName,
  itemName,
  feature = NULL,
  sample = NULL,
  dimension = NULL,
  groupBy = NULL,
  violin = TRUE,
  boxplot = TRUE,
  dots = TRUE,
  plotOrder = NULL,
  xlab = NULL,
  ylab = NULL,
  axisSize = 10,
  axisLabelSize = 10,
  dotSize = 0.1,
  transparency = 1,
  defaultTheme = TRUE,
  gridLine = FALSE,
  summary = NULL,
  title = NULL,
  titleSize = NULL,
  hcutoff = NULL,
  hcolor = "red",
  hsize = 1,
  hlinetype = 1,
  vcutoff = NULL,
  vcolor = "red",
  vsize = 1,
  vlinetype = 1,
  combinePlot = "none",
  plotLabels = NULL
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object with saved
dimension reduction components or a variable with saved results. Required.}

\item{slotName}{Desired slot of SingleCellExperiment used for plotting. Possible
options: "assays", "colData", "metadata", "reducedDims". Required.}

\item{itemName}{Desired vector within the slot used for plotting. Required.}

\item{feature}{Desired name of feature stored in assay of SingleCellExperiment
object. Only used when "assays" slotName is selected. Default NULL.}

\item{sample}{Character vector. Indicates which sample each cell belongs to.}

\item{dimension}{Desired dimension(s) stored in the specified reducedDims.
Either an integer which indicates the column(s) or a character vector specifies
column name(s). By default, the 1st dimension/column will be used.
Only used when "reducedDims" slotName is selected. Default NULL.}

\item{groupBy}{Groupings for each numeric value. A user may input a vector
equal length to the number of the samples in the SingleCellExperiment
object, or can be retrieved from the colData slot. Default NULL.}

\item{violin}{Boolean. If TRUE, will plot the violin plot. Default TRUE.}

\item{boxplot}{Boolean. If TRUE, will plot boxplots for each violin plot.
Default TRUE.}

\item{dots}{Boolean. If TRUE, will plot dots for each violin plot.
Default TRUE.}

\item{plotOrder}{Character vector. If set, reorders the violin plots
in the order of the character vector when `groupBy` is set.
Default NULL.}

\item{xlab}{Character vector. Label for x-axis. Default NULL.}

\item{ylab}{Character vector. Label for y-axis. Default NULL.}

\item{axisSize}{Size of x/y-axis ticks. Default 10.}

\item{axisLabelSize}{Size of x/y-axis labels. Default 10.}

\item{dotSize}{Size of dots. Default 0.1.}

\item{transparency}{Transparency of the dots, values will be 0-1. Default 1.}

\item{defaultTheme}{Removes grid in plot and sets axis title size to 10
when TRUE. Default TRUE.}

\item{gridLine}{Adds a horizontal grid line if TRUE. Will still be
drawn even if defaultTheme is TRUE. Default FALSE.}

\item{summary}{Adds a summary statistic, as well as a crossbar to the
violin plot. Options are "mean" or "median". Default NULL.}

\item{title}{Title of plot. Default NULL.}

\item{titleSize}{Size of title of plot. Default 15.}

\item{hcutoff}{Adds a horizontal line with the y-intercept at given value. Default NULL.}

\item{hcolor}{Character. A color available from `colors()`.
Controls the color of the horizontal cutoff line, if drawn.
Default 'black'.}

\item{hsize}{Size of horizontal line, if drawn. Default 0.5.}

\item{hlinetype}{Type of horizontal line, if drawn. can be specified with either an integer or
a name (0 = blank, 1 = solid, 2 = dashed, 3 = dotted, 4 = dotdash, 5 = longdash, 6 = twodash).
Default 1.}

\item{vcutoff}{Adds a vertical line with the x-intercept at given value. Default NULL.}

\item{vcolor}{Character. A color available from `colors()`.
Controls the color of the vertical cutoff line, if drawn.
Default 'black'.}

\item{vsize}{Size of vertical line, if drawn. Default 0.5.}

\item{vlinetype}{Type of vertical line, if drawn. can be specified with either an integer or
a name (0 = blank, 1 = solid, 2 = dashed, 3 = dotted, 4 = dotdash, 5 = longdash, 6 = twodash).
Default 1.}

\item{combinePlot}{Must be either "all", "sample", or "none". "all" will combine all plots into a single
.ggplot object, while "sample" will output a list of plots separated by sample. Default "none".}

\item{plotLabels}{labels to each plot. If set to "default", will use the name of the samples
as the labels. If set to "none", no label will be plotted.}
}
\value{
a ggplot of the violin plot.
}
\description{
Visualizes values stored in any slot of a
 SingleCellExperiment object via a violin plot.
}
\examples{
data("mouseBrainSubsetSCE")
plotSCEViolin(
  inSCE = mouseBrainSubsetSCE, slotName = "assays",
  itemName = "counts", feature = "Apoe", groupBy = "sex"
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/enrichRSCE.R
\name{plotEnrichR}
\alias{plotEnrichR}
\title{Plot EnrichR results}
\usage{
plotEnrichR(
  inSCE,
  analysisName,
  showTerms = 20,
  numChar = 40,
  y = "Count",
  orderBy = "Adjusted.P.value",
  xlab = NULL,
  ylab = NULL,
  title = NULL
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object with saved
EnrichR results. Required.}

\item{analysisName}{A string that identifies the specific analysis to plot.
Required.}

\item{showTerms}{Number of enrichment terms to show. Default is 20.}

\item{numChar}{Integer. Indicates the maximum number characters to be
displayed in the term names. Default is 40.}

\item{y}{Character string. Indicates the variable to be shown on the
y-axis. Can be one of "Count" or "Ratio". Results that include background
genes can only show "Count". Default is "Count".}

\item{orderBy}{Charachter string. Indicates how to order the results prior
to subsetting. Can be one of "P.value", "Adjusted.P.Value",
or "Combined.Score". Default is "Adjusted.P.value".}

\item{xlab}{Character vector. Label for x-axis. Default NULL.}

\item{ylab}{Character vector. Label for y-axis. Default NULL.}

\item{title}{Character string. Title of the plot. Default NULL.}
}
\value{
A ggplot object of EnrichR results.
}
\description{
Plot results of EnrichR analysis as a barplot.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runBatchCorrection.R
\name{runSCANORAMA}
\alias{runSCANORAMA}
\title{Apply the mutual nearest neighbors (MNN) batch effect correction method to
SingleCellExperiment object}
\usage{
runSCANORAMA(
  inSCE,
  useAssay = "logcounts",
  batch = "batch",
  assayName = "SCANORAMA",
  SIGMA = 15,
  ALPHA = 0.1,
  KNN = 20,
  approx = TRUE
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object}

\item{useAssay}{A single character indicating the name of the assay requiring
batch correction. Scanorama requires a transformed normalized expression
assay. Default \code{"logcounts"}.}

\item{batch}{A single character indicating a field in \code{colData} that
annotates the batches of each cell; or a vector/factor with the same length
as the number of cells. Default \code{"batch"}.}

\item{assayName}{A single characeter. The name for the corrected assay. Will
be saved to \code{\link{assay}}. Default
\code{"SCANORAMA"}.}

\item{SIGMA}{A numeric scalar. Algorithmic parameter, correction smoothing
parameter on Gaussian kernel. Default \code{15}.}

\item{ALPHA}{A numeric scalar. Algorithmic parameter, alignment score
minimum cutoff. Default \code{0.1}.}

\item{KNN}{An integer. Algorithmic parameter, number of nearest neighbors to
use for matching. Default \code{20}.}

\item{approx}{Boolean. Use approximate nearest neighbors, greatly speeds up
matching runtime. Default \code{TRUE}.}
}
\value{
The input \linkS4class{SingleCellExperiment} object with
\code{assay(inSCE, assayName)} updated.
}
\description{
SCANORAMA is analogous to computer vision algorithms for panorama stitching
that identify images with overlapping content and merge these into a larger
panorama.
}
\examples{
\dontrun{
data('sceBatches', package = 'singleCellTK')
logcounts(sceBatches) <- log1p(counts(sceBatches))
sceCorr <- runSCANORAMA(sceBatches, "ScaterLogNormCounts")
}
}
\references{
Brian Hie et al, 2019
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotBatchVariance.R
\name{plotSCEBatchFeatureMean}
\alias{plotSCEBatchFeatureMean}
\title{Plot mean feature value in each batch of a SingleCellExperiment object}
\usage{
plotSCEBatchFeatureMean(
  inSCE,
  useAssay = NULL,
  useReddim = NULL,
  useAltExp = NULL,
  batch = "batch",
  xlab = "batch",
  ylab = "Feature Mean",
  ...
)
}
\arguments{
\item{inSCE}{\linkS4class{SingleCellExperiment} inherited object.}

\item{useAssay}{A single character. The name of the assay that stores the
value to plot. For \code{useReddim} and \code{useAltExp} also. Default
\code{NULL}.}

\item{useReddim}{A single character. The name of the dimension reduced
matrix that stores the value to plot. Default \code{NULL}.}

\item{useAltExp}{A single character. The name of the alternative experiment
that stores an assay of the value to plot. Default \code{NULL}.}

\item{batch}{A single character. The name of batch annotation column in
\code{colData(inSCE)}. Default \code{"batch"}.}

\item{xlab}{label for x-axis. Default \code{"batch"}.}

\item{ylab}{label for y-axis. Default \code{"Feature Mean"}.}

\item{...}{Additional arguments passed to \code{.ggViolin}.}
}
\value{
ggplot
}
\description{
Plot mean feature value in each batch of a SingleCellExperiment object
}
\examples{
data('sceBatches', package = 'singleCellTK')
plotSCEBatchFeatureMean(sceBatches, useAssay = "counts")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/exportSCEtoTXT.R
\name{exportSCEtoFlatFile}
\alias{exportSCEtoFlatFile}
\title{Export a \link[SingleCellExperiment]{SingleCellExperiment} object to flat text files}
\usage{
exportSCEtoFlatFile(
  sce,
  outputDir = "./",
  overwrite = TRUE,
  gzipped = TRUE,
  prefix = "SCE"
)
}
\arguments{
\item{sce}{\link[SingleCellExperiment]{SingleCellExperiment} object to be
exported.}

\item{outputDir}{Name of the directory to store the exported file(s).}

\item{overwrite}{Boolean. Whether to overwrite the output files. Default
\code{TRUE}.}

\item{gzipped}{Boolean. \code{TRUE} if the output files are to be
gzip compressed. \code{FALSE} otherwise. Default
\code{TRUE}.}

\item{prefix}{Prefix of file names.}
}
\value{
Generates text files containing data from \code{inSCE}.
}
\description{
Writes all assays, colData, rowData, reducedDims, and altExps objects in a
\link[SingleCellExperiment]{SingleCellExperiment} to text files.
The items in the 'metadata' slot remain stored in list and are saved in an RDS file.
}
\examples{
data(sce_chcl, package = "scds")
\dontrun{
exportSCEtoFlatFile(sce_chcl, "sce_chcl")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/importBUStools.R
\name{importBUStools}
\alias{importBUStools}
\title{Construct SCE object from BUStools output}
\usage{
importBUStools(
  BUStoolsDirs,
  samples,
  matrixFileNames = "genes.mtx",
  featuresFileNames = "genes.genes.txt",
  barcodesFileNames = "genes.barcodes.txt",
  gzipped = "auto",
  class = c("Matrix", "matrix"),
  delayedArray = FALSE,
  rowNamesDedup = TRUE
)
}
\arguments{
\item{BUStoolsDirs}{A vector of paths to BUStools output files. Each sample
should have its own path. For example: \code{./genecount}.
Must have the same length as \code{samples}.}

\item{samples}{A vector of user-defined sample names for the samples to be
imported. Must have the same length as \code{BUStoolsDirs}.}

\item{matrixFileNames}{Filenames for the Market Exchange Format (MEX) sparse
matrix files (.mtx files). Must have length 1 or the same
length as \code{samples}.}

\item{featuresFileNames}{Filenames for the feature annotation files.
Must have length 1 or the same length as \code{samples}.}

\item{barcodesFileNames}{Filenames for the cell barcode list file.
Must have length 1 or the same length as \code{samples}.}

\item{gzipped}{Boolean. \code{TRUE} if the BUStools output files
(barcodes.txt, genes.txt, and genes.mtx) were
gzip compressed. \code{FALSE} otherwise. This is \code{FALSE} in BUStools
0.39.4. Default \code{"auto"} which automatically detects if the
files are gzip compressed. Must have length 1 or the same length as
\code{samples}.}

\item{class}{Character. The class of the expression matrix stored in the SCE
object. Can be one of "Matrix" (as returned by
\link{readMM} function), or "matrix" (as returned by
\link[base]{matrix} function). Default "Matrix".}

\item{delayedArray}{Boolean. Whether to read the expression matrix as
\link[DelayedArray]{DelayedArray-class} object or not. Default \code{FALSE}.}

\item{rowNamesDedup}{Boolean. Whether to deduplicate rownames. Default 
\code{TRUE}.}
}
\value{
A \code{SingleCellExperiment} object containing the count
 matrix, the gene annotation, and the cell annotation.
}
\description{
Read the barcodes, features (genes), and matrix from BUStools
 output. Import them
 as one \link[SingleCellExperiment]{SingleCellExperiment} object. Note the
 cells in the output files for BUStools 0.39.4 are not filtered.
}
\examples{
# Example #1
# FASTQ files were downloaded from
# https://support.10xgenomics.com/single-cell-gene-expression/datasets/3.0.0
# /pbmc_1k_v3
# They were concatenated as follows:
# cat pbmc_1k_v3_S1_L001_R1_001.fastq.gz pbmc_1k_v3_S1_L002_R1_001.fastq.gz >
# pbmc_1k_v3_R1.fastq.gz
# cat pbmc_1k_v3_S1_L001_R2_001.fastq.gz pbmc_1k_v3_S1_L002_R2_001.fastq.gz >
# pbmc_1k_v3_R2.fastq.gz
# The following BUStools command generates the gene, cell, and
# matrix files

# bustools correct -w ./3M-february-2018.txt -p output.bus | \
#   bustools sort -T tmp/ -t 4 -p - | \
#   bustools count -o genecount/genes \
#     -g ./transcripts_to_genes.txt \
#     -e matrix.ec \
#     -t transcripts.txt \
#     --genecounts -

# The top 20 genes and the first 20 cells are included in this example.
sce <- importBUStools(
  BUStoolsDirs = system.file("extdata/BUStools_PBMC_1k_v3_20x20/genecount/",
    package = "singleCellTK"),
  samples = "PBMC_1k_v3_20x20")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runSoupX.R
\name{plotSoupXResults}
\alias{plotSoupXResults}
\title{Plot SoupX Result}
\usage{
plotSoupXResults(
  inSCE,
  sample = NULL,
  background = FALSE,
  reducedDimName = NULL,
  plotNCols = 3,
  plotNRows = 2,
  baseSize = 8,
  combinePlot = c("all", "sample", "none"),
  xlab = NULL,
  ylab = NULL,
  dim1 = NULL,
  dim2 = NULL,
  labelClusters = FALSE,
  clusterLabelSize = 3.5,
  defaultTheme = TRUE,
  dotSize = 0.5,
  transparency = 1,
  titleSize = NULL,
  axisLabelSize = NULL,
  axisSize = NULL,
  legendSize = NULL,
  legendTitleSize = NULL
)
}
\arguments{
\item{inSCE}{A \linkS4class{SingleCellExperiment} object. With
\code{\link{runSoupX}} already applied.}

\item{sample}{Character vector. Indicates which sample each cell belongs to.
Default \code{NULL}.}

\item{background}{Logical. Whether \code{background} was applied when
running \code{\link{runSoupX}}. Default \code{FALSE}.}

\item{reducedDimName}{Character. The embedding to use for plotting. Leave it
\code{NULL} for using the sample-specific UMAPs generated when running
\code{\link{runSoupX}}. Default \code{NULL}.}

\item{plotNCols}{Integer. Number of columns for the plot grid per sample.
Will determine the number of top markers to show together with
\code{plotNRows}. Default \code{3}.}

\item{plotNRows}{Integer. Number of rows for the plot grid per sample. Will
determine the number of top markers to show together with \code{plotNCols}.
Default \code{2}.}

\item{baseSize}{Numeric. The base font size for all text. Default 12. Can be
overwritten by titleSize, axisSize, and axisLabelSize, legendSize,
legendTitleSize. Default \code{8}.}

\item{combinePlot}{Must be either \code{"all"}, \code{"sample"}, or
\code{"none"}. \code{"all"} will combine all plots into a single
\code{.ggplot} object, while \code{"sample"} will output a list of plots
separated by sample. Default \code{"all"}.}

\item{xlab}{Character vector. Label for x-axis. Default \code{NULL}.}

\item{ylab}{Character vector. Label for y-axis. Default \code{NULL}.}

\item{dim1}{See \code{\link{plotSCEDimReduceColData}}. Default \code{NULL}.}

\item{dim2}{See \code{\link{plotSCEDimReduceColData}}. Default \code{NULL}.}

\item{labelClusters}{Logical. Whether the cluster labels are plotted. Default
\code{FALSE}.}

\item{clusterLabelSize}{Numeric. Determines the size of cluster label when
\code{labelClusters} is set to \code{TRUE}. Default \code{3.5}.}

\item{defaultTheme}{Logical. Adds grid to plot when \code{TRUE}. Default
\code{TRUE}.}

\item{dotSize}{Numeric. Size of dots. Default \code{0.5}.}

\item{transparency}{Numeric. Transparency of the dots, values will be from 0
to 1. Default \code{1}.}

\item{titleSize}{Numeric. Size of title of plot. Default \code{15}.}

\item{axisLabelSize}{Numeric. Size of x/y-axis labels. Default \code{NULL}.}

\item{axisSize}{Numeric. Size of x/y-axis ticks. Default \code{NULL}.}

\item{legendSize}{Numeric. Size of legend. Default \code{NULL}.}

\item{legendTitleSize}{Numeric. Size of legend title. Default \code{NULL}.}
}
\value{
ggplot object of the combination of UMAPs. See description.
}
\description{
This function will generate a combination of plots basing on the
correction done by SoupX. For each sample, there will be a UMAP with cluster
labeling, followed by a number of UMAPs showing the change in selected top
markers. The cluster labeling is what should be used for SoupX to estimate
the contamination. The Soup Fraction is calculated by subtracting the gene
expression value of the output corrected matrix from that of the original
input matrix, and then devided by the input.
}
\examples{
\dontrun{
sce <- importExampleData("pbmc3k")
sce <- runSoupX(sce, sample = "sample")
plotSoupXResults(sce, sample = "sample")
}
}
\seealso{
runSoupX
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/exportSCEtoAnndata.R
\name{exportSCEtoAnnData}
\alias{exportSCEtoAnnData}
\title{Export a \link[SingleCellExperiment]{SingleCellExperiment} R object as
Python annData object}
\usage{
exportSCEtoAnnData(
  sce,
  useAssay = "counts",
  outputDir = "./",
  prefix = "sample",
  overwrite = TRUE,
  compression = c("gzip", "lzf", "None"),
  compressionOpts = NULL,
  forceDense = FALSE
)
}
\arguments{
\item{sce}{\link[SingleCellExperiment]{SingleCellExperiment} R object to be
exported.}

\item{useAssay}{Character. The name of assay of
interests that will be set as the primary matrix of the output AnnData.
Default \code{"counts"}.}

\item{outputDir}{Path to the directory where .h5ad outputs will be written. Default is the current working directory.}

\item{prefix}{Prefix to use for the name of the output file. Default \code{"sample"}.}

\item{overwrite}{Boolean. Default \code{TRUE}.}

\item{compression}{If output file compression is required, this variable accepts
'gzip', 'lzf' or "None" as inputs. Default \code{"gzip"}.}

\item{compressionOpts}{Integer. Sets the compression level}

\item{forceDense}{Default \code{False} Write sparse data as a dense matrix.
Refer \code{anndata.write_h5ad} documentation for details. Default \code{NULL}.}
}
\value{
Generates a Python anndata object containing data from \code{inSCE}.
}
\description{
Writes all assays, colData, rowData, reducedDims, and altExps objects in a
\link[SingleCellExperiment]{SingleCellExperiment} to a Python annData object in the .h5ad format
All parameters of Anndata.write_h5ad function (https://icb-anndata.readthedocs-hosted.com/en/stable/anndata.AnnData.write_h5ad.html)
are available as parameters to this export function and set to defaults. Defaults can be
overridden at function call.
}
\examples{
data(sce_chcl, package = "scds")
\dontrun{
exportSCEtoAnnData(sce=sce_chcl, compression="gzip")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scanpyFunctions.R
\name{runScanpyNormalizeData}
\alias{runScanpyNormalizeData}
\title{runScanpyNormalizeData
Wrapper for NormalizeData() function from scanpy library
Normalizes the sce object according to the input parameters}
\usage{
runScanpyNormalizeData(
  inSCE,
  useAssay,
  targetSum = 10000,
  maxFraction = 0.05,
  normAssayName = "scanpyNormData"
)
}
\arguments{
\item{inSCE}{(sce) object to normalize}

\item{useAssay}{Assay containing raw counts to use for normalization.}

\item{targetSum}{If NULL, after normalization, each observation (cell) has a 
total count equal to the median of total counts for observations (cells) 
before normalization. Default \code{1e4}}

\item{maxFraction}{Include cells that have more counts than max_fraction of 
the original total counts in at least one cell. Default \code{0.05}}

\item{normAssayName}{Name of new assay containing normalized data. Default
\code{scanpyNormData}.}
}
\value{
Normalized \code{SingleCellExperiment} object
}
\description{
runScanpyNormalizeData
Wrapper for NormalizeData() function from scanpy library
Normalizes the sce object according to the input parameters
}
\examples{
data(scExample, package = "singleCellTK")
sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
rownames(sce) <- rowData(sce)$feature_name
\dontrun{
sce <- runScanpyNormalizeData(sce, useAssay = "counts")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/allGenerics.R, R/sampleSummaryStats.R
\name{getSampleSummaryStatsTable}
\alias{getSampleSummaryStatsTable}
\alias{setSampleSummaryStatsTable<-}
\alias{getSampleSummaryStatsTable,SingleCellExperiment-method}
\alias{setSampleSummaryStatsTable<-,SingleCellExperiment-method}
\title{Stores and returns table of SCTK QC outputs to metadata.}
\usage{
getSampleSummaryStatsTable(inSCE, statsName, ...)

setSampleSummaryStatsTable(inSCE, statsName, ...) <- value

\S4method{getSampleSummaryStatsTable}{SingleCellExperiment}(inSCE, statsName, ...)

\S4method{setSampleSummaryStatsTable}{SingleCellExperiment}(inSCE, statsName, ...) <- value
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object with saved
\link{assay} data and/or \link{colData} data. Required.}

\item{statsName}{A \code{character} value indicating the slot
that stores the stats table within the metadata of the
SingleCellExperiment object. Required.}

\item{...}{Other arguments passed to the function.}

\item{value}{The summary table for QC statistics generated from SingleCellTK
to be added to the SCE object.}
}
\value{
For \code{getSampleSummaryStatsTable}, A matrix/array object. 
Contains a summary table for QC statistics generated from SingleCellTK. For
\code{setSampleSummaryStatsTable<-}, A SingleCellExperiment object where the 
summary table is updated in the \code{metadata} slot.
}
\description{
Stores and returns table of QC metrics generated from
 QC algorithms within the metadata slot of the SingleCellExperiment object.
}
\examples{
data(scExample, package = "singleCellTK")
sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
sce <- sampleSummaryStats(sce, simple = TRUE, statsName = "qc_table")
getSampleSummaryStatsTable(sce, statsName = "qc_table")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runVAM.R
\name{runVAM}
\alias{runVAM}
\title{Run VAM to score gene sets in single cell data}
\usage{
runVAM(
  inSCE,
  geneSetCollectionName = "H",
  useAssay = "logcounts",
  resultNamePrefix = NULL,
  center = FALSE,
  gamma = TRUE
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object.}

\item{geneSetCollectionName}{Character. The name of the gene set collection
to use. Default \code{"H"}.}

\item{useAssay}{Character. The name of the assay to use. This assay should
contain log normalized counts. Default \code{"logcounts"}.}

\item{resultNamePrefix}{Character. Prefix to the name the VAM results which
will be stored in the reducedDim slot of \code{inSCE}. The names of the
output matrices will be \code{resultNamePrefix_Distance} and
\code{resultNamePrefix_CDF}. If this parameter is set to \code{NULL}, then
\code{"VAM_geneSetCollectionName_"} will be used. Default \code{NULL}.}

\item{center}{Boolean. If \code{TRUE}, values will be mean centered when
computing the Mahalanobis statistic. Default \code{FALSE}.}

\item{gamma}{Boolean. If \code{TRUE}, a gamma distribution will be fit to
the non-zero squared Mahalanobis distances computed from a row-permuted
version of the gene expression matrix. The estimated gamma distribution will
be used to compute a one-sided p-value for each cell. If \code{FALSE}, the
p-value will be computed using the standard chi-square approximation for the
squared Mahalanobis distance (or non-central if \code{center = FALSE}).
Default \code{TRUE}.}
}
\value{
A \linkS4class{SingleCellExperiment} object with VAM metrics stored
in \code{reducedDim} as \code{VAM_NameOfTheGeneset_Distance} and
\code{VAM_NameOfTheGeneset_CDF}.
}
\description{
Wrapper for the Variance-adjusted Mahalanobis (VAM), which is a
fast and accurate method for cell-specific gene set scoring of single cell
data. This algorithm computes distance statistics and one-sided p-values for
all cells in the specified single cell gene expression matrix. Gene sets
should already be imported and stored in the meta data using functions such
as \link{importGeneSetsFromList} or \link{importGeneSetsFromMSigDB}
}
\examples{
data(scExample, package = "singleCellTK")
sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
sce <- scaterlogNormCounts(sce, assayName = "logcounts")
gs1 <- rownames(sce)[seq(10)]
gs2 <- rownames(sce)[seq(11,20)]
gs <- list("geneset1" = gs1, "geneset2" = gs2)
sce <- importGeneSetsFromList(inSCE = sce,geneSetList = gs,
                              by = "rownames")
sce <- runVAM(inSCE = sce,
              geneSetCollectionName = "GeneSetCollection",
              useAssay = "logcounts")
}
\seealso{
\link{importGeneSetsFromList}, \link{importGeneSetsFromMSigDB},
\link{importGeneSetsFromGMT}, \link{importGeneSetsFromCollection} for
importing gene sets. \link{sctkListGeneSetCollections},
\link{getPathwayResultNames} and \link{getGenesetNamesFromCollection} for
available related information in \code{inSCE}.
}
\author{
Nida Pervaiz
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scater_CPM.R
\name{scaterCPM}
\alias{scaterCPM}
\title{scaterCPM
Uses CPM from scater library to compute counts-per-million.}
\usage{
scaterCPM(inSCE, assayName = "ScaterCPMCounts", useAssay = "counts")
}
\arguments{
\item{inSCE}{Input SingleCellExperiment object}

\item{assayName}{New assay name for cpm data.}

\item{useAssay}{Input assay}
}
\value{
inSCE Updated SingleCellExperiment object
}
\description{
scaterCPM
Uses CPM from scater library to compute counts-per-million.
}
\examples{
data(sce_chcl, package = "scds")
sce_chcl <- scaterCPM(sce_chcl,"countsCPM", "counts")
}
\author{
Irzam Sarfraz
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/htmlReports.R
\name{reportSeuratRun}
\alias{reportSeuratRun}
\title{Generates an HTML report for Seurat Run (including Normalization,
 Feature Selection, Dimensionality Reduction & Clustering) and returns the
 SCE object with the results computed and stored inside the object.}
\usage{
reportSeuratRun(
  inSCE,
  biological.group = NULL,
  phenotype.groups = NULL,
  variable.features = 2000,
  pc.count = 50,
  runHVG = TRUE,
  plotHVG = TRUE,
  runDimRed = TRUE,
  plotJackStraw = FALSE,
  plotElbowPlot = TRUE,
  plotHeatmaps = TRUE,
  runClustering = TRUE,
  plotTSNE = TRUE,
  plotUMAP = TRUE,
  minResolution = 0.3,
  maxResolution = 1.5,
  outputFile = NULL,
  outputPath = NULL,
  subtitle = NULL,
  authors = NULL,
  showSession = FALSE,
  pdf = FALSE,
  forceRun = TRUE
)
}
\arguments{
\item{inSCE}{Input \code{\link[SingleCellExperiment]{SingleCellExperiment}}
object.}

\item{biological.group}{A character value that specifies the name of the
\code{colData()} column to use as the main biological group in the Seurat
report for tSNE & UMAP visualization.}

\item{phenotype.groups}{A character value that specifies the name of the
\code{colData()} column to use as additional phenotype variables in the
Seurat report for tSNE & UMAP visualization.}

\item{variable.features}{A numeric value indicating the number of top
variable genes to identify in the report. Default is \code{2000}.}

\item{pc.count}{A numeric value indicating the number of principal
components to use in the analysis workflow. Default is \code{50}.}

\item{runHVG}{A logical value indicating if feature selection should be run
in the report. Default \code{TRUE}.}

\item{plotHVG}{A logical value indicating if the top variable genes should
be visualized through a mean-to-variance plot. Default is \code{TRUE}.}

\item{runDimRed}{A logical value indicating if PCA should be computed in the
report. Default is \code{TRUE}.}

\item{plotJackStraw}{A logical value indicating if the JackStraw plot should
be visualized for the principal components. Default is \code{FALSE}.}

\item{plotElbowPlot}{A logical value indicating if the ElbowPlot should be
visualized for the principal components. Default is \code{FALSE}.}

\item{plotHeatmaps}{A logical value indicating if the Heatmaps should be
visualized for the principal components. Default is \code{FALSE}.}

\item{runClustering}{A logical value indicating if Clustering should be
run over multiple resolutions as defined by the \code{minResolution} and
\code{maxResolution} parameters. Default is \code{TRUE}.}

\item{plotTSNE}{A logical value indicating if TSNE plot should be visualized
for clusters. Default is \code{TRUE}.}

\item{plotUMAP}{A logical value indicating if UMAP plot should be visualized
for clusters. Default is \code{TRUE}.}

\item{minResolution}{A numeric value indicating the minimum resolution to use
for clustering. Default \code{0.3}.}

\item{maxResolution}{A numeric value indicating the maximum resolution to use
for clustering. Default \code{1.5}.}

\item{outputFile}{Specify the name of the generated output HTML file.
If \code{NULL} then the output file name will be based on the name of the
Rmarkdown template. Default \code{NULL}.}

\item{outputPath}{Specify the name of the output directory to save the
rendered HTML file. If \code{NULL} the file is stored to the current
working directory. Default \code{NULL}.}

\item{subtitle}{A character value specifying the subtitle to use in the
report. Default \code{NULL}.}

\item{authors}{A character value specifying the names of the authors to use
in the report. Default \code{NULL}.}

\item{showSession}{A logical value indicating if session information
should be displayed or not. Default is \code{FALSE}.}

\item{pdf}{A logical value indicating if a pdf should also be generated for
each figure in the report. Default is \code{FALSE}.}

\item{forceRun}{A logical value indicating if all computations previously
computed should be re-calculated regardless if these computations are
available in the input object. Default is \code{TRUE}.}
}
\value{
A \code{\link[SingleCellExperiment]{SingleCellExperiment}} object
 with computations stored.
}
\description{
Generates an HTML report for Seurat Run (including Normalization,
 Feature Selection, Dimensionality Reduction & Clustering) and returns the
 SCE object with the results computed and stored inside the object.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scanpyFunctions.R
\name{plotScanpyMarkerGenes}
\alias{plotScanpyMarkerGenes}
\title{plotScanpyMarkerGenes}
\usage{
plotScanpyMarkerGenes(
  inSCE,
  groups = NULL,
  nGenes = 10,
  nCols = 4,
  sharey = FALSE
)
}
\arguments{
\item{inSCE}{Input \code{SingleCellExperiment} object.}

\item{groups}{The groups for which to show the gene ranking. Default \code{NULL}
means that all groups will be considered.}

\item{nGenes}{Number of genes to show. Default \code{10}}

\item{nCols}{Number of panels shown per row. Default \code{4}}

\item{sharey}{Controls if the y-axis of each panels should be shared. 
Default \code{FALSE} allows each panel to have its own y-axis range.}
}
\value{
plot object
}
\description{
plotScanpyMarkerGenes
}
\examples{
data(scExample, package = "singleCellTK")
\dontrun{
sce <- runScanpyNormalizeData(sce, useAssay = "counts")
sce <- runScanpyFindHVG(sce, useAssay = "scanpyNormData", method = "seurat")
sce <- runScanpyScaleData(sce, useAssay = "scanpyNormData")
sce <- runScanpyPCA(sce, useAssay = "scanpyScaledData")
sce <- runScanpyFindClusters(sce, useReducedDim = "scanpyPCA")
sce <- runScanpyFindMarkers(sce, colDataName = "Scanpy_louvain_1" )
plotScanpyMarkerGenes(sce, groups = '0')
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ggPlotting.R
\name{plotEmptyDropsScatter}
\alias{plotEmptyDropsScatter}
\title{Plots for runEmptyDrops outputs.}
\usage{
plotEmptyDropsScatter(
  inSCE,
  sample = NULL,
  fdrCutoff = 0.01,
  defaultTheme = TRUE,
  dotSize = 0.1,
  title = NULL,
  titleSize = 18,
  xlab = NULL,
  ylab = NULL,
  axisSize = 12,
  axisLabelSize = 15,
  legendTitle = NULL,
  legendTitleSize = 12,
  legendSize = 10,
  combinePlot = "none",
  relHeights = 1,
  relWidths = 1,
  samplePerColumn = TRUE,
  sampleRelHeights = 1,
  sampleRelWidths = 1
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object with saved
dimension reduction components or a variable with saved results from
\code{\link{runEmptyDrops}}. Required.}

\item{sample}{Character vector or colData variable name. Indicates which
sample each cell belongs to. Default \code{NULL}.}

\item{fdrCutoff}{Numeric. Thresholds barcodes based on the FDR values from
\code{\link{runEmptyDrops}} as "Empty Droplet" or "Putative Cell". Default
\code{0.01}.}

\item{defaultTheme}{Removes grid in plot and sets axis title size to
\code{10} when \code{TRUE}. Default \code{TRUE}.}

\item{dotSize}{Size of dots. Default \code{0.1}.}

\item{title}{Title of plot. Default \code{NULL}.}

\item{titleSize}{Size of title of plot. Default \code{18}.}

\item{xlab}{Character vector. Label for x-axis. Default \code{NULL}.}

\item{ylab}{Character vector. Label for y-axis. Default \code{NULL}.}

\item{axisSize}{Size of x/y-axis ticks. Default \code{12}.}

\item{axisLabelSize}{Size of x/y-axis labels. Default \code{15}.}

\item{legendTitle}{Title of legend. Default \code{NULL}.}

\item{legendTitleSize}{size of legend title. Default \code{12}.}

\item{legendSize}{size of legend. Default \code{10}.}

\item{combinePlot}{Must be either \code{"all"}, \code{"sample"}, or
\code{"none"}. \code{"all"} will combine all plots into a single .ggplot
object, while \code{"sample"} will output a list of plots separated by
sample. Default \code{"all"}.}

\item{relHeights}{Relative heights of plots when combine is set. Default
\code{1}.}

\item{relWidths}{Relative widths of plots when combine is set. Default
\code{1}.}

\item{samplePerColumn}{If \code{TRUE}, when there are multiple samples and
combining by \code{"all"}, the output .ggplot will have plots from each
sample on a single column. Default \code{TRUE}.}

\item{sampleRelHeights}{If there are multiple samples and combining by
\code{"all"}, the relative heights for each plot. Default \code{1}.}

\item{sampleRelWidths}{If there are multiple samples and combining by
\code{"all"}, the relative widths for each plot. Default \code{1}.}
}
\value{
a ggplot object of the scatter plot.
}
\description{
A plotting function which visualizes outputs from the
\code{\link{runEmptyDrops}} function stored in the colData slot of the
\linkS4class{SingleCellExperiment} object via scatter plots.
}
\examples{
data(scExample, package = "singleCellTK")
sce <- runEmptyDrops(inSCE = sce)
plotEmptyDropsScatter(inSCE = sce)
}
\seealso{
\code{\link{runEmptyDrops}}, \code{\link{plotEmptyDropsResults}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scds_doubletdetection.R
\name{runCxdsBcdsHybrid}
\alias{runCxdsBcdsHybrid}
\title{Find doublets/multiplets using \link[scds]{cxds_bcds_hybrid}.}
\usage{
runCxdsBcdsHybrid(
  inSCE,
  sample = NULL,
  seed = 12345,
  nTop = 500,
  cxdsArgs = list(),
  bcdsArgs = list(),
  verb = FALSE,
  estNdbl = FALSE,
  force = FALSE,
  useAssay = "counts"
)
}
\arguments{
\item{inSCE}{A \link[SingleCellExperiment]{SingleCellExperiment} object.
Needs \code{counts} in assays slot.}

\item{sample}{Character vector. Indicates which sample each cell belongs to.
\link[scds]{cxds_bcds_hybrid} will be run on cells from each sample
separately. If NULL, then all cells will be processed together.
Default NULL.}

\item{seed}{Seed for the random number generator. Default 12345.}

\item{nTop}{The number of top varialbe genes to consider. Used in both \code{csds}
and \code{bcds}. Default \code{500}.}

\item{cxdsArgs}{See \link[scds]{cxds_bcds_hybrid} for more information. Default \code{NULL}.}

\item{bcdsArgs}{See \link[scds]{cxds_bcds_hybrid} for more information. Default \code{NULL}.}

\item{verb}{See \link[scds]{cxds_bcds_hybrid} for more information. Default \code{FALSE}.}

\item{estNdbl}{See \link[scds]{cxds_bcds_hybrid} for more information. Default \code{FALSE}.}

\item{force}{See \link[scds]{cxds_bcds_hybrid} for more information. Default \code{FALSE}.}

\item{useAssay}{A string specifying which assay in the SCE to use.}
}
\value{
A \link[SingleCellExperiment]{SingleCellExperiment} object with
 \link[scds]{cxds_bcds_hybrid} output appended to the
 \link{colData} slot. The columns include
 \emph{hybrid_score} and optionally \emph{hybrid_call}.
 Please refer to the documentation of \link[scds]{cxds_bcds_hybrid} for
 details.
}
\description{
A wrapper function for \link[scds]{cxds_bcds_hybrid}. Annotate
 doublets/multiplets using a binary classification approach to discriminate
 artificial doublets from original data. Generate a doublet
 score for each cell. Infer doublets if \code{estNdbl} is \code{TRUE}.
}
\examples{
data(scExample, package = "singleCellTK")
sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
sce <- runCxdsBcdsHybrid(sce)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/abundance.R
\name{plotClusterAbundance}
\alias{plotClusterAbundance}
\title{Plot the differential Abundance}
\usage{
plotClusterAbundance(inSCE, cluster, variable, combinePlot = c("all", "none"))
}
\arguments{
\item{inSCE}{A \code{\link[SingleCellExperiment]{SingleCellExperiment}}
object.}

\item{cluster}{A single \code{character}, specifying the name to store the
cluster label in \code{\link{colData}}.}

\item{variable}{A single \code{character}, specifying the name to store the
phenotype labels in \code{\link{colData}}.}

\item{combinePlot}{Must be either "all" or "none". "all" will combine all 
plots into a single \code{\link[ggplot2]{ggplot}} object. Default 
\code{"all"}.}
}
\value{
When \code{combinePlot = "none"}, a \code{list} with 4 
\code{\link[ggplot2]{ggplot}} objects; when \code{combinePlot = "all"}, a 
single \code{\link[ggplot2]{ggplot}} object with for subplots.
}
\description{
Plot the differential Abundance
}
\details{
This function will visualize the differential abundance in two given
variables, by making bar plots that presents the cell counting and fraction
in different cases.
}
\examples{
data("mouseBrainSubsetSCE", package = "singleCellTK")
plotClusterAbundance(inSCE = mouseBrainSubsetSCE,
                     cluster = "tissue",
                     variable = "level1class")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/htmlReports.R
\name{reportDropletQC}
\alias{reportDropletQC}
\title{Get runDropletQC .html report}
\usage{
reportDropletQC(
  inSCE,
  output_file = NULL,
  output_dir = NULL,
  subTitle = NULL,
  studyDesign = NULL
)
}
\arguments{
\item{inSCE}{A \link[SingleCellExperiment]{SingleCellExperiment} object containing
the full droplet count matrix with the output from runDropletQC function}

\item{output_file}{name of the generated file. If NULL/default then the output file name will be based on the name of the Rmarkdown template}

\item{output_dir}{name of the output directory to save the rendered file. If NULL/default the file is stored to the current working directory}

\item{subTitle}{subtitle of the QC HTML report. Default is NULL.}

\item{studyDesign}{description of the data set and experiment design. It would be shown at the top of QC HTML report. Default is NULL.}
}
\value{
.html file
}
\description{
A  function to generate .html Rmarkdown report containing the visualizations of the runDropletQC function output
}
\examples{
data(scExample, package = "singleCellTK")
\dontrun{
sce <- runDropletQC(sce)
reportDropletQC(inSCE = sce)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{MitoGenes}
\alias{MitoGenes}
\title{List of mitochondrial genes of multiple reference}
\format{
A list
}
\usage{
data("MitoGenes")
}
\value{
List of mitochondrial genes of multiple reference
}
\description{
A list of gene set that contains mitochondrial genes of multiple reference
(hg38, hg19, mm10 and mm9). It contains multiple types of gene identifier:
gene symbol, entrez ID, ensemble ID and ensemble transcript ID. It's used 
for the function 'importMitoGeneSet'.
}
\examples{
data("MitoGenes")
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{sceBatches}
\alias{sceBatches}
\title{Example Single Cell RNA-Seq data in SingleCellExperiment object, with
different batches annotated}
\format{
An object of class \code{SingleCellExperiment} with 100 rows and 250 columns.
}
\usage{
data('sceBatches')
}
\value{
Example Single Cell RNA-Seq data in SingleCellExperiment object, with
different batches annotated
}
\description{
Two batches of pancreas scRNAseq dataset are combined with their original
counts. Cell types and batches are annotated in `colData(sceBatches)`.
Two batches came from Wang, et al., 2016, annotated as `'w'`; and Xin, et
al., 2016, annotated as `'x'`. Two common cell types, `'alpha'` and
`'beta'`, that could be found in both original studies with relatively
large population were kept for cleaner demonstration.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/enrichRSCE.R
\name{getEnrichRResult<-}
\alias{getEnrichRResult<-}
\alias{getEnrichRResult}
\alias{getEnrichRResult,SingleCellExperiment-method}
\alias{getEnrichRResult<-,SingleCellExperiment-method}
\title{Get or Set EnrichR Result}
\usage{
getEnrichRResult(inSCE, analysisName) <- value

getEnrichRResult(inSCE, analysisName)

\S4method{getEnrichRResult}{SingleCellExperiment}(inSCE, analysisName)

\S4method{getEnrichRResult}{SingleCellExperiment}(inSCE, analysisName) <- value
}
\arguments{
\item{inSCE}{A \linkS4class{SingleCellExperiment} object.}

\item{analysisName}{A string that identifies each specific analysis}

\item{value}{The EnrichR result table}
}
\value{
For getter method, a data.frame of the EnrichR result;
For setter method, \code{inSCE} with EnrichR results updated.
}
\description{
Get or Set EnrichR Result
}
\examples{
data("mouseBrainSubsetSCE")
if (Biobase::testBioCConnection()) {
  mouseBrainSubsetSCE <- runEnrichR(mouseBrainSubsetSCE, features = c("Vamp7","Cntn2","Olig1"),
                                    db = "GO_Cellular_Component_2025",
                                    analysisName = "analysis1")
  result <- getEnrichRResult(mouseBrainSubsetSCE, "analysis1")
}
}
\seealso{
\code{\link{runEnrichR}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/seuratFunctions.R
\name{plotSeuratJackStraw}
\alias{plotSeuratJackStraw}
\title{plotSeuratJackStraw
Computes the plot object for jackstraw plot from the pca slot in the input
sce object}
\usage{
plotSeuratJackStraw(
  inSCE,
  dims = NULL,
  xmax = 0.1,
  ymax = 0.3,
  externalReduction = NULL
)
}
\arguments{
\item{inSCE}{(sce) object from which to compute the jackstraw plot (pca
should be computed)}

\item{dims}{Number of components to plot in Jackstraw. If \code{NULL}, then
all components are plotted Default \code{NULL}.}

\item{xmax}{X-axis maximum on each QQ plot. Default \code{0.1}.}

\item{ymax}{Y-axis maximum on each QQ plot. Default \code{0.3}.}

\item{externalReduction}{Pass DimReduc object if PCA/ICA computed through
other libraries. Default \code{NULL}.}
}
\value{
plot object
}
\description{
plotSeuratJackStraw
Computes the plot object for jackstraw plot from the pca slot in the input
sce object
}
\examples{
data(scExample, package = "singleCellTK")
\dontrun{
sce <- runSeuratNormalizeData(sce, useAssay = "counts")
sce <- runSeuratFindHVG(sce, useAssay = "counts")
sce <- runSeuratScaleData(sce, useAssay = "counts")
sce <- runSeuratPCA(sce, useAssay = "counts")
sce <- runSeuratJackStraw(sce, useAssay = "counts")
plotSeuratJackStraw(sce)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/singleCellTK.R
\name{singleCellTK}
\alias{singleCellTK}
\title{Run the single cell analysis app}
\usage{
singleCellTK(inSCE = NULL, includeVersion = TRUE, theme = "yeti")
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object.}

\item{includeVersion}{Include the version number in the SCTK header. The
default is TRUE.}

\item{theme}{The bootswatch theme to use for the singleCellTK UI. The default
is 'flatly'.}
}
\value{
The shiny app will open
}
\description{
Use this function to run the single cell analysis app.
}
\examples{
\dontrun{
#Upload data through the app
singleCellTK()

# Load the app with a SingleCellExperiment object
data("mouseBrainSubsetSCE")
singleCellTK(mouseBrainSubsetSCE)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scanpyFunctions.R
\name{plotScanpyPCAVariance}
\alias{plotScanpyPCAVariance}
\title{plotScanpyPCAVariance}
\usage{
plotScanpyPCAVariance(inSCE, nPCs = 50, log = FALSE)
}
\arguments{
\item{inSCE}{Input \code{SingleCellExperiment} object.}

\item{nPCs}{Number of PCs to show. Default \code{50}.}

\item{log}{Plot on logarithmic scale. Default \code{FALSE}}
}
\value{
plot object
}
\description{
plotScanpyPCAVariance
}
\examples{
data(scExample, package = "singleCellTK")
\dontrun{
sce <- runScanpyNormalizeData(sce, useAssay = "counts")
sce <- runScanpyFindHVG(sce, useAssay = "scanpyNormData", method = "seurat")
sce <- runScanpyScaleData(sce, useAssay = "scanpyNormData")
sce <- runScanpyPCA(sce, useAssay = "scanpyScaledData")
plotScanpyPCAVariance(sce)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotDEAnalysis.R
\name{plotDEGRegression}
\alias{plotDEGRegression}
\title{Create linear regression plot to show the expression the of top DEGs}
\usage{
plotDEGRegression(
  inSCE,
  useResult,
  threshP = FALSE,
  labelBy = NULL,
  nrow = 6,
  ncol = 6,
  defaultTheme = TRUE,
  isLogged = TRUE,
  check_sanity = TRUE
)
}
\arguments{
\item{inSCE}{\linkS4class{SingleCellExperiment} inherited object.}

\item{useResult}{character. A string specifying the \code{analysisName}
used when running a differential expression analysis function.}

\item{threshP}{logical. Whether to plot threshold values from adaptive
thresholding, instead of using the assay used by when performing DE analysis.
Default \code{FALSE}.}

\item{labelBy}{A single character for a column of \code{rowData(inSCE)} as
where to search for the labeling text. Default \code{NULL}.}

\item{nrow}{Integer. Number of rows in the plot grid. Default \code{6}.}

\item{ncol}{Integer. Number of columns in the plot grid. Default \code{6}.}

\item{defaultTheme}{Logical scalar. Whether to use default SCTK theme in
ggplot. Default \code{TRUE}.}

\item{isLogged}{Logical scalar. Whether the assay used for the analysis is
logged. If not, will do a \code{log(assay + 1)} transformation. Default
\code{TRUE}.}

\item{check_sanity}{Logical scalar. Whether to perform MAST's sanity check
to see if the counts are logged. Default \code{TRUE}}
}
\value{
A ggplot object of linear regression
}
\description{
Create linear regression plot to show the expression the of top DEGs
}
\details{
Any of the differential expression analysis method from SCTK should
be performed prior to using this function
}
\examples{
data("sceBatches")
logcounts(sceBatches) <- log1p(counts(sceBatches))
sce.w <- subsetSCECols(sceBatches, colData = "batch == 'w'")
sce.w <- runWilcox(sce.w, class = "cell_type",
                   classGroup1 = "alpha", classGroup2 = "beta",
                   groupName1 = "w.alpha", groupName2 = "w.beta",
                   analysisName = "w.aVSb")
plotDEGRegression(sce.w, "w.aVSb")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotDEAnalysis.R
\name{plotMASTThresholdGenes}
\alias{plotMASTThresholdGenes}
\title{MAST Identify adaptive thresholds}
\usage{
plotMASTThresholdGenes(
  inSCE,
  useAssay = "logcounts",
  doPlot = TRUE,
  isLogged = TRUE,
  check_sanity = TRUE
)
}
\arguments{
\item{inSCE}{SingleCellExperiment object}

\item{useAssay}{character, default \code{"logcounts"}}

\item{doPlot}{Logical scalar. Whether to directly plot in the plotting area.
If \code{FALSE}, will return a graphical object which can be visualized with
\code{grid.draw()}. Default \code{TRUE}.}

\item{isLogged}{Logical scalar. Whether the assay used for the analysis is
logged. If not, will do a \code{log(assay + 1)} transformation. Default
\code{TRUE}.}

\item{check_sanity}{Logical scalar. Whether to perform MAST's sanity check
to see if the counts are logged. Default \code{TRUE}}
}
\value{
Plot the thresholding onto the plotting region if \code{plot == TRUE}
or a graphical object if \code{plot == FALSE}.
}
\description{
Calculate and produce a list of thresholded counts (on natural scale),
thresholds, bins, densities estimated on each bin, and the original data from
\code{\link[MAST]{thresholdSCRNACountMatrix}}
}
\examples{
data("mouseBrainSubsetSCE")
plotMASTThresholdGenes(mouseBrainSubsetSCE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sctkQCUtils.R
\name{exportSCE}
\alias{exportSCE}
\title{Export data in SingleCellExperiment object}
\usage{
exportSCE(
  inSCE,
  samplename = "sample",
  directory = "./",
  type = "Cells",
  format = c("SCE", "AnnData", "FlatFile", "HTAN", "Seurat")
)
}
\arguments{
\item{inSCE}{A \link[SingleCellExperiment]{SingleCellExperiment} object
that contains the data. QC metrics are stored in colData of the
singleCellExperiment object.}

\item{samplename}{Sample name. This will be used as name of subdirectories
and the prefix of flat file output. Default is 'sample'.}

\item{directory}{Output directory. Default is './'.}

\item{type}{Type of data. The type of data stored in SingleCellExperiment object.
It can be 'Droplets'(raw droplets matrix) or 'Cells' (cells matrix).}

\item{format}{The format of output. It currently supports flat files, rds files
and python h5 files. It can output multiple formats. Default: c("SCE", "AnnData", "FlatFile", "HTAN").}
}
\value{
Generates a file containing data from \code{inSCE}, in specified \code{format}.
}
\description{
Export data in SingleCellExperiment object
}
\examples{
data(scExample)
\dontrun{
exportSCE(sce, format = "SCE")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/importGeneSets.R
\name{importMitoGeneSet}
\alias{importMitoGeneSet}
\title{Import mitochondrial gene sets}
\usage{
importMitoGeneSet(
  inSCE,
  reference = "human",
  id = "ensembl",
  by = "rownames",
  collectionName = "mito",
  noMatchError = TRUE
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object.}

\item{reference}{Character. Species available are "human" and "mouse".}

\item{id}{Types of gene id. Now it supports "symbol", "entrez", "ensembl"
and "ensemblTranscriptID".}

\item{by}{Character. Describes the location within \code{inSCE} where the gene
identifiers in the mitochondrial gene sets should be mapped.
If set to \code{"rownames"} then the features will
be searched for among \code{rownames(inSCE)}. This can also be
set to one of the column names of \code{rowData(inSCE)} in which case the
gene identifies will be mapped to that column in the \code{rowData}
of \code{inSCE}. See \link{featureIndex} for more information.
Default \code{"rownames"}.}

\item{collectionName}{Character. Name of collection to add gene sets to.
If this collection already exists in \code{inSCE}, then these gene sets will
be added to that collection. Any gene sets within the collection with the
same name will be overwritten. Default \code{"mito"}.}

\item{noMatchError}{Boolean. Show an error if a collection does not have
any matching features. Default \code{TRUE}.}
}
\value{
A \link[SingleCellExperiment]{SingleCellExperiment} object
with gene set from \code{collectionName} output stored to the
\link{metadata} slot.
}
\description{
Imports mitochondrial gene sets and  stores it in the metadata of the
\linkS4class{SingleCellExperiment} object. These gene sets can be used in
downstream quality control and analysis functions in \link{singleCellTK}.
}
\details{
The gene identifiers of mitochondrial genes will be loaded with
"data(AllMito)". Currently, it supports human and mouse references.
Also, it supports entrez ID, gene symbol, ensemble ID and ensemble transcript ID.
They will be mapped to the IDs in \code{inSCE} using the \code{by} parameter and
stored in a \linkS4class{GeneSetCollection} object from package
\link{GSEABase}. This object is stored in
\code{metadata(inSCE)$sctk$genesets}, which can be accessed in downstream
analysis functions such as \link[singleCellTK]{runCellQC}.
}
\examples{
data(scExample)
sce <- importMitoGeneSet(inSCE = sce,
                         reference = "human",
                         id = "ensembl",
                         collectionName = "human_mito",
                         by = "rownames")
}
\seealso{
\link{importGeneSetsFromList} for importing from lists,
\link{importGeneSetsFromGMT} for importing from GMT files, and
\linkS4class{GeneSetCollection} objects.
}
\author{
Rui Hong
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotDEAnalysis.R
\name{getDEGTopTable}
\alias{getDEGTopTable}
\title{Get Top Table of a DEG analysis}
\usage{
getDEGTopTable(
  inSCE,
  useResult,
  labelBy = S4Vectors::metadata(inSCE)$featureDisplay,
  onlyPos = FALSE,
  log2fcThreshold = 0.25,
  fdrThreshold = 0.05,
  minGroup1MeanExp = NULL,
  maxGroup2MeanExp = NULL,
  minGroup1ExprPerc = NULL,
  maxGroup2ExprPerc = NULL
)
}
\arguments{
\item{inSCE}{\linkS4class{SingleCellExperiment} inherited object, with of the
singleCellTK DEG method performed in advance.}

\item{useResult}{character. A string specifying the \code{analysisName}
used when running a differential expression analysis function.}

\item{labelBy}{A single character for a column of \code{rowData(inSCE)} as
where to search for the labeling text. Leave \code{NULL} for \code{rownames}.
Default \code{metadata(inSCE)$featureDisplay} (see
\code{\link{setSCTKDisplayRow}}).}

\item{onlyPos}{logical. Whether to only fetch DEG with positive log2_FC
value. Default \code{FALSE}.}

\item{log2fcThreshold}{numeric. Only fetch DEGs with the absolute values of
log2FC larger than this value. Default \code{0.25}.}

\item{fdrThreshold}{numeric. Only fetch DEGs with FDR value smaller than this
value. Default \code{0.05}.}

\item{minGroup1MeanExp}{numeric. Only fetch DEGs with mean expression in
group1 greater then this value. Default \code{NULL}.}

\item{maxGroup2MeanExp}{numeric. Only fetch DEGs with mean expression in
group2 less then this value. Default \code{NULL}.}

\item{minGroup1ExprPerc}{numeric. Only fetch DEGs expressed in greater then
this fraction of cells in group1. Default \code{NULL}.}

\item{maxGroup2ExprPerc}{numeric. Only fetch DEGs expressed in less then this
fraction of cells in group2. Default \code{NULL}.}
}
\value{
A \code{data.frame} object of the top DEGs, with variables of
\code{Gene}, \code{Log2_FC}, \code{Pvalue}, and \code{FDR}.
}
\description{
Users have to run \code{runDEAnalysis()} first, any of the
wrapped functions of this generic function. Users can set further filters on
the result. A \code{data.frame} object, with variables of \code{Gene},
\code{Log2_FC}, \code{Pvalue}, and \code{FDR}, will be returned.
}
\examples{
data("sceBatches")
sceBatches <- scaterlogNormCounts(sceBatches, "logcounts")
sce.w <- subsetSCECols(sceBatches, colData = "batch == 'w'")
sce.w <- runWilcox(sce.w, class = "cell_type",
                   classGroup1 = "alpha", classGroup2 = "beta",
                   groupName1 = "w.alpha", groupName2 = "w.beta",
                   analysisName = "w.aVSb")
getDEGTopTable(sce.w, "w.aVSb")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotPathway.R
\name{plotPathway}
\alias{plotPathway}
\title{Generate violin plots for pathway analysis results}
\usage{
plotPathway(
  inSCE,
  resultName,
  geneset,
  groupBy = NULL,
  boxplot = FALSE,
  violin = TRUE,
  dots = TRUE,
  summary = "median",
  axisSize = 10,
  axisLabelSize = 10,
  dotSize = 0.5,
  transparency = 1,
  defaultTheme = TRUE,
  gridLine = FALSE,
  title = geneset,
  titleSize = NULL
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object. With
\code{runGSVA()} or \code{runVAM()} applied in advance.}

\item{resultName}{A single character of the name of a score matrix, which
should be found in \code{getPathwayResultNames(inSCE)}.}

\item{geneset}{A single character specifying the geneset of interest. Should
be found in the geneSetCollection used for performing the analysis.}

\item{groupBy}{Either a single character specifying a column of
\code{colData(inSCE)} or a vector of equal length as the number of cells.
Default \code{NULL}.}

\item{boxplot}{Boolean, Whether to add a boxplot. Default \code{FALSE}.}

\item{violin}{Boolean, Whether to add a violin plot. Default \code{TRUE}.}

\item{dots}{Boolean, If \code{TRUE}, will plot dots for each violin plot.
Default \code{TRUE}.}

\item{summary}{Adds a summary statistic, as well as a crossbar to the violin
plot. Options are \code{"mean"} or \code{"median"}, and \code{NULL} for not
adding. Default \code{"median"}.}

\item{axisSize}{Size of x/y-axis ticks. Default \code{10}.}

\item{axisLabelSize}{Size of x/y-axis labels. Default \code{10}.}

\item{dotSize}{Size of dots. Default \code{0.5}.}

\item{transparency}{Transparency of the dots, values will be 0-1. Default
\code{1}.}

\item{defaultTheme}{Removes grid in plot and sets axis title size to
\code{10} when \code{TRUE}. Default \code{TRUE}.}

\item{gridLine}{Adds a horizontal grid line if \code{TRUE}. Will still be
drawn even if \code{defaultTheme} is \code{TRUE}. Default \code{FALSE}.}

\item{title}{Title of plot. Default using \code{geneset}.}

\item{titleSize}{Size of the title of the plot. Default \code{15}.}
}
\value{
A \code{ggplot} object for the violin plot
}
\description{
Generate violin plots for pathway analysis results
}
\details{
\code{runGSVA()} or \code{runVAM()} should be applied in advance of
using this function. Users can group the data by specifying \code{groupby}.
}
\examples{
data("scExample", package = "singleCellTK")
sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
sce <- scaterlogNormCounts(sce, assayName = "logcounts")
gs1 <- rownames(sce)[seq(10)]
gs2 <- rownames(sce)[seq(11,20)]
gs <- list("geneset1" = gs1, "geneset2" = gs2)
sce <- importGeneSetsFromList(inSCE = sce, geneSetList = gs,
                              by = "rownames")
sce <- runVAM(inSCE = sce, geneSetCollectionName = "GeneSetCollection",
              useAssay = "logcounts")
plotPathway(sce, "VAM_GeneSetCollection_CDF", "geneset1")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ggPerQCWrapper.R
\name{plotBarcodeRankDropsResults}
\alias{plotBarcodeRankDropsResults}
\title{Plots for runBarcodeRankDrops outputs.}
\usage{
plotBarcodeRankDropsResults(
  inSCE,
  sample = NULL,
  defaultTheme = TRUE,
  dotSize = 0.5,
  titleSize = 18,
  axisSize = 15,
  axisLabelSize = 18,
  legendSize = 15
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object with saved
dimension reduction components or a variable with saved results from
\code{\link{runBarcodeRankDrops}}. Required.}

\item{sample}{Character vector or colData variable name. Indicates which
sample each cell belongs to. Default \code{NULL}.}

\item{defaultTheme}{Removes grid in plot and sets axis title size to
\code{10} when \code{TRUE}. Default \code{TRUE}.}

\item{dotSize}{Size of dots. Default \code{0.5}.}

\item{titleSize}{Size of title of plot. Default \code{18}.}

\item{axisSize}{Size of x/y-axis ticks. Default \code{15}.}

\item{axisLabelSize}{Size of x/y-axis labels. Default \code{18}.}

\item{legendSize}{size of legend. Default \code{15}.}
}
\value{
list of .ggplot objects
}
\description{
A wrapper function which visualizes outputs from the
\code{runBarcodeRankDrops} function stored in the \code{metadata} slot of
the \linkS4class{SingleCellExperiment} object.
}
\examples{
data(scExample, package = "singleCellTK")
sce <- runBarcodeRankDrops(inSCE = sce)
plotBarcodeRankDropsResults(inSCE = sce)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/miscFunctions.R
\name{summarizeSCE}
\alias{summarizeSCE}
\title{Summarize an assay in a \linkS4class{SingleCellExperiment}}
\usage{
summarizeSCE(inSCE, useAssay = NULL, sampleVariableName = NULL)
}
\arguments{
\item{inSCE}{Input SingleCellExperiment object.}

\item{useAssay}{Indicate which assay to summarize. If \code{NULL}, then the
first assay in \code{inSCE} will be used. Default \code{NULL}.}

\item{sampleVariableName}{Variable name in \code{colData} denoting which
sample each cell belongs to. If \code{NULL}, all cells will be assumed
to come from the same sample. Default \code{"sample"}.}
}
\value{
A data.frame object of summary metrics.
}
\description{
Creates a table of summary metrics from an input
\linkS4class{SingleCellExperiment}
}
\examples{
data("mouseBrainSubsetSCE")
summarizeSCE(mouseBrainSubsetSCE, sample = NULL)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runNormalization.R
\name{runNormalization}
\alias{runNormalization}
\title{Run normalization/transformation with various methods}
\usage{
runNormalization(
  inSCE,
  useAssay = "counts",
  outAssayName = "logcounts",
  normalizationMethod = "logNormCounts",
  scale = FALSE,
  seuratScaleFactor = 10000,
  transformation = NULL,
  pseudocountsBeforeNorm = NULL,
  pseudocountsBeforeTransform = NULL,
  trim = NULL,
  verbose = TRUE
)
}
\arguments{
\item{inSCE}{Input \code{SingleCellExperiment} object.}

\item{useAssay}{Specify the name of the assay that should be used.}

\item{outAssayName}{Specify the name of the new output assay.}

\item{normalizationMethod}{Specify a normalization method from `LogNormalize`,
`CLR`, `RC` and `SCTransform` from Seurat or `logNormCounts` and `CPM` from
scater packages. Default \code{NULL} is set which will not run any
normalization method.}

\item{scale}{Logical value indicating if the data should be scaled using
Z.Score. Default \code{FALSE}.}

\item{seuratScaleFactor}{Specify the `scaleFactor` argument if a Seurat
normalization method is selected. Default is \code{10000}. This parameter
will not be used if methods other than seurat are selected.}

\item{transformation}{Specify the transformation options to run on the
selected assay. Options include `log2` (base 2 log transformation),
`log1p` (natural log + 1 transformation) and `sqrt` (square root). Default
value is \code{NULL}, which will not run any transformation.}

\item{pseudocountsBeforeNorm}{Specify a numeric pseudo value that should be added
to the assay before normalization is performed. Default is \code{NULL},
which will not add any value.}

\item{pseudocountsBeforeTransform}{Specify a numeric pseudo value that should be
added to the assay before transformation is run. Default is \code{NULL},
which will not add any value.}

\item{trim}{Specify a vector of two numeric values that should be used
as the upper and lower trim values to trim the assay between these two
values. For example, \code{c(10,-10)} will trim the values between 10
and -10. Default is \code{NULL}, which will not trim the data assay.}

\item{verbose}{Logical value indicating if progress messages should be
displayed to the user. Default is \code{TRUE}.}
}
\value{
Output SCE object with new normalized/transformed assay stored.
}
\description{
Wrapper function to run any of the integrated normalization/transformation
methods in the singleCellTK. The available methods include 'LogNormalize',
'CLR', 'RC' and 'SCTransform' from Seurat, 'logNormCounts and 'CPM' from
Scater. Additionally, users can 'scale' using Z.Score, 'transform' using
log, log1p and sqrt, add 'pseudocounts' and trim the final matrices
between a range of values.
}
\examples{
data(sce_chcl, package = "scds")
sce_chcl <- runNormalization(
 inSCE = sce_chcl,
 normalizationMethod = "LogNormalize",
 useAssay = "counts",
 outAssayName = "logcounts")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runTSCAN.R
\name{plotTSCANDimReduceFeatures}
\alias{plotTSCANDimReduceFeatures}
\title{Plot feature expression on cell 2D embedding with MST overlaid}
\usage{
plotTSCANDimReduceFeatures(
  inSCE,
  features,
  useReducedDim = "UMAP",
  useAssay = "logcounts",
  by = "rownames",
  useCluster = NULL,
  featureDisplay = metadata(inSCE)$featureDisplay,
  combinePlot = c("all", "none")
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object.}

\item{features}{Choose the feature of interest to explore the expression
level on the trajectory. Required.}

\item{useReducedDim}{A single character for the matrix of 2D embedding.
Should exist in \code{reducedDims} slot. Default \code{"UMAP"}.}

\item{useAssay}{A single character for the feature expression matrix. Should
exist in \code{assayNames(inSCE)}. Default \code{"logcounts"}.}

\item{by}{Where should \code{features} be found? \code{NULL},
\code{"rownames"} for \code{rownames(inSCE)}, otherwise will be regarded as
\code{rowData} variable.}

\item{useCluster}{Choose specific clusters where gene expression needs to be
visualized. By default \code{NULL}, all clusters are chosen.}

\item{featureDisplay}{Specify the feature ID type to display. Users can set
default value with \code{\link{setSCTKDisplayRow}}. \code{NULL} or
\code{"rownames"} specifies the rownames of \code{inSCE}. Other character
values indicates \code{rowData} variable.}

\item{combinePlot}{Must be either \code{"all"} or \code{"none"}. \code{"all"}
will combine plots of each feature into a single \code{.ggplot} object,
while \code{"none"} will output a list of plots. Default \code{"all"}.}
}
\value{
A \code{.ggplot} object of cell scatter plot, colored by the
expression of a gene of interest, with the layer of trajectory.
}
\description{
A wrapper function which plots all cells or cells in chosen
cluster. Each point is a cell colored by the expression of a feature of
interest, the relevant edges of the MST are overlaid on top.
}
\examples{
data("mouseBrainSubsetSCE", package = "singleCellTK")
mouseBrainSubsetSCE <- runTSCAN(inSCE = mouseBrainSubsetSCE,
                                useReducedDim = "PCA_logcounts")
plotTSCANDimReduceFeatures(inSCE = mouseBrainSubsetSCE,
                           features = "Tshz1",
                           useReducedDim = "TSNE_logcounts")
}
\author{
Yichen Wang
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotFindMarkerHeatmap.R
\name{plotFindMarkerHeatmap}
\alias{plotFindMarkerHeatmap}
\alias{plotMarkerDiffExp}
\title{Plot a heatmap to visualize the result of \code{\link{runFindMarker}}}
\usage{
plotFindMarkerHeatmap(
  inSCE,
  orderBy = "size",
  log2fcThreshold = 1,
  fdrThreshold = 0.05,
  minClustExprPerc = 0.7,
  maxCtrlExprPerc = 0.4,
  minMeanExpr = 1,
  topN = 10,
  decreasing = TRUE,
  rowLabel = TRUE,
  rowDataName = NULL,
  colDataName = NULL,
  featureAnnotations = NULL,
  cellAnnotations = NULL,
  featureAnnotationColor = NULL,
  cellAnnotationColor = NULL,
  colSplitBy = NULL,
  rowSplitBy = "marker",
  rowDend = FALSE,
  colDend = FALSE,
  title = "Top Marker Heatmap",
  ...
)

plotMarkerDiffExp(
  inSCE,
  orderBy = "size",
  log2fcThreshold = 1,
  fdrThreshold = 0.05,
  minClustExprPerc = 0.7,
  maxCtrlExprPerc = 0.4,
  minMeanExpr = 1,
  topN = 10,
  decreasing = TRUE,
  rowDataName = NULL,
  colDataName = NULL,
  featureAnnotations = NULL,
  cellAnnotations = NULL,
  featureAnnotationColor = NULL,
  cellAnnotationColor = NULL,
  colSplitBy = NULL,
  rowSplitBy = "marker",
  rowDend = FALSE,
  colDend = FALSE,
  title = "Top Marker Heatmap",
  ...
)
}
\arguments{
\item{inSCE}{\linkS4class{SingleCellExperiment} inherited object.}

\item{orderBy}{The ordering method of the clusters on the splitted heatmap.
Can be chosen from \code{"size"} or \code{"name"}, specified with vector of
ordered unique cluster labels, or set as \code{NULL} for unsplitted heatmap.
Default \code{"size"}.}

\item{log2fcThreshold}{Only use DEGs with the absolute values of log2FC
larger than this value. Default \code{1}}

\item{fdrThreshold}{Only use DEGs with FDR value smaller than this value.
Default \code{0.05}}

\item{minClustExprPerc}{A numeric scalar. The minimum cutoff of the
percentage of cells in the cluster of interests that expressed the marker
gene. Default \code{0.7}.}

\item{maxCtrlExprPerc}{A numeric scalar. The maximum cutoff of the
percentage of cells out of the cluster (control group) that expressed the
marker gene. Default \code{0.4}.}

\item{minMeanExpr}{A numeric scalar. The minimum cutoff of the mean
expression value of the marker in the cluster of interests. Default \code{1}.}

\item{topN}{An integer. Only to plot this number of top markers for each
cluster in maximum, in terms of log2FC value. Use \code{NULL} to cancel the
top N subscription. Default \code{10}.}

\item{decreasing}{Order the cluster decreasingly. Default \code{TRUE}.}

\item{rowLabel}{\code{TRUE} for displaying \code{rownames} of \code{inSCE}, a
\code{rowData} variable to use other feature identifiers, or a vector for
customized row labels. Use \code{FALSE} for not displaying. Default
\code{TRUE}.}

\item{rowDataName}{character. The column name(s) in \code{rowData} that need
to be added to the annotation. Default \code{NULL}.}

\item{colDataName}{character. The column name(s) in \code{colData} that need
to be added to the annotation. Default \code{NULL}.}

\item{featureAnnotations}{\code{data.frame}, with \code{rownames} containing
all the features going to be plotted. Character columns should be factors.
Default \code{NULL}.}

\item{cellAnnotations}{\code{data.frame}, with \code{rownames} containing
all the cells going to be plotted. Character columns should be factors.
Default \code{NULL}.}

\item{featureAnnotationColor}{A named list. Customized color settings for
feature labeling. Should match the entries in the \code{featureAnnotations}
or \code{rowDataName}. For each entry, there should be a list/vector of
colors named with categories. Default \code{NULL}.}

\item{cellAnnotationColor}{A named list. Customized color settings for
cell labeling. Should match the entries in the \code{cellAnnotations} or
\code{colDataName}. For each entry, there should be a list/vector of colors
named with categories. Default \code{NULL}.}

\item{colSplitBy}{character vector. Do semi-heatmap based on the grouping of
this(these) annotation(s). Should exist in either \code{colDataName} or
\code{names(cellAnnotations)}. Default is the value of \code{cluster} in
\code{\link{runFindMarker}} when \code{orderBy} is not \code{NULL}, or
\code{NULL} otherwise.}

\item{rowSplitBy}{character vector. Do semi-heatmap based on the grouping of
this(these) annotation(s). Should exist in either \code{rowDataName} or
\code{names(featureAnnotations)}. Default \code{"marker"}, which indicates an
auto generated annotation for this plot.}

\item{rowDend}{Whether to display row dendrogram. Default \code{FALSE}.}

\item{colDend}{Whether to display column dendrogram. Default \code{FALSE}.}

\item{title}{Text of the title, at the top of the heatmap. Default
\code{"Top Marker Heatmap"}.}

\item{...}{Other arguments passed to \code{\link{plotSCEHeatmap}}.}
}
\value{
A \code{\link[ComplexHeatmap]{Heatmap}} object
}
\description{
This function will first reads the result saved in
\code{metadata} slot, named by \code{"findMarker"} and generated by
\code{\link{runFindMarker}}. Then it do the filtering on the statistics
based on the input parameters and get unique genes to plot. We choose the
genes that are identified as up-regulated only. As for the genes identified
as up-regulated for multiple clusters, we only keep the belonging towards the
one they have the highest Log2FC value.
In the heatmap, there will always be a cell annotation for the cluster
labeling used when finding the markers, and a feature annotation for which
cluster each gene belongs to. And by default we split the heatmap by these
two annotations. Additional legends can be added and the splitting can be
canceled.
}
\examples{
data("sceBatches")
logcounts(sceBatches) <- log1p(counts(sceBatches))
sce.w <- subsetSCECols(sceBatches, colData = "batch == 'w'")
sce.w <- runFindMarker(sce.w, method = "wilcox", cluster = "cell_type")
plotFindMarkerHeatmap(sce.w)
}
\seealso{
\code{\link{runFindMarker}}, \code{\link{getFindMarkerTopTable}}
}
\author{
Yichen Wang
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DownsampleMatrix.R
\name{iterateSimulations}
\alias{iterateSimulations}
\title{Returns significance data from a snapshot.}
\usage{
iterateSimulations(
  originalData,
  useAssay = "counts",
  realLabels,
  totalReads,
  cells,
  iterations
)
}
\arguments{
\item{originalData}{The \linkS4class{SingleCellExperiment} object storing all
assay data from the shiny app.}

\item{useAssay}{Character. The name of the assay to be used for subsampling.}

\item{realLabels}{Character. The name of the condition of interest. Must match
a name from sample data.}

\item{totalReads}{Numeric. The total number of reads in the simulated
dataset, to be split between all simulated cells.}

\item{cells}{Numeric. The number of virtual cells to simulate.}

\item{iterations}{Numeric. How many times should each experimental design be
simulated.}
}
\value{
A matrix of significance information from a snapshot
}
\description{
Returns significance data from a snapshot.
}
\examples{
data("mouseBrainSubsetSCE")
res <- iterateSimulations(mouseBrainSubsetSCE, realLabels = "level1class",
                          totalReads = 1000, cells = 10, iterations = 2)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/importGeneSets.R
\name{getMSigDBTable}
\alias{getMSigDBTable}
\title{Shows MSigDB categories}
\usage{
getMSigDBTable()
}
\value{
data.frame, containing MSigDB categories
}
\description{
Returns a data.frame that shows MSigDB categories and
subcategories as well as descriptions for each. The entries in the ID
column in this table can be used as input for \link{importGeneSetsFromMSigDB}.
}
\examples{
getMSigDBTable()
}
\seealso{
\link{importGeneSetsFromMSigDB} for importing MSigDB gene sets.
}
\author{
Joshua D. Campbell
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runBatchCorrection.R
\name{runBBKNN}
\alias{runBBKNN}
\title{Apply BBKNN batch effect correction method to SingleCellExperiment object}
\usage{
runBBKNN(
  inSCE,
  useAssay = "logcounts",
  batch = "batch",
  reducedDimName = "BBKNN",
  nComponents = 50L
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object}

\item{useAssay}{A single character indicating the name of the assay requiring
batch correction. Default \code{"logcounts"}.}

\item{batch}{A single character indicating a field in \code{colData} that
annotates the batches of each cell; or a vector/factor with the same length
as the number of cells. Default \code{"batch"}.}

\item{reducedDimName}{A single character. The name for the corrected
low-dimensional representation. Will be saved to \code{reducedDim(inSCE)}.
Default \code{"BBKNN"}.}

\item{nComponents}{An integer. Number of principle components or the
dimensionality, adopted in the pre-PCA-computation step, the BBKNN step (for
how many PCs the algorithm takes into account), and the final UMAP
combination step where the value represent the dimensionality of the updated
reducedDim. Default \code{50L}.}
}
\value{
The input \linkS4class{SingleCellExperiment} object with
\code{reducedDim(inSCE, reducedDimName)} updated.
}
\description{
BBKNN, an extremely fast graph-based data integration algorithm. It modifies
the neighbourhood construction step to produce a graph that is balanced
across all batches of the data.
}
\examples{
\dontrun{
data('sceBatches', package = 'singleCellTK')
logcounts(sceBatches) <- log1p(counts(sceBatches))
sceBatches <- runBBKNN(sceBatches, useAssay = "logcounts",
                       nComponents = 10)
}
}
\references{
Krzysztof Polanski et al., 2020
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/seuratFunctions.R
\name{runSeuratScaleData}
\alias{runSeuratScaleData}
\title{runSeuratScaleData
Scales the input sce object according to the input parameters}
\usage{
runSeuratScaleData(
  inSCE,
  useAssay = "seuratNormData",
  scaledAssayName = "seuratScaledData",
  model = "linear",
  scale = TRUE,
  center = TRUE,
  scaleMax = 10,
  verbose = TRUE
)
}
\arguments{
\item{inSCE}{(sce) object to scale}

\item{useAssay}{Assay containing normalized counts to scale.}

\item{scaledAssayName}{Name of new assay containing scaled data. Default
\code{seuratScaledData}.}

\item{model}{selected model to use for scaling data. Default \code{"linear"}.}

\item{scale}{boolean if data should be scaled or not. Default \code{TRUE}.}

\item{center}{boolean if data should be centered or not. Default \code{TRUE}}

\item{scaleMax}{maximum numeric value to return for scaled data. Default
\code{10}.}

\item{verbose}{Logical value indicating if informative messages should
be displayed. Default is \code{TRUE}.}
}
\value{
Scaled \code{SingleCellExperiment} object
}
\description{
runSeuratScaleData
Scales the input sce object according to the input parameters
}
\examples{
data(scExample, package = "singleCellTK")
\dontrun{
sce <- runSeuratNormalizeData(sce, useAssay = "counts")
sce <- runSeuratFindHVG(sce, useAssay = "counts")
sce <- runSeuratScaleData(sce, useAssay = "counts")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/seuratFunctions.R
\name{plotSeuratReduction}
\alias{plotSeuratReduction}
\title{plotSeuratReduction
Plots the selected dimensionality reduction method}
\usage{
plotSeuratReduction(
  inSCE,
  useReduction = c("pca", "ica", "tsne", "umap"),
  showLegend = FALSE,
  groupBy = NULL,
  splitBy = NULL
)
}
\arguments{
\item{inSCE}{(sce) object which has the selected dimensionality reduction
algorithm already computed and stored}

\item{useReduction}{Dimentionality reduction to plot. One of "pca", "ica",
"tsne", or "umap". Default \code{"umap"}.}

\item{showLegend}{Select if legends and labels should be shown on the output
plot or not. Either "TRUE" or "FALSE". Default \code{FALSE}.}

\item{groupBy}{Specify a colData column name that be used for grouping.
Default is \code{NULL}.}

\item{splitBy}{Specify a colData column name that be used for splitting the
output plot. Default is \code{NULL}.}
}
\value{
plot object
}
\description{
plotSeuratReduction
Plots the selected dimensionality reduction method
}
\examples{
data(scExample, package = "singleCellTK")
\dontrun{
sce <- runSeuratNormalizeData(sce, useAssay = "counts")
sce <- runSeuratFindHVG(sce, useAssay = "counts")
sce <- runSeuratScaleData(sce, useAssay = "counts")
sce <- runSeuratPCA(sce, useAssay = "counts")
plotSeuratReduction(sce, useReduction = "pca")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/seuratFunctions.R
\name{convertSCEToSeurat}
\alias{convertSCEToSeurat}
\title{convertSCEToSeurat
Converts sce object to seurat while retaining all assays and metadata}
\usage{
convertSCEToSeurat(
  inSCE,
  countsAssay = NULL,
  normAssay = NULL,
  scaledAssay = NULL,
  copyColData = FALSE,
  copyReducedDim = FALSE,
  copyDecontX = FALSE,
  pcaReducedDim = NULL,
  icaReducedDim = NULL,
  tsneReducedDim = NULL,
  umapReducedDim = NULL
)
}
\arguments{
\item{inSCE}{A \code{SingleCellExperiment} object to convert to a Seurat
object.}

\item{countsAssay}{Which assay to use from sce object for raw counts.
Default \code{NULL}.}

\item{normAssay}{Which assay to use from sce object for normalized data.
Default \code{NULL}.}

\item{scaledAssay}{Which assay to use from sce object for scaled data.
Default \code{NULL}.}

\item{copyColData}{Boolean. Whether copy 'colData' of SCE object to
the 'meta.data' of Seurat object. Default \code{FALSE}.}

\item{copyReducedDim}{Boolean. Whether copy 'reducedDims' of the SCE
object to the 'reductions' of Seurat object. Default \code{FALSE}.}

\item{copyDecontX}{Boolean. Whether copy 'decontXcounts' assay of the
SCE object to the 'assays' of Seurat object. Default \code{TRUE}.}

\item{pcaReducedDim}{Specify a character value indicating the name of
the reducedDim to store as default pca computation in the output seurat
object. Default is \code{NULL} which will not store any reducedDim as the
default pca. This will only work when \code{copyReducedDim} parameter is
set to \code{TRUE}.}

\item{icaReducedDim}{Specify a character value indicating the name of
the reducedDim to store as default ica computation in the output seurat
object. Default is \code{NULL} which will not store any reducedDim as the
default ica. This will only work when \code{copyReducedDim} parameter is
set to \code{TRUE}.}

\item{tsneReducedDim}{Specify a character value indicating the name of
the reducedDim to store as default tsne computation in the output seurat
object. Default is \code{NULL} which will not store any reducedDim as the
default tsne. This will only work when \code{copyReducedDim} parameter is
set to \code{TRUE}.}

\item{umapReducedDim}{Specify a character value indicating the name of
the reducedDim to store as default umap computation in the output seurat
object. Default is \code{NULL} which will not store any reducedDim as the
default umap. This will only work when \code{copyReducedDim} parameter is
set to \code{TRUE}.}
}
\value{
Updated seurat object that contains all data from the input sce
object
}
\description{
convertSCEToSeurat
Converts sce object to seurat while retaining all assays and metadata
}
\examples{
data(scExample, package = "singleCellTK")
seurat <- convertSCEToSeurat(sce)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotDEAnalysis.R
\name{plotDEGHeatmap}
\alias{plotDEGHeatmap}
\title{Heatmap visualization of DEG result}
\usage{
plotDEGHeatmap(
  inSCE,
  useResult,
  onlyPos = FALSE,
  log2fcThreshold = 0.25,
  fdrThreshold = 0.05,
  minGroup1MeanExp = NULL,
  maxGroup2MeanExp = NULL,
  minGroup1ExprPerc = NULL,
  maxGroup2ExprPerc = NULL,
  useAssay = NULL,
  doLog = FALSE,
  featureAnnotations = NULL,
  cellAnnotations = NULL,
  featureAnnotationColor = NULL,
  cellAnnotationColor = NULL,
  rowDataName = NULL,
  colDataName = NULL,
  colSplitBy = "condition",
  rowSplitBy = "regulation",
  rowLabel = S4Vectors::metadata(inSCE)$featureDisplay,
  title = paste0("DE Analysis: ", useResult),
  ...
)
}
\arguments{
\item{inSCE}{\linkS4class{SingleCellExperiment} inherited object.}

\item{useResult}{character. A string specifying the \code{analysisName}
used when running a differential expression analysis function.}

\item{onlyPos}{logical. Whether to only plot DEG with positive log2_FC
value. Default \code{FALSE}.}

\item{log2fcThreshold}{numeric. Only plot DEGs with the absolute values of
log2FC larger than this value. Default \code{0.25}.}

\item{fdrThreshold}{numeric. Only plot DEGs with FDR value smaller than this
value. Default \code{0.05}.}

\item{minGroup1MeanExp}{numeric. Only plot DEGs with mean expression in
group1 greater then this value. Default \code{NULL}.}

\item{maxGroup2MeanExp}{numeric. Only plot DEGs with mean expression in
group2 less then this value. Default \code{NULL}.}

\item{minGroup1ExprPerc}{numeric. Only plot DEGs expressed in greater then
this fraction of cells in group1. Default \code{NULL}.}

\item{maxGroup2ExprPerc}{numeric. Only plot DEGs expressed in less then this
fraction of cells in group2. Default \code{NULL}.}

\item{useAssay}{character. A string specifying an assay of expression value
to plot. By default the assay used for \code{runMAST()} will be used.
Default \code{NULL}.}

\item{doLog}{Logical scalar. Whether to do \code{log(assay + 1)}
transformation on the assay used for the analysis. Default \code{FALSE}.}

\item{featureAnnotations}{\code{data.frame}, with \code{rownames} containing
all the features going to be plotted. Character columns should be factors.
Default \code{NULL}.}

\item{cellAnnotations}{\code{data.frame}, with \code{rownames} containing
all the cells going to be plotted. Character columns should be factors.
Default \code{NULL}.}

\item{featureAnnotationColor}{A named list. Customized color settings for
feature labeling. Should match the entries in the \code{featureAnnotations}
or \code{rowDataName}. For each entry, there should be a list/vector of
colors named with categories. Default \code{NULL}.}

\item{cellAnnotationColor}{A named list. Customized color settings for
cell labeling. Should match the entries in the \code{cellAnnotations} or
\code{colDataName}. For each entry, there should be a list/vector of colors
named with categories. Default \code{NULL}.}

\item{rowDataName}{character. The column name(s) in \code{rowData} that need
to be added to the annotation. Default \code{NULL}.}

\item{colDataName}{character. The column name(s) in \code{colData} that need
to be added to the annotation. Default \code{NULL}.}

\item{colSplitBy}{character. Do semi-heatmap based on the grouping of
this(these) annotation(s). Should exist in either \code{colDataName} or
\code{names(cellAnnotations)}. Default \code{"condition"}.}

\item{rowSplitBy}{character. Do semi-heatmap based on the grouping of
this(these) annotation(s). Should exist in either \code{rowDataName} or
\code{names(featureAnnotations)}. Default \code{"regulation"}.}

\item{rowLabel}{\code{FALSE} for not displaying; a variable in \code{rowData}
to display feature identifiers stored there; if have run
\code{\link{setSCTKDisplayRow}}, display the specified feature name;
\code{TRUE} for the \code{rownames} of \code{inSCE}; \code{NULL} for
auto-display \code{rownames} when the number of filtered feature is less
than 60. Default looks for \code{\link{setSCTKDisplayRow}} information.}

\item{title}{character. Main title of the heatmap. Default
\code{"DE Analysis: <useResult>"}.}

\item{...}{Other arguments passed to \code{\link{plotSCEHeatmap}}}
}
\value{
A \code{\link[ggplot2]{ggplot}} object
}
\description{
Heatmap visualization of DEG result
}
\details{
A differential expression analysis function has to be run in advance
so that information is stored in the metadata of the input SCE object. This
function wraps \code{\link{plotSCEHeatmap}}.
A feature annotation basing on the log2FC level called \code{"regulation"}
will be automatically added. A cell annotation basing on the condition
selection while running the analysis called \code{"condition"}, and the
annotations used from \code{colData(inSCE)} while setting the condition and
covariates will also be added.
}
\examples{
data("sceBatches")
logcounts(sceBatches) <- log1p(counts(sceBatches))
sce.w <- subsetSCECols(sceBatches, colData = "batch == 'w'")
sce.w <- runWilcox(sce.w, class = "cell_type",
                   classGroup1 = "alpha", classGroup2 = "beta",
                   groupName1 = "w.alpha", groupName2 = "w.beta",
                   analysisName = "w.aVSb")
plotDEGHeatmap(sce.w, "w.aVSb")
}
\author{
Yichen Wang
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ggPerQCWrapper.R
\name{plotRunPerCellQCResults}
\alias{plotRunPerCellQCResults}
\title{Plots for runPerCellQC outputs.}
\usage{
plotRunPerCellQCResults(
  inSCE,
  sample = NULL,
  groupBy = NULL,
  combinePlot = "all",
  violin = TRUE,
  boxplot = FALSE,
  dots = TRUE,
  dotSize = 0.5,
  summary = "median",
  summaryTextSize = 3,
  baseSize = 15,
  axisSize = NULL,
  axisLabelSize = NULL,
  transparency = 1,
  defaultTheme = TRUE,
  titleSize = NULL,
  relHeights = 1,
  relWidths = 1,
  labelSamples = TRUE,
  plotNCols = NULL,
  plotNRows = NULL,
  samplePerColumn = TRUE,
  sampleRelHeights = 1,
  sampleRelWidths = 1
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object with saved
dimension reduction components or a variable with saved results from
\code{\link{runPerCellQC}}. Required.}

\item{sample}{Character vector or colData variable name. Indicates which
sample each cell belongs to. Default \code{NULL}.}

\item{groupBy}{Groupings for each numeric value. Users may input a vector
equal length to the number of the samples in \code{inSCE}, or can be
retrieved from the colData slot. Default \code{NULL}.}

\item{combinePlot}{Must be either \code{"all"}, \code{"sample"}, or
\code{"none"}. \code{"all"} will combine all plots into a single ggplot
object, while \code{"sample"} will output a list of plots separated by
sample. Default \code{"all"}.}

\item{violin}{Boolean. If \code{TRUE}, will plot the violin plot. Default
\code{TRUE}.}

\item{boxplot}{Boolean. If \code{TRUE}, will plot boxplots for each violin
plot. Default \code{FALSE}.}

\item{dots}{Boolean. If \code{TRUE}, will plot dots for each violin plot.
Default \code{TRUE}.}

\item{dotSize}{Size of dots. Default \code{0.5}.}

\item{summary}{Adds a summary statistic, as well as a crossbar to the
violin plot. Options are \code{"mean"} or \code{"median"}. Default
\code{"median"}.}

\item{summaryTextSize}{The text size of the summary statistic displayed
above the violin plot. Default \code{3}.}

\item{baseSize}{The base font size for all text. Default \code{15}.
Can be overwritten by \code{titleSize}, \code{axisSize}, and
\code{axisLabelSize}.}

\item{axisSize}{Size of x/y-axis ticks. Default \code{NULL}.}

\item{axisLabelSize}{Size of x/y-axis labels. Default \code{NULL}.}

\item{transparency}{Transparency of the dots, values will be 0-1. Default \code{1}.}

\item{defaultTheme}{Removes grid in plot and sets axis title size to
\code{10} when \code{TRUE}. Default \code{TRUE}.}

\item{titleSize}{Size of title of plot. Default \code{NULL}.}

\item{relHeights}{Relative heights of plots when combine is set. Default
\code{1}.}

\item{relWidths}{Relative widths of plots when combine is set. Default
\code{1}.}

\item{labelSamples}{Will label sample name in title of plot if \code{TRUE}.
Default \code{TRUE}.}

\item{plotNCols}{Number of columns when plots are combined in a grid. Default
\code{NULL}.}

\item{plotNRows}{Number of rows when plots are combined in a grid. Default
\code{NULL}.}

\item{samplePerColumn}{If \code{TRUE}, when there are multiple samples and
combining by \code{"all"}, the output .ggplot will have plots from each
sample on a single column. Default \code{TRUE}.}

\item{sampleRelHeights}{If there are multiple samples and combining by
\code{"all"}, the relative heights for each plot. Default \code{1}.}

\item{sampleRelWidths}{If there are multiple samples and combining by
\code{"all"}, the relative widths for each plot. Default \code{1}.}
}
\value{
list of .ggplot objects
}
\description{
A wrapper function which visualizes outputs from the
 runPerCellQC function stored in the colData slot of the SingleCellExperiment
 object via various plots.
}
\examples{
data(scExample, package = "singleCellTK")
sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
sce <- runPerCellQC(sce)
plotRunPerCellQCResults(inSCE = sce)
}
\seealso{
\code{\link{runPerCellQC}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runTSCAN.R
\name{plotTSCANPseudotimeGenes}
\alias{plotTSCANPseudotimeGenes}
\title{Plot expression changes of top features along a TSCAN pseudotime path}
\usage{
plotTSCANPseudotimeGenes(
  inSCE,
  pathIndex,
  direction = c("increasing", "decreasing"),
  topN = 10,
  useAssay = NULL,
  featureDisplay = metadata(inSCE)$featureDisplay
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object.}

\item{pathIndex}{Path index for which the pseudotime values should be used.
Should have being used in \code{\link{runTSCANDEG}}.}

\item{direction}{Should we show features with expression increasing or
decreeasing along the increase in TSCAN pseudotime? Choices are
\code{"increasing"} or \code{"decreasing"}.}

\item{topN}{An integer. Only to plot this number of top genes that are
increasing/decreasing in expression with increasing pseudotime along
the path in the MST. Default 10}

\item{useAssay}{A single character to specify a feature expression matrix in
\code{assays} slot. The expression of top features from here will be
visualized. Default \code{NULL} use the one used for
\code{\link{runTSCANDEG}}.}

\item{featureDisplay}{Specify the feature ID type to display. Users can set
default value with \code{\link{setSCTKDisplayRow}}. \code{NULL} or
\code{"rownames"} specifies the rownames of \code{inSCE}. Other character
values indicates \code{rowData} variable.}
}
\value{
A \code{.ggplot} object with the facets of the top genes. Expression
on y-axis, pseudotime on x-axis.
}
\description{
A wrapper function which visualizes outputs from the
\code{\link{runTSCANDEG}} function. Plots the genes that increase or decrease
in expression with increasing pseudotime along the path in the MST.
\code{\link{runTSCANDEG}} has to be run in advance with using the same
\code{pathIndex} of interest.
}
\examples{
data("mouseBrainSubsetSCE", package = "singleCellTK")
mouseBrainSubsetSCE <- runTSCAN(inSCE = mouseBrainSubsetSCE,
                                useReducedDim = "PCA_logcounts")
terminalNodes <- listTSCANTerminalNodes(mouseBrainSubsetSCE)
mouseBrainSubsetSCE <- runTSCANDEG(inSCE = mouseBrainSubsetSCE,
                                   pathIndex = terminalNodes[1])
plotTSCANPseudotimeGenes(mouseBrainSubsetSCE,
                         pathIndex = terminalNodes[1],
                         useAssay = "logcounts")
}
\author{
Nida Pervaiz
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/seuratFunctions.R
\name{plotSeuratGenes}
\alias{plotSeuratGenes}
\title{Compute and plot visualizations for marker genes}
\usage{
plotSeuratGenes(
  inSCE,
  useAssay = "seuratNormData",
  plotType,
  features,
  groupVariable = NULL,
  reducedDimName = "seuratUMAP",
  splitBy = NULL,
  cols = c("lightgrey", "blue"),
  ncol = 1,
  combine = FALSE
)
}
\arguments{
\item{inSCE}{Input \code{SingleCellExperiment} object.}

\item{useAssay}{Specify the name of the assay that will be scaled by this
function.}

\item{plotType}{Specify the type of the plot to compute. Options are limited
to "ridge", "violin", "feature", "dot" and "heatmap".}

\item{features}{Specify the features to compute the plot against.}

\item{groupVariable}{Specify the column name from the colData slot that
should be used as grouping variable.
 Default is \code{NULL}.}

\item{reducedDimName}{saved dimension reduction name in the
SingleCellExperiment object. Default \code{seuratUMAP}.}

\item{splitBy}{Specify the column name from the colData slot that should be
used to split samples.
 Default is \code{NULL}.}

\item{cols}{Specify two colors to form a gradient between. Default is
\code{c("lightgrey", "blue")}.}

\item{ncol}{Visualizations will be adjusted in "ncol" number of columns.
Default is \code{1}.}

\item{combine}{A logical value that indicates if the plots should be combined
together into a single plot if \code{TRUE}, else if \code{FALSE} returns
separate ggplot objects for each feature. Only works when \code{plotType}
parameter is \code{"feature"}, \code{"violin"} or \code{"ridge"}. For
\code{"heatmap"} and \code{"dot"}, plots for all features are always
combined into a single plot. Default \code{FALSE}.}
}
\value{
Plot object
}
\description{
Compute and plot visualizations for marker genes
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/seuratFunctions.R
\name{runSeuratFindMarkers}
\alias{runSeuratFindMarkers}
\title{runSeuratFindMarkers}
\usage{
runSeuratFindMarkers(
  inSCE,
  cells1 = NULL,
  cells2 = NULL,
  group1 = NULL,
  group2 = NULL,
  allGroup = NULL,
  conserved = FALSE,
  test = "wilcox",
  onlyPos = FALSE,
  minPCT = 0.1,
  threshUse = 0.25,
  verbose = TRUE
)
}
\arguments{
\item{inSCE}{Input \code{SingleCellExperiment} object.}

\item{cells1}{A \code{list} of sample names included in group1.}

\item{cells2}{A \code{list} of sample names included in group2.}

\item{group1}{Name of group1.}

\item{group2}{Name of group2.}

\item{allGroup}{Name of all groups.}

\item{conserved}{Logical value indicating if markers conserved between two
groups should be identified. Default is \code{FALSE}.}

\item{test}{Test to use for DE. Default \code{"wilcox"}.}

\item{onlyPos}{Logical value indicating if only positive markers should be
returned.}

\item{minPCT}{Numeric value indicating the minimum fraction of min.pct
cells in which genes are detected. Default is \code{0.1}.}

\item{threshUse}{Numeric value indicating the logFC threshold value on
which on average, at least X-fold difference (log-scale) between the
two groups of cells exists. Default is \code{0.25}.}

\item{verbose}{Logical value indicating if informative messages should
be displayed. Default is \code{TRUE}.}
}
\value{
A \code{SingleCellExperiment} object that contains marker genes
populated in a data.frame stored inside metadata slot.
}
\description{
runSeuratFindMarkers
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/detectCellOutlier.R
\name{detectCellOutlier}
\alias{detectCellOutlier}
\title{Detecting outliers within the SingleCellExperiment object.}
\usage{
detectCellOutlier(
  inSCE,
  slotName,
  itemName,
  sample = NULL,
  nmads = 3,
  type = "both",
  overwrite = TRUE
)
}
\arguments{
\item{inSCE}{A \link[SingleCellExperiment]{SingleCellExperiment} object.}

\item{slotName}{Desired slot of SingleCellExperiment used for plotting. Possible
options: "assays", "colData", "metadata", "reducedDims". Required.}

\item{itemName}{Desired vector within the slot used for plotting. Required.}

\item{sample}{A single character specifying a name that can be found in
\code{colData(inSCE)} to directly use the cell annotation; or a character
vector with as many elements as cells to indicates which sample each cell
belongs to. Default NULL. \link[celda]{decontX} will be run on cells from
each sample separately.}

\item{nmads}{Integer. Number of median absolute deviation. Parameter may be
adjusted for more lenient or stringent outlier cutoff. Default 3.}

\item{type}{Character. Type/direction of outlier detection; whether
the lower/higher outliers should be detected, or both.
Options are "both", "lower", "higher".}

\item{overwrite}{Boolean. If TRUE, and this function has previously generated
an outlier decision on the same itemName, the outlier decision will be overwritten.
Default TRUE.}
}
\value{
A \link[SingleCellExperiment]{SingleCellExperiment} object with
 '' added to the
 \link{colData} slot. Additionally, the
decontaminated counts will be added as an assay called 'decontXCounts'.
}
\description{
A wrapper function for \link[scater]{isOutlier}. Identify
 outliers from numeric vectors stored in the SingleCellExperiment object.
}
\examples{
data(scExample, package = "singleCellTK")
sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
sce <- runDecontX(sce[,sample(ncol(sce),20)])
sce <- detectCellOutlier(sce, slotName = "colData", sample = sce$sample,
 nmads = 4, itemName = "decontX_contamination", type = "both")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/miscFunctions.R
\name{distinctColors}
\alias{distinctColors}
\title{Generate a distinct palette for coloring different clusters}
\usage{
distinctColors(
  n,
  hues = c("red", "cyan", "orange", "blue", "yellow", "purple", "green", "magenta"),
  saturation.range = c(0.7, 1),
  value.range = c(0.7, 1)
)
}
\arguments{
\item{n}{Integer; Number of colors to generate}

\item{hues}{Character vector of R colors available from the colors()
function. These will be used as the base colors for the clustering scheme.
Different saturations and values (i.e. darkness) will be generated for each
hue.}

\item{saturation.range}{Numeric vector of length 2 with values between 0 and
1. Default: c(0.25, 1)}

\item{value.range}{Numeric vector of length 2 with values between 0 and 1.
Default: c(0.5, 1)}
}
\value{
A vector of distinct colors that have been converted to  HEX from
HSV.
}
\description{
Generate a distinct palette for coloring different clusters
}
\examples{
distinctColors(10)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{msigdb_table}
\alias{msigdb_table}
\title{MSigDB gene get Category table}
\format{
A data.frame.
}
\usage{
data("msigdb_table")
}
\value{
A table of gene set categories
}
\description{
A table of gene set categories that can be download from MSigDB. The
categories and descriptions can be found here:
https://www.gsea-msigdb.org/gsea/msigdb/collections.jsp. The IDs in the
first column can be used to retrieve the gene sets for these categories
using the \link{importGeneSetsFromMSigDB} function.
}
\examples{
data("msigdb_table")
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getBiomarker.R
\name{getBiomarker}
\alias{getBiomarker}
\title{Given a list of genes and a SingleCellExperiment object, return
the binary or continuous expression of the genes.}
\usage{
getBiomarker(
  inSCE,
  gene,
  binary = "Binary",
  useAssay = "counts",
  featureLocation = NULL,
  featureDisplay = NULL
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object.}

\item{gene}{gene list}

\item{binary}{"Binary" for binary expression or "Continuous" for a gradient.
Default: "Binary"}

\item{useAssay}{Indicates which assay to use. The default is "counts".}

\item{featureLocation}{Indicates which column name of rowData to query gene.}

\item{featureDisplay}{Indicates which column name of rowData to use
to display feature for visualization.}
}
\value{
getBiomarker(): A data.frame of expression values
}
\description{
Given a list of genes and a SingleCellExperiment object, return
the binary or continuous expression of the genes.
}
\examples{
data("mouseBrainSubsetSCE")
getBiomarker(mouseBrainSubsetSCE, gene="C1qa")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/seuratFunctions.R
\name{runSeuratNormalizeData}
\alias{runSeuratNormalizeData}
\title{runSeuratNormalizeData
Wrapper for NormalizeData() function from seurat library
Normalizes the sce object according to the input parameters}
\usage{
runSeuratNormalizeData(
  inSCE,
  useAssay,
  normAssayName = "seuratNormData",
  normalizationMethod = "LogNormalize",
  scaleFactor = 10000,
  verbose = TRUE
)
}
\arguments{
\item{inSCE}{(sce) object to normalize}

\item{useAssay}{Assay containing raw counts to use for normalization.}

\item{normAssayName}{Name of new assay containing normalized data. Default
\code{seuratNormData}.}

\item{normalizationMethod}{selected normalization method. Default
\code{"LogNormalize"}.}

\item{scaleFactor}{numeric value that represents the scaling factor. Default
\code{10000}.}

\item{verbose}{Logical value indicating if informative messages should
be displayed. Default is \code{TRUE}.}
}
\value{
Normalized \code{SingleCellExperiment} object
}
\description{
runSeuratNormalizeData
Wrapper for NormalizeData() function from seurat library
Normalizes the sce object according to the input parameters
}
\examples{
data(scExample, package = "singleCellTK")
\dontrun{
sce <- runSeuratNormalizeData(sce, useAssay = "counts")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/reticulate_setup.R
\name{selectSCTKConda}
\alias{selectSCTKConda}
\title{Selects a Conda environment}
\usage{
selectSCTKConda(envname = "sctk-reticulate")
}
\arguments{
\item{envname}{Character. Name of the conda environment to activate.}
}
\value{
None. Selects Conda environment.
}
\description{
Selects a Conda environment with Python packages used in \code{\link{singleCellTK}}.
}
\examples{
\dontrun{
sctkPythonInstallConda(envname = "sctk-reticulate", selectConda = FALSE)
selectSCTKConda(envname = "sctk-reticulate")
}
}
\seealso{
\code{\link[reticulate]{conda-tools}} for more information on using Conda environments with package \code{\link{reticulate}}.
See \url{https://rstudio.github.io/reticulate/} for more information on package \code{\link{reticulate}}.

See \code{\link[singleCellTK]{sctkPythonInstallConda}} for installation of Python modules into a Conda environment.
See\code{\link[reticulate]{conda-tools}} for more information on using Conda environments with package \code{\link{reticulate}}.
See \url{https://rstudio.github.io/reticulate/} for more information on package \code{\link{reticulate}}.
See \url{https://docs.conda.io/en/latest/} for more information on Conda environments.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runTSCAN.R
\name{runTSCANClusterDEAnalysis}
\alias{runTSCANClusterDEAnalysis}
\title{Find DE genes between all TSCAN paths rooted from given cluster}
\usage{
runTSCANClusterDEAnalysis(
  inSCE,
  useCluster,
  useAssay = "logcounts",
  fdrThreshold = 0.05
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object.}

\item{useCluster}{The cluster to be regarded as the root, has to existing in
\code{colData(inSCE)$TSCAN_clusters}.}

\item{useAssay}{Character. The name of the assay to use. This assay should
contain log normalized counts. Default \code{"logcounts"}.}

\item{fdrThreshold}{Only out put DEGs with FDR value smaller than this value.
Default \code{0.05}.}
}
\value{
The input \code{inSCE} with results updated in \code{metadata}.
}
\description{
This function finds all paths that root from a given cluster
\code{useCluster}, and performs tests to identify significant features for
each path, and are not significant and/or changing in the opposite direction
in the other paths. Using a branching cluster (i.e. a node with degree > 2)
may highlight features which are responsible for the branching event. MST has
to be pre-calculated with \code{\link{runTSCAN}}.
}
\examples{
data("mouseBrainSubsetSCE", package = "singleCellTK")
mouseBrainSubsetSCE <- runTSCAN(inSCE = mouseBrainSubsetSCE,
                                useReducedDim = "PCA_logcounts")
mouseBrainSubsetSCE <- runTSCANClusterDEAnalysis(inSCE = mouseBrainSubsetSCE,
                                         useCluster = 1)
}
\author{
Nida Pervaiz
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/reticulate_setup.R
\name{sctkPythonInstallConda}
\alias{sctkPythonInstallConda}
\title{Installs Python packages into a Conda environment}
\usage{
sctkPythonInstallConda(
  envname = "sctk-reticulate",
  conda = "auto",
  packages = c("scipy", "numpy", "astroid", "six"),
  pipPackages = c("scrublet", "scanpy", "louvain", "leidenalg", "bbknn", "scanorama",
    "anndata"),
  selectConda = TRUE,
  forge = FALSE,
  pipIgnoreInstalled = TRUE,
  pythonVersion = NULL,
  ...
)
}
\arguments{
\item{envname}{Character. Name of the conda environment to create.}

\item{conda}{Character. Path to conda executable. Usue "auto" to find conda using the PATH and other conventional install locations. Default 'auto'.}

\item{packages}{Character Vector. List of packages to install from Conda.}

\item{pipPackages}{Character Vector. List of packages to install into the Conda environment using 'pip'.}

\item{selectConda}{Boolean. Run \code{\link[singleCellTK]{selectSCTKConda}} after installing all packages to select the Conda environment. Default TRUE.}

\item{forge}{Boolean. Include the Conda Forge repository.}

\item{pipIgnoreInstalled}{Boolean. Ignore installed versions when using pip. This is TRUE by default so that specific package versions can be installed even if they are downgrades.
The FALSE option is useful for situations where you don't want a pip install to attempt an overwrite of a conda binary package (e.g. SciPy on Windows which is very difficult
to install via pip due to compilation requirements).}

\item{pythonVersion}{Passed to \code{python_version} variable in \code{\link{conda_install}}. Default NULL.}

\item{...}{Other parameters to pass to \code{\link{conda_install}}.}
}
\value{
None. Installation of Conda environment.
}
\description{
Install all Python packages used in the \code{\link{singleCellTK}} package
using \code{\link{conda_install}} from package \code{\link{reticulate}}. This
will create a new Conda environment with the name \code{envname} if not already present.
Note that Anaconda or Miniconda already need to be installed on the local system.
}
\examples{
\dontrun{
sctkPythonInstallConda(envname = "sctk-reticulate")
}
}
\seealso{
See \code{\link{conda_create}} for more information on creating a Conda environment.
See \code{\link{conda_install}} for more description of the installation parameters.
See \url{https://rstudio.github.io/reticulate/} for more information on package \code{\link{reticulate}}.
See \code{\link[singleCellTK]{selectSCTKConda}} for reloading the Conda environment if R is restarted without
going through the whole installation process again.
See \url{https://docs.conda.io/en/latest/} for more information on Conda environments.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotPCA.R
\name{plotPCA}
\alias{plotPCA}
\title{Plot PCA run data from its components.}
\usage{
plotPCA(
  inSCE,
  colorBy = NULL,
  shape = NULL,
  pcX = "PC1",
  pcY = "PC2",
  reducedDimName = "PCA",
  runPCA = FALSE,
  useAssay = "logcounts"
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object.}

\item{colorBy}{The variable to color clusters by}

\item{shape}{Shape of the points}

\item{pcX}{User choice for the first principal component}

\item{pcY}{User choice for the second principal component}

\item{reducedDimName}{a name to store the results of the dimension reduction
coordinates obtained from this method. This is stored in the SingleCellExperiment
object in the reducedDims slot. Required.}

\item{runPCA}{Run PCA if the reducedDimName does not exist. the Default is
FALSE.}

\item{useAssay}{Indicate which assay to use. The default is "logcounts".}
}
\value{
A PCA plot
}
\description{
Plot PCA run data from its components.
}
\examples{
data("mouseBrainSubsetSCE")
plotPCA(mouseBrainSubsetSCE, colorBy = "level1class",
        reducedDimName = "PCA_counts")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/importOptimus.R
\name{importOptimus}
\alias{importOptimus}
\title{Construct SCE object from Optimus output}
\usage{
importOptimus(
  OptimusDirs,
  samples,
  matrixLocation = "call-MergeCountFiles/sparse_counts.npz",
  colIndexLocation = "call-MergeCountFiles/sparse_counts_col_index.npy",
  rowIndexLocation = "call-MergeCountFiles/sparse_counts_row_index.npy",
  cellMetricsLocation = "call-MergeCellMetrics/merged-cell-metrics.csv.gz",
  geneMetricsLocation = "call-MergeGeneMetrics/merged-gene-metrics.csv.gz",
  emptyDropsLocation = "call-RunEmptyDrops/empty_drops_result.csv",
  class = c("Matrix", "matrix"),
  delayedArray = FALSE,
  rowNamesDedup = TRUE
)
}
\arguments{
\item{OptimusDirs}{A vector of root directories of Optimus output files.
The paths should be something like this:
\code{/PATH/TO/bb4a2a5e-ff34-41b6-97d2-0c0c0c534530}.
Each entry in \code{OptimusDirs} is considered a sample and should have
its own path. Must have the same length as \code{samples}.}

\item{samples}{A vector of user-defined sample names for the sample to be
imported. Must have the same length as \code{OptimusDirs}.}

\item{matrixLocation}{Character. It is the intermediate
path to the filtered count maxtrix file saved in sparse matrix format
(\code{.npz}). Default
\code{call-MergeCountFiles/sparse_counts.npz} which works for
optimus_v1.4.0.}

\item{colIndexLocation}{Character. The intermediate path to the barcode
index file. Default \code{call-MergeCountFiles/sparse_counts_col_index.npy}.}

\item{rowIndexLocation}{Character. The intermediate path to the feature
(gene) index file. Default
\code{call-MergeCountFiles/sparse_counts_row_index.npy}.}

\item{cellMetricsLocation}{Character. It is the intermediate
path to the cell metrics file (\code{merged-cell-metrics.csv.gz}). Default
\code{call-MergeCellMetrics/merged-cell-metrics.csv.gz} which works for
optimus_v1.4.0.}

\item{geneMetricsLocation}{Character. It is the intermediate
path to the feature (gene) metrics file (\code{merged-gene-metrics.csv.gz}).
Default \code{call-MergeGeneMetrics/merged-gene-metrics.csv.gz} which works
for optimus_v1.4.0.}

\item{emptyDropsLocation}{Character. It is the intermediate
path to \link[DropletUtils]{emptyDrops} metrics file
(\code{empty_drops_result.csv}).
Default \code{call-RunEmptyDrops/empty_drops_result.csv} which works for
optimus_v1.4.0.}

\item{class}{Character. The class of the expression matrix stored in the SCE
object. Can be one of "Matrix" (as returned by
\link{readMM} function), or "matrix" (as returned by
\link[base]{matrix} function). Default "Matrix".}

\item{delayedArray}{Boolean. Whether to read the expression matrix as
\link{DelayedArray} object or not. Default \code{FALSE}.}

\item{rowNamesDedup}{Boolean. Whether to deduplicate rownames. Default 
\code{TRUE}.}
}
\value{
A \link[SingleCellExperiment]{SingleCellExperiment} object
 containing the count
 matrix, the gene annotation, and the cell annotation.
}
\description{
Read the barcodes, features (genes), and matrices from Optimus
 outputs. Import them
 as one \link[SingleCellExperiment]{SingleCellExperiment} object.
}
\examples{
file.path <- system.file("extdata/Optimus_20x1000",
  package = "singleCellTK")
\dontrun{
sce <- importOptimus(OptimusDirs = file.path,
  samples = "Optimus_20x1000")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotSCEHeatmap.R
\name{plotSCEHeatmap}
\alias{plotSCEHeatmap}
\title{Plot heatmap of using data stored in SingleCellExperiment Object}
\usage{
plotSCEHeatmap(
  inSCE,
  useAssay = "logcounts",
  useReducedDim = NULL,
  doLog = FALSE,
  featureIndex = NULL,
  cellIndex = NULL,
  scale = TRUE,
  trim = c(-2, 2),
  featureIndexBy = "rownames",
  cellIndexBy = "rownames",
  cluster_columns = FALSE,
  cluster_rows = FALSE,
  rowDataName = NULL,
  colDataName = NULL,
  aggregateRow = NULL,
  aggregateCol = NULL,
  featureAnnotations = NULL,
  cellAnnotations = NULL,
  featureAnnotationColor = NULL,
  cellAnnotationColor = NULL,
  palette = c("ggplot", "celda", "random"),
  heatmapPalette = c("sequential", "diverging"),
  addCellSummary = NULL,
  rowSplitBy = NULL,
  colSplitBy = NULL,
  rowLabel = FALSE,
  colLabel = FALSE,
  rowLabelSize = 6,
  colLabelSize = 6,
  rowDend = TRUE,
  colDend = TRUE,
  title = NULL,
  rowTitle = "Features",
  colTitle = "Cells",
  rowGap = grid::unit(0, "mm"),
  colGap = grid::unit(0, "mm"),
  border = FALSE,
  colorScheme = NULL,
  ...
)
}
\arguments{
\item{inSCE}{\linkS4class{SingleCellExperiment} inherited object.}

\item{useAssay}{character. A string indicating the assay name that
provides the expression level to plot. Only for \code{plotSCEHeatmap}.}

\item{useReducedDim}{character. A string indicating the reducedDim name that
provides the expression level to plot. Only for \code{plotSCEDimReduceHeatmap}.}

\item{doLog}{Logical scalar. Whether to do \code{log(assay + 1)}
transformation on the assay indicated by \code{useAssay}. Default
\code{FALSE}.}

\item{featureIndex}{A vector that can subset the input SCE object by rows
(features). Alternatively, it can be a vector identifying features in
another feature list indicated by \code{featureIndexBy}. Default \code{NULL}.}

\item{cellIndex}{A vector that can subset the input SCE object by columns
(cells). Alternatively, it can be a vector identifying cells in another
cell list indicated by \code{featureIndexBy}. Default \code{NULL}.}

\item{scale}{Whether to perform z-score or min-max scaling on each row.Choose from \code{"zscore"}, \code{"min-max"} or default
\code{TRUE} or \code{FALSE}}

\item{trim}{A 2-element numeric vector. Values outside of this range will be
trimmed to their nearst bound. Default \code{c(-2, 2)}}

\item{featureIndexBy}{A single character specifying a column name of
\code{rowData(inSCE)}, or a vector of the same length as \code{nrow(inSCE)},
where we search for the non-rowname feature indices. Not applicable for
\code{plotSCEDimReduceHeatmap}. Default \code{"rownames"}.}

\item{cellIndexBy}{A single character specifying a column name of
\code{colData(inSCE)}, or a vector of the same length as \code{ncol(inSCE)},
where we search for the non-rowname cell indices. Default \code{"rownames"}.}

\item{cluster_columns}{A logical scalar that turns on/off 
clustering of columns. Default \code{FALSE}. Clustering columns should be turned off when using reduced dim 
for plotting as it will be sorted by PCs}

\item{cluster_rows}{A logical scalar that turns on/off clustering of rows. 
Default \code{FALSE}.}

\item{rowDataName}{character. The column name(s) in \code{rowData} that need
to be added to the annotation. Not applicable for
\code{plotSCEDimReduceHeatmap}. Default \code{NULL}.}

\item{colDataName}{character. The column name(s) in \code{colData} that need
to be added to the annotation. Default \code{NULL}.}

\item{aggregateRow}{Feature variable for aggregating the heatmap by row. Can
be a vector or a \code{rowData} column name for feature variable. Multiple
variables are allowed. Default \code{NULL}.}

\item{aggregateCol}{Cell variable for aggregating the heatmap by column. Can
be a vector or a \code{colData} column name for cell variable. Multiple
variables are allowed. Default \code{NULL}.}

\item{featureAnnotations}{\code{data.frame}, with \code{rownames} containing
all the features going to be plotted. Character columns should be factors.
Default \code{NULL}.}

\item{cellAnnotations}{\code{data.frame}, with \code{rownames} containing
all the cells going to be plotted. Character columns should be factors.
Default \code{NULL}.}

\item{featureAnnotationColor}{A named list. Customized color settings for
feature labeling. Should match the entries in the \code{featureAnnotations}
or \code{rowDataName}. For each entry, there should be a list/vector of
colors named with categories. Default \code{NULL}.}

\item{cellAnnotationColor}{A named list. Customized color settings for
cell labeling. Should match the entries in the \code{cellAnnotations} or
\code{colDataName}. For each entry, there should be a list/vector of colors
named with categories. Default \code{NULL}.}

\item{palette}{Choose from \code{"ggplot"}, \code{"celda"} or \code{"random"}
to generate unique category colors.}

\item{heatmapPalette}{Choose from \code{"sequential"}, \code{"diverging"} or supply custom palette with colorScheme
to generate unique category colors. Default is \code{"sequential"}}

\item{addCellSummary}{Add summary barplots to column annotation. Supply the name of the column in colData as a character. This option will add summary for categorical variables 
as stacked barplots.}

\item{rowSplitBy}{character. Do semi-heatmap based on the grouping of
this(these) annotation(s). Should exist in either \code{rowDataName} or
\code{names(featureAnnotations)}. Default \code{NULL}.}

\item{colSplitBy}{character. Do semi-heatmap based on the grouping of
this(these) annotation(s). Should exist in either \code{colDataName} or
\code{names(cellAnnotations)}. Default \code{NULL}.}

\item{rowLabel}{Use a logical for whether to display all the feature names,
a single character to display a column of \code{rowData(inSCE)} annotation,
a vector of the same length as full/subset \code{nrow(inSCE)} to display
customized info. Default \code{FALSE}.}

\item{colLabel}{Use a logical for whether to display all the cell names, a
single character to display a column of \code{colData(inSCE)} annotation,
a vector of the same length as full/subset \code{ncol(inSCE)} to display
customized info. Default \code{FALSE}.}

\item{rowLabelSize}{A number for the font size of feature names. Default
\code{8}}

\item{colLabelSize}{A number for the font size of cell names. Default
\code{8}}

\item{rowDend}{Whether to display row dendrogram. Default \code{TRUE}.}

\item{colDend}{Whether to display column dendrogram. Default \code{TRUE}.}

\item{title}{The main title of the whole plot. Default \code{NULL}.}

\item{rowTitle}{The subtitle for the rows. Default \code{"Genes"}.}

\item{colTitle}{The subtitle for the columns. Default \code{"Cells"}.}

\item{rowGap}{A numeric value or a \code{\link[grid]{unit}} object. For the
gap size between rows of the splitted heatmap. Default
\code{grid::unit(0, 'mm')}.}

\item{colGap}{A numeric value or a \code{\link[grid]{unit}} object. For the
gap size between columns of the splitted heatmap. Default
\code{grid::unit(0, 'mm')}.}

\item{border}{A logical scalar. Whether to show the border of the heatmap or
splitted heatmaps. Default \code{TRUE}.}

\item{colorScheme}{function. A function that generates color code by giving
a value. Can be generated by \code{\link[circlize]{colorRamp2}}.
Default \code{NULL}.}

\item{...}{Other arguments passed to \code{\link[ComplexHeatmap]{Heatmap}}.}
}
\value{
A \code{\link[ggplot2]{ggplot}} object.
}
\description{
Plot heatmap of using data stored in SingleCellExperiment Object
}
\examples{
data(scExample, package = "singleCellTK")
plotSCEHeatmap(sce[1:3,1:3], useAssay = "counts")
}
\author{
Yichen Wang
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/enrichRSCE.R
\name{runEnrichR}
\alias{runEnrichR}
\title{Run EnrichR on SCE object}
\usage{
runEnrichR(
  inSCE,
  features,
  analysisName,
  db = NULL,
  by = "rownames",
  featureName = NULL
)
}
\arguments{
\item{inSCE}{A \linkS4class{SingleCellExperiment} object.}

\item{features}{Character vector, selected genes for enrichment analysis.}

\item{analysisName}{A string that identifies each specific analysis.}

\item{db}{Character vector. Selected database name(s) from the enrichR
database list. If \code{NULL} then EnrichR will be run on all the available
databases on the enrichR database. See details. Default \code{NULL}}

\item{by}{Character. From where should we find the \code{features}?
\code{"rownames"} for from \code{rownames(inSCE)}, otherwise, from a column
of feature metadata (\code{rowData(inSCE)[[by]]}). See details. Default
\code{"rownames"}.}

\item{featureName}{Character. Indicates the actual feature identifiers to be
passed to EnrichR. Can be \code{"rownames"}, a column in feature metadata
(\code{rowData(inSCE)[[featureName]]}), or a character vector with its length
equals to \code{nrow(inSCE)}. See details. Default \code{"rownames"}.}
}
\value{
Updates \code{inSCE} metadata with a data.frame of enrichment terms
overlapping in the respective databases along with p-values, z-scores etc.
}
\description{
Run EnrichR on SCE object
}
\details{
EnrichR works by querying the specified \code{features} to its online
databases, thus it requires the Internet connection.

Available \code{db} options could be shown by running
\code{enrichR::listEnrichrDbs()$libraryName}

This function checks for the existence of features in the SCE object. When
\code{features} do not have a match in \code{rownames(inSCE)}, users may
try to specify \code{by} to pass the check.

EnrichR expects gene symbols/names as the input (i.e. Ensembl ID might not
work). When specified \code{features} are not qualified for this, users may
try to specify \code{featureName} to change the identifier type to pass to
EnrichR.
}
\examples{
data("mouseBrainSubsetSCE")
if (Biobase::testBioCConnection()) {
  mouseBrainSubsetSCE <- runEnrichR(mouseBrainSubsetSCE, features =  c("Vamp7","Cntn2","Olig1"),
                                    db = "GO_Cellular_Component_2025",
                                    analysisName = "analysis1")
}

}
\seealso{
\code{\link{getEnrichRResult}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/importGeneSets.R
\name{importGeneSetsFromCollection}
\alias{importGeneSetsFromCollection}
\title{Imports gene sets from a GeneSetCollection object}
\usage{
importGeneSetsFromCollection(
  inSCE,
  geneSetCollection,
  collectionName = "GeneSetCollection",
  by = "rownames",
  noMatchError = TRUE
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object.}

\item{geneSetCollection}{A \linkS4class{GeneSetCollection} object. See
\link{GeneSetCollection} for more details.}

\item{collectionName}{Character. Name of collection to add gene sets to.
If this collection already exists in \code{inSCE}, then these gene sets will
be added to that collection. Any gene sets within the collection with the
same name will be overwritten. Default \code{GeneSetCollection}.}

\item{by}{Character, character vector, or NULL. Describes the
location within \code{inSCE} where the gene identifiers in
\code{geneSetCollection} should be mapped. If set to \code{"rownames"} then the
features will be searched for among \code{rownames(inSCE)}. This can also be
set to one of the column names of \code{rowData(inSCE)} in which case the
gene identifies will be mapped to that column in the \code{rowData}
of \code{inSCE}. \code{by} can be a vector the same length as
the number of gene sets in the \code{GeneSetCollection} and the elements of the vector
can point to different locations within \code{inSCE}. Finally, \code{by}
can be \code{NULL}. In this case, the location of the gene identifiers
in \code{inSCE} should be saved in the description slot for each gene set
in the \code{GeneSetCollection}.
See \link{featureIndex} for more information.
Default \code{"rownames"}.}

\item{noMatchError}{Boolean. Show an error if a collection does not have
any matching features. Default \code{TRUE}.}
}
\value{
A \link[SingleCellExperiment]{SingleCellExperiment} object
with gene set from \code{collectionName} output stored to the
\link{metadata} slot.
}
\description{
Converts a list of gene sets stored in a
\linkS4class{GeneSetCollection} object and stores it in the metadata of the
\linkS4class{SingleCellExperiment} object. These gene sets can be used in
downstream quality control and analysis functions in \link{singleCellTK}.
}
\details{
The gene identifiers in gene sets in the
\code{GeneSetCollection} will be mapped to the rownames of
\code{inSCE} using the \code{by} parameter and
stored in a \linkS4class{GeneSetCollection} object from package
\link{GSEABase}. This object is stored in
\code{metadata(inSCE)$sctk$genesets}, which can be accessed in downstream
analysis functions such as \link[singleCellTK]{runCellQC}.
}
\examples{
data(scExample)
gs1 <- GSEABase::GeneSet(setName = "geneset1",
                         geneIds = rownames(sce)[seq(10)])
gs2 <- GSEABase::GeneSet(setName = "geneset2",
                         geneIds = rownames(sce)[seq(11,20)])
gsc <- GSEABase::GeneSetCollection(list(gs1, gs2))
sce <- importGeneSetsFromCollection(inSCE = sce,
                                    geneSetCollection = gsc,
                                    by = "rownames")
}
\seealso{
\link{importGeneSetsFromList} for importing from lists,
\link{importGeneSetsFromGMT} for importing from GMT files, and
\link{importGeneSetsFromMSigDB} for importing MSigDB gene sets.
}
\author{
Joshua D. Campbell
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/seuratFunctions.R
\name{runSeuratTSNE}
\alias{runSeuratTSNE}
\title{runSeuratTSNE
Computes tSNE from the given sce object and stores the tSNE computations back
into the sce object}
\usage{
runSeuratTSNE(
  inSCE,
  useReduction = c("pca", "ica"),
  reducedDimName = "seuratTSNE",
  dims = 10,
  perplexity = 30,
  externalReduction = NULL,
  seed = 1
)
}
\arguments{
\item{inSCE}{(sce) object on which to compute the tSNE}

\item{useReduction}{selected reduction algorithm to use for computing tSNE.
One of "pca" or "ica". Default \code{"pca"}.}

\item{reducedDimName}{Name of new reducedDims object containing Seurat tSNE
Default \code{seuratTSNE}.}

\item{dims}{Number of reduction components to use for tSNE computation.
Default \code{10}.}

\item{perplexity}{Adjust the perplexity tuneable parameter for the underlying
tSNE call. Default \code{30}.}

\item{externalReduction}{Pass DimReduc object if PCA/ICA computed through
other libraries. Default \code{NULL}.}

\item{seed}{Random seed for reproducibility of results.
Default \code{1}.}
}
\value{
Updated sce object with tSNE computations stored
}
\description{
runSeuratTSNE
Computes tSNE from the given sce object and stores the tSNE computations back
into the sce object
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{SEG}
\alias{SEG}
\title{Stably Expressed Gene (SEG) list obect, with SEG sets for human and mouse.}
\format{
list, with two entries \code{"human"} and \code{"mouse"}, each is a
charactor vector.
}
\source{
\code{data('segList', package='scMerge')}
}
\usage{
data('SEG')
}
\value{
Stably Expressed Gene (SEG) list obect, with SEG sets for human and mouse.
}
\description{
The two gene sets came from dataset called `segList` of package `scMerge`.
}
\examples{
data('SEG')
humanSEG <- SEG$human
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runGSVA.R
\name{runGSVA}
\alias{runGSVA}
\title{Run GSVA analysis on a \linkS4class{SingleCellExperiment} object}
\usage{
runGSVA(
  inSCE,
  useAssay = "logcounts",
  resultNamePrefix = NULL,
  geneSetCollectionName,
  ...
)
}
\arguments{
\item{inSCE}{Input \linkS4class{SingleCellExperiment} object.}

\item{useAssay}{Indicate which assay to use. The default is "logcounts"}

\item{resultNamePrefix}{Character. Prefix to the name the GSVA results 
which will be stored in the reducedDim slot of \code{inSCE}. The names of the 
output matrix will be \code{resultNamePrefix_Scores}. If this parameter is 
set to \code{NULL}, then "GSVA_geneSetCollectionName_" will be used. Default 
\code{NULL}.}

\item{geneSetCollectionName}{Character. The name of the gene set collection 
to use.}

\item{...}{Parameters to pass to gsva()}
}
\value{
A \linkS4class{SingleCellExperiment} object with pathway activity 
scores from GSVA stored in \code{reducedDim} as 
\code{GSVA_geneSetCollectionName_Scores}.
}
\description{
Run GSVA analysis on a \linkS4class{SingleCellExperiment} object
}
\examples{
data(scExample, package = "singleCellTK")
sce <- subsetSCECols(sce, colData = "type != 'EmptyDroplet'")
sce <- scaterlogNormCounts(sce, assayName = "logcounts")
gs1 <- rownames(sce)[seq(10)]
gs2 <- rownames(sce)[seq(11,20)]
gs <- list("geneset1" = gs1, "geneset2" = gs2)

sce <- importGeneSetsFromList(inSCE = sce,geneSetList = gs,
                                           by = "rownames")
sce <- runGSVA(inSCE = sce, 
               geneSetCollectionName = "GeneSetCollection", 
               useAssay = "logcounts")
}
